// Alarm.h: interface for the CAlarm class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ALARM_H__A028351D_7889_4029_BFEE_0493649A8985__INCLUDED_)
#define AFX_ALARM_H__A028351D_7889_4029_BFEE_0493649A8985__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "X\XCtlDevice.h"
//---------------------------------------------------------------------------
// CAlarmItem
//---------------------------------------------------------------------------
class CAlarmItem
{
public:
	CAlarmItem( int nId, int nCode, char cLevel, CString sText , CString sDateTime )
	{
		m_nId       = nId;
		m_nCode		= nCode;
		m_cLevel    = cLevel;
		m_sText		= sText;
		m_sDateTime = sDateTime;
	}
public:
	int m_nId;
	int m_nCode;
	char m_cLevel;		// 'L' : Light Alarm, 'S' : Serious Alarm
	CString m_sText;
	CString m_sDateTime;
};

//---------------------------------------------------------------------------
// CAlarm
//---------------------------------------------------------------------------
class CAlarm
{
public:
	CAlarm();
	virtual ~CAlarm();

public:
	void SetDevice(XCtlDevice* pDevice) { m_pDevice = pDevice; }
	void OpenAlarmItems();
	void CloseAlarmItems();
	BOOL ParseAlarm(LPCTSTR lpszFileName);
	BOOL ParseLine( char* szLine );
	BOOL SetItem(int nId, int nCode, char cLevel, CString sText);
	CAlarmItem* GetItem(int nId);
	void DisplayErrMsg( char* szComment );

	void ClearAlarmList();
	void SetAlarm(int nAlarmId);
	void ResetAlarm(int nAlarmId);
	void ResetAlarmAll();
	BOOL IsPushedAlarmReset();
	void SetLampState(int i, int state);
	int  GetAlarmNo() { return m_nAlarmNo; }
	BOOL IsAlarm( int nAlarmId );
	CString GetAlarmMsg(int nAlarmId);

public:
	// enum
	enum LampSTATE     { lampOFF, lampON, lampTOGGLE };
	enum LampKIND
	{ 
		lampTOWER_LAMP_R,
		lampTOWER_LAMP_Y,
		lampTOWER_LAMP_G,
		lampTOWER_LAMP_B,
		lampBUZZER_OFF,
		lampALARM_RESET,
		lampMELODY1,
		lampMELODY2,
		lampMELODY3,
		lampMELODY4,
		lampMAX_SW_NO
	};
	enum almLevel
	{
		almLIGHT = 'L',
		almSERIOUS = 'S',
	};
	int m_nLampState[lampMAX_SW_NO];
	int m_nOldLampState[lampMAX_SW_NO];
	int m_nLineNo;
	int m_nAlarmNo;

#ifdef _MY_DEBUG
	BOOL m_bBuzzerOff;
	BOOL m_bAlarmReset;
#endif
	BOOL m_bBtnAlarmReset;	// SanghoCho 2015.05.12

	// Declare the tempelate variable
	CTypedPtrArray<CPtrArray, CAlarmItem* >		m_arrayAlarmItem;
	CArray<int, int >		m_arAlarmListSet;
	CArray<int, int >		m_arAlarmListReset;
	CArray<int, int >		m_arAlarmListSave;

	CMutex	m_mutex;
	XCtlDevice*	m_pDevice;


	//enum	_EQP_MODE { eqpNOTHING, eqpRUN, eqpIDLE, eqpDOWN, eqpINIT };
	//int		m_nEqpMode;
	//int		m_nOldEqpMode;

	//LPVOID	m_lpMapAddress;
};

#endif // !defined(AFX_ALARM_H__A028351D_7889_4029_BFEE_0493649A8985__INCLUDED_)
