// AnalogInputCln.cpp: implementation of the CAnalogInput1 class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Dics.h"
#include "AnalogInput1.h"
#include "DefineIo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
AI_SET CAnalogInput1::m_aiSet[MAX_ANALOG_IN_NO] = 
{	
	{ CDicsView::viewJobPiping, IF_UNIT_EUV,  0,  0, -1,	noEUV_UNIT_HEAT_EXT,			"EUV HEAT Exhaust Pressure",		IDC_AI_EUV_UNIT_HEAT_EXT_PRESS,		aiDM },
	{ CDicsView::viewJobPiping, IF_UNIT_EUV,  1,  1, -1,	noEUV_UNIT_ACID_EXT,			"EUV ACID Exhaust Pressure",		IDC_AI_EUV_UNIT_ACID_EXT_PRESS,		aiDM },
	{ CDicsView::viewJobPiping, IF_UNIT_EUV,  2,  2, -1,	noEUV_UNIT_CDA_IN_PRESS,		"EUV CDA IN Pressure",				IDC_AI_EUV_UNIT_CDA_PRESS,			aiPS },
	{ CDicsView::viewJobPiping, IF_UNIT_RB,	  3,  3, -1, 	noRB_UNIT_EXT1_PRESS,			"R/B(SBJ) Unit Exhaust1 Pressure",	IDC_AI_RB_UNIT_EXT1_PRESS,			aiDM },	
	{ CDicsView::viewJobPiping, IF_UNIT_RB,	  4,  4, -1, 	noRB_UNIT_EXT2_PRESS,			"R/B(SBJ) Unit Exhaust2 Pressure",	IDC_AI_RB_UNIT_EXT2_PRESS,			aiDM },	
	{ CDicsView::viewJobPiping, IF_UNIT_FR,	  5,  5, -1, 	noFR_UNIT_EXT1_PRESS,			"F/R Unit Exhaust1 Pressure",		IDC_AI_FR_UNIT_EXT1_PRESS,			aiDM },
	{ CDicsView::viewJobPiping, IF_UNIT_FR,	  6,  6, -1, 	noFR_UNIT_EXT2_PRESS,			"F/R Unit Exhaust2 Pressure",		IDC_AI_FR_UNIT_EXT2_PRESS,			aiDM },
	{ CDicsView::viewJobPiping, IF_UNIT_RB,	  7,  7, -1, 	noRB_UNIT_UP_SWR_FLOW,			"R/B(SBJ) Unit Upper Shower Flow",	IDC_AI_RB_UNIT_UP_SHW_FLOW,			aiFR },
	{ CDicsView::viewJobPiping, IF_UNIT_RB,	  8,  8, -1, 	noRB_UNIT_LO_SWR_FLOW,			"R/B(SBJ) Unit Lower Shower Flow",	IDC_AI_RB_UNIT_LO_SHW_FLOW,			aiFR },
	{ CDicsView::viewJobPiping, IF_UNIT_RB,	  9,  9, -1, 	noRB_UNIT_SBJ1_DI_FLOW,			"R/B(SBJ) Unit SBJ1 DI Flow",		IDC_AI_RB_UNIT_SBJ1_DI_FLOW,		aiFR },
	{ CDicsView::viewJobPiping, IF_UNIT_FR,	 10, 10, -1, 	noFR_UNIT_SBJ2_DI_FLOW,			"F/R Unit SBJ2 DI Flow",			IDC_AI_FR_UNIT_SBJ2_DI_FLOW,		aiFR },
	{ CDicsView::viewJobPiping, IF_UNIT_FR,	 11, 11, -1, 	noFR_UNIT_SBJ3_DI_FLOW,			"F/R Unit SBJ3 DI Flow",			IDC_AI_FR_UNIT_SBJ3_DI_FLOW,		aiFR },
	{ CDicsView::viewJobPiping, IF_UNIT_FR,	 12, 12, -1, 	noFR_UNIT_SBJ_LO_SWR_FLOW,		"F/R Unit Pump Lower Shower Flow",	IDC_AI_FR_UNIT_LO_SHW_FLOW,			aiFR },
	{ CDicsView::viewJobPiping, IF_UNIT_FR,	 13, 13, -1, 	noFR_UNIT_SWR_FLOW,				"F/R Unit Main DI Shower Flow",		IDC_AI_FR_UNIT_DI_SHW_FLOW,			aiFR },
	{ CDicsView::viewJobPiping, IF_UNIT_FR,	 14, 14, -1, 	noFR_UNIT_AQUA_SWR_FLOW,		"F/R Unit AQK Shower Flow",			IDC_AI_FR_UNIT_AQUA_DI_FLOW,		aiFR },
	{ CDicsView::viewJobPiping, IF_UNIT_FR,	 15, 15, -1, 	noFR_UNIT_TANK_DI_RESISTER,		"F/R Unit Tank DI Resistivity",		IDC_AI_FR_UNIT_TANK_RESISTANCE,		aiWR },
	{ CDicsView::viewJobPiping, IF_UNIT_FR,	 16, 16, -1, 	noFR_UNIT_DI_RESISTER,			"F/R Unit Main DI Resistivity",		IDC_AI_FR_UNIT_DI_RESISTANCE,		aiWR },
	{ CDicsView::viewJobPiping, IF_UNIT_AK,	 17, 17, -1, 	noAK_UNIT_UP_EXT_PRESS,			"A/K Unit Upper Exhaust Pressure",	IDC_AI_AK_UNIT_AK_UP_EXT_PRESS,		aiDM },
	{ CDicsView::viewJobPiping, IF_UNIT_AK,	 18, 18, -1, 	noAK_UNIT_LO_EXT_PRESS,			"A/K Unit Lower Exhaust Pressure",	IDC_AI_AK_UNIT_AK_LO_EXT_PRESS,		aiDM },
	{ CDicsView::viewJobPiping, IF_UNIT_AK,	 19, 19, -1, 	noAK_UNIT_UP_AK_CDA_PRESS,		"A/K Unit Upper AK CDA Pressure",	IDC_AI_AK_UNIT_AK_UP_CDA_PRESS,		aiPS },
	{ CDicsView::viewJobPiping, IF_UNIT_AK,	 20, 20, -1, 	noAK_UNIT_LO_AK_CDA_PRESS,		"A/K Unit Lower AK CDA Pressure",	IDC_AI_AK_UNIT_AK_LO_CDA_PRESS,		aiPS },
	{ CDicsView::viewJobPiping, IF_UNIT_AK,	 21, 21, -1, 	noAK_UNIT_UP_AK_CDA_FLOW,		"A/K Unit Upper AK CDA Flow",		IDC_AI_AK_UNIT_AK_UP_CDA_FLOW,		aiFR },
	{ CDicsView::viewJobPiping, IF_UNIT_AK,	 22, 22, -1, 	noAK_UNIT_LO_AK_CDA_FLOW,		"A/K Unit Lower AK CDA Flow",		IDC_AI_AK_UNIT_AK_LO_CDA_FLOW,		aiFR },
	{ CDicsView::viewJobPiping, IF_UNIT_RB,	 23, 23, -1, 	noUL_UNIT_SBJ1_CDA_PRESS,		"R/B(SBJ) Unit SBJ1 CDA Pressure",	IDC_AI_FR_UNIT_SBJ1_CDA_PRESS,		aiPS },
	{ CDicsView::viewJobPiping, IF_UNIT_FR,	 24, 24, -1, 	noUL_UNIT_SBJ2_CDA_PRESS,		"F/R Unit SBJ2 CDA Pressure",		IDC_AI_FR_UNIT_SBJ2_CDA_PRESS,		aiPS },
	{ CDicsView::viewJobPiping, IF_UNIT_FR,	 25, 25, -1, 	noUL_UNIT_SBJ3_CDA_PRESS,		"F/R Unit SBJ3 CDA Pressure",		IDC_AI_FR_UNIT_SBJ3_CDA_PRESS,		aiPS },
	{ CDicsView::viewJobPiping, IF_UNIT_LD,	 26, 26, -1, 	noUL_UNIT_DRIVING_AIR_PRESS,	"Driving Air Pressure",				IDC_AI_UL_UNIT_DRIVING_AIR_PRESS,	aiPS },
	{ CDicsView::viewJobPiping, IF_UNIT_FR,  27, 27, -1,	noFR_UNIT_TANK_LEVEL,			"F/R Unit DI Tank Level",			IDC_AI_FR_UNIT_TANK_LEVEL,			aiTL },
};

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
//--------------------------------------------------------------------
// constructor / destructor
//--------------------------------------------------------------------
CAnalogInput1::CAnalogInput1(CWnd* pOwner)
{
	m_pOwner = pOwner;

	m_nMaxApdAiNo	= 0;
	m_nMaxEdcAiNo	= 0;
	m_nMaxIntrAiNo	= 0;

	for( int i=0; i<MAX_ANALOG_IN_NO; i++ )
	{
		if( m_aiSet[i].nApdReportNo != -1 ) m_nMaxApdAiNo++;
		if( m_aiSet[i].nEdcReportNo != -1) m_nMaxEdcAiNo++;
		if( m_aiSet[i].nAiIntrNo != -1 ) m_nMaxIntrAiNo++;
	}
}

CAnalogInput1::~CAnalogInput1()
{

}

//--------------------------------------------------------------------
// Create the message box
//--------------------------------------------------------------------
void CAnalogInput1::CreateMsgBox(CWnd* pOwner)
{
//	m_pOwner = pOwner;
	for( int i=0; i<MAX_ANALOG_IN_NO; i++ )
	{
		CRect r;

		COLORREF	rgbBkColor;
		COLORREF	rgbTextColor = BLACK_COLOR;
		
		if( m_aiSet[i].nKind == aiPS ) rgbBkColor = LIGHT_CYAN_COLOR;
		else if( m_aiSet[i].nKind == aiFR ) rgbBkColor = LIGHT_RED_COLOR;
		else if( m_aiSet[i].nKind == aiDM ) rgbBkColor = LIGHT_YELLOW_COLOR;
		else if( m_aiSet[i].nKind == aiAM ) rgbBkColor = WHITE_COLOR;
		else if( m_aiSet[i].nKind == aiWR ) rgbBkColor = WHITE_COLOR;
		else if( m_aiSet[i].nKind == aiIC ) rgbBkColor = WHITE_COLOR;
		else if( m_aiSet[i].nKind == aiTL ) rgbBkColor = WHITE_COLOR;
		else if( m_aiSet[i].nKind == aiTM ) rgbBkColor = WHITE_COLOR;
		else if( m_aiSet[i].nKind == aiIL ) rgbBkColor = LIGHT_MAGENTA_COLOR;
		else rgbBkColor = WHITE_COLOR;

		CFormView* pView = NULL;
		if( m_aiSet[i].nOwnerViewNo == CDicsView::viewJobPiping )
		{
			 pView = ( (CDicsView*)m_pOwner )->m_pTabJobsPipingView;
		}

		// AI MSG ǥ (AC з)
		( pView->GetDlgItem( m_aiSet[i].uRESID ) )->GetWindowRect( &r );
		pView->ScreenToClient( &r );
		r -= CRect( 1, 1, 1, 1 );
		m_msgAI[i].Create( i, "0.0", WS_CHILD|WS_VISIBLE, r, pView, m_aiSet[i].uRESID,
			rgbBkColor, rgbTextColor, 14 );
	}
}

//--------------------------------------------------------------------
// Display a value in message box
//--------------------------------------------------------------------
void CAnalogInput1::SetOpMsg(int nID, float fVal )
{
	CString szMsg = "";

	if( m_aiSet[nID].nKind == aiPS ) szMsg.Format( "%3.1f kPa", fVal );
	else if( m_aiSet[nID].nKind == aiFR ) szMsg.Format( "%3.1f lpm", fVal );
	else if( m_aiSet[nID].nKind == aiDM ) szMsg.Format( "%3.1f Pa", fVal );
	else if( m_aiSet[nID].nKind == aiAM ) szMsg.Format( "%3.1f mm/s", fVal );
	else if( m_aiSet[nID].nKind == aiWR ) szMsg.Format( "%3.1f Mohm", fVal );
	else if( m_aiSet[nID].nKind == aiIC ) szMsg.Format( "%3.1f V", fVal );
	else if( m_aiSet[nID].nKind == aiTL ) szMsg.Format( "%3.1f L", fVal );
	else if( m_aiSet[nID].nKind == aiTM ) szMsg.Format( "%3.1f deg", fVal );
	else if( m_aiSet[nID].nKind == aiIL ) szMsg.Format( "%3.1f mW", fVal );

	m_msgAI[nID].SetOpMsg( szMsg );
}

// ljy_050220 : CAnalogInput1 -> 04HC30   Ϸ(1).
// ljy_050304 : CAnalogInput1 -> 04HC30   Ϸ(2).