// CommFlowMeter.h: interface for the CCommFlowMeter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMMFLOWMETER_H__020B74A6_26E5_4A7B_91B2_A81AE31AB3B3__INCLUDED_)
#define AFX_COMMFLOWMETER_H__020B74A6_26E5_4A7B_91B2_A81AE31AB3B3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "X\XCommThread.h"
#include "FactoryLib\EqpAssy.h"
#include "DicsData.h"	// 110726 halesu 

class CCommFlowMeter : public XCommThread  
{
public:
	void DataReceived();
	void SetDeviceNet( XCtlDevice * pDevice ){ m_pDevice = pDevice; }
	CCommFlowMeter();
	virtual ~CCommFlowMeter();

	enum ControlCharacters {
		ccSTX = 0x02,		// Start Byte
		ccETX = 0x03,		// End Byte
		ccENQ = 0x05,		// Request to Send
		ccEOT = 0x04,		// Request to Receive
		ccACK = 0x06,		// Correct Reception
		ccNAK = 0x15,		// Incorrect Reception
	};

	enum _TERMINATE_CODE{
		ccOK = 0x11,
		ccNG = 0x0F,
	};

	CEqpAssy*			m_pEqpAssy;
	CDicsData*			m_pDicsData;	// 110726 halesu
	void SetEqpAssy( CEqpAssy* pEqpAssy )						{ m_pEqpAssy = pEqpAssy; }
	void SetData(CDicsData* pData)								{ m_pDicsData	= pData; }	// 110726 halesu

public:
	void Reset();
	void SendCommand( int nNo );
	void SetLog(CString sSeqName, int nPortNo, int nSlotNo, CString sMessage);
	int		m_nTerminateCode;
	float	m_fIntegralFlow;
	float	m_fCurFlowrate;
	BOOL	m_bSendCommand;
	CString m_sSendData;

	XCtlDevice* m_pDevice;
};

#endif // !defined(AFX_COMMFLOWMETER_H__020B74A6_26E5_4A7B_91B2_A81AE31AB3B3__INCLUDED_)
