// CommFlowMeter2.cpp: implementation of the CCommFlowMeter2 class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "dics.h"
#include "CommFlowMeter2.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCommFlowMeter2::CCommFlowMeter2()
{
	m_fIntegralFlow = 0.f;
	m_fCurFlowrate = 0.f;
	m_bSendCommand = FALSE;
}

CCommFlowMeter2::~CCommFlowMeter2()
{

}

void CCommFlowMeter2::DataReceived()
{
	if( !m_bSendCommand )
		return;
	else
		m_bSendCommand = FALSE;
	char buf[256];
	Sleep( 20 );
	
	int nLen = XComm::Read( buf, 1 );
//	m_sReceivedData = CString( buf );
//	SetLog( "RCVD FM2", 0, 0, m_sReceivedData );

	if( nLen > 0 )
	{
		if( buf[0] == ccSTX )
		{
			nLen = XComm::Read( buf, 18 );
			if( buf[17] == ccETX && nLen == 18 ) 
			{
				m_sReceivedData = CString( buf );
//				SetLog( "RCVD", 0, 0, m_sReceivedData );
				char cChar = m_sReceivedData.GetAt( 2 );	// 091007 ssm
				if( cChar == ccOK )
				{
					CString sBuf;
					int nPoint;
					//  Data
					sBuf = m_sReceivedData.Mid( 3, 6 );
					nPoint = atoi( m_sReceivedData.Mid( 9, 1 ) );
					sBuf.Insert( 6 - nPoint, "." );
					m_fCurFlowrate = (float)atof( sBuf );
					//  Data
					sBuf = m_sReceivedData.Mid( 10, 6 );
					nPoint = atoi( m_sReceivedData.Mid( 16, 1 ) );
					sBuf.Insert( 6 - nPoint, "." );
					float fVal = (float)atof( sBuf );
//					m_fIntegralFlow = (float)(( fVal / 0.41 ) * 20);
					m_fIntegralFlow = fVal;
					m_pDicsData->fTotalFlowMeter[1]	= m_fIntegralFlow;	// 110726 halesu
				}
				else if( cChar == ccNG )	
				{
					AfxMessageBox("Receive Data NG");
				}
			}
		}
	}
}

void CCommFlowMeter2::SetLog(CString sSeqName, int nPortNo, int nSlotNo, CString sMessage)
{
	// Log
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	m_sMessage.Format( "FLOW\t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( m_sMessage );

	m_sMessage.Format( "%s : %s", sSeqName, sMessage );
	Msg( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) m_sMessage );
}

void CCommFlowMeter2::SendCommand(int nNo)
{
	FlushTx();
	m_sSendData.Format( "%C%02dDATA?%C", ccSTX, nNo, ccETX );
	m_bSendCommand = Write( (LPCTSTR)m_sSendData );
	
//	if( m_bSendCommand ) SetLog( "SEND FM2", 0, 0, "Send OK" );
	return;
}

void CCommFlowMeter2::Reset()
{
	m_fIntegralFlow = 0.f;
	m_fCurFlowrate = 0.f; 
}

