//jemoon : 060310
//for GlassData Delete and Recovery

#include "stdafx.h"
#include "..\dics.h"
#include "DaoLostGlassSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDaoLostGlassListSet

IMPLEMENT_DYNAMIC(CDaoLostGlassListSet, CDaoRecordset)

CDaoLostGlassListSet::CDaoLostGlassListSet(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CDaoLostGlassListSet)
	m_NO = 0;
	m_GLASS_DATA1 = 0;
	m_GLASS_DATA2 = 0;
	m_GLASS_DATA3 = 0;
	m_GLASS_DATA4 = 0;
	m_GLASS_DATA5 = 0;
	m_GLASS_DATA6 = 0;
	m_GLASS_DATA7 = 0;
	m_GLASS_DATA8 = 0;
	m_GLASS_DATA9 = 0;
	m_GLASS_DATA10 = 0;
	m_nFields = 11;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}


CString CDaoLostGlassListSet::GetDefaultDBName()
{
	return _T("D:\\DICS\\Database\\dics_lostglass.mdb");
}

CString CDaoLostGlassListSet::GetDefaultSQL()
{
	return _T("[LostGlassList]");
}

void CDaoLostGlassListSet::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CDaoLostGlassListSet)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Long(pFX, _T("[Id]"), m_NO);
	DFX_Long(pFX, _T("[GlassData1]"), m_GLASS_DATA1);
	DFX_Long(pFX, _T("[GlassData2]"), m_GLASS_DATA2);
	DFX_Long(pFX, _T("[GlassData3]"), m_GLASS_DATA3);
	DFX_Long(pFX, _T("[GlassData4]"), m_GLASS_DATA4);
	DFX_Long(pFX, _T("[GlassData5]"), m_GLASS_DATA5);
	DFX_Long(pFX, _T("[GlassData6]"), m_GLASS_DATA6);
	DFX_Long(pFX, _T("[GlassData7]"), m_GLASS_DATA7);
	DFX_Long(pFX, _T("[GlassData8]"), m_GLASS_DATA8);
	DFX_Long(pFX, _T("[GlassData9]"), m_GLASS_DATA9);
	DFX_Long(pFX, _T("[GlassData10]"), m_GLASS_DATA10);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CDaoLostGlassListSet diagnostics

#ifdef _DEBUG
void CDaoLostGlassListSet::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CDaoLostGlassListSet::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG

//---------------------------------------------------------------------------------
//Add New LostGlassData at last record
//---------------------------------------------------------------------------------
BOOL CDaoLostGlassListSet::AddGlassData(CGlassInfo& glsInfo)
{
	AddNew();
	m_NO 		  = GetRecordCount()+1;
	m_GLASS_DATA1 = glsInfo.nGlassData[0];
	m_GLASS_DATA2 = glsInfo.nGlassData[1];
	m_GLASS_DATA3 = glsInfo.nGlassData[2];
	m_GLASS_DATA4 = glsInfo.nGlassData[3];
	m_GLASS_DATA5 = glsInfo.nGlassData[4];
	//m_GLASS_DATA6 = glsInfo.nGlassData[5];
	//m_GLASS_DATA7 = glsInfo.nGlassData[6];
	//m_GLASS_DATA8 = glsInfo.nGlassData[7];
	//m_GLASS_DATA9 = glsInfo.nGlassData[8];
	//m_GLASS_DATA10 = glsInfo.nGlassData[14];	// Data for LD/ULD
	Update();
	Requery();
	return TRUE;
}

//---------------------------------------------------------------------------------
// Delete LostGlassData
//---------------------------------------------------------------------------------
BOOL CDaoLostGlassListSet::DelGlassData(int no)
{
	CString sBuf;
	
	sBuf.Format( "id = %d", no);
	BOOL bOk = 	Find( AFX_DAO_FIRST, sBuf );
	if( !bOk ) return FALSE;

	Delete();

	MoveFirst();
	while( !IsEOF() )
	{
		if(m_NO < no) ;
		else
		{
			Edit();
			m_NO -= 1;
			Update();
		}

		MoveNext();
	}	
	if(GetRecordCount()) MoveFirst();
	return TRUE;
}

//--------------------------------------------------------------------
// GetLostGlassListRowCount()
//--------------------------------------------------------------------
int CDaoLostGlassListSet::GetLostGlassListRowCount()
{
	if( !IsOpen() ) return 0;

	int nRow = 0;

	if( IsEOF() )	return nRow;

	MoveFirst();
	while( !IsEOF() ) { nRow++; MoveNext(); }	

	MoveFirst();
	return nRow;
}

void CDaoLostGlassListSet::GetLostGlassInfo(int nNo, CGlassInfo& glsInfo)
{
	if( FindLostGlassList( nNo ) )
	{
		glsInfo.nGlassData[0] = (short)m_GLASS_DATA1;
		glsInfo.nGlassData[1] = (short)m_GLASS_DATA2;
		glsInfo.nGlassData[2] = (short)m_GLASS_DATA3;
		glsInfo.nGlassData[3] = (short)m_GLASS_DATA4;
		glsInfo.nGlassData[4] = (short)m_GLASS_DATA5;
		//glsInfo.nGlassData[5] = (short)m_GLASS_DATA6;
		//glsInfo.nGlassData[6] = (short)m_GLASS_DATA7;
		//glsInfo.nGlassData[7] = (short)m_GLASS_DATA8;
		//glsInfo.nGlassData[8] = (short)m_GLASS_DATA9;
		//glsInfo.nGlassData[14] = (short)m_GLASS_DATA10;	// Data for LD/ULD
	}
}
 
//--------------------------------------------------------------------
// FindReasonCode()
//--------------------------------------------------------------------
BOOL CDaoLostGlassListSet::FindLostGlassList(int no)
{
	if( !IsOpen() ) return FALSE;

	MoveFirst();

	while(1)
	{
		if( IsEOF() ) return FALSE;
		if( m_NO == no ) break;
		MoveNext();
	}

	return TRUE;
}

