// daoerrhistset.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "daoerrhistset.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDaoErrHistSet

IMPLEMENT_DYNAMIC(CDaoErrHistSet, CDaoRecordset)

CDaoErrHistSet::CDaoErrHistSet(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CDaoErrHistSet)
	m_ID = 0;
	m_ErrorTime = (DATE)0;
	m_ErrorID = 0;
	m_ErrorLevel = _T("");
	m_ErrorContent = _T("");
	m_nFields = 5;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}


CString CDaoErrHistSet::GetDefaultDBName()
{
	return _T("D:\\DICS\\Database\\Dics_error.mdb");
}

CString CDaoErrHistSet::GetDefaultSQL()
{
	return _T("[ErrorHistory]");
}

void CDaoErrHistSet::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CDaoErrHistSet)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Long(pFX, _T("[ID]"), m_ID);
	DFX_DateTime(pFX, _T("[ErrorTime]"), m_ErrorTime);
	DFX_Long(pFX, _T("[ErrorID]"), m_ErrorID);
	DFX_Text(pFX, _T("[ErrorLevel]"), m_ErrorLevel);
	DFX_Text(pFX, _T("[ErrorContent]"), m_ErrorContent);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CDaoErrHistSet diagnostics

#ifdef _DEBUG
void CDaoErrHistSet::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CDaoErrHistSet::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG

//---------------------------------------------------------------------------------
//ο  ͸ ڵ  ÷Ѵ.
//---------------------------------------------------------------------------------
BOOL CDaoErrHistSet::AddErrData(int nCode, LPCTSTR szErr, LPCTSTR szLevel)
{
	COleDateTime CurTime = COleDateTime::GetCurrentTime();	//  ð   
	AddNew();
	m_ErrorID = nCode;
	m_ErrorContent = szErr;
	m_ErrorLevel = szLevel;
	m_ErrorTime = CurTime;	//  ð Update
	Update();
//	Requery();

//	//  Ⱓ  Data ϴ Code ߰
	CString sFilter;
	COleDateTimeSpan dtSpan( 365, 0, 0, 0 );	// 1 year
	COleDateTime dtTime = CurTime - dtSpan;
	sFilter.Format( "[ErrorTime] <= #%04d/%02d/%02d#", dtTime.GetYear(), dtTime.GetMonth(), dtTime.GetDay() );
	m_strFilter = sFilter;
	Requery();

	if( GetRecordCount() ) MoveFirst();
	while( !IsEOF() ) 
	{
#ifdef _MY_DEBUG
		TRACE( "ERROR TIME = %04d:%02d:%02d, ERROR ID = %d\n", m_ErrorTime.GetYear(), m_ErrorTime.GetMonth(), m_ErrorTime.GetDay(), nCode );
#endif
		Delete();
		MoveNext();
	}

	m_strFilter = "";
	Requery();

	return TRUE;
}

//---------------------------------------------------------------------------------
// no ޵ recordset   ͸ Ѵ.
//---------------------------------------------------------------------------------
BOOL CDaoErrHistSet::DelErrData(int nIndex)
{
	CString sBuf;
	sBuf.Format( "ID = %d", nIndex );
	Find( AFX_DAO_FIRST, sBuf );
	Delete();

//	MoveFirst();
//	int nID = m_ID;
//
//	while( !IsEOF() )
//	{
//		if( m_ID <= nID + nIndex ) Delete();	// Delete() Լ Edit()/AddNew() - Update()  ʿ.
//		else if( m_ID > nID + nIndex ) break;
//		MoveNext();
//	}
	return TRUE;
}
