// daorecipeset.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "..\Define.h"
#include "daorecipeset.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDaoRecipeSet

IMPLEMENT_DYNAMIC(CDaoRecipeSet, CDaoRecordset)

CDaoRecipeSet::CDaoRecipeSet(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CDaoRecipeSet)
	m_ID = _T("");
	m_CHANGE_TIME = (DATE)0;
	m_COMMENT = _T("");
	m_TACT_TIME = 0;
	m_CONV_SPEED = 0;
	m_JOB_PROCESS_ON_OFF = FALSE;
	m_SWR2_UPPER_RB1_ON_OFF = FALSE;
	m_SWR2_LOWER_RB1_ON_OFF = FALSE;
	m_SWR2_UPPER_RB2_ON_OFF = FALSE;
	m_SWR2_LOWER_RB2_ON_OFF = FALSE;
	m_SWR3_UPPER_RB1_ON_OFF = FALSE;
	m_SWR3_LOWER_RB1_ON_OFF = FALSE;
	m_SWR3_UPPER_RB2_ON_OFF = FALSE;
	m_SWR3_LOWER_RB2_ON_OFF = FALSE;
	m_SWR2_UPPER_RB1_DIRECTION = FALSE;
	m_SWR2_LOWER_RB1_DIRECTION = FALSE;
	m_SWR2_UPPER_RB2_DIRECTION = FALSE;
	m_SWR2_LOWER_RB2_DIRECTION = FALSE;
	m_SWR3_UPPER_RB1_DIRECTION = FALSE;
	m_SWR3_LOWER_RB1_DIRECTION = FALSE;
	m_SWR3_UPPER_RB2_DIRECTION = FALSE;
	m_SWR3_LOWER_RB2_DIRECTION = FALSE;
	m_SWR2_UPPER_RB1_SPEED = 0;
	m_SWR2_LOWER_RB1_SPEED = 0;
	m_SWR2_UPPER_RB2_SPEED = 0;
	m_SWR2_LOWER_RB2_SPEED = 0;
	m_SWR3_UPPER_RB1_SPEED = 0;
	m_SWR3_LOWER_RB1_SPEED = 0;
	m_SWR3_UPPER_RB2_SPEED = 0;
	m_SWR3_LOWER_RB2_SPEED = 0;
	m_SWR2_UPPER_RB1_GAP = 0.0f;
	m_SWR2_LOWER_RB1_GAP = 0.0f;
	m_SWR2_UPPER_RB2_GAP = 0.0f;
	m_SWR2_LOWER_RB2_GAP = 0.0f;
	m_SWR3_UPPER_RB1_GAP = 0.0f;
	m_SWR3_LOWER_RB1_GAP = 0.0f;
	m_SWR3_UPPER_RB2_GAP = 0.0f;
	m_SWR3_LOWER_RB2_GAP = 0.0f;
	m_nFields = MAX_RECIPE_BODY_NO;		
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}


CString CDaoRecipeSet::GetDefaultDBName()
{
	return _T("D:\\DICS\\Database\\Dics_recipe.mdb");
}

CString CDaoRecipeSet::GetDefaultSQL()
{
	return _T("[Recipe]");
}

void CDaoRecipeSet::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CDaoRecipeSet)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Text(pFX,	_T("[ID]"), m_ID);
	DFX_DateTime(pFX, _T("[CHANGE TIME]"), m_CHANGE_TIME);
	DFX_Text(pFX,	_T("[COMMENT]"), m_COMMENT);
	DFX_Long(pFX,	_T("[TACT TIME (sec)]"), m_TACT_TIME);
	DFX_Long(pFX,	_T("[CONV SPEED (mm/min)]"), m_CONV_SPEED);
	DFX_Bool(pFX,	_T("[JOB PROCESS ON / OFF]"),	m_JOB_PROCESS_ON_OFF);	
	DFX_Bool(pFX,	_T("[SWR2 UP RB1 ON / OFF]"),	m_SWR2_UPPER_RB1_ON_OFF);
	DFX_Bool(pFX,	_T("[SWR2 LO RB1 ON / OFF]"),	m_SWR2_LOWER_RB1_ON_OFF);
	DFX_Bool(pFX,	_T("[SWR2 UP RB2 ON / OFF]"),	m_SWR2_UPPER_RB2_ON_OFF);
	DFX_Bool(pFX,	_T("[SWR2 LO RB2 ON / OFF]"),	m_SWR2_LOWER_RB2_ON_OFF);
	DFX_Bool(pFX,	_T("[SWR3 UP RB1 ON / OFF]"),	m_SWR3_UPPER_RB1_ON_OFF);
	DFX_Bool(pFX,	_T("[SWR3 LO RB1 ON / OFF]"),	m_SWR3_LOWER_RB1_ON_OFF);
	DFX_Bool(pFX,	_T("[SWR3 UP RB2 ON / OFF]"),	m_SWR3_UPPER_RB2_ON_OFF);
	DFX_Bool(pFX,	_T("[SWR3 LO RB2 ON / OFF]"),	m_SWR3_LOWER_RB2_ON_OFF);
	DFX_Bool(pFX,	_T("[SWR2 UP RB1 DIRECTION]"),	m_SWR2_UPPER_RB1_DIRECTION);
	DFX_Bool(pFX,	_T("[SWR2 LO RB1 DIRECTION]"),	m_SWR2_LOWER_RB1_DIRECTION);
	DFX_Bool(pFX,	_T("[SWR2 UP RB2 DIRECTION]"),	m_SWR2_UPPER_RB2_DIRECTION);
	DFX_Bool(pFX,	_T("[SWR2 LO RB2 DIRECTION]"),	m_SWR2_LOWER_RB2_DIRECTION);
	DFX_Bool(pFX,	_T("[SWR3 UP RB1 DIRECTION]"),	m_SWR3_UPPER_RB1_DIRECTION);
	DFX_Bool(pFX,	_T("[SWR3 LO RB1 DIRECTION]"),	m_SWR3_LOWER_RB1_DIRECTION);
	DFX_Bool(pFX,	_T("[SWR3 UP RB2 DIRECTION]"),	m_SWR3_UPPER_RB2_DIRECTION);
	DFX_Bool(pFX,	_T("[SWR3 LO RB2 DIRECTION]"),	m_SWR3_LOWER_RB2_DIRECTION);
	DFX_Long(pFX,	_T("[SWR2 UP RB1 SPEED(rpm)]"),	m_SWR2_UPPER_RB1_SPEED);
	DFX_Long(pFX,	_T("[SWR2 LO RB1 SPEED(rpm)]"),	m_SWR2_LOWER_RB1_SPEED);
	DFX_Long(pFX,	_T("[SWR2 UP RB2 SPEED(rpm)]"),	m_SWR2_UPPER_RB2_SPEED);
	DFX_Long(pFX,	_T("[SWR2 LO RB2 SPEED(rpm)]"),	m_SWR2_LOWER_RB2_SPEED);
	DFX_Long(pFX,	_T("[SWR3 UP RB1 SPEED(rpm)]"),	m_SWR3_UPPER_RB1_SPEED);
	DFX_Long(pFX,	_T("[SWR3 LO RB1 SPEED(rpm)]"),	m_SWR3_LOWER_RB1_SPEED);
	DFX_Long(pFX,	_T("[SWR3 UP RB2 SPEED(rpm)]"),	m_SWR3_UPPER_RB2_SPEED);
	DFX_Long(pFX,	_T("[SWR3 LO RB2 SPEED(rpm)]"),	m_SWR3_LOWER_RB2_SPEED);
	DFX_Single(pFX, _T("[SWR2 UP RB1 GAP (mm)]"),	m_SWR2_UPPER_RB1_GAP);
	DFX_Single(pFX, _T("[SWR2 LO RB1 GAP (mm)]"),	m_SWR2_LOWER_RB1_GAP);
	DFX_Single(pFX, _T("[SWR2 UP RB2 GAP (mm)]"),	m_SWR2_UPPER_RB2_GAP);
	DFX_Single(pFX, _T("[SWR2 LO RB2 GAP (mm)]"),	m_SWR2_LOWER_RB2_GAP);
	DFX_Single(pFX, _T("[SWR3 UP RB1 GAP (mm)]"),	m_SWR3_UPPER_RB1_GAP);
	DFX_Single(pFX, _T("[SWR3 LO RB1 GAP (mm)]"),	m_SWR3_LOWER_RB1_GAP);
	DFX_Single(pFX, _T("[SWR3 UP RB2 GAP (mm)]"),	m_SWR3_UPPER_RB2_GAP);
	DFX_Single(pFX, _T("[SWR3 LO RB2 GAP (mm)]"),	m_SWR3_LOWER_RB2_GAP);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CDaoRecipeSet diagnostics

#ifdef _DEBUG
void CDaoRecipeSet::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CDaoRecipeSet::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG

//--------------------------------------------------------------------
// GetRecipeInfo()
//	Field 0 : [ID]
//	Field 1 : [CHANGE TIME]
//	Field 2 : [COMMENT]
//	Field 3 : [TACT TIME]
//	Field 4 : [CONV SPEED]
//  Field 5 : [JOB PROCESS ON / OFF]
//	Field 6 :  [SWR2 UPPER RB1 ON/OFF]
//	Field 7 :  [SWR2 LOWER RB1 ON/OFF]
//	Field 8 :  [SWR2 UPPER RB2 ON/OFF]
//	Field 9 :  [SWR2 LOWER RB2 ON/OFF]
//	Field 10 : [SWR3 UPPER RB1 ON/OFF]
//	Field 11 : [SWR3 LOWER RB1 ON/OFF]
//	Field 12 : [SWR3 UPPER RB2 ON/OFF]
//	Field 13 : [SWR3 LOWER RB2 ON/OFF]
//	Field 14 :  [SWR2 UPPER RB1 DIRECTION]
//	Field 15 : [SWR2 LOWER RB1 DIRECTION]
//	Field 16 : [SWR2 UPPER RB2 DIRECTION]
//	Field 17 : [SWR2 LOWER RB2 DIRECTION]
//	Field 18 : [SWR3 UPPER RB1 DIRECTION]
//	Field 19 : [SWR3 LOWER RB1 DIRECTION]
//	Field 20 : [SWR3 UPPER RB2 DIRECTION]
//	Field 21 : [SWR3 LOWER RB2 DIRECTION]
//	Field 22 : [SWR3 UPPER RB1 SPEED]
//	Field 23 : [SWR3 LOWER RB1 SPEED]
//	Field 24 : [SWR3 UPPER RB2 SPEED]
//	Field 25 : [SWR3 LOWER RB2 SPEED]
//	Field 26 : [SWR2 UPPER RB1 SPEED]
//	Field 27 : [SWR2 LOWER RB1 SPEED]
//	Field 28 : [SWR2 UPPER RB2 SPEED]
//	Field 29 : [SWR2 LOWER RB2 SPEED]
//	Field 30 : [SWR2 UPPER RB1 GAP]
//	Field 31 : [SWR2 LOWER RB1 GAP]
//	Field 32 : [SWR2 UPPER RB2 GAP]
//	Field 33 : [SWR2 LOWER RB2 GAP]
//	Field 34 : [SWR3 UPPER RB1 GAP]
//	Field 35 : [SWR3 LOWER RB1 GAP]
//	Field 36 : [SWR3 UPPER RB2 GAP]
//	Field 37 : [SWR3 LOWER RB2 GAP]
// You have to follow the order as above.
//--------------------------------------------------------------------
RECIPE_INFO CDaoRecipeSet::GetRecipeInfo(int nID)
{
	MoveFirst();
	Move( nID );
	
	RECIPE_INFO RecipeInfo;

//	if( FindRecipe( nID ) )
	{
		// Set Value
		int i = 0;
		RecipeInfo.sValue[i++].Format( "%s", m_ID );

		RecipeInfo.dtChangeTime	= m_CHANGE_TIME;
		RecipeInfo.sValue[i++].Format( "%02d/%02d/%02d %02d:%02d:%02d", 
			m_CHANGE_TIME.GetYear(),
			m_CHANGE_TIME.GetMonth(),
			m_CHANGE_TIME.GetDay(),
			m_CHANGE_TIME.GetHour(),
			m_CHANGE_TIME.GetMinute(),
			m_CHANGE_TIME.GetSecond() );

		RecipeInfo.sValue[i++]	= m_COMMENT;
		RecipeInfo.sValue[i++].Format( "%d", m_TACT_TIME );
		RecipeInfo.sValue[i++].Format( "%d", m_CONV_SPEED );
		RecipeInfo.sValue[i++].Format( "%s", m_JOB_PROCESS_ON_OFF ? "ON" : "OFF" );

		RecipeInfo.sValue[i++].Format( "%s", m_SWR2_UPPER_RB1_ON_OFF ? "ON" : "OFF" );
		RecipeInfo.sValue[i++].Format( "%s", m_SWR2_LOWER_RB1_ON_OFF ? "ON" : "OFF" );
		RecipeInfo.sValue[i++].Format( "%s", m_SWR2_UPPER_RB2_ON_OFF ? "ON" : "OFF" );
		RecipeInfo.sValue[i++].Format( "%s", m_SWR2_LOWER_RB2_ON_OFF ? "ON" : "OFF" );

		RecipeInfo.sValue[i++].Format( "%s", m_SWR3_UPPER_RB1_ON_OFF ? "ON" : "OFF" );
		RecipeInfo.sValue[i++].Format( "%s", m_SWR3_LOWER_RB1_ON_OFF ? "ON" : "OFF" );
		RecipeInfo.sValue[i++].Format( "%s", m_SWR3_UPPER_RB2_ON_OFF ? "ON" : "OFF" );
		RecipeInfo.sValue[i++].Format( "%s", m_SWR3_LOWER_RB2_ON_OFF ? "ON" : "OFF" );

		RecipeInfo.sValue[i++].Format( "%s", m_SWR2_UPPER_RB1_DIRECTION ? "CW" : "CCW" );
		RecipeInfo.sValue[i++].Format( "%s", m_SWR2_LOWER_RB1_DIRECTION ? "CW" : "CCW" );
		RecipeInfo.sValue[i++].Format( "%s", m_SWR2_UPPER_RB2_DIRECTION ? "CW" : "CCW" );
		RecipeInfo.sValue[i++].Format( "%s", m_SWR2_LOWER_RB2_DIRECTION ? "CW" : "CCW" );

		RecipeInfo.sValue[i++].Format( "%s", m_SWR3_UPPER_RB1_DIRECTION ? "CW" : "CCW" );
		RecipeInfo.sValue[i++].Format( "%s", m_SWR3_LOWER_RB1_DIRECTION ? "CW" : "CCW" );
		RecipeInfo.sValue[i++].Format( "%s", m_SWR3_UPPER_RB2_DIRECTION ? "CW" : "CCW" );
		RecipeInfo.sValue[i++].Format( "%s", m_SWR3_LOWER_RB2_DIRECTION ? "CW" : "CCW" );

		RecipeInfo.sValue[i++].Format( "%d", m_SWR2_UPPER_RB1_SPEED );
		RecipeInfo.sValue[i++].Format( "%d", m_SWR2_LOWER_RB1_SPEED );
		RecipeInfo.sValue[i++].Format( "%d", m_SWR2_UPPER_RB2_SPEED );
		RecipeInfo.sValue[i++].Format( "%d", m_SWR2_LOWER_RB2_SPEED );

		RecipeInfo.sValue[i++].Format( "%d", m_SWR3_UPPER_RB1_SPEED );
		RecipeInfo.sValue[i++].Format( "%d", m_SWR3_LOWER_RB1_SPEED );
		RecipeInfo.sValue[i++].Format( "%d", m_SWR3_UPPER_RB2_SPEED );
		RecipeInfo.sValue[i++].Format( "%d", m_SWR3_LOWER_RB2_SPEED );

		RecipeInfo.sValue[i++].Format( "%3.1f", m_SWR2_UPPER_RB1_GAP );
		RecipeInfo.sValue[i++].Format( "%3.1f", m_SWR2_LOWER_RB1_GAP );
		RecipeInfo.sValue[i++].Format( "%3.1f", m_SWR2_UPPER_RB2_GAP );
		RecipeInfo.sValue[i++].Format( "%3.1f", m_SWR2_LOWER_RB2_GAP );

		RecipeInfo.sValue[i++].Format( "%3.1f", m_SWR3_UPPER_RB1_GAP );
		RecipeInfo.sValue[i++].Format( "%3.1f", m_SWR3_LOWER_RB1_GAP );
		RecipeInfo.sValue[i++].Format( "%3.1f", m_SWR3_UPPER_RB2_GAP );
		RecipeInfo.sValue[i++].Format( "%3.1f", m_SWR3_LOWER_RB2_GAP );

		CDaoFieldInfo FieldInfo;
		for( i=0; i<MAX_RECIPE_BODY_NO; i++ )
		{
			GetFieldInfo( i, FieldInfo );
			RecipeInfo.sName[i] = FieldInfo.m_strName;
		}
	}
	return RecipeInfo;
}

//--------------------------------------------------------------------
// SetRecipeInfo()
//--------------------------------------------------------------------
int CDaoRecipeSet::SetRecipeInfo(CString sID, RECIPE_INFO& RecipeInfo)
{
	if( !FindRecipe( sID ) ) return -1;

	Edit();

	int nRv = 0;
	int i = 0;
	// Set Value
	m_ID			= RecipeInfo.sValue[0];
	i++;
	m_CHANGE_TIME	= RecipeInfo.dtChangeTime;

	RecipeInfo.sValue[i++].Format( "%02d/%02d/%02d %02d:%02d:%02d", 
			m_CHANGE_TIME.GetYear(),
			m_CHANGE_TIME.GetMonth(),
			m_CHANGE_TIME.GetDay(),
			m_CHANGE_TIME.GetHour(),
			m_CHANGE_TIME.GetMinute(),
			m_CHANGE_TIME.GetSecond() );

	m_COMMENT		= RecipeInfo.sValue[i++];
	
	m_TACT_TIME		= atoi( RecipeInfo.sValue[i++] );
	m_CONV_SPEED	= atoi( RecipeInfo.sValue[i++] );
	m_JOB_PROCESS_ON_OFF	= ( RecipeInfo.sValue[i++] == "ON" ) ? 1 : 0;
// 	m_EUV1_ON_OFF	= ( RecipeInfo.sValue[i++] == "ON" ) ? 1 : 0;
// 	m_EUV2_ON_OFF	= ( RecipeInfo.sValue[i++] == "ON" ) ? 1 : 0;
// 	m_EUV3_ON_OFF	= ( RecipeInfo.sValue[i++] == "ON" ) ? 1 : 0;
// 	m_EUV4_ON_OFF	= ( RecipeInfo.sValue[i++] == "ON" ) ? 1 : 0;

	m_SWR2_UPPER_RB1_ON_OFF	= ( RecipeInfo.sValue[i++] == "ON" ) ? 1 : 0;
	m_SWR2_LOWER_RB1_ON_OFF	= ( RecipeInfo.sValue[i++] == "ON" ) ? 1 : 0;
	m_SWR2_UPPER_RB2_ON_OFF	= ( RecipeInfo.sValue[i++] == "ON" ) ? 1 : 0;
	m_SWR2_LOWER_RB2_ON_OFF	= ( RecipeInfo.sValue[i++] == "ON" ) ? 1 : 0;

	m_SWR3_UPPER_RB1_ON_OFF	= ( RecipeInfo.sValue[i++] == "ON" ) ? 1 : 0;
	m_SWR3_LOWER_RB1_ON_OFF	= ( RecipeInfo.sValue[i++] == "ON" ) ? 1 : 0;
	m_SWR3_UPPER_RB2_ON_OFF	= ( RecipeInfo.sValue[i++] == "ON" ) ? 1 : 0;
	m_SWR3_LOWER_RB2_ON_OFF	= ( RecipeInfo.sValue[i++] == "ON" ) ? 1 : 0;

	m_SWR2_UPPER_RB1_DIRECTION	= ( RecipeInfo.sValue[i++] == "CW" ) ? 1 : 0;
	m_SWR2_LOWER_RB1_DIRECTION	= ( RecipeInfo.sValue[i++] == "CW" ) ? 1 : 0;
	m_SWR2_UPPER_RB2_DIRECTION	= ( RecipeInfo.sValue[i++] == "CW" ) ? 1 : 0;
	m_SWR2_LOWER_RB2_DIRECTION	= ( RecipeInfo.sValue[i++] == "CW" ) ? 1 : 0;

	m_SWR3_UPPER_RB1_DIRECTION	= ( RecipeInfo.sValue[i++] == "CW" ) ? 1 : 0;
	m_SWR3_LOWER_RB1_DIRECTION	= ( RecipeInfo.sValue[i++] == "CW" ) ? 1 : 0;
	m_SWR3_UPPER_RB2_DIRECTION	= ( RecipeInfo.sValue[i++] == "CW" ) ? 1 : 0;
	m_SWR3_LOWER_RB2_DIRECTION	= ( RecipeInfo.sValue[i++] == "CW" ) ? 1 : 0;

	m_SWR2_UPPER_RB1_SPEED	= atoi( RecipeInfo.sValue[i++] );
	m_SWR2_LOWER_RB1_SPEED	= atoi( RecipeInfo.sValue[i++] );
	m_SWR2_UPPER_RB2_SPEED	= atoi( RecipeInfo.sValue[i++] );
	m_SWR2_LOWER_RB2_SPEED	= atoi( RecipeInfo.sValue[i++] );

	m_SWR3_UPPER_RB1_SPEED	= atoi( RecipeInfo.sValue[i++] );
	m_SWR3_LOWER_RB1_SPEED	= atoi( RecipeInfo.sValue[i++] );
	m_SWR3_UPPER_RB2_SPEED	= atoi( RecipeInfo.sValue[i++] );
	m_SWR3_LOWER_RB2_SPEED	= atoi( RecipeInfo.sValue[i++] );

	m_SWR2_UPPER_RB1_GAP	= (float)atof( RecipeInfo.sValue[i++] );
	m_SWR2_LOWER_RB1_GAP	= (float)atof( RecipeInfo.sValue[i++] );
	m_SWR2_UPPER_RB2_GAP	= (float)atof( RecipeInfo.sValue[i++] );
	m_SWR2_LOWER_RB2_GAP	= (float)atof( RecipeInfo.sValue[i++] );

	m_SWR3_UPPER_RB1_GAP	= (float)atof( RecipeInfo.sValue[i++] );
	m_SWR3_LOWER_RB1_GAP	= (float)atof( RecipeInfo.sValue[i++] );
	m_SWR3_UPPER_RB2_GAP	= (float)atof( RecipeInfo.sValue[i++] );
	m_SWR3_LOWER_RB2_GAP	= (float)atof( RecipeInfo.sValue[i++] );

	Update();
	return nRv;
}

//--------------------------------------------------------------------
// FindRecipe()
//--------------------------------------------------------------------
BOOL CDaoRecipeSet::FindRecipe(CString sID)
{
	if( !IsOpen() ) return FALSE;

	MoveFirst();

	while(1)
	{
		if( IsEOF() ) return FALSE;
//		if( m_ID == sID ) break;
		if( atoi( m_ID ) == atoi( sID ) ) break;
		MoveNext();
	}

	return TRUE;
}

//--------------------------------------------------------------------
// GetRecipeRowCount()
//--------------------------------------------------------------------
int CDaoRecipeSet::GetRecipeRowCount()
{
	if( !IsOpen() ) return 0;

	int nRow = 0;

	MoveFirst();
	while( !IsEOF() ) { nRow++; MoveNext(); }	
	return nRow;
}

void CDaoRecipeSet::AddRecipeId(CString sID)
{
	AddNew();
	m_ID = sID;
	m_CHANGE_TIME	= (DATE)(COleDateTime::GetCurrentTime());
	m_COMMENT		= _T("");
	m_TACT_TIME		= 55;
	m_CONV_SPEED	= 4200;
	m_JOB_PROCESS_ON_OFF = TRUE;
	m_SWR2_UPPER_RB1_ON_OFF = FALSE;
	m_SWR2_LOWER_RB1_ON_OFF = FALSE;
	m_SWR2_UPPER_RB2_ON_OFF = FALSE;
	m_SWR2_LOWER_RB2_ON_OFF = FALSE;
	m_SWR3_UPPER_RB1_ON_OFF = FALSE;
	m_SWR3_LOWER_RB1_ON_OFF = FALSE;
	m_SWR3_UPPER_RB2_ON_OFF = FALSE;
	m_SWR3_LOWER_RB2_ON_OFF = FALSE;
	m_SWR2_UPPER_RB1_DIRECTION = FALSE;
	m_SWR2_LOWER_RB1_DIRECTION = FALSE;
	m_SWR2_UPPER_RB2_DIRECTION = FALSE;
	m_SWR2_LOWER_RB2_DIRECTION = FALSE;
	m_SWR3_UPPER_RB1_DIRECTION = FALSE;
	m_SWR3_LOWER_RB1_DIRECTION = FALSE;
	m_SWR3_UPPER_RB2_DIRECTION = FALSE;
	m_SWR3_LOWER_RB2_DIRECTION = FALSE;
	m_SWR2_UPPER_RB1_SPEED = 300;
	m_SWR2_LOWER_RB1_SPEED = 300;
	m_SWR2_UPPER_RB2_SPEED = 300;
	m_SWR2_LOWER_RB2_SPEED = 300;
	m_SWR3_UPPER_RB1_SPEED = 300;
	m_SWR3_LOWER_RB1_SPEED = 300;
	m_SWR3_UPPER_RB2_SPEED = 300;
	m_SWR3_LOWER_RB2_SPEED = 300;
	m_SWR2_UPPER_RB1_GAP = 1.0f;
	m_SWR2_LOWER_RB1_GAP = 1.0f;
	m_SWR2_UPPER_RB2_GAP = 1.0f;
	m_SWR2_LOWER_RB2_GAP = 1.0f;
	m_SWR3_UPPER_RB1_GAP = 1.0f;
	m_SWR3_LOWER_RB1_GAP = 1.0f;
	m_SWR3_UPPER_RB2_GAP = 1.0f;
	m_SWR3_LOWER_RB2_GAP = 1.0f;

	Update();
	Requery();

}

void CDaoRecipeSet::DeleteRecipeId( CString sID )
{
	CString sBuf;
	
	sBuf.Format( "id = '%s'", sID);
	BOOL bOk = 	Find( AFX_DAO_FIRST, sBuf );
	if( !bOk ) return;	

	Delete();

	MoveFirst();
	while( !IsEOF() )
	{
		MoveNext();
	}	
	if(GetRecordCount()) MoveFirst();
}
