//BEGIN **********************************************************************************************************
//----------------------------------------------------------------------------------------------
// Description : MELSEC INPUT - BIT AREA
//----------------------------------------------------------------------------------------------

#define mibLOAD_ROBOT_STATUS				(UMelInput(0x0030) ? 1:0)
#define mibLOAD_SUBSTRATE_ON_ARM_UPPER		(UMelInput(0x0031) ? 1:0)
#define mibLOAD_SUBSTRATE_ON_ARM_LOWER		(UMelInput(0x0032) ? 1:0)
#define mibLOAD_ROBOT_ACCESSING_UPPER		(UMelInput(0x0033) ? 1:0)
#define mibLOAD_ROBOT_ACCESSING_LOWER		(UMelInput(0x0034) ? 1:0)
#define mibLOAD_TRANSFER_REQUEST			(UMelInput(0x0035) ? 1:0)
#define mibLOAD_ROBOT_READY					(UMelInput(0x0036) ? 1:0)
#define mibLOAD_TIMEOUT_RESET				(UMelInput(0x0037) ? 1:0)

#define mibUNLOAD_ROBOT_STATUS				(UMelInput(0x00E0) ? 1:0)
#define mibUNLOAD_SUBSTRATE_ON_ARM_UPPER	(UMelInput(0x00E1) ? 1:0)
#define mibUNLOAD_SUBSTRATE_ON_ARM_LOWER	(UMelInput(0x00E2) ? 1:0)
#define mibUNLOAD_ROBOT_ACCESSING_UPPER		(UMelInput(0x00E3) ? 1:0)
#define mibUNLOAD_ROBOT_ACCESSING_LOWER		(UMelInput(0x00E4) ? 1:0)
#define mibUNLOAD_TRANSFER_REQUEST			(UMelInput(0x00E5) ? 1:0)
#define mibUNLOAD_ROBOT_READY				(UMelInput(0x00E6) ? 1:0)
#define mibUNLOAD_TIMEOUT_RESET				(UMelInput(0x00E7) ? 1:0)

//----------------------------------------------------------------------------------------------
// Description : MELSEC OUTPUT - BIT AREA
//----------------------------------------------------------------------------------------------
#define mobLOAD_EQP_STATUS(A)				MelOutput(0x00A0, A)
#define mobLOAD_SUBSTRATE_EQ_STATE(A)		MelOutput(0x00A1, A)
#define mobLOAD_EQP_ACCESS_POSSIBLE(A)		MelOutput(0x00A2, A)
#define mobLOAD_LOAD_REQUEST(A)				MelOutput(0x00A3, A)
#define mobLOAD_UNLOAD_REQUEST(A)			MelOutput(0x00A4, A)
#define mobLOAD_EXCHANGE_REQUEST(A)			MelOutput(0x00A5, A)
#define mobLOAD_TIMEOUT_RESET(A)			MelOutput(0x00A6, A)
#define mobLOAD_ANY_GLASS_PROCESS_FLAG(A)	MelOutput(0x00AF, A)

#define mobUNLOAD_EQP_STATUS(A)				MelOutput(0x0090, A)
#define mobUNLOAD_SUBSTRATE_EQ_STATE(A)		MelOutput(0x0091, A)
#define mobUNLOAD_EQP_ACCESS_POSSIBLE(A)	MelOutput(0x0092, A)
#define mobUNLOAD_LOAD_REQUEST(A)			MelOutput(0x0093, A)
#define mobUNLOAD_UNLOAD_REQUEST(A)			MelOutput(0x0094, A)
#define mobUNLOAD_EXCHANGE_REQUEST(A)		MelOutput(0x0095, A)
#define mobUNLOAD_TIMEOUT_RESET(A)			MelOutput(0x0096, A)
#define mobUNLOAD_ANY_GLASS_PROCESS_FLAG(A)	MelOutput(0x009F, A)

#define mosbLOAD_EQP_STATUS					(MelInput(0x00A0) ? 1:0)
#define mosbLOAD_SUBSTRATE_EQ_STATE			(MelInput(0x00A1) ? 1:0)
#define mosbLOAD_EQP_ACCESS_POSSIBLE		(MelInput(0x00A2) ? 1:0)
#define mosbLOAD_LOAD_REQUEST				(MelInput(0x00A3) ? 1:0)
#define mosbLOAD_UNLOAD_REQUEST				(MelInput(0x00A4) ? 1:0)
#define mosbLOAD_EXCHANGE_REQUEST			(MelInput(0x00A5) ? 1:0)
#define mosbLOAD_TIMEOUT_RESET				(MelInput(0x00A6) ? 1:0)
#define mosbLOAD_ANY_GLASS_PROCESS_FLAG		(MelInput(0x00AF) ? 1:0)

#define mosbUNLOAD_EQP_STATUS				(MelInput(0x0090) ? 1:0)
#define mosbUNLOAD_SUBSTRATE_EQ_STATE		(MelInput(0x0091) ? 1:0)
#define mosbUNLOAD_EQP_ACCESS_POSSIBLE		(MelInput(0x0092) ? 1:0)
#define mosbUNLOAD_LOAD_REQUEST				(MelInput(0x0093) ? 1:0)
#define mosbUNLOAD_UNLOAD_REQUEST			(MelInput(0x0094) ? 1:0)
#define mosbUNLOAD_EXCHANGE_REQUEST			(MelInput(0x0095) ? 1:0)
#define mosbUNLOAD_TIMEOUT_RESET			(MelInput(0x0096) ? 1:0)
#define mosbUNLOAD_ANY_GLASS_PROCESS_FLAG	(MelInput(0x009F) ? 1:0)

//----------------------------------------------------------------------------------------------
// Description : MELSEC INPUT - WORD AREA
//----------------------------------------------------------------------------------------------
#define miwLOAD_CST_PORT_NO					UMelRead(0x0A00)				// 1 word; 0x0A00	"_9"
#define miwLOAD_CST_SLOT_NO					UMelRead(0x0A01)				// 1 word; 0x0A01	"_9"
#define miwLOAD_GLASS_ID(A,B)				UMelReadString(0x0A02,A,B)		// 7 word; 0x0A02 - 0x0A08	"99999999999999"
#define miwLOAD_RECIPE_ID(A,B)				UMelReadString(0x0A09,A,B)		// 8 word; 0x0A09 - 0x0A10	"99999999999999"
#define miwLOAD_RECIPE_ID_NUM				UMelRead(0x0A09)				// 2 word; 0x0A09	"_9"
#define miwLOAD_RECIPE_PPID(A,B)			UMelReadString(0x0A0A,A,B)		// 7 word; 0x0A0A - 0x0A10	"99999999999999"	// Thomas 191225
#define miwLOAD_PROCESS_FLAG				UMelRead(0x0A11)				// 1 word; 0x0A11 - "_9"
//#define miwLOAD_RESERVED(A,B)				UMelReadString(0x0A12,A,B)		// 2 word; 0x0A12 - 0x0A13	"9999"
#define miwLOAD_CAS_ID(A,B)					UMelReadString(0x0A12,A,B)		// 3 word; 0x0A12 - 0x0A14	"999999"
#define miwLOAD_LOT_ID(A,B)					UMelReadString(0x0A15,A,B)		// 7 word; 0x0A15 - 0x0A21	"99999999999999"

//----------------------------------------------------------------------------------------------
// Description : MELSEC OUTPUT - WORD AREA
//----------------------------------------------------------------------------------------------
#define mowUNLOAD_CST_PORT_NO(A)			MelWrite(0x0C00,A)		// 1 word; 0x0C00	"_9"
#define mowUNLOAD_CST_SLOT_NO(A)			MelWrite(0x0C01,A)		// 1 word; 0x0C01	"_9"
#define mowUNLOAD_GLASS_ID(A,B)				MelWriteString(0x0C02,A,B)		// 7 word; 0x0C02 - 0x0C08	"99999999999999"
#define mowUNLOAD_RECIPE_ID(A,B)			MelWriteString(0x0C09,A,B)		// 8 word; 0x0C09 - 0x0C10	"9999999999999999"
#define mowUNLOAD_PROCESS_FLAG(A)			MelWrite(0x0C11,A)		// 1 word; 0x0C11 - "_9"
#define mowUNLOAD_RESERVED(A,B)				MelWriteString(0x0C12,A,B)		// 2 word; 0x0C12 - 0x0C13	"9999"

#define moswUNLOAD_CST_PORT_NO				UMelRead(0x0C00)			// 1 word; 0x0C00	"_9"
#define moswUNLOAD_CST_SLOT_NO				UMelRead(0x0C01)			// 1 word; 0x0C01	"_9"
#define moswUNLOAD_GLASS_ID(A,B)			UMelReadString(0x0C02,A,B)	// 7 word; 0x0C02 - 0x0C08	"99999999999999"
#define moswUNLOAD_RECIPE_ID(A,B)			UMelReadString(0x0C09,A,B)	// 8 word; 0x0C09 - 0x0C10	"9999999999999999"
#define moswUNLOAD_PROCESS_FLAG				UMelRead(0x0C11)			// 1 word; 0x0C11 - "_9"
#define moswUNLOAD_RESERVED(A,B)			UMelReadString(0x0C12,A,B)	// 2 word; 0x0C12 - 0x0C13	"9999"

//END *******************************************************************************************************

// ===============================================================================================================
// ========================== CIMPC Interface ====================================================================
// ===============================================================================================================

//BEGIN **********************************************************************************************************
//----------------------------------------------------------------------------------------------
// Description : MELSEC INPUT - BIT AREA
//----------------------------------------------------------------------------------------------

#define mibCIM_ALARM_REPLY_FLAG				(UMelInput(0x0001) ? 1:0)
#define mibCIM_RUN_MODE_REQUEST_FLAG		(UMelInput(0x0005) ? 1:0)
#define mibCST_PANEL_REMOVE_REPLY_FLAG		(UMelInput(0x0069) ? 1:0)

//----------------------------------------------------------------------------------------------
// Description : MELSEC OUTPUT - BIT AREA
//----------------------------------------------------------------------------------------------
#define mobCLN_LINK_SIGNAL_DOWNSTREAM(A)	MelOutput(0x0090, A)
#define mobCLN_LINK_SIGNAL_UPSTREAM(A)		MelOutput(0x00A0, A)
#define mobCLN_ALARM_REPORT_FLAG(A)			MelOutput(0x00B1, A)
#define mobCLN_RUN_MODE_CHANGE(A)			MelOutput(0x00B5, A)
#define mobCLN_PANEL_REMOVE_FLAG(A)			MelOutput(0x00B9, A)

#define mosbCLN_LINK_SIGNAL_DOWNSTREAM		(MelInput(0x0090) ? 1:0)
#define mosbCLN_LINK_SIGNAL_UPSTREAM		(MelInput(0x00A0) ? 1:0)
#define mosbCLN_ALARM_REPORT_FLAG			(MelInput(0x00B1) ? 1:0)
#define mosbCLN_RUN_MODE_CHANGE				(MelInput(0x00B5) ? 1:0)
#define mosbCLN_PANEL_REMOVE_FLAG			(MelInput(0x00B9) ? 1:0)


//----------------------------------------------------------------------------------------------
// Description : MELSEC INPUT - WORD AREA
//----------------------------------------------------------------------------------------------
#define miwCIM_ALIVE_CHECK					UMelRead(0x0000)				// 1 word; 0x0000	"_9" 1~255 ݺ.
#define miwCIM_RUNMODE_COMMAND				UMelRead(0x0035)				// 1 word; 0x0035	"_1"=Online "_2"=Offline
#define miwCIM_CLOCK_UPDATE					UMelRead(0x0030)				// 1 word; 0x0030	"_9" 1~255 ݺ.	//  Ҷ Clock  Ѵ.
#define miwCIM_CLOCK_YYMM					UMelRead(0x0031)				// 1 word; 0x0031	"YYMM  .
#define miwCIM_CLOCK_DDHH					UMelRead(0x0032)				// 1 word; 0x0032	"DDHH  .
#define miwCIM_CLOCK_MMSS					UMelRead(0x0033)				// 1 word; 0x0033	"MMSS  .

#define miwCIM_MSG_DISPLAY					UMelRead(0x0004)				// 1 word; 0x0004	"MMSS  .
#define miwCIM_MSG_BUZZER					UMelRead(0x0005)				// 1 word; 0x0005	"MMSS  .

#define miwCIM_MSG_ASCII(A,B)				UMelReadString(0x0006,A,B)		// 40 word; 0x0006 - 0x002D	80ascii .
//----------------------------------------------------------------------------------------------
// Description : MELSEC OUTPUT - WORD AREA
//----------------------------------------------------------------------------------------------
#define mowCLN_LINK_SIGNAL_DOWNSTREAM(A,B)	MelWriteString(0x0C00,A,B)		// 32 word; 0x0C00 - 0x0C1F	"9999999999999999999999999999999999999999999999999999999999999999"
#define mowCLN_LINK_SIGNAL_UPSTREAM(A,B)	MelWriteString(0x0C20,A,B)		// 32 word; 0x0C20 - 0x0C2F	"9999999999999999999999999999999999999999999999999999999999999999"
//#define mowCLN_ALIVE_CHECK(A,B)				MelWriteString(0x0C40,A,B)		// 1 word; 0x0C40 "_9"  1 ~ 255 ݺ.
#define mowCLN_ALIVE_CHECK(A)				MelWrite(0x0C40,A)
#define mowCLN_EQ_STATUS(A)					MelWrite(0x0C44,A)		// 1 word; 0x0C44 "_9" "_0"=DOWN, "_1"=RUN, "_2"=IDLE, "_3"=PM, "_4"=Maintain"
#define mowCLN_CIM_CONNECT_STATUS(A)		MelWrite(0x0C45,A)		// 1 word; 0x0C45 "_9" "_0"=CIM Disconnect, "_1"=CIM Connect
#define mowCLN_CONTROL_STATUS_MODE(A)		MelWrite(0x0C46,A)		// 1 word; 0x0C46 "_9" "_1"=AUTO, "_2"=Manual
#define mowCLN_EQ_RUN_MODE(A)				MelWrite(0x0C47,A)		// 1 word; 0x0C47 "_9" "_1"=Online, "_2"=Offline

#define mowCLN_POSITION_DATA_PORT1(A)		MelWrite(0x0C50,A)		// 1 word; 0x0C50 "_9"
#define mowCLN_POSITION_DATA_SLOT1(A)		MelWrite(0x0C51,A)		// 1 word; 0x0C51 "_9"
#define mowCLN_POSITION_DATA_PORT2(A)		MelWrite(0x0C52,A)		// 1 word; 0x0C52 "_9"
#define mowCLN_POSITION_DATA_SLOT2(A)		MelWrite(0x0C53,A)		// 1 word; 0x0C53 "_9"
#define mowCLN_POSITION_DATA_PORT3(A)		MelWrite(0x0C54,A)		// 1 word; 0x0C54 "_9"
#define mowCLN_POSITION_DATA_SLOT3(A)		MelWrite(0x0C55,A)		// 1 word; 0x0C55 "_9"
#define mowCLN_POSITION_DATA_PORT4(A)		MelWrite(0x0C56,A)		// 1 word; 0x0C56 "_9"
#define mowCLN_POSITION_DATA_SLOT4(A)		MelWrite(0x0C57,A)		// 1 word; 0x0C57 "_9"
#define mowCLN_POSITION_DATA_PORT5(A)		MelWrite(0x0C58,A)		// 1 word; 0x0C58 "_9"
#define mowCLN_POSITION_DATA_SLOT5(A)		MelWrite(0x0C59,A)		// 1 word; 0x0C59 "_9"
#define mowCLN_POSITION_DATA_PORT6(A)		MelWrite(0x0C5A,A)		// 1 word; 0x0C5A "_9"
#define mowCLN_POSITION_DATA_SLOT6(A)		MelWrite(0x0C5B,A)		// 1 word; 0x0C5B "_9"
#define mowCLN_POSITION_DATA_PORT7(A)		MelWrite(0x0C5C,A)		// 1 word; 0x0C5C "_9"
#define mowCLN_POSITION_DATA_SLOT7(A)		MelWrite(0x0C5D,A)		// 1 word; 0x0C5D "_9"
#define mowCLN_POSITION_DATA_PORT8(A)		MelWrite(0x0C5E,A)		// 1 word; 0x0C5E "_9"
#define mowCLN_POSITION_DATA_SLOT8(A)		MelWrite(0x0C5F,A)		// 1 word; 0x0C5F "_9"

#define mowCLN_ALARM_LEVEL(A)				MelWrite(0x0C60,A)		// 1 word; 0x0C60 "_9" "B0"=Danger for human, "B1"=Equipment error, "B2"=Parameter overflow cause process  error, "B3"=Parameter overflow cause equipment  can't work, "B4"=Can not recover trouble, "B5"=Equipment status warning, "B6"=process reached to  predefined  status, "B7"= 1: Alarm occurred,0: Alarm removed
#define mowCLN_ALARM_TYPE(A)				MelWrite(0x0C61,A)		// 1 word; 0x0C61 "_9" "_0"=Warning, "_1"=alarm
#define mowCLN_ALARM_CODE(A)				MelWrite(0x0C62,A)		// 1 word; 0x0C62 "_9" 1~32767  0 ! FFFF
#define mowCLN_ALARM_TEXT(A,B)				MelWriteString(0x0C63,A,B)		// 40 word; 0x0C63 - 0x0C8A "99999999999999999999999999999999999999999999999999999999999999999999999999999999"

#define mowCLN_RUN_MODE_CHANGE_ACK(A)		MelWrite(0x0C8D,A)		// 1 word; 0x0C8D "-9" "_1"=Online, "_2"=Offline

#define mowCLN_PANEL_REMOVE_PORTNO(A)		MelWrite(0x0C90,A)		// 1 word; 0x0C90 "_9
#define mowCLN_PANEL_REMOVE_SLOTNO(A)		MelWrite(0x0C91,A)		// 1 word; 0x0C91 "_9

#define moswCLN_LINK_SIGNAL_DOWNSTREAM(A,B)	UMelReadString(0x0C00,A,B)	// 32 word; 0x0C00 - 0x0C1F	"9999999999999999999999999999999999999999999999999999999999999999"
#define moswCLN_LINK_SIGNAL_UPSTREAM(A,B)	UMelReadString(0x0C20,A,B)	// 32 word; 0x0C20 - 0x0C2F	"9999999999999999999999999999999999999999999999999999999999999999"
#define moswCLN_ALIVE_CHECK					UMelRead(0x0C40)			// 1 word; 0x0C40 "_9
#define moswCLN_EQ_STATUS					UMelRead(0x0C44)			// 1 word; 0x0C44 "_9
#define moswCLN_CIM_CONNECT_STATUS			UMelRead(0x0C45)			// 1 word; 0x0C45 "_9
#define moswCLN_CONTROL_STATUS_MODE			UMelRead(0x0C46)			// 1 word; 0x0C46 "_9
#define moswCLN_EQ_RUN_MODE					UMelRead(0x0C47)			// 1 word; 0x0C47 "_9

#define moswCLN_POSITION_DATA_PORT1			UMelRead(0x0C50)			// 1 word; 0x0C50 "_9
#define moswCLN_POSITION_DATA_SLOT1			UMelRead(0x0C51)			// 1 word; 0x0C51 "_9
#define moswCLN_POSITION_DATA_PORT2			UMelRead(0x0C52)			// 1 word; 0x0C52 "_9
#define moswCLN_POSITION_DATA_SLOT2			UMelRead(0x0C53)			// 1 word; 0x0C53 "_9
#define moswCLN_POSITION_DATA_PORT3			UMelRead(0x0C54)			// 1 word; 0x0C54 "_9
#define moswCLN_POSITION_DATA_SLOT3			UMelRead(0x0C55)			// 1 word; 0x0C55 "_9
#define moswCLN_POSITION_DATA_PORT4			UMelRead(0x0C56)			// 1 word; 0x0C56 "_9
#define moswCLN_POSITION_DATA_SLOT4			UMelRead(0x0C57)			// 1 word; 0x0C57 "_9
#define moswCLN_POSITION_DATA_PORT5			UMelRead(0x0C58)			// 1 word; 0x0C58 "_9
#define moswCLN_POSITION_DATA_SLOT5			UMelRead(0x0C59)			// 1 word; 0x0C59 "_9
#define moswCLN_POSITION_DATA_PORT6			UMelRead(0x0C5A)			// 1 word; 0x0C5A "_9
#define moswCLN_POSITION_DATA_SLOT6			UMelRead(0x0C5B)			// 1 word; 0x0C5B "_9
#define moswCLN_POSITION_DATA_PORT7			UMelRead(0x0C5C)			// 1 word; 0x0C5C "_9
#define moswCLN_POSITION_DATA_SLOT7			UMelRead(0x0C5D)			// 1 word; 0x0C5D "_9
#define moswCLN_POSITION_DATA_PORT8			UMelRead(0x0C5E)			// 1 word; 0x0C5E "_9
#define moswCLN_POSITION_DATA_SLOT8			UMelRead(0x0C5F)			// 1 word; 0x0C5F "_9

#define moswCLN_ALARM_LEVEL					UMelRead(0x0C60)			// 1 word; 0x0C60 "_9
#define moswCLN_ALARM_TYPE					UMelRead(0x0C61)			// 1 word; 0x0C61 "_9
#define moswCLN_ALARM_CODE					UMelRead(0x0C62)			// 1 word; 0x0C62 "_9
#define moswCLN_ALARM_TEXT(A,B)				UMelReadString(0x0C63,A,B)	// 40 word; 0x0C63 - C8A "99999999999999999999999999999999999999999999999999999999999999999999999999999999"

#define moswCLN_RUN_MODE_CHANGE_CMD			UMelRead(0x0C8D)			// 1 word; 0x0C8D "_9"

#define moswCLN_PANEL_REMOVE_PORTNO			UMelRead(0x0C90)			// 1 word; 0x0C90 "_9"
#define moswCLN_PANEL_REMOVE_SLOTNO			UMelRead(0x0C91)			// 1 word; 0x0C91 "_9"


#define mogwCLN_POSITION_DATA_PORT(C, A)		( (C==0) ? mowCLN_POSITION_DATA_PORT1(A) : \
												  (C==1) ? mowCLN_POSITION_DATA_PORT2(A) : \
												  (C==2) ? mowCLN_POSITION_DATA_PORT3(A) : \
												  (C==3) ? mowCLN_POSITION_DATA_PORT4(A) : \
												  (C==4) ? mowCLN_POSITION_DATA_PORT5(A) : \
												  (C==5) ? mowCLN_POSITION_DATA_PORT6(A) : \
												  (C==6) ? mowCLN_POSITION_DATA_PORT7(A) : mowCLN_POSITION_DATA_PORT8(A) )

#define mogwCLN_POSITION_DATA_SLOT(C, A)		( (C==0) ? mowCLN_POSITION_DATA_SLOT1(A) : \
												  (C==1) ? mowCLN_POSITION_DATA_SLOT2(A) : \
												  (C==2) ? mowCLN_POSITION_DATA_SLOT3(A) : \
												  (C==3) ? mowCLN_POSITION_DATA_SLOT4(A) : \
												  (C==4) ? mowCLN_POSITION_DATA_SLOT5(A) : \
												  (C==5) ? mowCLN_POSITION_DATA_SLOT6(A) : \
												  (C==6) ? mowCLN_POSITION_DATA_SLOT7(A) : mowCLN_POSITION_DATA_SLOT8(A) )

//END *******************************************************************************************************
