#ifndef _DEFINETYPEDEF_H
#define _DEFINETYPEDEF_H

// Define the MAX Recipe Field number
#define MAX_RECIPE_BODY_NO			38	// 7 + 16 (SWR2 RB) + 16 (SWR3 RB)

#define MAX_TOTAL_RECIPE_BODY_NO	MAX_RECIPE_BODY_NO	// 150901 halesu	

#define MAX_LOST_GLASS_FIELD_NO		6
// Recipe Body Info
// ----------------------------------------------------------
//	Field 0 : [ID]
//	Field 1 : [CHANGE TIME]
//	Field 2 : [COMMENT]
//	Field 3 : [TACT TIME]
//	Field 4 : [C/V SPEED]
//	Field 5 : [PROCESS USE]
// ----------------------------------------------------------
typedef struct tagRECIPE_INFO 
{
//	BOOL	bChange;
	CString sName[MAX_RECIPE_BODY_NO];		// 150901 halesu
	CString sValue[MAX_RECIPE_BODY_NO];		// 150901 halesu
	COleDateTime	dtChangeTime;
} RECIPE_INFO;

// ----------------------------------------------------------
// General setup information
// ----------------------------------------------------------
typedef struct tagSETUP_INFO
{
	LPSTR	sName;
	int		nOption;
	int		nFormat;
	LPSTR	sUnit;
} SETUP_INFO;

// ----------------------------------------------------------
// ljy_050401 : C/V Roller Dia setup information
// ----------------------------------------------------------
typedef struct tagCV_INFO
{
	LPSTR	sName;
	double	dVelRatio;
	double	dRatio;
	double	dDia;
} CV_INFO;
// ----------------------------------------------------------
// Analog Input Calibration Factor Preset
// ----------------------------------------------------------
typedef struct aiPreSet	{
	int			nNo;
	LPCTSTR		sName;
	float		fRealMin;
	float		fRealMax;
	int			nAdcMin;
	int			nAdcMax;
} AI_PRESET;

// ----------------------------------------------------------
// Analog Input information
// ----------------------------------------------------------
typedef struct aiSet
{
	int		nOwnerViewNo;
	int		nOwnerUnitNo;
	int		nAiIntrNo;
	int		nApdReportNo;
	int		nEdcReportNo;
	int		nReal;
	CString	sName;
	UINT	uRESID;
	CString	sKind;
	CString sUnit;
} AI_SET;

// Init Status Data
typedef struct statusData {
	int			nNo;
	LPCTSTR		sName;
} STATUS_DATA;

#define MAX_GRID_IO_COLS	16
#define MAX_GRID_IO_CTRL	1
typedef struct tagGRID_IO_INFO
{
	INT				nRows;
	INT				nCols;
	LPTSTR			sText[MAX_GRID_IO_COLS];
	INT				nColWidth[MAX_GRID_IO_CTRL];
	unsigned int	uCellBackColor;
	BOOL			bTitle;
} GRID_IO_INFO;



#endif	// _DEFINETYPEDEF_H