// Dics.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Dics.h"

#include "MainFrm.h"
#include "ChildFrm.h"

#include "View\SystemView.h"
#include "View\ServoView.h"
#include "View\RecipesView.h"
#include "View\SetupView.h"
#include "View\AlarmsView.h"
#include "View\DatalogView.h"
#include "View\HelpView.h"

#include "SplashWindow.h"

#include ".\TwinCat\TcSystemServer_i.c"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//---------------------------------------------------------------------------------------
#define CppServerName "DICS_SERVER"
#define CppTopicName "DICS_TOPIC"
CDicsApp* p_OneApp;
//---------------------------------------------------------------------------------------

/////////////////////////////////////////////////////////////////////////////
// CDicsApp

BEGIN_MESSAGE_MAP(CDicsApp, CWinApp)
	//{{AFX_MSG_MAP(CDicsApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDicsApp construction

CDicsApp::CDicsApp()
{
	//---------------------------------------------------------------------------------------
	p_OneApp = this;
    m_bIsRun = FALSE;
	//---------------------------------------------------------------------------------------
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDicsApp object

CDicsApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDicsApp initialization

BOOL CDicsApp::InitInstance()
{
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	//---------------------------------------------------------------------------------------
	// Insert this code to execute just one instance
	if( DdeInitialize( &m_dwIdInst, (PFNCALLBACK) DdeCallback, 0, 0 ) ) return FALSE; 
	m_hszCppServer = DdeCreateStringHandle( m_dwIdInst, CppServerName, CP_WINANSI );
	m_hszCppTopic = DdeCreateStringHandle( m_dwIdInst, CppTopicName, CP_WINANSI ); 
	
	// try to find the first instance
	// ڽ α׷  õѴ. ι°  Ǹ .
	m_hconvCppServer = DdeConnect ( m_dwIdInst, m_hszCppServer, m_hszCppTopic, NULL );
	if( m_hconvCppServer )
	{
		m_bIsRun = TRUE;
	//	have connection, this is the second instance, you can send data to first instance
	//  DdeClientTransaction((unsigned char*)data, strlen(data)+1,
	//  hconvCppServer, 0, CF_TEXT, XTYP_EXECUTE, 0, &dderesult );
		return FALSE;
	} 
	DdeNameService ( m_dwIdInst, m_hszCppServer, 0, DNS_REGISTER );
	//---------------------------------------------------------------------------------------

#ifndef _MY_DEBUG
	CSplashWnd * pSplashWnd = new CSplashWnd(IDB_BITMAP_SPLASH_START,5000);
	pSplashWnd->Create();
#endif
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_DICSTYPE,
		RUNTIME_CLASS(CDicsDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CDicsView));
	AddDocTemplate(pDocTemplate);

	m_pSystemTemplate = new CMultiDocTemplate(
		IDR_DICSTYPE,
		RUNTIME_CLASS( CDicsDoc ),
		RUNTIME_CLASS( CChildFrame ),
		RUNTIME_CLASS( CSystemView ) );

	m_pServoTemplate = new CMultiDocTemplate(
		IDR_DICSTYPE,
		RUNTIME_CLASS( CDicsDoc ),
		RUNTIME_CLASS( CChildFrame ),
		RUNTIME_CLASS( CServoView ) );

	m_pRecipesTemplate = new CMultiDocTemplate(
		IDR_DICSTYPE,
		RUNTIME_CLASS( CDicsDoc ),
		RUNTIME_CLASS( CChildFrame ),
		RUNTIME_CLASS( CRecipesView ) );

	m_pSetupTemplate = new CMultiDocTemplate(
		IDR_DICSTYPE,
		RUNTIME_CLASS( CDicsDoc ),
		RUNTIME_CLASS( CChildFrame ),
		RUNTIME_CLASS( CSetupView ) );

	m_pAlarmsTemplate = new CMultiDocTemplate(
		IDR_DICSTYPE,
		RUNTIME_CLASS( CDicsDoc ),
		RUNTIME_CLASS( CChildFrame ),
		RUNTIME_CLASS( CAlarmsView ) );

	m_pDatalogTemplate = new CMultiDocTemplate(
		IDR_DICSTYPE,
		RUNTIME_CLASS( CDicsDoc ),
		RUNTIME_CLASS( CChildFrame ),
		RUNTIME_CLASS( CDatalogView ) );

	m_pHelpTemplate = new CMultiDocTemplate(
		IDR_DICSTYPE,
		RUNTIME_CLASS( CDicsDoc ),
		RUNTIME_CLASS( CChildFrame ),
		RUNTIME_CLASS( CHelpView ) );

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	//// Main window pointer saved	////
	CMDIChildWnd* pChild = (CMDIChildWnd*) pMainFrame->GetActiveFrame();
	m_pMainView = (CDicsView*) pChild->GetActiveView();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDicsApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CDicsApp message handlers

int CDicsApp::ExitInstance() 
{
	//---------------------------------------------------------------------------------------
	DdeFreeStringHandle ( m_dwIdInst, m_hszCppServer );
	DdeFreeStringHandle ( m_dwIdInst, m_hszCppTopic ); 

	// only unregister the DDE server for first instance
	if ( !m_bIsRun )
	{
		if ( !DdeNameService ( m_dwIdInst, m_hszCppServer, 0, DNS_UNREGISTER ) )
		{
			::MessageBox ( 0, "Error", "in ServiceUnRegister", MB_OK );
		}
	}
	DdeUninitialize( m_dwIdInst );
	//---------------------------------------------------------------------------------------

	delete m_pSystemTemplate;
	delete m_pServoTemplate;
	delete m_pRecipesTemplate;
	delete m_pSetupTemplate;
	delete m_pAlarmsTemplate;
	delete m_pDatalogTemplate;
	delete m_pHelpTemplate;
	
	return CWinApp::ExitInstance();
}

//---------------------------------------------------------------------------------------
HDDEDATA CALLBACK DdeCallback(WORD wType, WORD wFmt, HCONV hConv, HSZ hszTopic,
		HSZ hszItem, HDDEDATA hData, DWORD lData1, DWORD lData2)
{
	return p_OneApp->AppDdeCallback( wType, wFmt, hConv, hszTopic, hszItem, hData, lData1, lData2 );
} 

HDDEDATA CDicsApp::AppDdeCallback(WORD wType, WORD wFmt, HCONV hConv, HSZ hszTopic,
	HSZ hszItem, HDDEDATA hData, DWORD lData1, DWORD lData2)
{
	int icount;
	char* buffers;
	HDDEDATA ret = (HDDEDATA) NULL;
	CWnd* p_Wnd;
	switch( wType )
	{
	case XTYP_CONNECT:
		icount = DdeQueryString( m_dwIdInst, hszTopic, NULL, 0, CP_WINANSI );
		buffers = (char*)malloc( icount+1 );
		DdeQueryString( m_dwIdInst, hszTopic, buffers, icount+1, CP_WINANSI );
		if( !strcmp( buffers, CppTopicName ) )
		{
			p_Wnd = AfxGetMainWnd();
			p_Wnd->ShowWindow( SW_MINIMIZE );
			p_Wnd->ShowWindow( SW_RESTORE );
			p_Wnd->BringWindowToTop();
			p_Wnd->SetForegroundWindow(); 
			
			// add any code for the first instance have found the second one is launch
			ret = (HDDEDATA) DDE_FACK;
		}
		free( buffers );
		break;
	case XTYP_EXECUTE:
		// if the second instance send data, the first one received here.  
		// icount = DdeGetData ( hData, NULL, 0, 0 );
		// buffers = (char*)malloc ( icount+1 );
		// DdeGetData ( hData, (unsigned char*)buffers, icount, 0 );
		// free ( buffers );
		break;
	default: 
		break;
	}
	return ret;
}
//---------------------------------------------------------------------------------------

// ljy_050220 : CDicsApp -> 04HC30   Ϸ(1).
