// DicsData.cpp: implementation of the CDicsData class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Dics.h"
#include "DicsData.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
// Set the static member variables
CString	CDicsData::m_sInSensorUnitName[MAX_UNIT_NO] =
{
	"LD IN	",
	"SWR1 IN	",
	"SWR2 IN	",
	"SWR3 IN	",
	"SWR4 IN	",
	"AK IN	",
	"BUF IN	",
	"UL IN	",
};

CString	CDicsData::m_sOutSensorUnitName[MAX_UNIT_NO] =
{
	"LD OUT	",
	"SWR1 OUT	",
	"SWR2 OUT	",
	"SWR3 OUT	",
	"SWR4 OUT	",
	"AK OUT	",
	"BUF OUT	",
	"UL OUT	",
};

CString	CDicsData::m_sUnitName[MAX_UNIT_NO] = 
{ 
	"LD UNIT	",
	"SWR1 UNIT	",
	"SWR2 UNIT	",
	"SWR3 UNIT	",
	"SWR4 UNIT	",
	"AK UNIT	",
	"BUF UNIT	",
	"UL UNIT	",
};

int	CDicsData::m_nSensorAPDStatusType[MAX_APD_STATUS_DATA_DI_NO]=
{
	0,		// di_INCV_ION_CONTROL_ALM
	0,		// di_INCV_ION_LEVEL_ALM
	0,		// di_INCV_ION_CONDITION_ALM
	1,		// di_INCV_FFU1_CP_ON
	1,		// di_INCV_FFU2_CP_ON
	1,		// di_INCV_FFU3_CP_ON
	0,		// di_DIW_TANK1_LEVEL_L
	0,		// di_DIW_TANK1_LEVEL_M
	0,		// di_DIW_TANK1_LEVEL_H
	0,		// di_DIW_TANK1_LEVEL_HH
	0,		// di_DIW_TANK2_LEVEL_L
	0,		// di_DIW_TANK2_LEVEL_M
	0,		// di_DIW_TANK2_LEVEL_H
	0,		// di_DIW_TANK2_LEVEL_HH
	0,		// di_AK_HEPA_CP_ON
	0,		// dI_BUF_ION_CONTROL_ALM
	0,		// dI_BUF_ION_LEVEL_ALM
	0,		// dI_BUF_ION_CONDITION_ALM
	1,		// di_OUTCV_FFU1_CP_ON
	1,		// di_OUTCV_FFU2_CP_ON
	1,		// di_OUTCV_FFU3_CP_ON 
};


double  CDicsData::m_RB_TachometerData[MAX_MUX10 * MAX_MUX10_CHANNEL];
double  CDicsData::m_dUnitTackTime[MAX_APD_STATUS_DATA_TACKTIME_NO];

// ʱȭ  Ready   Flag.
STATUS_DATA CDicsData::m_InitMainItems[] = 
{
//	{ initCHECK_UP_CV_GLASS,	"CHK UP CV GLS EXIST"		},
//	{ initCHECK_UP_CV_CP,		"CHK UP CV MOTOR CP"		},
//	{ initCHECK_UP_CV_ALARM,	"CHK UP CV MOTOR ALM"		},
	{ initCHECK_CV_GLASS,		"CHK CV GLS EXIST"			},
	{ initCHECK_CV_CP,			"CHK CV MOTOR CP"			},
	{ initCHECK_CV_ALARM,		"CHK CV MOTOR ALM"			},
//	{ initINTERRUPT,			"CHK RBT HAND INTERRUPT"	},
//	{ initCHECK_RBT_GLASS,	    "CHK UL UPDN GLS EXIST"	},
	{ initCLEAN_OUT_SET,        "CLEAN OUT SETTING"			},
//	{ initRBT1,					"LD UPDN UNIT"				},
//	{ initRBT2,					"UL UPDN UNIT"				},

//#ifndef _NO_RB
	{ initSWR2_RB_UP1_SERVO,		    "SWR2 RB UP1 SERVO"	},
	{ initSWR2_RB_UP2_SERVO,			"SWR2 RB UP2 SERVO"	},
	{ initSWR2_RB_LO1_SERVO,			"SWR2 RB LO1 SERVO"	},
	{ initSWR2_RB_LO2_SERVO,			"SWR2 RB LO2 SERVO"	},
	{ initSWR3_RB_UP1_SERVO,		    "SWR3 RB UP1 SERVO"	},
	{ initSWR3_RB_UP2_SERVO,			"SWR3 RB UP2 SERVO"	},
	{ initSWR3_RB_LO1_SERVO,			"SWR3 RB LO1 SERVO"	},
	{ initSWR3_RB_LO2_SERVO,			"SWR3 RB LO2 SERVO"	},
//#endif
#ifndef _NO_EUV
//	{ initEUV_STATUS,			"EUV STATUS"						},
#endif
//	{ initAP_STATUS,		"AP Status"								},	
//	{ initHPMJ_STATUS,		"HPMJ Status"							},	
};

STATUS_DATA CDicsData::m_InitPumpItems[] = 
{
	{ initPUMP1_CHECK,		"CHK DI PUMP1" },
	{ initPUMP2_CHECK,		"CHK DI PUMP2" },
#ifdef _BUFTANK_USE
	{ initPUMP3_CHECK,		"CHK DI PUMP3" },
	{ initPUMP4_CHECK,		"CHK DI PUMP4" },
#endif
};

CDicsData::CDicsData()
{
	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	m_IniConfiguration.Open( "DicsInfo", "GenInfo" );

	m_nInitMainItemsNo = sizeof( m_InitMainItems ) / sizeof( STATUS_DATA );
	m_nInitPumpItemsNo = sizeof( m_InitPumpItems ) / sizeof( STATUS_DATA );

	m_GlsInfoReq.ClearGlassInfo();
	m_GlsInfoLost.ClearGlassInfo();
	m_GlsInfoRecovery.ClearGlassInfo();

	m_IfHpmj.ClearInfo();

	for( int i=0; i<MAX_IF_NO; i++ )
	{
		m_IfFlag[i].ClearInfo();
	}

	InitPara1();

	// GEN_INFO
	m_GenInfo.ClearInfo();
	m_GenInfo.sRecipeId			= m_IniConfiguration.GetStringValue( "RECIPE", "Recipe ID", "" );
	m_GenInfo.bEnableCommLog	= m_IniConfiguration.GetIntValue( "VIEW LOG", "COMM LOG", 1 );
	m_GenInfo.bEnableEqpLog		= m_IniConfiguration.GetIntValue( "VIEW LOG", "EQP LOG", 1 );

	// EQP_INFO
	m_EqpInfo.ClearInfo();
	m_EqpInfo.nEqpState[stateNONE]	= 1;		// stateNONE = 1 : Default
	m_EqpInfo.nLdState[stateNONE]	= 1;		// stateNONE = 1 : Default
	m_EqpInfo.cIonizerState = 'R';

	m_EqpInfo.cComboMode		= comboPRE_DEPO;
	m_EqpInfo.cInitCommState	= m_IniConfiguration.GetIntValue( "COMM", "INIT COMM STATE", 0 );
	m_EqpInfo.cInitCtlMode		= m_IniConfiguration.GetIntValue( "COMM", "INIT CTL MODE", 0 );
	m_EqpInfo.cCommState		= commDISABLE;

	m_EqpInfo.cInitCommState1	= m_IniConfiguration.GetIntValue( "COMM", "INIT COMM STATE1", 0 );
	m_EqpInfo.cInitCtlMode1		= m_IniConfiguration.GetIntValue( "COMM", "INIT CTL MODE1", 0 );
	m_EqpInfo.cCommState1		= commDISABLE;

	m_EqpInfo.cCtlMode			= modeOFFLINE;		// 'D' : Offline, 'B' : Online Monitor, 'A' : Online Control

	// Pump
	m_IfPump.ClearInfo();

#ifndef _NO_EUV
	// EUV
	m_IfEuv.ClearInfo();
#endif

	// Broken Scan
	m_IfScan.ClearInfo();

	// CCD Sensor 120111 halesu
	m_IfCcd.ClearInfo();

	// Job Condition
	m_JobCond.ClearInfo();

	// PORT Interface Information
	for( int i=0; i<MAX_PORT_NO; i++ )
	{	
		m_PortInfo[i].nInNum			= 0;
		m_PortInfo[i].nOutNum			= 0;
		m_PortInfo[i].cLotStatus		= lotEMPTY;
		m_PortInfo[i].sLotId			= "";
		m_PortInfo[i].sCstId			= "";
		m_PortInfo[i].nPortNo			= i + 1;
		m_PortInfo[i].sOpId				= "";
		m_PortInfo[i].sRcpId			= "";
		m_PortInfo[i].sSlotInfo			= "                        ";
		m_PortInfo[i].sSlotInfoSel		= "                        ";
		m_PortInfo[i].sSlotInfoMap		= "                        ";
		m_PortInfo[i].nQty				= 0;

		m_PortInfo[i].sRecipeIdChangeTime = ""; // A[12]

		m_PortInfo[i].sPortStatus		= "LR";	// LDRQ, LDCM, UDRQ, UDCM, USEM, USNE, UNUS
		m_PortInfo[i].cPortStatus		= portLR;
		m_PortInfo[i].cPortMode			= modeENABLE;	// Enable, Disable
		m_PortInfo[i].cPortLdMode		= 'N';
		m_PortInfo[i].cTrsMode			= modeAGV;
		m_PortInfo[i].cLdState			= 0;		// Loader status
		m_PortInfo[i].bOfflineLotStart	= FALSE;

		m_PortInfo[i].bCstExist			= FALSE;
		m_PortInfo[i].nSourcePortNo		= 0;
		m_PortInfo[i].nTargetPortNo		= 0;
		m_PortInfo[i].sPortType			= "PB";
		m_PortInfo[i].cUseType			= 'G';
		m_PortInfo[i].nJobMode			= CDicsData::jobU_MODE;

		m_PortInfo[i].cEsFlag			= ' ';

		ClearPortInfo( i );
		for( int j=0; j<MAX_SLOT_NO; j++ )
		{
			m_PortInfo[i].sSlotNo[j] = "";	// A[2]
			m_PortInfo[i].sGlassId[j] = "";	// A[20]
			m_PortInfo[i].sOpGlassId[j] = ""; // A[20] LYS20071011
			m_PortInfo[i].cProcessFlag[j] = glassEMPTY;	// A[1], '0' : No Process, '1' : Process
			m_PortInfo[i].sGlassRcpId[j] = "";
			m_PortInfo[i].sGlassLotId[j] = "";                // 08HC06
			m_PortInfo[i].bGlassMap[j] = FALSE;
			m_PortInfo[i].bGlassMapSel[j] = FALSE;

			m_PortInfo[i].cGlassJudge[j] = ' ';
			m_PortInfo[i].cGlassSortType[j] = ' ';
			m_PortInfo[i].cGlassSampleFlag[j]  = ' ';
			m_PortInfo[i].cRwkCount[j]  = ' ';
//			m_PortInfo[i].sCFGlassId[j] = ' ';
		}
	}

	// CIM Interface Information
	m_IfCim.ClearInfo();
	m_IfCim.bRcpCheckMode			= m_IniConfiguration.GetIntValue( "RECIPE", "RCP_CHECK_MODE", 0 );
	m_IfCim.bGlassDataCheckMode		= m_IniConfiguration.GetIntValue( "RECIPE", "GLS_DATA_CHECK_MODE", 0 );
	m_IfCim.bSptRecoveryMode		= m_IniConfiguration.GetIntValue( "RECIPE", "SPT_RECOVERY_MODE", 0 );
	m_IfCim.bClnRecoveryMode		= m_IniConfiguration.GetIntValue( "RECIPE", "CLN_RECOVERY_MODE", 0 );

	m_IfCim.bIonizerStatusChangeReq	= FALSE;
	m_IfCim.nRecoveryUnitNo			= IF_UNIT_LD*2+1;// JUN_RESUME
	m_IfCim.bEdcDataReportReq		= FALSE;
	////////////////////////////////////////////////////
	m_IfCim.bTraceDataStartReq = FALSE;
	m_IfCim.bTraceDataStopReq = FALSE;
	m_IfCim.dTraceDataSampTime = 0;
	m_IfCim.uTraceID = 0;

	m_IfCim.bAllGlsPosDataReq	= FALSE;
	m_IfCim.bAllGlsPosDataIng	= FALSE;
	m_IfCim.bAllGlsPosDataReqEnable	= FALSE;

	for( int i = 0; i< 99; i++ ) 
	{
		m_IfCim.bRecipeIdAdd[i]	= FALSE;
		m_IfCim.bRecipeChange[i]	= FALSE;
		m_IfCim.bRecipeChangeReq[i] = FALSE;
	}
	m_IfCim.bRecipeIdDelete	= FALSE;
	m_IfCim.bRecipeIdDeleteReq	= FALSE;
	m_IfCim.bRecipeIdAddReq	= FALSE;
	m_IfCim.sDelRecipeID = "";

	for( int i=0; i<MAX_PORT_NO; i++ )
	{
		m_IfCim.bProcessStartReq[i]	= FALSE;
		m_IfCim.bProcessStart[i]	= FALSE;

		m_IfCim.bPortModeChangeReq[i]	= FALSE;
		m_IfCim.bPortModeChangeReqLoader[i] = FALSE;
		m_IfCim.cPortMode[i]			= modeENABLE;

		m_IfCim.cTrsMode[i]				= modeAGV;
		m_IfCim.bTrsModeChangeReq[i]	= FALSE;
		m_IfCim.bKeyInCstIdComp[i]		= FALSE;
		m_IfCim.bPortCancelReq[i]		= FALSE;
		m_IfCim.bPortAbortReq[i]		= FALSE;

		m_IfCim.bEnableButtonStart[i]	= FALSE;
		m_IfCim.bEnableButtonCancel[i]	= FALSE;
		m_IfCim.bEnableButtonAbort[i]	= FALSE;
		m_IfCim.bEnableButtonLotInfo[i]	= FALSE;

		m_IfCim.bProcessDataReq[i] = FALSE;

	}

	for( int i=0; i<MAX_TRACE_DATA_NO; i++ )
	{
		m_IfCim.nTraceList[i] = 0;
		m_IfCim.sTraceDataValue[i] = "";
	}
	m_IfCim.sTraceDataTime = "";//2008.12.01 kimgun
	m_IfCim.sVcrMode = "FS";

	m_IfCim.bScrapReq = FALSE;

	// Combo mode
	m_IfCim.bComboModeChangeReq = FALSE;
	m_IfCim.cComboMode			= comboPRE_DEPO;

	m_IfCim.bCommStateChangeReq		= FALSE;
	m_IfCim.bCommStateChangeComp	= FALSE;

	m_IfCim.bCommStateChangeReq1		= FALSE;
	m_IfCim.bCommStateChangeComp1	= FALSE;

	// IF CIM Tag
	m_IfCimTag.nAck1				= '0';
	m_IfCimTag.nAck2				= '0';
	m_IfCimTag.nAck5				= '0';
	m_IfCimTag.nAck6				= '0';
	m_IfCimTag.nAck7				= '0';
	m_IfCimTag.nS6F11Ack6			= '0';

	// Loader Interface Information
	m_IfLoader.ClearInfo();
	
	for( int i=0; i<MAX_PORT_NO; i++ )
	{	
		m_IfLoader.bCstReady[i]			= FALSE;

		m_IfLoader.bPortReloadReq[i]	= FALSE;
		m_IfLoader.bPortReloadComp[i]	= FALSE;

		m_IfLoader.bPreLdReq[i]			= FALSE;
		m_IfLoader.bPreLdComp[i]		= FALSE;

		m_IfLoader.bComponentIn[i]		= FALSE;
		m_IfLoader.bComponentInToEqp[i]	= FALSE;
		m_IfLoader.bComponentOutToEqp[i]	= FALSE;
		m_IfLoader.bComponentOut[i]		= FALSE;
		m_IfLoader.bLastGlass[i]		= FALSE;
		m_IfLoader.bCleanerProcessing[i]	= FALSE;
		m_IfLoader.bProcessStartConfirm[i]	= FALSE;
		m_IfLoader.bProcessStartReq[i] = FALSE;

		m_IfLoader.bPortModeChangeFail[i] = FALSE;
		m_IfLoader.bPortAbortRecv[i]	= FALSE;

		m_IfLoader.bFirstLdComp[i] = FALSE;
		m_IfLoader.bStartLdComp[i] = FALSE;

		m_IfLoader.bFirstUdReq[i] = FALSE;
		m_IfLoader.bStartUdReq[i] = FALSE;
	}
	m_IfLoader.nLastGlassSlotNo = 0;
	m_IfLoader.bPutStageReady = FALSE;
	m_IfLoader.bInitReq	= FALSE;

	m_IfLoader.bDebugLdReady = FALSE;
	m_IfLoader.bDebugRecvComp = FALSE;
	m_IfLoader.bDebugGetFromCst = TRUE;

	// EVENT Report
	uDataId = 0;
	uRptId  = 100;
	uCeid   = 0;

	fTotalFlowMeter[0] = 10.0;	// 110726 halesu
	fTotalFlowMeter[1] = 10.0;

	m_SeqFlag.ClearInfo();
}

CDicsData::~CDicsData()
{
}

void CDicsData::ParseGlassData( int i, unsigned short* nGlassData )
{
	for( int n=0; n<5; n++ )
	{
		m_GlsInfo[i].nGlassData[n] = nGlassData[n] & 0x0FFFF;
		m_GlsInfo[i].sGlassData[n].Format( "%04X", nGlassData[n] );
	}

	m_GlsInfo[i].nCstSeqNo		= ( nGlassData[0] >> 12 ) & 0x000F;
	m_GlsInfo[i].nLineControl	= ( nGlassData[0] >> 11 ) & 0x0001;	
	m_GlsInfo[i].nSlotNo		= ( nGlassData[0] ) & 0x07FF;
	m_GlsInfo[i].nMaterialNo	= ( nGlassData[1] >> 12 ) & 0x000F; 
	m_GlsInfo[i].nMaintainCst	= ( nGlassData[1] >>  4 ) & 0x000F;
	m_GlsInfo[i].nBendingPara	= ( nGlassData[1] ) & 0x000F;
	
	// BCD to int
	m_GlsInfo[i].nLdRecipeId	= Bcd2Int( m_GlsInfo[i].nGlassData[2] );
	m_GlsInfo[i].nUlRecipeId    = Bcd2Int( m_GlsInfo[i].nGlassData[4] );
	
	int nRecipeId				= Bcd2Int( m_GlsInfo[i].nGlassData[3] );
	m_GlsInfo[i].sRecipeId.Format("%d", nRecipeId );
}

void CDicsData::ParseGlassData( CGlassInfo& glsInfo, unsigned short* nGlassData )
{
	for( int i=0; i<5; i++ )
	{
		glsInfo.nGlassData[i] = nGlassData[i] &= 0x0FFFF;
		glsInfo.sGlassData[i].Format( "%04X", nGlassData[i] );
	}

	glsInfo.nCstSeqNo		= ( nGlassData[0] >> 12 ) & 0x000F;
	glsInfo.nLineControl	= ( nGlassData[0] >> 11 ) & 0x0001;	
	glsInfo.nSlotNo			= ( nGlassData[0] ) & 0x07FF;
	glsInfo.nMaterialNo		= ( nGlassData[1] >> 12 ) & 0x000F; 
	glsInfo.nMaintainCst	= ( nGlassData[1] >>  4 ) & 0x000F;
	glsInfo.nBendingPara	= ( nGlassData[1] ) & 0x000F;
	
	// BCD to int
	glsInfo.nLdRecipeId	    = Bcd2Int( glsInfo.nGlassData[2] );
	glsInfo.nUlRecipeId	    = Bcd2Int( glsInfo.nGlassData[4] );

	int nRecipeId			= Bcd2Int( glsInfo.nGlassData[3] );
	glsInfo.sRecipeId.Format("%d", nRecipeId );
}

int	CDicsData::Bcd2Int( short nVal )
{
	int nReturnVal=0;

	nReturnVal  = nVal & 0X0F;
	nReturnVal += ( nVal >> 4 & 0X0F ) * 10;
	nReturnVal += ( nVal >> 8 & 0X0F ) * 100;
	nReturnVal += ( nVal >>12 & 0X0F ) * 1000;
	
	return nReturnVal;
}

short CDicsData::Int2Bcd( int nVal )
{
	int nReturnVal = 0;

	int nTmp[4] = { 0, };
	nTmp[0]	=   nVal / 1000 ; 
	nTmp[1] = ( nVal - nTmp[0] * 1000 ) / 100;
	nTmp[2] = ( nVal - nTmp[0] * 1000 - nTmp[1] * 100 ) / 10;
	nTmp[3] = ( nVal - nTmp[0] * 1000 - nTmp[1] * 100 - nTmp[2] * 10 );

	nReturnVal = nTmp[0] <<12 | nTmp[1] << 8 | nTmp[2] << 4 | nTmp[3];
	
	return nReturnVal;
}

unsigned short CDicsData::Ascii2Word( CString sVal )
{
	unsigned short nVal=0;
	char ch1, ch2;

	if( sVal.GetLength() <= 0 ) ch1 = 0x20;
	else ch1 = sVal.GetAt( 0 );

	if( sVal.GetLength() <= 1 ) ch2 = 0x20;
	else ch2 = sVal.GetAt( 1 );
	
	if( ch1 == ' ' ) ch1 = 0x20;
	if( ch2 == ' ' ) ch2 = 0x20;
	if( ch1 == '\r' ) ch1 = 0x00;
	if( ch2 == '\r' ) ch2 = 0x00;

	nVal = ch1 | ( ch2 << 8 );

	return nVal;
}

CString CDicsData::Word2Ascii( short nData )
{
	CString sData = "";
	char ch;

	ch = nData & 0x00FF;
	if( ch == 0 ) ch = ' ';
	sData += ch;

	ch = ( nData >> 8 ) & 0x00FF;
	if( ch == 0 ) ch = ' ';
	sData += ch;

	return sData;
}

void CDicsData::InitPara1()
{
	// Clear the m_IfFlag structure of CV Unit
//	for( int i=0; i<MAX_CV_NO; i++ )
//	{
//		m_IfFlag[i + IF_UNIT_LD].bInReady				= FALSE;
//		m_IfFlag[i + IF_UNIT_LD].bOutReady				= FALSE;
//		m_IfFlag[i + IF_UNIT_LD].bInComp				= FALSE;
//		m_IfFlag[i + IF_UNIT_LD].bOutComp				= FALSE;
//		m_IfFlag[i + IF_UNIT_LD].bWaitPos				= FALSE;
//		m_IfFlag[i + IF_UNIT_LD].bInError				= FALSE;
//		m_IfFlag[i + IF_UNIT_LD].bOutError				= FALSE;
//		m_IfFlag[i + IF_UNIT_LD].bSeqStop				= FALSE;
//		m_IfFlag[i + IF_UNIT_LD].bInSick				= FALSE; 
//		m_IfFlag[i + IF_UNIT_LD].bOutSick				= FALSE; 
//		m_IfFlag[i + IF_UNIT_LD].bInLogicCheckIgnore	= TRUE;
//		m_IfFlag[i + IF_UNIT_LD].bOutLogicCheckIgnore	= TRUE;

		// In & Out Complete flag is TRUE for CV Unit
		// LD Unit InSensor 
//		m_IfFlag[i + IF_UNIT_LD].bInComp = TRUE;
//		m_IfFlag[i + IF_UNIT_LD].bOutComp = TRUE;

//		for( int j=0; j<MAX_STOP_COUNT_NO; j++ )
//		{
//			m_SeqFlag.bRollerState[j][i + IF_UNIT_LD]		= FALSE;
//			m_SeqFlag.bRollerStateAll[j][i + IF_UNIT_LD]	= FALSE;
//			m_SeqFlag.bSeqStopState[j][i + IF_UNIT_LD]		= FALSE;
//		}
// 	}

//	m_SeqFlag.bStopCount1			= FALSE;
//	m_SeqFlag.bStopCount2			= FALSE;
// HDC Case
#ifdef _MY_DEBUG
	int i;
	for( i=0; i<MAX_UNIT_NO; i++ ) m_bDebugInSensor[i] = FALSE;
	for( i=0; i<MAX_UNIT_NO; i++ ) m_bDebugOutSensor[i] = FALSE;
	m_bDebugInterlockSensor = FALSE;
#endif
}
