// DicsDoc.cpp : implementation of the CDicsDoc class
//

#include "stdafx.h"
#include "Dics.h"

#include "Define.h"
#include "DicsDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDicsDoc

IMPLEMENT_DYNCREATE(CDicsDoc, CDocument)

BEGIN_MESSAGE_MAP(CDicsDoc, CDocument)
	//{{AFX_MSG_MAP(CDicsDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDicsDoc construction/destruction

CDicsDoc::CDicsDoc()
{
	m_pSystemWnd	= NULL;
	m_pServoWnd		= NULL;
	m_pRecipesWnd	= NULL;
	m_pSetupWnd		= NULL;
	m_pAlarmsWnd	= NULL;
	m_pDatalogWnd	= NULL;
	m_pHelpWnd		= NULL;

	m_pDicsView		= NULL;
	m_pSetupView	= NULL;
	m_pSystemView	= NULL;
	m_pAlarmsView	= NULL;
	m_pRecipesView	= NULL;
	m_pDatalogView	= NULL;
	m_pHelpView		= NULL;
	m_pErrHistSet	= NULL;
	m_pRecipeSet	= NULL;
	m_pSetupItems	= NULL;
}

CDicsDoc::~CDicsDoc()
{
}

BOOL CDicsDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;


	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	SetTitle( _TITLE );

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CDicsDoc serialization

void CDicsDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDicsDoc diagnostics

#ifdef _DEBUG
void CDicsDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDicsDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDicsDoc commands

// ---------------------------------------------------------
// User defined functions
// --- Create New view ---
//----------------------------------------------------------
void CDicsDoc::CreateNewView(int nID)
{	
	switch( nID ) 
	{
	case ID_SYSTEM:
		if( m_pSystemWnd )
		{
			m_pSystemWnd->MDIActivate();
			return;
		}
		else
		{
			CDocTemplate* pTemplate = ( (CDicsApp* ) AfxGetApp() )->m_pSystemTemplate;
			ASSERT_VALID( pTemplate );
			m_pSystemWnd = (CMDIChildWnd*) pTemplate->CreateNewFrame( this, NULL );
			if( m_pSystemWnd == NULL ) 
			{
				TRACE0( "Warning:failed to create new frame\n" );
				AfxMessageBox( AFX_IDP_COMMAND_FAILURE );
				return;
			}
			pTemplate->InitialUpdateFrame( m_pSystemWnd, NULL );
		}
		break;

	case ID_SERVO:
		if( m_pServoWnd )
		{
			m_pServoWnd->MDIActivate();
			return;
		}
		else
		{
			CDocTemplate* pTemplate = ( (CDicsApp* ) AfxGetApp() )->m_pServoTemplate;
			ASSERT_VALID( pTemplate );
			m_pServoWnd = (CMDIChildWnd*) pTemplate->CreateNewFrame( this, NULL );
			if( m_pServoWnd == NULL ) 
			{
				TRACE0( "Warning:failed to create new frame\n" );
				AfxMessageBox( AFX_IDP_COMMAND_FAILURE );
				return;
			}
			pTemplate->InitialUpdateFrame( m_pServoWnd, NULL );
		}
		break;

	case ID_RECIPES:
		if( m_pRecipesWnd )
		{
			m_pRecipesWnd->MDIActivate();
			return;
		}
		else
		{
			CDocTemplate* pTemplate = ( (CDicsApp* ) AfxGetApp() )->m_pRecipesTemplate;
			ASSERT_VALID( pTemplate );
			m_pRecipesWnd = (CMDIChildWnd*) pTemplate->CreateNewFrame( this, NULL );
			if( m_pRecipesWnd == NULL ) 
			{
				TRACE0( "Warning:failed to create new frame\n" );
				AfxMessageBox( AFX_IDP_COMMAND_FAILURE );
				return;
			}
			pTemplate->InitialUpdateFrame( m_pRecipesWnd, NULL );
		}
		break;

	case ID_SETUP:
		if( m_pSetupWnd )
		{
			m_pSetupWnd->MDIActivate();
			return;
		}
		else
		{
			CDocTemplate* pTemplate = ( (CDicsApp* ) AfxGetApp() )->m_pSetupTemplate;
			ASSERT_VALID( pTemplate );
			m_pSetupWnd = (CMDIChildWnd*) pTemplate->CreateNewFrame( this, NULL );
			if( m_pSetupWnd == NULL ) 
			{
				TRACE0( "Warning:failed to create new frame\n" );
				AfxMessageBox( AFX_IDP_COMMAND_FAILURE );
				return;
			}
			pTemplate->InitialUpdateFrame( m_pSetupWnd, NULL );
		}
		break;

	case ID_ALARMS:
		if( m_pAlarmsWnd )
		{
			m_pAlarmsWnd->MDIActivate();
			return;
		}
		else
		{
			CDocTemplate* pTemplate = ( (CDicsApp* ) AfxGetApp() )->m_pAlarmsTemplate;
			ASSERT_VALID( pTemplate );
			m_pAlarmsWnd = (CMDIChildWnd*) pTemplate->CreateNewFrame( this, NULL );
			if( m_pAlarmsWnd == NULL ) 
			{
				TRACE0( "Warning:failed to create new frame\n" );
				AfxMessageBox( AFX_IDP_COMMAND_FAILURE );
				return;
			}
			pTemplate->InitialUpdateFrame( m_pAlarmsWnd, NULL );
		}
		break;

	case ID_DATALOG:
		if( m_pDatalogWnd )
		{
			m_pDatalogWnd->MDIActivate();
			return;
		}
		else
		{
			CDocTemplate* pTemplate = ( (CDicsApp* ) AfxGetApp() )->m_pDatalogTemplate;
			ASSERT_VALID( pTemplate );
			m_pDatalogWnd = (CMDIChildWnd*) pTemplate->CreateNewFrame( this, NULL );
			if( m_pDatalogWnd == NULL ) 
			{
				TRACE0( "Warning:failed to create new frame\n" );
				AfxMessageBox( AFX_IDP_COMMAND_FAILURE );
				return;
			}
			pTemplate->InitialUpdateFrame( m_pDatalogWnd, NULL );
		}
		break;

	case ID_HELP:
		if( m_pHelpWnd )
		{
			m_pHelpWnd->MDIActivate();
			return;
		}
		else
		{
			CDocTemplate* pTemplate = ( (CDicsApp* ) AfxGetApp() )->m_pHelpTemplate;
			ASSERT_VALID( pTemplate );
			m_pHelpWnd = (CMDIChildWnd*) pTemplate->CreateNewFrame( this, NULL );
			if( m_pHelpWnd == NULL ) 
			{
				TRACE0( "Warning:failed to create new frame\n" );
				AfxMessageBox( AFX_IDP_COMMAND_FAILURE );
				return;
			}
			pTemplate->InitialUpdateFrame( m_pHelpWnd, NULL );
		}
		break;
	}
}

// ---------------------------------------------------------
// --- InitDB ---
//----------------------------------------------------------
void CDicsDoc::InitDoc()
{
	// Initialize the error history set
	if( m_pErrHistSet == NULL )
	{
		m_pErrHistSet = new CDaoErrHistSet;
		if( m_pErrHistSet )
		{
			m_pErrHistSet->m_strSort = "ErrorTime DESC, ErrorID, ErrorLevel, ErrorContent";
			m_pErrHistSet->Open();
		}
	}

	// Initialize the recipe set
	if( m_pRecipeSet == NULL )
	{
 		m_pRecipeSet = new CDaoRecipeSet;
		if( m_pRecipeSet ) m_pRecipeSet->Open();
	}

	// Dynamically allocate the recipe information
	m_nMaxRow			= m_pRecipeSet->GetRecipeRowCount();
	m_pRecipeInfo		= new RECIPE_INFO[m_nMaxRow];
	m_pRecipeInfoTemp	= new RECIPE_INFO[m_nMaxRow];

	// Get all the value from recipe set
	// Recipe No ==> starts from 1
	for( int nRow=0; nRow<m_nMaxRow; nRow++ )
	{
		m_pRecipeInfo[nRow]			= m_pRecipeSet->GetRecipeInfo( nRow );
//		m_pRecipeInfo[nRow].bChange	= FALSE;
		m_pRecipeInfoTemp[nRow]		= m_pRecipeInfo[nRow];
	}

//	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	m_IniConfiguration.Open( "DicsInfo", "GenInfo" );
	m_sRecipeId = m_IniConfiguration.GetStringValue( "RECIPE", "Recipe ID", m_pRecipeInfo[0].sValue[CDaoRecipeSet::rcpID] );

	if( GetRowfromID( m_sRecipeId ) == -1 )
	{
		m_sRecipeId = m_pRecipeInfo[0].sValue[CDaoRecipeSet::rcpID];		
		m_IniConfiguration.SetStringValue( "RECIPE", "Recipe ID", m_sRecipeId, TRUE );
	}

	//----------------------------------------------------------------------------
	// Initialize Setup Items
	m_pSetupItems = new CSetupItems();
}

// ---------------------------------------------------------
// SetRecipeId : Set the recipe ID to registry and update the contents of recipe table.
//----------------------------------------------------------
void CDicsDoc::SetRecipeId(CString sRecipeId)
{
	if( sRecipeId.GetLength() > 0 ) // In case of changing recipe
	{
		if( m_sRecipeId == sRecipeId ) return;
		m_sRecipeId = sRecipeId;
	}

	// Save the recipe id to profile.
//	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	m_IniConfiguration.Open( "DicsInfo", "GenInfo" );
	m_IniConfiguration.SetStringValue( "RECIPE", "Recipe ID", m_sRecipeId, TRUE );


	// display the main view also (Recipe Info)
	m_pDicsView->m_pTabJobsMainView->SetDataToGridCtrl_RecipeInfo();

	// display the main view also (Recipe ID)
	m_pDicsView->m_pTabJobsMainView->SetRecipeId2View( m_sRecipeId );
}

// ---------------------------------------------------------
// IsRecipeChanged
//----------------------------------------------------------
BOOL CDicsDoc::IsRecipeChanged(CString sRecipeId)
{
	if( sRecipeId.GetLength() == 0   )
	{
		for( int nRow=0; nRow<m_nMaxRow; nRow++ )
		{
			for( int i=0; i<MAX_RECIPE_BODY_NO; i++ )
			{
				if( m_pRecipeInfoTemp[nRow].sValue[i] != m_pRecipeInfo[nRow].sValue[i] ) 
					return TRUE;
			}
		}
	}
	else
	{
		int nRow = GetRowfromID( sRecipeId );
		if( nRow < 0 ) return FALSE;
		for( int i=0; i<MAX_RECIPE_BODY_NO; i++ )
		{
			if( m_pRecipeInfoTemp[nRow].sValue[i] != m_pRecipeInfo[nRow].sValue[i] ) 
			{
				m_pDicsView->m_pDicsData->m_IfCim.bRecipeChange[nRow] =TRUE;
				return TRUE;
			}
		}
	}
	return FALSE;
}

// ---------------------------------------------------------
// --- CloseDB ---
//----------------------------------------------------------
void CDicsDoc::CloseDoc()
{
	if( m_pErrHistSet )
	{
		if( m_pErrHistSet->IsOpen() ) m_pErrHistSet->Close();
		delete m_pErrHistSet;
	}

	if( m_pRecipeSet )
	{
		if( m_pRecipeSet->IsOpen() ) m_pRecipeSet->Close();
		delete	m_pRecipeSet;
	}

	// Delete the pointer
	delete []m_pRecipeInfo;
	delete []m_pRecipeInfoTemp;

	if( m_pSetupItems ) delete m_pSetupItems;
}

void CDicsDoc::UpDateRecipeData()
{
	m_nMaxRow	= m_pRecipeSet->GetRecipeRowCount();
	
	// Dynamically allocate the Recipe data information
	if( m_pRecipeInfo || m_pRecipeInfoTemp)
	{
		delete []m_pRecipeInfo;
		delete []m_pRecipeInfoTemp;
		m_pRecipeInfo		= new RECIPE_INFO[m_nMaxRow];
		m_pRecipeInfoTemp	= new RECIPE_INFO[m_nMaxRow];
	}
	else
	{
		m_pRecipeInfo		= new RECIPE_INFO[m_nMaxRow];
		m_pRecipeInfoTemp	= new RECIPE_INFO[m_nMaxRow];
	}

	// Get all the value from Recipe DB
	for(int nRow=0; nRow<m_nMaxRow; nRow++ )
	{
		m_pRecipeInfo[nRow]		= m_pRecipeSet->GetRecipeInfo( nRow );
		m_pRecipeInfoTemp[nRow]	= m_pRecipeInfo[nRow];
	}
}

// Get the sID's row from m_pRecipeInfo 
int CDicsDoc::GetRowfromID( CString sID )
{
	int nID = atoi( sID );
	sID.Format("%d", nID );

	for( int nRow=0; nRow<m_nMaxRow; nRow++ )
	{
		if( m_pRecipeInfo[nRow].sValue[0] == sID ) return nRow;
	}
	return -1;
}

BOOL CDicsDoc::ISExistRecipeID( CString sID )
{
	 BOOL bExistRecipe = FALSE;
	 for( int nRow=0; nRow<m_nMaxRow; nRow++ )
	 {
		 //if(m_pRecipeInfo[nRow].sValue[0] == sID )
		 if(atoi(m_pRecipeInfo[nRow].sValue[0]) == atoi(sID) )
		 {
			 bExistRecipe = TRUE;
		 }
	 }
	 return bExistRecipe;
}