// DicsDoc.h : interface of the CDicsDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DICSDOC_H__B5F8D0BA_4001_4FC2_8B16_16CCDE257F83__INCLUDED_)
#define AFX_DICSDOC_H__B5F8D0BA_4001_4FC2_8B16_16CCDE257F83__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Database\DaoErrHistSet.h"
#include "Database\DaoRecipeSet.h"
#include "View\SetupItems.h"
#include "FactoryLib\IniData.h"	// Added by ClassView


class CDicsView;
class CSetupView;
class CSystemView;
class CAlarmsView;
class CRecipesView;
class CDatalogView;
class CHelpView;

class CDicsDoc : public CDocument
{
protected: // create from serialization only
	CDicsDoc();
	DECLARE_DYNCREATE(CDicsDoc)

// Attributes
public:
	CMDIChildWnd*	m_pSystemWnd;
	CMDIChildWnd*	m_pServoWnd;
	CMDIChildWnd*	m_pRecipesWnd;
	CMDIChildWnd*	m_pSetupWnd;
	CMDIChildWnd*	m_pAlarmsWnd;
	CMDIChildWnd*	m_pDatalogWnd;
	CMDIChildWnd*	m_pHelpWnd;

	CDicsView*		m_pDicsView;
	CSetupView*		m_pSetupView;
	CSystemView*	m_pSystemView;
	CAlarmsView*	m_pAlarmsView;
	CRecipesView*	m_pRecipesView;
	CDatalogView*	m_pDatalogView;
	CDatalogView*	m_pHelpView;

	CDaoErrHistSet*		m_pErrHistSet;
	CDaoRecipeSet*		m_pRecipeSet;

	int m_nMaxRow;
	RECIPE_INFO*	m_pRecipeInfo;		// [Recipe No]
	RECIPE_INFO*	m_pRecipeInfoTemp;	// Buf[Recipe No]
	CString			m_sRecipeId;

	CSetupItems*	m_pSetupItems;
	CIniData		m_IniConfiguration;

	enum nameRECIPE_INFO
	{
		recipeID,
		recipeCHANGE_TIME,
		recipeCOMMENT,
		recipeTACT_TIME,
		recipeCONV_SPEED,
		recipeSBJ1_ON_OFF,
		recipeSBJ2_ON_OFF,
		recipeUPPER_RB1_DIR,
		recipeLOWER_RB1_DIR,
		recipeUPPER_RB2_DIR,
		recipeLOWER_RB2_DIR,
		recipeUPPER_RB3_DIR,	//190329 ksh
		recipeLOWER_RB3_DIR,
		recipeUPPER_RB4_DIR,
		recipeLOWER_RB4_DIR,
	};

// Operations
public:
	void SetDicsView(CDicsView* pView) { m_pDicsView = pView; }
	void CreateNewView(int nID);
	void SetSetupView(CSetupView* pView) { m_pSetupView = pView; }
	void SetSystemView(CSystemView* pView) { m_pSystemView = pView; }
	void SetAlarmsView(CAlarmsView* pView) { m_pAlarmsView = pView; }
	void SetRecipesView(CRecipesView* pView){ m_pRecipesView = pView; }
	void SetDatalogView(CDatalogView* pView) { m_pDatalogView = pView; }
	void InitDoc();
	void SetRecipeId(CString sRecipeId = "");
	BOOL IsRecipeChanged(CString sRecipeId = "");	// "" means that we have to check all recipe lists.
	void CloseDoc();
	void UpDateRecipeData();
	int GetRowfromID( CString sID );

	BOOL ISExistRecipeID( CString sID );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDicsDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDicsDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDicsDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DICSDOC_H__B5F8D0BA_4001_4FC2_8B16_16CCDE257F83__INCLUDED_)
