// DicsView.h : interface of the CDicsView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DICSVIEW_H__43BF87B3_9EBF_41CF_80C9_B0CEA8F30662__INCLUDED_)
#define AFX_DICSVIEW_H__43BF87B3_9EBF_41CF_80C9_B0CEA8F30662__INCLUDED_

#include "X\XCtlDevice.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "X\XTabCtrl.h"
#include "X\XCtlmelsec.h"	// Added by ClassView
#include "X\MuxCom.h"
#include "X\MuxCom2.h"		// 191126 hskwak
 
#include "View\JobsTabMainView.h"
#include "View\JobsTabInterfaceView.h"
#include "View\JobsTabPipingView.h"
#include "View\JobsTabPipingView2.h"
#include "View\JobsTabPipingBufTankView.h"		//200413 hskwak BufTank Add
#include "View\JobsTabMotorLoadFactorView.h"
#include "View\JobsTabEuvStatusView.h"
#include "View\JobsTabApStatusView.h"
#include "View\jobstabhpmjstatusview.h"
#include "View\JobsTabProcessDataView.h"
#include "View\JobsTabDoorView.h"
#include "View\JobsTabCimView.h"
//#include "View\JobsTabLoaderView.h"

#include "Sequence\MainSeq.h"
#include "Sequence\EqpStateSequence.h"
#include "Sequence\PumpSeq.h"
#include "Sequence\RbSeq.h"
#include "Sequence\EuvSeq.h"
#include "Sequence\CommonInterlockSeq.h"
#include "Sequence\GaugeInterlockSeq.h"
#include "Sequence\CimSeq.h"
#include "Sequence\CimSeq1.h"
#include "Sequence\InterfaceSeq.h"
#include "Sequence\CvSeq.h"	// Added by ClassView
#include "Sequence\SocketSequence.h"
#include "Sequence\HpmjSequence.h"	// Added by ClassView
#include "Sequence\PlasmaSequence.h"
#include "Sequence\SocketSeq.h"
#include "Sequence\SocketSeq1.h"
#include "Sequence\ScanSequence.h"

#include "Dlg\DlgInitStatus.h"
#include "Dlg\DlgInitStatus.h"
#include "Dlg\DlgEditVal.h"

#include "DicsData.h"
#include "GlassAni.h"
#include "AnalogInput1.h"
#include "Host.h"
#include "Host1.h"
#include "CommFlowMeter.h"
#include "CommFlowMeter2.h"		// 20100407 ssm
#include "X\XKM100.h"			// 20100707 ssm
#include "X\XKdyA.h" //190325 ksh
#include "CommModbusRTU.h"	// 231212 halesu
#include "CommVCR.h"
#include "GlassAni.h"
#include "DicsData.h"

#ifdef _MY_DEBUG
#include "FileMap.h"
#endif

// IO Device Class include
#include "FactoryLib\IniData.h"	// Added by ClassView
#include "FactoryLib\EqpAssy.h"	

class CDicsView : public CFormView
{
protected: // create from serialization only
	CDicsView();
	DECLARE_DYNCREATE(CDicsView)

public:
	//{{AFX_DATA(CDicsView)
	enum { IDD = IDD_DICS_FORM };
	CListBox	m_listHostLog;
	CListBox	m_listError;
	CListBox	m_listEqpLog;
	CXTabCtrl	m_tabCtrl;
	//}}AFX_DATA
	CMacCheckBox m_macEnableCommLog;
	CMacCheckBox m_macEnableEqpLog;

// Attributes
public:
	CDicsDoc* GetDocument();

	// Tab View
	CJobsTabMainView*			m_pTabJobsMainView;
//	CJobsTabCimView*			m_pTabJobsCimView;
	CJobsTabInterfaceView*		m_pTabJobsInterfaceView;
//	CJobsTabLoaderView*			m_pTabJobsLoaderView;
	CJobsTabPipingView*			m_pTabJobsPipingView;
	CJobsTabPipingView2*		m_pTabJobsPipingView2;
	CJobsTabPipingBufTankView*		m_pTabJobsPipingBufTankView;	//200413 hskwak BufTank Add
	CJobsTabMotorLoadFactorView*		m_pTabJobsMotorLoadFactorView;
	CJobsTabEuvStatusView*		m_pTabJobsEuvStatusView;		
//	CJobsTabApStatusView*		m_pTabJobsApStatusView;
#ifdef _HPMJ
	CJobsTabHpmjStatusView*		m_pTabJobHpmjStatusView;
#endif
	CJobsTabProcessDataView*	m_pTabJobsProcessDataView;		
	CJobsTabDoorView*			m_pTabJobsDoorView;		
	XTimer*				m_pTimer;
	XCtlDevice*			m_pDevice;
	XCtlMelsec*			m_pMelsec;
	CDicsData*			m_pDicsData;
	XMmc*				m_pMmc;
	CGlassAni*			m_pGlassAni;

	CMainSeq*			m_pMainSeq;
	CEqpStateSequence*	m_pEqpStateSeq;
	CPumpSeq*			m_pPumpSeq;
	CEuvSeq*			m_pEuvSeq;
	CCommonInterlockSeq*m_pCommonIntrSeq;
	CGaugeInterlockSeq*	m_pGaugeIntrSeq;
	CRbSeq*				m_pRbSeq;
	CCimSeq*			m_pCimSeq;
	CCimSeq1*			m_pCimSeq1;
	CInterfaceSeq*		m_pIfSeq;
	CCvSeq*				m_pCvSeq;
//	CTrSeq*				m_pTrSeq;
	CPlasmaSequence*	m_pPlasmaSeq;
	CHpmjSequence*		m_pHpmjSeq;

//	CSocketSequence*	m_pSocketSeq;
	CScanSequence*		m_pScanSeq;
	
	CDlgInitStatus*		m_pDlgInitStatus;
	CDlgEditVal*		m_pDlgEditStatus;
	CCommFlowMeter*		m_pFlowCtrl;
	CCommFlowMeter2*	m_pFlowCtrl2;		// 20100407 ssm
	CXKM100*			m_pXkm100;			// 20100707 ssm
	CXKdyA*				m_pXKdyA;			// 190325 ksh
	CCommModbusRTU*		m_pCommModbus;		// 231212 halesu
	CMuxCom*			m_pCommMux;
	CMuxCom2*			m_pCommMux2;	// 191126 hskwak

	CHost*				m_pHost;
	CHost1*				m_pHost1;
	CSocketSeq*			m_pSocketSeq;
	CSocketSeq1*		m_pSocketSeq1;

	XLog*				m_pHostSFLog;
	XLog*				m_pHostLoadSDFLog;
	XLog*				m_pHostHexLog;

	XLog*				m_pHost1SFLog;
	XLog*				m_pHost1LoadSDFLog;
	XLog*				m_pHost1HexLog;

	CMuxCom*			m_pCommEuv;
//	CCommVCR*			m_pCommVCR;

	CIniData			m_IniConfiguration;
#ifdef _CIM_SKIP
	CFileMap*			m_pFileMap;
#endif
	CString				m_sIpAddress;
	int					m_nPortNumber;

	CString				m_sIpAddress1;
	int					m_nPortNumber1;

	int					m_nUserChangeTime;
	// color brush
	CBrush				m_hbrBgColor;

	// member variables
	BOOL				m_bStartCount;
//	int					m_nTactTime;
	long				m_nTactTime;		// ljy_050212 : change -> Tact Time  ʱȭ ʰ ɶ.
	double				m_dTactTime_Unit[MAX_UNIT_NO];	// hskwak 191011 Unit  tack time ߰.
	double				m_dOldTactTime_Unit[MAX_UNIT_NO];	// hskwak 191011 Unit  tack time ߰.
	int					m_nSelectedTab;
	POINT				m_pntCurPos;

	enum _SOCKET	{ smHostConnect, smHostDisconnect, smUnpackerConnect, smUnpackerDisconnect, smLoaderConnect, smLoaderDisconnect };

// Operations
	enum dataManipulation
	{
		dmOK,
		dmDUP_DATA,
		dmNOT_SENSED_GLASS,
		dmSENSED_GLASS,
		dmEXCEED_GLASS_NO,
		dmDENIED_LOGICALLY,
	};

#ifndef _NO_EUV
	enum { viewJobMain, viewJobInterface, viewJobPiping, viewJobPiping2, viewJobEuv,viewJobProcess, viewJobHpmj, viewJobAP };
#else

#ifdef _BUFTANK_USE
	enum { viewJobMain, viewJobInterface, viewJobPiping, viewJobPiping2, viewJobPipingBufTank, viewJobMotorLoadFactor, viewJobProcess, viewJobDoor, viewJobHpmj, viewJobAP };
#else
#ifdef _MOTOR_LOAD_FACTOR
	enum { viewJobMain, viewJobInterface, viewJobPiping, viewJobPiping2, viewJobMotorLoadFactor, viewJobProcess, viewJobDoor, viewJobHpmj, viewJobAP };
#else
	enum { viewJobMain, viewJobInterface, viewJobPiping, viewJobPiping2, viewJobProcess, viewJobDoor, viewJobMotorLoadFactor, viewJobHpmj, viewJobAP };
#endif
#endif
#endif

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDicsView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	BOOL	OpenSocket(BOOL bShowMsgBox);
	BOOL	OpenSocket1(BOOL bShowMsgBox);
	void	SetSeqStart();
	void	SetLog(CString sSeqName, int nPortNo, int nSlotNo, CString sMessage);
	int		GlassInfoCopy(int i, int nTarget);
	int		GlassInfoMove(int i, int nTarget);
	void	SetToolbar( int nTab );
	void	HostLogMsg(LPCTSTR lpszMsg);
	int		GlassInfoDelete(int nId , BOOL bMove = FALSE);//2008.11.18 kimgun
	virtual ~CDicsView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDicsView)
	afx_msg void OnDestroy();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnCheckCommLog();
	afx_msg void OnCheckEqpLog();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	afx_msg LRESULT OnDevicenetMonitor( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnSelChangeTab( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnSelectTab( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnSetupView( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnEqpLog( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnHostLog( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnAlarm( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnGlassNo( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnTactTime( WPARAM wParam, LPARAM lParam );
	afx_msg void OnCvStatusChanged( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnSetRecipe( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnEqpMessage( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnJobsView( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnEditCstIdInfo( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnIdleRunningProgress( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnEuvOnProgress( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnAIValue( WPARAM wParam, LPARAM lParam );	
	afx_msg LRESULT OnInitStatus( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnLostGlassAdd( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnLostGlassRecovery( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnSocketOpen( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnSocketOpen1( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnSecsMsg( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnSecsMsg1( WPARAM wParam, LPARAM lParam );	// shcho 230207
	afx_msg LRESULT OnEuvComm( WPARAM wParam, LPARAM lParam );
	afx_msg	void GlassDataAdd( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnTestModeSet( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()

public:
	void SetSeqInitParameter();
	void AddHostMsg(LPCTSTR szMsg);
	BOOL SocketOpen(BOOL bShowMsgBox);
	BOOL m_bConnecting;
	
	CEqpAssy* m_pEqpAssy;
	CDigitalInputs	m_Di;
	CDigitalOutputs m_Do;
	CAnalogInputs	m_Ai;
	CAnalogOutputs	m_Ao;
};

#ifndef _DEBUG  // debug version in DicsView.cpp
inline CDicsDoc* CDicsView::GetDocument()
   { return (CDicsDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DICSVIEW_H__43BF87B3_9EBF_41CF_80C9_B0CEA8F30662__INCLUDED_)
