// DialogGlassInfo.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DialogGlassInfo.h"
#include "DlgTargetCv.h"
#include "DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDialogGlassInfo dialog


CDialogGlassInfo::CDialogGlassInfo(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogGlassInfo::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialogGlassInfo)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CString CDialogGlassInfo::m_sGlassDataName[] = 
{
	"Port No",
	"Slot No",
	"Recipe ID",
	"Glass ID",
	"Process Flag",
};

void CDialogGlassInfo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogGlassInfo)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Control(pDX, IDC_DELETE, m_Delete);
	DDX_Control(pDX, IDC_CHANGE, m_Change);
	DDX_Control(pDX, IDC_MOVE, m_Move);

	DDX_Control(pDX, IDC_GRID_GLASS_INFO, m_gridGlassInfo);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogGlassInfo, CDialog)
	//{{AFX_MSG_MAP(CDialogGlassInfo)
	ON_BN_CLICKED(IDC_CHANGE, OnChange)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_BN_CLICKED(IDC_MOVE, OnMove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialogGlassInfo message handlers

BOOL CDialogGlassInfo::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );
	m_Delete.LoadBitmaps( IDB_DELETE, IDB_DELETE1, 0, IDB_DELETE2 );
	m_Change.LoadBitmaps( IDB_REGISTER, IDB_REGISTER1, 0, IDB_REGISTER2 );
	m_Move.LoadBitmaps( IDB_DATA_MOVE, IDB_DATA_MOVE1, 0, IDB_DATA_MOVE2 );

	if( !m_bPermitAccess ) 
	{
		GetDlgItem( IDC_DELETE )->EnableWindow( FALSE );
		GetDlgItem( IDC_CHANGE )->EnableWindow( FALSE );
		GetDlgItem( IDC_MOVE )->EnableWindow( FALSE );
	}

	SetWindowText( m_sTitle );

	GridInit_GlassInfo();

	CRect r;
	GetWindowRect( &r );
	MoveWindow( 270, 330, r.right - r.left, r.bottom - r.top );	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE	
}

void CDialogGlassInfo::GridInit_GlassInfo()
{
	LPTSTR sLvcText[] = { " Item ", " Contents " };
	int nColWidth[] = { 1500, 2100 }; 

	// initialize GridCtrl
	m_gridGlassInfo.SetRows( MAX_GLASS_DATA_ITEM_NO + 1 ); 
	m_gridGlassInfo.SetCols( 2 );

	//-------------------------------------------
	m_gridGlassInfo.SetRow( 0 );  
	m_gridGlassInfo.SetColWidth( 0, nColWidth[0] );
	m_gridGlassInfo.SetCol( 0 ); 
	m_gridGlassInfo.SetCellAlignment( 4 );
	m_gridGlassInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridGlassInfo.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridGlassInfo.SetColWidth( 1, nColWidth[1] );
	m_gridGlassInfo.SetCol( 1 ); 
	m_gridGlassInfo.SetCellAlignment( 4 );
	m_gridGlassInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridGlassInfo.SetText( sLvcText[1] ); 

	SetDataToGridCtrl_GlassInfo();
}

void CDialogGlassInfo::SetDataToGridCtrl_GlassInfo()
{
	CString sBuf;

	for( int i=0; i<MAX_GLASS_DATA_ITEM_NO; i++ )
	{
		// 1st column
		m_gridGlassInfo.SetCol( 0 );
		m_gridGlassInfo.SetRow( i + 1 );
		m_gridGlassInfo.SetCellAlignment( 0 );	// Left adjusted
		m_gridGlassInfo.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( " %s", m_sGlassDataName[i] );
		m_gridGlassInfo.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridGlassInfo.SetCol( 1 );
		m_gridGlassInfo.SetRow( i + 1 );
		
		m_gridGlassInfo.SetCellBackColor( LIGHT_YELLOW_COLOR );
		m_gridGlassInfo.SetCellForeColor( BLACK_COLOR );
		sBuf.Format( " %s", m_sGlassData[i] );
		m_gridGlassInfo.SetText( (LPCTSTR) sBuf );
		m_gridGlassInfo.SetCellAlignment( 4 );
	}
}

void CDialogGlassInfo::OnChange() 
{
	if( AfxMessageBox( "CHANGE : Would you like to change slot information really?", MB_YESNO ) != IDYES ) return;

	for (int i=0; i<MAX_GLASS_DATA_ITEM_NO; i++)
	{
		m_gridGlassInfo.SetCol( 1 );
		m_gridGlassInfo.SetRow( i + 1 ); 

		m_sGlassData[i] = m_gridGlassInfo.GetText();
	}
 
	EndDialog( IDC_CHANGE );
}

void CDialogGlassInfo::OnDelete() 
{
	if( AfxMessageBox( "DELETE : Would you like to delete slot information really?", MB_YESNO ) != IDYES ) return;
	EndDialog( IDC_DELETE );
}

void CDialogGlassInfo::OnMove() 
{
//	if( AfxMessageBox( "MOVE : Would you like to move slot information really?", MB_YESNO ) != IDYES ) return;

	CDlgTargetCv dlg;

	if( dlg.DoModal() == IDOK ) 
	{
		m_nTargetCv = dlg.m_nTargetCv;
		EndDialog( IDC_MOVE );
	}
}

void CDialogGlassInfo::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

BEGIN_EVENTSINK_MAP(CDialogGlassInfo, CDialog)
    //{{AFX_EVENTSINK_MAP(CDialogGlassInfo)
	ON_EVENT(CDialogGlassInfo, IDC_GRID_GLASS_INFO, -601 /* DblClick */, OnDblClickGridGlassInfo, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CDialogGlassInfo::OnDblClickGridGlassInfo() 
{
	// TODO: Add your control notification handler code here
	int nRow = m_gridGlassInfo.GetRow();
	int nCol = m_gridGlassInfo.GetCol();

	if ( nRow == 0 || nCol == 0 ) return;

	CString sBuf;

	if ( nCol == 1 )
	{
		CDlgEditVal dlg;
		dlg.m_sOldVal.Format( "%s", m_gridGlassInfo.GetText() );
		dlg.m_sCurVal = dlg.m_sOldVal;
		dlg.m_nType = CDlgEditVal::typeINPUT;
		dlg.m_nFormat = CDlgEditVal::formatSTRING ;
		if( dlg.DoModal() == IDOK )
		{
//			sBuf.Format( "%s %s", dlg.m_sCurVal, pDoc->m_pSetupItems->m_infoGaugeLimit[nRow - 1].sUnit );
//			m_gridGaugeLimit.SetText( (LPCTSTR) dlg.m_sCurVal );

			sBuf = dlg.m_sCurVal;

			// Set the changed value to temperary variable
			m_gridGlassInfo.SetText( (LPCTSTR) sBuf );
		}
	}
}
