// DlgAlign.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DlgAlign.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgAlign dialog


CDlgAlign::CDlgAlign(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAlign::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgAlign)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void CDlgAlign::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgAlign)
		// NOTE: the ClassWizard will add DDX and DDV calls here	
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_RADIO_FW, m_macAlignFw );
	DDX_Control(pDX, IDC_RADIO_BW, m_macAlignBw );
}


BEGIN_MESSAGE_MAP(CDlgAlign, CDialog)
	//{{AFX_MSG_MAP(CDlgAlign)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_RADIO_FW, OnRadioFw)
	ON_BN_CLICKED(IDC_RADIO_BW, OnRadioBw)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgAlign message handlers

BOOL CDlgAlign::OnInitDialog() 
{
	CDialog::OnInitDialog();
	// Set button
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	MAC_COLOR_SET color_set;
	m_macAlignFw.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macAlignFw.SetColorSetting( color_set );
	m_macAlignFw.SetBold();

	m_macAlignBw.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macAlignBw.SetColorSetting( color_set );
	m_macAlignBw.SetBold();
	
	// TODO: Add extra initialization here
	SetTimer( TIMER_MANUAL, 100, NULL );

	UINT nAlignID[6] = { IDC_STATIC_ALIGN1, IDC_STATIC_ALIGN2, 
		IDC_STATIC_ALIGN3, IDC_STATIC_ALIGN4, IDC_STATIC_ALIGN5, IDC_STATIC_ALIGN6 };
	for( int i=0 ; i<6; i++ )
	{
		m_stcAlign[i].SubclassDlgItem( nAlignID[i], this ); 
		m_stcAlign[i].SetTextColor( BLACK_COLOR );
		m_stcAlign[i].SetBkColor( WHITE_COLOR );
	}	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgAlign::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	for( int i = 0 ; i < m_pEqpAssy->m_CylinderLdAlign.GetDiSize(); i ++ )
	{
		
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_CylinderLdAlign.GetFw( i ) )
#else
		if( m_pEqpAssy->m_CylinderLdAlign.GetFwState( ) )
#endif
		{
			m_stcAlign[i].SetBkColor( GREEN_COLOR );
			m_stcAlign[i].SetWindowText( "FW" );
		}
#ifndef _MY_DEBUG
		else if( m_pEqpAssy->m_CylinderLdAlign.GetBw( i ) )
#else
		else if( m_pEqpAssy->m_CylinderLdAlign.GetBwState( ) )
#endif
		{

			m_stcAlign[i].SetBkColor( YELLOW_COLOR );
			m_stcAlign[i].SetWindowText( "BW" );
		}
		else 
		{
			m_stcAlign[i].SetBkColor( WHITE_COLOR );
			m_stcAlign[i].SetWindowText( "?" );
		}
	}
	CDialog::OnTimer(nIDEvent);
}

void CDlgAlign::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	KillTimer( TIMER_MANUAL );
}

void CDlgAlign::OnRadioFw() 
{
	m_pEqpAssy->m_CylinderLdAlign.SetFw();
}

void CDlgAlign::OnRadioBw() 
{
	m_pEqpAssy->m_CylinderLdAlign.SetBw();
}
