// CDlgPump3Cln.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgBufTankPumpCln.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgPump3Cln dialog


CDlgBufTankPumpCln::CDlgBufTankPumpCln(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgBufTankPumpCln::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgBufTankPumpCln)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgBufTankPumpCln::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgBufTankPumpCln)
	DDX_Control(pDX, IDC_PUMP_ON, m_macPumpOn);
	DDX_Control(pDX, IDC_PUMP_OFF, m_macPumpOff);
	DDX_Control(pDX, IDC_PUMP_NO_ALARM, m_macPumpNoAlarm);
	DDX_Control(pDX, IDC_PUMP_ALARM, m_macPumpAlarm);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgBufTankPumpCln, CDialog)
	//{{AFX_MSG_MAP(CDlgBufTankPumpCln)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_PUMP_ON, OnPumpOn)
	ON_BN_CLICKED(IDC_PUMP_OFF, OnPumpOff)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgPump3Cln message handlers

BOOL CDlgBufTankPumpCln::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CString sTitle;
	SetTimer( TIMER_MANUAL, 500, NULL );
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	// Set the MAC button (Pump)
	MAC_COLOR_SET color_set;
	m_macPumpOn.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macPumpOn.SetColorSetting( color_set );
	m_macPumpOn.SetBold();

	m_macPumpOff.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_RED_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macPumpOff.SetColorSetting( color_set );
	m_macPumpOff.SetBold();

	m_macPumpNoAlarm.SetCheckColor( BLUE_COLOR );
	m_macPumpAlarm.SetCheckColor( RED_COLOR );
	
	CString strTitle;
	strTitle.Format("BUFTANK PUMP%d", m_nCurSelPump+1);
	this->SetWindowText(strTitle);

	// Set the state
	if( m_pTank->GetPumpOnState( m_nCurSelPump ) ) m_macPumpOn.SetCheck( 1 );
	else m_macPumpOff.SetCheck( 1 );

	CRect r;
	GetWindowRect( &r );
//	MoveWindow( 200, 200, r.right - r.left, r.bottom - r.top );	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//---------------------------------------------------------------------------
// Moitoring
//---------------------------------------------------------------------------
void CDlgBufTankPumpCln::OnTimer(UINT nIDEvent) 
{
	// Alarm Message Monitoring (Pump)

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	// 231218 halesu Auto Valve Control NG Fix
	BOOL bPumpOutValveStatus[2] = {FALSE};
	bPumpOutValveStatus[0] = pView->m_pEqpAssy->m_AutoValvePumpOut.GetState(NO_BUFTANK+(m_nCurSelPump*2)+0);
	bPumpOutValveStatus[1] = pView->m_pEqpAssy->m_AutoValvePumpOut.GetState(NO_BUFTANK+(m_nCurSelPump*2)+1);

	if( m_pTank->GetPumpAlarm(m_nCurSelPump) || 
		!pView->m_pPumpSeq->m_SeqFlag.bDiTankLevel[2][CPumpSeq::lvL] || 
		(!bPumpOutValveStatus[0] && !bPumpOutValveStatus[1]))
	{
		m_pTank->SetPumpOn( m_nCurSelPump , OFF );
		m_macPumpOn.SetCheck( 0 );
		m_macPumpAlarm.SetCheck( 1 );
		m_macPumpNoAlarm.SetCheck( 0 );
	}
	else
	{
		m_macPumpAlarm.SetCheck( 0 );
		m_macPumpNoAlarm.SetCheck( 1 );
	}
	
	CDialog::OnTimer(nIDEvent);
}

//---------------------------------------------------------------------------
// Strip1 Pump
//---------------------------------------------------------------------------
void CDlgBufTankPumpCln::OnPumpOn() 
{
	// 100908 halesu
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	
	m_pTank->SetPumpOn( m_nCurSelPump, ON );
}
void CDlgBufTankPumpCln::OnPumpOff() 
{
	// Pump3 OFF
	m_pTank->SetPumpOn( m_nCurSelPump, OFF );
}