// DlgCalibration.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgCalibration.h"
#include "DlgSelSensor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgCalibration dialog


CDlgCalibration::CDlgCalibration(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCalibration::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCalibration)
	m_nAdcMax = 0;
	m_nAdcMin = 0;
	m_nCurAdc = 0;
	m_fCurReal = 0.0f;
	m_fRealMax = 0.0f;
	m_fRealMin = 0.0f;
	m_fFilterGain = 1.0f;
	//}}AFX_DATA_INIT

	m_bPermitAccess = TRUE;
}


void CDlgCalibration::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCalibration)
	DDX_Text(pDX, IDC_ADC_MAX, m_nAdcMax);
	DDX_Text(pDX, IDC_ADC_MIN, m_nAdcMin);
	DDX_Text(pDX, IDC_CUR_ADC, m_nCurAdc);
	DDX_Text(pDX, IDC_CUR_REAL, m_fCurReal);
	DDX_Text(pDX, IDC_REAL_MAX, m_fRealMax);
	DDX_Text(pDX, IDC_REAL_MIN, m_fRealMin);
	DDX_Control(pDX, IDC_CALIBRATION, m_macCalibration);	
	DDX_Control(pDX, IDC_DEFAULT, m_macDefault);
	DDX_Control(pDX, IDC_RADIO_SCALE1, m_macCommon);
	DDX_Control(pDX, IDC_RADIO_SCALE2, m_macLog);
	DDX_Control(pDX, IDC_RADIO_SCALE3, m_macLog10);
	DDX_Text(pDX, IDC_ADC_FILTER_GAIN, m_fFilterGain);
	DDX_Control(pDX, IDC_BTN_KEYBOARD, m_KeyIn);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCalibration, CDialog)
	//{{AFX_MSG_MAP(CDlgCalibration)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CALIBRATION, OnCalibrate)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	ON_BN_CLICKED(IDC_BTN_KEYBOARD, OnBtnKeyboard)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCalibration message handlers

BOOL CDlgCalibration::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Set title
	CString sTitle;

	m_KeyIn.LoadBitmaps(IDB_BITMAP_KBD_PULL, IDB_BITMAP_KBD_PUSH, IDB_BITMAP_KBD_PULL, IDB_BITMAP_KBD_PULL );

	if( m_nWhatGroup == grpAI1 )
	{
//		sTitle.Format( "Calibration AI : %s", m_pAI1->m_aiSet[m_nID].sName );
//		m_nAiNo = m_pAI1->m_aiSet[m_nID].nReal;
	}
//	else if( m_nWhatGroup == grpAI2 )
//	{
//		sTitle.Format( "Calibration AI : %s", m_pAI2->m_aiSet[m_nID].sName );
//		m_nAiNo = m_pAI2->m_aiSet[m_nID].nReal;
//	}
//	else if( m_nWhatGroup == grpAI3 )
//	{
//		sTitle.Format( "Calibration AI : %s", m_pAI3->m_aiSet[m_nID].sName );
//		m_nAiNo = m_pAI3->m_aiSet[m_nID].nReal;
//	}
	SetWindowText( sTitle );

	m_nInitAdcMax = m_nAdcMax = m_pDevice->m_aiInfo[m_nAiNo].nAdcMax;
	m_nInitAdcMin = m_nAdcMin = m_pDevice->m_aiInfo[m_nAiNo].nAdcMin;
	m_fInitRealMax = m_fRealMax = m_pDevice->m_aiInfo[m_nAiNo].fRealMax;
	m_fInitRealMin = m_fRealMin = m_pDevice->m_aiInfo[m_nAiNo].fRealMin;
	m_fInitFilterGain = m_fFilterGain = m_pDevice->m_pFilterGain[m_nAiNo];

	UpdateData( FALSE );

	// Set the timer
	SetTimer( TIMER_MANUAL, 500, NULL );

	// Set the MAC button
	MAC_COLOR_SET color_set;
	m_macCalibration.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macCalibration.SetColorSetting( color_set );
	m_macCalibration.SetBold();

	m_macDefault.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macDefault.SetColorSetting( color_set );
	m_macDefault.SetBold();

	// Set button
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );
	VERIFY( m_Cancel.AutoLoad( IDCANCEL, this ) );

	// Enable the control
	if( !m_bPermitAccess ) 
	{
		GetDlgItem( IDC_CALIBRATION )->EnableWindow( FALSE );
		GetDlgItem( IDC_DEFAULT )->EnableWindow( FALSE );
		GetDlgItem( IDOK )->EnableWindow( FALSE );

		GetDlgItem( IDC_ADC_MAX )->EnableWindow( FALSE );
		GetDlgItem( IDC_ADC_MIN )->EnableWindow( FALSE );
		GetDlgItem( IDC_REAL_MAX )->EnableWindow( FALSE );
		GetDlgItem( IDC_REAL_MIN )->EnableWindow( FALSE );
		GetDlgItem( IDC_RADIO_SCALE1 )->EnableWindow( FALSE );
		GetDlgItem( IDC_RADIO_SCALE2 )->EnableWindow( FALSE );
		GetDlgItem( IDC_RADIO_SCALE3 )->EnableWindow( FALSE );
		GetDlgItem( IDC_ADC_FILTER_GAIN )->EnableWindow( FALSE );
	}
	int nScale;
	m_pDevice->GetAiCalScale( m_nAiNo, nScale );
	if( nScale == XCtlDevice::scaleCOMMON )
	{
		m_macCommon.SetCheck( 1 );
		m_macLog.SetCheck( 0 );
		m_macLog10.SetCheck( 0 );
	}
	else if( nScale == XCtlDevice::scaleLOG )
	{
		m_macCommon.SetCheck( 0 );
		m_macLog.SetCheck( 1 );
		m_macLog10.SetCheck( 0 );
	}
	else if( nScale == XCtlDevice::scaleLOG10 )
	{
		m_macCommon.SetCheck( 0 );
		m_macLog.SetCheck( 0 );
		m_macLog10.SetCheck( 1 );
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgCalibration::OnDestroy() 
{
	CDialog::OnDestroy();
	
	KillTimer( TIMER_MANUAL );
}

//--------------------------------------------------------------------
// OnOK()
//--------------------------------------------------------------------
void CDlgCalibration::OnOK() 
{
	UpdateData( TRUE );
	
	CDialog::OnOK();
}

//--------------------------------------------------------------------
// OnCancel()
//--------------------------------------------------------------------
void CDlgCalibration::OnCancel() 
{
	m_nAdcMax = m_nInitAdcMax;
	m_nAdcMin = m_nInitAdcMin;
	m_fRealMax = m_fInitRealMax;
	m_fRealMin = m_fInitRealMin;
	m_fFilterGain = m_fInitFilterGain;
	
	m_pDevice->SetCalPara( m_nAiNo, m_fRealMax, m_fRealMin, m_nAdcMax, m_nAdcMin );
	m_pDevice->SetFilterGain( m_nAiNo, m_fFilterGain );

	CDialog::OnCancel();
}

//--------------------------------------------------------------------
// OnCalibrate()
//--------------------------------------------------------------------
void CDlgCalibration::OnCalibrate() 
{
	UpdateData( TRUE );
	m_macCalibration.SetCheck( 0 );

	m_pDevice->SetCalPara( m_nAiNo, m_fRealMax, m_fRealMin, m_nAdcMax, m_nAdcMin );
	m_pDevice->SetFilterGain( m_nAiNo, m_fFilterGain );

	if( m_macCommon.GetCheck() ) 	m_pDevice->SetAiCalScale( m_nAiNo, XCtlDevice::scaleCOMMON );
	else if( m_macLog.GetCheck() ) 	m_pDevice->SetAiCalScale( m_nAiNo, XCtlDevice::scaleLOG );
	else if( m_macLog10.GetCheck() ) 	m_pDevice->SetAiCalScale( m_nAiNo, XCtlDevice::scaleLOG10 );
}

//--------------------------------------------------------------------
// OnDefault()
//--------------------------------------------------------------------
void CDlgCalibration::OnDefault() 
{
	m_macDefault.SetCheck( 0 );

	CDlgSelSensor dlg;
	dlg.SetDevice( m_pDevice );
	dlg.DoModal();

	m_pDevice->GetCalPara( m_nAiNo, m_fRealMax, m_fRealMin, m_nAdcMax, m_nAdcMin, TRUE, dlg.m_nNo );

	UpdateData( FALSE );
}

//--------------------------------------------------------------------
// OnTimer()
//--------------------------------------------------------------------
void CDlgCalibration::OnTimer(UINT nIDEvent) 
{
//	m_nCurAdc = m_pDevice->AioRead( m_nAiNo );
	m_nCurAdc = m_pDevice->m_pOldAdc[m_nAiNo]; // Filtering   ;
	m_fCurReal = m_pDevice->GetCalAI( m_nAiNo );

	CString strCurReal;
	strCurReal.Format( "%.1f", m_fCurReal );
	SetDlgItemText( IDC_CUR_REAL, strCurReal );
	SetDlgItemInt( IDC_CUR_ADC, m_nCurAdc );

	CDialog::OnTimer(nIDEvent);
}


void CDlgCalibration::OnBtnKeyboard() 
{
	// TODO: Add your control notification handler code here
	WinExec( "osk.exe", SW_SHOW );
}
