// DlgEditVal.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgEditVal dialog

CDlgEditVal::CDlgEditVal(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgEditVal::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgEditVal)
	m_sCurVal = _T("");
	m_sOldVal = _T("");
	//}}AFX_DATA_INIT
	m_nType		= typeINPUT;
	m_nFormat	= formatDIGIT;
	m_sTitle	= "KEY IN VALUE";

	m_bSetLimit = FALSE;
	m_dHigh		= 0.0;
	m_dLow		= 0.0;
}

void CDlgEditVal::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgEditVal)
	DDX_Text(pDX, IDC_CUR_VAL, m_sCurVal);
	DDX_Text(pDX, IDC_OLD_VAL, m_sOldVal);
	DDX_Control(pDX, IDC_BTN_KEYBOARD, m_KeyIn);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgEditVal, CDialog)
	//{{AFX_MSG_MAP(CDlgEditVal)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_KEYBOARD, OnBtnKeyboard)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgEditVal message handlers

//----------------------------------------------------------
// OnInitDialog
//----------------------------------------------------------
BOOL CDlgEditVal::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetWindowText( m_sTitle );
	
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	VERIFY( m_Ok.AutoLoad( IDOK, this ) );
	VERIFY( m_Cancel.AutoLoad( IDCANCEL, this ) );

	m_KeyIn.LoadBitmaps(IDB_BITMAP_KBD_PULL, IDB_BITMAP_KBD_PUSH, IDB_BITMAP_KBD_PULL, IDB_BITMAP_KBD_PULL );
	
	GetDlgItem( IDC_STATIC_OLD_VAL )->ShowWindow( SW_SHOW );
	GetDlgItem( IDC_OLD_VAL )->ShowWindow( SW_SHOW );

	if( m_nType == typeINPUT )
	{
		GetDlgItem( IDC_STATIC_OLD_VAL )->SetWindowText( "OLD VALUE : " );
		GetDlgItem( IDC_STATIC_CUR_VAL )->SetWindowText( "CUR VALUE : " );
	}
	if( m_nType == typeAI )
	{
		GetDlgItem( IDC_STATIC_OLD_VAL )->SetWindowText( "CUR VALUE : " );
		GetDlgItem( IDC_STATIC_CUR_VAL )->SetWindowText( "SET VALUE : " );
	}	
	else if( m_nType == typeCOPY )
	{
		GetDlgItem( IDC_STATIC_OLD_VAL )->SetWindowText( "FROM : " );
		GetDlgItem( IDC_STATIC_CUR_VAL )->SetWindowText( "TO : " );
	}
	else if( m_nType == typeGLASSID )
	{
		GetDlgItem( IDC_STATIC_OLD_VAL )->ShowWindow( SW_HIDE );
		GetDlgItem( IDC_OLD_VAL )->ShowWindow( SW_HIDE );
		GetDlgItem( IDC_STATIC_CUR_VAL )->SetWindowText( "GLASS ID : " );
		GetDlgItem( IDC_CUR_VAL )->EnableWindow( FALSE );
	}

	if( m_bSetLimit )
	{
		CString sHighVal;
		CString sLowVal;
		if( m_nFormat == formatDIGIT )
		{
			sLowVal.Format( "%d", (int)m_dLow );
			sHighVal.Format( "%d", (int)m_dHigh );		
		}
		else
		{
			sLowVal.Format( "%.1f", m_dLow );
			sHighVal.Format( "%.1f", m_dHigh );
		}

		GetDlgItem( IDC_STATIC_LOW )->SetWindowText( sLowVal );
		GetDlgItem( IDC_STATIC_HIGH )->SetWindowText( sHighVal );
		GetDlgItem( IDC_STATIC_LOW )->ShowWindow( SW_SHOW );
		GetDlgItem( IDC_STATIC_HIGH )->ShowWindow( SW_SHOW );
		GetDlgItem( IDC_STATIC_DASH )->ShowWindow( SW_SHOW );
	}
	// Set the initial window position
	CRect r;
	GetWindowRect( &r );
	MoveWindow( 300, 400, r.right - r.left, r.bottom - r.top );
	
	SetTimer( TIMER_MANUAL, 500, NULL );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgEditVal::OnOK() 
{
	UpdateData( TRUE );

	int nLen = m_sCurVal.GetLength();
	for( int i=0; i<nLen; i++ )
	{
		char ch = m_sCurVal.GetAt( i );
		if( m_nFormat == formatSTRING );
		else if( m_nFormat == formatFLOAT )
		{
			if( ( ch != '.' ) && ( ch < '0' || ch > '9' )  )
			{
				AfxMessageBox( "You have to key in floating point value." );
				return;
			}
		}
		else if( m_nFormat == formatHEX  )
		{
			if ( (ch >= '0' && ch <= '9') ||
			 	 (ch >= 'A' && ch <= 'F') || 
				 (ch >= 'a' && ch <= 'f') );
			else
			{
				AfxMessageBox( "You have to key in Hex value." );
				return;
			}
		}
		else if( m_nFormat == formatBIN )
		{
			if( ch != '0' && ch != '1' )
			{
				AfxMessageBox( "You have to key in Binary value." );
				return;
			}
		}
		else 
		{
			if( ( ch != '-' ) && ( ch < '0' || ch > '9' ) )
			{
				AfxMessageBox( "You have to key in numeric value." );
				return;
			}
		}
	}

//#ifndef _MY_DEBUG
	if( m_bSetLimit )
	{
		float fCurVal = (float) ( atof( m_sCurVal ) );
		if( fCurVal < m_dLow || fCurVal > m_dHigh )
		{
			m_sCurVal = m_sOldVal;
			UpdateData( FALSE );
			AfxMessageBox( "Out of Range." );
		}
	}
//#endif

	KillTimer( TIMER_MANUAL );
	CDialog::OnOK();
}

void CDlgEditVal::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if( m_nType == typeAI )
	{
		float fVal;
		fVal = m_pEqpAssy->m_AnalogInput.GetRealVal( m_nReal ); //2008.11.07 kimgun // m_pDevice->GetCalAI( m_nReal );
		m_sOldVal.Format( "%3.1f", fVal );
		( (CWnd*)GetDlgItem( IDC_OLD_VAL ) )->SetWindowText( (LPCTSTR)m_sOldVal );
	}
	CDialog::OnTimer(nIDEvent);
}

void CDlgEditVal::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	
}

void CDlgEditVal::OnBtnKeyboard() 
{
	// TODO: Add your control notification handler code here
	WinExec( "osk.exe", SW_SHOW );
}
