// DlgGlassInfo.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgGlassInfo.h"
#include "DlgTargetCv.h"
#include "DlgPassword.h"
#include "DlgEditVal.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgGlassInfo dialog
CString CDlgGlassInfo::m_sGlassDataName[] = 
{
/*	"PORT NO",
	"RECIPE ID",
	"WAFER ID",
	"LOT ID",
	"CASSETTE ID",
	"CASSETTE SLOT NO",
	"GLASS ID",
	"CASSETTE PORT NO"
*/
	"CST PORT NO",
	"CST SLOT NO",
	"GLASS ID",
	"RECIPE ID-Num",
	"RECIPE ID-Text",
	"PROCESS FLAG",
};

int CDlgGlassInfo::m_nGlassDataFormat[] =
{
	CDlgEditVal::formatSTRING,
	CDlgEditVal::formatSTRING,
	CDlgEditVal::formatSTRING,
	CDlgEditVal::formatSTRING,
	CDlgEditVal::formatSTRING,
};

CDlgGlassInfo::CDlgGlassInfo(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgGlassInfo::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgGlassInfo)
	m_sGlassId		= _T("");
	m_sOperatorId	= _T("");
	//}}AFX_DATA_INIT

	m_bPermitAccess = FALSE;
}

void CDlgGlassInfo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgGlassInfo)
	DDX_Control(pDX, IDC_DELETE, m_macDelete);
	DDX_Control(pDX, IDC_FORCE_DEL, m_macForceDel);	
	DDX_Control(pDX, IDC_MOVE, m_macMove);
	DDX_Control(pDX, IDC_EDIT, m_macEdit);	
	DDX_Control(pDX, IDC_GLASS_ID_INQUIRE, m_macGlassIdInquire);
	DDX_Control(pDX, IDC_GLASS_OPID_REPORT, m_macGlassOpIdReport);
	DDX_Text(pDX, IDC_GLASS_ID_QUERY2, m_sGlassId);
	DDX_Text(pDX, IDC_OPERATOR_ID, m_sOperatorId);
	DDX_Control(pDX, IDC_GRID_GLASS_INFO, m_gridGlassInfo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgGlassInfo, CDialog)
	//{{AFX_MSG_MAP(CDlgGlassInfo)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_GLASS_ID_INQUIRE, OnGlassIdInquire)
	ON_BN_CLICKED(IDC_GLASS_OPID_REPORT, OnGlassOpIdReport)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_BN_CLICKED(IDC_FORCE_DEL, OnForceDel)
	ON_BN_CLICKED(IDC_MOVE, OnMove)
	ON_BN_CLICKED(IDC_EDIT, OnEdit)
	ON_WM_DESTROY()
	ON_EN_CHANGE(IDC_OPERATOR_ID, OnChangeOperatorId)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgGlassInfo message handlers

BOOL CDlgGlassInfo::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	SetWindowText( m_sTitle );
	m_OldGlsInfo = m_GlsInfo;

	MAC_COLOR_SET color_set;

	m_macDelete.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macDelete.SetColorSetting( color_set );
	m_macDelete.SetBold();
	
	m_macForceDel.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macForceDel.SetColorSetting( color_set );
	m_macForceDel.SetBold();
	
	m_macMove.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macMove.SetColorSetting( color_set );
	m_macMove.SetBold();

	m_macEdit.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macEdit.SetColorSetting( color_set );
	m_macEdit.SetBold();
	
	m_macGlassIdInquire.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macGlassIdInquire.SetColorSetting( color_set );
	m_macGlassIdInquire.SetBold();

	m_macGlassOpIdReport.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macGlassOpIdReport.SetColorSetting( color_set );
	m_macGlassOpIdReport.SetBold();
	
	if( m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP &&
		( m_pDicsData->m_GenInfo.bPause || !m_pDicsData->m_GenInfo.bAuto ) )
	{
		GetDlgItem( IDC_DELETE )->EnableWindow( TRUE );
		GetDlgItem( IDC_FORCE_DEL )->EnableWindow( TRUE );
		GetDlgItem( IDC_MOVE )->EnableWindow( TRUE );
	}
	else 
	{
		GetDlgItem( IDC_DELETE )->EnableWindow( FALSE );
		GetDlgItem( IDC_FORCE_DEL )->EnableWindow( FALSE );
		GetDlgItem( IDC_MOVE )->EnableWindow( FALSE );
	}

	if( !m_pDicsData->m_GenInfo.bPause && m_pDicsData->m_GenInfo.bAuto )
	{
		GetDlgItem( IDC_EDIT )->EnableWindow( FALSE );
	}

	UpdateGlassData();
	GridInit_GlassInfo();

	CRect r;
	GetWindowRect( &r );
	MoveWindow( 170, 170, r.right - r.left, r.bottom - r.top );

	GetDlgItem( IDC_STATIC_GLASS		)->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_GLASS_ID_QUERY1		)->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATIC_GLASSNO		)->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_GLASS_OPID_REPORT	)->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_GLASS_ID_INQUIRE	)->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATIC_GLASSID		)->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATIC_GLASSKEY		)->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATIC_GLASS_INFO1	)->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATIC_GLASS_INFO2	)->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_GLASS_ID_QUERY2		)->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_GLASS_ID_QUERY3		)->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_GLASS_ID_QUERY4		)->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_GLASS_ID_QUERY5		)->ShowWindow( SW_HIDE );

	SetTimer( TIMER_MANUAL, 500, NULL );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgGlassInfo::OnTimer(UINT nIDEvent) 
{
	if( m_pDicsData->m_IfCim.bGlassDataReqReply )
	{
		m_pDicsData->m_IfCim.bGlassDataReqReply = FALSE;
		m_sGlassId.Format("%s", m_pDicsData->m_GlsInfoReq.sGlassId);
		UpdateData(FALSE);
	}

	CDialog::OnTimer(nIDEvent);
}

void CDlgGlassInfo::OnGlassIdInquire() 
{
	if( AfxMessageBox( "Would you like to inquire the glass ID?", MB_YESNO ) != IDYES ) return;
	
	m_pDicsData->m_IfCim.bGlassDataReq = TRUE;
	m_pDicsData->m_GlsInfoReq = m_GlsInfo;
}

void CDlgGlassInfo::OnGlassOpIdReport() 
{
	if( AfxMessageBox( "Would you like to Report the Operator ID?", MB_YESNO ) != IDYES ) return;
	
	m_pDicsData->m_IfCim.bOperatorIdReport  = TRUE;
}

void CDlgGlassInfo::OnMove() 
{
	CDlgTargetCv dlg;

	if( dlg.DoModal() == IDOK ) 
	{
		m_nTargetCv = dlg.m_nTargetCv;

		EndDialog( IDC_MOVE );
	}
}

void CDlgGlassInfo::OnDelete() 
{
	if( AfxMessageBox( "Would you like to erase the glass data?", MB_YESNO ) != IDYES ) return;

	UpdateData( TRUE );

	EndDialog( IDC_DELETE );
}

void CDlgGlassInfo::OnForceDel() 
{
	if( AfxMessageBox( "Would you like to erase the glass data?", MB_YESNO ) != IDYES ) return;

	UpdateData( TRUE );

	EndDialog( IDC_FORCE_DEL );
}

void CDlgGlassInfo::OnEdit() 
{
//	CDlgPassword dlg;
//	dlg.SetDicsData( m_pDicsData );
//
//	if( dlg.DoModal() != IDOK ) return;

	if( AfxMessageBox( "Would you like to modify the glass data?", MB_YESNO ) != IDYES ) return;

	UpdateData( TRUE );

	EndDialog( IDC_EDIT );
}

void CDlgGlassInfo::OnEditData(int nRow, CString sTemp)
{
	GetDlgItem( IDOK )->SetFocus();

	int nTemp=0;
	CDlgEditVal	dlg;
	dlg.m_sOldVal = sTemp;
	dlg.m_sCurVal = dlg.m_sOldVal;
	dlg.m_nType   = CDlgEditVal::typeINPUT;
	dlg.m_nFormat = m_nGlassDataFormat[nRow];

	if( dlg.DoModal() == IDOK )
	{
		m_sGlassData[nRow] = dlg.m_sCurVal;
	}
}

void CDlgGlassInfo::OnDestroy() 
{
	CDialog::OnDestroy();
	
	KillTimer( TIMER_MANUAL );
}

void CDlgGlassInfo::GridInit_GlassInfo()
{
	LPTSTR sLvcText[] = { " Item ", " Contents " };
	int nColWidth[] = { 3300, 2100 }; 

	// initialize GridCtrl
	m_gridGlassInfo.SetRows( MAX_GLASS_DATA_ITEM_NO + 1 ); 
	m_gridGlassInfo.SetCols( 2 );

	//-------------------------------------------
	m_gridGlassInfo.SetRow( 0 );  
	m_gridGlassInfo.SetColWidth( 0, nColWidth[0] );
	m_gridGlassInfo.SetCol( 0 ); 
	m_gridGlassInfo.SetCellAlignment( 4 );
	m_gridGlassInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridGlassInfo.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridGlassInfo.SetColWidth( 1, nColWidth[1] );
	m_gridGlassInfo.SetCol( 1 ); 
	m_gridGlassInfo.SetCellAlignment( 4 );
	m_gridGlassInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridGlassInfo.SetText( sLvcText[1] ); 

	SetDataToGridCtrl_GlassInfo();
}

void CDlgGlassInfo::SetDataToGridCtrl_GlassInfo()
{
	CString sBuf;

	for( int i=0; i<MAX_GLASS_DATA_ITEM_NO; i++ )
	{
		// 1st column
		m_gridGlassInfo.SetCol( 0 );
		m_gridGlassInfo.SetRow( i + 1 );
		m_gridGlassInfo.SetCellAlignment( 0 );	// Left adjusted
		m_gridGlassInfo.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%s", m_sGlassDataName[i] );
		m_gridGlassInfo.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridGlassInfo.SetCol( 1 );
		m_gridGlassInfo.SetRow( i + 1 );
		
		m_gridGlassInfo.SetCellBackColor( LIGHT_YELLOW_COLOR );
		m_gridGlassInfo.SetCellForeColor( BLACK_COLOR );
		sBuf.Format( "%s", m_sGlassData[i] );
		m_gridGlassInfo.SetText( (LPCTSTR) sBuf );
		m_gridGlassInfo.SetCellAlignment( 4 );
	}

	GetDlgItem( IDC_GLASS_ID_QUERY1 )->SetWindowText( m_sGlassData[0] );
	UpdateData(FALSE);
}

void CDlgGlassInfo::UpdateGlassData()
{
//	m_sGlassData[0].Format("%04X", m_GlsInfo.nGlassData[0] );
//	m_sGlassData[1].Format("%04X", m_GlsInfo.nGlassData[1] );
//	m_sGlassData[2].Format("%04X", m_GlsInfo.nGlassData[2] );
//	m_sGlassData[3].Format("%s", m_GlsInfo.sSptRecipeId );
//	m_sGlassData[4].Format("%d", (m_GlsInfo.nGlassData[14]&0x0003) );
//	
//	m_sGlassData[5].Format("%s", Dec2Bin( 4, m_GlsInfo.nCstSeqNo ) );
//	m_sGlassData[6].Format("%s", Dec2Bin( 4, m_GlsInfo.nPortNo ) );
	UpdateData( TRUE );
}


BEGIN_EVENTSINK_MAP(CDlgGlassInfo, CDialog)
    //{{AFX_EVENTSINK_MAP(CDlgGlassInfo)
	ON_EVENT(CDlgGlassInfo, IDC_GRID_GLASS_INFO, -601 /* DblClick */, OnDblClickGridGlassInfo, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CDlgGlassInfo::OnDblClickGridGlassInfo() 
{
	// TODO: Add your control notification handler code here
	int nRow = m_gridGlassInfo.GetRow();
	int nCol = m_gridGlassInfo.GetCol();

	if ( nRow == 0 || nCol == 0 ) return;

	CString sBuf;

	if ( nCol == 1 )
	{
		CDlgEditVal dlg;
		dlg.m_sOldVal.Format( "%s", m_gridGlassInfo.GetText() );
		dlg.m_sCurVal = dlg.m_sOldVal;
		dlg.m_nType = CDlgEditVal::typeINPUT;
		dlg.m_nFormat = CDlgEditVal::formatSTRING ;
		if( dlg.DoModal() == IDOK )
		{
			sBuf = dlg.m_sCurVal;
			m_sGlassData[nRow-1] = sBuf;

			// Set the changed value to temperary variable
			m_gridGlassInfo.SetText( (LPCTSTR) sBuf );
		}
	}
}

int CDlgGlassInfo::Bin2Dec(int nBitSize, CString sVal)
{
	int nBuf=0;
	int nSize = sVal.GetLength();
	for( int i=0; i<nBitSize; i++ )
	{
		if( i<nSize )	nBuf |= ( sVal.GetAt(i) - '0' )<<(nSize-i-1);
	}
	return nBuf;
}

CString CDlgGlassInfo::Dec2Bin(int nBitSize, int nVal)
{
	CString sBuf;
	sBuf.GetBufferSetLength(nBitSize);

	for( int i=0; i<nBitSize; i++ )
	{
		if( nVal & (0x0001<<(nBitSize-i-1)) ) sBuf.SetAt(i,'1');
		else  sBuf.SetAt(i,'0');
	}
	return sBuf;
}

int CDlgGlassInfo::Hex2Dec( CString sValue )
{
	CString sRv, sTemp;
	int nRv = 0,i = 0;
	sRv = "";

	int nlength = sValue.GetLength();
	
	for ( i = 0; i < nlength; i++ )
	{
		sTemp = sValue.GetAt( i );
		int n = atoi( sTemp );

		if ( sTemp >= 'A' && sTemp <= 'F' )
		{
			if ( sTemp == 'A' )	n = 10;
			if ( sTemp == 'B' )	n = 11;
			if ( sTemp == 'C' )	n = 12;
			if ( sTemp == 'D' )	n = 13;
			if ( sTemp == 'E' )	n = 14;
			if ( sTemp == 'F' )	n = 15;
		}

		nRv += (int)( n * pow( (float)16, nlength - i - 1 ) );
	}

	return nRv;
}

unsigned short CDlgGlassInfo::Ascii2Word( CString sVal )
{
	unsigned short nVal=0;
	char ch1, ch2;

	if( sVal.GetLength() <= 0 ) ch1 = 0x20;
	else ch1 = sVal.GetAt( 0 );

	if( sVal.GetLength() <= 1 ) ch2 = 0x20;
	else ch2 = sVal.GetAt( 1 );
	
	if( ch1 == ' ' ) ch1 = 0x20;
	if( ch2 == ' ' ) ch2 = 0x20;
	if( ch1 == '\r' ) ch1 = 0x00;
	if( ch2 == '\r' ) ch2 = 0x00;

	nVal = ch1 | ( ch2 << 8 );

	return nVal;
}

void CDlgGlassInfo::OnChangeOperatorId() 
{
	CString sTemp;
	GetDlgItemText( IDC_OPERATOR_ID, sTemp );

	m_pDicsData->m_IfCim.sOperatorId = sTemp;
//	m_sGlassData[7] = sTemp;
	m_gridGlassInfo.SetRow( 7+1 );
	m_gridGlassInfo.SetText( (LPCTSTR) sTemp );
	UpdateData( TRUE );
}
