// DlgGridCvMotor.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgGridCvMotor.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgGridCvMotor dialog


CDlgGridCvMotor::CDlgGridCvMotor(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgGridCvMotor::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgGridCvMotor)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_bExtendWndPos = FALSE;
	m_nCurSel		= 13;
}


void CDlgGridCvMotor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgGridCvMotor)
	DDX_Control(pDX, IDC_COMBO_CV_SPEED, m_cbCvSpeed);
	DDX_Control(pDX, IDC_GRID_CV_MOTOR,  m_gridCvMotor);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_MOTOR_ALL_BW, m_macMotorAllBw);
	DDX_Control(pDX, IDC_MOTOR_ALL_FW, m_macMotorAllFw);
	DDX_Control(pDX, IDC_MOTOR_ALL_STOP, m_macMotorAllStop);
	DDX_Control(pDX, IDC_SET_WND_POS, m_macSetWndPos);
}

BEGIN_MESSAGE_MAP(CDlgGridCvMotor, CDialog)
	//{{AFX_MSG_MAP(CDlgGridCvMotor)
	ON_BN_CLICKED(IDC_SET_WND_POS, OnSetWndPos)
	ON_CBN_SELCHANGE(IDC_COMBO_CV_SPEED, OnSelchangeComboCvSpeed)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_MOTOR_ALL_STOP, OnCvMotorAllStop)
	ON_BN_CLICKED(IDC_MOTOR_ALL_FW, OnCvMotorAllFw)
	ON_BN_CLICKED(IDC_MOTOR_ALL_BW, OnCvMotorAllBw)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_EVENTSINK_MAP(CDlgGridCvMotor, CDialog)
    //{{AFX_EVENTSINK_MAP(CRecipesTab1View)
	ON_EVENT(CDlgGridCvMotor, IDC_GRID_CV_MOTOR, -600 /* Double Click */, OnClickGridCvMotor, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgGridCvMotor message handlers

//--------------------------------------------------------------------
// OnInitDialog
//--------------------------------------------------------------------
BOOL CDlgGridCvMotor::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Set button
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	// Set the timer
	SetTimer( TIMER_MANUAL, 100, NULL );

	// Combo Box Inialize
	int nItemEA, nCurAns;
	nCurAns = nItemEA = 0;
	CString sSpeed;
	nItemEA = ( int )( ( m_nTopSpeed - m_nBottomSpeed ) / m_nIntervalSpeed );
	for( int i = 0 ; i < nItemEA + 1 ; i ++ )
	{
		nCurAns = m_nBottomSpeed + (int)( m_nIntervalSpeed * i );
		sSpeed.Format( "%d", nCurAns );
		m_cbCvSpeed.AddString( (LPCTSTR)sSpeed );
	}

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	
	for( int i = 0; i < m_nMotorEA; i ++ )
	{
		m_nOldDirStatus[i]		= -1;
		m_nOldAlarmStatus[i]	= -1;
		m_nOldCpStatus[i]		= -1;
		m_nOldCvSpeed[i]		= -1;

		m_pCvSeq->m_CvMotor.nSpeedManual[i] = pView->m_pDicsData->m_JobCond.nCvSpeed;	
	}


	SetDlgItemText( IDC_MOTOR_ALL_FW,  "All FW (>>)");
	SetDlgItemText( IDC_MOTOR_ALL_BW,  "All BW (<<)");
	
	// Set the MAC button
	MAC_COLOR_SET color_set;

	// C/V Motor FW (All)
	m_macMotorAllFw.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macMotorAllFw.SetColorSetting( color_set );
	m_macMotorAllFw.SetBold();

	// C/V Motor BW (All)
	m_macMotorAllBw.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macMotorAllBw.SetColorSetting( color_set );
	m_macMotorAllBw.SetBold();
	
	// C/V Motor Stop (All)
	m_macMotorAllStop.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_RED_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macMotorAllStop.SetColorSetting( color_set );
	m_macMotorAllStop.SetBold();

	GridInit_CvMotor();

	// Set the initial window position
	CRect r;
	GetWindowRect( &r );
	MoveWindow( 50, 400, r.right - r.left - 630, r.bottom - r.top );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//--------------------------------------------------------------------
// OnSetWndPos
//--------------------------------------------------------------------
void CDlgGridCvMotor::OnSetWndPos() 
{
	CRect r;
	GetWindowRect( &r );
	if( m_bExtendWndPos )
	{
		r.right -= 630;
		MoveWindow( &r, TRUE );
		m_bExtendWndPos = FALSE;
		GetDlgItem( IDC_SET_WND_POS )->SetWindowText( ">>" );
	}
	else
	{
		r.right += 630;
		MoveWindow( &r, TRUE );
		m_bExtendWndPos = TRUE;
		GetDlgItem( IDC_SET_WND_POS )->SetWindowText( "<<" );
	}
}

//--------------------------------------------------------------------
// OnCvMotorAllFw
//--------------------------------------------------------------------
void CDlgGridCvMotor::OnCvMotorAllFw() 
{
#ifndef _MY_DEBUG
	if( !m_pEqpAssy->m_CylinderLdAlign.GetFw() )
#else
	if( !m_pEqpAssy->m_CylinderLdAlign.GetFwState() )
#endif
	{
		AfxMessageBox( "INTERLOCK : LD Unit Aligner BW State!! Please. LD Unit Aliner FW!!");
		return;		
	}

	if(RobotInterlock(0) || RobotInterlock(MAX_CV_MOTOR_NO-1))	return;


#ifndef _MY_INTERLOCK_UL_CYLINER
#ifndef _MY_DEBUG
	if( !m_pEqpAssy->m_CylinderUlAlignUD.GetBw() )
#else
	if( !m_pEqpAssy->m_CylinderUlAlignUD.GetBwState() )
#endif
	{
		AfxMessageBox( "INTERLOCK : UL Unit Aligner FW State!! Please. UL Unit Aliner BW!!");
		return;		
	}

#ifndef _MY_DEBUG
	if( !m_pEqpAssy->m_CylinderUlPinUD.GetBw() )
#else
	if( !m_pEqpAssy->m_CylinderUlPinUD.GetBwState() )
#endif
	{
		AfxMessageBox( "INTERLOCK : UL Unit Pin UP State!! Please. UL Unit Pin Down!!");
		return;		
	}
#endif
	if ( m_pCvSeq->m_bAkManualAlarm )
	{
		AfxMessageBox( "INTERLOCK : A/K CDA Flow or Press Alarm!! Please. Check A/K CDA Flow or Press");
		return;	
	}

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	for( int i=0; i<MAX_CV_MOTOR_NO; i++ )
	{
		CvMotorCommnad( i, CCvSeq::cvFW );
	}
}

//--------------------------------------------------------------------
// OnCvMotorAllBw
//--------------------------------------------------------------------
void CDlgGridCvMotor::OnCvMotorAllBw()
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

#ifndef _MY_INTERLOCK_UL_CYLINER
#ifndef _MY_DEBUG
	if( !m_pEqpAssy->m_CylinderUlAlignUD.GetBw() )
#else
	if( !m_pEqpAssy->m_CylinderUlAlignUD.GetBwState() )
#endif
	{
		AfxMessageBox( "INTERLOCK : UL Unit Aligner FW State!! Please. UL Unit Aliner BW!!");
		return;		
	}

#ifndef _MY_DEBUG
	if( !m_pEqpAssy->m_CylinderLdAlign.GetFw() )
#else
	if( !m_pEqpAssy->m_CylinderLdAlign.GetFwState() )
#endif
	{
		AfxMessageBox( "INTERLOCK : LD Unit Aligner BW State!! Please. LD Unit Aliner FW!!");
		return;
	}
	
	if(RobotInterlock(0) || RobotInterlock(MAX_CV_MOTOR_NO-1))	return;

#ifndef _MY_DEBUG
	if( !m_pEqpAssy->m_CylinderUlPinUD.GetBw() )
#else
	if( !m_pEqpAssy->m_CylinderUlPinUD.GetBwState() )
#endif
	{
		AfxMessageBox( "INTERLOCK : UL Unit Pin UP State!! Please. UL Unit Pin Down!!");
		return;		
	}
#endif
	if ( m_pCvSeq->m_bAkManualAlarm )
	{
		AfxMessageBox( "INTERLOCK : A/K CDA Flow or Press Alarm!! Please. Check A/K CDA Flow or Press");
		return;	
	}
	
	for( int i=0; i<m_nMotorEA; i++ )
	{
		CvMotorCommnad( i, CCvSeq::cvBW );
	}
}

//--------------------------------------------------------------------
// OnCvMotorAllStop
//--------------------------------------------------------------------
void CDlgGridCvMotor::OnCvMotorAllStop() 
{
	for( int i=0; i<m_nMotorEA; i++ )
	{
		CvMotorCommnad( i, CCvSeq::cvSTOP );
	}
}

//--------------------------------------------------------------------
// OnSelchangeComboCvSpeed
//--------------------------------------------------------------------
void CDlgGridCvMotor::OnSelchangeComboCvSpeed() 
{
	CString sSpeed;
	m_cbCvSpeed.GetLBText( m_cbCvSpeed.GetCurSel(), sSpeed );
	int nSpeed = atoi( sSpeed );

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	for( int i = 0 ; i < m_nMotorEA ; i ++ )
	{
		pView->m_pCvSeq->m_CvMotor.nSpeedManual[i] = nSpeed; 
	}
}

//--------------------------------------------------------------------
// OnTimer
//--------------------------------------------------------------------
void CDlgGridCvMotor::OnTimer(UINT nIDEvent) 
{
	BOOL bAL, bCPdown;
	bAL = bCPdown = 0;
	int bCvStop = TRUE;

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	for( int i = 0; i < m_nMotorEA; i ++ )
	{
#ifndef _MY_DEBUG
		bAL = m_pEqpAssy->m_CvMotorAll.GetMotorAlarm( i );
		bCPdown = m_pEqpAssy->m_CvMotorAll.GetMotorCpAlarm( i );
#endif
		int nCvManual = CCvSeq::cvSTOP;
		nCvManual = m_pCvSeq->m_CvMotor.nCvManual[i];

		if( ( m_nOldDirStatus[i] != nCvManual ) && !bAL && !bCPdown )
		{
			m_nOldDirStatus[i] = nCvManual;
			
			if( nCvManual == CCvSeq::cvSTOP )
			{
				m_gridCvMotor.SetRow( i+1 );
				m_gridCvMotor.SetCol( colFW );		m_gridCvMotor.SetCellBackColor( BG_COLOR_INT );
				m_gridCvMotor.SetCol( colBW );		m_gridCvMotor.SetCellBackColor( BG_COLOR_INT );
				m_gridCvMotor.SetCol( colSTOP );	m_gridCvMotor.SetCellBackColor( LIGHT_RED_COLOR );
			}
			else if( nCvManual == CCvSeq::cvFW )
			{
				m_gridCvMotor.SetRow( i+1 );
				m_gridCvMotor.SetCol( colBW );		m_gridCvMotor.SetCellBackColor( BG_COLOR_INT );
				m_gridCvMotor.SetCol( colSTOP );	m_gridCvMotor.SetCellBackColor( BG_COLOR_INT );
				m_gridCvMotor.SetCol( colFW );		m_gridCvMotor.SetCellBackColor( LIGHT_CYAN_COLOR );
				
				m_macMotorAllBw.EnableWindow( FALSE );
			}
			else if( nCvManual == CCvSeq::cvBW )
			{
				m_gridCvMotor.SetRow( i+1 );
				m_gridCvMotor.SetCol( colFW );		m_gridCvMotor.SetCellBackColor( BG_COLOR_INT );
				m_gridCvMotor.SetCol( colSTOP );	m_gridCvMotor.SetCellBackColor( BG_COLOR_INT );
				m_gridCvMotor.SetCol( colBW );		m_gridCvMotor.SetCellBackColor( LIGHT_ORANGE_COLOR );

				m_macMotorAllFw.EnableWindow( FALSE );
			}
		}

		if( m_nOldAlarmStatus[i] != 1 && bAL ) 
		{
			m_nOldAlarmStatus[i] = 1;
			m_gridCvMotor.SetRow( i+1 );
			m_gridCvMotor.SetCol( colALARM );		m_gridCvMotor.SetCellBackColor( RED_COLOR );
		}
		else if( m_nOldAlarmStatus[i] != 2 && !bAL )
		{
			m_nOldAlarmStatus[i] = 2;
			m_gridCvMotor.SetRow( i+1 );
			m_gridCvMotor.SetCol( colALARM );		m_gridCvMotor.SetCellBackColor( LIGHT_GREEN_COLOR );
		}

		if( m_nOldCpStatus[i] != 1 && bCPdown ) 
		{
			m_nOldCpStatus[i] = 1;
			m_gridCvMotor.SetRow( i+1 );
			m_gridCvMotor.SetCol( colCPDOWN );		m_gridCvMotor.SetCellBackColor( RED_COLOR );
		}
		else if( m_nOldCpStatus[i] != 2 && !bCPdown ) 
		{
			m_nOldCpStatus[i] = 2;
			m_gridCvMotor.SetCol( colCPDOWN );		m_gridCvMotor.SetCellBackColor( LIGHT_GREEN_COLOR );
		}
		
		int nSpeed = 0;
		nSpeed = m_pCvSeq->m_CvMotor.nSpeedManual[i];

		if( m_nOldCvSpeed[i] != nSpeed )
		{
			m_nOldCvSpeed[i] = nSpeed;
			CString sTmp;
			sTmp.Format( "%d", nSpeed );
			m_gridCvMotor.SetCol( colSPEED );	
			m_gridCvMotor.SetRow( i+1 );	
			m_gridCvMotor.SetText( sTmp );
			m_gridCvMotor.SetCellAlignment( 3 );
		}

		bCvStop &= ( m_pCvSeq->m_CvMotor.nCvManual[i] == CCvSeq::cvSTOP ) ? TRUE : FALSE;
	}

	if( bCvStop )
	{
		m_macMotorAllFw.EnableWindow( TRUE );		
		m_macMotorAllBw.EnableWindow( TRUE );		
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CDlgGridCvMotor::OnDestroy() 
{
	CDialog::OnDestroy();
	
	KillTimer( TIMER_MANUAL );
}

void CDlgGridCvMotor::CvMotorCommnad( int nCvMotorNo, int nCmd )
{
	m_pCvSeq->m_CvMotor.nCvManual[nCvMotorNo] = nCmd;	
}


void CDlgGridCvMotor::SetSpeedRange(int nBottom, int nTop, int nInterval)
{
	m_nBottomSpeed = nBottom;
	m_nTopSpeed = nTop;
	m_nIntervalSpeed = nInterval;
}


void CDlgGridCvMotor::GridInit_CvMotor()
{
	LPTSTR sLvcText[] = { "Name", "STOP", "FW", "BW", "Speed", "Alarm", "C/P Off" };
	int nColWidth[] = { 2000, 1100, 1100, 1100, 1100, 1100, 1100, }; 
	if( colMAX > 15 )  
	{
		nColWidth[0] = 1300;
	}

	// initialize GridCtrl
	m_gridCvMotor.SetRows( m_nMotorEA+1 ); 
	m_gridCvMotor.SetCols( colMAX );

	//-------------------------------------------
	m_gridCvMotor.SetRow( 0 );  
	for( int i=0; i<colMAX; i++ )
	{
		m_gridCvMotor.SetColWidth( i, nColWidth[i] );
		m_gridCvMotor.SetCol( i ); 
		m_gridCvMotor.SetCellAlignment( 4 );
		m_gridCvMotor.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridCvMotor.SetText( sLvcText[i] ); 
	}

	for( int i = 0 ; i < m_nMotorEA ; i ++ )
	{
		CString sName;
		sName = m_sMotorName.Left( m_sMotorName.Find( ";", 0 ) );
		m_sMotorName.TrimLeft( sName );
		m_sMotorName.TrimLeft( ";" );
	
		m_gridCvMotor.SetCol( 0 );
		m_gridCvMotor.SetRow( i + 1 );
		m_gridCvMotor.SetCellAlignment( 4 );
		m_gridCvMotor.SetCellBackColor( LIGHT_GRAY );
		m_gridCvMotor.SetText( sName );
	}
}


void CDlgGridCvMotor::OnClickGridCvMotor()
{
	int nCol = m_gridCvMotor.GetCol();
	int nRow = m_gridCvMotor.GetRow();
	int nMotorNo = nRow -1;
	
	if( nCol == colSTOP )
	{
		CvMotorCommnad( nMotorNo, CCvSeq::cvSTOP );	
	}
	else if( nCol == colFW )
	{
		CDicsApp* pApp = (CDicsApp*) AfxGetApp();
		CDicsView* pView = (CDicsView*) pApp->m_pMainView;

		if(nMotorNo == 0)
		{
#ifndef _MY_DEBUG
			if( !m_pEqpAssy->m_CylinderLdAlign.GetFw() )
#else
			if( !m_pEqpAssy->m_CylinderLdAlign.GetFwState() )
#endif
			{
				AfxMessageBox( "INTERLOCK : LD Unit Aligner BW State!! Please. LD Unit Aliner FW!!");
				return;
			}
			if(RobotInterlock(nMotorNo))	return;
		}
#ifndef _MY_INTERLOCK_UL_CYLINER
		if(nMotorNo == MAX_CV_MOTOR_NO-1)
		{
#ifndef _MY_DEBUG
			if( !m_pEqpAssy->m_CylinderUlAlignUD.GetBw() )
#else
			if( !m_pEqpAssy->m_CylinderUlAlignUD.GetBwState() )
#endif
			{
				AfxMessageBox( "INTERLOCK : UL Unit Aligner FW State!! Please. UL Unit Aliner FW!!");
				return;	
			}

#ifndef _MY_DEBUG
			if( !m_pEqpAssy->m_CylinderUlPinUD.GetBw() )
#else
			if( !m_pEqpAssy->m_CylinderUlPinUD.GetBwState() )
#endif
			{
				AfxMessageBox( "INTERLOCK : UL Unit Pin UP State!! Please. UL Unit Pin Down!!");
				return;		
			}
			if(RobotInterlock(nMotorNo))	return;
		}
#endif
		if ( m_pCvSeq->m_bAkManualAlarm )
		{
			AfxMessageBox( "INTERLOCK : A/K CDA Flow or Press Alarm!! Please. Check A/K CDA Flow or Press");
			return;	
		}

		if( m_pCvSeq->m_CvMotor.nCvManual[nMotorNo] != CCvSeq::cvSTOP ) return;
		
		CvMotorCommnad( nMotorNo, CCvSeq::cvFW );	
	}
	else if( nCol == colBW )
	{
		if(nMotorNo == 0)
		{
			if(RobotInterlock(nMotorNo))	return;

#ifndef _MY_DEBUG
			if( !m_pEqpAssy->m_CylinderLdAlign.GetFw() )
#else
			if( !m_pEqpAssy->m_CylinderLdAlign.GetFwState() )
#endif
			{
				AfxMessageBox( "INTERLOCK : LD Unit Aligner BW State!! Please. LD Unit Aliner FW!!");
				return;
			}
		}
#ifndef _MY_INTERLOCK_UL_CYLINER
		if(nMotorNo == MAX_CV_MOTOR_NO-1)
		{
#ifndef _MY_DEBUG
			if( !m_pEqpAssy->m_CylinderUlAlignUD.GetBw() )
#else
			if( !m_pEqpAssy->m_CylinderUlAlignUD.GetBwState() )
#endif
			{
				AfxMessageBox( "INTERLOCK : UL Unit Aligner FW State!! Please. UL Unit Aliner FW!!");
				return;	
			}

			if(RobotInterlock(nMotorNo))	return;

#ifndef _MY_DEBUG
			if( !m_pEqpAssy->m_CylinderUlPinUD.GetBw() )
#else
			if( !m_pEqpAssy->m_CylinderUlPinUD.GetBwState() )
#endif
			{
				AfxMessageBox( "INTERLOCK : UL Unit Pin UP State!! Please. UL Unit Pin Down!!");
				return;		
			}
		}
#endif
		if ( m_pCvSeq->m_bAkManualAlarm )
		{
			AfxMessageBox( "INTERLOCK : A/K CDA Flow or Press Alarm!! Please. Check A/K CDA Flow or Press");
			return;	
		}

		if( m_pCvSeq->m_CvMotor.nCvManual[nMotorNo] != CCvSeq::cvSTOP ) return;

		CvMotorCommnad( nMotorNo, CCvSeq::cvBW );	
	}
}

BOOL CDlgGridCvMotor::RobotInterlock(int nMotor)
{
	BOOL bInterlock = FALSE;
	BOOL bLdUnitHandInterLock = m_pEqpAssy->m_SensorRobotHandInterlock.Get( 0 );
	BOOL bUlUnitHandInterLock = m_pEqpAssy->m_SensorRobotHandInterlock.Get( 1 );


	if(nMotor == 0)
	{
		if(bLdUnitHandInterLock == TRUE)
		{
			bInterlock = TRUE;
			AfxMessageBox( "INTERLOCK : Load Robot Sensing!! Please check robot!!");
		}
	}
	if(nMotor == MAX_CV_MOTOR_NO-1)
	{
		if(bUlUnitHandInterLock == TRUE)
		{
			bInterlock = TRUE;
			AfxMessageBox( "INTERLOCK : Unload Robot Sensing!! Please check robot!!");
		}
	}
	return bInterlock;
}