#if !defined(AFX_DlgGridCvMotor_H__599817BA_45EC_4AA8_96D0_26848EBC089A__INCLUDED_)
#define AFX_DlgGridCvMotor_H__599817BA_45EC_4AA8_96D0_26848EBC089A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgGridCvMotor.h : header file
//
#include "..\X\XCtlDevice.h"
#include "..\X\MacButtons.h"
#include "..\msflexgrid.h"
#include "..\FactoryLib\EqpAssy.h"
/////////////////////////////////////////////////////////////////////////////
// CDlgCvMotor dialog


class CDlgGridCvMotor : public CDialog
{
// Construction
public:
	CDlgGridCvMotor(CWnd* pParent = NULL);   // standard constructor
	void SetSpeedRange(int nBottom, int nTop, int nInterval);

	void SetDevice(XCtlDevice* pDevice) { m_pDevice = pDevice; }
	void SetSetupItems(CSetupItems* pSetupItems) { m_pSetupItems = pSetupItems; }
	void SetCvSeq( CCvSeq* pCvSeq ) { m_pCvSeq = pCvSeq; }
	void SetEqpAssy( CEqpAssy* pEqpAssy ){ m_pEqpAssy = pEqpAssy; }
	CBitmapButton	m_Ok;
	XCtlDevice* m_pDevice;
	CView* m_pView;
	CSetupItems* m_pSetupItems;
	CCvSeq* m_pCvSeq;
	CEqpAssy*	m_pEqpAssy;

	BOOL	m_bExtendWndPos;
	int		m_nCurSel;


	int	m_nOldDirStatus[MAX_CV_MOTOR_NO];
	int	m_nOldAlarmStatus[MAX_CV_MOTOR_NO];
	int	m_nOldCpStatus[MAX_CV_MOTOR_NO];
	int m_nOldCvSpeed[MAX_CV_MOTOR_NO];
	int m_nMotorEA;
	int m_nBottomSpeed;
	int m_nTopSpeed;
	int m_nIntervalSpeed;
	CString m_sMotorName;

	CMSFlexGrid		m_gridCvMotor;

	enum columnTYPE{ colNAME, colSTOP, colFW, colBW, colSPEED, colALARM, colCPDOWN, colMAX };

// Dialog Data
	//{{AFX_DATA(CDlgGridCvMotor)
	enum { IDD = IDD_DLG_GRID_CV_MOTOR };
	CComboBox		m_cbCvSpeed;
	CMacRadioButton	m_macMotorAllBw;
	CMacRadioButton	m_macMotorAllFw;
	CMacRadioButton	m_macMotorAllStop;
	CMacButton	m_macSetWndPos;
	//}}AFX_DATA

	void CvMotorCommnad( int nCvMotorNo, int nCmd );
	void GridInit_CvMotor();

	BOOL RobotInterlock(int nMotor);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgGridCvMotor)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgGridCvMotor)
	virtual BOOL OnInitDialog();
	afx_msg void OnSetWndPos();
	afx_msg void OnSelchangeComboCvSpeed();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnCvMotorAllStop();
	afx_msg void OnCvMotorAllFw();
	afx_msg void OnCvMotorAllBw();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	afx_msg void OnClickGridCvMotor();
	DECLARE_MESSAGE_MAP()
	DECLARE_EVENTSINK_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DlgGridCvMotor_H__599817BA_45EC_4AA8_96D0_26848EBC089A__INCLUDED_)
