// DlgGridRollBrush.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DlgGridRollBrush.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgGridRollBrush dialog


CDlgGridRollBrush::CDlgGridRollBrush(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgGridRollBrush::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgGridRollBrush)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgGridRollBrush::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgGridRollBrush)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Control(pDX, IDC_GRID_RB_MOTOR,  m_gridRbMotor);
	DDX_Control(pDX, IDC_COMBO_RB_RPM, m_comboRbRpm);
	DDX_Control(pDX, IDC_RB_ALL_STOP, m_macRbAllStop);
	DDX_Control(pDX, IDC_RB_ALL_CW, m_macRbAllCw);
	DDX_Control(pDX, IDC_RB_ALL_CCW, m_macRbAllCcw);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgGridRollBrush, CDialog)
	//{{AFX_MSG_MAP(CDlgGridRollBrush)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_COMBO_RB_RPM, OnSelchangeComboRbRpm)
	ON_BN_CLICKED(IDC_RB_ALL_STOP, OnAllStop)
	ON_BN_CLICKED(IDC_RB_ALL_CW, OnAllCw)
	ON_BN_CLICKED(IDC_RB_ALL_CCW, OnAllCcw)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgGridRollBrush message handlers

BOOL CDlgGridRollBrush::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	MAC_COLOR_SET color;
	
	m_macRbAllCw.GetColorSetting( &color );
	color.crFace = LIGHT_BLUE_COLOR;
	color.crLiteShadow = MAGENTA_COLOR;
	m_macRbAllCw.SetColorSetting( color );
	m_macRbAllCw.SetBold();

	color.crFace = LIGHT_ORANGE_COLOR;
	color.crLiteShadow = MAGENTA_COLOR;
	m_macRbAllCcw.SetColorSetting( color );
	m_macRbAllCcw.SetBold();

	color.crFace = LIGHT_RED_COLOR;
	color.crLiteShadow = MAGENTA_COLOR;
	m_macRbAllStop.SetColorSetting( color );
	m_macRbAllStop.SetBold();

	for( int i=0; i<=25; i++ ) 
	{
		CString sSpeed;
		sSpeed.Format( "%d", 100 + (20 * i) );
		m_comboRbRpm.AddString( sSpeed );
	}
	m_comboRbRpm.SetCurSel( 15 );

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	
	for( int i = 0 ; i < MAX_RB_NO ; i ++ )
	{
		m_nOldRbDirStatus[i]	= -1;
		m_nOldRbAlarmStatus[i]	= -1;
		m_nOldRbCpStatus[i]		= -1;
		m_nOldRbCvSpeed[i]		= -1;

		if( m_pEqpAssy->m_RbMotor.GetMotorFwState( i ) ) m_nDirection[i]	= rbCW;
		else if( m_pEqpAssy->m_RbMotor.GetMotorBwState( i ) ) m_nDirection[i]	= rbCCW;
		else m_nDirection[i] = rbSTOP;

//		m_pRbSeq->m_RbMotor.nRefRbVelocity[i] = 0;	
		
		m_bMotorReset[i]		= FALSE;
	}

	SetTimer( TIMER_MANUAL, 500, NULL );

//	SetButtonState();
	GridInit_RBMotor();

	// Set the initial window position
	CRect r;
	GetWindowRect( &r );
	MoveWindow( 110, 350, r.right - r.left, r.bottom - r.top );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgGridRollBrush::OnDestroy() 
{
	CDialog::OnDestroy();	
	// TODO: Add your message handler code here
//	for(int i = 0; i < MAX_RB_NO; i++)
//	m_pRbSeq->m_RbMotor.nRefRbVelocity[i] = 0;	

	KillTimer( TIMER_MANUAL );
	
}

void CDlgGridRollBrush::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	static int nCount[MAX_RB_NO] = { 0, };
	BOOL bAL, bCPdown;
	bAL = bCPdown = 0;

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	for( int i = 0 ; i < m_nMotorEA ; i ++ )
	{
#ifndef _MY_DEBUG
		bAL = m_pEqpAssy->m_RbMotor.GetMotorAlarm( i );
		bCPdown = m_pEqpAssy->m_RbMotor.GetMotorCpAlarm( i );
#endif
		if( ( m_nOldRbDirStatus[i] != m_nDirection[i] ) && !bAL && !bCPdown )
		{
			m_nOldRbDirStatus[i] = m_nDirection[i];
			
			if( m_nDirection[i] == rbSTOP )
			{
				m_gridRbMotor.SetRow( i+1 );
				m_gridRbMotor.SetCol( colCW );		m_gridRbMotor.SetCellBackColor( BG_COLOR_INT );
				m_gridRbMotor.SetCol( colCCW );		m_gridRbMotor.SetCellBackColor( BG_COLOR_INT );
				m_gridRbMotor.SetCol( colSTOP );	m_gridRbMotor.SetCellBackColor( LIGHT_RED_COLOR );
			}
			else if( m_nDirection[i] == rbCW )
			{
				m_gridRbMotor.SetRow( i+1 );
				m_gridRbMotor.SetCol( colCCW );		m_gridRbMotor.SetCellBackColor( BG_COLOR_INT );
				m_gridRbMotor.SetCol( colSTOP );	m_gridRbMotor.SetCellBackColor( BG_COLOR_INT );
				m_gridRbMotor.SetCol( colCW );		m_gridRbMotor.SetCellBackColor( LIGHT_CYAN_COLOR );
				
				m_macRbAllCcw.EnableWindow( FALSE );
			}
			else if( m_nDirection[i] == rbCCW )
			{
				m_gridRbMotor.SetRow( i+1 );
				m_gridRbMotor.SetCol( colCW );		m_gridRbMotor.SetCellBackColor( BG_COLOR_INT );
				m_gridRbMotor.SetCol( colSTOP );	m_gridRbMotor.SetCellBackColor( BG_COLOR_INT );
				m_gridRbMotor.SetCol( colCCW );		m_gridRbMotor.SetCellBackColor( LIGHT_ORANGE_COLOR );

				m_macRbAllCw.EnableWindow( FALSE );
			}
		}

		if( m_nOldRbAlarmStatus[i] != 1 && bAL ) 
		{
			m_nOldRbAlarmStatus[i] = 1;
			m_gridRbMotor.SetRow( i+1 );
			m_gridRbMotor.SetCol( colALARM );		m_gridRbMotor.SetCellBackColor( RED_COLOR );
		}
		else if( m_nOldRbAlarmStatus[i] != 2 && !bAL )
		{
			m_nOldRbAlarmStatus[i] = 2;
			m_gridRbMotor.SetRow( i+1 );
			m_gridRbMotor.SetCol( colALARM );		m_gridRbMotor.SetCellBackColor( LIGHT_GREEN_COLOR );
		}

		if( m_nOldRbCpStatus[i] != 1 && bCPdown ) 
		{
			m_nOldRbCpStatus[i] = 1;
			m_gridRbMotor.SetRow( i+1 );
			m_gridRbMotor.SetCol( colCPDOWN );		m_gridRbMotor.SetCellBackColor( RED_COLOR );
		}
		else if( m_nOldRbCpStatus[i] != 2 && !bCPdown ) 
		{
			m_nOldRbCpStatus[i] = 2;
			m_gridRbMotor.SetCol( colCPDOWN );		m_gridRbMotor.SetCellBackColor( LIGHT_GREEN_COLOR );
		}
		
		int nSpeed = pView->m_pRbSeq->m_RbMotor.nRefRbVelocity[i];
		if( m_nOldRbCvSpeed[i] != nSpeed )
		{
			m_nOldRbCvSpeed[i] = nSpeed;
			CString sTmp;
			sTmp.Format( "%d", nSpeed );
			m_gridRbMotor.SetCol( colSPEED );	
			m_gridRbMotor.SetRow( i+1 );	
			m_gridRbMotor.SetText( sTmp );
			m_gridRbMotor.SetCellAlignment( 3 );
		}
	}

	int bCvStop = TRUE;
	for( int i = 0 ; i < m_nMotorEA ; i++ )
	{
		bCvStop &= ( m_pRbSeq->m_RbMotor.nRefRbVelocity[i] == 0 ) ? TRUE : FALSE;
	}
	if( bCvStop )
	{
		m_macRbAllCw.EnableWindow( TRUE );		
		m_macRbAllCcw.EnableWindow( TRUE );		
	}
	CDialog::OnTimer(nIDEvent);
}

BEGIN_EVENTSINK_MAP(CDlgGridRollBrush, CDialog)
    //{{AFX_EVENTSINK_MAP(CDlgGridRollBrush)
	ON_EVENT(CDlgGridRollBrush, IDC_GRID_RB_MOTOR, -600 /* Click */, OnClickGridRbMotor, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CDlgGridRollBrush::SetSpeedRange(int nBottom, int nTop, int nInterval)
{
	m_nBottomSpeed = nBottom;
	m_nTopSpeed = nTop;
	m_nIntervalSpeed = nInterval;
}

void CDlgGridRollBrush::GridInit_RBMotor()
{
	LPTSTR sLvcText[] = { "Name", "STOP", "CW", "CCW", "Speed", "Alarm", "C/P Off" };
	int nColWidth[] = { 1620, 1080, 1080, 1080, 1080, 1080, 1080 }; 
	if( colMAX > 15 )  
	{
		nColWidth[0] = 1300;
	}

	// initialize GridCtrl
	m_gridRbMotor.SetRows( m_nMotorEA+1 );
	m_gridRbMotor.SetCols( colMAX );

	//-------------------------------------------
	m_gridRbMotor.SetRow( 0 );  
	for( int i=0; i<colMAX; i++ )
	{
		m_gridRbMotor.SetColWidth( i, nColWidth[i] );
		m_gridRbMotor.SetCol( i ); 
		m_gridRbMotor.SetCellAlignment( 4 );
		m_gridRbMotor.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridRbMotor.SetText( sLvcText[i] ); 
	}

	for( int i = 0 ; i < m_nMotorEA ; i ++ )
	{
		CString sName;
		sName = m_sMotorName.Left( m_sMotorName.Find( ";", 0 ) );
		m_sMotorName.TrimLeft( sName );
		m_sMotorName.TrimLeft( ";" );
	
		m_gridRbMotor.SetCol( 0 );
		m_gridRbMotor.SetRow( i + 1 );
		m_gridRbMotor.SetCellAlignment( 4 );
		m_gridRbMotor.SetCellBackColor( LIGHT_GRAY );
		m_gridRbMotor.SetText( sName );
	}
}

void CDlgGridRollBrush::OnClickGridRbMotor() 
{
	// TODO: Add your control notification handler code here
	int nSel = m_comboRbRpm.GetCurSel();
	if( nSel == CB_ERR ) return;

	CString sRpm;
	m_comboRbRpm.GetLBText( nSel, sRpm );
	double dfRpm = atof( sRpm );

	int nCol = m_gridRbMotor.GetCol();
	int nRow = m_gridRbMotor.GetRow();

	int nRbMotorNo = nRow -1;
	
	if( nCol == colSTOP )
	{
		m_pRbSeq->m_RbMotor.nRefRbVelocity[nRbMotorNo] = 0;
		m_nDirection[nRbMotorNo] = rbSTOP;
	}
	else if( nCol == colCW )
	{
		m_nDirection[nRbMotorNo] = rbCW;	 
		m_pRbSeq->m_RbMotor.nRefRbVelocity[nRbMotorNo] = (int)dfRpm;
	}
	else if( nCol == colCCW )
	{
		m_nDirection[nRbMotorNo] = rbCCW;	 
		m_pRbSeq->m_RbMotor.nRefRbVelocity[nRbMotorNo] = (int)dfRpm * -1;
	}
//	else if( nCol == colRESET )
//	{
//		m_bMotorReset[nRbMotorNo] = TRUE;
//	}
}

//--------------------------------------------------------------------
// get the roll brush RPM
//--------------------------------------------------------------------
void CDlgGridRollBrush::OnSelchangeComboRbRpm() 
{
	int nSel = m_comboRbRpm.GetCurSel();
	if( nSel == CB_ERR ) return;

	CString sRpm;
	m_comboRbRpm.GetLBText( nSel, sRpm );

	int nCol = m_gridRbMotor.GetCol();
	int nRow = m_gridRbMotor.GetRow();

/*	for( int i=0; i<MAX_RB_NO; i++ )
	{
		if( m_RadioRbType[i].GetCheck() )
		{
			if( !dosRB_MOTOR_CW( i ) && !dosRB_MOTOR_CCW( i ) )
				return;	// Before Turn current motor, if the value in ComboBox, 
						// the Motor will not turn but will turn after click CW or CCW Button
		}
	}*/

//	double dfRpm = atof( sRpm ) * 5.0;
//	aogRB_MOTOR_SPEED( m_nRbType, (int)( ( dfRpm / 3000.0 ) * 0x4000 ) );

	double dfRpm = atof( sRpm );
	int nRbMotorNo = nRow -1;

/*	if( m_pRbSeq->m_RbMotor.nRefRbVelocity[nRbMotorNo] > 0 )
		m_pRbSeq->m_RbMotor.nRefRbVelocity[nRbMotorNo] = (int) dfRpm;
	else 
		m_pRbSeq->m_RbMotor.nRefRbVelocity[nRbMotorNo] = (int) ( dfRpm * -1 );*/
}

//--------------------------------------------------------------------
// All Roll Brush CW
//--------------------------------------------------------------------
void CDlgGridRollBrush::OnAllCw() 
{
//	GetDlgItem( IDC_RB_CCW )->EnableWindow( FALSE );
	int nSel = m_comboRbRpm.GetCurSel();
	if( nSel == CB_ERR ) return;
	CString sRpm;
	m_comboRbRpm.GetLBText( nSel, sRpm );

//	double dfRpm = atof( sRpm ) * 5.0;
//	aogRB_MOTOR_SPEED( m_nRbType, (int)( ( dfRpm / 3000.0 ) * 0x4000 ) );
//	dogRB_MOTOR_CW( m_nRbType, ON );
//	dogRB_MOTOR_CCW( m_nRbType, OFF );

	double dfRpm = atof( sRpm );

	for( int i=0; i<MAX_RB_NO; i++ )
	{
		m_nDirection[i] = rbCW;	 
		m_pRbSeq->m_RbMotor.nRefRbVelocity[i] = (int)dfRpm;
	}
}

//--------------------------------------------------------------------
// All Roll Brush CCW
//--------------------------------------------------------------------
void CDlgGridRollBrush::OnAllCcw() 
{
//	GetDlgItem( IDC_RB_CW )->EnableWindow( FALSE );

	int nSel = m_comboRbRpm.GetCurSel();
	if( nSel == CB_ERR ) return;
	CString sRpm;
	m_comboRbRpm.GetLBText( nSel, sRpm );

//	double dfRpm = atof( sRpm ) * 5.0;
//	aogRB_MOTOR_SPEED( m_nRbType, (int)( ( dfRpm / 3000.0 ) * 0x4000 ) );
//	dogRB_MOTOR_CW( m_nRbType, OFF );
//	dogRB_MOTOR_CCW( m_nRbType, ON );

	double dfRpm = atof( sRpm );	

	for( int i=0; i<MAX_RB_NO; i++ )
	{
		m_nDirection[i] = rbCCW;
		m_pRbSeq->m_RbMotor.nRefRbVelocity[i] = (int)dfRpm * -1;
	}
}

//--------------------------------------------------------------------
// All Stop the roll brush
//--------------------------------------------------------------------
void CDlgGridRollBrush::OnAllStop() 
{
//	GetDlgItem( IDC_RB_CW )->EnableWindow( TRUE );
//	GetDlgItem( IDC_RB_CCW )->EnableWindow( TRUE );

	for( int i=0; i<MAX_RB_NO; i++ )
	{
//		dogRB_MOTOR_CW( i, OFF );
//		dogRB_MOTOR_CCW( i, OFF );

		m_pRbSeq->m_RbMotor.nRefRbVelocity[i] = 0;
		
		m_nDirection[i] = rbSTOP;
	}
	SetButtonState();
}

void CDlgGridRollBrush::SetButtonState()
{
	m_macRbAllCw.SetCheck( 0 );
	m_macRbAllCcw.SetCheck( 0 );
	m_macRbAllStop.SetCheck( 1 );
}
