// DlgHostMsg.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgHostMsg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgHostMsg dialog


CDlgHostMsg::CDlgHostMsg(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgHostMsg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgHostMsg)
	m_sEqpMessage = _T("");
	m_sMessage = _T("");
	//}}AFX_DATA_INIT
}


void CDlgHostMsg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgHostMsg)
	DDX_Control(pDX, IDC_MESSAGE, m_Message);
	DDX_Text(pDX, IDC_EQP_MESSAGE, m_sEqpMessage);
	DDV_MaxChars(pDX, m_sEqpMessage, 40);
	DDX_Text(pDX, IDC_MESSAGE, m_sMessage);
	DDX_Control(pDX, IDC_SEND, m_macSend);
	DDX_Control(pDX, IDC_CLEAR, m_macClear);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgHostMsg, CDialog)
	//{{AFX_MSG_MAP(CDlgHostMsg)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgHostMsg message handlers

BOOL CDlgHostMsg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Set button
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	// Set the MAC button
	MAC_COLOR_SET color_set;

	// Send
	m_macSend.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macSend.SetColorSetting( color_set );
	m_macSend.SetBold();
	
	// Clear
	m_macClear.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macClear.SetColorSetting( color_set );
	m_macClear.SetBold();

	SetTimer( TIMER_MANUAL, 500, NULL );

	int nLine = m_Message.GetLineCount();
	m_Message.LineScroll( nLine );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgHostMsg::OnSend() 
{
	UpdateData( TRUE );
	m_pHost->S10F1( m_sEqpMessage );
	
	COleDateTime curTime = COleDateTime::GetCurrentTime();
	CString sDateTime = curTime.Format(_T("%Y/%m/%d %H:%M:%S"));
	CString sData = "[SEND] " + sDateTime + " - " + m_sEqpMessage + "\r\n";
	m_pHost->m_sTerminalMessage += sData;
	m_sMessage = m_pHost->m_sTerminalMessage;
	m_sEqpMessage = "";
	UpdateData( FALSE );

	int nLine = m_Message.GetLineCount();
	m_Message.LineScroll( nLine ); 
}

void CDlgHostMsg::OnClear() 
{
	m_sEqpMessage = "";
	UpdateData( FALSE );
}

void CDlgHostMsg::OnTimer(UINT nIDEvent) 
{
	static int nOldLen;
	int nLen = m_pHost->m_sTerminalMessage.GetLength();
	if( nOldLen != nLen ) 
	{
		m_sMessage = m_pHost->m_sTerminalMessage;
		nOldLen = nLen;
		UpdateData( FALSE );
		
		int nLine = m_Message.GetLineCount();
		m_Message.LineScroll( nLine );
	}
	CDialog::OnTimer(nIDEvent);
}
