// DlgInitStatus.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgInitStatus.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgInitStatus dialog

CDlgInitStatus::CDlgInitStatus(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgInitStatus::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgInitStatus)
		m_nMaxRowsMain = 2;
		m_nMaxRowsPump = 2;
		m_nMaxCols		 = 3;
		m_bExtendWndPos	 = TRUE;
		//}}AFX_DATA_INIT
}
	
CDlgInitStatus::CDlgInitStatus( CGlassInfo mask, CWnd* pParent /*=NULL*/ )
	: CDialog(CDlgInitStatus::IDD, pParent)
{
}


void CDlgInitStatus::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgInitStatus)
	DDX_Control(pDX, IDC_GRID_INIT_STATUS_MAIN,  m_gridInitStatusMain);
	DDX_Control(pDX, IDC_GRID_INIT_STATUS_PUMP,  m_gridInitStatusPump);
	DDX_Control(pDX, IDC_BTN_SET_POS,		 m_macSetPos);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgInitStatus, CDialog)
	//{{AFX_MSG_MAP(CDlgInitStatus)
	ON_BN_CLICKED(IDC_BTN_SET_POS, OnBtnHide )
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgInitStatus message handlers

//--------------------------------------------------------------------
// OnInitDialog
//--------------------------------------------------------------------
BOOL CDlgInitStatus::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Set the MAC button
	MAC_COLOR_SET color_set;
	m_macSetPos.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = ORANGE_COLOR;
	m_macSetPos.SetColorSetting( color_set );
	m_macSetPos.SetBold();

	CRect r;
	GetWindowRect( &r );
	MoveWindow( 10, 120, r.right - r.left, r.bottom - r.top );


	GridInit_StatusMain();	
	GridInit_StatusPump();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CDlgInitStatus::OnDestroy() 
{
	CDialog::OnDestroy();
}

void CDlgInitStatus::PostNcDestroy()
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	pView->m_pDlgInitStatus = NULL;
	delete this;

	CDialog::PostNcDestroy();
}

void CDlgInitStatus::OnBtnHide()
{
//	ShowWindow( SW_HIDE );

	CRect r1;
	CRect r2;
	if( m_bExtendWndPos )
	{
		m_bExtendWndPos = FALSE;
		
		GetWindowRect( &r1 );
		r1.right -= 470; r1.bottom -= 313;
		MoveWindow( &r1, TRUE );

		m_macSetPos.SetWindowText( "Show" );
		m_macSetPos.GetWindowRect( &r2 );
		m_macSetPos.MoveWindow( 0, 0, r2.right - r2.left, r2.bottom - r2.top );		
	}
	else
	{
		m_bExtendWndPos = TRUE;
		GetWindowRect( &r1 );
		r1.right += 470; r1.bottom += 313;
		MoveWindow( &r1, TRUE );

		m_macSetPos.SetWindowText( "Hide" );
		m_macSetPos.GetWindowRect( &r2 );
		m_macSetPos.MoveWindow( 450, 0, r2.right - r2.left, r2.bottom - r2.top );	
	}
}

void CDlgInitStatus::GridInit_StatusMain()
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	m_nMaxRowsMain = pView->m_pDicsData->m_nInitMainItemsNo;

	LPTSTR sLvcText[] = { "No", "Contents", "Status" };
	int nColWidth[] = { 400, 2200, 850 }; 
	if( m_nMaxRowsMain > 15 )  
	{
		nColWidth[0] = 350;
		nColWidth[1] = 2010;
	}

	// initialize GridCtrl
	m_gridInitStatusMain.SetRows( m_nMaxRowsMain +1 ); 
	m_gridInitStatusMain.SetCols( m_nMaxCols );

	//-------------------------------------------
	m_gridInitStatusMain.SetRow( 0 );  

	for( int i=0; i<m_nMaxCols; i++ )
	{
		m_gridInitStatusMain.SetColWidth( i, nColWidth[i] );
		m_gridInitStatusMain.SetCol( i ); 
		m_gridInitStatusMain.SetCellAlignment( 4 );
		m_gridInitStatusMain.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridInitStatusMain.SetText( sLvcText[i] ); 
	}

	for( int i=0; i<m_nMaxRowsMain; i++ )
	{
		m_gridInitStatusMain.SetCol( 0 );
		m_gridInitStatusMain.SetRow( i + 1 );
		m_gridInitStatusMain.SetCellAlignment( 4 );
		m_gridInitStatusMain.SetCellBackColor( LIGHT_CYAN_COLOR );
		CString sTmp;
		sTmp.Format("%d", i+1);
		m_gridInitStatusMain.SetText(sTmp);
	
		m_gridInitStatusMain.SetCol( 1 );
		m_gridInitStatusMain.SetCellBackColor( BG_COLOR_INT );
		m_gridInitStatusMain.SetText( pView->m_pDicsData->m_InitMainItems[i].sName );
	}
}

void CDlgInitStatus::GridInit_StatusPump()
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	m_nMaxRowsPump = pView->m_pDicsData->m_nInitPumpItemsNo;

	LPTSTR sLvcText[] = { "No", "Contents", "Status" };
	int nColWidth[] = { 400, 2200, 850 }; 

	// initialize GridCtrl
	m_gridInitStatusPump.SetRows( m_nMaxRowsPump + 1 ); 
	m_gridInitStatusPump.SetCols( m_nMaxCols );

	//-------------------------------------------
	m_gridInitStatusPump.SetRow( 0 );  

	for( int i=0; i<m_nMaxCols; i++ )
	{
		m_gridInitStatusPump.SetColWidth( i, nColWidth[i] );
		m_gridInitStatusPump.SetCol( i ); 
		m_gridInitStatusPump.SetCellAlignment( 4 );
		m_gridInitStatusPump.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridInitStatusPump.SetText( sLvcText[i] ); 
	}

	for( int i=0; i<m_nMaxRowsPump; i++ )
	{
		m_gridInitStatusPump.SetCol( 0 );
		m_gridInitStatusPump.SetRow( i + 1 );
		m_gridInitStatusPump.SetCellAlignment( 4 );
		m_gridInitStatusPump.SetCellBackColor( LIGHT_CYAN_COLOR );
		CString sTmp;
		sTmp.Format("%d", i+1);
		m_gridInitStatusPump.SetText(sTmp);
	
		m_gridInitStatusPump.SetCol( 1 );
		m_gridInitStatusPump.SetCellBackColor( BG_COLOR_INT );
		m_gridInitStatusPump.SetText( pView->m_pDicsData->m_InitPumpItems[i].sName );
	}
}

void CDlgInitStatus::SetStatusMain( CString sData )
{
	int nItemNo = atoi( sData.Mid( 0, 2 ) );
	int nState	= atoi( sData.Mid( 2, 1 ) );

	m_gridInitStatusMain.SetRow( nItemNo+1 );
	m_gridInitStatusMain.SetCol( 2 );

	switch( nState	) 
	{
		case MSG_STATUS_START : // Check Start
			m_gridInitStatusMain.SetCellBackColor( YELLOW_COLOR );
			m_gridInitStatusMain.SetText( "Check..." );
			break;
		case MSG_STATUS_OK : // OK
			m_gridInitStatusMain.SetCellBackColor( GREEN_COLOR );
			m_gridInitStatusMain.SetText( "OK" );
			break;
		case MSG_STATUS_NG : // NG
			m_gridInitStatusMain.SetCellBackColor( RED_COLOR );
			m_gridInitStatusMain.SetText( "NG" );
			break;
		case MSG_STATUS_SERVO_ESTOP : 
			m_gridInitStatusMain.SetCellBackColor( LIGHT_RED_COLOR );
			m_gridInitStatusMain.SetText( "E-Stop" );
			break;
		case MSG_STATUS_SERVO_RESET : 
			m_gridInitStatusMain.SetCellBackColor( LIGHT_ORANGE_COLOR );
			m_gridInitStatusMain.SetText( "Reset" );
			break;
		case MSG_STATUS_SERVO_HOME : 
			m_gridInitStatusMain.SetCellBackColor( LIGHT_BLUE_COLOR );
			m_gridInitStatusMain.SetText( "Home" );
			break;
		case MSG_STATUS_SET_OK : 
			m_gridInitStatusMain.SetCellBackColor( LIGHT_GREEN_COLOR );
			m_gridInitStatusMain.SetText( "SetOk" );
			break;
		case MSG_STATUS_NO_USE : 
			m_gridInitStatusMain.SetCellBackColor( LIGHT_BLUE_COLOR );
			m_gridInitStatusMain.SetText( "NoUse" );
			break;
	}
}

void CDlgInitStatus::ResetStatusMain( )
{
	for( int i=0; i<m_nMaxRowsMain; i++ )
	{
		m_gridInitStatusMain.SetRow( i + 1 );		
		m_gridInitStatusMain.SetCol( 2 );
		m_gridInitStatusMain.SetCellBackColor( LIGHT_YELLOW_COLOR );
		m_gridInitStatusMain.SetText( "NotReady" );
	}
}

void CDlgInitStatus::SetStatusPump( CString sData )
{
	int nItemNo = atoi( sData.Mid( 0, 2 ) );
	int nState	= atoi( sData.Mid( 2, 1 ) );

	m_gridInitStatusPump.SetRow( nItemNo+1 );
	m_gridInitStatusPump.SetCol( 2 );
	switch( nState	) 
	{
		case MSG_STATUS_START : // Check Start
			m_gridInitStatusPump.SetCellBackColor( YELLOW_COLOR );
			m_gridInitStatusPump.SetText( "Check..." );
			break;
		case MSG_STATUS_OK : // OK
			m_gridInitStatusPump.SetCellBackColor( GREEN_COLOR );
			m_gridInitStatusPump.SetText( "OK" );
			break;
		case MSG_STATUS_NG : // NG
			m_gridInitStatusPump.SetCellBackColor( RED_COLOR );
			m_gridInitStatusPump.SetText( "NG" );
			break;
	}
}
void CDlgInitStatus::ResetStatusPump( )
{
	for( int i=0; i<m_nMaxRowsPump; i++ )
	{
		m_gridInitStatusPump.SetRow( i + 1 );		
		m_gridInitStatusPump.SetCol( 2 );
		m_gridInitStatusPump.SetCellBackColor( LIGHT_YELLOW_COLOR );
		m_gridInitStatusPump.SetText( "NotReady" );
	}
}
