// DlgKeyboard.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgKeyboard.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgKeyboard dialog


CDlgKeyboard::CDlgKeyboard(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgKeyboard::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgKeyboard)
	m_sValue = _T("");
	m_sInitValue = _T("");
	//}}AFX_DATA_INIT

	m_bUpperCase = TRUE;
	m_bLimitCharacter = FALSE;
	m_bLimitInteger = FALSE;
	m_bLimitFloat = FALSE;
}


void CDlgKeyboard::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgKeyboard)
	DDX_Control(pDX, IDC_BUTTON_UPPER, m_UpperCase);
	DDX_Control(pDX, IDC_BUTTON_LOWER, m_LowerCase);
	DDX_Text(pDX, IDC_EDIT_CHARACTER, m_sValue);
	DDX_Text(pDX, IDC_INIT_CHARACTER, m_sInitValue);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgKeyboard, CDialog)
	//{{AFX_MSG_MAP(CDlgKeyboard)
	ON_BN_CLICKED(IDC_BUTTON_1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON_2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON_3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON_4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON_5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON_6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON_7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON_8, OnButton8)
	ON_BN_CLICKED(IDC_BUTTON_9, OnButton9)
	ON_BN_CLICKED(IDC_BUTTON_0, OnButton0)
	ON_BN_CLICKED(IDC_BUTTON_A, OnButtonA)
	ON_BN_CLICKED(IDC_BUTTON_B, OnButtonB)
	ON_BN_CLICKED(IDC_BUTTON_C, OnButtonC)
	ON_BN_CLICKED(IDC_BUTTON_D, OnButtonD)
	ON_BN_CLICKED(IDC_BUTTON_E, OnButtonE)
	ON_BN_CLICKED(IDC_BUTTON_F, OnButtonF)
	ON_BN_CLICKED(IDC_BUTTON_G, OnButtonG)
	ON_BN_CLICKED(IDC_BUTTON_H, OnButtonH)
	ON_BN_CLICKED(IDC_BUTTON_I, OnButtonI)
	ON_BN_CLICKED(IDC_BUTTON_J, OnButtonJ)
	ON_BN_CLICKED(IDC_BUTTON_K, OnButtonK)
	ON_BN_CLICKED(IDC_BUTTON_L, OnButtonL)
	ON_BN_CLICKED(IDC_BUTTON_M, OnButtonM)
	ON_BN_CLICKED(IDC_BUTTON_N, OnButtonN)
	ON_BN_CLICKED(IDC_BUTTON_O, OnButtonO)
	ON_BN_CLICKED(IDC_BUTTON_P, OnButtonP)
	ON_BN_CLICKED(IDC_BUTTON_Q, OnButtonQ)
	ON_BN_CLICKED(IDC_BUTTON_R, OnButtonR)
	ON_BN_CLICKED(IDC_BUTTON_S, OnButtonS)
	ON_BN_CLICKED(IDC_BUTTON_T, OnButtonT)
	ON_BN_CLICKED(IDC_BUTTON_U, OnButtonU)
	ON_BN_CLICKED(IDC_BUTTON_V, OnButtonV)
	ON_BN_CLICKED(IDC_BUTTON_W, OnButtonW)
	ON_BN_CLICKED(IDC_BUTTON_X, OnButtonX)
	ON_BN_CLICKED(IDC_BUTTON_Y, OnButtonY)
	ON_BN_CLICKED(IDC_BUTTON_Z, OnButtonZ)
	ON_BN_CLICKED(IDC_BUTTON_MINUS, OnButtonMinus)
	ON_BN_CLICKED(IDC_BUTTON_UNDERBAR, OnButtonUnderbar)
	ON_BN_CLICKED(IDC_BUTTON_SPACE, OnButtonSpace)
	ON_BN_CLICKED(IDC_BUTTON_BACK, OnButtonBack)
	ON_BN_CLICKED(IDC_BUTTON_UPPER, OnButtonUpper)
	ON_BN_CLICKED(IDC_BUTTON_LOWER, OnButtonLower)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgKeyboard message handlers

BOOL CDlgKeyboard::OnInitDialog() 
{
	CDialog::OnInitDialog();

	VERIFY( m_Ok.AutoLoad( IDOK, this ) );	
	VERIFY( m_Cancel.AutoLoad( IDCANCEL, this ) );

	//m_UpperCase.SetBold();
	//m_LowerCase.SetBold();

	if( m_bUpperCase ) m_UpperCase.SetCheck( 1 );
	else m_LowerCase.SetCheck( 1 );

	UpdateData( FALSE );

	OnButtonClear();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgKeyboard::OnOK() 
{
/*
	if( m_bLimitCharacter )
	{
		if( m_nLimitMax < m_sValue.GetLength() ) 
		{
			CString sTemp;
			sTemp.Format( "%d  ڸ ԷϽʽÿ!", m_nMaxLimit );
			AfxMessageBox( sTemp, MB_OK | MB_ICONSTOP | MB_SYSTEMMODAL );

			return;
		}
	}
	else if( m_bLimitInteger )
	{
		int nValue = atoi( m_sValue );
		if( nValue > m_nLimitUpper || nValue < m_nLimitLower ) 
		{
			return;
		}
	}
	else if( m_bLimitFloat )
	{
		float fValue = atof( m_sValue );
		if( fValue > m_fLimitUpper || fValue < m_fLimitLower ) 
		{
			return;
		}
	}

	m_bLimitCharacter = FALSE;
	m_bLimitInteger = FALSE;
	m_bLimitFloat = FALSE;
*/
	CDialog::OnOK();
}

void CDlgKeyboard::OnButtonUpper() 
{
	m_bUpperCase = TRUE;
}

void CDlgKeyboard::OnButtonLower() 
{
	m_bUpperCase = FALSE;
}

void CDlgKeyboard::UpdateEditBox(char ch)
{
	char temp[2];
	
	temp[0] = ch; 
	temp[1] = 0;
	
	m_sValue += temp;

	UpdateData( FALSE );
}

void CDlgKeyboard::OnButtonBack() 
{
	if( m_sValue.GetLength() == 0 ) return;
	m_sValue = m_sValue.Left( m_sValue.GetLength() - 1 );

	UpdateData( FALSE );
}

void CDlgKeyboard::OnButtonClear() 
{
	m_sValue = "";

	UpdateData( FALSE );
}

void CDlgKeyboard::OnButton1() 
{
	UpdateEditBox( '1' );
}

void CDlgKeyboard::OnButton2() 
{
	UpdateEditBox( '2' );	
}

void CDlgKeyboard::OnButton3() 
{
	UpdateEditBox( '3' );	
}

void CDlgKeyboard::OnButton4() 
{
	UpdateEditBox( '4' );	
}

void CDlgKeyboard::OnButton5() 
{
	UpdateEditBox( '5' );	
}

void CDlgKeyboard::OnButton6() 
{
	UpdateEditBox( '6' );	
}

void CDlgKeyboard::OnButton7() 
{
	UpdateEditBox( '7' );
}

void CDlgKeyboard::OnButton8() 
{
	UpdateEditBox( '8' );	
}

void CDlgKeyboard::OnButton9() 
{
	UpdateEditBox( '9' );	
}

void CDlgKeyboard::OnButton0() 
{
	UpdateEditBox( '0' );	
}

void CDlgKeyboard::OnButtonA() 
{
	if( m_bUpperCase ) UpdateEditBox( 'A' );
	else UpdateEditBox( 'a' );
}

void CDlgKeyboard::OnButtonB() 
{
	if( m_bUpperCase ) UpdateEditBox( 'B' );
	else UpdateEditBox( 'b' );	
}

void CDlgKeyboard::OnButtonC() 
{
	if( m_bUpperCase ) UpdateEditBox( 'C' );
	else UpdateEditBox( 'c' );
}

void CDlgKeyboard::OnButtonD() 
{
	if( m_bUpperCase ) UpdateEditBox( 'D' );
	else UpdateEditBox( 'd' );
}

void CDlgKeyboard::OnButtonE() 
{
	if( m_bUpperCase ) UpdateEditBox( 'E' );
	else UpdateEditBox( 'e' );
}

void CDlgKeyboard::OnButtonF() 
{
	if( m_bUpperCase ) UpdateEditBox( 'F' );
	else UpdateEditBox( 'f' );
}

void CDlgKeyboard::OnButtonG() 
{
	if( m_bUpperCase ) UpdateEditBox( 'G' );
	else UpdateEditBox( 'g' );
}

void CDlgKeyboard::OnButtonH() 
{
	if( m_bUpperCase ) UpdateEditBox( 'H' );
	else UpdateEditBox( 'h' );
}

void CDlgKeyboard::OnButtonI() 
{
	if( m_bUpperCase ) UpdateEditBox( 'I' );
	else UpdateEditBox( 'i' );	
}

void CDlgKeyboard::OnButtonJ() 
{
	if( m_bUpperCase ) UpdateEditBox( 'J' );
	else UpdateEditBox( 'j' );	
}

void CDlgKeyboard::OnButtonK() 
{
	if( m_bUpperCase ) UpdateEditBox( 'K' );
	else UpdateEditBox( 'k' );	
}

void CDlgKeyboard::OnButtonL() 
{
	if( m_bUpperCase ) UpdateEditBox( 'L' );
	else UpdateEditBox( 'l' );	
}

void CDlgKeyboard::OnButtonM() 
{
	if( m_bUpperCase ) UpdateEditBox( 'M' );
	else UpdateEditBox( 'm' );
}

void CDlgKeyboard::OnButtonN() 
{
	if( m_bUpperCase ) UpdateEditBox( 'N' );
	else UpdateEditBox( 'n' );
}

void CDlgKeyboard::OnButtonO() 
{
	if( m_bUpperCase ) UpdateEditBox( 'O' );
	else UpdateEditBox( 'o' );	
}

void CDlgKeyboard::OnButtonP() 
{
	if( m_bUpperCase ) UpdateEditBox( 'P' );
	else UpdateEditBox( 'p' );
}

void CDlgKeyboard::OnButtonQ() 
{
	if( m_bUpperCase ) UpdateEditBox( 'Q' );
	else UpdateEditBox( 'q' );
}

void CDlgKeyboard::OnButtonR() 
{
	if( m_bUpperCase ) UpdateEditBox( 'R' );
	else UpdateEditBox( 'r' );
}

void CDlgKeyboard::OnButtonS() 
{
	if( m_bUpperCase ) UpdateEditBox( 'S' );
	else UpdateEditBox( 's' );
}

void CDlgKeyboard::OnButtonT() 
{
	if( m_bUpperCase ) UpdateEditBox( 'T' );
	else UpdateEditBox( 't' );	
}

void CDlgKeyboard::OnButtonU() 
{
	if( m_bUpperCase ) UpdateEditBox( 'U' );
	else UpdateEditBox( 'u' );
}

void CDlgKeyboard::OnButtonV() 
{
	if( m_bUpperCase ) UpdateEditBox( 'V' );
	else UpdateEditBox( 'v' );
}

void CDlgKeyboard::OnButtonW() 
{
	if( m_bUpperCase ) UpdateEditBox( 'W' );
	else UpdateEditBox( 'w' );
}

void CDlgKeyboard::OnButtonX() 
{
	if( m_bUpperCase ) UpdateEditBox( 'X' );
	else UpdateEditBox( 'x' );	
}

void CDlgKeyboard::OnButtonY() 
{
	if( m_bUpperCase ) UpdateEditBox( 'Y' );
	else UpdateEditBox( 'y' );
}

void CDlgKeyboard::OnButtonZ() 
{
	if( m_bUpperCase ) UpdateEditBox( 'Z' );
	else UpdateEditBox( 'z' );
}

void CDlgKeyboard::OnButtonMinus() 
{
	UpdateEditBox( '-' );	
}

void CDlgKeyboard::OnButtonUnderbar() 
{
	UpdateEditBox( '_' );
}

void CDlgKeyboard::OnButtonSpace() 
{
	UpdateEditBox( ' ' );
}
