// DlgListCvMotor.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DlgListCvMotor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgListCvMotor dialog


CDlgListCvMotor::CDlgListCvMotor(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgListCvMotor::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgListCvMotor)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgListCvMotor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgListCvMotor)
	DDX_Control(pDX, IDC_COMBO_SPEED, m_cbSpeed);
	DDX_Control(pDX, IDC_LIST_CV, m_lcMotor);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_BUTTON_FW, m_macFw);
	DDX_Control(pDX, IDC_BUTTON_BW, m_macBw);
	DDX_Control(pDX, IDC_BUTTON_STOP, m_macStop);
	DDX_Control(pDX, IDC_BUTTON_ALL_STOP, m_macAllStop);
	DDX_Control(pDX, IDC_CHECK_ALL, m_macCheckAll);
}


BEGIN_MESSAGE_MAP(CDlgListCvMotor, CDialog)
	//{{AFX_MSG_MAP(CDlgListCvMotor)
	ON_BN_CLICKED(IDC_BUTTON_FW, OnButtonFw)
	ON_BN_CLICKED(IDC_BUTTON_BW, OnButtonBw)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_ALL_STOP, OnButtonAllStop)
	ON_NOTIFY(NM_CLICK, IDC_LIST_CV, OnClickListCv)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CHECK_ALL, OnCheckAll)
	ON_CBN_SELCHANGE(IDC_COMBO_SPEED, OnSelchangeComboSpeed)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgListCvMotor message handlers

void CDlgListCvMotor::SetSpeedRange(int nBottom, int nTop, int nInterval)
{
	m_nBottomSpeed		= nBottom;
	m_nTopSpeed			= nTop;
	m_nIntervalSpeed	= nInterval;
}

BOOL CDlgListCvMotor::OnInitDialog() 
{
	CDialog::OnInitDialog();
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	CRect r;
	GetWindowRect( &r );
	MoveWindow( 200, 450, r.right - r.left, r.bottom - r.top );	

	// Combo Box Inialize
	int nItemEA, nCurAns;
	nCurAns = nItemEA = 0;
	CString sSpeed;
	nItemEA = ( int )( ( m_nTopSpeed - m_nBottomSpeed ) / m_nIntervalSpeed );
	for( int i = 0 ; i < nItemEA + 1 ; i ++ )
	{
		nCurAns = m_nBottomSpeed + (int)( m_nIntervalSpeed * i );
		sSpeed.Format( "%d", nCurAns );
		m_cbSpeed.AddString( (LPCTSTR)sSpeed );
	}
	m_cbSpeed.SetCurSel( 12 );


	MAC_COLOR_SET color_set;
	m_macFw.GetColorSetting( &color_set );
	color_set.crFace		= LIGHT_GREEN_COLOR;
	color_set.crHilight		= CYAN_COLOR;
	m_macFw.SetColorSetting( color_set );
	color_set.crFace		= LIGHT_ORANGE_COLOR;
	color_set.crHilight		= CYAN_COLOR;
	m_macBw.SetColorSetting( color_set );
	color_set.crFace		= LIGHT_RED_COLOR;
	color_set.crHilight		= CYAN_COLOR;
	m_macStop.SetColorSetting( color_set );
	color_set.crFace		= LIGHT_RED_COLOR;
	color_set.crHilight		= CYAN_COLOR;
	m_macAllStop.SetColorSetting( color_set );


	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;


	for( i = 0 ; i < MAX_CV_MOTOR_NO ; i ++ )
	{
		m_nOldDirStatus[i]		= -1;
		m_nOldAlarmStatus[i]	= -1;
		m_nOldCpStatus[i]		= -1;
		m_nOldCvSpeed[i]		= -1;

		pView->m_pCvSeq->m_CvMotor.nSpeedManual[i] = pView->m_pDicsData->m_JobCond.nCvSpeed;	
	}
	
	ListInit();
	SetTimer( TIMER_MANUAL, 100, NULL );
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgListCvMotor::ListInit()
{
	LV_COLUMN lvcolumn;
	m_lcMotor.SetExtendedStyle( LVS_EX_GRIDLINES |     
								//LVS_EX_SUBITEMIMAGES |
								LVS_EX_CHECKBOXES |  
								LVS_EX_TRACKSELECT |     
								LVS_EX_HEADERDRAGDROP |
								//LVS_EX_FULLROWSELECT |
								//LVS_EX_ONECLICKACTIVATE |
								//LVS_EX_TWOCLICKACTIVATE |
								//LVS_EX_FLATSB |
								LVS_EX_REGIONAL |
								//LVS_EX_INFOTIP |
								LVS_EX_UNDERLINEHOT );
								//LVS_EX_UNDERLINECOLD |
								//LVS_EX_MULTIWORKAREAS  );

	static CString sColName[colMAX] ={
		"Motor Name          ", "Dir ", "Speed", "Alarm", "C/P"
	};

	for( int i = 0 ; i < colMAX ; i ++ )
	{
		lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
		lvcolumn.fmt = LVCFMT_CENTER;	
 		lvcolumn.cx = (int)( (double)( sColName[i].GetLength() + 5 ) * 5. );
		lvcolumn.pszText = (LPTSTR)(LPCTSTR)sColName[i];
		m_lcMotor.InsertColumn( i, &lvcolumn );
	}

	LV_ITEM		lvitem;
	char temp[80];
	for( i = 0 ; i < m_nMotorEA ; i ++ )
	{
		CString sName;
		sName = m_sMotorName.Left( m_sMotorName.Find( ";", 0 ) );
		m_sMotorName.TrimLeft( sName );
		m_sMotorName.TrimLeft( ";" );

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = i;
		lvitem.iSubItem = colNAME;
		sprintf( temp, (LPCTSTR)sName );
		lvitem.pszText = temp;
		m_lcMotor.InsertItem( &lvitem );
	}
}

void CDlgListCvMotor::OnButtonFw() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	for( int i = 0 ; i < m_nMotorEA ; i ++ )
		if( m_lcMotor.GetCheck( i ) )
		{
			if( pView->m_pCvSeq->m_CvMotor.nCvManual[i] == CCvSeq::cvSTOP )
				pView->m_pCvSeq->m_CvMotor.nCvManual[i] = CCvSeq::cvFW;
		}
}

void CDlgListCvMotor::OnButtonBw() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	for( int i = 0 ; i < m_nMotorEA ; i ++ )
		if( m_lcMotor.GetCheck( i ) )
		{
			if( pView->m_pCvSeq->m_CvMotor.nCvManual[i] == CCvSeq::cvSTOP )
				pView->m_pCvSeq->m_CvMotor.nCvManual[i] = CCvSeq::cvBW;
		}
}

void CDlgListCvMotor::OnButtonStop() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	for( int i = 0 ; i < m_nMotorEA ; i ++ )
		if( m_lcMotor.GetCheck( i ) )
		{
			pView->m_pCvSeq->m_CvMotor.nCvManual[i] = CCvSeq::cvSTOP;
		}
}

void CDlgListCvMotor::OnButtonAllStop() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	for( int i = 0 ; i < m_nMotorEA ; i ++ )
	{
//		m_lcMotor.SetCheck( i, FALSE );
		pView->m_pCvSeq->m_CvMotor.nCvManual[i] = CCvSeq::cvSTOP;
	}
}


void CDlgListCvMotor::OnClickListCv(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

void CDlgListCvMotor::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	char temp[80];
	LV_ITEM		lvitem;
	lvitem.mask = LVIF_TEXT;
	
	BOOL bAL, bCPdown;
	bAL = bCPdown = 0;
	int nTemp;

	for( int i = 0 ; i < m_nMotorEA ; i ++ )
	{
#ifndef _MY_DEBUG
		bAL = m_pEqpAssy->m_CvMotorAll.GetMotorAlarm( i );
		bCPdown = m_pEqpAssy->m_CvMotorAll.GetMotorCpAlarm( i );
#endif
		lvitem.iItem	= i;
		lvitem.iSubItem = colDIR;
		if( ( m_nOldDirStatus[i] != m_pCvSeq->m_CvMotor.nCvManual[i] ) && !bAL && !bCPdown )
		{
			m_nOldDirStatus[i] = m_pCvSeq->m_CvMotor.nCvManual[i];
			
			if( m_pCvSeq->m_CvMotor.nCvManual[i] == CCvSeq::cvSTOP )
			{
				sprintf( temp, "STOP" );
				lvitem.pszText = temp;
				m_lcMotor.SetItem( &lvitem );
			}
			else if( m_pCvSeq->m_CvMotor.nCvManual[i] == CCvSeq::cvFW )
			{
				sprintf( temp, "FW" );
				lvitem.pszText = temp;
				m_lcMotor.SetItem( &lvitem );
			}
			else if( m_pCvSeq->m_CvMotor.nCvManual[i] == CCvSeq::cvBW )
			{
				sprintf( temp, "BW" );
				lvitem.pszText = temp;
				m_lcMotor.SetItem( &lvitem );
			}
		}	
		
		lvitem.iSubItem = colALARM;
		if( m_nOldAlarmStatus[i] != 1 && bAL ) 
		{
			m_nOldAlarmStatus[i] = 1;
			sprintf( temp, "1" );
			lvitem.pszText = temp;
			m_lcMotor.SetItem( &lvitem );
		}
		else if( m_nOldAlarmStatus[i] != 2 && !bAL )
		{
			m_nOldAlarmStatus[i] = 2;
			sprintf( temp, "0" );
			lvitem.pszText = temp;
			m_lcMotor.SetItem( &lvitem );
		}

		lvitem.iSubItem = colCPON;
		if( m_nOldCpStatus[i] != 1 && bCPdown ) 
		{
			m_nOldCpStatus[i] = 1;
			sprintf( temp, "Off" );
			lvitem.pszText = temp;
			m_lcMotor.SetItem( &lvitem );
		}
		else if( m_nOldCpStatus[i] != 2 && !bCPdown ) 
		{
			m_nOldCpStatus[i] = 2;
			sprintf( temp, "On" );
			lvitem.pszText = temp;
			m_lcMotor.SetItem( &lvitem );
		}
		
		lvitem.iSubItem = colSPEED;
		nTemp = m_pCvSeq->m_CvMotor.nSpeedManual[i];
		if( m_nOldCvSpeed[i] != nTemp )
		{
			m_nOldCvSpeed[i] = nTemp;
			sprintf( temp, "%d", nTemp );
			lvitem.pszText = temp;
			m_lcMotor.SetItem( &lvitem );				
		}
	}

	CDialog::OnTimer(nIDEvent);
}

void CDlgListCvMotor::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	KillTimer( TIMER_MANUAL );	
}

void CDlgListCvMotor::OnCheckAll() 
{
	// TODO: Add your control notification handler code here
	if( m_macCheckAll.GetCheck() ) 
	{
		for( int i = 0 ; i < m_nMotorEA ; i ++ )
			m_lcMotor.SetCheck( i, FALSE );
		m_macCheckAll.SetCheck( 0 );
	}
	else
	{
		for( int i = 0 ; i < m_nMotorEA ; i ++ )
			m_lcMotor.SetCheck( i, TRUE );
		m_macCheckAll.SetCheck( 1 );
	}
}

void CDlgListCvMotor::OnSelchangeComboSpeed() 
{
	CString sSpeed;
	m_cbSpeed.GetLBText( m_cbSpeed.GetCurSel(), sSpeed );
	int nSpeed = atoi( sSpeed );

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	for( int i = 0 ; i < m_nMotorEA ; i ++ )
	{
		if( m_lcMotor.GetCheck( i ) )
		{
			pView->m_pCvSeq->m_CvMotor.nSpeedManual[i] = nSpeed; 		
		}
	}	
}



