// DlgLostGlassList.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgLostGlassList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgLostGlassList dialog

CDlgLostGlassList::CDlgLostGlassList(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgLostGlassList::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgLostGlassList)
		m_nMaxRows = 2;
		m_nMaxCols = 2;
		//}}AFX_DATA_INIT
}
	

void CDlgLostGlassList::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgLostGlassList)
	DDX_Control(pDX, IDC_GRID_LOST_LIST,  m_gridLostGlassList);
	DDX_Control(pDX, IDC_LOST_DATA_RECOVERY,  m_macRecovery);
	DDX_Control(pDX, IDOK,  m_macOk);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgLostGlassList, CDialog)
	//{{AFX_MSG_MAP(CDlgLostGlassList)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_LOST_DATA_RECOVERY, OnRecovery )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgLostGlassList message handlers

//--------------------------------------------------------------------
// OnInitDialog
//--------------------------------------------------------------------
BOOL CDlgLostGlassList::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Set the MAC button
	MAC_COLOR_SET color_set;
	m_macRecovery.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = ORANGE_COLOR;
	m_macRecovery.SetColorSetting( color_set );
	m_macRecovery.SetBold();

	m_macOk.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_BLUE_COLOR;
	color_set.crLiteShadow = BLUE_COLOR;
	m_macOk.SetColorSetting( color_set );
	m_macOk.SetBold();

	m_LostGlassListSet.Open();
	
	CRect r;
	GetWindowRect( &r );
	MoveWindow( 10, 120, r.right - r.left, r.bottom - r.top );


	GridInit_LostGlassList();	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CDlgLostGlassList::OnDestroy() 
{
	m_LostGlassListSet.Close();

	CDialog::OnDestroy();
}

void CDlgLostGlassList::GridInit_LostGlassList()
{
	m_nMaxCols = 2;
	m_nMaxRows =  m_LostGlassListSet.GetLostGlassListRowCount();
	
	LPTSTR sLvcText[] = { "No", "Glass No Code" };
	int nColWidth[] = { 700, 1750 }; 
	if( m_nMaxRows > 10 )  nColWidth[1] = 1550;

	// initialize GridCtrl
	m_gridLostGlassList.SetRows( m_nMaxRows +1 ); 
	m_gridLostGlassList.SetCols( m_nMaxCols );

	//-------------------------------------------
	m_gridLostGlassList.SetRow( 0 );  

	for( int i=0; i<m_nMaxCols; i++ )
	{
		m_gridLostGlassList.SetColWidth( i, nColWidth[i] );
		m_gridLostGlassList.SetCol( i ); 
		m_gridLostGlassList.SetCellAlignment( 4 );
		m_gridLostGlassList.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridLostGlassList.SetText( sLvcText[i] ); 
	}

	GLS_INFO LostGlasInfo;
	for( int i=0; i<m_nMaxRows; i++ )
	{
		m_gridLostGlassList.SetCol( 0 );
		m_gridLostGlassList.SetRow( i + 1 );
		m_gridLostGlassList.SetCellAlignment( 4 );
		m_gridLostGlassList.SetCellBackColor( LIGHT_CYAN_COLOR );

		CString sTmp;
		sTmp.Format("%d", i+1);
		m_gridLostGlassList.SetText(sTmp);
	
		m_gridLostGlassList.SetCol( 1 );
		m_gridLostGlassList.SetCellAlignment( 3 );
		m_gridLostGlassList.SetCellBackColor( BG_COLOR_INT );
		m_LostGlassListSet.GetLostGlassInfo( i+1, LostGlasInfo );
		sTmp.Format("  %04X", LostGlasInfo.nGlassData[0] );
		m_gridLostGlassList.SetText( sTmp );
	}

	m_gridLostGlassList.SetRow( 0 );
}

void CDlgLostGlassList::OnRecovery() 
{
	m_nSelectNo = m_gridLostGlassList.GetRow();
	if( !m_nSelectNo ) return;

	m_LostGlassListSet.GetLostGlassInfo( m_nSelectNo, m_RecoverGlsInfo );
	EndDialog( IDC_LOST_DATA_RECOVERY );
}

BEGIN_EVENTSINK_MAP(CDlgLostGlassList, CDialog)
    //{{AFX_EVENTSINK_MAP(CDlgLostGlassList)
	ON_EVENT(CDlgLostGlassList, IDC_GRID_LOST_LIST, -600 /* Click */, OnClickGridLostList, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CDlgLostGlassList::OnClickGridLostList() 
{
	// TODO: Add your control notification handler code here
	int nRow = m_gridLostGlassList.GetRow();

	m_gridLostGlassList.SetCol( 1 );
	for(int i=0; i<m_nMaxRows; i++)
	{
		m_gridLostGlassList.SetRow( i + 1 );  
		m_gridLostGlassList.SetCellBackColor( BG_COLOR_INT );
	}
	m_gridLostGlassList.SetRow( nRow );  
	m_gridLostGlassList.SetCellBackColor( YELLOW_COLOR );
}
