// DlgMmcState.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DlgMmcState.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgMmcState dialog


CDlgMmcState::CDlgMmcState(CPoint pt, CWnd* pParent /*=NULL*/)
	: CAniDialog(pt, CDlgMmcState::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgMmcState)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_sHelp = _T("");
	m_sEdit = _T("");
	m_pntStart = pt;

}


void CDlgMmcState::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgMmcState)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Text( pDX, IDC_EDIT_HELP, m_sEdit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgMmcState, CDialog)
	//{{AFX_MSG_MAP(CDlgMmcState)
	ON_WM_LBUTTONDOWN()
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_WM_CTLCOLOR()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgMmcState message handlers

BOOL CDlgMmcState::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_hbrBgColor = CreateSolidBrush( BG_COLOR );

	CRect r;
	GetWindowRect( &r );
	MoveWindow( m_pntStart.x, m_pntStart.y, r.right - r.left, r.bottom - r.top );

	GetHelpFile( "MMC\\Help_Servo_State.txt" );

	SetText();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgMmcState::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	//SetAniStyles(AS_TOPLEFT, AS_TOPLEFT);
	// poof
	//OnOK();
	
	CDialog::OnLButtonDown(nFlags, point);
}

BOOL CDlgMmcState::GetHelpFile(LPCTSTR lpszFileName)
{
	FILE* pFileHelp;
	CString sData;
	CString	sStateName;

	if( ( pFileHelp = fopen( lpszFileName, "rt" ) ) == NULL ) 
	{
		AfxMessageBox( "Help file is not loaded" );
		return FALSE;
	}
	
	while( !feof( pFileHelp ) )
	{
		char szLine[1000];

		// Read one line
		CString sData;
		fgets( szLine, 1000, pFileHelp );
		sData.Format("%s", szLine );
		//m_nLineNo += 1;

		// Parse the first token
		char szSeps[] = "\t\n";
		char* ptoken;
		CString sToken;

		ptoken = strtok( szLine, szSeps );
		sToken.Format( "%s", ptoken );

		if( m_nHelpContents == HELP_EVENT )
		{
			if( !sToken.Compare( "[EVT]" ) )
			{
				ptoken = strtok( NULL, szSeps );
				sStateName.Format( "%s", ptoken );
				if( sStateName == m_sStateName )
				{
					fgets( szLine, 1000, pFileHelp );
					sData.Format("%s", szLine );
					ptoken = strtok( szLine, szSeps );
					sToken.Format( "%s", ptoken );

					if( !sToken.Compare( "[TXT]" ) )
					{
						ptoken = strtok( NULL, szSeps );
						m_sHelp.Format( "%s", ptoken );
						sData.ReleaseBuffer();
						fclose( pFileHelp );
						return TRUE;
					}
				}
			}
		}
		else if( m_nHelpContents == HELP_SOURCE )
		{
			if( !sToken.Compare( "[SRC]" ) )
			{
				ptoken = strtok( NULL, szSeps );
				sStateName.Format( "%s", ptoken );
				if( sStateName == m_sStateName )
				{
					fgets( szLine, 1000, pFileHelp );
					sData.Format("%s", szLine );
					ptoken = strtok( szLine, szSeps );
					sToken.Format( "%s", ptoken );

					if( !sToken.Compare( "[TXT]" ) )
					{
						ptoken = strtok( NULL, szSeps );
						m_sHelp.Format( "%s", ptoken );
						sData.ReleaseBuffer();
						fclose( pFileHelp );
						return TRUE;
					}
				}
			}
		}
				
		sData.ReleaseBuffer();
	} 

	fclose( pFileHelp ); 

	return TRUE;
}

void CDlgMmcState::SetText()
{
	if( m_nHelpContents == HELP_EVENT )
		m_sEdit.Format( "Event Name : %s \r\n\r\n %s", m_sStateName, m_sHelp );
	else if( m_nHelpContents == HELP_SOURCE )
		m_sEdit.Format( "Source Name : %s \r\n\r\n %s", m_sStateName, m_sHelp );

	UpdateData( FALSE );
}

void CDlgMmcState::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnClose();
}

void CDlgMmcState::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	
}

HBRUSH CDlgMmcState::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	UINT id = pWnd->GetDlgCtrlID();
	switch( nCtlColor )
	{
		case CTLCOLOR_STATIC:
			if( id == IDC_EDIT_HELP )
			{
				hbr = m_hbrBgColor;
				pDC->SetBkMode( TRANSPARENT );
				pDC->SetTextColor( BLACK_COLOR );
			}
			break;
	}
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CDlgMmcState::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	SetAniStyles(AS_TOPLEFT, AS_TOPLEFT);
	// poof
	OnOK();

	CDialog::OnLButtonUp(nFlags, point);
}
