//---------------------------------------------------------------------------
// Copyright		: DMS Co., LTd
// File Name		: CDlgPassword.cpp
// Modified Date	: 2001.2.2, 
// Version			: 1.0
// Programmer		: kds 
// CDlgPassword.cpp	: implementation file
// Description		: Password Ȯ Dialog
// Usage :
// - Bitmap Button  
//	1. Bitmap ΰ . Dialog	ư Caption "D", "U" ٿ...
//		( ex : "OKU", "OKD" ) => D : Down(Mouse button down) , U : Up(Mouse button up) 
//							  => X : Disabled, F : Focused
//	2. Dialog ư Style Owner Draw Ѵ.
//	3. < CBitmapButton m_Ok; >  Header File ϰ
//	4. InitDialog < VERIFY( m_Ok.AutoLoad( IDOK, this ) ); >  ϸ ...
//---------------------------------------------------------------------------

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgPassword.h"
#include "DlgUserPass.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgPassword dialog


CDlgPassword::CDlgPassword(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgPassword::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgPassword)
	m_sPassword = _T("");
	m_sPassword2 = _T("");
	//}}AFX_DATA_INIT
	m_sUserID = "";
	m_nMode = 0;
	m_bIdOk = FALSE;	// ljy_050414
}


void CDlgPassword::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgPassword)
	DDX_Control(pDX, IDC_LIST_ID, m_lbUserID);
	DDX_Text(pDX, IDC_EDIT_PASSWORD, m_sPassword);
	DDX_Text(pDX, IDC_EDIT_PASSWORD2, m_sPassword2);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_BUTTON_MANAGEMENT, m_bmpbtnManagement );
	DDX_Control(pDX, IDOK, m_macOk);
	DDX_Control(pDX, IDC_BUTTON_CONFIRM, m_macConfirm);
	DDX_Control(pDX, IDC_BUTTON_CHANGE, m_macChange);
}


BEGIN_MESSAGE_MAP(CDlgPassword, CDialog)
	//{{AFX_MSG_MAP(CDlgPassword)
	ON_BN_CLICKED(IDC_BUTTON_CHANGE, OnChangePass)
	ON_BN_CLICKED(IDC_BUTTON_CONFIRM, OnConfirm)
	ON_LBN_SELCHANGE(IDC_LIST_ID, OnSelchangeListId)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgPassword message handlers

BOOL CDlgPassword::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_bmpbtnManagement.LoadBitmaps( IDB_BITMAP_LOGIN );

	m_lbUserID.AddString( "OPERATOR" );
	m_lbUserID.AddString( "MAINT" );
	m_lbUserID.AddString( "ENGINEER" );
	m_lbUserID.AddString( "ADMIN" );
	m_lbUserID.SetCurSel( m_pDicsData->m_LoginInfo.nCurUserLevel );
	m_lbUserID.GetText( m_pDicsData->m_LoginInfo.nCurUserLevel, m_sUserID );

	MAC_COLOR_SET color_set;
	m_macOk.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macOk.SetBold();

	m_macConfirm.SetColorSetting( color_set );
	m_macConfirm.SetBold();

	color_set.crFace = LIGHT_YELLOW_COLOR;
	m_macChange.SetColorSetting( color_set );
	m_macChange.SetBold();

	GetDlgItem( IDC_EDIT_PASSWORD2 )->EnableWindow( FALSE );
	GetDlgItem( IDC_STATIC_RE_INPUT )->EnableWindow( FALSE );
	GetDlgItem( IDC_BUTTON_CHANGE )->EnableWindow( FALSE );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgPassword::OnOK() 
{
	CDialog::OnOK();
}

void CDlgPassword::OnChangePass()
{
	UpdateData( TRUE );
	if( m_sPassword2 == m_sPassword )
		m_pDicsData->ChangePassword( m_sUserID, m_sPassword2 );
	else
	{
		AfxMessageBox( "Password is not equal with each other" );
		m_sPassword2 = "";
		m_sPassword = "";
		UpdateData( FALSE );
	}
}

void CDlgPassword::OnConfirm()
{
	UpdateData( TRUE );
	if( !m_pDicsData->Login( m_sUserID, m_sPassword ) )
	{
		m_bIdOk = FALSE;	// ljy_050414
		GetDlgItem( IDOK )->SetWindowText( "CANCEL" );
		AfxMessageBox( "The user name or password is incorrect", MB_ICONSTOP | MB_SYSTEMMODAL | MB_OK );
		return;
	}
	if( m_pDicsData->m_LoginInfo.nCurUserLevel == CDicsData::idENGINEER )
	{
		GetDlgItem( IDC_EDIT_PASSWORD2 )->EnableWindow( TRUE );
		GetDlgItem( IDC_STATIC_RE_INPUT )->EnableWindow( TRUE );
		GetDlgItem( IDC_BUTTON_CHANGE )->EnableWindow( TRUE );
		m_sPassword = "";
		m_sPassword2 = "";
		m_bIdOk = TRUE;		// ljy_050414
		UpdateData( FALSE );
	}
	if( m_pDicsData->m_LoginInfo.nCurUserLevel == CDicsData::idADMIN )
	{
		GetDlgItem( IDC_EDIT_PASSWORD2 )->EnableWindow( TRUE );
		GetDlgItem( IDC_STATIC_RE_INPUT )->EnableWindow( TRUE );
		GetDlgItem( IDC_BUTTON_CHANGE )->EnableWindow( TRUE );
		m_sPassword = "";
		m_sPassword2 = "";
		m_bIdOk = TRUE;		// ljy_050414
		UpdateData( FALSE );
	}
	GetDlgItem( IDOK )->SetWindowText( "OK" );
}

void CDlgPassword::OnSelchangeListId() 
{
	int nIndex = m_lbUserID.GetCurSel();
	m_lbUserID.GetText( nIndex, m_sUserID );
}
