// DlgPumpCln.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgPumpCln.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgPumpCln dialog


CDlgPumpCln::CDlgPumpCln(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgPumpCln::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgPumpCln)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgPumpCln::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgPumpCln)
	DDX_Control(pDX, IDC_PUMP1_ON, m_macPump1On);
	DDX_Control(pDX, IDC_PUMP1_OFF, m_macPump1Off);
	DDX_Control(pDX, IDC_PUMP1_NO_ALARM, m_macPump1NoAlarm);
	DDX_Control(pDX, IDC_PUMP1_ALARM, m_macPump1Alarm);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgPumpCln, CDialog)
	//{{AFX_MSG_MAP(CDlgPumpCln)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_PUMP1_ON, OnPump1On)
	ON_BN_CLICKED(IDC_PUMP1_OFF, OnPump1Off)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgPumpCln message handlers

BOOL CDlgPumpCln::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CString sTitle;
	SetTimer( TIMER_MANUAL, 500, NULL );
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	// Set the MAC button (Pump1)
	MAC_COLOR_SET color_set;
	m_macPump1On.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macPump1On.SetColorSetting( color_set );
	m_macPump1On.SetBold();

	m_macPump1Off.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_RED_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macPump1Off.SetColorSetting( color_set );
	m_macPump1Off.SetBold();

	m_macPump1NoAlarm.SetCheckColor( BLUE_COLOR );
	m_macPump1Alarm.SetCheckColor( RED_COLOR );

	// Set the state
	if( m_pTank->GetPumpOnState( 0 ) ) m_macPump1On.SetCheck( 1 );
	else m_macPump1Off.SetCheck( 1 );

	CRect r;
	GetWindowRect( &r );
//	MoveWindow( 200, 200, r.right - r.left, r.bottom - r.top );	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//---------------------------------------------------------------------------
// Moitoring
//---------------------------------------------------------------------------
void CDlgPumpCln::OnTimer(UINT nIDEvent) 
{
	// Alarm Message Monitoring (Pump1)

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( m_pTank->GetPumpAlarm() || !pView->m_pPumpSeq->m_SeqFlag.bDiTankLevel[0][CPumpSeq::lvL] )
	{
		m_pTank->SetPumpOn( 0 , OFF );
		m_macPump1On.SetCheck( 0 );
		m_macPump1Alarm.SetCheck( 1 );
		m_macPump1NoAlarm.SetCheck( 0 );
	}
	else
	{
		m_macPump1Alarm.SetCheck( 0 );
		m_macPump1NoAlarm.SetCheck( 1 );
	}
	
	CDialog::OnTimer(nIDEvent);
}

//---------------------------------------------------------------------------
// Strip1 Pump
//---------------------------------------------------------------------------
void CDlgPumpCln::OnPump1On() 
{
	// 100908 halesu
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if ( pView->m_pDicsData->m_GenInfo.bMjCdaReady[0] )
	{
		m_pTank->SetPumpOn( 0, ON );
	}
	else
	{
		AfxMessageBox( "MJ CDA Pressure must be over 20.0 kpa", MB_OK );	// 111123 halesu
	}
}
void CDlgPumpCln::OnPump1Off() 
{
	// Pump1 OFF
	m_pTank->SetPumpOn( 0, OFF );
}