// DlgRollBrush.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgRollBrush.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgRollBrush dialog


CDlgRollBrush::CDlgRollBrush(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgRollBrush::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgRollBrush)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_nRbType = 0;
}


void CDlgRollBrush::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgRollBrush)
//	DDX_Control(pDX, IDC_LIST_RB_TYPE, m_listRbType);
	DDX_Control(pDX, IDC_COMBO_RB_RPM, m_comboRbRpm);
	DDX_Control(pDX, IDC_RB_LO1, m_RadioRbType[0]);
	DDX_Control(pDX, IDC_RB_LO2, m_RadioRbType[1]);
	DDX_Control(pDX, IDC_RB_CW, m_RbCw);
	DDX_Control(pDX, IDC_RB_CCW, m_RbCcw);
	DDX_Control(pDX, IDC_RB_STOP, m_RbStop);
	DDX_Control(pDX, IDC_MOTOR_CP_DOWN, m_MotorCpDown);
	DDX_Control(pDX, IDC_MOTOR_ALARM, m_MotorAlarm);
//	DDX_Control(pDX, IDC_MOTOR_NO_ALARM, m_MotorNoAlarm);
//	DDX_Control(pDX, IDC_CYL_UP_O, m_CylUpO);
//	DDX_Control(pDX, IDC_CYL_DN_O, m_CylDnO);
//	DDX_Control(pDX, IDC_CYL_UP, m_CylUp);
//	DDX_Control(pDX, IDC_CYL_DN, m_CylDn);
	DDX_Control(pDX, IDC_ALL_STOP, m_AllStop);
	DDX_Control(pDX, IDC_ALL_CW, m_AllCw);
	DDX_Control(pDX, IDC_ALL_CCW, m_AllCcw);
//	DDX_Control(pDX, IDC_ALL_CYL_UP_O, m_Up);
//	DDX_Control(pDX, IDC_ALL_CYL_DN_O, m_Down);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgRollBrush, CDialog)
	//{{AFX_MSG_MAP(CDlgRollBrush)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_COMBO_RB_RPM, OnSelchangeComboRbRpm)
	ON_BN_CLICKED(IDC_RB_CW, OnRbCw)
	ON_BN_CLICKED(IDC_RB_CCW, OnRbCcw)
	ON_BN_CLICKED(IDC_RB_STOP, OnRbStop)
	ON_BN_CLICKED(IDC_ALL_STOP, OnAllStop)
	ON_BN_CLICKED(IDC_ALL_CW, OnAllCw)
	ON_BN_CLICKED(IDC_ALL_CCW, OnAllCcw)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE( IDC_RB_UP1, IDC_RB_LO2, OnSelChangeRadioRbType )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgRollBrush message handlers
BOOL CDlgRollBrush::OnInitDialog() 
{
	CDialog::OnInitDialog();

	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	MAC_COLOR_SET color;
	
	m_RbCw.GetColorSetting( &color );
	color.crFace = LIGHT_BLUE_COLOR;
	color.crLiteShadow = MAGENTA_COLOR;
	m_RbCw.SetColorSetting( color );
	m_RbCw.SetBold();
	m_AllCw.SetColorSetting( color );
	m_AllCw.SetBold();

	color.crFace = LIGHT_ORANGE_COLOR;
	color.crLiteShadow = MAGENTA_COLOR;
	m_RbCcw.SetColorSetting( color );
	m_RbCcw.SetBold();
	m_AllCcw.SetColorSetting( color );
	m_AllCcw.SetBold();

	color.crFace = LIGHT_RED_COLOR;
	color.crLiteShadow = MAGENTA_COLOR;
	m_RbStop.SetColorSetting( color );
	m_RbStop.SetBold();
	m_AllStop.SetColorSetting( color );
	m_AllStop.SetBold();

//	m_MotorNoAlarm.SetCheckColor( BLUE_COLOR );
	m_MotorAlarm.SetCheckColor( RED_COLOR );
	m_MotorCpDown.SetCheckColor( RED_COLOR );

//	// Set the robot type
//	CString sRbtName[] = 
//	{ 
//		"R/B1 Unit Upper R/B1", "R/B1 Unit Lower R/B1",
//		"R/B1 Unit Upper R/B2", "R/B1 Unit Lower R/B2",
//		"R/B2 Unit Upper R/B1", "R/B2 Unit Lower R/B1",
//		"R/B2 Unit Upper R/B2", "R/B2 Unit Lower R/B2",
//	};
//	for( int i=0; i<MAX_RB_NO; i++ ) m_listRbType.AddString( sRbtName[i] );
//	m_listRbType.SetCurSel( 0 );

	m_RadioRbType[0].SetCheck( 1 );
	
	for(int i=0; i<=25; i++ ) 
	{
		CString sSpeed;
		sSpeed.Format( "%d", 100 + (20 * i) );
		m_comboRbRpm.AddString( sSpeed );
	}
	m_comboRbRpm.SetCurSel( 15 );

	SetTimer( TIMER_MANUAL, 500, NULL );

	for( int i=0; i<m_pEqpAssy->m_RbMotor.GetMaxSectionNo(); i++ )
	{
		BOOL nDirFw = m_pEqpAssy->m_RbMotor.GetMotorFwState( i );
		BOOL nDirBw = m_pEqpAssy->m_RbMotor.GetMotorBwState( i );
		if( nDirFw ) m_nDirection[i] = 1;
		else if( nDirBw ) m_nDirection[i] = -1;
		else m_nDirection[i] = 0;
	}

	CRect r;
	GetWindowRect( &r );
	MoveWindow( 300, 300, r.right - r.left, r.bottom - r.top );	

	SetButtonState();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgRollBrush::OnDestroy() 
{
	CDialog::OnDestroy();
	
	KillTimer( TIMER_MANUAL );
}

void CDlgRollBrush::OnTimer(UINT nIDEvent) 
{
	// R/B FBL Motor alarm monitoring
	if( m_pEqpAssy->m_RbMotor.GetMotorAlarm( m_nRbType ) ) 
	{
		m_MotorAlarm.SetCheck( 1 );
		m_pRbSeq->m_RbMotor.nRefRbVelocity[m_nRbType] = 0;
		m_RbStop.SetCheck( 1 );
		m_RbCw.SetCheck( 0 );
		m_RbCcw.SetCheck( 0 );
	}
	else
	{
		m_MotorAlarm.SetCheck( 0 );
	}

	// R/B FBL Motor C/P monitoring
	if( m_pEqpAssy->m_RbMotor.GetMotorCpAlarm( m_nRbType ) ) 
	{
		m_MotorCpDown.SetCheck( 1 );
		m_pRbSeq->m_RbMotor.nRefRbVelocity[m_nRbType] = 0;
		m_RbStop.SetCheck( 1 );
		m_RbCw.SetCheck( 0 );
		m_RbCcw.SetCheck( 0 );
	}
	else
	{
		m_MotorCpDown.SetCheck( 0 );
	}

	CDialog::OnTimer(nIDEvent);
}

//--------------------------------------------------------------------
// get the roll brush RPM
//--------------------------------------------------------------------
void CDlgRollBrush::OnSelchangeComboRbRpm() 
{
	int nSel = m_comboRbRpm.GetCurSel();
	if( nSel == CB_ERR ) return;

	CString sRpm;
	m_comboRbRpm.GetLBText( nSel, sRpm );

	for( int i=0; i<m_pEqpAssy->m_RbMotor.GetMaxSectionNo(); i++ )
	{
		BOOL nDirFw = m_pEqpAssy->m_RbMotor.GetMotorFwState( i );
		BOOL nDirBw = m_pEqpAssy->m_RbMotor.GetMotorBwState( i );
		if( m_RadioRbType[i].GetCheck() )
		{
			if( !nDirFw && !nDirBw )
				return;	// Before Turn current motor, if the value in ComboBox, 
						// the Motor will not turn but will turn after click CW or CCW Button
		}
	}

	double dfRpm = atof( sRpm );

	if( m_pRbSeq->m_RbMotor.nRefRbVelocity[m_nRbType] > 0 )
		m_pRbSeq->m_RbMotor.nRefRbVelocity[m_nRbType] = (int) dfRpm;
	else 
		m_pRbSeq->m_RbMotor.nRefRbVelocity[m_nRbType] = (int) ( dfRpm * -1 );
}

//--------------------------------------------------------------------
// Roll Brush Upper CW
//--------------------------------------------------------------------
void CDlgRollBrush::OnRbCw() 
{
//	GetDlgItem( IDC_RB_CCW )->EnableWindow( FALSE );
	int nSel = m_comboRbRpm.GetCurSel();
	if( nSel == CB_ERR ) return;
	CString sRpm;
	m_comboRbRpm.GetLBText( nSel, sRpm );

	double dfRpm = atof( sRpm );
	m_pRbSeq->m_RbMotor.nRefRbVelocity[m_nRbType] = (int) dfRpm;
	m_nDirection[m_nRbType] = 1;

	SetButtonState();
}

//--------------------------------------------------------------------
// Roll Brush Upper CCW
//--------------------------------------------------------------------
void CDlgRollBrush::OnRbCcw() 
{
//	GetDlgItem( IDC_RB_CW )->EnableWindow( FALSE );

	int nSel = m_comboRbRpm.GetCurSel();
	if( nSel == CB_ERR ) return;
	CString sRpm;
	m_comboRbRpm.GetLBText( nSel, sRpm );

	double dfRpm = atof( sRpm );	
	m_pRbSeq->m_RbMotor.nRefRbVelocity[m_nRbType] = (int) dfRpm * -1;

	m_nDirection[m_nRbType] = -1;
	
	SetButtonState();
}

//--------------------------------------------------------------------
// All Roll Brush CW
//--------------------------------------------------------------------
void CDlgRollBrush::OnAllCw() 
{
//	GetDlgItem( IDC_RB_CCW )->EnableWindow( FALSE );
	int nSel = m_comboRbRpm.GetCurSel();
	if( nSel == CB_ERR ) return;
	CString sRpm;
	m_comboRbRpm.GetLBText( nSel, sRpm );

	double dfRpm = atof( sRpm );

	for( int i=0; i<MAX_RB_NO; i++ )
	{
		m_nDirection[i] = 1;	 
		m_pRbSeq->m_RbMotor.nRefRbVelocity[i] = (int)dfRpm;
	}

	SetButtonState();
}

//--------------------------------------------------------------------
// All Roll Brush CCW
//--------------------------------------------------------------------
void CDlgRollBrush::OnAllCcw() 
{
//	GetDlgItem( IDC_RB_CW )->EnableWindow( FALSE );

	int nSel = m_comboRbRpm.GetCurSel();
	if( nSel == CB_ERR ) return;
	CString sRpm;
	m_comboRbRpm.GetLBText( nSel, sRpm );

	double dfRpm = atof( sRpm );	

	for( int i=0; i<m_pEqpAssy->m_RbMotor.GetMaxSectionNo(); i++ )
	{
		m_nDirection[i] = -1;
		m_pRbSeq->m_RbMotor.nRefRbVelocity[i] = (int)dfRpm * -1;
	}
	SetButtonState();
}

//--------------------------------------------------------------------
// Roll Brush Upper STOP
//--------------------------------------------------------------------
void CDlgRollBrush::OnRbStop() 
{
//	GetDlgItem( IDC_RB_CW )->EnableWindow( TRUE );
//	GetDlgItem( IDC_RB_CCW )->EnableWindow( TRUE );
//
//	dogRB_MOTOR_CW( m_nRbType, OFF );
//	dogRB_MOTOR_CCW( m_nRbType, OFF );

	m_pRbSeq->m_RbMotor.nRefRbVelocity[m_nRbType] = 0;

	m_nDirection[m_nRbType] = 0;
	SetButtonState();
}

//--------------------------------------------------------------------
// Sel change R/B type
//--------------------------------------------------------------------
void CDlgRollBrush::OnSelchangeListRbType() 
{
//	m_nRbType = m_listRbType.GetCurSel();
//
//	for( int i=0; i<MAX_RB_NO; i ++ )
//		((CButton *)GetDlgItem( IDC_RADIO_RB1 + i ))->SetCheck( 0 );
//	((CButton *)GetDlgItem( IDC_RADIO_RB1 + m_nRbType ))->SetCheck( 1 );
//
//	if( dogRB_MOTOR_CW( m_nRbType ) ) 
//	{
//		m_RbStop.SetCheck( 0 );
//		m_RbCw.SetCheck( 1 );
//		m_RbCcw.SetCheck( 0 );
//	}
//	else if( dogRB_MOTOR_CCW( m_nRbType ) ) 
//	{
//		m_RbStop.SetCheck( 0 );
//		m_RbCw.SetCheck( 0 );
//		m_RbCcw.SetCheck( 1 );
//	}
//	else
//	{
//		m_RbStop.SetCheck( 1 );
//		m_RbCw.SetCheck( 0 );
//		m_RbCcw.SetCheck( 0 );
//	}
//
//	SetButtonState();
}

//--------------------------------------------------------------------
// Sel change R/B type
//--------------------------------------------------------------------
void CDlgRollBrush::OnSelChangeRadioRbType( UINT nID ) 
{
	for( int i=0; i<m_pEqpAssy->m_RbMotor.GetMaxSectionNo(); i++ )
	{
		if( m_RadioRbType[i].GetCheck() )
		{
			m_nRbType = i;
		}
	}
	SetButtonState();
}

//--------------------------------------------------------------------
// All Stop the roll brush
//--------------------------------------------------------------------
void CDlgRollBrush::OnAllStop() 
{
//	GetDlgItem( IDC_RB_CW )->EnableWindow( TRUE );
//	GetDlgItem( IDC_RB_CCW )->EnableWindow( TRUE );

	m_RbStop.SetCheck( 1 );
	m_AllStop.SetCheck( 0 );
	m_RbCw.SetCheck( 0 );
	m_RbCcw.SetCheck( 0 );

	for( int i=0; i<m_pEqpAssy->m_RbMotor.GetMaxSectionNo(); i++ )
	{
		m_pRbSeq->m_RbMotor.nRefRbVelocity[i] = 0;
		m_nDirection[i] = 0;
	}
}

void CDlgRollBrush::SetButtonState()
{
	m_AllCw.SetCheck( 0 );
	m_AllCcw.SetCheck( 0 );
	m_AllStop.SetCheck( 0 );
	
	if( m_nDirection[m_nRbType] == -1 )
	{
		m_RbStop.SetCheck( 0 );
		m_RbCw.SetCheck( 0 );
		m_RbCcw.SetCheck( 1 );
	}
	else if( m_nDirection[m_nRbType] == 1 )
	{
		m_RbStop.SetCheck( 0 );
		m_RbCw.SetCheck( 1 );
		m_RbCcw.SetCheck( 0 );
	}
	else
	{
		m_RbStop.SetCheck( 1 );
		m_RbCw.SetCheck( 0 );
		m_RbCcw.SetCheck( 0 );
	}
}
