// DlgSemiAutoTrToSs.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgSemiAutoTrToSs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgSemiAutoTrToSs dialog


CDlgSemiAutoTrToSs::CDlgSemiAutoTrToSs(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSemiAutoTrToSs::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSemiAutoTrToSs)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CString CDlgSemiAutoTrToSs::m_sIFstateSignalName[] =
{
	"Cleaner Load Request",
	"Cleaner Unload Request",
	"Cleaner Access Possible",
	"Substrate Present at Cleaner",
	"Cleaner is Available"
};


void CDlgSemiAutoTrToSs::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSemiAutoTrToSs)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_IFDO_LED01, m_ledIFstate[0]);
	DDX_Control(pDX, IDC_IFDO_LED02, m_ledIFstate[1]);
	DDX_Control(pDX, IDC_IFDO_LED03, m_ledIFstate[2]);
	DDX_Control(pDX, IDC_IFDO_LED04, m_ledIFstate[3]);
	DDX_Control(pDX, IDC_IFDO_LED05, m_ledIFstate[4]);
	DDX_Control(pDX, IDC_BTN_IFDO01_ON, m_macIFstateON[0]);
	DDX_Control(pDX, IDC_BTN_IFDO01_OFF, m_macIFstateOFF[0]);
	DDX_Control(pDX, IDC_BTN_IFDO02_ON, m_macIFstateON[1]);
	DDX_Control(pDX, IDC_BTN_IFDO02_OFF, m_macIFstateOFF[1]);
	DDX_Control(pDX, IDC_BTN_IFDO03_ON, m_macIFstateON[2]);
	DDX_Control(pDX, IDC_BTN_IFDO03_OFF, m_macIFstateOFF[2]);
	DDX_Control(pDX, IDC_BTN_IFDO04_ON, m_macIFstateON[3]);
	DDX_Control(pDX, IDC_BTN_IFDO04_OFF, m_macIFstateOFF[3]);
	DDX_Control(pDX, IDC_BTN_IFDO05_ON, m_macIFstateON[4]);
	DDX_Control(pDX, IDC_BTN_IFDO05_OFF, m_macIFstateOFF[4]);
}


BEGIN_MESSAGE_MAP(CDlgSemiAutoTrToSs, CDialog)
	//{{AFX_MSG_MAP(CDlgSemiAutoTrToSs)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDC_BTN_IFDO01_ON, IDC_BTN_IFDO05_ON, OnIFstateOn)
	ON_COMMAND_RANGE(IDC_BTN_IFDO01_OFF, IDC_BTN_IFDO05_OFF, OnIFstateOff)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgSemiAutoTrToSs message handlers

BOOL CDlgSemiAutoTrToSs::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	SetTimer( TIMER_MANUAL, 500, NULL );

	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	// Set the MAC button	ljy_050118 : Use Mac BTN
	MAC_COLOR_SET color_set;

	int nIFnameResID[MAX_LOADER_IF_NO] =
	{
		IDC_STATIC_IFDO_NAME01,IDC_STATIC_IFDO_NAME02,IDC_STATIC_IFDO_NAME03,
		IDC_STATIC_IFDO_NAME04,IDC_STATIC_IFDO_NAME05,
	};

	for( int i = 0 ; i<MAX_LOADER_IF_NO ; i++ )
	{
		m_ledIFstate[i].SetLed( CLed::LED_COLOR_GREEN, CLed::LED_ON, CLed::LED_ROUND );
		GetDlgItem( nIFnameResID[i] )->SetWindowText( m_sIFstateSignalName[i] );

		m_macIFstateON[i].GetColorSetting( &color_set );
		color_set.crFace = LIGHT_ORANGE_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macIFstateON[i].SetColorSetting( color_set );
		m_macIFstateON[i].SetBold();

		m_macIFstateOFF[i].GetColorSetting( &color_set );
		color_set.crFace = LIGHT_CYAN_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macIFstateOFF[i].SetColorSetting( color_set );
		m_macIFstateOFF[i].SetBold();
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgSemiAutoTrToSs::MonitorInterface()
{
//	for( int i = 0 ; i<MAX_LOADER_IF_NO ; i++ )
//	{
//		if( mosbIF_LOADER_STATE( i ) ) m_ledIFstate[i].SetLed( CLed::LED_COLOR_GREEN, CLed::LED_ON, CLed::LED_ROUND );
//		else m_ledIFstate[i].SetLed( CLed::LED_COLOR_GREEN, CLed::LED_OFF, CLed::LED_ROUND );
//	}

}

void CDlgSemiAutoTrToSs::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	MonitorInterface();	
	CDialog::OnTimer(nIDEvent);
}

void CDlgSemiAutoTrToSs::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	KillTimer( TIMER_MANUAL );
	
}

void CDlgSemiAutoTrToSs::OnIFstateOn(UINT nID)
{
//	int nBTN = nID - IDC_BTN_IFDO01_ON;
//
//	if( !mosbIF_LOADER_STATE( nBTN ) )
//	{
//		mogbIF_LOADER_STATE( nBTN, ON );
//	}
//	else return;
}

void CDlgSemiAutoTrToSs::OnIFstateOff(UINT nID)
{
//	int nBTN = nID - IDC_BTN_IFDO01_OFF;
//
//	if( mosbIF_LOADER_STATE( nBTN ) )
//	{
//		mogbIF_LOADER_STATE( nBTN, OFF );
//	}
//	else return;
}

// ljy_050220 : CDlgSemiAutoTrToSs -> 04HC30   Ϸ(1).
