// DlgServoHelp.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DlgServoHelp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgServoHelp dialog
CString	CDlgServoHelp::m_sUnitName[] = 
{
//	"TR UNIT",
	"SWR2 UPPER RB1 UNIT",
	"SWR2 LOWER RB1 UNIT",
	"SWR2 UPPER RB2 UNIT",
	"SWR2 LOWER RB2 UNIT",
	"SWR3 UPPER RB1 UNIT",
	"SWR3 LOWER RB1 UNIT",
	"SWR3 UPPER RB2 UNIT",
	"SWR3 LOWER RB2 UNIT",
#ifndef _NO_UL_HAND
	"UL UPDN UNIT",
#endif
};


CDlgServoHelp::CDlgServoHelp(CPoint pt, CWnd* pParent /*=NULL*/)
	: CAniDialog(pt, CDlgServoHelp::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgServoHelp)
	m_sHelp = _T("");
	//}}AFX_DATA_INIT
	m_pntStart = pt;
	m_bMovePossible = FALSE;
}


void CDlgServoHelp::DoDataExchange(CDataExchange* pDX)
{
	CAniDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgServoHelp)
	DDX_Control(pDX, IDC_EDIT_HELP, m_editHelp);
	DDX_Text(pDX, IDC_EDIT_HELP, m_sHelp);
	DDX_Control(pDX, IDC_OCX_SERVO_POINT, m_ocxHandPosition);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgServoHelp, CAniDialog)
	//{{AFX_MSG_MAP(CDlgServoHelp)
	ON_WM_LBUTTONDOWN()
	ON_WM_CTLCOLOR()
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgServoHelp message handlers

void CDlgServoHelp::CloseDialog()
{
	// set animation styles
	SetAniStyles(AS_TOPLEFT, AS_TOPLEFT);
	// poof
	OnOK();
}


void CDlgServoHelp::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	//CloseDialog();
	
	CAniDialog::OnLButtonDown(nFlags, point);
}

BOOL CDlgServoHelp::OnInitDialog() 
{
	CAniDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CRect r;
	GetWindowRect( &r );
	MoveWindow( m_pntStart.x, m_pntStart.y, r.right - r.left, r.bottom - r.top );

//	m_stcFrame.SubclassDlgItem( IDC_STATIC_FRAME, this );
//	m_stcFrame.SetTextColor( BLACK_COLOR );
//	m_stcFrame.SetBkColor( WHITE_COLOR );

	if( m_bMovePossible )
		m_hbrBkColor = CreateSolidBrush( LIGHT_GREEN_COLOR );
	else
		m_hbrBkColor = CreateSolidBrush( LIGHT_RED_COLOR );

	m_hbrWhite = CreateSolidBrush( WHITE_COLOR );

	GetHelpFile( "MMC\\Help_Servo.txt" );

	if( m_nHandType == -1 )
	{
		GetDlgItem( IDC_OCX_SERVO_POINT )->ShowWindow( FALSE );
		GetDlgItem( IDC_STATIC_CUR_POS_BMP )->ShowWindow( FALSE );
		GetDlgItem( IDC_STATIC_TAR_POS_BMP1 )->ShowWindow( FALSE );
		GetDlgItem( IDC_STATIC_TAR_POS_BMP2 )->ShowWindow( FALSE );
		GetDlgItem( IDC_STATIC_CUR_POS )->ShowWindow( FALSE );
		GetDlgItem( IDC_STATIC_TAR_POS1 )->ShowWindow( FALSE );
		GetDlgItem( IDC_STATIC_TAR_POS2 )->ShowWindow( FALSE );
		MoveWindow( m_pntStart.x, m_pntStart.y, r.right - r.left - 240, r.bottom - r.top - 85 );
	}
	else
	{
		////////////////////////////////////////////////////////////////////////////////////////
		// void SetUnitType (short nPos, short nUnit)
		//			short nPos : T.P  ʿ ִ Hand ʿ ִ Hand ġ 
		//			short nUnit : LD Hand UL Hand 
		///////////////////////////////////////////////////////////////////////////////////////
		m_ocxHandPosition.SetUnitType( m_nUnitPosition, m_nUnitType );

		////////////////////////////////////////////////////////////////////////////////////////
		// void SetPoint (short nRbt, short nCurPos, short nTargetPos, short nPossible)
		//			short nRbt : Lower Hand or Upper Hand ??
		//			short nCurPos : Current Position Number.
		//			short nTargetPos : Tartet Position(Selected Position) Number
		//			short nPossible : Move Possible?? (from Current Position to Target Position)
		///////////////////////////////////////////////////////////////////////////////////////
		m_ocxHandPosition.SetPoint( m_nHandType, m_nCurPos, m_nPointNo, m_bMovePossible );
		MoveWindow( m_pntStart.x, m_pntStart.y, r.right - r.left, r.bottom - r.top );
	}

	SetText();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CDlgServoHelp::GetHelpFile(LPCTSTR lpszFileName)
{
	FILE* pFileHelp;
	CString sData;

	if( ( pFileHelp = fopen( lpszFileName, "rt" ) ) == NULL ) 
	{
		AfxMessageBox( "Help file is not loaded" );
		return FALSE;
	}
	
	while( !feof( pFileHelp ) )
	{
		char szLine[1000];

		// Read one line
		CString sData;
		fgets( szLine, 1000, pFileHelp );
		sData.Format("%s", szLine );
		//m_nLineNo += 1;

		// Parse the first token
		char szSeps[] = "\t\n";
		char* ptoken;
		CString sToken;

		ptoken = strtok( szLine, szSeps );
		sToken.Format( "%s", ptoken );

		if( !sToken.Compare( "[RBT]" ) )
		{
			ptoken = strtok( NULL, szSeps );
			m_sRbtName.Format( "%s", ptoken );
			if( m_sRbtName == m_sUnitName[m_nRbtType] )
			{
				fgets( szLine, 1000, pFileHelp );
				sData.Format("%s", szLine );
				ptoken = strtok( szLine, szSeps );
				sToken.Format( "%s", ptoken );
				if( !sToken.Compare( "[POS]" ) )
				{
					ptoken = strtok( NULL, szSeps );
					m_sPosName.Format( "%s", ptoken );
					if( m_sPosName == m_pMmc->m_sRbtPosName[m_nRbtType][m_nPointNo] )
					{
						fgets( szLine, 1000, pFileHelp );
						sData.Format("%s", szLine );
						ptoken = strtok( szLine, szSeps );
						sToken.Format( "%s", ptoken );
						if( !sToken.Compare( "[TXT]" ) )
						{
							ptoken = strtok( NULL, szSeps );
							m_sHelpText.Format( "%s", ptoken );
							sData.ReleaseBuffer();
							fclose( pFileHelp );
							return TRUE;
						}
					}
				}
			}
		}
		
		sData.ReleaseBuffer();
	} 

	fclose( pFileHelp ); 

	return TRUE;
}

HBRUSH CDlgServoHelp::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CAniDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	UINT id = pWnd->GetDlgCtrlID();
	switch( nCtlColor )
	{
		case CTLCOLOR_STATIC:
			if( id == IDC_EDIT_HELP )
			{
				hbr = m_hbrBkColor;
				pDC->SetBkMode( TRANSPARENT );
				pDC->SetTextColor( BLACK_COLOR );
			}
			else if( id == IDC_STATIC_CUR_POS || 
					 id == IDC_STATIC_TAR_POS1 ||
					 id == IDC_STATIC_TAR_POS2 )
			{
				hbr = m_hbrWhite;
				pDC->SetBkMode( TRANSPARENT );
				pDC->SetTextColor( BLACK_COLOR );
			}
			break;
	}
		
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CDlgServoHelp::OnClose() 
{
	// TODO: Add your message handler code here and/or call default

	CAniDialog::OnClose();
}

void CDlgServoHelp::OnDestroy() 
{
	CAniDialog::OnDestroy();
	
	DeleteObject( m_hbrBkColor );
	DeleteObject( m_hbrWhite );
	// TODO: Add your message handler code here
}

void CDlgServoHelp::SetText()
{
	if( m_bMovePossible )
	{
		m_sHelp.Format( "Robot Name : %s \r\nPoint Name : %s \r\n\r\n %s \r\n\r\n MOVE POSSIBLE", m_sRbtName, m_sPosName, m_sHelpText );
	}
	else
	{
		m_sHelp.Format( "Robot Name : %s \r\nPoint Name : %s \r\n\r\n %s \r\n\r\n MOVE IMPOSSIBLE", m_sRbtName, m_sPosName, m_sHelpText );
	}

	UpdateData( FALSE );
}

void CDlgServoHelp::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CloseDialog();
	
	CAniDialog::OnLButtonUp(nFlags, point);
}
