// DlgTestRunSet.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DlgTestRunSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgTestRunSet dialog


CDlgTestRunSet::CDlgTestRunSet(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgTestRunSet::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgTestRunSet)
	m_nTestCount = 0;
	m_sRecipeId = _T("");
	//}}AFX_DATA_INIT
}


void CDlgTestRunSet::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgTestRunSet)
	DDX_Control(pDX, IDC_CBO_RECIPE_SEL, m_cboRecipeSelect);
	DDX_Text(pDX, IDC_TEST_COUNT, m_nTestCount);
	DDX_CBString(pDX, IDC_CBO_RECIPE_SEL, m_sRecipeId);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_SEL_PORT1, m_macPortSelect[0]);
	DDX_Control(pDX, IDC_SEL_PORT2, m_macPortSelect[1]);
	DDX_Control(pDX, IDC_SEL_PORT3, m_macPortSelect[2]);
}


BEGIN_MESSAGE_MAP(CDlgTestRunSet, CDialog)
	//{{AFX_MSG_MAP(CDlgTestRunSet)
	ON_EN_CHANGE(IDC_TEST_COUNT, OnChangeTestCount)
	ON_BN_CLICKED(IDC_SEL_PORT1, OnSelPort1)
	ON_BN_CLICKED(IDC_SEL_PORT2, OnSelPort2)
	ON_BN_CLICKED(IDC_SEL_PORT3, OnSelPort3)
	ON_CBN_SELCHANGE(IDC_CBO_RECIPE_SEL, OnSelchangeCboRecipeSel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgTestRunSet message handlers

BOOL CDlgTestRunSet::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	for( int i = 0 ; i < MAX_PORT_NO ; i++ )
	{
		m_macPortSelect[i].SetBold();
		m_macPortSelect[i].SetCheckColor( BLUE_COLOR );
		m_macPortSelect[i].SetCheck( m_bPortEnable[i] );

		GetDlgItem( IDC_SEL_PORT1 + i )->EnableWindow( m_bPortEnable[i] );
	}

	CDicsDoc* pDoc = m_pView->GetDocument();
	for( int nRow=0; nRow<pDoc->m_nMaxRow; nRow++ )
	{
		m_cboRecipeSelect.AddString( pDoc->m_pRecipeInfo[nRow].sValue[0] );
	}

	m_cboRecipeSelect.SetCurSel( 0 );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgTestRunSet::OnChangeTestCount() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData( TRUE );
}

int CDlgTestRunSet::DoModal() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::DoModal();
}

void CDlgTestRunSet::OnSelPort1() 
{
	// TODO: Add your control notification handler code here
	if( m_macPortSelect[0].GetCheck() )
	{
		m_macPortSelect[0].SetCheck( FALSE );
	}
	else if( !m_macPortSelect[0].GetCheck() )
	{
		m_macPortSelect[0].SetCheck( TRUE );
	}
}

void CDlgTestRunSet::OnSelPort2() 
{
	// TODO: Add your control notification handler code here
	if( m_macPortSelect[1].GetCheck() )
	{
		m_macPortSelect[1].SetCheck( FALSE );
	}
	else if( !m_macPortSelect[1].GetCheck() )
	{
		m_macPortSelect[1].SetCheck( TRUE );
	}
}

void CDlgTestRunSet::OnSelPort3() 
{
	// TODO: Add your control notification handler code here
	if( m_macPortSelect[2].GetCheck() )
	{
		m_macPortSelect[2].SetCheck( FALSE );
	}
	else if( !m_macPortSelect[2].GetCheck() )
	{
		m_macPortSelect[2].SetCheck( TRUE );
	}
}

void CDlgTestRunSet::SetView(CDicsView *pView)
{
	m_pView = pView;
}

void CDlgTestRunSet::OnSelchangeCboRecipeSel() 
{
	// TODO: Add your control notification handler code here
	UpdateData( TRUE );
}
