// DlgTilt.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DlgTilt.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgTilt dialog


CDlgTilt::CDlgTilt(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgTilt::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgTilt)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_sTiltCylTitle[0] = "LD Unit Tilt Cylinder";
	m_sTiltCylTitle[1] = "UL Unit Tilt Cylinder";
}


void CDlgTilt::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgTilt)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_RADIO_UP, m_macTiltCylinderUp );
	DDX_Control(pDX, IDC_RADIO_DN, m_macTiltCylinderDn );
	DDX_Control(pDX, IDC_LD_TILT_CYL, m_ocxTiltCylinder[0] );
	DDX_Control(pDX, IDC_UL_TILT_CYL, m_ocxTiltCylinder[1] );
}


BEGIN_MESSAGE_MAP(CDlgTilt, CDialog)
	//{{AFX_MSG_MAP(CDlgTilt)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_RADIO_UP, OnRadioUp)
	ON_BN_CLICKED(IDC_RADIO_DN, OnRadioDn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgTilt message handlers
BOOL CDlgTilt::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_nOldTiltCylinderState[0] = 0;
	m_nOldTiltCylinderState[1] = 0;
	// Set button
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	CString sTitle;

	// ljy_041104 : AUO User Request
	sTitle.Format( "Valve : %s", m_sTiltCylTitle[m_nCurCylNo] );
	SetWindowText( sTitle );

	MAC_COLOR_SET color_set;
	m_macTiltCylinderUp.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macTiltCylinderUp.SetColorSetting( color_set );
	m_macTiltCylinderUp.SetBold();

	m_macTiltCylinderDn.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macTiltCylinderDn.SetColorSetting( color_set );
	m_macTiltCylinderDn.SetBold();
	
	// TODO: Add extra initialization here
	SetTimer( TIMER_MANUAL, 100, NULL );
		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgTilt::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	IsTiltCylinderStatus();

	CDialog::OnTimer(nIDEvent);
}

void CDlgTilt::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	
}

void CDlgTilt::OnRadioUp() 
{

	BOOL bUlHandSendSensorStatus = m_pEqpAssy->m_PosSensorUlHand.GetAnd( UL_HAND_UNIT_SEND_POS );	// 101119 halesu

	if( m_nCurCylNo == 0 )
	{
		if( m_pEqpAssy->m_PosSensorLdUnit.GetAnd( LD_UPDN_UNIT_RECV_POS ) ) // 2009.01.16 minhan
		{
            AfxMessageBox( "LD C/V Position Status Error" );
			return;
		}
		m_pEqpAssy->m_CylinderLdTilt.SetFw();
	}
	else
	{
		if( !m_pEqpAssy->m_CylinderUlHand.GetBw() && !bUlHandSendSensorStatus )	// 101119 halesu
		{
			AfxMessageBox( "UL Hand Cylinder Status Error" );
			return;
		}
		m_pEqpAssy->m_CylinderUlTilt.SetFw();
	}
}

void CDlgTilt::OnRadioDn() 
{
	if( m_nCurCylNo == 0 )
	{
		if( m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) )
		{
			AfxMessageBox( "LD C/V Status Error" );
			return;
		}
		m_pEqpAssy->m_CylinderLdTilt.SetBw();
	}
	else if( m_nCurCylNo == 1 )
	{
		if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_UL ) && m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_UL ) )
		{
			AfxMessageBox( "UL C/V Status Error" );
			return;
		}
		m_pEqpAssy->m_CylinderUlTilt.SetBw();
	}
}

void CDlgTilt::IsTiltCylinderStatus()
{
	// TODO: Add your control notification handler code here

#ifndef _MY_DEBUG
	if( ( m_nOldTiltCylinderState[0] != 1 ) && m_pEqpAssy->m_CylinderLdTilt.GetFw() )
#else
	if( ( m_nOldTiltCylinderState[0] != 1 ) && m_pEqpAssy->m_CylinderLdTilt.GetFwState() )
#endif
	{
		m_nOldTiltCylinderState[0] = 1;
		m_ocxTiltCylinder[0].SetFw();
	}
#ifndef _MY_DEBUG
	else if( ( m_nOldTiltCylinderState[0] != 2 ) && m_pEqpAssy->m_CylinderLdTilt.GetBw() )
#else
	else if( ( m_nOldTiltCylinderState[0] != 2 ) && m_pEqpAssy->m_CylinderLdTilt.GetBwState() )
#endif
	{
		m_nOldTiltCylinderState[0] = 2;
		m_ocxTiltCylinder[0].SetBw();
	}
#ifndef _MY_DEBUG
	else if( m_nOldTiltCylinderState[0] != 3 && 
			( !m_pEqpAssy->m_CylinderLdTilt.GetFw() && !m_pEqpAssy->m_CylinderLdTilt.GetBw() ) )
#else
	else if( m_nOldTiltCylinderState[0] != 3 && 
			( !m_pEqpAssy->m_CylinderLdTilt.GetFwState() && !m_pEqpAssy->m_CylinderLdTilt.GetBwState() ) )
#endif
	{
		m_nOldTiltCylinderState[0] = 3;
		m_ocxTiltCylinder[0].SetNone();
	}

#ifndef _MY_DEBUG
	if( ( m_nOldTiltCylinderState[1] != 1 ) && m_pEqpAssy->m_CylinderUlTilt.GetFw() )
#else
	if( ( m_nOldTiltCylinderState[1] != 1 ) && m_pEqpAssy->m_CylinderUlTilt.GetFwState() )
#endif
	{
		m_nOldTiltCylinderState[1] = 1;
		m_ocxTiltCylinder[1].SetFw();
	}
#ifndef _MY_DEBUG
	else if( ( m_nOldTiltCylinderState[1] != 2 ) && m_pEqpAssy->m_CylinderUlTilt.GetBw() )
#else
	else if( ( m_nOldTiltCylinderState[1] != 2 ) && m_pEqpAssy->m_CylinderUlTilt.GetBwState() )
#endif
	{
		m_nOldTiltCylinderState[1] = 2;
		m_ocxTiltCylinder[1].SetBw();
	}
#ifndef _MY_DEBUG
	else if( m_nOldTiltCylinderState[1] != 3 && 
			( !m_pEqpAssy->m_CylinderUlTilt.GetFw() && !m_pEqpAssy->m_CylinderUlTilt.GetBw() ) )
#else
	else if( m_nOldTiltCylinderState[1] != 3 && 
			( !m_pEqpAssy->m_CylinderUlTilt.GetFwState() && !m_pEqpAssy->m_CylinderUlTilt.GetBwState() ) )
#endif
	{
		m_nOldTiltCylinderState[1] = 3;
		m_ocxTiltCylinder[1].SetNone();
	}
}
