// DlgTrTurn.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DlgTrTurn.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgTrTurn dialog


CDlgTrTurn::CDlgTrTurn(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgTrTurn::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgTrTurn)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgTrTurn::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgTrTurn)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control( pDX, IDC_CHECK_PROCESS, m_macTurnProcessSensor );
	DDX_Control( pDX, IDC_CHECK_EXCHANGE, m_macTurnExchangeSensor );
	DDX_Control( pDX, IDC_CHECK_ALIGN_FW1, m_macAlignFw1 );
	DDX_Control( pDX, IDC_CHECK_ALIGN_FW2, m_macAlignFw2 );
	DDX_Control( pDX, IDC_CHECK_ALIGN_BW1, m_macAlignBw1 );
	DDX_Control( pDX, IDC_CHECK_ALIGN_BW2, m_macAlignBw2 );
	DDX_Control( pDX, IDC_CHECK_EXCHANGE, m_macTurnExchangeSensor );
	DDX_Control( pDX, IDC_RADIO_PROCESS, m_macTurnProcess );
	DDX_Control( pDX, IDC_RADIO_EXCHANGE, m_macTurnExchange );
	DDX_Control( pDX, IDC_RADIO_ALIGN_FW, m_macAlignFw );
	DDX_Control( pDX, IDC_RADIO_ALIGN_BW, m_macAlignBw );
}


BEGIN_MESSAGE_MAP(CDlgTrTurn, CDialog)
	//{{AFX_MSG_MAP(CDlgTrTurn)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_RADIO_EXCHANGE, OnRadioExchange)
	ON_BN_CLICKED(IDC_RADIO_PROCESS, OnRadioProcess)
	ON_BN_CLICKED(IDC_RADIO_ALIGN_FW, OnRadioAlignFw)
	ON_BN_CLICKED(IDC_RADIO_ALIGN_BW, OnRadioAlignBw)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgTrTurn message handlers

BOOL CDlgTrTurn::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Set button
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );
	// TODO: Add extra initialization here

	SetTimer( TIMER_MANUAL, 100, NULL );
	
	MAC_COLOR_SET color_set;
	m_macTurnProcess.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macTurnProcess.SetColorSetting( color_set );
	m_macTurnProcess.SetBold();
	m_macAlignBw.SetColorSetting( color_set );
	m_macAlignBw.SetBold();
	color_set.crFace = LIGHT_RED_COLOR;
	m_macTurnExchange.SetColorSetting( color_set );
	m_macTurnExchange.SetBold();
	m_macAlignFw.SetColorSetting( color_set );
	m_macAlignFw.SetBold();
	m_macTurnExchange.SetBold();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgTrTurn::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	UpdateSensorStatus();
	CDialog::OnTimer(nIDEvent);
}


void CDlgTrTurn::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	KillTimer( TIMER_MANUAL );
	CDialog::OnClose();
}

void CDlgTrTurn::OnRadioExchange() 
{
	// TODO: Add your control notification handler code here
	m_pEqpAssy->m_CylinderTrTurn->SetBw();

	m_macTurnProcess.SetCheck( 0 );
	m_macTurnExchange.SetCheck( 1 );
}

void CDlgTrTurn::OnRadioProcess() 
{
	m_pEqpAssy->m_CylinderTrTurn->SetFw();
	m_macTurnProcess.SetCheck( 1 );
	m_macTurnExchange.SetCheck( 0 );
}

void CDlgTrTurn::UpdateSensorStatus()
{
	if( m_pEqpAssy->m_CylinderTrTurn->GetFw() ) m_macTurnProcessSensor.SetCheck( 1 );
	else m_macTurnProcessSensor.SetCheck( 0 );

	if( m_pEqpAssy->m_CylinderTrTurn->GetBw() ) m_macTurnExchangeSensor.SetCheck( 1 );
	else m_macTurnExchangeSensor.SetCheck( 0 );

/*
		if( m_pTrJointConfim->GetState( jointWAIT ) )
		{
			if( diTR_UNIT_WAIT_POS_ALIGN1_FW ) m_macAlignFw1.SetCheck( 1 );
			else if( !diTR_UNIT_WAIT_POS_ALIGN1_FW ) m_macAlignFw1.SetCheck( 0 );
			if( diTR_UNIT_WAIT_POS_ALIGN2_FW ) m_macAlignFw2.SetCheck( 1 );
			else if( !diTR_UNIT_WAIT_POS_ALIGN2_FW ) m_macAlignFw2.SetCheck( 0 );
			if( diTR_UNIT_WAIT_POS_ALIGN1_BW ) m_macAlignBw1.SetCheck( 1 );
			else if( !diTR_UNIT_WAIT_POS_ALIGN1_BW ) m_macAlignBw1.SetCheck( 0 );
			if( diTR_UNIT_WAIT_POS_ALIGN2_BW ) m_macAlignBw2.SetCheck( 1 );
			else if( !diTR_UNIT_WAIT_POS_ALIGN2_BW ) m_macAlignBw2.SetCheck( 0 );
		}
		else if( m_pTrJointConfim->GetState( jointSEND ) )
		{
			if( diTR_UNIT_LD_POS_ALIGN1_FW ) m_macAlignFw1.SetCheck( 1 );
			else if( !diTR_UNIT_LD_POS_ALIGN1_FW ) m_macAlignFw1.SetCheck( 0 );
			if( diTR_UNIT_LD_POS_ALIGN2_FW ) m_macAlignFw2.SetCheck( 1 );
			else if( !diTR_UNIT_LD_POS_ALIGN2_FW ) m_macAlignFw2.SetCheck( 0 );
			if( diTR_UNIT_LD_POS_ALIGN1_BW ) m_macAlignBw1.SetCheck( 1 );
			else if( !diTR_UNIT_LD_POS_ALIGN1_BW ) m_macAlignBw1.SetCheck( 0 );
			if( diTR_UNIT_LD_POS_ALIGN2_BW ) m_macAlignBw2.SetCheck( 1 );
			else if( !diTR_UNIT_LD_POS_ALIGN2_BW ) m_macAlignBw2.SetCheck( 0 );
		}*/
	
}

void CDlgTrTurn::OnRadioAlignFw() 
{
	// TODO: Add your control notification handler code here
	
	if( m_pEqpAssy->m_TrJointConfirm->Get( jointWAIT ) )
	{
		m_pEqpAssy->m_CylinderTrWaitAlign->SetFw();
		m_macAlignFw.SetCheck( 1 );
		m_macAlignBw.SetCheck( 0 );
	}
	else if( m_pEqpAssy->m_TrJointConfirm->Get( jointSEND )  )
	{
		m_pEqpAssy->m_CylinderTrLdAlign->SetFw();
		m_macAlignFw.SetCheck( 1 );
		m_macAlignBw.SetCheck( 0 );
	}
}

void CDlgTrTurn::OnRadioAlignBw() 
{
	if( m_pEqpAssy->m_TrJointConfirm->Get( jointWAIT ) )
	{
		m_pEqpAssy->m_CylinderTrWaitAlign->SetBw();
		m_macAlignFw.SetCheck( 0 );
		m_macAlignBw.SetCheck( 1 );
	}
	else if( m_pEqpAssy->m_TrJointConfirm->Get( jointSEND )  )
	{
		m_pEqpAssy->m_CylinderTrLdAlign->SetBw();
		m_macAlignFw.SetCheck( 0 );
		m_macAlignBw.SetCheck( 1 );
	}
}
