// DlgUlAlign.cpp :  Դϴ.
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgUlAlign.h"
#include "afxdialogex.h"


// CDlgUlAlign ȭ Դϴ.

IMPLEMENT_DYNAMIC(CDlgUlAlign, CDialog)

CDlgUlAlign::CDlgUlAlign(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgUlAlign::IDD, pParent)
{

}

CDlgUlAlign::~CDlgUlAlign()
{
}

void CDlgUlAlign::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_RADIO_FW, m_macAlignFw );
	DDX_Control(pDX, IDC_RADIO_BW, m_macAlignBw );
	DDX_Control(pDX, ID_ULALIGN_ALLBW, m_macAlignAllBw );
}


BEGIN_MESSAGE_MAP(CDlgUlAlign, CDialog)
		//{{AFX_MSG_MAP(CDlgAlign)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_RADIO_FW, OnRadioFw)
	ON_BN_CLICKED(IDC_RADIO_BW, OnRadioBw)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(ID_ULALIGN_ALLBW, &CDlgUlAlign::OnBnClickedUlalignAllbw)
END_MESSAGE_MAP()


// CDlgUlAlign ޽ óԴϴ.
BOOL CDlgUlAlign::OnInitDialog() 
{
	CDialog::OnInitDialog();
	// Set button
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	MAC_COLOR_SET color_set;
	m_macAlignFw.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macAlignFw.SetColorSetting( color_set );
	m_macAlignFw.SetBold();

	if(m_nAssy == UL_CYL_ALIGN)	m_macAlignFw.SetWindowText("FW");
	else						m_macAlignFw.SetWindowText("UP");

	m_macAlignBw.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macAlignBw.SetColorSetting( color_set );
	m_macAlignBw.SetBold();
	
	if(m_nAssy == UL_CYL_ALIGN)	m_macAlignBw.SetWindowText("BW");
	else						m_macAlignBw.SetWindowText("DOWN");

	m_macAlignAllBw.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macAlignAllBw.SetColorSetting( color_set );
	m_macAlignAllBw.SetBold();	

	m_dwStartTick = GetCurrentTime();
	// TODO: Add extra initialization here
	SetTimer( TIMER_MANUAL, 100, NULL );

	UINT nAlignID[4] = { IDC_STATIC_ALIGN1, IDC_STATIC_ALIGN2, IDC_STATIC_ALIGN3, IDC_STATIC_ALIGN4 };
	int i;

	for( i = 0 ; i < 4 ; i ++ )
	{
		m_stcAlign[i].SubclassDlgItem( nAlignID[i], this ); 
		m_stcAlign[i].SetTextColor( BLACK_COLOR );
		m_stcAlign[i].SetBkColor( WHITE_COLOR );
	}	
	m_nTarget = -1;

	m_bAllOrigin = FALSE;
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgUlAlign::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	int nStateMax = 4, nStateFW[4], nStateBW[4], i, nCntTarget=0;
	static int	nOldTarget=0;
	static int nOldAllGrigin=0;

	if(m_bAllOrigin == TRUE)
	{
		if(nOldAllGrigin == 0)
		{
			GetDlgItem(IDC_RADIO_FW)->EnableWindow(FALSE);
			GetDlgItem(IDC_RADIO_BW)->EnableWindow(FALSE);
			GetDlgItem(ID_ULALIGN_ALLBW)->EnableWindow(FALSE);
			nOldAllGrigin = 1;
		}

		if(GetAlignState(&m_pEqpAssy->m_CylinderUlAlign, BW) == FALSE)			m_pEqpAssy->m_CylinderUlAlign.SetBw();
		else if(GetAlignState(&m_pEqpAssy->m_CylinderUlAlignUD, BW) == FALSE)	m_pEqpAssy->m_CylinderUlAlignUD.SetBw();
		else if(GetAlignState(&m_pEqpAssy->m_CylinderUlPinUD, BW) == FALSE)		m_pEqpAssy->m_CylinderUlPinUD.SetBw();
		else																	m_bAllOrigin = FALSE;
	}
	else 
	{
		if(nOldAllGrigin == 1)
		{
			GetDlgItem(IDC_RADIO_FW)->EnableWindow(TRUE);
			GetDlgItem(IDC_RADIO_BW)->EnableWindow(TRUE);
			GetDlgItem(ID_ULALIGN_ALLBW)->EnableWindow(TRUE);
			nOldAllGrigin = 0;
		}
	}

	for( i=0; i<4; i++)
	{
		nStateFW[i] = 0;
		nStateBW[i] = 0;
	}

	if(m_nAssy == UL_CYL_ALIGN)
	{
		nStateMax = m_pEqpAssy->m_CylinderUlAlign.GetDiSize();
		for( i = 0 ; i < nStateMax; i ++ )
		{
#ifndef _MY_DEBUG
			nStateFW[i] = m_pEqpAssy->m_CylinderUlAlign.GetFw( i );
			nStateBW[i] = m_pEqpAssy->m_CylinderUlAlign.GetBw( i );
#else
			nStateFW[i] = m_pEqpAssy->m_CylinderUlAlign.GetFwState();
			nStateBW[i] = m_pEqpAssy->m_CylinderUlAlign.GetBwState();
#endif
		}
	}
	else if(m_nAssy == UL_CYL_ALIGN_UD)
	{
		nStateMax = m_pEqpAssy->m_CylinderUlAlignUD.GetDiSize();
		for( i = 0 ; i < nStateMax; i ++ )
		{
#ifndef _MY_DEBUG
			nStateFW[i] = m_pEqpAssy->m_CylinderUlAlignUD.GetFw( i );
			nStateBW[i] = m_pEqpAssy->m_CylinderUlAlignUD.GetBw( i );
#else
			nStateFW[i] = m_pEqpAssy->m_CylinderUlAlignUD.GetFwState();
			nStateBW[i] = m_pEqpAssy->m_CylinderUlAlignUD.GetBwState();
#endif
		}
	}
	else if(m_nAssy == UL_CYL_PIN_UD)
	{
		m_stcAlign[2].ShowWindow(SW_HIDE);
		m_stcAlign[3].ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATIC_A3)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATIC_A4)->ShowWindow(SW_HIDE);
#ifdef _MY_DEBUG
		if(m_nTarget == UP && nOldTarget != UP)
		{
			m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[UP] = GetCurrentTime() - m_dwStartTick;
			if(GetCurrentTime() - m_dwStartTick < 1200)	return;
		}
		else if(m_nTarget == DN && nOldTarget != DN)
		{
			m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[DN] = GetCurrentTime() - m_dwStartTick;
			if(GetCurrentTime() - m_dwStartTick < 1300)	return;
		}
#endif

		nStateMax = m_pEqpAssy->m_CylinderUlPinUD.GetDiSize();
		for( i = 0 ; i < nStateMax; i ++ )
		{
#ifndef _MY_DEBUG
			nStateFW[i] = m_pEqpAssy->m_CylinderUlPinUD.GetFw( i );
			nStateBW[i] = m_pEqpAssy->m_CylinderUlPinUD.GetBw( i );
#else
			nStateFW[i] = m_pEqpAssy->m_CylinderUlPinUD.GetFwState();
			nStateBW[i] = m_pEqpAssy->m_CylinderUlPinUD.GetBwState();
#endif		
		}

		if(m_nTarget == UP)
		{
			for( i = 0 ; i < nStateMax; i ++ )
			{
				if(nStateFW[i])	nCntTarget++;
			}

			if(nCntTarget != nStateMax )
			{
				m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[UP] = GetCurrentTime() - m_dwStartTick;
			}
			else if(nOldTarget != UP)
			{
				m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[UP] = GetCurrentTime() - m_dwStartTick;
				nOldTarget = UP;
			}
		}
		else if(m_nTarget == DN)
		{
			for( i = 0 ; i < nStateMax; i ++ )
			{
				if(nStateBW[i])	nCntTarget++;
			}

			if(nCntTarget != nStateMax )
			{
				m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[DN] = GetCurrentTime() - m_dwStartTick;
			}
			else if(nOldTarget != DN)
			{
				m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[DN] = GetCurrentTime() - m_dwStartTick;
				nOldTarget = DN;
			}
		}
	}

	for( i = 0 ; i < nStateMax; i ++ )
	{
		if( nStateFW[i] )
		{
			m_stcAlign[i].SetBkColor( GREEN_COLOR );
			if(m_nAssy == UL_CYL_ALIGN)	m_stcAlign[i].SetWindowText( "FW" );
			else						m_stcAlign[i].SetWindowText( "UP" );			
		}
		else if( nStateBW[i] )
		{
			m_stcAlign[i].SetBkColor( YELLOW_COLOR );
			if(m_nAssy == UL_CYL_ALIGN)	m_stcAlign[i].SetWindowText( "BW" );
			else						m_stcAlign[i].SetWindowText( "DOWN" );
		}
		else 
		{
			m_stcAlign[i].SetBkColor( WHITE_COLOR );
			m_stcAlign[i].SetWindowText( "?" );
		}
	}
	CDialog::OnTimer(nIDEvent);
}

void CDlgUlAlign::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	KillTimer( TIMER_MANUAL );
}

void CDlgUlAlign::OnRadioFw() 
{
	if( m_nAssy == UL_CYL_ALIGN_UD || m_nAssy == UL_CYL_PIN_UD )
	{
		if( ChkInterlock(m_nAssy, FW) == TRUE ) return;
	}

	if(m_nAssy == UL_CYL_ALIGN)			m_pEqpAssy->m_CylinderUlAlign.SetFw();
	else if(m_nAssy == UL_CYL_ALIGN_UD)	m_pEqpAssy->m_CylinderUlAlignUD.SetFw();
	else if(m_nAssy == UL_CYL_PIN_UD)	m_pEqpAssy->m_CylinderUlPinUD.SetFw();

	m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[UP] = 0;
	m_dwStartTick = GetCurrentTime();
	m_nTarget = FW;
}

void CDlgUlAlign::OnRadioBw() 
{
	if( m_nAssy == UL_CYL_PIN_UD )
	{
		if( ChkInterlock(m_nAssy, BW) == TRUE ) return;
	}

	if(m_nAssy == UL_CYL_ALIGN)			m_pEqpAssy->m_CylinderUlAlign.SetBw();
	else if(m_nAssy == UL_CYL_ALIGN_UD)	m_pEqpAssy->m_CylinderUlAlignUD.SetBw();
	else if(m_nAssy == UL_CYL_PIN_UD) 	m_pEqpAssy->m_CylinderUlPinUD.SetBw();

	m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[DN] = 0;
	m_dwStartTick = GetCurrentTime();
	m_nTarget = BW;
}

BOOL CDlgUlAlign::ChkInterlock(int nDir, int nUD)
{
	BOOL bInterlock = FALSE;
	BOOL bUlUnitHandInterLock = m_pEqpAssy->m_SensorRobotHandInterlock.Get( 1 );
	BOOL bUlOutputSensor = m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 );
	BOOL bUlAlignUDStatus = GetAlignState(&m_pEqpAssy->m_CylinderUlAlignUD, BW);

	if(nDir == UL_CYL_PIN_UD && nUD == BW)
	{
		if(bUlUnitHandInterLock == TRUE)
		{
			AfxMessageBox( "INTERLOCK : Unload Robot Sensing!! Please check robot!!");
			bInterlock = TRUE;
		}
		if(bUlAlignUDStatus == FALSE)
		{
			AfxMessageBox( "INTERLOCK : Unload Align Up Sensing!! Please check Align Down!!");
			bInterlock = TRUE;
		}
	}
	else if(nDir == UL_CYL_PIN_UD && nUD == FW)
	{
		if(bUlUnitHandInterLock == TRUE)
		{
			bInterlock = TRUE;
			AfxMessageBox( "INTERLOCK : Unload Robot Sensing!! Please check robot!!");
		}
		if(bUlOutputSensor != TRUE)
		{
			AfxMessageBox( "INTERLOCK : UL Out Sensor Error!! Please check sensor!!");
			bInterlock = TRUE;
		}
	}
	else if(nDir == UL_CYL_ALIGN_UD && nUD == FW)
	{
		if(bUlOutputSensor != TRUE)
		{
			AfxMessageBox( "INTERLOCK : UL Out Sensor Error!! Please check sensor!!");
			bInterlock = TRUE;
		}
	}

	return bInterlock;
}


void CDlgUlAlign::OnBnClickedUlalignAllbw()
{
	if(m_bAllOrigin == FALSE)	m_bAllOrigin = TRUE;
/*
	BOOL bAlarmList[4] = {FALSE, FALSE, FALSE, FALSE};
	if(IsPowerState(TRUE, bAlarmList) == TRUE)
	{
		for(int i=0; i<4; i++ )
		{
			if(bAlarmList[i] == TRUE)
			{
				CString strTemp;
				strTemp.Format("%d", i+1);
				AfxMessageBox(strTemp);
			}
		}
	}
*/
}


BOOL CDlgUlAlign::GetAlignState(CFaCylinder* Cylinder, int nDir)
{
	int nStateMax, i, nState[4], nStateCount = 0;
	nStateMax = Cylinder->GetDiSize();
	for( i = 0 ; i < nStateMax; i ++ )
	{
#ifndef _MY_DEBUG
		if(nDir == FW)	nState[i] = Cylinder->GetFw( i );
		else			nState[i] = Cylinder->GetBw( i );
#else
		if(nDir == FW)	nState[i] = Cylinder->GetFwState();
		else			nState[i] = Cylinder->GetBwState();
#endif
	}

	nStateCount = 0;
	for( i=0; i<nStateMax; i++ )
	{
		if(nState[i] == TRUE) nStateCount++;
	}
	if(nStateMax == nStateCount)	return TRUE;
	else							return FALSE;
}


BOOL CDlgUlAlign::IsPowerState(BOOL bOn, BOOL *bAlarmList)
{
	BOOL bRv = TRUE;

	if(bOn)
	{
		for(int i=0; i<4; i++)
		{
			if(i%2)	bAlarmList[i] = TRUE;
		}	
	}
	return bRv;
}