// DlgUlHandCylinder.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DlgUlHandCylinder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgUlHandCylinder dialog


CDlgUlHandCylinder::CDlgUlHandCylinder(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgUlHandCylinder::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgUlHandCylinder)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_sDlgCylTitle = "Ul Unit Hand Cylinder";
}


void CDlgUlHandCylinder::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgUlHandCylinder)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_RADIO_UP, m_macUlCylinderFw );
	DDX_Control(pDX, IDC_RADIO_DN, m_macUlCylinderBw );
	DDX_Control(pDX, IDC_LD_TILT_CYL, m_ocxUlHandCylinder[0] );
	DDX_Control(pDX, IDC_UL_TILT_CYL, m_ocxUlHandCylinder[1] );
}


BEGIN_MESSAGE_MAP(CDlgUlHandCylinder, CDialog)
	//{{AFX_MSG_MAP(CDlgUlHandCylinder)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_RADIO_UP, OnRadioUp)
	ON_BN_CLICKED(IDC_RADIO_DN, OnRadioDn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgUlHandCylinder message handlers
BOOL CDlgUlHandCylinder::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_nOldUlHandCylinderState[0] = 0;
	m_nOldUlHandCylinderState[1] = 0;
	// Set button
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	CString sTitle;

	// ljy_041104 : AUO User Request
	sTitle.Format( "Valve : %s", m_sDlgCylTitle );
	SetWindowText( sTitle );



	MAC_COLOR_SET color_set;
	m_macUlCylinderFw.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macUlCylinderFw.SetColorSetting( color_set );
	m_macUlCylinderFw.SetBold();

	m_macUlCylinderBw.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macUlCylinderBw.SetColorSetting( color_set );
	m_macUlCylinderBw.SetBold();
	
	// TODO: Add extra initialization here
	SetTimer( TIMER_MANUAL, 100, NULL );
		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgUlHandCylinder::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	IsUlHandCylinderStatus();

	CDialog::OnTimer(nIDEvent);
}

void CDlgUlHandCylinder::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	
}

void CDlgUlHandCylinder::OnRadioUp() 
{
	if( m_pEqpAssy->m_CylinderUlTilt.GetFw() )
	{
		AfxMessageBox("UL Unit Tilt Status Error!");
		return;
	}
	m_pEqpAssy->m_CylinderUlHand.SetFw();
}

void CDlgUlHandCylinder::OnRadioDn() 
{
#ifndef _NO_UL_HAND	//hskwak skip/
	if( !m_pMmc->GetHomeSwitch(1) && m_pEqpAssy->m_GlassExistUnitIn.GetAnd( IF_UNIT_UL_HAND ) ) // minhan 080922
	{
		AfxMessageBox( "UL Hand Glass exist Error" );
		return;
	}
	m_pEqpAssy->m_CylinderUlHand.SetBw();
#endif
	
}

void CDlgUlHandCylinder::IsUlHandCylinderStatus()
{
	// TODO: Add your control notification handler code here

	for( int i = 0; i < 2; i++ )
	{
#ifndef _MY_DEBUG
		if( ( m_nOldUlHandCylinderState[i] != 1 ) && m_pEqpAssy->m_CylinderUlHand.GetFw( i ) )
#else
		if( ( m_nOldUlHandCylinderState[i] != 1 ) && m_pEqpAssy->m_CylinderUlHand.GetFwState() )
#endif
		{
			m_nOldUlHandCylinderState[i] = 1;
			m_ocxUlHandCylinder[i].SetFw();
		}
#ifndef _MY_DEBUG
		else if( ( m_nOldUlHandCylinderState[i] != 2 ) && m_pEqpAssy->m_CylinderUlHand.GetBw( i ) )
#else
		else if( ( m_nOldUlHandCylinderState[i] != 2 ) && m_pEqpAssy->m_CylinderUlHand.GetBwState() )
#endif
		{
			m_nOldUlHandCylinderState[i] = 2;
			m_ocxUlHandCylinder[i].SetBw();
		}
#ifndef _MY_DEBUG
		else if( m_nOldUlHandCylinderState[i] != 3 && 
				( !m_pEqpAssy->m_CylinderUlHand.GetFw( i ) && !m_pEqpAssy->m_CylinderUlHand.GetBw( i ) ) )
#else
		else if( m_nOldUlHandCylinderState[i] != 3 && 
				( !m_pEqpAssy->m_CylinderUlHand.GetFwState() && !m_pEqpAssy->m_CylinderUlHand.GetBwState() ) )
#endif
		{
			m_nOldUlHandCylinderState[i] = 3;
			m_ocxUlHandCylinder[i].SetNone();
		}
	}
}
