// DlgUserPass.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgUserPass.h"
#include "DlgAddUser.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgUserPass dialog


CDlgUserPass::CDlgUserPass(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgUserPass::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgUserPass)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgUserPass::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgUserPass)
	DDX_Control(pDX, IDC_GRID_USER_INFO, m_gridUserInfo);
	DDX_Control(pDX, IDC_BUTTON_ADD_USER, m_macAdd );
	DDX_Control(pDX, IDC_BUTTON_REM_USER, m_macRem );
	DDX_Control(pDX, IDC_BUTTON_CHANGE_PASS, m_macPass );
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgUserPass, CDialog)
	//{{AFX_MSG_MAP(CDlgUserPass)
	ON_BN_CLICKED(IDC_BUTTON_ADD_USER, OnButtonAddUser)
	ON_BN_CLICKED(IDC_BUTTON_REM_USER, OnButtonRemUser)
	ON_BN_CLICKED(IDC_BUTTON_CHANGE_PASS, OnButtonChangePass)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgUserPass message handlers

BOOL CDlgUserPass::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );
	VERIFY( m_Cancel.AutoLoad( IDCANCEL, this ) );

	MAC_COLOR_SET color;
	m_macAdd.GetColorSetting( &color );
	color.crFace = LIGHT_GREEN_COLOR;
	color.crLiteShadow = MAGENTA_COLOR;
	m_macAdd.SetColorSetting( color );
	m_macRem.SetColorSetting( color );
	m_macPass.SetColorSetting( color );

	GridInit_UserInfo();

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void CDlgUserPass::GridInit_UserInfo()
{
	LPTSTR sLvcText[] = { "No", " User Name ", " Group " };
	int nColWidth[] = { 500, 2500, 2500 }; 

	// initialize GridCtrl
	m_gridUserInfo.SetRows( MAX_ACCOUNT_NO + 1 ); 
	m_gridUserInfo.SetCols( 3 );

	//-------------------------------------------
	m_gridUserInfo.SetRow( 0 );  
	m_gridUserInfo.SetColWidth( 0, nColWidth[0] );
	m_gridUserInfo.SetCol( 0 ); 
	m_gridUserInfo.SetCellAlignment( 4 );
	m_gridUserInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridUserInfo.SetText( sLvcText[0] ); 
	//-------------------------------------------
	m_gridUserInfo.SetRow( 0 );  
	m_gridUserInfo.SetColWidth( 1, nColWidth[1] );
	m_gridUserInfo.SetCol( 1 ); 
	m_gridUserInfo.SetCellAlignment( 4 );
	m_gridUserInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridUserInfo.SetText( sLvcText[1] ); 
	//---------------------------------------------
	m_gridUserInfo.SetRow( 0 );  
	m_gridUserInfo.SetColWidth( 2, nColWidth[2] );
	m_gridUserInfo.SetCol( 2 ); 
	m_gridUserInfo.SetCellAlignment( 4 );
	m_gridUserInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridUserInfo.SetText( sLvcText[2] ); 

	if( m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER )
	{
		m_macAdd.EnableWindow( FALSE );
		m_macRem.EnableWindow( FALSE );
		m_macPass.EnableWindow( FALSE );
	}

//	SetDataToGridCtrl_RecipeInfo();
	SetGrid_UserInfo();
}

void CDlgUserPass::SetGrid_UserInfo()
{
	LPCTSTR sGroupName[] = { "OPERATOR", "MAINT", "ENGINEER" };
	CString sString;
	int j = 0;
	for( int i = 0 ; i < MAX_ACCOUNT_NO ; i ++ )
	{
		if( m_pDicsData->m_LoginInfo.bIsValid[i] )
		{
			j++;
			m_gridUserInfo.SetCol( 0 );
			m_gridUserInfo.SetRow( j );
			m_gridUserInfo.SetCellAlignment( 0 );
			m_gridUserInfo.SetCellBackColor( LIGHT_CYAN_COLOR );
			sString.Format( "%d", j );
			m_gridUserInfo.SetText( (LPCTSTR)sString );

			m_gridUserInfo.SetCol( 1 );
			m_gridUserInfo.SetRow( j );
			m_gridUserInfo.SetCellAlignment( 1 );
			m_gridUserInfo.SetCellBackColor( WHITE_COLOR );
			m_gridUserInfo.SetText( (LPCTSTR)m_pDicsData->m_LoginInfo.sUserID[i] );

			m_gridUserInfo.SetCol( 2 );
			m_gridUserInfo.SetRow( j );
			m_gridUserInfo.SetCellAlignment( 2 );
			m_gridUserInfo.SetCellBackColor( WHITE_COLOR );
			m_gridUserInfo.SetText( sGroupName[m_pDicsData->m_LoginInfo.nUserLevel[i]] );
		}
	}
}

void CDlgUserPass::OnButtonAddUser() 
{
	CDlgAddUser dlg;
	dlg.SetDicsData( m_pDicsData );
	dlg.DoModal();	
}

void CDlgUserPass::OnButtonRemUser() 
{
	// TODO: Add your control notification handler code here
	if( m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER )
	{
		AfxMessageBox( "You Can't Remove User ID" );
		return;
	}
	int nRowNo = m_gridUserInfo.GetRow();
	m_gridUserInfo.SetRow( nRowNo );
	m_gridUserInfo.SetCol( 1 );

	m_pDicsData->RemUser( m_gridUserInfo.GetText(), "654321" );
	SetGrid_UserInfo();
}

void CDlgUserPass::OnButtonChangePass() 
{
	// TODO: Add your control notification handler code here
	
}
