// DlgValve.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgValve.h"
#include "..\Define.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgValve dialog


CDlgValve::CDlgValve(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgValve::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgValve)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_sWndName = "Valve";

	m_sValveTitle[ 0] = "SWR1 MJ CDA SPL";
	m_sValveTitle[ 1] = "SWR1 DIW SPL";
	m_sValveTitle[ 2] = "SWR2 BATH DRAIN";
	m_sValveTitle[ 3] = "TANK2 RETURN DRAIN";
	m_sValveTitle[ 4] = "SWR2 DIW SPL";
	m_sValveTitle[ 5] = "SWR2 PUMP1 OUT SPL";
	m_sValveTitle[ 6] = "TANK1 DIW LITTLE SPL";
	m_sValveTitle[ 7] = "SWR3 DIW SPL";
	m_sValveTitle[ 8] = "SWR3 PUMP2 OUT SPL";
	m_sValveTitle[ 9] = "TANK1 DIW DRAIN";
	m_sValveTitle[10] = "TANK2 DIW LITTLE SPL";
	m_sValveTitle[11] = "SWR4 DIW SPL";
	m_sValveTitle[12] = "AK LO CDA SPL";
	m_sValveTitle[13] = "AK UP CDA SPL";
	m_sValveTitle[14] = "SWR4 MJ CDA SPL";
	m_sValveTitle[15] = "TANK2 DIW DRAIN";
#ifdef _BUFTANK_USE
	m_sValveTitle[16] = "BUF TANK SPL1";					//AV01
	m_sValveTitle[17] = "BUF TANK SPL2";					//AV02
	m_sValveTitle[18] = "BUF TANK BOTTOM DRAIN";			//AV03
	m_sValveTitle[19] = "BUF TANK SPL TO SWR2";				//AV04
	m_sValveTitle[20] = "BUF TANK SPL TO SWR3";				//AV05
	m_sValveTitle[21] = "BUF TANK SPL TO SWR1";				//AV06
	m_sValveTitle[22] = "BUF TANK SPL TO SWR4";				//AV07

#endif

	m_bPermitAccess = TRUE;
}


void CDlgValve::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgValve)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Control( pDX, IDC_RADIO1, m_macOpen );
	DDX_Control( pDX, IDC_RADIO2, m_macClose );
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgValve, CDialog)
	//{{AFX_MSG_MAP(CDlgValve)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgValve message handlers

void CDlgValve::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	// 100908 halesu
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
/*
	if ( m_nValveNo == 5 && !pView->m_pDicsData->m_GenInfo.bMjCdaReady[1] )  
		AfxMessageBox( "MJ4 CDA Pressure must be over 20.0 kpa", MB_OK );	// 111123 halesu	
	else if( m_nValveNo == 14 && !pView->m_pDicsData->m_GenInfo.bMjCdaReady[0] )	// 130812 halesu
		AfxMessageBox( "MJ1~3 CDA Pressure must be over 20.0 kpa", MB_OK );
	else
		m_pEqpAssy->m_AutoValvePiping.Set( m_nValveNo, CEqpAssy::actON );
*/
	if ( m_nValveNo == 1 )
	{
		m_pEqpAssy->m_AutoValvePiping.Set( 0, CEqpAssy::actON );
	}
	if ( m_nValveNo == 11 )
	{
		m_pEqpAssy->m_AutoValvePiping.Set( 14, CEqpAssy::actON );
	}
	m_pEqpAssy->m_AutoValvePiping.Set( m_nValveNo, CEqpAssy::actON );
}

void CDlgValve::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	if ( m_nValveNo == 0 )
	{
		m_pEqpAssy->m_AutoValvePiping.Set( 1, CEqpAssy::actOFF );
	}
	if ( m_nValveNo == 14 )
	{
		m_pEqpAssy->m_AutoValvePiping.Set( 11, CEqpAssy::actOFF );
	}

	m_pEqpAssy->m_AutoValvePiping.Set( m_nValveNo, CEqpAssy::actOFF );
}

BOOL CDlgValve::OnInitDialog() 
{
	CDialog::OnInitDialog();
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	CString sTitle;
//	sTitle.Format( "Valve %d : Open / Close", m_nValveNo + 1 );
//	GetDlgItem( IDC_STATIC_TITLE )->SetWindowText( sTitle );

	// ljy_041104 : AUO User Request
	sTitle.Format( "Valve : %s", m_sValveTitle[m_nValveNo] );
	SetWindowText( sTitle );

	MAC_COLOR_SET color;
	m_macOpen.GetColorSetting( &color );
	color.crFace = LIGHT_GREEN_COLOR;
	m_macOpen.SetColorSetting( color );

	m_macClose.GetColorSetting( &color );
	color.crFace = LIGHT_BLUE_COLOR;
	m_macClose.SetColorSetting( color );

	// ljy_041104 : AUO User Request
	if( !m_bPermitAccess )
	{
		GetDlgItem( IDC_RADIO1 )->EnableWindow( FALSE );
		GetDlgItem( IDC_RADIO2 )->EnableWindow( FALSE );
	}

	int nValveState = -1;
	nValveState = m_pEqpAssy->m_AutoValvePiping.GetState( m_nValveNo );
	if( nValveState == CEqpAssy::actON )
	{
		m_macOpen.SetCheck(1);
		m_macClose.SetCheck(0);
	}
	else if( nValveState == CEqpAssy::actOFF )
	{
		m_macOpen.SetCheck(0);
		m_macClose.SetCheck(1);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
