// dlgdualsensor.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "dlgdualsensor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgDualSensor dialog


CDlgDualSensor::CDlgDualSensor(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgDualSensor::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgDualSensor)
	//}}AFX_DATA_INIT

	m_nUnitNo = 0;
}


void CDlgDualSensor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgDualSensor)
	DDX_Control(pDX, IDC_GRID_DUAL_SENSOR,  m_gridDualSensor);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgDualSensor, CDialog)
	//{{AFX_MSG_MAP(CDlgDualSensor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgDualSensor message handlers


BOOL CDlgDualSensor::OnInitDialog() 
{
	CDialog::OnInitDialog();
	// Set button
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	SetWindowText( m_sTitle );
	
	GridInit_DualSensor();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
void CDlgDualSensor::GridInit_DualSensor()
{
	LPTSTR sLvcText[] = { "ITEM", "IN SENSOR", "OUT SENSOR", };
	LPTSTR sLvcRowText[] = { "OP MAIN SENSOR", "MT SUB SENSOR", };
	int nColWidth[] = { 3000, 2800, 2800, }; 
	int nRowHight[] = { 1000, 1000 };

	m_gridDualSensor.SetRows( 2 + 1); 
	m_gridDualSensor.SetCols( 3 );

	m_gridDualSensor.SetRow( 0 );  
	for( int i=0; i<3; i++ )
	{
		m_gridDualSensor.SetColWidth( i, nColWidth[i] );
		m_gridDualSensor.SetCol( i ); 
		m_gridDualSensor.SetCellAlignment( 4 );
		m_gridDualSensor.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridDualSensor.SetText( sLvcText[i] ); 
	}

	for( int i = 0 ; i < 2 ; i ++ )
	{
				
		m_gridDualSensor.SetCol( 0 );
		m_gridDualSensor.SetRow( i + 1 );
		m_gridDualSensor.SetRowHeight( i+1, nRowHight[i] );
		m_gridDualSensor.SetCellAlignment( 4 );
		m_gridDualSensor.SetCellBackColor( LIGHT_GRAY );
		m_gridDualSensor.SetText( sLvcRowText[i] );
	}
	SetDataToGridCtrl();
}

BEGIN_EVENTSINK_MAP(CDlgDualSensor, CDialog)
    //{{AFX_EVENTSINK_MAP(CDlgDualSensor)
	ON_EVENT(CDlgDualSensor, IDC_GRID_DUAL_SENSOR, -601 /* DblClick */, OnDblClickGridDualSensor, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CDlgDualSensor::SetDataToGridCtrl()
{
	CString sBuf;
	for( int i=0; i<2 ; i++ )
	{
		// 2nd column
		m_gridDualSensor.SetCol( 1 );
		m_gridDualSensor.SetRow( i + 1 );

		if( i == 0 )
		{
			if( m_pDicsData->m_IfFlag[m_nUnitNo].bInSensorSkip )
			{
				sBuf = "NOUSE";
				m_gridDualSensor.SetCellBackColor( LIGHT_GRAY );
			}
			else
			{
				sBuf = "USE";
				m_gridDualSensor.SetCellBackColor( LIGHT_GREEN_COLOR );
			}
		}
		else
		{
			if( m_pDicsData->m_IfFlag[m_nUnitNo].bSubInSensorSkip )
			{
				sBuf = "NOUSE";
				m_gridDualSensor.SetCellBackColor( LIGHT_GRAY );
			}
			else
			{
				sBuf = "USE";
				m_gridDualSensor.SetCellBackColor( LIGHT_GREEN_COLOR );

			}
		}
		m_gridDualSensor.SetCellAlignment( 4 );
		m_gridDualSensor.SetText( (LPCTSTR) sBuf );

		m_gridDualSensor.SetCol( 2 );
		m_gridDualSensor.SetRow( i + 1 );

		if( i == 0 )
		{					
			if( m_pDicsData->m_IfFlag[m_nUnitNo].bOutSensorSkip )
			{
				sBuf = "NOUSE";
				m_gridDualSensor.SetCellBackColor( LIGHT_GRAY );
			}
			else
			{
				sBuf = "USE";
				m_gridDualSensor.SetCellBackColor( LIGHT_GREEN_COLOR );
			}
		}
		else
		{
			if( m_pDicsData->m_IfFlag[m_nUnitNo].bSubOutSensorSkip )
			{
				sBuf = "NOUSE";
				m_gridDualSensor.SetCellBackColor( LIGHT_GRAY );
			}
			else
			{
				sBuf = "USE";
				m_gridDualSensor.SetCellBackColor( LIGHT_GREEN_COLOR );
			}
		}
		m_gridDualSensor.SetCellAlignment( 4 );
		m_gridDualSensor.SetText( (LPCTSTR) sBuf );
	}
}
void CDlgDualSensor::OnDblClickGridDualSensor() 
{
	// TODO: Add your control notification handler code here
	int nRow = m_gridDualSensor.GetRow();
	int nCol = m_gridDualSensor.GetCol();

	if ( nRow == 0 ) return;
	if ( nCol == 0 ) return;

	if( nRow== 1 )
	{
		if( nCol == 1 )
		{
/*
			if( m_pEqpAssy->m_GlassExistUnitIn.Get( m_nUnitNo, 0 ) )
			{
				AfxMessageBox( "SETTING CAN WHEN SENSOR IS OFF" ); 
				return;
			}
*/
			if( m_pDicsData->m_IfFlag[m_nUnitNo].bInSensorSkip && !m_pEqpAssy->m_GlassExistUnitIn.Get( m_nUnitNo, 0 ) )
			{
				m_pDicsData->m_IfFlag[m_nUnitNo].bInSensorSkip = FALSE; 
			}
			else
			{
				if( m_pDicsData->m_IfFlag[m_nUnitNo].bSubInSensorSkip ) 
				{
					AfxMessageBox( "MT SUB SENSOR IS SKIP" ); 
					return;
				}
				m_pDicsData->m_IfFlag[m_nUnitNo].bInSensorSkip = TRUE; 
			}
		}
		else
		{
/*					
			if( m_pEqpAssy->m_GlassExistUnitOut.Get( m_nUnitNo, 0 ) )
			{
				AfxMessageBox( "SETTING CAN WHEN SENSOR IS OFF" ); 
				return;
			}
*/
			if( m_pDicsData->m_IfFlag[m_nUnitNo].bOutSensorSkip && !m_pEqpAssy->m_GlassExistUnitOut.Get( m_nUnitNo, 0 ))
			{
				m_pDicsData->m_IfFlag[m_nUnitNo].bOutSensorSkip = FALSE; 
			}
			else
			{
				if( m_pDicsData->m_IfFlag[m_nUnitNo].bSubOutSensorSkip ) 
				{
					AfxMessageBox( "MT SUB SENSOR IS SKIP" ); 
					return;
				}
				m_pDicsData->m_IfFlag[m_nUnitNo].bOutSensorSkip = TRUE; 
			}
		}
	}

	if( nRow== 2)
	{		
		if( nCol == 1 )
		{
/*
			if( m_pEqpAssy->m_GlassExistUnitIn.Get( m_nUnitNo, 1 ) )
			{
				AfxMessageBox( "SETTING CAN WHEN SENSOR IS OFF" ); 
				return;
			}
*/
			if( m_pDicsData->m_IfFlag[m_nUnitNo].bSubInSensorSkip && !m_pEqpAssy->m_GlassExistUnitIn.Get( m_nUnitNo, 1 ) )
			{
				m_pDicsData->m_IfFlag[m_nUnitNo].bSubInSensorSkip = FALSE; 
			}
			else
			{
				if( m_pDicsData->m_IfFlag[m_nUnitNo].bInSensorSkip ) 
				{
					AfxMessageBox( "OP MAIN SENSOR IS SKIP" ); 
					return;
				}
				m_pDicsData->m_IfFlag[m_nUnitNo].bSubInSensorSkip = TRUE; 
			}
		}
		else
		{
/*
			if( m_pEqpAssy->m_GlassExistUnitOut.Get( m_nUnitNo, 1 ) )
			{
				AfxMessageBox( "SETTING CAN WHEN SENSOR IS OFF" ); 
				return;
			}
*/
			if( m_pDicsData->m_IfFlag[m_nUnitNo].bSubOutSensorSkip && !m_pEqpAssy->m_GlassExistUnitOut.Get( m_nUnitNo, 1 ) )
			{
				m_pDicsData->m_IfFlag[m_nUnitNo].bSubOutSensorSkip = FALSE; 
			}
			else
			{
				if( m_pDicsData->m_IfFlag[m_nUnitNo].bOutSensorSkip ) 
				{
					AfxMessageBox(" OP MAIN SENSOR IS SKIP" ); 
					return;
				}
				m_pDicsData->m_IfFlag[m_nUnitNo].bSubOutSensorSkip = TRUE; 
			}
		}
	}
	SetDataToGridCtrl();
}


void CDlgDualSensor::OnOK() 
{
	UpdateData( TRUE );
	
	m_pDicsData->m_JobCond.bDualSensorSave = TRUE;
	CDialog::OnOK();
}