// AnalogInputs.cpp: implementation of the CAnalogInputs class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "AnalogInputs.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CAnalogInputs::CAnalogInputs()
{
	m_pAi = NULL;
	m_pAiSpare = NULL;
}

CAnalogInputs::~CAnalogInputs()
{
	delete [] m_pAi;
	if( m_pAiSpare ) delete [] m_pAiSpare;
	if( m_pConfiguration ) delete [] m_pConfiguration;
}

BOOL CAnalogInputs::Create(XCtlDevice * pDevice)
{
	if( m_nMaxNode == 0 )
	{
		AfxMessageBox( "Node size was not set. Please call CChannel::SetMaxNodeSize( nMaxNode )" );
		return FALSE;
	}
	
	SetDevice( pDevice );

	if( m_bInitialized )
	{
		AfxMessageBox( "AnalogInputs Initialized job is already done!" );
		return FALSE;
	}

	CChannels::Create( m_nMaxNode );
#ifdef _BUFTANK_USE
	SetMapFileName( "D:\\DICS\\IO Information\\AI MAP MOTOR LOAD FACTOR BUFTANK.txt" );
#else
#ifdef _MOTOR_LOAD_FACTOR
	SetMapFileName( "D:\\DICS\\IO Information\\AI MAP MOTOR LOAD FACTOR.txt" );
#else
	SetMapFileName( "D:\\DICS\\IO Information\\AI MAP.txt" );
#endif
#endif
	OpenMapFile();
	m_nChannelSize = GetChannelEAFromMapFile();
	if( m_nChannelSize > 0 )
		m_pAi = new XAnalogInput[m_nChannelSize];
	m_pAiSpare = new XAnalogInput[1];
	CloseMapFile();

	int nAdd;
	int nNo; 
	int nNode;
	CString sName;
	CString sCpoint;
	OpenMapFile();
	if( m_nChannelSize > 0 )
	{
		while( GetInformation( nAdd, nNode, nNo, sName, sCpoint ) )
		{
			m_pAi[nAdd].Create( m_pDevice, nAdd, nNode, nNo, sName,"" );
		}
	}
	CloseMapFile();
	
	m_bInitialized = TRUE;
	return TRUE;	
}

XAnalogInput* CAnalogInputs::GetInstance(CString sName)
{
	XAnalogInput* p;
	for( int i = 0 ; i < m_nChannelSize ; i ++ )
	{
		if( m_pAi[i].GetName() == sName )
		{
			p = &m_pAi[i];
			p->SetDeviceLink( TRUE );;
			return p;
		}
	}
	if( sName == "ai_SPARE" ) return m_pAiSpare;
	return NULL;
}
