// AnalogOutputs.cpp: implementation of the CAnalogOutputs class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "AnalogOutputs.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CAnalogOutputs::CAnalogOutputs()
{
	m_pAo = NULL;
	m_pAoSpare = NULL;
}

CAnalogOutputs::~CAnalogOutputs()
{
	delete [] m_pAo;
	if( m_pAoSpare ) delete [] m_pAoSpare;
	if( m_pConfiguration ) delete [] m_pConfiguration;
}

BOOL CAnalogOutputs::Create(XCtlDevice * pDevice)
{
	if( m_nMaxNode == 0 )
	{
		AfxMessageBox( "Node size was not set. Please call CChannel::SetMaxNodeSize( nMaxNode )" );
		return FALSE;
	}
	
	SetDevice( pDevice );
	if( m_bInitialized )
	{
		AfxMessageBox( "AnalogOutputs Initialized job is already done!" );
		return FALSE;
	}

	CChannels::Create( m_nMaxNode );

	SetMapFileName( "D:\\DICS\\IO Information\\AO MAP.txt" );
	OpenMapFile();
	m_nChannelSize = GetChannelEAFromMapFile();
	if( m_nChannelSize > 0 )
		m_pAo = new XAnalogOutput[m_nChannelSize];
	m_pAoSpare = new XAnalogOutput[1];
	CloseMapFile();

	int nAdd;
	int nNo; 
	int nNode;
	CString sName;
	CString sCpoint;
	OpenMapFile();
	if( m_nChannelSize > 0 )
	{
		while( GetInformation( nAdd, nNode, nNo, sName,sCpoint) )
		{
			m_pAo[nAdd].Create( m_pDevice, nAdd, nNode, nNo, sName,"" );
		}
	}
	CloseMapFile();
	m_bInitialized = TRUE;
	
	return TRUE;	
}

XAnalogOutput* CAnalogOutputs::GetInstance(CString sName)
{
	XAnalogOutput* p;
	for( int i = 0 ; i < m_nChannelSize ; i ++ )
	{
		if( m_pAo[i].GetName() == sName )
		{
			p = &m_pAo[i];
			p->SetDeviceLink( TRUE );
			return p;
		}
	}
	if( sName == "ao_SPARE" ) return m_pAoSpare;
	return NULL;
}
