// ChannelPackage.cpp: implementation of the CChannelPackage class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "ChannelPackage.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CChannelPackage::CChannelPackage(CDigitalInputs * pDis,
								 CDigitalOutputs * pDos,
								 CAnalogInputs * pAis,
								 CAnalogOutputs * pAos)
{
	m_pDigitalInputs = pDis;
	m_pDigitalOutputs = pDos;
	m_pAnalogInputs = pAis;
	m_pAnalogOutputs = pAos;
}

CChannelPackage::CChannelPackage()
{

}

CChannelPackage::~CChannelPackage()
{

}

CDigitalInputs* CChannelPackage::GetDIChannels()
{
	return m_pDigitalInputs;
}

CDigitalOutputs* CChannelPackage::GetDOChannels()
{
	return m_pDigitalOutputs;
}

CAnalogInputs* CChannelPackage::GetAIChannels()
{
	return m_pAnalogInputs;
}

CAnalogOutputs* CChannelPackage::GetAOChannels()
{
	return m_pAnalogOutputs;
}

XDigitalInput* CChannelPackage::GetDIChannel(CString sName)
{
	return m_pDigitalInputs->GetInstance( sName );
}

XDigitalOutput* CChannelPackage::GetDOChannel(CString sName)
{
	return m_pDigitalOutputs->GetInstance( sName );
}

XAnalogInput* CChannelPackage::GetAIChannel(CString sName)
{
	return m_pAnalogInputs->GetInstance( sName );
}

XAnalogOutput* CChannelPackage::GetAOChannel(CString sName)
{
	return m_pAnalogOutputs->GetInstance( sName );
}

