// ChannelPackage.h: interface for the CChannelPackage class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHANNELPACKAGE_H__852CD7DA_DC8F_422A_8A9E_403EF8015A66__INCLUDED_)
#define AFX_CHANNELPACKAGE_H__852CD7DA_DC8F_422A_8A9E_403EF8015A66__INCLUDED_

#include "AnalogOutputs.h"	// Added by ClassView
#include "DigitalOutputs.h"	// Added by ClassView
#include "DigitalInputs.h"	// Added by ClassView
#include "AnalogInputs.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CChannelPackage  
{
public:
	XDigitalInput*		GetDIChannel(CString sName);
	XDigitalOutput*		GetDOChannel(CString sName);
	XAnalogInput*		GetAIChannel(CString sName);
	XAnalogOutput*		GetAOChannel(CString sName);

	CDigitalInputs*		GetDIChannels();
	CDigitalOutputs*	GetDOChannels();
	CAnalogInputs*		GetAIChannels();
	CAnalogOutputs*		GetAOChannels();

	CChannelPackage(CDigitalInputs * pDis,
					CDigitalOutputs * pDos,
					CAnalogInputs * pAis,
					CAnalogOutputs * pAos);
	CChannelPackage();
	virtual ~CChannelPackage();

protected:
	CAnalogOutputs *	m_pAnalogOutputs;
	CAnalogInputs *		m_pAnalogInputs;
	CDigitalOutputs *	m_pDigitalOutputs;
	CDigitalInputs *	m_pDigitalInputs;
};

#endif // !defined(AFX_CHANNELPACKAGE_H__852CD7DA_DC8F_422A_8A9E_403EF8015A66__INCLUDED_)
