// Channels.cpp: implementation of the CChannels class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "Channels.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
int CChannels::m_nMaxNode = 0;
CIniData CChannels::m_iniConfiguration;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CChannels::CChannels()
{
	m_pConfiguration = NULL;
	m_pDevice		= NULL;
	m_bInitialized	= FALSE;
	m_nNodeEA		= 0;
	m_nNode			= -1;
}

CChannels::~CChannels()
{

}

void CChannels::SetDevice(XCtlDevice *pDevice)
{
	m_pDevice = pDevice;
}

void CChannels::SetChannelSize(int nSize)
{
	m_nChannelSize = nSize;
}

int CChannels::GetChannelSize()
{
	return m_nChannelSize;
}

BOOL CChannels::Create(XCtlDevice * pDevice)
{
	m_pDevice = pDevice;
	return TRUE;
}

void CChannels::Create(int nMaxNode)
{
	m_pConfiguration = new UINT[nMaxNode];
	for( int i = 0 ; i < nMaxNode ; i ++ )
	{
		m_pConfiguration[i] = 0;
	}
}

void CChannels::SetMapFileName(CString sName)
{
	m_sMapFileName = sName;
}

BOOL CChannels::OpenMapFile()
{
	try
	{
		if( !m_File.Open( m_sMapFileName, CFile::modeRead ) )
		{
			CString sBuf;
			sBuf.Format( "Can't open %s file", m_sMapFileName );
			AfxMessageBox( sBuf );
			return FALSE;
		}
	}
	catch( CFileException e )
	{
		CString sBuf;
		sBuf.Format( "Can't open %s file", m_sMapFileName );
		AfxMessageBox( sBuf );
		return FALSE;
	}
	return TRUE;
}

void CChannels::CloseMapFile()
{
	if( m_File != NULL ) 
		m_File.Close();
}


int CChannels::GetNodeEA()
{
	return m_nNodeEA;
}

UINT * CChannels::GetConfiguration()
{
	return m_pConfiguration;
}

BOOL CChannels::GetInformation(int &add, int &node, int &no ,CString &name, CString &Cpoint)
{
	CString sBuf;
	CString sAdd;	int nAdd;
	CString sno;	int nNo;
	CString snode;	int nNode;
	CString sname;
	CString sCpoint; 

	if( m_File.ReadString( sBuf ) )
	{
		sAdd	= sBuf.Mid( 0, sBuf.Find( '\t', 0 ) ); 	sBuf.Delete( 0, sAdd.GetLength() + 1 );
		snode	= sBuf.Mid( 0, sBuf.Find( '\t', 0 ) ); 	sBuf.Delete( 0, snode.GetLength() + 1 );
		sno		= sBuf.Mid( 0, sBuf.Find( '\t', 0 ) ); 	sBuf.Delete( 0, sno.GetLength() + 1 );
		sname	= sBuf.Mid( 0, sBuf.Find( '\t', 0 ) ); 	sBuf.Delete( 0, sname.GetLength() + 1 );
		sCpoint	= sBuf;

		nNode = atoi( snode );
		nAdd  = atoi( sAdd );
		nNo   = atoi( sno );

		if( m_nNode != nNode )
		{
			m_nNodeEA ++;
			m_nNode = nNode;
		}
		m_pConfiguration[nNode-1] ++;

		node	= nNode;
		add		= nAdd;
		no		= nNo;
		name	= sname;
		if( sCpoint !="" )
		Cpoint = sCpoint;

		return TRUE;
	}
	else 
		return FALSE;
}

int CChannels::GetChannelEAFromMapFile()
{
	CString sBuf;
	CString sadd;	int nAdd;
	CString sno;	//int nNo;
	CString snode;	int nNode;
	CString sname;

	int nCount = 0;
	while( m_File.ReadString( sBuf ) )
	{
		sadd	= sBuf.Mid( 0, sBuf.Find( '\t', 0 ) ); 	sBuf.Delete( 0, sadd.GetLength() + 1 );
		snode	= sBuf.Mid( 0, sBuf.Find( '\t', 0 ) ); 	sBuf.Delete( 0, snode.GetLength() + 1 );
		sno		= sBuf.Mid( 0, sBuf.Find( '\t', 0 ) ); 	sBuf.Delete( 0, sno.GetLength() + 1 );
		sname	= sBuf;

		nNode = atoi( snode );
		nAdd  = atoi( sadd );
		if( sadd.GetLength() > 0 ) nCount ++;
	}
	return nCount;
}

void CChannels::SetMaxNodeSize(int nMaxNode)
{
	m_nMaxNode = nMaxNode;
}

int CChannels::GetMaxNodeSize()
{
	return m_nMaxNode;
}

void CChannels::ReadMaxNodeSize()
{
	CString sBuf;
	m_iniConfiguration.Open( "Channels", "SYSTEM" );
	sBuf = m_iniConfiguration.GetStringValue( "Device Net", "Max Node Size", "0" );
	m_iniConfiguration.SetStringValue( "Device Net", "Max Node Size", sBuf, TRUE );
	m_nMaxNode = atoi( sBuf );
	
	if( m_nMaxNode <= 0 ) 
	{
		sBuf.Format( "Bus Node count is zero. Type in node size" );
		AfxMessageBox( sBuf );
		// Է Code ʿ.
	}
}
