// Device.cpp: implementation of the CDevice class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "Device.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CStringList CDevice::m_slDeviceNames;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CDevice::CDevice() : m_Pi( 3.1415926535 )
{
	m_bInitialized	= FALSE;
	m_pSecKeyList = NULL;
}

CDevice::~CDevice()
{
	if( m_pSecKeyList )
	{
		CStringList* pSectionList = GetSectionList();
		for( int i=0; i<pSectionList->GetCount(); i++ ) delete m_pSecKeyList[i];
		delete []m_pSecKeyList;
	}
}

void CDevice::SetName(CString sName)
{
	m_sName = sName;
}

CString CDevice::GetName()
{
	return m_sName;
}

CDevice& CDevice::operator = (const CDevice &device)
{
	m_sName				= device.m_sName;
	m_bInitialized		= device.m_bInitialized;
	//m_IniConfiguration	= device.m_IniConfiguration;
	return *this;
}

BOOL CDevice::AddDeviceName2List(CString sName)
{
	POSITION pos;
	pos = m_slDeviceNames.Find( sName );
	if( pos != NULL )
	{
		CString sBuf;
		sBuf.Format( "%s is already created", sName );
		AfxMessageBox( sBuf );
		return FALSE;
	}
	m_slDeviceNames.InsertAfter( m_slDeviceNames.GetTailPosition(), sName );
	return TRUE;
}

BOOL CDevice::ReadConfiguration()
{
	// I'm virtual function! Please re-define me~
	return TRUE;
}

void CDevice::NewSectionKeyList()
{
	m_pSecKeyList = NULL;
	CStringList* pSectionList = GetSectionList();
	m_pSecKeyList = new CStringList*[pSectionList->GetCount()];
	int i;

	for( i=0; i<pSectionList->GetCount(); i++ )
	{
		m_pSecKeyList[i] = NULL;
		m_pSecKeyList[i] = new CStringList();	
	}

	CString sSecName, sKeyVal;
	POSITION keypos, keypos1;
	CStringList* pKeyList;
	keypos = pSectionList->GetHeadPosition();
	for( i=0; i<pSectionList->GetCount(); i++ )
	{
		sSecName = pSectionList->GetAt( keypos );
		pKeyList = GetKeyList( sSecName );

		keypos1 = pKeyList->GetHeadPosition();
		for( int j=0; j<pKeyList->GetCount(); j++ )
		{
			sKeyVal = pKeyList->GetAt( keypos1 );
			m_pSecKeyList[i]->AddTail( sKeyVal );
			pKeyList->GetNext( keypos1 );
		}
		pSectionList->GetNext( keypos );
	}
}

void CDevice::SetChannelPackage(CChannelPackage * p)
{
	m_pChannelPackage = p;
}

CStringList* CDevice::GetSectionList()
{
	return m_IniConfiguration.GetSectionList();
}

CStringList* CDevice::GetKeyList(CString sSectionName)
{
	return m_IniConfiguration.GetKeyList( sSectionName );
}

CStringList* CDevice::GetSectionListPoint()
{
	return m_IniConfiguration.m_pSectionList;
}

CStringList** CDevice::GetSectionKeyList()
{
	return m_pSecKeyList;
}

void CDevice::SetIniStringValue(CString sSection, CString sKey, CString sVal)
{
	m_IniConfiguration.SetStringValue( sSection, sKey, sVal, TRUE );
}

int CDevice::GetKeyCount(LPCTSTR sKeyName)
{
	return m_IniConfiguration.GetKeyList( sKeyName )->GetCount();
}

void CDevice::FileOpen(CString sName, CString sDir)
{
	m_IniConfiguration.Open( sName, sDir );
}
