// Device.h: interface for the CDevice class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DEVICE_H__2B12886B_E0EF_4D91_8998_A22599709DFD__INCLUDED_)
#define AFX_DEVICE_H__2B12886B_E0EF_4D91_8998_A22599709DFD__INCLUDED_

#include "IniData.h"	// Added by ClassView
#include "ChannelPackage.h"	// Added by ClassView
#include "..\X\XMmc.h"
#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\DicsData.h"	// SanghoCho 2015.04.30

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDevice  
{
public:
	CDicsData *			m_pDicsData;

	void FileOpen( CString sName, CString sDir);
	int GetKeyCount(LPCTSTR sKeyName);
	void SetIniStringValue(CString sSection, CString sKey, CString sVal);
	CStringList* GetKeyList(CString sSectionName);
	CStringList* GetSectionList();
	CStringList* GetSectionListPoint();
	CStringList** GetSectionKeyList();
	void NewSectionKeyList();
	void SetChannelPackage(CChannelPackage * p);
	void SetMmc( XMmc* pMmc ) { m_pMmc = pMmc; }
	void SetDevice(XCtlDevice* pDevice) { m_pDevice = pDevice; }
	void SetDicsData(CDicsData* pData) { m_pDicsData = pData; }

	const double m_Pi;
	CString GetName();
	void SetName(CString sName);
	virtual BOOL ReadConfiguration();
	CDevice();
	virtual ~CDevice();
	CDevice& operator = (const CDevice &device);

protected:
	XMmc *				m_pMmc; 
	XCtlDevice *		m_pDevice;
	CChannelPackage *	m_pChannelPackage;
	CIniData m_IniConfiguration;
	CIniData m_IniConfigurationSetup;
	CStringList**	m_pSecKeyList;

	BOOL AddDeviceName2List(CString sName);
	
	BOOL IsInitialized()
	{
		if( !m_bInitialized )
		{
			CString sBuf;
			sBuf.Format( "%s is not initialized", m_sName );
			return FALSE;
		}
		else 
			return TRUE;
	};
	BOOL m_bInitialized;
	CString m_sName;

private:
	static CStringList m_slDeviceNames;
};

#endif // !defined(AFX_DEVICE_H__2B12886B_E0EF_4D91_8998_A22599709DFD__INCLUDED_)
