// DigitalInpus.cpp: implementation of the CDigitalInputs class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "DigitalInputs.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CDigitalInputs::CDigitalInputs(int nChannelSize)
{
	m_pDi = NULL;
	m_pDiSpare = NULL;
	if( m_bInitialized )
	{
		AfxMessageBox( "DigitalInputs Initialized job is already done!" );
		return;
	}
	m_nChannelSize = nChannelSize;
}

CDigitalInputs::CDigitalInputs()
{
	m_pDi = NULL;
	m_pDiSpare = NULL;
	if( m_bInitialized )
	{
		AfxMessageBox( "DigitalInputs Initialized job is already done!" );
		return;
	}
}

CDigitalInputs::~CDigitalInputs()
{
	if( m_pDi ) delete [] m_pDi;
	if( m_pDiSpare ) delete [] m_pDiSpare;
	if( m_pConfiguration ) delete [] m_pConfiguration;
}

BOOL CDigitalInputs::Create(XCtlDevice * pDevice)
{
	if( m_nMaxNode == 0 )
	{
		AfxMessageBox( "Node size was not set. Please call CChannel::SetMaxNodeSize( nMaxNode )" );
		return FALSE;
	}

	SetDevice( pDevice );
	
	if( m_bInitialized )
	{
		AfxMessageBox( "DigitalInputs Initialized job is already done!" );
		return FALSE;
	}

	CChannels::Create( m_nMaxNode );

#ifdef _BUFTANK_USE
	SetMapFileName( "D:\\DICS\\IO Information\\DI MAP BUFTANK.txt" );
#else
	SetMapFileName( "D:\\DICS\\IO Information\\DI MAP.txt" );
#endif
	OpenMapFile();
	m_nChannelSize = GetChannelEAFromMapFile();
	if( m_nChannelSize > 0 )
		m_pDi = new XDigitalInput[m_nChannelSize];
	m_pDiSpare = new XDigitalInput[1];
	CloseMapFile();

	int nAdd;
	int nNo; 
	int nNode;
	CString sName;
	CString sCpoint;
	OpenMapFile();
	if( m_nChannelSize > 0 )
	{
		while( GetInformation( nAdd, nNode, nNo, sName,sCpoint  ) )
		{
			m_pDi[nAdd].Create( m_pDevice, nAdd, nNode, nNo, sName, sCpoint);
		}
	}
	CloseMapFile();
	if( m_nChannelSize > 0 )
		m_bInitialized = TRUE;
	else 
		m_bInitialized = FALSE;
	
	return TRUE;	
}

XDigitalInput* CDigitalInputs::GetInstance(CString sName)
{
	if( !m_bInitialized ) return NULL;

	XDigitalInput* p;
	for( int i = 0 ; i < m_nChannelSize ; i ++ )
	{
		if( m_pDi[i].GetName() == sName )
		{
			p = &m_pDi[i];
			p->SetDeviceLink( TRUE );
			return p;
		}
	}
	if( sName == "di_SPARE" ) return m_pDiSpare;
	return NULL;
}

XDigitalInput* CDigitalInputs::GetInstance(int nAdd)
{
	if( !m_bInitialized ) return NULL;

	if( nAdd < 0 || m_nChannelSize <= nAdd ) return NULL;

	XDigitalInput* p;
	p = &m_pDi[nAdd];

	return p;
}
