// DigitalOutputs.cpp: implementation of the CDigitalOutputs class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "DigitalOutputs.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDigitalOutputs::CDigitalOutputs(int nChannelSize)
{
	m_pDo = NULL;
	m_pDoSpare = NULL;
	if( m_bInitialized )
	{
		AfxMessageBox( "CDigitalOutputs Initialized job is already done!" );
		return;
	}
	m_nChannelSize = nChannelSize;
}

CDigitalOutputs::CDigitalOutputs()
{
	m_pDo = NULL;
	m_pDoSpare = NULL;
}

CDigitalOutputs::~CDigitalOutputs()
{
	if( m_pDo ) delete [] m_pDo;
	if( m_pDoSpare ) delete [] m_pDoSpare;
	if( m_pConfiguration ) delete [] m_pConfiguration;
}

BOOL CDigitalOutputs::Create(XCtlDevice * pDevice)
{
	if( m_nMaxNode == 0 )
	{
		AfxMessageBox( "Node size was not set. Please call CChannel::SetMaxNodeSize( nMaxNode )" );
		return FALSE;
	}

	SetDevice( pDevice );
	if( m_bInitialized )
	{
		AfxMessageBox( "DigitalInputs Initialized job is already done!" );
		return FALSE;
	}

	CChannels::Create( m_nMaxNode );

#ifdef _BUFTANK_USE
	SetMapFileName( "D:\\DICS\\IO Information\\DO MAP BUFTANK.txt" );
#else
	SetMapFileName( "D:\\DICS\\IO Information\\DO MAP.txt" );
#endif
	OpenMapFile();
	m_nChannelSize = GetChannelEAFromMapFile();
	if( m_nChannelSize > 0 )
		m_pDo = new XDigitalOutput[m_nChannelSize];
	m_pDoSpare = new XDigitalOutput[1];

	CloseMapFile();

	int nAdd;
	int nNo; 
	int nNode;
	CString sName;
	CString sCpoint;
	OpenMapFile();
	if( m_nChannelSize > 0 )
	{
		while( GetInformation( nAdd, nNode, nNo, sName,sCpoint ) )
		{
			m_pDo[nAdd].Create( m_pDevice, nAdd, nNode, nNo, sName );
		}
	}
	CloseMapFile();
	m_bInitialized = TRUE;
	
	return TRUE;	
}

XDigitalOutput* CDigitalOutputs::GetInstance(CString sName)
{
	XDigitalOutput * p;
	for( int i = 0 ; i < m_nChannelSize ; i ++ )
	{
		if( m_pDo[i].GetName() == sName )
		{
			p = &m_pDo[i];
			p->SetDeviceLink( TRUE );
			return p;
		}
	}
	if( sName == "do_SPARE" ) return m_pDoSpare;
	return NULL;
}
