// EqpAssy.h: interface for the CEqpAssy class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EQPASSY_H__C9A3DE86_DA5A_489C_B30E_174062CAB692__INCLUDED_)
#define AFX_EQPASSY_H__C9A3DE86_DA5A_489C_B30E_174062CAB692__INCLUDED_

#include "AnalogInputs.h"	// Added by ClassView
#include "AnalogOutputs.h"	// Added by ClassView
#include "DigitalOutputs.h"	// Added by ClassView
#include "DigitalInputs.h"	// Added by ClassView
#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\X\XMmc.h"
#include "..\DicsData.h"	// SanghoCho 2015.04.30

#include "Device.h"

#include "FaDigitalInput.h"
#include "FaDigitalOutput.h"
#include "FaAnalogInput.h"
#include "FaAnalogOutput.h"
#include "FaGlassExist.h"
#include "FaServoPosSensor.h"
#include "FaCylinder.h"
#include "FaDcMotor.h"
#include "FaInterfaceSignal.h"
#include "FaScanBrokenSensor.h"
#include "FaSwitch.h"
#include "FaTank.h"
#include "FaHpmj.h"
#include "FaPlasma.h"
#include "FaGsEuv.h"
#include "FaUshioEuv.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEqpAssy  
{
protected:
	CPtrArray*		m_pDeviceArray;
	XCtlDevice *	m_pDevice;
	XMmc*			m_pMmc;
	CDicsData*		m_pDicsData;
public:

	CDevice* GetDeviceFromDeviceArray(CString sDeviceName);
	CChannelPackage* m_pChannelPackage;

	enum
	{
		actSTOP = -1,
		actBW = 0,
		actFW = 1,
		actDN = 0,
		actUP = 1,
		actOFF = 0,
		actON = 1,
	};
/////Common Device///////////////////////////////////////////////////////
	CFaDigitalInput		m_PowerConfirm;
	CFaDigitalInput		m_PowerConfirm2;
	CFaDigitalInput		m_SwitchEmo;
	CFaDigitalInput		m_SwitchEms;
	CFaSwitch			m_SwitchBuzzerOff;
	CFaSwitch			m_SwitchAlarmReset;
	CFaDigitalOutput	m_TowerLamp;
	CFaDigitalOutput	m_Melody;
	CFaDigitalInput		m_SensorDoor;
	CFaDigitalInput		m_LdSensorDoor;
	CFaDigitalInput		m_UlSensorDoor;	
	CFaDigitalInput		m_SensorCover;
	CFaDigitalInput     m_RbServoCp;
	CFaDigitalInput		m_SensorLeak;
	CFaDigitalInput		m_SensorLeakBufTank;				//200413 hskwak BufTank Add
	CFaDigitalInput		m_SensorArea;
	CFaDigitalInput		m_SignalFfu;
	CFaDigitalInput		m_SignalIonizer;
	CFaDigitalOutput	m_OutputIonizer;
	CFaDigitalInput		m_SensorSafty;		// Safty  I/O ׷ 
	CFaDigitalOutput	m_IntegrateFlowmeter;
	CFaDigitalInput		m_SignalESD;	// hskwak 0502
//////////////////////////////////////////////////////////////////////////

/////TR Device///////////////////////////////////////////////////////
	CFaDigitalInput		m_TrJointConfirm;
	CFaCylinder			m_CylinderTrLdAlign;
	CFaCylinder			m_CylinderTrWaitAlign;
	CFaCylinder			m_CylinderTrJointUpDn;
	CFaCylinder			m_CylinderTrJointLock;
	CFaCylinder			m_CylinderTrTurn;
	CFaGlassExist		m_GlassExistTr;		//  TR Position   Ȯؾ ϹǷ

	CFaCylinder			m_CylinderUlAlignUD;	// hskwak 2019.05.09
	CFaCylinder			m_CylinderUlPinUD;		// hskwak 2019.05.09
//////////////////////////////////////////////////////////////////////////
	
/////Cassette Port Device/////////////////////////////////////////////////
	CFaSwitch			m_SwitchCstInputOK;
	CFaSwitch			m_SwitchCstOutputOK;
	CFaCylinder			m_CylinderCstClamp[MAX_PORT_NO];
	CFaCylinder			m_CylinderCstAlign[MAX_PORT_NO];
	CFaDigitalInput		m_MaskDetectSensor;
	CFaDigitalInput		m_CstDetectSensor;
//////////////////////////////////////////////////////////////////////////
	
/////DC Motor Device//////////////////////////////////////////////////////
	CFaDcMotor			m_CvMotor;
	CFaDcMotor			m_CvMotorAll;
	CFaDcMotor			m_RbMotor;
//////////////////////////////////////////////////////////////////////////
	
/////Interrupt Device/////////////////////////////////////////////////////
	CFaDigitalInput		m_SensorLdCvHandInterlock;
	CFaDigitalInput		m_SensorUlCvHandInterlock;
	CFaDigitalInput		m_SensorRobotHandInterlock;
	CFaDigitalInput		m_SensorBuf2Interlock;	// SanghoCho 2015.03.17
//	CFaDigitalInput		m_SensorBuf3Interlock;
	CFaDigitalInput		m_SensorLdUnitInterlock;
	CFaDigitalInput		m_SensorAPDStatus;	// hskwak 190812
	CFaDigitalInput		m_SensorDIAlarm;	// hskwak 191011
//////////////////////////////////////////////////////////////////////////
	
/////Glass Exist Sensor Device////////////////////////////////////////////
	CFaGlassExist		m_GlassExistUnit;	//	MAX_UNIT_NO
	CFaGlassExist		m_GlassExistUnitIn;
	CFaGlassExist		m_GlassExistUnitOut;
	CFaGlassExist		m_GlassExistServo;	//	Servo(TR,UP,LO Hand Glass )
	CFaGlassExist		m_FixedBrokenSensorUpLd;  // SanghoCho 2015.04.14
	CFaGlassExist		m_FixedBrokenSensorLd;
	CFaGlassExist		m_FixedBrokenSensorUl;
	CFaScanBrokenSensor	m_ScanBrokenSensorUpLd;  // SanghoCho 2015.04.14
	CFaScanBrokenSensor	m_ScanBrokenSensorLd;
	CFaScanBrokenSensor	m_ScanBrokenSensorUl;
//	CFaScanBrokenSensor	m_ScanBrokenSensorBuf3;	// 110412 halesu
//	CFaScanBrokenSensor	m_ScanBrokenSensorCcd;	// 120111 halesu
//	CFaDigitalInput		m_GlassExistDecelSensorLd;	// SanghoCho 2015.03.16
//	CFaDigitalInput		m_GlassExistDecelSensorUl;	// SanghoCho 2015.03.16
	CFaGlassExist		m_GlassExistAccelSensorUl;	// hskwak 19.05.09
	CFaGlassExist		m_GlassExistDecelSensorUl;	// hskwak 19.05.09
//////////////////////////////////////////////////////////////////////////
	
/////Servo Position Sensor Device/////////////////////////////////////////
	CFaServoPosSensor	m_PosSensorHandMainView;	//	Servo(TR,UP,LO Hand Position Sensor)
	CFaServoPosSensor	m_PosSensorTr;
	CFaServoPosSensor	m_PosSensorLdUp;
	CFaServoPosSensor	m_PosSensorLdLo;
	CFaServoPosSensor	m_PosSensorUlLo;
	CFaServoPosSensor	m_PosSensorUlUp;
	CFaServoPosSensor	m_PosSensorLdUnit;
	CFaServoPosSensor	m_PosSensorUlHand;
//////////////////////////////////////////////////////////////////////////

/////Cylinder Device//////////////////////////////////////////////////////
	CFaCylinder			m_CylinderLdAlign;
	CFaCylinder			m_CylinderUlAlign;
	CFaCylinder			m_CylinderLdFishBone;
	CFaCylinder			m_CylinderUlFishBone;
	CFaCylinder			m_CylinderChemicalShutter;
	CFaCylinder			m_CylinderLdTilt;
	CFaCylinder			m_CylinderUlTilt;
	CFaCylinder			m_CylinderUlHand;
//////////////////////////////////////////////////////////////////////////
	
/////IF Signal Device//////////////////////////////////////////////////////
	CFaInterfaceSignal	m_IfUpStream;
	CFaInterfaceSignal	m_IfDnStream;
	CFaInterfaceSignal	m_IfLoader;
//////////////////////////////////////////////////////////////////////////
	
/////Analog Input Device//////////////////////////////////////////////////////
	CFaAnalogInput		m_AnalogInput;
	CFaAnalogInput		m_AnalogInputAk;
	CFaAnalogInput		m_AnalogInputTank;
//////////////////////////////////////////////////////////////////////////

/////Auto Valve Device//////////////////////////////////////////////////////
	CFaDigitalOutput	m_AutoValvePiping;
	CFaDigitalOutput	m_AutoValveDet;
	CFaDigitalOutput	m_AutoValveAk;
	CFaDigitalOutput	m_AutoValveAkUp;
	CFaDigitalOutput	m_AutoValveAkLo;
	CFaDigitalOutput	m_AutoValveSbjDi;
	CFaDigitalOutput	m_AutoValveSbjCda;
	CFaDigitalOutput	m_AutoValveAcCda;
	CFaDigitalOutput	m_AutoValveFrShower;
	CFaDigitalOutput	m_AutoValveSwr1Shower;
	CFaDigitalOutput	m_AutoValveSwr2Shower;

	CFaDigitalOutput	m_AutoValvePumpOut;
#ifdef _BUFTANK_USE
	CFaDigitalOutput	m_AutoValveBufTankPumpOut;
#endif
	CFaDigitalOutput	m_AutoValveDirect;

	CFaDigitalOutput	m_AutoValveDrvAir;
	CFaDigitalOutput	m_AutoValveRbShower;
	CFaDigitalOutput	m_AutoValveGearSupply;
	CFaDigitalOutput	m_AutoValveMistNozzle;
	CFaDigitalOutput	m_AutoValveHotDiBathDrain;
	CFaDigitalOutput	m_AutoValueSWR2BathDrain;		// hskwak 0502
	CFaDigitalOutput	m_AutoValueSWR2TankReturn;		// hskwak 0502
//////////////////////////////////////////////////////////////////////////

/////TANK Device//////////////////////////////////////////////////////
	CFaTank				m_DiTank[MAX_DI_TANK_NO];
	CFaTank				m_HotDiTank[MAX_HOT_DI_TANK_NO];
	CFaTank				m_DetTank[MAX_MIX_TANK_NO];
//////////////////////////////////////////////////////////////////////////
	
/////EUV Device//////////////////////////////////////////////////////
	CFaUshioEuv			m_UshioEuv;
	CFaGsEuv			m_GsEuv;
	CFaDigitalOutput	m_AutoValveEuv;
	CFaDigitalOutput	m_AutoValveEuvN2;
	CFaDigitalOutput	m_AutoValveEuvHumN2;
	CFaDigitalOutput	m_AutoValveEuvPcw;
	CFaDigitalOutput	m_AutoValveEuvCda;
	CFaDigitalInput		m_SensorEuvHouseClose;
	CFaCylinder			m_CylinderEuvUpDn;
//////////////////////////////////////////////////////////////////////////

/////HPMJ Device//////////////////////////////////////////////////////////
	CFaHpmj				m_Hpmj;
//////////////////////////////////////////////////////////////////////////

/////Plasma Device//////////////////////////////////////////////////////////
	CFaPlasma			m_Plasma;
//////////////////////////////////////////////////////////////////////////

/////Timer Device///////////////////////////////////////////////////// halesu
	CFaDigitalOutput		m_TimerStart;
	CFaDigitalOutput		m_TimerReset;
//////////////////////////////////////////////////////////////////////////

////Loader EMO////////////////////////////////////////////////////////////
	CFaDigitalOutput		m_LoaderEmo;
	CFaDigitalInput			m_IFLoaderEmo;	// SanghoCho 2015.05.04
//////////////////////////////////////////////////////////////////////////

	CPtrArray* GetDeviceArray();
	BOOL Initialize();
	CDigitalInputs	* m_pDi;
	CDigitalOutputs * m_pDo;
	CAnalogInputs	* m_pAi;
	CAnalogOutputs	* m_pAo;
	void SetDevice(XCtlDevice* pDevice);
	void SetMmc( XMmc* pMmc ) { m_pMmc = pMmc; }
	void SetDicsData(CDicsData* pData) { m_pDicsData = pData; }
	CEqpAssy(CDigitalInputs * pDi, CDigitalOutputs * pDo, CAnalogInputs * pAi, CAnalogOutputs * pAo);
	CEqpAssy();
	virtual ~CEqpAssy();
private:
	void AddDevice(void* newDevice, CString sName);
	void AddDeviceToArray(void* newElement);
};
#endif // !defined(AFX_EQPASSY_H__C9A3DE86_DA5A_489C_B30E_174062CAB692__INCLUDED_)
