// FaAnalogOutput.cpp: implementation of the CFaAnalogOutput class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "FaAnalogOutput.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFaAnalogOutput::CFaAnalogOutput()
{
	m_nAoCount = 0;
	m_bInitialized = FALSE;
	m_pAo = NULL;
}

CFaAnalogOutput::~CFaAnalogOutput()
{
	if( m_bInitialized )
		delete []m_pAo;
}

BOOL CFaAnalogOutput::ReadConfiguration()
{
	CString sSetupFile;
	sSetupFile.Format("%s SETUP", m_sName);
	m_IniConfigurationSetup.Open( sSetupFile, "Configuration" );
	CString sDeviceUse = m_IniConfigurationSetup.GetStringValue( "DEVICE USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "DEVICE USE", "VALUE", "NO", TRUE );
		return FALSE;
	}

	m_IniConfiguration.Open( m_sName, "Configuration" );

	CString sBuf;
	CString sName;
	// Read Channel information & Initialize Sections and Keys
	CStringList *pKeyList;
//	///////////////////////////////////////////////////////////////////////////////////////////
//	///////////////////////////////////////////////////////////////////////////////////////////
	BOOL bAoInit = TRUE;
	pKeyList = GetKeyList( "AI" );
	m_nAoCount = pKeyList->GetCount();
	if( m_nAoCount == 0 )	m_pAo = new XAnalogOutput*[1];
	else m_pAo = new XAnalogOutput*[m_nAoCount];

	if( m_nAoCount == 0 )
	{
		sName.Format( "OUTPUT[%d]",0);
		m_IniConfiguration.SetStringValue( "AO", sName, "ao_SPARE", TRUE );
		pKeyList = GetKeyList( "AO" );
		m_nAoCount = pKeyList->GetCount();
	}
	for( int i=0; i<m_nAoCount; i++)
	{
		sName.Format( "OUTPUT[%d]",i);
		sBuf = m_IniConfiguration.GetStringValue( "AO", sName, "ao_SPARE" );
		m_pAo[i] = m_pChannelPackage->GetAOChannel( sBuf );
		m_IniConfiguration.SetStringValue( "AO", sName, sBuf, TRUE );

		if( m_pAo[i] != NULL )
		{
			m_pAo[i]->AddConnectingObjectName( m_sName );
			bAoInit &= bAoInit;
		}
		else bAoInit = FALSE;
	}
//	///////////////////////////////////////////////////////////////////////////////////////////
//	///////////////////////////////////////////////////////////////////////////////////////////

	m_bInitialized = bAoInit;

	if( !m_bInitialized ) 
	{
		sBuf.Format( "FA Analog Output [%s] ReadConfiguration Failed.", m_sName );
		AfxMessageBox( sBuf );
	}
	return TRUE;
}

void CFaAnalogOutput::Set( int nNo, WORD wVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nAoCount ) ||
		( !m_pAo[nNo]->IsDeviceLink() ) ) return;

	m_pAo[nNo]->Set( wVal );
}

float CFaAnalogOutput::Get( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nAoCount ) ||
		( !m_pAo[nNo]->IsDeviceLink() ) ) return 0.0;

	return m_pAo[nNo]->Get();
}
