// FaCylinder.h: interface for the CFaCylinder class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FACYLINDER_H__8C3753F6_6D00_4B4B_91FD_AC1A698478BE__INCLUDED_)
#define AFX_FACYLINDER_H__8C3753F6_6D00_4B4B_91FD_AC1A698478BE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"

class CFaCylinder : public CDevice  
{
public:
	void SetStop();
	CFaCylinder();
	virtual ~CFaCylinder();

	BOOL ReadConfiguration();
	void SetFw();
	void SetBw();
	BOOL GetFw();
	BOOL GetBw();
	void SetFw( int nNo, BOOL bVal=FALSE );
	void SetBw( int nNo, BOOL bVal=FALSE );
	BOOL GetFw( int nNo );
	BOOL GetBw( int nNo );
	INT GetBwTime( int nNo );
	INT GetFwTime( int nNo );

	void SetFwState();
	void SetBwState();
	BOOL GetFwState();
	BOOL GetBwState();
	void SetFwState( int nNo, BOOL bVal=FALSE );
	void SetBwState( int nNo, BOOL bVal=FALSE );
	BOOL GetFwState( int nNo );
	BOOL GetBwState( int nNo );

	int	GetDiSize() { return m_nDiFwCount; }
	int	GetDoSize() { return m_nDoFwCount; }

	int m_nActionTime[2];

protected:
	XDigitalInput**		m_pDiFw;
	XDigitalInput**		m_pDiBw;
	XDigitalOutput**	m_pDoFw;
	XDigitalOutput**	m_pDoBw;
	INT * m_nTimeoutFw;
	INT * m_nTimeoutBw;

	int m_nDiFwCount;
	int m_nDiBwCount;
	int m_nDoFwCount;
	int m_nDoBwCount;
	int m_nTimeoutFwCount;
	int m_nTimeoutBwCount;
};

#endif // !defined(AFX_FACYLINDER_H__8C3753F6_6D00_4B4B_91FD_AC1A698478BE__INCLUDED_)
