// FaDcMotor.h: interface for the CFaDcMotor class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FADCMOTOR_H__BBE644BA_21E3_4D2A_B0EA_CDDED552B151__INCLUDED_)
#define AFX_FADCMOTOR_H__BBE644BA_21E3_4D2A_B0EA_CDDED552B151__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"

class CFaDcMotor : public CDevice  
{
public:
	CFaDcMotor();
	virtual ~CFaDcMotor();

	enum _MOTOR_ACT_STATE
	{
		actSTOP = -1,
		actBW = 0,
		actFW = 1,
	};

	BOOL ReadConfiguration();
	void SetMaxSectionNo(int nNo=0);
	int GetMaxSectionNo();

	//   FBL Motor Function	//////////////////////////////////////////
	BOOL GetMotorCpAlarm(int nUnit);
	BOOL GetMotorAlarm(int nUnit);
	void SetMotorFw(int nUnit, BOOL bVal=FALSE);
	void SetMotorBw(int nUnit, BOOL bVal=FALSE);
	void SetMotorSpeed(int nUnit, int nMmSec=0);
	void SetMotorRpm(int nUnit, int nRpm=0);

	void SetSpeedScale(int nUnit, double dSpeedScale=0);
	void SetSpeedOffset(int nUnit, double dSpeedOffset=0);
	void SetGearRatio(int nUnit, double dRatio=0);
	void SetRollerDiameter(int nUnit, double dDiameter=0);

	BOOL GetMotorCpAlarm(int nUnit, int nNo);
	BOOL GetMotorAlarm(int nUnit, int nNo);
	void SetMotorFw(int nUnit, int nNo, BOOL bVal);
	void SetMotorBw(int nUnit, int nNo, BOOL bVal);
	void SetMotorSpeed(int nUnit, int nNo, int nMmSec);
	void SetMotorRpm(int nUnit, int nNo, int nRpm);

	void SetSpeedScale(int nUnit, int nNo, double dSpeedScale);
	void SetSpeedOffset(int nUnit, int nNo, double dSpeedOffset);
	void SetGearRatio(int nUnit, int nNo, double dRatio);
	void SetRollerDiameter(int nUnit, int nNo, double dDiameter);
	//////////////////////////////////////////////////////////////////////
	//   FBL Motor State Function	//////////////////////////////////////////
	void SetMotorCpAlarmState(int nUnit=0, BOOL bVal=FALSE);
	void SetMotorAlarmState(int nUnit=0, BOOL bVal=FALSE);

	void SetMotorCpAlarmState(int nUnit=0, int nNo=0, BOOL bVal=FALSE);
	void SetMotorAlarmState(int nUnit=0, int nNo=0, BOOL bVal=FALSE);
	BOOL GetMotorFwState(int nUnit=0, int nNo=0);
	BOOL GetMotorBwState(int nUnit=0, int nNo=0);
	WORD GetMotorSpeed(int nUnit=0, int nNo=0);
	WORD GetMotorRpm(int nUnit=0, int nNo=0);

	double GetSpeedScale(int nUnit=0, int nNo=0);
	double GetSpeedOffset(int nUnit=0, int nNo=0);
	double GetGearRatio(int nUnit=0, int nNo=0);
	double GetRollerDiameter(int nUnit=0, int nNo=0);
	//////////////////////////////////////////////////////////////////////

protected:
	XDigitalInput***	m_pDiCpAlarm;
	XDigitalInput***	m_pDiMotorAlarm;
	XDigitalOutput***	m_pDoMotorFw;
	XDigitalOutput***	m_pDoMotorBw;
	XAnalogOutput***	m_pAoMotorSpeed;

	double ** m_dRollerDia;
	double ** m_dGearRatio;
	double ** m_dSpeedOffset;	// Default : 0, For speed offset 
	double ** m_dSpeedScale;	// Default : 1, For speed scale
	WORD**	m_wMotorSpeed;
	WORD**	m_wMotorRpm;
	
	int*	m_nUnitMotorCount;
	int		m_nMaxSectionNo;
	int		m_nMaxMotorRpm;
};

#endif // !defined(AFX_FADCMOTOR_H__BBE644BA_21E3_4D2A_B0EA_CDDED552B151__INCLUDED_)
