// FaDigitalInput.cpp: implementation of the CFaDigitalInput class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "FaDigitalInput.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFaDigitalInput::CFaDigitalInput()
{
	m_nDiCount = 0;
	m_bInitialized = FALSE;
	m_pDi = NULL;
}

CFaDigitalInput::~CFaDigitalInput()
{
	if( m_bInitialized )
	{
		delete []m_pDi;
	}
}

BOOL CFaDigitalInput::ReadConfiguration()
{
	CString sSetupFile;
	sSetupFile.Format("%s SETUP", m_sName);
	m_IniConfigurationSetup.Open( sSetupFile, "Configuration" );
	CString sDeviceUse = m_IniConfigurationSetup.GetStringValue( "DEVICE USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "DEVICE USE", "VALUE", "NO", TRUE );
		return FALSE;
	}

	m_IniConfiguration.Open( m_sName, "Configuration" );

	CString sBuf;
	CString sName;
	// Read Channel information & Initialize Sections and Keys
	CStringList *pKeyList;
//	///////////////////////////////////////////////////////////////////////////////////////////
//	///////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDiInit = TRUE;
	pKeyList = GetKeyList( "DI" );
	m_nDiCount = pKeyList->GetCount();
	if( m_nDiCount == 0 )	m_pDi = new XDigitalInput*[1];
	else m_pDi = new XDigitalInput*[m_nDiCount];

	if( m_nDiCount == 0 )
	{
		sName.Format( "INPUT[%d]",0);
		m_IniConfiguration.SetStringValue( "DI", sName, "di_SPARE", TRUE );
		pKeyList = GetKeyList( "DI" );
		m_nDiCount = pKeyList->GetCount();
	}
	for( int i=0; i<m_nDiCount; i++)
	{
		sName.Format( "INPUT[%d]",i);
		sBuf = m_IniConfiguration.GetStringValue( "DI", sName, "di_SPARE" );
		m_pDi[i] = m_pChannelPackage->GetDIChannel( sBuf );
		m_IniConfiguration.SetStringValue( "DI", sName, sBuf, TRUE );

		if( m_pDi[i] != NULL )
		{
			m_pDi[i]->AddConnectingObjectName( m_sName );
			bDiInit &= bDiInit;
		}
		else bDiInit = FALSE;
	}
//	///////////////////////////////////////////////////////////////////////////////////////////
//	///////////////////////////////////////////////////////////////////////////////////////////

	m_bInitialized = bDiInit;

	if( !m_bInitialized ) 
	{
		sBuf.Format( "FA Digital Input [%s] ReadConfiguration Failed.", m_sName );
		AfxMessageBox( sBuf );
	}

	return TRUE;
}

BOOL CFaDigitalInput::Get(int nNo)
{
	if( !IsInitialized() ||
		( nNo >= m_nDiCount ) ||
		( !m_pDi[nNo]->IsDeviceLink() ) ) return FALSE;

	return ( m_pDi[nNo]->Get() );
}

BOOL CFaDigitalInput::GetAnd()
{
	if( !IsInitialized() ) return FALSE;

	BOOL bFlg = TRUE;
	for( int i=0; i<m_nDiCount; i++ ) bFlg &= Get( i );
	return bFlg;
}

BOOL CFaDigitalInput::GetOr()
{
	if( !IsInitialized() ) return FALSE;

	BOOL bFlg = FALSE;
	for( int i=0; i<m_nDiCount; i++ ) bFlg |= Get( i );
	return bFlg;
}

void CFaDigitalInput::SetState(int nNo, BOOL bVal)
{
	if( !IsInitialized() ||
		( nNo >= m_nDiCount ) ||
		( !m_pDi[nNo]->IsDeviceLink() ) ) return;
	
	m_pDi[nNo]->SetState( bVal );
}


BOOL CFaDigitalInput::GetType( int nNo )		// hskwak 20191010 Input A/B Type ȯ - A=0 B=1
{
	if( m_pDi[nNo]->GetConnectPoint() == "B" )	return TRUE;
	else										return FALSE;
}