// FaDigitalOutput.cpp: implementation of the CFaDigitalOutput class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "FaDigitalOutput.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFaDigitalOutput::CFaDigitalOutput()
{
	m_nDoCount = 0;
	m_bInitialized = FALSE;
	m_pDo = NULL;
}

CFaDigitalOutput::~CFaDigitalOutput()
{
	if( m_bInitialized )
		delete []m_pDo;
}

BOOL CFaDigitalOutput::ReadConfiguration()
{
	CString sSetupFile;
	sSetupFile.Format("%s SETUP", m_sName);
	m_IniConfigurationSetup.Open( sSetupFile, "Configuration" );
	CString sDeviceUse = m_IniConfigurationSetup.GetStringValue( "DEVICE USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "DEVICE USE", "VALUE", "NO", TRUE );
		return FALSE;
	}

	m_IniConfiguration.Open( m_sName, "Configuration" );

	CString sBuf;
	CString sName;
	// Read Channel information & Initialize Sections and Keys
	CStringList *pKeyList;
//	///////////////////////////////////////////////////////////////////////////////////////////
//	///////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDoInit = TRUE;
	pKeyList = GetKeyList( "DO" );
	m_nDoCount = pKeyList->GetCount();
	if( m_nDoCount == 0 )	m_pDo = new XDigitalOutput*[1];
	else m_pDo = new XDigitalOutput*[m_nDoCount];

	if( m_nDoCount == 0 )
	{
		sName.Format( "OUTPUT[%d]",0);
		m_IniConfiguration.SetStringValue( "DO", sName, "do_SPARE", TRUE );
		pKeyList = GetKeyList( "DO" );
		m_nDoCount = pKeyList->GetCount();
	}
	for( int i=0; i<m_nDoCount; i++)
	{
		sName.Format( "OUTPUT[%d]",i);
		sBuf = m_IniConfiguration.GetStringValue( "DO", sName, "do_SPARE" );
		m_pDo[i] = m_pChannelPackage->GetDOChannel( sBuf );
		m_IniConfiguration.SetStringValue( "DO", sName, sBuf, TRUE );

		if( m_pDo[i] != NULL )
		{
			m_pDo[i]->AddConnectingObjectName( m_sName );
			bDoInit &= bDoInit;
		}
		else bDoInit = FALSE;
	}
//	///////////////////////////////////////////////////////////////////////////////////////////
//	///////////////////////////////////////////////////////////////////////////////////////////

	m_bInitialized = bDoInit;

	if( !m_bInitialized ) 
	{
		sBuf.Format( "FA Digital Output [%s] ReadConfiguration Failed.", m_sName );
		AfxMessageBox( sBuf );
	}

	return TRUE;
}

void CFaDigitalOutput::Set(int nNo, BOOL bVal)
{
	if( !IsInitialized() ||
		( nNo >= m_nDoCount ) ||
		( !m_pDo[nNo]->IsDeviceLink() ) ) return;

	m_pDo[nNo]->Set( bVal );
}

BOOL CFaDigitalOutput::GetState(int nNo)
{
	if( !IsInitialized() ||
		( nNo >= m_nDoCount ) ||
		( !m_pDo[nNo]->IsDeviceLink() ) ) return FALSE;

	return m_pDo[nNo]->Get();
}

void CFaDigitalOutput::SetAll(BOOL bVal)
{
	if( !IsInitialized() ) return;

	for( int i=0; i<m_nDoCount; i++ )
		Set( i, bVal );
}
