// FaGsEuv.cpp: implementation of the CFaGsEuv class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "FaGsEuv.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFaGsEuv::CFaGsEuv()
{

}

CFaGsEuv::~CFaGsEuv()
{
}
BOOL CFaGsEuv::ReadConfiguration()
{
	CString sSetupFile;
	sSetupFile.Format("%s SETUP", m_sName);
	m_IniConfigurationSetup.Open( sSetupFile, "Configuration" );
	CString sDeviceUse = m_IniConfigurationSetup.GetStringValue( "DEVICE USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "DEVICE USE", "VALUE", "NO", TRUE );
		return FALSE;
	}


	m_IniConfiguration.Open( m_sName, "Configuration" );

	CString sBuf;

	// Read Channel information & Initialize Sections and Keys
		
	sBuf = m_IniConfiguration.GetStringValue( "DI", "GSUV_AUTO_MODE", "diSPARE" );
	m_GsUvAutoMode = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "GSUV_AUTO_MODE", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DI", "GSUV_OVER_HEAT", "diSPARE" );
	m_GsUvOverHeat = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "GSUV_OVER_HEAT", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DI", "GSUV_HOUSE_OPEN", "diSPARE" );
	m_GsUvHouseOpen = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "GSUV_HOUSE_OPEN", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DI", "GSUV_LAMP_FAULT", "diSPARE" );
	m_GsUvLampFault = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "GSUV_LAMP_FAULT", sBuf, TRUE );
	
	sBuf = m_IniConfiguration.GetStringValue( "DI", "GSUV_INVERTER_ERROR", "diSPARE" );
	m_GsUvInverterError = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "GSUV_INVERTER_ERROR", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DI", "GSUV_UTILITY_ERROR", "diSPARE" );
	m_GsUvUtyError = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "GSUV_UTILITY_ERROR", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DI", "GSUV_N2_FLOW_ERROR", "diSPARE" );
	m_GsUvN2FlowError = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "GSUV_N2_FLOW_ERROR", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DI", "GSUV_BCD_SUM_ERROR", "diSPARE" );
	m_GsUvBCDSumError = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "GSUV_BCD_SUM_ERROR", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DI", "DATA_SET_ENABLE", "diSPARE" );
	m_GsUvDataSetEnable = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "DATA_SET_ENABLE", sBuf, TRUE );
	
	sBuf = m_IniConfiguration.GetStringValue( "DI", "GSUV_MONITOR_READY", "diSPARE" );
	m_GsUvMonitorReady = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "GSUV_MONITOR_READY", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DO", "GS_EUV_LAMP_SELECT_1", "doSPARE" );
	m_GsUvLampSelect1 = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "GS_EUV_LAMP_SELECT_1", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DO", "GS_EUV_LAMP_SELECT_2", "doSPARE" );
	m_GsUvLampSelect2 = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "GS_EUV_LAMP_SELECT_2", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DO", "GS_EUV_LAMP_SELECT_3", "doSPARE" );
	m_GsUvLampSelect3 = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "GS_EUV_LAMP_SELECT_3", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DO", "GSUV_LAMP_ON", "doSPARE" );
	m_GsUvLampOn = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "GSUV_LAMP_ON", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DO", "GSUV_DATA_SET", "doSPARE" );
	m_GsUvDataSet = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "GSUV_DATA_SET", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DO", "GSUV_BCD_B1", "doSPARE" );
	m_GsUvBCDBit1 = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "GSUV_BCD_B1", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DO", "GSUV_BCD_B2", "doSPARE" );
	m_GsUvBCDBit2 = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "GSUV_BCD_B2", sBuf, TRUE );

	sBuf = m_IniConfiguration.GetStringValue( "DO", "GSUV_BCD_B3", "doSPARE" );
	m_GsUvBCDBit3 = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "GSUV_BCD_B3", sBuf, TRUE );

	BOOL bInitialized = TRUE;

	    bInitialized =	m_GsUvAutoMode != NULL  &&
						m_GsUvOverHeat != NULL  &&
						m_GsUvHouseOpen != NULL  &&
						m_GsUvLampFault != NULL  &&
						m_GsUvInverterError != NULL  &&
						m_GsUvUtyError != NULL  &&
						m_GsUvN2FlowError != NULL  &&
						m_GsUvBCDSumError != NULL  &&
						m_GsUvDataSetEnable != NULL  &&
						m_GsUvMonitorReady != NULL  &&
						m_GsUvLampSelect1 != NULL  &&						
						m_GsUvLampSelect2 != NULL  &&
						m_GsUvLampSelect3 != NULL  &&
						m_GsUvLampOn != NULL  &&
						m_GsUvDataSet != NULL  &&
						m_GsUvBCDBit1 != NULL  &&
						m_GsUvBCDBit2 != NULL  && 
						m_GsUvBCDBit3 != NULL ;

	m_bInitialized = bInitialized;

	if( NULL != m_GsUvAutoMode )		m_GsUvAutoMode->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvOverHeat )		m_GsUvOverHeat->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvHouseOpen )		m_GsUvHouseOpen->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvLampFault )		m_GsUvLampFault->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvInverterError )	m_GsUvInverterError->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvUtyError )		m_GsUvUtyError->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvN2FlowError )		m_GsUvN2FlowError->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvBCDSumError )		m_GsUvBCDSumError->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvDataSetEnable )	m_GsUvDataSetEnable->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvMonitorReady )	m_GsUvMonitorReady->AddConnectingObjectName( m_sName );

	if( NULL != m_GsUvLampSelect1 )		m_GsUvLampSelect1->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvLampSelect2 )		m_GsUvLampSelect2->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvLampSelect3 )		m_GsUvLampSelect3->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvLampOn )			m_GsUvLampOn->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvDataSet )			m_GsUvDataSet->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvBCDBit1 )			m_GsUvBCDBit1->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvBCDBit2 )			m_GsUvBCDBit2->AddConnectingObjectName( m_sName );
	if( NULL != m_GsUvBCDBit3 )			m_GsUvBCDBit3->AddConnectingObjectName( m_sName );

	if( !bInitialized ) 
	{
		sBuf.Format( "FA GS EUV [%s] ReadConfiguration Failed.", m_sName );
		AfxMessageBox( sBuf );
	}
	
	return TRUE;
}


void CFaGsEuv::SetGsUvLampOn(BOOL bAct)
{
	if( !IsInitialized() ) return;
	m_GsUvLampOn->Set( bAct );
}

void CFaGsEuv::SetGsUvLampSelect(int nLampNo, BOOL bAct)
{
	if( !IsInitialized() ) return;

	switch( nLampNo )
	{
	case lampNO1:
		m_GsUvLampSelect1->Set( bAct );
		break;
	case lampNO2:
		m_GsUvLampSelect1->Set( bAct );
		break;
	case lampNO3:
		m_GsUvLampSelect1->Set( bAct );
		break;
	}
}

int CFaGsEuv::GetGsUvLampSelect(int nLampNo )
{
	if( !IsInitialized() ) return -1 ;
	BOOL bLampOn = FALSE;
	switch( nLampNo )
	{
	case lampNO1:
		bLampOn =m_GsUvLampSelect1->Get( );
		break;
	case lampNO2:
		bLampOn = m_GsUvLampSelect1->Get( );
		break;
	case lampNO3:
		bLampOn = m_GsUvLampSelect1->Get( );
		break;
	}
	return bLampOn;
}

int CFaGsEuv::GetEuvAlarm()
{
	if( !IsInitialized() ) return -1;
	int nRv = 0;

	if( !IsRemoteMode() )				nRv |= euvAlmManualMode;	// EUV Manual Mode Alarm	
	if( m_GsUvOverHeat->Get() )			nRv |= euvAlmOverHeat;		// Lamp Over Heater Alarm
	if( m_GsUvHouseOpen->Get() )		nRv |= euvAlmLampHouseOpen; // Lamp House Open Alarm
	if( m_GsUvLampFault->Get() )		nRv |= euvAlmLampFault;		// Lamp Fault Alarm
	if( m_GsUvInverterError->Get() )	nRv |= euvAlmInverterErr;	// Inverter Alarm
	if( m_GsUvUtyError->Get() )			nRv |= euvAlmUtilityErr;	// Utility Alarm   
	if( m_GsUvN2FlowError->Get() )		nRv |= euvAlmN2Err;			// N2 Alarm
	if( m_GsUvBCDSumError->Get() )		nRv |= euvAlmSumErr;		// EUV SUM Alarm 
	return nRv;
}

BOOL CFaGsEuv::IsRemoteMode()
{
	if( !IsInitialized() ) return FALSE;
	BOOL bMode;
	bMode = ( m_GsUvAutoMode->Get() ? TRUE : FALSE );
	return bMode;
}

void CFaGsEuv::SetLampMonitorSelect(int nPos)
{

	if( !IsInitialized() ) return;
	if ( nPos == -1 )
	{
		m_GsUvBCDBit1->Set( OFF );
		m_GsUvBCDBit2->Set( OFF );
		m_GsUvBCDBit3->Set( OFF );
	}
	if ( nPos == 0 )
	{
		m_GsUvBCDBit1->Set( ON );
		m_GsUvBCDBit2->Set( OFF );
		m_GsUvBCDBit3->Set( OFF );
	}
	else if ( nPos == 1 )
	{
		m_GsUvBCDBit1->Set( OFF );
		m_GsUvBCDBit2->Set( ON );
		m_GsUvBCDBit3->Set( OFF );

	}
	else if ( nPos == 2 )
	{
		m_GsUvBCDBit1->Set( ON );
		m_GsUvBCDBit2->Set( ON );
		m_GsUvBCDBit3->Set( OFF );
	}
	else if ( nPos == 3 )
	{
		m_GsUvBCDBit1->Set( OFF );
		m_GsUvBCDBit2->Set( OFF );
		m_GsUvBCDBit3->Set( ON );
	}
	else if ( nPos == 4 )
	{
		m_GsUvBCDBit1->Set( ON );
		m_GsUvBCDBit2->Set( OFF );
		m_GsUvBCDBit3->Set( ON );
	}
	else if ( nPos == 5 )
	{
		m_GsUvBCDBit1->Set( OFF );
		m_GsUvBCDBit2->Set( ON );
		m_GsUvBCDBit3->Set( ON );
	}
}

void CFaGsEuv::SetGsUvDataSet(BOOL bAct)
{
	if( !IsInitialized() ) return;
	m_GsUvDataSet->Set(bAct);
}

BOOL CFaGsEuv::GetGsUvLampOnState()
{
	if( !IsInitialized() ) return FALSE;
	return m_GsUvLampOn->Get();
}

BOOL CFaGsEuv::GetGsUvMonitorReady()
{
	if( !IsInitialized() ) return FALSE;
	return m_GsUvMonitorReady->Get();
}

BOOL CFaGsEuv::GetGsUvDataSetEnable()
{
	if( !IsInitialized() ) return FALSE;
	return m_GsUvDataSet->Get();
}