// FaGsEuv.h: interface for the CFaGsEuv class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FAGSEUV_H__99E6B8D8_80A3_4215_A72A_D69404E6188E__INCLUDED_)
#define AFX_FAFSEUV_H__99E6B8D8_80A3_4215_A72A_D69404E6188E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"
#include "..\X\XDigitalOutput.h"	// Added by ClassView
#include "..\X\XDigitalInput.h"	// Added by ClassView

class CFaGsEuv : public CDevice  
{
public:
	BOOL GetGsUvLampOnState();
	BOOL GetGsUvMonitorReady();
	BOOL GetGsUvDataSetEnable();
	void SetGsUvDataSet(BOOL bAct);
	void SetLampMonitorSelect( int nPos );
	BOOL IsRemoteMode();
	int GetEuvAlarm();
	int GetGsUvLampSelect( int nLampNo );
	void SetGsUvLampSelect( int nLampNo, BOOL bAct );
	void SetGsUvLampOn( BOOL bAct );
	BOOL ReadConfiguration();
	CFaGsEuv();
	virtual ~CFaGsEuv();

	enum _LAMP_ACT_STATE
	{
		actOFF,
		actON
	}; 
	enum _LAMP_NO
	{
		lampNONE,
		lampNO1,
		lampNO2,
		lampNO3,	
	}; 

	enum euvALARMINDEX
	{	// GS 
		euvAlmOverHeat		 = 0x01, // Over heat
		euvAlmLampHouseOpen  = 0x02, // House Open
		euvAlmLampFault	     = 0x04, // Lamp Fault
		euvAlmInverterErr    = 0x08, // Inverter Error
		euvAlmUtilityErr     = 0x10, // Utility Error
		euvAlmN2Err		     = 0x20, // N2 Error
		euvAlmSumErr	     = 0x40, // Sum Error
		euvAlmManualMode	 = 0x80, // ManualMode Error
	};

protected:
	XDigitalInput	* m_GsUvAutoMode;
	XDigitalInput	* m_GsUvOverHeat;
	XDigitalInput	* m_GsUvHouseOpen;
	XDigitalInput	* m_GsUvLampFault;
	XDigitalInput	* m_GsUvInverterError;
	XDigitalInput	* m_GsUvUtyError;
	XDigitalInput	* m_GsUvN2FlowError;
	XDigitalInput	* m_GsUvBCDSumError;
	XDigitalInput	* m_GsUvDataSetEnable;
	XDigitalInput	* m_GsUvMonitorReady;

	XDigitalOutput  * m_GsUvLampSelect1;
	XDigitalOutput  * m_GsUvLampSelect2;
	XDigitalOutput  * m_GsUvLampSelect3;
	XDigitalOutput  * m_GsUvLampOn;
	XDigitalOutput  * m_GsUvDataSet;
	XDigitalOutput  * m_GsUvBCDBit1;
	XDigitalOutput  * m_GsUvBCDBit2;
	XDigitalOutput  * m_GsUvBCDBit3;
};

#endif // !defined(AFX_FAGSEUV_H__99E6B8D8_80A3_4215_A72A_D69404E6188E__INCLUDED_)
