// FaHpmj.cpp: implementation of the CFaHpmj class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "FaHpmj.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFaHpmj::CFaHpmj()
{
	m_bInitialized = FALSE;
	m_pAi = NULL;
	m_pAo = NULL;
	m_pDi= NULL;
	m_pDo = NULL;

	m_nAiCount	= 0;
	m_nAoCount	= 0;
	m_nDiCount	= 0;
	m_nDoCount	= 0;
}

CFaHpmj::~CFaHpmj()
{
	if( m_bInitialized )
	{
		delete []m_pAi;
		delete []m_pAo;
		delete []m_pDi;
		delete []m_pDo;
	}
}

BOOL CFaHpmj::ReadConfiguration()
{
	CString sSetupFile;
	sSetupFile.Format("%s SETUP", m_sName);
	m_IniConfigurationSetup.Open( sSetupFile, "Configuration" );
	CString sDeviceUse = m_IniConfigurationSetup.GetStringValue( "DEVICE USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "DEVICE USE", "VALUE", "NO", TRUE );
		return FALSE;
	}

	m_IniConfiguration.Open( m_sName, "Configuration" );

	CString sBuf;
	CString sName;
	// Read Channel information & Initialize Sections and Keys
	CStringList *pKeyList;

//	///////////////////////////////////////////////////////////////////////////////////////////
//	///////////////////////////////////////////////////////////////////////////////////////////
	BOOL bAiInit = TRUE;
	pKeyList = GetKeyList( "AI" );
	m_nAiCount = pKeyList->GetCount();
	if( m_nAiCount == 0 ) m_pAi = new XAnalogInput*[1];
	else m_pAi = new XAnalogInput*[m_nAiCount];

	if( m_nAiCount == 0 )
	{
		sName.Format( "aigHPMJ_GAUGE[%d]",0 );
		m_IniConfiguration.SetStringValue( "AI", sName, "aiSPARE", TRUE );
		pKeyList = GetKeyList( "AI" );
		m_nAiCount = pKeyList->GetCount();
	}
	for( int i = 0; i< m_nAiCount; i++)
	{
		sName.Format( "aigHPMJ_GAUGE[%d]",i);
		sBuf = m_IniConfiguration.GetStringValue( "AI", sName, "aiSPARE" );
		m_pAi[i] = m_pChannelPackage->GetAIChannel( sBuf );
		m_IniConfiguration.SetStringValue( "AI", sName, sBuf, TRUE );

		if( m_pAi[i] != NULL )
		{
			m_pAi[i]->AddConnectingObjectName( m_sName );
			bAiInit &= bAiInit;
		}
		else bAiInit = FALSE;
	}

//	///////////////////////////////////////////////////////////////////////////////////////////
//	///////////////////////////////////////////////////////////////////////////////////////////
	BOOL bAoInit = TRUE;
	pKeyList = GetKeyList( "AO" );
	m_nAoCount = pKeyList->GetCount();
	if( m_nAoCount == 0 ) m_pAo = new XAnalogOutput*[1];
	else m_pAo = new XAnalogOutput*[m_nAoCount];
	
	if( m_nAoCount == 0 )
	{
		m_pAo[0] = NULL;
		sName.Format( "aogHPMJ_GAUGE[%d]",0 );
		m_IniConfiguration.SetStringValue( "AO", sName, "aoSPARE", TRUE );
		pKeyList = GetKeyList( "AO" );
		m_nAoCount = pKeyList->GetCount();
	}
	for( int i = 0; i< m_nAoCount; i++)
	{
		m_pAo[i] = NULL;
		sName.Format( "aogHPMJ_GAUGE[%d]",i);
		sBuf = m_IniConfiguration.GetStringValue( "AO", sName, "aoSPARE" );
		m_pAo[i] = m_pChannelPackage->GetAOChannel( sBuf );
		m_IniConfiguration.SetStringValue( "AO", sName, sBuf, TRUE );

		if( m_pAo[i] != NULL )
		{
			m_pAo[i]->AddConnectingObjectName( m_sName );
			bAoInit &= bAoInit;
		}
		else bAoInit = FALSE;
	}

//	///////////////////////////////////////////////////////////////////////////////////////////
//	///////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDiInit = TRUE;
	pKeyList = GetKeyList( "DI" );
	m_nDiCount = pKeyList->GetCount();
	if( m_nDiCount == 0 ) m_pDi = new XDigitalInput*[1];
	else m_pDi = new XDigitalInput*[m_nDiCount];

	if( m_nDiCount == 0 )
	{
		m_pDi[0] = NULL;
		sName.Format( "digHPMJ_STATUS[%d]",0);
		m_IniConfiguration.SetStringValue( "DI", sName, "diSPARE", TRUE );
		pKeyList = GetKeyList( "DI" );
		m_nDiCount = pKeyList->GetCount();

	}
	for( int i = 0; i< m_nDiCount; i++)
	{
		m_pDi[i] = NULL;
		sName.Format( "digHPMJ_STATUS[%d]",i);
		sBuf = m_IniConfiguration.GetStringValue( "DI", sName, "diSPARE" );
		m_pDi[i] = m_pChannelPackage->GetDIChannel( sBuf );
		m_IniConfiguration.SetStringValue( "DI", sName, sBuf, TRUE );

		if( m_pDi[i] != NULL )
		{
			m_pDi[i]->AddConnectingObjectName( m_sName );
			bDiInit &= bDiInit;
		}
		else bDiInit = FALSE;
	}
	
//	///////////////////////////////////////////////////////////////////////////////////////////
//	///////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDoInit = TRUE;
	pKeyList = GetKeyList( "DO" );
	m_nDoCount = pKeyList->GetCount();
	if( m_nDoCount == 0 ) m_pDo = new XDigitalOutput*[1];
	else m_pDo = new XDigitalOutput*[m_nDoCount];

	if( m_nDoCount == 0 )
	{
		m_pDo[0] = NULL;
		sName.Format( "dogHPMJ_STATUS[%d]",0);
		m_IniConfiguration.SetStringValue( "DO", sName, "doSPARE", TRUE );
		pKeyList = GetKeyList( "DO" );
		m_nDoCount = pKeyList->GetCount();
	}
	for( int i = 0; i< m_nDoCount; i++)
	{
		m_pDo[i] = NULL;
		sName.Format( "dogHPMJ_STATUS[%d]",i);
		sBuf = m_IniConfiguration.GetStringValue( "DO", sName, "doSPARE" );
		m_pDo[i] = m_pChannelPackage->GetDOChannel( sBuf );
		m_IniConfiguration.SetStringValue( "DO", sName, sBuf, TRUE );

		if( m_pDo[i] != NULL )
		{
			m_pDo[i]->AddConnectingObjectName( m_sName );
			bDoInit &= bDoInit;
		}
		else bDoInit = FALSE;
	}
//	///////////////////////////////////////////////////////////////////////////////////////////
//	///////////////////////////////////////////////////////////////////////////////////////////
	m_bInitialized = bDiInit && bDoInit && bAiInit && bAoInit;
	
	if( !m_bInitialized ) 
	{
		sBuf.Format( "FA HPMJ [%s] ReadConfiguration Failed.", m_sName );
		AfxMessageBox( sBuf );
	}

	return TRUE;
}

void CFaHpmj::SetHpmjAct(int nAct, BOOL bState)
{
	if( !IsInitialized() ||
		( nAct >= m_nDoCount ) ||
		( !m_pDo[nAct]->IsDeviceLink() ) ) return;

	m_pDo[nAct]->Set( bState );
}

BOOL CFaHpmj::GetHpmjActState(int nAct)
{
	if( !IsInitialized() ||
		( nAct >= m_nDoCount ) ||
		( !m_pDo[nAct]->IsDeviceLink() ) ) return FALSE;

	return m_pDo[nAct]->Get();
}

BOOL CFaHpmj::GetHpmjInputState(int nState)
{
	if( !IsInitialized() ||
		( nState >= m_nDiCount ) ||
		( !m_pDi[nState]->IsDeviceLink() ) ) return FALSE;

	return m_pDi[nState]->Get();
}

void CFaHpmj::SetInverterHertz(int nNo, WORD wHertzVal)
{
	if( !IsInitialized() ||
		( nNo >= m_nAoCount ) ||
		( !m_pAo[nNo]->IsDeviceLink() ) ) return;

	m_pAo[nNo]->Set( wHertzVal );
}

float CFaHpmj::GetHpmjAanlogInput(int nNo)
{
	if( !IsInitialized() ||
		( nNo >= m_nAiCount ) ||
		( !m_pAi[nNo]->IsDeviceLink() ) ) return 0.0;

	return m_pAi[nNo]->GetCalAi();
}

int CFaHpmj::GetAiAddress(int nNo)
{
	if( !IsInitialized() ||
		( nNo >= m_nAiCount ) ||
		( !m_pAi[nNo]->IsDeviceLink() ) ) return 0;
	return m_pAi[nNo]->GetAddress();
}

int CFaHpmj::GetHpmjAdcVal(int nNo)
{
	if( !IsInitialized() ||
		( nNo >= m_nAiCount ) ||
		( !m_pAi[nNo]->IsDeviceLink() ) ) return 0;
	return m_pAi[nNo]->Get();
}
