// FaPlasma.h: interface for the CFaPlasma class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FAPLASMA_H__E4E3482E_D04A_414B_BC4F_76B26C818390__INCLUDED_)
#define AFX_FAPLASMA_H__E4E3482E_D04A_414B_BC4F_76B26C818390__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"
#include "..\X\XAnalogInput.h"	// Added by ClassView
#include "..\X\XAnalogOutput.h"	// Added by ClassView
#include "..\X\XDigitalInput.h"	// Added by ClassView
#include "..\X\XDigitalOutput.h"	// Added by ClassView

class CFaPlasma : public CDevice  
{
public:
	BOOL GetHouseCloseState();
	BOOL GetPlasmaInterlockActState();
	void SetPlasmaInterlock(BOOL bAct );
	int GetPlasmaHouseActState();
	int GetHouseSensorState();
	void SetPlasmaHouseAct( int nAct );
	BOOL GetPowerStatus();
	void SetPowerOn( BOOL bPowerStat );
	BOOL GetPlasmaStatus( int nNo );
	float GetPalsmGaugeState( int nNo );
	void SetPlasmaValue( int nNo, WORD nValue );
	CFaPlasma();
	virtual ~CFaPlasma();
	BOOL ReadConfiguration();

	enum _CLY_ACT_STATE
	{
		actSTOP,
		actUP,
		actDN,
	}; 
		
protected:
	XAnalogInput ** m_pAiGaugeGroup; 
	XAnalogOutput ** m_pAoGaugeGroup;
	XDigitalInput ** m_pDiPlasmStatus;
		
	XDigitalInput * m_pDiHouseCylFW;
	XDigitalInput * m_pDiHouseCylBW;
	XDigitalInput * m_pDiHouseClose;

	XDigitalOutput * m_pDoHouseCylFW;
	XDigitalOutput * m_pDoHouseCylBW;

	XDigitalOutput * m_pDoPower;
	XDigitalOutput * m_pDoInterlock;
	int m_nAiCount;
	int m_nAoCount;
	int m_nDiCount;


};

#endif // !defined(AFX_FAPLASMA_H__E4E3482E_D04A_414B_BC4F_76B26C818390__INCLUDED_)
