// FaScanBrokenSensor.h: interface for the CFaScanBrokenSensor class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FASCANBROKENSENSOR_H__9AF7013E_1444_4F81_B3DB_8C1DCB25BDA5__INCLUDED_)
#define AFX_FASCANBROKENSENSOR_H__9AF7013E_1444_4F81_B3DB_8C1DCB25BDA5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"

class CFaScanBrokenSensor : public CDevice  
{
public:
	CFaScanBrokenSensor();
	virtual ~CFaScanBrokenSensor();

	BOOL ReadConfiguration();
	BOOL GetAlarm( int nNo=0 );
	void SetAlarmState( int nNo=0, BOOL bVal=FALSE );
	BOOL GetScanEnd(int nNo=0);
	void SetScanEndState(int nNo=0, BOOL bVal=FALSE);
	BOOL GetScanStart(int nNo=0);
	void SetScanStartState(int nNo=0, BOOL bVal=FALSE);
	void Reset( int nNo=0, BOOL bVal=FALSE );
	BOOL GetResetState( int nNo=0 );
	int	GetDiSize() { return m_nDiCount; }
	int	GetDoSize() { return m_nDoCount; }

	enum _SCAN_ACT_STATE
	{
		actOFF,
		actON
	};
	enum _SCAN_POS_STATE
	{
		scanLD,
		scanUL
	};

protected:
	XDigitalInput ** m_pDi;	// Alarm
	XDigitalInput ** m_pDiScanStart;
	XDigitalInput ** m_pDiScanEnd;
	XDigitalOutput ** m_pDo;
	
	int m_nDiCount;
	int m_nDoCount;
};

#endif // !defined(AFX_FASCANBROKENSENSOR_H__9AF7013E_1444_4F81_B3DB_8C1DCB25BDA5__INCLUDED_)
