// FaTank.cpp: implementation of the CFaTank class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "FaTank.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFaTank::CFaTank()
{
	m_bInitialized = FALSE;
	m_pDiTankLevelSensor = NULL;
	m_pDiPumpAlarm = NULL;
	m_pDiHeaterAlarm = NULL;
	m_pDiTicControlEvent = NULL;
	m_pDiTicMonitorEvent = NULL;
	m_pDiCirPumpAlarm = NULL;
	m_pDiManualValveInterlock = NULL;
	m_pDoPumpOn = NULL;
	m_pDoTankSupplyInValve = NULL;
	m_pDoTankDrainOutValve = NULL;
	m_pDoTankReturnInValve = NULL;
	m_pDoTankCcssInValve = NULL;
	m_pDoTankOutValve = NULL;
	m_pDoHeaterOn = NULL;
	m_pDoTprMcOn = NULL;
	m_pDoCirPumpOn = NULL;
	m_pDoCirOutValve = NULL;
	m_pAiLoadCell = NULL;
	m_pAiShowerFlowInterlock = NULL;
	m_pDoAirPumpOn = NULL;
	m_pDiSaftyRelayAlarm = NULL;
	m_pDoSaftyRelayReset = NULL;
	m_pDiPumpOnState = NULL;	// 150901 halesu

	m_nDiTankLevelSensorCount = 0;
	m_nDiPumpAlarmCount = 0;
	m_nDiHeaterAlarmCount = 0;
	m_nDiTicControlEventCount = 0;
	m_nDiTicMonitorEventCount = 0;
	m_nDiCirPumpAlarmCount = 0;
	m_nDiManualValveInterlockCount = 0;
	m_nDoPumpOnCount = 0;
	m_nDoTankSupplyInValveCount = 0;
	m_nDoTankDrainOutValveCount = 0;
	m_nDoTankReturnInValveCount = 0;
	m_nDoTankCcssInValveCount = 0;
	m_nDoTankOutValveCount = 0;
	m_nDoHeaterOnCount = 0;
	m_nDoTprMcOnCount = 0;
	m_nDoCirPumpOnCount = 0;
	m_nDoCirOutValveCount = 0;
	m_nAiLoadCellCount = 0;
	m_nAiShowerFlowInterlockCount = 0;
	m_nDoAirPumpOnCount = 0;
	m_nDiSaftyRelayAlarmCount = 0;
	m_nDoSaftyRelayResetCount = 0;
}

CFaTank::~CFaTank()
{
	if( m_bInitialized )
	{
		delete []m_pDiTankLevelSensor;
		delete []m_pDiPumpAlarm;
		delete []m_pDiHeaterAlarm;
		delete []m_pDiTicControlEvent;
		delete []m_pDiTicMonitorEvent;
		delete []m_pDiCirPumpAlarm;
		delete []m_pDiManualValveInterlock;
		delete []m_pDoPumpOn;
		delete []m_pDoTankSupplyInValve;
		delete []m_pDoTankDrainOutValve;
		delete []m_pDoTankReturnInValve;
		delete []m_pDoTankCcssInValve;
		delete []m_pDoTankOutValve;
		delete []m_pDoHeaterOn;
		delete []m_pDoTprMcOn;
		delete []m_pDoCirPumpOn;
		delete []m_pDoCirOutValve;
		delete []m_pAiLoadCell;
		delete []m_pAiShowerFlowInterlock;
		delete []m_pDoAirPumpOn;
		delete []m_pDiSaftyRelayAlarm;
		delete []m_pDoSaftyRelayReset;
		delete []m_pDiPumpOnState;	// 150901 halesu
	}
}

BOOL CFaTank::ReadConfiguration()
{
	CString sSetupFile;
	sSetupFile.Format("%s SETUP", m_sName);
	m_IniConfigurationSetup.Open( sSetupFile, "Configuration" );
	CString sDeviceUse = m_IniConfigurationSetup.GetStringValue( "DEVICE USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "DEVICE USE", "VALUE", "NO", TRUE );
		return FALSE;
	}

	m_IniConfiguration.Open( m_sName, "Configuration" );

	CString sBuf, sName;
	CStringList *pKeyList;
//1./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDiTLInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "TANK LEVEL SENSOR USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "TANK LEVEL SENSOR USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DITL" );
		m_nDiTankLevelSensorCount	= pKeyList->GetCount();
		if( m_nDiTankLevelSensorCount == 0 ) m_pDiTankLevelSensor = new XDigitalInput*[1];
		else m_pDiTankLevelSensor = new XDigitalInput*[m_nDiTankLevelSensorCount];

		if( m_nDiTankLevelSensorCount == 0 )
		{
			sName.Format( "DI_TANK_LEVEL[%d]",0 );
			m_IniConfiguration.SetStringValue( "DITL", sName, "di_SPARE", TRUE );
			pKeyList = GetKeyList( "DITL" );
			m_nDiTankLevelSensorCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDiTankLevelSensorCount; i++)
		{
			sName.Format( "DI_TANK_LEVEL[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DITL", sName, "di_SPARE" );
			m_pDiTankLevelSensor[i] = m_pChannelPackage->GetDIChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DITL", sName, sBuf, TRUE );

			if( m_pDiTankLevelSensor[i] != NULL )
			{
				m_pDiTankLevelSensor[i]->AddConnectingObjectName( m_sName );
				bDiTLInit &= bDiTLInit;
			}
			else bDiTLInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//2./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDiPAInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "PUMP ALARM USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "PUMP ALARM USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DIPA" );
		m_nDiPumpAlarmCount	= pKeyList->GetCount();
		if( m_nDiPumpAlarmCount ==  0 ) m_pDiPumpAlarm = new XDigitalInput*[1];
		else m_pDiPumpAlarm = new XDigitalInput*[m_nDiPumpAlarmCount];
		
		if( m_nDiPumpAlarmCount == 0 )
		{
			sName.Format( "DI_PUMP_ALARM[%d]",0 );
			m_IniConfiguration.SetStringValue( "DIPA", sName, "di_SPARE", TRUE );
			pKeyList = GetKeyList( "DIPA" );
			m_nDiPumpAlarmCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDiPumpAlarmCount; i++)
		{
			sName.Format( "DI_PUMP_ALARM[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DIPA", sName, "di_SPARE" );
			m_pDiPumpAlarm[i] = m_pChannelPackage->GetDIChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DIPA", sName, sBuf, TRUE );

			if( m_pDiPumpAlarm[i] != NULL )
			{
				m_pDiPumpAlarm[i]->AddConnectingObjectName( m_sName );
				bDiPAInit &= bDiPAInit;
			}
			else bDiPAInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//3./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDiHAInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "HEATER ALARM USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "HEATER ALARM USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DIHA" );
		m_nDiHeaterAlarmCount	= pKeyList->GetCount();
		if( m_nDiHeaterAlarmCount ==  0 ) m_pDiHeaterAlarm = new XDigitalInput*[1];
		else m_pDiHeaterAlarm = new XDigitalInput*[m_nDiHeaterAlarmCount];
		
		if( m_nDiHeaterAlarmCount == 0 )
		{
			sName.Format( "DI_HEATER_ALARM[%d]",0 );
			m_IniConfiguration.SetStringValue( "DIHA", sName, "di_SPARE", TRUE );
			pKeyList = GetKeyList( "DIHA" );
			m_nDiHeaterAlarmCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDiHeaterAlarmCount; i++)
		{
			sName.Format( "DI_HEATER_ALARM[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DIHA", sName, "di_SPARE" );
			m_pDiHeaterAlarm[i] = m_pChannelPackage->GetDIChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DIHA", sName, sBuf, TRUE );

			if( m_pDiHeaterAlarm[i] != NULL )
			{
				m_pDiHeaterAlarm[i]->AddConnectingObjectName( m_sName );
				bDiHAInit &= bDiHAInit;
			}
			else bDiHAInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//4./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDiTCEInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "TIC CONTROL EVENT USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "TIC CONTROL EVENT USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DITCE" );
		m_nDiTicControlEventCount	= pKeyList->GetCount();
		if( m_nDiTicControlEventCount ==  0 ) m_pDiTicControlEvent = new XDigitalInput*[1];
		else m_pDiTicControlEvent = new XDigitalInput*[m_nDiTicControlEventCount];
		
		if( m_nDiTicControlEventCount == 0 )
		{
			sName.Format( "DI_TIC_CONTROL_EVENT[%d]",0 );
			m_IniConfiguration.SetStringValue( "DITCE", sName, "di_SPARE", TRUE );
			pKeyList = GetKeyList( "DITCE" );
			m_nDiTicControlEventCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDiTicControlEventCount; i++)
		{
			sName.Format( "DI_TIC_CONTROL_EVENT[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DITCE", sName, "di_SPARE" );
			m_pDiTicControlEvent[i] = m_pChannelPackage->GetDIChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DITCE", sName, sBuf, TRUE );

			if( m_pDiTicControlEvent[i] != NULL )
			{
				m_pDiTicControlEvent[i]->AddConnectingObjectName( m_sName );
				bDiTCEInit &= bDiTCEInit;
			}
			else bDiTCEInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//5./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDiTMEInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "TIC MONITOR EVENT USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "TIC MONITOR EVENT USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DITME" );
		m_nDiTicMonitorEventCount	= pKeyList->GetCount();
		if( m_nDiTicMonitorEventCount ==  0 ) m_pDiTicMonitorEvent = new XDigitalInput*[1];
		else m_pDiTicMonitorEvent = new XDigitalInput*[m_nDiTicMonitorEventCount];
		
		if( m_nDiTicMonitorEventCount == 0 )
		{
			sName.Format( "DI_TIC_MONITOR_EVENT[%d]",0 );
			m_IniConfiguration.SetStringValue( "DITME", sName, "di_SPARE", TRUE );
			pKeyList = GetKeyList( "DITME" );
			m_nDiTicMonitorEventCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDiTicMonitorEventCount; i++)
		{
			sName.Format( "DI_TIC_MONITOR_EVENT[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DITME", sName, "di_SPARE" );
			m_pDiTicMonitorEvent[i] = m_pChannelPackage->GetDIChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DITME", sName, sBuf, TRUE );

			if( m_pDiTicMonitorEvent[i] != NULL )
			{
				m_pDiTicMonitorEvent[i]->AddConnectingObjectName( m_sName );
				bDiTMEInit &= bDiTMEInit;
			}
			else bDiTMEInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//6./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDiCPAInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "CIR PUMP ALARM USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "CIR PUMP ALARM USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DICPA" );
		m_nDiCirPumpAlarmCount	= pKeyList->GetCount();
		if( m_nDiCirPumpAlarmCount ==  0 ) m_pDiCirPumpAlarm = new XDigitalInput*[1];
		else m_pDiCirPumpAlarm = new XDigitalInput*[m_nDiCirPumpAlarmCount];
		
		if( m_nDiCirPumpAlarmCount == 0 )
		{
			sName.Format( "DI_CIR_PUMP_ALARM[%d]",0 );
			m_IniConfiguration.SetStringValue( "DICPA", sName, "di_SPARE", TRUE );
			pKeyList = GetKeyList( "DICPA" );
			m_nDiCirPumpAlarmCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDiCirPumpAlarmCount; i++)
		{
			sName.Format( "DI_CIR_PUMP_ALARM[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DICPA", sName, "di_SPARE" );
			m_pDiCirPumpAlarm[i] = m_pChannelPackage->GetDIChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DICPA", sName, sBuf, TRUE );

			if( m_pDiCirPumpAlarm[i] != NULL )
			{
				m_pDiCirPumpAlarm[i]->AddConnectingObjectName( m_sName );
				bDiCPAInit &= bDiCPAInit;
			}
			else bDiCPAInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//7./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDiMVISInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "MANUAL VALVE INTERLOCK SENSOR USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "MANUAL VALVE INTERLOCK SENSOR USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DIMVIS" );
		m_nDiManualValveInterlockCount	= pKeyList->GetCount();
		if( m_nDiManualValveInterlockCount ==  0 ) m_pDiManualValveInterlock = new XDigitalInput*[1];
		else m_pDiManualValveInterlock = new XDigitalInput*[m_nDiManualValveInterlockCount];
		
		if( m_nDiManualValveInterlockCount == 0 )
		{
			sName.Format( "DI_MANUAL_VALVE_INTERLOCK_SENSROR[%d]",0 );
			m_IniConfiguration.SetStringValue( "DIMVIS", sName, "di_SPARE", TRUE );
			pKeyList = GetKeyList( "DIMVIS" );
			m_nDiManualValveInterlockCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDiManualValveInterlockCount; i++)
		{
			sName.Format( "DI_MANUAL_VALVE_INTERLOCK_SENSROR[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DIMVIS", sName, "di_SPARE" );
			m_pDiManualValveInterlock[i] = m_pChannelPackage->GetDIChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DIMVIS", sName, sBuf, TRUE );

			if( m_pDiManualValveInterlock[i] != NULL )
			{
				m_pDiManualValveInterlock[i]->AddConnectingObjectName( m_sName );
				bDiMVISInit &= bDiMVISInit;
			}
			else bDiMVISInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//8./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDoPOInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "PUMP ON USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "PUMP ON USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DOPO" );
		m_nDoPumpOnCount	= pKeyList->GetCount();
		if( m_nDoPumpOnCount ==  0 ) m_pDoPumpOn = new XDigitalOutput*[1];
		else m_pDoPumpOn = new XDigitalOutput*[m_nDoPumpOnCount];
		
		if( m_nDoPumpOnCount == 0 )
		{
			sName.Format( "DO_PUMP_ON[%d]",0 );
			m_IniConfiguration.SetStringValue( "DOPO", sName, "do_SPARE", TRUE );
			pKeyList = GetKeyList( "DOPO" );
			m_nDoPumpOnCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDoPumpOnCount; i++)
		{
			sName.Format( "DO_PUMP_ON[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DOPO", sName, "do_SPARE" );
			m_pDoPumpOn[i] = m_pChannelPackage->GetDOChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DOPO", sName, sBuf, TRUE );

			if( m_pDoPumpOn[i] != NULL )
			{
				m_pDoPumpOn[i]->AddConnectingObjectName( m_sName );
				bDoPOInit &= bDoPOInit;
			}
			else bDoPOInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//9./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDoTSIVInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "TANK SUPPLY IN VALVE USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "TANK SUPPLY IN VALVE USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DOTSIV" );
		m_nDoTankSupplyInValveCount	= pKeyList->GetCount();
		if( m_nDoTankSupplyInValveCount ==  0 ) m_pDoTankSupplyInValve = new XDigitalOutput*[1];
		else m_pDoTankSupplyInValve = new XDigitalOutput*[m_nDoTankSupplyInValveCount];
		
		if( m_nDoTankSupplyInValveCount == 0 )
		{
			sName.Format( "DO_TANK_SUPPLY_IN_VALVE[%d]",0 );
			m_IniConfiguration.SetStringValue( "DOTSIV", sName, "do_SPARE", TRUE );
			pKeyList = GetKeyList( "DOTSIV" );
			m_nDoTankSupplyInValveCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDoTankSupplyInValveCount; i++)
		{
			sName.Format( "DO_TANK_SUPPLY_IN_VALVE[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DOTSIV", sName, "do_SPARE" );
			m_pDoTankSupplyInValve[i] = m_pChannelPackage->GetDOChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DOTSIV", sName, sBuf, TRUE );

			if( m_pDoTankSupplyInValve[i] != NULL )
			{
				m_pDoTankSupplyInValve[i]->AddConnectingObjectName( m_sName );
				bDoTSIVInit &= bDoTSIVInit;
			}
			else bDoTSIVInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//10./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDoTDOVInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "TANK DRAIN OUT VALVE USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "TANK DRAIN OUT VALVE USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DOTDOV" );
		m_nDoTankDrainOutValveCount	= pKeyList->GetCount();
		if( m_nDoTankDrainOutValveCount ==  0 ) m_pDoTankDrainOutValve = new XDigitalOutput*[1];
		else m_pDoTankDrainOutValve = new XDigitalOutput*[m_nDoTankDrainOutValveCount];
		
		if( m_nDoTankDrainOutValveCount == 0 )
		{
			sName.Format( "DO_TANK_DRAIN_OUT_VALVE[%d]",0 );
			m_IniConfiguration.SetStringValue( "DOTDOV", sName, "do_SPARE", TRUE );
			pKeyList = GetKeyList( "DOTDOV" );
			m_nDoTankDrainOutValveCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDoTankDrainOutValveCount; i++)
		{
			sName.Format( "DO_TANK_DRAIN_OUT_VALVE[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DOTDOV", sName, "do_SPARE" );
			m_pDoTankDrainOutValve[i] = m_pChannelPackage->GetDOChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DOTDOV", sName, sBuf, TRUE );

			if( m_pDoTankDrainOutValve[i] != NULL )
			{
				m_pDoTankDrainOutValve[i]->AddConnectingObjectName( m_sName );
				bDoTDOVInit &= bDoTDOVInit;
			}
			else bDoTDOVInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//11./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDoTRIVInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "TANK RETURN IN VALVE USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "TANK RETURN IN VALVE USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DOTRIV" );
		m_nDoTankReturnInValveCount	= pKeyList->GetCount();
		if( m_nDoTankReturnInValveCount ==  0 ) m_pDoTankReturnInValve = new XDigitalOutput*[1];
		else m_pDoTankReturnInValve = new XDigitalOutput*[m_nDoTankReturnInValveCount];
		
		if( m_nDoTankReturnInValveCount == 0 )
		{
			sName.Format( "DO_TANK_RETURN_IN_VALVE[%d]",0 );
			m_IniConfiguration.SetStringValue( "DOTRIV", sName, "do_SPARE", TRUE );
			pKeyList = GetKeyList( "DOTRIV" );
			m_nDoTankReturnInValveCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDoTankReturnInValveCount; i++)
		{
			sName.Format( "DO_TANK_RETURN_IN_VALVE[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DOTRIV", sName, "do_SPARE" );
			m_pDoTankReturnInValve[i] = m_pChannelPackage->GetDOChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DOTRIV", sName, sBuf, TRUE );

			if( m_pDoTankReturnInValve[i] != NULL )
			{
				m_pDoTankReturnInValve[i]->AddConnectingObjectName( m_sName );
				bDoTRIVInit &= bDoTRIVInit;
			}
			else bDoTRIVInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//12./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDoTCIVInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "TANK CCSS IN VALVE USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "TANK CCSS IN VALVE USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DOTCIV" );
		m_nDoTankCcssInValveCount	= pKeyList->GetCount();
		if( m_nDoTankCcssInValveCount ==  0 ) m_pDoTankCcssInValve = new XDigitalOutput*[1];
		else m_pDoTankCcssInValve = new XDigitalOutput*[m_nDoTankCcssInValveCount];
		
		if( m_nDoTankCcssInValveCount == 0 )
		{
			sName.Format( "DO_TANK_CCSS_IN_VALVE[%d]",0 );
			m_IniConfiguration.SetStringValue( "DOTCIV", sName, "do_SPARE", TRUE );
			pKeyList = GetKeyList( "DOTCIV" );
			m_nDoTankCcssInValveCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDoTankCcssInValveCount; i++)
		{
			sName.Format( "DO_TANK_CCSS_IN_VALVE[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DOTCIV", sName, "do_SPARE" );
			m_pDoTankCcssInValve[i] = m_pChannelPackage->GetDOChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DOTCIV", sName, sBuf, TRUE );

			if( m_pDoTankCcssInValve[i] != NULL )
			{
				m_pDoTankCcssInValve[i]->AddConnectingObjectName( m_sName );
				bDoTCIVInit &= bDoTCIVInit;
			}
			else bDoTCIVInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//13./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDoTOVInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "TANK OUT VALVE USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "TANK OUT VALVE USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DOTOV" );
		m_nDoTankOutValveCount	= pKeyList->GetCount();
		if( m_nDoTankOutValveCount ==  0 ) m_pDoTankOutValve = new XDigitalOutput*[1];
		else m_pDoTankOutValve = new XDigitalOutput*[m_nDoTankOutValveCount];
		
		if( m_nDoTankOutValveCount == 0 )
		{
			sName.Format( "DO_TANK_OUT_VALVE[%d]",0 );
			m_IniConfiguration.SetStringValue( "DOTOV", sName, "do_SPARE", TRUE );
			pKeyList = GetKeyList( "DOTOV" );
			m_nDoTankOutValveCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDoTankOutValveCount; i++)
		{
			sName.Format( "DO_TANK_OUT_VALVE[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DOTOV", sName, "do_SPARE" );
			m_pDoTankOutValve[i] = m_pChannelPackage->GetDOChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DOTOV", sName, sBuf, TRUE );

			if( m_pDoTankOutValve[i] != NULL )
			{
				m_pDoTankOutValve[i]->AddConnectingObjectName( m_sName );
				bDoTOVInit &= bDoTOVInit;
			}
			else bDoTOVInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//14./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDoHOInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "HEATER ON USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "HEATER ON USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DOHO" );
		m_nDoHeaterOnCount	= pKeyList->GetCount();
		if( m_nDoHeaterOnCount ==  0 ) m_pDoHeaterOn = new XDigitalOutput*[1];
		else m_pDoHeaterOn = new XDigitalOutput*[m_nDoHeaterOnCount];
		
		if( m_nDoHeaterOnCount == 0 )
		{
			sName.Format( "DO_HEATER_ON[%d]",0 );
			m_IniConfiguration.SetStringValue( "DOHO", sName, "do_SPARE", TRUE );
			pKeyList = GetKeyList( "DOHO" );
			m_nDoHeaterOnCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDoHeaterOnCount; i++)
		{
			sName.Format( "DO_HEATER_ON[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DOHO", sName, "do_SPARE" );
			m_pDoHeaterOn[i] = m_pChannelPackage->GetDOChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DOHO", sName, sBuf, TRUE );

			if( m_pDoHeaterOn[i] != NULL )
			{
				m_pDoHeaterOn[i]->AddConnectingObjectName( m_sName );
				bDoHOInit &= bDoHOInit;
			}
			else bDoHOInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//15./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDoTMOInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "TPR MC ON USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "TPR MC ON USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DOTMO" );
		m_nDoTprMcOnCount	= pKeyList->GetCount();
		if( m_nDoTprMcOnCount ==  0 ) m_pDoTprMcOn = new XDigitalOutput*[1];
		else m_pDoTprMcOn = new XDigitalOutput*[m_nDoTprMcOnCount];
		
		if( m_nDoTprMcOnCount == 0 )
		{
			sName.Format( "DO_TPR_MC_ON[%d]",0 );
			m_IniConfiguration.SetStringValue( "DOTMO", sName, "do_SPARE", TRUE );
			pKeyList = GetKeyList( "DOTMO" );
			m_nDoTprMcOnCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDoTprMcOnCount; i++)
		{
			sName.Format( "DO_TPR_MC_ON[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DOTMO", sName, "do_SPARE" );
			m_pDoTprMcOn[i] = m_pChannelPackage->GetDOChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DOTMO", sName, sBuf, TRUE );

			if( m_pDoTprMcOn[i] != NULL )
			{
				m_pDoTprMcOn[i]->AddConnectingObjectName( m_sName );
				bDoTMOInit &= bDoTMOInit;
			}
			else bDoTMOInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//16./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDoCPOInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "CIR PUMP ON USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "CIR PUMP ON USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DOCPO" );
		m_nDoCirPumpOnCount	= pKeyList->GetCount();
		if( m_nDoCirPumpOnCount ==  0 ) m_pDoCirPumpOn = new XDigitalOutput*[1];
		else m_pDoCirPumpOn = new XDigitalOutput*[m_nDoCirPumpOnCount];
		
		if( m_nDoCirPumpOnCount == 0 )
		{
			sName.Format( "DO_CIR_PUMP_ON[%d]",0 );
			m_IniConfiguration.SetStringValue( "DOCPO", sName, "do_SPARE", TRUE );
			pKeyList = GetKeyList( "DOCPO" );
			m_nDoCirPumpOnCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDoCirPumpOnCount; i++)
		{
			sName.Format( "DO_CIR_PUMP_ON[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DOCPO", sName, "doSPARE" );
			m_pDoCirPumpOn[i] = m_pChannelPackage->GetDOChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DOCPO", sName, sBuf, TRUE );

			if( m_pDoCirPumpOn[i] != NULL )
			{
				m_pDoCirPumpOn[i]->AddConnectingObjectName( m_sName );
				bDoCPOInit &= bDoCPOInit;
			}
			else bDoCPOInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//17./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDoCOVInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "CIR OUT VALVE USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "CIR OUT VALVE USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DOCOV" );
		m_nDoCirOutValveCount	= pKeyList->GetCount();
		if( m_nDoCirOutValveCount ==  0 ) m_pDoCirOutValve = new XDigitalOutput*[1];
		else m_pDoCirOutValve = new XDigitalOutput*[m_nDoCirOutValveCount];
		
		if( m_nDoCirOutValveCount == 0 )
		{
			sName.Format( "DO_CIR_OUT_VALVE[%d]",0 );
			m_IniConfiguration.SetStringValue( "DOCOV", sName, "do_SPARE", TRUE );
			pKeyList = GetKeyList( "DOCOV" );
			m_nDoCirOutValveCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDoCirOutValveCount; i++)
		{
			sName.Format( "DO_CIR_OUT_VALVE[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DOCOV", sName, "do_SPARE" );
			m_pDoCirOutValve[i] = m_pChannelPackage->GetDOChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DOCOV", sName, sBuf, TRUE );

			if( m_pDoCirOutValve[i] != NULL )
			{
				m_pDoCirOutValve[i]->AddConnectingObjectName( m_sName );
				bDoCOVInit &= bDoCOVInit;
			}
			else bDoCOVInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//18./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bAiLCLInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "LOAD CELL LEVEL USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "LOAD CELL LEVEL USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "AILCL" );
		m_nAiLoadCellCount	= pKeyList->GetCount();
		if( m_nAiLoadCellCount ==  0 ) m_pAiLoadCell = new XAnalogInput*[1];
		else m_pAiLoadCell = new XAnalogInput*[m_nAiLoadCellCount];
		
		if( m_nAiLoadCellCount == 0 )
		{
			sName.Format( "AI_LOAD_CELL_LEVEL[%d]",0 );
			m_IniConfiguration.SetStringValue( "AILCL", sName, "ai_SPARE", TRUE );
			pKeyList = GetKeyList( "AILCL" );
			m_nAiLoadCellCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nAiLoadCellCount; i++)
		{
			sName.Format( "AI_LOAD_CELL_LEVEL[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "AILCL", sName, "ai_SPARE" );
			m_pAiLoadCell[i] = m_pChannelPackage->GetAIChannel( sBuf );
			m_IniConfiguration.SetStringValue( "AILCL", sName, sBuf, TRUE );

			if( m_pAiLoadCell[i] != NULL )
			{
				m_pAiLoadCell[i]->AddConnectingObjectName( m_sName );
				bAiLCLInit &= bAiLCLInit;
			}
			else bAiLCLInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//19./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bAiSFIInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "SHOWER FLOW INTERLOCK USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "SHOWER FLOW INTERLOCK USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "AISFI" );
		m_nAiShowerFlowInterlockCount	= pKeyList->GetCount();
		if( m_nAiShowerFlowInterlockCount ==  0 ) m_pAiShowerFlowInterlock = new XAnalogInput*[1];
		else m_pAiShowerFlowInterlock = new XAnalogInput*[m_nAiShowerFlowInterlockCount];
		
		if( m_nAiShowerFlowInterlockCount == 0 )
		{
			sName.Format( "AI_SHOWER_FLOW_INTERLOCK[%d]",0 );
			m_IniConfiguration.SetStringValue( "AISFI", sName, "ai_SPARE", TRUE );
			pKeyList = GetKeyList( "AISFI" );
			m_nAiShowerFlowInterlockCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nAiShowerFlowInterlockCount; i++)
		{
			sName.Format( "AI_SHOWER_FLOW_INTERLOCK[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "AISFI", sName, "ai_SPARE" );
			m_pAiShowerFlowInterlock[i] = m_pChannelPackage->GetAIChannel( sBuf );
			m_IniConfiguration.SetStringValue( "AISFI", sName, sBuf, TRUE );

			if( m_pAiShowerFlowInterlock[i] != NULL )
			{
				m_pAiShowerFlowInterlock[i]->AddConnectingObjectName( m_sName );
				bAiSFIInit &= bAiSFIInit;
			}
			else bAiSFIInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//20./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDoAPOInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "DET AIR PUMP USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "DET AIR PUMP USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DOAPO" );
		m_nDoAirPumpOnCount	= pKeyList->GetCount();
		if( m_nDoAirPumpOnCount ==  0 ) m_pDoAirPumpOn = new XDigitalOutput*[1];
		else m_pDoAirPumpOn = new XDigitalOutput*[m_nDoAirPumpOnCount];
		
		if( m_nDoAirPumpOnCount == 0 )
		{
			sName.Format( "DO_AIR_PUMP_ON[%d]",0 );
			m_IniConfiguration.SetStringValue( "DOAPO", sName, "do_SPARE", TRUE );
			pKeyList = GetKeyList( "DOAPO" );
			m_nDoAirPumpOnCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDoAirPumpOnCount; i++)
		{
			sName.Format( "DO_AIR_PUMP_ON[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DOAPO", sName, "do_SPARE" );
			m_pDoAirPumpOn[i] = m_pChannelPackage->GetDOChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DOAPO", sName, sBuf, TRUE );

			if( m_pDoAirPumpOn[i] != NULL )
			{
				m_pDoAirPumpOn[i]->AddConnectingObjectName( m_sName );
				bDoAPOInit &= bDoAPOInit;
			}
			else bDoAPOInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//21./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDiSRAInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "SAFTY RELAY ALARM USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "SAFTY RELAY ALARM USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DISRA" );
		m_nDiSaftyRelayAlarmCount	= pKeyList->GetCount();
		if( m_nDiSaftyRelayAlarmCount ==  0 ) m_pDiSaftyRelayAlarm = new XDigitalInput*[1];
		else m_pDiSaftyRelayAlarm = new XDigitalInput*[m_nDiSaftyRelayAlarmCount];
		
		if( m_nDiSaftyRelayAlarmCount == 0 )
		{
			sName.Format( "DI_SAFTY_RELAY_ALARM[%d]",0 );
			m_IniConfiguration.SetStringValue( "DISRA", sName, "di_SPARE", TRUE );
			pKeyList = GetKeyList( "DISRA" );
			m_nDiSaftyRelayAlarmCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDiSaftyRelayAlarmCount; i++)
		{
			sName.Format( "DI_SAFTY_RELAY_ALARM[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DISRA", sName, "di_SPARE" );
			m_pDiSaftyRelayAlarm[i] = m_pChannelPackage->GetDIChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DISRA", sName, sBuf, TRUE );

			if( m_pDiSaftyRelayAlarm[i] != NULL )
			{
				m_pDiSaftyRelayAlarm[i]->AddConnectingObjectName( m_sName );
				bDiSRAInit &= bDiSRAInit;
			}
			else bDiSRAInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//22./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDoSRRInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "SAFTY RELAY RESET USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "SAFTY RELAY RESET USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DISRR" );
		m_nDoSaftyRelayResetCount	= pKeyList->GetCount();
		if( m_nDoSaftyRelayResetCount ==  0 ) m_pDoSaftyRelayReset = new XDigitalOutput*[1];
		else m_pDoSaftyRelayReset = new XDigitalOutput*[m_nDoSaftyRelayResetCount];
		
		if( m_nDoSaftyRelayResetCount == 0 )
		{
			sName.Format( "DI_SAFTY_RELAY_ALARM[%d]",0 );
			m_IniConfiguration.SetStringValue( "DISRR", sName, "do_SPARE", TRUE );
			pKeyList = GetKeyList( "DISRR" );
			m_nDoSaftyRelayResetCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDoSaftyRelayResetCount; i++)
		{
			sName.Format( "DI_SAFTY_RELAY_ALARM[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DISRR", sName, "do_SPARE" );
			m_pDoSaftyRelayReset[i] = m_pChannelPackage->GetDOChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DISRR", sName, sBuf, TRUE );

			if( m_pDoSaftyRelayReset[i] != NULL )
			{
				m_pDoSaftyRelayReset[i]->AddConnectingObjectName( m_sName );
				bDoSRRInit &= bDoSRRInit;
			}
			else bDoSRRInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//23./////////////////////////////////////////////////////////////////////////////////////////////////////
	BOOL bDiPOSInit = TRUE;
	sDeviceUse = m_IniConfigurationSetup.GetStringValue( "PUMP ON STATE USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "PUMP ON STATE USE", "VALUE", "NO", TRUE );
	}
	else
	{
		pKeyList = GetKeyList( "DIPOS" );
		m_nDiPumpOnStateCount	= pKeyList->GetCount();
		if( m_nDiPumpOnStateCount ==  0 ) m_pDiPumpOnState = new XDigitalInput*[1];
		else m_pDiPumpOnState = new XDigitalInput*[m_nDiPumpOnStateCount];
		
		if( m_nDiPumpOnStateCount == 0 )
		{
			sName.Format( "DI_PUMP_ON_STATE[%d]",0 );
			m_IniConfiguration.SetStringValue( "DIPOS", sName, "di_SPARE", TRUE );
			pKeyList = GetKeyList( "DIPOS" );
			m_nDiPumpOnStateCount = pKeyList->GetCount();
		}
		for( int i = 0; i< m_nDiPumpOnStateCount; i++)
		{
			sName.Format( "DI_PUMP_ON_STATE[%d]",i);
			sBuf = m_IniConfiguration.GetStringValue( "DIPOS", sName, "di_SPARE" );
			m_pDiPumpOnState[i] = m_pChannelPackage->GetDIChannel( sBuf );
			m_IniConfiguration.SetStringValue( "DIPOS", sName, sBuf, TRUE );
			
			if( m_pDiPumpOnState[i] != NULL )
			{
				m_pDiPumpOnState[i]->AddConnectingObjectName( m_sName );
				bDiPOSInit &= bDiPOSInit;
			}
			else bDiPOSInit = FALSE;
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////

	BOOL bInitialized = TRUE;
	bInitialized &= bDiTLInit;
	bInitialized &= bDiPAInit;
	bInitialized &= bDiHAInit;
	bInitialized &= bDiTCEInit;
	bInitialized &= bDiTMEInit;
	bInitialized &= bDiCPAInit;
	bInitialized &= bDiMVISInit;
	bInitialized &= bDoPOInit;
	bInitialized &= bDoTSIVInit;
	bInitialized &= bDoTDOVInit;
	bInitialized &= bDoTRIVInit;
	bInitialized &= bDoTCIVInit;
	bInitialized &= bDoTOVInit;
	bInitialized &= bDoHOInit;
	bInitialized &= bDoTMOInit;
	bInitialized &= bDoCPOInit;
	bInitialized &= bDoCOVInit;
	bInitialized &= bAiLCLInit;
	bInitialized &= bAiSFIInit;
	bInitialized &= bDoAPOInit;
	bInitialized &= bDiSRAInit;
	bInitialized &= bDoSRRInit;
	bInitialized &= bDiPOSInit;

	m_bInitialized = bInitialized;
	if( !m_bInitialized ) 
	{
		sBuf.Format( "FA Tank [%s] ReadConfiguration Failed.", m_sName );
		AfxMessageBox( sBuf );
	}

	return TRUE;
}

//1.//////////////////////////////////////////////////////////////////////////////////////////
BOOL CFaTank::GetTankLevel( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiTankLevelSensorCount ) ||
		( !m_pDiTankLevelSensor[nNo]->IsDeviceLink() ) ) return FALSE;

	return ( m_pDiTankLevelSensor[nNo]->Get() );
}
void CFaTank::SetTankLevelState( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiTankLevelSensorCount ) ||
		( !m_pDiTankLevelSensor[nNo]->IsDeviceLink() ) ) return;
	
	m_pDiTankLevelSensor[nNo]->SetState( bVal );
}

//2.//////////////////////////////////////////////////////////////////////////////////////////
BOOL CFaTank::GetPumpAlarm( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiPumpAlarmCount ) ||
		( !m_pDiPumpAlarm[nNo]->IsDeviceLink() ) ) return FALSE;

	return ( m_pDiPumpAlarm[nNo]->Get() );
}
void CFaTank::SetPumpAlarmState( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiPumpAlarmCount ) ||
		( !m_pDiPumpAlarm[nNo]->IsDeviceLink() ) ) return;
	
	m_pDiPumpAlarm[nNo]->SetState( bVal );
}

//3.//////////////////////////////////////////////////////////////////////////////////////////
BOOL CFaTank::GetHeaterAlarm( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiHeaterAlarmCount ) ||
		( !m_pDiHeaterAlarm[nNo]->IsDeviceLink() ) ) return FALSE;

	return ( m_pDiHeaterAlarm[nNo]->Get() );
}
void CFaTank::SetHeaterAlarmState( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiHeaterAlarmCount ) ||
		( !m_pDiHeaterAlarm[nNo]->IsDeviceLink() ) ) return;
	
	m_pDiHeaterAlarm[nNo]->SetState( bVal );
}

//4.//////////////////////////////////////////////////////////////////////////////////////////
BOOL CFaTank::GetTicControlEvent( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiTicControlEventCount ) ||
		( !m_pDiTicControlEvent[nNo]->IsDeviceLink() ) ) return FALSE;

	return ( m_pDiTicControlEvent[nNo]->Get() );
}
void CFaTank::SetTicControlEventState( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiTicControlEventCount ) ||
		( !m_pDiTicControlEvent[nNo]->IsDeviceLink() ) ) return;
	
	m_pDiTicControlEvent[nNo]->SetState( bVal );
}

//5.//////////////////////////////////////////////////////////////////////////////////////////
BOOL CFaTank::GetTicMonitorEvent( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiTicMonitorEventCount ) ||
		( !m_pDiTicMonitorEvent[nNo]->IsDeviceLink() ) ) return FALSE;

	return ( m_pDiTicMonitorEvent[nNo]->Get() );
}
void CFaTank::SetTicMonitorEventState( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiTicMonitorEventCount ) ||
		( !m_pDiTicMonitorEvent[nNo]->IsDeviceLink() ) ) return;
	
	m_pDiTicMonitorEvent[nNo]->SetState( bVal );
}

//6.//////////////////////////////////////////////////////////////////////////////////////////
BOOL CFaTank::GetCirPumpAlarm( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiCirPumpAlarmCount ) ||
		( !m_pDiCirPumpAlarm[nNo]->IsDeviceLink() ) ) return FALSE;

	return ( m_pDiCirPumpAlarm[nNo]->Get() );
}
void CFaTank::SetCirPumpAlarmState( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiCirPumpAlarmCount ) ||
		( !m_pDiCirPumpAlarm[nNo]->IsDeviceLink() ) ) return;
	
	m_pDiCirPumpAlarm[nNo]->SetState( bVal );
}

//7.//////////////////////////////////////////////////////////////////////////////////////////
BOOL CFaTank::GetManualValveInterlockSensor( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiManualValveInterlockCount ) ||
		( !m_pDiManualValveInterlock[nNo]->IsDeviceLink() ) ) return FALSE;

	return ( m_pDiManualValveInterlock[nNo]->Get() );
}
void CFaTank::SetManualValveInterlockSensor( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiManualValveInterlockCount ) ||
		( !m_pDiManualValveInterlock[nNo]->IsDeviceLink() ) ) return;
	
	m_pDiManualValveInterlock[nNo]->SetState( bVal );
}

//8.//////////////////////////////////////////////////////////////////////////////////////////
void CFaTank::SetPumpOn( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoPumpOnCount ) ||
		( !m_pDoPumpOn[nNo]->IsDeviceLink() ) ) return;

	m_pDoPumpOn[nNo]->Set( bVal );
}
BOOL CFaTank::GetPumpOnState( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoPumpOnCount ) ||
		( !m_pDoPumpOn[nNo]->IsDeviceLink() ) ) return FALSE;

	return m_pDoPumpOn[nNo]->Get();
}

//9.//////////////////////////////////////////////////////////////////////////////////////////
void CFaTank::SetTankSupplyInValve( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoTankSupplyInValveCount ) ||
		( !m_pDoTankSupplyInValve[nNo]->IsDeviceLink() ) ) return;

	m_pDoTankSupplyInValve[nNo]->Set( bVal );
}
BOOL CFaTank::GetTankSupplyInValveState( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoTankSupplyInValveCount ) ||
		( !m_pDoTankSupplyInValve[nNo]->IsDeviceLink() ) ) return FALSE;

	return m_pDoTankSupplyInValve[nNo]->Get();
}

//10.//////////////////////////////////////////////////////////////////////////////////////////
void CFaTank::SetTankDrainOutValve( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoTankDrainOutValveCount ) ||
		( !m_pDoTankDrainOutValve[nNo]->IsDeviceLink() ) ) return;

	m_pDoTankDrainOutValve[nNo]->Set( bVal );
}
BOOL CFaTank::GetTankDrainOutValveState( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoTankDrainOutValveCount ) ||
		( !m_pDoTankDrainOutValve[nNo]->IsDeviceLink() ) ) return FALSE;

	return m_pDoTankDrainOutValve[nNo]->Get();
}

//11.//////////////////////////////////////////////////////////////////////////////////////////
void CFaTank::SetTankReturnInValve( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoTankReturnInValveCount ) ||
		( !m_pDoTankReturnInValve[nNo]->IsDeviceLink() ) ) return;

	m_pDoTankReturnInValve[nNo]->Set( bVal );
}
BOOL CFaTank::GetTankReturnInValveState( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoTankReturnInValveCount ) ||
		( !m_pDoTankReturnInValve[nNo]->IsDeviceLink() ) ) return FALSE;

	return m_pDoTankReturnInValve[nNo]->Get();
}

//12.//////////////////////////////////////////////////////////////////////////////////////////
void CFaTank::SetTankCcssInValve( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoTankCcssInValveCount ) ||
		( !m_pDoTankCcssInValve[nNo]->IsDeviceLink() ) ) return;

	m_pDoTankCcssInValve[nNo]->Set( bVal );
}
BOOL CFaTank::GetTankCcssInValveState( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoTankCcssInValveCount ) ||
		( !m_pDoTankCcssInValve[nNo]->IsDeviceLink() ) ) return FALSE;

	return m_pDoTankCcssInValve[nNo]->Get();
}

//13.//////////////////////////////////////////////////////////////////////////////////////////
void CFaTank::SetTankOutValve( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoTankOutValveCount ) ||
		( !m_pDoTankOutValve[nNo]->IsDeviceLink() ) ) return;

	m_pDoTankOutValve[nNo]->Set( bVal );
}
BOOL CFaTank::GetTankOutValveState( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoTankOutValveCount ) ||
		( !m_pDoTankOutValve[nNo]->IsDeviceLink() ) ) return FALSE;

	return m_pDoTankOutValve[nNo]->Get();
}

//14.//////////////////////////////////////////////////////////////////////////////////////////
void CFaTank::SetHeaterOn( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoHeaterOnCount ) ||
		( !m_pDoHeaterOn[nNo]->IsDeviceLink() ) ) return;

	m_pDoHeaterOn[nNo]->Set( bVal );
}
BOOL CFaTank::GetHeaterOnState( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoHeaterOnCount ) ||
		( !m_pDoHeaterOn[nNo]->IsDeviceLink() ) ) return FALSE;

	return m_pDoHeaterOn[nNo]->Get();
}

//15.//////////////////////////////////////////////////////////////////////////////////////////
void CFaTank::SetTprMcOn( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoTprMcOnCount ) ||
		( !m_pDoTprMcOn[nNo]->IsDeviceLink() ) ) return;

	m_pDoTprMcOn[nNo]->Set( bVal );
}
BOOL CFaTank::GetTprMcOnState( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoTprMcOnCount ) ||
		( !m_pDoTprMcOn[nNo]->IsDeviceLink() ) ) return FALSE;

	return m_pDoTprMcOn[nNo]->Get();
}

//16.//////////////////////////////////////////////////////////////////////////////////////////
void CFaTank::SetCirPumpOn( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoCirPumpOnCount ) ||
		( !m_pDoCirPumpOn[nNo]->IsDeviceLink() ) ) return;

	m_pDoCirPumpOn[nNo]->Set( bVal );
}
BOOL CFaTank::GetCirPumpOnState( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoCirPumpOnCount ) ||
		( !m_pDoCirPumpOn[nNo]->IsDeviceLink() ) ) return FALSE;

	return m_pDoCirPumpOn[nNo]->Get();
}

//17.//////////////////////////////////////////////////////////////////////////////////////////
void CFaTank::SetCirOutValve( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoCirOutValveCount ) ||
		( !m_pDoCirOutValve[nNo]->IsDeviceLink() ) ) return;

	m_pDoCirOutValve[nNo]->Set( bVal );
}
BOOL CFaTank::GetCirOutValveState( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoCirOutValveCount ) ||
		( !m_pDoCirOutValve[nNo]->IsDeviceLink() ) ) return FALSE;

	return m_pDoCirOutValve[nNo]->Get();
}

//18.//////////////////////////////////////////////////////////////////////////////////////////
float CFaTank::GetLoadCell( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nAiLoadCellCount ) ||
		( !m_pAiLoadCell[nNo]->IsDeviceLink() ) ) return 0.0;

	return m_pAiLoadCell[nNo]->GetCalAi();
}
void CFaTank::SetLoadCelState( int nNo, float fVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nAiLoadCellCount ) ||
		( !m_pAiLoadCell[nNo]->IsDeviceLink() ) ) return;

	m_pAiLoadCell[nNo]->SetRawAi( fVal );
}

//19.//////////////////////////////////////////////////////////////////////////////////////////
float CFaTank::GetShowerFlowInterlock( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nAiShowerFlowInterlockCount ) ||
		( !m_pAiShowerFlowInterlock[nNo]->IsDeviceLink() ) ) return 0.0;

	return m_pAiShowerFlowInterlock[nNo]->GetCalAi();
}
void CFaTank::SetShowerFlowInterlock( int nNo, float fVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nAiShowerFlowInterlockCount ) ||
		( !m_pAiShowerFlowInterlock[nNo]->IsDeviceLink() ) ) return;

	m_pAiShowerFlowInterlock[nNo]->SetRawAi( fVal );
}
////////////////////////////////////////////////////////////////////////////////////////////

//20.//////////////////////////////////////////////////////////////////////////////////////////
void CFaTank::SetAirPumpOn( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoAirPumpOnCount ) ||
		( !m_pDoAirPumpOn[nNo]->IsDeviceLink() ) ) return;

	m_pDoAirPumpOn[nNo]->Set( bVal );
}
BOOL CFaTank::GetAirPumpOnState( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoAirPumpOnCount ) ||
		( !m_pDoAirPumpOn[nNo]->IsDeviceLink() ) ) return FALSE;

	return m_pDoAirPumpOn[nNo]->Get();
}
////////////////////////////////////////////////////////////////////////////////////////////

//21.//////////////////////////////////////////////////////////////////////////////////////////
BOOL CFaTank::GetSaftyRelayAlarm( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiSaftyRelayAlarmCount ) ||
		( !m_pDiSaftyRelayAlarm[nNo]->IsDeviceLink() ) ) return FALSE;

	return ( m_pDiSaftyRelayAlarm[nNo]->Get() );
}
void CFaTank::SetSaftyRelayAlarmState( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiSaftyRelayAlarmCount ) ||
		( !m_pDiSaftyRelayAlarm[nNo]->IsDeviceLink() ) ) return;
	
	m_pDiSaftyRelayAlarm[nNo]->SetState( bVal );
}
////////////////////////////////////////////////////////////////////////////////////////////

//22.//////////////////////////////////////////////////////////////////////////////////////////
void CFaTank::SetSaftyRelayReset( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoSaftyRelayResetCount ) ||
		( !m_pDoSaftyRelayReset[nNo]->IsDeviceLink() ) ) return;

	m_pDoSaftyRelayReset[nNo]->Set( bVal );
}
BOOL CFaTank::GetSaftyRelayResetState( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoSaftyRelayResetCount ) ||
		( !m_pDoSaftyRelayReset[nNo]->IsDeviceLink() ) ) return FALSE;

	return m_pDoSaftyRelayReset[nNo]->Get();
}
////////////////////////////////////////////////////////////////////////////////////////////

//23.//////////////////////////////////////////////////////////////////////////////////////////
BOOL CFaTank::GetPumpOn( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiPumpOnStateCount ) ||
		( !m_pDiPumpOnState[nNo]->IsDeviceLink() ) ) return FALSE;
	
	return ( m_pDiPumpOnState[nNo]->Get() );
}