// FaTank.h: interface for the CFaTank class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FATANK_H__FE061944_BC77_4D03_9747_7CD7D1BAE318__INCLUDED_)
#define AFX_FATANK_H__FE061944_BC77_4D03_9747_7CD7D1BAE318__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"
#include "..\X\XDigitalOutput.h"	// Added by ClassView
#include "..\X\XDigitalInput.h"	// Added by ClassView
#include "..\X\XAnalogInput.h"

// Property ////////////////////////
// 1. Tank Level Sensor
// 2. Pump Alarm
// 3. Heater Alarm
// 4. Control TIC Event
// 5. Monitor TIC Event
// 6. CIR Pump Alarm
// 7. Manual Valve Interlock Sensor
// 8. Pump ON
// 9. Tank Supply IN Auto Valve
// 10. Tank Drain Out Auto Valve
// 11. Bath Drain In Auto Valve
// 12. Tank CCSS IN Auto Valve
// 13. Tank OUT Auto Valve
// 14. Heater ON
// 15. TPR MC ON
// 16. CIR Pump ON
// 17. CIR Pump OUT Auto Valve
// 18. Load Cell Sensor
// 19. Shower Flow Interlock Analog
// 20. Air Pump ON
// 21. Safty Relay Alarm
// 22. Safty Relay Reset
// 23. Pump On State	// SanghoCho 2015.04.15
////////////////////////////////////
class CFaTank : public CDevice  
{
public:
	CFaTank();
	virtual ~CFaTank();

	BOOL ReadConfiguration();

	//1.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDiTankLevelSensorCount(){return m_nDiTankLevelSensorCount;}
	BOOL GetTankLevel( int nNo );
	void SetTankLevelState( int nNo, BOOL bVal );
	//2.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDiPumpAlarmCount(){return m_nDiPumpAlarmCount;}
	BOOL GetPumpAlarm( int nNo = 0 );
	void SetPumpAlarmState( int nNo, BOOL bVal );
	//3.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDiHeaterAlarmCount(){return m_nDiHeaterAlarmCount;}
	BOOL GetHeaterAlarm( int nNo = 0 );
	void SetHeaterAlarmState( int nNo, BOOL bVal );	
	//4.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDiTicControlEventCount(){return m_nDiTicControlEventCount;}
	BOOL GetTicControlEvent( int nNo = 0 );
	void SetTicControlEventState( int nNo, BOOL bVal );	
	//5.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDiTicMonitorEventCount(){return m_nDiTicMonitorEventCount;}
	BOOL GetTicMonitorEvent( int nNo = 0 );
	void SetTicMonitorEventState( int nNo, BOOL bVal );
	//6.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDiCirPumpAlarmCount(){return m_nDiCirPumpAlarmCount;}
	BOOL GetCirPumpAlarm( int nNo = 0 );
	void SetCirPumpAlarmState( int nNo, BOOL bVal );
	//7.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDiManualValveInterlockCount(){return m_nDiManualValveInterlockCount;}
	BOOL GetManualValveInterlockSensor( int nNo = 0 );
	void SetManualValveInterlockSensor( int nNo, BOOL bVal );
	//8.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDoPumpOnCount(){return m_nDoPumpOnCount;}
	void SetPumpOn( int nNo, BOOL bVal );
	BOOL GetPumpOnState( int nNo = 0 );
	//9.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDoTankSupplyInValveCount(){return m_nDoTankSupplyInValveCount;}
	void SetTankSupplyInValve( int nNo, BOOL bVal );
	BOOL GetTankSupplyInValveState( int nNo = 0 );
	//10.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDoTankDrainOutValveCount(){return m_nDoTankDrainOutValveCount;}
	void SetTankDrainOutValve( int nNo, BOOL bVal );
	BOOL GetTankDrainOutValveState( int nNo = 0 );
	//11.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDoTankReturnInValveCount(){return m_nDoTankReturnInValveCount;}
	void SetTankReturnInValve( int nNo, BOOL bVal );
	BOOL GetTankReturnInValveState( int nNo = 0 );
	//12.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDoTankCcssInValveCount(){return m_nDoTankCcssInValveCount;}
	void SetTankCcssInValve( int nNo, BOOL bVal );
	BOOL GetTankCcssInValveState( int nNo = 0 );
	//13.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDoTankOutValveCount(){return m_nDoTankOutValveCount;} 
	void SetTankOutValve( int nNo, BOOL bVal );
	BOOL GetTankOutValveState( int nNo = 0 );
	//14.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDoHeaterOnCount(){return m_nDoHeaterOnCount;}
	void SetHeaterOn( int nNo, BOOL bVal );
	BOOL GetHeaterOnState( int nNo = 0 );
	//15.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDoTprMcOnCount(){return m_nDoTprMcOnCount;}
	void SetTprMcOn( int nNo, BOOL bVal );
	BOOL GetTprMcOnState( int nNo = 0 );
	//16.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDoCirPumpOnCount(){return m_nDoCirPumpOnCount;}
	void SetCirPumpOn( int nNo, BOOL bVal );
	BOOL GetCirPumpOnState( int nNo = 0 );
	//17.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDoCirOutValveCount(){return m_nDoCirOutValveCount;}
	void SetCirOutValve( int nNo, BOOL bVal );
	BOOL GetCirOutValveState( int nNo = 0 );
	//18.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetAiLoadCellCount(){return m_nAiLoadCellCount;}
	float GetLoadCell( int nNo = 0 );
	void SetLoadCelState( int nNo, float fVal );
	//19.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetAiShowerFlowInterlockCount(){return m_nAiShowerFlowInterlockCount;}
	float GetShowerFlowInterlock( int nNo = 0 );
	void SetShowerFlowInterlock( int nNo, float fVal );
	////////////////////////////////////////////////////////////////////////////////////////////
	//20.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDoAirPumpOnCount(){return m_nDoAirPumpOnCount;}
	void SetAirPumpOn( int nNo, BOOL bVal );
	BOOL GetAirPumpOnState( int nNo = 0 );
	////////////////////////////////////////////////////////////////////////////////////////////
	//21.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDiSaftyRelayAlarmCount(){return m_nDiSaftyRelayAlarmCount;}
	BOOL GetSaftyRelayAlarm( int nNo = 0 );
	void SetSaftyRelayAlarmState( int nNo, BOOL bVal );
	////////////////////////////////////////////////////////////////////////////////////////////
	//22.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDiSaftyRelayResetCount(){return m_nDoSaftyRelayResetCount;}
	void SetSaftyRelayReset( int nNo, BOOL bVal );
	BOOL GetSaftyRelayResetState( int nNo = 0 );
	////////////////////////////////////////////////////////////////////////////////////////////
	//23.//////////////////////////////////////////////////////////////////////////////////////////
	int	GetDiPumpOnStateCount(){return m_nDiPumpOnStateCount;}
	BOOL GetPumpOn( int nNo = 0 );

protected:
	XDigitalInput **	m_pDiTankLevelSensor;
	XDigitalInput **	m_pDiPumpAlarm;
	XDigitalInput **	m_pDiHeaterAlarm;
	XDigitalInput **	m_pDiTicControlEvent;
	XDigitalInput **	m_pDiTicMonitorEvent;
	XDigitalInput **	m_pDiCirPumpAlarm;
	XDigitalInput **	m_pDiManualValveInterlock;
	XDigitalOutput **	m_pDoPumpOn;
	XDigitalOutput **	m_pDoTankSupplyInValve;
	XDigitalOutput **	m_pDoTankDrainOutValve;
	XDigitalOutput **	m_pDoTankReturnInValve;
	XDigitalOutput **	m_pDoTankCcssInValve;
	XDigitalOutput **	m_pDoTankOutValve;
	XDigitalOutput **	m_pDoHeaterOn;
	XDigitalOutput **	m_pDoTprMcOn;
	XDigitalOutput **	m_pDoCirPumpOn;
	XDigitalOutput **	m_pDoCirOutValve;
	XAnalogInput **		m_pAiLoadCell;
	XAnalogInput **		m_pAiShowerFlowInterlock;
	XDigitalOutput **	m_pDoAirPumpOn;
	XDigitalInput **	m_pDiSaftyRelayAlarm;
	XDigitalOutput **	m_pDoSaftyRelayReset;
	XDigitalInput **	m_pDiPumpOnState;

	int	m_nDiTankLevelSensorCount;
	int	m_nDiPumpAlarmCount;
	int	m_nDiHeaterAlarmCount;
	int	m_nDiTicControlEventCount;
	int	m_nDiTicMonitorEventCount;
	int	m_nDiCirPumpAlarmCount;
	int	m_nDiManualValveInterlockCount;
	int	m_nDoPumpOnCount;
	int	m_nDoTankSupplyInValveCount;
	int	m_nDoTankDrainOutValveCount;
	int	m_nDoTankReturnInValveCount;
	int	m_nDoTankCcssInValveCount;
	int	m_nDoTankOutValveCount;
	int	m_nDoHeaterOnCount;
	int	m_nDoTprMcOnCount;
	int	m_nDoCirPumpOnCount;
	int	m_nDoCirOutValveCount;
	int	m_nAiLoadCellCount;
	int	m_nAiShowerFlowInterlockCount;
	int m_nDoAirPumpOnCount;
	int	m_nDiSaftyRelayAlarmCount;
	int	m_nDoSaftyRelayResetCount;
	int m_nDiPumpOnStateCount;
};

#endif // !defined(AFX_FATANK_H__FE061944_BC77_4D03_9747_7CD7D1BAE318__INCLUDED_)
