// FaUshioEuv.cpp: implementation of the CFaUshioEuv class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "FaUshioEuv.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFaUshioEuv::CFaUshioEuv()
{
	m_bInitialized = FALSE;
	m_nDiIfULACount = 0;
	m_nDiIfUPOWCount = 0;
	m_nDoIfULSCount = 0;

	m_pDiIfULA = NULL;
	m_pDiIfUPOW = NULL;
	m_pDoIfULS = NULL;
}

CFaUshioEuv::~CFaUshioEuv()
{
	delete m_pDiIfULA;
	delete m_pDiIfUPOW;
	delete m_pDoIfULS;
}

BOOL CFaUshioEuv::ReadConfiguration()
{
	CString sSetupFile;
	sSetupFile.Format("%s SETUP", m_sName);
	m_IniConfigurationSetup.Open( sSetupFile, "Configuration" );
	CString sDeviceUse = m_IniConfigurationSetup.GetStringValue( "DEVICE USE", "VALUE", "NO" );
	if( sDeviceUse == "NO" )
	{
		m_IniConfigurationSetup.SetStringValue( "DEVICE USE", "VALUE", "NO", TRUE );
		return FALSE;
	}

	m_IniConfiguration.Open( m_sName, "Configuration" );

	CString sBuf, sName;
	// Read Channel information & Initialize Sections and Keys
	CStringList *pKeyList;

//	///////////////////////////////////////////////////////////////////////////////////////////
//	///////////////////////////////////////////////////////////////////////////////////////////
	BOOL bInit = TRUE;
	pKeyList = GetKeyList( "DI_ULA" );
	m_nDiIfULACount = pKeyList->GetCount();
	if( m_nDiIfULACount == 0 )	m_pDiIfULA = new XDigitalInput*[1];
	else m_pDiIfULA = new XDigitalInput*[m_nDiIfULACount];

	if( m_nDiIfULACount == 0 )
	{
		sName.Format( "ULA[%d]",0);
		m_IniConfiguration.SetStringValue( "DI_ULA", sName, "diSPARE", TRUE );
		pKeyList = GetKeyList( "DI_ULA" );
		m_nDiIfULACount = pKeyList->GetCount();
	}
	for( int i=0; i<m_nDiIfULACount; i++)
	{
		sName.Format( "ULA[%d]",i);
		sBuf = m_IniConfiguration.GetStringValue( "DI_ULA", sName, "diSPARE" );
		m_pDiIfULA[i] = m_pChannelPackage->GetDIChannel( sBuf );
		m_IniConfiguration.SetStringValue( "DI_ULA", sName, sBuf, TRUE );

		if( m_pDiIfULA[i] != NULL )
		{
			m_pDiIfULA[i]->AddConnectingObjectName( m_sName );
			bInit &= bInit;
		}
		else bInit = FALSE;
	}
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	pKeyList = GetKeyList( "DI_UPOW" );
	m_nDiIfUPOWCount = pKeyList->GetCount();
	if( m_nDiIfUPOWCount == 0 )	m_pDiIfUPOW = new XDigitalInput*[1];
	else m_pDiIfUPOW = new XDigitalInput*[m_nDiIfUPOWCount];

	if( m_nDiIfUPOWCount == 0 )
	{
		sName.Format( "UPOW[%d]",0);
		m_IniConfiguration.SetStringValue( "DI_UPOW", sName, "diSPARE", TRUE );
		pKeyList = GetKeyList( "DI_UPOW" );
		m_nDiIfUPOWCount = pKeyList->GetCount();
	}
	for( int i=0; i<m_nDiIfUPOWCount; i++)
	{
		sName.Format( "UPOW[%d]",i);
		sBuf = m_IniConfiguration.GetStringValue( "DI_UPOW", sName, "diSPARE" );
		m_pDiIfUPOW[i] = m_pChannelPackage->GetDIChannel( sBuf );
		m_IniConfiguration.SetStringValue( "DI_UPOW", sName, sBuf, TRUE );

		if( m_pDiIfUPOW[i] != NULL )
		{
			m_pDiIfUPOW[i]->AddConnectingObjectName( m_sName );
			bInit &= bInit;
		}
		else bInit = FALSE;
	}
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	pKeyList = GetKeyList( "DO_ULS" );
	m_nDoIfULSCount = pKeyList->GetCount();
	if( m_nDoIfULSCount == 0 )	m_pDoIfULS = new XDigitalOutput*[1];
	else m_pDoIfULS = new XDigitalOutput*[m_nDoIfULSCount];

	if( m_nDoIfULSCount == 0 )
	{
		sName.Format( "ULS[%d]",0);
		m_IniConfiguration.SetStringValue( "DO_ULS", sName, "doSPARE", TRUE );
		pKeyList = GetKeyList( "DO_ULS" );
		m_nDoIfULSCount = pKeyList->GetCount();
	}
	for( int i=0; i<m_nDoIfULSCount; i++)
	{
		sName.Format( "ULS[%d]",i);
		sBuf = m_IniConfiguration.GetStringValue( "DO_ULS", sName, "doSPARE" );
		m_pDoIfULS[i] = m_pChannelPackage->GetDOChannel( sBuf );
		m_IniConfiguration.SetStringValue( "DO_ULS", sName, sBuf, TRUE );

		if( m_pDoIfULS[i] != NULL )
		{
			m_pDoIfULS[i]->AddConnectingObjectName( m_sName );
			bInit &= bInit;
		}
		else bInit = FALSE;
	}
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UNRE", "diSPARE" );
	m_pDiIfUNRE = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UNRE", sBuf, TRUE );
	if( m_pDiIfUNRE != NULL )
	{
		m_pDiIfUNRE->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UCRE", "diSPARE" );
	m_pDiIfUCRE = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UCRE", sBuf, TRUE );
	if( m_pDiIfUCRE != NULL )
	{
		m_pDiIfUCRE->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "ULAC", "diSPARE" );
	m_pDiIfULAC = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "ULAC", sBuf, TRUE );
	if( m_pDiIfULAC != NULL )
	{
		m_pDiIfULAC->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "URDY", "diSPARE" );
	m_pDiIfURDY = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "URDY", sBuf, TRUE );
	if( m_pDiIfURDY != NULL )
	{
		m_pDiIfURDY->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UWLL", "diSPARE" );
	m_pDiIfUWLL = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UWLL", sBuf, TRUE );
	if( m_pDiIfUWLL != NULL )
	{
		m_pDiIfUWLL->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UEUV", "diSPARE" );
	m_pDiIfUEUV = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UEUV", sBuf, TRUE );
	if( m_pDiIfUEUV != NULL )
	{
		m_pDiIfUEUV->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UESF", "diSPARE" );
	m_pDiIfUESF = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UESF", sBuf, TRUE );
	if( m_pDiIfUESF != NULL )
	{
		m_pDiIfUESF->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UEEL", "diSPARE" );
	m_pDiIfUEEL = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UEEL", sBuf, TRUE );
	if( m_pDiIfUEEL != NULL )
	{
		m_pDiIfUEEL->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UICA", "diSPARE" );
	m_pDiIfUICA = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UICA", sBuf, TRUE );
	if( m_pDiIfUICA != NULL )
	{
		m_pDiIfUICA->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UFLT", "diSPARE" );
	m_pDiIfUFLT = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UFLT", sBuf, TRUE );
	if( m_pDiIfUFLT != NULL )
	{
		m_pDiIfUFLT->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UWNH", "diSPARE" );
	m_pDiIfUWNH = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UWNH", sBuf, TRUE );
	if( m_pDiIfUWNH != NULL )
	{
		m_pDiIfUWNH->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UWLT", "diSPARE" );
	m_pDiIfUWLT = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UWLT", sBuf, TRUE );
	if( m_pDiIfUWLT != NULL )
	{
		m_pDiIfUWLT->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UWLO", "diSPARE" );
	m_pDiIfUWLO = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UWLO", sBuf, TRUE );
	if( m_pDiIfUWLO != NULL )
	{
		m_pDiIfUWLO->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UWTT", "diSPARE" );
	m_pDiIfUWTT = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UWTT", sBuf, TRUE );
	if( m_pDiIfUWTT != NULL )
	{
		m_pDiIfUWTT->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UWNL", "diSPARE" );
	m_pDiIfUWNL = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UWNL", sBuf, TRUE );
	if( m_pDiIfUWNL != NULL )
	{
		m_pDiIfUWNL->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UECO", "diSPARE" );
	m_pDiIfUECO = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UECO", sBuf, TRUE );
	if( m_pDiIfUECO != NULL )
	{
		m_pDiIfUECO->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UOPT", "diSPARE" );
	m_pDiIfUOPT = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UOPT", sBuf, TRUE );
	if( m_pDiIfUOPT != NULL )
	{
		m_pDiIfUOPT->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UCPU", "diSPARE" );
	m_pDiIfUCPU = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UCPU", sBuf, TRUE );
	if( m_pDiIfUCPU != NULL )
	{
		m_pDiIfUCPU->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UEMO", "diSPARE" );
	m_pDiIfUEMO = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UEMO", sBuf, TRUE );
	if( m_pDiIfUEMO != NULL )
	{
		m_pDiIfUEMO->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UHRY", "diSPARE" );
	m_pDiIfUHRY = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UHRY", sBuf, TRUE );
	if( m_pDiIfUHRY != NULL )
	{
		m_pDiIfUHRY->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "UHEM", "diSPARE" );
	m_pDiIfUHEM = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "UHEM", sBuf, TRUE );
	if( m_pDiIfUHEM != NULL )
	{
		m_pDiIfUHEM->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "N2_FLOW_H", "diSPARE" );
	m_pDiUtN2FlowH = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "N2_FLOW_H", sBuf, TRUE );
	if( m_pDiUtN2FlowH != NULL )
	{
		m_pDiUtN2FlowH->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "N2_FLOW_L", "diSPARE" );
	m_pDiUtN2FlowL = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "N2_FLOW_L", sBuf, TRUE );
	if( m_pDiUtN2FlowL != NULL )
	{
		m_pDiUtN2FlowL->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "PCW_FLOW_L", "diSPARE" );
	m_pDiUtPcwFlowL = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "PCW_FLOW_L", sBuf, TRUE );
	if( m_pDiUtPcwFlowL != NULL )
	{
		m_pDiUtPcwFlowL->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "CDA_FLOW_H", "diSPARE" );
	m_pDiUtCdaFlowH = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "CDA_FLOW_H", sBuf, TRUE );
	if( m_pDiUtCdaFlowH != NULL )
	{
		m_pDiUtCdaFlowH->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "CDA_FLOW_L", "diSPARE" );
	m_pDiUtCdaFlowL = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "CDA_FLOW_L", sBuf, TRUE );
	if( m_pDiUtCdaFlowL != NULL )
	{
		m_pDiUtCdaFlowL->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "N2_FLOW_ALARM_H", "diSPARE" );
	m_pDiUtN2FlowAlarmH = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "N2_FLOW_ALARM_H", sBuf, TRUE );
	if( m_pDiUtN2FlowAlarmH != NULL )
	{
		m_pDiUtN2FlowAlarmH->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DI", "N2_FLOW_ALARM_L", "diSPARE" );
	m_pDiUtN2FlowAlarmL = m_pChannelPackage->GetDIChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DI", "N2_FLOW_ALARM_L", sBuf, TRUE );
	if( m_pDiUtN2FlowAlarmL != NULL )
	{
		m_pDiUtN2FlowAlarmL->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DO", "UDLC", "doSPARE" );
	m_pDoIfUDLC = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "UDLC", sBuf, TRUE );
	if( m_pDoIfUDLC != NULL )
	{
		m_pDoIfUDLC->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DO", "UTRE", "doSPARE" );
	m_pDoIfUTRE = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "UTRE", sBuf, TRUE );
	if( m_pDoIfUTRE != NULL )
	{
		m_pDoIfUTRE->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DO", "ULON", "doSPARE" );
	m_pDoIfULON = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "ULON", sBuf, TRUE );
	if( m_pDoIfULON != NULL )
	{
		m_pDoIfULON->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DO", "UICR", "doSPARE" );
	m_pDoIfUICR = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "UICR", sBuf, TRUE );
	if( m_pDoIfUICR != NULL )
	{
		m_pDoIfUICR->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DO", "ULST", "doSPARE" );
	m_pDoIfULST = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "ULST", sBuf, TRUE );
	if( m_pDoIfULST != NULL )
	{
		m_pDoIfULST->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DO", "UEMG", "doSPARE" );
	m_pDoIfUEMG = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "UEMG", sBuf, TRUE );
	if( m_pDoIfUEMG != NULL )
	{
		m_pDoIfUEMG->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DO", "UERT", "doSPARE" );
	m_pDoIfUERT = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "UERT", sBuf, TRUE );
	if( m_pDoIfUERT != NULL )
	{
		m_pDoIfUERT->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////
	sBuf = m_IniConfiguration.GetStringValue( "DO", "UHER", "doSPARE" );
	m_pDoIfUHER = m_pChannelPackage->GetDOChannel( sBuf );
	m_IniConfiguration.SetStringValue( "DO", "UHER", sBuf, TRUE );
	if( m_pDoIfUHER != NULL )
	{
		m_pDoIfUHER->AddConnectingObjectName( m_sName );
		bInit &= bInit;
	}
	else bInit = FALSE;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////

	m_bInitialized = bInit;

	if( !m_bInitialized ) 
	{
		sBuf.Format( "FA Ushio EUV [%s] ReadConfiguration Failed.", m_sName );
		AfxMessageBox( sBuf );
	}

	return TRUE;
}

// Interface Input //////////////////////////////////////////////////////////
BOOL CFaUshioEuv::GetIfUnre()
{
	if( !IsInitialized() || !m_pDiIfUNRE->IsDeviceLink() ) return FALSE;
	return m_pDiIfUNRE->Get();
}

void CFaUshioEuv::SetIfUnreState(BOOL bVal)
{
	if( !IsInitialized() || !m_pDiIfUNRE->IsDeviceLink() ) return;
	m_pDiIfUNRE->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUcre()
{
	if( !IsInitialized() || !m_pDiIfUCRE->IsDeviceLink() ) return FALSE;
	return m_pDiIfUCRE->Get();
}

void CFaUshioEuv::SetIfUcreState(BOOL bVal)
{
	if( !IsInitialized() || !m_pDiIfUCRE->IsDeviceLink() ) return;
	m_pDiIfUCRE->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUlac()
{
	if( !IsInitialized() || !m_pDiIfULAC->IsDeviceLink() ) return FALSE;
	return m_pDiIfULAC->Get();
}

void CFaUshioEuv::SetIfUlacState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfULAC->IsDeviceLink() ) return;
	m_pDiIfULAC->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUrdy()
{
	if( !IsInitialized() || !m_pDiIfURDY->IsDeviceLink() ) return FALSE;
	return m_pDiIfURDY->Get();
}

void CFaUshioEuv::SetIfUrdyState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfURDY->IsDeviceLink() ) return;
	m_pDiIfURDY->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUwll()
{
	if( !IsInitialized() || !m_pDiIfUWLL->IsDeviceLink() ) return FALSE;
	return m_pDiIfUWLL->Get();
}

void CFaUshioEuv::SetIfUwllState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUWLL->IsDeviceLink() ) return;
	m_pDiIfUWLL->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUeuv()
{
	if( !IsInitialized() || !m_pDiIfUEUV->IsDeviceLink() ) return FALSE;
	return m_pDiIfUEUV->Get();
}

void CFaUshioEuv::SetIfUeuvState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUEUV->IsDeviceLink() ) return;
	m_pDiIfUEUV->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUesf()
{
	if( !IsInitialized() || !m_pDiIfUESF->IsDeviceLink() ) return FALSE;
	return m_pDiIfUESF->Get();
}

void CFaUshioEuv::SetIfUesfState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUESF->IsDeviceLink() ) return;
	m_pDiIfUESF->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUeel()
{
	if( !IsInitialized() || !m_pDiIfUEEL->IsDeviceLink() ) return FALSE;
	return m_pDiIfUEEL->Get();
}

void CFaUshioEuv::SetIfUeelState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUEEL->IsDeviceLink() ) return;
	m_pDiIfUEEL->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUica()
{
	if( !IsInitialized() || !m_pDiIfUICA->IsDeviceLink() ) return FALSE;
	return m_pDiIfUICA->Get();
}

void CFaUshioEuv::SetIfUicaState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUICA->IsDeviceLink() ) return;
	m_pDiIfUICA->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUflt()
{
	if( !IsInitialized() || !m_pDiIfUFLT->IsDeviceLink() ) return FALSE;
	return m_pDiIfUFLT->Get();
}

void CFaUshioEuv::SetIfUfltState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUFLT->IsDeviceLink() ) return;
	m_pDiIfUFLT->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUwnh()
{
	if( !IsInitialized() || !m_pDiIfUWNH->IsDeviceLink() ) return FALSE;
	return m_pDiIfUWNH->Get();
}

void CFaUshioEuv::SetIfUwnhState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUWNH->IsDeviceLink() ) return;
	m_pDiIfUWNH->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUwlt()
{
	if( !IsInitialized() || !m_pDiIfUWLT->IsDeviceLink() ) return FALSE;
	return m_pDiIfUWLT->Get();
}

void CFaUshioEuv::SetIfUwltState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUWLT->IsDeviceLink() ) return;
	m_pDiIfUWLT->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUwlo()
{
	if( !IsInitialized() || !m_pDiIfUWLO->IsDeviceLink() ) return FALSE;
	return m_pDiIfUWLO->Get();
}

void CFaUshioEuv::SetIfUwloState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUWLO->IsDeviceLink() ) return;
	m_pDiIfUWLO->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUwtt()
{
	if( !IsInitialized() || !m_pDiIfUWTT->IsDeviceLink() ) return FALSE;
	return m_pDiIfUWTT->Get();
}

void CFaUshioEuv::SetIfUwttState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUWTT->IsDeviceLink() ) return;
	m_pDiIfUWTT->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUwnl()
{
	if( !IsInitialized() || !m_pDiIfUWNL->IsDeviceLink() ) return FALSE;
	return m_pDiIfUWNL->Get();
}

void CFaUshioEuv::SetIfUwnlState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUWNL->IsDeviceLink() ) return;
	m_pDiIfUWNL->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUeco()
{
	if( !IsInitialized() || !m_pDiIfUECO->IsDeviceLink() ) return FALSE;
	return m_pDiIfUECO->Get();
}

void CFaUshioEuv::SetIfUecoState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUECO->IsDeviceLink() ) return;
	m_pDiIfUECO->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUopt()
{
	if( !IsInitialized() || !m_pDiIfUOPT->IsDeviceLink() ) return FALSE;
	return m_pDiIfUOPT->Get();
}

void CFaUshioEuv::SetIfUoptState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUOPT->IsDeviceLink() ) return;
	m_pDiIfUOPT->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUcpu()
{
	if( !IsInitialized() || !m_pDiIfUCPU->IsDeviceLink() ) return FALSE;
	return m_pDiIfUCPU->Get();
}

void CFaUshioEuv::SetIfUcpuState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUCPU->IsDeviceLink() ) return;
	m_pDiIfUCPU->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUemo()
{
	if( !IsInitialized() || !m_pDiIfUEMO->IsDeviceLink() ) return FALSE;
	return m_pDiIfUEMO->Get();
}

void CFaUshioEuv::SetIfUemoState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUEMO->IsDeviceLink() ) return;
	m_pDiIfUEMO->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUhry()
{
	if( !IsInitialized() || !m_pDiIfUHRY->IsDeviceLink() ) return FALSE;
	return m_pDiIfUHRY->Get();
}

void CFaUshioEuv::SetIfUhryState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUHRY->IsDeviceLink() ) return;
	m_pDiIfUHRY->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUhem()
{
	if( !IsInitialized() || !m_pDiIfUHEM->IsDeviceLink() ) return FALSE;
	return m_pDiIfUHEM->Get();
}

void CFaUshioEuv::SetIfUhemState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiIfUHEM->IsDeviceLink() ) return;
	m_pDiIfUHEM->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUla( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiIfULACount ) || 
	    !m_pDiIfULA[nNo]->IsDeviceLink() ) return FALSE;

	return m_pDiIfULA[nNo]->Get();
}

void CFaUshioEuv::SetIfUlaState( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiIfULACount ) || 
	    !m_pDiIfULA[nNo]->IsDeviceLink() ) return;

	m_pDiIfULA[nNo]->SetState( bVal );
}

BOOL CFaUshioEuv::GetIfUpow( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiIfUPOWCount ) || 
	    !m_pDiIfUPOW[nNo]->IsDeviceLink() ) return FALSE;

	return m_pDiIfUPOW[nNo]->Get();
}

void CFaUshioEuv::SetIfUpowState( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDiIfUPOWCount ) || 
	    !m_pDiIfUPOW[nNo]->IsDeviceLink() ) return;

	m_pDiIfUPOW[nNo]->SetState( bVal );
}


// Utility Input //////////////////////////////////////////////////////////
BOOL CFaUshioEuv::GetUtN2FlowH()
{
	if( !IsInitialized() || !m_pDiUtN2FlowH->IsDeviceLink() ) return FALSE;
	return m_pDiUtN2FlowH->Get();
}

void CFaUshioEuv::SetUtN2FlowHState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiUtN2FlowH->IsDeviceLink() ) return;
	m_pDiUtN2FlowH->SetState( bVal );
}

BOOL CFaUshioEuv::GetUtN2FlowL()
{
	if( !IsInitialized() || !m_pDiUtN2FlowL->IsDeviceLink() ) return FALSE;
	return m_pDiUtN2FlowL->Get();
}

void CFaUshioEuv::SetUtN2FlowLState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiUtN2FlowL->IsDeviceLink() ) return;
	m_pDiUtN2FlowL->SetState( bVal );
}

BOOL CFaUshioEuv::GetUtPcwFlowL()
{
	if( !IsInitialized() || !m_pDiUtPcwFlowL->IsDeviceLink() ) return FALSE;
	return m_pDiUtPcwFlowL->Get();
}

void CFaUshioEuv::SetUtPcwFlowLState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiUtPcwFlowL->IsDeviceLink() ) return;
	m_pDiUtPcwFlowL->SetState( bVal );
}

BOOL CFaUshioEuv::GetUtCdaFlowH()
{
	if( !IsInitialized() || !m_pDiUtCdaFlowH->IsDeviceLink() ) return FALSE;
	return m_pDiUtCdaFlowH->Get();
}

void CFaUshioEuv::SetUtCdaFlowHState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiUtCdaFlowH->IsDeviceLink() ) return;
	m_pDiUtCdaFlowH->SetState( bVal );
}

BOOL CFaUshioEuv::GetUtCdaFlowL()
{
	if( !IsInitialized() || !m_pDiUtCdaFlowL->IsDeviceLink() ) return FALSE;
	return m_pDiUtCdaFlowL->Get();
}

void CFaUshioEuv::SetUtCdaFlowLState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiUtCdaFlowL->IsDeviceLink() ) return;
	m_pDiUtCdaFlowL->SetState( bVal );
}

BOOL CFaUshioEuv::GetUtN2FlowAlarmH()
{
	if( !IsInitialized() || !m_pDiUtN2FlowAlarmH->IsDeviceLink() ) return FALSE;
	return m_pDiUtN2FlowAlarmH->Get();
}

void CFaUshioEuv::SetUtN2FlowAlarmHState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiUtN2FlowAlarmH->IsDeviceLink() ) return;
	m_pDiUtN2FlowAlarmH->SetState( bVal );
}

BOOL CFaUshioEuv::GetUtN2FlowAlarmL()
{
	if( !IsInitialized() || !m_pDiUtN2FlowAlarmL->IsDeviceLink() ) return FALSE;
	return m_pDiUtN2FlowAlarmL->Get();
}

void CFaUshioEuv::SetUtN2FlowAlarmLState( BOOL bVal )
{
	if( !IsInitialized() || !m_pDiUtN2FlowAlarmL->IsDeviceLink() ) return;
	m_pDiUtN2FlowAlarmL->SetState( bVal );
}

BOOL CFaUshioEuv::GetUtAlarm(int nNo)
{
	BOOL bFlg = FALSE;
	switch( nNo )
	{
	case 0:
		bFlg = GetUtN2FlowH();
		break;
	case 1:
		bFlg = GetUtN2FlowL();
		break;
	case 2:
		bFlg = GetUtPcwFlowL();
		break;
	case 3:
		bFlg = GetUtCdaFlowH();
		break;
	case 4:
		bFlg = GetUtCdaFlowL();
		break;
	case 5:
		bFlg = GetUtN2FlowAlarmH();
		break;
	case 6:
		bFlg = GetUtN2FlowAlarmL();
		break;	
	}
	return bFlg;
}

// Interface Output //////////////////////////////////////////////////////////
void CFaUshioEuv::SetIfUdlc( BOOL bVal )
{
	if( !IsInitialized() || !m_pDoIfUDLC->IsDeviceLink() ) return;
	m_pDoIfUDLC->Set( bVal );
}

BOOL CFaUshioEuv::GetIfUdlcState()
{
	if( !IsInitialized() || !m_pDoIfUDLC->IsDeviceLink() ) return FALSE;
	return m_pDoIfUDLC->Get();
}

void CFaUshioEuv::SetIfUtre( BOOL bVal )
{
	if( !IsInitialized() || !m_pDoIfUTRE->IsDeviceLink() ) return;
	m_pDoIfUTRE->Set( bVal );
}

BOOL CFaUshioEuv::GetIfUtreState()
{
	if( !IsInitialized() || !m_pDoIfUTRE->IsDeviceLink() ) return FALSE;
	return m_pDoIfUTRE->Get();
}

void CFaUshioEuv::SetIfUlon( BOOL bVal )
{
	if( !IsInitialized() || !m_pDoIfULON->IsDeviceLink() ) return;
	m_pDoIfULON->Set( bVal );
}

BOOL CFaUshioEuv::GetIfUlonState()
{
	if( !IsInitialized() || !m_pDoIfULON->IsDeviceLink() ) return FALSE;
	return m_pDoIfULON->Get();
}

void CFaUshioEuv::SetIfUicr( BOOL bVal )
{
	if( !IsInitialized() || !m_pDoIfUICR->IsDeviceLink() ) return;
	m_pDoIfUICR->Set( bVal );
}

BOOL CFaUshioEuv::GetIfUicrState()
{
	if( !IsInitialized() || !m_pDoIfUICR->IsDeviceLink() ) return FALSE;
	return m_pDoIfUICR->Get();
}

void CFaUshioEuv::SetIfUlst( BOOL bVal )
{
	if( !IsInitialized() || !m_pDoIfULST->IsDeviceLink() ) return;
	m_pDoIfULST->Set( bVal );
}

BOOL CFaUshioEuv::GetIfUlstState()
{
	if( !IsInitialized() || !m_pDoIfULST->IsDeviceLink() ) return FALSE;
	return m_pDoIfULST->Get();
}

void CFaUshioEuv::SetIfUemg( BOOL bVal )
{
	if( !IsInitialized() || !m_pDoIfUEMG->IsDeviceLink() ) return;
	m_pDoIfUEMG->Set( bVal );
}

BOOL CFaUshioEuv::GetIfUemgState()
{
	if( !IsInitialized() || !m_pDoIfUEMG->IsDeviceLink() ) return FALSE;
	return m_pDoIfUEMG->Get();
}

void CFaUshioEuv::SetIfUert( BOOL bVal )
{
	if( !IsInitialized() || !m_pDoIfUERT->IsDeviceLink() ) return;
	m_pDoIfUERT->Set( bVal );
}

BOOL CFaUshioEuv::GetIfUertState()
{
	if( !IsInitialized() || !m_pDoIfUERT->IsDeviceLink() ) return FALSE;
	return m_pDoIfUERT->Get();
}

void CFaUshioEuv::SetIfUher( BOOL bVal )
{
	if( !IsInitialized() || !m_pDoIfUHER->IsDeviceLink() ) return;
	m_pDoIfUHER->Set( bVal );
}

BOOL CFaUshioEuv::GetIfUherState()
{
	if( !IsInitialized() || !m_pDoIfUHER->IsDeviceLink() ) return FALSE;
	return m_pDoIfUHER->Get();
}

void CFaUshioEuv::SetIfUls( int nNo, BOOL bVal )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoIfULSCount ) || 
	    !m_pDoIfULS[nNo]->IsDeviceLink() ) return;

	m_pDoIfULS[nNo]->Set( bVal );
}

BOOL CFaUshioEuv::GetIfUlsState( int nNo )
{
	if( !IsInitialized() ||
		( nNo >= m_nDoIfULSCount ) || 
	    !m_pDoIfULS[nNo]->IsDeviceLink() ) return FALSE;

	return m_pDoIfULS[nNo]->Get();
}
