// FaUshioEuv.h: interface for the CFaUshioEuv class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FAUSHIOEUV_H__9460FA25_59D0_4C42_AC77_80EC0CABAA72__INCLUDED_)
#define AFX_FAUSHIOEUV_H__9460FA25_59D0_4C42_AC77_80EC0CABAA72__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"
#include "..\X\XDigitalOutput.h"	// Added by ClassView
#include "..\X\XDigitalInput.h"	// Added by ClassView

class CFaUshioEuv : public CDevice  
{
public:
	CFaUshioEuv();
	virtual ~CFaUshioEuv();

public:
	BOOL GetUtAlarm( int nNo );
	BOOL ReadConfiguration();
	// Interface Input
	BOOL GetIfUnre();
	void SetIfUnreState( BOOL bVal );
	BOOL GetIfUcre();
	void SetIfUcreState( BOOL bVal );
	BOOL GetIfUlac();
	void SetIfUlacState( BOOL bVal );
	BOOL GetIfUrdy();
	void SetIfUrdyState( BOOL bVal );
	BOOL GetIfUwll();
	void SetIfUwllState( BOOL bVal );
	BOOL GetIfUeuv();
	void SetIfUeuvState( BOOL bVal );
	BOOL GetIfUesf();
	void SetIfUesfState( BOOL bVal );
	BOOL GetIfUeel();
	void SetIfUeelState( BOOL bVal );
	BOOL GetIfUica();
	void SetIfUicaState( BOOL bVal );
	BOOL GetIfUflt();
	void SetIfUfltState( BOOL bVal );
	BOOL GetIfUwnh();
	void SetIfUwnhState( BOOL bVal );
	BOOL GetIfUwlt();
	void SetIfUwltState( BOOL bVal );
	BOOL GetIfUwlo();
	void SetIfUwloState( BOOL bVal );
	BOOL GetIfUwtt();
	void SetIfUwttState( BOOL bVal );
	BOOL GetIfUwnl();
	void SetIfUwnlState( BOOL bVal );
	BOOL GetIfUeco();
	void SetIfUecoState( BOOL bVal );
	BOOL GetIfUopt();
	void SetIfUoptState( BOOL bVal );
	BOOL GetIfUcpu();
	void SetIfUcpuState( BOOL bVal );
	BOOL GetIfUemo();
	void SetIfUemoState( BOOL bVal );
	BOOL GetIfUhry();
	void SetIfUhryState( BOOL bVal );
	BOOL GetIfUhem();
	void SetIfUhemState( BOOL bVal );
	int GetDiIfUlaSize(){ return m_nDiIfULACount; }
	BOOL GetIfUla( int nNo );
	void SetIfUlaState( int nNo, BOOL bVal );
	int GetDiIfUpowSize(){ return m_nDiIfUPOWCount; }
	BOOL GetIfUpow( int nNo );
	void SetIfUpowState( int nNo, BOOL bVal );

	// Utility Input
	BOOL GetUtN2FlowH();
	void SetUtN2FlowHState( BOOL bVal );
	BOOL GetUtN2FlowL();
	void SetUtN2FlowLState( BOOL bVal );
	BOOL GetUtPcwFlowL();
	void SetUtPcwFlowLState( BOOL bVal );
	BOOL GetUtCdaFlowH();
	void SetUtCdaFlowHState( BOOL bVal );
	BOOL GetUtCdaFlowL();
	void SetUtCdaFlowLState( BOOL bVal );
	BOOL GetUtN2FlowAlarmH();
	void SetUtN2FlowAlarmHState( BOOL bVal );
	BOOL GetUtN2FlowAlarmL();
	void SetUtN2FlowAlarmLState( BOOL bVal );

	// Interface Output
	void SetIfUdlc( BOOL bVal );
	BOOL GetIfUdlcState();
	void SetIfUtre( BOOL bVal );
	BOOL GetIfUtreState();
	void SetIfUlon( BOOL bVal );
	BOOL GetIfUlonState();
	void SetIfUicr( BOOL bVal );
	BOOL GetIfUicrState();
	void SetIfUlst( BOOL bVal );
	BOOL GetIfUlstState();
	void SetIfUemg( BOOL bVal );
	BOOL GetIfUemgState();
	void SetIfUert( BOOL bVal );
	BOOL GetIfUertState();
	void SetIfUher( BOOL bVal );
	BOOL GetIfUherState();
	int GetDoIfUlsSize(){ return m_nDoIfULSCount; }
	void SetIfUls( int nNo, BOOL bVal );
	BOOL GetIfUlsState( int nNo );

protected:
	XDigitalInput*		m_pDiIfUNRE;
	XDigitalInput*		m_pDiIfUCRE;
	XDigitalInput*		m_pDiIfULAC;
	XDigitalInput*		m_pDiIfURDY;
	XDigitalInput*		m_pDiIfUWLL;
	XDigitalInput*		m_pDiIfUEUV;
	XDigitalInput*		m_pDiIfUESF;
	XDigitalInput*		m_pDiIfUEEL;
	XDigitalInput*		m_pDiIfUICA;
	XDigitalInput*		m_pDiIfUFLT;
	XDigitalInput*		m_pDiIfUWNH;
	XDigitalInput*		m_pDiIfUWLT;
	XDigitalInput*		m_pDiIfUWLO;
	XDigitalInput*		m_pDiIfUWTT;
	XDigitalInput*		m_pDiIfUWNL;
	XDigitalInput*		m_pDiIfUECO;
	XDigitalInput*		m_pDiIfUOPT;
	XDigitalInput*		m_pDiIfUCPU;
	XDigitalInput*		m_pDiIfUEMO;
	XDigitalInput*		m_pDiIfUHRY;
	XDigitalInput*		m_pDiIfUHEM;
	XDigitalInput**		m_pDiIfULA;
	XDigitalInput**		m_pDiIfUPOW;
	int					m_nDiIfULACount;
	int					m_nDiIfUPOWCount;

	XDigitalInput*		m_pDiUtN2FlowH;
	XDigitalInput*		m_pDiUtN2FlowL;
	XDigitalInput*		m_pDiUtPcwFlowL;
	XDigitalInput*		m_pDiUtCdaFlowH;
	XDigitalInput*		m_pDiUtCdaFlowL;
	XDigitalInput*		m_pDiUtN2FlowAlarmH;
	XDigitalInput*		m_pDiUtN2FlowAlarmL;

	XDigitalOutput*		m_pDoIfUDLC;
	XDigitalOutput*		m_pDoIfUTRE;
	XDigitalOutput*		m_pDoIfULON;
	XDigitalOutput*		m_pDoIfUICR;
	XDigitalOutput*		m_pDoIfULST;
	XDigitalOutput*		m_pDoIfUEMG;
	XDigitalOutput*		m_pDoIfUERT;
	XDigitalOutput*		m_pDoIfUHER;
	XDigitalOutput**	m_pDoIfULS;
	int					m_nDoIfULSCount;
};

#endif // !defined(AFX_FAUSHIOEUV_H__9460FA25_59D0_4C42_AC77_80EC0CABAA72__INCLUDED_)
