// GlassAni.cpp : implementation file
//

#include "stdafx.h"
#include "Dics.h"
#include "GlassAni.h"
#include "DicsDoc.h"
#include "DicsView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTransferAni
// MAX_RBT_ANI_NO : TR, LD UPPER, LD LOWER, UL UPPER, UL LOWER : 5 EA
// TR UNIT : RECV (0:Current Position)	        WAIT Pos(1)		SEND Pos(2)
// LD UPPER :													(2:Position)
//																(1:Position)
//																(0:Current Position)
// LD UPPER :													(2:Position)
//																(1:Position)
//																(0:Current Position)
ANI_AXIS CGlassAni::m_RbtPos[MAX_RBT_ANI_NO][MAX_RBT_POS_NO] =
{
#ifndef _LTYPE
	{ 
		{ 0, 0 },
		{ 0, -168 }
	},
	{ 
		{ 0, 0 },
		{ 0, -168 }
	},
	{ 
		{ 0, 0 },
		{ 0, -168 }
	},
	{ 
		{ 0, 0 },
		{ 0, -169 }
	},
	{ 
		{ 0, 0 },
		{ 0, -169 }
	},
	{ 
		{ 0, 0 },
		{ 0, -169 }
	},
	{ 
		{ 0, 0 },
		{ 0, -169 }
	},
	{ 
		{ 0, 0 },
		{ 0, -169 }
	},
	{ 
		{ 0, 0 },
		{ 0, -169 }
	},
	{ 
		{ 0, 0 },
		{ 0, -169  }
	},
	{ 
		{ 0, 0 },
		{ 0, -169 }
	},
#else
	{ 
		{ 0, 0 },
		{ 0, -153 }
	},
	{ 
		{ 0, 0 },
		{ 0, -153 }
	},
	{ 
		{ 0, 0 },
		{ 0, -153 }
	},
	{ 
		{ 0, 0 },
		{ 0, -153 }
	},
	{ 
		{ 0, 0 },
		{ 0, -153 }
	},
	{ 
		{ 0, 0 },
		{ 0, -153 }
	},
	{ 
		{ 0, 0 },
		{ 0, -153 }
	},
	{ 
		{ 0, 0 },
		{ 0, -153 }
	},
	{ 
		{ 0, 0 },
		{ 0, -153 }
	},
	{ 
		{ 0, 0 },
		{ 0, -154  }
	},
	{ 
		{ 0, 0 },
		{ 0, -154 }
	},
#endif
};

///////RTYPE/////////////////////////////////////////////////////////////////
//	CGlassAni
//							|---------------------> +X
// RECV				 WAIT Pos(0)					SEND Pos(1)
// UL UP Hand(18, 19)		|						LD Up Hand(2,3)
//							+Y
// UL LO Hand(16, 17)								LD LO Hand(4,5)
// UL(15,14)	AK(13,12)	RB(11,10)	EUV(9,8)	LD(7,6)
/////////////////////////////////////////////////////////////////////////////
///////LTYPE/////////////////////////////////////////////////////////////////
//	CGlassAni
//							|---------------------> +X
// SEND	Pos(1)	     WAIT Pos(0)					RECV 
// LD UP Hand(2,3)			|						UL Up Hand(18,19)
//							+Y
// LD LO Hand(4, 5)									UL LO Hand(16,17)
// LD(6,7)		EUV(8,9)	RB(10,11)	AK(12,13)	UL(14,15)
/////////////////////////////////////////////////////////////////////////////

///////SAHDC RTYPE///////////////////////////////////////////////////////////
//	CGlassAni
//	|---------------------> +X						
// RECV(0)				 WAIT Pos(1)					SEND Pos(2)
// UL UP Hand(18, 19)		|						LD Up Hand(2,3)
//							+Y
// UL LO Hand(16, 17)								LD LO Hand(4,5)
// UL(15,14)	AK(13,12)	RB(11,10)	EUV(9,8)	LD(7,6)
/////////////////////////////////////////////////////////////////////////////
ANI_AXIS CGlassAni::m_GlassPos[MAX_GLASS_NO][(MAX_UNIT_NO) * 2] = 
{
	/*
	{	
		{ 0,   0 },		// 0 UP LD IN
		{ 48,  0 },		// 1 UP LD OUT
		{ 152,  0 },	// 2 BUF1 IN
		{ 200, 0 },		// 3 BUF1 OUT
		{ 300, 0 },		// 4 BUF MID IN
		{ 348, 0 },		// 5 BUF MID OUT
		{ 450, 0 },		// 4 BUF2 IN
		{ 498, 0 },		// 5 BUF2 OUT
		{ 600, 0 },		// 6 LD IN  (RECV)
		{ 601, 0 },		// 7 LD OUT (RECV) 
		{ 601, 155 },	// 8 LD IN (SEND)
		{ 601, 155 },	// 9 LD OUT(SEND)
		{ 515, 155 },	// 10 BUF3 IN
		{ 480, 155 },	// 11 BUF3 OUT
		{ 410, 155 },	// 12 RB IN
		{ 376, 155 },	// 13 RB OUT
		{ 307, 155 },	// 14 SWR1 IN
		{ 273, 155 },	// 15 SWR1 OUT
		{ 204, 155 },	// 16 SWR2 IN
		{ 172, 155 },	// 17 SWR2 OUT
		{ 101, 155 },	// 16 AK IN
		{ 70, 155 },	// 17 AK OUT
		{ 1,  155 },	// 18 UL IN
		{ -15,   155 },	// 19 UL OUT
	},	// Glass1
	*/
	{	
		{   0, 0 },	// 0 LD IN
		{  20, 0 },	// 1 LD OUT
		{  40, 0 },	// 2 SWR1 IN
		{ 105, 0 },	// 3 SWR1 OUT
		{ 140, 0 },	// 4 SWR2 IN
		{ 205, 0 },	// 5 SWR2 OUT
		{ 240, 0 },	// 4 SWR3 IN
		{ 305, 0 },	// 5 SWR3 OUT
		{ 350, 0 },	// 6 SWR4 IN
		{ 405, 0 },	// 7 SWR4 OUT
		{ 440, 0 },	// 8 AK IN
		{ 505, 0 },	// 9 AK OUT
		{ 540, 0 },	// 10 BUF IN
		{ 615, 0 },	// 11 BUF OUT
		{ 645, 0 },	// 12 UL IN
		{ 740, 0 },	// 13 UL OUT
	},	// Glass1
};

LEN_INFO CGlassAni::m_LenInfo = 
{	// Fig	Real
	//750,	10200,	// 0	Glass Size( fig. 124 , real 1850 ) 5.009(mm/pixel)  Glass G5 1100 X 1300
	120,	2000,
};

CGlassAni::CGlassAni(CWnd *pOwner)
{
	// Create window
	VERIFY(CreateEx(0, AfxRegisterWndClass(0), _T("Glass Animation"), 
		WS_OVERLAPPED, 0, 0, 0, 0, NULL, NULL));

	// Set Owner
	m_pOwner = pOwner;

	// Set the glass position : Initialize at here
	for( int i=1; i<MAX_GLASS_NO; i++ )
	{
		for( int j=0; j<( (MAX_UNIT_NO)*2 ); j++ ) m_GlassPos[i][j] = m_GlassPos[0][j];
	}

	// Set the robot position
	for( int i=0; i<MAX_RBT_ANI_NO; i++ ) 
	{ 
		m_RbtMoveOn[i].nX	= 0;		// stop
		m_RbtMoveOn[i].nY	= 0;		// stop
		m_RbtDir[i].nX		= 0;
		m_RbtDir[i].nY		= 0;

		m_nRbtPosNo[i]		= -1;		// position is not defined
		m_fRbtMoveSpeed[i]	= 1.0;		// default

		for( int j=0; j<MAX_RBT_POS_NO; j++ ) m_bRbtMoveEnd[i][j] = FALSE;
	}

	// set the glass position
	for( int i=0; i<MAX_GLASS_NO; i++ )
	{ 
		m_GlassMoveOn[i].nX = 0;
		m_GlassMoveOn[i].nY = 0;
		m_GlassDir[i].nX = 0;
		m_GlassDir[i].nY = 0;

		m_nGlassPosNo[i]	= -1;		//  position is not defined
		m_fGlassMoveSpeed[i] = 1.0;
		m_bGlassMoveTarget[i] = FALSE;
	}
	m_bRun = TRUE;	// Glass Move Stop & Start ؼ
}

CGlassAni::~CGlassAni()
{
}

BEGIN_MESSAGE_MAP(CGlassAni, CWnd)
	//{{AFX_MSG_MAP(CGlassAni)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGlassAni message handlers

int CGlassAni::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	SetTimer( TIMER_CV_GLASS_MOVE, TIME_GLASS_MOVE, NULL );
	
	return 0;
}

void CGlassAni::OnDestroy() 
{
	CWnd::OnDestroy();
	
	KillTimer( TIMER_CV_GLASS_MOVE );
}

void CGlassAni::OnTimer(UINT nIDEvent) 
{
	// If its mode is auto and not initialize, then move glass
	// Glass Move
	if( m_bRun )
	{
		for( int i=0; i<MAX_GLASS_NO; i++ ) 
		{ 
			if( m_GlassMoveOn[i].nX || m_GlassMoveOn[i].nY ) GlassMove( i ); 
		}
		
		for( int i=0; i<MAX_RBT_ANI_NO; i++ )
		{
			if( m_RbtMoveOn[i].nX || m_RbtMoveOn[i].nY ) RbtMove( i );
		}
	}
	CWnd::OnTimer(nIDEvent);
}

//------------------------------------------------------------------------------------------------
// Initialize the glass resources.
// nDir : dTop, dBottom, dRight, dLeft
//		  dTop : Buttom => Top
//		  dLeft : Right => Left, 
//		  dRight : Left => Right,
//		  dBottom : Top => Bottom,
// nResNo : virtual glass resource ID
//------------------------------------------------------------------------------------------------
void CGlassAni::InitGlassMove( int nGlassNo, BOOL bVisible )
{
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_STATIC_GLASS1 + nGlassNo )->GetWindowRect( &m_rectGlass[nGlassNo] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->ScreenToClient( &m_rectGlass[nGlassNo] );
	m_rectInitGlass[nGlassNo] = m_rectGlass[nGlassNo];

	if( !bVisible )
	{
		// hide the glass
		( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_STATIC_GLASS1 + nGlassNo )->ShowWindow( FALSE );
	}
}

//------------------------------------------------------------------------------------------------
// Only show window, nothing else.
//------------------------------------------------------------------------------------------------
void CGlassAni::StartGlassMove( int nGlassNo )
{
	// Show window
	if( !( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_STATIC_GLASS1 + nGlassNo )->IsWindowVisible() ) 
		( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_STATIC_GLASS1 + nGlassNo )->ShowWindow( TRUE );	
}

//------------------------------------------------------------------------------------------------
// start the glass moving
// dTop, dBottom, dRight, dLeft
//------------------------------------------------------------------------------------------------
void CGlassAni::GlassMove( int nGlassNo )
{
	CRect rect( m_rectGlass[nGlassNo] );
	int nPosNo	= m_nGlassPosNo[nGlassNo];

	// Move X-Direction
	if( m_bGlassMoveTarget[nGlassNo] && m_GlassMoveOn[nGlassNo].nX )
	{	
		int nCurPos	= rect.left - m_rectInitGlass[nGlassNo].left;

		// ó ġ  Ÿ Target ġ ?
		if( nCurPos < m_GlassPos[nGlassNo][nPosNo].nX )
		{
			// ࿡ ݴ  ̴µ   Target ġ  
			if( m_GlassDir[nGlassNo].nX == -1 )
			{
				GlassMoveRegion( nGlassNo, nPosNo );
				m_GlassMoveOn[nGlassNo].nX = 0;
				m_GlassDir[nGlassNo].nX = 0;
			}
		}
		// Target ġ Ȯ  ==> 
		else if( nCurPos ==  m_GlassPos[nGlassNo][nPosNo].nX ) 
		{
			m_GlassMoveOn[nGlassNo].nX = 0;
			m_GlassDir[nGlassNo].nX = 0;
		}

		// ó ġ  Ÿ Target ġ ũ?
		else if( nCurPos >  m_GlassPos[nGlassNo][nPosNo].nX )
		{
			if( m_GlassDir[nGlassNo].nX == 1 )
			{
				GlassMoveRegion( nGlassNo, m_nGlassPosNo[nGlassNo] );
				m_GlassMoveOn[nGlassNo].nX = 0;
				m_GlassDir[nGlassNo].nX = 0;
			}
		}
	}

	// Move Y-Direction
	if( m_bGlassMoveTarget[nGlassNo] && m_GlassMoveOn[nGlassNo].nY )
	{
		int nCurPos	= rect.top - m_rectInitGlass[nGlassNo].top;

		// ó ġ  Ÿ Target ġ ?
		if( nCurPos < m_GlassPos[nGlassNo][nPosNo].nY )
		{
			// ࿡ ݴ  ̴µ   Target ġ  
			if( m_GlassDir[nGlassNo].nY == -1 )
			{
				GlassMoveRegion( nGlassNo, nPosNo );
				m_GlassMoveOn[nGlassNo].nY = 0;
				m_GlassDir[nGlassNo].nY = 0;
			}
		}
		// Target ġ Ȯ  ==> 
		else if( nCurPos ==  m_GlassPos[nGlassNo][nPosNo].nY ) 
		{
			m_GlassMoveOn[nGlassNo].nY = 0;
			m_GlassDir[nGlassNo].nY = 0;
		}

		// ó ġ  Ÿ Target ġ ũ?
		else if( nCurPos >  m_GlassPos[nGlassNo][nPosNo].nY )
		{
			//  ̴µ ũ  Target ġ  
			if( m_GlassDir[nGlassNo].nY == 1 )
			{
				GlassMoveRegion( nGlassNo, m_nGlassPosNo[nGlassNo] );
				m_GlassMoveOn[nGlassNo].nY = 0;
				m_GlassDir[nGlassNo].nY = 0;
			}
		}
	}

	// Set the speed : Re-calculation the speed value that is lower than 1
	float fSpeed[MAX_GLASS_NO];
	if( m_fGlassMoveSpeed[nGlassNo] < 1 )
	{
		static float fOldSpeed[MAX_GLASS_NO] = { 0, };
		fOldSpeed[nGlassNo] += m_fGlassMoveSpeed[nGlassNo];
		if( fOldSpeed[nGlassNo] > 1.0 )
		{
			fOldSpeed[nGlassNo] -= 1.0;
			fSpeed[nGlassNo] = 1;
		}
		else fSpeed[nGlassNo] = 0;
	}
	else fSpeed[nGlassNo] = m_fGlassMoveSpeed[nGlassNo];

	rect.left = (long) ( rect.left + m_GlassDir[nGlassNo].nX * fSpeed[nGlassNo] );
	rect.right  = (long) ( rect.right + m_GlassDir[nGlassNo].nX * fSpeed[nGlassNo] );
	rect.top = (long) ( rect.top + m_GlassDir[nGlassNo].nY * fSpeed[nGlassNo] );
	rect.bottom  = (long) ( rect.bottom + m_GlassDir[nGlassNo].nY * fSpeed[nGlassNo] );

	m_rectGlass[nGlassNo] = rect;

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_STATIC_GLASS1 + nGlassNo )->MoveWindow( &m_rectGlass[nGlassNo] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_STATIC_GLASS1 + nGlassNo )->Invalidate( TRUE );
}

//------------------------------------------------------------------------------------------------
// m_bGlassMoveOn : ON => Move the glass
// m_bGlassMoveOn : OFF => Stop the glass
//------------------------------------------------------------------------------------------------
void CGlassAni::GlassMove( int nGlassNo, int nPosNo, BOOL bMove, BOOL bGoTarget )
{
	// Check the position no.
	if( nPosNo <= (MAX_UNIT_NO) * 2 )
	{
		CRect rect( m_rectGlass[nGlassNo] );

		// Set the glass direction
		int nCurPos	= rect.left - m_rectInitGlass[nGlassNo].left;
		if( nCurPos < m_GlassPos[nGlassNo][nPosNo].nX ) m_GlassDir[nGlassNo].nX = 1;
		else if( nCurPos > m_GlassPos[nGlassNo][nPosNo].nX ) m_GlassDir[nGlassNo].nX = -1;
		else m_GlassDir[nGlassNo].nX = 0;

		nCurPos	= rect.top - m_rectInitGlass[nGlassNo].top;
		if( nCurPos < m_GlassPos[nGlassNo][nPosNo].nY ) m_GlassDir[nGlassNo].nY = 1;
		else if( nCurPos > m_GlassPos[nGlassNo][nPosNo].nY ) m_GlassDir[nGlassNo].nY = -1;
		else m_GlassDir[nGlassNo].nY = 0;

		// Set the position number
		m_nGlassPosNo[nGlassNo] = nPosNo;
	}

	m_bGlassMoveTarget[nGlassNo] = bGoTarget;
	m_GlassMoveOn[nGlassNo].nX = bMove;
	m_GlassMoveOn[nGlassNo].nY = bMove;
}

//------------------------------------------------------------------------------------------------
// Set the glass moving speed
// nSpeed = mm / min
//------------------------------------------------------------------------------------------------
void CGlassAni::SetGlassMoveSpeed( int nGlassNo, int nSpeed )
{
	float fTime = ( (float)( TIME_GLASS_MOVE / 1000.0 ) );
	double dVal = (( (float)m_LenInfo.nLengthReal / (float)nSpeed ) );
	m_fGlassMoveSpeed[nGlassNo] = (float) ( (float) ( m_LenInfo.nLengthFig / dVal ) * fTime );
}

//------------------------------------------------------------------------------------------------
// Move the glass any region
//------------------------------------------------------------------------------------------------
void CGlassAni::GlassMoveRegion( int nGlassNo, int nCvNo, int bAutoStop )
{
	if( bAutoStop )
	{
		// stop the glass automatically.
		m_GlassMoveOn[nGlassNo].nX = 0;
		m_GlassMoveOn[nGlassNo].nY = 0;
	}

	CRect rect( m_rectInitGlass[nGlassNo] );

	// dTop, dBottom, dRight, dLeft
	rect.top = rect.top + m_GlassPos[nGlassNo][nCvNo].nY;
	rect.bottom =  rect.bottom + m_GlassPos[nGlassNo][nCvNo].nY;
	rect.left =  rect.left + m_GlassPos[nGlassNo][nCvNo].nX;
	rect.right = rect.right + m_GlassPos[nGlassNo][nCvNo].nX;

	m_rectGlass[nGlassNo] = rect;

//	TRACE( "Top = %d, Bottom = %d, Left = %d, Right = %d \n", rect.top, rect.bottom, rect.left, rect.right );
	
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_STATIC_GLASS1 + nGlassNo )->MoveWindow( &rect );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_STATIC_GLASS1 + nGlassNo )->Invalidate( TRUE );
}

//------------------------------------------------------------------------------------------------
// Hide the glass and move to initial position.
//------------------------------------------------------------------------------------------------
void CGlassAni::EndGlassMove( int nGlassNo )
{
	// Hide window
	if( ( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_STATIC_GLASS1 + nGlassNo )->IsWindowVisible() ) 
		( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_STATIC_GLASS1 + nGlassNo )->ShowWindow( FALSE );	

	m_rectGlass[nGlassNo] = m_rectInitGlass[nGlassNo];
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_STATIC_GLASS1 + nGlassNo )->MoveWindow( &m_rectGlass[nGlassNo] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_STATIC_GLASS1 + nGlassNo )->Invalidate( TRUE );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_STATIC_GLASS1 + nGlassNo )->ShowWindow( FALSE );	//2008.11.07 kimgun
}

//------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
// For ROBOT
//------------------------------------------------------------------------------------------------
// Hide the Servo Moving Unit initial position.
//------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
void CGlassAni::InitRbtMove(int nRbtNo, int nDir)
{
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR5_1 )->GetWindowRect( &m_rectRbt[0] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->ScreenToClient( &m_rectRbt[0] );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR5_2 )->GetWindowRect( &m_rectRbt[1] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->ScreenToClient( &m_rectRbt[1] );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR_SUB5_1 )->GetWindowRect( &m_rectRbt[2] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->ScreenToClient( &m_rectRbt[2] );
	
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR_SUB5_2 )->GetWindowRect( &m_rectRbt[3] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->ScreenToClient( &m_rectRbt[3] );

//hskwak skip/	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_LD_SPEED_DEC )->GetWindowRect( &m_rectRbt[4] );
//hskwak skip/	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->ScreenToClient( &m_rectRbt[4] );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_RBT_STATIC1_1 )->GetWindowRect( &m_rectRbt[5] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->ScreenToClient( &m_rectRbt[5] );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_RBT_STATIC2_1 )->GetWindowRect( &m_rectRbt[6] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->ScreenToClient( &m_rectRbt[6] );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_SUB_UNIT5_1 )->GetWindowRect( &m_rectRbt[7] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->ScreenToClient( &m_rectRbt[7] );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_SUB_UNIT5_2 )->GetWindowRect( &m_rectRbt[8] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->ScreenToClient( &m_rectRbt[8] );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_UNIT5 )->GetWindowRect( &m_rectRbt[9] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->ScreenToClient( &m_rectRbt[9] );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_CV_MOTOR5 )->GetWindowRect( &m_rectRbt[10] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->ScreenToClient( &m_rectRbt[10] );

	m_rectInitRbt[nRbtNo] = m_rectRbt[nRbtNo];	
}

//------------------------------------------------------------------------------------------------
// Servo Unit move to the Set Position
//------------------------------------------------------------------------------------------------
void CGlassAni::RbtMove(int nRbtNo)
{
	CRect rect(m_rectRbt[nRbtNo]);
	int nPosNo = m_nRbtPosNo[nRbtNo];

	//-----------------------------------------------------------------------
	// For X-Direction
	if( m_RbtMoveOn[nRbtNo].nX )
	{	
		int nCurPos	= rect.left - m_rectInitRbt[nRbtNo].left;

		// ó ġ  Ÿ Target ġ ?
		if( nCurPos < m_RbtPos[nRbtNo][nPosNo].nX )
		{
			// ࿡ ݴ  ̴µ   Target ġ  
			if( m_RbtDir[nRbtNo].nX == -1 )
			{
				RbtMoveRegion( nRbtNo, nPosNo );
				m_RbtMoveOn[nRbtNo].nX = 0;
				m_RbtDir[nRbtNo].nX = 0;
			}
		}

		// Target ġ Ȯ  ==> 
		else if( nCurPos == m_RbtPos[nRbtNo][nPosNo].nX ) 
		{
			m_RbtMoveOn[nRbtNo].nX = 0;
			m_RbtDir[nRbtNo].nX = 0;
		}

		// ó ġ  Ÿ Target ġ ũ?
		else if( nCurPos >  m_RbtPos[nRbtNo][nPosNo].nX )
		{
			if( m_RbtDir[nRbtNo].nX == 1 )
			{
				RbtMoveRegion( nRbtNo, m_nRbtPosNo[nRbtNo] );
				m_RbtMoveOn[nRbtNo].nX = 0;
				m_RbtDir[nRbtNo].nX = 0;
			}
		}
	}

	//-----------------------------------------------------------------------
	// For Y-Direction
	if( m_RbtMoveOn[nRbtNo].nY )
	{
		int nCurPos	= rect.top - m_rectInitRbt[nRbtNo].top;

		// ó ġ  Ÿ Target ġ ?
		if( nCurPos < m_RbtPos[nRbtNo][nPosNo].nY )
		{
			// ࿡ ݴ  ̴µ   Target ġ  
			if( m_RbtDir[nRbtNo].nY == -1 )
			{
				RbtMoveRegion( nRbtNo, nPosNo );
				m_RbtMoveOn[nRbtNo].nY = 0;
				m_RbtDir[nRbtNo].nY = 0;
			}
		}

		// Target ġ Ȯ  ==> 
		else if( nCurPos == m_RbtPos[nRbtNo][nPosNo].nY ) 
		{
			m_RbtMoveOn[nRbtNo].nY = 0;
			m_RbtDir[nRbtNo].nY = 0;
		}

		// ó ġ  Ÿ Target ġ ũ?
		else if( nCurPos >  m_RbtPos[nRbtNo][nPosNo].nY )
		{
			//  ̴µ ũ  Target ġ  
			if( m_RbtDir[nRbtNo].nY == 1 )
			{
				RbtMoveRegion( nRbtNo, m_nRbtPosNo[nRbtNo] );
				m_RbtMoveOn[nRbtNo].nY = 0;
				m_RbtDir[nRbtNo].nY = 0;
			}
		}
	}

#ifdef _MY_DEBUG
	// Set the flag for debugging
	if( m_RbtMoveOn[nRbtNo].nX == 0 && m_RbtMoveOn[nRbtNo].nY == 0 ) m_bRbtMoveEnd[nRbtNo][nPosNo] = TRUE;
#endif

	//-----------------------------------------------------------------------
	// Set the speed : Re-calculation the speed value that is lower than 1
	float fSpeed[MAX_RBT_ANI_NO];
	if( m_fRbtMoveSpeed[nRbtNo] < 1 )
	{
		static float fOldSpeed[MAX_RBT_ANI_NO] = { 0, };
		fOldSpeed[nRbtNo] += m_fRbtMoveSpeed[nRbtNo];
		if( fOldSpeed[nRbtNo] > 1.0 )
		{
			fOldSpeed[nRbtNo] -= 1.0;
			fSpeed[nRbtNo] = 1;
		}
		else fSpeed[nRbtNo] = 0;
	}
	else fSpeed[nRbtNo] = m_fRbtMoveSpeed[nRbtNo];

	rect.left = (long) ( rect.left + m_RbtDir[nRbtNo].nX * fSpeed[nRbtNo] );
	rect.right  = (long) ( rect.right + m_RbtDir[nRbtNo].nX * fSpeed[nRbtNo] );
	rect.top = (long) ( rect.top + m_RbtDir[nRbtNo].nY * fSpeed[nRbtNo] );
	rect.bottom  = (long) ( rect.bottom + m_RbtDir[nRbtNo].nY * fSpeed[nRbtNo] );

	m_rectRbt[nRbtNo] = rect;

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR5_1 )->MoveWindow( &m_rectRbt[0] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR5_1 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR5_2 )->MoveWindow( &m_rectRbt[1] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR5_2 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR_SUB5_1 )->MoveWindow( &m_rectRbt[2] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR_SUB5_1 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR_SUB5_2 )->MoveWindow( &m_rectRbt[3] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR_SUB5_2 )->Invalidate( TRUE );

//hskwak skip/	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_LD_SPEED_DEC )->MoveWindow( &m_rectRbt[4] );
//hskwak skip/	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_LD_SPEED_DEC )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_RBT_STATIC1_1 )->MoveWindow( &m_rectRbt[5] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_RBT_STATIC1_1 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_RBT_STATIC2_1 )->MoveWindow( &m_rectRbt[6] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_RBT_STATIC2_1 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_SUB_UNIT5_1 )->MoveWindow( &m_rectRbt[7] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_SUB_UNIT5_1 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_SUB_UNIT5_2 )->MoveWindow( &m_rectRbt[8] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_SUB_UNIT5_2 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_UNIT5 )->MoveWindow( &m_rectRbt[9] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_UNIT5 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_CV_MOTOR5 )->MoveWindow( &m_rectRbt[10] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_CV_MOTOR5 )->Invalidate( TRUE );
}

//------------------------------------------------------------------------------------------------
// Servo Unit set moving
//------------------------------------------------------------------------------------------------
void CGlassAni::RbtMove(int nRbtNo, int nPosNo)
{
	CRect rect(m_rectRbt[nRbtNo]);

#ifdef _MY_DEBUG
	// Reset Flag : For simulation
	m_bRbtMoveEnd[nRbtNo][nPosNo] = FALSE;
#endif

	// Set the direction
	int nCurPos	= rect.left - m_rectInitRbt[nRbtNo].left;
	if( nCurPos < m_RbtPos[nRbtNo][nPosNo].nX ) m_RbtDir[nRbtNo].nX = 1;
	else if( nCurPos > m_RbtPos[nRbtNo][nPosNo].nX ) m_RbtDir[nRbtNo].nX = -1;
	else m_RbtDir[nRbtNo].nX = 0;

	nCurPos	= rect.top - m_rectInitRbt[nRbtNo].top;
	if( nCurPos < m_RbtPos[nRbtNo][nPosNo].nY ) m_RbtDir[nRbtNo].nY = 1;
	else if( nCurPos > m_RbtPos[nRbtNo][nPosNo].nY ) m_RbtDir[nRbtNo].nY = -1;
	else m_RbtDir[nRbtNo].nY = 0;

	m_RbtMoveOn[nRbtNo].nX = 1;
	m_RbtMoveOn[nRbtNo].nY = 1;
	m_nRbtPosNo[nRbtNo] = nPosNo;
}

//------------------------------------------------------------------------------------------------
// Servo Unit Speed Setting
//------------------------------------------------------------------------------------------------
void CGlassAni::SetRbtMoveSpeed( int nRbtNo, int nSpeed )
{
	float fTime = ( (float)( TIME_GLASS_MOVE / 1000.0 ) );
	double dVal = ( ( (float)m_LenInfo.nLengthReal / (float)nSpeed ) );

//	m_fRbtMoveSpeed[nRbtNo] = (float)(((720*nTrSpeed)/4800.0)*fTime);

	m_fRbtMoveSpeed[nRbtNo] = (float) ( (float) ( m_LenInfo.nLengthFig / dVal ) * fTime );
}

//------------------------------------------------------------------------------------------------
// Servo Unit move the any region
//------------------------------------------------------------------------------------------------
void CGlassAni::RbtMoveRegion( int nRbtNo, int nPosNo )
{
	CRect rect( m_rectInitRbt[nRbtNo] );

	// dTop, dBottom, dRight, dLeft
	rect.top = rect.top + m_RbtPos[nRbtNo][nPosNo].nY;
	rect.bottom =  rect.bottom + m_RbtPos[nRbtNo][nPosNo].nY;
	rect.left =  rect.left + m_RbtPos[nRbtNo][nPosNo].nX;
	rect.right = rect.right + m_RbtPos[nRbtNo][nPosNo].nX;

	m_rectRbt[nRbtNo] = rect;

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR5_1 )->MoveWindow( &m_rectRbt[0] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR5_1 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR5_2 )->MoveWindow( &m_rectRbt[1] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR5_2 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR_SUB5_1 )->MoveWindow( &m_rectRbt[2] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR_SUB5_1 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR_SUB5_2 )->MoveWindow( &m_rectRbt[3] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_SENSOR_SUB5_2 )->Invalidate( TRUE );
	
//hskwak skip/	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_LD_SPEED_DEC )->MoveWindow( &m_rectRbt[4] );
//hskwak skip/	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_GLS_EXIST_LD_SPEED_DEC )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_RBT_STATIC1_1 )->MoveWindow( &m_rectRbt[5] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_RBT_STATIC1_1 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_RBT_STATIC2_1 )->MoveWindow( &m_rectRbt[6] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_RBT_STATIC2_1 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_SUB_UNIT5_1 )->MoveWindow( &m_rectRbt[7] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_SUB_UNIT5_1 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_SUB_UNIT5_2 )->MoveWindow( &m_rectRbt[8] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_SUB_UNIT5_2 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_UNIT5 )->MoveWindow( &m_rectRbt[9] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_UNIT5 )->Invalidate( TRUE );

	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_CV_MOTOR5 )->MoveWindow( &m_rectRbt[10] );
	( (CDicsView*) m_pOwner)->m_pTabJobsMainView->GetDlgItem( IDC_CV_MOTOR5 )->Invalidate( TRUE );
}

//------------------------------------------------------------------------------------------------
// stop the moving glass
//------------------------------------------------------------------------------------------------
void CGlassAni::GlassMoveStop()
{
	m_bRun = FALSE;
}

//------------------------------------------------------------------------------------------------
// Restart the glass
//------------------------------------------------------------------------------------------------
void CGlassAni::GlassMoveStart()
{
	m_bRun = TRUE;
}
