#if !defined(AFX_GLASSANI_H__FB38702A_E423_4C2F_9882_AA8D5A9A9F93__INCLUDED_)
#define AFX_GLASSANI_H__FB38702A_E423_4C2F_9882_AA8D5A9A9F93__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GlassAni.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CGlassAni window

#define TIME_GLASS_MOVE		40	// 1 sec
#define MAX_RBT_POS_NO		2
#define MAX_RBT_ANI_NO		11

#define LENGTH_FIG			800
#define LENGTH_REAL			5300
#define MAX_GLASS_NO		4

#define ANI_RBT_POS_1		0
#define ANI_RBT_POS_2		1
#define ANI_RBT_POS_3		2

#define TR_SPEED_RATIO		0.7
#define UPDOWN_SPEED_RATIO	2.0


typedef struct tagLengthInfo 
{
	int nLengthFig;
	int nLengthReal;
} LEN_INFO;

typedef struct tagAXIS
{
	int nX;
	int nY;
} ANI_AXIS;	// Animation coordinate

typedef struct tagGlsPos
{
	int xPos;
	int yPos;
} GLASSPOS;

typedef struct tagGlsDir
{
	int xDir;
	int yDir;
} GLASSDIR;

class CGlassAni : public CWnd
{
// Construction
public:
	CGlassAni(CWnd *pOwner);

// Attributes
public:
	CWnd* m_pOwner;

	static LEN_INFO	m_LenInfo;

	// define for glass
	static ANI_AXIS m_GlassPos[MAX_GLASS_NO][(MAX_UNIT_NO) * 2];
	static ANI_AXIS m_RbtPos[MAX_RBT_ANI_NO][MAX_RBT_POS_NO];
	ANI_AXIS		m_GlassMoveOn[MAX_GLASS_NO];
	ANI_AXIS		m_GlassDir[MAX_GLASS_NO];

	int				m_nGlassPosNo[MAX_GLASS_NO];
	CRect			m_rectGlass[MAX_GLASS_NO];
	CRect			m_rectInitGlass[MAX_GLASS_NO];
	float			m_fGlassMoveSpeed[MAX_GLASS_NO];

	// define for robot
	ANI_AXIS		m_RbtMoveOn[MAX_RBT_ANI_NO];
	ANI_AXIS		m_RbtDir[MAX_RBT_ANI_NO];

	int				m_nRbtPosNo[MAX_RBT_ANI_NO];
	CRect			m_rectInitRbt[MAX_RBT_ANI_NO];
	CRect			m_rectRbt[MAX_RBT_ANI_NO];
	float			m_fRbtMoveSpeed[MAX_RBT_ANI_NO];

	enum	_GLASS_DIR {dTop, dBottom, dRight, dLeft};
	enum	_RBT_POS	{ aniPOS1, aniPOS2, aniPOS3 };
	enum	_RBT_TR_POS	{ aniTR_RECV, aniTR_WAIT, aniTR_SEND };
	enum	_RBT_LDUP_POS{ aniLDUP_SEND, aniLDUP_RECV };
	enum	_RBT_ULHAND_POS{aniULHAND_RECV, aniULHAND_SEND};

	BOOL			m_bRbtMoveEnd[MAX_RBT_ANI_NO][MAX_RBT_POS_NO];
	BOOL			m_bGlassMoveTarget[MAX_GLASS_NO];
// Operations
public:
	void SetOwner(CWnd* pOwner) { m_pOwner = pOwner; }

	void InitRbtMove(int nTrNo, int nDir);
	void RbtMove(int nTrNo);
	void RbtMove(int nTrNo, int nPosNo);
	void SetRbtMoveSpeed( int nTrNo, int nSpeed );
	void RbtMoveRegion( int nTrNo, int nPosNo );

	void InitGlassMove( int nResNo, BOOL bVisible = FALSE );
	void StartGlassMove( int nGlassNo );
	void GlassMove( int nGlassNo );
	void GlassMove( int nGlassNo, int nPosNo, BOOL bMove = TRUE, BOOL bGoTarget = FALSE );
	void SetGlassMoveSpeed( int nGlassNo, int nSpeed );
	void GlassMoveRegion( int nGlassNo, int nCvNo, int bAutoStop = FALSE );
	void EndGlassMove( int nGlassNo );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGlassAni)
	//}}AFX_VIRTUAL

// Implementation
public:
	BOOL m_bRun;
	void GlassMoveStart();
	void GlassMoveStop();
	virtual ~CGlassAni();

	// Generated message map functions
protected:
	//{{AFX_MSG(CGlassAni)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GLASSANI_H__FB38702A_E423_4C2F_9882_AA8D5A9A9F93__INCLUDED_)
