// Host.cpp: implementation of the CHost class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Dics.h"
#include "Host.h"
#include "X\Xlog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
#ifdef __LOG__
extern XLog HostLog;
#endif

CHost::CHost()
{
	m_flagS7F25Received = FALSE;
	m_flagS1F79Received = FALSE;
	m_flagS1F77Received = FALSE;
	m_flagONLINE_FAIL	= FALSE;

	m_dS1F3SampleTime = 0.0;
	m_dS1F3SampleTime1 = 0.0;
	m_dS1F3RecvSampTime = 0.0;
	m_dS1F3SendSampTime = 0.0;
	m_dS2F23SampleTime = 0.0;
	m_dS2F23SampleTime1 = 0.0;
	m_nS2F23ListSize = 0;

	for( int i=0; i<MAX_PORT_NO; i++ )
	{
		m_flagS7F65Received[i] = FALSE;
		m_flagS2F27Received[i] = FALSE;
		m_flagS2F21Received[i] = FALSE;
	}
	m_nPortNo			= 0;
}

CHost::~CHost()
{
}
/*
CString CHost::m_S1F5ItemName[] = 
{
	"EUV_N2_P",		"EUV_EXT",		"EUV1_USE_T",		"EUV2_USE_T",
	"EUV3_USE_T",	"PCW_IN_P",		"SBJ_CDA_P",		"DRV_AIR_P",
	"AC_M_CDA_P",	"AK_U_F",		"AK_L_F",			"AK_U_P",
	"AK_L_P",		"AK_U_EXT",		"AK_L_EXT",			"AK_U_BLW",
	"AK_L_BLW",		"AK_DMP_ON_OF",	"RB1_UP_GAP",		"RB1_LO_GAP",
	"RB2_UP_GAP",	"RB2_LO_GAP",	"DET_TK1_TMP",		"DET_TK2_TMP",
	"RB_EXT",		"SBJ_EXT",		"SBJ_M_CDA_P",		"AQK_DI_REST",
	"DI_TK_REST"
};

CString CHost::m_TraceDataName[] = 
{
	"LOT_ID",			"SLOT_NO",			"GLASS_ID",			"RECIPE_ID",
	"TACT_TIME",		"CONV_SPD",			"JOB_USE",			"EUV1_ON_OFF",
	"EUV2_ON_OFF",		"EUV3_ON_OFF",		"EUV4_ON_OFF",		"EUV5_ON_OFF",
	"EUV6_ON_OFF",		"EUV7_ON_OFF",		"EUV8_ON_OFF",		"UP_RB1_ON_OFF",
	"LO_RB1_ON_OFF",	"UP_RB2_ON_OFF",	"LO_RB2_ON_OFF",	"UP_RB1_DIR",
	"LO_RB1_DIR",		"UP_RB2_DIR",		"LO_RB2_DIR",		"UP_RB1_SPD",
	"LO_RB1_SPD",		"UP_RB2_SPD",		"LO_RB2_SPD",		"UP_RB1_GAP",
	"LO_RB1_GAP",		"UP_RB2_GAP",		"LO_RB2_GAP",		"EUV1_ILLUMIN",
	"EUV2_ILLUMIN",		"EUV3_ILLUMIN",		"EUV4_ILLUMIN",		"EUV5_ILLUMIN",
	"EUV6_ILLUMIN",		"EUV7_ILLUMIN",		"EUV8_ILLUMIN",		"EUV_H_EXT",	
	"EUV_A_EXT",		"EUV_CDA_PRS",		"CLN_EXT1",			"CLN_EXT2",
	"FR_EXT1",			"FR_EXT2",			"CLN_UP_SH_FLOW",	"CLN_LO_SH_FLOW",	
	"SBJ1_DI_FLOW",		"SBJ2_DI_FLOW",		"SBJ3_DI_FLOW",		"SBJ_LO_SH_FLOW",
	"SBJ_SH_FLOW",		"AQK_SH_FLOW",		"TANK_DI_RESIST",	"FR_DI_RESIST",
	"AK_UP_EXT",		"AK_LO_EXT",		"AK_UP_PRS",    	"AK_LO_PRS",
	"AK_UP_FLOW",		"AK_LO_FLOW",		"SBJ1_CDA_PRS",		"SBJ2_CDA_PRS",	
	"SBJ3_CDA_PRS",		"DRV_AIR_PRS",	
};
*/
CString CHost::m_RecipeName[] = 
{
/*
	"TACT_TIME",
	"CONV_SPD",
	"JOB_USE",
// #ifndef _NO_EUV
// 	"EUV1_ON_OFF",
// 	"EUV2_ON_OFF",
// 	"EUV3_ON_OFF",
// 	"EUV4_ON_OFF",
// #endif
//#ifndef _NO_RB
	"UP_RB1_ON_OFF",
	"LO_RB1_ON_OFF",
	"UP_RB2_ON_OFF",
	"LO_RB2_ON_OFF",
	"UP_RB1_DIR",
	"LO_RB1_DIR",
	"UP_RB2_DIR",
	"LO_RB2_DIR",
	"UP_RB1_SPD",
	"LO_RB1_SPD",
	"UP_RB2_SPD",
	"LO_RB2_SPD",
	"UP_RB1_GAP",
	"LO_RB1_GAP",
	"UP_RB2_GAP",
	"LO_RB2_GAP",
//#endif
*/
	"TACT_TIME",
	"PROC_CV_SPEED",
//	"OUT_CV_SPEED",
	"JOB_PROCESS",
	"S2_UP_RB1_USE",
	"S2_LO_RB1_USE",
	"S2_UP_RB2_USE",
	"S2_LO_RB2_USE",
	"S3_UP_RB1_USE",
	"S3_LO_RB1_USE",
	"S3_UP_RB2_USE",
	"S3_LO_RB2_USE",
	"S2_UP_RB1_DIR",
	"S2_LO_RB1_DIR",
	"S2_UP_RB2_DIR",
	"S2_LO_RB2_DIR",
	"S3_UP_RB1_DIR",
	"S3_LO_RB1_DIR",
	"S3_UP_RB2_DIR",
	"S3_LO_RB2_DIR",
	"S2_UP_RB1_SPD",
	"S2_LO_RB1_SPD",
	"S2_UP_RB2_SPD",
	"S2_LO_RB2_SPD",
	"S3_UP_RB1_SPD",
	"S3_LO_RB1_SPD",
	"S3_UP_RB2_SPD",
	"S3_LO_RB2_SPD",
	"S2_UP_RB1_GAP",
	"S2_LO_RB1_GAP",
	"S2_UP_RB2_GAP",
	"S2_LO_RB2_GAP",
	"S3_UP_RB1_GAP",
	"S3_LO_RB1_GAP",
	"S3_UP_RB2_GAP",
	"S3_LO_RB2_GAP",

};
CString CHost::m_S6F65GlsApdName[] = 
{
/*		// 20100528 ssm  L8A
	"GLS_START_T",		"GLS_END_T",		"EUV1_ILLUMIN",		"EUV2_ILLUMIN",
	"EUV3_ILLUMIN",		"EUV4_ILLUMIN",		"EUV_A_EXT",		"CLN_AC_CDA_PRS",
	"CLN_EXT1",			"CLN_EXT2",			"FR_EXT1",			"FR_EXT2",							
	"CLN_UP_SH_FLOW",	"CLN_LO_SH_FLOW",	"SBJ1_DI_FLOW",		"SBJ2_DI_FLOW",		
	"SBJ3_DI_FLOW",		"SBJ_LO_SH_FLOW",	"SBJ_SH_FLOW",		"AQK_SH_FLOW",		
	"TANK_DI_RESIST",	"FR_DI_RESIST",		"AK_UP_EXT1",		"AK_UP_EXT2",		
	"AK_LO_EXT",		"AK_UP_PRS",    	"AK_LO_PRS",		"AK_UP_FLOW",		
	"AK_LO_FLOW",		"SBJ1_CDA_PRS",		"SBJ2_CDA_PRS",		"SBJ3_CDA_PRS",		
	"SBJ1_CDA_FLOW",	"SBJ2_CDA_FLOW",	"SBJ3_CDA_FLOW",	"DRV_AIR_PRS",		
*/
/*
	// 20100528 ssm  L8B
	"GLS_START_T",			"GLS_END_T",			"EUV1_ILLUMIN",		"EUV2_ILLUMIN",
	"EUV3_ILLUMIN",			"EUV4_ILLUMIN",			"EUV_A_EXT",		"RB_AC_CDA_FLOW",
	"RB_AC_CDA_PRS",		"RB_EXT1",				"RB_EXT2",			"RB_LO_SWR_FLOW",							
	"RB_UP_SWR_FLOW",		"RB_MJ1_DI_FLOW",		"FR_MJ3_DI_FLOW",	"FR_MJ1_CDA_PRS",		
	"FR_MJ1CDA_FLOW",		"FR_MJ2CDA_FLOW",		"FR_MJ3CDA_FLOW",	"FR_MJ4CDA_FLOW",
	"FR_EXT1",				"FR_EXT2",				"FR_MJ2_CDA_PRS",	"FR_MJ3_CDA_PRS",
	"FR_MJ4_CDA_PRS",		"MJ_LO_SWR_FLOW",   	"FR_MJ4_DI_FLOW",	"FR_UP_SWR_FLOW",		
	"FR_LO_SWR_FLOW",		"FR_AQASWR_FLOW",		"FR_TANK_DI_RES",	"FR_DI_RES",		
	"AK_UP_EXT1",			"AK_UP_EXT2",			"AK_LO_EXT",		"AK_LO_CDA_PRS",
	"AK_UP_CDA_PRS",		"AK_LO_CDA_FLOW",		"AK_UP_CDA_FLOW",	"DRIV_AIR_PRS",
	"TANK_TOTAL_FLOW",		"FR_TOTAL_FLOW",		"UL_WAIT_TIME",	// 110609 halesu
*/
	// SanghoCho 2015.04.22 L6A
/*	"GLS_START_TIME",			"GLS_END_TIME",			"AK_EXH1",			"AK_EXH2",
	"AK_LO_CDA_FLW",			"AK_UP_CDA_FLW",		"SWR2_MJ1_CDA_FLW",	"SWR2_MJ2_CDA_FLW",
	"SWR2_AQK_DI_WTR_REGISTR",	"AK_LO_CDA_PRESS",		"AK_UP_CDA_PRESS",	"SWR2_MJ1_CDA_PRESS",
	"SWR2_MJ2_CDA_PRESS",		"DRIV_AIR_PRESS",		"IONZR_CDA_PRESS",	"SWR1_AC_CDA_PRESS",
	"SWR1_EXH",					"SWR1_LO_DI_FLW",		"SWR1_UP_DI_FLW",	"SWR2_EXH",
	"SWR2_MJ1_DI_FLW",			"SWR2_MJ2_DI_FLW",		"SWR2_LO_DI_FLW",	"AK_AQK_DI_FLW",
	"AK_UP_DI_FLW",				"SWR2_TNK_WTR_REGISTR",	"UL_WAIT_TIME",
	"RB_EXH",					"RB_AQK_DI_FLW",        "RB_LO_DI_FLW",		"RB_UP_DI_FLW",
	"RB_AQUA_SWR_DI_FLW",       "RB_AC_CDA_PRESS",		"SWR2_DI_WTR_REGISTR",
*/
	//hskwak 2019.07.11

	// 64ea	
	"SLOT_NO",				"RECIPE_ID",			"GLS_START_TIME",	"GLS_END_TIME",		"S1_INCV_CDA",			//1
	"S1_AC_UP_CDA",			"S1_AC_LO_CDA",			"S1_ION_AC_CDA",	"S1_MJ_UP_CDA",		"S1_MJ_LO_CDA",			//2
	"S1_MJ_CDA",			"S1_DI_IN_BE_FT",		"S1_UPMJ_FL_CDA",	"S1_LOMJ_FL_CDA",	"S1_DI_AQUA_FL",		//3
	"S1_UP_MJ_FL_DI",		"S1_LO_MJ_FL_DI",		"S1_BE_FT_DI_FL",	"S1_DI_LO_SW_FL",	"S1_DI_UP_SW_FL",		//4
	"S1_DI_WR",				"S1_EXH",				"S2_DI_BE_FT_PG",	"S2_RE_DI_FL",		"S2_DI_LO_S2_FL",		//5
	"S2_DI_S2_FL",			"S2_DI_UP_S2_FL",		"S2_DI_WR",			"S2_EXH",			"S3_DI_BE_FT_PG",		//6
	"S3_CDA_MJ_PG",			"S3_CDA_SP_PG",			"S3_CDA_S4MJ_PG",	"S3_LO_S3_FL",		"S3_DI_BE_FT_FL",		//7
	"S3_UP_S3_FL",			"S3_CDA_S4MJ_FL",		"S3_SPRE_FL",		"S3_DI_WR",			"S3_EXH",				//8
	"S4_LO_SWR_FL",			"S4_MJ_FL",				"S4_UP_SWR_FL",		"S4_AQUA_FL",		"S4_DI_FL",				//9
	"S4_EXH",				"S4_TANK2_CONC",		"AK_DI_S4_PG",		"AK_LO_BE_FT",		"AK_UP_BE_FT",			//10
	"AK_LO_PG",				"AK_UP_PG",				"AK_CDA_ION_PG",	"AK_UP_S4_PG",		"AK_LO_S4_PG",			//11
	"AK_CDA_OUT_PG",		"AK_DRIVING",			"AK_EXH1",			"AK_EXH2",			"AK_DI_S4_BF_FT",		//12
	"AK_LO_BE_FT_FL",		"AK_UP_BE_FT_FL",		"AK_DI_WR",			"OUT_CV_ESD",	
#ifdef _MOTOR_LOAD_FACTOR
	// 27 ea
	"S2RB_UP_SV1_LF",		"S2RB_LO_SV1_LF",	"S2RB_UP_SV2_LF",	"S2RB_LO_SV2_LF",	"S3RB_UP_SV1_LF",			//1
	"S3RB_LO_SV1_LF",		"S3RB_UP_SV2_LF",	"S3RB_LO_SV2_LF",	"S2RB_UP_M1_LF",	"S2RB_LO_M1_LF",			//2
	"S2RB_UP_M2_LF",		"S2RB_LO_M2_LF",	"S3RB_UP_M1_LF",	"S3RB_LO_M1_LF",	"S3RB_UP_M2_LF",			//3
	"S3RB_LO_M2_LF",		"INCV_M_LF",		"S1CV_M_LF",		"S2CV_M1_LF",		"S2CV_M2_LF",				//4
	"S3CV_M1_LF",			"S3CV_M2_LF",		"S4CV_M_LF",		"AKCV_M1_LF",		"AKCV_M2_LF",				//5
	"BUFCV_M_LF",			"OUTCV_M_LF",																			//6
#endif

#ifdef _BUFTANK_USE
	"BT_SPL_PG1",			"BT_SPL_PG2",		"BT_SPL_FL1",		"BT_SPL_FL2",		"BT_SPL_SWR_FL1",	"BT_SPL_SWR_FL2",				
#endif
	// 39ea
	"INCV_ION_CONT",		"INCV_ION_LEVEL",		"INCV_ION_COND",	"INCV_FFU1_PWR",	"INCV_FFU2_PWR",		//1
	"INCV_FFU3_PWR",		"S3_TANK1_LV_L",		"S3_TANK1_LV_M",	"S3_TANK1_LV_H",	"S3_TANK1_LV_HH",		//2
	"S4_TANK2_LV_L",		"S4_TANK2_LV_M",		"S4_TANK2_LV_H",	"S4_TANK2_LV_HH",	"AK_HEPA_PWR",			//3
	"BUF_ION_CONT",			"BUF_ION_LEVEL",		"BUF_ION_COND",		"OUTCV_FFU1_PWR",	"OUTCV_FFU2_PWR",		//4									
	"OUTCV_FFU3_PWR",		"S2_RB1_UP_IGAP",		"S2_RB1_LO_IGAP",	"S2_RB2_UP_IGAP",	"S2_RB2_LO_IGAP",		//5
	"S3_RB1_UP_IGAP",		"S3_RB1_LO_IGAP",		"S3_RB2_UP_IGAP",	"S3_RB2_LO_IGAP",	"PINCYL_DN_TIME",		//6
	"PINCYL_UP_TIME",		"LD_UNIT_TIME",			"SWR1_UNIT_TIME",	"SWR2_UNIT_TIME",	"SWR3_UNIT_TIME",		//7
	"SWR4_UNIT_TIME",		"AK_UNIT_TIME",			"BUF_UNIT_TIME",	"UL_UNIT_TIME",								//8
};
/*
CString CHost::m_S6F3GlassApdName[] = 
{
	"EUV1_ON_OFF",	"EUV2_ON_OFF",	"EUV3_ON_OFF",		"EUV1_USE_T",	
	"EUV2_USE_T",	"EUV3_USE_T",	"GLS_START_T",		"GLS_END_T",
	"DET_USE_T",	"DET_GLS_CNT",	"DET_REP_CNT",		"SHW1_F_AVE",
	"SHW2_F_AVE",	"SHW2_P_AVE",	"MTNK_USE_T",		"MTNK_GLS_CNT",
	"MTNK_REP_CNT",	"MTNK_TMP",		"MTNK_NO",			"AQK_F_AVE",
	"AQK_DI_REST",	"AQK_P_AVE",	"DI_TK_REST",		"GLS_ION_CHK",
	"GLS_P_JUDGE",	"SHW_F_DET_AV",	"SHW_F_DI_AVE",		"AK_U_F_AVE",
	"AK_L_F_AVE",	"AK_U_P_AVE",	"AK_L_P_AVE",		"SBJ_CDA_P_AV",
	"SBJ_DI_F_AVE",	"SBJ_DI_P_AVE",	"IJ_U_P_AVE",		"IJ_L_P_AVE",
	"IJ_F_AVE",		"EUV_EXT_AVE",	"AK_U_EXT_AVE",		"AK_L_EXT_AVE",
	"AK_U_BLW_AVE",	"AK_L_BLW_AVE",	"RB_EXT_AVE",		"SBJ_EXT_AVE"
};

CString CHost::m_S6F3LotApdName[] = 
{
	"LOT_P_JUDGE",	"EUV_EXT_MAX",	"EUV_EXT_MIN",		"EUV_EXT_AVE",
	"EUV1_ON_OFF",	"EUV2_ON_OFF",	"EUV3_ON_OFF",		"EUV1_USE_MAX",
	"EUV1_USE_MIN",	"EUV2_USE_MAX",	"EUV2_USE_MIN",		"EUV3_USE_MAX",
	"EUV3_USE_MIN",	"SHW1_F_MAX",	"SHW1_F_MIN",		"SHW1_F_AVE",	
	"SHW2_F_MAX",	"SHW2_F_MIN",	"SHW2_F_AVE",		"SHW2_P_MAX",
	"SHW2_P_MIN",	"SHW2_P_AVE",	"DET_F_MAX",		"DET_F_MIN",
	"DET_F_AVE",	"SBJ_DI_F_MAX",	"SBJ_DI_F_MIN",		"SBJ_DI_F_AVE",
	"SBJ_DI_P_MAX",	"SBJ_DI_P_MIN",	"SBJ_DI_P_AVE",		"SBJ_CDA_P_MA",
	"SBJ_CDA_P_MI",	"SBJ_CDA_P_AV",	"SBJ_EXT_MAX",		"SBJ_EXT_MIN",
	"SBJ_EXT_AVE",	"RB_EXT_MAX",	"RB_EXT_MIN",		"RB_EXT_AVE",
	"IJ_DI_F_MAX",	"IJ_DI_F_MIN",	"IJ_DI_F_AVE",		"IJ_U_P_MAX",
	"IJ_U_P_MIN",	"IJ_U_P_AVE",	"IJ_L_P_MAX",		"IJ_L_P_MIN",
	"IJ_L_P_AVE",	"AQK_F_MAX",	"AQK_F_MIN",		"AQK_F_AVE",
	"AQK_P_MAX",	"AQK_P_MIN",	"AQK_P_AVE",		"AK_U_F_MAX",
	"AK_U_F_MIN",	"AK_U_F_AVE",	"AK_U_P_MAX",		"AK_U_P_MIN",
	"AK_U_P_AVE",	"AK_L_F_MAX",	"AK_L_F_MIN",		"AK_L_F_AVE",
	"AK_L_P_MAX",	"AK_L_P_MIN",	"AK_L_P_AVE",		"GLS_ION_MAX",
	"GLS_ION_MIN",	"GLS_ION_AVE",	"AK_U_EXT_MAX",		"AK_U_EXT_MIN",
	"AK_U_EXT_AVE",	"AK_L_EXT_MAX",	"AK_L_EXT_MIN",		"AK_L_EXT_AVE",
	"AK_U_BLW_MAX",	"AK_U_BLW_MIN",	"AK_U_BLW_AVE",		"AK_L_BLW_MAX",	
	"AK_L_BLW_MIN",	"AK_L_BLW_AVE"
};

CString CHost::m_S6F3LotApdDvType[] = 
{
	"X  ", "MAX", "MIN", "AVG",
	"X  ", "X  ", "X  ", "MAX",
	"MIN", "MAX", "MIN", "MAX",
	"MIN", "MAX", "MIN", "AVG",
	"MAX", "MIN", "AVG", "MAX",
	"MIN", "AVG", "MAX", "MIN", 
	"AVG", "MAX", "MIN", "AVE", 
	"MAX", "MIN", "AVG", "MAX", 
	"MIN", "AVG", "MAX", "MIN", 
	"AVG", "MAX", "MIN", "AVE", 
	"MAX", "MIN", "AVG", "MAX", 
	"MIN", "AVG", "MAX", "MIN", 
	"MAX", "MIN", "AVG", "AVE", 
	"MAX", "MIN", "AVG", "MAX", 
	"MIN", "AVG", "MAX", "MIN", 
	"AVG", "MAX", "MIN", "AVE", 
	"MAX", "MIN", "AVG", "MAX", 
	"MIN", "AVG", "MAX", "MIN", 
	"AVG", "MAX", "MIN", "AVG", 
	"MAX", "MIN", "AVG", "MAX", 
	"MIN", "AVG",
};
*/
//---------------------------------------------------------------------------
// Primary Message : ECS ===> HDC
//---------------------------------------------------------------------------
int CHost::OnPrimaryRcvd(XSecsTranxThread *pTranx)
{
	static char cRCODE = '0';
	CString szBuf;
	char buf[256];

	switch( pTranx->Primary.GetSFCode() )
	{
	case _S1F1 :	// Online Request
		{
			SYSTEMBYTES sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );

#ifndef _MY_DEBUG
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( 0 )
#endif
			{
				SYSTEMBYTES sysBytes;
				pTranx->Primary.GetSystemBytes( &sysBytes );

				XSecsTranxThread* pTranx = Transaction("S1F0");
				if( pTranx == NULL ) return -1;
				pTranx->Primary.SetSystemBytes( sysBytes );
				pTranx->PrimaryOut( FALSE );
			}
			else
			{
				pTranx->Secondary.SetItemData( "MDLN", "DHDC");
				pTranx->Secondary.SetItemData( "SOFTREV", "VERSION 0.01" );
				pTranx->Secondary.SetItemData( "RMS", m_pDicsData->m_EqpInfo.cCtlMode );
				pTranx->SecondaryOut();
			}
		}
		break;

	case _S1F5 : // Formatted Status Report
		{
			SYSTEMBYTES sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );
#ifndef _MY_DEBUG
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( 0 )
#endif
			{
				SYSTEMBYTES sysBytes;
				pTranx->Primary.GetSystemBytes( &sysBytes );

				XSecsTranxThread* pTranx = Transaction("S1F0");
				if( pTranx == NULL ) return -1;
				pTranx->Primary.SetSystemBytes( sysBytes );
				pTranx->PrimaryOut( FALSE );
			}
			else
			{
				// In case that there is no matched recipe number
				pTranx->Primary.GetItemData( "SFCD", buf );
				if( buf[0] == 3 )
				{
					SYSTEMBYTES sysBytes;
					pTranx->Primary.GetSystemBytes( &sysBytes );
					pTranx->ResetSystemByte(XSecsHSMS::smSecondaryOut);

					XSecsTranxThread* pTranx3 = Transaction( "S1F5_3" );
					if( pTranx3 == NULL ) return -1;

					// Set the equipment status
					char cEqpState;
					if( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeDOWN || 
						m_pDicsData->m_EqpInfo.cLdState == CDicsData::modeDOWN ) cEqpState = CDicsData::modeDOWN;
					else if( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeRUN || 
							m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeRUN ) cEqpState = CDicsData::modeRUN;
					else cEqpState = CDicsData::modeIDLE;

					pTranx3->Secondary.SetItemData( "MCSTATUS", cEqpState );
					pTranx3->Secondary.SetItemData( "MCSUBST", ' ' ); // AU L10 HDC Fix 

					CString sName(""), sValName(""), sVal("");
					for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
					{
						int nApdNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nApdReportNo;
						if( nApdNo < 0 ) continue;
						sName.Format("DVNAME%02d", nApdNo+1);
						sValName.Format("DVVAL%02d", nApdNo+1);
						pTranx3->Secondary.SetItemData( sName, m_pEqpAssy->m_AnalogInput.m_aiSet[i].sName );
						sVal.Format("%.3f", m_pEqpAssy->m_AnalogInput.GetRealVal(i) );
						pTranx3->Secondary.SetItemData( sValName, sVal );
					}
					pTranx3->Secondary.SetSystemBytes( sysBytes );
					pTranx3->SecondaryOut( FALSE );

				}
				else if( buf[0] == 5 )
				{
					CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();
					SYSTEMBYTES sysBytes;
					pTranx->Primary.GetSystemBytes( &sysBytes );
					pTranx->ResetSystemByte(XSecsHSMS::smSecondaryOut);

					XSecsTranxThread* pTranx5 = Transaction( "S1F5_5" );
					if( pTranx5 == NULL ) return -1;

					pTranx5->Secondary.SetItemData( "RMS", m_pDicsData->m_EqpInfo.cCtlMode );
					
//********************************** CASE 1: RECIPE ID ALL REPORT ************************
					CString sRcpId;
					sRcpId = "                                ";

					for( int k=0; k < MAX_IF_NO * 2; k++ )
					{
						if( m_pDicsData->m_GlsInfo[k].bIsValid )
						{
							sRcpId = m_pDicsData->m_GlsInfo[k].sRecipeId;
							break;
						}
					}

					int nRow = pDoc->GetRowfromID( sRcpId );

					for( int i = 0 ; i < MAX_SLOT_NO ; i ++ )
					{
						CString sBuf;
						sBuf.Format( "CPPID%d", i+1 );
// CASE 1: REPORT RECIPE ID
						pTranx5->Secondary.SetItemData( (char*)(LPCTSTR)sBuf, sRcpId );
// CASE 2: REPORT RECIPE NAME
//						pTranx5->Secondary.SetItemData( (char*)(LPCTSTR)sBuf, pDoc->m_pRecipeInfo[nRow].sValue[CDaoRecipeSet::rcpCOMMENT] );
					} 
					CString sChgid;
					sChgid = "              ";
					CString sCasid;
					sCasid= "      ";
					pTranx5->Secondary.SetItemData( "CHGID", sChgid );
					pTranx5->Secondary.SetItemData( "CASID", sCasid );
					pTranx5->Secondary.SetItemData( "CHGS", ' ' );


					char cAlarmState = 'O';	// No Alarm (Default)
					if( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeDOWN || 
						m_pDicsData->m_EqpInfo.cLdState == CDicsData::modeDOWN ) cAlarmState = 'N';	// Have a alarm

					char cEqpState;
					if( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeDOWN || 
						m_pDicsData->m_EqpInfo.cLdState == CDicsData::modeDOWN ) cEqpState = CDicsData::modeDOWN;
					else if( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeRUN || 
							m_pDicsData->m_EqpInfo.cLdState == CDicsData::modeRUN ) cEqpState = CDicsData::modeRUN;
					else cEqpState = CDicsData::modeIDLE;
					
					char cCHGAS = 'L';		// Can Receive Lot
					if( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeDOWN ) 
					{
						cEqpState = CDicsData::modeDOWN;
						cAlarmState = 'N';	// Have a alarm
						cCHGAS = 'M';		// Can not receive Lot
					}

					pTranx5->Secondary.SetItemData( "ALMS", cAlarmState );
					pTranx5->Secondary.SetItemData( "UNITNO", m_pDicsData->m_EqpInfo.nUnitNo );
					pTranx5->Secondary.SetItemData( "EQPS", cEqpState );
					pTranx5->Secondary.SetItemData( "EQPSUB", ' ' );
					pTranx5->Secondary.SetItemData( "CHGAS", cCHGAS);

					pTranx5->Secondary.SetSystemBytes( sysBytes );
					pTranx5->SecondaryOut( FALSE );
				}
				else if( buf[0] == 7 )
				{
					SYSTEMBYTES sysBytes;
					pTranx->Primary.GetSystemBytes( &sysBytes );
					pTranx->ResetSystemByte(XSecsHSMS::smSecondaryOut);

					XSecsTranxThread* pTranx7 = Transaction( "S1F5_7" );
					if( pTranx7 == NULL ) return -1;

					// Set the equipment status
					char cEqpState;
					if( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeDOWN || 
						m_pDicsData->m_EqpInfo.cLdState == CDicsData::modeDOWN ) cEqpState = CDicsData::modeDOWN;
					else if( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeRUN || 
							m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeRUN ) cEqpState = CDicsData::modeRUN;
					else cEqpState = CDicsData::modeIDLE;

					pTranx7->Secondary.SetItemData( "MCSTATUS", cEqpState );
					pTranx7->Secondary.SetItemData( "MCSUBST", ' ' ); // AU L10 HDC Fix 

					CString sName(""), sValName(""), sVal("");
					for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
					{
						int nEdcNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nEdcReportNo;
						if( nEdcNo == -1 ) continue;
						sName.Format("DVNAME%02d", nEdcNo+1);
						sValName.Format("DVVAL%02d", nEdcNo+1);
						pTranx7->Secondary.SetItemData( sName, m_pEqpAssy->m_AnalogInput.m_aiSet[i].sName );
						sVal.Format("%.3f", m_pEqpAssy->m_AnalogInput.GetRealVal(i) );
						pTranx7->Secondary.SetItemData( sValName, sVal );
					}


					pTranx7->Secondary.SetSystemBytes( sysBytes );
					pTranx7->SecondaryOut( FALSE );
				}
			}
		}
		break;

	case _S1F15 :
		{
			pTranx->Secondary.SetItemData( "OFLACK", 0 ); // 
			pTranx->SecondaryOut();
			m_pDicsData->m_IfCim.bCtlModeChangeReq = TRUE;
			m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeOFFLINE;

			CString sMsg = "Host Request Change OFF-LINE(S1F15)";

//			Msg( WM_JOBS_VIEW, (WPARAM) MSG_HOST_WARNING, (LPARAM)(LPCTSTR) sMsg);
			( (CDicsView*) m_pOwner )->SendMessage( WM_JOBS_VIEW, (WPARAM) MSG_HOST_WARNING, (LPARAM)(LPCTSTR) sMsg);
		}
		break;

	case _S1F17 :           
		{
#ifndef _MY_DEBUG
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE )
#endif
			{
				CString sString;					
				pTranx->Primary.GetItemData( "RMS", buf ); buf[1] = 0;

				sString = buf;

				if( sString == "A")
				{
					pTranx->Secondary.SetItemData( "ONLACK", 0 ); // 
					pTranx->SecondaryOut();

					m_pDicsData->m_IfCim.bCtlModeChangeReq = TRUE;
					m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeCONTROL;

					CString sMsg = "Host Request Change ON-LINE_CONTORL(S1F17)";
					( (CDicsView*) m_pOwner )->SendMessage( WM_JOBS_VIEW, (WPARAM) MSG_HOST_WARNING1, (LPARAM)(LPCTSTR) sMsg);
				}
				else if( sString == "B")
				{
					pTranx->Secondary.SetItemData( "ONLACK", 0 ); // 
					pTranx->SecondaryOut();

					m_pDicsData->m_IfCim.bCtlModeChangeReq = TRUE;
					m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeMONITOR;

					CString sMsg = "Host Request Change ON-LINE MONITOR(S1F17)";
					( (CDicsView*) m_pOwner )->SendMessage( WM_JOBS_VIEW, (WPARAM) MSG_HOST_WARNING1, (LPARAM)(LPCTSTR) sMsg);
				}
			}
			else
			{
				pTranx->Secondary.SetItemData( "ONLACK", 2 ); // Already Online
				pTranx->SecondaryOut();
			}
//			pTranx->SecondaryOut();
		}
		break;

	case _S1F77 : // Port Status Query
		{
			m_flagS1F77Received = TRUE;					
			pTranx->SecondaryOut();
		}
		break;

	case _S1F79 :
		{
			SYSTEMBYTES sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );
			pTranx->Primary.GetItemData( "CMDCD", buf );
			if( buf[0] == 0x00 )
			{
				if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeCONTROL )
					pTranx->Secondary.SetItemData( "GRANT", 0x01 ); // Can not turn Online
				else
				{
					pTranx->Secondary.SetItemData( "GRANT", 0x00 ); // Can Turn Online
					m_flagS1F79Received = TRUE;
				}
			}
			else if( buf[0] == 0x01 )
			{	
				if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeCONTROL ||
					m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeMONITOR )
				{
					m_flagS1F79Received = TRUE;
					pTranx->Secondary.SetItemData( "GRANT", 0x00 );
				}
				else if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE )
				{
					m_flagONLINE_FAIL = TRUE;
					pTranx->Secondary.SetItemData( "GRANT", 0x01 );
				}
			}
			else if( buf[0] ==0x02 )
			{
				m_flagONLINE_FAIL = TRUE;
				pTranx->Secondary.SetItemData( "GRANT", 0x01 );
			}
			pTranx->SecondaryOut();
		}
		break;

		// Equipment Constant Request
	case _S2F13 :
#ifndef _MY_DEBUG
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( 0 )
#endif
		{
			SYSTEMBYTES sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );

			XSecsTranxThread* pTranx = Transaction("S2F0");
			if( pTranx == NULL ) return -1;
			pTranx->Primary.SetSystemBytes( sysBytes );
			pTranx->PrimaryOut( FALSE );
		}
		else
		{
			SYSTEMBYTES sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );
			CString sString;
			CString sString1;
			int nListSize = pTranx->Primary.GetListSize( 0 );
			CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();

			if( nListSize == 0 )
			{				
				// Recipe  Update.
				CString sBuf;
				sBuf.Format( "ECID1");
				pTranx->Secondary.SetItemData( (char*)(LPCTSTR)sBuf, "RECIPE ID" );
				sBuf.Format( "ECV1");
				sString1.Format( "%d", atoi(pDoc->m_sRecipeId)); //Recipe id
				pTranx->Secondary.SetItemData( (char*)(LPCTSTR)sBuf, sString1 );

				for( int i = 1 ; i < MAX_ECID_NO ; i ++ )
				{					
					sBuf.Format( "ECID%d", i + 1 );
					pTranx->Secondary.SetItemData( (char*)(LPCTSTR)sBuf, m_pSetupItems->m_infoSetup[i-1].sName );
					sBuf.Format( "ECV%d", i + 1 );
					sString1.Format( "%d", m_pSetupItems->m_nValueSetup_Option[i-1] ); //LYS20060320
					pTranx->Secondary.SetItemData( (char*)(LPCTSTR)sBuf, sString1 );
				}
			}
			else
			{
				pTranx->Secondary.SetListSize( 0, nListSize, 9 );
				for( int i = 0 ; i < nListSize ; i ++ )
				{
					sString.Format( "ECID%d", i + 1 );
					pTranx->Primary.GetItemData( (char*)(LPCTSTR)sString, buf );
					buf[14] = 0;
					sString = buf;
					sString.TrimRight(" ");

					CString sTemp;
				
					for( int j = 0 ; j < MAX_ECID_NO ; j ++ )
					{
						sTemp.Format( "RECIPE ID");
						if(sTemp.Compare( (LPCTSTR)sString ) == 0 )
						{
							CString sBuf;
							sBuf.Format( "ECID%d", i + 1 );
							pTranx->Secondary.SetItemData( (char*)(LPCTSTR)sBuf, "RECIPE ID" );
							sBuf.Format( "ECV%d", i + 1 );
							sTemp.Format( "%d", atoi(pDoc->m_sRecipeId)); //Recipe id
							pTranx->Secondary.SetItemData( (char*)(LPCTSTR)sBuf, sTemp );
							break;
						}
						else	
						{
							sTemp.Format( "%s", m_pSetupItems->m_infoSetup[j].sName );
							if( sTemp.Compare( (LPCTSTR)sString ) == 0 )
							{
								CString sBuf;
								sBuf.Format( "ECID%d", i + 1 );
								pTranx->Secondary.SetItemData( (char*)(LPCTSTR)sBuf, m_pSetupItems->m_infoSetup[j].sName );
								sBuf.Format( "ECV%d", i + 1 );
								sTemp.Format( "%d", m_pSetupItems->m_nValueSetup_Option[j] ); //LYS20060320
								pTranx->Secondary.SetItemData( (char*)(LPCTSTR)sBuf, sTemp );
								break;
							}
						}
					}
				}
			}

			pTranx->SecondaryOut();
		}
		break;

		// New Equipment Constant Send
	case _S2F15 :
#ifndef _MY_DEBUG
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( 0 )
#endif
		{
			SYSTEMBYTES sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );

			XSecsTranxThread* pTranx = Transaction("S2F0");
			if( pTranx == NULL ) return -1;
			pTranx->Primary.SetSystemBytes( sysBytes );
			pTranx->PrimaryOut( FALSE );
		}
		else
		{
			CString sString;
			BOOL bEcidNameWrong = FALSE;
			BOOL bEcidValueWrong = FALSE;

			int nListSize = pTranx->Primary.GetListSize( 0 );

			for( int i = 0 ; i < nListSize ; i ++ )
			{
				sString.Format( "ECID%d", i + 1 );
				pTranx->Primary.GetItemData( (char*)(LPCTSTR)sString, buf );
				buf[14] = 0;

				sString = buf;
				if( sString !="RECIPE ID     " &&
					sString !="PUMP1 USE     " &&
					sString !="PUMP2 USE     " &&
					sString !="SWR1 MJ USE   " &&
					sString !="SWR4 MJ USE   " &&
					sString !="LD FIX BROKEN " &&
					sString !="LD SCAN BROKEN" &&
					sString !="UL FIX BROKEN " &&
					sString !="UL SCAN BROKEN" )
				{
					bEcidNameWrong = TRUE;
					break;
				}

				sString.Format( "ECV%d", i + 1 );
				pTranx->Primary.GetItemData((char*)(LPCTSTR)sString, buf );

				if( atoi( (LPCTSTR)buf ) != 1 && atoi( (LPCTSTR)buf ) != 0 )
				{
					bEcidValueWrong = TRUE;
					break;
				}

				for( int i = 0 ; i < nListSize ; i ++ )
				{
					sString.Format( "ECID%d", i + 1 );
					pTranx->Primary.GetItemData( (char*)(LPCTSTR)sString, buf );
					buf[14] = 0;
					sString = buf;
					for( int j = 0 ; j < MAX_ECID_NO ; j ++ )
					{
						CString sBuf;
						sBuf.Format( "%s", m_pSetupItems->m_infoSetup[j].sName );
						sString.TrimRight(" ");//2008.11.20 kimgun
						if( sString.Compare( (LPCTSTR)sBuf ) == 0 )
						{
							sString.Format( "ECV%d", i + 1 );
							pTranx->Primary.GetItemData((char*)(LPCTSTR)sString, buf );
							m_pSetupItems->m_nValueSetup_OptionTemp[j] = atoi( (LPCTSTR)buf );
						}
					}
				} 
			} 

			if( bEcidNameWrong )
			{
				bEcidNameWrong = FALSE;
				pTranx->Secondary.SetItemData( "EAC", 1 );
				pTranx->SecondaryOut();
			}
			else if( bEcidValueWrong )
			{
				bEcidValueWrong = FALSE;
				pTranx->Secondary.SetItemData( "EAC", 3 );
				pTranx->SecondaryOut();
			}
			else
			{
				m_pSetupItems->SetRegistryTabJobCondView(); //JUN_MELSEC// Need Modify

				pTranx->Secondary.SetItemData( "EAC", 0 );
				pTranx->SecondaryOut();
			}

		}
		break;

	case _S2F25 : // 'Loopback  û'		
		pTranx->Primary.GetItemData( "ABS", buf );
		pTranx->Secondary.SetItemData( "ABS", buf );
		pTranx->SecondaryOut();
		break;

	case _S2F31 : // Date and Time Send
#ifndef _MY_DEBUG
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( 0 )
#endif
		{
			SYSTEMBYTES sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );

			XSecsTranxThread* pTranx = Transaction("S2F0");
			if( pTranx == NULL ) return -1;
			pTranx->Primary.SetSystemBytes( sysBytes );
			pTranx->PrimaryOut( FALSE );
		}	
		else
		{
			// YYYYMMDDHHMMSS
			pTranx->Primary.GetItemData( "TIME", buf ); buf[14] = 0;
			m_pDicsData->m_EqpInfo.sHostTime.Format( "%s", buf );

/*			TIME_ZONE_INFORMATION timeZoneInfo;
			::GetTimeZoneInformation(&timeZoneInfo);
			timeZoneInfo.Bias = 0; 
			::SetTimeZoneInformation(&timeZoneInfo);*/

			SYSTEMTIME sysTime;
			::GetSystemTime( &sysTime );
			sysTime.wYear	= (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(0, 4) ));
			sysTime.wMonth	= (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(4, 2) ));
			sysTime.wDay	= (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(6, 2) ));
			sysTime.wHour	= (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(8, 2) ));
			sysTime.wMinute = (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(10, 2) ));
			sysTime.wSecond = (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(12, 2) ));
			::SetLocalTime( &sysTime ); 
//---------------------------------------------------------------------------
			if( sysTime.wHour < 0 || sysTime.wHour > 24 
				|| sysTime.wMinute < 0 || sysTime.wMinute > 60 
				|| sysTime.wSecond < 0 || sysTime.wSecond > 60 )
			{
				pTranx->Secondary.SetItemData( "TIACK", '1' );
				pTranx->SecondaryOut();
			}
			else
			{
				pTranx->Secondary.SetItemData( "TIACK", '0' );
				pTranx->SecondaryOut();
			}
		}
		break;
// 
	case _S2F41 : // Host Online Request
		pTranx->Primary.GetItemData( "RCMD", buf );
		if( buf[0] == '0' ) m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeMONITOR;
		else if( buf[0] == '1' ) m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeCONTROL;
		else if( buf[0] == '2' ) m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeOFFLINE;

		if( buf[0] == '0' || buf[0] == '1' || buf[0] == '2' )
		{
			// same state
			if( m_pDicsData->m_EqpInfo.cCtlMode == m_pDicsData->m_IfCim.cCtlMode )
			{
				pTranx->Secondary.SetItemData( "HCACK", 2 ); // NG; Already in desired condition
			}
			else if( buf[0] != '2' &&	// If online monitor or control 
				( m_pDicsData->m_PortInfo[0].nTSIP != CDicsData::portEMPTY ||
				  m_pDicsData->m_PortInfo[1].nTSIP != CDicsData::portEMPTY ||
				  m_pDicsData->m_PortInfo[2].nTSIP != CDicsData::portEMPTY ) )
			{
				pTranx->Secondary.SetItemData( "HCACK", 1 ); // Reject
			}
			else 
			{
				m_pDicsData->m_IfCim.bCtlModeChangeReq = TRUE;
				pTranx->Secondary.SetItemData( "HCACK", 0 ); // OK
			}
		}
		else pTranx->Secondary.SetItemData( "HCACK", 1 );
		pTranx->SecondaryOut();
		break;

	case _S7F1:
#ifndef _MY_DEBUG
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( 0 )
#endif
		{
			SYSTEMBYTES sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );

			XSecsTranxThread* pTranx = Transaction("S7F0");
			if( pTranx == NULL ) return -1;
			pTranx->Primary.SetSystemBytes( sysBytes );
			pTranx->PrimaryOut( FALSE );
		}
		else
		{
			CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();
			// Get the recipe ID
			pTranx->Primary.GetItemData( "PPID", buf ); buf[32] = 0;
			CString sRecipeId;

			int nRecipeId = atoi( buf );

			sRecipeId.Format("%d",nRecipeId );
			int nRow = pDoc->GetRowfromID( sRecipeId );


			if( nRecipeId <= 0 || nRecipeId > 99 ) pTranx->Secondary.SetItemData( "ACKC7", 1 );
			else
			{
				for( int i=0; i<MAX_TOTAL_RECIPE_BODY_NO - 3; i++ )
				{
					CString sItemName;
					
					//sItemName.Format( "PARANAME%d", i + 1 );
					//pTranx->Primary.GetItemData( (char*)(LPCTSTR) sItemName, buf ); buf[16] = 0;
					//pDoc->m_pRecipeInfo[nRecipeId - 1].sName[i + 2].Format( "%s", buf );

					sItemName.Format( "PARAVAL%d", i + 2 );	// Recipe  JOB PROCESS  о ´.
					pTranx->Primary.GetItemData( (char*)(LPCTSTR) sItemName, buf ); buf[16] = 0;

//************************************************************// case : if Host Send zero or one..
					CString sString;
					int nSelected = atoi( buf );

					if( i >= CDaoRecipeSet::rcpJOB_PROCESS - 3 && i <= CDaoRecipeSet::rcpSWR3_LO_RB2_USE - 3 )
					{
// #ifdef _UNIT_AP
// 						if( i == CDaoRecipeSet::rcpAP_RECIPE_NO - 3 )
// 						{
// 							pDoc->m_pRecipeInfo[nRow].sValue[i + 3].Format( "%s", buf );
// 							continue;
// 						}
// 						else if( nSelected == 1 ) sString = "ON";
// #else
						if( nSelected == 1 ) sString = "ON";
//#endif
						else sString = "OFF";
						pDoc->m_pRecipeInfo[nRow].sValue[i + 3].Format( "%s", sString );
					}
					else if( i >= CDaoRecipeSet::rcpSWR2_UP_RB1_DIR - 3 && i <= CDaoRecipeSet::rcpSWR3_LO_RB2_DIR - 3 )
					{
						if( nSelected == 1 ) sString = "CW";
						else sString = "CCW";
						pDoc->m_pRecipeInfo[nRow].sValue[i + 3].Format( "%s", sString );
					}
					else 
					{
						pDoc->m_pRecipeInfo[nRow].sValue[i + 3].Format( "%s", buf );
					}
					//2008.12.03 kimgun
					if( nRecipeId == atoi(m_pDicsData->m_GenInfo.sRecipeId) )
					m_pDicsData->m_GenInfo.bRecipeBodyChanged = TRUE;
//***************************************************************************************************//					
//					pDoc->m_pRecipeInfo[nRecipeId - 1].sValue[i + 3].Format( "%s", buf );
				}

				pDoc->m_pRecipeSet->SetRecipeInfo( sRecipeId, pDoc->m_pRecipeInfo[nRow] );

				pTranx->Secondary.SetItemData( "ACKC7", 0 );
			}
			pTranx->SecondaryOut();
		}
		break;

	case _S7F3:
#ifndef _MY_DEBUG
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( 0 )
#endif
		{
			SYSTEMBYTES sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );

			XSecsTranxThread* pTranx = Transaction("S7F0");
			if( pTranx == NULL ) return -1;
			pTranx->Primary.SetSystemBytes( sysBytes );
			pTranx->PrimaryOut( FALSE );
		}
		else
		{
			CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();
			// Get the recipe ID
			pTranx->Primary.GetItemData( "PPID", buf ); buf[32] = 0;

			int nRecipeId = atoi( buf );

			CString sRecipeId;
			sRecipeId.Format("%d",nRecipeId );
			int nRow = pDoc->GetRowfromID( sRecipeId );

			CString sBuf;
			sBuf.Format("%d",nRecipeId );

			if( nRecipeId <= 0 || nRecipeId > 99 )
			{
				pTranx->Secondary.SetItemData( "ACKC7", 1 );
				pTranx->Secondary.SetItemData( "PPID", buf );

				CString sBuf;
				sBuf.Format("%d", m_pDicsData->m_EqpInfo.nUnitNo );
				pTranx->Secondary.SetItemData( "UNITNO", sBuf );

				CString sItemName;
				sItemName.Format( "PARANAME1");
				pTranx->Secondary.SetItemData( sItemName, "RECIPE ID");
				sItemName.Format( "PARAVAL1");
				pTranx->Secondary.SetItemData( sItemName, buf );

				for( int i=0; i<MAX_TOTAL_RECIPE_BODY_NO - 3; i++ )
				{                 
					CString sItemName;
					sItemName.Format( "PARANAME%d", i + 2 );

					pTranx->Secondary.SetItemData( sItemName, m_RecipeName[i] );

					CString sRecipePara = "                ";
					sItemName.Format( "PARAVAL%d", i + 2 );
					pTranx->Secondary.SetItemData( sItemName, sRecipePara );
				}                                                                                                                                                                         
			}
			else
			{
				CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();
				if( pDoc->m_pRecipeSet->FindRecipe( sBuf/*nRecipeId */) )
				{	
					RECIPE_INFO *pRecipeInfo = pDoc->m_pRecipeInfo;

					pTranx->Secondary.SetItemData( "PPID", buf );
					CString sBuf;
					sBuf.Format("%d", m_pDicsData->m_EqpInfo.nUnitNo );
					pTranx->Secondary.SetItemData( "UNITNO", sBuf );
					
					// pRecipeInfo[nRecipeId - 1].sValue[i + 2] = sVal;
					pTranx->Secondary.SetItemData( "ACKC7", 0 );

					CString sItemName;
					sItemName.Format( "PARANAME1");
					pTranx->Secondary.SetItemData( sItemName, "RECIPE ID");
					sItemName.Format( "PARAVAL1");
					pTranx->Secondary.SetItemData( sItemName, buf );

					for( int i=0; i<MAX_TOTAL_RECIPE_BODY_NO - 3; i++ )
					{
						sItemName.Format( "PARANAME%d", i + 2 );
						pTranx->Secondary.SetItemData( sItemName, m_RecipeName[i]);

						sItemName.Format( "PARAVAL%d", i + 2 );
//#ifndef _NO_RB
						pTranx->Secondary.SetItemData( sItemName, pDoc->m_pRecipeInfo[nRow].sValue[i + 3] );
//#else
// 						if( i <= 10 ) 
// 						{
// 							pTranx->Secondary.SetItemData( sItemName, pDoc->m_pRecipeInfo[nRow].sValue[i + 3] );
// 						}
// 						else if( i >= 11 )
// 						{
// 							CString sString = "";
// 							pTranx->Secondary.SetItemData( sItemName, pDoc->m_pRecipeInfo[nRow].sValue[i + 3] );
// 						}
// #endif
					}
				}
				else
				{
					pTranx->Secondary.SetItemData( "PPID", buf );
					CString sBuf;
					sBuf.Format("%d", m_pDicsData->m_EqpInfo.nUnitNo );
					pTranx->Secondary.SetItemData( "UNITNO", sBuf );
					
					// pRecipeInfo[nRecipeId - 1].sValue[i + 2] = sVal;
					pTranx->Secondary.SetItemData( "ACKC7", 0 );

					CString sItemName;
					CString sRecipePara = "                ";
					sItemName.Format( "PARANAME1");
					pTranx->Secondary.SetItemData( sItemName, "RECIPE ID");
					sItemName.Format( "PARAVAL1");
					pTranx->Secondary.SetItemData( sItemName, sRecipePara );

					for( int i=0; i<MAX_TOTAL_RECIPE_BODY_NO - 3; i++ )
					{                 
						
						sItemName.Format( "PARANAME%d", i + 2 );
						pTranx->Secondary.SetItemData( sItemName, m_RecipeName[i]);

						
						sItemName.Format( "PARAVAL%d", i + 2 );
						pTranx->Secondary.SetItemData( sItemName, sRecipePara );
					}
				}
			}
			pTranx->SecondaryOut();
		}
		break;

	case _S7F19: // Current EEPD Report
#ifndef _MY_DEBUG
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( 0 )
#endif
		{
			SYSTEMBYTES sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );

			XSecsTranxThread* pTranx = Transaction("S7F0");
			if( pTranx == NULL ) return -1;
			pTranx->Primary.SetSystemBytes( sysBytes );
			pTranx->PrimaryOut( FALSE );
		}
		else
		{
			int nCount = 0;
			for( int i=0; i<99; i++ )
			{
				CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();
				RECIPE_INFO *pRecipeInfo = pDoc->m_pRecipeInfo;

				CString sBuf;
				sBuf.Format("%d", i + 1 );

				if( pDoc->m_pRecipeSet->FindRecipe( sBuf/*i + 1*/ ) )
				{	
					CString sItemName;

					sItemName.Format( "RECIPEID_%02d", i + 1 );

					int nRow = pDoc->GetRowfromID( sBuf );

					CString sData = pDoc->m_pRecipeInfo[nRow].sValue[CDaoRecipeSet::rcpID]; // CASE 1: Recipe ID
//					CString sData = pDoc->m_pRecipeInfo[nRow].sValue[CDaoRecipeSet::rcpCOMMENT]; // CASE 2: Recipe Name
					pTranx->Secondary.SetItemData( sItemName, sData );
				}
				else // for "not exist recipe" ascii 32 report..
				{
					CString sItemName1;

					sItemName1.Format( "RECIPEID_%02d", i + 1 );

					CString sData1 = "                               ";
					pTranx->Secondary.SetItemData( sItemName1, sData1 );
				}
			}
			pTranx->SecondaryOut();
		}
		break;

	case _S7F67:
#ifndef _MY_DEBUG
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( 0 )
#endif
		{
			SYSTEMBYTES sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );

			XSecsTranxThread* pTranx = Transaction("S7F0");
			if( pTranx == NULL ) return -1;
			pTranx->Primary.SetSystemBytes( sysBytes );
			pTranx->PrimaryOut( FALSE );
		}
		else
		{
			CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();
			// Get the recipe ID
			pTranx->Primary.GetItemData( "PPID", buf ); buf[32] = 0;
			int nRecipeId = atoi( buf );

			CString sRecipeId;
			sRecipeId.Format("%d",nRecipeId );
			int nRow = pDoc->GetRowfromID( sRecipeId );

			CString sBuf;
			sBuf.Format("%d",nRecipeId );

			if( nRecipeId <= 0 || nRecipeId >= 99 ) 
			{
				CString sString = "              ";
				pTranx->Secondary.SetItemData( "ACKC7", 4 );
				pTranx->Secondary.SetItemData( "PPID", buf );
				pTranx->Secondary.SetItemData( "DATETIME", sString );
			}
			else
			{
				if( pDoc->m_pRecipeSet->FindRecipe( sBuf/*nRecipeId*/ ) )
				{	
					RECIPE_INFO *pRecipeInfo = pDoc->m_pRecipeInfo;

					pTranx->Secondary.SetItemData( "PPID", buf );
					
					// Set Date Time
					CString sData = pDoc->m_pRecipeInfo[nRow].sValue[CDaoRecipeSet::rcpTIME];
					// 04/04/20 12:43:35 ==> 040420124335 0/0/0 0:0:0
					sData.Remove( '/' ); sData.Remove( ':' ); sData.Remove( ' ' );
					pTranx->Secondary.SetItemData( "DATETIME", sData );

					pTranx->Secondary.SetItemData( "ACKC7", 0 );
				}
				else
				{
					CString sString = "              ";
					pTranx->Secondary.SetItemData( "ACKC7", 4 );
					pTranx->Secondary.SetItemData( "PPID", buf );
					pTranx->Secondary.SetItemData( "DATETIME", sString );
				}
			}
			pTranx->SecondaryOut();
		}
		break;

	case _S10F5 :	// 'Terminal Message(VMN:Terminal Display Multiblock)'
		pTranx->Primary.GetItemData( "TID", buf );
		pTranx->Primary.GetItemData( "TEXT", buf+1 );
		buf[80] = '\x0';
		if( buf[0] == 1 ) 
		{
			m_szHostMsg.Format( "%s", buf+1 ); // RED Color
			// Send Message
//			Msg( WM_JOBS_VIEW, (WPARAM) MSG_TERMINAL_WARNING, (LPARAM) (LPARAM)(LPCTSTR)m_szHostMsg );
			( (CDicsView*) m_pOwner )->SendMessage( WM_JOBS_VIEW, (WPARAM) MSG_TERMINAL_WARNING, (LPARAM) (LPARAM)(LPCTSTR)m_szHostMsg );
		}
		else 
		{
			m_szHostMsg.Format( "%s", buf+1 );	// BLACK Color
			// Send Message
///			Msg( WM_JOBS_VIEW, (WPARAM) MSG_TERMINAL_MESSAGE, (LPARAM) (LPARAM)(LPCTSTR)m_szHostMsg );
			( (CDicsView*) m_pOwner )->SendMessage( WM_JOBS_VIEW, (WPARAM) MSG_TERMINAL_MESSAGE, (LPARAM) (LPARAM)(LPCTSTR)m_szHostMsg );
		}

		// Set Tab
		( (CDicsView*) m_pOwner )->SendMessage( WM_JOBS_VIEW_SELECT_TAB, 1, NULL );
		break;
	}

	return 0;
}

//---------------------------------------------------------------------------
// Secondary Message : ECS ===> HDC
//---------------------------------------------------------------------------
int CHost::OnSecondaryRcvd(XSecsTranxThread *pTranx)
{
	char buf[256];

	switch( pTranx->Secondary.GetSFCode() )
	{
	case _S1F66:
	case _S1F68:
	case _S1F70:
		pTranx->Secondary.GetItemData( "GRANT", buf );
		m_pDicsData->m_IfCimTag.nAck1 = buf[0];
		break;
	case _S1F74:
	case _S1F76:
		pTranx->Secondary.GetItemData( "ACKC1", buf );
		m_pDicsData->m_IfCimTag.nAck1 = buf[0];
		break;
	case _S2F18:
		pTranx->Secondary.GetItemData( "DATETIME", buf );
		m_pDicsData->m_EqpInfo.sHostTime.Format( "%s", buf );

		SYSTEMTIME sysTime;
		::GetSystemTime( &sysTime );
		sysTime.wYear	= (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(0, 4) ));
		sysTime.wMonth	= (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(4, 2) ));
		sysTime.wDay	= (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(6, 2) ));
		sysTime.wHour	= (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(8, 2) ));
		sysTime.wMinute = (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(10, 2) ));
		sysTime.wSecond = (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(12, 2) ));
		::SetLocalTime( &sysTime ); 

		break;

	case _S5F66:
		pTranx->Secondary.GetItemData( "ACKC5", buf );
		m_pDicsData->m_IfCimTag.nAck5 = buf[0];
		break;

	case _S6F64:
	case _S6F66:
	case _S6F68:
	case _S6F70:
		pTranx->Secondary.GetItemData( "ACKC6", buf );
		m_pDicsData->m_IfCimTag.nAck6 = buf[0];
		break;

	case _S7F22:
		pTranx->Secondary.GetItemData( "ACKC7", buf );
		m_pDicsData->m_IfCimTag.nAck7 = buf[0];
		break;
	case _S7F72:
	case _S7F74:
		pTranx->Secondary.GetItemData( "GRANT", buf );
		m_pDicsData->m_IfCimTag.nAck7 = buf[0];
		break;

	default:
		#ifdef __LOG__
		m_pHexLog->TextOut( "Received not registered message" );
		#endif
		break;
	}

	return 0;
}

//---------------------------------------------------------------------------
// Check whether the secondary message is recevided ? 
//---------------------------------------------------------------------------
BOOL CHost::SecondaryRcvd(LPCTSTR lpszName, BOOL bLock)
{
	//if( !m_bConnected ) return 0;

	BOOL bRv;

	XSecsTranxThread* pTranx = Transaction( (char*)lpszName, XSecsMessage::toHost );
	if( pTranx == NULL ) return FALSE; // But, Error!!!

	//if( bLock ) bRv = pTranx->IsSecondaryRcvd( bLock );
	//else bRv = pTranx->IsSecondaryRcvd();

	bRv = pTranx->IsSecondaryRcvd( bLock );
	return bRv;
}


//---------------------------------------------------------------------------
// Primary :  HOST <=== CIM
//---------------------------------------------------------------------------
int CHost::S1F1()
{
	if( !m_bConnected || m_bRetryConnect ) return -1; //0;

	XSecsTranxThread* pTranx = Transaction( "S1F1" );
	if( pTranx == NULL ) return -1;

//	pTranx->Primary.SetItemData( "MDLN", "D-HDC" );
//	pTranx->Primary.SetItemData( "SOFTREV", "VER1.0" );

	return pTranx->PrimaryOut();
}

//---------------------------------------------------------------------------
// Primary : HOST <=== CIM : Equipment Status Change Report
//---------------------------------------------------------------------------
int CHost::S1F65( char cCtlMode, char cEqSubStus )
{
	if( !m_bConnected || m_bRetryConnect ) return -1; //0;

	XSecsTranxThread* pTranx = Transaction( "S1F65" );
	if( pTranx == NULL ) return -1;

	// Set the equipment status
	char cEqpState, cMcSubSt, cChgAs;

	if( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeDOWN || 
		m_pDicsData->m_EqpInfo.cLdState == CDicsData::modeDOWN ) cEqpState = CDicsData::modeDOWN;
	else if( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeRUN || 
			m_pDicsData->m_EqpInfo.cLdState == CDicsData::modeRUN ) cEqpState = CDicsData::modeRUN;
	else cEqpState = CDicsData::modeIDLE;

	if( cEqSubStus == CDicsData::modeDOWN )	cEqpState = CDicsData::modeDOWN;	// 120315 halesu

	cMcSubSt = ' ';
	cChgAs = 'L';

	CString sStatus;
	sStatus.Format( "%c%c%c%c", cCtlMode, cEqpState, cMcSubSt, cChgAs);

	pTranx->Primary.SetItemData( "UNITNO", m_pDicsData->m_EqpInfo.nUnitNo );
	pTranx->Primary.SetItemData( "STATUS", sStatus );

	return pTranx->PrimaryOut();
}


//---------------------------------------------------------------------------
// Primary : HOST <=== CIM : Summary Status Report
//---------------------------------------------------------------------------
int CHost::S1F69()
{
	if( !m_bConnected || m_bRetryConnect ) return -1; //0;

	XSecsTranxThread* pTranx = Transaction( "S1F69" );
	if( pTranx == NULL ) return -1;

	CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();
	CString sData;
	// Set the equipment status
	char cEqpState;
	char cAlarmState = 'O';	// No Alarm (Default)
	char cCHGAS = 'L';		// Can Receive Lot
	if( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeDOWN ) 
	{
		cEqpState = CDicsData::modeDOWN;
		cAlarmState = 'N';	// Have a alarm
		cCHGAS = 'M';		// Can not receive Lot
	}
	else if( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeRUN || 
			m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeRUN ) cEqpState = CDicsData::modeRUN;
	else cEqpState = CDicsData::modeIDLE;
	pTranx->Primary.SetItemData( "ALMS", cAlarmState );

	// Set Control Status
	pTranx->Primary.SetItemData( "RMS", m_pDicsData->m_EqpInfo.cCtlMode );
	
//	CString sRcpId;
//	sRcpId.Format( "%d", m_pDicsData->m_GenInfo.nRecipeId );
//	sRcpId = "1"; // Temporary JUN_MELSEC Why 1???

//********************************** CASE 1: RECIPE ID ALL REPORT ************************
	CString sRcpId;
	sRcpId = "                                ";

	for( int k=0; k < MAX_IF_NO * 2; k++ )
	{
		if( m_pDicsData->m_GlsInfo[k].bIsValid )
		{
			sRcpId = m_pDicsData->m_GlsInfo[k].sRecipeId;
			break;
		}
	}

	int nRow = pDoc->GetRowfromID( sRcpId );

//	for( int i=0; i<MAX_SLOT_NO; i++ )
	{
//		sData.Format( "CPPID%d", i + 1 );
		sData.Format( "CPPID" );
// CASE 1: REPORT RECIPE ID
		pTranx->Primary.SetItemData( sData, sRcpId );
// CASE 2: REPORT RECIPE NAME
//		pTranx->Primary.SetItemData( sData, pDoc->m_pRecipeInfo[nRow].sValue[CDaoRecipeSet::rcpCOMMENT] );
	}

	// Set the Other data

	CString sChgid;
	sChgid = "              ";
	CString sCasid;
	sCasid= "      ";
	pTranx->Primary.SetItemData( "CHGID", sChgid );
	pTranx->Primary.SetItemData( "CASID", sCasid );
	pTranx->Primary.SetItemData( "CHGS", ' ' );

	pTranx->Primary.SetItemData( "UNITNO", m_pDicsData->m_EqpInfo.nUnitNo );
	pTranx->Primary.SetItemData( "EQPS", cEqpState );
	pTranx->Primary.SetItemData( "EQPSUB", ' ' );
	pTranx->Primary.SetItemData( "CHGAS", cCHGAS );

	return pTranx->PrimaryOut();
}
//---------------------------------------------------------------------------
// Primary : ECS <=== HDC
//---------------------------------------------------------------------------
int CHost::S2F17()
{
	if( !m_bConnected || m_bRetryConnect ) return -1;//0;

	XSecsTranxThread* pTranx = Transaction( "S2F17" );
	if( pTranx == NULL ) return -1;

	return pTranx->PrimaryOut();
}

//---------------------------------------------------------------------------
// Primary : ECS <=== HDC
//---------------------------------------------------------------------------
int CHost::S2F25( char* buf )
{
	if( !m_bConnected || m_bRetryConnect ) return -1;//0;

	XSecsTranxThread* pTranx = Transaction( "S2F25" );
	if( pTranx == NULL ) return -1;

	pTranx->Primary.SetItemData( "ABS", buf );
	return pTranx->PrimaryOut();
}

//---------------------------------------------------------------------------
// Primary : ECS <=== HDC
//---------------------------------------------------------------------------
int CHost::S5F65(int iALCD, UINT uALID, CString sALTX, char cAlarmLevel, CString sSEQNO )
{
	if( !m_bConnected || m_bRetryConnect ) return -1;//0;

	XSecsTranxThread* pTranx = Transaction( "S5F65" );
	if( pTranx == NULL ) return -1;

	pTranx->Primary.SetItemData( "UNITNO", m_pDicsData->m_EqpInfo.nUnitNo );
	pTranx->Primary.SetItemData( "ALCD", iALCD );

//	CString sALID;
//	sALID.Format( "%07d", uALID );
	char cALID[3];
	for( int i = 0 ; i < 3 ; i ++ )
	{
		cALID[2-i] = ( ( uALID >> ( 8 * i ) ) & 0xFF );
	}

	if( cAlarmLevel == 'S' )
//		cALID[0] = cALID[0] + 240; // 11110000 ??
		cALID[0] = cALID[0] + 128; 
	pTranx->Primary.SetItemData( "ALID", (char*)cALID );
	pTranx->Primary.SetItemData( "SEQN", sSEQNO );

	pTranx->Primary.SetItemData( "ALTX", sALTX );

	return pTranx->PrimaryOut();
}

//---------------------------------------------------------------------------
// Primary : ECS <=== HDC : Glass Process Data Report
//---------------------------------------------------------------------------
int CHost::S6F65(int i)
{
	if( !m_bConnected || m_bRetryConnect ) return -1;
	
	XSecsTranxThread* pTranx = Transaction( "S6F65" );
	if( pTranx == NULL ) return -1;

	pTranx->Primary.SetItemData( "STRMNO", 1 );
	pTranx->Primary.SetItemData( "STRMQTY", 1 );
	pTranx->Primary.SetItemData( "CHGID", m_pDicsData->m_GlsInfo[i].sLotId );		
	pTranx->Primary.SetItemData( "CASID", m_pDicsData->m_GlsInfo[i].sCassetteId );

	CString sSlotNo;
	sSlotNo.Format( "%02d", m_pDicsData->m_GlsInfo[i].nSlotNo );
	pTranx->Primary.SetItemData( "SLOTNO", sSlotNo );

	pTranx->Primary.SetItemData( "KOUID", "BSITO"/*m_pDicsData->m_GlsInfo[i].sOperationNo*/ );	// Thomas 191225
	pTranx->Primary.SetItemData( "PROCID", "1" );	// Glass
	pTranx->Primary.SetItemData( "PRODCD", "0" );   // Product Code
	pTranx->Primary.SetItemData( "PPID", m_pDicsData->m_GlsInfo[i].sRecipeIdFull/*m_pDicsData->m_GlsInfo[i].sPPId*/ ); // Recipe Name
	pTranx->Primary.SetItemData( "PPIDCHG", "0" ); // Recipe Change Flag
	pTranx->Primary.SetItemData( "CEID", 'T' );	// m_pDicsData->m_GlsInfo[i].PortInfo.cLotStatus
	
	pTranx->Primary.SetItemData( "PCBID", m_pDicsData->m_GlsInfo[i].sGlassId );

	int nSlot = m_pDicsData->m_GlsInfo[i].nGlass_slot;		// Read index ith slot No : ljy_050621

	// Glass End time Ѵ.
	CString sString;
	COleDateTime time = COleDateTime::GetCurrentTime();
	sString.Format( "%04d%02d%02d%02d%02d%02d", 
		time.GetYear(), time.GetMonth(), time.GetDay(), time.GetHour(), time.GetMinute(), time.GetSecond() );	

	m_pDicsData->m_GlsInfo[i].sApdData[CCimSeq::apdSLOT_NO] = m_pDicsData->m_GlsInfo[i].sSlotNo;
	m_pDicsData->m_GlsInfo[i].sApdData[CCimSeq::apdRCP_ID] = m_pDicsData->m_GlsInfo[i].sRecipeId;
//	m_pDicsData->m_GlsInfo[i].sGlassApd[1] = sString;
	m_pDicsData->m_GlsInfo[i].sApdData[CCimSeq::apdGLS_END_TIME] = sString;		// APD End ð  Ƿ Ȯ ʿ.
	//2008.08.27 kimgun Process data view Set
//	CJobsTabProcessDataView* pViewProcess = ( (CDicsView *) m_pOwner )->m_pTabJobsProcessDataView;
//	pViewProcess->SendMessage( WM_APD_DATA_CHANGED, (WPARAM) 0 );
	//////////////////////////////////////////////////////////////////////////

	// Pin Time .
	CString strBuf;
	for( int j=0; j< 2; j++)
	{
		strBuf.Format("%d.%ds", m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[j]/1000, m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[j]%1000/100);
		m_pDicsData->m_GlsInfo[j].sApdData[CCimSeq::apdPinTime_START+j].Format("%4.1f", atof(strBuf));
	}

	// Temporary
	CString sBuf;
	//for( int nApd = 0; nApd < MAX_APD_DATA_NO - CCimSeq::apdRCP_ID ; nApd++ )
	for( int nApd = 0; nApd < MAX_APD_DATA_NO ; nApd++ )	// hskwak 20191004 APD Data .
	{
		pTranx->Primary.SetItemData( m_S6F65GlsApdName[nApd], m_S6F65GlsApdName[nApd] );
		//pTranx->Primary.SetItemData( m_S6F65GlsApdName[nApd]+"_VAL", m_pDicsData->m_GlsInfo[i].sApdData[nApd+CCimSeq::apdRCP_ID] );
		pTranx->Primary.SetItemData( m_S6F65GlsApdName[nApd]+"_VAL", m_pDicsData->m_GlsInfo[i].sApdData[nApd] );	// hskwak 20191004 APD Data .
	}

	CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();
//	int nRecipeId = atoi(m_pDicsData->m_GenInfo.sRecipeId);
#ifndef _NO_UL_HAND
	int nRecipeId = atoi(m_pDicsData->m_GlsInfo[IF_UNIT_UL_HAND*2].sRecipeId);
#else 
	int nRecipeId = atoi(m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].sRecipeId);	// 20100610 ssm
#endif

	if( nRecipeId < 0 ) nRecipeId = 1;

	CString sRecipeId;
	sRecipeId.Format("%d",nRecipeId );
	int nRow = pDoc->GetRowfromID( sRecipeId );
		
	for( int j=0; j<MAX_TOTAL_RECIPE_BODY_NO - 3; j++ )
	{
		CString sItemName;
		sItemName.Format( "PARANAME%d", j + 1 );
		pTranx->Primary.SetItemData( sItemName, m_RecipeName[j] );

		sItemName.Format( "PARAVAL%d", j + 1 );

//190909 ksh S6F65 KPC Data Type Change
		if( j < CDaoRecipeSet::rcpSWR3_LO_RB2_USE && pDoc->m_pRecipeInfo[nRow].sValue[j + 3] == "ON" )
			pTranx->Primary.SetItemData( sItemName, "1");
		else if( j < CDaoRecipeSet::rcpSWR3_LO_RB2_USE && pDoc->m_pRecipeInfo[nRow].sValue[j + 3] == "OFF" )
			pTranx->Primary.SetItemData( sItemName, "0");
		else if( j < CDaoRecipeSet::rcpSWR3_LO_RB2_DIR && pDoc->m_pRecipeInfo[nRow].sValue[j + 3] == "CW" ) 
			pTranx->Primary.SetItemData( sItemName, "1");
		else if( j < CDaoRecipeSet::rcpSWR3_LO_RB2_DIR && pDoc->m_pRecipeInfo[nRow].sValue[j + 3] == "CCW" ) 
			pTranx->Primary.SetItemData( sItemName, "0");
		else
			pTranx->Primary.SetItemData( sItemName, pDoc->m_pRecipeInfo[nRow].sValue[j + 3] ); // ʿٸ ̰͸ ΰ  ǹ ๮ 

//#ifndef _NO_RB
//		pTranx->Primary.SetItemData( sItemName, pDoc->m_pRecipeInfo[nRow].sValue[j + 3] );
//#else
// 		if( j < CDaoRecipeSet::rcpUP_RB1_USE - 3 ) 
// 		{
// 			pTranx->Primary.SetItemData( sItemName, pDoc->m_pRecipeInfo[nRow].sValue[j + 3] );
// 		}
// 		else if( j >= CDaoRecipeSet::rcpUP_RB1_USE - 3 )
// 		{
// 			CString sString = "";
// 			pTranx->Primary.SetItemData( sItemName, (LPCTSTR)sString );
// 		}
// #endif
	}
	// Temporary
	return pTranx->PrimaryOut();
}

//---------------------------------------------------------------------------
// Primary : ECS <=== HDC : Operator ID Report
//---------------------------------------------------------------------------
int CHost::S6F67(int i)
{
	if( !m_bConnected || m_bRetryConnect ) return -1; // 2009.03.17 minhan

	XSecsTranxThread* pTranx = Transaction( "S6F67" );
	if( pTranx == NULL ) return -1;

	int nIndex = m_pDicsData->m_LoginInfo.nCurUserLevel;
	
	pTranx->Primary.SetItemData( "OPID", m_pDicsData->m_GlsInfo[i].sOperationId );
	return pTranx->PrimaryOut();
}

//---------------------------------------------------------------------------
// Primary : ECS <=== HDC : Recipe Change Report
//---------------------------------------------------------------------------
int CHost::S7F21(int nRecipeId)
{
	CString sBuf;
	sBuf.Format("%d",nRecipeId);
	if( !m_bConnected || m_bRetryConnect ) return -1;//0;

	XSecsTranxThread* pTranx = Transaction("S7F21");
	if( pTranx == NULL ) return -1;

	CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();
	if( pDoc->m_pRecipeSet->FindRecipe( sBuf ) )
	{	
		RECIPE_INFO *pRecipeInfo = pDoc->m_pRecipeInfo;
		CString sData;
		sData.Format( "%d", nRecipeId );
		pTranx->Primary.SetItemData( "PPID", sData );
		
		// Set Date Time
		sData = pDoc->m_pRecipeInfo[nRecipeId - 1].sValue[CDaoRecipeSet::rcpTIME];
		// 04/04/20 12:43:35 ==> 040420124335 0/0/0 0:0:0
		sData.Remove( '/' ); sData.Remove( ':' ); sData.Remove( ' ' );
		pTranx->Primary.SetItemData( "DATETIME", sData );

		// Check again
		pTranx->Primary.SetItemData( "OPID", m_pDicsData->m_LoginInfo.sUserID[m_pDicsData->m_LoginInfo.nCurUserLevel] );
	}
	
	return pTranx->PrimaryOut();
}



//---------------------------------------------------------------------------
// Primary : ECS <=== HDC : Lot Process Data Request
//---------------------------------------------------------------------------
int CHost::S7F73(int i)
{
	if( !m_bConnected || m_bRetryConnect ) return -1;//0;

	XSecsTranxThread* pTranx = Transaction("S7F73");
	if( pTranx == NULL ) return -1;

	pTranx->Primary.SetItemData( "LOTID", m_pDicsData->m_PortInfo[i].sLotId );
	pTranx->Primary.SetItemData( "CSTID", m_pDicsData->m_PortInfo[i].sCstId );
	pTranx->Primary.SetItemData( "PORTNO", m_pDicsData->m_PortInfo[i].nPortNo );
	return pTranx->PrimaryOut();
}

//---------------------------------------------------------------------------
// Primary : ECS <=== HDC : Lot Process Data Request
//---------------------------------------------------------------------------
int CHost::S10F1(CString sText)
{
	if( !m_bConnected || m_bRetryConnect ) return -1;//0;

	XSecsTranxThread* pTranx = Transaction("S10F1");
	if( pTranx == NULL ) return -1;

	pTranx->Primary.SetItemData( "TID", 0 );
	pTranx->Primary.SetItemData( "TEXT", sText );
	return pTranx->PrimaryOut();
}

int CHost::S9F13(CString sMEXP, CString sEDID)
{
	if( !m_bConnected || m_bRetryConnect ) return -1;

	XSecsTranxThread* pTranx = Transaction("S9F13");
	if( pTranx == NULL ) return -1;

	pTranx->Primary.SetItemData( "MEXP", sMEXP );
	pTranx->Primary.SetItemData( "EDID", sEDID );
	return pTranx->PrimaryOut();
}
