// Host.h: interface for the CHost class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HOST_H__9DD50FDF_A2DB_11D3_90BA_A688038FF019__INCLUDED_)
#define AFX_HOST_H__9DD50FDF_A2DB_11D3_90BA_A688038FF019__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SECS\XSecs.h"
#include "DicsData.h"

#include "View\SetupItems.h"	// Added by ClassView
#include "X\XCtlMelsec.h"	// Added by ClassView
#include "X\XTimer.h"
#include "FactoryLib\EqpAssy.h"

class CHost : public XSecsHSMS  
{
public:
	int S9F13( CString sMEXP, CString sEDID );
	CHost();

	XTimer*				m_pTimer;
	CEqpStateSequence*	m_pEqpStateSeq;
	CDicsView*			m_pDicsView;
	CDicsData*			m_pDicsData;
	XCtlMelsec*			m_pMelsec;
	XCtlDevice*			m_pDevice;
	CSetupItems*		m_pSetupItems;
	CEqpAssy*		m_pEqpAssy;

	virtual ~CHost();
	void SetDicsView( CDicsView *pView )		   { m_pDicsView = pView;	}
	void SetMelsec( XCtlMelsec* pMelsec )		   { m_pMelsec = pMelsec; }
	void SetDevice( XCtlDevice* pDevice )		   { m_pDevice = pDevice; }
	void SetSeqTimer( XTimer* pTimer )			   { m_pTimer = pTimer; }
	void SetDicsData( CDicsData* pDicsData )	   { m_pDicsData = pDicsData; }
	void SetSetupItems( CSetupItems* pSetupItems ) { m_pSetupItems = pSetupItems; }
	void SetData(CDicsData* pData)				   { m_pDicsData	= pData; }
	void SetEqpAssy( CEqpAssy* pAssy )				{m_pEqpAssy = pAssy;}

	BOOL SecondaryRcvd( LPCTSTR lpszName, BOOL bLock = TRUE );

	int S1F1();
	int S1F65(char cCtlMode, char cEqSubStus = ' ');
	int S1F67(int i);
	int S1F69();
	int S1F73(int i, char cPortChangeStatus, char cPortMode );
	int S1F75(int i, char cPortChangeStatus );

	int S2F17();
	int S2F25( char* buf );

	int S5F65(int iALCD, UINT uALID, CString sALTX, char cAlarmLevel, CString sSEQNO );
	int S6F1(int nTrId);
	int S6F63(int i);
	int S6F65(int i);
	int S6F67(int i);
	int S6F69(int i, int j);

	int S7F21(int nRecipeId);
	int S7F71(int i);
	int S7F73(int i);
	int S10F1(CString sText);

	CString m_szHostMsg;
	CString	m_sTerminalMessage;

	BOOL m_flagS7F25Received;
	BOOL m_flagS2F27Received[MAX_PORT_NO];
	BOOL m_flagS7F65Received[MAX_PORT_NO];
	BOOL m_flagS2F21Received[MAX_PORT_NO];
	BOOL m_flagS1F79Received;
	BOOL m_flagS1F77Received;
	BOOL m_flagONLINE_FAIL;

	double m_dS1F3SampleTime;
	double m_dS1F3SampleTime1;
	double m_dS1F3RecvSampTime;
	double m_dS1F3SendSampTime;
	double m_dS2F23SampleTime;
	double m_dS2F23SampleTime1;

	int m_nS2F23ListSize;
	
	int  m_nPortNo;

//	static CString m_S1F5ItemName[MAX_EDC_DATA_NO];
//	static CString m_S7F25ItemName[138];
//	static CString m_S6F3GlassApdName[MAX_GLASS_APD_NO];
//	static CString m_S6F3LotApdName[MAX_LOT_APD_NO];
//	static CString m_S6F3LotApdDvType[MAX_LOT_APD_NO];
	static CString m_TraceDataName[MAX_TRACE_DATA_NO];
	static CString m_RecipeName[MAX_RECIPE_BODY_NO - 3];	// 150901 halesu
	static CString m_S6F65GlsApdName[MAX_APD_DATA_NO];

	enum alarmLEVEL { almLIGHT = 'L', almSERIOUS = 'S' };

protected:
	int OnSecondaryRcvd( XSecsTranxThread *pTranx );
	int OnPrimaryRcvd( XSecsTranxThread *pTranx );
};

#endif // !defined(AFX_HOST_H__9DD50FDF_A2DB_11D3_90BA_A688038FF019__INCLUDED_)
