///////////////////////////////////////////////////////////////////////////////
// File:		PIDControl.cpp
///////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "PIDControl.h"
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
CPIDControl::CPIDControl()
{
	m_dKp = -0.05;
	m_dKd = 0.001;
	m_dKi = -0.0015;
	m_dXSum = 0.0;
	m_dPrevX = 0.0;
	m_dDelta = 0.0;
	m_dDigitalFiltarK = 0.96;
	m_iDeltaT = 0;
	m_iDeltaTf = 0;

	m_dVelSum = 0.0;
	m_iVelCount = 0;
	m_dVelAvg = 0.0;
}


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
double CPIDControl::PIDCalc(double dX,double dFinalX)
{
	double dVal;

	dVal = dX - dFinalX;
	m_dXSum = m_dXSum + dVal;

	dVal = m_dPrevX - dX;	// Calculate the vlocity
	// Average the vlocity
	m_dVelSum += dVal;
	m_iVelCount++;
	if(m_iVelCount >= 10)
	{
		m_dVelAvg = m_dVelSum/(double)m_iVelCount;
		m_iVelCount = 0;
		m_dVelSum = 0.0;
	}

	m_dDelta = m_dKp*dX + m_dKd*m_dVelAvg + m_dKi*m_dXSum;
	m_dPrevX = dX;

	///////////////////////////////////////////////////////////////////////////
	//Statistics 
	m_dKpFactor = m_dKp*dX;
	m_dKdFactor = m_dKd*m_dVelAvg;
	m_dKiFactor = m_dKi*m_dXSum;
	m_PreviousdFinalX = dFinalX;

	return m_dDelta;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
void CPIDControl::SetCoefficients(double dKp, double dKd, double dKi)
{
	m_dKp = dKp;
	m_dKd = dKd;
	m_dKi = dKi;
//	if(m_dKi != 0.0)
//	{
//		m_dXSum = ( m_dDelta-(m_dKp*m_PreviousdFinalX) )/m_dKi;
//	}
}

