// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Dics.h"

#include "MainFrm.h"
#include "View\DatalogView.h"
#include "View\SystemView.h"
#include "View\AlarmsView.h"
#include "View\RecipesView.h"
#include "View\SetupView.h"
#include "Dlg\DlgPassword.h"	// ljy_050414
#include "Dlg\DlgIORepeat.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_MOVE()
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_COMMAND(ID_JOBS, OnJobs)
	ON_COMMAND(ID_AUTO, OnAuto)
	ON_COMMAND(ID_MAINT, OnMaint)
	ON_COMMAND(ID_SYSTEM, OnSystem)
	ON_COMMAND(ID_SERVO, OnServo)
	ON_COMMAND(ID_DATALOG, OnDatalog)
	ON_COMMAND(ID_SETUP, OnSetup)
	ON_COMMAND(ID_RECIPES, OnRecipes)
	ON_COMMAND(ID_ALARMS, OnAlarms)
	ON_COMMAND(ID_HELP, OnHelp)
	ON_COMMAND(ID_JOBS_INIT, OnJobsInit)
	ON_COMMAND(ID_JOBS_CYCLE_STOP, OnJobsCycleStop)
	ON_COMMAND(ID_JOBS_CYCLE_START, OnJobsCycleStart)
	ON_COMMAND(ID_MAINT_DI_RUN, OnMaintDiRun)
	ON_COMMAND(ID_MAINT_DI_STOP, OnMaintDiStop)
	ON_COMMAND(ID_MAINT_CLEANING_RUN, OnMaintCleaningRun)
	ON_COMMAND(ID_MAINT_CLEANING_STOP, OnMaintCleaningStop)
	ON_COMMAND(ID_RECIPES_SELECT, OnRecipesSelect)
	ON_COMMAND(ID_RECIPES_COPY, OnRecipesCopy)
	ON_COMMAND(ID_RECIPES_SAVE, OnRecipesSave)
	ON_COMMAND(ID_DATALOG_OPEN, OnDatalogOpen)
	ON_COMMAND(ID_SETUP_SAVE, OnSetupSave)
	ON_COMMAND(ID_ALARMS_SAVE, OnAlarmsSave)
	ON_COMMAND(ID_ALARMS_DELETE, OnAlarmsDelete)
	ON_COMMAND(ID_EXIT, OnExit)
	ON_COMMAND(ID_SYSTEM_REVERSE, OnSystemReverse)
	ON_COMMAND(ID_SYSTEM_SAVE, OnSystemSave)
	ON_COMMAND(ID_JOBS_CONTROL, OnJobsControl)
	ON_COMMAND(ID_JOBS_MONITOR, OnJobsMonitor)
	ON_COMMAND(ID_JOBS_OFFLINE, OnJobsOffline)
	ON_COMMAND(ID_JOBS_LOADER_INIT, OnJobsLoaderInit)
	ON_COMMAND(ID_JOBS_LOOPBACK, OnJobsLoopback)
	ON_COMMAND(ID_MAIN_ONLINE, OnJobsMainOnline)
	ON_COMMAND(ID_MAIN_OFFLINE, OnJobsMainOffline)
	ON_COMMAND(ID_JOBS_PAUSE, OnJobsPause)
	ON_COMMAND(ID_JOBS_IF_RESET, OnJobsIfReset)
	ON_COMMAND(ID_RECIPES_ADD, OnRecipesAdd)
	ON_COMMAND(ID_RECIPES_DELETE, OnRecipesDelete)
	ON_UPDATE_COMMAND_UI(ID_JOBS, OnUpdateJobs)
	ON_UPDATE_COMMAND_UI(ID_AUTO, OnUpdateAuto)
	ON_UPDATE_COMMAND_UI(ID_MAINT, OnUpdateMaint)
	ON_UPDATE_COMMAND_UI(ID_SYSTEM, OnUpdateSystem)
	ON_UPDATE_COMMAND_UI(ID_SERVO, OnUpdateServo)
	ON_UPDATE_COMMAND_UI(ID_RECIPES, OnUpdateRecipes)
	ON_UPDATE_COMMAND_UI(ID_DATALOG, OnUpdateDatalog)
	ON_UPDATE_COMMAND_UI(ID_SETUP, OnUpdateSetup)
	ON_UPDATE_COMMAND_UI(ID_ALARMS, OnUpdateAlarms)
	ON_UPDATE_COMMAND_UI(ID_HELP, OnUpdateHelp)
	ON_UPDATE_COMMAND_UI(ID_EXIT, OnUpdateExit)
	ON_UPDATE_COMMAND_UI(ID_SYSTEM_REVERSE, OnUpdateSystemReverse)
	ON_UPDATE_COMMAND_UI(ID_JOBS_CONTROL, OnUpdateJobsControl)
	ON_UPDATE_COMMAND_UI(ID_JOBS_MONITOR, OnUpdateJobsMonitor)
	ON_UPDATE_COMMAND_UI(ID_JOBS_LOADER_INIT, OnUpdateJobsLoaderInit)
	ON_UPDATE_COMMAND_UI(ID_JOBS_OFFLINE, OnUpdateJobsOffline)
	ON_UPDATE_COMMAND_UI(ID_RECIPES_COPY, OnUpdateRecipesCopy)
	ON_UPDATE_COMMAND_UI(ID_RECIPES_SELECT, OnUpdateRecipesSelect)
	ON_UPDATE_COMMAND_UI(ID_JOBS_INIT, OnUpdateJobsInit)
	ON_UPDATE_COMMAND_UI(ID_JOBS_CYCLE_STOP, OnUpdateJobsCycleStop)
	ON_UPDATE_COMMAND_UI(ID_JOBS_CYCLE_START, OnUpdateJobsCycleStart)
	ON_UPDATE_COMMAND_UI(ID_MAINT_DI_RUN, OnUpdateMaintDiRun)
	ON_UPDATE_COMMAND_UI(ID_MAINT_DI_STOP, OnUpdateMaintDiStop)
	ON_UPDATE_COMMAND_UI(ID_MAINT_CLEANING_RUN, OnUpdateMaintCleaningRun)
	ON_UPDATE_COMMAND_UI(ID_MAINT_CLEANING_STOP, OnUpdateMaintCleaningStop)
	ON_UPDATE_COMMAND_UI(ID_RECIPES_SAVE, OnUpdateRecipesSave)
	ON_UPDATE_COMMAND_UI(ID_SETUP_SAVE, OnUpdateSetupSave)
	ON_UPDATE_COMMAND_UI(ID_ALARMS_DELETE, OnUpdateAlarmsDelete)
	ON_UPDATE_COMMAND_UI(ID_MAIN_ONLINE, OnUpdateJobsMainOnline)
	ON_UPDATE_COMMAND_UI(ID_MAIN_OFFLINE, OnUpdateJobsMainOffline)
	ON_UPDATE_COMMAND_UI(ID_JOBS_PAUSE, OnUpdateJobsPause)
	ON_UPDATE_COMMAND_UI(ID_JOBS_IF_RESET, OnUpdateJobsIfReset)
	ON_UPDATE_COMMAND_UI(ID_RECIPES_ADD, OnUpdateRecipesAdd)
	ON_UPDATE_COMMAND_UI(ID_RECIPES_DELETE, OnUpdateRecipesDelete)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_SYSTEM_REPEAT, &CMainFrame::OnSystemRepeat)
	ON_UPDATE_COMMAND_UI(ID_SYSTEM_REPEAT, &CMainFrame::OnUpdateSystemRepeat)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_bCycleStop	= FALSE;
	m_bAuto			= TRUE;
	m_nMenu			= menuJOBS;
	m_bDiStateSave	= FALSE;

	// ljy_050128 : Initialize restore valiable
	for( int i=0 ; i<MAX_LOADER_IF_NO ; i++ )
	{
		m_bLoaderIFSave[i] = FALSE;
	}
}

CMainFrame::~CMainFrame()
{
}

//--------------------------------------------------------------------
// OnCreate
//--------------------------------------------------------------------
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	//	_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );
	// 090226 memory leak find   -- how to use
	// ex) dumping object -> { number }
	// _CrtSetBreakAlloc( 73d22bb6 );

	// Create the title panel
	if( !m_wndTitlePanel.Create(this, IDD_TITLE_PANEL, 
		CBRS_ALIGN_TOP | WS_CHILD | WS_VISIBLE | CBRS_BOTTOM , AFX_IDW_DIALOGBAR ) )
	{
		TRACE0("Failed to create dialogbar\n");
		return -1;		// fail to create
	}
	
	if( !m_wndToolBar.CreateEx(this, /*TBSTYLE_FLAT*/ TBSTYLE_BUTTON, WS_CHILD | WS_VISIBLE | CBRS_BOTTOM
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar( IDR_MAINFRAME ) )
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if( !m_wndCommandToolBar.CreateEx(this, TBSTYLE_FLAT /*TBSTYLE_BUTTON*/, WS_CHILD | WS_VISIBLE | CBRS_RIGHT
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndCommandToolBar.LoadToolBar( IDR_JOBS ) )
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	//-------------------------------------------------
	//	m_bmpNavigation.LoadBitmap( IDB_BITMAP_NAV_TOOLBAR );
	//	m_wndToolBar.SetBitmap( (HBITMAP)m_bmpNavigation );
	//-------------------------------------------------
	m_wndToolBar.LoadTrueColorToolBar( 65,
									IDB_BITMAP_NAV_TOOLBAR,
									IDB_BITMAP_NAV_TOOLBAR,
									IDB_BITMAP_NAV_TOOLBAR_DIS );

	//ToolBarImage create
	m_JobsToolBarImage		= new TOOLBARIMAGE;
	m_JobsCimToolBarImage	= new TOOLBARIMAGE;
	m_MaintToolBarImage		= new TOOLBARIMAGE;
	m_SystemToolBarImage	= new TOOLBARIMAGE;
	m_ServoToolBarImage		= new TOOLBARIMAGE;
	m_RecipeToolBarImage	= new TOOLBARIMAGE;
	m_SetupToolBarImage		= new TOOLBARIMAGE;
	m_DatalogToolBarImage	= new TOOLBARIMAGE;
	m_AlarmToolBarImage		= new TOOLBARIMAGE;

	m_wndCommandToolBar.SetTrueColorToolBarImage(m_JobsToolBarImage,65,
												IDB_BITMAP_JOB1_HI,
												IDB_BITMAP_JOB1_HI,
												IDB_BITMAP_JOB1_DIS);
		
	m_wndCommandToolBar.SetTrueColorToolBarImage(m_JobsCimToolBarImage,65,
												IDB_BITMAP_JOBS_CIM_AKT_HI,
												IDB_BITMAP_JOBS_CIM_AKT_HI,
												IDB_BITMAP_JOBS_CIM_AKT_DIS);

	m_wndCommandToolBar.SetTrueColorToolBarImage(m_MaintToolBarImage,65,
												IDB_BITMAP_MAINT1_HI,
												IDB_BITMAP_MAINT1_HI,
												IDB_BITMAP_MAINT1_DIS);
	m_wndCommandToolBar.SetTrueColorToolBarImage(m_SystemToolBarImage,65,
												IDB_BITMAP_SYSTEM1_HI,
												IDB_BITMAP_SYSTEM1_HI,
												IDB_BITMAP_SYSTEM1_HI );
	m_wndCommandToolBar.SetTrueColorToolBarImage(m_ServoToolBarImage,65,
												IDB_BITMAP_SERVO,
												IDB_BITMAP_SERVO,
												IDB_BITMAP_SERVO );	
	m_wndCommandToolBar.SetTrueColorToolBarImage(m_RecipeToolBarImage,65,
												IDB_BITMAP_RECIPE_HI,
												IDB_BITMAP_RECIPE_HI,
												IDB_BITMAP_RECIPE_DIS );
	m_wndCommandToolBar.SetTrueColorToolBarImage(m_SetupToolBarImage,65,
												IDB_BITMAP_SETUP1_HI,
												IDB_BITMAP_SETUP1_HI,
												IDB_BITMAP_SETUP1_DIS );
	m_wndCommandToolBar.SetTrueColorToolBarImage(m_DatalogToolBarImage,65,
												IDB_BITMAP_DATALOG1_HI,
												IDB_BITMAP_DATALOG1_HI,
												IDB_BITMAP_DATALOG1_DIS );
	m_wndCommandToolBar.SetTrueColorToolBarImage(m_AlarmToolBarImage,65,
												IDB_BITMAP_ALARM1_HI,
												IDB_BITMAP_ALARM1_HI,
												IDB_BITMAP_ALARM1_DIS );

	m_wndCommandToolBar.LoadTrueColorToolBar( m_JobsToolBarImage );

//	AfxSetResourceHandle(hDefault);
///////////////////////////////////////////////////////////////////////
// 	RegBackup();
	return 0;
}

//--------------------------------------------------------------------
// PreCreateWindow
//--------------------------------------------------------------------
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow( cs ) ) return FALSE;

	// TODO: Modify the Window class or styles here by modifying the CREATESTRUCT cs

	// Added
	cs.style &= ~WS_SYSMENU; // disappear the sysmenu

	if( cs.hMenu != NULL )
     {
         ::DestroyMenu( cs.hMenu ); // delete menu if loaded
         cs.hMenu = NULL; // no menu for this window
     }

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

//--------------------------------------------------------------------
// Set the window size to 1024 x 768
//--------------------------------------------------------------------
void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CMDIFrameWnd::OnSize(nType, cx, cy);

	int nScreenX = GetSystemMetrics( SM_CXSCREEN );
	int nScreenY = GetSystemMetrics( SM_CYSCREEN );
#ifdef _MY_DEBUG
	if(nScreenX > 1050)	nScreenX = 1050;
	if(nScreenY >  780)	nScreenY =  780;
#else
	nScreenX = 1024;
	nScreenY = 768;
#endif
	MoveWindow( 0, 0, nScreenX, nScreenY );
}

void CMainFrame::OnMove(int x, int y) 
{
	CMDIFrameWnd::OnMove(x, y);

	int nScreenX = GetSystemMetrics( SM_CXSCREEN );
	int nScreenY = GetSystemMetrics( SM_CYSCREEN );
#ifdef _MY_DEBUG
	if(nScreenX > 1050)	nScreenX = 1050;
	if(nScreenY >  780)	nScreenY =  780;
#else
	nScreenX = 1024;
	nScreenY = 768;
#endif
	MoveWindow( 0, 0, nScreenX, nScreenY );
}

//--------------------------------------------------------------------
// destruction
//--------------------------------------------------------------------
void CMainFrame::OnDestroy() 
{
	CMDIFrameWnd::OnDestroy();

	KillTimer( TIMER_MAINFRM );
	KillTimer( TIMER_CUR_TIME );

	if( m_JobsToolBarImage )	delete m_JobsToolBarImage;
	if( m_JobsCimToolBarImage ) delete m_JobsCimToolBarImage;
	if( m_MaintToolBarImage )	delete m_MaintToolBarImage;
	if( m_SystemToolBarImage )	delete m_SystemToolBarImage;
	if( m_RecipeToolBarImage )	delete m_RecipeToolBarImage;
	if( m_ServoToolBarImage )	delete m_ServoToolBarImage;
	if( m_SetupToolBarImage )	delete m_SetupToolBarImage;
	if( m_DatalogToolBarImage ) delete m_DatalogToolBarImage;
	if( m_AlarmToolBarImage )	delete m_AlarmToolBarImage;
}

//--------------------------------------------------------------------
// Overridden method declarations for CMainFrame
// : To delete the menu bar
//--------------------------------------------------------------------
BOOL CMainFrame::LoadFrame(UINT nIDResource, DWORD dwDefaultStyle,
     CWnd* pParentWnd, CCreateContext* pContext)
{
	return CFrameWnd::LoadFrame( nIDResource, dwDefaultStyle,
		pParentWnd, pContext );
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs,
      CCreateContext* /*pContext*/)
{
	return CreateClient( lpcs, NULL );
}

void CMainFrame::OnAuto() 
{
	// Get document pointer
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	CDicsDoc* pDoc = pView->GetDocument();

	if( pView->m_pDicsData->m_GenInfo.bAuto ) return;

#ifndef _MY_DEBUG
	// Saving Servo Position
	BOOL bRbtPositionChanged = FALSE;

#endif	

	if( AfxMessageBox( "Do you want to change to auto mode ?", MB_YESNO | MB_ICONQUESTION ) == IDNO ) return;

	if( pDoc->m_pSystemWnd ) 
	{
		pDoc->m_pSystemWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pServoWnd ) 
	{
		pDoc->m_pServoWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pRecipesWnd ) 
	{
		if( pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idMAINT && pDoc->IsRecipeChanged() )
		{
			int nRet = AfxMessageBox( "There is some change of recipe value. \r\n"
				"Do you want to save it anyway ?", MB_YESNO );
			if( nRet == IDYES ) pDoc->m_pRecipesView->Save();
		}
		pDoc->m_pRecipesWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pSetupWnd ) 
	{
		if( ( pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP ) && 
			( pDoc->m_pSetupItems->IsSetupChangedTabJobCondView() || 
			  pDoc->m_pSetupItems->IsSetupChangedTabInterlockSetView() ||
			  pDoc->m_pSetupItems->IsSetupChangedTabInterlockSet2View() ||
			  pDoc->m_pSetupItems->IsSetupChangedTabInterfaceParaView() ||
			  pDoc->m_pSetupItems->IsSetupChangedTabCVDistanceSetView() ) )
			  // || pDoc->m_pSetupItems->IsSetupChangedTabCVMotorParaView() ) )		// 201000702 ssm
		{
			int nRet = AfxMessageBox( "There is some change of setup value. \r\n"
				"Do you want to save it anyway ?", MB_YESNO );
			if( nRet == IDYES ) pDoc->m_pSetupView->OnSetupSave( TRUE );
		}
		pDoc->m_pSetupWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pAlarmsWnd ) 
	{
		pDoc->m_pAlarmsWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pDatalogWnd ) 
	{
		pDoc->m_pDatalogWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pHelpWnd ) 
	{
		pDoc->m_pHelpWnd->SendMessage( WM_CLOSE );
	}

	// Glass   Puase  Ų.
	if( !pView->m_pDicsData->m_GenInfo.bAuto && pView->m_pDicsData->m_GenInfo.nGlassNo )
	{
		pView->m_pDicsData->m_EqpInfo.nEqpState[CDicsData::statePAUSE] = 1;
		pView->m_pDicsData->m_GenInfo.bPause = TRUE;
	}

//	if( !pView->m_pDicsData->m_GenInfo.bAuto )
//	{
//		pView->m_pTrSeq->InitParameter();
//		pView->m_pTrSeq->SetSeqNo();
//	}

	// Set Eqp State
	pView->m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateMANUAL] = 0;
	pView->m_pDicsData->m_GenInfo.bAuto = TRUE;
//	m_nMenu = menuAuto;
	m_bAuto = TRUE;

	// Layout toolbar
	m_wndCommandToolBar.LoadToolBar( IDR_JOBS );
	m_wndCommandToolBar.LoadTrueColorToolBar( m_JobsToolBarImage );

	// Set the view name
	m_wndTitlePanel.m_msgViewName.SetOpMsg( "AUTO" );
	// Layout toolbar
//	pView->SetToolbar( pView->m_nSelectedTab );
	RecalcLayout();

	// ljy_050302 : Log
	SetLog( "EQ MODE ", 0, 0, "OnJobs" );
}

void CMainFrame::OnUpdateAuto(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp   = (CDicsApp*)AfxGetApp();
	CDicsView* pView = (CDicsView*)pApp->m_pMainView;
	if( pView == NULL ) return;
	pCmdUI->SetCheck( pView->m_pDicsData->m_GenInfo.bAuto );
}

void CMainFrame::OnJobsPause() 
{
	CDicsApp* pApp   = (CDicsApp*)AfxGetApp();
	CDicsView* pView = (CDicsView*)pApp->m_pMainView;
	CDicsData* pData = pView->m_pDicsData;
	CDicsDoc* pDoc   = pView->GetDocument();

	if( pData->m_GenInfo.bPause )
	{
		if( pView->m_pDicsData->m_GenInfo.bEmo )
		{
			AfxMessageBox( "Can not Restart...\nNow EMO Condition!" );	
			return;
		}

//		if(	!pView->m_pMainSeq->IsDetReady() ) 
//		{
//			AfxMessageBox( "All of mixing tanks are not ready!!! Please wait..." );
//			return;
//		}

		if( AfxMessageBox( "Do you want to restart the CV ?", MB_YESNO | MB_ICONQUESTION ) != IDYES )
			return;

		if ( pView->m_pDicsData->m_JobCond.bJobProcessUse == 1 )	// SanghoCho 2015.05.09
		{
			if ( !pDoc->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] && !pDoc->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE])
			{
				if( AfxMessageBox( "This mode is pump1 & Pump2 Nouse", MB_YESNO | MB_ICONQUESTION ) != IDYES )
				return;
				SetLog( "OP      ", 0, 0, "PUMP1 & PUMP2 NO USE MODE" );
			}
			else if ( !pDoc->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] )
			{
				if( AfxMessageBox( "This mode is pump1 Nouse", MB_YESNO | MB_ICONQUESTION ) != IDYES )
				return;
				SetLog( "OP      ", 0, 0, "PUMP1 NO USE MODE" );
			}
			else if ( !pDoc->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE] )
			{
				if( AfxMessageBox( "This mode is pump2 Nouse", MB_YESNO | MB_ICONQUESTION ) != IDYES )
				return;
				SetLog( "OP      ", 0, 0, "PUMP2 NO USE MODE" );
			}
		}

		AddTitleMessage( "CLICK BUTTON : Restart" );
		SetLog( "OP      ", 0, 0, "Restart button" );

		// Set Equipment State
		pData->m_EqpInfo.nEqpState[CDicsData::statePAUSE] = 0;
		pData->m_GenInfo.bPause = FALSE;
	}
	else
	{
		// Skip for no glass in equipment
		if( !pData->m_GenInfo.nGlassNo ) return;

		if( AfxMessageBox( "Do you want to PAUSE the CV ?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) 
			return;

		AddTitleMessage( "CLICK BUTTON : Temporary stop" );
		SetLog( "OP      ", 0, 0, "Puase button" );

		// Set Equipment State
		pData->m_EqpInfo.nEqpState[CDicsData::statePAUSE] = 1;
		pData->m_GenInfo.bPause = TRUE;
	}
}

void CMainFrame::OnUpdateJobsPause(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = ( (CDicsView*) pApp->m_pMainView );
	if( pView == NULL ) return;
	
	CDicsData* pData = pView->m_pDicsData;

	if( !pData->m_GenInfo.bEqpInitComp ||
		!pData->m_GenInfo.bAuto ) { pCmdUI->Enable( FALSE ); return; }

	pCmdUI->SetCheck( pData->m_GenInfo.bPause );
}

//--------------------------------------------------------------------
// Jobs navigation button
//--------------------------------------------------------------------
void CMainFrame::OnJobs() 
{
	if( m_nMenu == menuJOBS ) return;

	// Get document pointer
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	CDicsDoc* pDoc = pView->GetDocument();

	if ( pView->m_pDicsData->m_SeqFlag.bSemiAutoMove || 
		 pView->m_pDicsData->m_SeqFlag.bServoMove ) return;

 	if( pDoc->m_pSystemWnd ) 
	{
		pDoc->m_pSystemWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pServoWnd ) 
	{
		pDoc->m_pServoWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pRecipesWnd ) 
	{
		if( pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idMAINT && pDoc->IsRecipeChanged() )
		{
			int nRet = AfxMessageBox( "There is some change of recipe value. \r\n"
				"Do you want to save it anyway ?", MB_YESNO );
			if( nRet == IDYES ) pDoc->m_pRecipesView->Save();
		}
		pDoc->m_pRecipesWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pSetupWnd ) 
	{
		if( ( pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP ) && 
			( pDoc->m_pSetupItems->IsSetupChangedTabJobCondView() || 
			  pDoc->m_pSetupItems->IsSetupChangedTabInterlockSetView() ||
			  pDoc->m_pSetupItems->IsSetupChangedTabInterlockSet2View() ||
			  pDoc->m_pSetupItems->IsSetupChangedTabInterfaceParaView() ||
			  pDoc->m_pSetupItems->IsSetupChangedTabCVDistanceSetView() ) )
			  // || pDoc->m_pSetupItems->IsSetupChangedTabCVMotorParaView() ) ) 	// 20100702 ssm
		{
			int nRet = AfxMessageBox( "There is some change of setup value. \r\n"
				"Do you want to save it anyway ?", MB_YESNO );
			if( nRet == IDYES ) pDoc->m_pSetupView->OnSetupSave( TRUE );
		}
		pDoc->m_pSetupWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pAlarmsWnd ) 
	{
		pDoc->m_pAlarmsWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pDatalogWnd ) 
	{
		pDoc->m_pDatalogWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pHelpWnd ) 
	{
		pDoc->m_pHelpWnd->SendMessage( WM_CLOSE );
	}

	// Set Flags
	m_nMenu = menuJOBS;

//	// Layout toolbar
//	m_wndCommandToolBar.LoadToolBar( IDR_JOBS );
//	m_wndCommandToolBar.LoadTrueColorToolBar( m_JobsToolBarImage );
	// Layout toolbar
	pView->SetToolbar( pView->m_nSelectedTab );
	RecalcLayout();

	// ljy_050302 : Log
	SetLog( "EQ MODE ", 0, 0, "OnJobs" );
}

void CMainFrame::OnUpdateJobs(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_nMenu == menuJOBS );
}

//--------------------------------------------------------------------
void CMainFrame::OnJobsInit() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( AfxMessageBox( "Do you want to initialize the equipment ?", MB_YESNO ) == IDYES )
	{
//		Log.TextOut( "CLICK_BUTTON\tInit button" );

		pView->SendMessage( WM_INIT_STATUS, MSG_STATUS_DLG_CREATE, NULL );
		
		pView->m_pDicsData->m_GenInfo.bEqpInitReq = TRUE;
	}
}

void CMainFrame::OnUpdateJobsInit(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	
	if ( pView == NULL ) return;

	CDicsData* pData = pView->m_pDicsData;
	
	BOOL bEnable = TRUE;
	bEnable &= pData->m_GenInfo.bAuto;
	bEnable &= !pData->m_GenInfo.bEqpInitReq;
	bEnable &= !pData->m_GenInfo.bEqpInitComp;
	bEnable &= !pData->m_GenInfo.bEmo;
	
	pCmdUI->Enable( bEnable );
	pCmdUI->SetCheck( pData->m_GenInfo.bEqpInitReq );

	static DWORD dTime;
	static BOOL bTrigger = FALSE;
	if( pData->m_GenInfo.bEqpInitComp && pView->m_pDlgInitStatus )
	{
		if(!bTrigger)
		{
			dTime = GetCurrentTime();
			bTrigger = TRUE;
		}

		if( GetCurrentTime()- dTime < 1000)	return;
		pView->SendMessage( WM_INIT_STATUS, MSG_STATUS_DLG_DESTROY, NULL );
	}
}

//--------------------------------------------------------------------
// OnJobsLoaderInit
//--------------------------------------------------------------------
void CMainFrame::OnJobsLoaderInit() 
{/*
	if( AfxMessageBox( "Do you want to initialize the loader ?", MB_YESNO ) == IDYES )
	{
//		Log.TextOut( "CLICK_BUTTON\tInit button" );

		CDicsApp* pApp = (CDicsApp*) AfxGetApp();

		if( !( (CDicsView*) pApp->m_pMainView )->m_pLoaderSeq->m_SeqFlag.bInitComp )
		{
			( (CDicsView*) pApp->m_pMainView )->m_pLoaderSeq->m_SeqFlag.bInitReq = TRUE;
			( (CDicsView*) pApp->m_pMainView )->m_pLoaderSeq->m_SeqFlag.bResetReq = TRUE;
		}		
	}*/
}

void CMainFrame::OnUpdateJobsLoaderInit(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	if ( pView == NULL ) return;
}

//--------------------------------------------------------------------
void CMainFrame::OnJobsCycleStop() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsData* pData = ( (CDicsView*) pApp->m_pMainView )->m_pDicsData;

	if( pData->m_GenInfo.bCycleStop ) return;

	if( AfxMessageBox( "Do you want to change to CYCLE STOP ?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) return;

	if( pData->m_EqpInfo.cOpMode != CDicsData::opRECOVERY )		// ljy_050103 : Servo Tool Bar Recovery BTN
	{
		// Set message
//		m_wndTitlePanel.m_msgMessage.SetOpMsg( (LPCTSTR) "Cycle Stop" );
		AddTitleMessage( (LPCTSTR) "Cycle Stop" );

	}

	// Set Equipment State
	pData->m_EqpInfo.nEqpState[CDicsData::stateSTOP] = 1;
	pData->m_GenInfo.bCycleStop = TRUE;
	SetLog( "OP      ", 0, 0, "Cycle Stop button" );	// Thomas 200211
}

void CMainFrame::OnUpdateJobsCycleStop(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	if ( pView == NULL ) return;
	CDicsData* pData = pView->m_pDicsData;

//	if( !pData->m_GenInfo.bEqpInitComp ) { pCmdUI->Enable( FALSE ); return; }

	pCmdUI->SetCheck( pData->m_GenInfo.bCycleStop );
}

//--------------------------------------------------------------------
void CMainFrame::OnJobsCycleStart() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsData* pData = ( (CDicsView*)pApp->m_pMainView )->m_pDicsData;
	CDicsDoc* pDoc   = ( (CDicsView*)pApp->m_pMainView )->GetDocument();

	if( !pData->m_GenInfo.bCycleStop ) return; 

	if(	pData->m_GenInfo.bCleanOut )
	{
		AfxMessageBox( "Can not Change to CYCLE START : Now ClreanOut Mode" );
		return;
	}
	if( AfxMessageBox( "Do you want to change to CYCLE START?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) return;

	if ( pData->m_JobCond.bJobProcessUse == 1 )	// SanghoCho 2015.05.09
	{
		if ( !pDoc->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] && !pDoc->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE] )
		{
			if( AfxMessageBox( "This mode is pump1 & pump2 Nouse", MB_YESNO | MB_ICONQUESTION ) != IDYES )
				return;
			SetLog( "OP      ", 0, 0, "PUMP1 & PUMP2 NO USE MODE" );
		}
		else if ( !pDoc->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] )
		{
			if( AfxMessageBox( "This mode is pump1 Nouse", MB_YESNO | MB_ICONQUESTION ) != IDYES )
				return;
			SetLog( "OP      ", 0, 0, "PUMP1 NO USE MODE" );
		}
		else if ( !pDoc->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE] )
		{
			if( AfxMessageBox( "This mode is pump2 Nouse", MB_YESNO | MB_ICONQUESTION ) != IDYES )
				return;
			SetLog( "OP      ", 0, 0, "PUMP2 NO USE MODE" );
		}
	}

	if( pData->m_EqpInfo.cOpMode != CDicsData::opRECOVERY )		// ljy_050103 : Servo Tool Bar Recovery BTN
	{
		// Set message
//		m_wndTitlePanel.m_msgMessage.SetOpMsg( (LPCTSTR) "Ready" );
		AddTitleMessage( (LPCTSTR) "Ready" );
	}
	
	// Set Equipment State
	pData->m_EqpInfo.nEqpState[CDicsData::stateSTOP] = 0;
	pData->m_GenInfo.bCycleStop = FALSE;
	SetLog( "OP      ", 0, 0, "Cycle Start button" );	// Thomas 200211
}

void CMainFrame::OnUpdateJobsCycleStart(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	if ( pView == NULL ) return;
	CDicsData* pData = pView->m_pDicsData;

	if( !pData->m_GenInfo.bEqpInitComp ||
		pData->m_GenInfo.bCleanOut ) { pCmdUI->Enable( FALSE ); return; }

	pCmdUI->SetCheck( !pData->m_GenInfo.bCycleStop );
}

void CMainFrame::OnJobsIfReset() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	CDlgPassword dlg;
	dlg.SetDicsData( pView->m_pDicsData );
	if( dlg.DoModal() != IDOK ) return;
	
	if( AfxMessageBox( "Do you really Interface Signal Reset?", MB_YESNO | MB_ICONQUESTION ) == IDNO ) return;

	if( pView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER ) return;

	if( pView->m_pDicsData->m_IfRecv.bBit[CDicsData::rcvON_IF2] )
		pView->m_pDicsData->m_IfRecv.bBit[CDicsData::rcvRESET] = TRUE;
	else if( pView->m_pDicsData->m_IfSend.bBit[CDicsData::sndON_IF2] )
		pView->m_pDicsData->m_IfSend.bBit[CDicsData::sndRESET] = TRUE;
	
	//( (CDicsView*) pApp->m_pMainView )->m_pIfSeq->ResetInterfaceSignal();

/*
	( (CDicsView*) pApp->m_pMainView )->m_pCimSeq->m_nSeqEdcDataReportNo = 0;
	( (CDicsView*) pApp->m_pMainView )->m_pIfSeq->m_nSeqGlassRecvNo = 0;
	( (CDicsView*) pApp->m_pMainView )->m_pIfSeq->m_nSeqGlassSendNo = 0;
	( (CDicsView*) pApp->m_pMainView )->m_pTrSeq->m_nSeqUnitTrNo = 0;
	
	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfRecv.bBit[CDicsData::rcvREQ] = FALSE;
	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfSend.bBit[CDicsData::sndREQ] = FALSE;

	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfCim.bUnitTrApdReportReq = FALSE;
	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfCim.bUnitUlUpHandApdReportReq = FALSE;
	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfCim.bUnitUlUpHandApdReportReq = FALSE;

	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfCim.bApdDataWriteComp = FALSE;
	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfCim.bApdReportReq = FALSE;
	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfCim.bApdReportComp = FALSE;
*/
}

void CMainFrame::OnUpdateJobsIfReset(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	CDicsData* pData = pView->m_pDicsData;
	if( pView == NULL ) return;

	// Disable Condition
	BOOL bDisable = ( pView->m_pDicsData->m_LoginInfo.nCurUserLevel != CDicsData::idENGINEER ) || 
					( pView->m_pDicsData->m_GenInfo.bAuto );
	pCmdUI->Enable( !bDisable );
}

void CMainFrame::OnJobsControl() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	if( !( (CDicsView*) pApp->m_pMainView )->m_pHost->m_bConnected ) 
	{
		AfxMessageBox( "No connection with host" );
		return;
	}

	if( ( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeCONTROL ) return;
	if( AfxMessageBox( "Do you want to change to Online Remote mode ?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) return;

//	Log.TextOut( "CLICK_BUTTON\tOnline control button" );

	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfCim.bCtlModeChangeReq = TRUE;
	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeCONTROL;
// 	( (CDicsView*) pApp->m_pMainView )->m_pTabJobsCimView->SetCtrlState( MSG_CTRL_MODE, CDicsData::modeCONTROL, CDicsData::stateTOGGLE );
}

void CMainFrame::OnUpdateJobsControl(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	if( pView == NULL ) return;

	CDicsData* pData = pView->m_pDicsData;
	pCmdUI->SetCheck( pData->m_EqpInfo.cCtlMode == CDicsData::modeCONTROL );

	// Disable Condition
	BOOL bDisable = ( pData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) &
		( pData->m_PortInfo[0].bCstExist |
		  pData->m_PortInfo[1].bCstExist |
		  pData->m_PortInfo[2].bCstExist );
	pCmdUI->Enable( !bDisable );
}

//--------------------------------------------------------------------
void CMainFrame::OnJobsMonitor() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	if( !( (CDicsView*) pApp->m_pMainView )->m_pHost->m_bConnected ) 
	{
		AfxMessageBox( "No connection with host" );
		return;
	}

	if( ( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeMONITOR ) return;
	if( AfxMessageBox( "Do you want to change to Online Local mode ?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) return;

//	Log.TextOut( "CLICK_BUTTON\tOnline control button" );

	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfCim.bCtlModeChangeReq = TRUE;
	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeMONITOR;
// 	( (CDicsView*) pApp->m_pMainView )->m_pTabJobsCimView->SetCtrlState( MSG_CTRL_MODE, CDicsData::modeMONITOR, CDicsData::stateTOGGLE );
}

void CMainFrame::OnUpdateJobsMonitor(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	if( pView == NULL ) return;

	CDicsData* pData = pView->m_pDicsData;
	pCmdUI->SetCheck( pData->m_EqpInfo.cCtlMode == CDicsData::modeMONITOR );

	// Disable Condition
	BOOL bDisable = ( pData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) &
		( pData->m_PortInfo[0].bCstExist |
		  pData->m_PortInfo[1].bCstExist |
		  pData->m_PortInfo[2].bCstExist );
	pCmdUI->Enable( !bDisable );
}

//--------------------------------------------------------------------
void CMainFrame::OnJobsOffline() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
//	if( !( (CDicsView*) pApp->m_pMainView )->m_pHost->m_bConnected ) 
//	{
//		AfxMessageBox( "No connection with host" );
//		return;
//	}

	if( ( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) return;
	if( AfxMessageBox( "Do you want to change to offline mode ?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) return;

//	Log.TextOut( "CLICK_BUTTON\tOnline control button" );

	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfCim.bCtlModeChangeReq = TRUE;
	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfCim.cCtlMode = CDicsData::modeOFFLINE;
// 	( (CDicsView*) pApp->m_pMainView )->m_pTabJobsCimView->SetCtrlState( MSG_CTRL_MODE, CDicsData::modeOFFLINE, CDicsData::stateTOGGLE );
}

void CMainFrame::OnUpdateJobsOffline(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	if( pView == NULL ) return;

	CDicsData* pData = pView->m_pDicsData;
	pCmdUI->SetCheck( pData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE );
}

void CMainFrame::OnJobsLoopback() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	if( !( (CDicsView*) pApp->m_pMainView )->m_pHost->m_bConnected ) 
	{
		AfxMessageBox( "No connection with host" );
		return;
	}

	if( AfxMessageBox( "Do you want to execute the LOOP BAKC to Host?", MB_YESNO ) == IDNO ) return;

	char* szData = "0123456789";
 	( (CDicsView*) pApp->m_pMainView )->m_pHost->S2F25( szData );
}

void CMainFrame::OnJobsMainOnline() 
{
	// TODO: Add your command handler code here
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

//	pView->m_pDicsData->m_IfMainMc.bModeChangeReq = TRUE;
//	pView->m_pDicsData->m_IfMainMc.bOnline = TRUE;	
}

void CMainFrame::OnUpdateJobsMainOnline(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	pCmdUI->Enable( FALSE );
}

void CMainFrame::OnJobsMainOffline() 
{
	// TODO: Add your command handler code here
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

//	pView->m_pDicsData->m_IfMainMc.bModeChangeReq = TRUE;
//	pView->m_pDicsData->m_IfMainMc.bOnline = FALSE;	
}

void CMainFrame::OnUpdateJobsMainOffline(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	pCmdUI->Enable( FALSE );
}

//--------------------------------------------------------------------
// Maint navigation button
//--------------------------------------------------------------------
void CMainFrame::OnMaint() 
{
	if( m_nMenu == menuMAINT ) return;

	// Get document pointer
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	CDicsDoc* pDoc = pView->GetDocument();
	CDicsMainSeq* pMain = pView->m_pMainSeq;

	if( pView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;

	if( AfxMessageBox( "Do you want to change to manual mode ?", MB_YESNO | MB_ICONQUESTION ) == IDNO ) return;

#ifndef _MY_DEBUG
	if( pView->m_pDicsData->m_IfRecv.bBit[CDicsData::rcvON_IF2] ||
		pView->m_pDicsData->m_IfSend.bBit[CDicsData::sndON_IF2] )
	{
		if( AfxMessageBox( "Now EQP is Interfacing with Loader\nDo You want to change to Manual Mode?", MB_YESNO | MB_ICONQUESTION ) == IDNO ) return;
//		AfxMessageBox( "Now EQP is Interfacing with Loader." );
//		return;
	}
#endif
	
	if( pDoc->m_pSystemWnd ) 
	{
		pDoc->m_pSystemWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pServoWnd ) 
	{
		pDoc->m_pServoWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pRecipesWnd ) 
	{
		if( pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idMAINT && pDoc->IsRecipeChanged() )
		{
			int nRet = AfxMessageBox( "There is some change of recipe value. \r\n"
				"Do you want to save it anyway ?", MB_YESNO );
			if( nRet == IDYES ) pDoc->m_pRecipesView->Save();
		}
		pDoc->m_pRecipesWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pSetupWnd ) 
	{
		if( ( pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP ) && 
			( pDoc->m_pSetupItems->IsSetupChangedTabJobCondView() || 
			  pDoc->m_pSetupItems->IsSetupChangedTabInterlockSetView() ||
			  pDoc->m_pSetupItems->IsSetupChangedTabInterlockSet2View() ||
			  pDoc->m_pSetupItems->IsSetupChangedTabInterfaceParaView() ||
			  pDoc->m_pSetupItems->IsSetupChangedTabCVDistanceSetView() ) )
			  //|| pDoc->m_pSetupItems->IsSetupChangedTabCVMotorParaView() ) ) 	// 20100702 ssm
		{
			int nRet = AfxMessageBox( "There is some change of setup value. \r\n"
				"Do you want to save it anyway ?", MB_YESNO );
			if( nRet == IDYES ) pDoc->m_pSetupView->OnSetupSave( TRUE );
		}
		pDoc->m_pSetupWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pAlarmsWnd ) 
	{
		pDoc->m_pAlarmsWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pDatalogWnd ) 
	{
		pDoc->m_pDatalogWnd->SendMessage( WM_CLOSE );
	}
	if( pDoc->m_pHelpWnd ) 
	{
		pDoc->m_pHelpWnd->SendMessage( WM_CLOSE );
	}

//	m_nMenu = menuMAINT;
	m_bAuto = FALSE;

	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_GenInfo.bAuto = FALSE;

	// Set Eqp State
	( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateMANUAL] = 1;


	// Set the view name
	m_wndTitlePanel.m_msgViewName.SetOpMsg( "MANUAL" );

	// Layout toolbar
	pView->SetToolbar( pView->m_nSelectedTab );

	// ljy_050302 : Log
	SetLog( "EQ MODE ", 0, 0, "ON MAINT" );
}

void CMainFrame::OnUpdateMaint(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	if( pView == NULL ) return;
	pCmdUI->SetCheck( !pView->m_pDicsData->m_GenInfo.bAuto );

	pCmdUI->Enable( pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP );
}

//--------------------------------------------------------------------
void CMainFrame::OnMaintDiRun() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if(pView->m_pDicsData->m_IfPump.bCleaningStart)
	{
		AfxMessageBox( "Cleaning Run Status .....");
		return;
	}

	if( AfxMessageBox( "Do you want to start DI?", MB_YESNO | MB_ICONQUESTION ) == IDNO ) return;

	pView->m_pDicsData->m_IfPump.bDiStart = TRUE;

	SetLog( "EQ MODE ", 0, 0, "MAINT : DIW RUN" );
}

void CMainFrame::OnUpdateMaintDiRun(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp   = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView == NULL ) return;
	
	pCmdUI->SetCheck( pView->m_pDicsData->m_IfPump.bDiStart );
}

//--------------------------------------------------------------------
void CMainFrame::OnMaintDiStop() 
{
//	if( AfxMessageBox( "Do you want to stop DI ?", MB_YESNO | MB_ICONQUESTION ) == IDNO ) return;
	
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	pView->m_pDicsData->m_IfPump.bDiStart = FALSE;

	SetLog( "EQ MODE ", 0, 0, "MAINT : DIW STOP" );
}

void CMainFrame::OnUpdateMaintDiStop(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp   = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView == NULL ) return;
	
	pCmdUI->SetCheck( !pView->m_pDicsData->m_IfPump.bDiStart );
}

//--------------------------------------------------------------------
void CMainFrame::OnMaintCleaningRun() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if(pView->m_pDicsData->m_IfPump.bDiStart)
	{
		AfxMessageBox( "DI Run Status .....");
		return;
	}

	if( AfxMessageBox( "Do you want to start Cleaning?", MB_YESNO | MB_ICONQUESTION ) == IDNO ) return;

	pView->m_pDicsData->m_IfPump.bCleaningStart = TRUE;

	SetLog( "EQ MODE ", 0, 0, "MAINT : Cleaning RUN" );
}

void CMainFrame::OnUpdateMaintCleaningRun(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp   = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	CDicsDoc* pDoc = pView->GetDocument();

	if( pView == NULL ) return;
	
	pCmdUI->SetCheck( pView->m_pDicsData->m_IfPump.bCleaningStart );
	if( pDoc->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] && pDoc->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE])
	{
		pCmdUI->Enable(TRUE);
	}
	else
	{
		pCmdUI->Enable(FALSE);
	}
}

//--------------------------------------------------------------------
void CMainFrame::OnMaintCleaningStop() 
{
//	if( AfxMessageBox( "Do you want to stop DI ?", MB_YESNO | MB_ICONQUESTION ) == IDNO ) return;
	
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	pView->m_pDicsData->m_IfPump.bCleaningStart = FALSE;

	SetLog( "EQ MODE ", 0, 0, "MAINT : Cleaning STOP" );
}

void CMainFrame::OnUpdateMaintCleaningStop(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp   = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView == NULL ) return;
	
	pCmdUI->SetCheck( !pView->m_pDicsData->m_IfPump.bCleaningStart );
}

//--------------------------------------------------------------------
// System navigation button
//--------------------------------------------------------------------
void CMainFrame::OnSystem() 
{
	if( m_nMenu == menuSYSTEM ) return;

	// Get document pointer
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->CreateNewView( ID_SYSTEM );

	// Set the view name
//	m_wndTitlePanel.m_msgViewName.SetOpMsg( "SYSTEM" );

	// Layout toolbar
	m_wndCommandToolBar.LoadToolBar( IDR_SYSTEM );
	m_wndCommandToolBar.LoadTrueColorToolBar( m_SystemToolBarImage );
	RecalcLayout();
	
	m_nMenu = menuSYSTEM;

	// ljy_050302 : Log
	SetLog( "EQ MODE ", 0, 0, "OnSystem" );
}

void CMainFrame::OnUpdateSystem(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_nMenu == menuSYSTEM );

	CDicsApp* pApp   = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView == NULL ) return;
	pCmdUI->Enable( /*!m_bAuto &*/ ( pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP ) );	// 231220 halesu
}

//--------------------------------------------------------------------
void CMainFrame::OnSystemReverse() 
{
	m_IniConfiguration.Open( "ProcessData", "Config" );

	CDicsApp* pApp   = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->m_pSystemView->m_nNameOrDesc = !pDoc->m_pSystemView->m_nNameOrDesc;

	m_IniConfiguration.SetIntValue( "SYSTEM VIEW DISPLAY", "Name or Desc", pDoc->m_pSystemView->m_nNameOrDesc );

	BeginWaitCursor(); 
	pDoc->m_pSystemView->m_pTabSystemTab1View->GridInit();
	pDoc->m_pSystemView->m_pTabSystemTab2View->GridInit();
	EndWaitCursor(); 	
}

void CMainFrame::OnUpdateSystemReverse(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pCmdUI->Enable(TRUE);//2008.12.17 kimgun
//	pCmdUI->SetCheck( pDoc->m_pSystemView->m_nNameOrDesc );//2008.12.17 kimgun
}

//--------------------------------------------------------------------
void CMainFrame::OnSystemSave() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->m_pSystemView->OnWriteFile();
}

void CMainFrame::OnSystemRepeat()
{
	CDlgIORepeat ioDlg;
	ioDlg.DoModal();
}


void CMainFrame::OnUpdateSystemRepeat(CCmdUI *pCmdUI)
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	CDicsDoc* pDoc =( (CDicsView*) pApp->m_pMainView )->GetDocument();

	pCmdUI->Enable( !m_bAuto & ( pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idENGINEER ) & (pDoc->m_pSystemView->m_nSelectedTab==1) );
}

//--------------------------------------------------------------------
// Servo navigation button
//--------------------------------------------------------------------
void CMainFrame::OnServo() 
{
	if( m_nMenu == menuSERVO ) return;

	// Get document pointer
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->CreateNewView( ID_SERVO );

	// Set the view name
//	m_wndTitlePanel.m_msgViewName.SetOpMsg( "SERVO" );

	// Layout toolbar
	m_wndCommandToolBar.LoadToolBar( IDR_SERVO );
	m_wndCommandToolBar.LoadTrueColorToolBar( m_ServoToolBarImage );
	RecalcLayout();
	
	m_nMenu = menuSERVO;

	// ljy_050302 : Log
	SetLog( "EQ MODE ", 0, 0, "OnServo" );
}

void CMainFrame::OnUpdateServo(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_nMenu == menuSERVO );

	CDicsApp* pApp   = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView == NULL ) return;
	pCmdUI->Enable( !m_bAuto & ( pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP ) );
}

//--------------------------------------------------------------------
// Recipes navigation button
//--------------------------------------------------------------------
void CMainFrame::OnRecipes() 
{
	if( m_nMenu == menuRECIPES ) return;

	// Get document pointer
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->CreateNewView( ID_RECIPES );

	// Set the view name
//	m_wndTitlePanel.m_msgViewName.SetOpMsg( "RECIPES" );

	// Layout toolbar
	m_wndCommandToolBar.LoadToolBar( IDR_RECIPES );
	m_wndCommandToolBar.LoadTrueColorToolBar( m_RecipeToolBarImage );
	RecalcLayout();

	// ljy_041105 : Save DI status
	//m_bDiStateSave = ( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfPump.bDiStart;
	
	m_nMenu = menuRECIPES;

	// ljy_050302 : Log
	SetLog( "EQ MODE ", 0, 0, "OnRecipes" );
}

void CMainFrame::OnUpdateRecipes(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_nMenu == menuRECIPES );
}

//--------------------------------------------------------------------
void CMainFrame::OnRecipesSelect() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->m_pRecipesView->OnRecipesSelect();
}

void CMainFrame::OnUpdateRecipesSelect(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	// m_nViewNo = 0 : One Recipe View
	pCmdUI->Enable( pDoc->m_pRecipesView->m_nViewNo == 0 );
}


//--------------------------------------------------------------------
void CMainFrame::OnRecipesCopy() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->m_pRecipesView->OnRecipesCopy();
}

void CMainFrame::OnUpdateRecipesCopy(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	// m_nViewNo = 1 : All Recipe View
	pCmdUI->Enable( pDoc->m_pRecipesView->m_nViewNo == 1 );
}

//--------------------------------------------------------------------
void CMainFrame::OnRecipesSave() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->m_pRecipesView->OnRecipesSave();
}

void CMainFrame::OnUpdateRecipesSave(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp   = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView == NULL ) return;
	pCmdUI->Enable( pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idMAINT );
}

//--------------------------------------------------------------------
// Datalog navigation button
//--------------------------------------------------------------------
void CMainFrame::OnDatalog() 
{
	if( m_nMenu == menuDATALOG ) return;

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->CreateNewView( ID_DATALOG );

	// Set the view name
//	m_wndTitlePanel.m_msgViewName.SetOpMsg( "DATALOG" );

	// Layout toolbar
	m_wndCommandToolBar.LoadToolBar( IDR_DATALOG );
	m_wndCommandToolBar.LoadTrueColorToolBar( m_DatalogToolBarImage );
	RecalcLayout();
	
	m_nMenu = menuDATALOG;

	// ljy_050302 : Log
	SetLog( "EQ MODE ", 0, 0, "OnDatalog" );
}

void CMainFrame::OnUpdateDatalog(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp   = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView == NULL ) return;
	pCmdUI->SetCheck( m_nMenu == menuDATALOG );
	pCmdUI->Enable( !m_bAuto & ( pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP ) );
}

//--------------------------------------------------------------------
void CMainFrame::OnDatalogOpen() 
{
	// Get document pointer
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->m_pDatalogView->OnOpenFile();
}

//--------------------------------------------------------------------
// Setup navigation button
//--------------------------------------------------------------------
void CMainFrame::OnSetup() 
{
	if( m_nMenu == menuSETUP ) return;

	// Get document pointer
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->CreateNewView( ID_SETUP );

	// Set the view name
//	m_wndTitlePanel.m_msgViewName.SetOpMsg( "SETUP" );

	// Layout toolbar
	m_wndCommandToolBar.LoadToolBar( IDR_SETUP );
	m_wndCommandToolBar.LoadTrueColorToolBar( m_SetupToolBarImage );
	RecalcLayout();

	// ljy_041105 : Save DI status
	//m_bDiStateSave = ( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfPump.bDiStart;
	
	m_nMenu = menuSETUP;

	// ljy_050302 : Log
	SetLog( "EQ MODE ", 0, 0, "OnSetup" );
}

void CMainFrame::OnUpdateSetup(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_nMenu == menuSETUP );
}

//--------------------------------------------------------------------
void CMainFrame::OnSetupSave() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->m_pSetupView->OnSetupSave();
//	RegBackup();
}

void CMainFrame::OnUpdateSetupSave(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp   = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView == NULL ) return;
	pCmdUI->Enable( pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP );
}

//--------------------------------------------------------------------
// Alarms navigation button
//--------------------------------------------------------------------
void CMainFrame::OnAlarms() 
{
	if( m_nMenu == menuALARMS ) return;

	// Get document pointer
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->CreateNewView( ID_ALARMS );

	// Set the view name
//	m_wndTitlePanel.m_msgViewName.SetOpMsg( "ALARMS" );

	// Layout toolbar
	m_wndCommandToolBar.LoadToolBar( IDR_ALARMS );
	m_wndCommandToolBar.LoadTrueColorToolBar( m_AlarmToolBarImage );
	RecalcLayout();

	// ljy_041105 : Save DI status
	//m_bDiStateSave = ( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfPump.bDiStart;
	
	m_nMenu = menuALARMS;

	// ljy_050302 : Log
	SetLog( "EQ MODE ", 0, 0, "OnAlarms" );
}

void CMainFrame::OnUpdateAlarms(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_nMenu == menuALARMS );
}

//--------------------------------------------------------------------
void CMainFrame::OnAlarmsSave() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	
	int tab = pDoc->m_pAlarmsView->m_nSelectedTab;
	
	if( tab == 0 ) pDoc->m_pAlarmsView->m_pTabAlarmsTab1View->OnSaveFile();
	if( tab == 2 ) pDoc->m_pAlarmsView->m_pTabAlarmsTab3View->OnAlarmsListSave();
}

//--------------------------------------------------------------------
void CMainFrame::OnAlarmsDelete() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->m_pAlarmsView->m_pTabAlarmsTab1View->OnDelete();
}

void CMainFrame::OnUpdateAlarmsDelete(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp   = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView == NULL ) return;
	BOOL bEnable = ( pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idMAINT ) ? TRUE : FALSE;

	// Innolux Specific
	//pCmdUI->Enable( FALSE );
	pCmdUI->Enable( bEnable );
}

//--------------------------------------------------------------------
// Help navigation button
//--------------------------------------------------------------------
void CMainFrame::OnHelp() 
{
	return;

	if( m_nMenu == menuHELP ) return;

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->CreateNewView( ID_HELP );

	// Set the view name
//	m_wndTitlePanel.m_msgViewName.SetOpMsg( "HELP" );

	// Layout toolbar
	m_wndCommandToolBar.LoadToolBar( IDR_HELP );
	RecalcLayout();

	// ljy_041105 : Save DI status
	//m_bDiStateSave = ( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_IfPump.bDiStart;
	
	m_nMenu = menuHELP;

	// ljy_050302 : Log
	SetLog( "EQ MODE ", 0, 0, "OnHelp" );
}

void CMainFrame::OnUpdateHelp(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_nMenu == menuHELP );
}

//--------------------------------------------------------------------
// Exit navigation button
//--------------------------------------------------------------------
void CMainFrame::OnExit() 
{
//	RegBackup();
	SendMessage( WM_CLOSE, 0, 0L );
}

void CMainFrame::OnUpdateExit(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

//--------------------------------------------------------------------
// Close : Alt+F4, etc
//--------------------------------------------------------------------
void CMainFrame::OnClose() 
{
	// ljy_050414 : Exit Interlock->ڰ Engineer̻̾ OFF .
	CDicsApp* pApp = (CDicsApp *) AfxGetApp();
	CDicsView* pView = (CDicsView *) pApp->m_pMainView;

	if( AfxMessageBox( "Program EXIT : Please Confirm your Level !!", MB_YESNO | MB_ICONQUESTION ) == IDNO ) return;

	CDlgPassword dlg;
	dlg.SetDicsData( pView->m_pDicsData );

	if( dlg.DoModal() != IDOK || !dlg.m_bIdOk ) return;
	else if( pView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER ) return;

	if( AfxMessageBox( "Do you really exit the program ?", MB_YESNO | MB_ICONQUESTION ) == IDNO ) return;

		//2008.11.18 kimgun   Trace data  .
 	for( int i = 0; i < MAX_TRACE_MULTI_NO; i++)
 	pView->m_pDicsData->m_TraceData[i].bTraceDataStopReq = TRUE;
	pView->m_pIfSeq->ResetInterfaceSignalAll();

	// ljy_050302 : Log
	SetLog( "EQ MODE ", 0, 0, "OnExit" );

	BOOL bDone[MAX_RBT_NO] = { FALSE, };
	for( int i = 0 ; i < MAX_RBT_NO ; i ++ )
	{
		while( !bDone[i] )
		{
			if( !bDone[i] && pView->m_pMmc->EStopRbt( i ) )
			{
				bDone[i] = TRUE;
			}
		}
	}

	CMDIFrameWnd::OnClose();
}

// OnTimer
//--------------------------------------------------------------------
void CMainFrame::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	ToggleDisplayAlarmButton();
	CMDIFrameWnd::OnTimer(nIDEvent);
}

//--------------------------------------------------------------------
// OnTimer
//--------------------------------------------------------------------
void CMainFrame::ToggleDisplayAlarmButton()
{
	static BOOL bAlarm = FALSE, bToggle = FALSE;

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	if( (CDicsView*) pApp->m_pMainView == NULL ) return;
	

//	if( m_pCimData->m_arAlarmListSave.GetSize() != 0 && !bAlarm )
	if( 1 && !bAlarm )
	{
		bAlarm = TRUE;
		bToggle = TRUE;
	}
//	else if( m_pCimData->m_arAlarmListSave.GetSize() == 0 && bAlarm )
	{
		bAlarm = FALSE;
		bToggle = FALSE;
	}

	if( bToggle && bAlarm )
	{
		bToggle = FALSE;
		m_wndToolBar.SetButtonInfo( 50, ID_ALARMS, TBBS_BUTTON, 10 ); // Red
	}
	else if( !bToggle ) 
	{
		bToggle = TRUE;
		m_wndToolBar.SetButtonInfo( 50, ID_ALARMS, TBBS_BUTTON, 8 );
	}
}

//--------------------------------------------------------------------
// OnRecovery
//--------------------------------------------------------------------
void CMainFrame::OnRecovery() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsData* pData = ( (CDicsView*) pApp->m_pMainView )->m_pDicsData;

	// ljy_050103 : Servo Tool Bar Recovery BTN
	if( pData->m_EqpInfo.cOpMode == CDicsData::opRECOVERY ) return;
	if( AfxMessageBox( "Do you really want to change Recovery Mode ?", MB_YESNO ) == IDNO ) return;

	// Set message
//	m_wndTitlePanel.m_msgMessage.SetOpMsg( (LPCTSTR) "Recovery" );
	AddTitleMessage( (LPCTSTR) "Recovery" );
	// ljy_050103 : End

	pData->m_EqpInfo.cOpMode = CDicsData::opRECOVERY;
	
	// ljy_050302 : Log
	SetLog( "EQ MODE ", 0, 0, "OnRecovery" );
}

//--------------------------------------------------------------------
// OnUpdateRecovery
//--------------------------------------------------------------------
void CMainFrame::OnUpdateRecovery(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	if ( pView == NULL ) return;
	CDicsData* pData = ( (CDicsView*) pApp->m_pMainView )->m_pDicsData;

	BOOL bDisable = pData->m_GenInfo.bEqpInitComp;
	
	pCmdUI->Enable( bDisable );	

	pCmdUI->SetCheck( pData->m_EqpInfo.cOpMode == CDicsData::opRECOVERY );
}

// ljy_050220 : CMainFrame -> 04HC30   Ϸ(1).

void CMainFrame::SetLog(CString sSeqName, int nPortNo, int nSlotNo, CString sMessage)
{
	CDicsApp* pApp = ( CDicsApp * )AfxGetApp();
	CDicsView* pView = ( CDicsView * )pApp->m_pMainView;

	// Log
	CString sLog;
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	sLog.Format( "BTN     \t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( sLog );

	if( pView->m_pDicsData->m_GenInfo.bEnableEqpLog )
	{
		sLog.Format( "%s : %s", sSeqName, sMessage );
		pView->m_pMainSeq->Msg( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) sLog );
	}
}

void CMainFrame::AddTitleMessage(CString sMessage)
{
	COleDateTime tm = COleDateTime::GetCurrentTime();
	CString sDateTime = tm.Format(_T("%Y/%m/%d %H:%M:%S"));
	sMessage = sDateTime + " " + sMessage;
	if( m_wndTitlePanel.m_cbMessage.GetCount() >= 30 ) m_wndTitlePanel.m_cbMessage.DeleteString( 0 );
	int i = m_wndTitlePanel.m_cbMessage.AddString( (LPCTSTR) sMessage );
	m_wndTitlePanel.m_cbMessage.SetCurSel( i );
}


void CMainFrame::RegBackup()
{
    CString sBuf, sFileName, sRegistryName, sAppName;
 
     sAppName.LoadString( AFX_IDS_APP_TITLE );
     CreateDirectory( "Backup", NULL );
#ifndef _MY_DEBUG 
	 sFileName.Format( "Backup\\Recovery.reg" );
#else
	 sFileName.Format( "Backup\\Recovery_Debug.reg" );
#endif
     sRegistryName.Format( "\"HKEY_CURRENT_USER\\SOFTWARE\\Local AppWizard-Generated Applications\\%s", sAppName );

     sBuf.Format( "regedit /e %s %s", sFileName, sRegistryName );
     WinExec( sBuf, SW_SHOW );
}

void CMainFrame::OnRecipesAdd() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->m_pRecipesView->OnRecipesAdd();
}

void CMainFrame::OnUpdateRecipesAdd(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp   = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();

	if( pView == NULL ) return;
	pCmdUI->Enable( (pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idMAINT) && (pDoc->m_pRecipesView->m_nViewNo == 1) );
}
void CMainFrame::OnRecipesDelete() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();
	pDoc->m_pRecipesView->OnRecipesDelete();
}

void CMainFrame::OnUpdateRecipesDelete(CCmdUI* pCmdUI) 
{
	CDicsApp* pApp   = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	CDicsDoc* pDoc = ( (CDicsView*) pApp->m_pMainView )->GetDocument();

	if( pView == NULL ) return;
	pCmdUI->Enable( (pView->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idMAINT) && (pDoc->m_pRecipesView->m_nViewNo == 1) );
}
