// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__5A4CDDC9_B684_47C8_8B79_AC6C393E807B__INCLUDED_)
#define AFX_MAINFRM_H__5A4CDDC9_B684_47C8_8B79_AC6C393E807B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TitlePanel.h"
#include "TrueColorToolBar.h"	// Added by ClassView

#include "X\XCtlMelsec.h"		// ljy_050128 : add
#include "FactoryLib\IniData.h"	// Added by ClassView

class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();

// Attributes
public:
	TOOLBARIMAGE* m_JobsToolBarImage;
	TOOLBARIMAGE* m_JobsCimToolBarImage;
	TOOLBARIMAGE* m_JobsLoaderToolBarImage;
	TOOLBARIMAGE* m_MaintToolBarImage;
	TOOLBARIMAGE* m_SystemToolBarImage;
	TOOLBARIMAGE* m_ServoToolBarImage;		// ljy_050411 : Servo Tool Bar Recovery BTN -> No Use
	TOOLBARIMAGE* m_RecipeToolBarImage;
	TOOLBARIMAGE* m_SetupToolBarImage;
	TOOLBARIMAGE* m_DatalogToolBarImage;
	TOOLBARIMAGE* m_AlarmToolBarImage;

	XCtlDevice*	m_pDevice;		// ljy_041120
	XCtlMelsec*	m_pMelsec;

	BOOL	m_bCycleStop;
	BOOL	m_bAuto;
	int		m_nMenu;
//	int		m_nAutoRbtPos[MAX_RBT_NO - 3];

	CString	m_sMessage;		// ljy_050302 : add
	
	CIniData m_IniConfiguration;

	void ToggleDisplayAlarmButton();
	void AddTitleMessage(CString sMessage);
	void RegBackup();
	CBitmap m_bmpCmdToolBar;

	// Define the enum
	enum tagMENU { menuAuto,menuJOBS, menuMAINT, menuSYSTEM, 
				   menuSERVO, menuRECIPES, menuSETUP, menuDATALOG,
				   menuALARMS, menuHELP };


// Operations
public:
	BOOL LoadFrame( UINT nIDResource,
			DWORD dwDefaultStyle = WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE,
			CWnd* pParentWnd = NULL, CCreateContext* pContext = NULL );
	BOOL CMainFrame::OnCreateClient( LPCREATESTRUCT lpcs, CCreateContext* /*pContext*/ );

	void SetMelsec( XCtlMelsec * pMelsec ){ m_pMelsec = pMelsec; }

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:  // control bar embedded members
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );
	BOOL					m_bDiStateSave;			// for maint mode Di Stop and restore.

	//---------------------------------------------------------------------------------------------
	// ljy_050128 : for maint Loader I/F Signal off and restore.
	// 0 -> MC Status					1 -> Substrate on the stage
	// 2 -> Stage Access possible		3 -> Pre Load Request
	// 4 -> Pre UnLoad Request
	BOOL					m_bLoaderIFSave[MAX_LOADER_IF_NO];
	//---------------------------------------------------------------------------------------------

	CStatusBar				m_wndStatusBar;
	CTrueColorToolBar		m_wndToolBar;
	CTrueColorToolBar		m_wndCommandToolBar;

	CTitlePanel	m_wndTitlePanel;

	void SetDevice(XCtlDevice* pDevice) { m_pDevice = pDevice; }		// ljy_041123


// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMove(int x, int y);
	afx_msg void OnDestroy();
	afx_msg void OnJobs();
	afx_msg void OnUpdateJobs(CCmdUI* pCmdUI);
	afx_msg void OnAuto();
	afx_msg void OnUpdateAuto(CCmdUI* pCmdUI);
	afx_msg void OnMaint();
	afx_msg void OnUpdateMaint(CCmdUI* pCmdUI);
	afx_msg void OnSystem();
	afx_msg void OnUpdateSystem(CCmdUI* pCmdUI);
	afx_msg void OnServo();
	afx_msg void OnUpdateServo(CCmdUI* pCmdUI);
	afx_msg void OnRecipes();
	afx_msg void OnUpdateRecipes(CCmdUI* pCmdUI);
	afx_msg void OnDatalog();
	afx_msg void OnUpdateDatalog(CCmdUI* pCmdUI);
	afx_msg void OnSetup();
	afx_msg void OnUpdateSetup(CCmdUI* pCmdUI);
	afx_msg void OnAlarms();
	afx_msg void OnUpdateAlarms(CCmdUI* pCmdUI);
	afx_msg void OnHelp();
	afx_msg void OnUpdateHelp(CCmdUI* pCmdUI);
	afx_msg void OnJobsInit();
	afx_msg void OnJobsCycleStop();
	afx_msg void OnJobsCycleStart();
	afx_msg void OnMaintDiRun();
	afx_msg void OnMaintDiStop();
	afx_msg void OnMaintCleaningRun();
	afx_msg void OnMaintCleaningStop();
	afx_msg void OnRecipesSelect();
	afx_msg void OnRecipesCopy();
	afx_msg void OnRecipesSave();
	afx_msg void OnDatalogOpen();
	afx_msg void OnSetupSave();
	afx_msg void OnAlarmsSave();
	afx_msg void OnAlarmsDelete();
	afx_msg void OnExit();
	afx_msg void OnUpdateExit(CCmdUI* pCmdUI);
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSystemReverse();
	afx_msg void OnUpdateSystemReverse(CCmdUI* pCmdUI);
	afx_msg void OnSystemSave();
	afx_msg void OnUpdateRecipesCopy(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRecipesSelect(CCmdUI* pCmdUI);
	afx_msg void OnUpdateJobsInit(CCmdUI* pCmdUI);
	afx_msg void OnJobsControl();
	afx_msg void OnUpdateJobsControl(CCmdUI* pCmdUI);
	afx_msg void OnJobsMonitor();
	afx_msg void OnUpdateJobsMonitor(CCmdUI* pCmdUI);
	afx_msg void OnJobsOffline();
	afx_msg void OnUpdateJobsOffline(CCmdUI* pCmdUI);
	afx_msg void OnJobsLoaderInit();
	afx_msg void OnUpdateJobsLoaderInit(CCmdUI* pCmdUI);
	afx_msg void OnJobsLoopback();
	afx_msg void OnUpdateJobsCycleStop(CCmdUI* pCmdUI);
	afx_msg void OnUpdateJobsCycleStart(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMaintDiRun(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMaintDiStop(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMaintCleaningRun(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMaintCleaningStop(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRecipesSave(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSetupSave(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAlarmsDelete(CCmdUI* pCmdUI);
	afx_msg void OnJobsMainOnline();
	afx_msg void OnUpdateJobsMainOnline(CCmdUI* pCmdUI);
	afx_msg void OnJobsMainOffline();
	afx_msg void OnUpdateJobsMainOffline(CCmdUI* pCmdUI);
	afx_msg void OnRecovery();
	afx_msg void OnUpdateRecovery(CCmdUI* pCmdUI);
	afx_msg void OnJobsPause();
	afx_msg void OnUpdateJobsPause(CCmdUI* pCmdUI);
	afx_msg void OnJobsIfReset();
	afx_msg void OnUpdateJobsIfReset(CCmdUI* pCmdUI);
	afx_msg void OnRecipesAdd();
	afx_msg void OnRecipesDelete();
	afx_msg void OnUpdateRecipesAdd(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRecipesDelete(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnSystemRepeat();
	afx_msg void OnUpdateSystemRepeat(CCmdUI *pCmdUI);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__5A4CDDC9_B684_47C8_8B79_AC6C393E807B__INCLUDED_)
