// DicsCimSeq.h: interface for the CDicsCimSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CIMSEQUENCE_H__6E2FDD36_ED82_4AD3_9D3B_324BCAD43B19__INCLUDED_)
#define AFX_CIMSEQUENCE_H__6E2FDD36_ED82_4AD3_9D3B_324BCAD43B19__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
//////////////////////////////////////////////////////////////////////
// Header File  Sequence->Data->X File ...
//   BOOL -> int -> float -> double -> WORD -> DWORD -> Char -> CString -> enum
// ٸ      ִ.. 
//////////////////////////////////////////////////////////////////////

#include "X\XSequence.h"
#include "X\XTimer.h"
#include "X\XLog.h"
#include "EqpStateSequence.h"
#include "DicsData.h"
#ifdef _CIM_SKIP
#include "FileMap.h"
#endif
#include "..\FactoryLib\EqpAssy.h"

class CDicsCimSeq : public XSequence  
{
public:

public:
	virtual void InitParameter();
	virtual BOOL Sequence();
	virtual BOOL Initialize();

	CDicsCimSeq();
	virtual ~CDicsCimSeq();

	CString			m_sMessage;
	CString			m_sSeqName;
	CString			m_sLog;

	// Pointer variables
public:	
	CSetupItems*		m_pSetupItems;
	XCtlDevice*			m_pDevice;
	XTimer*				m_pTimer;
	CDicsData*			m_pDicsData;
	CEqpStateSequence*	m_pEqpStateSeq;
	XCtlMelsec *		m_pMelsec;
	CAnalogInput1*		m_pAI1;
	CEqpAssy*			m_pEqpAssy;

#ifdef _CIM_SKIP
	CFileMap*			m_pFileMap;
	void SetFileMap(CFileMap* pFileMap)							{ m_pFileMap = pFileMap; }
#endif
	// Pointer Set Function
public:
	void SetTimer(XTimer* pTimer)								{ m_pTimer		= pTimer; }
	void SetData(CDicsData* pData)								{ m_pDicsData	= pData; }
	void SetEqpStateSequence(CEqpStateSequence* pEqpStateSeq)	{ m_pEqpStateSeq= pEqpStateSeq; }
	void SetSetupItems( CSetupItems* pSetupItems )				{ m_pSetupItems = pSetupItems; }
	void SetMelsec( XCtlMelsec * pMelsec )						{ m_pMelsec		= pMelsec; }
	void SetDevice(XCtlDevice* pDevice)							{ m_pDevice	= pDevice; }
	void SetEqpAssy( CEqpAssy* pEqpAssy )						{ m_pEqpAssy = pEqpAssy; }

public:
	void SetOwnerPointer(CWnd* pWnd);
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );
};

#endif // !defined(AFX_CIMSEQUENCE_H__6E2FDD36_ED82_4AD3_9D3B_324BCAD43B19__INCLUDED_)
