// DicsCommonInterlockSeq.h: interface for the CDicsCommonInterlockSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMMONINTERLOCKSEQUENCE_H__DC5E647A_4652_4E90_8FEB_087E6C8614EC__INCLUDED_)
#define AFX_COMMONINTERLOCKSEQUENCE_H__DC5E647A_4652_4E90_8FEB_087E6C8614EC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\X\XCtlDevice.h"
#include "..\X\XSequence.h"
#include "..\X\XTimer.h"
#include "..\X\XMmc.h"
#include "..\X\xctlmelsec.h"
#include "..\GlassAni.h"
#include "..\View\SetupItems.h"
#include "..\DicsData.h"
#include "..\Sequence\EqpStateSequence.h"
#include "..\FactoryLib\IniData.h"	// Added by ClassView
#include "..\FactoryLib\EqpAssy.h"


class CDicsCommonInterlockSeq : public XSequence  
{
protected:
	CDicsView*			m_pDicsView;
	CDicsData*			m_pDicsData;
	XCtlDevice*			m_pDevice;
	CSetupItems*		m_pSetupItems;
	CEqpStateSequence*	m_pEqpStateSeq;
	XMmc*				m_pMmc;
	XTimer*				m_pTimer;
	CEqpAssy*			m_pEqpAssy;
	CIniData			m_IniSetUpInfo;

public:
	int					m_nSeqEmoNo;
	int					m_nSeqLeakSensorNo;
	int					m_nSeqCoverSensorNo;
	int					m_nSeqDoorSensorNo;
	int					m_nSeqIonizerCondNo;
	int					m_nSeqFfuCondNo;
	int					m_nSeqPartsCondNo[MAX_PARTS_NO];
	int					m_nSeqPartsUseTimeNo[MAX_PARTS_NO];


	CString				m_sSeqName;
	CString				m_sMessage;

	struct tagInterlock
	{
		BOOL bCvMotorCond[MAX_CV_MOTOR_NO];			// Cv FBL Motor Condition
	} m_Interlock;

	struct tagParts 
	{
		BOOL bPartsCond;
		int nUsedTime;
		int nGlsCount;
	} m_PartsData[MAX_PARTS_NO];

public:
	CDicsCommonInterlockSeq();
	virtual ~CDicsCommonInterlockSeq();
	void SetOwnerPointer(CWnd* pWnd);

	BOOL Initialize();
	virtual void InitParameter();
	BOOL Sequence();
	BOOL GetCvCond( int nUnitNo );
	BOOL GetPartsCond( int nPartsNo );
	virtual BOOL GetPartsCheckCond( int nPartsNo );
	int GetPartsUsedTime( int nPartsNo );
	int GetPartsGlsCount( int nPartsNo );
	void ResetPartsData( int nPartsNo );
	void PartsGlsCountIncrease( int nPartsNo );
	void PartsUsedTimeIncrease( int nPartsNo );
private:
	void SetDevice( XCtlDevice* pDevice )						{ m_pDevice = pDevice; }
	void SetSeqTimer( XTimer* pTimer )							{ m_pTimer = pTimer; }
	void SetDicsView( CDicsView *pView )						{ m_pDicsView = pView;	}
	void SetDicsData( CDicsData* pDicsData )					{ m_pDicsData = pDicsData; }
	void SetSetupItems( CSetupItems* pSetupItems )				{ m_pSetupItems = pSetupItems; }
	void SetEqpStateSequence(CEqpStateSequence* pEqpStateSeq)	{ m_pEqpStateSeq = pEqpStateSeq; }
	void SetMmc( XMmc* pMmc )									{ m_pMmc = pMmc; }
	void SetEqpAssy( CEqpAssy* pEqpAssy )						{ m_pEqpAssy = pEqpAssy; }

protected:
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );

	void SeqEMO();
	void SeqLeakSensor();
	void SeqCoverSensor();
	void SeqDoorSensor();
	void SeqCvMotorCondition();
	void SeqIonizerCondition();
	void SeqFfuCondition();
	void SeqPartsUseTime( int nPartsNo );
	void SeqPartsCondition( int nPartsNo );
};

#endif // !defined(AFX_COMMONINTERLOCKSEQUENCE_H__DC5E647A_4652_4E90_8FEB_087E6C8614EC__INCLUDED_)
