 // DicsCvSeq.cpp: implementation of the CDicsCvSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "DicsCvSeq.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDicsCvSeq::CDicsCvSeq()
{
	m_SeqFlag.bInitReq	= FALSE;
	m_SeqFlag.bInitComp = FALSE;
	m_SeqFlag.bInitFail	= FALSE;
}

CDicsCvSeq::~CDicsCvSeq()
{
}

BOOL CDicsCvSeq::Initialize()
{
	m_nSeqInitNo = 0;
	InitParameter();
	return TRUE;
}

void CDicsCvSeq::InitParameter()
{
///////////////////////////////////////////////////////////////////////////////
// Init : Member
///////////////////////////////////////////////////////////////////////////////
	for( int i = 0 ; i < MAX_UNIT_NO ; i ++ )
	{
		m_nSeqInSensorNo[i]				= 0;
		m_nSeqOutSensorNo[i]			= 0;
		m_nSeqInSensorSickAlarmNo[i]	= 0;
		m_nSeqOutSensorSickAlarmNo[i]	= 0;
	}

	m_nStopCountAll		= 0;
	m_nStopCount		= 0;
	m_nSeqAkManualCheckNo = 0;
	m_bAkManualAlarm	= FALSE;
	
///////////////////////////////////////////////////////////////////////////////
// Init : IfFlag
///////////////////////////////////////////////////////////////////////////////
	for( int i = 0 ; i < MAX_CV_NO ; i ++ )
	{
		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bInReady				= FALSE;
		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bOutReady				= FALSE;
		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bInComp				= FALSE;
		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bOutComp				= FALSE;
		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bWaitPos				= FALSE;
		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bInError				= FALSE;
		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bOutError				= FALSE;
		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bSeqStop				= FALSE;
		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bInSick				= FALSE; 
		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bOutSick				= FALSE; 
		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bSubInSick			= FALSE; 
		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bSubOutSick			= FALSE; 

		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bInLogicCheckIgnore	= TRUE;
		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bOutLogicCheckIgnore	= TRUE;

		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bCvBwReq				= FALSE;

		// In & Out Complete flag is TRUE for CV Unit
		// LD Unit InSensor 
		m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bOutComp = TRUE;
		if( (i+IF_UNIT_LD)  != IF_UNIT_LD )
		{
			m_pDicsData->m_IfFlag[i + IF_UNIT_LD].bInComp = TRUE;
		}
	}
	
///////////////////////////////////////////////////////////////////////////////		
// Init : SeqFlag
///////////////////////////////////////////////////////////////////////////////
	for( int i = 0 ; i < MAX_CV_NO ; i ++ )
	{
		m_pDicsData->m_SeqFlag.bCvStop[i + IF_UNIT_LD] = FALSE;

		for( int j=0; j<MAX_STOP_COUNT_NO; j++ )
		{
			m_pDicsData->m_SeqFlag.nRollerState[j][i + IF_UNIT_LD]		= cvSTOP;
			m_pDicsData->m_SeqFlag.nRollerStateAll[j][i + IF_UNIT_LD]	= cvSTOP;
			m_pDicsData->m_SeqFlag.bSeqStopState[j][i + IF_UNIT_LD]		= FALSE;
		}			
	}

	m_pDicsData->m_SeqFlag.bStopCount1		= FALSE;
	m_pDicsData->m_SeqFlag.bStopCount2		= FALSE;
	m_pDicsData->m_SeqFlag.bGlassOutComp1	= TRUE;
	m_pDicsData->m_SeqFlag.bGlassOutComp2	= TRUE;

///////////////////////////////////////////////////////////////////////////////		
// Init : Debug Mode
///////////////////////////////////////////////////////////////////////////////		
#ifdef _MY_DEBUG
	for( int i = 0 ; i < MAX_CV_NO ; i ++ )
	{
		m_pDicsData->m_bDebugInSensor[i + IF_UNIT_LD] = FALSE;
		m_pDicsData->m_bDebugOutSensor[i + IF_UNIT_LD] = FALSE;
	}
#endif


	for( int i = 0 ; i < MAX_CV_NO ; i ++ )
	{
		m_CvMotor.nCvAuto[i]	= cvSTOP;
		m_CvMotor.nSpeedAuto[i] = 0;
	}
	for( int i = 0 ; i < MAX_CV_MOTOR_NO ; i ++ )
	{
		m_CvMotor.nCvManual[i]		= cvSTOP;
		m_CvMotor.nSpeedManual[i]	= 0 ;
	}

}

BOOL CDicsCvSeq::Sequence()
{
	Sleep( 10 );

	return TRUE;
}


//---------------------------------------------------------------------------
// Set the Log
//---------------------------------------------------------------------------
void CDicsCvSeq::SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage )
{
	// Log
	CString sLog;
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	sLog.Format( "CV\t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( sLog );

	if( m_pDicsData->m_GenInfo.bEnableEqpLog )
	{
		sLog.Format( "%s : %s", sSeqName, sMessage );
		Msg( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) sLog );
	}
}

//---------------------------------------------------------------------------
// CheckUnitCondition
//---------------------------------------------------------------------------
// Check CvMotor, Gauge, ProcessCondition, etc... for Run DicsCvSeq
// int nSensorType means :: InSensor or OutSensor( 0 or 1 )
//---------------------------------------------------------------------------
BOOL CDicsCvSeq::CheckUnitCondition( int nSensorType, int nUnitNo )
{
	BOOL bOk = TRUE;
	int nIndex = nUnitNo-IF_UNIT_LD+nSensorType;

	if( nIndex == MAX_CV_NO ) return bOk;

	bOk &= m_pDicsView->m_pCommonIntrSeq->GetCvCond( nIndex );
	bOk &= m_pDicsView->m_pGaugeIntrSeq->GetGaugeCond( nIndex );

	switch ( nUnitNo )
	{
	case IF_UNIT_LD:
		break;
//#ifndef _NO_RB
	case (IF_UNIT_SWR1):
		bOk &= m_pDicsView->m_pRbSeq->GetRbCond();
		break;
//#endif
	default :
		break;
	}
	
	return bOk;
}

void CDicsCvSeq::SeqInSensor(int nSensorNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	// return if not initialized
	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	int nSeqNo = m_nSeqInSensorNo[nSensorNo];
	static int nReturnSeqNo[MAX_UNIT_NO]		  = { 0, };
	static DWORD dwTickStart[MAX_UNIT_NO];
	
	int tm1 = TM_IN_SENSOR_ON( nSensorNo );
	int tm2 = TM_IN_SENSOR_OFF( nSensorNo );
	int tm3 = TM_IN_SENSOR_IN2OUT( nSensorNo );
		
	static int nTime1[MAX_UNIT_NO];
	static int nTime2[MAX_UNIT_NO];
	static int nTime3[MAX_UNIT_NO];
	static BOOL bTm3Warning[MAX_UNIT_NO];
	
	static int nPortNo[MAX_UNIT_NO] = { 0, };
	static int nSlotNo[MAX_UNIT_NO] = { 0, };
	static int nGlassNo[MAX_UNIT_NO] = { 0, };
	static int nAlarmId[MAX_UNIT_NO] = { 0, };

	TimerControl( ssIN, nSensorNo );

	if( !GetSeqRunCond( nSensorNo ) )	return;

	switch( nSeqNo )
	{
	case 0 :
		{
			if( nAlarmId[nSensorNo] > 0 )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId[nSensorNo] );
				nAlarmId[nSensorNo] = 0;
			}
			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid;
	
			if( bIsValid )
			{  // When there is glass data.
				m_pDicsData->m_IfFlag[nSensorNo].bInComp		= FALSE;
				m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady	= TRUE;
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugInSensor[nSensorNo]		= TRUE;
				m_pDicsData->m_bDebugOutSensor[nSensorNo - 1]	= TRUE;
				m_nSeqOutSensorNo[nSensorNo - 1] = 0;
#endif
				nSeqNo = 1;
			}
			else
			{	// NO Glass Data, but Glass Sensing
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) ) 
#else
				if( m_pDicsData->m_bDebugInSensor[nSensorNo] ) 
#endif
				{ 
					m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE; 
					nSeqNo = 500;
				}
				else
				{
					nSeqNo = 1; 
				}
			}
		}
		break;
	case 1 :
		//-----------------------------------------------------------------------------------------
		// 1. bOutReady : Program ׾   Sensor Ǿ  ̰ TRUE Ǵµ
		//    => ׷ ʵ? => ׷  History   True Ѵ.
		// 2. bOutError : Error   Glass  Դ  ϰ Ҽ ִµ ̶
		//    Sensor Ǵ ͵ ϰ Ѵ.
		//    =>  : Error ߻ϸ   C/V  Sequence θ ʴµ,  Error
		//       ߻ C/V   C/V  Ѵ.
		//-----------------------------------------------------------------------------------------
#ifndef _MY_DEBUG
		if( m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady && 
			!m_pDicsData->m_IfFlag[nSensorNo - 1].bOutError &&
			m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) )
#else
		if( m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady && 
			!m_pDicsData->m_IfFlag[nSensorNo - 1].bOutError &&
			m_pDicsData->m_bDebugInSensor[nSensorNo] )
#endif
		{
			// Flag Reset
			m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady = FALSE;

			// Glass Data Move
			GlassDataMove( ( nSensorNo - 1 )*2 + 1, nSensorNo*2 + 0, &nSlotNo[nSensorNo], &nPortNo[nSensorNo] );
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "In Sensor is ON" );

			// glass move
			nGlassNo[nSensorNo] = m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].nGlassNo;
			m_pGlassAni->SetGlassMoveSpeed( nGlassNo[nSensorNo], m_pDicsData->m_JobCond.nCvSpeed / 60 );
			m_pGlassAni->GlassMove( nGlassNo[nSensorNo], nSensorNo*2 + 1 );

			GetTimeOut( nSensorNo, 0, &nTime1[nSensorNo], &nTime2[nSensorNo], &nTime3[nSensorNo] );
			TIMER_ON( tm1, nTime1[nSensorNo] );
			TIMER_ON( tm2, nTime2[nSensorNo] );
			TIMER_ON( tm3, nTime3[nSensorNo] );

			bTm3Warning[nSensorNo] = FALSE;
			
			// Current C/V Turn On
			int nCvSpeed = m_pDicsData->m_JobCond.nCvSpeedSet[nSensorNo - IF_UNIT_LD][CJobCond::speedNORMAL];
			//Speed  
			m_pEqpAssy->m_CvMotor.SetMotorSpeed( nSensorNo - IF_UNIT_LD, nCvSpeed );

			// Previous C/V Turn On
			// (Prev.Unit OutSensor ~ Cur.Unit InSensor) > GlassSize 

			int nPrevSensorNo = nSensorNo - 1;
			if( !m_pDicsData->m_IfFlag[nPrevSensorNo].bOutComp  )
			{
				int nCvSpeed = m_pDicsData->m_JobCond.nCvSpeedSet[nPrevSensorNo - IF_UNIT_LD][CJobCond::speedNORMAL];
				//Speed  
				m_pEqpAssy->m_CvMotor.SetMotorSpeed( nPrevSensorNo - IF_UNIT_LD, nCvSpeed );
			}
	
			if( !m_pDicsData->m_IfCim.bAllGlsPosDataIng )  
				m_pDicsData->m_IfCim.bAllGlsPosDataReq = TRUE;

			nSeqNo = 10;
		}
		break;
	
	case 10:
		//-----------------------------------------------------------------------------------------
		// Check the out complete (Whether Out Sensor is Off or not)
		//-----------------------------------------------------------------------------------------
		if( m_pDicsData->m_IfFlag[nSensorNo].bOutComp )
		{
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Out Complete OK" );
			nSeqNo = 20;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm3 ) )
#else 
		else if( FALSE )
#endif
		{
			m_pDicsData->m_IfFlag[nSensorNo].bInLogicCheckIgnore = TRUE;
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Out Complete NG" );
			nSeqNo = 20;
		}
		break;

	case 20:
		//-----------------------------------------------------------------------------------------
		// ׸ Out Sensor Ǹ شϴ Glass  ¥ Ǵ ̴.
		//-----------------------------------------------------------------------------------------
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) && !bTm3Warning[nSensorNo] ) // tm3 Glass Ǵ 
#else
	   if( 0 ) // tm3 Glass Ǵ 
#endif
		{
			// Flag Reset
			m_pDicsData->m_IfFlag[nSensorNo].bOutComp = FALSE;
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Next Sensor NG(1st)" );
		
			dwTickStart[nSensorNo] = GetTickCount();
			nSeqNo = 25;
		}	
#ifndef _MY_DEBUG
		else if( m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) && 
			( TIMER( tm3 ) || m_pDicsData->m_IfFlag[nSensorNo].bInLogicCheckIgnore ) )
#else
		if( TIMER( tm1 ) )
#endif
		{
#ifdef _MY_DEBUG
			m_pDicsData->m_bDebugOutSensor[nSensorNo] = TRUE;
#endif
			// Flag Reset
			m_pDicsData->m_IfFlag[nSensorNo].bOutComp			= FALSE;
			// Flag Set
			m_pDicsData->m_IfFlag[nSensorNo].bInReady			= TRUE;
			m_pDicsData->m_IfFlag[nSensorNo].bInLogicCheckIgnore = FALSE;
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Out Sensor is ON (Next Sensor)" );
			// glass move
			m_pGlassAni->GlassMoveRegion( nGlassNo[nSensorNo], nSensorNo*2 + 1 );
			// C/V Restart for previous alarm
			if( m_pDicsData->m_IfFlag[nSensorNo].bInError ) 
			{
				m_pDicsData->m_IfFlag[nSensorNo].bInError     = FALSE;
				m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
			}
			nSeqNo = 30;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm1 ) )	// Sensor On Timeout Error
#else
		else if( FALSE )
#endif
		{
			// C/V Stop
			//  Down 
			nAlarmId[nSensorNo] = ALM_SENSOR_OUT_ON_TIMEOUT1 + nSensorNo - IF_UNIT_LD;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Out Sensor ON Timeout Error" );
			
			// Flag Set
			m_pDicsData->m_IfFlag[nSensorNo].bInError	  = TRUE;
			
			nReturnSeqNo[nSensorNo] = nSeqNo;
			nSeqNo = 1000;

		}
		else if( !CheckUnitCondition( ssIN, nSensorNo ) ) 
		{
			// C/V Stop
			m_pDicsData->m_IfFlag[nSensorNo].bInError	  = TRUE;

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Unit Condition : NG" );
			
			nReturnSeqNo[nSensorNo] = nSeqNo;
			nSeqNo = 3000;
		}
		break;

	case 25:
		if( GetTickCount() - dwTickStart[nSensorNo] > 500 )
		{
			if( m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) && !bTm3Warning[nSensorNo] )
			{

				if( m_pEqpAssy->m_GlassExistUnitOut.Get( nSensorNo, 0 ) )
				{
					m_pDicsData->m_IfFlag[nSensorNo].bOutSick	= TRUE;
				}
				else if( m_pEqpAssy->m_GlassExistUnitOut.Get( nSensorNo, 1 ) )
				{
					m_pDicsData->m_IfFlag[nSensorNo].bSubOutSick	= TRUE;
				}
				bTm3Warning[nSensorNo]			= TRUE;
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Next Sensor NG(2nd)" );
				nSeqNo=20;
			}
			else
			{
				nSeqNo=20;
			}

		}
		else if( !m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) )
		{
			nSeqNo=20;
		}
		break;

	case 30:
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) )
#else
		if( TIMER( tm2 ) )
#endif
		{
			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "In Sensor is OFF(1st)" );

			// C/V Restart for previous alarm
			if( m_pDicsData->m_IfFlag[nSensorNo].bInError ) 
			{
				 m_pDicsData->m_IfFlag[nSensorNo].bInError     = FALSE;
				 m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
			}

			dwTickStart[nSensorNo] = GetTickCount();
			nSeqNo = 40;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm2 ) )	// Sensor Off Timeout Error
#else
		else if( FALSE )
#endif
		{
			if( m_pSetupItems->m_nValueOutSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 1 )
			{
				// Set Alarm
				nAlarmId[nSensorNo] = ALM_SENSOR_IN_OFF_TIMEOUT1 + nSensorNo - IF_UNIT_LD;
				m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );

				// Log
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "In Sensor OFF Timeout Error" );

				// Flag Set
				m_pDicsData->m_IfFlag[nSensorNo].bInError = TRUE;
				nReturnSeqNo[nSensorNo] = nSeqNo;
				nSeqNo = 1000;
			}
			else
			{
				// Log
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "In Sensor OFF Timeout Skip" );
				dwTickStart[nSensorNo] = GetTickCount();
				nSeqNo = 40;
			}
		}
		break;

	case 40:
		if( GetTickCount() - dwTickStart[nSensorNo] > 1000 )	// 0.1 sec 
		{
#ifndef _MY_DEBUG
			if( !m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) || m_pSetupItems->m_nValueOutSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 0 )
#else
			if( 1 )
#endif
			{
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugInSensor[nSensorNo] = FALSE;
#endif
			
#ifndef _MY_DEBUG
				if( !m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo ) )
#else
				if( 1 )
#endif
				{
					SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "In Sensor is OFF(2nd)->End" );
				}
				else if( m_pSetupItems->m_nValueOutSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 0 )
				{
					SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "In Sensor OFF Timeout Skip(2nd->End" );
				}				
				// Flag Set
				m_pDicsData->m_IfFlag[nSensorNo].bInComp = TRUE;

				// C/V Restart for previous alarm
				if( m_pDicsData->m_IfFlag[nSensorNo].bInError ) 
				{
					m_pDicsData->m_IfFlag[nSensorNo].bInError     = FALSE;
					m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
				}
				nSeqNo = 1;
			}
			else nSeqNo = 30;
		}
		break;

	// SetSeqNo  case
	case 500 :
		{
			double dGlassSize	= GLASS_SIZE;
			double dCvSpeed		= m_pDicsData->m_JobCond.nCvSpeed / 60.0; // mm/sec
#ifndef _MY_DEBUG
			nTime2[nSensorNo]	= (int)( ( dGlassSize / dCvSpeed ) * 10 );
#else
			nTime2[nSensorNo]	= (int)( ( (dGlassSize/3.) / dCvSpeed ) * 10 );
#endif
			TIMER_ON( tm2, nTime2[nSensorNo] );

			nSeqNo = 30;
		}
		break;

	// Error ó (Timeout Error)
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId[nSensorNo] );
			nAlarmId[nSensorNo] = 0;

			// Set Timer
			TIMER_ON( tm1, nTime1[nSensorNo] );
			TIMER_ON( tm2, nTime2[nSensorNo] );

			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = TRUE;
			// C/V Restart

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Error Recovery" );
			nSeqNo = nReturnSeqNo[nSensorNo];
		}
		break;

	case 3000 :
		if( CheckUnitCondition( ssIN, nSensorNo ) )
		{
			// C/V Restart
			m_pDicsData->m_IfFlag[nSensorNo].bInError = FALSE;

//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm = FALSE;

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Re-check Unit Condition : OK" );
			nSeqNo = nReturnSeqNo[nSensorNo];
		}
		break;
	} // Switch End
	m_nSeqInSensorNo[nSensorNo] = nSeqNo;
}

void CDicsCvSeq::SeqOutSensor(int nSensorNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	int nSeqNo = m_nSeqOutSensorNo[nSensorNo];
	static int nReturnSeqNo[MAX_UNIT_NO]		  = { 0, };
	static DWORD dwTickStart[MAX_UNIT_NO];
		
	int tm1 = TM_OUT_SENSOR_ON( nSensorNo );
	int tm2 = TM_OUT_SENSOR_OFF( nSensorNo );
	int tm3 = TM_OUT_SENSOR_OUT2IN( nSensorNo );
	static int nTime1[MAX_UNIT_NO];
	static int nTime2[MAX_UNIT_NO];
	static int nTime3[MAX_UNIT_NO];
	static BOOL bTm3Warning[MAX_UNIT_NO];
	
	static int nPortNo[MAX_UNIT_NO] = { 0, };
	static int nSlotNo[MAX_UNIT_NO] = { 0, };
	static int nGlassNo[MAX_UNIT_NO] = { 0, };
	static int nAlarmId[MAX_UNIT_NO] = { 0, };
	
	
	TimerControl( ssOUT, nSensorNo );

	if( !GetSeqRunCond( nSensorNo) )	return;

	switch( nSeqNo )
	{
	case 0 :
		{
			if( nAlarmId[nSensorNo] > 0 )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId[nSensorNo] );
				nAlarmId[nSensorNo] = 0;
			}

			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid;
			if( bIsValid )
			{  // When there is glass data.
				m_pDicsData->m_IfFlag[nSensorNo].bInReady	= TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bOutComp	= FALSE;
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugOutSensor[nSensorNo]	= TRUE;
				m_pDicsData->m_bDebugInSensor[nSensorNo]	= TRUE;
				m_nSeqInSensorNo[nSensorNo] = 0;
#endif
				nSeqNo = 1;
			}
			else
			{	// NO Glass Data, but Glass Sensing
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) ) 
#else
				if( m_pDicsData->m_bDebugOutSensor[nSensorNo] ) 
#endif
				{ 
					m_pDicsData->m_IfFlag[nSensorNo].bOutComp = FALSE; 
					nSeqNo = 500;
				}
				else
				{
					nSeqNo = 1;
				}
			}
		}
		break;
	case 1 :
		//-----------------------------------------------------------------------------------------
		// 1. bInReady : Program ׾   Sensor Ǿ  ̰ TRUE Ǵµ
		//    => ׷ ʵ? => ׷  History   True Ѵ.
		// 2. bOutError : Error   Glass  Դ  ϰ Ҽ ִµ ̶
		//    Sensor Ǵ ͵ ϰ Ѵ.
		//    =>  : Error ߻ϸ   C/V  Sequence θ ʴµ,  Error
		//       ߻ C/V   C/V  Ѵ.
		//-----------------------------------------------------------------------------------------
#ifndef _MY_DEBUG
		if(  m_pDicsData->m_IfFlag[nSensorNo].bInReady && 
			!m_pDicsData->m_IfFlag[nSensorNo].bInError &&
			m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) )
#else
		if( m_pDicsData->m_IfFlag[nSensorNo].bInReady && 
			!m_pDicsData->m_IfFlag[nSensorNo].bInError &&
			m_pDicsData->m_bDebugOutSensor[nSensorNo] )
#endif
		{
			SetApdData( nSensorNo );
//			Msg( WM_APD_DATA_CHANGED, 0, 0 );
			// Flag Reset
			m_pDicsData->m_IfFlag[nSensorNo].bInReady = FALSE;
			// Glass Data Move
			GlassDataMove( nSensorNo*2 + 0, nSensorNo*2 + 1, &nSlotNo[nSensorNo], &nPortNo[nSensorNo] );
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Out Sensor is ON(2nd)" );

			// Glass Move
			nGlassNo[nSensorNo] = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nGlassNo;
			m_pGlassAni->SetGlassMoveSpeed( nGlassNo[nSensorNo], m_pDicsData->m_JobCond.nCvSpeed / 60 );
			m_pGlassAni->GlassMove( nGlassNo[nSensorNo], ( nSensorNo + 1 ) * 2 + 0 );

			GetTimeOut( nSensorNo, 1, &nTime1[nSensorNo], &nTime2[nSensorNo], &nTime3[nSensorNo] );
			TIMER_ON( tm1, nTime1[nSensorNo] );
			TIMER_ON( tm2, nTime2[nSensorNo] );
			TIMER_ON( tm3, nTime3[nSensorNo] );

			// Turn On Current C/V
			int nCvSpeed = m_pDicsData->m_JobCond.nCvSpeedSet[nSensorNo - IF_UNIT_LD][CJobCond::speedNORMAL];
			m_pEqpAssy->m_CvMotor.SetMotorSpeed( nSensorNo - IF_UNIT_LD, nCvSpeed );

			// Turn On Previous C/V
			if( nSensorNo > IF_UNIT_LD )
			{
				int nPrevSensorNo = nSensorNo - 1;
				double dPreOut2In = m_pSetupItems->m_fValueCvLength[( nPrevSensorNo - IF_UNIT_LD ) * 2 + 1 ];
				double dCurIn2Out = m_pSetupItems->m_fValueCvLength[( nSensorNo - IF_UNIT_LD ) * 2];

				if( GLASS_SIZE > ( ( dPreOut2In / 2. ) + dCurIn2Out ) )
				{
#ifndef _MY_DEBUG
					if( !m_pDicsData->m_IfFlag[nSensorNo].bInComp )
#else
					if( m_pDicsData->m_bDebugOutSensor[nPrevSensorNo] )
#endif
					{
						nCvSpeed = m_pDicsData->m_JobCond.nCvSpeedSet[nPrevSensorNo - IF_UNIT_LD][CJobCond::speedNORMAL];
						m_pEqpAssy->m_CvMotor.SetMotorSpeed( nPrevSensorNo - IF_UNIT_LD, nCvSpeed );
					}
				}
			}
			// Turn Next C/V
			// Check Next Unit Condition
// Get Glass APD Data
//			if( nSensorNo == IF_UNIT_EUV )
//				m_pDicsData->m_SeqFlag.bGlassApdCalStart = TRUE;
			bTm3Warning[nSensorNo] = FALSE;
			nSeqNo = 10;
		}
		break;

	case 10:
		// A sensor is simultaneously working as LD OUT sensor and EUV IN sensor.
//		if( nSensorNo == IF_UNIT_LD || m_pDicsData->m_IfFlag[nSensorNo + 1].bInComp )
		if( !CheckUnitCondition( ssOUT, nSensorNo ) ) 
		{
			// C/V Stop
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Unit Condition : NG" );
			
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm = TRUE;
			nReturnSeqNo[nSensorNo] = nSeqNo;
			nSeqNo = 3000;
		}
		else if( m_pDicsData->m_IfFlag[nSensorNo + 1].bInComp )
		{
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "In Complete OK" );
			nSeqNo = 15;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm3 ) )
#else 
		else if( FALSE )
#endif
		{
			m_pDicsData->m_IfFlag[nSensorNo].bOutLogicCheckIgnore	= TRUE;

			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "In Complete NG" );
			nSeqNo = 15;
		}
		break;
	case 15 :
		if( CheckUnitCondition( ssOUT, nSensorNo ) )
		{	// Next C/V ̻   Ѵ.
			// for exam. : gauge interlock, broken alarm. etc...
			// Turn Next C/V
			if( nSensorNo < ( IF_UNIT_UL - 1) )
			{
				int nNextSensorNo = nSensorNo + 1;
				int nCvSpeed = m_pDicsData->m_JobCond.nCvSpeedSet[nNextSensorNo- IF_UNIT_LD][CJobCond::speedNORMAL];
//				int nSpeed	 = (int) ( CV_SPEED_2_AO( nNextSensorNo, nCvSpeed ) );
//				if( nSpeed > 0x4000 ) nSpeed = 0x4000;
//				aogCV_MOTOR_SPEED( nNextSensorNo, nSpeed );ӽ
			}

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Cv Condition : OK" );
			nSeqNo = 20;
		}
		else
		{
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
			
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Cv Condition : NG" );

//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm = TRUE;
			nReturnSeqNo[nSensorNo] = nSeqNo;
			nSeqNo = 3000;			
		}
		break;
	case 20:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo + 1 ) && !bTm3Warning[nSensorNo] )
#else
	    if( 0 )
#endif
		{
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Next Sensor NG(1st)" );
			dwTickStart[nSensorNo] = GetTickCount();
		
			nSeqNo = 25;
		}
#ifndef _MY_DEBUG
		else if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo + 1 ) && 
			( TIMER( tm3 ) || m_pDicsData->m_IfFlag[nSensorNo].bOutLogicCheckIgnore ) )
#else
		if( TIMER( tm1 ) )
#endif
		{
#ifdef _MY_DEBUG
			m_pDicsData->m_bDebugInSensor[nSensorNo + 1] = TRUE;
#endif
			// Flag Reset
			m_pDicsData->m_IfFlag[nSensorNo + 1].bInComp = FALSE;
			// Flag Set
			m_pDicsData->m_IfFlag[nSensorNo].bOutReady				= TRUE;
			m_pDicsData->m_IfFlag[nSensorNo].bOutLogicCheckIgnore	= FALSE;
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "In Sensor is ON (Next Sensor)" );
			// Glass Move
			m_pGlassAni->GlassMoveRegion( nGlassNo[nSensorNo], ( nSensorNo + 1 )*2 + 0 );

			// C/V Restart
			if( m_pDicsData->m_IfFlag[nSensorNo].bOutError ) 
			{
				m_pDicsData->m_IfFlag[nSensorNo].bOutError    = FALSE;
//				m_pDicsData->m_IfFlag[nSensorNo].bAlarm       = FALSE;
				m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
			}
			nSeqNo = 30;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm1 ) )	// Sensor On Timeout Error
#else
		else if( FALSE )
#endif
		{
			// C/V Stop
			// Set Alarm
			nAlarmId[nSensorNo] = ALM_SENSOR_IN_ON_TIMEOUT1 + nSensorNo + 1 - IF_UNIT_LD;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "In Sensor ON Timeout Error" );

			// Flag Set
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm    = TRUE;

			nReturnSeqNo[nSensorNo] = nSeqNo;
			nSeqNo = 1000;
		}
		if( !CheckUnitCondition( ssOUT, nSensorNo ) ) 
		{
			// C/V Stop
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;

			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Unit Condition : NG" );
			nReturnSeqNo[nSensorNo] = nSeqNo;
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm = TRUE;
			nSeqNo = 3000;
		}
		break;

	case 25 :
		if( GetTickCount() - dwTickStart[nSensorNo] > 500 )
		{
			if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo + 1 ) && !bTm3Warning[nSensorNo] )
			{
				bTm3Warning[nSensorNo] = TRUE;

				if( m_pEqpAssy->m_GlassExistUnitIn.Get( nSensorNo+1, 0 ) )
				{
					m_pDicsData->m_IfFlag[nSensorNo + 1].bInSick = TRUE;
				}
				else if( m_pEqpAssy->m_GlassExistUnitIn.Get( nSensorNo+1, 1 ) )
				{
					m_pDicsData->m_IfFlag[nSensorNo + 1].bSubInSick = TRUE;
				}
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "Next Sensor NG(2nd)" );
				nSeqNo=20;
			}
			else
			{
				nSeqNo=20;
			}

		}
		else if( !m_pEqpAssy->m_GlassExistUnitIn.GetOr( nSensorNo + 1 ) )
		{
			nSeqNo=20;
		}
		break;

	case 30:
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) )
#else
		if( TIMER( tm2 ) )
#endif
		{
			// Log
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Out Sensor is OFF (1st)" );
			// C/V Restart for previous alarm
			if( m_pDicsData->m_IfFlag[nSensorNo].bOutError ) 
			{
				 m_pDicsData->m_IfFlag[nSensorNo].bOutError	   = FALSE;
//				 m_pDicsData->m_IfFlag[nSensorNo].bAlarm	   = FALSE;
				 m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
			}
			dwTickStart[nSensorNo] = GetTickCount();
			nSeqNo = 40;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm2 ) )	// Sensor Off Timeout Error
#else
		else if( FALSE )
#endif
		{
			// C/V Stop
			if( m_pSetupItems->m_nValueInSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 1 )
			{
				// Set Alarm
				nAlarmId[nSensorNo] = ALM_SENSOR_OUT_OFF_TIMEOUT1 + nSensorNo - IF_UNIT_LD;
				m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );

				// Log
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Out Sensor OFF Timeout Error" );

				// Flag Set
				m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
				nReturnSeqNo[nSensorNo] = nSeqNo;
				nSeqNo = 1000;
			}
			else
			{
				// Log
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Out Sensor OFF Timeout Skip" );
				dwTickStart[nSensorNo] = GetTickCount();
				nSeqNo = 40;
			}
		}
		break;

	case 40:
		if( GetTickCount() - dwTickStart[nSensorNo] > 1000 )	// 0.1 sec 
		{
#ifndef _MY_DEBUG
			if( !m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) || m_pSetupItems->m_nValueInSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 0 )
#else
			if( 1 )
#endif
			{
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugOutSensor[nSensorNo] = FALSE;
#endif

#ifndef _MY_DEBUG
				if( !m_pEqpAssy->m_GlassExistUnitOut.GetOr( nSensorNo ) )
#else
				if( 1 )
#endif
				{
					SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Out Sensor is OFF (2nd)" );
				}
				else if( m_pSetupItems->m_nValueInSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 0 )
				{
					SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Out Sensor OFF Timeout Skip(2nd)" );
				}

				// Flag Set
				m_pDicsData->m_IfFlag[nSensorNo].bOutComp = TRUE;
				// C/V Restart
				if( m_pDicsData->m_IfFlag[nSensorNo].bOutError ) 
				{
					m_pDicsData->m_IfFlag[nSensorNo].bOutError	  = FALSE;
					m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
				}
				nSeqNo = 1;
			}
			else nSeqNo = 30;
		}
		break;

	case 500 :
		{
			double dGlassSize	= GLASS_SIZE;
			double dCvSpeed		= m_pDicsData->m_JobCond.nCvSpeed / 60.0; // mm/sec
#ifndef _MY_DEBUG
			nTime2[nSensorNo]	= (int)( ( dGlassSize / dCvSpeed ) * 10 );
#else
			nTime2[nSensorNo]	= (int)( ( (dGlassSize/3.) / dCvSpeed ) * 10 );
#endif
			TIMER_ON( tm2, nTime2[nSensorNo] );

			// Turn On Current C/V
			int nCvSpeed = m_pDicsData->m_JobCond.nCvSpeedSet[nSensorNo - IF_UNIT_LD][CJobCond::speedNORMAL];
			m_pEqpAssy->m_CvMotor.SetMotorSpeed( nSensorNo - IF_UNIT_LD, nCvSpeed );

			nSeqNo = 30;
		}
		break;

	// Error ó (Timeout Error)
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId[nSensorNo] );

			// Set Timer
			TIMER_ON( tm1, nTime1[nSensorNo] );
			TIMER_ON( tm2, nTime2[nSensorNo] );

			// C/V Restart
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = TRUE;
			// Log
//			int nPortNo = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nPortNo;
			int nSlotNo = atoi( m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].sSlotNo );
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo, "Error Recovery" );
			nSeqNo = nReturnSeqNo[nSensorNo];
		}
		break;

	case 3000 :
		if( CheckUnitCondition( ssOUT, nSensorNo ) )
		{
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = FALSE;
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], 0, nSlotNo[nSensorNo], "Re-check Unit Condition : OK" );
			nSeqNo = nReturnSeqNo[nSensorNo];
		}
		break;

	} // Switch End 

	m_nSeqOutSensorNo[nSensorNo] = nSeqNo;
}


void CDicsCvSeq::SetSeqNo()
{
}

void CDicsCvSeq::SeqInSensorSickAlarm(int i)
{
	int nSeqNo = m_nSeqInSensorSickAlarmNo[i];
	static int nAlarmId[MAX_UNIT_NO];
	static DWORD dwTickStart[MAX_UNIT_NO] = { 0, };

	switch( nSeqNo )
	{
	case 0 :
		if( m_pDicsData->m_IfFlag[i].bInSick || m_pDicsData->m_IfFlag[i].bSubInSick  )
		{
			nAlarmId[i] = ALM_IN_ON_SENSOR_WARNING1 + i - IF_UNIT_LD;
			m_pEqpStateSeq->SetAlarm( nAlarmId[i] );
			nSeqNo = 1000;
		}		
		break;

	case 1000 :
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			dwTickStart[i] = GetTickCount();
			nSeqNo = 1010;
		}
		break;
	
	case 1010 :
		if( ( GetTickCount() - dwTickStart[i] ) > 1000 )
		{
			m_pDicsData->m_IfFlag[i].bInSick = FALSE;
			m_pDicsData->m_IfFlag[i].bSubInSick = FALSE;
			m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqInSensorSickAlarmNo[i] = nSeqNo;
}

void CDicsCvSeq::SeqOutSensorSickAlarm(int i)
{
	int nSeqNo = m_nSeqOutSensorSickAlarmNo[i];
	static int nAlarmId[MAX_UNIT_NO];
	static DWORD dwTickStart[MAX_UNIT_NO] = { 0, };	
	
	switch( nSeqNo )
	{
	case 0 :
		if( m_pDicsData->m_IfFlag[i].bOutSick || m_pDicsData->m_IfFlag[i].bSubOutSick )
		{
			nAlarmId[i] = ALM_OUT_ON_SENSOR_WARNING1 + i - IF_UNIT_LD;
			m_pEqpStateSeq->SetAlarm( nAlarmId[i] );
			nSeqNo = 1000;
		}
		break;

	case 1000 :
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			dwTickStart[i] = GetTickCount();
			nSeqNo = 1010;
		}
		break;

	case 1010 :
		if( ( GetTickCount() - dwTickStart[i] ) > 1000 )
		{
			m_pDicsData->m_IfFlag[i].bOutSick = FALSE;
			m_pDicsData->m_IfFlag[i].bSubOutSick = FALSE;
			m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
			nSeqNo = 0;
		}
		break;

	}
	m_nSeqOutSensorSickAlarmNo[i] = nSeqNo;
}

void CDicsCvSeq::GetTimeOut(int nSensorNo, int nIsOutSensor, int* nTm1, int* nTm2, int* nTm3)
{
	double dCvLength		= m_pSetupItems->m_fValueCvLength[( nSensorNo - IF_UNIT_LD )*2 + nIsOutSensor];
	double dCvSpeed			= m_pDicsData->m_JobCond.nCvSpeed / 60.0; // mm/sec
	double dCvMarginOn		= TIMEOUT_MARGIN_LENGTH_ON;
	double dCvMarginOff		= TIMEOUT_MARGIN_LENGTH_OFF;
	double dMarginOnTime	= dCvMarginOn / dCvSpeed;
	double dMarginOffTime	= dCvMarginOff / dCvSpeed;
	double dGlassSize		= GLASS_SIZE;

	// In Sensor Time out Setting
	*nTm1 = (int)( ( dCvLength / dCvSpeed + dMarginOnTime ) * 10 );
	*nTm2 = (int)( ( ( dGlassSize / dCvSpeed ) + dMarginOffTime ) * 10 );
	if( nTm3 != NULL )
		*nTm3 = (int)( ( dCvLength / dCvSpeed - dMarginOnTime ) * 10 );
#ifdef _MY_DEBUG
	*nTm1 = (int)( ( dCvLength / dCvSpeed ) * 10 );
	*nTm2 = (int)( ( dGlassSize / dCvSpeed ) * 10 );
	if( nTm3 != NULL )
		*nTm3 = (int)( ( dCvLength / dCvSpeed + dMarginOnTime ) * 10 );
#endif
}

void CDicsCvSeq::SetApdData( int nUnitNo )
{
	int nOwnerUnitNo;
	int nIndex;
	float fVal;
	int nApdReportNo;

	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		nOwnerUnitNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nOwnerUnitNo;
		nApdReportNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nApdReportNo;
		if( ( nUnitNo == nOwnerUnitNo ) && ( nApdReportNo >= 0 )  )
		{
			nIndex = CCimSeq::apdAI_START + nApdReportNo;
			fVal = m_pEqpAssy->m_AnalogInput.GetRealVal( i );
			m_pDicsData->m_GlsInfo[nUnitNo*2 + 0].sApdData[nIndex].Format( "%3.1f", fVal );
			SetLog( "APD", nOwnerUnitNo , nIndex, m_pDicsData->m_GlsInfo[nUnitNo*2 + 0].sApdData[nIndex] );
		}
	}
}

void CDicsCvSeq::SetLotApdData()
{
	int nOwnerUnitNo;
	int nIndex;
	float fVal;
	int nApdReportNo;

	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		nOwnerUnitNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nOwnerUnitNo;
		nApdReportNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nApdReportNo;
		if( nApdReportNo >= 0  )
		{
			nIndex = CCimSeq::lpdAI_START + nApdReportNo;
			fVal = m_pEqpAssy->m_AnalogInput.GetRealVal( i );
			m_pDicsData->m_GlsLotEndInfo.sLotApd[nIndex].Format( "%3.1f", fVal );
			SetLog( "LOT_APD", nOwnerUnitNo , nIndex, m_pDicsData->m_GlsLotEndInfo.sLotApd[nIndex] );
		}
	}
}
//******************************************************************************
//
//
//	-o-----o--o----o--o----o--o----o--o----o--o----o--o----o-
//	|		||		||		||		||		||		||		||
//	|	0	||	1	||	2	||	3	||	4	||	5	||	6	||		MAX_UNIT_NO = 7
//	----------------------------------------------------------
//	(M0)---->|(M1)---------->|(M2)------------------>|(M3)-->|		MAX_CV_NO = 4
//	
//	n=	1			2					3				1			nInfoSet[MAX_CV_NO][1] = n
//
//	static int nInfoSet[MAX_CV_NO][2]
//	{
//		{ IF_UNIT_O, 1},
//		{ IF_UNIT_1, 2},
//		{ IF_UNIT_3, 3},
//		{ IF_UNIT_6, 1},
//	};
//******************************************************************************
void CDicsCvSeq::SeqCv(int nCvNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	static int nInfoSet[MAX_CV_NO][2] = {
		{ IF_UNIT_LD, 1 },
		{ IF_UNIT_SWR1, 1 },
		{ IF_UNIT_SWR2, 1 },
		{ IF_UNIT_SWR3, 1 },
		{ IF_UNIT_SWR4, 1 },
		{ IF_UNIT_AK, 1 },
		{ IF_UNIT_BUF, 1 },
		{ IF_UNIT_UL, 1 },
	};

	int nUnit = nInfoSet[nCvNo][cvinfoSTART_UNIT];
	int nUnitEA = nInfoSet[nCvNo][cvinfoUNIT_NO];
	//******************************************************************************
	// Get Run Condition
	//******************************************************************************
	BOOL bRunCond = FALSE;
	for( int i = 0 ; i < nUnitEA ; i ++ )
	{
		nUnit = nUnit + i;
		bRunCond |= ( m_pDicsData->m_IfFlag[nUnit-1].bOutReady & ( nUnit != IF_UNIT_LD ) );
 		bRunCond |= ( !m_pDicsData->m_IfFlag[nUnit-1].bOutComp & ( nUnit != IF_UNIT_LD ) );
		bRunCond |= m_pDicsData->m_IfFlag[nUnit].bInReady;
		bRunCond |= m_pDicsData->m_IfFlag[nUnit].bOutReady;
		bRunCond |= ( m_pDicsData->m_GlsInfo[nUnit*2+0].bIsValid & ( nUnit != IF_UNIT_LD ) );
		bRunCond |= !m_pDicsData->m_IfFlag[nUnit].bOutComp;
//		bRunCond |= !m_pDicsData->m_IfFlag[nUnit+i].bInComp;
		bRunCond |= ( !m_pDicsData->m_IfFlag[nUnit+1].bInComp & ( nUnit != IF_UNIT_UL ) );
	}
	nUnit = nInfoSet[nCvNo][cvinfoSTART_UNIT];
	if( nUnit == IF_UNIT_UL && m_pDicsData->m_IfFlag[IF_UNIT_UL].bInComp && 
	     m_pDicsData->m_IfFlag[IF_UNIT_UL].bOutComp )
	{
		bRunCond = FALSE;	
	}
	//******************************************************************************
	// Get Alarm Condition
	//******************************************************************************
	BOOL bAlarm = FALSE;
	for( int i = nCvNo ; i < MAX_CV_NO ; i ++ )
	{
		nUnit = nInfoSet[i][cvinfoSTART_UNIT];
		nUnitEA = nInfoSet[i][cvinfoUNIT_NO];
		for( int j = 0 ; j < nUnitEA ; j ++ )
		{
			nUnit = nUnit + j;
			bAlarm |= m_pDicsData->m_IfFlag[nUnit].bInError | m_pDicsData->m_IfFlag[nUnit].bOutError;
		}
	}
	//******************************************************************************
	// Get Recovery Condition
	//******************************************************************************
	BOOL bRecoveryReq = FALSE;
	for( int i = nCvNo ; i < nCvNo + 2 ; i ++ )
	{
		if( nCvNo == MAX_CV_NO ) continue;

		nUnit = nInfoSet[i][cvinfoSTART_UNIT];
		nUnitEA = nInfoSet[i][cvinfoUNIT_NO];
		for( int j = 0 ; j < nUnitEA ; j ++ )
		{
			nUnit = nUnit + j;
			bRecoveryReq |= m_pDicsData->m_IfFlag[nUnit].bRecoveryReq;
		}
	}
	//******************************************************************************
	// Get Interlock Condition
	//******************************************************************************
	BOOL bInterlock = FALSE;
	bInterlock|= !m_pDicsData->m_GenInfo.bAuto;
	bInterlock|= m_pDicsData->m_GenInfo.bPause;
	bInterlock|= m_pDicsData->m_GenInfo.bUlTimeOut;
	bInterlock|= m_pDicsData->m_GenInfo.bLeakSensor;
	bInterlock|= m_pDicsData->m_GenInfo.bEmo;
	bInterlock|= m_pDicsData->m_GenInfo.bAreaSensor;
	bInterlock|= m_pDicsData->m_GenInfo.bCoverOpen;
	bInterlock|= m_pDicsData->m_GenInfo.bDoorOpen;

	//******************************************************************************
	// Set C/V Motor Command
	//******************************************************************************
	if( !bInterlock && bRunCond && ( bRecoveryReq || !bAlarm ) )
	{
		m_CvMotor.nCvAuto[nCvNo] = cvFW;
	}
	else
	{
		m_CvMotor.nCvAuto[nCvNo] = cvSTOP;
	}
}

void CDicsCvSeq::SeqCvMotorControl(int nCvNo )
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif	

	if ( m_pDicsData->m_GenInfo.bAuto )
	{
		if ( m_CvMotor.nCvAuto[nCvNo] == cvFW )
		{
			m_pEqpAssy->m_CvMotor.SetMotorFw( nCvNo, ON );
			m_pEqpAssy->m_CvMotor.SetMotorBw( nCvNo, OFF );
		}
		else if( m_CvMotor.nCvAuto[nCvNo] == cvBW )
		{
			m_pEqpAssy->m_CvMotor.SetMotorFw( nCvNo, OFF );
			m_pEqpAssy->m_CvMotor.SetMotorBw( nCvNo, ON );
		}
		else if( m_CvMotor.nCvAuto[nCvNo] == cvSTOP )
		{
			m_pEqpAssy->m_CvMotor.SetMotorFw( nCvNo, OFF );
			m_pEqpAssy->m_CvMotor.SetMotorBw( nCvNo, OFF );
		}
	}
}


void CDicsCvSeq::SeqCvMotorManualControl(int nCvNo )
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if ( !m_pDicsData->m_GenInfo.bAuto )
	{
		if ( m_CvMotor.nCvManual[nCvNo] == cvFW )
		{
			m_pEqpAssy->m_CvMotorAll.SetMotorFw( nCvNo, ON );
			m_pEqpAssy->m_CvMotorAll.SetMotorBw( nCvNo, OFF );
		}
		else if( m_CvMotor.nCvManual[nCvNo] == cvBW )
		{
			m_pEqpAssy->m_CvMotorAll.SetMotorFw( nCvNo, OFF );
			m_pEqpAssy->m_CvMotorAll.SetMotorBw( nCvNo, ON );
		}
		else if( m_CvMotor.nCvManual[nCvNo] == cvSTOP )
		{
			m_pEqpAssy->m_CvMotorAll.SetMotorFw( nCvNo, OFF );
			m_pEqpAssy->m_CvMotorAll.SetMotorBw( nCvNo, OFF );
		}		
	}
	else
	{
		m_CvMotor.nCvManual[nCvNo] = cvSTOP ;
	}
}

void CDicsCvSeq::SeqCvMotorSpeedControl()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	static int nSeqCvMotorSpeedControlNo = 0;
	static int nCurSpeedAuto[MAX_CV_NO] = { 0, };
	static int nCurSpeedManual[MAX_CV_MOTOR_NO] = { 0, };

	int nSeqNo = nSeqCvMotorSpeedControlNo;

	switch( nSeqNo ) 
	{
	case 0 :
		if( !m_pDicsData->m_GenInfo.bAuto )
		{
			nSeqNo = 10;			
		}
		else
		{
			for( int i = 0 ; i < m_pEqpAssy->m_CvMotor.GetMaxSectionNo(); i++ )
			{
				int nCvSpeed = m_pDicsData->m_JobCond.nCvSpeedSet[i][CJobCond::speedNORMAL];
				if( nCvSpeed != nCurSpeedAuto[i] )
				{
					nCurSpeedAuto[i] = nCvSpeed;
					m_pEqpAssy->m_CvMotor.SetMotorSpeed( i, nCvSpeed );
				}
			}	
		}
		break;
	case 10 :
		if( m_pDicsData->m_GenInfo.bAuto )
		{
			for( int i = 0 ; i < m_pEqpAssy->m_CvMotor.GetMaxSectionNo() ; i++ )
			{
				nCurSpeedAuto[i] = 0;
			}
			nSeqNo = 0;
		}
		else
		{
			for( int i = 0 ; i < m_pEqpAssy->m_CvMotorAll.GetMaxSectionNo() ; i++ )
			{
				int nCvSpeed = m_CvMotor.nSpeedManual[i];
				if( nCvSpeed != nCurSpeedManual[i] )
				{
					nCurSpeedManual[i] = nCvSpeed; 
					m_pEqpAssy->m_CvMotorAll.SetMotorSpeed( i, nCvSpeed );
				}
			}
		}
		break;
	}

	nSeqCvMotorSpeedControlNo = nSeqNo;
}

void CDicsCvSeq::CheckStopCountCond()
{
	BOOL bAlarm = FALSE;
	for( int i = IF_UNIT_LD; i<= IF_UNIT_UL; i++ )
	{
		bAlarm |= m_pDicsData->m_IfFlag[i].bInError;
		bAlarm |= m_pDicsData->m_IfFlag[i].bOutError;
//		bAlarm |= m_pDicsData->m_IfFlag[i].bAlarm;
	}
	bAlarm |= m_pDicsData->m_GenInfo.bUlTimeOut;
	
	if ( bAlarm )
		m_pDicsData->m_SeqFlag.bStopCount1 = TRUE;
	else 
		m_pDicsData->m_SeqFlag.bStopCount1 = FALSE;
}

BOOL CDicsCvSeq::GetSeqRunCond( int nSensorNo )
{
	BOOL bRunCond   = TRUE;
	BOOL bAlarm		= FALSE;

	// Check CvStop Condition
	for( int i = nSensorNo + 1; i<= IF_UNIT_UL; i++ )
	{
		bAlarm |= m_pDicsData->m_IfFlag[i].bInError;
		bAlarm |= m_pDicsData->m_IfFlag[i].bOutError;

//		bAlarm |= m_pDicsData->m_IfFlag[i].bAlarm;
	}

	bRunCond &=	m_pDicsData->m_GenInfo.bAuto &  
				!m_pDicsData->m_GenInfo.bEmo &
				!m_pDicsData->m_GenInfo.bCoverOpen &
				!m_pDicsData->m_GenInfo.bDoorOpen &
				!m_pDicsData->m_GenInfo.bLeakSensor &
				!m_pDicsData->m_GenInfo.bPause &
				!bAlarm;

	return bRunCond;
}

void CDicsCvSeq::TimerControl( int nSensorType, int nSensorNo )
{
	static BOOL bTimerPause[MAX_UNIT_NO*2] = { FALSE, };
	int nIndex = nSensorNo*2 + nSensorType;

//	static int nCvInfo[MAX_UNIT_NO] = {
//		0,
//		0,
//		0,
//		CV_NO_LD,
//		CV_NO_EUV,
//		CV_NO_RB,
//		CV_NO_FR,
//		CV_NO_AK,
//		CV_NO_UL,
//		0,
//		0,
//	};

//	if( ( m_CvMotor.nCvAuto[nCvInfo[nSensorNo]] == cvFW ) && bTimerPause[nIndex] )
	if( ( m_CvMotor.nCvAuto[nSensorNo-IF_UNIT_LD] == cvFW ) && bTimerPause[nIndex] )
	{
		TimerRestart( nIndex );
		bTimerPause[nIndex] = FALSE;

		// Glass Start
		BOOL bIsValid = m_pDicsData->m_GlsInfo[nIndex].bIsValid;
		if( bIsValid ) 
		{
			int nGlassNo = m_pDicsData->m_GlsInfo[nIndex].nGlassNo;
			m_pGlassAni->GlassMove( nGlassNo, nIndex + 1, TRUE );
		}
	}
//	else if( ( m_CvMotor.nCvAuto[nCvInfo[nSensorNo]] == cvSTOP ) && !bTimerPause[nIndex] )
	else if( ( m_CvMotor.nCvAuto[nSensorNo-IF_UNIT_LD] == cvSTOP ) && !bTimerPause[nIndex] )
	{
		TimerStop( nIndex );
		bTimerPause[nIndex] = TRUE;

		// Glass Stop
		BOOL bIsValid = m_pDicsData->m_GlsInfo[nIndex].bIsValid;
		if( bIsValid ) 
		{
			int nGlassNo = m_pDicsData->m_GlsInfo[nIndex].nGlassNo;
			m_pGlassAni->GlassMove( nGlassNo, nIndex + 1, FALSE );
		}
	}
}



void CDicsCvSeq::TimerStop(int nSensorNo)
{
	int nCvNo = nSensorNo/2;
	
	int bAlarm = FALSE;
	
//	for( int i = IF_UNIT_LD; i<= IF_UNIT_UL; i++ )
//	{
//		bAlarm |= m_pDicsData->m_IfFlag[i].bAlarm;
//	}
//	
//	if ( bAlarm )
//	{
//		m_pDicsData->m_SeqFlag.bStopCount1 = TRUE;
//	}
//
	// Timer Off
	if ( nSensorNo%2 )
	{
		m_pTimer->PauseTimer( TM_OUT_SENSOR_ON( nCvNo ) );  // Out Sensor On
		m_pTimer->PauseTimer( TM_OUT_SENSOR_OFF( nCvNo ) );  // Out Sensor Off
		m_pTimer->PauseTimer( TM_OUT_SENSOR_OUT2IN( nCvNo ) );  // Out Sensor, Next InSensor On	
	}	
	else 
	{
		m_pTimer->PauseTimer( TM_IN_SENSOR_ON( nCvNo ) );  // In Sensor On
		m_pTimer->PauseTimer( TM_IN_SENSOR_OFF( nCvNo ) );  // In Sensor Off
		m_pTimer->PauseTimer( TM_IN_SENSOR_IN2OUT( nCvNo ) );  // In Sensor, Next OutSensor On
	}

}

void CDicsCvSeq::TimerRestart(int nSensorNo)
{
	int nCvNo = nSensorNo/2;
	
	int bAlarm = FALSE;
	
//	for( int i = IF_UNIT_LD; i<= IF_UNIT_UL; i++ )
//	{
//		bAlarm |= m_pDicsData->m_IfFlag[i].bAlarm;
//	}
//	
//	if ( !bAlarm )
//	{
//		m_pDicsData->m_SeqFlag.bStopCount1 = FALSE;
//	}
//
	// Timer On
	if ( nSensorNo%2 )
	{
		m_pTimer->RePlayTimer( TM_OUT_SENSOR_ON( nCvNo ) );		// Out Sensor On
		m_pTimer->RePlayTimer( TM_OUT_SENSOR_OFF( nCvNo ) );	// Out Sensor Off
		m_pTimer->RePlayTimer( TM_OUT_SENSOR_OUT2IN( nCvNo ) );	// Out Sensor Off
	}
	else
	{
		m_pTimer->RePlayTimer( TM_IN_SENSOR_ON( nCvNo ) );		// In Sensor On
		m_pTimer->RePlayTimer( TM_IN_SENSOR_OFF( nCvNo ) );		// In Sensor Off
		m_pTimer->RePlayTimer( TM_IN_SENSOR_IN2OUT( nCvNo ) );	// In Sensor Off
	}
}
void CDicsCvSeq::SeqAkManualInterlockCheck()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	int nSeqNo = m_nSeqAkManualCheckNo;
	
	static DWORD dwTickStart; 

	BOOL bUse[4]    = { FALSE,};

	static BOOL bAlarm[4][2]    = { { FALSE, FALSE,}, };
	static BOOL bWarning[4][2]  = { { FALSE, FALSE,}, };	
	
	BOOL bCheckCond = TRUE; 
		
	double dCurVal[4] = { 0,};	

	int nLowLimit[4]   = { 0,};
	int	nLoWarning[4] = { 0,};	
	int	nUpWarning[4] = { 0,};
	int nUpLimit[4]	  = { 0,};

	bCheckCond &= !m_pDicsData->m_GenInfo.bAuto;
	bCheckCond &= ( m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_AK1 ) || 
					m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_AK1 ) || 
					m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_AK2 ) ||
					m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_AK2 ) );
	bCheckCond &= ( m_pEqpAssy->m_AutoValveAkUp.GetState() || m_pEqpAssy->m_AutoValveAkLo.GetState() );

	for(int i=0; i<4; i++)
	{
		bUse[i]	   = m_pSetupItems->m_nValueGaugeLimit_Option[13+i];
		dCurVal[i] = 0; //(double) m_pDevice->GetCalAI( noAK_UNIT_UP_AK_CDA_FLOW + i);ӽ 

		nLowLimit[i]	= m_pSetupItems->m_nValueGaugeLimit[0][13+i];
		nLoWarning[i]	= m_pSetupItems->m_nValueGaugeLimit[1][13+i];
		nUpWarning[i]	= m_pSetupItems->m_nValueGaugeLimit[2][13+i];
		nUpLimit[i]		= m_pSetupItems->m_nValueGaugeLimit[3][13+i];
	}
	
	switch( nSeqNo )
	{
	case 0:
		if( bCheckCond )
		{
			dwTickStart = GetTickCount();
			nSeqNo = 10;
		}
		break;

	case 10:
		if( !bCheckCond )
		{
			nSeqNo = 0;
		}
		else if( GetTickCount() - dwTickStart > 3000 )
		{
			for(int i=0; i<4; i++)
			{
				if( bCheckCond && bUse[i] )
				{
					if(	nLowLimit[i] >= dCurVal[i]  ) bAlarm[i][0] = TRUE;
					else if( nLowLimit[i] < dCurVal[i] && nLoWarning[i] >= dCurVal[i] ) bWarning[i][0] = TRUE;
					else if( nUpLimit[i] <= dCurVal[i] ) bAlarm[i][1] = TRUE;
					else if( nUpLimit[i] > dCurVal[i] && nUpWarning[i] <= dCurVal[i] ) bWarning[i][1] = TRUE;
				}
			}
			
			if ( bAlarm[0][0] || bAlarm[0][1] || bWarning[0][0] || bWarning[0][1] ||
				 bAlarm[1][0] || bAlarm[1][1] || bWarning[1][0] || bWarning[1][1] || 
				 bAlarm[2][0] || bAlarm[2][1] || bWarning[2][0] || bWarning[2][1] ||
				 bAlarm[3][0] || bAlarm[3][1] || bWarning[3][0] || bWarning[3][1] )
			{
				for( int j=0; j<MAX_CV_MOTOR_NO; j++ )
				{
					m_CvMotor.nCvManual[j] = CCvSeq::cvSTOP;
				}

				m_bAkManualAlarm = TRUE;
				nSeqNo = 20;
			}
		}
		break;

	case 20:
		{
			for( int i=0; i<4; i++)
			{
				if ( bAlarm[i][0] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_LOWER_ALARM1 + 13 + i );
			    if ( bAlarm[i][1] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_UPPER_ALARM1 + 13 + i );
				if ( bWarning[i][0] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_LOWER_WARNING1 + 13 + i );
				if ( bWarning[i][1] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_UPPER_WARNING1 + 13 + i );
			}
			nSeqNo = 30;
		}
		break;

	case 30:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			for ( int i=0; i<4; i++ )
			{ 
				if ( bAlarm[i][0] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_LOWER_ALARM1 + 13 + i );
					 bAlarm[i][0] = FALSE;
				}
				if ( bAlarm[i][1] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_UPPER_ALARM1 + 13 + i );
					bAlarm[i][1] = FALSE;
				}
				if ( bWarning[i][0] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_LOWER_WARNING1 + 13 + i );
					bWarning[i][0] =FALSE;
				}
				if ( bWarning[i][1] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_UPPER_WARNING1 + 13 + i );
					bWarning[i][1] = FALSE;
				}
			}
			m_bAkManualAlarm = FALSE;

			nSeqNo = 0;
		}
		break;
	}
	m_nSeqAkManualCheckNo = nSeqNo;
}
