// DicsCvSeq.h: interface for the CDicsCvSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CVSEQUENCE_H__70601FBE_730E_41AE_9CD0_C826B1C741EC__INCLUDED_)
#define AFX_CVSEQUENCE_H__70601FBE_730E_41AE_9CD0_C826B1C741EC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\X\xsequence.h"
#include "..\X\Xtimer.h"
#include "..\X\XMmc.h"
#include "..\X\XCtlDevice.h"
#include "..\View\SetupItems.h"
#include "..\Sequence\EqpStateSequence.h"
#include "..\DicsData.h"
#include "..\GlassAni.h"

class CDicsCvSeq : public CDicsMainSeq 
{
protected:
//	CDicsData*			m_pDicsData;
//	XCtlDevice*			m_pDevice;
//	CSetupItems*		m_pSetupItems;
//	XTimer*				m_pTimer;
//	CEqpStateSequence*	m_pEqpStateSeq;
//	CGlassAni*			m_pGlassAni;
//	XMmc*				m_pMmc;
public:
	CString				m_sMessage;
	CString				m_sSeqName;
	int					m_nStopCount;
	int					m_nStopCountAll;

public:
	int	m_nSeqInSensorNo[MAX_UNIT_NO];
	int m_nSeqOutSensorNo[MAX_UNIT_NO];
	int m_nSeqInSensorSickAlarmNo[MAX_UNIT_NO];
	int m_nSeqOutSensorSickAlarmNo[MAX_UNIT_NO];
	BOOL m_bAkManualAlarm;

	enum TackTime   { ttCOUNT_START, ttCOUNT_END };
	enum _SENSOR_TYPE{ ssIN, ssOUT };
	enum CV_STATE	{ cvSTOP, cvFW, cvBW };
	enum CV_UNIT	{ cvinfoSTART_UNIT, cvinfoUNIT_NO };

	enum dataManipulation
	{
		dmOK,
		dmDUP_DATA,
		dmNOT_SENSED_GLASS,
		dmSENSED_GLASS,
		dmEXCEED_GLASS_NO,
		dmDENIED_LOGICALLY,
	};

	enum unitKIND
	{
		unitLD,
		unitUL
	};
	
	struct tagSeqFlag
	{
		BOOL bInitReq;					// if initialized, it's TRUE 
		BOOL bInitComp;					// if initialized, it's TRUE 
		BOOL bInitFail;
	} m_SeqFlag;

	struct tagCvControl
	{
		int	nCvAuto[MAX_CV_NO];
		int	nCvManual[MAX_CV_MOTOR_NO];
		int nSpeedAuto[MAX_CV_NO];
		int nSpeedManual[MAX_CV_MOTOR_NO];
	} m_CvMotor;

protected:
	void GetTimeOut(int nSensorNo, int nIsOutSensor, int* nTm1, int* nTm2, int* nTm3 = NULL);
	virtual BOOL CheckUnitCondition( int nSensorType, int nUnitNo );
	void SeqOutSensorSickAlarm(int i);
	void SeqInSensorSickAlarm(int i);
	void SeqOutSensor(int nSensorNo);
	void SeqInSensor(int nSensorNo);
	BOOL Sequence();
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );
	
public:
	int m_nSeqAkManualCheckNo;
	void SeqAkManualInterlockCheck();
	
	virtual BOOL Initialize();
	CDicsCvSeq();
	virtual ~CDicsCvSeq();
	void InitParameter();
	void SetSeqNo();

	virtual void SetApdData( int nUnitNo );
	virtual	void SetLotApdData();
	virtual void SeqCv(int nCvNo);
	virtual void SeqCvMotorControl(int nCvNo);
	virtual void SeqCvMotorManualControl(int nCvNo);
	virtual void SeqCvMotorSpeedControl();
	virtual void CheckStopCountCond();
	virtual BOOL GetSeqRunCond( int nSensorNo );
	virtual void TimerControl( int nSensorType, int nSensorNo );
	virtual void TimerStop(int nSensorNo);
	virtual void TimerRestart(int nSensorNo);
};

#endif // !defined(AFX_CVSEQUENCE_H__70601FBE_730E_41AE_9CD0_C826B1C741EC__INCLUDED_)
