// EuvSequence.cpp: implementation of the CDicsEuvSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "..\MainFrm.h"
#include "DicsEuvSeq.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//#define _USE_HEATER
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDicsEuvSeq::CDicsEuvSeq()
{
}

CDicsEuvSeq::~CDicsEuvSeq()
{

}

// Call After XSequence::Start( HWND hWnd )
void CDicsEuvSeq::SetOwnerPointer(CWnd* pWnd)
{
	SetDicsView( ( CDicsView* )pWnd );
	SetData( m_pDicsView->m_pDicsData );
	SetDevice( m_pDicsView->m_pDevice );
	SetSetupItems( m_pDicsView->GetDocument()->m_pSetupItems );
	SetSeqTimer( m_pDicsView->m_pTimer );
	SetEqpStateSequence( m_pDicsView->m_pEqpStateSeq );
	SetEqpAssy( m_pDicsView->m_pEqpAssy );
}


BOOL CDicsEuvSeq::Initialize()
{
	InitParameter();

	return TRUE;
}

void CDicsEuvSeq::InitParameter()
{
	// Reset Sequence Flag
	m_SeqFlag.bInitReq	= FALSE;
	m_SeqFlag.bInitComp	= FALSE;
	m_SeqFlag.bInitFail	= FALSE;

	m_nSeqInitNo		= 0;
	m_nSeqAlarmNo		= 0;
	m_nSeqEuvNo			= 0;
	m_nSeqEuvProgressNo = 0;
	

//	m_IfEuv.bLampOnComp	= FALSE;
//	m_IfEuv.bLampOnFail	= FALSE;
//	m_IfEuv.bLampAlarm  = FALSE;
//	m_IfEuv.bLampPause  = FALSE;
		
	m_IniConfiguration.Open( "EUVInfo", "EqpInfo" );
	m_IfEuv.nLampControl = -1;
	for( int i=0; i<MAX_LAMP_NO; i++ )
	{
		// Get Total Euv Run Time
		CString sName;
		sName.Format("LAMP ON TIME%d", i + 1 );
		m_IfEuv.nLampOnTime[i] = m_IniConfiguration.GetIntValue( "EUV SET", sName, 0 );
		
		// Reset Sequence No.
		m_nSeqLampOnTimeNo[i]	  = 0;
		m_nSeqTimeOverNo[i]		  = 0;
	}

	for( int i=0; i<MAX_LAMP_INTENSITY_NO; i++ )
	{
//		m_IfEuv.bLampIntensityCheckComp[i]	= 0;
//		m_IfEuv.bLampIntensityCheckFail[i]	= 0;
		m_nSeqIntensityCheckNo[i]			= 0;
		m_IfEuv.bLampIntensityCheckReq[i]	= FALSE;
		m_IfEuv.fLampIntensity[i]			= .0;
	}

	m_IfEuv.bLampOnTimer = FALSE;
}

BOOL CDicsEuvSeq::GetEuvCond()
{
	static BOOL bCheckMargine = FALSE;
	BOOL bOk = FALSE;
	

	BOOL bEuvUse		= IsEuvUse();
	BOOL bGlassExist	= IsGlassExist();
	BOOL bEuvAlarm		= GetEuvAlarm() > 0 ? TRUE : FALSE;
	BOOL bCvRun			= FALSE;
#ifndef _TYPE7
	bCvRun				= m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_EUV ); //dosCV_MOTOR_FW( IF_UNIT_EUV );ӽ
#endif

	BOOL bEuvRun = TRUE;
	bEuvRun &= bEuvUse;
	bEuvRun &= bGlassExist;
	
	if( bEuvUse && bEuvAlarm )
	{
		return FALSE;
	}
	else if( !bEuvRun )
	{
		if( !GetLampOnState() ) bOk = TRUE;
	}
	else
	{
		if( bCvRun && GetLampOnState() )
		{
			bCheckMargine = FALSE;
			bOk = TRUE;
		}
		else if( !bCvRun && !bEuvAlarm )
		{
			bCheckMargine = FALSE;
			bOk = TRUE;
		}
		else if( bCvRun && !GetLampOnState() )
		{
			if( !bCheckMargine )
			{
				bCheckMargine = TRUE;
				bOk = TRUE;
			}
			else
			{
				bOk = FALSE;
			}
		}
	}

	return bOk;
}

void CDicsEuvSeq::LampOnSelect( )
{
}

void CDicsEuvSeq::LampControl( BOOL bOn )
{
}

void CDicsEuvSeq::LampMonitorSelect( int nPos )
{
}

void CDicsEuvSeq::SeqLampIntensityCheck()
{
}

void CDicsEuvSeq::UtControl( BOOL bOn )
{
}

BOOL CDicsEuvSeq::GetUtState()
{
	return FALSE;
}

BOOL CDicsEuvSeq::GetLampOnState()
{
	return FALSE;
}

BOOL CDicsEuvSeq::GetLampOnSelected( int nLampNo )
{
	return FALSE;
}

BOOL CDicsEuvSeq::IsRemoteMode()
{
	return FALSE;
}

BOOL CDicsEuvSeq::IsGlassExist()
{
	return FALSE;
}

int	CDicsEuvSeq::GetEuvAlarm()
{
	return 1;
}

BOOL CDicsEuvSeq::GetHouseCloseState()
{
	return FALSE;
}

float CDicsEuvSeq::GetLampIntensity( int nPos )
{
	return (float) m_IfEuv.fLampIntensity[nPos];
}

BOOL CDicsEuvSeq::Sequence()
{
 	Sleep( 10 );

	SeqInit();
	SeqEuvAlarm();

	SeqEuv();
	SeqUtControl();

	for( int i=0; i<MAX_LAMP_NO; i++ ) 
	{
		SeqLampOnTime( i );
		SeqTimeOver( i );
	}
	
	SeqLampIntensityCheck();
	SeqEuvProgress();	

	return TRUE;
}

//----------------------------------------------------------------------------------------------
// SeqInit
//----------------------------------------------------------------------------------------------
void CDicsEuvSeq::SeqInit()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	int nSeqNo = m_nSeqInitNo;
	static DWORD dwTickStart;
	static int nAlarmId;
	static BOOL bEuvOk = FALSE;

	switch( nSeqNo )
	{
	case 0:
		if( m_SeqFlag.bInitReq )
		{
			m_SeqFlag.bInitReq	= FALSE;
			m_SeqFlag.bInitComp	= FALSE;
			m_SeqFlag.bInitFail	= FALSE;

			
#ifndef _NO_EUV
			m_sMessage.Format( "%2d%d", CDicsData::initEUV_STATUS, MSG_STATUS_START );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );	
#endif

			// Log
			SetLog( "INIT    ", 0, 0, "Initialize..." );

			dwTickStart = GetTickCount();
	
			if( !IsEuvUse() )	nSeqNo = 40;
			else
			{	
				UtControl( ON );

				SetLog( "INIT    ", 0, 0, "UT Turn ON" );
				nSeqNo = 10;
			}
		}
		break;
	case 10 :
		if ( ( GetTickCount() - dwTickStart ) > 3000 ) 
		{
			nSeqNo = 20;
		}
		break;
	case 20 :		
		if( IsRemoteMode() )
		{
			// Set Log
			SetLog( "INIT    ", 0, 0, "Confirm Remote Mode" );
			nSeqNo = 30;
		}
		else
		{
#ifndef _NO_EUV
			nAlarmId = ALM_EUV_MANUAL;
#endif
			m_pEqpStateSeq->SetAlarm( nAlarmId );
					
#ifndef _NO_EUV
			m_sMessage.Format( "%2d%d", CDicsData::initEUV_STATUS, MSG_STATUS_NG );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
#endif

			SetLog( "ALARM", 0, 0, "Alarm Set" );

			m_SeqFlag.bInitFail	= TRUE;

			nSeqNo = 1000;
		}	
		break;

	case 30 :
		if( GetEuvAlarm() == 0 )
		{
			SetLog( "INIT    ", 0, 0, "No Alarm" );	
			nSeqNo = 40;
		}
		else
		{
#ifndef _NO_EUV
			nAlarmId = ALM_EUV_NOT_READY;
#endif
			m_pEqpStateSeq->SetAlarm( nAlarmId );
					
#ifndef _NO_EUV
			m_sMessage.Format( "%2d%d", CDicsData::initEUV_STATUS, MSG_STATUS_NG );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
#endif
			SetLog( "ALARM", 0, 0, "Alarm Set" );

			m_SeqFlag.bInitFail	= TRUE;

			nSeqNo = 1000;
		}
		break;
	case 40 :
		if( GetHouseCloseState() )
		{
			SetLog( "INIT    ", 0, 0, "House Close Confirm" );	
			nSeqNo = 100;
		}
		else
		{
#ifndef _NO_EUV
			nAlarmId = ALM_EUV_HOUSE_OPEN;
#endif
			m_pEqpStateSeq->SetAlarm( nAlarmId );
					
#ifndef _NO_EUV
			m_sMessage.Format( "%2d%d", CDicsData::initEUV_STATUS, MSG_STATUS_NG );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
#endif
			SetLog( "ALARM", 0, 0, "Alarm Set" );

			m_SeqFlag.bInitFail	= TRUE;

			nSeqNo = 1000;
		}
		break;
	case 100:
		{			
			// Flag Set
			m_SeqFlag.bInitComp = TRUE;

#ifndef _NO_EUV
			m_sMessage.Format( "%2d%d", CDicsData::initEUV_STATUS, MSG_STATUS_OK );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
#endif
			// Log
			SetLog( "INIT    ", 0, 0, "Ends Initialize" );
			
			Msg( WM_EQP_MESSAGE, MSG_TITLEBAR_MESSAGE, (LPARAM)(LPCTSTR)"READY", FALSE );
			nSeqNo = 0;
		}
		break;

	// Error
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			nSeqNo = 0;
		}
		break;
	}

	m_nSeqInitNo = nSeqNo;
}

void CDicsEuvSeq::SeqEuvAlarm()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	if( !m_SeqFlag.bInitComp ) return;
}

void CDicsEuvSeq::SeqEuv()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
//	if( !m_SeqFlag.bInitComp ) return;
//	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;
	
	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();

	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 2000 )	bInit = TRUE;
		if( !bInit ) return;
	}

	m_IfEuv.nLampControl = SetLampControl();

	switch( m_IfEuv.nLampControl )
	{
	case euvLAMP_MANUAL :
		break;
	case euvLAMP_PAUSE :
	case euvLAMP_OFF :
		if( GetLampOnState() == ON )
		{
			LampControl( OFF );
			SetLog( "EUV LAMP", 0, 0, "Lamp OFF" );
		}
		break;
	case euvLAMP_ON :
	case euvLAMP_ON_KEEP :
		if( GetLampOnState() == OFF )
		{
			LampOnSelect();
			LampControl( ON );
			SetLog( "EUV LAMP", 0, 0, "Lamp ON" );
		}
		break;
	}
}

void CDicsEuvSeq::SeqLampOnTime( int i )
{
	int nSeqNo = m_nSeqLampOnTimeNo[i];
	static int dwTickStart[MAX_LAMP_NO];
	static int nAlarmId[MAX_LAMP_NO] = { 0, };

	switch( nSeqNo ) 
	{
	case 0:
		{
			BOOL bOn = TRUE;
			bOn &= GetLampOnState();
			bOn &= GetLampOnSelected( i / (MAX_LAMP_NO/MAX_LAMP_CONTROL_NO ) );
			bOn &= GetEuvAlarm() > 0 ? FALSE : TRUE;
						
			if( bOn )
			{
				dwTickStart[i] = GetTickCount();
				nSeqNo = 10;
			}
		}
		break;

	case 10:
		if( GetTickCount() - dwTickStart[i] > 1000 )
		{
			// +1
			SetLampUsedTime( i, 1 );
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqLampOnTimeNo[i] = nSeqNo;
}

void CDicsEuvSeq::SeqTimeOver(int i)
{
	int nSeqNo = m_nSeqTimeOverNo[i];
	static int nAlarmId[MAX_LAMP_NO] = { 0, };

	UINT nTimeOver;
	nTimeOver = atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupEUV1_LIFE_TIME + i] );	// Hour
	nTimeOver *= 3600;	// second


	switch( nSeqNo )
	{
	case 0:
		if( GetLampUsedTime( i ) > nTimeOver ) 
		{
			// Set Alarm
#ifndef _NO_EUV
			nAlarmId[i] = ALM_EUV_LAMP1_TIME_OVER + i;
#endif
			m_pEqpStateSeq->SetAlarm( nAlarmId[i] );
			
			// Log
			m_sMessage.Format( "Lamp%d Timeover Warning", i + 1 );
			SetLog( "ALARM", 0, 0, m_sMessage );
			nSeqNo = 1000;
		}
		break;
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			if( GetLampUsedTime( i ) <= nTimeOver ) 
			{
				// Reset Alarm
				m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );

				// Log
				m_sMessage.Format( "Lamp%d Alarm Recovery", i + 1 );
				SetLog( "ALARM", 0, 0, m_sMessage );
				nSeqNo = 0;
			}
		}
		break;
	}

	m_nSeqTimeOverNo[i] = nSeqNo;
}


BOOL CDicsEuvSeq::IsEuvUse()
{
	BOOL bUse = TRUE;

	bUse &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupJOB_MODE];
	bUse &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUSE_EUV];

	BOOL bLampSelect = FALSE;
	for( int i=0; i<MAX_LAMP_CONTROL_NO; i++ )
	{
		bLampSelect |= m_pDicsData->m_JobCond.bEuvUse[i];
	}

	bUse &= bLampSelect;

	return bUse;
}


int CDicsEuvSeq::SetLampControl()
{
	int nControl = euvLAMP_OFF;
	
	return nControl;
}

int CDicsEuvSeq::GetLampControl()
{
	return m_IfEuv.nLampControl;
}

UINT CDicsEuvSeq::GetLampUsedTime( int nLampNo )
{
	return m_IfEuv.nLampOnTime[nLampNo];
}

void CDicsEuvSeq::SetLampUsedTime( int nLampNo, int nType )
{
	m_IniConfiguration.Open( "EUVInfo", "EqpInfo" );
	if( nType == -1 )
	{	// Reset
		m_IfEuv.nLampOnTime[nLampNo] = 0;		
	}
	else
	{
		m_IfEuv.nLampOnTime[nLampNo] += 1;
	}

	// Write to profile
	CString sName;
	sName.Format( "LAMP ON TIME%d", nLampNo + 1 );
	m_IniConfiguration.SetIntValue( "EUV SET", sName, m_IfEuv.nLampOnTime[nLampNo], TRUE );
}

void CDicsEuvSeq::SeqEuvProgress()
{
	static DWORD dwStartTick = 0;
	static int nOldControl = -1;
	static int nOldTime = 0;
	int nTime;
	DWORD dwEuvOnTime = 0;
#ifndef _NO_EUV
	dwEuvOnTime = (DWORD) ( ( m_pSetupItems->m_fValueCvLength[( IF_UNIT_EUV - IF_UNIT_LD ) * 2 + 0] + GLASS_SIZE ) 
		                            / ( m_pDicsData->m_JobCond.nCvSpeed / 60 ) * 10 );
#endif
	int nControl = GetLampControl();
	
	int nSeqNo = m_nSeqEuvProgressNo;


	switch ( nControl )
	{
	case euvLAMP_ON :
		if( nOldControl != euvLAMP_ON )
		{	// Progress starts
			Msg( WM_EUV_ON_PROGRESS, PROGRESS_START, dwEuvOnTime/10, FALSE );			

			TIMER_ON( TM_EUV_PROGRESS, dwEuvOnTime );
			nOldTime = 0;
	
			dwStartTick = GetTickCount();
		}
		break;
	case euvLAMP_OFF :
		if( nOldControl != euvLAMP_OFF )
		{	// Progress OFF
			Msg( WM_EUV_ON_PROGRESS, PROGRESS_END, 0, FALSE );			

			nOldTime = 0;
		}
		break;
	case euvLAMP_ON_KEEP :
		if( TIMER( TM_EUV_PROGRESS ) )
		{	// Progress ++->
			nOldTime = 0;
		}
		else if( m_pTimer->m_pTimer[TM_EUV_PROGRESS].bPause )
		{
			m_pTimer->RePlayTimer( TM_EUV_PROGRESS );					
		}
		
		nTime = (int)( m_pTimer->m_pTimer[TM_EUV_PROGRESS].dwNow / 100 );
		if( nTime - nOldTime > 2 )
		{
			nOldTime = nTime;
			
			Msg( WM_EUV_ON_PROGRESS, PROGRESS_SET, (LPARAM)nTime, FALSE );
		}
		break;
	case euvLAMP_MANUAL :
	case euvLAMP_PAUSE :
		if( !m_pTimer->m_pTimer[TM_EUV_PROGRESS].bPause )
		{
			m_pTimer->PauseTimer( TM_EUV_PROGRESS );
		}
		break;			
	}

	if( nControl != euvLAMP_MANUAL ) nOldControl = nControl;

	m_nSeqEuvProgressNo = nSeqNo;
}

void CDicsEuvSeq::SeqUtControl()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	if( !m_SeqFlag.bInitComp ) return;

	if( !m_pDicsData->m_GenInfo.bAuto ) return;

	if( IsEuvUse() ) 
	{
		if( !GetUtState() )	UtControl( ON );
	}
	else
	{
		if( GetUtState() )	UtControl( OFF );
	}
}

//---------------------------------------------------------------------------
// Set the Log
//---------------------------------------------------------------------------
void CDicsEuvSeq::SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage )
{
	// Log
	CString sLog;
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );
	
	sLog.Format( "EUV\t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( sLog );

	sLog.Format( "%s : %s", sSeqName, sMessage );
	Msg( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) sLog );
}
