// DicsGaugeInterlockSeq.h: interface for the CGaugeInterlockSequence class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAUGEINTERLOCKSEQUENCE_H__063AE499_9254_451F_9CBA_56AD10D13EBA__INCLUDED_)
#define AFX_GAUGEINTERLOCKSEQUENCE_H__063AE499_9254_451F_9CBA_56AD10D13EBA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "..\X\XCtlDevice.h"
#include "..\X\XSequence.h"
#include "..\X\XTimer.h"
#include "..\X\XMmc.h"
#include "..\GlassAni.h"
#include "..\View\SetupItems.h"
#include "..\DicsData.h"
#include "..\Sequence\EqpStateSequence.h"
#include "..\X\xctlmelsec.h"
#include "..\AnalogInput1.h"
#include "..\FactoryLib\EqpAssy.h"

class CDicsGaugeInterlockSeq : public XSequence  
{
public:
	CDicsView*			m_pDicsView;
	CDicsData*			m_pDicsData;
	XCtlDevice*			m_pDevice;
	CSetupItems*		m_pSetupItems;
	CEqpStateSequence*	m_pEqpStateSeq;
	XMmc*				m_pMmc;
	XTimer*				m_pTimer;
	CAnalogInput1*		m_pAI1;
	CEqpAssy*			m_pEqpAssy;

	CString				m_sSeqName;
	CString				m_sMessage;

	struct tagInterlock
	{
		BOOL			*bGaugeAlarmSet;
		BOOL			*bGaugeWarningSet;
		BOOL			*bNg;
	} m_Interlock;
		
	int *m_nSeqCheckInterlockNo;

public:
	int m_nMaxIntroNo;
	CDicsGaugeInterlockSeq();
	virtual ~CDicsGaugeInterlockSeq();
	void SetOwnerPointer(CWnd* pWnd);

	BOOL Initialize();
	void InitParameter();
	BOOL Sequence();

	void SetDevice( XCtlDevice* pDevice )						{ m_pDevice = pDevice; }
	void SetSeqTimer( XTimer* pTimer )							{ m_pTimer = pTimer; }
	void SetDicsView( CDicsView *pView )						{ m_pDicsView = pView;	}
	void SetDicsData( CDicsData* pDicsData )					{ m_pDicsData = pDicsData; }
	void SetSetupItems( CSetupItems* pSetupItems )				{ m_pSetupItems = pSetupItems; }
	void SetEqpStateSequence(CEqpStateSequence* pEqpStateSeq)	{ m_pEqpStateSeq = pEqpStateSeq; }
	void SetEqpAssy( CEqpAssy* pEqpAssy )						{ m_pEqpAssy = pEqpAssy; }
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );

	void SeqGaugeInterlock( int nNo );
	virtual BOOL GetCheckCond( int nIntrNo );
	BOOL GetGaugeCond( int nUnitNo );
};

#endif // !defined(AFX_GAUGEINTERLOCKSEQUENCE_H__063AE499_9254_451F_9CBA_56AD10D13EBA__INCLUDED_)
