// DicsInterfaceSeq.h: interface for the CDicsInterfaceSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DICSINTERFACESEQ_H__43EB64C1_72B2_4B12_861B_13476B81F3C4__INCLUDED_)
#define AFX_DICSINTERFACESEQ_H__43EB64C1_72B2_4B12_861B_13476B81F3C4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "X\XSequence.h"
#include "X\XTimer.h"
#include "X\XCtlDevice.h"	// Added by ClassView
#include "X\XCtlMelsec.h"
#include "X\XMmc.h"

#include "View\SetupItems.h"
#include "DicsData.h"
#include "Sequence\EqpStateSequence.h"
#ifdef _CIM_SKIP
#include "FileMap.h"
#endif
#include "..\FactoryLib\EqpAssy.h"

class CDicsInterfaceSeq : public XSequence  
{
public:
	virtual BOOL Initialize();
	virtual void InitParameter();
	virtual BOOL Sequence();

	CDicsInterfaceSeq();
	virtual ~CDicsInterfaceSeq();

	// Pointer variables
public:
	CDicsView*			m_pDicsView;
	XTimer*				m_pTimer;
	XCtlDevice*			m_pDevice;
	XCtlMelsec*			m_pMelsec;
	CSetupItems*		m_pSetupItems;
	CDicsData*			m_pDicsData;
	CEqpStateSequence*	m_pEqpStateSeq;
	XMmc*				m_pMmc;
	CEqpAssy*			m_pEqpAssy;

#ifdef _CIM_SKIP
	CFileMap*			m_pFileMap;
	void SetFileMap(CFileMap* pFileMap)							{ m_pFileMap = pFileMap; }
#endif
	// Pointer Set Function
public:
	void SetDicsView( CDicsView *pView )						{ m_pDicsView	= pView;	}
	void SetSeqTimer(XTimer* pTimer)							{ m_pTimer		= pTimer; }
	void SetDevice( XCtlDevice* pDevice )						{ m_pDevice		= pDevice; }
	void SetMelsec( XCtlMelsec* pMelsec )						{ m_pMelsec		= pMelsec; }
	void SetSetupItems( CSetupItems* pSetupItems )				{ m_pSetupItems = pSetupItems; }
	void SetData( CDicsData* pData )							{ m_pDicsData	= pData; }
	void SetMmc( XMmc * pMmc )									{ m_pMmc		= pMmc; }
	void SetEqpStateSequence(CEqpStateSequence* pEqpStateSeq)	{ m_pEqpStateSeq = pEqpStateSeq; }
	void SetEqpAssy( CEqpAssy* pEqpAssy )						{ m_pEqpAssy = pEqpAssy; }

public:
	CString		m_sMessage;
	CString		m_sSeqName;

public:
	void SetOwnerPointer(CWnd* pWnd);
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );
protected:
};

#endif // !defined(AFX_DICSINTERFACESEQ_H__43EB64C1_72B2_4B12_861B_13476B81F3C4__INCLUDED_)
