// DicsMainSeq.cpp: implementation of the CDicsMainSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "DicsMainSeq.h"
#include "..\MainFrm.h"
#include "..\X\XLog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define MAX_RBT_INTERLOCK	2		// ljy_041124
#define LD_LO_HAND_WAIT		25000	// ljy_050402 (msec)

XLog Log( "EqpLog", XLog::stampNoDateTime, TRUE ); // TRUE : Append
//XLog EdcLog( "EdcDataLog", XLog::stampNoDateTime, TRUE ); // TRUE : Append
XLog ApdLog( "ApdDataLog", XLog::stampNoDateTime, TRUE ); // TRUE : Append
//XLog LoaderLog( "LoaderLog", XLog::stampNoDateTime, TRUE );
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// Set the static member variables
CDicsMainSeq::CDicsMainSeq()
{
	m_pDicsView		= NULL;
	m_pEqpStateSeq	= NULL;
	m_pDevice		= NULL;
	m_pTimer		= NULL;
	m_pSetupItems	= NULL;
	m_pDicsData		= NULL;
	m_pMmc			= NULL;
	m_pGlassAni		= NULL;
	m_pAI1			= NULL;
	m_pMelsec		= NULL;
	m_pEqpAssy		= NULL;

// Clear the m_SeqFlag structure
//	m_SeqFlag.bInitReq		= FALSE;
//	m_SeqFlag.bInitComp		= FALSE;

	// Reset sequence number
	m_nSeqDistanceNo		= 0;
	m_nSeqInitNo			= 0;

	m_nSeqPauseNo			= 0;
	m_nSeqModeNo			= 0;
	m_nSeqGlassExistNo		= 0;
	m_nSeqInitServoNo		= 0;	// ljy_050425 : Initialize to Servo Unit
	m_nRbtHandInterlockCount = 0;

	m_bRbtEStopReq = FALSE;		// ljy_050425 : Initialize to Servo Unit
}

CDicsMainSeq::~CDicsMainSeq()
{

}

// Call After XSequence::Start( HWND hWnd )
void CDicsMainSeq::SetOwnerPointer(CWnd* pWnd)
{
	SetDicsView( ( CDicsView* )pWnd );
	SetData( m_pDicsView->m_pDicsData );
	SetDevice( m_pDicsView->m_pDevice );
	SetSetupItems( m_pDicsView->GetDocument()->m_pSetupItems );
	SetSeqTimer( m_pDicsView->m_pTimer );
	SetEqpStateSequence( m_pDicsView->m_pEqpStateSeq );
	SetMmc( m_pDicsView->m_pMmc );
	SetGlassAni( m_pDicsView->m_pGlassAni );
//	SetMelsec( m_pDicsView->m_pMelsec );
	SetEqpAssy( m_pDicsView->m_pEqpAssy );
#ifdef _CIM_SKIP
	SetFileMap( m_pDicsView->m_pFileMap );
#endif
}

BOOL CDicsMainSeq::Initialize()
{
#ifdef _MY_DEBUG
	m_pDevice->ResetOutNodeAll();
#endif	

	InitParameter();
	for( int i=0; i<MAX_RBT_NO; i++ )
	{
		//if( i == RBT_SPARE_UNIT) continue;
		// Set the position to memory from the file
		m_pMmc->PosFile2Mem( i );
		m_rvVel[i] = m_pMmc->GetVel( i );
	}

	return TRUE;
}

BOOL CDicsMainSeq::Sequence()
{
	Sleep( 10 );

	SeqInitServo();	// ljy_050425 : Initialize Servo Unit
	if( m_pDicsData->m_GenInfo.bEmo ) return TRUE;
	SeqInit();
	SeqMode();
	SeqPause();
	SeqCleanOutMode();
	SeqGlassExist();

	//if( m_pSetupItems->m_bCalReq ) SeqDistance();
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// Sequence Լ
//---------------------------------------------------------------------------
// - SeqInit()
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// - InitParameter()
//---------------------------------------------------------------------------
void CDicsMainSeq::InitParameter()
{
	m_nSeqRecoveryNo		= 0;
	m_nSeqCleanOutModeNo	= 0;

	// Reset the timer pause flag
	m_pTimer->RePlayTimer();


//	if( !m_pDicsData->m_GenInfo.bEqpInitComp )
//	{
//		m_pDicsData->m_GenInfo.bEqpInitReq = FALSE;
//	}

    m_pDicsData->m_GenInfo.nMaxEqpGlassNo = atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupMAX_GLASS_NO] );
	if ( m_pDicsData->m_GenInfo.nMaxEqpGlassNo > MAX_EQP_GLASS_NO ) m_pDicsData->m_GenInfo.nMaxEqpGlassNo = MAX_EQP_GLASS_NO;
}

void CDicsMainSeq::SeqInit()
{

}

//---------------------------------------------------------------------------
// - SeqMode
//---------------------------------------------------------------------------
void CDicsMainSeq::SeqMode()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	int nSeqNo = m_nSeqModeNo;

	static int nRv[MAX_RB_NO];
	static DWORD dwStartCount;

	CString sSeqName( "MODE    " );

	switch( nSeqNo ) 
	{
	case 0 :
		if( m_pDicsData->m_GenInfo.bAuto )
		{
			nSeqNo = 100;
		}
		break;
	case 100:
		if( !m_pDicsData->m_GenInfo.bAuto )
		{
			if( m_pDicsData->m_GenInfo.bEqpInitComp && m_pDicsData->m_GenInfo.nGlassNo ) 
			{
				m_pDicsData->m_EqpInfo.nEqpState[CDicsData::statePAUSE] = 1;
				m_pDicsData->m_GenInfo.bPause = TRUE;
			}

			nSeqNo = 0;
		}
		break;
	}
	m_nSeqModeNo = nSeqNo;
}

//---------------------------------------------------------------------------
// - SeqMode
//---------------------------------------------------------------------------
void CDicsMainSeq::SeqPause()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	int nSeqNo = m_nSeqPauseNo;

	switch( nSeqNo ) 
	{
	case 0 :
		if( m_pDicsData->m_GenInfo.bPause )
		{
			// Log
			SetLog( "PAUSE   ", 0, 0, "TRUE" );

			//( (CDicsView *) m_pOwnerWnd )->m_pInterfaceSeq->SetStop( -1, TRUE );

			nSeqNo = 10;
		}
		break;

	case 10:
		if( !m_pDicsData->m_GenInfo.bPause )
		{
			// Log
			SetLog( "PAUSE   ", 0, 0, "FALSE" );
			//( (CDicsView *) m_pOwnerWnd )->m_pInterfaceSeq->SetStop( -1, FALSE );

			nSeqNo = 0;
		}
		break;
	}

	m_nSeqPauseNo = nSeqNo;
}

//---------------------------------------------------------------------------
// - SeqGlassExist
//---------------------------------------------------------------------------
void CDicsMainSeq::SeqGlassExist()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	int nSeqNo = m_nSeqGlassExistNo;

	static CString sSeqName( "SeqGlassExist" );

	switch( nSeqNo )
	{
	case 0:
		// case 0  m_pDicsData->m_GenInfo.nGlassNo = 0  
	  	// case 10  m_pDicsData->m_GenInfo.nGlassNo > 0  Ǵ  ~
		if( !m_pDicsData->m_GenInfo.nGlassNo ) 
		{
			SetLog( sSeqName, 0, 0, "EQP GLASS NO IS 0" );
			nSeqNo = 20;
		}
		else nSeqNo = 20;
		break;
	case 10:
		if( !m_pDicsData->m_GenInfo.nGlassNo )
		{
			m_pDicsData->m_SeqFlag.bTimeOver = TRUE;

			Msg( WM_TACT_TIME, ttCOUNT_END, 0L );

			SetLog( sSeqName, 0, 0, "TACT TIMEOVER FLAG : TRUE" );
			nSeqNo = 20;			
		}
		break;
	case 20:
		if( m_pDicsData->m_GenInfo.nGlassNo ) 
		{
			SetLog( sSeqName, 0, 0, "EQP GLASS NO IS NOT 0" );
			nSeqNo = 10;
		}
		break;
	}
	m_nSeqGlassExistNo = nSeqNo;
}

//---------------------------------------------------------------------------
// Set the sequence no and the other conditions.
// i : 0 ~ 1 => 0=IN, 1=OUT
// j : 0 ~ 5 => Unit No (LD, EUV, R/B, SBJ, AK, UL)
//---------------------------------------------------------------------------
void CDicsMainSeq::SetSeqNo()
{

}

//---------------------------------------------------------------------------
// Get Profile data
//---------------------------------------------------------------------------
void CDicsMainSeq::GetProfileGlassData()
{
	for( int i = 0 ; i < 2 ; i ++ )
	{
		for( int j = 0 ; j < MAX_IF_NO ; j ++ )
		{
			// Get Data
			m_pDicsData->GetProfileGlassData( j*2 + i );

			// 0 1 2
			// 1 0 3 => 0 : 1̸ Glass ְ 0̸ Glass .
			//			2 : 03 Glass No
			BOOL bIsValid = m_pDicsData->m_GlsInfo[j*2 + i].bIsValid;
			if( bIsValid )
			{
				m_pDicsData->m_GenInfo.nGlassNo += 1;
				Msg( WM_GLASS_NO, m_pDicsData->m_GenInfo.nGlassNo, 0L );

				// Show the glass
				int nGlassNo = m_pDicsData->m_GlsInfo[j*2 + i].nGlassNo;
				m_pGlassAni->StartGlassMove( nGlassNo );
				m_pGlassAni->GlassMoveRegion( nGlassNo, j*2 + i );
			}
		}
	}
}

//---------------------------------------------------------------------------
// Set the Log
//---------------------------------------------------------------------------
void CDicsMainSeq::SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage )
{
	// Log
	CString sLog;
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	sLog.Format( "MAIN    \t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( sLog );

	if( m_pDicsData->m_GenInfo.bEnableEqpLog )
	{
		sLog.Format( "%s : %s", sSeqName, sMessage );
		Msg( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) sLog );
	}
}


void CDicsMainSeq::SeqInitServo()
{
	if( m_pDicsData->m_SeqFlag.bInitServo ) return;

	static BOOL bServoOff[MAX_RBT_NO] = { FALSE, };
	int nSeqNo = m_nSeqInitServoNo;

	switch( nSeqNo )
	{
	case 0 :
		{
			for( int i = 0 ; i < MAX_RBT_NO ; i ++ )
			{
				if( !bServoOff[i] && ( m_pMmc->EStopRbt( i ) == TRUE ) )
				{
					bServoOff[i] = TRUE;
				}
			}
			nSeqNo = 10;
		}
		break;

	case 10 :
		{
			BOOL bAllServoOff = TRUE;
			for( int i = 0 ; i < MAX_RBT_NO ; i ++ )
			{
				if( !bServoOff[i] ) bAllServoOff = FALSE;
			}
			if( bAllServoOff ) nSeqNo = 100;
			else nSeqNo = 0;
		}
		break;		

	case 100:
		{
			SetLog( "RBT OFF ", 0, 0, "Servo Unit All-Estop to Initialize" );
			for( int i = 0 ; i < MAX_RBT_NO ; i ++ )
			{
				bServoOff[i] = FALSE;
			}
			m_pDicsData->m_SeqFlag.bInitServo = TRUE;
			nSeqNo = 0;
		}
	}
	m_nSeqInitServoNo = nSeqNo;
}




void CDicsMainSeq::ApdSave(UINT nID, int nPortNo, int nSlotNo)
{

}



//////////////////////////////////////////////////////////////////////
// Sequence Լ
//---------------------------------------------------------------------------
// - SeqInit()
//---------------------------------------------------------------------------

void CDicsMainSeq::SeqCleanOutMode()
{
	int nSeqNo = m_nSeqCleanOutModeNo;
	static DWORD dwTickStart;
	switch( nSeqNo )
	{
	case 0 :
		if( m_pDicsData->m_GenInfo.bCleanOut )
		{
			m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateCLEAN] = 1;

			CDicsApp* pApp = (CDicsApp*) AfxGetApp();
			CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;
			pMainFrame->AddTitleMessage( "Clean Out Mode Start" );
			
			nSeqNo = 10;
		}
		break;
		
	case 10 :
		if( m_pDicsData->m_GenInfo.nGlassNo == 0 )
		{
			BOOL bRv = FALSE;
			for( int i = 0 ; i < MAX_IF_NO * 2 ; i ++ )
			{
				bRv |= m_pDicsData->m_GlsInfo[i].bIsValid;
#ifndef _MY_DEBUG				
				bRv |= m_pEqpAssy->m_GlassExistUnit.DualGetOr( i, 2 );
#else 
				if ( i%2 ) bRv |= m_pDicsData->m_bDebugOutSensor[i/2];
				else bRv |= m_pDicsData->m_bDebugInSensor[i/2];
#endif 
			}
			if( !bRv )
			{
				m_pDicsData->m_GenInfo.bEqpInitComp = FALSE;
				dwTickStart = GetTickCount();
				nSeqNo = 20;
			}
		}
		break;

	case 20 :
		if( GetTickCount() - dwTickStart > 500 )
		{
			m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateCLEAN] = 0;
			m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateRUN]	= 0;
			m_pDicsData->m_GenInfo.bEqpInitComp = FALSE;
			m_pDicsData->m_GenInfo.bCleanOut = FALSE;

			CDicsApp* pApp = (CDicsApp*) AfxGetApp();
			CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;
			pMainFrame->AddTitleMessage( "Clean Out Mode End" );

			nSeqNo = 0;
		}
		break;
	}
	m_nSeqCleanOutModeNo = nSeqNo;
}


BOOL CDicsMainSeq::GlassDataMove(int nSource, int nTarget, int *nSlotNo, int *nPortNo)
{
	BOOL bRv = FALSE;
	if( !m_pDicsData->m_GlsInfo[nTarget].bIsValid )
	{
		//***************************************************1*************************
		// Glass Data shift
		m_pDicsData->MoveGlassData( nSource, nTarget );

		bRv = TRUE;
	}
	return bRv;
}

void CDicsMainSeq::GetRbtVel(int nRbtType, RBT_VEL &rvVel)
{
	rvVel = m_rvVel[nRbtType];
}


void CDicsMainSeq::SetRecipe2JobCond(CString sRecipeId)
{
	CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();

	CString sBuf;
	sBuf.Format( "Recipe = %s", sRecipeId );
	SetLog( "Rcp2Job ", 0, 0, sBuf );

	int nRow = pDoc->GetRowfromID( sRecipeId );
	if( nRow > -1 )
	{			
		m_pDicsData->m_JobCond.nTactTime
			= atoi( pDoc->m_pRecipeInfo[nRow].sValue[CDaoRecipeSet::rcpTACT_TIME] );
		sBuf.Format( "Tact Time = %d", m_pDicsData->m_JobCond.nTactTime );
		SetLog( "Rcp2Job ", 0, 0, sBuf );

		m_pDicsData->m_JobCond.nCvSpeed
			= atoi( pDoc->m_pRecipeInfo[nRow].sValue[CDaoRecipeSet::rcpCV_SPEED] );
		sBuf.Format( "CV Speed = %d", m_pDicsData->m_JobCond.nCvSpeed );
		SetLog( "Rcp2Job ", 0, 0, sBuf );

		// Set the C/V Speed
		for( int i = 0; i < MAX_CV_NO; i++ ) // ljy_050317 : change
		{
			m_pDicsData->m_JobCond.nCvSpeedSet[i][CJobCond::speedNORMAL] =
				m_pDicsData->m_JobCond.nCvSpeed;
		}
				
		// Set the recipe information
		Msg( WM_SET_RECIPE, 0, (LPARAM)(LPCTSTR)sRecipeId );
	}
}


