// DicsMainSeq.h: interface for the CDicsMainSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINSEQUENCE_H__00606509_F127_405A_A097_9E80B48AAB9D__INCLUDED_)
#define AFX_MAINSEQUENCE_H__00606509_F127_405A_A097_9E80B48AAB9D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// EMO, Cover Open, Manual, Pause  C/V    
// ü 󸶱 ϴ  ϰڴ°? ==> 10 ϶ Ѵ.

//////////////////////////////////////////////////////////////////////
// Header File  Sequence->Data->X File ...
//   BOOL -> int -> float -> double -> WORD -> DWORD -> Char -> CString -> enum
// ٸ      ִ.. 
//////////////////////////////////////////////////////////////////////
#include "..\X\XCtlDevice.h"
#include "..\X\XSequence.h"
#include "..\X\XTimer.h"
#include "..\X\XMmc.h"
#include "..\X\xctlmelsec.h"
#include "..\GlassAni.h"
#include "..\View\SetupItems.h"
#include "..\DicsData.h"
#include "..\Sequence\EqpStateSequence.h"
#include "..\AnalogInput1.h"
#include "..\FactoryLib\EqpAssy.h"

class CDicsMainSeq : public XSequence  
{
public:
	CDicsView*			m_pDicsView;
	CEqpStateSequence*	m_pEqpStateSeq;
	XCtlDevice*			m_pDevice;
	XTimer*				m_pTimer;
	CSetupItems*		m_pSetupItems;
	CDicsData*			m_pDicsData;
	XMmc*				m_pMmc;
	CGlassAni*			m_pGlassAni;
	CAnalogInput1*		m_pAI1;
	XCtlMelsec*			m_pMelsec;
	CEqpAssy*			m_pEqpAssy;
	
#ifdef _CIM_SKIP
	CFileMap*			m_pFileMap;
	void SetFileMap(CFileMap* pFileMap)							{ m_pFileMap = pFileMap; }
#endif
	// General variables
	CString			m_sMessage;

protected:
	RBT_VEL			m_rvVel[MAX_RBT_NO];
	RBT_POS			m_rpPos;

	int m_nSeqDistanceNo;
	int m_nSeqInitNo;
	int m_nSeqModeNo;
	int m_nSeqPauseNo;
	int m_nSeqGlassExistNo;
	int m_nSeqCleanOutModeNo;
public:
	// Sequence No
	int m_nRbtHandInterlockCount;
	int m_nMaxGlassNo;
	int	m_nSeqRecoveryNo;
	int m_nSeqInitServoNo;			// ljy_050425 : add
	BOOL m_bRbtEStopReq;			// ljy_050425 : add

	// enum variables
	enum TackTime   { ttCOUNT_START, ttCOUNT_END };

	enum IntrCheck  { icOK, icALARM, icWARNING };

	enum _SENSOR_TYPE{ ssIN, ssOUT };
	enum doorPos { Door_F_M, Door_F_B, Door_S_M, Door_R_M, Door_R_B };
	enum alignTYPE{ alignON, alignOFF, alignONOFF };

protected:
	BOOL GlassDataMove( int nSource, int nTarget, int* nSlotNo, int* nPortNo );
	void ApdSave(UINT nID, int nPortNo, int nSlotNo);
	void SeqInitServo();
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );
	virtual void SeqInit();

private:
	void SeqPause();
	// Set pointer
	void SetDicsView( CDicsView *pView )						{ m_pDicsView = pView;	}
	void SetSeqTimer(XTimer* pTimer)							{ m_pTimer = pTimer; }
	void SetDevice(XCtlDevice* pDevice)							{ m_pDevice = pDevice; }
	void SetSetupItems( CSetupItems* pSetupItems )				{ m_pSetupItems = pSetupItems; }
	void SetData( CDicsData* pData )							{ m_pDicsData = pData; }
	void SetEqpStateSequence(CEqpStateSequence* pEqpStateSeq)	{ m_pEqpStateSeq = pEqpStateSeq; }
	void SetMmc( XMmc* pMmc )									{ m_pMmc = pMmc; }
	void SetGlassAni( CGlassAni* pGlassAni )					{ m_pGlassAni = pGlassAni; }
	void SetMelsec( XCtlMelsec * pMelsec )						{ m_pMelsec = pMelsec; }
	void SetAI1( CAnalogInput1 * pAI1 )							{m_pAI1 = pAI1;}	
	void SetEqpAssy( CEqpAssy* pAssy )							{m_pEqpAssy = pAssy;}
	void SeqMode();
	void SeqGlassExist();
public:
	virtual void SetRecipe2JobCond(CString sRecipeId);
	void GetRbtVel(int nRbtType, RBT_VEL& rvVel);
	void SetOwnerPointer(CWnd* pWnd);
	// Glass data manipulation functions
	void GetProfileGlassData();
	void SetSeqNo();
	
	// Sequence member functions
public:
	// member function
//	void RegBackUp();
	virtual void SeqCleanOutMode();
 	virtual void InitParameter();
	BOOL Sequence();
	BOOL Initialize();

	CDicsMainSeq();
	virtual ~CDicsMainSeq();

};



#endif // !defined(AFX_MAINSEQUENCE_H__00606509_F127_405A_A097_9E80B48AAB9D__INCLUDED_)
