// DicsPumpSeq.h: interface for the CDicsPumpSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PUMPSEQUENCE_H__0BA052FE_CFAE_442C_AA42_F105427C1059__INCLUDED_)
#define AFX_PUMPSEQUENCE_H__0BA052FE_CFAE_442C_AA42_F105427C1059__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
//////////////////////////////////////////////////////////////////////
// Header File  Sequence->Data->X File ...
//   BOOL -> int -> float -> double -> WORD -> DWORD -> Char -> CString -> enum
// ٸ      ִ.. 
//////////////////////////////////////////////////////////////////////

#include "..\X\xsequence.h"
#include "..\X\XCtlDevice.h"
#include "..\X\XLog.h"
#include "..\X\XTimer.h"
#include "..\X\XMmc.h"
#include "..\DicsData.h"
#include "..\View\SetupItems.h"
#include "..\Sequence\EqpStateSequence.h"
#include "..\FactoryLib\EqpAssy.h"
#include "..\FactoryLib\IniData.h"

class CDicsView;

class CDicsPumpSeq : public XSequence  
{
public:
	XCtlDevice*			m_pDevice;
	XMmc*				m_pMmc;
	XTimer*				m_pTimer;
	CDicsView*			m_pDicsView;
	CDicsData*			m_pDicsData;
	CSetupItems*		m_pSetupItems;
	CEqpStateSequence*	m_pEqpStateSeq;
	CEqpAssy*			m_pEqpAssy;

	CIniData			m_IniConfiguration;
	enum noDI_PUMP	{ noDIPUMP1, noDIPUMP2, noDIPUMP3, noDIPUMP4 };
	enum tprUSE		{ tprNONE, tprSTOP, tprRUN };
	enum tankLEVEL	{ /*lvLL, */lvL, /*lvML, lvMH, lvHL,*/ lvM, lvH, lvHH, lvMAX };

	int					m_nSeqInitNo;
	int					m_nSeqModeChangeNo;
	int					m_nSeqGlassExistNo;
	int					m_nSeqAirKnifeNo;
	int					m_nSeqSbjNo[MAX_SBJ_NO];
	int					m_nSeqDiTankNo[MAX_DI_TANK_NO];
	int					m_nSeqDiPumpNo[MAX_DI_PUMP_NO];
	int					m_nSeqDiPumpInterlockNo[MAX_DI_TANK_NO];
	int					m_nSeqDiwIdleRunningNo;
	int					m_nSeqLevelSensorNo[MAX_DI_TANK_NO][lvMAX];

	int					m_nTankLevelStartAddress[MAX_DI_TANK_NO];
	int					m_nInterlockFlowMeterID[MAX_DI_TANK_NO];	

	int					m_nHotTankLevelStartAddress[MAX_HOT_DI_TANK_NO];
	int					m_nHotInterlockFlowMeterID[MAX_HOT_DI_TANK_NO];

	CString				m_sMessage;
	CString				m_sSeqName;

	// Define the Struct variables
	struct tagSeqFlag
	{
		BOOL bInitReq;					// if initialized, it's TRUE 
		BOOL bInitComp;					// if initialized, it's TRUE 
		BOOL bInitFail;

		int  nTprStatus[MAX_DI_HEATER_NO];			//0:NONE, 1:Stop, 2:Run
		int  nTprStatusReq[MAX_DI_HEATER_NO];			//
		BOOL bDiTankReady[MAX_DI_TANK_NO];
		BOOL bInsufficientDiFlowrate[MAX_DI_TANK_NO];
		BOOL bDiTankLevel[MAX_DI_TANK_NO][lvMAX];
		BOOL bDiTankLevelSensorFault[MAX_DI_TANK_NO][lvMAX];
		BOOL bHotDiTankReady[MAX_HOT_DI_TANK_NO];
		BOOL bInsufficientHotDiFlowrate[MAX_HOT_DI_TANK_NO];
		BOOL bHotDiTankLevel[MAX_HOT_DI_TANK_NO][lvMAX];
		BOOL bHotDiTankLevelSensorFault[MAX_HOT_DI_TANK_NO][lvMAX];
		BOOL bCirReq[MAX_HOT_DI_TANK_NO];
	} m_SeqFlag;
	
public:
	void SetOwnerPointer(CWnd* pWnd);
	CDicsPumpSeq();
	virtual ~CDicsPumpSeq();

	BOOL Initialize();
	virtual void InitParameter();
	BOOL Sequence();
	BOOL GetLevelSensorFault( int nTankNo );
	BOOL GetHotTankLevelSensorFault( int nTankNo );
	void SetDicsView( CDicsView *pView )						{ m_pDicsView = pView;	}
	void SetDevice( XCtlDevice* pDevice )						{ m_pDevice = pDevice; }
	void SetSeqTimer( XTimer* pTimer )							{ m_pTimer = pTimer; }
	void SetDicsData( CDicsData* pDicsData )					{ m_pDicsData = pDicsData; }
	void SetSetupItems( CSetupItems* pSetupItems )				{ m_pSetupItems = pSetupItems; }
	void SetEqpStateSequence(CEqpStateSequence* pEqpStateSeq)	{ m_pEqpStateSeq = pEqpStateSeq; }
	void SetEqpAssy( CEqpAssy* pAssy )							{m_pEqpAssy = pAssy;}
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );
	
	void SeqInit();
	void SeqModeChange();
	void SeqGlassExist();
	void SeqAirKnife();
	void SeqSbj(int i);
	void SeqDiTank(int i);
	void SeqDiPump(int i);
	void SeqDiPumpInterlock(int i);
	void SeqDiwIdleRunning();
	void SeqLevelSensor(int nTankNo, int nSensorNo);

};

#endif // !defined(AFX_PUMPSEQUENCE_H__0BA052FE_CFAE_442C_AA42_F105427C1059__INCLUDED_)
