//////////////////////////////////////////////////////////////////////
// DicsRbSeq.h: interface for the DicsRbSeq class.
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RBSEQUENCE_H__28887258_C84C_4E32_95A3_BF25274AF777__INCLUDED_)
#define AFX_RBSEQUENCE_H__28887258_C84C_4E32_95A3_BF25274AF777__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\X\XCtlDevice.h"
#include "..\X\XSequence.h"
#include "..\X\XTimer.h"
#include "..\X\XMmc.h"
#include "..\X\XLog.h"
#include "..\GlassAni.h"
#include "..\View\SetupItems.h"
#include "..\DicsData.h"
#include "..\Sequence\EqpStateSequence.h"
#include "..\X\xctlmelsec.h"
#include "..\AnalogInput1.h"
#include "..\FactoryLib\EqpAssy.h"

class CDicsRbSeq : public XSequence  
{

protected:
	CDicsView*			m_pDicsView;
	CDicsData*			m_pDicsData;
	XCtlDevice*			m_pDevice;
	CSetupItems*		m_pSetupItems;
	CEqpStateSequence*	m_pEqpStateSeq;
	XMmc*				m_pMmc;	
	XTimer*				m_pTimer;
	CEqpAssy*			m_pEqpAssy;

public:
	int					m_nServoMode;
	int					m_nSeqInitNo[MAX_RB_GAP_SERVO_NO];
	int					m_nSeqRbGapControlNo[MAX_RB_GAP_SERVO_NO];	
	CString				m_sMessage;
	CString				m_sSeqName;
	struct tagSeqFlag
	{
		BOOL			bInitReq[MAX_RB_NO];	// if initialized, it's TRUE 
		BOOL			bInitComp[MAX_RB_NO];	// if initialized, it's TRUE 
		BOOL			bInitFail[MAX_RB_NO];
	} m_SeqFlag;
	struct tagRbMotor
	{
		BOOL			bRbMotorCond[MAX_RB_NO];	// R/B FBL Motor Condition
		int				nRefRbVelocity[MAX_RB_NO];	// R/B ȸ ǥġ
		double			dCurRbVelocity[MAX_RB_NO];	// R/B  ִ Speed
		double			dErrRbVelocity[MAX_RB_NO];	//  Feedback 
	} m_RbMotor;
	struct tagRbGap
	{
		int				nRefRbPosition[MAX_RB_GAP_SERVO_NO];
		BOOL			bGapSettingComp[MAX_RB_GAP_SERVO_NO];
	} m_RbGap;	
	
	enum rbPOS	{ rbOFF, rbNOOP, rbWAIT, rbZERO, rbPROCESS, rbIDLERUN };	// 170714 halesu
	enum servo	{ servoNO_USE, servoUP_ONLY, servoBOTH };

public:
	CDicsRbSeq();
	virtual ~CDicsRbSeq();
	void SetOwnerPointer(CWnd* pWnd);

	BOOL Sequence();
	BOOL Initialize();
	void InitParameter();
	BOOL GetRbCond();
	BOOL IsRbUse( int nRbNo );
	BOOL IsRbMotorRun( int nRbNo );
	virtual BOOL IsRbPumpUse( int nRbNo );
	virtual BOOL IsRbPumpAlarm( int nRbNo );
	
private: 
	void SetDicsView(CDicsView *pView)							{ m_pDicsView = pView;	}
	void SetData(CDicsData *pData)								{ m_pDicsData = pData;}
	void SetDevice(XCtlDevice* pDevice)							{ m_pDevice = pDevice; }
	void SetSetupItems(CSetupItems* pSetupItems)				{ m_pSetupItems = pSetupItems; }
	void SetEqpStateSequence(CEqpStateSequence* pEqpStateSeq)	{ m_pEqpStateSeq = pEqpStateSeq; }
	void SetMmc(XMmc* pMmc)										{ m_pMmc = pMmc; }
	void SetSeqTimer( XTimer* pTimer )							{ m_pTimer = pTimer; }
	void SetEqpAssy( CEqpAssy* pAssy )							{m_pEqpAssy = pAssy;}

protected:
	void SetLog(CString sSeqName, int nPortNo, int nSlotNo, CString sMessage);
	void SeqInit();
	void SeqRbMotorControl(int nRbNo);
	void SeqRbGapControl(int nRbNo);
	void SeqRbMotorCond(int nRbNo);
	int SetRbSpeed( int nRbNo );
	int SetRbGap( int nRbGap );
};

#endif // !defined(AFX_RBSEQUENCE_H__28887258_C84C_4E32_95A3_BF25274AF777__INCLUDED_)
