// PortInfo.cpp: implementation of the CPortInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Dics.h"
#include "PortInfo.h"

//////////////////////////////////////////////////////////////////////
// CGlassInfo Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGlassInfo::CGlassInfo()
{
	ClearGlassInfo();
}

CGlassInfo::CGlassInfo( int nSlotNo, int nStateNew )
{
	nSlotNo = nSlotNo;
	nState = nStateNew;
}

CGlassInfo::~CGlassInfo()
{

}

CGlassInfo& CGlassInfo::operator =(const CGlassInfo &gls)
{
//	bIsValid		= gls.bIsValid; 2009.01.20 kimgun glass portno slotno  
	                                //ν ǥð  data ǥõǴ  ƴұ??
	UlWaitTime		= gls.UlWaitTime;	// 110609 halesu
	nGlassNo		= gls.nGlassNo;
	nGlass_slot		= gls.nGlass_slot;
	bProcessed		= gls.bProcessed;
	cRcpChangeFlag	= gls.cRcpChangeFlag;
	cProcessFlag	= gls.cProcessFlag;
	nState			= gls.nState;		
	nSlotNo			= gls.nSlotNo;
	sSlotNo			= gls.sSlotNo;
	nPortNo			= gls.nPortNo;
	sPortNo			= gls.sPortNo;
	bIsValid		= gls.bIsValid;//2009.01.20 kimgun
	sLotId			= gls.sLotId;
	sOpId			= gls.sOpId;
	sProdId			= gls.sProdId;
	sCassetteId		= gls.sCassetteId;
	sPPId			= gls.sPPId;	
	sCassetteSlotNo = gls.sCassetteSlotNo;
	sGlassType		= gls.sGlassType;
	sRcpIdChangeTime = gls.sRcpIdChangeTime;
	sRecipeId		= gls.sRecipeId;
	sPostRcpId		= gls.sPostRcpId;
	sPortRcpId		= gls.sPortRcpId;
	sCassettePortNo = gls.sCassettePortNo;
	sGlassId		= gls.sGlassId;
	sOpGlassId		= gls.sOpGlassId;
	sWaferId		= gls.sWaferId;
	nCstSeqNo		= gls.nCstSeqNo;
	nLineControl	= gls.nLineControl;
	nMaterialNo		= gls.nMaterialNo;
	nMaintainCst	= gls.nMaintainCst;
	nBendingPara	= gls.nBendingPara;
	nLdRecipeId		= gls.nLdRecipeId;
	nUlRecipeId		= gls.nUlRecipeId;
	sOperationId    = gls.sOperationId;
	sOperationNo    = gls.sOperationNo;
	nMultiTraceKey	= gls.nMultiTraceKey;//2008.11.07 kimgun
	sGlassHeadPos	= gls.sGlassHeadPos;//2008.11.07 kimgunhosung
	sGlassTailPos	= gls.sGlassTailPos;//2008.11.07 kimgun

	bProcessFlag	= gls.bProcessFlag;	//hskwak 
	sRecipeIdFull	= gls.sRecipeIdFull;
	int i;
	for( i=0; i<5; i++ )
	{
		nGlassData[i]	= gls.nGlassData[i];
		sGlassData[i]	= gls.sGlassData[i];
	}
	for( i=0; i<MAX_APD_DATA_NO; i++ ) sApdData[i] = gls.sApdData[i];
	for( i=0; i<MAX_LOT_APD_NO; i++ ) sLotApd[i] = gls.sLotApd[i];	
	
	return *this;
}

CGlassInfo& CGlassInfo::operator =(const int nStateNew)
{
	nState = nStateNew;

	return *this;
}

void CGlassInfo::ClearGlassInfo()
{
	//////////////////////////////////////////////////////////////
	// Glass Information
	bIsValid	= FALSE;
	nGlassNo	= 0;
	nGlass_slot	= 0;
	bProcessed	= FALSE;
	cRcpChangeFlag = rcpNOT_CHANGED;
	cProcessFlag= glsPROC_NG;
	nState		= glsEMPTY;
	nSlotNo		= 0;
	sSlotNo		= "";
	nPortNo		= 0;
	sPortNo		= "";
	sLotId		= "";
	sOpId		= "";
	sProdId		= "";
	sCassetteId = "";
	sPPId		= "";	
	sCassetteSlotNo = "";
	sCassettePortNo = "";
	sOperationId	= "";
	sOperationNo	= "";
	sGlassType	= "";
	sRcpIdChangeTime = "";
	sRecipeId	= "";
	sPostRcpId	= "1";
	sPortRcpId  = "1";
	sGlassId	= "";
	sOpGlassId	= "";
	sWaferId	= "";
	nCstSeqNo	= 0;
	nLineControl = 0;
	nMaterialNo = 0;
	nMaintainCst= 0;
	nBendingPara= 0;
	nLdRecipeId = 1;
	nUlRecipeId = 1;
	nMultiTraceKey = -1;//2008.11.07 kimgun
	sGlassHeadPos = "";//2008.11.07 kimgun
	sGlassTailPos = "";//2008.11.07 kimgun
	sRecipeIdFull = "";
	bProcessFlag = FALSE;	//hskwak 
	UlWaitTime = COleDateTime::GetCurrentTime();	// 110609 halesu
	int i;
	for( i=0; i<5; i++ )
	{
		nGlassData[i]	= 0;
		sGlassData[i]	= "0";
	}
	for( i=0; i<MAX_APD_DATA_NO; i++ ) sApdData[i] = "0";
	for( i=0; i<MAX_LOT_APD_NO; i++ ) sLotApd[i] = "0";	
}

CString CGlassInfo::GetGlassID()
{
	CString sRv;
	sRv.Format("%02d%1d", atoi(sSlotNo), nPortNo);
//	sRv.Format("%s", sWaferId);
	return sRv;
}

void CGlassInfo::GetProfileGlassData(int i)
{
//	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	m_IniConfiguration.Open( "GlassData", "GLSINFO" );
	CString szEntry;
	CString szSection;

	szSection.Format( "GLASS DATA : %d", i );
//----------------------------------------------------------------------------------------------
// Description : EQP GLASS DATA
//----------------------------------------------------------------------------------------------
	szEntry.Format( "bIsValid%d", i );
	bIsValid = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );
	szEntry.Format( "nGlassNo%d", i );
	nGlassNo = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );
	szEntry.Format( "nPortNo%d", i );
	nPortNo = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );
	szEntry.Format( "nSlotNo%d", i );
	nSlotNo = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );
 	szEntry.Format( "nGlassSlot%d", i );
 	nGlass_slot = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );
//----------------------------------------------------------------------------------------------
// Description : CIM PC -> CLEANER DATA
//----------------------------------------------------------------------------------------------
	szEntry.Format( "sPortNo%d", i );
 	sPortNo = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sSlotNo%d", i );
 	sSlotNo = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sRecipeId%d", i );
	sRecipeId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sWaferId%d", i );
	sWaferId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sLotId%d", i );
	sLotId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sCassetteId%d", i );
	sCassetteId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sCassetteSlotNo%d", i );
	sCassetteSlotNo = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
/*
	szEntry.Format( "sPortRcpId%d", i );
	sPortRcpId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sPPId%d", i );
	sPPId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
*/
	szEntry.Format( "sGlassId%d", i );
	sGlassId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );

	szEntry.Format( "sRecipIdFull%d", i );
	sRecipeIdFull = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );

	szEntry.Format( "sCassettePortNo%d", i );
	sCassettePortNo = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
/*
	szEntry.Format( "sOperationID%d", i );
	sOperationId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sOperationNO%d", i );
	sOperationNo = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
*/
	//Trace Pos 2008.11.08 kimgun
	//////////////////////////////////////////////////////////////////////////
	szEntry.Format( "nMultiTraceKey%d", i );
	nMultiTraceKey = m_IniConfiguration.GetIntValue( szSection, szEntry,0 );
	szEntry.Format( "sGlassHeadPos%d", i );
	sGlassHeadPos = m_IniConfiguration.GetStringValue( szSection, szEntry,"" );
	szEntry.Format( "sGlassTailPos%d", i );
	sGlassTailPos = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	//////////////////////////////////////////////////////////////////////////

	szEntry.Format( "sProcessFlag%d", i );
	bProcessFlag = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );
//	szEntry.Format( "sGlassApd%d", i );
//	sGlassApd[0] = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
//	szEntry.Format( "sGlassApd%d", i );
//	sGlassApd[1] = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	for( int j=0; j<MAX_APD_DATA_NO; j++ )
	{
		szEntry.Format( "sApdData%d_%d", i, j );
		sApdData[j] = m_IniConfiguration.GetStringValue(szSection, (LPCTSTR)szEntry, "" );
	}


//	for( int j = 0 ; j < MAX_EDC_DATA_NO ; j ++ )
//	{
//		szEntry.Format( "sEDCData%d_%d", i, j );
//		sEDC[j] = pApp->GetProfileString( "GLS_DATA", (LPCTSTR)szEntry, "NULL_DATA" );
//	}
/*
	// Default arguments
 	szEntry.Format( "bIsValid%d", i );
	bIsValid = pApp->GetProfileInt( "GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "nGlassNo%d", i );
	nGlassNo = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "nGlass_slot%d", i );
	nGlass_slot = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "bProcessed%d", i );
	bProcessed = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "cRcpChangeFlag%d", i );
	cRcpChangeFlag = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "cProcessFlag%d", i );
	cProcessFlag = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "nState%d", i );
	nState = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "nSlotNo%d", i );
	nSlotNo = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "sSlotNo%d", i );
	sSlotNo = pApp->GetProfileString("GLS_DATA", (LPCTSTR)szEntry, "NULL" );
	szEntry.Format( "nPortNo%d", i );
	nPortNo = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "sPortNo%d", i );
	sPortNo = pApp->GetProfileString("GLS_DATA", (LPCTSTR)szEntry, "NULL" );
	szEntry.Format( "sLotId%d", i );
	sOpId = pApp->GetProfileString("GLS_DATA", (LPCTSTR)szEntry, "NULL" );
	szEntry.Format( "sOpId%d", i );
	sProdId = pApp->GetProfileString("GLS_DATA", (LPCTSTR)szEntry, "NULL" );
	szEntry.Format( "sProdId%d", i );
	sLotId = pApp->GetProfileString("GLS_DATA", (LPCTSTR)szEntry, "NULL" );
	szEntry.Format( "sCassetteId%d", i );
	sCassetteId = pApp->GetProfileString("GLS_DATA", (LPCTSTR)szEntry, "NULL" );
	szEntry.Format( "sPPId%d", i );
	sPPId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sCassetteSlotNO%d", i );
	sCassetteSlotNO = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sGlassType%d", i );
	sGlassType = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sRcpIdChangeTime%d", i );
	sRcpIdChangeTime = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sRecipeId%d", i );
	sRecipeId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sPostRcpId%d", i );
	sPostRcpId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sGlassId%d", i );
	sGlassId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
	szEntry.Format( "sOpGlassId%d", i );
	sOpGlassId = pApp->GetProfileString("GLS_DATA", (LPCTSTR)szEntry, "NULL" );
	szEntry.Format( "sWaferId%d", i );
	sWaferId = pApp->GetProfileString("GLS_DATA", (LPCTSTR)szEntry, "NULL" );
	szEntry.Format( "nCstSeqNo%d", i );
	nCstSeqNo = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "nLineControl%d", i );
	nLineControl = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "nMaterialNo%d", i );
	nMaterialNo = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "nMaintainCst%d", i );
	nMaintainCst = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "nBendingPara%d", i );
	nBendingPara = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "nLdRecipeId%d", i );
	nLdRecipeId = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
	szEntry.Format( "nUlRecipeId%d", i );
	nUlRecipeId = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );

	for( int j=0; j<5; j++ )
	{
		szEntry.Format( "nGlassData%d_%d", i, j );
		nGlassData[j] = pApp->GetProfileInt("GLS_DATA", (LPCTSTR)szEntry, NULL );
		szEntry.Format( "sGlassData%d_%d", i, j );
		sGlassData[j] = pApp->GetProfileString("GLS_DATA", (LPCTSTR)szEntry, "NULL" );
	}
	for( j=0; j<MAX_APD_DATA_NO; j++ )
	{
		szEntry.Format( "sApdData%d_%d", i, j );
		sApdData[j] = pApp->GetProfileString("GLS_DATA", (LPCTSTR)szEntry, "NULL" );
	}
	for( j=0; j<MAX_LOT_APD_NO; j++ )
	{
		szEntry.Format( "sLotApd%d_%d", i, j );
		sLotApd[j] = pApp->GetProfileString("GLS_DATA", (LPCTSTR)szEntry, "NULL" );
	} */
}

void CGlassInfo::WriteProfileGlassData(int i)
{
	m_IniConfiguration.Open("GlassData", "GLSINFO" );
	CString szEntry;
	CString szSection;

	szSection.Format( "GLASS DATA : %d", i );
//----------------------------------------------------------------------------------------------
// Description : EQP GLASS DATA
//----------------------------------------------------------------------------------------------
 	szEntry.Format( "bIsValid%d", i );
	m_IniConfiguration.SetIntValue( szSection, szEntry, bIsValid, TRUE );
	szEntry.Format( "nGlassNo%d",i );
	m_IniConfiguration.SetIntValue( szSection, szEntry, nGlassNo, TRUE );
	szEntry.Format( "nPortNo%d",i );
	m_IniConfiguration.SetIntValue( szSection, szEntry, nPortNo, TRUE );
	szEntry.Format( "nSlotNo%d",i );
	m_IniConfiguration.SetIntValue( szSection, szEntry, nSlotNo, TRUE );
	szEntry.Format( "nGlassSlot%d", i );
	m_IniConfiguration.SetIntValue( szSection, szEntry, nGlass_slot, TRUE );
//----------------------------------------------------------------------------------------------
// Description : CIM PC -> CLEANER DATA
//----------------------------------------------------------------------------------------------
	szEntry.Format( "sPortNo%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sPortNo, TRUE );
	szEntry.Format( "sSlotNo%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sSlotNo, TRUE );
	szEntry.Format( "sRecipeId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sRecipeId, TRUE );
	szEntry.Format( "sWaferId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sWaferId, TRUE );
	szEntry.Format( "sLotId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sLotId, TRUE );
	szEntry.Format( "sCassetteId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sCassetteId, TRUE );
	szEntry.Format( "sCassetteSlotNo%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sCassetteSlotNo, TRUE );
/*	
	szEntry.Format( "sPortRcpId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sPortRcpId, TRUE );
	szEntry.Format( "sPPId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sPPId, TRUE );
*/
	szEntry.Format( "sGlassId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sGlassId, TRUE );

	szEntry.Format( "sRecipIdFull%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sRecipeIdFull, TRUE );

	szEntry.Format( "sCassettePortNo%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sCassettePortNo, TRUE );
/*
	szEntry.Format( "sOperationId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sOperationId, TRUE );
	szEntry.Format( "sOperationNo%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sOperationNo, TRUE );
*/
	//Trace Pos 2008.11.08 kimgun
	//////////////////////////////////////////////////////////////////////////
	szEntry.Format( "nMultiTraceKey%d", i );
	m_IniConfiguration.SetIntValue( szSection, szEntry, nMultiTraceKey, TRUE );
	szEntry.Format( "sGlassHeadPos%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sGlassHeadPos, TRUE );
	szEntry.Format( "sGlassTailPos%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sGlassTailPos, TRUE );
	//////////////////////////////////////////////////////////////////////////
	szEntry.Format( "sProcessFlag%d", i );
	m_IniConfiguration.SetIntValue( szSection, szEntry, bProcessFlag, TRUE );

	for( int j=0; j<MAX_APD_DATA_NO; j++ )
	{
		szEntry.Format( "sApdData%d_%d", i, j );
		m_IniConfiguration.SetStringValue(szSection, (LPCTSTR)szEntry, sApdData[j], TRUE );
	}
}

//////////////////////////////////////////////////////////////////////
// CPortInfo Construction/Destruction
//////////////////////////////////////////////////////////////////////
CPortInfo::CPortInfo()
{
	nInNum  = 0;
	nOutNum = 0;
	ClearPortInfo();
	m_EmptyGlass.nSlotNo = -1;
}

CPortInfo::~CPortInfo()
{

}

void CPortInfo::ClearGlassState()
{
	for( int i=0; i<MAX_SLOT_NO; i++ )
	{
		m_GlsInfo[i].ClearGlassInfo();
		m_GlsInfo[i].nSlotNo = i;

		cProcessFlag[i]		= '0';
		sSlotNo[i]			= "";
		sGlassId[i]			= "";
		sOpGlassId[i]		= "";
		sGlassRcpId[i]		= "";
		sGlassLotId[i]      = ""; //08HC06
		sPAIRGlassId[i]		= "";

		bGlassMap[i]				= FALSE;
		bGlassMapSel[i]				= FALSE;
		bGlassMapProcess[i]			= FALSE;

		cGlassJudge[i];			// A[1]
		cGlassSortType[i];		// A[1]
		cGlassSampleFlag[i];	// A[1]
		cRwkCount[i];			// A[1]
	}
}

CGlassInfo& CPortInfo::GetNextInputGlass()
{
	for( int i=0; i<MAX_SLOT_NO; i++ )
	{
		if( m_GlsInfo[i].nState == CGlassInfo::glsPROC ) return m_GlsInfo[i];
	}

	return m_EmptyGlass;
}

CGlassInfo& CPortInfo::GetNextOutputGlass()
{
	// Out from down to up
//	for( int i=0; i<MAX_SLOT_NO; i++ )
//	{
//		if( m_GlsInfo[i].nState == CGlassInfo::glsREADY ) return m_GlsInfo[i];
//	}

	// Out from up to down (050509 by KDS)
	for( int i=MAX_SLOT_NO - 1; i>=0; i-- )
	{
		if( m_GlsInfo[i].nState == CGlassInfo::glsREADY ) return m_GlsInfo[i];
	}

	return m_EmptyGlass;
}

char CPortInfo::GetGlassOrder()
{
	int nReadyNum = 0, nProcNum = 0, nEndNum = 0, nScrapNum = 0;

	for( int i=0; i<MAX_SLOT_NO; i++ )
	{
		if( m_GlsInfo[i].nState == CGlassInfo::glsREADY ) nReadyNum += 1;
		else if( m_GlsInfo[i].nState == CGlassInfo::glsPROC ) nProcNum += 1;
		else if( m_GlsInfo[i].nState == CGlassInfo::glsEND ) nEndNum += 1;
		else if( m_GlsInfo[i].nState == CGlassInfo::glsSCRAP ) nScrapNum += 1;
	}

	if( nReadyNum == 1 && !nProcNum )   
	{	
		if( !nEndNum && !nScrapNum ) return '3'; // Only Glass...
		else return '2'; // Last Glass...
	}
	else if( nReadyNum == 1 ) return '2';
	else if( nReadyNum > 1 && !nProcNum && !nEndNum  ) return '0'; // First Glass...
	else return '1'; // Middle Glass...
}

void CPortInfo::SetMapData( CString sMapData )
{
	if( sMapData.GetLength() < MAX_SLOT_NO ) return;

	for( int i=0; i<MAX_SLOT_NO; i++ )
	{
		if( sMapData.GetAt( i ) == '1' ) 
			 m_GlsInfo[i].nState = CGlassInfo::glsEXIST;
		else m_GlsInfo[i].nState = CGlassInfo::glsEMPTY;
	}
}

void CPortInfo::SetMapData( BOOL* bMap )
{
	for( int i=0; i<MAX_SLOT_NO; i++ )
	{
		if( bMap[i] ) m_GlsInfo[i].nState = CGlassInfo::glsEXIST;
		else m_GlsInfo[i].nState = CGlassInfo::glsEMPTY;
	}
}

int CPortInfo::GetGlassState( int nSlotNo )
{
	if( nSlotNo < 0 || nSlotNo >= MAX_SLOT_NO ) return 0;
	return m_GlsInfo[nSlotNo].nState;
}

void CPortInfo::SetGlassState( int nSlotNo, int nState )
{
	if( nSlotNo < 0 || nSlotNo >= MAX_SLOT_NO ) return;

	m_GlsInfo[nSlotNo].nState = nState;
}

int CPortInfo::GetRealGlassNo()
{
	int nGlassNo = 0;

	for( int i=0; i<MAX_SLOT_NO; i++ )
	{
		if( m_GlsInfo[i].nState != CGlassInfo::glsEMPTY ) nGlassNo += 1;		 
	}

	return nGlassNo;
}

int CPortInfo::GetReadyGlassNo()
{
	int nGlassNo = 0;

	for( int i=0; i<MAX_SLOT_NO; i++ )
	{
		if( m_GlsInfo[i].nState == CGlassInfo::glsREADY ) nGlassNo += 1;		 
	}

	return nGlassNo;
}

int CPortInfo::GetProcGlassNo()
{
	int nGlassNo = 0;

	for( int i=0; i<MAX_SLOT_NO; i++ )
	{
		if( m_GlsInfo[i].nState == CGlassInfo::glsPROC ) nGlassNo += 1;		 
	}

	return nGlassNo;
}

BOOL CPortInfo::IsFirstGlass()
{
	int nGlassNo = 0;

	for( int i = 0 ; i < MAX_SLOT_NO ; i ++ )
	{
		if( m_GlsInfo[i].nState == CGlassInfo::glsPROC ||
			m_GlsInfo[i].nState == CGlassInfo::glsEND ) nGlassNo += 1;
	}

	if( nGlassNo == 0 )
		return TRUE;

	return FALSE;
}

void CPortInfo::ForceAbort()
{
	for( int i = 0 ; i < MAX_SLOT_NO ; i ++ )
	{
		if( m_GlsInfo[i].nState == CGlassInfo::glsREADY ) 
			m_GlsInfo[i].nState = CGlassInfo::glsNOTSELECT;
	}
}

int CPortInfo::GetFirstGlass()
{
	int i;
	for( i = 0 ; i < MAX_SLOT_NO ; i ++ )
	{
		if( m_GlsInfo[i].nState == CGlassInfo::glsEXIST ||
			m_GlsInfo[i].nState == CGlassInfo::glsREADY ||  
			m_GlsInfo[i].nState == CGlassInfo::glsPROC ||  
			m_GlsInfo[i].nState == CGlassInfo::glsEND ) 
			break;
	}

	if( i == MAX_SLOT_NO)	i--;
	return i;
}

int CPortInfo::GetLastGlass()
{
	int nGlassNo = -1;

	// Out from down to up
//	for( int i = 0 ; i < MAX_SLOT_NO ; i ++ )
//	{
//		if( m_GlsInfo[i].nState == CGlassInfo::glsEXIST ||
//			m_GlsInfo[i].nState == CGlassInfo::glsREADY ||  
//			m_GlsInfo[i].nState == CGlassInfo::glsPROC ||  
//			m_GlsInfo[i].nState == CGlassInfo::glsEND ) 
//			nGlassNo = i;
//	}

	// Out from up to down (050509 by KDS)
	for( int i=MAX_SLOT_NO - 1; i>=0; i-- )
	{
		if( m_GlsInfo[i].nState == CGlassInfo::glsEXIST ||
			m_GlsInfo[i].nState == CGlassInfo::glsREADY ||  
			m_GlsInfo[i].nState == CGlassInfo::glsPROC ||  
			m_GlsInfo[i].nState == CGlassInfo::glsEND ) 
			nGlassNo = i;
	}

	return nGlassNo;
}

void CPortInfo::ClearPortInfo()
{
	ClearGlassState();

	cLotProcessState	= lotIDLE;	
	cLotStatus			= lotEMPTY;			
	cLotHoldFlag		= lotNOT_HOLD;

	// Tianma Use Lot Data ------------------------
	nPortNo				= 1;
	nQty				= 0;

	sPtId				= "";
	sLotId				= "";				
	sCstId				= "";
	sPPId				= "";			
	sOpId				= "";				
	sRcpId				= "1";
	sProdcate			= "";
	sThickness			= "";
	sSlotInfo			= "";
	sSlotInfoSel		= "";
	sSlotInfoMap		= "";
	sPortStatus			= "";
	sPortType			= "PB";

	sGlassOrder			= "";
	sPAIRlotId			= "";

	cLdState			= modeIDLE;
	cPortMode			= modeENABLE;			
//	cTrsMode			= modeAGV;
	bCstExist			= FALSE;

	nSourcePortNo		= 1;
	nTargetPortNo		= 1;
	nJobMode			= jobU_MODE;				
	// ---------------------------------------------

	cPCode				= '0';				
	cRCode				= '0';				
	sBatchGroupId		= "";		
	sBatchId			= "";			
	sLotType			= "";			
	sOperationNo		= "";		
	cHFlag				= '0';				
	sRecipeIdChangeTime	= "";
	sSamplingRatio		= "";

	sTCNT				= "";				
	sPCNT				= "";				

	nTSIP				= 1;					
	// Maybe delete
	cBendParam			= 0;
	for( int i=0; i<MAX_LOT_APD_NO; i++ ) sLotApd[i] = "";
}

void CPortInfo::SetLotApd()
{
	int nCount=0;
	double fSum=0.0;
	for( int i=0; i<MAX_LOT_APD_NO; i++ )
	{
		nCount=0, fSum=0.0;
		for( int j=0; j<MAX_SLOT_NO; j++ )
		{
			if( m_GlsInfo[j].nState == CGlassInfo::glsPROC ||  
				m_GlsInfo[j].nState == CGlassInfo::glsEND ) 
			{
				nCount++;
				fSum += atof( m_GlsInfo[j].sLotApd[i] );
			}
		}
		sLotApd[i].Format("%.2f", (float)(fSum/nCount));
	}
}

void CPortInfo::WriteProfilePortInfo(int i)
{
	m_IniConfiguration.Open("GlassData", "PORTINFO" );
	CString szEntry;
	CString szSection;

	szSection.Format( "PORT DATA (%d)", i );

	szEntry.Format( "bIsValid%d",i );
	m_IniConfiguration.SetIntValue( szSection, szEntry, bCstExist, TRUE );

	szEntry.Format( "sPtId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sPtId, TRUE );

	szEntry.Format( "sLotId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sLotId, TRUE );

	szEntry.Format( "sCstId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sCstId, TRUE );

	szEntry.Format( "sPPId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sPPId, TRUE );

	szEntry.Format( "sRcpId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sRcpId, TRUE );

	szEntry.Format( "sOpId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sOpId, TRUE );

	szEntry.Format( "sProdId%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sProdId, TRUE );

	szEntry.Format( "sProdcate%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sProdcate, TRUE );

	szEntry.Format( "cLotJudge%d", i );
	m_IniConfiguration.SetIntValue( szSection, szEntry, cLotJudge, TRUE );

	szEntry.Format( "cLotSortType%d", i );
	m_IniConfiguration.SetIntValue( szSection, szEntry, cLotSortType, TRUE );

	szEntry.Format( "nQty%d", i );
	m_IniConfiguration.SetIntValue( szSection, szEntry, nQty, TRUE );

	szEntry.Format( "sThickness%d", i );
	m_IniConfiguration.SetStringValue( szSection, szEntry, sThickness, TRUE );

	for( int j = 0 ; j < MAX_SLOT_NO ; j++ )
	{
		szEntry.Format( "GlsInfo%d.nSlotNo%d", i, j );
		m_IniConfiguration.SetIntValue( szSection, szEntry, m_GlsInfo[j].nSlotNo, TRUE );

		szEntry.Format( "GlsInfo%d.sGlassId%d", i, j );
		m_IniConfiguration.SetStringValue( szSection, szEntry, sGlassId[j], TRUE );

		szEntry.Format( "GlsInfo%d.sOpGlassId%d", i, j );
		m_IniConfiguration.SetStringValue( szSection, szEntry, sOpGlassId[j], TRUE );

		szEntry.Format( "GlsInfo%d.cGlassJudge%d", i, j );
		m_IniConfiguration.SetIntValue( szSection, szEntry, cGlassJudge[j], TRUE );
		
		szEntry.Format( "GlsInfo%d.cGlassSortType%d", i, j );
		m_IniConfiguration.SetIntValue( szSection, szEntry, cGlassSortType[j], TRUE );
		
		szEntry.Format( "GlsInfo%d.cGlassSampleFlag%d", i, j );
		m_IniConfiguration.SetIntValue( szSection, szEntry, cGlassSampleFlag[j], TRUE );

		szEntry.Format( "GlsInfo%d.cRwkCount%d", i, j );
		m_IniConfiguration.SetIntValue( szSection, szEntry, cRwkCount[j], TRUE );

		szEntry.Format( "GlsInfo%d.sPAIRGlassId%d", i, j );
		m_IniConfiguration.SetStringValue( szSection, szEntry, sPAIRGlassId[j], TRUE );
		
		//szEntry.Format( "GlsInfo%d.bGlassMapSel%d", i, j );
		//pApp->WriteProfileInt( "PORT_DATA", (LPCTSTR) szEntry, m_GlsInfo[j].bGlassMapSel );
		
//		if( m_pDicsData->m_PortInfo[i].m_GlsInfo[j].cProcessFlag == 'Y' )
//			m_pDicsData->m_PortInfo[i].bGlassMapSel[j] = TRUE;
//		else
//			m_pDicsData->m_PortInfo[i].bGlassMapSel[j] = FALSE;
	}	
}

void CPortInfo::GetProfilePortInfo(int i)
{
	m_IniConfiguration.Open("GlassData", "PORTINFO" );
	CString szEntry;
	CString szSection;

	szSection.Format( "PORT DATA (%d)", i );

	// Default arguments
	szEntry.Format( "bIsValid%d",i );
	bCstExist = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );

	szEntry.Format( "sPtId%d", i );
	sPtId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );

	szEntry.Format( "sLotId%d", i );
	sLotId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );

	szEntry.Format( "sCstId%d", i );
	sCstId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );

	szEntry.Format( "sPPId%d", i );
	sPPId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );

	szEntry.Format( "sRcpId%d", i );
	sRcpId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
			
	szEntry.Format( "sOpId%d", i );
	sOpId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );

	szEntry.Format( "sProdId%d", i );
	sProdId = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );

	szEntry.Format( "sProdcate%d", i );
	sProdcate = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
			
	szEntry.Format( "cLotJudge%d", i );
	cLotJudge = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );
			
	szEntry.Format( "cLotSortType%d", i );
	cLotSortType = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );

	szEntry.Format( "nQty%d", i );
	nQty = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );
			
	szEntry.Format( "sThickness%d", i );
	sThickness = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );

	for( int j = 0 ; j < MAX_SLOT_NO ; j++ )
	{
		szEntry.Format( "GlsInfo%d.nSlotNo%d", i, j );
		m_GlsInfo[j].nSlotNo = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );

		szEntry.Format( "GlsInfo%d.sGlassId%d", i, j );
		sGlassId[j] = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );

		szEntry.Format( "GlsInfo%d.sOpGlassId%d", i, j );
		sOpGlassId[j] = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );

		szEntry.Format( "GlsInfo%d.cGlassJudge%d", i, j );
		cGlassJudge[j] = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );
		
		szEntry.Format( "GlsInfo%d.cGlassSortType%d", i, j );
		cGlassSortType[j] = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );
		
		szEntry.Format( "GlsInfo%d.cGlassSampleFlag%d", i, j );
		cGlassSampleFlag[j] = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );

		szEntry.Format( "GlsInfo%d.cRwkCount%d", i, j );
		cRwkCount[j] = m_IniConfiguration.GetIntValue( szSection, szEntry, 0 );

		szEntry.Format( "GlsInfo%d.sPAIRGlassId%d", i, j );
		sPAIRGlassId[j] = m_IniConfiguration.GetStringValue( szSection, szEntry, "" );
		
		//szEntry.Format( "GlsInfo%d.bGlassMapSel%d", i, j );
		//pApp->WriteProfileInt( "PORT_DATA", (LPCTSTR) szEntry, m_GlsInfo[j].bGlassMapSel );
		
//		if( m_pDicsData->m_PortInfo[i].m_GlsInfo[j].cProcessFlag == 'Y' )
//			m_pDicsData->m_PortInfo[i].bGlassMapSel[j] = TRUE;
//		else
//			m_pDicsData->m_PortInfo[i].bGlassMapSel[j] = FALSE;
	}
}

