// PortInfo.h: interface for the CPortInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PORTINFO_H__AFD83FB7_BC95_4590_863F_B70BE6FF4CA5__INCLUDED_)
#define AFX_PORTINFO_H__AFD83FB7_BC95_4590_863F_B70BE6FF4CA5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FactoryLib\IniData.h"	// Added by ClassView
class CGlassInfo : public CObject
{
public:
	CGlassInfo();
	CGlassInfo( int nSlotNo, int nState=glsREADY );
	virtual ~CGlassInfo();

	CGlassInfo& operator =(const CGlassInfo &glsinfo);
	CGlassInfo& operator =(const int nState);
	CIniData	m_IniConfiguration;

	BOOL		bIsValid;		// Unloading Ϸ  FALSE
	int			nGlassNo;		// Logical Glass No  (For glass animation)
	int			nGlass_slot;	// CLN  Slot No. : ljy_050617
	BOOL		bProcessed;
	char		cRcpChangeFlag;
	enum	_RCP_CHANGE_FLAG	{ rcpNOT_CHANGED = '0', rcpCHANGED =  '1' };
	char		cProcessFlag;	// '0' : No Process, '1' : Process
	enum glsPROC_FLAG { glsPROC_NG = '0', glsPROC_OK = '1' };
	int			nState;

	enum glsSTATE { glsEMPTY, glsEXIST, glsNOTSELECT, glsEMPTY_LOCK, glsREADY, glsPROC, glsEND, glsSCRAP };

public:
	//////////////////////////////////////////////////////////////
	// Glass Information
	int			nSlotNo;
	CString		sSlotNo;

	int			nPortNo;
	CString		sPortNo;

	CString		sLotId;				 //A[20]	:	Lot ID		// 08HC06
	CString		sCassetteId;		 //A[20]	:	Cassette ID // 08HC06
	CString		sRecipeId;			 //A[20]	:	Recipe ID
	CString		sRecipeIdFull;		 //A[20]	:	FULL Recipe ID - hskwak 20191014 Recipe ID +  Ǿ ְ ڴ Recipe ID .   Data Unload  ϹǷ ߰.
	CString		sOpId;				 //A[10]    :	Operation ID  // 08HC06
	CString		sProdId;			 //A[20]	:	Product	ID
	CString		sGlassId;			 //A[20]	:	Glass ID    // 08HC06
	CString		sOpGlassId;			 //A[20]	:	Glass ID
	CString		sPPId;                                          // 08HC06
	CString		sPortRcpId;	
	CString		sCassettePortNo;
	// ---------------------------------------------
	
	CString		sPostRcpId;	
	CString		sCassetteSlotNo;
	CString		sGlassType;
	CString		sRcpIdChangeTime;
	CString		sWaferId;
	CString		sOperationId;
	CString		sOperationNo;

	BOOL		bProcessFlag;	// hskwak 20190531
	CString		sReserved;		// hskwak 20190531

	unsigned short	nGlassData[5];
	CString		sGlassData[5];
	int			nCstSeqNo;
	int			nLineControl;
	int			nMaterialNo;
	int			nMaintainCst;
	int			nBendingPara;
	int			nLdRecipeId;
	int			nUlRecipeId;
	int			nMultiTraceKey;//2008.11.07 kimgun
	CString		sGlassHeadPos;//2008.11.07 kimgun
	CString		sGlassTailPos;//2008.11.07 kimgun
	CString		sApdData[MAX_APD_DATA_NO];	
	CString		sLotApd[MAX_LOT_APD_NO];	// Lot APD Data
	//////////////////////////////////////////////////////////////
	CString		sGlassApd[MAX_APD_DATA_NO];	// APD Data // 08HC06
	COleDateTime	UlWaitTime;	// 110609 halesu

public:
	void GetProfileGlassData(int i);
	void WriteProfileGlassData(int i);
	CString GetGlassID();
	void ClearGlassInfo(); 
};

class CPortInfo : public CObject  
{
public:
	CPortInfo();
	virtual ~CPortInfo();
	int GetLastGlass();
	int GetFirstGlass();
	void ForceAbort();
	BOOL IsFirstGlass();

public:
	CGlassInfo& GetNextOutputGlass();
	CGlassInfo& GetNextInputGlass();

	void SetMapData( CString sMapData );
	void SetMapData( BOOL* bMap );
	char GetGlassOrder();

	int  GetGlassState( int nSlotNo );
	void SetGlassState( int nSlotNo, int nState );
	void ClearGlassState();

	int GetRealGlassNo();
	int GetReadyGlassNo();
	int GetProcGlassNo();

	CGlassInfo m_GlsInfo[MAX_SLOT_NO];
	void ClearPortInfo();
	void SetLotApd();

	CIniData	m_IniConfiguration;

public:
	void GetProfilePortInfo(int i);
	void WriteProfilePortInfo(int i);

	enum	_JOBMode			{ jobU_MODE, jobI_MODE };
	enum	_PORT_MODE			{ modeRUN = 'R', modeIDLE = 'I', modeDOWN = 'D' };
	enum	_PORT_LD_MODE		{ modeLR = '0', modeLC = '1' };
	enum	_PORT_UL_MODE		{ modeUR = '0', modeUC = '1' };
	enum	_PORT_ENABLE_MODE	{ modeENABLE = '8', modeDISABLE = '9' };
	enum	_PORT_U_MODE		{ modeNORMAL = 'N', modeSORTER = 'S', modeLD = 'L', modeUL = 'U' };
	enum	_PORT_STATUS		{ portEMPTY = 1, portEMPTY_CST = 2, portWAITS = 3, portPROCESSING = 4, 
								  portEnd = 5, portCANT_USED = 7 };
	enum	_TRS_MODE			{ modeAGV = 'A', modeMGV = 'M' };
	// enum : Lot info
	enum	_LOT_PROCESS_STATE	{ lotIDLE = '0', lotRUNNING =  '1' };
	enum	_LOT_STATUS			{ lotWAIT = 'W', lotPROCESSING = 'I', lotEND = 'T', lotABNORMAL_END = 'F', 
								  lotABORT = 'A', lotEMPTY = 'E', lotCANCEL = 'C', lotEXIST = 'X' };
	enum	_LOT_HOLD_FLAG		{ lotHOLD = 'Y', lotNOT_HOLD = 'N', lotPROCESS_HOLD = 'P' };
	//////////////////////////////////////////////////////////////
	// Port Information
	int		nInNum;
	int		nOutNum;
	char	cLotProcessState;		// A[1] '0' : Idle, '1' Running
	char	cLotStatus;				// A[1] 'W' : Wait, 'I' : Processing, 'T' : End, 'F' : Abnormal End, 'A' : Abort, 'E' : Empty
	char	cLotHoldFlag;			// A[1]	'Y' : Hole, 'N' : Not Hold, 'P' : Process Hold

	int		nPortNo;				// B[1]

	// Tianma Use Lot Data ------------------------
	CString sModuleId;				// A[08]
	CString sPtId;					// A[03]
	CString sLotId;					// A[20]
	CString sCstId;					// A[20]
	CString sPPId;					// A[20]
	CString sRcpId;					// A[20]
	CString sOpId;					// A[10]
	CString sProdId;				// A[20]
	CString sProdcate;				// A[04]
	CString	sLotType;				// A[01] 
	CString sThickness;				// A[05]
	CString	sSlotInfo;				// A[25]
	CString	sSlotInfoSel;			// A[25]
	CString	sSlotInfoMap;			// A[25]

	CString sSlotNo[MAX_SLOT_NO];	// A[3]
	CString sGlassId[MAX_SLOT_NO];	// A[20]
	CString sOpGlassId[MAX_SLOT_NO];	// A[20]

	int		nQty;				// A[2]

	char cLotJudge;				// A[1]
	char cLotSortType;			// A[1]
	char cEsFlag;				// A[1]

	char cGlassJudge[MAX_SLOT_NO];			// A[1]
	char cGlassSortType[MAX_SLOT_NO];		// A[1]
	char cGlassSampleFlag[MAX_SLOT_NO];		// A[1]
	char cRwkCount[MAX_SLOT_NO];			// A[1]

	CString sPAIRGlassId[MAX_SLOT_NO];		// A[20]
	CString sGlassOrder;					// A[11]
	CString sPAIRlotId;						// A[20]
	// ---------------------------------------------

	CString sGlassRcpId[MAX_SLOT_NO];	// A[16]
	CString sGlassLotId[MAX_SLOT_NO]; //08HC06

	CString sStartTime;
	CString sEndTime;
	CString sPortStatus;			// LR, LC, UR, UC
	CString	sPortType;				// 1 "PB" L/UL, 2 "PL" L , 3 "PU" UL, 4 "BB" Buffer L/UL, 5 "BL" L, 6 "BU" 

	char	cPortMode;				// Enable, Disable
	char	cUseType;				// O Ok(or Source), G , N , R Rework, P rePair, S Scrap 
	char	cProcessFlag[MAX_SLOT_NO];	// Not report
	char	cAbortStatus;
	char	cLdState;
	char	cPortStatus;
	char	cPortLdMode;			// A[1] : N=Normal, S=Sorter, L=LD, U=UNLD
	char	cTrsMode;

	int		bGlassMapSel[MAX_SLOT_NO];
	int		bGlassMap[MAX_SLOT_NO];
	int		nSourcePortNo;
	int		nTargetPortNo;
	int		nJobMode;				// jobI_MODE, jobU_MODE

	BOOL	bCstExist;
	BOOL	bOfflineLotStart;
	BOOL	bGlassMapProcess[MAX_SLOT_NO];
	//-------------------------------------------

	char	cPCode;					// '0' : Lot Process Data, '1' : Glass & Lot Process Data
	char	cRCode;					// '0' : Can't change recipe ID, '1' : Can change recipe ID
	char	cHFlag;					// A[1]

	CString sSourceCstId;
	CString sTargetCstId;
	CString	sBatchGroupId;			// A[16]
	CString	sBatchId;				// A[16]
	CString	sOperationNo;			// A[8]
	CString	sRecipeIdChangeTime;	// A[12]
	CString	sSamplingRatio;			// A[18]
	CString sTCNT;					// A[2]
	CString sPCNT;					// A[2]

	int		nTSIP;					// B[1] : 1=Port Empty, 2=Empty Cassette, 3=Wait, 4=Processing, 5=End, 7=Port can't be used now
	
	// Maybe delete
	char	cBendParam;
	CString sLotApd[MAX_LOT_APD_NO];	// Lot APD Data
	//////////////////////////////////////////////////////////////

private:
	CGlassInfo m_EmptyGlass;
};

#endif // !defined(AFX_PORTINFO_H__AFD83FB7_BC95_4590_863F_B70BE6FF4CA5__INCLUDED_)
