///////////////////////////////////////////////
//	XSecs.h
//	Ver 1.0b
///////////////////////////////////////////////

#ifndef __SECS_H__
#define __SECS_H__
//#define __LOG__ // Host Log...//2009.04.22 KIMGUN  ּ.

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <afxsock.h> // MFC socket extensions
#include <afxtempl.h>
#include <afxmt.h>
//HSMS#include "CommThread.h"
#include "XSecsSFCode.h"
#include "XSocket.h"
#include "..\X\XLog.h"
typedef unsigned char BYTE;

#define WM_TERMINAL_MSG		WM_USER + 1100
#define WM_SECS_MSG			WM_USER + 1200
#define WM_SOCKET_WRITE		WM_USER + 1300

/*
	<Usage>

    XSecsControl Secs;

	Secs.OpenPort( "COM1", _9600|_N|_8|_1 );
	Secs.S1F1.Send( "P.Clnr", "v1.0" );
	//Secs.Send( "S1F1", "P.Clnr", "v1.0" );
	Wait( Secs.S1F1.Sended );

	Secs.Transaction( "S1F1" ).Send( "P.Clnr", "v1.0" );
	Secs.Transaction( "Online Request" ).Send( "P.Clnr", "v1.0" );
	//Transaction( char *SmFn ); // Get SmFn Message
	//AbortTransaction(S*F0)
*/
/*
	Defines for Event Message and params

	WM_SECS_MSG
		wParam
			smConnected
			smDisconnected
			smPrimaryIn
			smPrimaryOut
			smSecondaryIn
			smSecondaryOut
			smMonitor
			smError
			smWarning
		lParam
			CObject...
*/

//class XSecs;
class XSecsLibrary;
class XSecsTransaction;
class XSecsTranxThread;
class XSecsMessageBlock;
class XSecsItem;
class XSecsHSMS;

typedef struct { char bytes[4]; } SYSTEMBYTES;

class XSDFToken : public CString  
{
public:

	enum XSDFTokenType {
		ttBDeclaration,
		ttSFCode,
		ttItemName, 
		ttDescription, 
		ttOther
	};

	XSDFTokenType Type;
	XSDFToken();
	virtual ~XSDFToken();
};

class XSDFTokenList  
{
public:
	void LexicalAnalysis( CString& szBuf, XLog* pLog );
	XSDFToken& GetCur();
	XSDFToken& GetNext();
	XSDFToken& GetPrev();
	XSDFToken& GetHead();
	XSDFTokenList();
	virtual ~XSDFTokenList();

protected:
	XSDFToken m_xNull;
	CTypedPtrList<CPtrList,XSDFToken*> m_xTokenList;
	POSITION m_pos;
};

class XSecsItem
{
public:
	XSecsItem();
	~XSecsItem();

	XSecsItem& operator[]( int idx );

	BOOL GetData( void *lpData );
	void SetData( LPCTSTR lpData, int iLength=256 );
	void SetData( const char chValue );
	void SetData(const UINT uValue);
	void SetData( const int iValue );
	void SetData( unsigned char* lpData, int iLength );

	void SetListSize();
	void SetListSize(int iDepth, int iLength, int iTargetLen = -1, int iIncDepth=0, int iTargetList = -1, int iIncList=0);
	int GetListSize(int iDepth, int iIncDepth = 0);

	XSecsItem* FindItem( int iItemNo );
	XSecsItem* FindItem( LPCTSTR lpszName, int iDepth = 0, BOOL bDelete = FALSE);
	void SaveAllItems(XLog* pLog, int iDepth = 0 );

	int GetSize();
	void Format( int iItemNo, LPCTSTR lpszName, LPCTSTR lpszDescription, BYTE byteFormat, int iLength );
	int ParseIHData( BYTE* lpFormatted, BYTE* lpInput );
	int FindIHData(BYTE *lpFormatted, BYTE *lpInput);
	void BuildIHData( BYTE* buf );

//FormatConstant	Value	Description
//wsFormatList		0	SECS item list
//wsFormatBinary	8	SECS binary item
//wsFormatBoolean	9	SECS Boolean item (one byte, zero = False, non-zero = True)
//wsFormatAscii		16	SECS ASCII item		( 00010000 00 => 40h )
//wsFormatJis8		17	SECS JIS8 item
//wsFormatI2		26	SECS signed integer item, 2 bytes
//wsFormatI1		25	SECS signed integer item, 1 byte
//wsFormatI8		24	SECS signed integer item, 8 bytes
//wsFormatI4		28	SECS signed integer item, 4 bytes
//wsFormatF8		32	SECS floating point item, 8 byte IEEE format
//wsFormatF4		36	SECS floating point item, 4 byte IEEE format
//wsFormatU8		40	SECS unsigned integer item, 8 bytes
//wsFormatU4		44	SECS unsigned integer item, 4 bytes
//wsFormatU2		42	SECS unsigned integer item, 2 bytes
//wsFormatU1		41	SECS unsigned integer item, 1 bytes
//wsFormatVar		63	SECS format inferred from Variant data type

	enum ItemFormat {
		wsFormatList	= 0x00,
		wsFormatBinary	= 0x20,
		wsFormatBoolean	= 0x24,
		wsFormatI2		= 0x68,
		wsFormatU4		= 0xB0,
		wsFormatU2		= 0xA8,
		wsFormatU1		= 0xA4,
		wsFormatAscii	= 0x40,
		wsFormatNull	= 0xff,
		wsFormatVirtualList	= 0xff,
	};

private:
	int			m_iItemNo;
	BYTE		m_byteFormat;
	int			m_iLength; // length with m_byteFormat size
	int			m_iBackupLength; // length with m_byteFormat size
	int			m_iByteLength; // data size, except IH = data block size???
	void*		m_lpData;
	CString		m_szName;
	CString		m_szDescription;
};

class XSecsMessage
{
protected:
	int			m_iLDataBlockSize;
	void ClearAll();
	CTypedPtrList<CPtrList,XSecsMessageBlock*> m_MessageBlockList;
	XSecsItem	m_Item;
	BYTE*		m_lpBuf;					// merge data block
	int			m_iNItems;
	int			m_iNumOfBlocks;
	BYTE		m_byteSystemBytes[4];
	int			m_iDeviceID;
	CString		m_szName;
	CString		m_szDescription;
	int			m_iStreamCode;
	int			m_iFunctionCode;
	int			m_iDirectionFlag;
	int			m_iWaitFlag;

public:
	XSecsMessage(XSecsMessage& msg);
	XSecsMessage();
	virtual ~XSecsMessage();
	XSecsMessage& operator =(XSecsMessage &msg);
	XSecsMessageBlock& operator[]( int idx );

	CMutex		m_mutex;
	char*		m_cHead;


public:
	int		GetSFCode();
	int		GetWaitFlag();
	int		GetFunctionCode();
	int		GetStreamCode();
	int		GetDirection();
	UINT	GetDeviceID();
	void	SetDeviceID( int iDevID=1 );
	//void GetHeader(BYTE* szHeader);
	void	SetHeader( LPCTSTR lpszName, LPCTSTR lpszDescription, int iDirectionFlag, int iWaitFlag );
	void	SetSystemBytes( SYSTEMBYTES sysBytes );
	void	GetSystemBytes( SYSTEMBYTES *sysBytes );
	int		GetListSize(int iDepth);
	void	SetListSize();
	void	SetListSize(int iDepth, int iLength, int iTargetLen = -1, int iTargetList = -1);
	void	AddNewItem( LPCTSTR lpszName, LPCTSTR lpszDescription, BYTE byteFormat, int iLength );
	BOOL	GetItemData( char* lpszName, void* pBuf );
	void	SetItemData(LPCTSTR lpszName, const char chValue, BOOL bDelete = FALSE );
	void	SetItemData( LPCTSTR lpszName, int iValue, BOOL bDelete = FALSE );
	void	SetItemData( LPCTSTR lpszName, UINT uValue, BOOL bDelete = FALSE );
	void	SetItemData( int iItemNo, LPCTSTR pBuf, int iLength);
	void	SetItemData( LPCTSTR lpszName, LPCTSTR pBuf, int iLength=256, BOOL bDelete = FALSE );
	void	SetItemData( LPCTSTR lpszName, unsigned char* pBuf, int iLength=256, BOOL bDelete = FALSE );
	int		SetItemData( XSecsMessage& msg );
	int		FindItemData(XSecsMessage &msg);
	int		GetNumOfBlocks();
	int		MergeMsgBlocks();
	int		AddMsgBlock( XSecsMessageBlock& msgBlock );
	int		Parse(BYTE *lpBuf);
	int		Build();
	void	BuildSFLog(XLog* pLog);

	enum Direction { toHost, fromHost };
	enum WaitFlag { waitFlagOn, waitFlagOff };
};

class XSecsMessageBlock
{
friend class XSecsMesasge;
protected:
	int		m_iDataBlockSize;
	int		m_iDeviceID;
	int		m_iStreamCode;
	int		m_iFunctionCode;
	int		m_iDirectionFlag;
	int		m_iWaitFlag;
	int		m_iBlockNo;
	int		m_iEndBlockFlag;
	BYTE	m_byteSystemBytes[4];
	BYTE*	m_lpBuf; // length + header + data block + checksum

	void	ClearAll();
public:
	char m_cHead[10];
	XSecsMessageBlock( XSecsMessageBlock &msgBlock );
	XSecsMessageBlock();
	~XSecsMessageBlock();

	XSecsMessageBlock& operator =(XSecsMessageBlock &msg);

	void	SetHeader( int iDeviceID, int iStreamCode, int iFunctionFlag, int iDirectionFlag, int iWaitFlag, int iBlockNo, int iEndBlockFlag, BYTE byteSystemBytes[] );
	void	GetHeader(BYTE* szHeader);

	int		GetBuf( unsigned char* lpBuf );
	void	Build(BYTE *lpDataBlock, int iDataBlockSize);
	BOOL	Parse( BYTE* lpBuf );

	int		GetBufSize();
	int		GetBlockNo();
	BOOL	IsLastBlock();
	friend int XSecsMessage::AddMsgBlock(XSecsMessageBlock& msgBlock);
};

class XSecsTransaction
{
protected:
	long			m_lIndex;
	CString			m_szName;
	CString			m_szDescription;
	long			m_lDeviceID;
	BOOL			m_bAutoSystemBytes;
	BOOL			m_bReplyExpected;
	long			m_lSystemBytes;
public:
	XSecsMessage	Primary;
	XSecsMessage	Secondary;

public:
	XSecsTransaction( LPCTSTR SmFn, LPCTSTR Description );
	XSecsTransaction();
	~XSecsTransaction();

	void operator =(XSecsTransaction &tranx);

	CString&	GetName();
	CString&	GetDescription();
	void		SetHeader( LPCTSTR SmFn, LPCTSTR Description );

};

class XSecsLibrary
{
public:
	XSecsLibrary();
	~XSecsLibrary();

	void	SetControl( XSecsHSMS* pControl );
	void	SetDefaults();
	int		LoadSDF( LPCTSTR lpszFileName=_T("Default.sdf") );
	int		SmFnFind(int Sm, int Fn);
	void	SetDeviceID(int iDeviceID);
	void	SetLog( XLog* pLog ) { m_pLoadSDFLog = pLog; }
	XSecsTranxThread* Find( SYSTEMBYTES sysBytes );
	XSecsTranxThread* Find( int Sm, int Fn, int dir=-1 );
	XSecsTranxThread* Find( LPCTSTR szName, int iDir=-1 ); // szName = SmFn or Description
	XSecsTranxThread* Find( XSecsMessage &msg, int Sm, int Fn, int iDir=-1);
	XSecsTranxThread* AddNewTransaction( LPCTSTR SmFn, LPCTSTR Description );

protected:
	CTypedPtrList<CPtrList, XSecsTranxThread*> m_TranxList;
	XLog* m_pLoadSDFLog;

protected:
	int ParseItem( XSDFTokenList& xTokenList, XSecsMessage& xMsg );
	int ParseMsgHeader( XSDFTokenList& xTokenList, XSecsMessage& xMsg );
};

// -- Secs Interface Class
// XSecs is virtual Class !!!
//class XSecs : public XSecsHSMS
//{
//public:
//	XSecs();
//	~XSecs();
//  S1F1() { return Transaction( "S1F1" ); }
//};

/////////////////////////////////////////////////////////////////////////////
// XSecsTranxThread thread

class XSecsTranxThread : /*public CWinThread,*//*KDS041223*/ public XSecsTransaction
{
//	DECLARE_DYNCREATE(XSecsTranxThread)	//KDS041223
protected:
	XSecsTranxThread(); // protected constructor used by dynamic creation

// Attributes
public:
	CEvent		m_evSecondaryIn;
	CEvent		m_evSecondaryRcvd;
	int			m_iMessageType;
	XSecsHSMS*	m_pSECS;
	BOOL		m_bSecondaryRcvd;
	BOOL		T3_Timeout;
	BOOL		T3_FirstTimeout; // 230607 ssm
	int			ReConnetCount;	 // 230803 ssm
	CArray <SYSTEMBYTES, SYSTEMBYTES> m_ArrayPrimarySystemByte; //LYS20051221
	CArray <SYSTEMBYTES, SYSTEMBYTES> m_ArraySecondarySystemByte; //LYS20051221

// Operations
public:
	virtual ~XSecsTranxThread();
	XSecsTranxThread(LPCTSTR SmFn, LPCTSTR Description );//HSMS, XSecsControl* pControl=NULL);

	int		MsgLinkThread( int iType );
	void	SetControl( XSecsHSMS* pHSMS );
	void 	ResetSystemByte(int iType);	//HJYOU20061110///////////////////

	BOOL	IsSecondaryRcvd(BOOL bLock);
	BOOL	IsSecondaryRcvd();
	BOOL	IsPrimaryOutOK();
	int		PrimaryOut( BOOL bSetSysByte = TRUE );
	int		SecondaryOut( BOOL bSetSysByte = TRUE );
	int		PrimaryIn( XSecsMessage& msg );
	int		SecondaryIn( XSecsMessage& msg );
};

/////////////////////////////////////////////////////////////////////////////

class XSecsHSMS : public CWinThread //KDS041223
{
// Attributes
public:

// Operations
public:
	XSecsHSMS();
	DECLARE_DYNCREATE(XSecsHSMS)

	virtual ~XSecsHSMS();

	void OnAccept();
	void OnClose();
	void OnReceive();
	void SetOwnerWnd(CWnd* pOwner);
	void SetLog( XLog* pLog1, XLog* pLog2, XLog* pLog3  ) 
	{ 
		m_pSFLog = pLog1; m_pLoadSDFLog = pLog2; m_pHexLog = pLog3;
	}

	void SetLocalPortNo( int nPortNo ) {IPPortLocal = nPortNo;}
	void SetRemotePortNo( int nPortNo ) {IPPortRemote = nPortNo;}
// Overrides
public:
	XLog*			m_pSFLog;
	XLog*			m_pHexLog;
	XLog*			m_pLoadSDFLog;
	XListenSocket*	m_pListenSocket;
	XClientSocket*	m_pClientSocket;
	XClientSocket*	m_pClientSocket2;
	CWnd*			m_pOwner;
	CMutex			m_mtxSecs;
	BOOL			m_bConnected;
	BOOL			m_bSelected;
	BOOL			m_bTransComp;//2008.10.20 kimgun
	CEvent			m_evListRemove;
	CEvent			m_evListAdd;
	BOOL			m_bRetryConnect;	// 230803 ssm
	CTypedPtrList<CPtrList, XSecsTranxThread*> m_TranxList;


	char* 			IPAddressLocal;
	char* 			IPAddressRemote;
	long  			IPPortLocal;
	long  			IPPortRemote;
	long  			HSMST3; // 45
	long  			HSMST5; // 10
	long  			HSMST6; // 5
	long  			HSMST7; // 10
	long  			HSMST8; // 5
	long  			HSMST9; // 5
	long			HSMSCT;	// 5
	long  			LinkTestTimer;
	UINT			m_uDeviceID;

	int		Connect( LPCTSTR ipAddr, long port, BOOL bShowMsgBox );
	BOOL	ConnectEnable( LPCTSTR ipAddr, long port );
	int		LoadLibrary( LPCTSTR lpszFileName=NULL );
	void	SetDeviceID( UINT uID );
	void	GetSystemBytes( SYSTEMBYTES *sysBytes );
	void	AbortTransaction();
	XSecsTranxThread* Transaction( char* lpszName, int dir=-1 );

	BOOL	Start( HWND hWnd=NULL );
	void	End();

//--------------------------------------------//KDS041223
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(XSecsHSMS)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL
//KDS041223
	
// Implementation
protected:

//KDS041223
	HANDLE	m_evDead;
	HANDLE	m_evKill;

//KDS041223
	// Generated message map functions
	//{{AFX_MSG(XSecsHSMS)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
//--------------------------------------------//KDS041223

// Implementation
protected:
	CSocket m_SocketListen;
	long	m_lDefaultDeviceID;	// 0
	BOOL	m_bIgnoreSystemBytes;
	ULONG   m_ulSystemBytes;

	XSecsLibrary m_Library;
public:
	BOOL	m_bActiveMode;
	BOOL	m_bLinkTestRespRecvd;
	long	m_lRTY;
	long	m_lT1;
	long	m_lT2;
	long	m_lT3;
	long	m_lT4;
	CString m_szReceivedData;
	CString m_szMessage;
protected:	
	int			ReadMsgBlock(XSecsMessageBlock* pMsgBlock);
	int			ReadMessage();
	virtual int OnSecondaryRcvd( XSecsTranxThread *pTranx );
	virtual int OnPrimaryRcvd( XSecsTranxThread *pTranx );
	int			MessageProc( XSecsMessage& msg );
public:
	int			SelectResp( SYSTEMBYTES sysBytes );
	int			LinkTestReq();
	int			LinkTestResp( SYSTEMBYTES sysBytes );
	int			Select();
	BOOL		Write(unsigned char* lpBuf, DWORD dwLength);
//	DWORD		Read(LPSTR lpBuf, DWORD dwLength);
	DWORD		Read(unsigned char* lpBuf, DWORD dwLength);
	BOOL		Msg(UINT msg, WPARAM wParam, LPARAM lParam);

	enum ControlCharacters {
		ccENQ = 0x05,		// Request to Send
		ccEOT = 0x04,		// Request to Receive
		ccACK = 0x06,		// Correct Reception
		ccNAK = 0x15,		// Incorrect Reception
	};
	enum MessageNames {
		smConnected,
		smDisconnected,
		smMonitor,
		smPrimaryIn,
		smPrimaryOut,
		smSecondaryIn,
		smSecondaryOut,
		smError,
		smT3Error,
		smHostMessage,
		smWarning,
		smPrimaryOutError,
		smSecondaryOutError,
		smAbortTransaction,
	};
};

extern CMutex g_SecsMutex;
extern CMutex g_SecsMutexOut;
#endif //__SECS_H__
