// XSocket.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "XSecs.h"
#include "XSecs1.h"	// shcho 220525
#include "XSocket.h"
//#include "DicsCimSeq.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// XClientSocket

IMPLEMENT_DYNCREATE( XClientSocket, CSocket )

XClientSocket::XClientSocket()
{
	m_pFile = NULL;
//	m_pArchiveIn = NULL;
//	m_pArchiveOut = NULL;
}

XClientSocket::XClientSocket(XSecsHSMS* pHSMS)
{
	m_pSECS = pHSMS;
//	m_pArchiveIn = NULL;
//	m_pArchiveOut = NULL;
	m_pFile = NULL;
}

XClientSocket::~XClientSocket()
{
//	if( m_pArchiveIn ) 
//	{
//		m_pArchiveIn->Flush();
//		delete m_pArchiveIn;
//	}
//	if( m_pArchiveOut ) 
//	{
//		m_pArchiveOut->Flush();
//		delete m_pArchiveOut;
//	}
	if( m_pFile ) delete m_pFile;
}

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(XClientSocket, CSocket)
	//{{AFX_MSG_MAP(XClientSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// XClientSocket member functions
BOOL XClientSocket::Init()
{
	m_pFile = new CSocketFile( this );
//	m_pArchiveIn = new CArchive( m_pFile, CArchive::load );
//	m_pArchiveOut = new CArchive( m_pFile, CArchive::store );

//	m_pArchiveOut->Flush();
//	m_pArchiveIn->Flush();
	return TRUE; 
}

BOOL XClientSocket::Init( LPCTSTR ipAddr, long port, BOOL bShowMsgBox  )
{
	if( !Create() )
	{
		AfxMessageBox("Socket Creation Error");
		return FALSE;
	}
	Sleep( 200 );
	if( Connect( ipAddr, port ) )
	{
		m_pFile = new CSocketFile( this );
//		m_pArchiveIn = new CArchive( m_pFile, CArchive::load );
//		m_pArchiveOut = new CArchive( m_pFile, CArchive::store );

//		m_pArchiveOut->Flush();
//		m_pArchiveIn->Flush();
		Sleep( 200 );
		return TRUE;
	}
	else 
	{
		CString errMsg;
		int nErrNo = GetLastError();

		if( nErrNo==WSAENETDOWN ) 
			errMsg="The Windows Sockets implementation detected that the network subsystem failed";
		else if( nErrNo==WSAECONNREFUSED )
			errMsg="There is no connection with host! \nCheck the server status";
		else if( nErrNo==WSAEISCONN )
			errMsg="The socket is already connected.";
		else if( nErrNo==WSAENETUNREACH )
			errMsg="The network cannot be reached from this host at this time.";
		else if( nErrNo==WSAETIMEDOUT )
			errMsg="Attempt to connect timed out without establishing a connection";
		else errMsg="Connection failed";

		if( bShowMsgBox ) AfxMessageBox( errMsg, MB_ICONSTOP );
	}
	return FALSE;
}

//DWORD XClientSocket::Read(LPSTR lpBuf, DWORD dwLength)
DWORD XClientSocket::Read(unsigned char* lpBuf, DWORD dwLength)
{
	int nRead;

	// KDS050512
	if( !m_pFile ) return (DWORD) 0;

	if (!m_pFile->m_bArchiveCompatible)
	{
		int nLeft = dwLength;
		PBYTE pBuf = (PBYTE)lpBuf;

		while(nLeft > 0)
		{
			nRead = Receive(pBuf, nLeft);
			if (nRead == SOCKET_ERROR)
			{
				int nError = GetLastError();
				return 0;
			}
			else if (nRead == 0)
			{
				return dwLength - nLeft;
			}

			nLeft -= nRead;
			pBuf += nRead;
		}
		return dwLength - nLeft;
	}

	nRead = Receive(lpBuf, dwLength, 0);
	if (nRead == SOCKET_ERROR)
	{
		int nError = GetLastError();
		return 0;
	}
	return nRead;
	
//	UINT uLen;
//	uLen = m_pFile->Read( lpBuf, dwLength );
//	return (DWORD)uLen;
}

BOOL XClientSocket::Write(unsigned char* lpBuf, DWORD dwLength)
{
	if( !m_pSECS->m_bConnected ) return FALSE;

	int nWritten = Send(lpBuf, dwLength);
	if (nWritten == SOCKET_ERROR)
	{
		int nError = GetLastError();
		return 0;
	}



	//m_pFile->Write( lpBuf, dwLength );
//	m_pArchiveOut->Write( lpBuf, dwLength );
//	m_pArchiveOut->Flush();
	return TRUE;
}

void XClientSocket::OnReceive(int nErrorCode) 
{	
	CSocket::OnReceive( nErrorCode );
	/*if( nErrorCode ) TRACE( "nErrorCode = %d", nErrorCode );
	int nError = m_pFile->m_pSocket->GetLastError();*/
	//Sleep( 50 );

	// KDS050512
	if( !m_pFile ) return;

	int nLeft = 1;
	PBYTE pBuf[1];
	int nRead = m_pFile->m_pSocket->Receive(pBuf, nLeft, MSG_PEEK );
	if (nRead == SOCKET_ERROR || nRead == 0 || pBuf == NULL) return;

//	Sleep(200);
	Sleep(10);

	m_pSECS->OnReceive();
}

void XClientSocket::OnClose(int nErrorCode) 
{
	CSocket::OnClose(nErrorCode);

	m_pSECS->OnClose();
}

BOOL XClientSocket::ConnectHelper(const SOCKADDR* lpSockAddr, int nSockAddrLen)
{
	if (m_pbBlocking != NULL)
	{
		WSASetLastError(WSAEINPROGRESS);
		return  FALSE;
	}

	m_nConnectError = -1;

	if (!CAsyncSocket::ConnectHelper(lpSockAddr, nSockAddrLen))
	{
		if (GetLastError() == WSAEWOULDBLOCK)
		{
	// Insert....
			CTime		curt, st;
			CTimeSpan	span(0, 0, 0, m_nTimeOut = 0);

			st = CTime().GetCurrentTime();
	//.......
			while (PumpMessages(FD_CONNECT))
			{
				if (m_nConnectError != -1)
				{
					WSASetLastError(m_nConnectError);
					return (m_nConnectError == 0);
				}
	// Insert....
				curt = CTime().GetCurrentTime();
				if(curt > (st+span))
					return FALSE;
	//..............
			}
		}
		return FALSE;
	}
	m_Kill = FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// XListenSocket

XListenSocket::XListenSocket(XSecsHSMS* pSECS)
{
	m_pSECS = pSECS;
}

XListenSocket::XListenSocket()
{
}

XListenSocket::~XListenSocket()
{
}

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(XListenSocket, CSocket)
	//{{AFX_MSG_MAP(XListenSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// XListenSocket member functions

void XListenSocket::OnAccept(int nErrorCode) 
{	
	CSocket::OnAccept( nErrorCode );

	m_pSECS->OnAccept();
}

// shcho 220525
// XClientSocket1
IMPLEMENT_DYNCREATE( XClientSocket1, CSocket )

XClientSocket1::XClientSocket1()
{
	m_pFile = NULL;
//	m_pArchiveIn = NULL;
//	m_pArchiveOut = NULL;
}

XClientSocket1::XClientSocket1(XSecsHSMS1* pHSMS)
{
	m_pSECS = pHSMS;
//	m_pArchiveIn = NULL;
//	m_pArchiveOut = NULL;
	m_pFile = NULL;
}

XClientSocket1::~XClientSocket1()
{
//	if( m_pArchiveIn ) 
//	{
//		m_pArchiveIn->Flush();
//		delete m_pArchiveIn;
//	}
//	if( m_pArchiveOut ) 
//	{
//		m_pArchiveOut->Flush();
//		delete m_pArchiveOut;
//	}
	if( m_pFile ) delete m_pFile;
}

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(XClientSocket1, CSocket)
	//{{AFX_MSG_MAP(XClientSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// XClientSocket1 member functions
BOOL XClientSocket1::Init()
{
	m_pFile = new CSocketFile( this );
//	m_pArchiveIn = new CArchive( m_pFile, CArchive::load );
//	m_pArchiveOut = new CArchive( m_pFile, CArchive::store );

//	m_pArchiveOut->Flush();
//	m_pArchiveIn->Flush();
	return TRUE; 
}

BOOL XClientSocket1::Init( LPCTSTR ipAddr, long port, BOOL bShowMsgBox  )
{
	if( !Create() )
	{
		AfxMessageBox("Socket Creation Error");
		return FALSE;
	}
	Sleep( 200 );
	if( Connect( ipAddr, port ) )
	{
		m_pFile = new CSocketFile( this );
//		m_pArchiveIn = new CArchive( m_pFile, CArchive::load );
//		m_pArchiveOut = new CArchive( m_pFile, CArchive::store );

//		m_pArchiveOut->Flush();
//		m_pArchiveIn->Flush();
		Sleep( 200 );
		return TRUE;
	}
	else 
	{
		CString errMsg;
		int nErrNo = GetLastError();

		if( nErrNo==WSAENETDOWN ) 
			errMsg="The Windows Sockets implementation detected that the network subsystem failed";
		else if( nErrNo==WSAECONNREFUSED )
			errMsg="There is no connection with host! \nCheck the server status";
		else if( nErrNo==WSAEISCONN )
			errMsg="The socket is already connected.";
		else if( nErrNo==WSAENETUNREACH )
			errMsg="The network cannot be reached from this host at this time.";
		else if( nErrNo==WSAETIMEDOUT )
			errMsg="Attempt to connect timed out without establishing a connection";
		else errMsg="Connection failed";

		if( bShowMsgBox ) AfxMessageBox( errMsg, MB_ICONSTOP );
	}
	return FALSE;
}

//DWORD XClientSocket1::Read(LPSTR lpBuf, DWORD dwLength)
DWORD XClientSocket1::Read(unsigned char* lpBuf, DWORD dwLength)
{
	int nRead;

	// KDS050512
	if( !m_pFile ) return (DWORD) 0;

	if (!m_pFile->m_bArchiveCompatible)
	{
		int nLeft = dwLength;
		PBYTE pBuf = (PBYTE)lpBuf;

		while(nLeft > 0)
		{
			nRead = Receive(pBuf, nLeft);
			if (nRead == SOCKET_ERROR)
			{
				int nError = GetLastError();
				return 0;
			}
			else if (nRead == 0)
			{
				return dwLength - nLeft;
			}

			nLeft -= nRead;
			pBuf += nRead;
		}
		return dwLength - nLeft;
	}

	nRead = Receive(lpBuf, dwLength, 0);
	if (nRead == SOCKET_ERROR)
	{
		int nError = GetLastError();
		return 0;
	}
	return nRead;
	
//	UINT uLen;
//	uLen = m_pFile->Read( lpBuf, dwLength );
//	return (DWORD)uLen;
}

BOOL XClientSocket1::Write(unsigned char* lpBuf, DWORD dwLength)
{
	if( !m_pSECS->m_bConnected ) return FALSE;

	int nWritten = Send(lpBuf, dwLength);
	if (nWritten == SOCKET_ERROR)
	{
		int nError = GetLastError();
		return 0;
	}



	//m_pFile->Write( lpBuf, dwLength );
//	m_pArchiveOut->Write( lpBuf, dwLength );
//	m_pArchiveOut->Flush();
	return TRUE;
}

void XClientSocket1::OnReceive(int nErrorCode) 
{	
	CSocket::OnReceive( nErrorCode );
	/*if( nErrorCode ) TRACE( "nErrorCode = %d", nErrorCode );
	int nError = m_pFile->m_pSocket->GetLastError();*/
	//Sleep( 50 );

	// KDS050512
	if( !m_pFile ) return;

	int nLeft = 1;
	PBYTE pBuf[1];
	int nRead = m_pFile->m_pSocket->Receive(pBuf, nLeft, MSG_PEEK );
	if (nRead == SOCKET_ERROR || nRead == 0 || pBuf == NULL) return;

//	Sleep(200);
	Sleep(10);

	m_pSECS->OnReceive();
}

void XClientSocket1::OnClose(int nErrorCode) 
{
	CSocket::OnClose(nErrorCode);

	m_pSECS->OnClose();
}

BOOL XClientSocket1::ConnectHelper(const SOCKADDR* lpSockAddr, int nSockAddrLen)
{
	if (m_pbBlocking != NULL)
	{
		WSASetLastError(WSAEINPROGRESS);
		return  FALSE;
	}

	m_nConnectError = -1;

	if (!CAsyncSocket::ConnectHelper(lpSockAddr, nSockAddrLen))
	{
		if (GetLastError() == WSAEWOULDBLOCK)
		{
	// Insert....
			CTime		curt, st;
			CTimeSpan	span(0, 0, 0, m_nTimeOut = 0);

			st = CTime().GetCurrentTime();
	//.......
			while (PumpMessages(FD_CONNECT))
			{
				if (m_nConnectError != -1)
				{
					WSASetLastError(m_nConnectError);
					return (m_nConnectError == 0);
				}
	// Insert....
				curt = CTime().GetCurrentTime();
				if(curt > (st+span))
					return FALSE;
	//..............
			}
		}
		return FALSE;
	}
	m_Kill = FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// XListenSocket1

XListenSocket1::XListenSocket1(XSecsHSMS1* pSECS)
{
	m_pSECS = pSECS;
}

XListenSocket1::XListenSocket1()
{
}

XListenSocket1::~XListenSocket1()
{
}

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(XListenSocket1, CSocket)
	//{{AFX_MSG_MAP(XListenSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// XListenSocket member functions

void XListenSocket1::OnAccept(int nErrorCode) 
{	
	CSocket::OnAccept( nErrorCode );

	m_pSECS->OnAccept();
}
