// CimSeq.cpp: implementation of the CDicsCimSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "CimSeq.h"
#include "..\Dlg\DlgGlassInfo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCimSeq::CCimSeq()
{

}

void CCimSeq::SetOwnerPointer(CWnd* pWnd)
{
	SetDicsView( ( CDicsView* )pWnd );
	SetDicsData( m_pDicsView->m_pDicsData );
	SetDevice( m_pDicsView->m_pDevice );
	SetSetupItems( m_pDicsView->GetDocument()->m_pSetupItems );
	SetEqpStateSequence( m_pDicsView->m_pEqpStateSeq );
	SetSeqTimer( m_pDicsView->m_pTimer );
}

CCimSeq::~CCimSeq()
{

}

BOOL CCimSeq::Initialize()
{
	InitParameter();
	mowCLN_EQ_RUN_MODE( 0 );
	mowCLN_EQ_STATUS(0);
	mowCLN_EQ_RUN_MODE( 2 );
	mowCLN_RUN_MODE_CHANGE_ACK(2);
	m_bCIMPCAliveOnline = FALSE;
	return TRUE;
}

BOOL CCimSeq::Sequence()
{
	Sleep( 100 );


	SeqConnect();
	SeqAlarm();
	SeqEqpState();
	SeqCtlModeChange();
//	SeqRecipeBodyChangeReport();  ..

	// Data Report
	SeqGlsApd();
#ifndef _TYPE7
	SeqOpIdReport();
#endif
//	SetTraceDataValue();

	// Cim PC;
	SeqSubIdDataSet();
	SeqGlassDataDel();
	SeqRunModeChange();
	SeqCimPcClockUpdate();
	SeqCimPcMSGUpdate();
/*
	for( int i=0; i<MAX_PORT_NO; i++ ) 
	{
		SeqPortModeChange( i );
		SeqTrsModeChange( i );
		SeqNormal( i );
	}
*/
	SeqCimT3TimeoutCheck();	// shcho 230207
	SeqCimT9TimeoutCheck();	// shcho 230207
	return TRUE;
}

void CCimSeq::InitParameter()
{
	m_nSeqConnectNo			= 0;
	m_nSeqCtlModeChangeNo	= 0;
	m_nSeqAlarmNo			= 0;
	m_nSeqRecipeBodyChangeReportNo = 0;
	m_nSeqDailyCheckReportNo		= 0;

	m_nSeqRunModeChangeNo	= 0;

	m_nSeqSubIdDataSetNo    = 0; 
	m_nSeqGlassDelNo		= 0;
	for( int i=0; i<MAX_PORT_NO; i++ ) 
	{
		m_nSeqPortModeChangeNo[i]	= 0;
		m_nSeqTrsModeChangeNo[i]	= 0;
//		m_nSeqNormalNo[i]			= 0;

		m_SeqFlag.bAgvModeChangeReq[i]	 = 0;
	}
	m_SeqFlag.bReqGlsApd = FALSE;
	m_SeqFlag.bReqLotApd = FALSE;
	m_SeqFlag.bInitFail	 = FALSE;


#ifdef _LOADER_DEBUG
	m_bSubIdDataSetReq		= FALSE;
#endif
}

void CCimSeq::SeqConnect()
{
	int nSeqNo = m_nSeqConnectNo;

	switch( nSeqNo )
	{
	case 0:
		if( m_pHost->m_bConnected )
		{
			SetLog( "CONNECT", 0, 0, "Host is Connected" );
			nSeqNo = 10;
		}
		break;
	case 10:
		if( !m_pHost->m_bConnected ) 
		{
			// Log
			SetLog( "CONNECT", 0, 0, "Host is Disconnected" );
			// Log
			SetLog( "CONNECT", 0, 0, "Change to Offline" );

			// Set value
			m_pDicsData->m_EqpInfo.cCtlMode = CDicsData::modeOFFLINE;

			// Send Message
			Msg( WM_JOBS_VIEW, (WPARAM) MSG_CTRL_MODE, (LPARAM) "Offline" );

			nSeqNo = 0;
		}
		break;
	}
	m_nSeqConnectNo = nSeqNo;
}

void CCimSeq::SeqEqpState()
{
	static char cOldEqpState = 0;
	static BOOL bOnce = FALSE;
	CString m_sMessage;
	m_sSeqName.Format( "SeqEqpState" );
#ifndef _TYPE7	
	if( m_pDicsData->m_EqpInfo.cLdState != CDicsData::modeDOWN ) 
	{
		m_pDicsData->m_EqpInfo.cLdState = CDicsData::modeIDLE;
		for( int i=0; i<MAX_PORT_NO; i++ )
		{
			if( m_pDicsData->m_PortInfo[i].cLdState == CDicsData::modeRUN )
			{	
				m_pDicsData->m_EqpInfo.cLdState = CDicsData::modeRUN; 
				break; 
			}
		}
	}
#endif

//#ifndef _SPT_TYPE	// 231122 halesu ITO300
	if( !m_pDicsData->m_GenInfo.bAuto && !bOnce )
	{
		bOnce = TRUE;
		if( m_pHost->m_bConnected )
		{
			if( m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeOFFLINE )
			{
				// Report S1F65 : Assist
				m_pHost->S1F65( m_pDicsData->m_EqpInfo.cCtlMode, CDicsData::modeDOWN );
				// Log
				SetLog( "STATE", 0, 0, "S1F65 (EQP->HOST) : DOWN ( manual mode change )" );
	
				// Check Secondary
				m_pHost->SecondaryRcvd( "S1F65" );
				// Log
				SetLog( "STATE", 0, 0, "S1F66 (EQP<-HOST)" );
			}
		}		
	}
	else if ( m_pDicsData->m_GenInfo.bAuto && bOnce )
	{
		bOnce = FALSE;
		if( m_pHost->m_bConnected )
		{
			if( m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeOFFLINE )
			{
				// Report S1F65 : Assist
				m_pHost->S1F65( m_pDicsData->m_EqpInfo.cCtlMode );
			
				// Log
				m_sMessage.Format("S1F65 (EQP->HOST) : %s ( auto mode change )", ( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeDOWN ) ? "DOWN" :
																				 ( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeRUN ) ? "RUN" : "IDLE");
				SetLog( "STATE", 0, 0, m_sMessage );
	
				// Check Secondary
				m_pHost->SecondaryRcvd( "S1F65" );
				// Log
				SetLog( "STATE", 0, 0, "S1F66 (EQP<-HOST)" );
			}
		}		
	}
//#endif
#ifndef _TYPE7
	if( ( cOldEqpState != CDicsData::modeDOWN ) && 
		( ( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeDOWN ) ||
		  ( m_pDicsData->m_EqpInfo.cLdState == CDicsData::modeDOWN ) ) )
#else
	if( ( cOldEqpState != CDicsData::modeDOWN ) && 
		( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeDOWN ) )
#endif
	{
		cOldEqpState = CDicsData::modeDOWN;

//#ifndef _SPT_TYPE		// 231122 halesu ITO300
		if( m_pHost->m_bConnected )
		{
			if( m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeOFFLINE )
			{
				// Report S1F65 : Assist
				m_pHost->S1F65( m_pDicsData->m_EqpInfo.cCtlMode );
				// Log
				SetLog( "STATE", 0, 0, "S1F65 (EQP->HOST) : DOWN" );

				// Check Secondary
				m_pHost->SecondaryRcvd( "S1F65" );
				// Log
				SetLog( "STATE", 0, 0, "S1F66 (EQP<-HOST)" );
			}
		}
//#endif
	}
#ifndef _TYPE7
	else if( ( cOldEqpState != CDicsData::modeRUN ) && 
		( ( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeRUN ) ||
		  ( m_pDicsData->m_EqpInfo.cLdState == CDicsData::modeRUN ) ) )
#else
	else if( ( cOldEqpState != CDicsData::modeRUN ) && 
			 ( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeRUN ) )
#endif
	{
		cOldEqpState = CDicsData::modeRUN;

//#ifndef _SPT_TYPE	// 231122 halesu ITO300
		if( m_pHost->m_bConnected )
		{
			if( m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeOFFLINE )
			{
				// Report S1F65 : Assist
				m_pHost->S1F65( m_pDicsData->m_EqpInfo.cCtlMode );
				// Log
				SetLog( "STATE", 0, 0, "S1F65 (EQP->HOST) : RUN" );

				// Check Secondary
				m_pHost->SecondaryRcvd( "S1F65" );
				// Log
				SetLog( "STATE", 0, 0, "S1F66 (EQP<-HOST)" );
			}
		}
//#endif
	}
	else if( ( cOldEqpState != CDicsData::modeIDLE )  &&
			 ( m_pDicsData->m_EqpInfo.cEqpState == CDicsData::modeIDLE ) )
	{
		cOldEqpState = CDicsData::modeIDLE;

//#ifndef _SPT_TYPE	// 231122 halesu ITO300
		if( m_pHost->m_bConnected )
		{
			if( m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeOFFLINE )
			{
				// Report S1F65 : Assist
				m_pHost->S1F65( m_pDicsData->m_EqpInfo.cCtlMode );
				// Log
				SetLog( "STATE", 0, 0, "S1F65 (EQP->HOST) : IDLE" );

				// Check Secondary
				m_pHost->SecondaryRcvd( "S1F65" );
				// Log
				SetLog( "STATE", 0, 0, "S1F66 (EQP<-HOST)" );
			}
		}
//#endif
	}
}

void CCimSeq::SeqCtlModeChange()
{
	if( !m_pHost->m_bConnected || m_pHost->m_bRetryConnect ) return;

	int nSeqNo = m_nSeqCtlModeChangeNo;
	static DWORD dwTickStart;
	static BOOL bOldT9Timeout = FALSE;
	static int nAlarmId = 0;

	char cRCS = m_pDicsData->m_IfCim.cCtlMode;

	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();

	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 10000 )	bInit = TRUE;
		if( !bInit ) return;
	}

	switch( nSeqNo )
	{
	case 0 :
		if( m_pDicsData->m_IfCim.bCtlModeChangeReq )
		{
			m_pDicsData->m_IfCim.bCtlModeChangeReq = FALSE;
			m_pHost->S1F65( m_pDicsData->m_EqpInfo.cCtlMode );
			CString sTemp;
			sTemp.Format( " case 0 : RCS = %c", m_pDicsData->m_EqpInfo.cCtlMode );
			SetLog( "MODE CHG", 0, 0, sTemp );
			nSeqNo = 10;
		}
		break;

	case 10:
		if( cRCS == m_pDicsData->m_EqpInfo.cCtlMode )
		{
			nSeqNo = 0;
		}
		else
		{
			nSeqNo = 20;
		}
		break;

	case 20:
		if( cRCS == CDicsData::modeOFFLINE )
		{
			// Log
			SetLog( "MODE CHG", 0, 0, "Offline Mode Change" );
			nSeqNo = 100;
		}
		else
		{
			// Check the T9 Timeout Alarm
			if( bOldT9Timeout )
			{
				bOldT9Timeout = FALSE;
				m_pEqpStateSeq->ResetAlarm( nAlarmId );
				Msg( WM_JOBS_VIEW, MSG_CIM_MESSAGE, (LPARAM)(LPCTSTR) "OK" );
			}

			// Log
			SetLog( "MODE CHG", 0, 0, "Online Mode Change" );

			// Are you there request
			m_pHost->S1F1();
			SetLog( "MODE CHG", 0, 0, "S1F1 (EQP->HOST)" );

			nSeqNo = 30;
		}
		break;

	case 30:
		if( m_pHost->SecondaryRcvd( "S1F1" ) )
		{
			// Check Secondary
			SetLog( "MODE CHG", 0, 0, "S1F2 (EQP<-HOST)" );

			// Counting starts
			dwTickStart = GetTickCount();
			nSeqNo = 40;
		}
		else
		{
			// Set Log
			SetLog( "MODE CHG", 0, 0, "S1F1 T3 Timeout Error" );

			m_pDicsData->m_EqpInfo.cCtlMode = CDicsData::modeOFFLINE;
			// Send Message
			Msg( WM_JOBS_VIEW, (WPARAM) MSG_CTRL_MODE, (LPARAM) "Offline" );
			dwTickStart = GetTickCount();
			nSeqNo = 40;
		}
		break;

	case 40 :
		if( m_pHost->m_flagS1F79Received )
		{
			m_pHost->m_flagS1F79Received = FALSE;
			
			// Summary Status Report
			m_pHost->S1F69();
			SetLog( "MODE CHG", 0, 0, "S1F69 (EQP->HOST)" );
			nSeqNo = 50;
		}
		else if( m_pHost->m_flagONLINE_FAIL )
		{
			m_pHost->m_flagONLINE_FAIL = FALSE;
			nSeqNo = 0;
		}
		else if( GetTickCount() - dwTickStart > (DWORD) m_pHost->HSMST9 * 1000 )
		{
			m_pHost->S9F13( "S1F79", "    " );
//			AfxMessageBox( "T9 Timeout!" );
			CString sMsg = "HOST->EQ : T9 Timeout (S1F79)";
			m_pDicsView->SendMessage( WM_JOBS_VIEW, (WPARAM) MSG_HOST_TIMEOUT, (LPARAM)(LPCTSTR) sMsg);
			nSeqNo = 0;
		}
		break;

	case 50:
		if( m_pHost->SecondaryRcvd( "S1F69" ) )
		{
			// Check Secondary
			SetLog( "MODE CHG", 0, 0, "S1F70 (EQP<-HOST)" );

			if( m_pDicsData->m_IfCimTag.nAck1 != 0 )
			{
				// Set Log
				SetLog( "MODE CHG", 0, 0, "Online Failed : S1F70 <GRANT> is not zero" );

				m_pDicsData->m_EqpInfo.cCtlMode = CDicsData::modeOFFLINE;
				// Send Message
				Msg( WM_JOBS_VIEW, (WPARAM) MSG_CTRL_MODE, (LPARAM) "Offline" );
				nSeqNo = 0;
			}
			else
			{
				// Date and Time Data Request
				m_pHost->S2F17();
				SetLog( "MODE CHG", 0, 0, "S2F17 (EQP->HOST)" );
				nSeqNo = 60;
			}
		}
		else
		{
			// Set Log
			SetLog( "MODE CHG", 0, 0, "S1F69 T3 Timeout Error" );

			m_pDicsData->m_EqpInfo.cCtlMode = CDicsData::modeOFFLINE;
			dwTickStart = GetTickCount();
			// Send Message
			Msg( WM_JOBS_VIEW, (WPARAM) MSG_CTRL_MODE, (LPARAM) "Offline" );
			nSeqNo = 60;
		}
		break;

	case 60:
		if( m_pHost->SecondaryRcvd( "S2F17" ) )
		{
			// Check Secondary
			SetLog( "MODE CHG", 0, 0, "S2F18 (EQP<-HOST)" );

#ifndef _MY_DEBUG // 2009.03.05 minhan		// no change time 20100604 ssm
			SYSTEMTIME sysTime;
			::GetSystemTime( &sysTime );
			sysTime.wYear	= (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(0, 4) ));
			sysTime.wMonth	= (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(4, 2) ));
			sysTime.wDay	= (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(6, 2) ));
			sysTime.wHour	= (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(8, 2) )); 
			sysTime.wMinute = (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(10, 2) ));
			sysTime.wSecond = (WORD)(atoi( m_pDicsData->m_EqpInfo.sHostTime.Mid(12, 2) ));
//			::SetSystemTime( &sysTime ); 
			::SetLocalTime( &sysTime ); 
#endif
			dwTickStart = GetTickCount();

			nSeqNo = 70;
		}
		else
		{
			// Set Log
			SetLog( "MODE CHG", 0, 0, "S2F17 T3 Timeout Error" );

			dwTickStart = GetTickCount();
			m_pDicsData->m_EqpInfo.cCtlMode = CDicsData::modeOFFLINE;
			// Send Message
			Msg( WM_JOBS_VIEW, (WPARAM) MSG_CTRL_MODE, (LPARAM)(LPCTSTR) "Offline" );
			nSeqNo = 70;
		}
		break;

	case 70 :
		if( m_pHost->m_flagS1F77Received )
		{
			m_pHost->m_flagS1F77Received = FALSE;
			m_pDicsData->m_EqpInfo.cCtlMode = cRCS;
			dwTickStart = GetTickCount();
			nSeqNo = 80;
		}
		else if( GetTickCount() - dwTickStart > (DWORD) m_pHost->HSMST9 * 1000 )
		{
			m_pHost->S9F13( "S1F77", "    " );
//			AfxMessageBox( "T9 Timeout!" );

			CString sMsg = "HOST->EQ : T9 Timeout (S1F77)";
			m_pDicsView->SendMessage( WM_JOBS_VIEW, (WPARAM) MSG_HOST_TIMEOUT, (LPARAM)(LPCTSTR) sMsg);
			nSeqNo = 0;
		}
		break;

	case 80 :
		if( m_pHost->m_flagS1F79Received )
		{
			m_pHost->m_flagS1F79Received = FALSE;
			nSeqNo = 90;
		}
		else if( m_pHost->m_flagONLINE_FAIL )
		{
			m_pHost->m_flagONLINE_FAIL = FALSE;
			nSeqNo = 0;
		}
		else if( GetTickCount() - dwTickStart > (DWORD) m_pHost->HSMST9 * 1000 )
		{
			m_pDicsData->m_EqpInfo.cCtlMode = 'D';
			m_pHost->S9F13( "S1F79", "    " );
//			AfxMessageBox( "T9 Timeout!" );
			CString sMsg = "HOST->EQ : T9 Timeout (S1F79)";
			m_pDicsView->SendMessage( WM_JOBS_VIEW, (WPARAM) MSG_HOST_TIMEOUT, (LPARAM)(LPCTSTR) sMsg);
			nSeqNo = 0;
		}
		break;

	case 90:
		{
				// Change OK
				// Set value
				m_pDicsData->m_EqpInfo.cCtlMode = cRCS;

				CString sTemp;
				sTemp.Format( " case 90 : RCS = %c", cRCS );
				SetLog( "MODE CHG", 0, 0, sTemp );

				m_pHost->S1F65( cRCS );
				SetLog( "MODE CHG", 0, 0, "S1F65 (EQP->HOST)" );
				// Send Message
				if( cRCS == CDicsData::modeCONTROL )
					Msg( WM_JOBS_VIEW, (WPARAM) MSG_CTRL_MODE, (LPARAM) "Online Control" );
				else if( cRCS == CDicsData::modeMONITOR )
					Msg( WM_JOBS_VIEW, (WPARAM) MSG_CTRL_MODE, (LPARAM) "Online Monitor" );

				nSeqNo = 0;

		}
		break;

	case 100:
		// Offline ϶  Offline => Secondary ޵   offline
//		if( m_pHost->SecondaryRcvd( "S1F65" ) )
		{
			// Log
			SetLog( "MODE CHG", 0, 0, "S1F66 (EQP->HOST)");

			m_pDicsData->m_EqpInfo.cCtlMode = cRCS;
			CString sTemp;
			sTemp.Format( " case 100 : RCS = %c", cRCS );
			SetLog( "MODE CHG", 0, 0, sTemp );

			m_pHost->S1F65( 'D' );
			// Send Message
			if( cRCS == CDicsData::modeCONTROL )
				Msg( WM_JOBS_VIEW, (WPARAM) MSG_CTRL_MODE, (LPARAM) "Online Control" );
			else if( cRCS == CDicsData::modeMONITOR )
				Msg( WM_JOBS_VIEW, (WPARAM) MSG_CTRL_MODE, (LPARAM) "Online Monitor" );
			else if( cRCS == CDicsData::modeOFFLINE )
				Msg( WM_JOBS_VIEW, (WPARAM) MSG_CTRL_MODE, (LPARAM) "Offline" );
			nSeqNo = 0;
		}
/*
		else
		{
			// Log
			SetLog( "MODE CHG", 0, 0, "S1F66 (EQP<-HOST)");

			m_pDicsData->m_EqpInfo.cCtlMode = CDicsData::modeOFFLINE;
			// Send Message
			Msg( WM_JOBS_VIEW, (WPARAM) MSG_CTRL_MODE, (LPARAM) "Offline" );
			nSeqNo = 0;
		}
*/
		break;
	}
	m_nSeqCtlModeChangeNo = nSeqNo;
}

//--------------------------------------------------------------------
// Port Enable <-> Disable
// Command : MAIN ---> LOADER / UNLOADER
//--------------------------------------------------------------------
void CCimSeq::SeqPortModeChange(int i)
{
/*
	int nSeqNo = m_nSeqPortModeChangeNo[i];
	char cPortMode = m_pDicsData->m_IfCim.cPortMode[i];

	switch( nSeqNo )
	{
	case 0 :
		if( m_pDicsData->m_IfCim.bPortModeChangeReq[i] )
		{
			// Flag Reset
			m_pDicsData->m_IfCim.bPortModeChangeReq[i] = FALSE;
			if( cPortMode == m_pDicsData->m_PortInfo[i].cPortMode ) return;
			else 
			{
				// Set to loader
				m_pDicsData->m_IfLoader.cPortMode[i] = cPortMode;
				m_pDicsData->m_IfLoader.bPortModeChangeReq[i] = TRUE;
				// Log
				SetLog( "MODE CHG", i + 1, 0, "Port Mode Change Request EQP=>Loader" );
				nSeqNo = 10;
			}
		}
		break;

	// Port Enable : For Loader
	case 10:
#ifndef _LOADER_DEBUG
		if( m_pDicsData->m_IfLoader.bPortModeChangeComp[i] )
#else 
		if( 1 )
#endif
		{
			// Flag Reset
			m_pDicsData->m_IfLoader.bPortModeChangeComp[i] = FALSE;

			// Change the Port Status
			if( cPortMode == CDicsData::modeENABLE ) m_pDicsData->m_PortInfo[i].sPortStatus = "ENABLE";
			else if( cPortMode == CDicsData::modeDISABLE ) m_pDicsData->m_PortInfo[i].sPortStatus = "DISABLE";

			if( m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeOFFLINE )
			{
				m_pHost->S1F73( i, cPortMode, m_pDicsData->m_PortInfo[i].cPortLdMode );
				// Log
				m_sMessage.Format( "S1F73 (EQP->HOST) : %s", m_pDicsData->m_PortInfo[i].sPortStatus );
				SetLog( "MODE CHG", i + 1, 0, m_sMessage );

				// Secondary
				m_pHost->SecondaryRcvd( "S1F73" );
				// Log
				SetLog( "MODE CHG", i + 1, 0, "S1F74 (EQP<-HOST)" );
			}

			// Set value
			m_pDicsData->m_PortInfo[i].cPortMode = cPortMode;
			// Send Message
			// xxxx y => xxxx : Port No, y : Enable / Disable
			int nData = ( i << 1 ) + ( cPortMode == CDicsData::modeENABLE ? 1 : 0 );
			Msg( WM_JOBS_VIEW, (WPARAM) MSG_PORT_MODE, (LPARAM) nData );
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqPortModeChangeNo[i] = nSeqNo;
*/
}

//--------------------------------------------------------------------
// AGV <-> MGV
// Command : MAIN ---> LOADER / UNLOADER
//--------------------------------------------------------------------
void CCimSeq::SeqTrsModeChange(int i)
{
/*
	int nSeqNo = m_nSeqTrsModeChangeNo[i];
	char cTrsMode = m_pDicsData->m_IfCim.cTrsMode[i];

	switch( nSeqNo )
	{
	case 0 :
		if( m_pDicsData->m_IfCim.bTrsModeChangeReq[i] )
		{
			// Flag Reset
			m_pDicsData->m_IfCim.bTrsModeChangeReq[i] = FALSE;
			if( cTrsMode == m_pDicsData->m_PortInfo[i].cTrsMode ) return;
			else 
			{
				// Set to loader
				m_pDicsData->m_IfLoader.cTrsMode[i] = cTrsMode;
				m_pDicsData->m_IfLoader.bTrsModeChangeReq[i] = TRUE;
				// Log
				SetLog( "MODE CHG", i + 1, 0, "TRS Mode Change Request EQP=>Loader" );
				nSeqNo = 10;
			}
		}
		break;

	case 10:
#ifndef _LOADER_DEBUG
		if( m_pDicsData->m_IfLoader.bTrsModeChangeComp[i] )
#else 
		if( 1 )
#endif
		{
			// Flag Reset
			m_pDicsData->m_IfLoader.bTrsModeChangeComp[i] = FALSE;

			// Change the Trs Status
			CString sVal;
			if( cTrsMode == CDicsData::modeAGV ) sVal = "AGV Mode";
			else if( cTrsMode == CDicsData::modeMGV ) sVal = "MGV Mode";

			if( m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeOFFLINE )
			{
				m_pHost->S1F73( i, cTrsMode, m_pDicsData->m_PortInfo[i].cPortLdMode );
				// Log
				m_sMessage.Format( "S1F73 (EQP->HOST) : %s", sVal );
				SetLog( "MODE CHG", i + 1, 0, m_sMessage );

				// Secondary
				m_pHost->SecondaryRcvd( "S1F73" );
				// Log
				SetLog( "MODE CHG", i + 1, 0, "S1F74 (EQP<-HOST)" );
			}

			// Set value
			m_pDicsData->m_PortInfo[i].cTrsMode = cTrsMode;
			m_pDicsData->m_EqpInfo.cTrsMode		= cTrsMode;

			// Send Message
			// xxxx y => xxxx : Port No, y : AGV / MGV
			int nData = ( i << 1 ) + ( cTrsMode == CDicsData::modeAGV ? 1 : 0 );
			Msg( WM_JOBS_VIEW, (WPARAM) MSG_TRS_MODE, (LPARAM) nData );
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqTrsModeChangeNo[i] = nSeqNo;
*/
}

void CCimSeq::SeqAlarm()
{
	int nSeqNo = m_nSeqAlarmNo;
	int nSendData, nBitdata=0;
	CString strTemp;
	m_sSeqName.Format( "SeqAlarm" );
	
	static DWORD dTimeOut = GetCurrentTime();

	CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();
	DWORD nT1_Timeout = atoi( pDoc->m_pSetupItems->m_sValueInterfacePara[CSetupItems::timeoutINTERFACE_T1] ) * 1000;
	DWORD nT3_Timeout = atoi( pDoc->m_pSetupItems->m_sValueInterfacePara[CSetupItems::timeoutINTERFACE_T3] ) * 1000;

	switch( nSeqNo )
	{
	case 0:
		if( m_pDicsData->m_IfCim.bAlarmSetReq == TRUE )
		{
			m_pDicsData->m_IfCim.bAlarmSetReq = FALSE;
//#ifndef _SPT_TYPE
			if( m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeOFFLINE )
			{
				// Set Alarm : 128 means that 8th bit is 1
				int nALCD = m_pDicsData->m_IfCim.nAlarmCode + 128;
				int nALID = m_pDicsData->m_IfCim.nAlarmId;
				CString sALTX = m_pDicsData->m_IfCim.sAlarmText;
				char cAlarmLevel = m_pDicsData->m_IfCim.cAlarmLevel;
				CString sSEQNO = m_pDicsData->m_IfCim.sAlarmTime;
				m_pHost->S5F65( nALCD, nALID, sALTX, cAlarmLevel, sSEQNO );
				SetLog( "ALARM", 0, 0, "S5F65 (EQP->HOST) : Alarm Set" );
				
				// Secondary
				m_pHost->SecondaryRcvd( "S5F65" );

				SetLog( m_sSeqName, 0, 0, "S5F66 (EQP<-HOST)" );
			}
//#endif
			CString sALCD, sALText, sAlarmLevel;
			
			int nALID = m_pDicsData->m_IfCim.nAlarmId;

			char cAlarmLevel = m_pDicsData->m_IfCim.cAlarmLevel;
			
			sAlarmLevel.Format("%c", cAlarmLevel );

			if( sAlarmLevel == "S" )	nSendData = 1; //sALText = "B1";
			else
			{
				if( ALM_IN_ON_SENSOR_WARNING1 <= nALID && nALID <= ALM_OUT_OFF_SENSOR_WARNING8 )	nSendData = 32;
				else if( ALM_GAUGE_LOWER_WARNING1 <= nALID && nALID <= ALM_GAUGE_LOWER_WARNING60)	nSendData = 4;
				else if( ALM_GAUGE_UPPER_WARNING1 <= nALID && nALID <= ALM_GAUGE_UPPER_WARNING60)	nSendData = 4;
				else if( ALM_PARTS_LIFE_TIME_OVER1 <= nALID && nALID <= ALM_PARTS_LIFE_TIME_OVER20)	nSendData = 4;
				else		nSendData = 2;
			}

			nBitdata = nSendData;

			nBitdata += 128;
			mowCLN_ALARM_LEVEL(nBitdata);

			
			//sALText.Format("%2x", 1);
			//nSendData = 1;
			mowCLN_ALARM_TYPE(nSendData);	//  ˶.

			//sALCD.Format("%2x", m_pDicsData->m_IfCim.nAlarmCode);
			//nSendData = m_pDicsData->m_IfCim.nAlarmCode;
			mowCLN_ALARM_CODE( nALID ); 
			//sALCD.ReleaseBuffer();

			sALText = m_pDicsData->m_IfCim.sAlarmText;
			mowCLN_ALARM_TEXT(sALText.GetBuffer(40), 40);

			mobCLN_ALARM_REPORT_FLAG(ON);
			dTimeOut = GetCurrentTime();

			m_pDicsData->m_IfCim.bAlarmSetComp = TRUE;

			// hskwak 191106
			strTemp.Format("[Alarm] SetAlarm ALID:%d, ALText:%s (Alarm Step=0)", nALID, sALText);
			SetLog( m_sSeqName, 0, 0,strTemp );

			nSeqNo = 10;
		}
		else if( m_pDicsData->m_IfCim.bAlarmResetReq == TRUE )
		{
			m_pDicsData->m_IfCim.bAlarmResetReq = FALSE;
//#ifndef _SPT_TYPE
			if( m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeOFFLINE )
			{
				// Set Alarm : 128 means that 8th bit is 1
				int nALCD = m_pDicsData->m_IfCim.nAlarmCode;
				int nALID = m_pDicsData->m_IfCim.nAlarmId;
				CString sALTX = m_pDicsData->m_IfCim.sAlarmText;
				char cAlarmLevel = m_pDicsData->m_IfCim.cAlarmLevel;

//****************CASE1: ALARM OCCUR TIME *********************************//
				CString sSEQNO = m_pDicsData->m_IfCim.sAlarmTime;
				m_pHost->S5F65( nALCD, nALID, sALTX, cAlarmLevel, sSEQNO );
//**************************************************************************//

//****************CASE2: ALARM RESET TIME *********************************//
/*				SYSTEMTIME SystemTime;
				GetLocalTime(&SystemTime);
				CString sDateTime;
				sDateTime.Format("%04d%02d%02d%02d%02d%02d.%02d",
					SystemTime.wYear, 
					SystemTime.wMonth, 
					SystemTime.wDay, 
					SystemTime.wHour, 
					SystemTime.wMinute, 
					SystemTime.wSecond, 
					SystemTime.wMilliseconds );

				m_pHost->S5F65( nALCD, nALID, sALTX, cAlarmLevel, sDateTime );*/
//**************************************************************************//

				SetLog( "ALARM", 0, 0, "S5F65 (EQP->HOST) : Alarm Reset" );
				
				// Secondary
				m_pHost->SecondaryRcvd( "S5F65" );
				// Log
				SetLog( "ALARM", 0, 0, "S5F66 (EQP<-HOST)" );
			}
//#endif
			CString sALCD, sALID, sAlarmLeve, sALText, sAlarmLevel;
			
			int nALID = m_pDicsData->m_IfCim.nAlarmId;

			char cAlarmLevel = m_pDicsData->m_IfCim.cAlarmLevel;

			sAlarmLevel.Format("%c", cAlarmLevel );
			if( sAlarmLevel == "S" )	nSendData = 1; //sALText = "B1";
			else
			{
				if( ALM_IN_ON_SENSOR_WARNING1 <= nALID && nALID <= ALM_OUT_OFF_SENSOR_WARNING8 )	nSendData = 32;
				else if( ALM_GAUGE_LOWER_WARNING1 <= nALID && nALID <= ALM_GAUGE_LOWER_WARNING60)	nSendData = 4;
				else if( ALM_GAUGE_UPPER_WARNING1 <= nALID && nALID <= ALM_GAUGE_UPPER_WARNING60)	nSendData = 4;
				else if( ALM_PARTS_LIFE_TIME_OVER1 <= nALID && nALID <= ALM_PARTS_LIFE_TIME_OVER20)	nSendData = 4;
				else		nSendData = 2;
			}
			mowCLN_ALARM_LEVEL(nSendData);

			//sALCD.Format("%x", m_pDicsData->m_IfCim.nAlarmCode);
			mowCLN_ALARM_CODE(  nALID );
			sALCD.ReleaseBuffer();

			sALText = m_pDicsData->m_IfCim.sAlarmText;
			mowCLN_ALARM_TEXT(sALText.GetBuffer(40), 40);

			mobCLN_ALARM_REPORT_FLAG(ON);
			dTimeOut = GetCurrentTime();

			nSeqNo = 10;

			// hskwak 191106
			strTemp.Format("[Alarm] ClearAlarm ALID:%d, ALText:%s (Alarm Step=0)", nALID, sALText);
			SetLog( m_sSeqName, 0, 0,strTemp );

			m_pDicsData->m_IfCim.bAlarmResetComp = TRUE;
		}
		break;
	case 10:
		if(moswCLN_CIM_CONNECT_STATUS==FALSE)	// Disconnect̸ Flag Ⱥ.
		{
			mobCLN_ALARM_REPORT_FLAG(OFF);
			SetLog( m_sSeqName, 0, 0, "[Alarm] CIMPC IS DISCONNECT (Alarm Step=10)" );
			nSeqNo = 0;
		}
		else if(mibCIM_ALARM_REPLY_FLAG )
		{
			mobCLN_ALARM_REPORT_FLAG(OFF);
			nSeqNo = 20;
			dTimeOut = GetCurrentTime();
		}
		else if( GetCurrentTime() - dTimeOut > nT1_Timeout )
		{
			SetLog( m_sSeqName, 0, 0, "[Alarm] Not respons reply flag(FALSE)" );
			nSeqNo = 0;
		}
		break;
	case 20:
		if(moswCLN_CIM_CONNECT_STATUS==FALSE)	// Disconnect̸ Flag Ⱥ.
		{
			SetLog( m_sSeqName, 0, 0, "[Alarm] CIMPC IS DISCONNECT (Alarm Step= 20)" );
			mowCLN_ALARM_TEXT("", 40);
			nSeqNo = 0;
		}
		else if(!mibCIM_ALARM_REPLY_FLAG )
		{
			// hskwak 191106
			mowCLN_ALARM_TEXT("", 40);
			nSeqNo = 0;
		}
		else if( GetCurrentTime() - dTimeOut > nT3_Timeout )
		{
			SetLog( m_sSeqName, 0, 0, "[Alarm] Not respons reply flag(FALSE)" );
			mowCLN_ALARM_TEXT("", 40);
			nSeqNo = 0;
		}
		break;


	}
	m_nSeqAlarmNo = nSeqNo;
}

void CCimSeq::SeqRecipeBodyChangeReport()
{
	int nSeqNo = m_nSeqRecipeBodyChangeReportNo;

	switch( nSeqNo )
	{
	case 0:
		if( m_pDicsData->m_IfCim.bRecipeBodyChangeReq )
		{
			// Reset Flag
			m_pDicsData->m_IfCim.bRecipeBodyChangeReq = FALSE;

			if( m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeOFFLINE )
			{
				// Set Value (word)
//				m_pHost->S7F21( m_pDicsData->m_IfCim.nRecipeId );// S7F21 NO USE-->OK
				SetLog( "RECIPE", 1, 0, "S7F21 (EQP->HOST) : Report Modification date/time of PPID" );
					
				// Secondary
				m_pHost->SecondaryRcvd( "S7F21" );
				// Log
				SetLog( "RECIPE", 1, 0, "S7F22 (EQP<-HOST)" );
			}
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqRecipeBodyChangeReportNo = nSeqNo;
}

void CCimSeq::GetMapInfoFromRecipe( int i )
{
	CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();
	if( pDoc->m_pRecipeSet->FindRecipe( m_pDicsData->m_PortInfo[i].sRcpId ) )
	{	
		// Get Mapping Data
//		for( int j=0; j<MAX_SLOT_NO; j++ ) 
//		{
//			CString sMapData = pDoc->m_pRecipeInfo[nRcpId - 1].sValue[CDaoRecipeSet::rcpSLOT1 + j];
//			if( sMapData == "NO PROCESS" ) m_pDicsData->m_PortInfo[i].bGlassMapSel[j] = FALSE;
//		}
		// Set to view : Display the map data
//		( (CDicsView *) m_pOwnerWnd )->m_pTabJobsTab2View->SetSelDataToGridMapInfo( i, m_pDicsData->m_PortInfo[i].bGlassMapSel );
// 		( (CDicsView *) m_pOwnerWnd )->m_pTabJobsTab4View->SetSelDataToGridMapInfo( i, m_pDicsData->m_PortInfo[i].bGlassMapSel );
	}
}

/*
//---------------------------------------------------------------------------
// Set the Log
//---------------------------------------------------------------------------
void CCimSeq::SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage )
{
	// Log
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	m_sLog.Format( "CIM\t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( m_sLog );

	m_sLog.Format( "%s : %s", sSeqName, sMessage );
	Msg( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) m_sLog );
}
*/

void CCimSeq::SeqGlsApd()
{
	int nSeqNo = 0;
	int nUnitNo = 0;

	nUnitNo = IF_UNIT_UL*2+1;

	switch( nSeqNo )
	{
	case 0 :
		if( m_pDicsData->m_IfCim.bApdReportReq )
		{
			m_pDicsData->m_IfCim.bApdReportReq = FALSE;

			m_pHost->S6F65( nUnitNo );

			CString sBuf;
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nSlotNo;

			// APD LOG
			CDicsView* pView = (CDicsView *) m_pOwnerWnd;
			CJobsTabProcessDataView* pViewProcess = pView->m_pTabJobsProcessDataView;
			pViewProcess->SendMessage( WM_APD_DATA_CHANGED, (WPARAM) 0 );
		}
		break;
	}
}

void CCimSeq::SeqOpIdReport()
{
	int nSeqNo = 0;
	switch( nSeqNo )
	{
	case 0 :
		if( m_pDicsData->m_IfCim.bOperatorIdReport )
		{
			int Index = m_pDicsData->m_IfCim.nSelectedOpIdNo;
			m_pDicsData->m_IfCim.bOperatorIdReport = FALSE;
			m_pHost->S6F67( Index );
		}
		break;
	}
}

void CCimSeq::SetTraceDataValue()
{ 
	SYSTEMTIME SystemTime;
	GetLocalTime(&SystemTime);
	m_pDicsData->m_IfCim.sTraceDataTime.Format("%04d%02d%02d%02d%02d%02d.%02d",
		SystemTime.wYear, 
		SystemTime.wMonth, 
		SystemTime.wDay, 
		SystemTime.wHour, 
		SystemTime.wMinute, 
		SystemTime.wSecond, 
		SystemTime.wMilliseconds );
// #ifndef _NO_EUV
// 	m_pDicsData->m_IfCim.sTraceDataValue[29].Format( "%.1f", m_pDicsView->m_pEuvSeq->GetLampIntensity(0) );
// 	m_pDicsData->m_IfCim.sTraceDataValue[30].Format( "%.1f", m_pDicsView->m_pEuvSeq->GetLampIntensity(1) );
// 	m_pDicsData->m_IfCim.sTraceDataValue[31].Format( "%.1f", m_pDicsView->m_pEuvSeq->GetLampIntensity(2) );
// 	m_pDicsData->m_IfCim.sTraceDataValue[32].Format( "%.1f", m_pDicsView->m_pEuvSeq->GetLampIntensity(3) );
// #else
// 	m_pDicsData->m_IfCim.sTraceDataValue[29].Format( "%.1f", 0.0 );
// 	m_pDicsData->m_IfCim.sTraceDataValue[30].Format( "%.1f", 0.0 );
// 	m_pDicsData->m_IfCim.sTraceDataValue[31].Format( "%.1f", 0.0 );
// 	m_pDicsData->m_IfCim.sTraceDataValue[32].Format( "%.1f", 0.0 );
// #endif

	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		int nApdNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nApdReportNo;
		if( nApdNo < 0 ) continue;
		m_pDicsData->m_IfCim.sTraceDataValue[nApdNo].Format( "%.1f", m_pEqpAssy->m_AnalogInput.GetRealVal(i) );
	}
}

void CCimSeq::SeqDailyCheckReport()
{
	CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();
	
	int nSeqNo = m_nSeqDailyCheckReportNo;
	CString sBuf;

	switch( nSeqNo )
	{
	case 0:
//#ifndef _LOADER_DEBUG
//		if ( mibIF_DCL_REQ )
//#else
//		if ( 0 )
//#endif
//		{
//			CDicsView* pView = (CDicsView *) m_pOwnerWnd;
//
//			m_sEDC[edcJOB_MODE]	= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupJOB_MODE] == 1 ? "1 " : "0 ";
//			m_sEDC[edcPUMP_USE]	= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1 ? "1 " : "0 "; 
//			m_sEDC[edcLD_BROKEN_USE] = m_pSetupItems->m_nValueBrokenIntr[CSetupItems::intrLD_UNIT_BROKEN_SENSOR] == 1 ? "1 " : "0 ";
//			m_sEDC[edcUL_BROKEN_USE] = m_pSetupItems->m_nValueBrokenIntr[CSetupItems::intrUL_UNIT_BROKEN_SENSOR] == 1 ? "1 " : "0 ";
//			m_sEDC[edcGEAR_DI_USE] = m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupGEAR_SUPPLY_USE] == 1 ? "1 " : "0 ";
//#ifndef	_NO_EUV
//			m_sEDC[edcEUV_TIME1].Format( " %6d", pView->m_pEuvSeq->GetLampUsedTime( 0 ) / 3600 );
//			m_sEDC[edcEUV_TIME2].Format( " %6d", pView->m_pEuvSeq->GetLampUsedTime( 1 ) / 3600 );
//			m_sEDC[edcEUV_TIME3].Format( " %6d", pView->m_pEuvSeq->GetLampUsedTime( 2 ) / 3600 );
//			m_sEDC[edcEUV_TIME4].Format( " %6d", pView->m_pEuvSeq->GetLampUsedTime( 3 ) / 3600 );
//			m_sEDC[edcEUV_TIME5].Format( " %6d", pView->m_pEuvSeq->GetLampUsedTime( 4 ) / 3600 );
//			m_sEDC[edcEUV_TIME6].Format( " %6d", pView->m_pEuvSeq->GetLampUsedTime( 5 ) / 3600 );
//#else
//			m_sEDC[edcEUV_TIME1].Format( "      0" );
//			m_sEDC[edcEUV_TIME2].Format( "      0" );
//			m_sEDC[edcEUV_TIME3].Format( "      0" );
//			m_sEDC[edcEUV_TIME4].Format( "      0" );
//			m_sEDC[edcEUV_TIME5].Format( "      0" );
//			m_sEDC[edcEUV_TIME6].Format( "      0" );
//#endif
//			m_sEDC[edcRCP_ID].Format(" %2s ", pDoc->m_sRecipeId);
//
//			sBuf =	m_sEDC[edcJOB_MODE] + 
//					m_sEDC[edcPUMP_USE] + 
//					m_sEDC[edcLD_BROKEN_USE] + 
//					m_sEDC[edcUL_BROKEN_USE] + 
//					m_sEDC[edcGEAR_DI_USE] + 
//					m_sEDC[edcEUV_TIME1] + 
//					m_sEDC[edcEUV_TIME2] + 
//					m_sEDC[edcEUV_TIME3] + 
//					m_sEDC[edcEUV_TIME4] + 
//					m_sEDC[edcEUV_TIME5] + 
//					m_sEDC[edcEUV_TIME6] + 
//					m_sEDC[edcRCP_ID];
//
//			int nLength = sBuf.GetLength();
//			mowDAILY_REPORT_AREA( sBuf.GetBuffer(nLength), nLength); sBuf.ReleaseBuffer();
//			m_sMessage.Format( "Length = %d  Daily Check = %s", nLength, sBuf );
//			SetLog("DAILY SET", 0, 0, m_sMessage );
//	
//			mobIF_DCL_SET( ON );
//
//			m_sEDC[edcJOB_MODE]	= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupJOB_MODE] ? "Process" : "Pass"; 
//			m_sEDC[edcPUMP_USE]	= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1 ? "USE" : "NO Use"; 
//			m_sEDC[edcLD_BROKEN_USE] = m_pSetupItems->m_nValueBrokenIntr[CSetupItems::intrLD_UNIT_BROKEN_SENSOR] == 1 ? "USE" : "NO Use"; 
//			m_sEDC[edcUL_BROKEN_USE] = m_pSetupItems->m_nValueBrokenIntr[CSetupItems::intrUL_UNIT_BROKEN_SENSOR] == 1 ? "USE" : "NO Use"; 
//			m_sEDC[edcGEAR_DI_USE] = m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupGEAR_SUPPLY_USE] == 1 ? "USE" : "NO Use"; 
//#ifndef _NO_EUV	
//			m_sEDC[edcEUV_TIME1].Format( "%6d H", pView->m_pEuvSeq->GetLampUsedTime( 0 ) / 3600 );
//			m_sEDC[edcEUV_TIME2].Format( "%6d H", pView->m_pEuvSeq->GetLampUsedTime( 1 ) / 3600 );
//			m_sEDC[edcEUV_TIME3].Format( "%6d H", pView->m_pEuvSeq->GetLampUsedTime( 2 ) / 3600 );
//			m_sEDC[edcEUV_TIME4].Format( "%6d H", pView->m_pEuvSeq->GetLampUsedTime( 3 ) / 3600 );
//			m_sEDC[edcEUV_TIME5].Format( "%6d H", pView->m_pEuvSeq->GetLampUsedTime( 4 ) / 3600 );
//			m_sEDC[edcEUV_TIME6].Format( "%6d H", pView->m_pEuvSeq->GetLampUsedTime( 5 ) / 3600 );
//#else
//			m_sEDC[edcEUV_TIME1].Format( "    0 H" );
//			m_sEDC[edcEUV_TIME2].Format( "    0 H" );
//			m_sEDC[edcEUV_TIME3].Format( "    0 H" );
//			m_sEDC[edcEUV_TIME4].Format( "    0 H" );
//			m_sEDC[edcEUV_TIME5].Format( "    0 H" );
//			m_sEDC[edcEUV_TIME6].Format( "    0 H" );
//#endif
//			m_sEDC[edcRCP_ID].Format("%2s", pDoc->m_sRecipeId);
//
//
//			CJobsTabProcessDataView* pViewProcess = ( (CDicsView *) m_pOwnerWnd )->m_pTabJobsProcessDataView;
//			pViewProcess->SendMessage( WM_EDC_DATA_CHANGED, (WPARAM) 0 );
//			
//			nSeqNo = 20;
//		}
//		break;
//	case 20:
//		if ( !mibIF_DCL_REQ )
//		{
//			mobIF_DCL_SET( OFF );
//			nSeqNo = 0;
//		}
		break;
	}
	m_nSeqDailyCheckReportNo = nSeqNo;
}

void CCimSeq::SeqSubIdDataSet()
{
	int nStep = m_nSeqSubIdDataSetNo;

	// Position Glass Data <<
	int nMaxGlassNo = m_pDicsData->m_GenInfo.nMaxEqpGlassNo;
	static BOOL nOldGlsInfo[MAX_UNIT_NO*2] = {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
	static int nOldEQStatus = -1;
	CString sSendData, sReciveData;
	int nHasGlass = 0;
	int nSendData=0;

	for( int i = 0 ; i < MAX_UNIT_NO*2 ; i++ )
	{
		if( m_pDicsData->m_GlsInfo[i].bIsValid != nOldGlsInfo[i] )
		{
			if( m_pDicsData->m_GlsInfo[i].bIsValid )
			{

				int nPortNo = m_pDicsData->m_GlsInfo[i].nPortNo;
				int nSlotNo = m_pDicsData->m_GlsInfo[i].nSlotNo;

				//sSendData.Format( "%2x", nPortNo );
				mogwCLN_POSITION_DATA_PORT( (int)(i/2), nPortNo );
				//sSendData.Format( "%2x", nSlotNo );
				mogwCLN_POSITION_DATA_SLOT( (int)(i/2), nSlotNo );

				m_sMessage.Format( "Substrate ID Data No%d", i + 1 );
				SetLog( "SUB ID  ", nPortNo, nSlotNo, m_sMessage );
			}
			else
			{
				mogwCLN_POSITION_DATA_PORT( (int)(i/2), 0);
				mogwCLN_POSITION_DATA_SLOT( (int)(i/2), 0 );
			}
			nOldGlsInfo[i] = m_pDicsData->m_GlsInfo[i].bIsValid;
		}
	}
	// >>


	// EQ Status <<
	sSendData = "";
	for( int i = 0 ; i < MAX_UNIT_NO*2 ; i++ )
	{
		if( m_pDicsData->m_GlsInfo[i].bIsValid ) nHasGlass++;
	}


	if( m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateDOWN] )	// DOWN.
	{
		sSendData.Format( "%2x", 0 );
		nSendData = 0;
		nOldEQStatus = 0;
	}
	else if( m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateMANUAL] )		// Maintain Status.
	{
		sSendData.Format( "%2x", 4 );
		nSendData = 4;
		nOldEQStatus = 4;
	}
/*	else if( nOldEQStatus != 3 )		// PM Status. PM   manual(Maint)  .
	{
		sSendData.Format( "%2x", 3 );
		nOldEQStatus = 3;
	}
*/	else if( nHasGlass != 0)	// RUN.
	{
		sSendData.Format( "%2x", 1 );
		nSendData = 1;
		nOldEQStatus = 1;
	}
	else if( !m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateMANUAL])	// Idle.
	{
		sSendData.Format( "%2x", 2 );
		nSendData = 2;
		nOldEQStatus = 2;
	}

	if( sSendData != "" )
	{
		mowCLN_EQ_STATUS( nSendData);
	}
	// >>

	// Alive  . <<<<<
	// Alive ´ 4ʿ ѹ  Ѵ. 1 255 . 15 ̻    α׷ ̳̽   ǴѴ.
	static DWORD dAliveTime = GetCurrentTime();
	static int nAliveStep = 1 ;
	if(GetCurrentTime() - dAliveTime > 2000)
	{
		if(nAliveStep > 255) nAliveStep = 1;

		//sSendData.Format( "%2x", nAliveStep );
		//sSendData.Format( "%02x", nAliveStep );
		//mowCLN_ALIVE_CHECK( sSendData.GetBuffer(2), 2 );
		mowCLN_ALIVE_CHECK( nAliveStep );
		nAliveStep++;
		dAliveTime = GetCurrentTime();
	}
	// >>>>

	// Control Status Mode <<<<<
	static int nOldAuto = -1;
	if( m_pDicsData->m_GenInfo.bAuto != nOldAuto )
	{
		if( m_pDicsData->m_GenInfo.bAuto)	nSendData = 1;//sSendData.Format( "%2x", 1 );
		else								nSendData = 2; //sSendData.Format( "%2x", 2 );

		mowCLN_CONTROL_STATUS_MODE( nSendData );
		nOldAuto = m_pDicsData->m_GenInfo.bAuto;
	}
	// >>

	// CIM Connect Status <<<<<<
	static int nOldCimConnect = -1;
	static DWORD dCIMAliveTime = GetCurrentTime();
	static int nAliveStatus = 0;
	int nMode, nVal;
	BOOL bFirstCheck=FALSE;

	nVal = miwCIM_ALIVE_CHECK;
//	sReciveData.Format( "%c%c", nVal & 0xFF, ( ( nVal & 0xFF00 ) >> 8 ) );
	nMode = nVal;//atoi(sReciveData);
	

	sSendData = "";
	if( 0 < nMode && nMode <= 255)
	{
		if( nOldCimConnect != nMode )	//  ¿ ٸٸ 1̴.
		{
			sSendData.Format( "%2x", 1 );
			nSendData = 1;
			nOldCimConnect = nMode;
			dCIMAliveTime = GetCurrentTime();
			nAliveStatus = 1;
//			sReciveData.Format("[Glass Delete] CIM Disconnect Check data(%d)", nMode);
//			SetLog( m_sSeqName, 0, 0, sReciveData );
			m_bCIMPCAliveOnline = TRUE;
		}
		else if( GetCurrentTime() - dCIMAliveTime > 15000 && nAliveStatus != 2)	// 15     OFFLINE ̴.
		{
			sSendData.Format( "%2x", 0 );
			nSendData = 0;
			dCIMAliveTime = GetCurrentTime();
			nAliveStatus = 2;
			SetLog( m_sSeqName, 0, 0, "[Glass Delete] CIM Disconnect. Alive time out" );
			m_bCIMPCAliveOnline = FALSE;
		}

		if( sSendData != "" )
		{
			mowCLN_CIM_CONNECT_STATUS( nSendData );
		}
	}
	else if( nOldCimConnect != nMode && nAliveStatus !=3 )	// 1~255  ƴϰ  ¿ ٸٸ OFFLINE
	{
		//sSendData.Format( "%2x", 0 );
		nSendData = 0;
		mowCLN_CIM_CONNECT_STATUS( nSendData );
		sSendData.Format("[Glass Delete] CIM Disconnect. Alive value error(%d)", nMode);
		SetLog( m_sSeqName, 0, 0, sSendData );
		nOldCimConnect = nMode;
		nAliveStatus = 3;
		m_bCIMPCAliveOnline = FALSE;
	}
	// >>
	m_nSeqSubIdDataSetNo = nStep;
}


void CCimSeq::SeqGlassDataDel()
{
	int nStep = m_nSeqGlassDelNo;
	CString sGlassData;
	static DWORD dTimeOut = GetCurrentTime();
	static int nAlarmId = 0;
	static int nReturnSeqNo;

	CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();
	DWORD nT1_Timeout = atoi( pDoc->m_pSetupItems->m_sValueInterfacePara[CSetupItems::timeoutINTERFACE_T1] ) * 1000;
	DWORD nT3_Timeout = atoi( pDoc->m_pSetupItems->m_sValueInterfacePara[CSetupItems::timeoutINTERFACE_T3] ) * 1000;

	switch(nStep)
	{
	case 0:
		if(m_pDicsData->m_IfCim.bGlassDataDelete)
		{
			m_pDicsData->m_IfCim.bGlassDataDelete=FALSE;
			SetLog( m_sSeqName, 0, 0, "[Glass Delete] Start" );
			nStep = 10;
		}
		break;
	case 10:
		{
			int nNo = m_pDicsData->m_IfCim.nGlassDataDeleteNo;
			int nPortNo = m_pDicsData->m_GlsInfo[nNo].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[nNo].nSlotNo;

			//sGlassData.Format( "%2x", nPortNo );
			mowCLN_PANEL_REMOVE_PORTNO( nPortNo );
			//sGlassData.Format( "%2x", nSlotNo );
			mowCLN_PANEL_REMOVE_SLOTNO( nSlotNo );
			dTimeOut = GetCurrentTime();

			sGlassData.Format("[Glass Delete] Port=%d, Slot=%d", nPortNo, nSlotNo);
			SetLog( m_sSeqName, 0, 0, sGlassData );
			nStep = 20;
		}
		break;
	case 20:
		if(GetCurrentTime()-dTimeOut > 300)
		{
			mobCLN_PANEL_REMOVE_FLAG(TRUE);
			dTimeOut = GetCurrentTime();
			nStep = 30;
		}
		break;
	case 30:
		if(moswCLN_CIM_CONNECT_STATUS==FALSE)	// Disconnect̸ Flag Ⱥ.
		{
			SetLog( m_sSeqName, 0, 0, "[Glass Delete] CIMPC Disconnect" );
			nStep = 40;
			break;
		}
		if(mibCST_PANEL_REMOVE_REPLY_FLAG)
		{
			nStep = 40;
		}
		else if(GetCurrentTime()-dTimeOut > nT1_Timeout)
		{
			SetLog( m_sSeqName, 0, 0, "[Glass Delete] Not respons reply flag(TRUE)" );
			
			nAlarmId = ALM_CIMPC_T1_TIMEOUT;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			nReturnSeqNo = nStep;
			nStep = 5000;

		}
		else if( m_pDicsData->m_EqpInfo.cCIMPCMode == CDicsData::modeOFFLINE )
		{
			SetLog( m_sSeqName, 0, 0, "[Glass Delete] OFFLINE(TRUE)" );
			nStep = 40;
		}
		break;
	case 40:
		{
			mobCLN_PANEL_REMOVE_FLAG(FALSE);
			dTimeOut = GetCurrentTime();
			nStep = 50;
		}
		break;
	case 50:
		if(moswCLN_CIM_CONNECT_STATUS==FALSE)	// Disconnect̸ Flag Ⱥ.
		{
			SetLog( m_sSeqName, 0, 0, "[Glass Delete] CIMPC Disconnect" );
			nStep = 60;
			break;
		}
		if(!mibCST_PANEL_REMOVE_REPLY_FLAG)
		{			
			nStep =60;
		}
		else if(GetCurrentTime()-dTimeOut > nT3_Timeout)
		{
			SetLog( m_sSeqName, 0, 0, "[Glass Delete] Not respons reply flag(FALSE)" );
			nAlarmId = ALM_CIMPC_T3_TIMEOUT;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			nReturnSeqNo = nStep;
			nStep = 5000;
		}
		else if( m_pDicsData->m_EqpInfo.cCIMPCMode == CDicsData::modeOFFLINE )
		{
			SetLog( m_sSeqName, 0, 0, "[Glass Delete] OFFLINE(TRUE)" );
			nStep = 60;
		}
		break;
	case 60:
		{
			SetLog( m_sSeqName, 0, 0, "[Glass Delete] DONE" );
			mowCLN_PANEL_REMOVE_PORTNO( 0 );
			mowCLN_PANEL_REMOVE_SLOTNO( 0 );
			nStep = 0;
		}
		break;
	case 5000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			mobCLN_PANEL_REMOVE_FLAG(FALSE);
			m_pEqpStateSeq->ResetAlarm( nAlarmId );
			nAlarmId = 0;
			nStep = 0;
		}
		break;
	}

	m_nSeqGlassDelNo = nStep;
}


void CCimSeq::SeqRunModeChange()
{
	int nStep = m_nSeqRunModeChangeNo;
	int nVal, nReturnSeqNo;
	CString sRunMode, sReciveData;
	int nSendData;
	static DWORD dTimeOut = GetCurrentTime();
	static int nAlarmId = 0;

	CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();
	DWORD nT2_Timeout = atoi( pDoc->m_pSetupItems->m_sValueInterfacePara[CSetupItems::timeoutINTERFACE_T2] ) * 1000;

	switch(nStep)
	{
	case 0:
		if(mibCIM_RUN_MODE_REQUEST_FLAG)
		{
			SetLog( m_sSeqName, 0, 0, "[Run Mode Change] Start" );
			nStep = 10;
		}
		break;
	case 10:
		{
			int nMode;
			nVal = miwCIM_RUNMODE_COMMAND;
			//sReciveData.Format( "%c%c", nVal & 0xFF, ( ( nVal & 0xFF00 ) >> 8 ) );

			nMode = nVal;//atoi(sReciveData);
			
			if( nMode != 1 && nMode !=2 )	// hskwak 191106
			{
				sRunMode.Format("[Run Mode Change] Mode information fail(%d)", nMode);
				SetLog( m_sSeqName, 0, 0, sRunMode );

				//sRunMode.Format( "%2x", 1 );
				nSendData = 2;	// hskwak 191106 .
				mowCLN_RUN_MODE_CHANGE_ACK( nSendData );
				nStep=0;
				break;
			}

			if( nMode== 1)
			{
				sRunMode = "[Run Mode Change] Mode=Online";
				m_pDicsData->m_EqpInfo.cCIMPCMode = CDicsData::modeCONTROL;

				//sRunMode.Format( "%2x", 1 );
				nSendData = 1;
				mowCLN_EQ_RUN_MODE( nSendData );
//				mowCLN_RUN_MODE_CHANGE_ACK( nSendData );
			}
			else
			{
				sRunMode = "[Run Mode Change] Mode=Offline";
				m_pDicsData->m_EqpInfo.cCIMPCMode = CDicsData::modeOFFLINE;
				//sRunMode.Format( "%2x", 0 );
				nSendData = 2;
				mowCLN_EQ_RUN_MODE( nSendData );
//				mowCLN_RUN_MODE_CHANGE_ACK( nSendData );
			}

			SetLog( m_sSeqName, 0, 0, sRunMode );
			nStep = 20;
		}
		break;
	case 20:
		if(GetCurrentTime()-dTimeOut > 300)
		{
			mobCLN_RUN_MODE_CHANGE(TRUE);
			dTimeOut = GetCurrentTime();
			nStep = 30;
		}
		break;
	case 30:
		if(moswCLN_CIM_CONNECT_STATUS==FALSE)	// Disconnect̸ Flag Ⱥ.
		{
			SetLog( m_sSeqName, 0, 0, "[Run Mode Change] CIMPC Disconnect" );
			nStep = 40;
			break;
		}
		if(!mibCIM_RUN_MODE_REQUEST_FLAG)
		{
			nStep = 40;
		}
		else if(GetCurrentTime()-dTimeOut > nT2_Timeout)
		{
			SetLog( m_sSeqName, 0, 0, "[Run Mode Change] Not respons request flag(FALSE)" );

			nAlarmId = ALM_CIMPC_T2_TIMEOUT;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			nReturnSeqNo = nStep;
			nStep = 5000;
		}
		break;
	case 40:
		{
			nSendData = 1/*2*/;
			mowCLN_RUN_MODE_CHANGE_ACK( nSendData );
			mobCLN_RUN_MODE_CHANGE(FALSE);
			dTimeOut = GetCurrentTime();
			nStep = 50;
		}
		break;
	case 50:
		{
			SetLog( m_sSeqName, 0, 0, "[Run Mode Change] DONE" );
			mowCLN_PANEL_REMOVE_PORTNO( 0 );
			mowCLN_PANEL_REMOVE_SLOTNO( 0 );
			nStep = 0;
		}
		break;
	case 5000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId );
			nAlarmId = 0;
			nStep = 40;
		}
		break;
	}

	m_nSeqRunModeChangeNo = nStep;
}

void CCimSeq::SeqCimPcClockUpdate()
{
	static int nOldClockIndex = 0;

	if( nOldClockIndex == 0 )
	{
		nOldClockIndex = miwCIM_CLOCK_UPDATE;
	}
	else if( nOldClockIndex != miwCIM_CLOCK_UPDATE )
	{
		nOldClockIndex = miwCIM_CLOCK_UPDATE;

		SYSTEMTIME sysTime;
		::GetSystemTime( &sysTime );
		if((WORD)(miwCIM_CLOCK_YYMM/100) < 0 || 99 < (WORD)(miwCIM_CLOCK_YYMM/100)) return;
		if((WORD)(miwCIM_CLOCK_YYMM%100) < 0 || 12 < (WORD)(miwCIM_CLOCK_YYMM%100)) return;
		if((WORD)(miwCIM_CLOCK_DDHH/100) < 0 || 31 < (WORD)(miwCIM_CLOCK_DDHH/100)) return;
		if((WORD)(miwCIM_CLOCK_DDHH%100) < 0 || 23 < (WORD)(miwCIM_CLOCK_DDHH%100)) return;
		if((WORD)(miwCIM_CLOCK_MMSS/100) < 0 || 59 < (WORD)(miwCIM_CLOCK_MMSS/100)) return;
		if((WORD)(miwCIM_CLOCK_MMSS%100) < 0 || 59 < (WORD)(miwCIM_CLOCK_MMSS%100)) return;
		sysTime.wYear	= (WORD)(miwCIM_CLOCK_YYMM/100);
		sysTime.wMonth	= (WORD)(miwCIM_CLOCK_YYMM%100);
		sysTime.wDay	= (WORD)(miwCIM_CLOCK_DDHH/100);
		sysTime.wHour	= (WORD)(miwCIM_CLOCK_DDHH%100);
		sysTime.wMinute = (WORD)(miwCIM_CLOCK_MMSS/100);
		sysTime.wSecond = (WORD)(miwCIM_CLOCK_MMSS%100);
		::SetLocalTime( &sysTime ); 
	}
}

void CCimSeq::SeqCimPcMSGUpdate()
{
	static int nOldMSGIndex = 0;
	CString sBuf;

	if( nOldMSGIndex == 0 )
	{
		nOldMSGIndex = miwCIM_MSG_DISPLAY;
	}
	else if( nOldMSGIndex != miwCIM_MSG_DISPLAY )
	{
		nOldMSGIndex = miwCIM_MSG_DISPLAY;

		miwCIM_MSG_ASCII( sBuf.GetBuffer( 40 ), 40	);

		CDicsView* pView = (CDicsView *) m_pOwnerWnd;
		( (CDicsView*) m_pOwnerWnd )->SendMessage( WM_JOBS_VIEW, (WPARAM) MSG_TERMINAL_MESSAGE, (LPARAM) (LPARAM)(LPCTSTR)sBuf );
	}
}

void CCimSeq::SeqCimT3TimeoutCheck()	// shcho 230207
{
	if (m_pEqpStateSeq->IsAlarm(ALM_CIM_T3_TIMEOUT))
	{
		if (m_pEqpStateSeq->IsPushedAlarmReset())
		{
			m_pEqpStateSeq->ResetAlarm(ALM_CIM_T3_TIMEOUT);
		}
	}
}

void CCimSeq::SeqCimT9TimeoutCheck()	// shcho 230207
{
	if (m_pEqpStateSeq->IsAlarm(ALM_CIM_T9_TIMEOUT))
	{
		if (m_pEqpStateSeq->IsPushedAlarmReset())
		{
			m_pEqpStateSeq->ResetAlarm(ALM_CIM_T9_TIMEOUT);
		}
	}
}
