// DicsCimSeq.h: interface for the CDicsCimSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CIMSEQ_H__6E2FDD36_ED82_4AD3_9D3B_324BCAD43B19__INCLUDED_)
#define AFX_CIMSEQ_H__6E2FDD36_ED82_4AD3_9D3B_324BCAD43B19__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
//////////////////////////////////////////////////////////////////////
// Header File  Sequence->Data->X File ...
//   BOOL -> int -> float -> double -> WORD -> DWORD -> Char -> CString -> enum
// ٸ      ִ.. 
//////////////////////////////////////////////////////////////////////
#include "..\MOTHER\DicsCimSeq.h"
#include "..\DicsView.h"
#include "..\Host.h"
#include "..\Host1.h"

#include "..\X\XTimer.h"
#include "..\X\XLog.h"
#include "..\X\XCtlDevice.h"

class CCimSeq : public CDicsCimSeq  
{
public:
	CCimSeq();
	virtual ~CCimSeq();

	void SetOwnerPointer(CWnd* pWnd);
public:
	// Pointer variables
	CHost*			    m_pHost;
	CHost1*			    m_pHost1;
	CDicsView*			m_pDicsView;

	CString			m_sMessage;
	CString			m_sErrMessage;
	CString			m_sLog;
	CString			m_sSeqName;

	// Define the Struct variables
public:
	struct tagSeqFlag
	{
		BOOL bInitReq;
		BOOL bInitComp;	
		BOOL bInitFail;
		BOOL bAgvModeChangeReq[MAX_PORT_NO];
		BOOL bReqGlsApd;
		BOOL bReqLotApd;

		int  nSourcePortNo;
		int  nTargetPortNo;
	} m_SeqFlag;

	enum	_LOT_APD_DATA
	{
		lpdLOT_LD_TIME,
		lpdLOT_UL_TIME,
		lpdAI_START,
	};

	enum	_APD_Data
	{
 		apdSLOT_NO,
 		apdRCP_ID,
		apdGLS_START_TIME,
		apdGLS_END_TIME,
		apdAI_START,
		apdStatus_START = apdAI_START + MAX_AI_INTR_NO,
		apdGap_START = apdStatus_START + MAX_APD_STATUS_DATA_DI_NO,
		apdPinTime_START = apdGap_START + MAX_APD_STATUS_DATA_GAP_NO,
		apdTackTime_START = apdPinTime_START + MAX_APD_STATUS_DATA_PIMTIME_NO,
	
	};

	CString		m_sEDC[MAX_EDC_DATA_NO];		// CMO = Daily Check

	// Sequence
	int	m_nSeqConnectNo;
	int m_nSeqCtlModeChangeNo;
	int m_nSeqPortModeChangeNo[MAX_PORT_NO];
	int m_nSeqTrsModeChangeNo[MAX_PORT_NO];
	int m_nSeqNormalNo[MAX_PORT_NO];
	int m_nSeqAlarmNo;
	int m_nSeqRecipeBodyChangeReportNo;
	int m_nSeqSubIdDataSetNo;
	int	m_nSeqDailyCheckReportNo;
	int	m_nSeqRunModeChangeNo;
	int m_nSeqGlassDelNo;
	BOOL m_bCIMPCAliveOnline;
	
public:
	void InitParameter();
	BOOL Sequence();
	BOOL Initialize();

	// Pointer Set Function
	void SetDevice(XCtlDevice* pDevice) { m_pDevice = pDevice; }
	void SetHost( CHost* pHost )	{ m_pHost = pHost; }
	void SetHost1( CHost1* pHost1 )	{ m_pHost1 = pHost1; }
	void SetDicsView( CDicsView *pView ) { m_pDicsView = pView;	}
	void GetGlassDv();
	void GetLotDv();

	void SetSeqTimer( XTimer* pTimer ) { m_pTimer = pTimer; }
	void SetDicsData( CDicsData* pDicsData ) { m_pDicsData = pDicsData; }
	void SetSetupItems( CSetupItems* pSetupItems ) { m_pSetupItems = pSetupItems; }
	void SetEqpStateSequence(CEqpStateSequence* pEqpStateSeq) { m_pEqpStateSeq = pEqpStateSeq; }
	void SetMelsec( XCtlMelsec * pMelsec ){ m_pMelsec = pMelsec; }
	void SetEqpAssy( CEqpAssy* pEqpAssy) { m_pEqpAssy = pEqpAssy; }
	// Sequence
public:
	// Sequence
	void SeqConnect();
	void SeqEqpState();
	void SeqCtlModeChange();
	void SeqPortModeChange(int i);
	void SeqTrsModeChange(int i);
	void SeqAlarm();
	void SeqOpIdReport();
	void SeqRecipeBodyChangeReport();
	void GetMapInfoFromRecipe( int i );
//	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );//2008.12.17 KIMGUN
	void SetTraceDataValue();
	void SeqDailyCheckReport();

	void SetAPDDataStatus();	// 2019.08.22 hskwak set APD Data Status 
	
public:
	void SeqGlsApd();
	void SeqSubIdDataSet();
	void SeqGlassDataDel();
	void SeqRunModeChange();
	void SeqCimPcClockUpdate();
	void SeqCimPcMSGUpdate();
	void SeqCimT3TimeoutCheck();	// shcho 230207
	void SeqCimT9TimeoutCheck();	// shcho 230207

#ifdef _LOADER_DEBUG
	BOOL m_bSubIdDataSetReq;
#endif

};

#endif // !defined(AFX_CIMSEQ_H__6E2FDD36_ED82_4AD3_9D3B_324BCAD43B19__INCLUDED_)
