// CimSeq1.cpp: implementation of the CCimSeq1 class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "CimSeq1.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCimSeq1::CCimSeq1()
{

}

CCimSeq1::~CCimSeq1()
{

}

void CCimSeq1::SetOwnerPointer(CWnd* pWnd)
{
	SetDicsView( ( CDicsView* )pWnd );
	SetDicsData( m_pDicsView->m_pDicsData );
	SetDevice( m_pDicsView->m_pDevice );
	SetSetupItems( m_pDicsView->GetDocument()->m_pSetupItems );
	SetEqpStateSequence( m_pDicsView->m_pEqpStateSeq );
	SetSeqTimer( m_pDicsView->m_pTimer );
}

BOOL CCimSeq1::Initialize()
{
	InitParameter();

	return TRUE;
}

void CCimSeq1::InitParameter()
{
	for(int i = 0; i < MAX_TRACE_MULTI_NO; i++ ) 	// 231220 halesu Index NG Fix
	{
		m_nSeqTraceDataReportNo[i] = 0;
		m_nSeqSampleTime[i] = 0;
	}
	m_nSeqConnectNo = 0;
	m_nSeqTraceNo = 0;	// shcho 220525
}


BOOL CCimSeq1::Sequence()
{
	static DWORD dTime = GetCurrentTime();
	Sleep( 10 );

	SeqConnect();

	SetTraceDataValue();	// 100614 halesu

//	for(int i = 0; i < MAX_TRACE_MULTI_NO ; i++ )//2008.10.08 kimgun
//	{
//		SeqTraceDataReport( i );
//	}
//	
//	for( int i = 0; i < MAX_CEID_NO ; i++ )
//	{
//		if( m_pHost1->m_bEventReportReq[i] )
//		{
//			//if(GetCurrentTime() - dTime > 100)
//			if(GetCurrentTime() - dTime > 500)	// shcho 220525
//			{
//				SeqEventIdReport( i );
//				dTime = GetCurrentTime();
//			}
//		}
//		//if(GetCurrentTime() - dTime > 1000)
//		if(GetCurrentTime() - dTime > 1000)	// shcho 220525
//		{
//			dTime = GetCurrentTime();
//		}
////	SeqSampleTime( i );
//	}
	SeqTrace();	// shcho 220525
	SeqCimT3TimeoutCheck();	// shcho 230207

	return TRUE;
}

void CCimSeq1::SeqConnect()
{
	int nSeqNo = m_nSeqConnectNo;

	switch( nSeqNo )
	{
	case 0:
		if( m_pHost1->m_bConnected )
		{
			// Log
			SetLog( "CONNECT", 0, 0, "Host1 is Connected" );
			nSeqNo = 10;
		}
		break;

	case 10:
		if( !m_pHost1->m_bConnected ) 
		{
			// Log
			SetLog( "CONNECT", 0, 0, "Host1 is Disconnected" );
			// Log
			SetLog( "CONNECT", 0, 0, "Change to Offline" );

			// Set value
//			m_pDicsData->m_EqpInfo.cCtlMode = CDicsData::modeOFFLINE;

			// Send Message
//			Msg( WM_JOBS_VIEW, (WPARAM) MSG_CTRL_MODE, (LPARAM) "Offline" );

			nSeqNo = 0;
		}
		break;
	}

	m_nSeqConnectNo = nSeqNo;

}

void CCimSeq1::SeqTrace()
{	
	static DWORD dwStartTick = 0;

	int nSeqNo = m_nSeqTraceNo;

	switch (nSeqNo)
	{
	case 0:
		{
			for (int i = 0; i < MAX_TRACE_MULTI_NO; i++)
			{
				SeqTraceDataReport(i);
			}
			dwStartTick = GetTickCount();
			nSeqNo = 10;					
		}
		break;
	case 10:
		if ((GetTickCount() - dwStartTick) > 300)
		{
			for (int i = 0; i < MAX_CEID_NO; i++)
			{
				if (m_pHost1->m_bEventReportReq[i])
				{
					SeqEventIdReport(i);					
					break;
				}
			}
			dwStartTick = GetTickCount();
			nSeqNo = 20;
		}
		break;
	case 20:
		if ((GetTickCount() - dwStartTick) > 200)
		{
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqTraceNo = nSeqNo;
}

void CCimSeq1::SeqTraceDataReport( int nIndex )
{
	int nSeqNo = m_nSeqTraceDataReportNo[nIndex];
	static DWORD dwStartTick[MAX_TRACE_MULTI_NO] = { 0, };
//	static int nOldTime[MAX_TRACE_MULTI_NO] = {-1,-1,-1,-1,-1,-1};
//	static UINT uSampleNo = 0;
//	m_pDicsData->m_TraceData[nIndex].uSampleNo = 0;
	//2008.10.08 kimgun Time keyϱ..
	SYSTEMTIME SystemTime;
	GetLocalTime(&SystemTime);
	CString sDateTime;
	sDateTime.Format("%02d",SystemTime.wSecond);
	int nTimeKey = 0;
	int nCurTime = atoi( sDateTime );
	nTimeKey = nCurTime % 6;
	//static UINT oldSampleNo = 0;	// 20200406 ssm
	static UINT oldSampleNo[MAX_TRACE_MULTI_NO] = { 0, };	// shcho 220525
	//////////////////////////////////////////////////////////////////////////

	if( m_pDicsData->m_TraceData[nIndex].uSampleNo > 99 )
	{
		m_pDicsData->m_TraceData[nIndex].uSampleNo = 0;
	}

	switch( nSeqNo ) 
	{
	case 0 :
		if( m_pDicsData->m_TraceData[nIndex].bTraceDataStartReq/* && ( nTimeKey == nIndex )*/ )
		{
			m_pDicsData->m_TraceData[nIndex].bTraceDataStartReq = FALSE;
			m_pDicsData->m_TraceData[nIndex].bTraceDataStopReq = FALSE;
			m_pDicsData->m_TraceData[nIndex].uSampleNo = 0;
			dwStartTick[nIndex] = GetTickCount();

			//2008.11.07 kimgun Trace key Glass data Sync
//			for( int i = TRACE_START_UNIT * 2; i < IF_UNIT_UL_HAND * 2; i++ )	//hskwak Ȯ ʿ
//			{
//				if( m_pDicsData->m_GlsInfo[i].bIsValid )
//				{
//					m_pDicsData->m_GlsInfo[i].nMultiTraceKey = nIndex;
//				    break;
//				}
//			}

			nSeqNo = 10;
		}
		break;

	case 10 :
		if( ( GetTickCount() - dwStartTick[nIndex] ) > (DWORD)( m_pDicsData->m_TraceData[nIndex].dSamplePeriod * 994 ) )
		{
			m_pDicsData->m_TraceData[nIndex].uSampleNo++;

			dwStartTick[nIndex] = GetTickCount();

			nSeqNo = 20;
		}
		else if( m_pDicsData->m_TraceData[nIndex].bTraceDataStopReq )
		{
			m_pDicsData->m_TraceData[nIndex].bTraceDataStopReq = FALSE;
			nSeqNo = 0;
		}
		break;

	case 20 :
		if( oldSampleNo[nIndex] != m_pDicsData->m_TraceData[nIndex].uSampleNo )	// 20200406 ssm
		{
			oldSampleNo[nIndex] = m_pDicsData->m_TraceData[nIndex].uSampleNo;

			if( m_pHost1->S6F1( nIndex/* + 1*/ ) != -100)//m_pHost1->SecondaryRcvd( "S6F1" ) )
			{
				nSeqNo = 30;
			}
			else if( m_pDicsData->m_TraceData[nIndex].bTraceDataStopReq )
		{
			m_pDicsData->m_TraceData[nIndex].bTraceDataStopReq = FALSE;
			nSeqNo = 0;
			}
	//		else // ð DELAY ϴ° Ƴ?
	//		{
	//			m_pDicsData->m_TraceData[nIndex].bTraceDataStartReq= FALSE;
	//			nSeqNo = 0;
	//		}
		}
		else
		{
			nSeqNo = 10;
		}
		break;

	case 30 :
		if( m_pDicsData->m_TraceData[nIndex].bTraceDataStopReq )
		{
			m_pDicsData->m_TraceData[nIndex].bTraceDataStopReq = FALSE;
			nSeqNo = 0;
		}
		else
		{
			dwStartTick[nIndex] = GetTickCount();	// shcho 230202
			nSeqNo = 10;
		}
		break;
	}
	m_nSeqTraceDataReportNo[nIndex] = nSeqNo;
}

void CCimSeq1::SeqEventIdReport( int nIndex )
{
	if( m_pHost1->m_bEventReportReq[nIndex] )
	{
		m_pHost1->m_bEventReportReq[nIndex] = FALSE;
		m_pHost1->S6F11( nIndex );
	}
}
/*
void CCimSeq1::SeqSampleTime( int nIndex )
{
	int nSeqNo = m_nSeqSampleTime[nIndex];
	static DWORD dwStartTick[MAX_TRACE_DATA_NO]				= { 0, };

	switch( nSeqNo ) 
	{
	case 0 :
		if( m_pDicsData->m_TraceData[nIndex].bTraceDataStartReq )
		{
			m_pDicsData->m_TraceData[nIndex].bTraceDataStartReq = FALSE;
			m_pDicsData->m_TraceData[nIndex].bTraceDataStopReq = FALSE;

			dwStartTick[nIndex] = GetTickCount();

			nSeqNo = 10;
		}
		break;

	case 10 :
		if( ( GetTickCount() - dwStartTick[nIndex] ) > (DWORD)( m_pDicsData->m_TraceData[nIndex].dSamplePeriod * 985 ) )
		{
			m_pDicsData->m_TraceData[nIndex].uSampleNo++;

			m_pDicsData->m_TraceData[nIndex].bTraceDataReportReq = TRUE;

			nSeqNo = 20;
		}
		break;

	case 20 :
		if( m_pDicsData->m_TraceData[nIndex].bTraceDataStopReq )
		{
			m_pDicsData->m_TraceData[nIndex].bTraceDataStopReq = FALSE;
			m_pDicsData->m_TraceData[nIndex].bTraceDataStartReq = FALSE;
			m_pDicsData->m_TraceData[nIndex].uSampleNo = 0;
			nSeqNo = 0;
		}
		else
		{
			dwStartTick[nIndex] = GetTickCount();
			nSeqNo = 10;
		}
		break;
	}
	m_nSeqSampleTime[nIndex] = nSeqNo;
}

void CCimSeq1::SeqTraceDataReport( int nIndex )
{
	int nSeqNo = m_nSeqTraceDataReportNo[nIndex];
	static DWORD dwStartTick[MAX_TRACE_DATA_NO]				= { 0, };
//	static UINT uSampleNo = 0;
//	m_pDicsData->m_TraceData[nIndex].uSampleNo = 0;

	switch( nSeqNo ) 
	{
	case 0 :
		if( m_pDicsData->m_TraceData[nIndex].bTraceDataReportReq )
		{
			m_pDicsData->m_TraceData[nIndex].bTraceDataReportReq = FALSE;

			m_pHost1->S6F1( nIndex + 1 );

			nSeqNo = 10;
		}
		break;

	case 10 :
		if( m_pHost1->SecondaryRcvd( "S6F1" ) )
		{
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqTraceDataReportNo[nIndex] = nSeqNo;
}
*/// 100614 halesu
void CCimSeq1::SetTraceDataValue()
{
	SYSTEMTIME SystemTime;
	GetLocalTime(&SystemTime);
	m_pDicsData->m_IfCim.sTraceDataTime.Format("%04d%02d%02d%02d%02d%02d.%02d",
		SystemTime.wYear, 
		SystemTime.wMonth, 
		SystemTime.wDay, 
		SystemTime.wHour, 
		SystemTime.wMinute, 
		SystemTime.wSecond, 
		SystemTime.wMilliseconds );
// #ifndef _NO_EUV
// 	m_pDicsData->m_IfCim.sTraceDataValue[29].Format( "%.1f", m_pDicsView->m_pEuvSeq->GetLampIntensity(0) );
// 	m_pDicsData->m_IfCim.sTraceDataValue[30].Format( "%.1f", m_pDicsView->m_pEuvSeq->GetLampIntensity(1) );
// 	m_pDicsData->m_IfCim.sTraceDataValue[31].Format( "%.1f", m_pDicsView->m_pEuvSeq->GetLampIntensity(2) );
// 	m_pDicsData->m_IfCim.sTraceDataValue[32].Format( "%.1f", m_pDicsView->m_pEuvSeq->GetLampIntensity(3) );
// #else
// 	m_pDicsData->m_IfCim.sTraceDataValue[29].Format( "%.1f", 0.0 );
// 	m_pDicsData->m_IfCim.sTraceDataValue[30].Format( "%.1f", 0.0 );
// 	m_pDicsData->m_IfCim.sTraceDataValue[31].Format( "%.1f", 0.0 );
// 	m_pDicsData->m_IfCim.sTraceDataValue[32].Format( "%.1f", 0.0 );
// #endif

/*#ifndef _MY_DEBUG*/
	CDicsDoc* pDoc = ( (CDicsView*) m_pOwnerWnd )->GetDocument();
//	m_pDicsData->m_IfCim.sTraceDataValue[0] = pDoc->m_sRecipeId;		// Trace 1 = Recipe

	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		int nApdNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nApdReportNo ;
		if( nApdNo < 0 ) continue;
		//m_pDicsData->m_IfCim.sTraceDataValue[25+nApdNo].Format( "%.1f", m_pEqpAssy->m_AnalogInput.GetRealVal(i) );
		m_pDicsData->m_IfCim.sTraceDataValue[traceAI_START + nApdNo].Format( "%.1f", m_pEqpAssy->m_AnalogInput.GetRealVal(i) );
	}

	for( int i=0; i<m_pEqpAssy->m_SensorAPDStatus.GetDiSize(); i++)
	{
		if( m_pEqpAssy->m_SensorAPDStatus.Get(i) == TRUE)
		{
			if( m_pDicsData->m_nSensorAPDStatusType[i] == FALSE ) 
				m_pDicsData->m_IfCim.sTraceDataValue[traceStatus_START+i] = "1";
			else
				m_pDicsData->m_IfCim.sTraceDataValue[traceStatus_START+i] = "0";
		}
		else
		{
			if( m_pDicsData->m_nSensorAPDStatusType[i] == FALSE ) 
				m_pDicsData->m_IfCim.sTraceDataValue[traceStatus_START+i] = "0";
			else
				m_pDicsData->m_IfCim.sTraceDataValue[traceStatus_START+i] = "1";
		}
	}

	for( int i=0; i<MAX_APD_STATUS_DATA_GAP_NO; i++)
	{
		m_pDicsData->m_IfCim.sTraceDataValue[traceGap_START+i].Format("%.2f", m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i ]);
	}

	CString strBuf;
	for( int i=0; i< MAX_APD_STATUS_DATA_PIMTIME_NO; i++)
	{
		strBuf.Format("%d.%d", m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[i]/1000, m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[i]%1000/100);
		m_pDicsData->m_IfCim.sTraceDataValue[tracePinTime_START+i] = strBuf;
	}

	for( int i=0; i<MAX_APD_STATUS_DATA_TACKTIME_NO; i++ )
	{
		m_pDicsData->m_IfCim.sTraceDataValue[traceTackTime_START+i].Format("%.2f", m_pDicsData->m_dUnitTackTime[i] );
	}

//  *** TEST ****
// 	CDicsDoc* pDoc = ( (CDicsView*) m_pOwnerWnd )->GetDocument();
// 	int nRow = pDoc->GetRowfromID( m_pDicsData->m_GlsInfo[1].sRecipeId );
// 	//			int nRecipeId = atoi( m_pDicsData->m_GlsInfo[k].sRecipeId );
// 	
// 	for( i=0; i<MAX_TOTAL_RECIPE_BODY_NO - 3; i++ )
// 	{
// 		// #ifdef _NO_RB //2008.11.07 kimgun 
// 		// 				if( i >= 7) continue;
// 		// #endif
// 		//				m_pDicsData->m_IfCim.sTraceDataValue[i+6] = ((pDoc->m_pRecipeInfo[nRow].sValue[i + 3] == "ON" ) ? "1" : "0" );
// 		//				m_pDicsData->m_IfCim.sTraceDataValue[i+6] = pDoc->m_pRecipeInfo[nRow].sValue[i + 3];
// 		// 110221 halesu
// 		m_pDicsData->m_IfCim.sTraceDataValue[i+6] = ((pDoc->m_pRecipeInfo[nRow].sValue[i + 3] == "ON" ) ? "1" :
// 		(pDoc->m_pRecipeInfo[nRow].sValue[i + 3] == "OFF" )? "0" :
// 		(pDoc->m_pRecipeInfo[nRow].sValue[i + 3] == "CW" ) ? "1" :
// 		(pDoc->m_pRecipeInfo[nRow].sValue[i + 3] == "CCW" )? "0" : pDoc->m_pRecipeInfo[nRow].sValue[i + 3] );
// 	}
}

void CCimSeq1::SeqCimT3TimeoutCheck()	// shcho 230207
{
	if (m_pEqpStateSeq->IsAlarm(ALM_CIM_T3_TIMEOUT2))
	{
		if (m_pEqpStateSeq->IsPushedAlarmReset())
		{
			m_pEqpStateSeq->ResetAlarm(ALM_CIM_T3_TIMEOUT2);
		}
	}
}
