// CimSeq1.h: interface for the CCimSeq1 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CIMSEQ1_H__59889DB7_2FD0_4047_8978_E6B39C956D08__INCLUDED_)
#define AFX_CIMSEQ1_H__59889DB7_2FD0_4047_8978_E6B39C956D08__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\MOTHER\DicsCimSeq.h"
#include "..\DicsView.h"
#include "..\Host.h"
#include "..\Host1.h"

#include "..\X\XTimer.h"
#include "..\X\XLog.h"
#include "..\X\XCtlDevice.h"

class CCimSeq1 : public CDicsCimSeq  
{
public:
	CCimSeq1();
	virtual ~CCimSeq1();

	void SetOwnerPointer(CWnd* pWnd);
public:
	// Pointer variables
	CHost1*			    m_pHost1;
	CDicsView*			m_pDicsView;

	CString			m_sMessage;
	CString			m_sErrMessage;
	CString			m_sLog;
	
	int m_nSeqTrsModeChangeNo[MAX_PORT_NO];
	
public:
	void InitParameter();

	BOOL Sequence();

	BOOL Initialize();

	int m_nSeqTraceDataReportNo[MAX_TRACE_MULTI_NO];
	int m_nSeqSampleTime[MAX_TRACE_MULTI_NO];		// 231220 halesu Size NG Fix
	int m_nSeqConnectNo;
	int m_nSeqTraceNo;	// shcho 220525
	// Pointer Set Function
	void SetDevice(XCtlDevice* pDevice) { m_pDevice = pDevice; }
	void SetHost1( CHost1* pHost1 )	{ m_pHost1 = pHost1; }
	void SetDicsView( CDicsView *pView ) { m_pDicsView = pView;	}

	void SetSeqTimer( XTimer* pTimer ) { m_pTimer = pTimer; }
	void SetDicsData( CDicsData* pDicsData ) { m_pDicsData = pDicsData; }
	void SetSetupItems( CSetupItems* pSetupItems ) { m_pSetupItems = pSetupItems; }
	void SetEqpStateSequence(CEqpStateSequence* pEqpStateSeq) { m_pEqpStateSeq = pEqpStateSeq; }

	enum	_TRACE_Data
	{
 		traceGLS_ID,
		traceRCP_ID,
		traceLOT_ID,
		traceSLOT_ID,
		traceRecipe_Start = MAX_IF_NO * 4,
		traceAI_START = traceRecipe_Start+MAX_RECIPE_CIM_DATA_NO,
		traceStatus_START = traceAI_START + MAX_AI_INTR_NO,
		traceGap_START = traceStatus_START + MAX_APD_STATUS_DATA_DI_NO,
		tracePinTime_START = traceGap_START + MAX_APD_STATUS_DATA_GAP_NO,
		traceTackTime_START = tracePinTime_START + MAX_APD_STATUS_DATA_PIMTIME_NO,
	};

	// Sequence
public:
	// Sequence
	void SeqConnect();
	void SeqTraceDataReport( int nIndex );
	void SeqEventIdReport( int nIndex  );
	void SeqSampleTime( int nIndex );
	void SeqTrace();	// shcho 220525
	void SeqCimT3TimeoutCheck();	// shcho 230207
//	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );

public:
	void SetTraceDataValue();
};

#endif // !defined(AFX_CIMSEQ1_H__59889DB7_2FD0_4047_8978_E6B39C956D08__INCLUDED_)
