// CvSeq.h: interface for the CCvSeq class.
// Ver 1.1
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CVSEQ_H__56390082_D129_4028_87C8_B79E022F812D__INCLUDED_)
#define AFX_CVSEQ_H__56390082_D129_4028_87C8_B79E022F812D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MOTHER\DicsCvSeq.h"
#include "X\XMmc.h"	// Added by ClassView

class CCvSeq : public CDicsCvSeq  
{
public:
	void SetSeqNo();
	CCvSeq();
	virtual ~CCvSeq();
	
	void InitParameter();
	void CvStop(int nCvNo, BOOL bError = FALSE);
	void CvStopAll();
	void CurCvRestart(int i);
	void CvRestart(int nCvNo);
	void CvRestartAll();
	void CheckStopCountCond();
	
protected:
	BOOL Sequence();
	BOOL Initialize();
	BOOL CheckUnitCondition( int nSensorType, int nUnitNo );
public:
	BOOL m_bAkManualAlarm;
	int m_nSeqUnitLdNo;
	int m_nSeqUnitUl1No;
	int m_nSeqUnitUl2No;
	int m_nSeqInitNo;
	int m_nSeqAkManualCheckNo;
	int m_nSeqUnitUlTiltNo;
	int m_nSeqCVMotorDeccelNo;
	BOOL m_bUnloadWaitRequest;
	BOOL m_bCvStop[5];
	void SeqInit();
	void SeqUnitUl2();
	void SeqUnitUl1();
	void SeqUnitLd();
	void SeqCv(int nCvNo);
	void SeqCvMotorControl(int nCvNo);
	void SeqCvManualControlInterlock();
	void SeqAkManualInterlockCheck();
	void SeqCvMotorManualControl(int nCvMotorNo);
	void SeqCvMotorSpeedControl();
	BOOL SeqULRobotInterlock(int nSensorNo, BOOL bError);
	BOOL SeqLDRobotInterlock(int nSensorNo, BOOL bError);
	BOOL GetSeqRunCond( int nSensorNo );
	void GetTimeOut(int nSensorNo, int nIsOutSensor, int* nTm1, int* nTm2, int* nTm3 = NULL);
	void TimerControl( int nSensorType, int nSensorNo );
	void ApdSave(UINT nID, int nPortNo, int nSlotNo);
	void SeqCVMotorAccelDeccel();	// SanghoCho 2015.03.31
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );	// SanghoCho 2015.04.24
public:	
	void SeqOutSensor(int nSensorNo);
	void SeqInSensor(int nSensorNo);

	enum rbPOS	{ rbOFF, rbNOOP, rbWAIT, rbZERO, rbPROCESS, rbIDLERUN };	// 170714 halesu
};

#endif // !defined(AFX_CVSEQ_H__56390082_D129_4028_87C8_B79E022F812D__INCLUDED_)
