// EqpStateSequence.cpp: implementation of the CEqpStateSequence class.
//
//////////////////////////////////////////////////////////////////////


#include "stdafx.h"
#include "..\Dics.h"
#include "EqpStateSequence.h"
#include "..\X\XLog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEqpStateSequence::CEqpStateSequence()
{

}

CEqpStateSequence::~CEqpStateSequence()
{

}

BOOL CEqpStateSequence::Initialize()
{
	InitParameter();

	return TRUE;
}

BOOL CEqpStateSequence::Sequence()
{
	Sleep( 50 );

	SeqInit();
	SeqAlarmNState();
	SeqEqpState();
	SeqSetEqpState();
	SeqLdState();
	SeqSetLdState();
	SeqSwToggle();

	return TRUE;
}

void CEqpStateSequence::InitParameter()
{
	m_pEqpAssy = ( (CDicsView *) m_pOwnerWnd )->m_pEqpAssy;

	for( int i=0; i<lampMAX_SW_NO; i++ )
	{
		m_nLampState[i] = lampOFF;
		m_nOldLampState[i] = lampOFF;
	}

	m_nSeqSetEqpStateNo = 0;
	m_nSeqAlarmNStateNo = 0;

	// Clear the m_SeqFlag structure
	m_SeqFlag.bInitReq		= FALSE;
	m_SeqFlag.bInitComp		= FALSE;
	m_SeqFlag.bInitFail		= FALSE;
}

//---------------------------------------------------------------------------
// SeqInit()
//---------------------------------------------------------------------------
void CEqpStateSequence::SeqInit()
{
	if( m_SeqFlag.bInitReq ) 
	{
		// Flag Clear
		m_SeqFlag.bInitReq	= FALSE;

		// Flag Set
		m_SeqFlag.bInitComp = TRUE;

		// Initialize this parameter just once.
		m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateNONE] = 0;
		m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateNONE] = 0;
	}
}

//--------------------------------------------------------------------
// Normal Sequence for Loader port
// ==> Loader Warning κ    ؾ  (040504)
//--------------------------------------------------------------------
void CEqpStateSequence::SeqAlarmNState()
{
	int nSeqNo = m_nSeqAlarmNStateNo;
	static DWORD dwTickStart = 0;
	static int nAlarmId		 = 0;

	switch( nSeqNo )
	{
	case 0:
		if( m_arAlarmListReset.GetSize() )
		{
			nAlarmId = m_arAlarmListReset.GetAt( 0 );
			m_arAlarmListReset.RemoveAt( 0 );

			// Set Alarm Message
			CAlarmItem* pItem = GetItem( nAlarmId );
			if( pItem != NULL )
			{
				m_sMessage.Format( "%04d %c %s", pItem->m_nId, pItem->m_cLevel, pItem->m_sText );
				if( m_arAlarmListSave.GetSize() )//2009.03.11 kimgun
//				Msg( WM_ALARM, ALARM_RESET, (LPARAM) pItem->m_nId, TRUE );	// SendMessage
				Msg( WM_ALARM, ALARM_RESET, (LPARAM)(LPCTSTR) m_sMessage, TRUE );	// SendMessage	// SanghoCho 2015.05.20
				else Msg( WM_ALARM, ALARM_RESET_ALL, (LPARAM) pItem->m_nId, TRUE );	// SendMessage//2009.03.11 kimgun

				// Send Cim Sequence
				m_pDicsData->m_IfCim.nAlarmId		= pItem->m_nId;
				m_pDicsData->m_IfCim.nAlarmCode		= pItem->m_nCode;
				m_pDicsData->m_IfCim.sAlarmText		= pItem->m_sText;
				m_pDicsData->m_IfCim.cAlarmLevel	= pItem->m_cLevel;
				m_pDicsData->m_IfCim.sAlarmTime		= pItem->m_sDateTime;

				m_pDicsData->m_IfCim.bAlarmResetReq = TRUE;
/*
#ifdef USE_WARNING_TOO_MUCH				
				// Check the warning too much : Specific for CMO PPCLN
				if( USE_WARNING_TOO_MUCH && !m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateWARNING] )
				{
					m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateWARNING_TOO_MUCH] = 0;
					dwTickStart = 0;

					// Special Case : Warning Too Much
					Msg( WM_ALARM, ALARM_RESET, (LPARAM) ALM_WARNING_TOO_MUCH, TRUE );	// SendMessage
				}
#endif
*///------------------------------------------------------------------------------------
				nSeqNo = 20;
			}
		}
		// Check the alarm occurrence
		else if( m_arAlarmListSet.GetSize() )
		{
			nAlarmId = m_arAlarmListSet.GetAt( 0 );
			m_arAlarmListSet.RemoveAt( 0 );

			// Set Alarm Message
			CAlarmItem* pItem = m_pItem = GetItem( nAlarmId );		// ljy_041129
			if( pItem == NULL ) return;

			m_sMessage.Format( "%04d %c %s", pItem->m_nId, pItem->m_cLevel, pItem->m_sText );
			Msg( WM_ALARM, ALARM_SET, (LPARAM)(LPCTSTR) m_sMessage, TRUE );	// SendMessage

			// Flag Set
			m_pDicsData->m_IfCim.nAlarmId		= pItem->m_nId;
			m_pDicsData->m_IfCim.nAlarmCode		= pItem->m_nCode;
			m_pDicsData->m_IfCim.sAlarmText		= pItem->m_sText;
			m_pDicsData->m_IfCim.cAlarmLevel	= pItem->m_cLevel;
			m_pDicsData->m_IfCim.sAlarmTime		= pItem->m_sDateTime;
			m_pDicsData->m_IfCim.bAlarmSetReq	= TRUE;
			nSeqNo = 10;
		}
/*
		//------------------------------------------------------------------------------------
		// Check the warning too much : Specific for CMO PPCLN
#ifdef USE_WARNING_TOO_MUCH
		else if( m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateWARNING] &&
				dwTickStart &&
				GetTickCount() - dwTickStart > (DWORD) atoi( m_pSetupItems->m_sValueInterfacePara[CSetupItems::timeoutWARNING_TOO_MUCH] ) * 1000 ) 
		{
			m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateWARNING_TOO_MUCH] = 1;
			dwTickStart = 0;

			// Special Case : Warning Too Much
			m_sMessage.Format( "%03d %c %s", ALM_WARNING_TOO_MUCH, 'L', "Warning Too Much" );
			Msg( WM_ALARM, ALARM_SET, (LPARAM)(LPCTSTR) m_sMessage, TRUE );	// SendMessage
		}
#endif
*///------------------------------------------------------------------------------------
		// Check the alarm clear
		break;
	case 10:
/*
#ifndef _MY_DEBUG
		if( m_pDicsData->m_IfCim.bAlarmSetComp )
#else
		if( 1 )
#endif
*/
		{
			m_pDicsData->m_IfCim.bAlarmSetComp = FALSE;

			//----------------------------------------------------------------------
			// Set equipment state
			CAlarmItem* pItem = GetItem( nAlarmId );
			if( pItem == NULL ) return;
			if( pItem->m_cLevel == 'L' )	// For a Light Alarm, Set it.
			{
				if( IsEqpAlarm( pItem->m_nId ) )
					m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateWARNING] = 1;
				else m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateWARNING] = 1;

				SetLampState( lampTOWER_LAMP_R, lampTOGGLE );
				SetLampState( lampMELODY2, lampON );	// Don't care buzzer for warning
//				mobMELODY_SIGNAL2(ON);//JUN_MELSEC

				// Set the tick count 
				dwTickStart = GetTickCount();
			}
			else 
			{
				SetLampState( lampMELODY1, lampON );	// Don't care buzzer for warning

				if( IsEqpAlarm( pItem->m_nId ) )
				{
					m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateDOWN] = 1;
					m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateALARM] = 1;
				}
				else
				{
					m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateDOWN] = 1;
					m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateALARM] = 1;
				}

				if( !m_pDicsData->m_GenInfo.nGlassNo )
					m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateIDLE] = 0;
				else if( m_pDicsData->m_GenInfo.nGlassNo )
					m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateRUN] = 0;

			}
			//----------------------------------------------------------------------
			nSeqNo = 0;
		}
		break;
	case 20:
/*
#ifndef _MY_DEBUG
		if( m_pDicsData->m_IfCim.bAlarmResetComp )
#else
		if( 1 )
#endif
*/
		{
			m_pDicsData->m_IfCim.bAlarmResetComp = FALSE;

			//----------------------------------------------------------------------
			// Set equipment state : Check the Warning or Error
			CAlarmItem* pItem = GetItem( nAlarmId );
			if( IsEqpAlarm( pItem->m_nId ) )
			{
				m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateDOWN]		= 0;
				m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateALARM]		= 0;
				m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateWARNING]	= 0;
			}
			else
			{
				m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateDOWN]		= 0;
				m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateALARM]		= 0;
				m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateWARNING]	= 0;
			}
			
			if( pItem->m_cLevel != 'L' )
			{
				if( !m_pDicsData->m_GenInfo.nGlassNo )
					m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateIDLE] = 1;
				else if( m_pDicsData->m_GenInfo.nGlassNo )
					m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateRUN] = 1;
			}

			int nSize = m_arAlarmListSave.GetSize();
			if( nSize !=0 ) 
			{
				SetLampState( lampALARM_RESET, lampTOGGLE );
			}
			else
			{
				SetLampState( lampBUZZER_OFF, lampOFF );	
				SetLampState( lampALARM_RESET, lampOFF );
			}

			for( int i=0; i<nSize; i++ )
			{
				nAlarmId = m_arAlarmListSave.GetAt( i );
				pItem = GetItem( nAlarmId );
				if( pItem->m_cLevel == 'L' ) 
				{
					if( IsEqpAlarm( pItem->m_nId ) )
						m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateWARNING] = 1;
					else
						m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateWARNING] = 1;
				}
				else 
				{
					if( IsEqpAlarm( pItem->m_nId ) )
					{
						m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateDOWN]	= 1;
						m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateALARM] = 1;
					}
					else
					{
						m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateDOWN]	= 1;
						m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateALARM] = 1;
					}

					if( !m_pDicsData->m_GenInfo.nGlassNo )
						m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateIDLE] = 0;
					else if( m_pDicsData->m_GenInfo.nGlassNo )
						m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateRUN] = 0;
				}
			}
			//------------------------------------------------------------------------------------
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqAlarmNStateNo = nSeqNo;
}

//--------------------------------------------------------------------
// Normal Sequence for Loader port
//--------------------------------------------------------------------
void CEqpStateSequence::SeqEqpState()
{
	static int nOldEqpState = -1;
	CJobsTabMainView* pView = ( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView;

	if( m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateMANUAL] ) // 2nd priority
	{
		if( nOldEqpState != CDicsData::stateMANUAL ) 
		{
			nOldEqpState = CDicsData::stateMANUAL;
			pView->SendMessage( WM_EQP_STATUS_CHANGED, CDicsData::stateMANUAL, 0L );
			//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView->SetEqpState( CDicsData::stateMANUAL );
			
			// Set Tower Lamp
			SetLampState( lampTOWER_LAMP_R, lampOFF );
			SetLampState( lampTOWER_LAMP_Y, lampON );
			SetLampState( lampTOWER_LAMP_G, lampOFF );
		}
	}
	else if( m_pDicsData->m_EqpInfo.nEqpState[CDicsData::statePAUSE] ) // 3rd priority
	{
		if( nOldEqpState != CDicsData::statePAUSE ) 
		{
			nOldEqpState = CDicsData::statePAUSE;
			pView->SendMessage( WM_EQP_STATUS_CHANGED, CDicsData::statePAUSE, 0L );
			//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView->SetEqpState( CDicsData::statePAUSE );

			// Set Tower Lamp
			SetLampState( lampTOWER_LAMP_R, lampTOGGLE );
			SetLampState( lampTOWER_LAMP_Y, lampOFF );
			SetLampState( lampTOWER_LAMP_G, lampON );
		}
	}
	else if( m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateCLEAN] ) // 4th priority
	{
		if( nOldEqpState != CDicsData::stateCLEAN ) 
		{
			nOldEqpState = CDicsData::stateCLEAN;
			pView->SendMessage( WM_EQP_STATUS_CHANGED, CDicsData::stateCLEAN, 0L );
			//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView->SetEqpState( CDicsData::stateSTOP );

			// Set Tower Lamp : Don't care
			SetLampState( lampTOWER_LAMP_R, lampTOGGLE );
			SetLampState( lampTOWER_LAMP_Y, lampOFF );
			SetLampState( lampTOWER_LAMP_G, lampON );
		}
	}
	else if( m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateDOWN] ) // 5th priority
	{
		if( nOldEqpState != CDicsData::stateDOWN ) 
		{
			nOldEqpState = CDicsData::stateDOWN;
			pView->SendMessage( WM_EQP_STATUS_CHANGED, CDicsData::stateDOWN, 0L );
			//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView->SetEqpState( CDicsData::stateDOWN );

			// Set Tower Lamp
			SetLampState( lampTOWER_LAMP_R, lampON );
			SetLampState( lampTOWER_LAMP_Y, lampOFF );
			SetLampState( lampTOWER_LAMP_G, lampOFF );

			// Set the main equipment state to DOWN
			m_pDicsData->m_EqpInfo.cEqpState = CDicsData::modeDOWN;
			// AU L10 HDC CASE
//			m_pDicsData->m_IfMainMc.bEqpStateReportReq = TRUE;
//			m_pDicsData->m_IfMainMc.cEqpState = CDicsData::modeDOWN;	
			//
		}
	}
/*	else if( m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateSTOP] ) // 4th priority
	{
		if( nOldEqpState != CDicsData::stateSTOP ) 
		{
			nOldEqpState = CDicsData::stateSTOP;
			pView->SendMessage( WM_EQP_STATUS_CHANGED, CDicsData::stateSTOP, 0L );
			//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView->SetEqpState( CDicsData::stateSTOP );

			// Set Tower Lamp : Don't care
			//SetLampState( lampTOWER_LAMP_R, lampTOGGLE );
			//SetLampState( lampTOWER_LAMP_Y, lampOFF );
			//SetLampState( lampTOWER_LAMP_G, lampON );
		}
	}*/
/*	else if( m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateDOWN] ) // 5th priority
	{
		if( nOldEqpState != CDicsData::stateDOWN ) 
		{
			nOldEqpState = CDicsData::stateDOWN;
			pView->SendMessage( WM_EQP_STATUS_CHANGED, CDicsData::stateDOWN, 0L );
			//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView->SetEqpState( CDicsData::stateDOWN );

			// Set Tower Lamp
			SetLampState( lampTOWER_LAMP_R, lampON );
			SetLampState( lampTOWER_LAMP_Y, lampOFF );
			SetLampState( lampTOWER_LAMP_G, lampOFF );

			// Set the main equipment state to DOWN
			m_pDicsData->m_EqpInfo.cEqpState = CDicsData::modeDOWN;
			// AU L10 HDC CASE
//			m_pDicsData->m_IfMainMc.bEqpStateReportReq = TRUE;
//			m_pDicsData->m_IfMainMc.cEqpState = CDicsData::modeDOWN;	
			//
		}
	}*/
	else if( m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateIDLE] )	// 6th priority
	{
		if( nOldEqpState != CDicsData::stateIDLE ) 
		{
			nOldEqpState = CDicsData::stateIDLE;
			pView->SendMessage( WM_EQP_STATUS_CHANGED, CDicsData::stateIDLE, 0L );
			//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView->SetEqpState( CDicsData::stateIDLE );
			// Set Tower Lamp
			SetLampState( lampTOWER_LAMP_R, lampOFF );
			SetLampState( lampTOWER_LAMP_Y, lampOFF );
			SetLampState( lampTOWER_LAMP_G, lampTOGGLE );


			// Set the main equipment state to IDLE
			m_pDicsData->m_EqpInfo.cEqpState = CDicsData::modeIDLE;
			// AU L10 HDC CASE
//			m_pDicsData->m_IfMainMc.bEqpStateReportReq = TRUE;
//			m_pDicsData->m_IfMainMc.cEqpState = CDicsData::modeIDLE;
			//
		}
	}
	else if( m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateRUN] )	// 7th priority
	{
		if( nOldEqpState != CDicsData::stateRUN ) 
		{
			nOldEqpState = CDicsData::stateRUN;
			pView->SendMessage( WM_EQP_STATUS_CHANGED, CDicsData::stateRUN, 0L );
			//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView->SetEqpState( CDicsData::stateRUN );

			// Set Tower Lamp
			SetLampState( lampTOWER_LAMP_R, lampOFF );
			SetLampState( lampTOWER_LAMP_Y, lampOFF );
			SetLampState( lampTOWER_LAMP_G, lampON );

			// Set the main equipment state to RUN
			m_pDicsData->m_EqpInfo.cEqpState = CDicsData::modeRUN;
			// AU L10 HDC CASE
//			m_pDicsData->m_IfMainMc.bEqpStateReportReq = TRUE;
//			m_pDicsData->m_IfMainMc.cEqpState = CDicsData::modeRUN;	
			//
		}
	}
	else if( m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateSTOP] ) // 4th priority
	{
		if( nOldEqpState != CDicsData::stateSTOP ) 
		{
			nOldEqpState = CDicsData::stateSTOP;
			pView->SendMessage( WM_EQP_STATUS_CHANGED, CDicsData::stateSTOP, 0L );
			//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView->SetEqpState( CDicsData::stateSTOP );

			// Set Tower Lamp : Don't care
			//SetLampState( lampTOWER_LAMP_R, lampTOGGLE );
			//SetLampState( lampTOWER_LAMP_Y, lampOFF );
			//SetLampState( lampTOWER_LAMP_G, lampON );
		}
	}
	else if( m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateNONE] ) // 1st priority
	{
		if( nOldEqpState != CDicsData::stateNONE ) 
		{
			nOldEqpState = CDicsData::stateNONE;
			pView->SendMessage( WM_EQP_STATUS_CHANGED, CDicsData::stateNONE, 0L );
			//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView->SetEqpState( CDicsData::stateNONE );

			// Set Tower Lamp
			SetLampState( lampTOWER_LAMP_R, lampOFF );
			SetLampState( lampTOWER_LAMP_Y, lampON );
			SetLampState( lampTOWER_LAMP_G, lampOFF );
		}

		// Initialize this parameter just once.
		//m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateNONE] = 0;
		//////////////////////////////////////////////////////////////////
	}
}

//--------------------------------------------------------------------
// Normal Sequence for Loader port
//--------------------------------------------------------------------
void CEqpStateSequence::SeqLdState()
{
	static int nOldLdState = -1;
	static int nOldPortState[MAX_PORT_NO] = { -1, };
	CJobsTabMainView* pView = ( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView;
	if( m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateNONE] ) // 1st priority
	{
		if( nOldLdState != CDicsData::stateNONE ) 
		{
			nOldLdState = CDicsData::stateNONE;
			pView->SendMessage( WM_LD_STATUS_CHANGED, CDicsData::stateNONE, 0L );
			//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView->SetEqpState( CDicsData::stateNONE );

			// Set Tower Lamp
			//SetLampState( lampTOWER_LAMP_R, lampOFF );
			//SetLampState( lampTOWER_LAMP_Y, lampON );
			//SetLampState( lampTOWER_LAMP_G, lampOFF );
		}

		// Initialize this parameter at here.
		m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateNONE] = 0;
	}
	else if( m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateMANUAL] ) // 2nd priority
	{
		if( nOldLdState != CDicsData::stateMANUAL ) 
		{
			nOldLdState = CDicsData::stateMANUAL;
			pView->SendMessage( WM_LD_STATUS_CHANGED, CDicsData::stateMANUAL, 0L );
			//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView->SetEqpState( CDicsData::stateMANUAL );

			// Set Tower Lamp
			//SetLampState( lampTOWER_LAMP_R, lampON );
			//SetLampState( lampTOWER_LAMP_Y, lampON );
			//SetLampState( lampTOWER_LAMP_G, lampOFF );

			// Initialize the Port State
			for( int i=0; i<MAX_PORT_NO; i++ ) nOldPortState[i] = 0;
		}
	}
	else if( m_pDicsData->m_EqpInfo.nLdState[CDicsData::statePAUSE] ) // 3rd priority
	{
		if( nOldLdState != CDicsData::statePAUSE ) 
		{
			nOldLdState = CDicsData::statePAUSE;
			pView->SendMessage( WM_LD_STATUS_CHANGED, CDicsData::statePAUSE, 0L );
			//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView->SetEqpState( CDicsData::statePAUSE );

			// Set Tower Lamp
			//SetLampState( lampTOWER_LAMP_R, lampTOGGLE );
			//SetLampState( lampTOWER_LAMP_Y, lampOFF );
			//SetLampState( lampTOWER_LAMP_G, lampON );

			// Initialize the Port State
			for( int i=0; i<MAX_PORT_NO; i++ ) nOldPortState[i] = 0;
		}
	}
	else if( m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateDOWN] ) // 5th priority
	{
		if( nOldLdState != CDicsData::stateDOWN ) 
		{
			nOldLdState = CDicsData::stateDOWN;
			pView->SendMessage( WM_LD_STATUS_CHANGED, CDicsData::stateDOWN, 0L );
			//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView->SetEqpState( CDicsData::stateDOWN );

			// Set Tower Lamp
			SetLampState( lampTOWER_LAMP_R, lampON );
			//SetLampState( lampTOWER_LAMP_Y, lampOFF );
			//SetLampState( lampTOWER_LAMP_G, lampOFF );
			// Set the main equipment state to DOWN
			m_pDicsData->m_EqpInfo.cLdState = CDicsData::modeDOWN;

			// Initialize the Port State
			for( int i=0; i<MAX_PORT_NO; i++ ) nOldPortState[i] = 0;
		}
	}
	else if( m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateIDLE] )	// 6th priority
	{
		if( nOldLdState != CDicsData::stateIDLE ) 
		{
			nOldLdState = CDicsData::stateIDLE;

			// Set Tower Lamp
//			SetIfLampState( lampTOWER_LAMP_R, lampOFF );
//			SetIfLampState( lampTOWER_LAMP_Y, lampON );
//			SetIfLampState( lampTOWER_LAMP_G, lampOFF );

			// Set the main equipment state to IDLE
			m_pDicsData->m_EqpInfo.cLdState = CDicsData::modeIDLE;
//			m_pDicsData->m_EqpInfo.cUnitStatus[0] = CDicsData::modeIDLE;
		}
	}
	else if( m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateRUN] )	// 7th priority
	{
		if( nOldLdState != CDicsData::stateRUN ) 
		{
			nOldLdState = CDicsData::stateRUN;

			// Set Tower Lamp
//			SetIfLampState( lampTOWER_LAMP_R, lampOFF );
//			SetIfLampState( lampTOWER_LAMP_Y, lampOFF );
//			SetIfLampState( lampTOWER_LAMP_G, lampON );

			// Set the main equipment state to RUN
			m_pDicsData->m_EqpInfo.cLdState = CDicsData::modeRUN;
//			m_pDicsData->m_EqpInfo.cUnitStatus[0] = CDicsData::modeRUN;
		}
	}
}

//--------------------------------------------------------------------
// Normal Sequence for Loader port
//--------------------------------------------------------------------
void CEqpStateSequence::SeqSetLdState()
{
	static int	nOldPortState[MAX_PORT_NO] = { -1, };
	BOOL		bLdRun = FALSE;

	if( m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateDOWN] ) 
	{
		for( int i=0; i<MAX_PORT_NO; i++ ) nOldPortState[i] = 0;
		return;
	}

	// Check the loader state for each port
	CJobsTabMainView* pView = ( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView;
	for( int i=0; i<MAX_PORT_NO; i++ )
	{
		if( m_pDicsData->m_PortInfo[i].cLdState == CDicsData::modeIDLE )	// 6th priority
		{
			if( nOldPortState[i] != CDicsData::modeIDLE ) 
			{
				nOldPortState[i] = CDicsData::modeIDLE;

				//-------------------------------------------------------------------------------
				// lParam : 0 ==> All Ports
				// lParam : > 0 ==> given port
				pView->SendMessage( WM_LD_STATUS_CHANGED, CDicsData::stateIDLE, i + 1 );
				//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsTab1View->SetEqpState( CDicsData::stateIDLE );
			}
		}
		else if( m_pDicsData->m_PortInfo[i].cLdState == CDicsData::modeRUN )	// 7th priority
		{
			// Check the LD Run State
			bLdRun = TRUE;

			if( nOldPortState[i] != CDicsData::modeRUN ) 
			{
				nOldPortState[i] = CDicsData::modeRUN;

				pView->SendMessage( WM_LD_STATUS_CHANGED, CDicsData::stateRUN, i + 1 );
				//( (CDicsView *) m_pOwnerWnd )->m_pTabJobsTab1View->SetEqpState( CDicsData::stateRUN );

				// Set Tower Lamp
//				SetIfLampState( lampTOWER_LAMP_R, lampOFF );
//				SetIfLampState( lampTOWER_LAMP_Y, lampOFF );
//				SetIfLampState( lampTOWER_LAMP_G, lampON );
			}
		}
	}

	// Set the Loader State
	if( bLdRun )
	{
		m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateIDLE] = 0;
		m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateRUN] = 1;
	}
	else
	{
		m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateIDLE] = 1;
		m_pDicsData->m_EqpInfo.nLdState[CDicsData::stateRUN] = 0;
	}
}

//---------------------------------------------------------------------------
// - SeqGlassExist()
//---------------------------------------------------------------------------
void CEqpStateSequence::SeqSetEqpState()
{
	if( !m_SeqFlag.bInitComp ) return;

	static DWORD dwStartTick = 0;
	DWORD nIdleWaitTime = 60 * 1000 * atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupIDLE_WAIT_TIME] );

	int nSeqNo = m_nSeqSetEqpStateNo;

	switch( nSeqNo )
	{
	case 0:
		if( m_pDicsData->m_GenInfo.nGlassNo ) 
		{	
			m_pDicsData->m_EqpInfo.nEqpState[CDicsData::statePAUSE] = 1;
			m_pDicsData->m_GenInfo.bPause = TRUE;

			nSeqNo = 20;
		}
		else 
		{
			if( !m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateDOWN] )
			{
				// Idle 
				m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateIDLE] = 1;
				m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateRUN] = 0;
			}

			m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateSTOP] = 1;
			m_pDicsData->m_GenInfo.bCycleStop = TRUE;

			nSeqNo = 20;
		}
		break;

	case 10:
		if( !m_pDicsData->m_GenInfo.nGlassNo )
		{
			m_pDicsData->m_EqpInfo.nEqpState[CDicsData::statePAUSE] = 0;
			m_pDicsData->m_GenInfo.bPause = FALSE;

			dwStartTick = GetTickCount();

			nSeqNo = 20;
		}
		break;

	case 20:
		//if( m_pDicsData->m_GenInfo.nGlassNo )
		if( m_pDicsData->m_GenInfo.nGlassNo || ( mibLOAD_ROBOT_STATUS ))  // 101005 halesu
		{
			if( !m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateDOWN] )
			{
				// Run
				m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateIDLE] = 0;
				m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateRUN] = 1;				
			}
			nSeqNo = 10;
		}
		else if( !m_pDicsData->m_GenInfo.bEqpInitComp )
		{			
			dwStartTick = GetTickCount();
		}
		else if( m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateIDLE] != 1 &&
				 ( GetTickCount()-dwStartTick ) > nIdleWaitTime )
		{
			if( !m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateDOWN] )
			{
				// Idle 
				m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateIDLE] = 1;
				m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateRUN] = 0;
			}			
		}
		else if( m_pDicsData->m_GenInfo.bEqpInitComp )
		{
			if( !m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateDOWN] &&
				!m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateIDLE] )
			{
				m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateRUN] = 1;
			}			
		}
		break;
	}

	m_nSeqSetEqpStateNo = nSeqNo;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Toggle lamp
// bOn = TRUE : nSwNo switch lamp is flashed.
//---------------------------------------------------------------------------
void CEqpStateSequence::SeqSwToggle()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	static int nToggleSeqNo = 0;
	static BOOL bToggle = TRUE;
	static DWORD dwStartTick = 0;

	switch(nToggleSeqNo) 
	{
	case 0 :
		// Whenever it is pushed, turn off the buzzer.
		if( m_pEqpAssy->m_SwitchBuzzerOff.Get() ) 
		{ 
			SetLampState( lampBUZZER_OFF, lampOFF ); 
			SetLampState( lampMELODY2, lampOFF ); 
			SetLampState( lampMELODY1, lampOFF ); 
		}

		// set start time
		dwStartTick = GetTickCount();
		nToggleSeqNo = 10;
		break;

	case 10:
		if( GetTickCount() - dwStartTick > 500 )	// 0.5 sec ̸̻ 
		{
			// 150914 halesu m_bBtnAlarmReset must be auto reset
			CDicsApp* pApp = (CDicsApp*) AfxGetApp();
			((CDicsView*) pApp->m_pMainView)->m_pEqpStateSeq->m_bBtnAlarmReset = FALSE;
				
			for(int i=0; i<lampMAX_SW_NO; i++) 
			{
			//	if( m_nLampState[i] == lampOFF || m_nLampState[i] == lampON )//2008.09.11 kimgun Toggle S/W
				{
					if( m_nLampState[i] != m_nOldLampState[i] )
					{
						m_nOldLampState[i] = m_nLampState[i];
						
						if( i == lampTOWER_LAMP_R )		{ m_pEqpAssy->m_TowerLamp.Set(lampTOWER_LAMP_R, m_nLampState[i] ); 	}
						if( i == lampTOWER_LAMP_Y )		{ m_pEqpAssy->m_TowerLamp.Set(lampTOWER_LAMP_Y, m_nLampState[i] );	}
						if( i == lampTOWER_LAMP_G )		{ m_pEqpAssy->m_TowerLamp.Set(lampTOWER_LAMP_G, m_nLampState[i] ); 	}
						if( i == lampTOWER_LAMP_B )		{ m_pEqpAssy->m_TowerLamp.Set(lampTOWER_LAMP_B, m_nLampState[i] ); 	}
						if( i == lampMELODY1 )			{ m_pEqpAssy->m_Melody.Set( 0, m_nLampState[i] );		}
						if( i == lampMELODY2 )			{ m_pEqpAssy->m_Melody.Set( 1, m_nLampState[i] );		}
						if( i == lampMELODY3 )			{ m_pEqpAssy->m_Melody.Set( 2, m_nLampState[i] );		}
						if( i == lampMELODY4 )			{ m_pEqpAssy->m_Melody.Set( 3, m_nLampState[i] );		}
						if( i == lampBUZZER_OFF )		{ m_pEqpAssy->m_SwitchBuzzerOff.Set( m_nLampState[i] );		}
						if( i == lampALARM_RESET )		{ m_pEqpAssy->m_SwitchAlarmReset.Set( m_nLampState[i] );	}
					}
					//		continue;//2008.09.11 kimgun Toggle S/W
				}
				if( m_nLampState[i] == lampTOGGLE )//2008.09.11 kimgun Toggle S/W
				{
					if( i == lampTOWER_LAMP_R )	{ m_pEqpAssy->m_TowerLamp.Set(lampTOWER_LAMP_R, bToggle);	}
					if( i == lampTOWER_LAMP_Y )	{ m_pEqpAssy->m_TowerLamp.Set(lampTOWER_LAMP_Y, bToggle );	}
					if( i == lampTOWER_LAMP_G )	{ m_pEqpAssy->m_TowerLamp.Set(lampTOWER_LAMP_G, bToggle );	}
					if( i == lampTOWER_LAMP_B )	{ m_pEqpAssy->m_TowerLamp.Set(lampTOWER_LAMP_B, bToggle );	}
					if( i == lampMELODY1 )		{ m_pEqpAssy->m_Melody.Set( 0, bToggle );	}
					if( i == lampMELODY2 )		{ m_pEqpAssy->m_Melody.Set( 1, bToggle );	}
					if( i == lampMELODY3 )		{ m_pEqpAssy->m_Melody.Set( 2, bToggle );	}
					if( i == lampMELODY4 )		{ m_pEqpAssy->m_Melody.Set( 3, bToggle );	} 
					if( i == lampBUZZER_OFF )	{ m_pEqpAssy->m_SwitchBuzzerOff.Set(0, bToggle);		} 
					if( i == lampALARM_RESET )	{ m_pEqpAssy->m_SwitchAlarmReset.Set(0, bToggle);		} 
				}
			}
			bToggle = !bToggle;
			nToggleSeqNo = 0;
		}
		break;
	}
}


//---------------------------------------------------------------------------
// Set the Lo
//---------------------------------------------------------------------------
void CEqpStateSequence::SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage )
{
	// Log
	CString sLog("");
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "\t";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "\t";
	else sSlotNo.Format( "%d", nSlotNo );

	sLog.Format( "ALARM\t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( sLog );
	if( m_pDicsData->m_GenInfo.bEnableEqpLog )//2008.12.17 KIMGUN
	{
		sLog.Format( "%s : %s", sSeqName, sMessage );
		Msg( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) sLog );
	}
}

BOOL CEqpStateSequence::IsEqpAlarm(int nAlarmId)
{
//	if(  nAlarmId > START_LOADER_ALARM_NO ) return FALSE;
	return TRUE;
}

void CEqpStateSequence::SetLampState(int i, int state)
{
	m_nLampState[i] = state;
}

BOOL CEqpStateSequence::IsPushedAlarmReset()
{
	BOOL bRv = FALSE;

	// Set to toggle state before pushed this button
	SetLampState( lampALARM_RESET, lampTOGGLE );

#ifndef _MY_DEBUG
	if( m_pEqpAssy->m_SwitchBuzzerOff.Get() )
#else
	if( m_bBuzzerOff )
#endif
	{
#ifdef _MY_DEBUG
		m_bBuzzerOff = FALSE;
#endif
		// Buzzer Off switch & Melody Off
		SetLampState( lampBUZZER_OFF, lampOFF );
		SetLampState( lampMELODY1, lampOFF );
	}

#ifndef _MY_DEBUG
	if( m_pEqpAssy->m_SwitchAlarmReset.Get() || m_bBtnAlarmReset )
#else
	if( m_bAlarmReset || m_bBtnAlarmReset )
#endif
	{
#ifdef _MY_DEBUG
		if( m_bAlarmReset ) m_bAlarmReset = FALSE;
#endif
		if ( m_bBtnAlarmReset ) m_bBtnAlarmReset = FALSE;

// move to ResetAlarm()
//		// Buzzer Off switch and Alarm Reset Lamp Off
		SetLampState( lampBUZZER_OFF, lampOFF );
		SetLampState( lampALARM_RESET, lampOFF );
		SetLampState( lampMELODY2, lampOFF );

		bRv = TRUE;
	}
	return bRv;
}
