// EqpStateSequence.h: interface for the CEqpStateSequence class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EQPSTATESEQUENCE_H__5EC16DEB_99DD_4CF4_9CE7_621A2FCD3403__INCLUDED_)
#define AFX_EQPSTATESEQUENCE_H__5EC16DEB_99DD_4CF4_9CE7_621A2FCD3403__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// If it has "Warning Too Much" alarm, set this value to TURE
//#define USE_WARNING_TOO_MUCH

//////////////////////////////////////////////////////////////////////
// Header File  Sequence->Data->X File ...
//   BOOL -> int -> float -> double -> WORD -> DWORD -> Char -> CString -> enum
// ٸ      ִ.. 
//////////////////////////////////////////////////////////////////////

#include "..\Alarm.h"
#include "..\X\xsequence.h"
#include "..\X\XCtlMelsec.h"
#include "..\DicsData.h"
#include "..\View\SetupItems.h"
#include "..\FactoryLib\EqpAssy.h"

class CEqpStateSequence : public XSequence, public CAlarm
{
public:
	CDicsData*		m_pDicsData;
	CSetupItems*	m_pSetupItems;
	CAlarmItem*		m_pItem;			// ljy_041129

	XCtlMelsec*		m_pMelsec;
	CEqpAssy*		m_pEqpAssy;

	int			m_nSeqAlarmNStateNo;
	int			m_nSeqSetEqpStateNo;

public:
	CEqpStateSequence();
	virtual ~CEqpStateSequence();

	void InitParameter();
	BOOL Sequence();
	BOOL Initialize();

	void SeqInit();
	void SeqSetEqpState();
	void SeqEqpState();
	void SeqLdState();
	void SeqSetLdState();
	void SeqAlarmNState();
	void SeqSwToggle();
	void SetLampState(int i, int state);
	BOOL IsPushedAlarmReset();

	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );
	void SetData( CDicsData* pData ) { m_pDicsData = pData; }
	void SetSetupItems( CSetupItems* pSetupItems ) { m_pSetupItems = pSetupItems; }
	void SetMelsec( XCtlMelsec * pMelsec ){ m_pMelsec = pMelsec; }

#ifdef _CIM_SKIP
	CFileMap*			m_pFileMap;
	void SetFileMap(CFileMap* pFileMap)	{ m_pFileMap = pFileMap; }
#endif

public:
	BOOL IsEqpAlarm( int nAlarmId );
	CString m_sMessage;

	// Sequence flag
	struct tagSeqFlag
	{
		BOOL bInitReq;					// if initialized, it's TRUE 
		BOOL bInitComp;					// if initialized, it's TRUE 
		BOOL bInitFail;
	} m_SeqFlag;
};

#endif // !defined(AFX_EQPSTATESEQUENCE_H__5EC16DEB_99DD_4CF4_9CE7_621A2FCD3403__INCLUDED_)
