// GaugeInterlockSeq.cpp: implementation of the CGaugeInterlockSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "GaugeInterlockSeq.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGaugeInterlockSeq::CGaugeInterlockSeq()
{

}

CGaugeInterlockSeq::~CGaugeInterlockSeq()
{

}

BOOL CGaugeInterlockSeq::GetCheckCond( int nIntrNo )
{
	BOOL bCheckCond = TRUE;
	bCheckCond &= m_pDicsData->m_GenInfo.bAuto;
	bCheckCond &= !m_pDicsData->m_GenInfo.bEmo;
	bCheckCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bCheckCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bCheckCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
	bCheckCond &= !m_pDicsData->m_GenInfo.bPause;
//	bCheckCond &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupJOB_MODE];
	bCheckCond &= m_pDicsData->m_JobCond.bJobProcessUse;
	bCheckCond &= m_pSetupItems->m_nValueGaugeLimit_Option[nIntrNo];

	switch( nIntrNo ) 
	{
	case CSetupItems::gaugeSWR1_UNIT_CDA_IN_INCV_ION:
	case CSetupItems::gaugeSWR1_UNIT_CDA_IN_SWR1_UP_AC:
	case CSetupItems::gaugeSWR1_UNIT_CDA_IN_SWR1_LO_AC:
	case CSetupItems::gaugeSWR1_UNIT_CDA_IN_ION_AND_AC_IN_FT:

	case CSetupItems::gaugeSWR1_UNIT_EXH_DM:
	case CSetupItems::gaugeSWR2_UNIT_EXH_DM:
	case CSetupItems::gaugeSWR3_UNIT_EXH_DM:
	case CSetupItems::gaugeSWR4_UNIT_EXH_DM:
	case CSetupItems::gaugeAK_UNIT_EXH_DM_L:
	case CSetupItems::gaugeAK_UNIT_EXH_DM_U:

	case CSetupItems::gaugeAK_UNIT_DRIVING_AIR_PG:
	case CSetupItems::gaugeAK_UNIT_CDA_IN_ION_AND_AC_IN_FT_PG:
	case CSetupItems::gaugeAK_UNIT_CDA_IN_UP_SWR4_AC_PG:
	case CSetupItems::gaugeAK_UNIT_CDA_IN_LO_SWR4_AC_PG:
	case CSetupItems::gaugeAK_UNIT_CDA_IN_OUT_ION_PG:
	case CSetupItems::GaugeOUTCV_UNIT_ESD_SURIFACE_POTENTIAL:
#ifdef _MOTOR_LOAD_FACTOR
	case CSetupItems::gaugeS2RB_UP_SV1_LF:
	case CSetupItems::gaugeS2RB_LO_SV1_LF:
	case CSetupItems::gaugeS2RB_UP_SV2_LF:
	case CSetupItems::gaugeS2RB_LO_SV2_LF:
	case CSetupItems::gaugeS3RB_UP_SV1_LF:
	case CSetupItems::gaugeS3RB_LO_SV1_LF:
	case CSetupItems::gaugeS3RB_UP_SV2_LF:
	case CSetupItems::gaugeS3RB_LO_SV2_LF:
	case CSetupItems::gaugeS2RB_UP_M1_LF:
	case CSetupItems::gaugeS2RB_LO_M1_LF:
	case CSetupItems::gaugeS2RB_UP_M2_LF:
	case CSetupItems::gaugeS2RB_LO_M2_LF:
	case CSetupItems::gaugeS3RB_UP_M1_LF:
	case CSetupItems::gaugeS3RB_LO_M1_LF:
	case CSetupItems::gaugeS3RB_UP_M2_LF:
	case CSetupItems::gaugeS3RB_LO_M2_LF:
	case CSetupItems::gaugeINCV_M_LF:
	case CSetupItems::gaugeS1CV_M_LF:
	case CSetupItems::gaugeS2CV_M1_LF:
	case CSetupItems::gaugeS2CV_M2_LF:
	case CSetupItems::gaugeS3CV_M1_LF:
	case CSetupItems::gaugeS3CV_M2_LF:
	case CSetupItems::gaugeS4CV_M_LF:
	case CSetupItems::gaugeAKCV_M1_LF:
	case CSetupItems::gaugeAKCV_M2_LF:
	case CSetupItems::gaugeBUFCV_M_LF:
	case CSetupItems::gaugeOUTCV_M_LF:
#endif

		break;

	case CSetupItems::gaugeSWR1_UNIT_CDA_IN_SWR1_UP_MJ:
	case CSetupItems::gaugeSWR1_UNIT_CDA_IN_SWR1_LO_MJ:
	case CSetupItems::gaugeSWR1_UNIT_CDA_IN_SWR1_MJ_IN_FT:
	case CSetupItems::gaugeSWR1_UNIT_CDA_IN_SWR1_UP_MJ_FL:
	case CSetupItems::gaugeSWR1_UNIT_CDA_IN_SWR1_LO_MJ_FL:
		bCheckCond &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupSWR1_SBJ_USE];
		bCheckCond &= m_pEqpAssy->m_AutoValveSbjCda.GetState( 0 );
		break;

	case CSetupItems::gaugeSWR1_UNIT_DI_SPL_UP_MJ_FL:
	case CSetupItems::gaugeSWR1_UNIT_DI_SPL_LO_MJ_FL:
		bCheckCond &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupSWR1_SBJ_USE];
		bCheckCond &= m_pEqpAssy->m_AutoValveSbjDi.GetState( 0 );		
		break;

	case CSetupItems::gaugeSWR1_UNIT_DI_SPL_AK_FL:
	case CSetupItems::gaugeSWR1_UNIT_DI_SPL_IN_FT_FL:
	case CSetupItems::gaugeSWR1_UNIT_DI_SPL_LO_FL:
	case CSetupItems::gaugeSWR1_UNIT_DI_SPL_UP_FL:
	case CSetupItems::gaugeSWR1_UNIT_DI_SPL_WR:
	case CSetupItems::gaugeSWR1_UNIT_DI_SPL_IN_FT:
		bCheckCond &= m_pEqpAssy->m_AutoValveSbjDi.GetState( 0 );		
		break;

	case CSetupItems::gaugeSWR2_UNIT_DI_SPL_LO_FL:
	case CSetupItems::gaugeSWR2_UNIT_DI_SPL_UP_FL:
		bCheckCond &= m_pEqpAssy->m_DiTank[0].GetPumpOn( 0 ) | m_pEqpAssy->m_DiTank[0].GetPumpOnState( 0 ) | m_pEqpAssy->m_AutoValveDirect.GetState( 0 );
		break;


	case CSetupItems::gaugeSWR2_UNIT_DI_IN_FT_PG:
	case CSetupItems::gaugeSWR2_UNIT_DI_SPL_FL:
	case CSetupItems::gaugeSWR2_UNIT_DI_SPL_WR:
		bCheckCond &= m_pEqpAssy->m_AutoValveDirect.GetState( 0 );
		break;

	case CSetupItems::gaugeSWR3_UNIT_DI_SPL_LO_SWR3_FL:
	case CSetupItems::gaugeSWR3_UNIT_DI_SPL_UP_SWR3_FL:
		bCheckCond &= m_pEqpAssy->m_DiTank[1].GetPumpOn( 0 ) | m_pEqpAssy->m_DiTank[1].GetPumpOnState( 0 ) | m_pEqpAssy->m_AutoValveDirect.GetState( 1 );
		break;

	case CSetupItems::gaugeSWR3_UNIT_DI_SPL_WR:
	case CSetupItems::gaugeSWR3_UNIT_DI_SPL_SWR3_IN_FT_FL:
	case CSetupItems::gaugeSWR3_UNIT_DI_IN_SWR3_IN_FT_PG:
		bCheckCond &= m_pEqpAssy->m_AutoValveDirect.GetState( 1 );
		break;

	case CSetupItems::gaugeSWR2_UNIT_DI_RETURN_FL:
	case CSetupItems::gaugeAK_UNIT_DI_SPL_SHOWER4_IN_FT_FL:
		bCheckCond &= m_pEqpAssy->m_DiTank[0].GetPumpOn( 0 ) | m_pEqpAssy->m_DiTank[0].GetPumpOnState( 0 ) | m_pEqpAssy->m_DiTank[1].GetPumpOn( 0 ) | m_pEqpAssy->m_DiTank[1].GetPumpOnState( 0 );
		break;

	case CSetupItems::gaugeSWR4_UNIT_DI_TANK2_CM:
		bCheckCond &= m_pEqpAssy->m_DiTank[1].GetPumpOn( 0 ) | m_pEqpAssy->m_DiTank[1].GetPumpOnState( 0 );
		break;
#ifdef _BUFTANK_USE
	case CSetupItems::gaugeBUFTANK_UNIT_DIW_SPL1_TO_SWR_FL:
		bCheckCond &= m_pEqpAssy->m_DiTank[2].GetPumpOn( 0 ) | m_pEqpAssy->m_DiTank[2].GetPumpOnState( 0 );
		break;
	case CSetupItems::gaugeBUFTANK_UNIT_DIW_SPL2_TO_SWR_FL:
		bCheckCond &= m_pEqpAssy->m_DiTank[2].GetPumpOn( 1 ) | m_pEqpAssy->m_DiTank[2].GetPumpOnState( 1 );
		break;
#endif

	case CSetupItems::gaugeSWR4_UNIT_MJ_FL:
		bCheckCond &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupSWR4_SBJ_USE];
		bCheckCond &= m_pEqpAssy->m_AutoValveFrShower.GetState( 0 );
		break;

	case CSetupItems::gaugeSWR4_UNIT_LO_SWR_FL:
	case CSetupItems::gaugeSWR4_UNIT_UP_SWR_FL:
	case CSetupItems::gaugeSWR4_UNIT_AK_FL:
	case CSetupItems::gaugeSWR4_UNIT_DI_SPL_FL:
	case CSetupItems::gaugeAK_UNIT_DI_SPL_WR:
	case CSetupItems::gaugeAK_UNIT_DI_SPL_SWR4_IN_FT_PG:
		bCheckCond &= m_pEqpAssy->m_AutoValveFrShower.GetState( 0 );
		break;		 

	case CSetupItems::gaugeSWR3_UNIT_CDA_IN_SWR4_MJ_PG:
	case CSetupItems::gaugeSWR3_UNIT_CDA_IN_SPARE_PORT_PG:
	case CSetupItems::gaugeSWR3_UNIT_CDA_IN_SWR4_MJ_IN_FT_PG:
	case CSetupItems::gaugeSWR3_UNIT_CDA_IN_SWR4_MJ_FL:
	case CSetupItems::gaugeSWR3_UNIT_CDA_IN_SPARE_PORT_FL:
		bCheckCond &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupSWR4_SBJ_USE];
		bCheckCond &= m_pEqpAssy->m_AutoValveSbjCda.GetState( 1 );
		break;


	case CSetupItems::gaugeAK_UNIT_CDA_IN_LO_AK_IN_FT_PG:
	case CSetupItems::gaugeAK_UNIT_CDA_IN_LO_AK_PG:
	case CSetupItems::gaugeAK_UNIT_CDA_IN_LO_AK_IN_FT_FL:
		bCheckCond &= m_pEqpAssy->m_AutoValveAkLo.GetState( 0 );
		break;

	case CSetupItems::gaugeAK_UNIT_CDA_IN_UP_AK_IN_FT_PG:
	case CSetupItems::gaugeAK_UNIT_CDA_IN_UP_AK_PG:
	case CSetupItems::gaugeAK_UNIT_CDA_IN_UP_AK_IN_FT_FL:
		bCheckCond &= m_pEqpAssy->m_AutoValveAkUp.GetState( 0 );
		break;
	}	
	return bCheckCond;
}
