// GsEuvSeq.cpp: implementation of the CGsEuvSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GsEuvSeq.h"

#include "..\Dics.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGsEuvSeq::CGsEuvSeq()
{

}

CGsEuvSeq::~CGsEuvSeq()
{

}

void CGsEuvSeq::InitParameter()
{
	CDicsEuvSeq::InitParameter();

	m_pSensorEuvHouseClose = &( (CDicsView *) m_pOwnerWnd)->m_pEqpAssy->m_SensorEuvHouseClose;
}

void CGsEuvSeq::LampOnSelect( int nLampNo, BOOL bOn )
{
	SetLampOnSelect( nLampNo, bOn );
}

void CGsEuvSeq::LampOnSelect()
{
	BOOL bOn = IsEuvUse();
	for( int i=0; i<MAX_LAMP_CONTROL_NO; i++ )
	{
		LampOnSelect( i, bOn & m_pDicsData->m_JobCond.bEuvUse[i] );
	}
}

BOOL CGsEuvSeq::GetLampOnSelected( int nLampNo )
{
	BOOL bSelected;
//	bSelected = m_pGsEuvControl->GetGsUvLampSelect( nLampNo );
	return bSelected;
}


void CGsEuvSeq::LampControl( BOOL bOn )
{
//	doIF_GSUV_LAMP_ON( bOn );
}


void CGsEuvSeq::SeqLampIntensityCheck()
{
	for( int i=0; i<MAX_LAMP_INTENSITY_NO; i++ )
	{
		SeqLampIntensityCheck( i ); 
	}
}

void CGsEuvSeq::SeqLampIntensityCheck( int nPos )
{
	int	nSeqNo = m_nSeqIntensityCheckNo[nPos];
	static int nReturnSeqNo;

	static DWORD dwTickCount = 0;
	static int nAlarmId;

	switch( nSeqNo )
	{	
	case 0:
		if( m_IfEuv.bLampIntensityCheckReq[nPos] && IsRemoteMode() )
		{
			m_IfEuv.bLampIntensityCheckReq[nPos] = FALSE; 
			nSeqNo = 10;
		}
		else if( m_IfEuv.bLampIntensityCheckReq[nPos] )
		{
			m_IfEuv.bLampIntensityCheckReq[nPos] = FALSE; 
			// Log
			m_sMessage.Format( "EUV %d Error. Can't Check : Manual Mode", nPos + 1 );
			SetLog( "INTENSTY", 0, 0, m_sMessage );
	
			nSeqNo = 0;
		}
		break;

	case 10:
#ifndef _MY_DEBUG
		if( diIF_GSUV_DATA_SET_ENABLE )
#else
		if( 1 )
#endif
		{
			dwTickCount = GetTickCount();
			nSeqNo = 20;
		}
		break;

	case 20:
		if( ( dwTickCount - GetTickCount() ) > 1000 )
		{
			LampMonitorSelect( nPos );
	
			// Log
			m_sMessage.Format( "EUV Lamp Intensity Pos %d Check On", nPos + 1 );
			SetLog( "INTENSTY", 0, 0, m_sMessage );

			dwTickCount = GetTickCount();
			nSeqNo = 30;
		}		
		break;		

	case 30:
		if( ( GetTickCount() - dwTickCount ) > 1000 )
		{
			SetGsUvDataSet(CGsEuvGroup::actON);
			dwTickCount = GetTickCount();
			nSeqNo = 40;
		}
		break;

	case 40:
		if( ( GetTickCount() - dwTickCount ) > 1000 )
		{
			SetGsUvDataSet( CGsEuvGroup::actOFF);
	
			TIMER_ON( TM_EUV_SENSOR_MOVE, 150 );

			nSeqNo = 50;
		}
		break;	
		
	case 50:
#ifndef _MY_DEBUG
		if( diIF_GSUV_UV_MONITOR_READY )
#else
		if( 1 )
#endif
		{
			// Log
			m_sMessage.Format( "EUV Sensor Move Complete (POS %d)", nPos + 1 );
			SetLog( "INTENSTY", 0, 0, m_sMessage );

			//m_msgDuv.SetOpMsg( m_sMessage );

			dwTickCount = GetTickCount();
			nSeqNo = 60;
		}		
		else if( TIMER( TM_EUV_SENSOR_MOVE ) )
		{
			// Log
			m_sMessage.Format( "EUV %d Intensity Sensor Move Overtime Warning.", nPos + 1 );
			SetLog( "INTENSTY", 0, 0, m_sMessage );
			
			nAlarmId = ALM_EUV_INTENSITY_CHECK_TIMEOVER1 + nPos;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			nReturnSeqNo = 0;
			nSeqNo = 1000;
		}
		break;

	case 60:
		if( ( dwTickCount - GetTickCount() ) > 500 )
		{
			m_IfEuv.fLampIntensity[nPos] = 0;//aiEUV_UNIT_LAMP_INTENSITY; ӽ 

			// Log
			m_sMessage.Format( "EUV Lamp Intensity Pos %d Value is %.2f", nPos + 1, m_IfEuv.fLampIntensity[nPos] );
			SetLog( "INTENSTY", 0, 0, m_sMessage );
			
			dwTickCount = GetTickCount();			

			nSeqNo = 70;
		}		
		break;

	case 70:
		{
			LampMonitorSelect( -1 );	
	
			dwTickCount = GetTickCount();
			nSeqNo = 80;
		}		
		break;

	case 80:
		if( ( GetTickCount() - dwTickCount ) > 1000 )
		{
			SetGsUvDataSet( CGsEuvGroup::actON);
	
			dwTickCount = GetTickCount();
		
			nSeqNo = 90;
		}
		break;

	case 90:
		if( ( GetTickCount() - dwTickCount ) > 1000 )
		{
			SetGsUvDataSet( CGsEuvGroup::actOFF);
			
			nSeqNo = 0;
		}
		break;

	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Log
			m_sMessage.Format( "EUV Intensity Check Alarm Reset. Intensity Check Restart.", nPos + 1 );
			SetLog( "INTENSTY", 0, 0, m_sMessage );
			
			m_pEqpStateSeq->ResetAlarm( nAlarmId );

//			TIMER_ON( TM_EUV_SENSOR_MOVE, 300 );

			nSeqNo = nReturnSeqNo;
		}
		break;
	}

	m_nSeqIntensityCheckNo[nPos] = nSeqNo;
}

void CGsEuvSeq::UtControl( BOOL bOn )
{
	SetEuvN2AutoValveAct( bOn );
	SetEuvPcwAutoValveAct(bOn);
}

BOOL CGsEuvSeq::GetUtState()
{
	BOOL bOk = TRUE;

	bOk &= GetEuvN2AutoValveState();	
	bOk &= GetEuvPcwAutoValveState();

	return bOk;
}

int	CGsEuvSeq::GetEuvAlarm()
{
	int nRv = 0;
#ifndef _MY_DEBUG
	nRv = m_pGsEuvControl->GetEuvAlarm();
#endif
	return nRv;
}

BOOL CGsEuvSeq::GetHouseCloseState()
{
	BOOL bClose = TRUE;
	
#ifndef _MY_DEBUG
	bClose &= m_pSensorEuvHouseClose->GetState();
	if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUSE_EUV] )//2007.10.05 bkh
	bClose &= !diIF_GSUV_HOUSE_OPEN;
#endif
	
	return bClose;
}

//---------------------------------------------------------------------------
// Get EUV Status
//---------------------------------------------------------------------------
int CGsEuvSeq::GetStatus()
{
	int nStatus = 0;

	if( IsRemoteMode() )			nStatus |= euvREMOTE_MODE;		// Remote Mode
	if( IsMonitorReady() )			nStatus |= euvMONITOR_READY;	//   
	if( IsDataSetEnable() )			nStatus |= euvDATA_SET_ENABLE;	//  

	return nStatus;
}


BOOL CGsEuvSeq::IsGlassExist( )
{
	BOOL bGlassExist = FALSE;
#ifndef _MY_DEBUG
//	bGlassExist |= m_pEqpAssy->m_GlassExistUnit.GetOr( ( ( IF_UNIT_EUV - 1 )*2 + 1 ));
	bGlassExist |= m_pEqpAssy->m_GlassExistUnit.GetOr( ( IF_UNIT_AP*2 )  ); 
	bGlassExist |= m_pEqpAssy->m_GlassExistUnit.GetOr( ( IF_UNIT_AP*2 + 1 ) );
#else
//	bGlassExist |= (( CDicsView* ) m_pOwnerWnd )->m_pDicsData->m_bDebugOutSensor[IF_UNIT_EUV-1];
	bGlassExist |= (( CDicsView* ) m_pOwnerWnd )->m_pDicsData->m_bDebugInSensor[IF_UNIT_AP];
	bGlassExist |= (( CDicsView* ) m_pOwnerWnd )->m_pDicsData->m_bDebugOutSensor[IF_UNIT_AP];
#endif
	return bGlassExist;
}


BOOL CGsEuvSeq::GetOnTimeOver( BOOL bEuvRun )
{
	int nEuvStartTime;
	int nEuvOnTime;
	double dGlassSize;
	double dCvSpeed;

	dGlassSize		= atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupGLASS_SIZE] );
	dCvSpeed		= m_pDicsData->m_JobCond.nCvSpeed / 60.;
	nEuvStartTime	= (int) ( m_pDicsData->m_JobCond.nEuvStartDistance / dCvSpeed  * 10 );
	nEuvOnTime		= (int) ( ( dGlassSize + m_pDicsData->m_JobCond.nEuvOnDistance ) / dCvSpeed * 10 );

	static int nSeqGetOnTimeOverNo = 0;
	int nSeqNo = nSeqGetOnTimeOverNo;


	if( !m_pDicsData->m_JobCond.bEuvDelayTimeUse )
	{
		m_IfEuv.bLampOnTimer	= TRUE;
		nSeqGetOnTimeOverNo		= 0;
		return m_IfEuv.bLampOnTimer;
	}

	if( !m_pDicsData->m_GenInfo.bAuto )
	{
		nSeqNo = 0;
	}

	switch( nSeqNo )
	{
	case 0 :
		if( !IsGlassExist() ) 
		{
			m_IfEuv.bLampOnTimer = FALSE;
			nSeqNo = 10;
		}
		else
		{
			m_IfEuv.bLampOnTimer = TRUE;
			nSeqNo = 100;
		}
		break;
	case 10 :
		if( bEuvRun )
		{
			TIMER_ON( TM_EUV_ON, nEuvStartTime );
			nSeqNo = 20;
		}
		break;
	case 20 :
		if( TIMER( TM_EUV_ON ) )
		{ 
			m_IfEuv.bLampOnTimer = TRUE;

			TIMER_ON( TM_EUV_ON, nEuvOnTime );
			nSeqNo = 30;
		}
		else if( !bEuvRun )
		{
			m_pTimer->PauseTimer( TM_EUV_ON );
		}
		else if( m_pTimer->m_pTimer[TM_EUV_ON].bPause )
		{ 
			m_pTimer->RePlayTimer( TM_EUV_ON );
		}
		break;
	case 30 :
		if( TIMER( TM_EUV_ON ) )
		{ 
			m_IfEuv.bLampOnTimer = FALSE;
			nSeqNo = 100;
		}
		else if( !bEuvRun )
		{
			m_pTimer->PauseTimer( TM_EUV_ON );
		}
		else if( m_pTimer->m_pTimer[TM_EUV_ON].bPause )
		{
			m_pTimer->RePlayTimer( TM_EUV_ON );
		}
		break;
	case 100:
		if( !IsGlassExist() )
		{
			nSeqNo = 0;
		}
		break;
	}

	nSeqGetOnTimeOverNo = nSeqNo;
	
	return	m_IfEuv.bLampOnTimer;
}

int CGsEuvSeq::SetLampControl()
{
	int nControl = euvLAMP_OFF;
	static int nOldControl = euvLAMP_OFF;
	static BOOL bManualModeChangeComp = FALSE;

	BOOL bRunCond = TRUE;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bRunCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bRunCond &= !m_pDicsData->m_GenInfo.bDoorOpen;

	BOOL bEuvUse		= IsEuvUse();
	BOOL bEuvAlarm		= GetEuvAlarm() > 0 ? TRUE : FALSE;  
	BOOL bGlassExist	= IsGlassExist();
	BOOL bCvRun			= 1; //dosUNIT_MOTOR_FW( IF_UNIT_EUV );ӽ 

	BOOL bEuvRun = TRUE;
	bEuvRun &= bRunCond;
	bEuvRun &= bEuvUse;
	bEuvRun &= !bEuvAlarm;
	bEuvRun &= bGlassExist;
	bEuvRun &= bCvRun;

	BOOL bTimeOver = FALSE;
	bTimeOver = GetOnTimeOver( bEuvRun );
	bEuvRun &= bTimeOver ;
	

	if( m_pDicsData->m_GenInfo.bAuto )
	{
		bManualModeChangeComp = FALSE;

		if( bEuvRun )
		{
			if( nOldControl == euvLAMP_OFF )
			{
				nControl = euvLAMP_ON;
			}
			else if( nOldControl >= euvLAMP_PAUSE )
			{
				nControl = euvLAMP_ON_KEEP;
			}
		}
		else
		{
			if( !bGlassExist || !bTimeOver )
			{
				nControl = euvLAMP_OFF;
			}
			else if( nOldControl >= euvLAMP_PAUSE )
			{
				nControl = euvLAMP_PAUSE;
			}
		}
	}
	else
	{
		if( !bRunCond || !bManualModeChangeComp )
		{
			bManualModeChangeComp = TRUE;

			if( !bGlassExist )
			{
				nControl = euvLAMP_OFF;
			}
			else if( nOldControl >= euvLAMP_PAUSE )
			{
				nControl = euvLAMP_PAUSE;
			}
		}
		else
		{
			nControl = euvLAMP_MANUAL;
		}
	}
	
	if( nControl != euvLAMP_MANUAL ) nOldControl = nControl;

	return nControl;
}


void CGsEuvSeq::SeqEuvAlarm()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	if( !m_SeqFlag.bInitComp || !m_pDicsData->m_GenInfo.bAuto ) return;
		
	static int nAlarmId[MAX_EUV_ALARM] = { 0, };
	static DWORD dwStartTick = 0;

	int nAlarmCode	= 0;
	int nSeqNo		= m_nSeqAlarmNo;

	switch ( nSeqNo )
	{
	case 0:
		if( ( nAlarmCode = GetEuvAlarm() ) == 0 )
		{
			;	// No Operation
		}
		else if( IsEuvUse() )
		{
			dwStartTick = GetTickCount();
			nSeqNo = 10;
		}
		break;
	case 10:
		if( !IsEuvUse() ||
		  ( nAlarmCode = GetEuvAlarm() ) == 0 )
		{
			nSeqNo = 0;
		}
		else if( ( GetTickCount() - dwStartTick ) > 1500 )
		{	// Parsing EUV Alarm Code
			for( int i=0; i<MAX_EUV_ALARM; i++ )
			{
				if( nAlarmCode & ( 0x0001 << i ) )
				{
					nAlarmId[i] = ALM_EUV_OVER_HEAT + i;
					m_pEqpStateSeq->SetAlarm( nAlarmId[i] );

				}
			}		

			// Log
			SetLog( "ALARM   ", 0, 0, "Alarm Set" );	
			
			dwStartTick = GetTickCount();
			nSeqNo = 1000;			
		}
		break;
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() || 
		  ( ( GetTickCount() - dwStartTick ) > 1000 && GetEuvAlarm() == 0 ) )
		{
			if ( GetEuvAlarm() && IsEuvUse() ) return;

			for( int i=0; i<MAX_EUV_ALARM; i++)
			{
				if( nAlarmId[i] )
				{	// Reset Alarm
					m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
				
//					m_pDicsData->m_IfEuv.bLampAlarm = FALSE;

					// Clear the alarm ID
					nAlarmId[i] = 0;
				}
			}
			// Log
			SetLog( "ALARM", 0, 0, "Alarm Recovery" );
			nSeqNo = 0;
		}
		break;
	}
    
	m_nSeqAlarmNo = nSeqNo;
}


BOOL CGsEuvSeq::GetEuvCond()
{
	static BOOL bCheckMargine = FALSE;
	BOOL bOk = FALSE;
	

	BOOL bEuvUse		= IsEuvUse();
	BOOL bGlassExist	= IsGlassExist();
	BOOL bEuvAlarm		= GetEuvAlarm() > 0 ? TRUE : FALSE;
	BOOL bCvRun			= 1; //dosUNIT_MOTOR_FW( IF_UNIT_EUV );ӽ 

	BOOL bEuvRun = TRUE;
	bEuvRun &= bEuvUse;
	bEuvRun &= bGlassExist;
	bEuvRun &= m_IfEuv.bLampOnTimer;
	
	if( !bEuvRun )
	{
		if( !GetLampOnState() ) bOk = TRUE;
	}
	else
	{
		if( bCvRun && GetLampOnState() )
		{
			bCheckMargine = FALSE;
			bOk = TRUE;
		}
		else if( !bCvRun && !bEuvAlarm )
		{
			bCheckMargine = FALSE;
			bOk = TRUE;
		}
		else if( bCvRun && !GetLampOnState() )
		{
			if( !bCheckMargine )
			{
				bCheckMargine = TRUE;
				bOk = TRUE;
			}
			else
			{
				bOk = FALSE;
			}
		}
	}

	return bOk;
}
