// HpmjSequence.h: interface for the CHpmjSequence class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HPMJSEQUENCE_H__4694C0C3_E597_43F9_B19F_0BD12ABA6254__INCLUDED_)
#define AFX_HPMJSEQUENCE_H__4694C0C3_E597_43F9_B19F_0BD12ABA6254__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\X\xsequence.h"
#include "..\X\XCtlDevice.h"
#include "..\X\XTimer.h"
#include "..\View\SetupItems.h"
#include "..\Sequence\EqpStateSequence.h"
#include "..\DicsData.h"
#include "..\Lib\PIDControl.h"
#include "..\X\XTimer.h"
#include "..\FactoryLib\EqpAssy.h"

class CHpmjSequence : public XSequence  
{
public:
	CHpmjSequence();
	virtual ~CHpmjSequence();

public:
	BOOL	Initialize();
	BOOL	Sequence();
	void	InitParameter();

	enum _inputSTATE{
		hpmjEMO,
		hpmjLEAK,
		hpmjINVTALARM,
		hpmjCOGEN2POWER,
		hpmjPUMPRUN,
	};
	
	enum _outputSTATE{
		hpmjINVTRUN,
		hpmjINVTRESET,
		hpmjMANUAL,
		hpmjPUMPMCON,
	};

	enum _analogInSTATE{
		hpmjSHOWR,
		hpmjINPRESS,
		hpmjOUTPRESS,
		hpmjMAINDIPRESS,
		hpmjDIW_RESISTIVITY,
		hpmjCO2PRESS
	};
		
	enum _analogOutSTATE{
		INVERTER_HERTZ,
	};
public:
	CPIDControl		m_PidPump;

	CDicsView*			m_pDicsView;
	XCtlDevice*			m_pDevice;
	XTimer*				m_pTimer;
	CSetupItems*		m_pSetupItems;
	CEqpStateSequence*	m_pEqpStateSeq;
	CDicsData*			m_pDicsData;
	CIniData			m_IniSetUpInfo;
	CEqpAssy*			m_pEqpAssy;
	CString	m_sSeqName;
	CString m_sMessage;
	int		m_nHpmjStateData[MAX_HPMJ_STATE_DATA];

	int m_nSeqInitNo;
	int m_nSeqModeChangeNo;
	int m_nSeqAlarmNo;
	int m_nSeqPumpRunNo;
	int m_nSeqStateMonitorNo;
	int m_nSeqCheckInterlockNo[MAX_HPMJ_AI_INTRO_NO];
	int m_nSeqHpmjAiNo;

	struct tagInterlock
	{
		BOOL			bGaugeAlarmSet[2*MAX_HPMJ_AI_INTRO_NO];
		BOOL			bGaugeWarningSet[2*MAX_HPMJ_AI_INTRO_NO];
	} m_InterlockHpmj;


	// Sequence flag
	struct tagSeqFlag
	{
		BOOL bInitReq;					// if initialized, it's TRUE 
		BOOL bInitComp;					// if initialized, it's TRUE 
		BOOL bInitFail;
	} m_SeqFlag;

public:
	void SeqHpmjAi();
	void SeqHpmjState();
	void SeqAISampling(int nAiNo);

	void SeqInit();
	void SeqModeChange();

	BOOL GetCheckCond( int nIntrNo );

	void SeqAlarm();
	void SeqGaugeInterlock( int nIntrNo );
	void SeqPumpRun();
	void SeqStateMonitor();
	double SetHpmjPumpControl();
	void SeqCheckWaterJetManual();

	void SetLog( CString sUnitName, CString sMessage, BOOL bSetGlsInfo = TRUE );
	void SetOwnerPointer(CWnd* pWnd);
	void SetDicsView( CDicsView *pView )						{ m_pDicsView = pView;	}
	void SetDevice(XCtlDevice* pDevice)							{ m_pDevice = pDevice; }
	void SetSeqTimer( XTimer* pTimer )							{ m_pTimer = pTimer; }
	void SetSetupItems( CSetupItems* pSetupItems )				{ m_pSetupItems = pSetupItems; }
	void SetEqpStateSequence(CEqpStateSequence* pEqpStateSeq)	{ m_pEqpStateSeq = pEqpStateSeq; }
	void SetDicsData( CDicsData* pData )						{ m_pDicsData = pData; }
	void SetEqpAssy( CEqpAssy* pAssy )							{m_pEqpAssy = pAssy;}
};

#endif // !defined(AFX_HPMJSEQUENCE_H__4694C0C3_E597_43F9_B19F_0BD12ABA6254__INCLUDED_)
