// CInterfaceSeq.cpp: implementation of the CInterfaceSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "InterfaceSeq.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CInterfaceSeq::CInterfaceSeq()
{

}

CInterfaceSeq::~CInterfaceSeq()
{

}

void CInterfaceSeq::InitParameter()
{
	m_nSeqGlassSendNo			= 0;
	m_nSeqGlassRecvNo			= 0;
	m_nSeqLoaderOnlineNo		= 0;
	m_nSeqResetRecvInterfaceNo	= 0;
	m_nSeqResetSendInterfaceNo	= 0;
	m_nSeqSendGlassDataNo		= 0;
	m_nSeqSubIdDataSetNo		= 0;
#ifdef _LOADER_DEBUG
	m_bSubIdDataSetReq = FALSE;
#endif
}

BOOL CInterfaceSeq::Initialize()
{
	InitParameter();

	return TRUE;
}

BOOL CInterfaceSeq::Sequence()
{
	Sleep( 10 );
	SeqLoaderOnline();			//   ON/OFF  Ȯ
//	SeqResetRecvInterface();
//	SeqResetSendInterface();
/*
	if( mibIF_NO_SUBSTRATE ) m_pDicsData->m_IfRecv.bBit[CDicsData::rcvNO_SUBSTRATE] = TRUE;
	else m_pDicsData->m_IfRecv.bBit[CDicsData::rcvNO_SUBSTRATE] = FALSE;
*/
	if( m_pDicsData->m_GenInfo.bAuto )
	{
		if( !m_pDicsData->m_GenInfo.bPause )
		{
			SeqGlassRecv();
			SeqGlassSend();
		}
	}
	static int nCycle=0;
//	SeqSendGlassData();
	if( nCycle==0 )SeqMonitorSignal();		// Signal Monitoring,     Ͽ ϴ  
//	SeqSubIdDataSet();		// Glass   ̵   Data û ϴ Set.  .

	nCycle++;
	if( nCycle > 10 ) nCycle = 0;
	return TRUE;
}

void CInterfaceSeq::SeqGlassRecv()
{
	m_sSeqName.Format( "SeqGlassRecv" );

	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;
	
	static int nReturnSeqNo = 0;
	static int nAlarmId		= 0;
	static int nTimeout = 0;
	static int nPortNo, nSlotNo = 0;
	static DWORD dDelayTime;	//191120 ksh

	static DWORD dwStartTick = 0;

	int tm = TM_GLASS_RECV;
	int nSeqNo = m_nSeqGlassRecvNo;

	CJobsTabInterfaceView* pView = ( (CDicsView *) m_pOwnerWnd )->m_pTabJobsInterfaceView;
	
	// Time Alarm ؼ  Ͽ ش.

	CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();
	int nT5_Timeout = atoi( pDoc->m_pSetupItems->m_sValueInterfacePara[CSetupItems::timeoutINTERFACE_T5] ) * 1000;

	switch( nSeqNo )
	{
	case 0:
#ifndef _LOADER_DEBUG
		if( m_pDicsData->m_IfRecv.bBit[CDicsData::rcvREQ] &&
			!m_pDicsData->m_GenInfo.bCycleStop &&
			!m_pDicsData->m_GenInfo.bIFLoaderEmoInterlock &&
			 mibLOAD_ROBOT_STATUS )	// 150902 halesu
#else
		if( m_pDicsData->m_IfRecv.bBit[CDicsData::rcvREQ] &&
			!m_pDicsData->m_GenInfo.bCycleStop &&
			!m_pDicsData->m_GenInfo.bIFLoaderEmoInterlock )
#endif
		{
			m_pDicsData->m_IfRecv.bBit[CDicsData::rcvREQ] = FALSE;

			SetLog( m_sSeqName, 0, 0, "INTERFACE GLASS RECV : START" );
			//SetLog( m_sSeqName, 0, 0, "mobSUBSTRATE_GLS_LD_STAGE(0x0085) : OFF(CLEANER -> ROBOT)" );
			nSeqNo = 10;
		}
		break;
	case 10:
		{
			if(m_pDicsData->m_IfRecv.bBit[CDicsData::rcvREQ])
			{
				m_pDicsData->m_IfRecv.bBit[CDicsData::rcvREQ] = FALSE;
			}
			nSeqNo = 20;
		}
		break;
	case 20:
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_LD, 0 ) &&
			!m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_LD, 1 ) )
#else
		if( 1 )
#endif
		{
			SetLog( m_sSeqName, 0, 0, "LD UNIT GLASS NOT EXIST : OK" );
			nSeqNo = 30;
		}
		else 
		{
			m_pDicsData->m_IfRecv.bBit[CDicsData::rcvERROR] = TRUE;

			nAlarmId = ALM_INCV_GLS_EXIST_BEFORE_RECV;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			SetLog( m_sSeqName, 0, 0, "LD UNIT GLASS EXIST : NG" );
			nSeqNo = nReturnSeqNo;
			nSeqNo = 1000;
		}
		break;
	case 30:
#ifndef _MY_DEBUG
		if( !mibLOAD_ROBOT_STATUS ) 
#else
		if( 0 )
#endif
		{
			ResetInterfaceSignalLd();
			m_pDicsData->m_IfRecv.bBit[CDicsData::rcvCANCEL_REQ] = TRUE;
			
			SetLog( m_sSeqName, 0, 0, "INTERFACE SIGNAL : RESET(LD)" );
			SetLog( m_sSeqName, 0, 0, "mibLOAD_ROBOT_STATUS(0x0030) : OFF(ROBOT -> CLEANER)" );			
			nSeqNo = 0;
		}
#ifndef _MY_DEBUG
		else //if(mibLOAD_TRANSFER_REQUEST)
#else
		else if(1)
#endif
		{
			mobLOAD_LOAD_REQUEST( ON );
			SetLog( m_sSeqName, 0, 0, "mobLOAD_LOAD_REQUEST(0x00A3) : ON(CLEANER -> ROBOT)" );
			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_HDC_LD_REQ, (LPARAM) 0 );

			nSeqNo = 40;
		}
		break;
	case 40:
#ifndef _MY_DEBUG
		if( !mibLOAD_ROBOT_STATUS ) 
#else
		if( 0 )
#endif
		{
			ResetInterfaceSignalLd();
			m_pDicsData->m_IfRecv.bBit[CDicsData::rcvCANCEL_REQ] = TRUE;
			
			SetLog( m_sSeqName, 0, 0, "INTERFACE SIGNAL : RESET(LD)" );
			SetLog( m_sSeqName, 0, 0, "mibLOAD_ROBOT_STATUS(0x0030) : OFF(ROBOT -> CLEANER)" );			
			nSeqNo = 0;
		}
#ifndef _MY_DEBUG
		else if( mibLOAD_ROBOT_READY ) //&& mibLOAD_TRANSFER_REQUEST )
#else
		else if(1)
#endif
		{
			SetLog( m_sSeqName, 0, 0, "mibLOAD_ROBOT_READY(0x0036) : ON(ROBOT -> CLEANER)" );
			SetLog( m_sSeqName, 0, 0, "mobLOAD_EQ_STAGE_ACCESS_POSSIBLE(0x00A2) : ON(CLEANER -> ROBOT)" );

			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_READY_LD_STAGE, (LPARAM) 0 );
			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_HDC_ACCESS_PBL_LD, (LPARAM) 0 );

			dDelayTime = GetTickCount();	//191120 ksh

			nSeqNo = 50;
		}
		else if( mibLOAD_TIMEOUT_RESET )
		{
			mobLOAD_LOAD_REQUEST( OFF );
			SetLog( m_sSeqName, 0, 0, "mobLOAD_LOAD_REQUEST(0x00A3) : OFF(CLEANER -> ROBOT)" );

			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_RCV_DATA_READ_COMP, (LPARAM) 0 );
			SetLog( m_sSeqName, 0, 0, "mibLOAD_TIMEOUT_RESET(0x0037) : ON(ROBOT -> CLEANER)" );
			m_pDicsData->m_IfRecv.bBit[CDicsData::rcvCANCEL_REQ] = TRUE;
			nSeqNo = 0;
		}
		break;
	case 50:
		{
			if( GetTickCount() - dDelayTime < 200 ) break;	//191120 ksh 
			ReadGlassData();	// Robot غ Ǹ Data о ´.

			if( GlassDataCheck() )
			{
				// Glass Data    EQ Stage Access Possible · .
				mobLOAD_EQP_ACCESS_POSSIBLE( ON );					
				SetLog( m_sSeqName, 0, 0, "GLASS RECEIVE DATA : OK )" );
				
				TIMER_ON( tm, nT5_Timeout );	// t5
				nSeqNo = 60;	
			}
			else
			{
				nAlarmId = ALM_GLS_DATA_WRONG;
				m_pEqpStateSeq->SetAlarm( nAlarmId );
				
				SetLog( m_sSeqName, 0, 0, "GLASS RECEIVE DATA : NG" );				
				nReturnSeqNo = nSeqNo;
				nSeqNo = 1000;	
			}
		}
		break;
	case 60:
#ifndef _MY_DEBUG
		if( !mibLOAD_ROBOT_ACCESSING_UPPER )
#else
		if(1)
#endif
		{
			SetLog( m_sSeqName, 0, 0, "mibLOAD_ROBOT_ACCESSING_UPPER(0x0033) : OFF(ROBOT -> CLEANER)" );
			TIMER_ON( tm, nT5_Timeout );
			nSeqNo = 65;
		}
		else if( TIMER( tm ) )
		{
			nAlarmId = ALM_LOADER_LOADING_T5;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			SetLog( m_sSeqName, 0, 0, "mibLOAD_ROBOT_ACCESSING_UPPER(0x0033) : ON TIMEOUT(ROBOT -> CLEANER)" );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 2000;			
		}
		break;

	case 65:
		#ifndef _MY_DEBUG
		if( mibLOAD_ROBOT_ACCESSING_UPPER )
#else
		if(1)
#endif
		{
			SetLog( m_sSeqName, 0, 0, "mibLOAD_ROBOT_ACCESSING_UPPER(0x0033) : ON(ROBOT -> CLEANER)" );
			nSeqNo = 70;
		}
		else if( TIMER( tm ) )
		{
			nAlarmId = ALM_LOADER_LOADING_T5;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			SetLog( m_sSeqName, 0, 0, "mibLOAD_ROBOT_ACCESSING_UPPER(0x0033) : ON TIMEOUT(ROBOT -> CLEANER)" );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 2000;			
		}
		break;

	case 70:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_LD, 0 ) && mibLOAD_ROBOT_STATUS )
#else
		if( 1 )
#endif
		{
			int nGlassNo = m_pDicsData->FindGlassNo();
			m_pDicsData->SetGlassData( IF_UNIT_LD*2 + 0, nGlassNo );	//191115 ksh unloading time out & LD glass send -> glass data 
			
			mobLOAD_SUBSTRATE_EQ_STATE( ON );

			SetLog( m_sSeqName, 0, 0, "GLASS EXIST" );
			SetLog( m_sSeqName, 0, 0, "mobLOAD_SUBSTRATE_EQ_STATE(0x00A1) : ON(CLEANER -> ROBOT)" );
			nSeqNo = 80;
		}
		// Glass  ȵ  ó .
		break;
	case 80:
#ifndef _MY_DEBUG
		if( !mibLOAD_SUBSTRATE_ON_ARM_UPPER && mibLOAD_ROBOT_ACCESSING_UPPER && mibLOAD_ROBOT_STATUS )
#else
		if( 1 )
#endif
		{
			mobLOAD_EQP_ACCESS_POSSIBLE( OFF );
			mobLOAD_LOAD_REQUEST( OFF );

			SetLog( m_sSeqName, 0, 0, "mibLOAD_SUBSTRATE_ON_ARM_UPPER(0x0036) : OFF(ROBOT -> CLEANER)" );
			SetLog( m_sSeqName, 0, 0, "mibLOAD_ROBOT_ACCESSING_UPPER(0x0033) : OFF(ROBOT -> CLEANER)" );
			SetLog( m_sSeqName, 0, 0, "mobLOAD_EQ_STAGE_ACCESS_POSSIBLE(0x00A2) : OFF(CLEANER -> ROBOT)" );
			SetLog( m_sSeqName, 0, 0, "mobLOAD_LOAD_REQUEST(0x00A3) : OFF(CLEANER -> ROBOT)" );
						
			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_RCV_DATA_READ_REQ, (LPARAM) 0 );
			TIMER_ON(tm, nT5_Timeout);
			nSeqNo = 110;		
		}
		break;
	case 110:
#ifndef _MY_DEBUG
		if(!mibLOAD_ROBOT_READY)
#else
		if( 1 )
#endif
		{
			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_RCV_DATA_READ_COMP, (LPARAM) 0 );

			if(m_pDicsData->m_IfRecv.bBit[CDicsData::rcvREQ])
			{
				m_pDicsData->m_IfRecv.bBit[CDicsData::rcvREQ] = FALSE;				
			}
			m_pDicsData->m_IfRecv.bBit[CDicsData::rcvCOMP] = TRUE;	

			SetLog( m_sSeqName, nPortNo, nSlotNo, "INTERFACE GLASS RECV : COMPLETE" );
			nSeqNo = 0;

		}
		else if( TIMER( tm ) )
		{
			nAlarmId = ALM_LOADER_UNLOADING_T5;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			SetLog( m_sSeqName, nPortNo, nSlotNo, "mibLOAD_ROBOT_READY(0x0036) : OFF TIMEOUT(ROBOT -> CLEANER)" );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 2000;			
		}
		break;
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			if ( m_pDicsData->m_IfRecv.bBit[CDicsData::rcvERROR] )
			{
				m_pDicsData->m_IfRecv.bBit[CDicsData::rcvERROR] = FALSE;
			}
			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			SetLog( m_sSeqName, nPortNo, nSlotNo, "ALARM RESET" );
			nSeqNo = nReturnSeqNo;
		}
		break;
	case 2000:	// TIMEOUT ALARM RESET
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			TIMER_ON( tm, 40000 ); //4000 sec

			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			SetLog( m_sSeqName, nPortNo, nSlotNo, "ALARM RESET : TIMEROUT ALARM" );
			nSeqNo = nReturnSeqNo;
		}
		break; 
	case 2500:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			TIMER_ON( tm, 20 ); //20 sec

			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			SetLog( m_sSeqName, nPortNo, nSlotNo, "ALARM RESET : TIMEROUT ALARM" );
			nSeqNo = nReturnSeqNo;
		}
		break;
	} 
	m_nSeqGlassRecvNo = nSeqNo;
}

//----------------------------------------------------------------------------------------------
// Description : 
//----------------------------------------------------------------------------------------------
void CInterfaceSeq::SeqGlassSend()
{
	m_sSeqName.Format( "SeqGlassSend" );

	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	static int nReturnSeqNo = 0;
	static int nAlarmId		= 0;
	static int nTimeout = 0;
	static int nPortNo, nSlotNo = 0;
	static DWORD dwStartTick;

	CString sMessage;
	int tm = TM_GLASS_SEND;
	int nSeqNo = m_nSeqGlassSendNo;
	int nGlsInfo = 0;

	CJobsTabInterfaceView* pView = ( (CDicsView *) m_pOwnerWnd )->m_pTabJobsInterfaceView;

	CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();
	int nT5_Timeout = atoi( pDoc->m_pSetupItems->m_sValueInterfacePara[CSetupItems::timeoutINTERFACE_T5] ) * 1000;
	
	switch( nSeqNo ) 
	{
	case 0:
#ifndef _MY_DEBUG
		if( m_pDicsData->m_IfSend.bBit[CDicsData::sndREQ] &&
			m_pEqpAssy->m_CylinderUlPinUD.GetFw() &&
			m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].bIsValid && 
			mibUNLOAD_ROBOT_STATUS &&
			!m_pDicsData->m_GenInfo.bIFLoaderEmoInterlock )
#else
		if( m_pDicsData->m_IfSend.bBit[CDicsData::sndREQ] &&
			m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].bIsValid &&
			!m_pDicsData->m_GenInfo.bIFLoaderEmoInterlock )
#endif
		{
			m_pDicsData->m_IfSend.bBit[CDicsData::sndREQ] = FALSE;
			nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nPortNo;
			nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nSlotNo;
			SetLog( m_sSeqName, nPortNo, nSlotNo, "INTERFACE GLASS SEND : START" );
			nSeqNo = 10;
		}
		break;
	case 10:
#ifndef _MY_DEBUG
		if(m_pEqpAssy->m_CylinderUlPinUD.GetFw())
#else
		if(m_pEqpAssy->m_CylinderUlPinUD.GetFwState())
#endif
		{
			dwStartTick = GetTickCount();
			nSeqNo = 20;
		}
		break;
	case 20:
		//if( GetTickCount() - dwStartTick > 500 )
		{
			WriteGlassData(nPortNo, nSlotNo);	// Glass data Set Ѵ.

			mobUNLOAD_SUBSTRATE_EQ_STATE( ON );
			mobUNLOAD_UNLOAD_REQUEST( ON );

			SetLog( m_sSeqName, nPortNo, nSlotNo, "mobUNLOAD_SUBSTRATE_EQ_STATE(0x0091) : ON(CLEANER -> OHCV)" );
			SetLog( m_sSeqName, nPortNo, nSlotNo, "mobUNLOAD_UNLOAD_REQUEST(0x0094) : ON(CLEANER -> OHCV)" );
			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_HDC_UL_REQ, (LPARAM) 0 );	

			dwStartTick = GetTickCount();
			nSeqNo = 30;
		}
		break;
	case 30:
#ifndef _MY_DEBUG
		if( mibUNLOAD_ROBOT_READY)
#else
		if( GetTickCount() - dwStartTick > 500 )
#endif
		{
			mobUNLOAD_EQP_ACCESS_POSSIBLE( ON );

			SetLog( m_sSeqName, nPortNo, nSlotNo, "mibUNLOAD_ROBOT_READY(0x00E6) : ON(OHCV -> CLEANER)" );
			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_READY_UL_STAGE, (LPARAM) 0 );

			SetLog( m_sSeqName, nPortNo, nSlotNo, "mobUNLOAD_EQP_ACCESS_POSSIBLE(0x0092) : ON(CLEANER -> OHCV)" );
			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_HDC_ACCESS_PBL_UL, (LPARAM) 0 );

			TIMER_ON( tm, nT5_Timeout );
			dwStartTick = GetTickCount();
			nSeqNo = 40;
		}
		if( !mibUNLOAD_ROBOT_STATUS ) 
		{
			ResetInterfaceSignalUl();
			
			SetLog( m_sSeqName, 0, 0, "INTERFACE SIGNAL : RESET(UL)" );
			SetLog( m_sSeqName, 0, 0, "mibUNLOAD_ROBOT_STATUS(0x00E0)  : OFF(ROBOT -> CLEANER)" );			
			nSeqNo = 0;
			m_pDicsData->m_IfSend.bBit[CDicsData::sndREQ] = TRUE;	// hskwak 191016
		}
		break;
	case 40:
#ifndef _MY_DEBUG
		if( !mibUNLOAD_ROBOT_ACCESSING_LOWER )
#else
		if( GetTickCount() - dwStartTick > 500 )
#endif
		{
			SetLog( m_sSeqName, nPortNo, nSlotNo, "mibUNLOAD_ROBOT_ACCESSING_LOWER(0x00E4) : OFF(OHCV -> CLEANER)" );
			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_RBT_ACCESS_UL, (LPARAM) 0 );
			TIMER_ON( tm, nT5_Timeout );
			nSeqNo = 45;
		}
		else if( TIMER( tm ) )
		{
			nAlarmId = ALM_LOADER_UNLOADING_T5;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			SetLog( m_sSeqName, nPortNo, nSlotNo, "mibUNLOAD_ROBOT_ACCESSING_LOWER(0x00E4) : OFF TIMEOUT(OHCV -> CLEANER)" );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 2000;	
		}
		break;

	case 45:
#ifndef _MY_DEBUG
		if( mibUNLOAD_ROBOT_ACCESSING_LOWER )
#else
		if( GetTickCount() - dwStartTick > 500 )
#endif
		{
			SetLog( m_sSeqName, nPortNo, nSlotNo, "mibUNLOAD_ROBOT_ACCESSING_LOWER(0x00E4) : OFF(OHCV -> CLEANER)" );
			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_RBT_ACCESS_UL, (LPARAM) 0 );
			nSeqNo = 50;
		}
		else if( TIMER( tm ) )
		{
			nAlarmId = ALM_LOADER_UNLOADING_T5;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			SetLog( m_sSeqName, nPortNo, nSlotNo, "mibUNLOAD_ROBOT_ACCESSING_LOWER(0x00E4) : OFF TIMEOUT(OHCV -> CLEANER)" );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 2000;			
		}
		break;

	case 50:
#ifndef _MY_DEBUG
		if( mibUNLOAD_SUBSTRATE_ON_ARM_LOWER && mibUNLOAD_ROBOT_STATUS )
#else
		if( 1 )
#endif
		{
			mobUNLOAD_SUBSTRATE_EQ_STATE( OFF ); 

			SetLog( m_sSeqName, nPortNo, nSlotNo, "GLASS NOT EXIST" );
			SetLog( m_sSeqName, nPortNo, nSlotNo, "mobUNLOAD_SUBSTRATE_EQ_STATE : OFF(CLEANER -> ROBOT)" );
			nSeqNo = 60;
		}
		break;

	case 60:
#ifndef _LOADER_DEBUG
		if( mibUNLOAD_ROBOT_ACCESSING_LOWER )
#else
		if( 1 )
#endif
		{
			ClearGlassData();
			mobUNLOAD_UNLOAD_REQUEST( OFF );
			mobUNLOAD_EQP_ACCESS_POSSIBLE( OFF );
			SetLog( m_sSeqName, nPortNo, nSlotNo, "GLASS EXIST" );
			SetLog( m_sSeqName, nPortNo, nSlotNo, "mibUNLOAD_ROBOT_ACCESSING_LOWER(0x00E4) : ON(OHCV -> CLEANER)" );
			SetLog( m_sSeqName, nPortNo, nSlotNo, "mobUNLOAD_UNLOAD_REQUEST(0x0094) : OFF(CLEANER -> OHCV)" );
			SetLog( m_sSeqName, nPortNo, nSlotNo, "mobUNLOAD_EQ_STAGE_ACCESS_POSSIBLE(0x0092) : OFF(CLEANER -> OHCV)" );

			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_REP_DATA_READ_REQ, (LPARAM) 0 );
			
			nSeqNo = 70;
		}
		break;
	case 70:
#ifndef _LOADER_DEBUG
		if( !mibUNLOAD_ROBOT_READY )
#else
		if( 1 )
#endif
		{
			COleDateTime time = COleDateTime::GetCurrentTime();
			CString sString;

			time = COleDateTime::GetCurrentTime();
			sString.Format( "%04d%02d%02d%02d%02d%02d", 
				time.GetYear(), time.GetMonth(), time.GetDay(), time.GetHour(), time.GetMinute(), time.GetSecond() );

			m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].sApdData[CDicsData::apdGLS_END_TIME] = sString;
			m_sMessage.Format( "GLASS END TIME : %s",  sString );
			SetLog( m_sSeqName, nPortNo, nSlotNo, m_sMessage );

			int nGlassNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nGlassNo;
			int nGlass_slot = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nGlass_slot;
			m_sMessage.Format( "GLASS NO : %d", nGlassNo+1 );
			SetLog( m_sSeqName, nPortNo, nSlotNo, m_sMessage );
			m_sMessage.Format( "GLASS SLOT NO : %d", nGlass_slot+1 );
			SetLog( m_sSeqName, nPortNo, nSlotNo, m_sMessage );

			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_REP_DATA_READ_COMP, (LPARAM) 0 );

			// APD REPORT REQUEST
			m_pDicsData->m_IfCim.bApdReportReq = TRUE;

			nSeqNo = 100;
		}
		break;
	case 100:
		m_pDicsData->m_SeqFlag.bUnloadProcess = TRUE;
		m_pDicsData->m_IfSend.bBit[CDicsData::sndCOMP] = TRUE;

		SetLog( m_sSeqName, nPortNo, nSlotNo, "INTERFACE GLASS SEND : COMPLETE" );
		nSeqNo = 0;
		break;

	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId );
			nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nPortNo;
			nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nSlotNo;
			SetLog( m_sSeqName, nPortNo, nSlotNo, "ALARM RESET" );
			nSeqNo = nReturnSeqNo;
		}
		break;
	case 2000:	// TIMEOUT ALARM
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId );
			nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nPortNo;
			nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nSlotNo;
			SetLog( m_sSeqName, nPortNo, nSlotNo, "ALARM RESET : TIMER ALARM" );
			TIMER_ON( tm, 40000 );
			nSeqNo = nReturnSeqNo;
		}
		break;
	}
	m_nSeqGlassSendNo = nSeqNo; 
}

void CInterfaceSeq::ResetInterfaceSignal()
{
/*
	mobIF_RDY_TO_LOAD(OFF);
	mobIF_PUT_REQ_LOAD(OFF);
	mobIF_GET_REQ_LOAD(OFF);
	mobIF_EXCHANGE_REQ_LOAD(OFF);
	mobIF_ARM_INTERFERE_OK_LOAD(OFF);

	mobIF_RDY_TO_UNLOAD(OFF);
	mobIF_PUT_REQ_UNLOAD(OFF);
	mobIF_GET_REQ_UNLOAD(OFF);
	mobIF_EXCHANGE_REQ_UNLOAD(OFF);
	mobIF_ARM_INTERFERE_OK_UNLOAD(OFF);
*///JUN_MELSEC
}

void CInterfaceSeq::ResetInterfaceSignalAll()
{
	mobLOAD_EQP_ACCESS_POSSIBLE(OFF);
	mobLOAD_LOAD_REQUEST(OFF);
	mobUNLOAD_EQP_ACCESS_POSSIBLE(OFF);
	mobUNLOAD_UNLOAD_REQUEST(OFF);
}

void CInterfaceSeq::ResetInterfaceSignalLd()
{
	mobLOAD_LOAD_REQUEST(OFF);
	mobLOAD_EQP_ACCESS_POSSIBLE(OFF);
}

void CInterfaceSeq::ResetInterfaceSignalUl()
{
	mobUNLOAD_EQP_ACCESS_POSSIBLE(OFF);
	mobUNLOAD_UNLOAD_REQUEST(OFF);
	mobUNLOAD_SUBSTRATE_EQ_STATE(OFF);
}

void CInterfaceSeq::SetStop(int nTimer, BOOL bStop)
{
/*
	if( nTimer < 0 ) // All stop
	{
		if( bStop )
		{
			// Timer Off
			m_pTimer->PauseTimer( TM_GLASS_RECV );
			m_pTimer->PauseTimer( TM_GLASS_SEND );
		}
		else
		{
			m_pTimer->RePlayTimer( TM_GLASS_RECV );
			m_pTimer->RePlayTimer( TM_GLASS_SEND );
		}
	}
	else
	{
		if( bStop )
		{
			m_pTimer->PauseTimer( nTimer );
		}
		else
		{
			m_pTimer->RePlayTimer( nTimer );
		}
	}
*/
}

void CInterfaceSeq::SeqResetRecvInterface()
{
	static DWORD dwTickStart = 0;
	int nSeqNo = m_nSeqResetRecvInterfaceNo;
	switch( nSeqNo )
	{
	case 0 :
		if( m_pDicsData->m_IfRecv.bBit[CDicsData::rcvRESET] )
		{
			SetLog( "RST RECV", 0, 0, "Signal Reset" );
			for( int i = 0 ; i < CDicsData::rcvMAX_RECV_BIT_NO ; i ++ )
				m_pDicsData->m_IfRecv.bBit[i] = FALSE;
			m_pDicsData->m_IfRecv.bBit[CDicsData::rcvCANCEL] = TRUE;
			ResetInterfaceSignal();
			m_nSeqGlassRecvNo = 0;
						
			dwTickStart = GetTickCount();

			nSeqNo = 10;
		}
		break;

	case 10 :
		if( m_pDicsData->m_GenInfo.bAuto )
		{
			SetLog( "RST RECV", 0, 0, "HDC Online ON" );
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqResetRecvInterfaceNo = nSeqNo;
}

void CInterfaceSeq::SeqResetSendInterface()
{
/*
	int nSeqNo = m_nSeqResetSendInterfaceNo;
	switch( nSeqNo )
	{
	case 0:
		if( m_pDicsData->m_IfSend.bBit[CDicsData::sndRESET] )
		{
			SetLog( "RST SEND", 0, 0, "Signal Reset" );
			for( int i = 0 ; i < CDicsData::sndMAX_SEND_BIT_NO ; i ++ )
				m_pDicsData->m_IfSend.bBit[i] = FALSE;
			m_pDicsData->m_IfSend.bBit[CDicsData::sndCANCEL] = TRUE;
		
			ResetInterfaceSignal();
			SetLog( "RST RECV", 0, 0, "HDC Online OFF" );
			
			m_nSeqGlassSendNo = 0;
			( (CDicsView *) m_pOwnerWnd )->m_pCimSeq->m_nSeqEdcDataReportNo	= 0;
			m_pDicsData->m_IfCim.bApdReportReq = FALSE;
			nSeqNo = 10;
		}
		break;
		
	case 10 :
		if( m_pDicsData->m_GenInfo.bAuto )
		{
			SetLog( "RST SEND", 0, 0, "HDC Online ON" );
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqResetSendInterfaceNo = nSeqNo;
*/
}

void CInterfaceSeq::SeqLoaderOnline()	// ROBOT  Ȯ.  Robot ΰ ̹Ƿ  ʿ.
{
	static BOOL bInit = FALSE;
	static BOOL bChangedStatus1 = 0;
	static BOOL bChangedStatus2 = 0;
	static DWORD dwStartTick = GetTickCount();

	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 7000 )	bInit = TRUE;
		if( !bInit ) return;
	}

	if( mibLOAD_ROBOT_STATUS && bChangedStatus1 !=1 )
	{
		Msg( WM_EQP_MESSAGE, (WPARAM)MSG_DN_STREAM_STATE, (LPARAM)"LD_ONLINE" );
		bChangedStatus1 = 1;
	}
	else if( !mibLOAD_ROBOT_STATUS && bChangedStatus1 != 2 )
	{
		Msg( WM_EQP_MESSAGE, (WPARAM)MSG_DN_STREAM_STATE, (LPARAM)"LD_OFFLINE" );
		bChangedStatus1 = 2;
	}
	
	if( mibUNLOAD_ROBOT_STATUS && bChangedStatus2 !=1 )
	{
		Msg( WM_EQP_MESSAGE, (WPARAM)MSG_MELSEC_UNLOAD_STATE, (LPARAM)"UL_ONLINE" );
		bChangedStatus2 = 1;
	}
	else if( !mibUNLOAD_ROBOT_STATUS && bChangedStatus2 != 2 )
	{
		Msg( WM_EQP_MESSAGE, (WPARAM)MSG_MELSEC_UNLOAD_STATE, (LPARAM)"UL_OFFLINE" );
		bChangedStatus2 = 2;
	}
}

int CInterfaceSeq::GetPortNo()
{
	int nRv    = 0;
	short nVal = 0;
	CString sPortNo;

	nVal = miwLOAD_CST_PORT_NO;
//	sPortNo.Format( "%c%c", nVal & 0xFF, ( ( nVal & 0xFF00 ) >> 8 ) );
	sPortNo.Format( "%c", ( ( nVal & 0xFF00 ) >> 8 ) );	// 150902 halesu
	nRv = atoi( sPortNo );
	return nRv;
}

int CInterfaceSeq::GetSlotNo()
{
	int nRv     = 0;
	short nVal  = 0;
	CString sSlotNo;

	nVal = miwLOAD_CST_SLOT_NO;
	sSlotNo.Format( "%c%c", nVal & 0xFF, ( ( nVal & 0xFF00 ) >> 8 ) );
	nRv = atoi( sSlotNo );
	return nRv;
}

void CInterfaceSeq::SeqMonitorSignal()
{
	m_sSeqName.Format( "SeqMonitorSignal" );

#ifdef _MY_DEBUG
	return;
#endif

	// AVAILABLE 
	if( m_pDicsData->m_GenInfo.bEqpInitComp && m_pDicsData->m_GenInfo.bAuto && !mosbLOAD_EQP_STATUS )
	{
		mobLOAD_EQP_STATUS( ON );		
		SetLog( m_sSeqName, 0, 0, "mobLOAD_EQP_STATUS(0x00A0) : ON(CLEANER -> ROBOT)" );
	}
	else if( ( !m_pDicsData->m_GenInfo.bEqpInitComp || !m_pDicsData->m_GenInfo.bAuto ) && mosbLOAD_EQP_STATUS )
	{
		mobLOAD_EQP_STATUS( OFF );
		SetLog( m_sSeqName, 0, 0, "mobLOAD_EQP_STATUS(0x00A0) : OFF(CLEANER -> ROBOT)" );
	}

	// GLASS EXIST
#ifndef _MY_DEBUG
	if(m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_LD, 0 ) && !mosbLOAD_SUBSTRATE_EQ_STATE)
#else
	if( m_pDicsData->m_bDebugInSensor[IF_UNIT_LD] && !mosbLOAD_SUBSTRATE_EQ_STATE)
#endif
	{
		mobLOAD_SUBSTRATE_EQ_STATE ( ON );
		SetLog( m_sSeqName, 0, 0, "mobLOAD_SUBSTRATE_EQ_STATE(0x00A1) : ON(CLEANER -> ROBOT)" );
	}
#ifndef _MY_DEBUG
	else if(!m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_LD, 0 ) && mosbLOAD_SUBSTRATE_EQ_STATE)
#else
	else if( m_pDicsData->m_bDebugInSensor[IF_UNIT_LD] && mosbLOAD_SUBSTRATE_EQ_STATE)
#endif
	{
		mobLOAD_SUBSTRATE_EQ_STATE ( OFF );
		SetLog( m_sSeqName, 0, 0, "mobLOAD_SUBSTRATE_EQ_STATE(0x00A1) : OFF(CLEANER -> ROBOT)" );
	}

	if( m_pDicsData->m_GenInfo.bEqpInitComp && m_pDicsData->m_GenInfo.bAuto && !mosbUNLOAD_EQP_STATUS )
	{
		mobUNLOAD_EQP_STATUS( ON );		
		SetLog( m_sSeqName, 0, 0, "mobUNLOAD_EQP_STATUS(0x0090) : ON(CLEANER -> OHCV)" );
	}
	else if( ( !m_pDicsData->m_GenInfo.bEqpInitComp || !m_pDicsData->m_GenInfo.bAuto ) && mosbUNLOAD_EQP_STATUS )
	{
		mobUNLOAD_EQP_STATUS( OFF );
		SetLog( m_sSeqName, 0, 0, "mobUNLOAD_EQP_STATUS(0x0090) : OFF(CLEANER -> OHCV)" );
	}

	// Any glass process flag
	int nGlassEA = 0;
	int nProcessFlag = 0;
	for( int i=IF_UNIT_LD; i<MAX_IF_NO; i++ )
	{
		if( m_pDicsData->m_GlsInfo[i*2 + 0].bIsValid)// && m_pDicsData->m_GlsInfo[i*2 + 0].bProcessFlag )
			nGlassEA++;
		if( m_pDicsData->m_GlsInfo[i*2 + 1].bIsValid)// && m_pDicsData->m_GlsInfo[i*2 + 1].bProcessFlag )
			nGlassEA++;

		if( m_pDicsData->m_GlsInfo[i*2 + 0].bProcessFlag)
			nProcessFlag++;
		if( m_pDicsData->m_GlsInfo[i*2 + 1].bProcessFlag)
			nProcessFlag++;
	}

/*	if(nGlassEA > 0 && !mosbLOAD_ANY_GLASS_PROCESS_FLAG)
	{
		mobLOAD_ANY_GLASS_PROCESS_FLAG( ON );
		SetLog( m_sSeqName, 0, 0, "modLOAD_ANY_GLASS_PROCESS_FLAG(0x00AF) : ON(CLEANER -> ROBOT)" );
	}
	else if(nGlassEA <= 0 && mosbLOAD_ANY_GLASS_PROCESS_FLAG)
	{
		mobLOAD_ANY_GLASS_PROCESS_FLAG( OFF );
		SetLog( m_sSeqName, 0, 0, "modLOAD_ANY_GLASS_PROCESS_FLAG(0x00AF) : OFF(CLEANER -> ROBOT)" );
	}
*/
	if(nGlassEA > 0 && nProcessFlag > 0 && !mosbUNLOAD_ANY_GLASS_PROCESS_FLAG)
	{
		mobUNLOAD_ANY_GLASS_PROCESS_FLAG( ON );
		SetLog( m_sSeqName, 0, 0, "modUNLOAD_ANY_GLASS_PROCESS_FLAG(0x00AF) : ON(CLEANER -> OHCV)" );
	}
	else if((nGlassEA <= 0 || nProcessFlag <= 0)&& mosbUNLOAD_ANY_GLASS_PROCESS_FLAG)
	{
		mobUNLOAD_ANY_GLASS_PROCESS_FLAG( OFF );
		SetLog( m_sSeqName, 0, 0, "modUNLOAD_ANY_GLASS_PROCESS_FLAG(0x00AF) : OFF(CLEANER -> OHCV)" );
	}



	/*
	// UNLOAD WAIT 
	if( ( (CDicsView *) m_pOwnerWnd )->m_pCvSeq->m_bUnloadWaitRequest )
	{
		( (CDicsView *) m_pOwnerWnd )->m_pCvSeq->m_bUnloadWaitRequest = FALSE;
		mobUNLOAD_WAIT( ON );
		mobSUBSTRATE_GLS_UL_STAGE( ON );
		SetLog( m_sSeqName, 0, 0, "mobUNLOAD_WAIT(0x008A) : ON(CLEANER -> ROBOT)" );
		SetLog( m_sSeqName, 0, 0, "mobSUBSTRATE_GLS_UL_STAGE(0x0089) : ON(CLEANER -> ROBOT)" );
	}
	*/
}

BOOL CInterfaceSeq::GlassDataCheck()
{
	BOOL bCheck = TRUE;
	CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();
	bCheck &= m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].nPortNo > 0;
	bCheck &= m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].nPortNo < 6;		// Port  Ȯ.
	bCheck &= atoi( m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sSlotNo ) > 0;
	bCheck &= atoi( m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sSlotNo ) < 29;		// Slot  Ȯ
//	bCheck &= pDoc->m_pRecipeSet->FindRecipe( m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sRecipeId );	// Recipe  ޾Ƽ   ִ Recipe  .
	bCheck &= pDoc->ISExistRecipeID( m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sRecipeId );	//  Recipe  Robot  Recipe  .	 
	
	return bCheck;
}
/*
void CInterfaceSeq::SeqSendGlassData()
{
	m_sSeqName.Format( "SeqSendGlassData" );

	static DWORD dwTickStart;
	
	int nSeqNo = m_nSeqSendGlassDataNo;	
	
	CJobsTabInterfaceView* pView = ( (CDicsView *) m_pOwnerWnd )->m_pTabJobsInterfaceView;
	
	switch( nSeqNo )
	{
	case 0:
		if( mibSUBSTRATE_ID_DATA_SET_REQ && m_pDicsData->m_IfCim.bSendDataCheck )
		{
			CString sLOT_ID = "";
			CString sGLASS_ID = "";
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nSlotNo;

			int nGlassNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nGlassNo;
			sLOT_ID = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].sLotId;
			sGLASS_ID = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].sGlassId;
			int nGlass_slot = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nGlass_slot;
			SetLog( m_sSeqName, nPortNo, nSlotNo, "mibSUBSTRATE_ID_DATA_SET_REQ(0x0006) : ON(ROBOT -> CLEANER" );
			SetLog( m_sSeqName, nPortNo, nSlotNo, "SEND GLASS DATA : START" );

			mowLOT_ID( sLOT_ID, 14 );
			mowGLASS_ID( sGLASS_ID, 14 );
			mobSUBSTRATE_ID_DATA_SET_COM( ON );

			m_sMessage.Format( "GLASS NO : %d", nGlassNo );
			SetLog( m_sSeqName, nPortNo, nSlotNo, m_sMessage );
			m_sMessage.Format( "LOT ID : %s", sLOT_ID );
			SetLog( m_sSeqName, nPortNo, nSlotNo, m_sMessage );
			m_sMessage.Format( "GLASS ID : %s", sGLASS_ID );
			SetLog( m_sSeqName, nPortNo, nSlotNo, m_sMessage );
			m_sMessage.Format( "GLASS SLOT NO : %d", nGlass_slot );
			SetLog( m_sSeqName, nPortNo, nSlotNo, m_sMessage );			
			SetLog( m_sSeqName, nPortNo, nSlotNo, "mobSUBSTRATE_ID_DATA_SET_COM(0x0086) : ON(CLEANER -> ROBOT)" );
			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_REP_DATA_READ_REQ, (LPARAM) 0 );

			nSeqNo = 10;
		}
		break;
	case 10 :
#ifndef _LOADER_DEBUG
		if( !mibSUBSTRATE_ID_DATA_SET_REQ )
#else
		if( 1 )
#endif
		{
			mobSUBSTRATE_ID_DATA_SET_COM( OFF );
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].nSlotNo;
			SetLog( m_sSeqName, nPortNo, nSlotNo, "mibSUBSTRATE_ID_DATA_SET_REQ(0x0006) : OFF(ROBOT -> CLEANER)" );
			SetLog( m_sSeqName, nPortNo, nSlotNo, "mobSUBSTRATE_ID_DATA_SET_COM(0x0086) : OFF(CLEANER -> ROBOT)" );
			pView->SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_REP_DATA_READ_COMP, (LPARAM) 0 );			
			
			for( int i =1; i <= 7; i++)
			{
				mowLOT_ID( "", i*2 );
				mowGLASS_ID( "", i*2 );
			}

//			m_pDicsData->DeleteGlassData( IF_UNIT_UL_HAND*2 + 0 );
			m_sMessage.Format( "0%02d%1d", nSlotNo, nPortNo );
			SetLog( m_sSeqName, nPortNo, nSlotNo, m_sMessage );
			SetLog( m_sSeqName, nPortNo, nSlotNo, "SEND GLASS DATA : COMPLETE" );
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqSendGlassDataNo = nSeqNo;
}
*/
/*
void CInterfaceSeq::SeqSubIdDataSet()
{
	m_sSeqName.Format( "SeqSubIdDataSet" );

	int nSeqNo = m_nSeqSubIdDataSetNo;
	int nMaxGlassNo = m_pDicsData->m_GenInfo.nMaxEqpGlassNo;

	switch( nSeqNo )
	{
	case 0:
#ifndef _LOADER_DEBUG	// 150902 halesu
		if( mibSUBSTRATE_ID_DATA_SET_REQ )
#else
		if( m_bSubIdDataSetReq )
#endif
		{
			int nCurGlsNo = m_pDicsData->m_GenInfo.nGlassNo;
			int nGlsNo = 0;//nCurGlsNo - 1;
			CString sGlassData;
			CString sSlot_Num;			

			SetLog( m_sSeqName, 0, 0, "mibSUBSTRATE_ID_DATA_SET_REQ(0x0006) : ON(ROBOT -> CLEANER)" );
			SetLog( m_sSeqName, 0, 0, "SUBSTRATE ID DATA SET : START" );

			for( int i=MAX_UNIT_NO*2-1; i>=0; i-- )
			{
				if( m_pDicsData->m_GlsInfo[i].bIsValid )
				{
					int nPortNo = m_pDicsData->m_GlsInfo[i].nPortNo;
					int nSlotNo = m_pDicsData->m_GlsInfo[i].nSlotNo;

					sGlassData.Format( "%02d", nPortNo );
					mogwSUBID_PORT_NO( nGlsNo, sGlassData, 2 );
					sGlassData.Format( "%02d", nSlotNo );
					mogwSUBID_SLOT_NO( nGlsNo, sGlassData, 2 );

					m_sMessage.Format( "SUBSTRATE ID DATA NO%d", nGlsNo + 1 );
					SetLog( m_sSeqName, nPortNo, nSlotNo, m_sMessage );

					if( nGlsNo < nMaxGlassNo ) nGlsNo++;
				}
			}
			nSeqNo = 10;
		}
		break;
	case 10:
		{
#ifdef _LOADER_DEBUG	// 150902 halesu
			m_bSubIdDataSetReq = FALSE;
#endif
			mobSUBSTRATE_ID_DATA_SET_COM( ON );

			SetLog( m_sSeqName, 0, 0, "mobSUBSTRATE_ID_DATA_SET_COM(0x0086) : ON(CLEANER -> ROBOT)" );
			nSeqNo = 20;
		}
		break;
	case 20:
#ifndef _LOADER_DEBUG	// 150902 halesu
		if( !mibSUBSTRATE_ID_DATA_SET_REQ )
#else
		if( !m_bSubIdDataSetReq )
#endif
		{
			mobSUBSTRATE_ID_DATA_SET_COM( OFF );

			SetLog( m_sSeqName, 0, 0, "mibSUBSTRATE_ID_DATA_SET_REQ(0x0006) : OFF(ROBOT -> CLEANER)" );
			SetLog( m_sSeqName, 0, 0, "mobSUBSTRATE_ID_DATA_SET_COM(0x0086) : OFF(CLEANER -> ROBOT)" );

			for( int i=0; i<nMaxGlassNo; i++ )
			{
				mogwSUBID_PORT_NO( i, "", 2 );
				mogwSUBID_SLOT_NO( i, "", 2 );
			}

			SetLog( m_sSeqName, 0, 0, "SUBSTRATE ID DATA RESEST" );
			SetLog( m_sSeqName, 0, 0, "SUBSTRATE ID DATA SET : COMPLETE" );
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqSubIdDataSetNo = nSeqNo;	
}
*/
void CInterfaceSeq::ReadGlassData()
{
	CString sPORT_NO;
	CString sSLOT_NO;
	CString sRECIPE_ID;	
	CString sFULLRECIPE_ID;	
	CString sGLASS_ID;
	CString sLOT_ID;			// Thomas 191226
	CString sCASSETTE_ID;		// Thomas 191226
	CString sPROCESS_FLAG;
	CString sRESERVED;
	static int nGls_slot = 0;
	static int nRecipIDCnt = 0;
	short nVal = 0;

	// hskwak  κ  ؾ  Glass data ޴ κ. Robot Ready Ŀ Data д°  .
#ifndef _LOADER_DEBUG
	// hskwak 190531
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].nPortNo = GetPortNo();
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].nSlotNo = GetSlotNo();

	// PORT NO
	nVal = miwLOAD_CST_PORT_NO;
	//sPORT_NO.Format( "%c%c", nVal & 0xFF, ( ( nVal & 0xFF00 ) >> 8 ) );
	sPORT_NO.Format("%d", nVal);

	// SLOT NO
	nVal = miwLOAD_CST_SLOT_NO;
	//sSLOT_NO.Format( "%c%c", nVal & 0xFF, ( ( nVal & 0xFF00 ) >> 8 ) );
	sSLOT_NO.Format("%d", nVal);

	// LOT ID, Thomas 191226
	miwLOAD_LOT_ID( sLOT_ID.GetBuffer( 14 ), 14 );
	sLOT_ID.ReleaseBuffer();

	// CASSETTE ID, Thomas 191226
	miwLOAD_CAS_ID( sCASSETTE_ID.GetBuffer( 6 ), 6 );
	sCASSETTE_ID.ReleaseBuffer();

	miwLOAD_GLASS_ID( sGLASS_ID.GetBuffer( 14 ), 14 );	// GLASS ID
	sGLASS_ID.ReleaseBuffer();

	nVal = miwLOAD_RECIPE_ID_NUM;	// RECIPE ID
	sRECIPE_ID.Format( "%c%c", nVal & 0xFF, ( ( nVal & 0xFF00 ) >> 8 ) );
	sRECIPE_ID.ReleaseBuffer();

	miwLOAD_RECIPE_ID( sFULLRECIPE_ID.GetBuffer( 16 ), 16 );	// RECIPE ID
	sFULLRECIPE_ID.ReleaseBuffer();
	

	nVal = miwLOAD_PROCESS_FLAG;	// sPROCESS FLAG
	//sPROCESS_FLAG.Format( "%c%c", nVal & 0xFF, ( ( nVal & 0xFF00 ) >> 8 ) );
	sPROCESS_FLAG.Format("%d", nVal);
	//miwLOAD_RESERVED( sRESERVED.GetBuffer( 4 ), 4 );	// RESERVED
	//sRESERVED.ReleaseBuffer();

	sPORT_NO.TrimRight(' ');
	sSLOT_NO.TrimRight(' ');
	sGLASS_ID.TrimRight(' ');
	sRECIPE_ID.TrimRight(' ');
	sPROCESS_FLAG.TrimRight(' ');
	sRESERVED.TrimRight(' ');
	sFULLRECIPE_ID.TrimRight(' ');
	sLOT_ID.TrimRight(' ');				// Thomas 191226
	sCASSETTE_ID.TrimRight(' ');		// Thomas 191226

	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sPortNo			= sPORT_NO;
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sSlotNo			= sSLOT_NO;
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sGlassId			= sGLASS_ID;
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sLotId				= sLOT_ID;		// Thomas 191226
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sCassetteId		= sCASSETTE_ID;	// Thomas 191226
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sRecipeId			= sRECIPE_ID;
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sRecipeIdFull		= sFULLRECIPE_ID;

	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].bProcessFlag		= atoi(sPROCESS_FLAG);
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sReserved			= sRESERVED;

	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sOperationId		= "";
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sOperationNo		= "";

	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].nPortNo = atoi(sPORT_NO);
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].nSlotNo = atoi(sSLOT_NO);
#else
	static int nGlsNo = 0;
	static int nCVDPortNo = 0;

	if( nGlsNo < 29 ) nGlsNo++;
	else nGlsNo = 1;

	if( nCVDPortNo < 6 ) nCVDPortNo++;
	else nCVDPortNo = 1;
	sPORT_NO = "1";
	sSLOT_NO = "2";
	if( nRecipIDCnt == 1 )		sRECIPE_ID = "02";
	else if( nRecipIDCnt == 2 )	sRECIPE_ID = "03";
	else
	{
		nRecipIDCnt = 0;
		sRECIPE_ID = "01";
	}
	nRecipIDCnt++;
	sGLASS_ID.Format( "GLASS_DUMMY%d", nGlsNo );
	sPROCESS_FLAG = "1";
	sPORT_NO.TrimRight(' ');
	sRECIPE_ID.TrimRight(' ');
	sGLASS_ID.TrimRight(' ');		//PCBID

	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sPortNo			= sPORT_NO;
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sSlotNo			= sSLOT_NO;		// PCBID
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sCassettePortNo	= sPORT_NO;
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sCassetteSlotNo	= sSLOT_NO;

	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sRecipeId			= sRECIPE_ID;
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sGlassId			= sGLASS_ID;		// PCBID
	
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].nPortNo = atoi(sPORT_NO);
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].nSlotNo = atoi(sSLOT_NO);

//	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].bProcessFlag		= atoi(bPROCESS_FLAG);
	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sReserved			= sRESERVED;
#endif
	CString sBuf;
	int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].nSlotNo;
	int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].nPortNo;

	sBuf.Format("sPortNo : %s",  sPORT_NO );
	SetLog("RECV DATA", nPortNo, nSlotNo, sBuf );

	sBuf.Format("sSlotNo : %s",  sSLOT_NO );
	SetLog("RECV DATA", nPortNo, nSlotNo, sBuf );

	// Lot Id, Thomas 191226
	sBuf.Format("sLotId : %s",  sLOT_ID );
	SetLog("RECV DATA", nPortNo, nSlotNo, sBuf );

	// Cassette Id, Thomas 191226
	sBuf.Format("sCassetteId : %s",  sCASSETTE_ID );
	SetLog("RECV DATA", nPortNo, nSlotNo, sBuf );

	sBuf.Format("sRecipeId : %s",  sRECIPE_ID );
	SetLog("RECV DATA", nPortNo, nSlotNo, sBuf );

	sBuf.Format( "sGlassId : %s",  sGLASS_ID);
	SetLog("RECV DATA", nPortNo, nSlotNo, sBuf );

	sBuf.Format( "sProcess flag : %s",  sPROCESS_FLAG);
	SetLog("RECV DATA", nPortNo, nSlotNo, sBuf );
	
	CString sString;
	COleDateTime time = COleDateTime::GetCurrentTime();	// GLASS RECEIVE TIME
	sString.Format( "%04d%02d%02d%02d%02d%02d", 
		time.GetYear(), time.GetMonth(), time.GetDay(), time.GetHour(), time.GetMinute(), time.GetSecond() );	

	m_pDicsData->m_GlsInfo[IF_UNIT_LD*2].sApdData[CDicsData::apdGLS_START_TIME] = sString;
	m_sMessage.Format( "GLASS START TIME : %s",  sString);
	SetLog( m_sSeqName, nPortNo, nSlotNo, m_sMessage );

	//m_pDicsData->SetGlassData( IF_UNIT_UP_LD*2 + 0, nGlassNo );	// 2nd parameter : Glass No
	//--------------------------------------------------------------
	// 0 1 2
	// 1 0 3 => 0 : 1̸ Glass ְ 0̸ Glass .
	//			2 : 03 Glass No
	//--------------------------------------------------------------
	// Insert the data to TR unit rectangle box.

	m_pDicsData->m_GlsInfo[IF_UNIT_LD * 2].nGlass_slot = nGls_slot;
	m_sMessage.Format( "THIS GLASS SLOT NO IS %d", nGls_slot + 1 );
	SetLog( m_sSeqName, nPortNo, nSlotNo, m_sMessage );

	if( nGls_slot >= ( m_pDicsData->m_GenInfo.nMaxEqpGlassNo - 1 ) ) nGls_slot = 0;
	else nGls_slot += 1;
}

void CInterfaceSeq::WriteGlassData(int nPortNo, int nSlotNo)
{
	CString sLOT_ID;
	CString sGLASS_ID;
	CString sRecipe_ID;
	
	CString sBuf;	
	int nID=0;
	
	sBuf = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].sSlotNo;
	sBuf.Format( "%2s", sBuf );
	nID = atoi(sBuf);
	mowUNLOAD_CST_SLOT_NO( nID );
	m_sMessage.Format( "sSlotNo : %d", nID );				// Thomas 20200108
	SetLog( "SEND DATA", nPortNo, nSlotNo, m_sMessage );	// Thomas 20200108
	sBuf.ReleaseBuffer();

	sBuf = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].sPortNo;
	sBuf.Format( "%2s", sBuf );
	nID = atoi(sBuf);
	mowUNLOAD_CST_PORT_NO( nID );
	m_sMessage.Format( "sPortNo : %d", nID );				// Thomas 20200108
	SetLog( "SEND DATA", nPortNo, nSlotNo, m_sMessage );	// Thomas 20200108
	sBuf.ReleaseBuffer();

	sGLASS_ID = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].sGlassId;
	mowUNLOAD_GLASS_ID( sGLASS_ID, 14 );
	m_sMessage.Format( "sGlassId : %s", sGLASS_ID );
	SetLog( "SEND DATA", nPortNo, nSlotNo, m_sMessage );

	sRecipe_ID = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].sRecipeIdFull;
	mowUNLOAD_RECIPE_ID( sRecipe_ID, 16 );
	m_sMessage.Format( "sRecipeId : %s", sRecipe_ID );
	SetLog( "SEND DATA", nPortNo, nSlotNo, m_sMessage );

	sBuf.Format( "%2d", m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].bProcessFlag );
	nID = atoi(sBuf);
	mowUNLOAD_PROCESS_FLAG( nID );
	m_sMessage.Format( "bProcessFlag : %d", nID );			// Thomas 20200108
	SetLog( "SEND DATA", nPortNo, nSlotNo, m_sMessage );	// Thomas 20200108
	sBuf.ReleaseBuffer();

}

void CInterfaceSeq::ClearGlassData()
{
	mowUNLOAD_CST_SLOT_NO(0);
	mowUNLOAD_CST_PORT_NO(0);
	mowUNLOAD_PROCESS_FLAG( 0 );

	for( int i=1; i<=8; i++)
	{
		mowUNLOAD_RECIPE_ID( "", i*2 );
		if(i<=7)	mowUNLOAD_GLASS_ID( "", i*2 );
	}
}