// CInterfaceSeq.h: interface for the CInterfaceSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INTERFACESEQ_H__C66433C0_DF8C_4A64_A326_C5DC74F263D0__INCLUDED_)
#define AFX_INTERFACESEQ_H__C66433C0_DF8C_4A64_A326_C5DC74F263D0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\MOTHER\DicsInterfaceSeq.h"

class CInterfaceSeq : public CDicsInterfaceSeq  
{
public:
	BOOL Initialize();
	void InitParameter();
	BOOL Sequence();

	void SeqMonitorSignal();

	CInterfaceSeq();
	virtual ~CInterfaceSeq();

public:
	int			m_nSeqGlassSendNo;
	int			m_nSeqGlassRecvNo;
	int			m_nSeqSubIdDataSetNo;

#ifdef _LOADER_DEBUG
	BOOL		m_bSubIdDataSetReq;
#endif

private:
	int			m_nSeqResetRecvInterfaceNo;
	int			m_nSeqResetSendInterfaceNo;
	int			m_nSeqLoaderOnlineNo;
	int			m_nSeqSendGlassDataNo;

public:
//	void SeqSubIdDataSet();
	void ResetInterfaceSignal();
	void ResetInterfaceSignalAll();
	void ResetInterfaceSignalLd();
	void ResetInterfaceSignalUl();
	void SeqGlassSend();
	void SeqGlassRecv();
	void SetStop( int nTimer, BOOL bStop );
//	void SeqSendGlassData();
	void ReadGlassData();
	void WriteGlassData(int nPortNo, int nSlotNo);
	void ClearGlassData();
private:
	void SeqLoaderOnline();
	void SeqResetRecvInterface();
	void SeqResetSendInterface();
	int  GetPortNo();
	int  GetSlotNo();
	BOOL GlassDataCheck();
};

#endif // !defined(AFX_INTERFACESEQ_H__C66433C0_DF8C_4A64_A326_C5DC74F263D0__INCLUDED_)
