// MainSeq.cpp: implementation of the CMainSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "MainSeq.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMainSeq::CMainSeq()
{

}

CMainSeq::~CMainSeq()
{

}


void CMainSeq::SeqInit()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	static int nReturnSeqNo = 0;
	static DWORD dwTickStart = 0;

	// Use for alarm reset
	static int nAlarmId[MAX_UNIT_NO] = { 0, };
	CString sSeqName( "SeqInit    " );
	int tm = TM_SEQ_INIT;
	
	int nSeqNo = m_nSeqInitNo;
	
	switch( nSeqNo )
	{
	case 0 :
		if( m_pDicsData->m_GenInfo.bEqpInitReq )
		{
			dwTickStart = GetTickCount();
			nSeqNo = 100;
		}
		break;
	case 10 :
		if( m_pDicsData->m_GenInfo.bEqpInitReq )
		{
			dwTickStart = GetTickCount();
			nSeqNo = 200;
		}
		break;
	case 100 :
		if( ( GetTickCount() - dwTickStart ) > 100 )
		{
			m_pDicsData->m_GenInfo.bEqpInitComp = FALSE;

			m_pDicsView->m_pCimSeq->m_SeqFlag.bInitReq		= TRUE;
			m_pDicsView->m_pEqpStateSeq->m_SeqFlag.bInitReq = TRUE;
			m_pDicsView->m_pPumpSeq->m_SeqFlag.bInitReq		= TRUE;
			
//			m_pDicsView->m_pTrSeq->m_SeqFlag.bInitReq		= TRUE;
			m_pDicsView->m_pCvSeq->m_SeqFlag.bInitReq		= TRUE;
//#ifndef _NO_RB
			for( int i=0; i<MAX_RB_GAP_SERVO_NO; i++ )
			{
				m_pDicsView->m_pRbSeq->m_SeqFlag.bInitReq[i]	= TRUE;
			}
//#endif
//			m_pDicsView->m_pLoaderSeq->m_SeqFlag.bInitReq	= TRUE;
#ifndef _NO_EUV
			m_pDicsView->m_pEuvSeq->m_SeqFlag.bInitReq = TRUE;
#endif		
			int nInitTimeout = 10 * atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupEQP_INITIAL_TIME] );
			TIMER_ON( tm, nInitTimeout );
	
			dwTickStart = GetTickCount();
			nSeqNo = 300;
		}
		break;
	case 200 :
		if( ( GetTickCount() - dwTickStart ) > 100 )
		{
			m_pDicsData->m_GenInfo.bEqpInitComp = FALSE;
			
//			if( m_pDicsView->m_pCimSeq->m_SeqFlag.bInitFail )
//				m_pDicsView->m_pCimSeq->m_SeqFlag.bInitReq		= TRUE;

			if( m_pDicsView->m_pEqpStateSeq->m_SeqFlag.bInitFail )
				m_pDicsView->m_pEqpStateSeq->m_SeqFlag.bInitReq = TRUE;
	
			if( m_pDicsView->m_pPumpSeq->m_SeqFlag.bInitFail )
			{
				m_pDicsView->m_pPumpSeq->m_SeqFlag.bInitReq		= TRUE;
			}

//			if( m_pDicsView->m_pTrSeq->m_SeqFlag.bInitFail )
//				m_pDicsView->m_pTrSeq->m_SeqFlag.bInitReq		= TRUE;

			if( m_pDicsView->m_pCvSeq->m_SeqFlag.bInitFail )
				m_pDicsView->m_pCvSeq->m_SeqFlag.bInitReq		= TRUE;

//#ifndef _NO_RB
			for( int i=0; i<MAX_RB_GAP_SERVO_NO; i++ )
			{
				if( m_pDicsView->m_pRbSeq->m_SeqFlag.bInitFail[i] )
					m_pDicsView->m_pRbSeq->m_SeqFlag.bInitReq[i]		= TRUE;
			}
//#endif

#ifndef _NO_EUV
			if( m_pDicsView->m_pEuvSeq->m_SeqFlag.bInitFail )
				m_pDicsView->m_pEuvSeq->m_SeqFlag.bInitReq = TRUE;
#endif		
//			if( m_pDicsView->m_pLoaderSeq->m_SeqFlag.bInitFail )
//				m_pDicsView->m_pLoaderSeq->m_SeqFlag.bInitReq = TRUE;

			int nInitTimeout = 10 * atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupEQP_INITIAL_TIME] );
			TIMER_ON( tm, nInitTimeout );
	
			dwTickStart = GetTickCount();
			nSeqNo = 300;
		}
		break;
	case 300 :
		if( ( GetTickCount() - dwTickStart ) > 500 )
		{
			BOOL bInitFail = FALSE;
			bInitFail |= m_pDicsView->m_pEqpStateSeq->m_SeqFlag.bInitFail;
			bInitFail |= m_pDicsView->m_pPumpSeq->m_SeqFlag.bInitFail;
//			bInitFail |= m_pDicsView->m_pTrSeq->m_SeqFlag.bInitFail;
			bInitFail |= m_pDicsView->m_pCvSeq->m_SeqFlag.bInitFail;
//#ifndef _NO_RB
			for( int i=0; i<MAX_RB_GAP_SERVO_NO; i++ )
			{
				bInitFail |= m_pDicsView->m_pRbSeq->m_SeqFlag.bInitFail[i];
			}
//#endif
//			bInitFail |= m_pDicsView->m_pLoaderSeq->m_SeqFlag.bInitFail;
#ifndef _CIM_SKIP
			bInitFail |= m_pDicsView->m_pCimSeq->m_SeqFlag.bInitFail;
#endif
#ifndef _NO_EUV
			bInitFail |= m_pDicsView->m_pEuvSeq->m_SeqFlag.bInitFail;
#endif		

			BOOL bInitComp = TRUE;
			bInitComp &= m_pDicsView->m_pEqpStateSeq->m_SeqFlag.bInitComp;
			bInitComp &= m_pDicsView->m_pPumpSeq->m_SeqFlag.bInitComp;
//			bInitComp &= m_pDicsView->m_pTrSeq->m_SeqFlag.bInitComp;
			bInitComp &= m_pDicsView->m_pCvSeq->m_SeqFlag.bInitComp;
//#ifndef _NO_RB
			for( int i=0; i<MAX_RB_GAP_SERVO_NO; i++ )
			{
				bInitComp &= m_pDicsView->m_pRbSeq->m_SeqFlag.bInitComp[i];
			}
//#endif
//			bInitComp &= m_pDicsView->m_pLoaderSeq->m_SeqFlag.bInitComp;
#ifndef _CIM_SKIP
//			bInitComp &= m_pDicsView->m_pCimSeq->m_SeqFlag.bInitComp;
#endif
#ifndef _NO_EUV
			bInitComp &= m_pDicsView->m_pEuvSeq->m_SeqFlag.bInitComp;
#endif		

			if( bInitFail )
			{
				SetLog( sSeqName, 0, 0, "INITIALIZE : FAILED" );
				nSeqNo = 1000;				
			}
			else if( bInitComp )
			{
				m_pDicsData->m_GenInfo.bEqpInitReq	= FALSE;
				m_pDicsData->m_GenInfo.bEqpInitComp	= TRUE;

				SetLog( sSeqName, 0, 0, "INITIALIZE : COMPLETE" );
				nSeqNo = 0;
			}
		}
		break;
	case 1000 :
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			m_pDicsData->m_GenInfo.bEqpInitReq  = FALSE;

			SetLog( sSeqName, 0, 0, "ALARM RESET" );
			nSeqNo = 10;
		}
		break;
	}
	m_nSeqInitNo = nSeqNo;
}

void CMainSeq::SetRecipe2JobCond(CString sRecipeId)
{
	CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();

	CString sBuf;
	sBuf.Format( "Recipe = %s", sRecipeId );
	SetLog( "Rcp2Job ", 0, 0, sBuf );

	int nRow = pDoc->GetRowfromID( sRecipeId );
	if( nRow > -1 )
	{			
		m_pDicsData->m_JobCond.nTactTime
			= atoi( pDoc->m_pRecipeInfo[nRow].sValue[CDaoRecipeSet::rcpTACT_TIME] );
		sBuf.Format( "Tact Time = %d", m_pDicsData->m_JobCond.nTactTime );
		SetLog( "Rcp2Job ", 0, 0, sBuf );

		m_pDicsData->m_JobCond.nCvSpeed
			= atoi( pDoc->m_pRecipeInfo[nRow].sValue[CDaoRecipeSet::rcpCV_SPEED] );
		sBuf.Format( "CV Speed = %d", m_pDicsData->m_JobCond.nCvSpeed );
		SetLog( "Rcp2Job ", 0, 0, sBuf );

		m_pDicsData->m_JobCond.bJobProcessUse
				=( pDoc->m_pRecipeInfo[nRow].sValue[CDaoRecipeSet::rcpJOB_PROCESS] == "ON" ? 1 : 0 );
		sBuf.Format( "Job Process = %d", m_pDicsData->m_JobCond.bJobProcessUse );
		SetLog( "Rcp2Job ", 0, 0, sBuf );

		for( int i = 0 ; i < MAX_RB_GAP_SERVO_NO ; i ++ )
		{
			m_pDicsData->m_JobCond.dRbGap[i] =
				atof( pDoc->m_pRecipeInfo[nRow].sValue[CDaoRecipeSet::rcpSWR2_UP_RB1_GAP + i] );
		}
		for( int i = 0 ; i < MAX_RB_NO ; i ++ )
		{
			m_pDicsData->m_JobCond.bRbUse[i] = 
				( pDoc->m_pRecipeInfo[nRow].sValue[CDaoRecipeSet::rcpSWR2_UP_RB1_USE + i] == "ON" ? 1 : 0 );
			
			m_pDicsData->m_JobCond.bRbDir[i]	= 
				( pDoc->m_pRecipeInfo[nRow].sValue[CDaoRecipeSet::rcpSWR2_UP_RB1_DIR + i] == "CW" ? 1 : 0 );
			
			m_pDicsData->m_JobCond.nRbSpeed[i] =
				atoi( pDoc->m_pRecipeInfo[nRow].sValue[CDaoRecipeSet::rcpSWR2_UP_RB1_SPEED + i] );
		}

		for( int i=IF_UNIT_LD; i<IF_UNIT_UL; i++ )
		{
			m_pDicsData->m_JobCond.nCvSpeedSet[i][CJobCond::speedNORMAL] //= atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUP_CV_NORMAL_SPEED] );
				= m_pDicsData->m_JobCond.speedNORMAL;
			m_pDicsData->m_JobCond.nCvSpeedSet[i][CJobCond::speedACC] = 
				atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_CV_ACCEL_SPEED] );
			m_pDicsData->m_JobCond.nCvSpeedSet[i][CJobCond::speedDEC] =
				atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_CV_DECEL_SPEED] );
		}

		for( int i=IF_UNIT_LD; i<MAX_CV_NO; i++ )
		{
			m_pDicsData->m_JobCond.nCvSpeedSet[i][CJobCond::speedNORMAL] = m_pDicsData->m_JobCond.nCvSpeed;
			m_pDicsData->m_JobCond.nCvSpeedSet[i][CJobCond::speedACC] = m_pDicsData->m_JobCond.nCvSpeed;

			if( i == IF_UNIT_BUF || i == IF_UNIT_UL )
			{
				m_pDicsData->m_JobCond.nCvSpeedSet[i][CJobCond::speedACC] = 
					atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_CV_ACCEL_SPEED] );

				m_pDicsData->m_JobCond.nCvSpeedSet[i][CJobCond::speedDEC] = 
					atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_CV_DECEL_SPEED] );
			}
			else
			{
				m_pDicsData->m_JobCond.nCvSpeedSet[i][CJobCond::speedDEC] = m_pDicsData->m_JobCond.nCvSpeed;
			}
		}

		// Set the recipe information
		Msg( WM_SET_RECIPE, 0, (LPARAM)(LPCTSTR)sRecipeId );
	}
}


void CMainSeq::GetProfileGlassData()
{
	int nGlassPos = 0;
	int nOutUnitNo = 0;
#ifndef _NO_UL_HAND
	nOutUnitNo = IF_UNIT_UL_HAND;
#else
	nOutUnitNo = IF_UNIT_UL;
#endif

	for( int i = 0 ; i < 2 ; i ++ )
	{
		for( int j = 0 ; j < MAX_IF_NO ; j ++ )
		{
// 101214 halesu
#ifndef _NO_UL_HAND	
			if( i == 1 && j == nOutUnitNo )
#else
			if( j > nOutUnitNo )
#endif
				continue;
			
			nGlassPos = j * 2 + i;
			m_pDicsData->GetProfileGlassData( nGlassPos );

			// 0 1 2
			// 1 0 3 => 0 : 1̸ Glass ְ 0̸ Glass .
			//			2 : 03 Glass No
			BOOL bIsValid = m_pDicsData->m_GlsInfo[nGlassPos].bIsValid;
			if( bIsValid )
			{
				m_pDicsData->m_GenInfo.nGlassNo += 1;
				Msg( WM_GLASS_NO, m_pDicsData->m_GenInfo.nGlassNo, 0L );

				// Show the glass
				int nGlassNo = m_pDicsData->m_GlsInfo[nGlassPos].nGlassNo;
				m_pGlassAni->StartGlassMove( nGlassNo );
//				m_pGlassAni->GlassMoveRegion( nGlassNo, nGlassPos );

				m_pGlassAni->GlassMoveRegion( nGlassNo, nGlassPos );
			}
		}
	}
}

void CMainSeq::InitParameter()
{
	m_nSeqRecoveryNo		= 0;
	m_nSeqCleanOutModeNo	= 0;

	// Reset the timer pause flag
	m_pTimer->RePlayTimer();


//	if( !m_pDicsData->m_GenInfo.bEqpInitComp )
//	{
//		m_pDicsData->m_GenInfo.bEqpInitReq = FALSE;
//	}

    m_pDicsData->m_GenInfo.nMaxEqpGlassNo = atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupMAX_GLASS_NO] );
	if ( m_pDicsData->m_GenInfo.nMaxEqpGlassNo > MAX_EQP_GLASS_NO ) m_pDicsData->m_GenInfo.nMaxEqpGlassNo = MAX_EQP_GLASS_NO;
}
