// PlasmaSequence.h: interface for the PlasmaSequence class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PLASMASEQUENCE_H__6D1A0D69_6480_49DA_ADCC_2A99BC581EE5__INCLUDED_)
#define AFX_PLASMASEQUENCE_H__6D1A0D69_6480_49DA_ADCC_2A99BC581EE5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\X\XSequence.h"
#include "..\X\XTimer.h"
#include "..\DicsData.h"
#include "..\View\SetupItems.h"
#include "EqpStateSequence.h"
#include "..\X\XCtlDevice.h"
#include "..\FactoryLib\EqpAssy.h"

class CPlasmaSequence : public XSequence
{
public:
	
	CSetupItems*		m_pSetupItems;
	XTimer*				m_pTimer;
	CDicsData*			m_pDicsData;
	CEqpStateSequence*	m_pEqpStateSeq;
	CDicsView*			m_pDicsView;
	XCtlDevice*			m_pDevice;
	CEqpAssy*			m_pEqpAssy;
	
	void SetSetupItems( CSetupItems* pSetupItems )				{ m_pSetupItems = pSetupItems; }
	void SetDicsData( CDicsData* pData )						{ m_pDicsData = pData; }
	void SetEqpStateSequence(CEqpStateSequence* pEqpStateSeq)	{ m_pEqpStateSeq = pEqpStateSeq; }
	void SetDevice( XCtlDevice* pDevice )						{ m_pDevice = pDevice; }
	void SetDicsView( CDicsView *pView )						{ m_pDicsView = pView;	}
	void SetSeqTimer( XTimer* pTimer )							{ m_pTimer = pTimer; }
	void SetEqpAssy( CEqpAssy* pEqpAssy )						{ m_pEqpAssy = pEqpAssy; }
public:

	CString m_sMessage;
	int m_nSeqPlasamProgressNo;
	int m_nSeqPlasmaAlarmNo;
	int m_nSeqInitNo;

	void SeqPlasamProgress( BOOL bPlasmaPorgress);
	void SetDebugState();
	void SeqPlasmaAlarm();
	BOOL IsGlassExist();
	void SetOwnerPointer(CWnd* pWnd);
	BOOL IsPlasmaUse();
	int GetPlasmaAlarm();
	BOOL GetHouseCloseState();

	void SetPlasmaPowerSupply( int nPower );
	void SetGasFlow( int nGaugeNo, float fFlowRate );
	void SeqPlasma();
	BOOL GetPlasmaStatus();
	void SeqInit();
	int m_nPlasmaAlarmAddress[4];

	struct tagSeqFlag
	{
		BOOL bInitReq;					// if initialized, it's TRUE 
		BOOL bInitComp;					// if initialized, it's TRUE 
		BOOL bInitFail;
	} m_SeqFlag;

	enum _GAUGE_VALUE
	{
		flowN2,
		flowCDA,
		supKv,
		supPOWER,
		pressN2,
		pressCDA,
		pressUTCDA,
		pressUTPCW,
		flowUTPCW,
	}; 

	enum euvALARMINDEX
	{	// GS 
		plasmaAlmInterlockErr	 = 0, 
		plasmaAlmInverterErr	 = 1, 
		plasmaAlmLowVoltageErr   = 2, 
		plasmaAlmHighVoltageErr  = 3, 
		plasmaAlmArcFault		 = 4, 
		plasmaAlmLocalModeRunErr = 5, 
		plasmaAlmOnFaultErr		 = 6, 
		plasmaNoAlm				 = 7, 
	};
		
	BOOL	m_bPlasmaPowerOff;
	BOOL	m_bPlasmaPowerOn;
	BOOL	m_bHighPowerMonitor;
	BOOL	m_bLowPowerMonitor;	
	BOOL	m_bApAlarm;
	BOOL	m_bPlasmaStatusOn;
	float	m_fFlowRate; 
	float	m_fReflectedReal;	
	float	m_fForwardReal;  
    int		m_nSeqPlasmaNo;
	int     m_nSeqPowerMointorNo;
	int     m_nSeqGasMointorNo;
	void	InitParameter();
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );
	BOOL	Initialize();
	BOOL	Sequence();
	CPlasmaSequence();
	virtual ~CPlasmaSequence();
};

#endif // !defined(AFX_PLASMASEQUENCE_H__6D1A0D69_6480_49DA_ADCC_2A99BC581EE5__INCLUDED_)
