// PumpSeq.h: interface for the CPumpSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PUMPSEQ_H__5A8F77A1_8F07_424B_BC7D_E10AC698E09D__INCLUDED_)
#define AFX_PUMPSEQ_H__5A8F77A1_8F07_424B_BC7D_E10AC698E09D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\MOTHER\DicsPumpSeq.h"

class CPumpSeq : public CDicsPumpSeq  
{
public:
	CPumpSeq();
	virtual ~CPumpSeq();

	enum tankLEVEL	{ /*lvLL,*/ lvL, lvM, lvH, lvHH, lvMAX };  // SanghoCho 2015.04.15
	void InitParameter();
	BOOL Initialize();

protected:
	int m_nSeqInitNo;
	int m_nSeqGearSupplyNo;
	int m_nSeqMistShowerNo;
	int m_nSeqFrShowerNo;  // SanghoCho 2015.04.20	// SWR4
	int m_nSeqSbjDiShowerNo;	// SWR1 SBJ DI
	int m_nSeqPumpOutValveNo[MAX_DI_TANK_NO];
	int m_nSeqRbDirectValveNo[MAX_DI_TANK_NO];
	int m_nSeqCleaningModeCtrlNo;
	int m_nSeqSWR1BathdrainNTankReturnNo;
	float m_fDebugTankLevel;
	
//	void SeqGearSupply();
	void SeqAirKnife();
	BOOL Sequence();
	BOOL GetLevelSensorFault( int nTankNo );  // SanghoCho 2015.04.21
	void SeqDiPump( int nPumpNo );
	void SeqDiPumpWithBufTank( int nPumpNo );
	void SeqSbj(int nSbjNo);
	void SeqInit();
	void SeqLevelSensor( int nTankNo, int nSensorNo );
	void SeqGlassExist();
	void SeqDiwIdleRunning();
	void SeqDiTank(int nTankNo);
	void SeqMistShower();
	void SeqDiPumpInterlock(int nDiNo);
	void SeqGearValve();
	void SeqFrShower();		// SWR4 FR DI
	void SeqSbjDiShower();	// SWR1 SBJ DI
	void SeqPumpOutValve( int nTankNo );
	void SeqRbDirectValve( int nTankNo );
	void SeqIonizer( int nIonNo );	// SanghoCho 2015.05.22
	void SeqCleaningModeCtrl();
	void SeqSWR1BathDrainNTankReturn();
};

#endif // !defined(AFX_PUMPSEQ_H__5A8F77A1_8F07_424B_BC7D_E10AC698E09D__INCLUDED_)
