// RbSeq.cpp: implementation of the CRbSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RbSeq.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRbSeq::CRbSeq()
{
	for( int i=0; i<MAX_RB_NO; i++ ) 
	{
		m_nSeqInitNo[i] = 0;
	}
	for( int i=0; i<MAX_MUX10; i++ )
	{
		m_nSeqCommMux[i] = 0;
	}
	m_pMuxCom = NULL;
	m_pMuxCom2 = NULL;
}

CRbSeq::~CRbSeq()
{

}

BOOL CRbSeq::Sequence()
{
	Sleep( 10 );

	for( int i=0; i<MAX_RB_NO; i++ ) 
	{
		SeqInit( i );
		SeqRbMotorControl( i );
		SeqRbMotorCond( i );
	}
	for( int i = 0 ; i < MAX_RB_GAP_SERVO_NO ; i ++ )
	{
		SeqRbGapControl( i );
	}
	for( int i=0; i<MAX_MUX10; i++)
	{
		SeqCommMux(i);
	}	
	return TRUE;
}

//---------------------------------------------------------------------------
// - SeqRbMotorControl
//---------------------------------------------------------------------------
void CRbSeq::SeqRbMotorControl(int nRbNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif


/////////////////////////////////////////////////////////////////////////////
// bInit : Wait for Initialize Device 
/////////////////////////////////////////////////////////////////////////////
	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();
	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 2000 )	bInit = TRUE;
		if( !bInit ) return;
	}
/////////////////////////////////////////////////////////////////////////////	

	int i = nRbNo;	

#ifndef _MY_DEBUG
	double dGain = 0.2;
#else
	double dGain = 0.5;
#endif

	m_RbMotor.nRefRbVelocity[i] = SetRbSpeed( i );

	// Get Error Value
	m_RbMotor.dErrRbVelocity[i] = m_RbMotor.nRefRbVelocity[i] - m_RbMotor.dCurRbVelocity[i];
	
//	CString strTemp;
//	strTemp.Format("RBVel =%.2f, RBVel=%.2f, CurRBVel=%.2f", m_RbMotor.dErrRbVelocity[i], m_RbMotor.nRefRbVelocity[i], m_RbMotor.dCurRbVelocity[i]);
//	SetLog( "RBTEST", 0, 0, strTemp );

	if( ABS( m_RbMotor.dErrRbVelocity[i] ) < 1. /*&& ABS( m_RbMotor.dCurRbVelocity[i] ) < 1.*/ ) 
		m_RbMotor.dErrRbVelocity[i] = 0.;	

	if( m_RbMotor.dErrRbVelocity[i] != 0. ) // +/- 10 rpm
	{
		double dProperty;
		dProperty = dGain * m_RbMotor.dErrRbVelocity[i];
		
		if( ABS( dProperty ) > 5.0 ) 
		{
			if( dProperty > 0 ) dProperty = 5.0;
			else dProperty = -5.0;
		}
		
		m_RbMotor.dCurRbVelocity[i] = m_RbMotor.dCurRbVelocity[i] + dProperty;
		
		if( m_RbMotor.dCurRbVelocity[i] > 0 ) 
		{
			m_pEqpAssy->m_RbMotor.SetMotorFw(i, ON);
			m_pEqpAssy->m_RbMotor.SetMotorBw(i, OFF);
		}
		else
		{
			m_pEqpAssy->m_RbMotor.SetMotorFw(i, OFF);
			m_pEqpAssy->m_RbMotor.SetMotorBw(i, ON);
		}
		int nVal = ( int )ABS( m_RbMotor.dCurRbVelocity[i] );
		m_pEqpAssy->m_RbMotor.SetMotorRpm( i , nVal );
		
		//TRACE( "%d %f\r\n", i, m_dCurRbVelocity[i] );
	}
	else if( m_RbMotor.nRefRbVelocity[i] == 0 )
	{
		m_pEqpAssy->m_RbMotor.SetMotorFw(i, OFF);
		m_pEqpAssy->m_RbMotor.SetMotorBw(i, OFF);
	}
}

void CRbSeq::SeqRbMotorCond( int nRbNo )
{
/////////////////////////////////////////////////////////////////////////////
// bInit : Wait for Initialize Device 
/////////////////////////////////////////////////////////////////////////////
	static BOOL bInit = FALSE;
	static DWORD dwStartTick = GetTickCount();
	if( !bInit )
	{
		if( GetTickCount() - dwStartTick > 2000 )	bInit = TRUE;
		if( !bInit ) return;
	}
/////////////////////////////////////////////////////////////////////////////	
				
	if( m_pDicsData->m_GenInfo.bEqpInitComp )
	{
		BOOL bUse = IsRbUse( nRbNo );
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_RbMotor.GetMotorAlarm( nRbNo ) && bUse ) 
#else
		if( FALSE )
#endif
		{
			m_RbMotor.bRbMotorCond[nRbNo] = FALSE;
//#ifndef _NO_RB
			if( !m_pEqpStateSeq->IsAlarm( ALM_RB_FBL_MOTOR_DRIVER_ALARM1 + nRbNo ) )
			{
				m_pEqpStateSeq->SetAlarm( ALM_RB_FBL_MOTOR_DRIVER_ALARM1 + nRbNo );
			}
//#endif
		}
#ifndef _MY_DEBUG
		else if( m_pEqpAssy->m_RbMotor.GetMotorCpAlarm( nRbNo ) && bUse ) 
#else
		else if( FALSE )
#endif
		{
			m_RbMotor.bRbMotorCond[nRbNo] = FALSE;
//#ifndef _NO_RB
			if( !m_pEqpStateSeq->IsAlarm( ALM_RB_FBL_MOTOR_CP_OFF1 + nRbNo ) )
			{
				m_pEqpStateSeq->SetAlarm( ALM_RB_FBL_MOTOR_CP_OFF1 + nRbNo );
			}
//#endif
		}
		else if( m_RbMotor.bRbMotorCond[nRbNo] != TRUE && m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			m_RbMotor.bRbMotorCond[nRbNo] = TRUE;
//#ifndef _NO_RB
			if( m_pEqpStateSeq->IsAlarm( ALM_RB_FBL_MOTOR_DRIVER_ALARM1 + nRbNo ) )
			{
				m_pEqpStateSeq->ResetAlarm( ALM_RB_FBL_MOTOR_DRIVER_ALARM1 + nRbNo );
			}
			if( m_pEqpStateSeq->IsAlarm( ALM_RB_FBL_MOTOR_CP_OFF1 + nRbNo ) )
			{
				m_pEqpStateSeq->ResetAlarm( ALM_RB_FBL_MOTOR_CP_OFF1 + nRbNo );
			}
//#endif
		}
	}	
}

//---------------------------------------------------------------------------
// - SetRbSpeed
//---------------------------------------------------------------------------
int CRbSeq::SetRbSpeed( int nRbNo )
{
//	if( !m_pDicsData->m_GenInfo.bEqpInitComp && m_pDicsData->m_GenInfo.bAuto) return 0;//2008.10.10 kimgun
	static BOOL bManualModeChangeComp[MAX_RB_NO] = { FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE };
	int nRbSpeed;
	
	BOOL bRun = TRUE;
	bRun &= !m_pDicsData->m_GenInfo.bEmo;
	bRun &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bRun &= !m_pDicsData->m_GenInfo.bCoverOpen;
//	bRun &= !m_pDicsData->m_GenInfo.bDoorOpen;
	
#ifndef _MY_DEBUG
	bRun &= !m_pEqpAssy->m_RbMotor.GetMotorAlarm( nRbNo );
	bRun &= !m_pEqpAssy->m_RbMotor.GetMotorCpAlarm(nRbNo);
#endif


	if( !m_pDicsData->m_GenInfo.bAuto )
	{
		if( !bRun || !bManualModeChangeComp[nRbNo] )
		{
			bManualModeChangeComp[nRbNo] = TRUE;
			nRbSpeed = 0;
		}
		else
		{
			nRbSpeed = m_RbMotor.nRefRbVelocity[nRbNo];		
		}
	}
	else
	{
		bManualModeChangeComp[nRbNo] = FALSE;

/*		bRun &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupJOB_MODE]; -->08HC06
		bRun &= !IsRbPumpAlarm( nRbNo );
		bRun &= IsRbPumpUse( nRbNo );
		bRun &= m_pDicsData->m_IfPump.bDiStart;                                  -->08HC06
		bRun &=	!m_pDicsData->m_GenInfo.bPause;
//		bRun &= !m_pDicsData->m_IfFlag[IF_UNIT_RB-1].bSeqStop;
		bRun &=	!m_pDicsData->m_SeqFlag.bStopCount2;
//		bRun &= !m_pDicsView->m_pMainSeq->m_IfFlag[IF_UNIT_RB].bGageFault; */

		if( m_pDicsData->m_JobCond.bJobProcessUse )
		{
			if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE + (nRbNo/MAX_RB_PART )])
			{
				bRun &= !IsRbPumpAlarm( nRbNo );
				bRun &= IsRbPumpUse( nRbNo );
			}

			bRun &= m_pDicsData->m_IfPump.bDiStart;
			bRun &=	!m_pDicsData->m_GenInfo.bPause;
			bRun &=	!m_pDicsData->m_SeqFlag.bStopCount2;
		}
		else
		{
			bRun &= !m_pDicsData->m_GenInfo.bIdleRunning;
			bRun &=	!m_pDicsData->m_GenInfo.bPause;
			bRun &=	!m_pDicsData->m_SeqFlag.bStopCount2;
		}
//		bRun &= m_pDicsData->m_GenInfo.bEqpInitComp;
		
		BOOL bCvStop = FALSE;
 		for( int i = IF_UNIT_SWR1; i<= IF_UNIT_UL; i++ )
 		{
 			bCvStop |= m_pDicsData->m_IfFlag[i].bInError;
 			bCvStop |= m_pDicsData->m_IfFlag[i].bOutError;
 			bCvStop |= m_pDicsData->m_GenInfo.bAkInterlock;
 			bCvStop |= m_pDicsData->m_GenInfo.bUlNotReady;	
 		}
		bRun &= !bCvStop;

		if( !bRun )
		{
			nRbSpeed = 0;
		}
		else if( m_pDicsData->m_GenInfo.bIdleRunning )
		{
			if( !m_pSetupItems->m_nValueIdleRun[CSetupItems::idleDIW_ZONE_USE] )
			{
				nRbSpeed = 0;
			}
			else
			{
				int nCW  = m_pSetupItems->m_nValueIdleRun[CSetupItems::idleSWR2_UPPER_RB1_DIR + nRbNo];
				nRbSpeed = ( nCW ? 1:-1 ) * m_pSetupItems->m_nValueIdleRun[CSetupItems::idleSWR2_UPPER_RB1_SPEED + nRbNo];
			}
		}
		else 
		{
			BOOL bUse = IsRbUse( nRbNo );
			if( !bUse )
			{
				nRbSpeed = 0;
			}
			else
			{
				int nCW  = m_pDicsData->m_JobCond.bRbDir[nRbNo];
				nRbSpeed =  ( nCW ? 1:-1 ) * ( m_pDicsData->m_JobCond.nRbSpeed[nRbNo]);

			}
		}
	}
	return nRbSpeed;
}

BOOL CRbSeq::IsRbUse( int nRbNo )
{
	BOOL bUse = TRUE;
//	bUse &= m_pDicsData->m_JobCond.bRbUse[nRbNo];	// hskwak 191010 Wait Position RB   .
	bUse &= ( ( m_pDicsData->m_JobCond.bJobProcessUse==0 ) ? FALSE : TRUE );
	if( m_pDicsData->m_JobCond.bJobProcessUse )
	{
		if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+ (nRbNo/MAX_RB_PART)])
		{
			bUse &= IsRbPumpUse( nRbNo );
		}
	}

	switch( m_nServoMode )
	{
	case servoUP_ONLY:
//#ifndef _NO_RB		// 20100719 ssm
		if( nRbNo%2 == 0 )
			bUse &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupSWR2_RB_SERVO1_USE+(nRbNo/2)];
//#endif		
		break;
	case servoBOTH:
//#ifndef _NO_RB		// 20100719 ssm
		bUse &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupSWR2_RB_SERVO1_USE+nRbNo];
//#endif
		break;
	}

	return bUse;
}

void CRbSeq::SeqInit( int nRbNo )
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	static int nAlarmId[MAX_RB_GAP_SERVO_NO] = { 0, };
	static DWORD dwStartTickCount[MAX_RB_GAP_SERVO_NO];
	static BOOL bServoUse[MAX_RB_GAP_SERVO_NO] = {FALSE,};

	int nRv = -1;
	int tm = TM_SEQ_INIT_RB(nRbNo);	// ִ 10  ǹǷ Ȯ ʿ.
	int nInitTimeout = atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupEQP_INITIAL_TIME] );
	int nSeqNo = m_nSeqInitNo[nRbNo];

	CString sSeqName( "INIT    " );

	if( m_SeqFlag.bInitComp[nRbNo] ) return;

	switch( nSeqNo )
	{
	case 0:
		if(m_SeqFlag.bInitReq[nRbNo])
		{
			m_SeqFlag.bInitReq[nRbNo] = FALSE;
			m_SeqFlag.bInitComp[nRbNo] = FALSE;
			m_SeqFlag.bInitFail[nRbNo] = FALSE;

			bServoUse[nRbNo]  = m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupSWR2_RB_SERVO1_USE+nRbNo] ? 1 : 0;

			nSeqNo = 10;
		}
		break;

	case 10:
		{
			m_sMessage.Format("%2d%d", CDicsData::initSWR2_RB_UP1_SERVO+nRbNo, MSG_STATUS_START );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
			
			SetLog( sSeqName, 0, 0, m_sMessage );
			TIMER_ON( tm, 20 ); // 2 sec
			nSeqNo = 20;
		}
		break;	
	case 20:
		if( m_pMmc->EStopRbt( SWR2_RBT_RB_UNIT_UP_RB1_UNIT+nRbNo ) )
		{
			m_sMessage.Format("%2d%d", CDicsData::initSWR2_RB_UP1_SERVO+nRbNo, MSG_STATUS_SERVO_ESTOP );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

			m_sMessage.Format( "R/B%d servo motor E-stop OK", nRbNo + 1 );
			SetLog( sSeqName, 0, 0, m_sMessage );

			m_sMessage.Format("%2d%d", CDicsData::initSWR2_RB_UP1_SERVO+nRbNo, MSG_STATUS_START );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

			TIMER_ON( tm, 20 ); // 2 sec				

			nSeqNo = 30;
		}
		else if( TIMER( tm ) )
		{
			m_sMessage.Format("%2d%d", CDicsData::initSWR2_RB_UP1_SERVO+nRbNo, MSG_STATUS_NG );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
//#ifndef _NO_RB
			nAlarmId[nRbNo] = ALM_SWR2_RB_UNIT_UP_RB1_SERVO_ALARM + nRbNo;
//#endif
			m_sMessage.Format( "R/B%d servo motor E-stop Error", nRbNo + 1 );
			
			m_pEqpStateSeq->SetAlarm( nAlarmId[nRbNo] );

			SetLog( sSeqName, 0, 0, m_sMessage );

			m_SeqFlag.bInitFail[nRbNo] = TRUE;

			nSeqNo = 1000;
		}
		break;

	case 30 :
		if( !bServoUse[nRbNo] || 
		  ( m_pMmc->ResetRbt( SWR2_RBT_RB_UNIT_UP_RB1_UNIT+nRbNo ) > 0 && 
		    m_pMmc->m_bServoReady[SWR2_RBT_RB_UNIT_UP_RB1_UNIT+nRbNo] ) ) 
		{
			m_sMessage.Format("%2d%d", CDicsData::initSWR2_RB_UP1_SERVO+nRbNo, MSG_STATUS_SERVO_RESET );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
 
			if( bServoUse[nRbNo] )	m_sMessage.Format( "R/B%d servo motor reset OK", nRbNo + 1 );
			else					m_sMessage.Format( "R/B%d servo motor reset Skip", nRbNo + 1 );
			SetLog( sSeqName, 0, 0, m_sMessage );

			m_sMessage.Format("%2d%d", CDicsData::initSWR2_RB_UP1_SERVO+nRbNo, MSG_STATUS_START );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

			dwStartTickCount[nRbNo] = GetTickCount();
		
			nSeqNo = 40;
		}
		else if( TIMER( tm ) )
		{
			m_sMessage.Format("%2d%d", CDicsData::initSWR2_RB_UP1_SERVO+nRbNo, MSG_STATUS_NG );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
//#ifndef _NO_RB	
			nAlarmId[nRbNo] = ALM_SWR2_RB_UNIT_UP_RB1_SERVO_ALARM + nRbNo;
//#endif
			m_sMessage.Format( "R/B%d servo motor Reset Error", nRbNo + 1 );

			m_pEqpStateSeq->SetAlarm( nAlarmId[nRbNo] );

			SetLog( sSeqName, 0, 0, m_sMessage );

			m_SeqFlag.bInitFail[nRbNo] = TRUE;
			
			nSeqNo = 1000;
		}
		break;

	case 40:
		if( GetTickCount() - dwStartTickCount[nRbNo] > 500 )
		{
			TIMER_ON( tm, 100 );
			nSeqNo = 50;
		}
		break;

	case 50:
		if(( !bServoUse[nRbNo] || 
		  ( nRv = m_pMmc->MoveRbtHome( SWR2_RBT_RB_UNIT_UP_RB1_UNIT+nRbNo ) ) == 0 ) ) 
		{
			m_sMessage.Format("%2d%d", CDicsData::initSWR2_RB_UP1_SERVO+nRbNo, MSG_STATUS_OK );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

			if( bServoUse[nRbNo] )	m_sMessage.Format( "R/B servo motor%d Homing OK", nRbNo + 1 );
			else			m_sMessage.Format( "R/B servo motor%d Homing Skip", nRbNo + 1 );
			SetLog( sSeqName, 0, 0, m_sMessage );
			
			dwStartTickCount[nRbNo] = GetTickCount();
			TIMER_ON( tm, 10 ); // 1 sec
			nSeqNo = 60;
		}
		else if( nRv > 0 && TIMER( tm ) )
		{
			m_sMessage.Format("%2d%d", CDicsData::initSWR2_RB_UP1_SERVO+nRbNo, MSG_STATUS_NG );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
//#ifndef _NO_RB
			nAlarmId[nRbNo] = ALM_SWR2_RB_UNIT_UP_RB1_SERVO_HOME + nRbNo;
//#endif
			m_sMessage.Format( "R/B Servo motor%d homing error", nRbNo + 1 );
			m_pEqpStateSeq->SetAlarm( nAlarmId[nRbNo] );

			SetLog( sSeqName, 0, 0, m_sMessage );

			m_SeqFlag.bInitFail[nRbNo] = TRUE;

			nSeqNo = 1000;
		}
		break;

	case 60:
		if( TIMER( tm ) )
		{
			m_SeqFlag.bInitComp[nRbNo] = TRUE;
			m_SeqFlag.bInitReq[nRbNo]	= FALSE;

			m_sMessage.Format("Init Complete(RBNo=%d)", nRbNo+1);
			SetLog( sSeqName, 0, 0, m_sMessage );
			
			nSeqNo = 0;
		}
		break;
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			if( nAlarmId[nRbNo] )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId[nRbNo] );
					
				nAlarmId[nRbNo] = 0;
			}			
			SetLog( sSeqName, 0, 0, "Alarm reset" );
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqInitNo[nRbNo] = nSeqNo;
	
}

//---------------------------------------------------------------------------
// - SetRbGap
//---------------------------------------------------------------------------
int CRbSeq::SetRbGap( int nRbNo )
{
	static BOOL bManualModeChangeComp[MAX_RB_GAP_SERVO_NO] = { FALSE, };
	int nRbPosNo = rbNOOP;

	BOOL bRun = TRUE;
	bRun &= !m_pDicsData->m_GenInfo.bEmo;

	BOOL bGapRun = bRun;
	bGapRun &= m_pDicsData->m_GenInfo.bEqpInitComp;
//	bGapRun &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupJOB_MODE];
//#ifndef _NO_RB		// 20100719 ssm
	bGapRun &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupSWR2_RB_SERVO1_USE+nRbNo];
//#endif

	if( !m_pDicsData->m_GenInfo.bAuto )
	{
		if( !bRun || !bManualModeChangeComp[nRbNo] )
		{		
			bManualModeChangeComp[nRbNo] = TRUE;
			
			if( !bRun )			nRbPosNo = rbOFF;
//			else if( bGapRun )	nRbPosNo = rbWAIT;	//DMST say : Manual mode -> servo motion change x
		}
		else//2008.10.12 kimgun
		{
			nRbPosNo = rbNOOP;
		}
	}
	else
	{
		bManualModeChangeComp[nRbNo] = FALSE;

		int nIndex = ( m_nServoMode == servoBOTH ) ? nRbNo : nRbNo*2;

		BOOL bSetPos = bGapRun;
		if( m_pDicsData->m_JobCond.bJobProcessUse )
		{
			bSetPos &= bGapRun;
			bSetPos &= !m_pDicsData->m_GenInfo.bIdleRunning;
			bSetPos &= IsRbMotorRun( nIndex );
			bSetPos &= m_pDicsData->m_JobCond.bRbUse[nIndex];
//			bSetPos &= !m_pDicsData->m_GenInfo.bSbjStop;
		}
		else
			bSetPos = FALSE;

		/********** 170714 halesu********/
		BOOL bIdleRunPos = bGapRun;
		if( m_pDicsData->m_JobCond.bJobProcessUse )
		{
			bIdleRunPos &= bGapRun;
			bIdleRunPos &= m_pDicsData->m_GenInfo.bIdleRunning;
			bIdleRunPos &= IsRbMotorRun( nIndex );
		}
		else
			bIdleRunPos = FALSE;
		/*********************************/
		
		if( bSetPos )		nRbPosNo = rbPROCESS;
		else if( bIdleRunPos )	nRbPosNo = rbIDLERUN;	// 170714 halesu
		else if( bGapRun )	
		{
			nRbPosNo = rbWAIT;
		}
		else if( bRun )		nRbPosNo = rbNOOP;
		else			
		{
			nRbPosNo = rbOFF;
		}
	}

	return nRbPosNo;
}
void CRbSeq::SeqRbGapControl(int nRbNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	int i = nRbNo;
	int nRv;
	int nSeqNo	 = m_nSeqRbGapControlNo[i];
	int nServoNo = SWR2_RBT_RB_UNIT_UP_RB1_UNIT + i;

	static RBT_POS	rpRefPos[MAX_RB_GAP_SERVO_NO]		= { 0.0, };
	static RBT_POS	rpOldRefPos[MAX_RB_GAP_SERVO_NO]	= { 0.0, };
	static RBT_POS	rpCurPos[MAX_RB_GAP_SERVO_NO]		= { 0.0, };
	static DWORD	dwTickStart[MAX_RB_GAP_SERVO_NO]	= { 0, };
	static int		nAlarmId[MAX_RB_GAP_SERVO_NO]		= { 0, };

	m_sSeqName.Format( "RB GAP %d", i+1 );	

	m_RbGap.nRefRbPosition[i] = SetRbGap( i );

	switch( nSeqNo )
	{
	case 0 :
		if( m_RbGap.nRefRbPosition[i] == rbNOOP )
		{
			m_RbGap.bGapSettingComp[i] = TRUE;
			rpOldRefPos[i].dPos[Z_AXIS] = -0.05;
		}
		else if( m_RbGap.nRefRbPosition[i] == rbOFF )
		{ // NoUse Case
			if( !m_pMmc->m_bServoReady[nServoNo] )
			{
				m_RbGap.bGapSettingComp[i] = TRUE;
			}
			else if( !m_pDicsData->m_GenInfo.bEmo )//2009.02.18 kimgun emoseq     ü    ʵ..
			{
				m_RbGap.bGapSettingComp[i] = FALSE;
				m_sMessage.Format( "R/B%d Servo E-Stop Req", i+1 );
				SetLog( m_sSeqName, 0, 0, m_sMessage );
				nSeqNo = 200;
			}
		}
		else if( m_RbGap.nRefRbPosition[i] == rbPROCESS )
		{ // ProcessPosition Move
			rpRefPos[i].dPos[Z_AXIS] = m_pDicsData->m_JobCond.dRbGap[i] + 
										m_pMmc->m_RbtInfo[nServoNo].pos[RBT_RB_ZERO_POS].dPos[Z_AXIS];
			nSeqNo = 10;
		}
		else if( m_RbGap.nRefRbPosition[i] == rbWAIT )
		{ // Wait Position Move
			rpRefPos[i].dPos[Z_AXIS] = m_pMmc->m_RbtInfo[nServoNo].pos[RBT_RB_WAIT_POS].dPos[Z_AXIS];
//			RBT_POS stest;
//			stest.dPos[Z_AXIS] = rpOldRefPos[i].dPos[Z_AXIS];
			nSeqNo = 10;
		}
		else if( m_RbGap.nRefRbPosition[i] == rbIDLERUN )
		{ // Idle Run Position Move
			// hskwak 191016 idle gap
			//rpRefPos[i].dPos[Z_AXIS] = (double)m_pSetupItems->m_nValueIdleRun[CSetupItems::idleSWR2_UPPER_RB1_GAP + i] * 0.001 + 
			rpRefPos[i].dPos[Z_AXIS] = (double)m_pSetupItems->m_nValueIdleRun[CSetupItems::idleSWR2_UPPER_RB1_GAP + i] * 0.1 + 
										m_pMmc->m_RbtInfo[nServoNo].pos[RBT_RB_ZERO_POS].dPos[Z_AXIS];
			nSeqNo = 10;
		}
		break;
	case 10 :
		if( rpRefPos[i].dPos[Z_AXIS] == rpOldRefPos[i].dPos[Z_AXIS] )
		{
			if( m_RbGap.bGapSettingComp[i] )	nSeqNo = 0;
			else	
			{
#ifdef _MY_DEBUG 
				dwTickStart[i] = GetTickCount();
#endif 
				nSeqNo = 100;
			}
		}
		else if( rpRefPos[i].dPos[Z_AXIS] != rpOldRefPos[i].dPos[Z_AXIS] )
		{
			rpOldRefPos[i] = rpRefPos[i];//2008.10.12 kimgun
			m_sMessage.Format( "R/B%d Servo Pos Change Req", i+1 );
			SetLog( m_sSeqName, 0, 0, m_sMessage );

			if( m_RbGap.bGapSettingComp[i] )
			{ 
				m_RbGap.bGapSettingComp[i] = FALSE; //2008.10.12 kimgun checkunitcond ʿϰ c/v  ʵ alarm False
#ifdef _MY_DEBUG 
				dwTickStart[i] = GetTickCount();
#endif 	
				nSeqNo = 100;
			}
			else
			{
				m_sMessage.Format( "R/B%d Servo Stop Req", i+1 );
				SetLog( m_sSeqName, 0, 0, m_sMessage );
				//m_RbGap.bGapSettingComp[i] = FALSE;// 2008.10.12 kimgun 
				nSeqNo = 200;			
			}
		}
		break;
	case 100 :
		if( !m_pMmc->m_bServoReady[nServoNo] )
		{
			m_sMessage.Format( "R/B%d Servo Reset Req", i+1 );
			SetLog( m_sSeqName, 0, 0, m_sMessage );
			nSeqNo = 300;
		}
		else if( !m_pMmc->m_bHomeComp[nServoNo] || !m_pMmc->m_bServoReady[nServoNo] )
		{
//#ifndef _NO_RB
			nAlarmId[i] = ALM_SWR2_RB_UNIT_UP_RB1_SERVO_MOVE_POS + i;
//#endif
			m_pEqpStateSeq->SetAlarm( nAlarmId[i] );

			//m_RbGap.bGapSettingComp[i] = FALSE;// 2008.10.12 kimgun 
			m_sMessage.Format( "R/B%d Servo Not Ready", i+1 );
			SetLog( m_sSeqName, 0, 0, m_sMessage );
			
			nSeqNo = 1000;		
		}
#ifndef _MY_DEBUG
		else if( ( nRv = m_pMmc->MoveRbtPos( nServoNo, rpRefPos[i] ) ) == 0 )
#else	
		else if( GetTickCount() - dwTickStart[i] > 1000 )
#endif
		{
			rpCurPos[i] = rpRefPos[i];
			//rpOldRefPos[i] = rpRefPos[i];//2008.10.12 kimgun

			if( !m_RbGap.bGapSettingComp[i] )
			{
				m_RbGap.bGapSettingComp[i] = TRUE;
				
				if( m_RbGap.nRefRbPosition[i] == rbPROCESS )
				{
					m_sMessage.Format( "R/B%d Servo Gap Set Comp : %2.2f",  i + 1, rpRefPos[i].dPos[Z_AXIS] );
					
				}
				else if( m_RbGap.nRefRbPosition[i] == rbWAIT )
				{
					m_sMessage.Format( "R/B%d Servo Wait Set Comp : %2.2f",  i + 1, rpRefPos[i].dPos[Z_AXIS] );
				}
				
				SetLog( m_sSeqName, 0, 0, m_sMessage );
			}
			
			nSeqNo = 0;
		}
#ifndef _MY_DEBUG
		else if( nRv > 0 )
#else
		else if( 0 )
#endif 
		{
//#ifndef _NO_RB
			nAlarmId[i] = ALM_SWR2_RB_UNIT_UP_RB1_SERVO_MOVE_POS + i;
//#endif
			m_pEqpStateSeq->SetAlarm( nAlarmId[i] );
			m_sMessage.Format( "R/B%d Servo Moving Error : %d", i+1, nRv );
			SetLog( m_sSeqName, 0, 0, m_sMessage );
			m_RbGap.bGapSettingComp[i] = FALSE;// 2008.10.12 kimgun 
			nSeqNo = 1000;
		}
//		else//2008.10.12 kimgun
//		{
//			nSeqNo = 0;
//		}
		break;
	case 200 :
		if( m_pMmc->EStopRbt( nServoNo ) &&
			!m_pMmc->m_bServoReady[nServoNo] )
		{
			m_sMessage.Format( "R/B%d Servo E-Stop Comp", i+1 );
			SetLog( m_sSeqName, 0, 0, m_sMessage );
			nSeqNo = 300;//2008.12.09 kimgun
		}
		break;
	case 300 :
		if( m_pMmc->ResetRbt( nServoNo ) &&
			m_pMmc->m_bServoReady[nServoNo] )
		{
			m_sMessage.Format( "R/B%d Servo Reset Comp", i+1 );
			SetLog( m_sSeqName, 0, 0, m_sMessage );
			//m_RbGap.bGapSettingComp[i] = TRUE;// 2008.12.09 kimgun 
			nSeqNo = 0;
		}
		break;
	case 1000 :
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			SetLog( m_sSeqName, 0, 0, "Error Recovery" );
			m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );

			dwTickStart[i] =  GetTickCount();
			nSeqNo = 1100;
		}
		break;
	case 1100 :
		if( ( GetTickCount() - dwTickStart[i] ) > 2000 )
		{
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqRbGapControlNo[i] = nSeqNo;
}
BOOL CRbSeq::GetRbCond()
{
	BOOL bCond = TRUE;

	for( int i = 0; i < MAX_RB_NO; i++ )
	{
		BOOL bUse = IsRbUse( i );
		if( !bUse )
		{
			bCond &= ( m_RbMotor.nRefRbVelocity[i] == 0 );
			bCond &= ( ABS( m_RbMotor.dErrRbVelocity[i] ) < 50 ) ;
		}
		else
		{
			bCond &= m_RbMotor.bRbMotorCond[i];
			bCond &= ( m_RbMotor.nRefRbVelocity[i] != 0 || m_pDicsData->m_JobCond.nRbSpeed[i] == 0 ) ;
			bCond &= ( ABS( m_RbMotor.dErrRbVelocity[i] ) < 50 ) ;
//			bCond &= m_RbGap.bGapSettingComp[i];//2008.12.09 kimgun
		}
	}

	for( int i = 0; i < MAX_RB_GAP_SERVO_NO; i++ )
	{
		bCond &= m_RbGap.bGapSettingComp[i];
	}
		
	return bCond;
}
//---------------------------------------------------------------------------
// Set the Log
//2008.12.17 kimgun
//---------------------------------------------------------------------------
void CRbSeq::SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage )
{
	// Log
	CString sLog;
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	sLog.Format( "SEQRB\t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( sLog );
	if( m_pDicsData->m_GenInfo.bEnableEqpLog )
	{
		sLog.Format( "%s : %s", sSeqName, sMessage );
		Msg( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) sLog );
	}
}

enum CHANNELSEND
{
	SendA, Send1, Send2, Send3, Send4, SendB, SendC, SendD, SendE, SendF, SendG, SendH, SendI, SendJ, SendK,
};

enum MUX_RECEIVE
{
	MUXGOOD, MUXERROR1, MUXERROR2, MUXERROR3, MUXERROR4,
};

void CRbSeq::SeqCommMux(int nMuxNo)
{
	int nSeqNo = m_nSeqCommMux[nMuxNo];
	static DWORD dwStartTick[MAX_MUX10];
	static int nReturnSeqNo[MAX_MUX10];
	static int nAlarmId[MAX_MUX10] = {0, };
	static int nCount[MAX_MUX10];
	static int nErrorCode[MAX_MUX10] = {0, };
	static int nErrorPart[MAX_MUX10] = {0, };
	static CString strReceiveAccData[MAX_MUX10];
	int nErrorCheck;
	CString sRecvData, sSeqName, m_sMessage, sSendData;
	static char cSendData[MAX_MUX10]; 
	static int nSendCount[MAX_MUX10] = {0, 0};
	BOOL bSendData = FALSE;
	BOOL bReceiveData = FALSE;

	if(nMuxNo == 0)		sSeqName = ( "	SEQCOMMMUX_SW2	" );
	else				sSeqName = ( "	SEQCOMMMUX_SW3	" );

	// 191126 hskwak
	if(nMuxNo == 0)
	{
		if(m_pMuxCom == NULL)
		{
			for( int i=0; i< MAX_MUX10_CHANNEL; i++ )
			{
				m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i+(MAX_MUX10_CHANNEL*nMuxNo) ] = 0.0f;
			}
			return;
		}
	}
	else
	{
		if(m_pMuxCom2 == NULL)
		{
			for( int i=0; i< MAX_MUX10_CHANNEL; i++ )
			{
				m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i+(MAX_MUX10_CHANNEL*nMuxNo) ] = 0.0f;
			}
			return;
		}
	}

	switch( nSeqNo )
	{
	case 0:
		{
			sSendData.Format("%d", nSendCount[nMuxNo]+1);
			cSendData[nMuxNo] = sSendData.GetAt(0);
#ifndef _MY_DEBUG
			// 191126 hskwak
			if(nMuxNo == 0)
				bSendData = m_pMuxCom->SendCommand( cSendData[nMuxNo] );
			else
				bSendData = m_pMuxCom2->SendCommand( cSendData[nMuxNo] );
			if( bSendData )
#endif
			{
				dwStartTick[nMuxNo] = GetTickCount();
				nSeqNo = 10;
			}
		}
		break;
	case 10:
		{
			strReceiveAccData[nMuxNo] = "";
			dwStartTick[nMuxNo] = GetTickCount();
			nSeqNo=20;
		}
		break;
	case 20:
#ifdef _MY_DEBUG
		for( int i=0; i< MAX_MUX10_CHANNEL; i++ )
		{
			sRecvData.Format("%d.%d", i+1+(MAX_MUX10_CHANNEL*nMuxNo), i+1);
			m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i+(MAX_MUX10_CHANNEL*nMuxNo) ] = atof(sRecvData);
		}
#else
		// 191126 hskwak
		if(nMuxNo == 0)	bReceiveData = m_pMuxCom->IsCommRcvd();
		else			bReceiveData = m_pMuxCom2->IsCommRcvd();
		if( bReceiveData )
		{	 
			if(nMuxNo == 0)	sRecvData = m_pMuxCom->m_sReceivedData;
			else			sRecvData = m_pMuxCom2->m_sReceivedData;
			nErrorCheck = ReceiveMux(cSendData[nMuxNo], sRecvData, sSeqName, nMuxNo, nErrorCode[nMuxNo], nErrorPart[nMuxNo]);

			//			m_sMessage.Format("Mux Receive data = %s(%d)", sRecvData, sRecvData.GetLength());
			//			SetLog( sSeqName, 0, 0, m_sMessage );

			if(nErrorCheck == MUXGOOD)	// GOOD
			{
				nCount[nMuxNo] = 0;
				strReceiveAccData[nMuxNo] = "";

				if( nSendCount[nMuxNo] >= MAX_MUX10_CHANNEL-1)
				{
					nSeqNo = 30;
					nSendCount[nMuxNo] = 0;
				}
				else
				{
					nSendCount[nMuxNo]++;
					nSeqNo = 0;
				}				
			}
			else if(nErrorCheck == MUXERROR2)	// ERROR
			{
				nSeqNo = 1010;
				strReceiveAccData[nMuxNo] = "";
			}
			else if(nErrorCheck == MUXERROR4)	// Channel Mismatch
			{
				nSeqNo = 1020;
				strReceiveAccData[nMuxNo] = "";
			}
//			else
//			{
//				strReceiveAccData[nMuxNo] += sRecvData;
//			}
		}
		if( ( GetTickCount() - dwStartTick[nMuxNo] ) > 5000 )
		{
			nReturnSeqNo[nMuxNo] = 0;
			nSeqNo = 1000;
		}
#endif
		break;
	case 30:
		if( ( GetTickCount() - dwStartTick[nMuxNo] ) > 200 )
		{
			nSeqNo = 0;
		}
		break;
	case 1000:
		{
			nCount[nMuxNo]++;
			if( nCount[nMuxNo] >= 10 ) 
			{
				nCount[nMuxNo] = 0;
				//SET ALARM
				nAlarmId[nMuxNo] = ALM_MUX_COMM_READ_ERROR1+nMuxNo;

				for( int i=0; i< MAX_MUX10_CHANNEL; i++ )
				{
					m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i+(MAX_MUX10_CHANNEL*nMuxNo) ] = 0.0f;
				}

				if(nMuxNo == 0)	m_sMessage.Format("Mux not respons data [SWR2]");
				else			m_sMessage.Format("Mux not respons data [SWR3]");
				SetLog( sSeqName, 0, 0, m_sMessage );

				m_pEqpStateSeq->SetAlarm( nAlarmId[nMuxNo] );
				dwStartTick[nMuxNo] = GetTickCount();
				nReturnSeqNo[nMuxNo] = 0;
				nSeqNo = 1050;
			}
			else
			{
				dwStartTick[nMuxNo] = GetTickCount();
				nSeqNo = 30;
			}
		}
		break;
	case 1010:
		{
			for( int i=0; i< MAX_MUX10_CHANNEL; i++ )
			{
				m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i+(MAX_MUX10_CHANNEL*nMuxNo) ] = 0.0f;
			}

			if( nErrorCode[nMuxNo] == 1 )
			{
				nAlarmId[nMuxNo] = ALM_MUX_COMM_DATA_ERROR_SW2_RB1_UP+(nErrorPart[nMuxNo]-1)+(nMuxNo*MAX_MUX10_CHANNEL);
			}
			else
			{
				nAlarmId[nMuxNo] = ALM_MUX_COMM_FORMAT_ERROR_SW2_RB1_UP+(nErrorPart[nMuxNo]-1)+(nMuxNo*MAX_MUX10_CHANNEL);
			}

			m_pEqpStateSeq->SetAlarm( nAlarmId[nMuxNo] );
			dwStartTick[nMuxNo] = GetTickCount();
			nReturnSeqNo[nMuxNo] = 0;
			nSeqNo = 1050;
		}
		break;
	case 1020:
		{
			for( int i=0; i< MAX_MUX10_CHANNEL; i++ )
			{
				m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i+(MAX_MUX10_CHANNEL*nMuxNo) ] = 0.0f;
			}

			nAlarmId[nMuxNo] = ALM_MUX_COMM_CHANNEL_MATCHING_SW2_RB1_UP+(nErrorPart[nMuxNo]-1)+(nMuxNo*MAX_MUX10_CHANNEL);

			m_pEqpStateSeq->SetAlarm( nAlarmId[nMuxNo] );
			dwStartTick[nMuxNo] = GetTickCount();
			nReturnSeqNo[nMuxNo] = 0;
			nSeqNo = 1050;
		}
		break;
	case 1050:
		if( m_pEqpStateSeq->IsPushedAlarmReset() &&
			( ( GetTickCount() - dwStartTick[nMuxNo] ) > 1000 ) )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId[nMuxNo] );
			nAlarmId[nMuxNo] = 0;

			nSeqNo = nReturnSeqNo[nMuxNo];
		}
		break;
	}
	
	m_nSeqCommMux[nMuxNo] = nSeqNo;
}

/*
void CRbSeq::SeqCommMux(int nMuxNo)
{
	int nSeqNo = m_nSeqCommMux[nMuxNo];
	static DWORD dwStartTick[MAX_MUX10];
	static int nReturnSeqNo[MAX_MUX10];
	static int nAlarmId[MAX_MUX10] = {0, };
	static int nCount[MAX_MUX10];
	static int nErrorCode[MAX_MUX10] = {0, };
	static int nErrorPart[MAX_MUX10] = {0, };
	static CString strReceiveAccData[MAX_MUX10];
	int nErrorCheck;
	CString sRecvData, sSeqName, m_sMessage, sSendData;
	static char cSendData; 
	if(nMuxNo == 0)		sSeqName = ( "	SEQCOMMMUX_SW2	" );
	else				sSeqName = ( "	SEQCOMMMUX_SW3	" );

	if(m_pMuxCom[nMuxNo] == NULL)
	{
		for( int i=0; i< MAX_MUX10_CHANNEL; i++ )
		{
			m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i+(MAX_MUX10_CHANNEL*nMuxNo) ] = 0.0f;
		}
		return;
	}

	switch( nSeqNo )
	{
	case 0:
		{
			sSendData = "A";
			cSendData = sSendData.GetAt(0);
#ifndef _MY_DEBUG
			if( m_pMuxCom[nMuxNo]->SendCommand( cSendData ) )
#endif
			{
				dwStartTick[nMuxNo] = GetTickCount();
				nSeqNo = 10;
			}
		}
		break;
	case 10:
		//if( ( GetTickCount() - dwStartTick[nMuxNo] ) > 500 )
		{
			strReceiveAccData[nMuxNo] = "";
			dwStartTick[nMuxNo] = GetTickCount();
			nSeqNo=20;
		}
		break;
	case 20:
#ifdef _MY_DEBUG
		for( int i=0; i< MAX_MUX10_CHANNEL; i++ )
		{
			sRecvData.Format("%d.%d", i+1+(MAX_MUX10_CHANNEL*nMuxNo), i+1);
			m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i+(MAX_MUX10_CHANNEL*nMuxNo) ] = atof(sRecvData);
		}
#else
		if( m_pMuxCom[nMuxNo]->IsCommRcvd() )
		{
			 
			sRecvData = m_pMuxCom[nMuxNo]->m_sReceivedData;

			m_sMessage.Format("Mux Receive data = %s(%d)", sRecvData, sRecvData.GetLength());
			SetLog( sSeqName, 0, 0, m_sMessage );
			
			if(sRecvData.GetAt(sRecvData.GetLength()-1) == CMuxCom::ccCR)
			{
				if(strReceiveAccData[nMuxNo].GetLength() !=0)
				{
					strReceiveAccData[nMuxNo] += sRecvData;
					sRecvData = strReceiveAccData[nMuxNo];
				}

				nErrorCheck = ReceiveMux(cSendData, sRecvData, sSeqName, nMuxNo, nErrorCode[nMuxNo], nErrorPart[nMuxNo]);
		}
				if(nErrorCheck == MUXGOOD)	// GOOD
				{
					nCount[nMuxNo] = 0;
//					dwStartTick[nMuxNo] = GetTickCount();
//					nSeqNo = 30;

				}
				else if(nErrorCheck == MUXERROR2)	// ERROR
				{
					nSeqNo = 1010;
				}
				else if(nErrorCheck == MUXERROR4)	// Channel Mismatch
				{
					nSeqNo = 1020;
				}
				strReceiveAccData[nMuxNo] = "";
			}
			else
			{
				strReceiveAccData[nMuxNo] += sRecvData;
			}
		}
		if( ( GetTickCount() - dwStartTick[nMuxNo] ) > 5000 )
		{
			nReturnSeqNo[nMuxNo] = 0;
			nSeqNo = 1000;
		}
#endif
		break;
	case 30:
		if( ( GetTickCount() - dwStartTick[nMuxNo] ) > 3000 )
		{
			nSeqNo = 0;
		}
		break;
	case 1000:
		{
			nCount[nMuxNo]++;
			if( nCount[nMuxNo] >= 10 ) 
			{
				nCount[nMuxNo] = 0;
				//SET ALARM
				nAlarmId[nMuxNo] = ALM_MUX_COMM_READ_ERROR1+nMuxNo;

				for( int i=0; i< MAX_MUX10_CHANNEL; i++ )
				{
					m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i+(MAX_MUX10_CHANNEL*nMuxNo) ] = 0.0f;
				}

				if(nMuxNo == 0)	m_sMessage.Format("Mux not respons data [SWR2]");
				else			m_sMessage.Format("Mux not respons data [SWR3]");
				SetLog( sSeqName, 0, 0, m_sMessage );

				m_pEqpStateSeq->SetAlarm( nAlarmId[nMuxNo] );
				dwStartTick[nMuxNo] = GetTickCount();
				nReturnSeqNo[nMuxNo] = 0;
				nSeqNo = 1050;
			}
			else
			{
				dwStartTick[nMuxNo] = GetTickCount();
				nSeqNo = 30;
			}
		}
		break;
	case 1010:
		{
			for( int i=0; i< MAX_MUX10_CHANNEL; i++ )
			{
				m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i+(MAX_MUX10_CHANNEL*nMuxNo) ] = 0.0f;
			}

			if( nErrorCode[nMuxNo] == 1 )
			{
				nAlarmId[nMuxNo] = ALM_MUX_COMM_DATA_ERROR_SW2_RB1_UP+(nErrorPart[nMuxNo]-1)+(nMuxNo*MAX_MUX10_CHANNEL);
			}
			else
			{
				nAlarmId[nMuxNo] = ALM_MUX_COMM_FORMAT_ERROR_SW2_RB1_UP+(nErrorPart[nMuxNo]-1)+(nMuxNo*MAX_MUX10_CHANNEL);
			}

			m_pEqpStateSeq->SetAlarm( nAlarmId[nMuxNo] );
			dwStartTick[nMuxNo] = GetTickCount();
			nReturnSeqNo[nMuxNo] = 0;
			nSeqNo = 1050;
		}
		break;
	case 1020:
		{
			for( int i=0; i< MAX_MUX10_CHANNEL; i++ )
			{
				m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i+(MAX_MUX10_CHANNEL*nMuxNo) ] = 0.0f;
			}

			nAlarmId[nMuxNo] = ALM_MUX_COMM_CHANNEL_MATCHING_SW2_RB1_UP+(nErrorPart[nMuxNo]-1)+(nMuxNo*MAX_MUX10_CHANNEL);

			m_pEqpStateSeq->SetAlarm( nAlarmId[nMuxNo] );
			dwStartTick[nMuxNo] = GetTickCount();
			nReturnSeqNo[nMuxNo] = 0;
			nSeqNo = 1050;
		}
		break;
	case 1050:
		if( m_pEqpStateSeq->IsPushedAlarmReset() &&
			( ( GetTickCount() - dwStartTick[nMuxNo] ) > 1000 ) )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId[nMuxNo] );
			nAlarmId[nMuxNo] = 0;

			nSeqNo = nReturnSeqNo[nMuxNo];
		}
		break;
	}
	
	m_nSeqCommMux[nMuxNo] = nSeqNo;
}
*/

int CRbSeq::ReceiveMux(char cSend, CString strReceiveData, CString sSeqName, int nMuxNo, int &nErrCode, int &nErrPart)
{
	int nDataCount;
	int nChannelInfo;
	int nChannel[15][4] = { {1, 2, 3, 4}, {1, 0, 0, 0}, {2, 0, 0, 0}, {3, 0, 0, 0}, {4, 0, 0, 0},
							{1, 2, 4, 0}, {1, 3, 4, 0}, {2, 3, 4, 0}, {1, 2, 3, 0},
							{1, 2, 0, 0}, {1, 3, 0, 0}, {1, 4, 0, 0}, {2, 3, 0, 0}, {2, 4, 0, 0}, {3, 4, 0, 0}}; 

	nErrCode = 0;
	nErrPart = 0;

	if( cSend == 'A' )		{	nDataCount = 4;	nChannelInfo = SendA;	}
	else if( cSend == '1' ) {	nDataCount = 1;	nChannelInfo = Send1;	}
	else if( cSend == '2' ) {	nDataCount = 1;	nChannelInfo = Send2;	}
	else if( cSend == '3' ) {	nDataCount = 1;	nChannelInfo = Send3;	}
	else if( cSend == '4' ) {	nDataCount = 1;	nChannelInfo = Send4;	}
	else if( cSend == 'B' ) {	nDataCount = 3;	nChannelInfo = SendB;	}
	else if( cSend == 'C' ) {	nDataCount = 3;	nChannelInfo = SendC;	}
	else if( cSend == 'D' ) {	nDataCount = 3;	nChannelInfo = SendD;	}
	else if( cSend == 'E' ) {	nDataCount = 3;	nChannelInfo = SendE;	}
	else if( cSend == 'F' ) {	nDataCount = 2;	nChannelInfo = SendF;	}
	else if( cSend == 'G' ) {	nDataCount = 2;	nChannelInfo = SendG;	}
	else if( cSend == 'H' ) {	nDataCount = 2;	nChannelInfo = SendH;	}
	else if( cSend == 'I' ) {	nDataCount = 2;	nChannelInfo = SendI;	}
	else if( cSend == 'J' ) {	nDataCount = 2;	nChannelInfo = SendJ;	}
	else if( cSend == 'K' ) {	nDataCount = 2;	nChannelInfo = SendK;	}
	else
	{
		
		return MUXERROR1;	//  ߸.  message.
	}

	if(strReceiveData.GetLength() == 4)	// Error Receive  .
	{
		nErrCode = atoi(strReceiveData.Mid(2, 1));
		nErrPart = atoi(strReceiveData.Mid(1, 1));

		m_sMessage.Format("Mux Receive error data Port%d = %d", nErrPart, nErrCode);
		SetLog( sSeqName, 0, 0, m_sMessage );
		
		return MUXERROR2;
	}
	//else if(strReceiveData.GetLength() != nDataCount * MAX_MUX10_RECV_LENGTH)	// Receive ٸ  Error.
	else if(strReceiveData.GetLength() != MAX_MUX10_RECV_LENGTH)	// Receive ٸ  Error.
	{
		return MUXERROR3;	
	}

	// Data Parsing
/*	for( int i=0; i< nDataCount; i++ )
	{
		m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i+(MAX_MUX10_CHANNEL*nMuxNo) ] = atof(strReceiveData.Mid(3+(i*MAX_MUX10_RECV_LENGTH), 9));
		

		if( atoi(strReceiveData.Mid(1+(i*MAX_MUX10_RECV_LENGTH), 1)) != nChannel[nChannelInfo][i])
		{
			m_sMessage.Format("Mux Channel error : Now=%d, Error=%d", nChannel[nChannelInfo][i], atoi(strReceiveData.Mid(1+(i*MAX_MUX10_RECV_LENGTH), 1)));
			SetLog( sSeqName, 0, 0, m_sMessage );

			nErrPart = i+1;
			return MUXERROR4;
		}

		

		m_sMessage.Format("Mux Receive data Port%d = %.2f", i+(MAX_MUX10_CHANNEL*nMuxNo)+1, m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i+(MAX_MUX10_CHANNEL*nMuxNo) ]);
		SetLog( sSeqName, 0, 0, m_sMessage );
	}
*/
	m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+atoi(strReceiveData.Mid(1, 1))-1+(MAX_MUX10_CHANNEL*nMuxNo) ] = atof(strReceiveData.Mid(3, 9));

	return MUXGOOD;
}