// ScanSequence.cpp: implementation of the CScanSequence class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "ScanSequence.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CScanSequence::CScanSequence()
{

}

void CScanSequence::SetOwnerPointer(CWnd* pWnd)
{
	SetDicsView( ( CDicsView* )pWnd );
	SetDicsData( m_pDicsView->m_pDicsData );
	SetDevice( m_pDicsView->m_pDevice );
	SetSetupItems( m_pDicsView->GetDocument()->m_pSetupItems );
	SetEqpStateSequence( m_pDicsView->m_pEqpStateSeq );
	SetSeqTimer( m_pDicsView->m_pTimer );
	SetEqpAssy( m_pDicsView->m_pEqpAssy );
}

CScanSequence::~CScanSequence()
{

}

BOOL CScanSequence::Initialize()
{
	InitParameter();
	return TRUE;
}

void CScanSequence::InitParameter()
{
	for( int i = 0; i < MAX_SCAN_NO ; i++ )
	{
		m_nSeqScanBrokenNo[i] = 0;
		m_nSeqManualScanBrokenNo[i] = 0;
	}
//	m_nSeqCcdSensorNo	= 0;	// 120111 halesu
	m_nSeqLdScanBrokenNo	= 0;	// 231122 halesu

	m_pEqpAssy->m_ScanBrokenSensorUpLd.Reset( 0, ON );
	m_pEqpAssy->m_ScanBrokenSensorUl.Reset( 0, ON );
	m_pEqpAssy->m_ScanBrokenSensorLd.Reset( 0, ON );
}

BOOL CScanSequence::Sequence()
{
	Sleep( 100 );
	
	if( m_pDicsData->m_GenInfo.bAuto )
	{

		int nULScanUse = (((CDicsView *) m_pOwnerWnd )->GetDocument()->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUL_UNIT_SCAN_SENSOR]);
		int nLDScanUse = (((CDicsView *) m_pOwnerWnd )->GetDocument()->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupLD_UNIT_SCAN_SENSOR]);
		
		if( nULScanUse ) 
			SeqScanBroken( BS_UNIT_UL );
		else if( m_nSeqScanBrokenNo[BS_UNIT_UL] != 0 )
		{
			m_nSeqScanBrokenNo[BS_UNIT_UL] = 0;
			m_pEqpAssy->m_ScanBrokenSensorUl.Reset( 0, OFF );
		}

		if( nLDScanUse ) 
			SeqScanBroken( BS_UNIT_LD );
		else if( m_nSeqScanBrokenNo[BS_UNIT_LD] != 0 )
		{
			m_nSeqScanBrokenNo[BS_UNIT_LD] = 0;
			m_pEqpAssy->m_ScanBrokenSensorLd.Reset( 0, OFF );
		}

		SeqLdScanBroken();	// 231122 halesu
	}
	return TRUE;
}
	
void CScanSequence::SeqScanBroken(int nUnitNo)
{
 	int nSeqNo = m_nSeqScanBrokenNo[nUnitNo];

	static CString sUnitName[MAX_SCAN_NO] = { "UL_SCAN ", "LD_SCAN" };

	CJobsTabMainView* pView = ( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView;

#ifdef _MY_DEBUG

	if(nUnitNo == IF_UNIT_UL)
	{
		if( m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].bIsValid &&
			!m_pEqpAssy->m_ScanBrokenSensorUl.GetScanEnd() && !m_pEqpAssy->m_ScanBrokenSensorUl.GetScanStart() )
		{
			m_pEqpAssy->m_ScanBrokenSensorUl.SetScanStartState(0, ON);
			m_pEqpAssy->m_ScanBrokenSensorUl.SetScanEndState(0, ON);
		}
		else if( m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].bIsValid &&
			( m_pEqpAssy->m_ScanBrokenSensorUl.GetScanEnd() || m_pEqpAssy->m_ScanBrokenSensorUl.GetScanStart() ) )
		{
			m_pEqpAssy->m_ScanBrokenSensorUl.SetScanStartState(0, OFF);
			m_pEqpAssy->m_ScanBrokenSensorUl.SetScanEndState(0, OFF);
			if( !m_pEqpAssy->m_ScanBrokenSensorUl.GetResetState() )
				m_pEqpAssy->m_ScanBrokenSensorUl.SetAlarmState(0, OFF);
		}
	}
	else if(nUnitNo == IF_UNIT_LD)
	{
		if( m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].bIsValid &&
			!m_pEqpAssy->m_ScanBrokenSensorLd.GetScanEnd() && !m_pEqpAssy->m_ScanBrokenSensorLd.GetScanStart() )
		{
			m_pEqpAssy->m_ScanBrokenSensorLd.SetScanStartState(0, ON);
			m_pEqpAssy->m_ScanBrokenSensorLd.SetScanEndState(0, ON);
		}
		else if( m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 1].bIsValid &&
			( m_pEqpAssy->m_ScanBrokenSensorLd.GetScanEnd() || m_pEqpAssy->m_ScanBrokenSensorLd.GetScanStart() ) )
		{
			m_pEqpAssy->m_ScanBrokenSensorLd.SetScanStartState(0, OFF);
			m_pEqpAssy->m_ScanBrokenSensorLd.SetScanEndState(0, OFF);
			if( !m_pEqpAssy->m_ScanBrokenSensorLd.GetResetState() )
				m_pEqpAssy->m_ScanBrokenSensorLd.SetAlarmState(0, OFF);
		}
	}
#endif
	
	BOOL bScanStart=FALSE, bScanEnd=FALSE, bError=FALSE;

	if( nUnitNo == BS_UNIT_UL )
	{
		bScanStart = m_pEqpAssy->m_ScanBrokenSensorUl.GetScanStart();
		bScanEnd = m_pEqpAssy->m_ScanBrokenSensorUl.GetScanEnd();
		bError = m_pEqpAssy->m_ScanBrokenSensorUl.GetAlarm();
	}
	else if(nUnitNo == BS_UNIT_LD )
	{
		bScanStart = m_pEqpAssy->m_ScanBrokenSensorLd.GetScanStart();
		bScanEnd = m_pEqpAssy->m_ScanBrokenSensorLd.GetScanEnd();
		bError = m_pEqpAssy->m_ScanBrokenSensorLd.GetAlarm();
	}

	switch( nSeqNo )
	{
	case 0:
		if(	bScanStart && bScanEnd )
		{
			if( nUnitNo == BS_UNIT_UL )	m_pEqpAssy->m_ScanBrokenSensorUl.Reset(0, ON);
			if( nUnitNo == BS_UNIT_LD )	m_pEqpAssy->m_ScanBrokenSensorLd.Reset(0, ON);
			SetLog( sUnitName[nUnitNo], 0, 0, "Broken Scan is started");
			
			m_pDicsData->m_IfScan.bGlassBroken[nUnitNo] = FALSE;
			m_pDicsData->m_IfScan.sStatus[nUnitNo] = "SCAN START";
			pView->SendMessage( WM_BROKEN_SCAN_STATUS_CHANGED, (WPARAM)-1, (LPARAM)nUnitNo );

			nSeqNo = 10;
		}
		else if( ( !bScanStart || !bScanEnd ) &&
				 m_pDicsData->m_IfScan.sStatus[nUnitNo] != "SCAN READY" )
		{ 
			if( nUnitNo == BS_UNIT_UL )	m_pEqpAssy->m_ScanBrokenSensorUl.Reset(0, ON);	
			if( nUnitNo == BS_UNIT_LD )	m_pEqpAssy->m_ScanBrokenSensorLd.Reset(0, ON);

			SetLog( sUnitName[nUnitNo], 0, 0, "Broken Scan is ready to Start");

			m_pDicsData->m_IfScan.sStatus[nUnitNo] = "SCAN READY";
			pView->SendMessage( WM_BROKEN_SCAN_STATUS_CHANGED, (WPARAM)-1, (LPARAM)nUnitNo );
		}
		break;
	case 10:
		if( bError )
		{
			SetLog( sUnitName[nUnitNo], 0, 0, "Broken is Detected" );

			m_pDicsData->m_IfScan.bGlassBroken[nUnitNo] = TRUE;
			m_pDicsData->m_IfScan.sStatus[nUnitNo] = "BROKEN";
			pView->SendMessage( WM_BROKEN_SCAN_STATUS_CHANGED, (WPARAM) -1, (LPARAM) nUnitNo );

			nSeqNo = 100;
		}
		else if( !bScanStart || !bScanEnd )
		{
			if( nUnitNo == BS_UNIT_UL )m_pEqpAssy->m_ScanBrokenSensorUl.Reset(0, OFF);
			if( nUnitNo == BS_UNIT_LD )m_pEqpAssy->m_ScanBrokenSensorLd.Reset(0, OFF);
			m_pDicsData->m_IfScan.bGlassBroken[nUnitNo] = FALSE;
			SetLog( sUnitName[nUnitNo], 0, 0, "Broken is not Detected" );
			
			nSeqNo = 0;
		}
		break;
	case 100:
		if( !m_pDicsData->m_IfScan.bGlassBroken[nUnitNo] )
		{
			if( nUnitNo == BS_UNIT_UL )	m_pEqpAssy->m_ScanBrokenSensorUl.Reset(0, OFF);
			if( nUnitNo == BS_UNIT_LD )	m_pEqpAssy->m_ScanBrokenSensorLd.Reset(0, OFF);
			SetLog( sUnitName[nUnitNo], 0, 0, "Broken is Recovered" );
			
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqScanBrokenNo[nUnitNo] = nSeqNo;
}

void CScanSequence::SeqManualScanBroken(int nUnitNo)
{
	int nSeqNo = m_nSeqManualScanBrokenNo[nUnitNo];
	static int nReturnSeqNo[MAX_SCAN_NO];
	static int nAlarmId[MAX_SCAN_NO];
	static CString sUnitName[MAX_SCAN_NO] = { "UL_SCAN_M", "LD_SCAN_M", };
	
	BOOL bScanStart=FALSE, bScanEnd=FALSE, bError=FALSE, bCvFw=FALSE;
	if( nUnitNo = BS_UNIT_UL )
	{
		bScanStart = m_pEqpAssy->m_ScanBrokenSensorUl.GetScanStart();
		bScanEnd = m_pEqpAssy->m_ScanBrokenSensorUl.GetScanEnd();
		bError = m_pEqpAssy->m_ScanBrokenSensorUl.GetAlarm();
		bCvFw = m_pEqpAssy->m_CvMotor.GetMotorBwState(CV_NO_AK) && m_pEqpAssy->m_CvMotor.GetMotorBwState(CV_NO_UL);
	}
	else if( nUnitNo = BS_UNIT_LD )
	{
		bScanStart = m_pEqpAssy->m_ScanBrokenSensorLd.GetScanStart();
		bScanEnd = m_pEqpAssy->m_ScanBrokenSensorLd.GetScanEnd();
		bError = m_pEqpAssy->m_ScanBrokenSensorLd.GetAlarm();
		bCvFw = m_pEqpAssy->m_CvMotor.GetMotorBwState(CV_NO_LD) && m_pEqpAssy->m_CvMotor.GetMotorBwState(CV_NO_LD+1);
	}

	switch( nSeqNo )
	{
	case 0:
#ifndef _MY_DEBUG
		if ( bScanStart && bCvFw )
#else 
		if ( bCvFw ) 
#endif		
		{
			if( nUnitNo == BS_UNIT_UL )	m_pEqpAssy->m_ScanBrokenSensorUl.Reset(0, OFF);
			if( nUnitNo == BS_UNIT_LD )	m_pEqpAssy->m_ScanBrokenSensorLd.Reset(0, OFF);
			SetLog( sUnitName[nUnitNo], 0, 0, "Scan Start Sensor On - Scan Start");

			m_pDicsData->m_IfScan.sStatus[nUnitNo] = "SCAN START";
			CJobsTabMainView* pView = ( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView;
			pView->SendMessage( WM_BROKEN_SCAN_STATUS_CHANGED, (WPARAM) -1, (LPARAM) nUnitNo );

			nSeqNo = 10;
		}
		break;

	case 10:
#ifndef _MY_DEBUG
		if( bError )
#else
		if( 0 )
#endif
		{
			SetLog(sUnitName[nUnitNo], 0, 0, "Glass Broken");

			m_pDicsData->m_IfScan.sStatus[nUnitNo] = "BROKEN";
			CJobsTabMainView* pView = ( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView;
			pView->SendMessage( WM_BROKEN_SCAN_STATUS_CHANGED, (WPARAM) -1, (LPARAM) nUnitNo );

			m_pDicsData->m_IfScan.bGlassBroken[nUnitNo] = TRUE;
			
			if( nUnitNo == BS_UNIT_UL )
			{
				m_pEqpAssy->m_ScanBrokenSensorUl.Reset(0, OFF);
				m_pEqpAssy->m_CvMotor.SetMotorFw( CV_NO_AK, OFF );
				m_pEqpAssy->m_CvMotor.SetMotorBw( CV_NO_AK, OFF );
				m_pEqpAssy->m_CvMotor.SetMotorFw( CV_NO_UL, OFF );
				m_pEqpAssy->m_CvMotor.SetMotorBw( CV_NO_UL, OFF );
			}
			else if( nUnitNo == BS_UNIT_LD )
			{
				m_pEqpAssy->m_ScanBrokenSensorLd.Reset(0, OFF);
				m_pEqpAssy->m_CvMotor.SetMotorFw( CV_NO_LD, OFF );
				m_pEqpAssy->m_CvMotor.SetMotorBw( CV_NO_LD, OFF );
				m_pEqpAssy->m_CvMotor.SetMotorFw( CV_NO_LD+1, OFF );
				m_pEqpAssy->m_CvMotor.SetMotorBw( CV_NO_LD+1, OFF );
			}
			SetLog( sUnitName[nUnitNo], 0, 0, "C/V Stop");

			nAlarmId[nUnitNo] = ALM_UL_UNIT_SCAN_SENSOR + nUnitNo;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nUnitNo] );

			nReturnSeqNo[nUnitNo] = nSeqNo;
			nSeqNo = 1000;
		}
//#ifndef _SKIP_SCAN
#ifndef _MY_DEBUG
		else if ( !bScanEnd )
#else   
		else if ( 1 )
#endif
		{
			if( nUnitNo == BS_UNIT_UL )	m_pEqpAssy->m_ScanBrokenSensorUl.Reset(0, OFF);
			if( nUnitNo == BS_UNIT_LD )	m_pEqpAssy->m_ScanBrokenSensorLd.Reset(0, OFF);

			SetLog( sUnitName[nUnitNo], 0, 0, "Glass Broken Scan End" );

			m_pDicsData->m_IfScan.sStatus[nUnitNo] = "READY";
			CJobsTabMainView* pView = ( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView;
			pView->SendMessage( WM_BROKEN_SCAN_STATUS_CHANGED, (WPARAM) -1, (LPARAM) nUnitNo );

			nSeqNo = 0;
		}
		break;
	case 1000: // Set Glass Broken Error
		{
			if( m_pEqpStateSeq->IsPushedAlarmReset() )
			{
				if( nUnitNo == BS_UNIT_UL )
				{
					m_pEqpAssy->m_ScanBrokenSensorUl.Reset(0, ON);
					m_pEqpAssy->m_CvMotor.SetMotorFw( CV_NO_AK, ON );
					m_pEqpAssy->m_CvMotor.SetMotorBw( CV_NO_AK, OFF );
					m_pEqpAssy->m_CvMotor.SetMotorFw( CV_NO_UL, ON );
					m_pEqpAssy->m_CvMotor.SetMotorBw( CV_NO_UL, OFF );
				}
				if( nUnitNo == BS_UNIT_LD )
				{
					m_pEqpAssy->m_ScanBrokenSensorLd.Reset(0, ON);
					m_pEqpAssy->m_CvMotor.SetMotorFw( CV_NO_LD, ON );
					m_pEqpAssy->m_CvMotor.SetMotorBw( CV_NO_LD, OFF );
					m_pEqpAssy->m_CvMotor.SetMotorFw( CV_NO_LD+1, ON );
					m_pEqpAssy->m_CvMotor.SetMotorBw( CV_NO_LD+1, OFF );
				}

				SetLog( sUnitName[nUnitNo], 0, 0, "C/V Start");

				m_pDicsData->m_IfScan.bGlassBroken[nUnitNo] = FALSE;

				SetLog( sUnitName[nUnitNo], 0, 0, "Broken Alarm Recovery");

				m_pDicsData->m_IfScan.sStatus[nUnitNo] = "RESET";
				CJobsTabMainView* pView = ( (CDicsView *) m_pOwnerWnd )->m_pTabJobsMainView;	
				pView->SendMessage( WM_BROKEN_SCAN_STATUS_CHANGED, (WPARAM) -1, (LPARAM) nUnitNo );


				m_pEqpStateSeq->ResetAlarm( nAlarmId[nUnitNo] );
				nSeqNo = nReturnSeqNo[nUnitNo];
			}
			break;
		}

	} // switch end

	m_nSeqManualScanBrokenNo[nUnitNo] = nSeqNo;
}

// 231122 halesu
void CScanSequence::SeqLdScanBroken()
{
	int nSeqNo = m_nSeqLdScanBrokenNo;
	static int nReturnSeqNo;
	static int nAlarmId;
	static CString sUnitName = "LD_SCAN	";
	BOOL nPortNo = 0;
	BOOL nSlotNo = 0;

	static int nGlassHeadUnitError;
	int nGlassHeadUnit = IF_UNIT_SWR2;

	while ( nGlassHeadUnit >= IF_UNIT_LD )
	{
#ifndef _MY_DEBUG
		if( m_pDicsData->m_GlsInfo[ nGlassHeadUnit*2+1 ].bIsValid )
#else
		if( m_pDicsData->m_bDebugOutSensor[nGlassHeadUnit] )
#endif
		{
			nPortNo	= m_pDicsData->m_GlsInfo[ nGlassHeadUnit*2+1 ].nPortNo;
			nSlotNo = m_pDicsData->m_GlsInfo[ nGlassHeadUnit*2+1 ].nSlotNo;
			break;
		}
#ifndef _MY_DEBUG
		if( m_pDicsData->m_GlsInfo[ nGlassHeadUnit*2+0 ].bIsValid )
#else
		if( m_pDicsData->m_bDebugInSensor[nGlassHeadUnit] )
#endif
		{
			nPortNo	= m_pDicsData->m_GlsInfo[ nGlassHeadUnit*2+0 ].nPortNo;
			nSlotNo = m_pDicsData->m_GlsInfo[ nGlassHeadUnit*2+0 ].nSlotNo;
			break;
		}
		nGlassHeadUnit--;
	}

	BOOL bCheckCond = TRUE;
	bCheckCond &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupLD_UNIT_SCAN_SENSOR];
	bCheckCond &= ( nGlassHeadUnit >= IF_UNIT_LD );	// Glass Exist

	switch( nSeqNo )
	{
	case 0:
		if( bCheckCond )	
		{
			SetLog( sUnitName, nPortNo, nSlotNo, "LD SCAN BROKEN SENSOR : START" );
			nSeqNo = 10;
		}
		else
		{
			if( nAlarmId > 0 )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId );
				nAlarmId = 0;
				if( m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_UL] )
				{
					m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_UL] = FALSE;
				}
			}
		}
		break;
	case 10:
		if( !bCheckCond )
		{
			SetLog( sUnitName, nPortNo, nSlotNo, "LD SCAN BROKEN SENSOR : END" );
			nSeqNo = 0;
		}
#ifndef _MY_DEBUG
		else if( m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_LD] )
#else
		else if( m_pDicsData->m_bDebugInSensor[IF_UNIT_SWR1] || m_pDicsData->m_bDebugOutSensor[IF_UNIT_SWR1] || 
				 m_pDicsData->m_bDebugInSensor[IF_UNIT_SWR2] || m_pDicsData->m_bDebugOutSensor[IF_UNIT_SWR2] )
#endif
		{
			nGlassHeadUnitError = nGlassHeadUnit;	// save head Pos
			m_pDicsData->m_IfFlag[nGlassHeadUnitError].bOutError = TRUE;

			nAlarmId = ALM_LD_UNIT_SCAN_SENSOR;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			SetLog( sUnitName, nPortNo, nSlotNo, "LD SCAN BROKEN SENSOR : NG" );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 1000;	
		}
		break;
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_LD] = FALSE;
			m_pDicsData->m_IfFlag[nGlassHeadUnitError].bOutError = FALSE;

			m_pEqpStateSeq->ResetAlarm( nAlarmId );
			nAlarmId = 0;

			SetLog( sUnitName, nPortNo, nSlotNo, "LD SCAN BROKEN SENSOR : RESET");
			nSeqNo = nReturnSeqNo;
		}
		break;
	}

	m_nSeqLdScanBrokenNo = nSeqNo;
}

void CScanSequence::SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage )
{
	// Log
	CString sLog;
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	m_sMessage.Format( "SCAN    \t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( m_sMessage );
	
	if( m_pDicsData->m_GenInfo.bEnableEqpLog )//2008.12.17 KIMGUN
	{
		sLog.Format( "%s : %s", sSeqName, sMessage );
		Msg( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) sLog );
	}
}