// ScanSequence.h: interface for the CScanSequence class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCANSEQUENCE_H__EE21AADA_B775_4EF6_B50B_AF65DBC431F9__INCLUDED_)
#define AFX_SCANSEQUENCE_H__EE21AADA_B775_4EF6_B50B_AF65DBC431F9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\X\xsequence.h"
#include "..\DicsData.h"
#include "EqpStateSequence.h"
#include "..\View\SetupItems.h"	// Added by ClassView
#include "..\DicsData.h"
#include "..\X\XTimer.h"
#include "..\FactoryLib\EqpAssy.h"

class CScanSequence : public XSequence  
{
public:	
	CScanSequence();
	virtual ~CScanSequence();

	void SetOwnerPointer(CWnd* pWnd);

	XTimer*				m_pTimer;
	CEqpStateSequence*	m_pEqpStateSeq;
	CDicsView*			m_pDicsView;
	CDicsData*			m_pDicsData;
	XCtlDevice*			m_pDevice;
	CSetupItems*		m_pSetupItems;
	CEqpAssy*			m_pEqpAssy;

	BOOL Sequence();
	BOOL Initialize();
	void InitParameter();
 
	void SeqLdScanBroken();	// 231122 halesu
	void SeqCcdSensor();	// 120111 halesu
	void SeqScanBroken( int nUnitNo);	
	void SeqManualScanBroken( int nUnitNo );
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );
	void SetDicsView( CDicsView *pView ) { m_pDicsView = pView;	}
	void SetDevice( XCtlDevice* pDevice ) { m_pDevice = pDevice; }
	void SetSeqTimer( XTimer* pTimer ) { m_pTimer = pTimer; }
	void SetDicsData( CDicsData* pDicsData ) { m_pDicsData = pDicsData; }
	void SetSetupItems( CSetupItems* pSetupItems ) { m_pSetupItems = pSetupItems; }
	void SetEqpStateSequence(CEqpStateSequence* pEqpStateSeq) { m_pEqpStateSeq = pEqpStateSeq; }
	void SetEqpAssy( CEqpAssy* pAssy )						{m_pEqpAssy = pAssy;}

	int			m_nSeqScanBrokenNo[MAX_SCAN_NO];
	int			m_nSeqCcdSensorNo;	// 120111 halesu
	int			m_nSeqLdScanBrokenNo;	// 231122 halesu
	int			m_nSeqManualScanBrokenNo[MAX_SCAN_NO];
	BOOL		bGlassBroken[MAX_SCAN_NO];
	
	CString		m_sMessage;
};

#endif // !defined(AFX_SCANSEQUENCE_H__EE21AADA_B775_4EF6_B50B_AF65DBC431F9__INCLUDED_)
