// SocketSeq.cpp: implementation of the CSocketSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "SocketSeq.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSocketSeq::CSocketSeq()
{

}

CSocketSeq::~CSocketSeq()
{

}

//---------------------------------------------------------------------------
// Sequence Thread   ȣ...
//---------------------------------------------------------------------------
BOOL CSocketSeq::Initialize()
{
	InitParameter();

	return TRUE;
}

//----------------------------------------------------------------------------
// Sequence Parameter ʱȭ
//----------------------------------------------------------------------------
void CSocketSeq::InitParameter()
{
	m_nSeqSocketConnectNo	= 0;
	m_nSeqLinkTestReqNo		= 0;
	m_nSeqConfirmConnectNo	= 0;
	m_bLinkTestReq = FALSE;
	m_pDicsView = ( CDicsView* )m_pOwnerWnd;
}

//---------------------------------------------------------------------------
// Sequence loop... Sequence Run  ׻ ȣ...
//---------------------------------------------------------------------------
BOOL CSocketSeq::Sequence()
{
	Sleep(1);

	SeqSocketConnect();
	SeqLinkTestReq();
	SeqConfirmConnect();

	return TRUE;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void CSocketSeq::SeqSocketConnect()
{
	int nSeqNo = m_nSeqSocketConnectNo;
	static DWORD dwStartTickCount = 0;

	static int nRetryCount = 0;	// 151212 halesu
	if( nRetryCount > 10 )	return;

	switch( nSeqNo )
	{
	case 0:
		dwStartTickCount = GetTickCount();
		nSeqNo = 10;
		break;

	case 10:
		if( m_pDicsView->m_pHost->m_bActiveMode && ( GetTickCount() - dwStartTickCount ) > (DWORD) (5000) )
		{
			//DicsView connect  õϸ view ߴ  ߻..
			if( !( m_pDicsView->m_pHost->m_bConnected ) )
			{	
				if( m_pDicsView->m_pHost->ConnectEnable( m_pDicsView->m_sIpAddress, m_pDicsView->m_nPortNumber ) ) 
				{
					Msg( WM_SOCKET_OPEN, 0, 1 );	//socket open
					nRetryCount++;
				}
			}
			else	nRetryCount = 0;

			nSeqNo = 0;
		}
		else if( m_pDicsView->m_pHost->m_bRetryConnect)	// 230803 ssm
		{
			Msg( WM_SOCKET_OPEN, 0, 0 );	//socket close
			dwStartTickCount = GetTickCount();
			nSeqNo = 20;  // m_bConnected = FALSE re Connect try
		}
		break;

	case 20:
		if (( GetTickCount() - dwStartTickCount ) > (DWORD) (3000))
		{
			Msg( WM_SOCKET_OPEN, 0, 1 );	//socket open
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqSocketConnectNo = nSeqNo;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void CSocketSeq::SeqLinkTestReq()
{
	if( !m_pDicsView->m_pHost->m_bConnected || m_pDicsView->m_pHost->m_bRetryConnect ) return;

	int nSeqNo = m_nSeqLinkTestReqNo;
	static DWORD dwStartTickCount = 0;

	switch( nSeqNo )
	{
	case 0:
		dwStartTickCount = GetTickCount();
		nSeqNo = 10;
		break;

	case 10:
		if( (GetTickCount() - dwStartTickCount) > (DWORD)(m_pDicsView->m_pHost->LinkTestTimer * 1000) )
		{
			m_pDicsView->m_pHost->LinkTestReq();
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqLinkTestReqNo = nSeqNo;
}

//---------------------------------------------------------------------------
//Host  Lan cable  disconnection ϱ  ...
//Lan cable  socket onclose event ߻ ʴ´.
//---------------------------------------------------------------------------
void CSocketSeq::SeqConfirmConnect()
{
	int nSeqNo = m_nSeqConfirmConnectNo;
	static DWORD dwStartTickCount = 0;
	if( !m_pDicsView->m_pHost->m_bConnected || m_pDicsView->m_pHost->m_bRetryConnect ) nSeqNo = 0;
	
	switch( nSeqNo )
	{
	case 0:
		if( m_bLinkTestReq )
		{
			m_bLinkTestReq = FALSE;
			dwStartTickCount = GetTickCount();
			nSeqNo = 10;
		}
		break;

	case 10:
		if( m_pDicsView->m_pHost->m_bLinkTestRespRecvd )
		{
			m_pDicsView->m_pHost->m_bLinkTestRespRecvd = FALSE;
			nSeqNo = 0;
		}
		else if( (GetTickCount() - dwStartTickCount) > (DWORD)( ( m_pDicsView->m_pHost->LinkTestTimer + 10 ) * 1000) )
		{
			//Hostκ Linktest time LinktestReq  ϸ disconnection Ǵ..   
			if( m_pDicsView->m_pHost->m_bConnected )	//Onclose event ߻ ʾ
				Msg( WM_SOCKET_OPEN, 0, 0 );			//socket close

			nSeqNo = 0;
		}
		break;
	}

	m_nSeqConfirmConnectNo = nSeqNo;
}