// UshioEuvSeq.cpp: implementation of the CUshioEuvSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "UshioEuvSeq.h"
//#include "X\Xlog.h"

#include "..\Dics.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
//XLog EuvLog( "EuvCommLog", XLog::stampNoDateTime, TRUE ); // TRUE : Append

CUshioEuvSeq::CUshioEuvSeq()
{

}

CUshioEuvSeq::~CUshioEuvSeq()
{

}

void CUshioEuvSeq::InitParameter()
{
	// Reset Sequence Flag
	CDicsEuvSeq::InitParameter();
	
	m_nSeqEuvUtilAlarmNo	= 0;
	m_nSeqHumAlarmNo		= 0;
	m_nSeqCommEuv			= 0;

	m_bEuvResetReq		= FALSE;
	m_bEuvResetComp		= FALSE;
		
	for( int i=0; i<MAX_LAMP_INTENSITY_NO; i++ )
	{
		m_pDicsData->m_IfEuv.fLampIntensity[i] = .0;
	}
}

BOOL CUshioEuvSeq::Sequence()
{
	Sleep( 10 );

	SeqInit();
	SeqEuvReset();
	SeqEuvAlarm();

	SeqEuv();
	SeqUtControl();

	for( int i=0; i<MAX_LAMP_NO; i++ ) 
	{
//		SeqLampOnTime( i );
		SeqTimeOver( i );
	}

	SeqEuvProgress();	

	SeqEuvUtilAlarm();
	SeqHumAlarm();
//	if( IsEuvUse())
//	SeqCommEuv();

	return TRUE;
}

void CUshioEuvSeq::SeqInit()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
#ifdef _MY_DEBGG
// clear kimgun test
	m_SeqFlag.bInitFail	= FALSE;
	m_SeqFlag.bInitReq	= FALSE;
	m_SeqFlag.bInitComp	= TRUE;
	return;
#endif
	int nSeqNo = m_nSeqInitNo;
	static DWORD dwTickStart;
	static int nAlarmId;
	static BOOL bEuvOk = FALSE;
	static BOOL bInitialCountStart = FALSE;

	switch( nSeqNo )
	{
	case 0:
		if( m_SeqFlag.bInitReq )
		{
			m_SeqFlag.bInitReq	= FALSE;
			m_SeqFlag.bInitComp	= FALSE;
			m_SeqFlag.bInitFail	= FALSE;


			m_sMessage.Format( "%2d%d", CDicsData::initEUV_STATUS, MSG_STATUS_START );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

			// Log
			SetLog( "INIT    ", 0, 0, "Initialize..." );
	
			if( !IsEuvUse() )	nSeqNo = 100;//2008.10.16 kimgun
			else
			{	
				UtControl( ON );

				SetLog( "INIT    ", 0, 0, "UT Turn ON" );
				dwTickStart = GetTickCount();
				nSeqNo = 10;
			}
		}
		break;

	case 10 : 
		if ( ( GetTickCount() - dwTickStart ) > 1000 )
		{
			LampEmergency( ON );
			SetLog( "INIT    ", 0, 0, "UEMG ON" );

			dwTickStart = GetTickCount();
			nSeqNo = 20;
		}
		break;

	case 20:	
		if ( ( GetTickCount() - dwTickStart ) > 3000 )
		{
			SetLog( "INIT    ", 0, 0, "EUV Reset Request : m_bEuvResetReq <T>" );
			m_bEuvResetReq = TRUE;
			dwTickStart = GetTickCount();
			nSeqNo = 30;
		}
		break;

	case 30 :
		if ( ( GetTickCount() - dwTickStart ) > 3000 )
		{
			if( GetEuvAlarm() == 0 )
			{
				if( GetHumAlarm() == 0 )
				{
					SetLog( "INIT    ", 0, 0, "No Alarm" );	
					nSeqNo = 40;
				}
				else
				{
#ifndef _NO_EUV
					nAlarmId = ALM_HUMIDIFIER_NOT_READY;
#endif
					m_pEqpStateSeq->SetAlarm( nAlarmId );
							
					m_sMessage.Format( "%2d%d", CDicsData::initEUV_STATUS, MSG_STATUS_NG );
					Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

					SetLog( "ALARM", 0, 0, "Alarm Set" );

					m_SeqFlag.bInitFail	= TRUE;

					nSeqNo = 1000;
				}
			}
			else
			{
#ifndef _NO_EUV
				nAlarmId = ALM_EUV_NOT_READY;
#endif
				m_pEqpStateSeq->SetAlarm( nAlarmId );
						
				m_sMessage.Format( "%2d%d", CDicsData::initEUV_STATUS, MSG_STATUS_NG );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				SetLog( "ALARM", 0, 0, "Alarm Set" );

				m_SeqFlag.bInitFail	= TRUE;

				nSeqNo = 1000;
			}
		}
		break;
		
	case 40:
		if( IsRemoteMode() )
		{
			// Set Log
			SetLog( "INIT    ", 0, 0, "Confirm Remote Mode : OK" );
			LampLocalLock( ON );
			nSeqNo = 50;
		}
		else
		{
#ifndef _NO_EUV
			nAlarmId = ALM_EUV_MANUAL;
#endif
			m_pEqpStateSeq->SetAlarm( nAlarmId );
					
			m_sMessage.Format( "%2d%d", CDicsData::initEUV_STATUS, MSG_STATUS_NG );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

			SetLog( "ALARM", 0, 0, "Alarm Set" );

			m_SeqFlag.bInitFail	= TRUE;

			nSeqNo = 1000;
		}	
		break;

	case 50:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_UshioEuv.GetIfUnre() )
#else
		if( 1 )
#endif
		{
			SetLog( "INIT    ", 0, 0, "Confirm UNRE ON : OK" );	
			nSeqNo = 60;
		}
		break;
		
	case 60:
		if( /*IsHumReady() &&*/ IsEuvReady() && !GetInitialCount() )
		{
			SetLog( "INIT    ", 0, 0, "Confirm EUV and Hum Ready : OK" );
			nSeqNo = 70;
		}
		else if( !bEuvOk && GetInitialCount() )
		{
			bEuvOk = TRUE;	
			CString sMsg;
			sMsg.Format("Do you want to keep going EUV House N2 Purge?\n It task around 15minutes.");
			int nRv = AfxMessageBox( (LPCTSTR)sMsg, MB_YESNO | MB_ICONQUESTION | MB_SYSTEMMODAL );
			if( nRv == IDNO )
			{
				SetInitialCount( ON );
				// Set Log
				SetLog( "INIT    ", 0, 0, "Initial Counter ON" );

				bInitialCountStart = TRUE;
				dwTickStart = GetTickCount();
				nSeqNo = 65;
			}
		}
		break;

	case 65:
		if( bInitialCountStart )
		{
			if( ( GetTickCount() - dwTickStart ) > 1000 )
			{
				bInitialCountStart = FALSE;
				SetInitialCount( OFF );
				// Set Log
				SetLog( "INIT    ", 0, 0, "Initial Counter OFF" );
			}
			nSeqNo = 70;
		}
		break;

	case 70 :
		if( GetHouseCloseState() )
		{
			SetLog( "INIT    ", 0, 0, "House Close Confirm" );	
			nSeqNo = 100;
		}
		else
		{
#ifndef _NO_EUV
			nAlarmId = ALM_EUV_HOUSE_CLOSE;
#endif
			m_pEqpStateSeq->SetAlarm( nAlarmId );
					
			m_sMessage.Format( "%2d%d", CDicsData::initEUV_STATUS, MSG_STATUS_NG );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

			SetLog( "ALARM", 0, 0, "Alarm Set" );

			m_SeqFlag.bInitFail	= TRUE;

			nSeqNo = 1000;
		}
		break;

	case 100:
		{			
			// Flag Set
			m_SeqFlag.bInitComp = TRUE;
			bEuvOk = FALSE;
			bInitialCountStart = FALSE;

			m_sMessage.Format( "%2d%d", CDicsData::initEUV_STATUS, MSG_STATUS_OK );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

			// Log
			SetLog( "INIT    ", 0, 0, "Ends Initialize" );
			
			Msg( WM_EQP_MESSAGE, MSG_TITLEBAR_MESSAGE, (LPARAM)(LPCTSTR)"READY", FALSE );
			nSeqNo = 0;
		}
		break;

	// Error
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			nSeqNo = 0;
		}
		break;
	}

	m_nSeqInitNo = nSeqNo;
}

BOOL CUshioEuvSeq::GetInitialCount()
{
#ifndef _MY_DEBUG
	if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUSE_EUV] == 0 )
	{
		return FALSE;
	}
	else
	{
		return m_pEqpAssy->m_UshioEuv.GetIfUica();
	}
#else
	return FALSE;
#endif
}

void CUshioEuvSeq::SetInitialCount(BOOL bInitialCount)
{
#ifndef _MY_DEBUG
	m_pEqpAssy->m_UshioEuv.SetIfUicr( bInitialCount );
#endif
}

float CUshioEuvSeq::GetLampIntensity( int nPos )
{
	return m_IfEuv.fLampIntensity[nPos];
}

int CUshioEuvSeq::GetStatus()	//FOR UpdateObjects
{
	int nStatus = 0;

	if( IsRemoteMode() )			nStatus |= euvREMOTE_MODE;		// Remote Mode
	if( m_pEqpAssy->m_UshioEuv.GetIfUcre() )				nStatus |= euvREMOTE_MODE_POSSIBLE;
	if( m_pEqpAssy->m_UshioEuv.GetIfUlac() )				nStatus |= euvBUSY;
	if( m_pEqpAssy->m_UshioEuv.GetIfUrdy() )				nStatus |= euvREADY;

	return nStatus;
}

BOOL CUshioEuvSeq::IsEuvUse()
{
	BOOL bUse = TRUE;

//	bUse &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupJOB_MODE];
	bUse &=	m_pDicsData->m_JobCond.bJobProcessUse; // JUN_080829
	bUse &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUSE_EUV];

	///////////////////////////////////////////////////////////////////////////
	// limjy_071114 : "BOOL bLampSelect = FALSE" ϸ Setup  
	//				  Recipe󿡼 EUV Lamp  N2, PCW .
	//				  ׷ Ǹ ٽ EUV Ready ° Ǳ ؼ 30
	//				  ҿǱ  Setup Item  ش. (CMO G6)
	///////////////////////////////////////////////////////////////////////////
	BOOL bLampSelect = bUse;
//	BOOL bLampSelect = FALSE;
	for( int i=0; i<MAX_LAMP_CONTROL_NO; i++ )
	{
		bLampSelect |= m_pDicsData->m_JobCond.bEuvUse[i];
	}

	bUse &= bLampSelect;

	return bUse;
}

BOOL CUshioEuvSeq::IsEuvReady()
{
	BOOL bReady;
#ifndef _MY_DEBUG
	if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUSE_EUV] == 0 )
	{
		bReady = TRUE;
	}
	else
	{
		bReady = ( m_pEqpAssy->m_UshioEuv.GetIfUrdy() ? TRUE : FALSE );
	}
#else
	bReady = TRUE;
#endif
	return bReady;
}

BOOL CUshioEuvSeq::IsHumReady()
{
	BOOL bReady;
#ifndef _MY_DEBUG
	if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUSE_EUV] == 0 )
	{
		bReady = TRUE;
	}
	else
	{
		bReady = ( m_pEqpAssy->m_UshioEuv.GetIfUhry() ? TRUE : FALSE );
	}
#else
	bReady = TRUE;
#endif
	return bReady;
}

int CUshioEuvSeq::GetHumStatus()
{
	int nStatus = 0;

	if( IsHumReady() )				nStatus |= humREADY;
//	if( diIF_EUV_HUMIDIFIER_UHEM )	nStatus |= humABNORMAL;

	return nStatus;
}

int CUshioEuvSeq::GetHumAlarm()
{
	int nRv = 0;
#ifndef _MY_DEBUG
	if( m_pEqpAssy->m_UshioEuv.GetIfUhem() )	nRv |= humABNORMAL;
#endif

	return nRv;
}

void CUshioEuvSeq::SeqEuvAlarm()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	if( !m_SeqFlag.bInitComp ) return;

	static int nAlarmId[MAX_EUV_ALARM + 1] = { 0, };
	static DWORD dwStartTick = 0;

	int nAlarmCode	= 0;
	int nSeqNo		= m_nSeqAlarmNo;

	switch ( nSeqNo )
	{
	case 0:
		if( ( nAlarmCode = GetEuvAlarm() ) == 0 && GetHouseCloseState() )//2009.01.20 kimgun
		{
			// No Operation
		}
		else if( IsEuvUse() )
		{
			dwStartTick = GetTickCount();
			nSeqNo = 10;
		}
		break;
	case 10:
		if( !IsEuvUse() ||
		  ( ( nAlarmCode = GetEuvAlarm() ) == 0 && GetHouseCloseState() ))//2009.01.20 kimgun
		{
			nSeqNo = 0;
		}
		else if( ( GetTickCount() - dwStartTick ) > 1500 )
		{	
			LampEmergency( OFF );

			// Parsing EUV Alarm Code
			for( int i=0; i<MAX_EUV_ALARM; i++ )
			{
				if( nAlarmCode & ( 0x0001 << i ) )
				{
#ifndef _NO_EUV
					nAlarmId[i] = ALM_EUV_LAMP_TIME_OVER + i;
#endif
					m_pEqpStateSeq->SetAlarm( nAlarmId[i] );

				}
			}		
			if( !m_pDicsData->m_GenInfo.bAuto && ( nAlarmCode == 0 ) ) nSeqNo = 0;//2009.01.20 kimgun house close alarm maint  ʵ.
			else 
			{
				if( !GetHouseCloseState() ) 
				{
#ifndef _NO_EUV
					nAlarmId[12] = ALM_EUV_HOUSE_CLOSE;
#endif
					m_pEqpStateSeq->SetAlarm( nAlarmId[12] );
					SetLog( "ALARM   ", 0, 0, "EUV Not Close Alarm" );
				}
				// Log
			SetLog( "ALARM   ", 0, 0, "Alarm Set" );	
			
			dwStartTick = GetTickCount();
			nSeqNo = 1000;			
			}
		}
		break;

	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() &&
			( ( GetTickCount() - dwStartTick ) > 1000 ) )
		{
			LampEmergency( ON );
			SetLog( "ALARM   ", 0, 0, "EUV Alarm : LampEmergency( ON )" );
			dwStartTick = GetTickCount();
			nSeqNo = 1010;
		}
		else if(( GetEuvAlarm() == 0 ) && ( GetHumAlarm() == 0 )) nSeqNo = 1030;
		break;
		
	case 1010:
		if( ( GetHumAlarm() == 0 ) && m_pEqpAssy->m_UshioEuv.GetIfUemo() &&
			 (( GetTickCount() - dwStartTick ) > 1000 ) )
		{
			// limjy_071114 : Add Euv Reset
			m_bEuvResetReq = TRUE;
			SetLog( "ALARM   ", 0, 0, "EUV Alarm : m_bEuvResetReq <T>" );

			dwStartTick = GetTickCount();
			nSeqNo = 1020;
		}
		break;

	case 1020:
		if( m_bEuvResetComp && ( ( GetTickCount() - dwStartTick ) > 3000 ) )
		{
			if ( ( GetEuvAlarm() > 0 ) && IsEuvUse() )
			{
				LampEmergency( OFF );
				SetLog( "ALARM   ", 0, 0, "EUV Alarm : remain" );

				dwStartTick = GetTickCount();
				nSeqNo = 1000;
			}
			else nSeqNo = 1030;
		}
		break;

	case 1030:
		if( GetEuvAlarm() == 0 )
		{
			for( int i=0; i<MAX_EUV_ALARM; i++ )
			{
				if( nAlarmId[i] )
				{	// Reset Alarm
					m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
				
//					m_pDicsData->m_IfEuv.bLampAlarm = FALSE;

					// Clear the alarm ID
					nAlarmId[i] = 0;
				}
			}
			// Log
			SetLog( "ALARM   ", 0, 0, "EUV Alarm Recovery" );
			nSeqNo = 0;
		}
		else 
		{
			dwStartTick = GetTickCount();
			nSeqNo = 1000;
		}
		break;
	}
    
	m_nSeqAlarmNo = nSeqNo;
}

void CUshioEuvSeq::SeqHumAlarm()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	if( !m_SeqFlag.bInitComp ) return;

	static int nAlarmId = 0;
	static DWORD dwStartTick = 0;

	int nAlarmCode	= 0;
	int nSeqNo		= m_nSeqHumAlarmNo;

	switch ( nSeqNo )
	{
	case 0:
		if( ( nAlarmCode = GetHumAlarm() ) == 0 )
		{
			// No Operation
		}
		else if( IsEuvUse() )
		{
			dwStartTick = GetTickCount();
			nSeqNo = 10;
		}
		break;
	case 10:
		if( !IsEuvUse() ||
		  ( nAlarmCode = GetHumAlarm() ) == 0 )
		{
			nSeqNo = 0;
		}
		else if( ( GetTickCount() - dwStartTick ) > 1500 )
		{	
			LampEmergency( OFF );

#ifndef _NO_EUV
			nAlarmId = ALM_EUV_HUMIDIFIER_ERR;
#endif
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			// Log
			SetLog( "ALARM   ", 0, 0, "Hum Alarm Set" );	
			
			dwStartTick = GetTickCount();
			nSeqNo = 1000;			
		}
		break;

	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() || 
		  ( ( GetTickCount() - dwStartTick ) > 1000 && GetHumAlarm() == 0 ) )
		{
			LampEmergency( ON );
			nSeqNo = 1010;
		}
		break;

	case 1010:
		if( (( GetTickCount() - dwStartTick ) > 2000 ) && GetUtState()  )
		{
			if ( GetHumAlarm() && IsEuvUse() ) return;

			m_pEqpStateSeq->ResetAlarm( nAlarmId );
			nAlarmId = 0;
			// Log
			SetLog( "ALARM   ", 0, 0, "Hum Alarm Recovery" );

			m_pEqpAssy->m_UshioEuv.SetIfUert( ON );
			m_pEqpAssy->m_UshioEuv.SetIfUher( ON );

			dwStartTick = GetTickCount();
			nSeqNo = 1020;
		}
		break;
		
	case 1020:
		if( ( GetTickCount() - dwStartTick ) > 500 )
		{
			m_pEqpAssy->m_UshioEuv.SetIfUert( OFF );
			m_pEqpAssy->m_UshioEuv.SetIfUher( OFF );
			LampEmergency( ON );
			SetLog( "ALARM   ", 0, 0, "Hum Alarm Reset : OK" );
			nSeqNo = 0;
		}
		break;
	}
    
	m_nSeqHumAlarmNo = nSeqNo;
}


void CUshioEuvSeq::SeqEuvUtilAlarm()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	static int		nAlarmId[MAX_EUV_UTIL_ALARM] = { 0, };
	static DWORD	dwStartTick = 0;
	int nAlarmPos[MAX_EUV_UTIL_ALARM] = { 1, 2, 4};//2008.12.03 kimgun
	int		nSeqNo	= m_nSeqEuvUtilAlarmNo;
	BOOL	bNg		= FALSE;
//	return;//2008.12.08 kimgun    ..
	BOOL bEuvUse = IsEuvUse();
#ifndef _MY_DEBUG
	BOOL bGlassExist = m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) && m_pDicsData->m_GlsInfo[IF_UNIT_LD].bIsValid;
#else
	BOOL bGlassExist = m_pDicsData->m_bDebugInSensor[IF_UNIT_LD] && m_pDicsData->m_GlsInfo[IF_UNIT_LD].bIsValid;
#endif

	BOOL bEuvRun = FALSE;
	bEuvRun = bEuvUse;// && bGlassExist;

	switch( nSeqNo )
	{
	case 0:
		if( !m_pDicsData->m_GenInfo.bAuto || !m_pDicsData->m_GenInfo.bEqpInitComp ) return;
		else if( !bEuvRun )
		{
			// No Operation
		}
		else
		{
// #ifndef _MY_DEBUG
			if( GetEuvUtilAlarm() )
// #else	
// 			if( 0 )
// #endif
			{
			//	m_pDicsData->m_IfEuv.bEuvUtilAlarm = TRUE; 2008.12.03 kimgun
				SetLog( "ALARM   ", 0, 0, "EUV UT ALARM CHECK" );
				nSeqNo = 10;
			}
			else 
			{
				m_pDicsData->m_IfEuv.bEuvUtilAlarm = FALSE;
				nSeqNo = 0;
			}
		}
		break;
	case 10:
		{
			for( int i = 0; i < MAX_EUV_UTIL_ALARM; i++ )
			{
/*#ifndef _MY_DEBUG*/
				bNg = m_pSetupItems->m_nValueETCIntr[CSetupItems::intrEUV_LEVEL1 + i] & m_pEqpAssy->m_UshioEuv.GetUtAlarm( nAlarmPos[i] );//2008.12.03 kimgun
// #else
// 				if( i == 2 ) bNg = 1;	//test
// 				else bNg = 0;
// #endif
				if( bNg && ( nAlarmId[i] == 0 ) )
				{
#ifndef _NO_EUV
					nAlarmId[i] = ALM_EUV_UNIT_N2_LOW_LEVEL + i; //JUN_LAST
#endif
					m_pEqpStateSeq->SetAlarm( nAlarmId[i] );
					m_pDicsData->m_IfEuv.bEuvUtilAlarm = TRUE;
				}
			}

			dwStartTick = GetTickCount();
			nSeqNo = 1000;
		}
		break;
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )//||    ִ..ڵ reset  2008.12.08 kimgun
		//	( ( GetTickCount() - dwStartTick > 1000 ) && !GetEuvUtilAlarm() ) )
		{
			if( GetEuvUtilAlarm() ) return;

			for( int i = 0; i < MAX_EUV_UTIL_ALARM; i++ )
			{
				int nUtAlarmAllClear = 0;
#ifndef _MY_DEBUG
				bNg = m_pEqpAssy->m_UshioEuv.GetUtAlarm(nAlarmPos[i]);
#else
				bNg = 0;
#endif
				if( !bNg && ( nAlarmId[i] != 0 ) )
				{
					m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
					nAlarmId[i] = 0;
				}
			}
			//nSeqNo = 0;//2008.12.08 kimgun
			//if( GetEuvUtilAlarm() ) reset  Ǿµ üũ alarm    ߻.
			if( nAlarmId[0] == 0 && nAlarmId[1] == 0 && nAlarmId[2] == 0 ) 
			{
				m_pDicsData->m_IfEuv.bEuvUtilAlarm = FALSE;
				nSeqNo = 0;//2008.12.08 kimgun
			}
		}
		break;
	}
	m_nSeqEuvUtilAlarmNo = nSeqNo;
}

BOOL CUshioEuvSeq::GetEuvUtilAlarm()
{
	BOOL bNg = FALSE;
	int nAlarmPos[MAX_EUV_UTIL_ALARM] = { 1, 2, 4};//2008.12.03 kimgun
	for( int i = 0; i < MAX_EUV_UTIL_ALARM; i++ )
	{
		bNg |= m_pSetupItems->m_nValueETCIntr[CSetupItems::intrEUV_LEVEL1 + i] & m_pEqpAssy->m_UshioEuv.GetUtAlarm(nAlarmPos[i]);
	}

#ifdef _MY_DEBUG
	bNg = FALSE;
#endif

	return bNg;
}

void CUshioEuvSeq::SeqTimeOver(int i)
{
	int nSeqNo = m_nSeqTimeOverNo[i];
	static int nAlarmId[MAX_LAMP_NO] = { 0, };

	UINT nTimeOver;
	nTimeOver = atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupEUV1_LIFE_TIME + i] );	// Hour
// 	nTimeOver *= 3600;	// second

	switch( nSeqNo )
	{
	case 0:
		if( GetLampUsedTime( i ) > nTimeOver ) 
		{
			// Set Alarm
#ifndef _NO_EUV
			nAlarmId[i] = ALM_EUV_LAMP1_TIME_OVER + i;
#endif
			m_pEqpStateSeq->SetAlarm( nAlarmId[i] );
			
			// Log
			m_sMessage.Format( "Lamp%d Timeover Warning", i + 1 );
			SetLog( "ALARM", 0, 0, m_sMessage );
			nSeqNo = 1000;
		}
		break;
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			if( GetLampUsedTime( i ) <= nTimeOver ) 
			{
				// Reset Alarm
				m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );

				// Log
				m_sMessage.Format( "Lamp%d Alarm Recovery", i + 1 );
				SetLog( "ALARM", 0, 0, m_sMessage );
				nSeqNo = 0;
			}
		}
		break;
	}

	m_nSeqTimeOverNo[i] = nSeqNo;
}

void CUshioEuvSeq::LampOnSelect( )
{
	BOOL bOn = IsEuvUse();
	for( int i=0; i<MAX_LAMP_CONTROL_NO; i++ )
	{
		LampOnSelect( i, bOn & m_pDicsData->m_JobCond.bEuvUse[i] );
	}
}

void CUshioEuvSeq::LampOnSelect( int nLampNo, BOOL bOn )
{
	if( bOn ^ GetLampOnSelected( nLampNo ) )
	{
		m_pEqpAssy->m_UshioEuv.SetIfUls( nLampNo, bOn );
	}
}

void CUshioEuvSeq::LampControl( BOOL bOn )
{
	m_pEqpAssy->m_UshioEuv.SetIfUlon( bOn );
}

void CUshioEuvSeq::UtControl( BOOL bOn )
{
	m_pEqpAssy->m_AutoValveEuvCda.Set( 0, bOn );
	m_pEqpAssy->m_AutoValveEuvN2.Set( 0, bOn );
	m_pEqpAssy->m_AutoValveEuvPcw.Set( 0, bOn );
}

void CUshioEuvSeq::SeqUtControl()
{
	static BOOL bStMaint = FALSE;
	static BOOL bStAlarm = FALSE;

#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
//	if( !m_SeqFlag.bInitComp ) return;
	if( !m_pDicsData->m_GenInfo.bAuto ) return;

	if( IsEuvUse() /*&& m_pDicsData->m_GenInfo.bAuto*/ ) 
	{
#ifndef _MY_DEBUG
		if( ( !GetEuvAlarm() == 0 ) &&
			!GetUtState() &&
			!m_pEqpAssy->m_UshioEuv.GetUtN2FlowH() )
#else
		if( !GetUtState() )
#endif
		{
			UtControl( ON );
			LampEmergency( ON );
			// limjy_071114 : Add Euv Reset
			m_bEuvResetReq = TRUE;
		}
		// CMO G6 : Maint -> Auto ȯ Alarm ¿ UT Valve ON  Ѵ. (ȣ)
		else if( bStMaint && bStAlarm &&
				 !GetUtState() && 
				 !m_pEqpAssy->m_UshioEuv.GetUtN2FlowH() )
		{
			UtControl( ON );
		}
		if( bStAlarm && GetUtState() && ( GetEuvAlarm() == 0 ) ) bStAlarm = FALSE;
		if( bStMaint ) bStMaint = FALSE;
	}
	// Auto -> Maint mode ȯ  UtControl( OFF ) Ѵ.
	else
	{
		if( !bStMaint && GetUtState() )
		{
			UtControl( OFF );
		}

		if( !bStMaint || ( bStAlarm && !GetUtState() ) )
		{
			if( !m_pDicsData->m_GenInfo.bAuto ) bStMaint = TRUE;
		}
	}

	// Alarm  ߻  UtControl( OFF ) Ѵ.
	if( !bStAlarm && ( GetEuvAlarm() > 0 ) )
	{
		if( !bStAlarm && GetUtState() )
		{
			bStAlarm = TRUE;
			UtControl( OFF );
		}
	}
}

void CUshioEuvSeq::SeqEuvReset()
{
	static int nEuvResetSeqNo = 0;
	static DWORD dwTickStart = 0;

	switch( nEuvResetSeqNo )
	{
	case 0:
		if( GetUtState() && m_bEuvResetReq )
		{
			SetLog( "EUVRESET", 0, 0, "UERT <ON>" );

			m_pEqpAssy->m_UshioEuv.SetIfUert( ON );

			m_bEuvResetComp	= FALSE;
			m_bEuvResetReq	= FALSE;
			dwTickStart = GetTickCount();
			nEuvResetSeqNo = 10;
		}
		break;
	case 10:
		if( ( GetTickCount() - dwTickStart ) > 500 )
		{
			SetLog( "EUVRESET", 0, 0, "HUMIDIFIER_UHER <ON>" );

			m_pEqpAssy->m_UshioEuv.SetIfUher( ON );

			dwTickStart = GetTickCount();
			nEuvResetSeqNo = 20;
		}
		break;
	case 20:
		if( ( GetTickCount() - dwTickStart ) > 1000 )
		{
			SetLog( "EUVRESET", 0, 0, "UERT <OFF>, HUMIDIFIER_UHER <OFF>" );

			m_pEqpAssy->m_UshioEuv.SetIfUert( OFF );
			m_pEqpAssy->m_UshioEuv.SetIfUher( OFF );
			m_bEuvResetComp	= TRUE;
			nEuvResetSeqNo = 0;
		}
		break;
	}
}

int	CUshioEuvSeq::SetLampControl()	//For SeqEuv()
{
	int nControl = euvLAMP_OFF;
	static int nOldControl = euvLAMP_OFF;
	static BOOL bManualModeChangeComp = FALSE;

	BOOL bRunCond = TRUE;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bRunCond &= !m_pDicsData->m_GenInfo.bCoverOpen;

	BOOL bEuvUse		= IsEuvUse();
	BOOL bEuvAlarm		= GetEuvAlarm() > 0 ? TRUE : FALSE;
		 bEuvAlarm		= m_pDicsData->m_IfEuv.bEuvUtilAlarm;//2008.12.08 kimgun
	BOOL bGlassExist	= IsGlassExist();
	BOOL bCvRun			= FALSE;
#ifndef _TYPE7
	bCvRun				= m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_EUV );
#endif
	BOOL bHumReady		= IsHumReady();
	BOOL bEuvReady		= IsEuvReady();

	BOOL bEuvRun = TRUE;
	bEuvRun &= bRunCond;
	bEuvRun &= bEuvUse;
	bEuvRun &= !bEuvAlarm;
	bEuvRun &= bGlassExist;
	bEuvRun &= bCvRun;
//	bEuvRun &= bHumReady;no use
	bEuvRun &= bEuvReady;

//	BOOL bTimeOver = FALSE;
//	bTimeOver = GetOnTimeOver( bEuvRun );
//	bEuvRun &= bTimeOver ;

	BOOL bEuvReset = TRUE;
#ifndef _TYPE7
	bEuvReset &= m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_EUV );
	bEuvReset &= m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_EUV );
	bEuvReset &= m_pDicsData->m_GlsInfo[IF_UNIT_EUV*2+0].bIsValid;
#endif
	bEuvReset &= m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_LD );

	if( m_pDicsData->m_GenInfo.bAuto )
	{
		bManualModeChangeComp = FALSE;

		if( bEuvRun )
		{
			if( nOldControl == euvLAMP_OFF )
			{
				nControl = euvLAMP_ON;
			}
			else if( nOldControl >= euvLAMP_PAUSE )
			{
				nControl = euvLAMP_ON_KEEP;
			}
		}
		else
		{
//			if( !bGlassExist || !bTimeOver )
			if( !bGlassExist )
			{
				nControl = euvLAMP_OFF;
			}
			else if( nOldControl >= euvLAMP_PAUSE )
			{
				nControl = euvLAMP_PAUSE;
			}
		}
	}
	else
	{
		if( !bRunCond || !bManualModeChangeComp )
		{
			bManualModeChangeComp = TRUE;

			if( !bGlassExist )
			{
				nControl = euvLAMP_OFF;
			}
			else if( nOldControl >= euvLAMP_PAUSE )
			{
				nControl = euvLAMP_PAUSE;
			}
		}
		else
		{
			nControl = euvLAMP_MANUAL;
		}
	}
	
	if( nControl != euvLAMP_MANUAL ) nOldControl = nControl;

	return nControl;
}

void CUshioEuvSeq::SeqEuvProgress()
{
	static DWORD dwStartTick = 0;
	static int nOldControl = -1;
	static int nOldTime = 0;
	int nTime;
//	static BOOL bNextGlass = FALSE;
	BOOL bNextGlass = FALSE;
	DWORD dwEuvOnTime = 0;
#ifndef _NO_EUV
	dwEuvOnTime = (DWORD) ( ( m_pSetupItems->m_fValueCvLength[( IF_UNIT_EUV - IF_UNIT_UP_LD ) * 2 + 1] + GLASS_SIZE ) 
		                            / ( m_pDicsData->m_JobCond.nCvSpeed / 60 ) * 10 );
#endif
	int nControl = GetLampControl();
	
	int nSeqNo = m_nSeqEuvProgressNo;

	BOOL bEuvReset = TRUE;
#ifndef _NO_EUV
#ifndef _MY_DEBUG
	bEuvReset &= m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_EUV );
	bEuvReset &= m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_EUV );
#else
	bEuvReset &= m_pDicsData->m_bDebugOutSensor[IF_UNIT_EUV];
	bEuvReset &= m_pDicsData->m_bDebugInSensor[IF_UNIT_EUV];
#endif
	bEuvReset &= m_pDicsData->m_GlsInfo[IF_UNIT_EUV*2+0].bIsValid;
#endif
	bEuvReset &= m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_LD );

	switch ( nControl )
	{
	case euvLAMP_ON :
		if( nOldControl != euvLAMP_ON )
		{	// Progress starts
			Msg( WM_EUV_ON_PROGRESS, PROGRESS_START, dwEuvOnTime/10, FALSE );			

			TIMER_ON( TM_EUV_PROGRESS, dwEuvOnTime );
			nOldTime = 0;
	
			dwStartTick = GetTickCount();
		}
		break;
	case euvLAMP_OFF :
		if( nOldControl != euvLAMP_OFF )
		{	// Progress OFF
			Msg( WM_EUV_ON_PROGRESS, PROGRESS_END, 0, FALSE );			
			bNextGlass = FALSE;
			nOldTime = 0;
		}
		break;
	case euvLAMP_ON_KEEP :
		if( TIMER( TM_EUV_PROGRESS ) )
		{	// Progress ++->
			nOldTime = 0;
		}
		else if( m_pTimer->m_pTimer[TM_EUV_PROGRESS].bPause )
		{
			m_pTimer->RePlayTimer( TM_EUV_PROGRESS );					
		}
		
		nTime = (int)( m_pTimer->m_pTimer[TM_EUV_PROGRESS].dwNow / 100 );
		if( nTime - nOldTime > 2 )
		{
			nOldTime = nTime;
			
			Msg( WM_EUV_ON_PROGRESS, PROGRESS_SET, (LPARAM)nTime, FALSE );
		}
		//When glass enters before progress end..
#ifndef _TYPE7
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_EUV ) && 
			m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_EUV ) &&
			m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_EUV - 1 ) &&
			m_pDicsData->m_GlsInfo[IF_UNIT_EUV].bIsValid && !bNextGlass )
#else
		if( m_pDicsData->m_bDebugOutSensor[IF_UNIT_EUV] && 
			m_pDicsData->m_bDebugInSensor[IF_UNIT_EUV] &&
			m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_EUV - 1 ) && 
			m_pDicsData->m_GlsInfo[IF_UNIT_EUV].bIsValid && !bNextGlass )
#endif
#endif
		{
			if( !bNextGlass ) bNextGlass = TRUE;
			Msg( WM_EUV_ON_PROGRESS, PROGRESS_START, dwEuvOnTime/10, FALSE );			

			TIMER_ON( TM_EUV_PROGRESS, dwEuvOnTime );
			nOldTime = 0;
	
			dwStartTick = GetTickCount();
		}
		break;
	case euvLAMP_MANUAL :
	case euvLAMP_PAUSE :
		if( !m_pTimer->m_pTimer[TM_EUV_PROGRESS].bPause )
		{
			m_pTimer->PauseTimer( TM_EUV_PROGRESS );
		}
		break;			
	}

	if( nControl != euvLAMP_MANUAL ) nOldControl = nControl;

	m_nSeqEuvProgressNo = nSeqNo;
}

int	CUshioEuvSeq::GetEuvAlarm()
{
	int nRv = 0;
	
#ifndef _MY_DEBUG
	if( m_pEqpAssy->m_UshioEuv.GetIfUwll() )				nRv |= euvAlmLampUseTimeExcess;		// Lamp Used Time Over
	if( m_pEqpAssy->m_UshioEuv.GetIfUeuv() )				nRv |= euvAlmLampOnFail;			// Lamp On Fail
	if( m_pEqpAssy->m_UshioEuv.GetIfUesf() )				nRv |= euvAlmProtectiveFunction;	// Protective Function Appearance
	if( m_pEqpAssy->m_UshioEuv.GetIfUeel() )				nRv |= euvAlmElectricCircuit;		// Electric Circuit Error
//	if( m_pEqpAssy->m_UshioEuv.GetIfUwnh() )				nRv |= euvAlmN2PressSurplus	;		// N2 Pressure Surplus
	if( m_pEqpAssy->m_UshioEuv.GetIfUwlt() )				nRv |= euvAlmLampHouseTemp;			// Lamp House Temperature Error
	if( m_pEqpAssy->m_UshioEuv.GetIfUwlo() )				nRv |= euvAlmLampHouseOpen;			// Lamp House Open
	if( m_pEqpAssy->m_UshioEuv.GetIfUwtt() )				nRv |= euvAlmTransformerTemp;		// Step-up Transformer Temperature Error
	if( m_pEqpAssy->m_UshioEuv.GetIfUwnl() )				nRv |= euvAlmN2PressDrop;			// Lamp House N2 Pressure Drop
	if( m_pEqpAssy->m_UshioEuv.GetIfUeco() )				nRv |= euvAlmElectricCompCover;		// Electric Component Cover Open 
	if( m_pEqpAssy->m_UshioEuv.GetIfUcpu() )				nRv |= euvAlmControlSystem;			// Control System Error
	if( m_pEqpAssy->m_UshioEuv.GetIfUemo() )				nRv |= euvAlmEMO;					// EMO
#else
	nRv = 0;
#endif
	return nRv;
}

BOOL CUshioEuvSeq::GetLampOnState()
{
	BOOL bOn;
#ifndef _MY_DEBUG
//	bOn = dosIF_GSUV_LAMP_ON;
	bOn = m_pEqpAssy->m_UshioEuv.GetIfUlonState();
#else
	bOn = m_pEqpAssy->m_UshioEuv.GetIfUlonState();
#endif
	return bOn;
}

BOOL CUshioEuvSeq::IsRemoteMode()
{	
	BOOL bMode;
#ifndef _MY_DEBUG	
//	bMode = ( diIF_GSUV_AUTO_MODE ? TRUE : FALSE );
	bMode = ( m_pEqpAssy->m_UshioEuv.GetIfUnre() ? TRUE : FALSE );
#else
	bMode = TRUE;
#endif

	return bMode;
}

BOOL CUshioEuvSeq::GetHouseCloseState()
{
	BOOL bClose = TRUE;
	
#ifndef _MY_DEBUG
#ifndef _NO_EUV
	bClose &= m_pEqpAssy->m_SensorEuvHouseClose.GetAnd();
	bClose &= m_pEqpAssy->m_CylinderEuvUpDn.GetBw( 0 );//2009.01.20 kimgun
	bClose &= !m_pEqpAssy->m_CylinderEuvUpDn.GetFw( 0 );//2009.01.20 kimgun
//	bClose &= !m_pEqpAssy->m_UshioEuv.GetIfUwlo();	//2009.01.20 kimgun ̰Ŵ house coverϱ ̰ ߵ. Use it after EUV I/F test 
#endif
#endif
	
	return bClose;
}

BOOL CUshioEuvSeq::GetLampOnSelected( int nLampNo )
{
	BOOL bSelected;

	bSelected = m_pEqpAssy->m_UshioEuv.GetIfUlsState( nLampNo );

	return bSelected;
}

BOOL CUshioEuvSeq::IsGlassExist()
{
	BOOL bGlassExist = FALSE;
#ifndef _TYPE7
#ifndef _MY_DEBUG
//	bGlassExist |= m_pEqpAssy->m_GlassExistUnit.GetOr( ( IF_UNIT_EUV - 1 )*2 + 1 );
	bGlassExist |= m_pEqpAssy->m_GlassExistUnit.GetOr( IF_UNIT_EUV*2 ); 
	bGlassExist |= m_pEqpAssy->m_GlassExistUnit.GetOr( IF_UNIT_EUV*2 + 1 );
#else
//	bGlassExist |= (( CDicsView* ) m_pOwnerWnd )->m_pDicsData->m_bDebugOutSensor[IF_UNIT_EUV-1];
	bGlassExist |= (( CDicsView* ) m_pOwnerWnd )->m_pDicsData->m_bDebugInSensor[IF_UNIT_EUV];
	bGlassExist |= (( CDicsView* ) m_pOwnerWnd )->m_pDicsData->m_bDebugOutSensor[IF_UNIT_EUV];
#endif
#endif	
	return bGlassExist;
}

BOOL CUshioEuvSeq::GetEuvCond()			//for CCvSeq->CheckUnitCondition
{
	static BOOL bCheckMargine = FALSE;
	static BOOL s_bLampSelsect = FALSE;
	BOOL bOk = FALSE;
	
	BOOL bEuvUse		= IsEuvUse();
	BOOL bGlassExist	= IsGlassExist();
	BOOL bCvRun = FALSE;
#ifndef _NO_EUV
	bCvRun			= m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_EUV );
#endif
	BOOL bEuvState		= ( IsEuvReady() /*& IsHumReady()*/);//khh080111 Recipe  Euv    C/V ߴ  .
	
	BOOL bEuvAlarm = FALSE;
	bEuvAlarm |= GetEuvAlarm() > 0 ? TRUE : FALSE;
	bEuvAlarm |= m_pDicsData->m_IfEuv.bEuvUtilAlarm;
	
	BOOL bEuvRun = TRUE;
	bEuvRun &=  bEuvUse;
	bEuvRun &=  bGlassExist;
	bEuvRun &=  bCvRun; //̰  EUV Ready ȵǸ C/V ݺ  Ѵ. 
	bEuvRun &= !bEuvAlarm;
	//	bEuvRun &= m_IfEuv.bLampOnTimer;
	if( rcpLampSelect() )
	{
		bEuvRun &= bEuvState;	
	}
	
	if( !bEuvRun )
	{
		if( bEuvAlarm ) bOk = FALSE;
		else if( !GetLampOnState() ) 
		{
			bOk = TRUE;
		}
		 
	}
	else
	{
		if( bCvRun && GetLampOnState() )
		{
			bCheckMargine = FALSE;
			bOk = TRUE;
		}
		else if( !bCvRun && !bEuvAlarm )
		{
			bCheckMargine = FALSE;
			bOk = TRUE;
		}
		else if( bCvRun && !GetLampOnState() )
		{
			if( !bCheckMargine )
			{
				bCheckMargine = TRUE;
				bOk = TRUE;
			}
			else
			{
				bOk = FALSE;
			}
		}
	}

	return bOk;
}

BOOL CUshioEuvSeq::GetUtState()
{
	BOOL bOk = TRUE;

	bOk &= m_pEqpAssy->m_AutoValveEuvN2.GetState();	
	bOk &= m_pEqpAssy->m_AutoValveEuvPcw.GetState();

	return bOk;
}

//---------------------------------------------------------------------------
// Local Mode 
//---------------------------------------------------------------------------
BOOL CUshioEuvSeq::LampLocalLock( BOOL bOn )
{
	m_pEqpAssy->m_UshioEuv.SetIfUdlc( bOn ); // Local Mode   
	return TRUE;
}

//---------------------------------------------------------------------------
// Remote
//---------------------------------------------------------------------------
BOOL CUshioEuvSeq::LampRemote( BOOL bOn )
{
	if( bOn )
	{
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_UshioEuv.GetIfUcre() ) m_pEqpAssy->m_UshioEuv.SetIfUtre( bOn ); // Remote Mode  
#else
		if( 1 ) m_pEqpAssy->m_UshioEuv.SetIfUtre( bOn ); // Remote Mode  
#endif 	
		else
		{
//			m_sErrorMessage = "EUV Warning : Remote Mode Failed (UCRE = 0)";
			return FALSE;
		}
	}
	else m_pEqpAssy->m_UshioEuv.SetIfUtre( bOn );

	return TRUE;
}

//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
BOOL CUshioEuvSeq::LampEmergency( BOOL bOn )
{
	m_pEqpAssy->m_UshioEuv.SetIfUemg( bOn );
	return TRUE;
}

BOOL CUshioEuvSeq::HumidifierReset( BOOL bOn )
{
	m_pEqpAssy->m_UshioEuv.SetIfUher( bOn );
	return TRUE;
}

int CUshioEuvSeq::GetBCC( CString sData )
{
	int nBCC = 0;
	int nVal = 0;
	int nSize = sData.GetLength();

	for( int i=0 ; i<nSize ; i++ )
	{
		nVal = sData.GetAt( i );

		if( i == 0 )
		{
			nBCC = nVal;
		}
		else
		{
			nBCC = nBCC ^ nVal;
		}
	}

	return nBCC;
}


#define _INTENSITY		100
#define _LIFE_TIME		200
void CUshioEuvSeq::SeqCommEuv()
{
	int nSeqNo = m_nSeqCommEuv;
	int nBCC = 0;

	CString sRecvData = "";
	static CString sCommand = "";
	static DWORD dwStartTick = 0;
	static int nLampNo = 0;	
	static int nCount = 0;
	static int nDelay = 0;
	static int nAlarmId = 0;
	static int nReturnSeqNo;

	switch( nSeqNo )
	{
	case 0:
		{
			BOOL bCheckIntensity = FALSE;
			bCheckIntensity |= m_pEqpAssy->m_UshioEuv.GetIfUlonState();
#ifndef _NO_EUV
			bCheckIntensity |= m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_EUV );
			bCheckIntensity |= m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_EUV );
#endif
			bCheckIntensity |= m_pEqpAssy->m_CvMotor.GetMotorFwState( IF_UNIT_LD );

			if( bCheckIntensity ||
				( nDelay > 0 ) )
			{
				if( bCheckIntensity ) nDelay = 10;
				else nDelay--;

				sCommand.Format( "LA0D" );
			}
			else
			{
				nDelay = 0;
				if( nLampNo >= MAX_LAMP_NO ) nLampNo = 1;
				else nLampNo++;

				CString sData = "";
				sData.Format( "RT%02d0001", nLampNo );
				nBCC = GetBCC( sData );

				sCommand.Format( "RT%02d0001%02X", nLampNo, nBCC );
			}

			nSeqNo = 10;
		}
		break;
	case 10:
		{
			if( m_pMuxCom->SendCommand( sCommand ) )
			{
				dwStartTick = GetTickCount();

				if( sCommand == "LA0D" ) nSeqNo = _INTENSITY;
				else nSeqNo = _LIFE_TIME;
			}
		}
		break;

	case _INTENSITY:
		if( m_pMuxCom->IsCommRcvd() )
		{
			sRecvData = m_pMuxCom->m_sReceivedData;

			if( sRecvData.GetLength() == 32 )
			{
				if( sRecvData.Mid( 1, 2 ) == "LA" )
				{
					if( sRecvData.Mid( 3, 2 ) == "00" )
					{
						for( int i = 0; i < MAX_LAMP_NO; i++ )
						{
							m_IfEuv.fLampIntensity[i] = (float)atof( sRecvData.Mid( 5 + (i*3), 3 ) );
							m_pDicsData->m_IfEuv.fLampIntensity[i] = m_IfEuv.fLampIntensity[i];
						}
					}
					else
					{
						for( int i = 0; i < MAX_LAMP_NO; i++ )
						{
							m_IfEuv.fLampIntensity[i] = .0;
							m_pDicsData->m_IfEuv.fLampIntensity[i] = .0;
						}
					}
				}
			}

			dwStartTick = GetTickCount();
			nSeqNo = 300;
		}
		else if( ( GetTickCount() - dwStartTick ) > 2000 )
		{
			nReturnSeqNo = 0;
			nSeqNo = 1000;
		}
		break;

	case _LIFE_TIME:
		if( m_pMuxCom->IsCommRcvd() )
		{
			sRecvData = m_pMuxCom->m_sReceivedData;

			if( sRecvData.GetLength() == 12 )
			{
				if( sRecvData.Mid( 1, 2 ) == "RT" )
				{
					int nIndex = nLampNo - 1;

					if( sRecvData.Mid( 3, 2 ) == "00" )
					{
						m_IfEuv.nLampOnTime[nIndex] = (int)atoi( sRecvData.Mid( 5, 4 ) );
					}
					else
					{
						m_IfEuv.nLampOnTime[nIndex] = 0;
					}
				}
			}

			dwStartTick = GetTickCount();
			nSeqNo = 300;
		}
		else if( ( GetTickCount() - dwStartTick ) > 2000 )
		{
			nReturnSeqNo = 0;
			nSeqNo = 1000;
		}
		break;

	case 300:
		if( ( GetTickCount() - dwStartTick ) > 1000 )
		{
			nSeqNo = 0;
		}
		break;

	case 1000:
		{
			nCount++;
			if( nCount >= 4 ) 
			{
				nCount = 0;
				//SET ALARM
#ifndef _NO_EUV
				nAlarmId = ALM_EUV_COMM_OPEN_ERROR;
#endif
				m_pEqpStateSeq->SetAlarm( nAlarmId );
				dwStartTick = GetTickCount();
				nSeqNo = 1010;
			}
			else
			{
				nSeqNo = 0;
			}
		}
		break;
	case 1010:
		if( m_pEqpStateSeq->IsPushedAlarmReset() &&
			( ( GetTickCount() - dwStartTick ) > 1000 ) )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId );
			nAlarmId = 0;

			nSeqNo = nReturnSeqNo;
		}
		break;
	}

	m_nSeqCommEuv = nSeqNo;
}

BOOL CUshioEuvSeq::rcpLampSelect()
{
	///////////////////////////////////////////////////////////////////////////
	// limjy_071114 : "BOOL bLampSelect = FALSE" ϸ Setup  
	//				  Recipe󿡼 EUV Lamp  N2, PCW .
	//				  ׷ Ǹ ٽ EUV Ready ° Ǳ ؼ 30
	//				  ҿǱ  Setup Item  ش. (CMO G6)
	///////////////////////////////////////////////////////////////////////////
	BOOL bLampSelect = FALSE;
	for( int i=0; i<MAX_LAMP_CONTROL_NO; i++ )
	{
		bLampSelect |= m_pDicsData->m_JobCond.bEuvUse[i];
	}
	return bLampSelect;
}

//---------------------------------------------------------------------------
// Set the Log
//2008.12.17 kimgun
//---------------------------------------------------------------------------
void CUshioEuvSeq::SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage )
{
	// Log
	CString sLog;
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );
	
	sLog.Format( "EUV\t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( sLog );
	if( m_pDicsData->m_GenInfo.bEnableEqpLog )
	{
		sLog.Format( "%s : %s", sSeqName, sMessage );
		Msg( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) sLog );
	}
}
