// UshioEuvSeq.h: interface for the CUshioEuvSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_USHIOEUVSEQ_H__433E1D4C_D37B_4A89_8682_209800731064__INCLUDED_)
#define AFX_USHIOEUVSEQ_H__433E1D4C_D37B_4A89_8682_209800731064__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\MOTHER\DicsEuvSeq.h"
#include "..\X\MuxCom.h"

class CUshioEuvSeq : public CDicsEuvSeq  
{
public:
	BOOL rcpLampSelect();
	CUshioEuvSeq();
	virtual ~CUshioEuvSeq();

	enum euvSTATUS
	{
		euvREMOTE_MODE			= 0x01,
		euvREMOTE_MODE_POSSIBLE	= 0x02,
		euvBUSY					= 0x04,
		euvREADY				= 0x08,
	};

	enum euvALARMINDEX
	{	// USHIO 
		euvAlmLampUseTimeExcess		= 0x01,		// Lamp Use Time Excess
		euvAlmLampOnFail			= 0x02,		// Lamp On Fail
		euvAlmProtectiveFunction	= 0x04,		// Protective Function Appearance
		euvAlmElectricCircuit		= 0x08,		// Electric Circuit Anomaly
		euvAlmN2PressSurplus		= 0x10,		// N2 Press Surplus
		euvAlmLampHouseTemp			= 0x20,		// Lamp House Temp Anomaly
		euvAlmLampHouseOpen			= 0x40,		// Lamp House Open
		euvAlmTransformerTemp		= 0x80,		// Step-up Transformer Temp Anomaly
		euvAlmN2PressDrop			= 0x100,	// N2 Press Drop
		euvAlmElectricCompCover		= 0x200,	// Electric Component Cover Open
		euvAlmControlSystem			= 0x400,	// Control System Anomaly
		euvAlmEMO					= 0x800,	// EMO
	};
	
	enum humidifierSTATUS
	{
		humREADY	= 0x01,
		humABNORMAL	= 0x02,
	};

	CMuxCom*	m_pMuxCom;
	int			m_nSeqEuvUtilAlarmNo;
	int			m_nSeqHumAlarmNo;
	int			m_nSeqCommEuv;

	void SetInitialCount(BOOL bInitialCount);
	void SetCommEuv( CMuxCom * pComm) { m_pMuxCom = pComm; }
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );//2008.12.17 kimgun

	void InitParameter();
	void SeqInit();

	int GetStatus();
	int	GetEuvAlarm();
	int	SetLampControl();

	void SeqEuvReset();
	void SeqEuvAlarm();
	void SeqHumAlarm();
	void SeqTimeOver( int i );

	void SeqCommEuv();		//RS232C, LampOnTime & Intensity
	void SeqUtControl();
	void SeqEuvProgress();
	void SeqEuvUtilAlarm();
	
	void LampOnSelect( );
	void LampOnSelect( int nLampNo, BOOL bOn );
	void LampControl( BOOL bOn );
	void UtControl( BOOL bOn );

	BOOL Sequence();

	BOOL IsEuvUse();
	BOOL IsEuvReady();
	BOOL IsHumReady();
	BOOL IsGlassExist();
	BOOL IsRemoteMode();
	BOOL GetInitialCount();
	BOOL GetEuvCond();
	BOOL GetUtState();
	BOOL GetLampOnState();
	BOOL GetLampOnSelected( int nLampNo );
	BOOL GetHouseCloseState();
	BOOL GetEuvUtilAlarm();
	BOOL LampLocalLock( BOOL bOn );
	BOOL LampRemote( BOOL bOn );
	BOOL LampEmergency( BOOL bOn );
	BOOL HumidifierReset( BOOL bOn );

	int GetBCC( CString sData );
	int GetHumStatus();
	int GetHumAlarm();

	float GetLampIntensity( int nPos );

private:
	BOOL m_bEuvResetReq;
	BOOL m_bEuvResetComp;
};

#endif // !defined(AFX_USHIOEUVSEQ_H__433E1D4C_D37B_4A89_8682_209800731064__INCLUDED_)
