// AlarmsTab1View.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "AlarmsTab1View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAlarmsTab1View

IMPLEMENT_DYNCREATE(CAlarmsTab1View, CFormView)

CAlarmsTab1View::CAlarmsTab1View()
	: CFormView(CAlarmsTab1View::IDD)
{
	//{{AFX_DATA_INIT(CAlarmsTab1View)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CAlarmsTab1View::CAlarmsTab1View(CView* pView, int nTabNo )
	: CFormView(CAlarmsTab1View::IDD)
{
	//{{AFX_DATA_INIT(CAlarmsTab1View)
	m_dtFrom = COleDateTime::GetCurrentTime();
	m_dtTo = COleDateTime::GetCurrentTime();
	m_sSearchContents = _T("");
	m_sSearchCode = _T("");
	//}}AFX_DATA_INIT

	// Ⱓ ϰ Ҷ ⺻ 1  Ÿ ǥϵ Ѵ.
	COleDateTimeSpan dtSpan( 6, 0, 0, 0 );
	m_dtFrom	= COleDateTime::GetCurrentTime() - dtSpan;
	m_dtTo		= COleDateTime::GetCurrentTime();
	m_lErrorCount =  0;

	// Set view
	m_pView = pView;
	m_nTabNo = nTabNo;
}

CAlarmsTab1View::~CAlarmsTab1View()
{
}

void CAlarmsTab1View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAlarmsTab1View)
	DDX_Control(pDX, IDC_DT_TO, m_dtToCtrl);
	DDX_Control(pDX, IDC_DT_FROM, m_dtFromCtrl);
	DDX_Control(pDX, IDC_LIST_ERROR, m_lcErrHist);
	DDX_DateTimeCtrl(pDX, IDC_DT_FROM, m_dtFrom);
	DDX_DateTimeCtrl(pDX, IDC_DT_TO, m_dtTo);
	DDX_Text(pDX, IDC_EDIT_SEARCH_CONTENTS, m_sSearchContents);
	DDX_Text(pDX, IDC_EDIT_SEARCH_CODE, m_sSearchCode);
	DDX_Control(pDX, IDC_SEARCH_CODE, m_macSearchCode );
	DDX_Control(pDX, IDC_SEARCH_CONTENTS, m_macSearchContents );
	DDX_Control(pDX, IDC_RB_TIME_AREA1, m_RbTimeArea1);
	DDX_Control(pDX, IDC_RB_TIME_AREA2, m_RbTimeArea2);
	DDX_Control(pDX, IDC_BTN_KEYBOARD, m_KeyIn);
	DDX_Control(pDX, IDC_ALARM_RESET, m_macAlarmReset );	// SanghoCho 2015.05.12
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAlarmsTab1View, CFormView)
	//{{AFX_MSG_MAP(CAlarmsTab1View)
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_DT_TO, OnDatetimechangeDtTo)
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_DT_FROM, OnDatetimechangeDtFrom)
	ON_BN_CLICKED(IDC_RB_TIME_AREA2, OnRbTimeArea2)
	ON_BN_CLICKED(IDC_RB_TIME_AREA1, OnRbTimeArea1)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST_ERROR, OnColumnclickListError)
	ON_BN_CLICKED(IDC_SEARCH_CODE, OnSearchCode)
	ON_BN_CLICKED(IDC_SEARCH_CONTENTS, OnSearchContents)
	ON_BN_CLICKED(IDC_BTN_KEYBOARD, OnBtnKeyboard)
	ON_BN_CLICKED(IDC_ALARM_RESET, OnBtnAlarmReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAlarmsTab1View diagnostics

#ifdef _DEBUG
void CAlarmsTab1View::AssertValid() const
{
	CFormView::AssertValid();
}

void CAlarmsTab1View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAlarmsTab1View message handlers

BOOL CAlarmsTab1View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CAlarmsTab1View::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	m_KeyIn.LoadBitmaps(IDB_BITMAP_KBD_PULL, IDB_BITMAP_KBD_PUSH, IDB_BITMAP_KBD_PULL, IDB_BITMAP_KBD_PULL );

	// Set the MAC button
	MAC_COLOR_SET color_set;
	m_macSearchCode.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macSearchCode.SetColorSetting( color_set );
	m_macSearchCode.SetBold();

	m_macSearchContents.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macSearchContents.SetColorSetting( color_set );
	m_macSearchContents.SetBold();

	m_macAlarmReset.GetColorSetting( &color_set );	// SanghoCho 2015.05.12
	color_set.crFace = LIGHT_RED_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macAlarmReset.SetColorSetting( color_set );
	m_macAlarmReset.SetBold();

	m_RbTimeArea1.SetBold();
	m_RbTimeArea1.SetCheckColor( RED_COLOR );
	m_RbTimeArea1.SetCheck( TRUE );
	m_RbTimeArea2.SetBold();
	m_RbTimeArea2.SetCheckColor( RED_COLOR );
	
	m_lcErrHist.SetExtendedStyle(LVS_EX_FULLROWSELECT |
								LVS_EX_ONECLICKACTIVATE | 
								LVS_EX_UNDERLINEHOT | 
								LVS_EX_GRIDLINES);
	AddColumn();
	
	CDicsDoc* pDoc = (CDicsDoc*) m_pView->GetDocument();

	if( pDoc->m_pErrHistSet->IsOpen() ) pDoc->m_pErrHistSet->Close();
	pDoc->m_pErrHistSet->m_strSort = "ErrorTime DESC, ErrorID, ErrorLevel, ErrorContent";
	pDoc->m_pErrHistSet->Open();
	
	FillData();

	// DateTimePicker     Ѵ.
	SubResetDtPickerRange( m_dtFrom, m_dtTo );

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	if ( ( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_GenInfo.bAuto )
	{
		GetDlgItem( IDC_SEARCH_CODE )->EnableWindow( FALSE );
		GetDlgItem( IDC_SEARCH_CONTENTS )->EnableWindow( FALSE );
		GetDlgItem( IDC_RB_TIME_AREA1 )->EnableWindow( FALSE );
		GetDlgItem( IDC_RB_TIME_AREA2 )->EnableWindow( FALSE );
		GetDlgItem( IDC_DT_TO )->EnableWindow( FALSE );
		GetDlgItem( IDC_DT_FROM )->EnableWindow( FALSE );
		GetDlgItem( IDC_EDIT_SEARCH_CODE )->EnableWindow( FALSE );
		GetDlgItem( IDC_EDIT_SEARCH_CONTENTS )->EnableWindow( FALSE );
	}
}

//---------------------------------------------------------------------------
// Add Column
//---------------------------------------------------------------------------
void CAlarmsTab1View::AddColumn()
{
	int i = 0;
	//ListControl ʱȭ
	int nLvcFmt[] = { LVCFMT_CENTER, LVCFMT_CENTER, LVCFMT_LEFT, LVCFMT_CENTER, LVCFMT_LEFT, LVCFMT_LEFT };
	LPTSTR sLvcText[] = { "No", 
						  "               Time               ", 
						  "  Code  ", 
						  "Level", 
						  "                                                                          Contents                                                                  ",
						  "" };

	LV_COLUMN lvc;
	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	int nLen = sizeof( sLvcText ) / sizeof( LPTSTR );
	for( i=0; i<nLen - 1; i++ )
	{
		lvc.fmt = nLvcFmt[i];
		lvc.pszText = sLvcText[i];
		lvc.cx = m_lcErrHist.GetStringWidth( lvc.pszText ) + 15;
		m_lcErrHist.InsertColumn( i, &lvc );
	}
	lvc.fmt = nLvcFmt[i];
	lvc.pszText = sLvcText[i];
	lvc.cx = 0;
	m_lcErrHist.InsertColumn( i, &lvc );
}


#define MAX_ALARM_LIST_IN_AUTO_MODE	 50	//Auto Mode  Alarm List 
//---------------------------------------------------------------------------
// Fill Data
//---------------------------------------------------------------------------
void CAlarmsTab1View::FillData()
{
	LV_ITEM		lvitem;
	char temp[100];
	int i = 0;
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	CDicsDoc* pDoc = (CDicsDoc*) m_pView->GetDocument();
	if( !pDoc->m_pErrHistSet->IsOpen() ) return;

	m_lcErrHist.DeleteAllItems();
// jemoon : 050412 ->
	if( !pDoc->m_pErrHistSet->GetRecordCount() ) return;
	else pDoc->m_pErrHistSet->MoveFirst();
// jemoon : 050412 <-
	while( !pDoc->m_pErrHistSet->IsEOF() )
	{
		// Index
		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = i;
		lvitem.iSubItem = 0;
		sprintf( temp,"%ld", i + 1 );
		lvitem.pszText = temp;
		m_lcErrHist.InsertItem( &lvitem );

		// Time
		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = i;
		lvitem.iSubItem = 1;
		sprintf( temp, "%02d-%02d-%02d %02d:%02d:%02d",
			pDoc->m_pErrHistSet->m_ErrorTime.GetYear(),
			pDoc->m_pErrHistSet->m_ErrorTime.GetMonth(),
			pDoc->m_pErrHistSet->m_ErrorTime.GetDay(),
			pDoc->m_pErrHistSet->m_ErrorTime.GetHour(),
			pDoc->m_pErrHistSet->m_ErrorTime.GetMinute(),
			pDoc->m_pErrHistSet->m_ErrorTime.GetSecond()
		);
		lvitem.pszText = temp;
		m_lcErrHist.SetItem( &lvitem );

		// Code
		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = i;
		lvitem.iSubItem = 2;
		sprintf( temp,"%ld", pDoc->m_pErrHistSet->m_ErrorID );
		lvitem.pszText = temp;
		m_lcErrHist.SetItem( &lvitem );

		// Level
		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = i;
		lvitem.iSubItem = 3;
		sprintf( temp,"%s", pDoc->m_pErrHistSet->m_ErrorLevel );
		lvitem.pszText = temp;
		m_lcErrHist.SetItem( &lvitem );

		// Content
		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = i;
		lvitem.iSubItem = 4;
		sprintf( temp,"%s", pDoc->m_pErrHistSet->m_ErrorContent );
		lvitem.pszText = temp;
		m_lcErrHist.SetItem( &lvitem );

		// Key ID (hiding item)
		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = i;
		lvitem.iSubItem = 5;
		sprintf( temp,"%d", pDoc->m_pErrHistSet->m_ID );
		lvitem.pszText = temp;
		m_lcErrHist.SetItem( &lvitem );

		if( pDoc->m_pErrHistSet->m_ErrorLevel == "S" ) m_lcErrHist.SetCheck( i, TRUE );

		pDoc->m_pErrHistSet->MoveNext();
		i++;

		// Display only MAX_ALARM_LIST_IN_AUTO_MODE list of alarm when auto mode 
		if( i == MAX_ALARM_LIST_IN_AUTO_MODE )
		{
			if ( ( (CDicsView*) pApp->m_pMainView )->m_pDicsData->m_GenInfo.bAuto ) 
			{
				m_lErrorCount = i;
				return;
			}
		}
	}

	// Save the record number
	m_lErrorCount = i;
}

//---------------------------------------------------------------------------
// OnDelete
//---------------------------------------------------------------------------
void CAlarmsTab1View::OnDelete() 
{
	if( MessageBox( "Do you really delete the selected items?", "Delete", MB_ICONQUESTION | MB_YESNO | MB_DEFBUTTON2) != IDYES ) return;

	// Open the DB
	CDicsDoc* pDoc = (CDicsDoc*) m_pView->GetDocument();
	if( !pDoc->m_pErrHistSet ) return;
	if( !pDoc->m_pErrHistSet->IsOpen() ) return;

	POSITION pos = m_lcErrHist.GetFirstSelectedItemPosition();
	if (pos == NULL)
	{
		AfxMessageBox( "Select the record(s) that you want delete", MB_OK | MB_ICONSTOP | MB_SYSTEMMODAL );
		return;
	}
	else
	{
		while( pos )
		{
			int nItem = m_lcErrHist.GetNextSelectedItem( pos );
			int nID = atoi(m_lcErrHist.GetItemText( nItem, 5 ) );
			pDoc->m_pErrHistSet->DelErrData( nID );
		}
		FillData();
	}
}

//---------------------------------------------------------------------------
// OnColumnclickListError : Sorting
//---------------------------------------------------------------------------
void CAlarmsTab1View::OnColumnclickListError(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	CDicsDoc* pDoc = (CDicsDoc*) m_pView->GetDocument();
	switch( pNMListView->iSubItem )
    {
	case 1: // Time
		//if( pDoc->m_pErrHistSet->IsOpen() ) pDoc->m_pErrHistSet->Close();
		pDoc->m_pErrHistSet->m_strSort = "ErrorTime DESC, ErrorID, ErrorLevel, ErrorContent";
		break;
    case 2: // Code
		//if (pDoc->m_pErrHistSet->IsOpen()) pDoc->m_pErrHistSet->Close();
		pDoc->m_pErrHistSet->m_strSort = "ErrorID, ErrorTime DESC, ErrorLevel, ErrorContent";
		break;

	case 3:	// Level
		//if (pDoc->m_pErrHistSet->IsOpen()) pDoc->m_pErrHistSet->Close();
		pDoc->m_pErrHistSet->m_strSort = "ErrorLevel, ErrorContent, ErrorTime DESC, ErrorID";
		break;

	case 4:	// Content
		//if (pDoc->m_pErrHistSet->IsOpen()) pDoc->m_pErrHistSet->Close();
		pDoc->m_pErrHistSet->m_strSort = "ErrorContent, ErrorLevel, ErrorTime DESC, ErrorID";
		break;
	default:
		return;
    }
	//pDoc->m_pErrHistSet->Open();
	pDoc->m_pErrHistSet->Requery();
	FillData();
	
	*pResult = 0;
}

//---------------------------------------------------------------------------
// OnSaveFile
//---------------------------------------------------------------------------
void CAlarmsTab1View::OnSaveFile() 
{
	// Backup the current directory
	char szPathName[100];
	GetCurrentDirectory( 100, szPathName );

	// Open the File Open Dialog
	CFileDialog fileOpenDlg( FALSE, _T("log"), NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
		_T( "ErrorHist File (*.txt)|*.txt||" ) );
	
	if( fileOpenDlg.DoModal() != IDOK ) return;
	SaveTextFile( fileOpenDlg.GetPathName() );

	// Set to the original path
	SetCurrentDirectory( szPathName );
}

//---------------------------------------------------------------------------
// SaveTextFile
//---------------------------------------------------------------------------
void CAlarmsTab1View::SaveTextFile(CString sFileName)
{
	// Create the file
	CFile File;
	if( File.Open( sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone ) == 0 )
	{
		AfxMessageBox("File Creation Error !!");
		return;
	}

	// Read from list control and then add to text file as below
	// Table : No / Time / Code / Level / Content
	CString sOneDataLine = " NO \tTIME \t\t\tCODE \tLEVEL \tCONTENTS  ";
	File.Write( sOneDataLine + "\r\n", sOneDataLine.GetLength() + 2 );
	sOneDataLine = "---------------------------------------------------------------------------------------------------";
	File.Write( sOneDataLine + "\r\n", sOneDataLine.GetLength()+2 );

	for( int i=0 ; i<m_lErrorCount ; i++ )
	{
		sOneDataLine = "";
		sOneDataLine = m_lcErrHist.GetItemText( i, 0 )
					+ "\t" + m_lcErrHist.GetItemText( i, 1 )
					+ "\t" + m_lcErrHist.GetItemText( i, 2 )
					+ "\t" + m_lcErrHist.GetItemText( i, 3 )
					+ "\t" + m_lcErrHist.GetItemText( i, 4 );
		File.Write( sOneDataLine + "\r\n", sOneDataLine.GetLength()+2 );
	}
	File.Close();
}

//---------------------------------------------------------------------------
// OnRbTimeArea1 : Display all the items (All)
//---------------------------------------------------------------------------
void CAlarmsTab1View::OnRbTimeArea1() 
{
	CDicsDoc* pDoc = (CDicsDoc*) m_pView->GetDocument();
//	if( pDoc->m_pErrHistSet->IsOpen() ) pDoc->m_pErrHistSet->Close();
	pDoc->m_pErrHistSet->m_strSort = "ErrorTime DESC, ErrorID, ErrorLevel, ErrorContent";
	pDoc->m_pErrHistSet->m_strFilter = "";
	pDoc->m_pErrHistSet->Requery();
//	pDoc->m_pErrHistSet->Open();
	FillData();
}

//---------------------------------------------------------------------------
// OnRbTimeArea2 : Display the items that is selected period. (Period)
//---------------------------------------------------------------------------
void CAlarmsTab1View::OnRbTimeArea2() 
{
	UpdateData( TRUE );

	// ǥڿ 1 Ѵ.  11/11 ~ 11/11  ˻ ߴٸ,
	// 11/11 00:00 ~ 11/11 00:00   Select Ǳ ,
	// ȭ鿡 11/11 ~ 11/11 Ͽٸ δ 11/11 ~ 11/12  ˻ؾ
	// ǵߴ   ȴ.

	CString sFilter;
	COleDateTimeSpan dtSpan( 1, 0, 0, 0 );
	m_dtTo = m_dtTo + dtSpan;
	sFilter.Format( "[ErrorTime] >= #%04d/%02d/%02d# and [ErrorTime] < #%04d/%02d/%02d#",
				m_dtFrom.GetYear(),
				m_dtFrom.GetMonth(),
				m_dtFrom.GetDay(),
				m_dtTo.GetYear(),
				m_dtTo.GetMonth(),
				m_dtTo.GetDay() );

	CDicsDoc* pDoc = (CDicsDoc*)m_pView->GetDocument();
	//if( pDoc->m_pErrHistSet->IsOpen() ) pDoc->m_pErrHistSet->Close();
	pDoc->m_pErrHistSet->m_strFilter = sFilter;
	pDoc->m_pErrHistSet->Requery();
	//pDoc->m_pErrHistSet->Open();
	FillData();
}

//---------------------------------------------------------------------------
// OnDatetimechangeDtFrom
//---------------------------------------------------------------------------
void CAlarmsTab1View::OnDatetimechangeDtFrom(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData( TRUE );

	// DateTimePicker     Ѵ.
	SubResetDtPickerRange( m_dtFrom, m_dtTo );
	
	*pResult = 0;
}

//---------------------------------------------------------------------------
// OnDatetimechangeDtTo
//---------------------------------------------------------------------------
void CAlarmsTab1View::OnDatetimechangeDtTo(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData( TRUE );

	// DateTimePicker     Ѵ.
	SubResetDtPickerRange(m_dtFrom, m_dtTo);

	*pResult = 0;
}

//---------------------------------------------------------------------------
// OnSearchCode
//---------------------------------------------------------------------------
void CAlarmsTab1View::OnSearchCode() 
{
	CDicsDoc* pDoc = (CDicsDoc*)m_pView->GetDocument();

	// Sorting by Ascending
	pDoc->m_pErrHistSet->m_strSort = "ErrorID ASC"; 

	UpdateData( TRUE );
	
	//  Search by code
	CString sFilter;
	if( !m_sSearchCode.IsEmpty() )
	{
		sFilter.Format( "[ErrorID] LIKE '*%s*' ", m_sSearchCode );
	}

	pDoc->m_pErrHistSet->m_strFilter = sFilter;
	pDoc->m_pErrHistSet->Requery();
	FillData();
}

//---------------------------------------------------------------------------
// OnSearchContents
//---------------------------------------------------------------------------
void CAlarmsTab1View::OnSearchContents() 
{
	CDicsDoc* pDoc = (CDicsDoc*)m_pView->GetDocument();

	// Sorting by Ascending
	pDoc->m_pErrHistSet->m_strSort = "ErrorID ASC"; 

	UpdateData( TRUE );
	
	//  Search by contents
	CString sFilter;
	if( !m_sSearchContents.IsEmpty() )
	{
		sFilter.Format( "[ErrorContent] LIKE '*%s*' ", m_sSearchContents );
	}

	pDoc->m_pErrHistSet->m_strFilter = sFilter;
	pDoc->m_pErrHistSet->Requery();
	FillData();	
}

//---------------------------------------------------------------------------
// OnBtnAlarmReset
//---------------------------------------------------------------------------
void CAlarmsTab1View::OnBtnAlarmReset()
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	
	if( ((CDicsView*) pApp->m_pMainView)->m_pDicsData->m_LoginInfo.nCurUserLevel >= CDicsData::idENGINEER ) 
	{
		if( AfxMessageBox( "Do you want to Alarm Reset?", MB_YESNO, NULL ) == IDYES )
		{
			((CDicsView*) pApp->m_pMainView)->m_pEqpStateSeq->m_bBtnAlarmReset = TRUE;
		}
	}
}

//---------------------------------------------------------------------------
// SubResetDtPickerRange : Display the items that is selected period.
// ˻ Ⱓ  Ʈ(DateTimePicker)    Ѵ.
// ˻Ⱓ From  , dtTo  ¥  Ұϰ ϸ,
// ˰Ⱓ To   dtFrom  ¥  Ұϰ ȴ,
//---------------------------------------------------------------------------
void CAlarmsTab1View::SubResetDtPickerRange(COleDateTime dtFrom, COleDateTime dtTo)
{
	COleDateTime dtFrom1, dtFrom2, dtTo1, dtTo2;

	// Get current set range
	m_dtFromCtrl.GetRange( &dtFrom1, &dtFrom2 );
	m_dtToCtrl.GetRange( &dtTo1, &dtTo2 );

	// Set range again
	m_dtFromCtrl.SetRange( &dtFrom1, &dtTo );
	m_dtToCtrl.SetRange(& dtFrom, &dtTo2 );
}

void CAlarmsTab1View::OnBtnKeyboard()
{
	WinExec( "osk.exe", SW_SHOW );
}
