#if !defined(AFX_ALARMSTAB1VIEW_H__980ADD32_D4EA_447D_AA40_36EB32B2D835__INCLUDED_)
#define AFX_ALARMSTAB1VIEW_H__980ADD32_D4EA_447D_AA40_36EB32B2D835__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AlarmsTab1View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CAlarmsTab1View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "..\Database\DaoErrHistSet.h"
#include "..\X\PointListCtrl.h"
#include "..\X\MacButtons.h"

class CAlarmsTab1View : public CFormView
{
public:
	CAlarmsTab1View();           // protected constructor used by dynamic creation
	CAlarmsTab1View( CView* pView, int nTabNo );
	DECLARE_DYNCREATE(CAlarmsTab1View)

// Form Data
public:
	//{{AFX_DATA(CAlarmsTab1View)
	enum { IDD = IDD_ALARMS_TAB1_VIEW };
	CDateTimeCtrl	m_dtToCtrl;
	CDateTimeCtrl	m_dtFromCtrl;
	CPointListCtrl	m_lcErrHist;
	COleDateTime	m_dtFrom;
	COleDateTime	m_dtTo;
	CString			m_sSearchCode;
	CString			m_sSearchContents;
	long			m_lErrorCount;
	CMacButton		m_macSearchCode;
	CMacButton		m_macSearchContents;
	CMacRadioButton	m_RbTimeArea1;
	CMacRadioButton	m_RbTimeArea2;
	CBitmapButton	m_KeyIn;
	CMacButton		m_macAlarmReset;	// SanghoCho 2015.05.12
	//}}AFX_DATA

// Attributes
public:
	int	m_nTabNo;
	CView* m_pView;
	BOOL m_bPermitAccess;
// Operations
public:
	void AddColumn();
	void FillData();
	void SubResetDtPickerRange(COleDateTime dtFrom, COleDateTime dtTo);
	void SaveTextFile(CString sFileName);
	void OnSaveFile();
	void OnDelete();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAlarmsTab1View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CAlarmsTab1View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CAlarmsTab1View)
	afx_msg void OnDatetimechangeDtTo(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDatetimechangeDtFrom(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnRbTimeArea2();
	afx_msg void OnRbTimeArea1();
	afx_msg void OnColumnclickListError(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSearchCode();
	afx_msg void OnSearchContents();
	afx_msg void OnBtnKeyboard();
	afx_msg void OnBtnAlarmReset();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ALARMSTAB1VIEW_H__980ADD32_D4EA_447D_AA40_36EB32B2D835__INCLUDED_)
