// AlarmsTab2View.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "AlarmsTab2View.h"
#include "AlarmsView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAlarmsTab2View

IMPLEMENT_DYNCREATE(CAlarmsTab2View, CFormView)

CAlarmsTab2View::CAlarmsTab2View()
	: CFormView(CAlarmsTab2View::IDD)
{
	//{{AFX_DATA_INIT(CAlarmsTab2View)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CAlarmsTab2View::CAlarmsTab2View(CView* pView, int nTabNo )
	: CFormView(CAlarmsTab2View::IDD)
{
	m_nTabNo	= nTabNo;
	m_pView		= pView;
	m_nMargin	= 40;
	m_nMaxCount	= 0;
}

CAlarmsTab2View::~CAlarmsTab2View()
{
}

void CAlarmsTab2View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAlarmsTab2View)
	DDX_Control(pDX, IDC_CHART, m_ChartWnd);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAlarmsTab2View, CFormView)
	//{{AFX_MSG_MAP(CAlarmsTab2View)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_MESSAGE( WM_MOUSEMOVE_ON_USER, OnMouseMoveOnUser )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAlarmsTab2View diagnostics

#ifdef _DEBUG
void CAlarmsTab2View::AssertValid() const
{
	CFormView::AssertValid();
}

void CAlarmsTab2View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAlarmsTab2View message handlers

BOOL CAlarmsTab2View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

//---------------------------------------------------------------------------
// OnInitialUpdate
//---------------------------------------------------------------------------
void CAlarmsTab2View::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// Create the note message box
	CRect r;
	GetDlgItem( IDC_TITLE_DESCRIPTION )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgTitleDescription.Create( 100, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_TITLE_DESCRIPTION, LIGHT_YELLOW_COLOR, BLUE_COLOR, 18, TRUE );
	m_msgTitleDescription.SetOpMsg( "Alarm Name" );

	GetDlgItem( IDC_DESCRIPTION )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgDescription.Create( 101, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_DESCRIPTION, WHITE, BLUE_COLOR, 18, TRUE );
	m_msgDescription.SetAlign( CMsgBox::alignLEFT );
	m_msgDescription.SetOpMsg( " " );
}

//---------------------------------------------------------------------------
// OnClose
//---------------------------------------------------------------------------
void CAlarmsTab2View::OnClose() 
{
	CAlarmInfo* pItem;

    for( int i=0; i<m_arrayAlarmInfo.GetSize(); i++ )
    {
        pItem = m_arrayAlarmInfo.GetAt( i );
        delete pItem;
        pItem = NULL;
    }
	
	CFormView::OnClose();
}

//---------------------------------------------------------------------------
// OnDraw
//---------------------------------------------------------------------------
void CAlarmsTab2View::OnDraw(CDC* pDC) 
{
	CSingleLock sLock( &m_mutex );
	sLock.Lock();

	GetAlarmCodeInfo();

	m_ChartWnd.RemoveAll();
	m_ChartWnd.SetChartFromToValue( 0, (float)m_nMaxCount + ( (m_nMaxCount/5)==0 ? 1 : m_nMaxCount/5 ), 4 );
	AlarmGraphDraw();
	m_ChartWnd.Initialize();

	sLock.Unlock();
}

//---------------------------------------------------------------------------
// AlarmGraphDraw
//---------------------------------------------------------------------------
void CAlarmsTab2View::AlarmGraphDraw()
{
	static COLORREF rgbColor[] =
	{
		RGB( 0, 0, 0 ), RGB( 160, 0, 0 ), RGB( 0, 160, 0 ), RGB( 0, 0, 160 ),
		RGB( 128, 0, 0 ), RGB( 0, 128, 0 ), RGB( 0, 0, 128 ), RGB( 128, 128, 0 ),
		RGB( 0, 128, 128), RGB( 128, 0, 128 ), RGB( 220, 0, 0 ), RGB( 26, 166, 57 ),
		RGB( 166, 26, 57 ), RGB( 57, 166, 26 ), RGB( 26, 57, 166 ), RGB( 57, 26, 166 ),
		RGB( 220, 0, 0), RGB( 220, 0, 128 ), RGB( 220, 220, 0 ), RGB( 0, 0, 220 )
	};
	int i = 0;
	int nCount = m_arrayAlarmInfo.GetSize();
	BOOL* bChecked = new BOOL[nCount];
	for( int i=0; i<nCount; i++ ) bChecked[i] = FALSE;

	for( i=0; ( i < nCount ) && ( i < 20 ); i++ )
	{
		int nMaxCount = 0;
		int nOrder = 0;
		for( int j=0; j<nCount; j++ ) 
		{
			CAlarmInfo* pItem = m_arrayAlarmInfo.GetAt( j );
			if( !bChecked[j] && nMaxCount < pItem->m_nCount ) { nOrder = j; nMaxCount = pItem->m_nCount; }
		}

		// Check skip it.
		bChecked[nOrder] = TRUE;

		CAlarmInfo* pItem = m_arrayAlarmInfo.GetAt( nOrder );
		CString sCode;
		sCode.Format( "%d", pItem->m_nCode );
		m_ChartWnd.AddChartItem( sCode, pItem->m_nCount, rgbColor[i] );
	}
	delete bChecked;

//	for( int i=0; ( i < nCount ) && ( i < 20 ); i++ )
//	{
//		CAlarmInfo* pItem = m_arrayAlarmInfo.GetAt( i );
//		CString sCode;
//		sCode.Format( "%d", pItem->m_nCode );
//		m_ChartWnd.AddChartItem( sCode, pItem->m_nCount, rgbColor[i] );
//	}
}

//---------------------------------------------------------------------------
// GetAlarmCodeInfo
//---------------------------------------------------------------------------
void CAlarmsTab2View::GetAlarmCodeInfo()
{
	int nCount = ( (CAlarmsView*) m_pView )->m_pTabAlarmsTab1View->m_lcErrHist.GetItemCount();
	
	int* nData = new int[nCount];
	for( int i=0; i<nCount; i++ )
	{
		CString sCode = ( (CAlarmsView*) m_pView )->m_pTabAlarmsTab1View->m_lcErrHist.GetItemText( i, 2 );
		nData[i] = atoi( sCode );
	}

	if( nCount > 0 )
	{
		QuickSort( nData, 0, nCount - 1 );
	}

	// Set the array list of alarm information
	CAlarmInfo* pAlarmInfo;
	int nSubCount = 0;
	int nOldData = nData[0];
	int i = 0;
	// Delete the all item
	m_nMaxCount	= 0;
    for( i=0; i<m_arrayAlarmInfo.GetSize(); i++ )
    {
        pAlarmInfo = m_arrayAlarmInfo.GetAt( i );
        delete pAlarmInfo;
    }
	m_arrayAlarmInfo.RemoveAll();

	// Set the alarm information
	for( i=0; i<nCount; i++ )
	{
		if( nData[i] != nOldData )
		{
			// Set the info
			pAlarmInfo = new CAlarmInfo( nOldData, nSubCount );
			m_arrayAlarmInfo.Add( pAlarmInfo );

			// Backup
			nOldData = nData[i];
			nSubCount = 0;
		}
		nSubCount += 1;
		
		// Get the largest count number
		if( m_nMaxCount < nSubCount ) m_nMaxCount = nSubCount;
	}

	if( nCount > 0 )
	{
		// Set the alarm information of last item
		pAlarmInfo = new CAlarmInfo( nOldData, nSubCount );
		m_arrayAlarmInfo.Add( pAlarmInfo );
	}

	delete nData;
}

//---------------------------------------------------------------------------
// QuickSort
// lb : Lower bound
// ub : Upper bound
//---------------------------------------------------------------------------
void CAlarmsTab2View::QuickSort( int* nData, int lb, int ub )
{
	if( lb >= ub ) return;

	int a = nData[lb];	// key holder 
	int up = ub;
	int down = lb;
	int temp;           // temporary variable, used in swapping


	while( down < up )
	{
		while( nData[down] <= a )
		{
			down++;	// scan the keys from left to right
			if( down > up ) break;
		}
		while (nData[up] > a )
		{
			up--;		// scan the keys from right to left
			if( up < 0 ) break;
		}
		if( down < up )
		{
			temp = nData[down];				// interchange records
			nData[down] = nData[up];
			nData[up] = temp;
		}
	}

	nData[lb] = nData[up];					// interchange records
	nData[up] = a;

	QuickSort( nData, lb, up - 1 );			// recursive call - sort first subtable
	QuickSort( nData, up + 1, ub );			// recursive call - sort second subtable
}

//-----------------------------------------------------------
// OnMouseMoveOnUser
//-----------------------------------------------------------
LRESULT CAlarmsTab2View::OnMouseMoveOnUser( WPARAM wParam, LPARAM lParam )
{
	CString sCode = (CString)(LPCTSTR) lParam;
	int i = 0;
	int nCount = ( (CAlarmsView*) m_pView )->m_pTabAlarmsTab1View->m_lcErrHist.GetItemCount();
	for( i=0; i<nCount; i++ )
	{
		CString sData = ( (CAlarmsView*) m_pView )->m_pTabAlarmsTab1View->m_lcErrHist.GetItemText( i, 2 );
		if( sCode == sData ) break;
	}

	CString sContents = ( (CAlarmsView*) m_pView )->m_pTabAlarmsTab1View->m_lcErrHist.GetItemText( i, 4 );
	m_msgDescription.SetOpMsg( "[" + sCode + "] " + sContents );
	return 0;
}