// AlarmsTab3View.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "AlarmsTab3View.h"
#include "AlarmsView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAlarmsTab3View

IMPLEMENT_DYNCREATE(CAlarmsTab3View, CFormView)

CAlarmsTab3View::CAlarmsTab3View()
	: CFormView(CAlarmsTab3View::IDD)
{
	//{{AFX_DATA_INIT(CAlarmsTab3View)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CAlarmsTab3View::CAlarmsTab3View(CView* pView, int nTabNo )
	: CFormView(CAlarmsTab3View::IDD)
{
	m_pView		= pView;
	m_nTabNo	= nTabNo;
	
	m_pAlarm	= NULL;
}

CAlarmsTab3View::~CAlarmsTab3View()
{
	if ( m_pAlarm ) 
	{
		m_pAlarm->CloseAlarmItems();
		delete m_pAlarm;
	}
}

void CAlarmsTab3View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAlarmsTab3View)
	DDX_Control(pDX, IDC_MSFLEXGRID1, m_gridCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAlarmsTab3View, CFormView)
	//{{AFX_MSG_MAP(CAlarmsTab3View)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
	ON_WM_MOUSEWHEEL()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAlarmsTab3View diagnostics

#ifdef _DEBUG
void CAlarmsTab3View::AssertValid() const
{
	CFormView::AssertValid();
}

void CAlarmsTab3View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAlarmsTab3View message handlers
BOOL CAlarmsTab3View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CAlarmsTab3View::GridInit()
{
	LPTSTR sLvcText[] = { "   No   ", "   Alarm ID   ", "   Alarm Code   ", "   Level   ", "   AlarmText   " , "" };
	
	int nColWidth[] = { 1000, 1400, 1500, 1500, 8000, 0 }; 
	
	// initialize GridCtrl
	//m_gridCtrl.SetRows( m_pAlarm->GetAlarmNo()+1 );  
	m_gridCtrl.SetRows( MAX_ALARM_NO + 1 );
	m_gridCtrl.SetCols( 6 );
	
	//-------------------------------------------
	m_gridCtrl.SetRow( 0 );  
	m_gridCtrl.SetColWidth( 0, nColWidth[0] );
	m_gridCtrl.SetCol( 0 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridCtrl.SetColWidth( 1, nColWidth[1] );
	m_gridCtrl.SetCol( 1 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[1] ); 
	//---------------------------------------------
	m_gridCtrl.SetColWidth( 2, nColWidth[2] );
	m_gridCtrl.SetCol( 2 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[2] ); 
	//---------------------------------------------
	m_gridCtrl.SetColWidth( 3, nColWidth[3] );
	m_gridCtrl.SetCol( 3 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[3] );
	//---------------------------------------------
	m_gridCtrl.SetColWidth( 4, nColWidth[4] );
	m_gridCtrl.SetCol( 4 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[4] );
	//---------------------------------------------
	m_gridCtrl.SetColWidth( 5, nColWidth[5] );
	m_gridCtrl.SetCol( 5 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[5] );
}

void CAlarmsTab3View::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	m_pAlarm = new CAlarm();
	m_pAlarm->OpenAlarmItems(); 
	GridInit();
	SetDataToGridCtrl();
	// TODO: Add your specialized code here and/or call the base class
}

void CAlarmsTab3View::SetDataToGridCtrl()
{
	int no =0;
	CString sBuf;
	CDicsDoc* pDoc = (CDicsDoc*)(m_pView->GetDocument());

	for( int nRow = 1; nRow < MAX_ALARM_NO+1 ; nRow++ )
	{
		CAlarmItem* pItem;
		pItem = m_pAlarm->GetItem( nRow );
		// 1. Alarm ID
		
		
//		if ( pItem->m_nCode )
		{
			no++;
			// 1. n0
			m_gridCtrl.SetCol( 0 );
			m_gridCtrl.SetRow( no );
			m_gridCtrl.SetCellAlignment( 4 );
			m_gridCtrl.SetCellBackColor( LIGHT_CYAN_COLOR );
			sBuf.Format( "%d", no  );
			m_gridCtrl.SetText( (LPCTSTR) sBuf );
			
			// 2. Alarm Code
			m_gridCtrl.SetCol( 1 );
			m_gridCtrl.SetRow( no );
			m_gridCtrl.SetCellAlignment( 4 );
			if( pItem->m_cLevel == 'S' || pItem->m_cLevel == 'H' ) m_gridCtrl.SetCellBackColor( YELLOW_COLOR ); 
			if( pItem->m_nCode == 0 ) m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR ); 
			sBuf.Format( "%d", pItem->m_nId  );
			m_gridCtrl.SetText( (LPCTSTR) sBuf );
			
			// 3. Alarm Code
			m_gridCtrl.SetCol( 2 );
			m_gridCtrl.SetRow( no );
			sBuf.Format( "%d", pItem->m_nCode );
			if( pItem->m_cLevel == 'S' || pItem->m_cLevel == 'H' ) m_gridCtrl.SetCellBackColor( YELLOW_COLOR ); 
			if( pItem->m_nCode == 0 ) m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR ); 
			m_gridCtrl.SetText( (LPCTSTR) sBuf );
	
			// 4. Level
			m_gridCtrl.SetCol( 3 );
			m_gridCtrl.SetRow( no );
			sBuf.Format(" %c", pItem->m_cLevel);
			if( pItem->m_cLevel == 'S' || pItem->m_cLevel == 'H' ) m_gridCtrl.SetCellBackColor( YELLOW_COLOR ); 
			if( pItem->m_nCode == 0 ) m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR ); 
			m_gridCtrl.SetCellAlignment( 4 );
			m_gridCtrl.SetText( (LPCTSTR) sBuf );

			// 5. Text
			m_gridCtrl.SetCol( 4 );
			m_gridCtrl.SetRow( no );
			sBuf.Format(" %s", pItem->m_sText ) ;
			if( pItem->m_cLevel == 'S' || pItem->m_cLevel == 'H' ) m_gridCtrl.SetCellBackColor( YELLOW_COLOR ); 
			if( pItem->m_nCode == 0 ) m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR ); 
			m_gridCtrl.SetCellAlignment( 1 );
			m_gridCtrl.SetText( (LPCTSTR) sBuf );
		}

	} 
}

void CAlarmsTab3View::OnAlarmsListSave()
{
	char szPathName[100];
	GetCurrentDirectory( 100, szPathName );

	// Open the File Open Dialog
	CFileDialog fileOpenDlg( FALSE, _T("log"), NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
		_T( "Alarm List File (*.txt)|*.txt||" ) );
	
	if( fileOpenDlg.DoModal() != IDOK ) return;
	SaveTextFile( fileOpenDlg.GetPathName() );

	// Set to the original path
	SetCurrentDirectory( szPathName );
}

void CAlarmsTab3View::SaveTextFile(CString sFileName)
{
	// Create the file
	CFile File;
	if( File.Open( sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone ) == 0 )
	{
		AfxMessageBox("File Creation Error !!");
		return;
	}

	// Read from list control and then add to text file as below
	// Table : No / Time / Code / Level / Content
	CString sOneDataLine = " NO \tAlarm ID \tCODE \tLEVEL \tAlarm Text  ";
	File.Write( sOneDataLine + "\r\n", sOneDataLine.GetLength() + 2 );
	sOneDataLine = "------------------------------------------------------------------------------------";
	File.Write( sOneDataLine + "\r\n", sOneDataLine.GetLength()+2 );                                   
	int no = 0;

	for( int i=1 ; i<MAX_ALARM_NO+1 ; i++ )
	{
		CAlarmItem* pItem;
		pItem = m_pAlarm->GetItem( i );
				
		if ( pItem->m_nCode )
		{
			no++;
			sOneDataLine = "";
								" NO \tAlarm ID \tCODE \tLEVEL \tAlarm Text  ";
			sOneDataLine.Format(" %d \t%d       \t%d   \t%c    \t%s          ", no, pItem->m_nId, pItem->m_nCode, pItem->m_cLevel, pItem->m_sText );
			File.Write( sOneDataLine + "\r\n", sOneDataLine.GetLength()+2 );
		}
	}
	File.Close();
}


BOOL CAlarmsTab3View::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
#define MAX_ID	4
	DWORD dw;
	if(zDelta <=0)	dw = SB_LINEDOWN;
	else			dw = SB_LINEUP;

	CRect rect;
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	int nID[MAX_ID] = { IDC_MSFLEXGRID1, };
	int i;
	for( i=0; i<MAX_ID; i++)
	{
		if(((CMSFlexGrid*)GetDlgItem( nID[i] ))->GetRows() <= 8) continue;

		GetDlgItem( nID[i] )->GetWindowRect( &rect );

		if(rect.left < pt.x && pt.x < rect.right && rect.top < pt.y && pt.y < rect.bottom)
		{
			GetDlgItem(nID[i])->SendMessage(WM_VSCROLL, dw, 0);
		}
	}
	return CFormView::OnMouseWheel(nFlags, zDelta, pt);
}
