// AlarmsView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "AlarmsView.h"
#include "..\MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAlarmsView

IMPLEMENT_DYNCREATE(CAlarmsView, CFormView)

CAlarmsView::CAlarmsView()
	: CFormView(CAlarmsView::IDD)
{
	//{{AFX_DATA_INIT(CAlarmsView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_nSelectedTab = 0;
	m_pTabAlarmsTab1View	= NULL;
}

CAlarmsView::~CAlarmsView()
{
	GetDocument()->m_pAlarmsWnd = NULL;
}

void CAlarmsView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAlarmsView)
	DDX_Control(pDX, IDC_TAB_ALARMS, m_tabCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAlarmsView, CFormView)
	//{{AFX_MSG_MAP(CAlarmsView)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_MESSAGE( WM_SEL_CHANGE_TAB, OnSelChangeTab )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAlarmsView diagnostics

#ifdef _DEBUG
void CAlarmsView::AssertValid() const
{
	CFormView::AssertValid();
}

void CAlarmsView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CDicsDoc* CAlarmsView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDicsDoc)));
	return (CDicsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAlarmsView message handlers

void CAlarmsView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Set the current view pointer
	GetDocument()->SetAlarmsView( this );
	
	// Create the TAB view 
	CRect r;
	GetDlgItem( IDC_TAB_ALARMS )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 0, 0, 6, 30 );

	m_pTabAlarmsTab1View = new CAlarmsTab1View( this, viewAlarmHistory );
	CCreateContext context;
	m_pTabAlarmsTab1View->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CAlarmsTab1View::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabAlarmsTab1View, "    ALARM HISTORY VIEW    ", viewAlarmHistory );
	m_pTabAlarmsTab1View->SetFocus();

	m_pTabAlarmsTab2View = new CAlarmsTab2View( this, viewAlarmGraph );
	m_pTabAlarmsTab2View->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CAlarmsTab2View::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabAlarmsTab2View, "    ALARM GRAPH VIEW    ", viewAlarmGraph );

	m_pTabAlarmsTab3View = new CAlarmsTab3View( this, viewAlarmList );
	m_pTabAlarmsTab3View->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CAlarmsTab3View::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabAlarmsTab3View, "    ALARM LIST VIEW    ", viewAlarmList );

	m_tabCtrl.SetSelectedColor( RED_COLOR );
	m_tabCtrl.SetMouseOverColor( GREEN_COLOR );
	m_tabCtrl.SetNormalColor( DARK_GRAY_COLOR );
}

void CAlarmsView::OnDestroy() 
{
	CFormView::OnDestroy();
	
	if( m_pTabAlarmsTab1View ) 
	{
		m_pTabAlarmsTab1View->SendMessage( WM_CLOSE );
		delete m_pTabAlarmsTab1View;
	}

	if( m_pTabAlarmsTab2View ) 
	{
		m_pTabAlarmsTab2View->SendMessage( WM_CLOSE );
		delete m_pTabAlarmsTab2View;
	}

	if( m_pTabAlarmsTab3View ) 
	{
		m_pTabAlarmsTab3View->SendMessage( WM_CLOSE );
		delete m_pTabAlarmsTab3View;
	}
}

LRESULT CAlarmsView::OnSelChangeTab( WPARAM wParam, LPARAM lParam )
{
	m_nSelectedTab = (int) wParam;

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CMainFrame* pMainFrame = (CMainFrame*) pApp->m_pMainWnd;
	
	if ( m_nSelectedTab == viewAlarmHistory )
	{
		pMainFrame->m_wndCommandToolBar.LoadToolBar( IDR_ALARMS );
		pMainFrame->RecalcLayout();
		m_pTabAlarmsTab1View->SetFocus();
	}
	
	if ( m_nSelectedTab == viewAlarmGraph )
	{
		pMainFrame->m_wndCommandToolBar.LoadToolBar( IDR_ALARMSVIEW2 );
		pMainFrame->RecalcLayout();
		m_pTabAlarmsTab2View->SetFocus();
	}
	
	if ( m_nSelectedTab == viewAlarmList )
	{
		pMainFrame->m_wndCommandToolBar.LoadToolBar( IDR_ALARMSLIST );
		pMainFrame->RecalcLayout();
		m_pTabAlarmsTab3View->SetFocus();
	}
	return 0;
}
