// DatalogTab1View.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DatalogTab1View.h"
#include "..\SortClass.h"
#include "DatalogView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDatalogTab1View

IMPLEMENT_DYNCREATE(CDatalogTab1View, CFormView)

CDatalogTab1View::CDatalogTab1View()
	: CFormView(CDatalogTab1View::IDD)
{
	//{{AFX_DATA_INIT(CDatalogTab1View)
	//}}AFX_DATA_INIT
}

CDatalogTab1View::CDatalogTab1View(CView* pView)
	: CFormView(CDatalogTab1View::IDD)
{
	//{{AFX_DATA_INIT(CDatalogTab1View)
	//}}AFX_DATA_INIT

	m_pView = pView;
	m_nColNo = -1;
	m_nOldIndex	= -1;
	m_sPathName = "No file name";
}

CDatalogTab1View::~CDatalogTab1View()
{
}

void CDatalogTab1View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDatalogTab1View)
	DDX_Control(pDX, IDC_LIST_LOG, m_lcLog);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDatalogTab1View, CFormView)
	//{{AFX_MSG_MAP(CDatalogTab1View)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST_LOG, OnColumnclickListLog)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDatalogTab1View diagnostics

#ifdef _DEBUG
void CDatalogTab1View::AssertValid() const
{
	CFormView::AssertValid();
}

void CDatalogTab1View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDatalogTab1View message handlers

BOOL CDatalogTab1View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

//--------------------------------------------------------------------
// OnInitialUpdate
//--------------------------------------------------------------------
void CDatalogTab1View::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// Set the list control items
	m_lcLog.SetExtendedStyle( LVS_EX_FULLROWSELECT |
								LVS_EX_ONECLICKACTIVATE | 
								LVS_EX_UNDERLINEHOT | 
								LVS_EX_GRIDLINES );
}

//--------------------------------------------------------------------
// OnOpenFile
//--------------------------------------------------------------------
void CDatalogTab1View::OnOpenFile()
{
	// Backup the current directory
	char szPathName[100];
	GetCurrentDirectory( 100, szPathName );

	CFileDialog fileOpenDlg( TRUE, _T("log"), NULL, OFN_FILEMUSTEXIST|OFN_HIDEREADONLY,
		_T( "Eqp Log Files (EqpLog*.log)|EqpLog*.log|"
			"SF Log Files (SFLog*.log)|SFLog*.log|"
			"All Files (*.*)|*.*||") );
		
	if( fileOpenDlg.DoModal() != IDOK ) return;

	// Get the path name
	m_sPathName = fileOpenDlg.GetPathName();

	// Parse & Fill the data
	BeginWaitCursor(); 
	ParseLogData();
	EndWaitCursor(); 

	// Set to the original path
	SetCurrentDirectory( szPathName );
}

//--------------------------------------------------------------------
// OnInitialUpdate
//--------------------------------------------------------------------
void CDatalogTab1View::ParseLogData()
{
	CStdioFile file;
	CString szBuf;

	if( !file.Open( m_sPathName, CFile::modeRead | CFile::shareDenyNone ) ) 
	{
		AfxMessageBox( "File could not be opened" );
		return;
	}

	// Read one line first of all.
	if( !file.ReadString( szBuf ) ) 
	{
		file.Close(); return;	// No data
	}

	// Set the path name
	( ( CDatalogView* ) m_pView )->m_msgFileName.SetOpMsg( m_sPathName );

	// Delete the all items
	m_lcLog.DeleteAllItems();
	if( m_nColNo >= 0 ) { for( int i=0; i<m_nColNo + 1; i++ ) m_lcLog.DeleteColumn( 0 ); }

	// Get the column number
	m_nColNo = GetColumnNo( szBuf );

	// Add the column of list view control
	AddColumns( m_nColNo +1);//2008.12.17 kmgun

	// Return the file pointer to original position.
	try { file.SeekToBegin(); }
	catch( CFileException* pEX ) { pEX->Delete(); }

	int nRow = 0;
	while( file.ReadString( szBuf ) ) FillData( nRow++, szBuf );
	file.Close();

	// Set the column width to autosizeable
	m_lcLog.SetColumnWidth( 0, 0 );	// Hide the first column
	for( int i=1; i<m_nColNo + 1; i++ ) m_lcLog.AutoSizeColumns( i );
}

//--------------------------------------------------------------------
// GetColumnNo
//--------------------------------------------------------------------
int CDatalogTab1View::GetColumnNo( CString szBuf )
{
	int nCount	= 0;

	int nFirst	= 0;
	int nNext	= 0;

	while( 1 )
	{
		nNext = szBuf.Find( '\t', nFirst );
		nFirst = nNext + 1;
		if( nNext == -1 ) break;
		nCount += 1;
	}
	
	return nCount + 1;
}

//--------------------------------------------------------------------
// AddColumns
//--------------------------------------------------------------------
void CDatalogTab1View::AddColumns( int nCol )
{
	//ListControl ʱȭ
	static CString sColName[7] = {
		"",
		"Date Time",
		"Seq",
		"Func",
		"Port",
		"Slot",
		"Context",
	};
	LV_COLUMN lvc;
	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	for( int i=0; i<nCol; i++ )
	{
		CString sCol;
		lvc.fmt = LVCFMT_LEFT;
		sCol.Format( "%s", sColName[i] );
		lvc.pszText = (LPTSTR)(LPCTSTR) sCol;
		lvc.cx = m_lcLog.GetStringWidth( lvc.pszText ) + 15;
		m_lcLog.InsertColumn( i, &lvc );
	}
}

//---------------------------------------------------------------------------
// Fill Data
//---------------------------------------------------------------------------
void CDatalogTab1View::FillData( int nRow, CString szBuf )
{
	LV_ITEM		lvitem;
	CString 	sData;

	// Column1 : Number
	lvitem.mask = LVIF_TEXT;
	lvitem.iItem = nRow;
	lvitem.iSubItem = 0;
	sData.Format( "%d", nRow + 1 );
	lvitem.pszText = (LPTSTR)(LPCTSTR)sData;
	m_lcLog.InsertItem( &lvitem );

	// Column 2 ~ Column n
	int i		= 0;
	int nFirst	= 0;
	int nNext	= 0;
	int nLast = 0;
	while( 1 )
	{
		nNext = szBuf.Find( '\t', nFirst );
		nLast = szBuf.GetLength();
		int nCount = nNext - nFirst;
		if( nNext > 0 )  sData = szBuf.Mid( nFirst, nCount );
		else break;
		nFirst = nNext + 1;
		
		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = nRow;
		lvitem.iSubItem = i + 1;
		lvitem.pszText = (LPTSTR)(LPCTSTR) sData;
		m_lcLog.SetItem( &lvitem );
		i += 1;
	}

	// Set the last data to list control
	lvitem.mask = LVIF_TEXT;
	lvitem.iItem = nRow;
	lvitem.iSubItem = i + 1;
	sData = szBuf.Mid( nFirst, szBuf.GetLength() - nFirst );
	lvitem.pszText = (LPTSTR)(LPCTSTR) sData;
	m_lcLog.SetItem( &lvitem );
}

//---------------------------------------------------------------------------
// Sort by column header
//---------------------------------------------------------------------------
void CDatalogTab1View::OnColumnclickListLog(NMHDR* pNMHDR, LRESULT* pResult) 
{
	BeginWaitCursor(); 

	static int  nSortedCol = -1;
	static bool bSortAscending = true; 
	
	HD_NOTIFY *phdn = (HD_NOTIFY *) pNMHDR;
	
	// User clicked on header using left mouse button
	if( phdn->iButton == nSortedCol )
		bSortAscending = !bSortAscending;
	else
		bSortAscending = TRUE;
	
	nSortedCol = phdn->iButton;
	CSortClass csc( &m_lcLog, nSortedCol );
	csc.Sort( bSortAscending, CSortClass::dtSTRING ); 

	EndWaitCursor(); 

	*pResult = 0;

/*	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	
	BeginWaitCursor(); 
	m_lcLog.SortTextItems( pNMListView->iSubItem, TRUE );
	EndWaitCursor(); 
	
	*pResult = 0;*/
}

//---------------------------------------------------------------------------
// Search data
//---------------------------------------------------------------------------
void CDatalogTab1View::OnSearch() 
{
	BeginWaitCursor(); 

	( ( CDatalogView* ) m_pView )->UpdateData( TRUE );

	int nStartIndex = m_lcLog.GetSelectionMark();
	int nRow = m_lcLog.GetItemCount();
	int i, j;
	for( i=nStartIndex; i<nRow; i++ ) 
	{
		for( j=1; j<m_nColNo + 1; j++ )
		{
			CString sBuf = m_lcLog.GetItemText( i, j );
			if( sBuf.Find( ( ( CDatalogView* ) m_pView )->m_sTextSearch, 0 ) != -1 ) break;
		}
		if( j != m_nColNo + 1 ) break;
	}
	if( i == nRow ) { AfxMessageBox( "Can't find the selected text" ); EndWaitCursor(); return; }
	int nIndex = i;

	m_lcLog.SetSelectionMark( nIndex + 1 );
	m_lcLog.SetItemState( nIndex, LVIS_SELECTED | LVIS_FOCUSED , LVIS_SELECTED | LVIS_FOCUSED );
	m_lcLog.EnsureVisible( nIndex, FALSE ); 
	m_lcLog.SetCheck( nIndex, TRUE );
	if( m_nOldIndex >= 0 && m_nOldIndex != nIndex ) m_lcLog.SetCheck( m_nOldIndex, FALSE );
	m_nOldIndex = nIndex;

	EndWaitCursor(); 
}

//---------------------------------------------------------------------------
// OnClose
//---------------------------------------------------------------------------
void CDatalogTab1View::OnClose() 
{
	// Delete the all items
	m_lcLog.DeleteAllItems();
	
	CFormView::OnClose();
}
