// HelpTab1SearchView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "HelpTab1SearchView.h"
#include "HelpTab1View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHelpTab1SearchView

IMPLEMENT_DYNCREATE(CHelpTab1SearchView, CFormView)

CHelpTab1SearchView::CHelpTab1SearchView()
	: CFormView(CHelpTab1SearchView::IDD)
{
	//{{AFX_DATA_INIT(CHelpTab1SearchView)
	m_sSearch = _T("");
	//}}AFX_DATA_INIT
}

CHelpTab1SearchView::CHelpTab1SearchView(CView* pView)
	: CFormView(CHelpTab1SearchView::IDD)
{
	m_pView = pView;
}

CHelpTab1SearchView::~CHelpTab1SearchView()
{
}

void CHelpTab1SearchView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHelpTab1SearchView)
	DDX_Control(pDX, IDC_LIST_CONTENTS, m_lcContents);
	DDX_Text(pDX, IDC_SEARCH, m_sSearch);
	DDX_Control( pDX, IDC_SEARCH_BUTTON, m_macSearch );
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHelpTab1SearchView, CFormView)
	//{{AFX_MSG_MAP(CHelpTab1SearchView)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_CONTENTS, OnItemchangedListContents)
	ON_BN_CLICKED(IDC_SEARCH_BUTTON, OnSearchButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHelpTab1SearchView diagnostics

#ifdef _DEBUG
void CHelpTab1SearchView::AssertValid() const
{
	CFormView::AssertValid();
}

void CHelpTab1SearchView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CHelpTab1SearchView message handlers

BOOL CHelpTab1SearchView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

//--------------------------------------------------------------------
// OnInitialUpdate
//--------------------------------------------------------------------
void CHelpTab1SearchView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Set the MAC button
	MAC_COLOR_SET color_set;
	m_macSearch.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macSearch.SetColorSetting( color_set );
	m_macSearch.SetBold();
	
	InsertColumn();
	AddItem();
}

//--------------------------------------------------------------------
// InsertColumn
//--------------------------------------------------------------------
void CHelpTab1SearchView::InsertColumn()
{
	CRect rect;
  	m_lcContents.GetClientRect( &rect );

	LV_COLUMN lvcolumn;
	lvcolumn.mask = LVCF_FMT|LVCF_SUBITEM|LVCF_TEXT|LVCF_WIDTH | LVIF_PARAM;
	lvcolumn.fmt = LVCFMT_CENTER;

	for( int i=0; i<2; i++ )
	{
	    lvcolumn.iSubItem = i;
		switch (i)
		{
		case 0:
			lvcolumn.cx = 150;
			lvcolumn.pszText = "CONTENTS";
			break;
		case 1:
			lvcolumn.cx = 60;
			lvcolumn.pszText = "NO";
			break;
		}
		m_lcContents.InsertColumn( i,&lvcolumn );		
	}	
}

//--------------------------------------------------------------------
// AddItem
//--------------------------------------------------------------------
void CHelpTab1SearchView::AddItem()
{
	HTREEITEM hItemRoot = ( (CHelpTab1View*) m_pView )->m_pHelpTab1ContentsView->m_treeContents.GetRootItem();
	if( hItemRoot == NULL ) return;
	GetItem( hItemRoot );
}

//--------------------------------------------------------------------
// GetItem
// hItemParent : Parent item handle 
// hItemCurrent : Current item handle 
//--------------------------------------------------------------------
void CHelpTab1SearchView::GetItem( HTREEITEM hItemParent )
{
	// From parent item
	HTREEITEM hItemCurrent = ( (CHelpTab1View*) m_pView )->m_pHelpTab1ContentsView->m_treeContents.GetChildItem( hItemParent );
	if( hItemCurrent == NULL )		// No child item
	{
		hItemCurrent = ( (CHelpTab1View*) m_pView )->m_pHelpTab1ContentsView->m_treeContents.GetNextSiblingItem( hItemParent );
		if( hItemCurrent == NULL )	// No sibling item
		{
			while( 1 )
			{
				// go to parent item
				hItemParent = ( (CHelpTab1View*) m_pView )->m_pHelpTab1ContentsView->m_treeContents.GetParentItem( hItemParent );
				hItemCurrent = ( (CHelpTab1View*) m_pView )->m_pHelpTab1ContentsView->m_treeContents.GetNextSiblingItem( hItemParent );
				if( hItemCurrent != NULL )	// there is sibling item of parent one.
				{
					CString sText = ( (CHelpTab1View*) m_pView )->m_pHelpTab1ContentsView->m_treeContents.GetItemText( hItemCurrent );
					FillData( sText );
					GetItem( hItemCurrent );
					break;
				}
				else	// there is no sibling item of parent one.
				{
					HTREEITEM hItemRoot = ( (CHelpTab1View*) m_pView )->m_pHelpTab1ContentsView->m_treeContents.GetRootItem();
					if( hItemParent == hItemRoot ) return;
				}
			}
		}
		else
		{
			CString sText = ( (CHelpTab1View*) m_pView )->m_pHelpTab1ContentsView->m_treeContents.GetItemText( hItemCurrent );
			FillData( sText );
			GetItem( hItemCurrent );
		}
	}
	else 
	{
		CString sText = ( (CHelpTab1View*) m_pView )->m_pHelpTab1ContentsView->m_treeContents.GetItemText( hItemCurrent );
		FillData( sText );
		GetItem( hItemCurrent );
	}
}

//--------------------------------------------------------------------
// FillData
//--------------------------------------------------------------------
void CHelpTab1SearchView::FillData( CString sData )
{
	int nFind = sData.Find( '.' );
	if( nFind != -1 ) 
	{
		CString sNo = sData.Left( nFind );
		CString sName = sData.Mid( nFind + 1 );
		sName.TrimLeft( " " );

		LV_ITEM lvitem;
		lvitem.iItem = m_lcContents.GetItemCount();

		lvitem.mask = LVIF_TEXT | LVIF_STATE;
		lvitem.iSubItem = 0;
		lvitem.stateMask = LVIS_STATEIMAGEMASK;
		lvitem.state = INDEXTOSTATEIMAGEMASK( 1 );
		lvitem.pszText = (LPTSTR)(LPCTSTR) sName;

		m_lcContents.InsertItem( &lvitem );
		m_lcContents.ModifyStyle( LVS_TYPEMASK, LVS_LIST );
		m_lcContents.ModifyStyle( LVS_TYPEMASK, LVS_SHOWSELALWAYS );
     	m_lcContents.ModifyStyle( LVS_TYPEMASK, LVS_REPORT );
	   	m_lcContents.SetExtendedStyle( LVS_EX_FULLROWSELECT |
									LVS_EX_ONECLICKACTIVATE | 
									LVS_EX_UNDERLINEHOT | 
									LVS_EX_GRIDLINES); 
		m_lcContents.SetItemText( lvitem.iItem, 0, sName );
		m_lcContents.SetItemText( lvitem.iItem, 1, sNo );
	}
}

//--------------------------------------------------------------------
// OnItemchangedListContents
//--------------------------------------------------------------------
void CHelpTab1SearchView::OnItemchangedListContents(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	
	LPNMITEMACTIVATE pItemActivate = (LPNMITEMACTIVATE) pNMHDR;

	CString sText = m_lcContents.GetItemText( pItemActivate->iItem, 1 );
	if( sText == "" ) return;

	// Get the online help file name
	char szPathName[100];
	GetCurrentDirectory( 100, szPathName );

	CString sFileName;
	sFileName.Format( "%s\\OnLineHelp\\On_Help%s.htm", szPathName, sText );
	( (CHelpTab1View*) m_pView )->m_webHelp.Navigate( sFileName, NULL, NULL, NULL,NULL );

	// Set the selected item name
	CString sName = m_lcContents.GetItemText( pItemActivate->iItem, 0 );
	CString sBuf = sText + ". " + sName;
	( (CHelpTab1View *) m_pView )->m_msgSelectedItem.SetOpMsg( sBuf );
		
	*pResult = 0;
}

//--------------------------------------------------------------------
// OnSearchButton
//--------------------------------------------------------------------
void CHelpTab1SearchView::OnSearchButton() 
{
	int i=0, j=0;
	BeginWaitCursor(); 

	UpdateData( TRUE );

	int nStartIndex = m_lcContents.GetSelectionMark();
	int nRow = m_lcContents.GetItemCount();
	int nColNo = 2;

	for( i=nStartIndex; i<nRow; i++ ) 
	{
		for( j=0; j<nColNo; j++ )
		{
			CString sBuf = m_lcContents.GetItemText( i, j );
			if( sBuf.Find( m_sSearch, 0 ) != -1 ) break;
		}
		if( j != nColNo ) break;
	}
	if( i == nRow ) { AfxMessageBox( "Can't find the selected text" ); EndWaitCursor(); return; }

	m_lcContents.SetSelectionMark( i + 1 );
	m_lcContents.SetItemState( i, LVIS_SELECTED | LVIS_FOCUSED , LVIS_SELECTED | LVIS_FOCUSED );
	m_lcContents.EnsureVisible( i, FALSE ); 
	m_lcContents.SetCheck( i, TRUE );
	m_lcContents.SetFocus();

	EndWaitCursor(); 
}
