// HelpTab1View.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "HelpTab1View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHelpTab1View

IMPLEMENT_DYNCREATE(CHelpTab1View, CFormView)

CHelpTab1View::CHelpTab1View()
	: CFormView(CHelpTab1View::IDD)
{
	//{{AFX_DATA_INIT(CHelpTab1View)
	//}}AFX_DATA_INIT

	m_pHelpTab1ContentsView = NULL;
	m_pHelpTab1SearchView = NULL;
}

CHelpTab1View::CHelpTab1View(CView* pView)
	: CFormView(CHelpTab1View::IDD)
{
	m_pView = pView;

	m_pHelpTab1ContentsView = NULL;
	m_pHelpTab1SearchView = NULL;
}

CHelpTab1View::~CHelpTab1View()
{
}

void CHelpTab1View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHelpTab1View)
	DDX_Control(pDX, IDC_TAB1_HELP, m_tabCtrl);
	DDX_Control(pDX, IDC_WEB_HELP, m_webHelp);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHelpTab1View, CFormView)
	//{{AFX_MSG_MAP(CHelpTab1View)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHelpTab1View diagnostics

#ifdef _DEBUG
void CHelpTab1View::AssertValid() const
{
	CFormView::AssertValid();
}

void CHelpTab1View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CHelpTab1View message handlers

BOOL CHelpTab1View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CHelpTab1View::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// Create the TAB view 
	CRect r;
	GetDlgItem( IDC_TAB1_HELP )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 0, 0, 6, 30 );
	
	m_pHelpTab1ContentsView = new CHelpTab1ContentsView( this );
	CCreateContext context;
	m_pHelpTab1ContentsView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CHelpTab1ContentsView::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pHelpTab1ContentsView, "    CONTENTS    ", 0 );

	m_pHelpTab1SearchView = new CHelpTab1SearchView( this );
	m_pHelpTab1SearchView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CHelpTab1SearchView::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pHelpTab1SearchView, "    SEARCH    ", 1 );

	m_tabCtrl.SetSelectedColor( RED_COLOR );
	m_tabCtrl.SetMouseOverColor( GREEN_COLOR );
	m_tabCtrl.SetNormalColor( DARK_GRAY_COLOR );

	// Get the online help file name
	char szPathName[100];
	GetCurrentDirectory( 100, szPathName );

	CString sFileName;
	sFileName.Format( "%s\\OnLineHelp\\On_Help0.htm", szPathName );
	m_webHelp.Navigate( sFileName, NULL, NULL, NULL,NULL );

	// MESSAGE BOX
	GetDlgItem( IDC_TITLE )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgTitle.Create( 200, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_TITLE,
                		  LIGHT_YELLOW_COLOR, BLUE_COLOR, 16, TRUE );
	m_msgTitle.SetOpMsg( "Selected Item" );

	GetDlgItem( IDC_SELECTED_ITEM )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgSelectedItem.Create( 201, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_SELECTED_ITEM,
                	       WHITE_COLOR, BLUE_COLOR , 16, TRUE );
}

void CHelpTab1View::OnDestroy() 
{
	CFormView::OnDestroy();
	
	if( m_pHelpTab1ContentsView ) 
	{
		m_pHelpTab1ContentsView->SendMessage( WM_CLOSE );
		delete m_pHelpTab1ContentsView;
	}

	if( m_pHelpTab1SearchView ) 
	{
		m_pHelpTab1SearchView->SendMessage( WM_CLOSE );
		delete m_pHelpTab1SearchView;
	}
}
