// CJobsTabApStatusView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "JobsTabApStatusView.h"

#include "..\Dlg\DlgKeypad.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJobsTabApStatusView

IMPLEMENT_DYNCREATE(CJobsTabApStatusView, CFormView)

CJobsTabApStatusView::CJobsTabApStatusView()
	: CFormView(CJobsTabApStatusView::IDD)
{
	//{{AFX_DATA_INIT(CJobsTabApStatusView)
	m_sApPowerSet = _T("");
	m_sN2FlowRate = _T("");
	m_sCDAFlowRate = _T("");
	m_fApPowerSet = 0.0;
	m_fN2FlowRate = 0.0;
	m_fCDAFlowRate = 0.0;
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CJobsTabApStatusView::~CJobsTabApStatusView()
{
/*	if( m_pRfg )
	{
		delete m_pRfg;
	}
	if( m_pMfc )
	{
		delete m_pMfc;
	}

	m_pRfg = NULL;
	m_pMfc = NULL;*/
}

CJobsTabApStatusView::CJobsTabApStatusView(CView* pView, int nTabNo)
	: CFormView(CJobsTabApStatusView::IDD)
{
	m_pView		= pView;
	m_nTabNo	= nTabNo; 
	m_nApAlarmNo = 0;
	
	m_pEqpAssy = ( (CDicsView *) m_pView )->m_pEqpAssy;

}

void CJobsTabApStatusView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJobsTabApStatusView)
	DDX_Control(pDX, IDC_HOUSE_UP, m_macHouseUpO);
	DDX_Control(pDX, IDC_HOUSE_DOWN, m_macHouseDnO);
	DDX_Control(pDX, IDC_AP_ON, m_macApPowerOn);
//	DDX_Control(pDX, IDC_AP_INTERLOCK_ON, m_macInterlockOn);
	DDX_Control(pDX, IDC_AP_SETTING, m_macApDataSet);
	DDX_Control(pDX, IDC_AP_RESET, m_macApDataReset);
	DDX_Control(pDX, IDC_GRID_ALARM_STATUS1, m_gridAlarm1);
	DDX_Control(pDX, IDC_GRID_ALARM_STATUS2, m_gridAlarm2);
	DDX_Control(pDX, IDC_GRID_AP_ALARM, m_gridAlarmList);
	DDX_Text(pDX, IDC_EDIT_AP_POWER_SET, m_sApPowerSet);
	DDX_Text(pDX, IDC_EDIT_N2_FLOWRATE, m_sN2FlowRate);
	DDX_Text(pDX, IDC_EDIT_CDA_FLOWRATE, m_sCDAFlowRate);
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_HOUSE_POS1, m_macHousePos[0]);
	DDX_Control(pDX, IDC_HOUSE_POS2, m_macHousePos[1]);
//	DDX_Control(pDX, IDC_HOUSE_POS3, m_macHousePos[2]);
//	DDX_Control(pDX, IDC_HOUSE_POS4, m_macHousePos[3]);
//	DDX_Control(pDX, IDC_HOUSE_POS5, m_macHousePos[4]);
//	DDX_Control(pDX, IDC_HOUSE_POS6, m_macHousePos[5]);
}


BEGIN_MESSAGE_MAP(CJobsTabApStatusView, CFormView)
	//{{AFX_MSG_MAP(CJobsTabApStatusView)
	ON_WM_CLOSE()
	ON_WM_CREATE()
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_AP_ON, OnApPowerOn)
//	ON_BN_CLICKED(IDC_AP_PN2_OPEN, OnApPn2Open)
//	ON_BN_CLICKED(IDC_AP_PN2_CLOSE, OnApPn2Close)
//	ON_BN_CLICKED(IDC_AP_PCW_OPEN, OnApPcwOpen)
//	ON_BN_CLICKED(IDC_AP_PCW_CLOSE, OnApPcwClose)
//	ON_BN_CLICKED(IDC_AP_INTERLOCK_ON, OnApInterlock)
	ON_BN_CLICKED(IDC_AP_SETTING, OnApDataSet)
	ON_BN_CLICKED(IDC_AP_RESET, OnApReset)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_BTN_PUSHED, OnBtnPushed)
	ON_MESSAGE(WM_BTN_RELEASED, OnBtnReleased)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJobsTabApStatusView diagnostics

#ifdef _DEBUG
void CJobsTabApStatusView::AssertValid() const
{
	CFormView::AssertValid();
}

void CJobsTabApStatusView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJobsTabApStatusView message handlers

BOOL CJobsTabApStatusView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CJobsTabApStatusView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	MAC_COLOR_SET color_set;

	for( int i = 0 ; i < 2 ; i++ )
	{
		m_macHousePos[i].SetCheckColor( BLUE_COLOR );
		m_macHousePos[i].SetBold();
		if( m_pEqpAssy->m_Plasma.GetHouseSensorState() == actDN )
		{
			m_macHousePos[i].SetCheck( 1 );
		}
		else
		{
			m_macHousePos[i].SetCheck( 0 );
		}
	}
	
	m_macHouseUpO.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macHouseUpO.SetColorSetting( color_set );
	m_macHouseUpO.SetBold();

	m_macHouseDnO.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_RED_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macHouseDnO.SetColorSetting( color_set );
	m_macHouseDnO.SetBold();

	m_macApDataSet.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macApDataSet.SetColorSetting( color_set );
	m_macApDataSet.SetBold();

	m_macApDataReset.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macApDataReset.SetColorSetting( color_set );
	m_macApDataReset.SetBold();

	m_macApPowerOn.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macApPowerOn.SetColorSetting( color_set );
	m_macApPowerOn.SetBold();
	GetDlgItem( IDC_AP_ON )->SetWindowText( "PLASMA ON" );
	
	CRect r;

	long lBkColor[] = { WHITE_COLOR, WHITE_COLOR, WHITE_COLOR };
	long lFgColor[] = { RED_COLOR, BLUE_COLOR, BLUE_COLOR };

	// AP Plasma Analog Input... Power, N2, CDA 
	for( int j=0; j<MAX_RFG_AI_NO; j++ ) 
	{
		int nResorceNo = IDC_AP_POWER_MONITOR + j;
		GetDlgItem( nResorceNo )->GetWindowRect( &r );
		ScreenToClient( &r );
		r -= CRect( 1, 1, 1, 1 );
		m_msgRfgAI[j].Create( nResorceNo, "0.0", WS_CHILD|WS_VISIBLE, r, this, 
				                 nResorceNo, lBkColor[j], lFgColor[j], 18, TRUE );
	}

	GetDlgItem( IDC_AP_MESSAGE )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 2, 2, 2, 2 );
	m_msgAP.Create( 800, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_DATE,
			BLACK_COLOR, WHITE_COLOR, 18, TRUE );
	m_msgAP.SetOpMsg( "AP PLASMA Manual Operation View." );

	CString sVal;

	sVal.Format( "%d", 0/*m_pRfg->GetRfPower( 0 )*/ );
	SetDlgItemText( IDC_EDIT_AP_POWER_SET, sVal );

	sVal.Format( "%d", 0/*m_pMfc->m_iSetGasFlowRate[N2]*/ );
	SetDlgItemText( IDC_EDIT_N2_FLOWRATE, sVal );

	sVal.Format( "%d", 0/*m_pMfc->m_iSetGasFlowRate[CDA]*/ );
	SetDlgItemText( IDC_EDIT_CDA_FLOWRATE, sVal );

	m_hbrBgColor = CreateSolidBrush( BG_COLOR );
	m_hbrLightBlueColor = CreateSolidBrush( LIGHT_BLUE_COLOR );
	m_hbrLightCyanColor = CreateSolidBrush( LIGHT_CYAN_COLOR );
	m_hbrLightGreenColor = CreateSolidBrush( LIGHT_GREEN_COLOR );
	m_hbrLightRedColor = CreateSolidBrush( LIGHT_RED_COLOR );
	m_hbrLightMagentaColor = CreateSolidBrush( LIGHT_MAGENTA_COLOR );

	GetDlgItem( IDC_HOUSE_UP )->EnableWindow( FALSE );
	GetDlgItem( IDC_HOUSE_DOWN )->EnableWindow( FALSE );
	GetDlgItem( IDC_HOUSE_POS1 )->EnableWindow( FALSE );
	GetDlgItem( IDC_HOUSE_POS2 )->EnableWindow( FALSE );

	m_bFlowState[0] = m_bFlowState[1] = FALSE;
	
	GridInit_PlasmaState();
	GridInit_ApAlarmList();
}

void CJobsTabApStatusView::OnClose() 
{
#ifdef _UNIT_AP  //Bryan_070409 AP ÿ Ѵ.
	// TODO: Add your message handler code here and/or call default

	KillTimer( TM_AP_MONITOR );

	DeleteObject( m_hbrBgColor );
	DeleteObject( m_hbrLightBlueColor );
	DeleteObject( m_hbrLightCyanColor );
	DeleteObject( m_hbrLightGreenColor );
	DeleteObject( m_hbrLightRedColor );
	DeleteObject( m_hbrLightMagentaColor );
	
	CFormView::OnClose();
#endif
}

int CJobsTabApStatusView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFormView::OnCreate(lpCreateStruct) == -1)	return -1;
	
	// TODO: Add your specialized creation code here
	return 0;

}

HBRUSH CJobsTabApStatusView::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CFormView::OnCtlColor(pDC, pWnd, nCtlColor);
	// TODO: Change any attributes of the DC here
	UINT id = pWnd->GetDlgCtrlID();
	switch( nCtlColor )
	{
	case CTLCOLOR_STATIC: 
		if( id == IDC_STATIC_POWER_SUPPLY || 
			id == IDC_STATIC_MFC_READ )
		{
			hbr = m_hbrLightBlueColor;
			pDC->SetBkMode( TRANSPARENT );
		}
		else if( id == IDC_STATIC_AP_POWER || 
				 id == IDC_STATIC_N2_FLOW || 
				 id == IDC_STATIC_CDA_FLOW )
		{
			hbr = m_hbrBgColor;
			pDC->SetBkMode( TRANSPARENT );
		}
		else if( id == IDC_STATIC_AP_POWER_SET || 
				 id == IDC_STATIC_N2_FLOW_SET || 
				 id == IDC_STATIC_CDA_FLOW_SET )
		{
			hbr = m_hbrLightMagentaColor;
			pDC->SetBkMode( TRANSPARENT );
		}
		break;
	}
	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

LRESULT CJobsTabApStatusView::OnBtnPushed(WPARAM wParam, LPARAM lParam)
{
	switch( wParam ) 
	{
	case IDC_HOUSE_UP:
		//SetDlgItemText( IDC_MESSAGE, "Lamp House is moving upward" );
		m_msgAP.SetOpMsg( "AP PLASMA is moving upward." );
		m_pEqpAssy->m_Plasma.SetPlasmaHouseAct( actUP );
		break;
	case IDC_HOUSE_DOWN:
		//SetDlgItemText( IDC_MESSAGE, "Lamp House is moving downward" );
		m_msgAP.SetOpMsg( "AP PLASMA is moving downward" );
		m_pEqpAssy->m_Plasma.SetPlasmaHouseAct( actDN);
		break;
	}
	return 0;
}

//--------------------------------------------------------------------
// When jog button is released 
//--------------------------------------------------------------------
LRESULT CJobsTabApStatusView::OnBtnReleased(WPARAM wParam, LPARAM lParam)
{
	switch( wParam ) 
	{
	case IDC_HOUSE_UP:
		m_pEqpAssy->m_Plasma.SetPlasmaHouseAct( actSTOP );
		m_macHouseUpO.SetCheck( 0 );
		//SetDlgItemText( IDC_MESSAGE, "Lamp House is stopped" );
		m_msgAP.SetOpMsg( "AP PLASMA MOVE SIGNAL OFF" );
		break;
	case IDC_HOUSE_DOWN:
		//SetDlgItemText( IDC_MESSAGE, "Lamp House is stopped" );
		m_pEqpAssy->m_Plasma.SetPlasmaHouseAct( actSTOP );
		m_macHouseDnO.SetCheck( 0 );
		m_msgAP.SetOpMsg( "AP PLASMA MOVE SIGNAL OFF" );
		break;
	}
	return 0;
}

void CJobsTabApStatusView::OnApPowerOn() 
{
	// TODO: Add your control notification handler code here
	MAC_COLOR_SET color_set;
	if( !m_pEqpAssy->m_Plasma.GetPowerStatus() )
	{
		m_macApPowerOn.GetColorSetting( &color_set );
		color_set.crFace = LIGHT_ORANGE_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macApPowerOn.SetColorSetting( color_set );
		m_macApPowerOn.SetBold();
		m_macApPowerOn.SetCheck( 1 );
		GetDlgItem( IDC_AP_ON )->SetWindowText( "PLASMA POWER OFF" );
		m_msgAP.SetOpMsg( "AP PLASMA ON" );

		m_pEqpAssy->m_Plasma.SetPowerOn( ON );
	}
	else
	{
		m_macApPowerOn.GetColorSetting( &color_set );
		color_set.crFace = LIGHT_GREEN_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macApPowerOn.SetColorSetting( color_set );
		m_macApPowerOn.SetBold();
		m_macApPowerOn.SetCheck( 0 );
		GetDlgItem( IDC_AP_ON )->SetWindowText( "PLASMA POWER ON" );
		m_msgAP.SetOpMsg( "AP PLASMA OFF" );
		m_pEqpAssy->m_Plasma.SetPowerOn( OFF );
	}
	Invalidate();
}

void CJobsTabApStatusView::OnApPn2Open() 
{
	// TODO: Add your control notification handler code here
#ifdef _UNIT_AP
//	doAP_UNIT_N2_VALVE( ON );                 //khh00331
//	m_msgAP.SetOpMsg( "N2 Valve Open" );
#endif
}

void CJobsTabApStatusView::OnApPn2Close() 
{
	// TODO: Add your control notification handler code here
#ifdef _UNIT_AP
//	doAP_UNIT_N2_VALVE( OFF );                //khh00331
//	m_msgAP.SetOpMsg( "N2 Valve Close" );
#endif

}

void CJobsTabApStatusView::OnApPcwOpen() 
{
	// TODO: Add your control notification handler code here
#ifdef _UNIT_AP
//	doAP_UNIT_PCW_VALVE( ON );
//	m_msgAP.SetOpMsg( "PCW Valve Open" );
#endif

}

void CJobsTabApStatusView::OnApPcwClose() 
{
	// TODO: Add your control notification handler code here
#ifdef _UNIT_AP 
//	doAP_UNIT_PCW_VALVE( OFF );            //khh070331
//	m_msgAP.SetOpMsg( "PCW Valve Close" );
#endif
}

void CJobsTabApStatusView::OnApInterlock()
{
//#ifdef _UNIT_AP
//	MAC_COLOR_SET color_set;
//	
//	if( !dosAP_UNIT_INTERLOCK )
//	{
//		m_macInterlockOn.GetColorSetting( &color_set );
//		color_set.crFace = LIGHT_ORANGE_COLOR;
//		color_set.crLiteShadow = MAGENTA_COLOR;
//		m_macInterlockOn.SetColorSetting( color_set );
//		m_macInterlockOn.SetBold();
//		m_macInterlockOn.SetCheck( 1 );
//		GetDlgItem( IDC_AP_INTERLOCK_ON )->SetWindowText( "AP INTERLOCK OFF" );
//
//		m_sMessage.Format( "AP Controller Interlock On" );
//		m_msgAP.SetOpMsg( m_sMessage );
//
//		doAP_UNIT_INTERLOCK( ON );
//	}
//	else
//	{
//		m_macInterlockOn.GetColorSetting( &color_set );
//		color_set.crFace = LIGHT_GREEN_COLOR;
//		color_set.crLiteShadow = MAGENTA_COLOR;
//		m_macInterlockOn.SetColorSetting( color_set );
//		m_macInterlockOn.SetBold();
//		m_macInterlockOn.SetCheck( 0 );
//		GetDlgItem( IDC_AP_INTERLOCK_ON )->SetWindowText( "AP INTERLOCK ON" );
//
//		m_sMessage.Format( "AP Controller Interlock Off" );
//		m_msgAP.SetOpMsg( m_sMessage );
//
//		doAP_UNIT_INTERLOCK( OFF );
//	}
// #endif
}

void CJobsTabApStatusView::OnApDataSet() 
{
	CString sTemp;
	GetDlgItemText( IDC_EDIT_AP_POWER_SET, sTemp );

	CString sTemp1;
	GetDlgItemText( IDC_EDIT_N2_FLOWRATE, sTemp1 );

	CString sTemp2;
	GetDlgItemText( IDC_EDIT_CDA_FLOWRATE, sTemp2);

	SetDlgItemText( IDC_EDIT_AP_POWER_SET, sTemp );
	m_sApPowerSet = sTemp;
	m_fApPowerSet = atof( m_sApPowerSet );

	SetDlgItemText( IDC_EDIT_N2_FLOWRATE, sTemp1 );
	m_sN2FlowRate = sTemp1;
	m_fN2FlowRate = atof( m_sN2FlowRate );

	SetDlgItemText( IDC_EDIT_CDA_FLOWRATE, sTemp2 );
	m_sCDAFlowRate = sTemp2;
	m_fCDAFlowRate = atof( m_sCDAFlowRate );

	if( m_fApPowerSet > 13 || m_fApPowerSet < 10 )
	{
		AfxMessageBox( "POWER Է ߸Ǿϴ..10 13 ڸ Էϼ..!!", MB_OK | MB_ICONSTOP | MB_SYSTEMMODAL );
			return;
	}

	if( m_fN2FlowRate > 1000 || m_fN2FlowRate < 900 )
	{
		AfxMessageBox( "N2 Է ߸Ǿϴ..900 1000 ڸ Էϼ..!!", MB_OK | MB_ICONSTOP | MB_SYSTEMMODAL );
			return;
	}

	if( m_fCDAFlowRate > 3 || m_fCDAFlowRate < 0 )
	{
		AfxMessageBox( "CDA Է ߸Ǿϴ..0 3 ڸ Էϼ..!!", MB_OK | MB_ICONSTOP | MB_SYSTEMMODAL );
			return;
	}
	
	UpdateData( TRUE );

	m_pEqpAssy->m_Plasma.SetPlasmaValue( flowN2, (WORD)m_fN2FlowRate);
	m_pEqpAssy->m_Plasma.SetPlasmaValue( flowCDA, (WORD)m_fCDAFlowRate);
	m_pEqpAssy->m_Plasma.SetPlasmaValue( supKv,  (int)(m_fApPowerSet) );
	
	sTemp.Format( "Set AP Data : Power(%.1f kW), N2(%.1f lpm), CDA(%.1f lpm)", m_fApPowerSet, m_fN2FlowRate, m_fCDAFlowRate );
	m_msgAP.SetOpMsg( sTemp );

	m_macApDataSet.SetCheck( 0 );
}

void CJobsTabApStatusView::EnableButton(BOOL bStatus)
{
	GetDlgItem( IDC_AP_SETTING )->EnableWindow( bStatus );
//	GetDlgItem( IDC_AP_INTERLOCK_ON )->EnableWindow( bStatus );
	GetDlgItem( IDC_HOUSE_UP )->EnableWindow( bStatus );
	GetDlgItem( IDC_HOUSE_DOWN )->EnableWindow( bStatus );
	GetDlgItem( IDC_AP_ON )->EnableWindow( bStatus );
	GetDlgItem( IDC_AP_RESET )->EnableWindow( bStatus );
}

//2005.11.10 Yougnsik --->
void CJobsTabApStatusView::OnApReset() 
{
#ifdef _UNIT_AP  //Bryan_070409 AP ÿ Ѵ.
	if( ( AfxMessageBox( " Reset Ͻðڽϱ?", MB_YESNO ) ) == IDNO ) 
	{
		m_macApDataReset.SetCheck( 0 );
		return;
	}

	m_sApPowerSet = "0";
	m_sCDAFlowRate = "0";
	m_sN2FlowRate = "0";
	m_fApPowerSet = 0.0;
	m_fCDAFlowRate = 0.0;
	m_fN2FlowRate = 0.0;
	UpdateData( FALSE );
	// TODO: Add your control notification handler code here
	m_pEqpAssy->m_Plasma.SetPlasmaValue( flowN2, m_fN2FlowRate);
	m_pEqpAssy->m_Plasma.SetPlasmaValue( flowCDA, m_fCDAFlowRate);
	m_pEqpAssy->m_Plasma.SetPlasmaValue( supKv,  (int)(m_fApPowerSet) );

	m_msgAP.SetOpMsg( "Reset All AP Plasma Data." );

	m_macApDataReset.SetCheck( 0 );
#endif
}
//2005.11.10 Yougnsik <---
void CJobsTabApStatusView::GridInit_PlasmaState()
{

	LPTSTR	sLvcText[] = { " No ", " Signal Name ", " STATE " };
	int		nColWidth[] = { 500, 3200, 1000 }; 
	int		nRow, nCol;
	
	LPTSTR	sAlarm1[] = { "  MFC N2 Flow Low", "  MFC CDA Flow Low", "  AP House Open", };
	LPTSTR  sAlarm2[] = { "  POWER SUPPLY STATUS 0",  "  POWER SUPPLY STATUS 1",  "  POWER SUPPLY STATUS 2", "  POWER SUPPLY READY" };

	CString		sMsg;

	m_gridAlarm1.SetRows( 4 );
	m_gridAlarm1.SetCols( 3 );

	for( nRow = 0 ; nRow < 4 ; nRow++ )
	{
		m_gridAlarm1.SetRow( nRow );

		for( nCol = 0 ; nCol < 3 ; nCol++ )
		{
			m_gridAlarm1.SetCol( nCol );
			m_gridAlarm1.SetColWidth( nCol, nColWidth[nCol] ); 

			if( nRow > 0 && nCol == 1 )
				m_gridAlarm1.SetCellAlignment( 2 );
			else
				m_gridAlarm1.SetCellAlignment( 4 );
			
			if( nRow == 0 )
			{	
				m_gridAlarm1.SetCellBackColor( LIGHT_BLUE_COLOR );
				m_gridAlarm1.SetText( sLvcText[nCol] ); 
			}
			else
			{
				if( nCol == 0 )
				{
					m_gridAlarm1.SetCellBackColor( LIGHT_BLUE_COLOR );
					sMsg.Format( "%d", nRow );
					m_gridAlarm1.SetText( sMsg );
				}
				else if( nCol == 1 )
				{
					m_gridAlarm1.SetCellBackColor( WHITE_COLOR );
					m_gridAlarm1.SetText( sAlarm1[nRow-1] );
				}
				else
				{
					m_gridAlarm1.SetText( "Normal" );
					m_gridAlarm1.SetCellBackColor( GREEN_COLOR );
				}
			}
		}
	}

	m_gridAlarm2.SetRows( 5 );
	m_gridAlarm2.SetCols( 3 );

	for( nRow = 0 ; nRow < 5 ; nRow++ )
	{
		m_gridAlarm2.SetRow( nRow );

		for( int nCol = 0 ; nCol < 3 ; nCol++ )
		{
			m_gridAlarm2.SetCol( nCol );
			m_gridAlarm2.SetColWidth( nCol, nColWidth[nCol] ); 

			if( nRow > 0 && nCol == 1 )
				m_gridAlarm2.SetCellAlignment( 2 );
			else
				m_gridAlarm2.SetCellAlignment( 4 );
			
			if( nRow == 0 )
			{	
				m_gridAlarm2.SetCellBackColor( LIGHT_BLUE_COLOR );
				m_gridAlarm2.SetText( sLvcText[nCol] ); 
			}
			else
			{
				if( nCol == 0 )
				{
					m_gridAlarm2.SetCellBackColor( LIGHT_BLUE_COLOR );
					sMsg.Format( "%d", nRow );
					m_gridAlarm2.SetText( sMsg );
				}
				else if( nCol == 1 )
				{
					m_gridAlarm2.SetCellBackColor( WHITE_COLOR );
					m_gridAlarm2.SetText( sAlarm2[nRow-1] );
				}
				else
				{
					m_gridAlarm2.SetCellBackColor( WHITE_COLOR );
				}
			}
		}
	}
}

void CJobsTabApStatusView::SetApAlarm1(int nAlarmNo, BOOL bState)
{
	m_gridAlarm1.SetRow( nAlarmNo + 1 );
	m_gridAlarm1.SetCol( 2 );

	if( !bState )
	{
		m_gridAlarm1.SetCellBackColor( GREEN_COLOR );
		m_gridAlarm1.SetText( "Normal" );
	}
	else
	{
		m_gridAlarm1.SetCellBackColor( RED_COLOR );
		m_gridAlarm1.SetText( "Alarm" );
	}
}

void CJobsTabApStatusView::UpdateMfcData()
{
#ifdef _UNIT_AP  //Bryan_070409 AP ÿ Ѵ.
	m_pMfc->MonitorMfc();

	CString	sVal;

	if( m_pMfc->GetGasFlowState( N2 ) )
	{
		m_fN2Real = m_pMfc->GetGasFlowRate( N2 );
		sVal.Format( "%.1f", m_fN2Real );
		m_msgRfgAI[1].SetOpMsg( sVal );
	}
	if( m_pMfc->GetGasFlowState( CDA ) ) 
	{
		m_fCDAReal = m_pMfc->GetGasFlowRate( CDA );
		sVal.Format( "%.1f", m_fCDAReal );
		m_msgRfgAI[2].SetOpMsg( sVal );
	}
#endif
}

void CJobsTabApStatusView::UpdateRfgData()
{

	CString sVal;
	if( m_pEqpAssy->m_Plasma.GetPowerStatus() )
	{
		m_fForwardReal = m_pEqpAssy->m_Plasma.GetPlasmaStatus( supPOWER );
		sVal.Format( "%.1f kV", m_fForwardReal );
		m_msgRfgAI[FORWARD].SetOpMsg( sVal );
	}
	else
	{
		m_fForwardReal = 0.0;
		sVal.Format( "%.1f kV", m_fForwardReal );
		m_msgRfgAI[FORWARD].SetOpMsg( sVal );
	}
}

void CJobsTabApStatusView::UpdateObjects()
{
	if( ( ( (CDicsView*) m_pView )->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER ) 
				|| ( (CDicsView*) m_pView )->m_pDicsData->m_GenInfo.bAuto )
	{
		EnableButton( FALSE );
	}
	else EnableButton(TRUE);
	
	
	UpdateAlarmState();
	UpdateAlarmStatus();
//	UpdatePlasmaStatus();
}

void CJobsTabApStatusView::GridInit_ApAlarmList()
{
	int		nColWidth = 3050; 
	LPTSTR	sAlarmName[] = 
	{
		"Interlock Open Alarm",
		"Inverter fault",
		"Inverter DC Low-Voltage",
		"Output Over-Voltage",
		"ARC fault",
		"Local Mode",
		"Plasma On fault",
	};
	CString		sMsg;

	m_gridAlarmList.SetRows( 8 );
	m_gridAlarmList.SetCols( 1 );

	for( int nRow = 0 ; nRow < 8 ; nRow++ )
	{
		m_gridAlarmList.SetRow( nRow );
		m_gridAlarmList.SetRowHeight( nRow, 400 );

		m_gridAlarmList.SetCol( 0 );
		m_gridAlarmList.SetColWidth( 0, nColWidth ); 
		m_gridAlarmList.SetCellAlignment( 4 );

		if( nRow == 0 )
		{
			m_gridAlarmList.SetCellBackColor( LIGHT_BLUE_COLOR );
			m_gridAlarmList.SetText( "Alarm Name" );
		}
		else
		{
			m_gridAlarmList.SetCellBackColor( WHITE_COLOR );
			m_gridAlarmList.SetText( sAlarmName[nRow-1] );
		}
	}
}

void CJobsTabApStatusView::UpdateAlarmState()
{
	static	BOOL	bOldAlarmState[7] = { FALSE, };
	m_nApAlarmNo = 0;
	int nRow, i;
	
	for( i = 0; i<3; i++)
	{
		if( m_pEqpAssy->m_Plasma.GetPlasmaStatus( i ) )
		{
			m_nApAlarmNo |= (0x01<<i); 
		}
	}
	
	
	for( nRow = 1 ; nRow < 8 ; nRow++ )
	{
		if( ( m_nApAlarmNo == ( nRow - 1 ) ) && !bOldAlarmState[nRow-1] )
		{
			bOldAlarmState[nRow-1] = TRUE;
			m_gridAlarmList.SetRow( nRow );
			m_gridAlarmList.SetCol( 0 );
			m_gridAlarmList.SetCellBackColor( RED_COLOR );
		}
		else if( ( m_nApAlarmNo != ( nRow - 1 ) ) && bOldAlarmState[nRow-1] )
		{
			bOldAlarmState[nRow-1] = FALSE;
			m_gridAlarmList.SetRow( nRow );
			m_gridAlarmList.SetCol( 0 );
			m_gridAlarmList.SetCellBackColor( WHITE_COLOR );
		}
	}

	static	BOOL	bOldFlowState[2] = { FALSE, };

	for( nRow = 0 ; nRow < 2 ; nRow++ )
	{
		if( m_bFlowState[nRow] && !bOldFlowState[nRow] )
		{
			bOldFlowState[nRow] = TRUE;
			SetApAlarm1( nRow, bOldFlowState[nRow] );
		}
		else if( !m_bFlowState[nRow] && bOldFlowState[nRow] )
		{
			bOldFlowState[nRow] = FALSE;
			SetApAlarm1( nRow, bOldFlowState[nRow] );
		}
	}

	static	BOOL	bOldHouseOpen = FALSE;

	if( m_pEqpAssy->m_Plasma.GetHouseSensorState() == actUP && !bOldHouseOpen )
	{
		bOldHouseOpen = TRUE;
		SetApAlarm1( 2, bOldHouseOpen );
	}
	else if( m_pEqpAssy->m_Plasma.GetHouseSensorState() == actDN && bOldHouseOpen )
	{
		bOldHouseOpen = FALSE;
		SetApAlarm1( 2, bOldHouseOpen );
	}
}


/*
void CJobsTabApStatusView::UpdatePlasmaStatus()
{
	if( m_pEqpAssy->m_Plasma.GetPowerStatus() )				
	{
		float	fN2FlowRate, fCDAFlowRate, fN2FlowRateSet, fCDAFlowRateSet;
								
		fN2FlowRate = m_pEqpAssy->m_Plasma.GetPalsmGaugeState( flowN2 ); 
		
		fCDAFlowRate = m_pEqpAssy->m_Plasma.GetPalsmGaugeState( flowCDA ); 
		
		if( ( (CDicsView*) m_pView )->m_pDicsData->m_GenInfo.bAuto )			
			
		{
			CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
			CString	 sN2FlowRate = pDoc->m_pSetupItems->m_sValueSetupTemp[CSetupItems::setupPLASMA_N2_MFC_SET];
			CString	 sCDAFlowRate = pDoc->m_pSetupItems->m_sValueSetupTemp[CSetupItems::setupPLASMA_CDA_MFC_SET]; 
			
			fN2FlowRateSet = (float)((atof)(sN2FlowRate));
			fCDAFlowRateSet = (float)((atof)(sCDAFlowRate));
			
		}
		else		// 忡 Plasma view setting  .
		{
			fN2FlowRateSet = (float)m_fN2FlowRate;
			fCDAFlowRateSet = (float)m_fCDAFlowRate;
			//fApPower = m_fApPowerSet;
		}
		
		if( ABS_VAL( fN2FlowRateSet - fN2FlowRate ) >= fN2FlowRateSet * 0.1 ) 
			m_bFlowState[0] = TRUE;
		else
			m_bFlowState[0] = FALSE;
		
		if( ABS_VAL( fCDAFlowRateSet - fCDAFlowRate ) >= fCDAFlowRateSet * 0.1 )
			m_bFlowState[1] = TRUE;
		else
			m_bFlowState[1] = FALSE;
	}
	else
	{
		m_bFlowState[0] = m_bFlowState[1] = FALSE;
	}
	
}
*/
void CJobsTabApStatusView::UpdateAlarmStatus()
{
	for( int i = 0 ; i < 4 ; i++ )
	{
		SetApAlarm2( i, m_pEqpAssy->m_Plasma.GetPlasmaStatus( i ) );
	}
}

void CJobsTabApStatusView::SetApAlarm2(int nAlarmNo, BOOL bState)
{
	m_gridAlarm2.SetRow( nAlarmNo + 1 );
	m_gridAlarm2.SetCol( 2 );

	if( !bState )
	{
		if( nAlarmNo == 3 )
		{
			m_gridAlarm2.SetCellBackColor( RED_COLOR );
			m_gridAlarm2.SetText( "Not Ready" );
		}
		else
		{
			m_gridAlarm2.SetCellBackColor( WHITE_COLOR );
			m_gridAlarm2.SetText( "OFF" );
		}
	}
	else
	{
		if( nAlarmNo == 3 )
		{
			m_gridAlarm2.SetCellBackColor( GREEN_COLOR );
			m_gridAlarm2.SetText( "Ready" );
		}
		else
		{
			m_gridAlarm2.SetCellBackColor( GREEN_COLOR );
			m_gridAlarm2.SetText( "ON" );
		}
	}
}
