#if !defined(AFX_JOBSTABAPSTATUSVIEW_H__0DF33E14_25A1_4C38_8A7B_D24A2DACE6A7__INCLUDED_)
#define AFX_JOBSTABAPSTATUSVIEW_H__0DF33E14_25A1_4C38_8A7B_D24A2DACE6A7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// JobsTab6View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CJobsTabApStatusView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "..\X\MacButtons.h"
#include "..\X\MsgBox.h"
#include "..\FactoryLib\EqpAssy.h"

class CJobsTabApStatusView : public CFormView
{
public:
	CJobsTabApStatusView();           // protected constructor used by dynamic creation
	CJobsTabApStatusView( CView* pView, int nTabNo);
	DECLARE_DYNCREATE(CJobsTabApStatusView)
// Form Data
public:
	//{{AFX_DATA(CJobsTabApStatusView)
	enum { IDD = IDD_JOBS_TAB_AP_STATUS_VIEW };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA
// Attributes
	int				m_nTabNo;

	BOOL			m_bUERT;
	BOOL			m_bEnableWindow;
	BOOL			m_bFlowState[2];

	CString			m_sMessage;
	CString			m_sApPowerSet; 
	CString			m_sN2FlowRate; 
	CString			m_sCDAFlowRate;

    double	        m_fApPowerSet;
	double			m_fN2FlowRate;
	double			m_fCDAFlowRate;

	double			m_fN2Real;
	double			m_fCDAReal;
	double			m_fForwardReal;

	int				m_nApAlarmNo;

	//BOOL			m_bLampSelect[MAX_EUV_LAMP_NO];
	//CMacCheckBox	m_macLampSelect[MAX_EUV_LAMP_NO];

	CMacCheckBox	m_macHousePos[6];

	CMacRadioButton	m_macPN2Open;
	CMacRadioButton	m_macPN2Close;
	CMacRadioButton	m_macPCWOpen;
	CMacRadioButton	m_macPCWClose;
	CMacRadioButton	m_macHouseUpO;
	CMacRadioButton	m_macHouseDnO;
	CMacRadioButton	m_macApPowerOn;
	CMacRadioButton m_macApDataSet;
	CMacRadioButton m_macApDataReset;

	CMacRadioButton m_macInterlockOn;
	CMacRadioButton m_macInterlockOff;

	/*CMacCheckBox	m_macN2LOW;
	CMacCheckBox	m_macCDALOW;
	CMacCheckBox	m_macPCWLOW;
	CMacCheckBox	m_macSTATUS0;
	CMacCheckBox	m_macSTATUS1;
	CMacCheckBox	m_macSTATUS2;
	CMacCheckBox	m_macREADY;*/

	CMSFlexGrid		m_gridAlarm1;
	CMSFlexGrid		m_gridAlarm2;
	CMSFlexGrid		m_gridAlarmList;

	CMsgBox			m_msgAP;
	CMsgBox			m_msgRfgAI[MAX_RFG_AI_NO];

	HBRUSH			m_hbrBgColor;
	HBRUSH			m_hbrLightCyanColor;
	HBRUSH			m_hbrLightRedColor;
	HBRUSH			m_hbrLightGreenColor;
	HBRUSH			m_hbrLightBlueColor;
	HBRUSH			m_hbrLightMagentaColor;

	enum			msgAP_VAL
	{	msgAP_POWER,
		msgN2_FLOW,
		msgCDA_FLOW 
	};
	
	enum _CLY_ACT_STATE
	{
		actSTOP,
		actUP,
		actDN,
	}; 

	enum _GAUGE_VALUE
	{
		flowN2,
		flowCDA,
		supKv,
		supPOWER,
		pressN2,
		pressCDA,
		pressUTCDA,
		pressUTPCW,
		flowUTPCW,
	}; 

// Attributes
public:
	CView*			m_pView;
	CDicsData*		m_pDicsData;
	CSetupItems*	m_pSetupItems;
	
// Operations
public:
	void SetData( CDicsData* pDicsData ) { m_pDicsData = pDicsData; }
	void SetSetupItems( CSetupItems* pSetupItems ) { m_pSetupItems = pSetupItems; } 
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJobsTabApStatusView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	void SetApAlarm2(int nAlarmNo, BOOL bState);
	void UpdateAlarmStatus();
//	void UpdatePlasmaStatus();
	void UpdateAlarmState();
	void GridInit_ApAlarmList();
	void UpdateObjects();
	void UpdateRfgData();
	void UpdateMfcData();
	void SetApAlarm1( int nAlarmNo, BOOL bState );
	void GridInit_PlasmaState();
	void EnableButton( BOOL bStatus );
	virtual ~CJobsTabApStatusView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CJobsTabApStatusView)
	afx_msg void OnClose();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnApPowerOn();
	afx_msg void OnApPn2Open();
	afx_msg void OnApPn2Close();
	afx_msg void OnApPcwOpen();
	afx_msg void OnApPcwClose();
	afx_msg void OnApInterlock();
	afx_msg void OnApDataSet(); 
	afx_msg void OnApReset();
	//}}AFX_MSG
	afx_msg LRESULT OnBtnPushed(WPARAM, LPARAM);
	afx_msg LRESULT OnBtnReleased(WPARAM, LPARAM);
	DECLARE_MESSAGE_MAP()

private:
	CEqpAssy* m_pEqpAssy;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JOBSTABAPSTATUSVIEW_H__0DF33E14_25A1_4C38_8A7B_D24A2DACE6A7__INCLUDED_)
