// JobsTabCimView.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "..\MainFrm.h"
#include "JobsTabCimView.h"
#include "..\SECS\XSecs.h"
#include "..\Dlg\DlgEditVal.h"
#include "..\Dlg\DlgTestRunSet.h"
#include "..\Dlg\DlgVcrMode.h"
#include "..\Dlg\DialogGlassInfo.h"
#include "..\DicsDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJobsTabCimView

IMPLEMENT_DYNCREATE(CJobsTabCimView, CFormView)

CJobsTabCimView::CJobsTabCimView()
	: CFormView(CJobsTabCimView::IDD)
{
	//{{AFX_DATA_INIT(CJobsTabCimView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CJobsTabCimView::CJobsTabCimView(CView* pView, int nTabNo)
	: CFormView(CJobsTabCimView::IDD)
{
	m_pView		= pView;
	m_nTabNo	= nTabNo;
	for( int i=0; i<MAX_PORT_NO; i++ )
		m_bCanModify[i] = FALSE;	
}

CJobsTabCimView::~CJobsTabCimView()
{
}

void CJobsTabCimView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJobsTabCimView)
	DDX_Control(pDX, IDC_TERMINAL_MSG, m_cbTerminalMsg);
	DDX_Control(pDX, IDC_GRID_LOT_INFO, m_gridLotInfo);
	DDX_Control(pDX, IDC_GRID_MAP_INFO, m_gridMapInfo);
	DDX_Control(pDX, IDC_HOST_MESSAGE, m_macHostMessage);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CJobsTabCimView, CFormView)
	//{{AFX_MSG_MAP(CJobsTabCimView)
	ON_WM_CTLCOLOR()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_HOST_MESSAGE, OnHostMessage)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_TEST_MODE_START, OnTestModeStart)
	ON_BN_CLICKED(IDC_TEST_MODE_END, OnTestModeEnd)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE( IDC_AGV_PORT1, IDC_AGV_PORT3, OnPortAgv )
	ON_COMMAND_RANGE( IDC_MGV_PORT1, IDC_MGV_PORT3, OnPortMgv )
	ON_COMMAND_RANGE( IDC_ENABLE_PORT1, IDC_ENABLE_PORT3, OnPortEnable )
	ON_COMMAND_RANGE( IDC_DISABLE_PORT1, IDC_DISABLE_PORT3, OnPortDisable )
	ON_COMMAND_RANGE( IDC_PROCESS_START_PORT1, IDC_PROCESS_START_PORT3, OnPortStart )
	ON_COMMAND_RANGE( IDC_CANCEL_PORT1, IDC_CANCEL_PORT3, OnPortCancel )
	ON_COMMAND_RANGE( IDC_ABORT_PORT1, IDC_ABORT_PORT3, OnPortAbort )
	ON_COMMAND_RANGE( IDC_RELOAD_PORT1, IDC_RELOAD_PORT3, OnPortReload )
	ON_MESSAGE( WM_MSG_BOX_CLICKED, OnVcrMode )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJobsTabCimView diagnostics

#ifdef _DEBUG
void CJobsTabCimView::AssertValid() const
{
	CFormView::AssertValid();
}

void CJobsTabCimView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJobsTabCimView message handlers

BOOL CJobsTabCimView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CJobsTabCimView::OnInitialUpdate() 
{/*
	CFormView::OnInitialUpdate();

	// Set the pointer
	m_pDicsData = ( (CDicsView*) m_pView)->m_pDicsData;
	m_pLoaderSeq = ( (CDicsView*) m_pView)->m_pLoaderSeq;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// CMsgBox : Date (100)
	CRect r;
	GetDlgItem( IDC_CIM_MESSAGE )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgCimMessage.Create( 200, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_CIM_MESSAGE,
			LIGHT_YELLOW_COLOR, BLUE_COLOR, 18, TRUE );
	m_msgCimMessage.SetOpMsg( "OK" );

	GetDlgItem( IDC_MSG_GLASS_COUNT )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 2, 2, 2, 2 );
	m_msgGlassCount.Create( 201, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_MSG_GLASS_COUNT,
			BLACK_COLOR, GREEN_COLOR, 22, TRUE );
	m_msgGlassCount.SetOpMsg( "N / A" );

	GetDlgItem( IDC_MSG_VCR_REPORT )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgVcrReport.Create( 202, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_MSG_VCR_REPORT,
			YELLOW_COLOR, BLUE_COLOR, 16 );
	m_msgVcrReport.SetOpMsg( "OFF(SKIP)" );
	
	// Get brush
	m_hbrBgColor =	CreateSolidBrush( BG_COLOR );
	m_hbrTextColor = CreateSolidBrush( BLUE_COLOR );

	for( int i=0; i<MAX_PORT_NO; i++ )
	{
		m_btnPortAgv[i].Attach( IDC_AGV_PORT1 + i, this, LIGHT_YELLOW_COLOR, BLUE_COLOR, DARK_GRAY_COLOR );
		m_btnPortMgv[i].Attach( IDC_MGV_PORT1 + i, this, LIGHT_YELLOW_COLOR, BLUE_COLOR, DARK_GRAY_COLOR );
		SetTrsMode( i, CDicsData::modeAGV );

		m_btnPortEnable[i].Attach( IDC_ENABLE_PORT1 + i, this, LIGHT_YELLOW_COLOR, BLUE_COLOR, DARK_GRAY_COLOR );
		m_btnPortDisable[i].Attach( IDC_DISABLE_PORT1 + i, this, LIGHT_YELLOW_COLOR, BLUE_COLOR, DARK_GRAY_COLOR );
		SetPortMode( i, CPortInfo::modeENABLE );

		m_btnPortStart[i].Attach( IDC_PROCESS_START_PORT1 + i, this, GRAY_COLOR, BLUE_COLOR, DARK_GRAY_COLOR );
		GetDlgItem( IDC_PROCESS_START_PORT1 + i )->EnableWindow( FALSE );

		m_btnPortCancel[i].Attach( IDC_CANCEL_PORT1 + i, this, GRAY_COLOR, BLACK_COLOR, DARK_GRAY_COLOR );
		GetDlgItem( IDC_CANCEL_PORT1 + i )->EnableWindow( FALSE );

		m_btnPortAbort[i].Attach( IDC_ABORT_PORT1 + i, this, GRAY_COLOR, BLUE_COLOR, DARK_GRAY_COLOR );
		GetDlgItem( IDC_ABORT_PORT1 + i )->EnableWindow( FALSE );

		m_btnPortReload[i].Attach( IDC_RELOAD_PORT1 + i, this, GRAY_COLOR, BLUE_COLOR, DARK_GRAY_COLOR );
		GetDlgItem( IDC_RELOAD_PORT1 + i )->EnableWindow( FALSE ); 
	}

	// Set the MAC button
	MAC_COLOR_SET color_set;
	m_macHostMessage.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macHostMessage.SetColorSetting( color_set );
	m_macHostMessage.SetBold(); 

	for( i = 0 ; i < MAX_PORT_NO ; i++ )
	{
		m_pDicsData->m_PortInfo[i].GetProfilePortInfo( i );
		//SetDataToGridLotInfo( i );
	}

	GridMapInfoInit();
	GridLotInfoInit();
	CtrlStateInit();
	SetCtrlState( MSG_CTRL_MODE, CDicsData::modeOFFLINE, CDicsData::stateON );
	SetCtrlState( MSG_LOADER_MODE, CDicsData::modeMANUAL, CDicsData::stateON );

	for( i = 0 ; i < MAX_PORT_NO ; i++ )
	{
		//m_pDicsData->m_PortInfo[i].GetProfilePortInfo( i );
		SetDataToGridLotInfo( i );
	} */
}

HBRUSH CJobsTabCimView::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CFormView::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CJobsTabCimView::OnClose() 
{
	DeleteObject( m_hbrBgColor );
	DeleteObject( m_hbrTextColor );
	
	CFormView::OnClose();
}

//--------------------------------------------------------------------
// Grid Initialize (Port Info)
//--------------------------------------------------------------------
#define MAX_LOT_INFO_COL_NO		3
#define MAX_LOT_INFO_ROW_NO		13

void CJobsTabCimView::GridLotInfoInit()
{
	// Para GridCtrl ʱȭ
	m_gridLotInfo.SetRows( MAX_LOT_INFO_ROW_NO + 1 );
	m_gridLotInfo.SetCols( MAX_LOT_INFO_COL_NO + 1 );
	CString sCol[] = { " ITEM", " PORT1", " PORT2", " PORT3" };
	CString sRow[] = 
	{
		"RECIPE ID",
		"CST ID",
		"LOT ID",
		"LOT JUDGE",
		"LOT SORT TYPE",
		"OP ID",
		"PROD ID",
		"QUANTITY",
		"SLOT MAP",
		"LOT STATUS", 
		"PORT STATUS", 
		"PORT TYPE",
		"TRS MODE"
	};

	for( int nCol=0; nCol<MAX_LOT_INFO_COL_NO + 1; nCol++ )
	{
		if( nCol == 0 ) m_gridLotInfo.SetColWidth( nCol, 1500 );
		else m_gridLotInfo.SetColWidth( nCol, 1480 );
		m_gridLotInfo.SetCol( nCol );
		m_gridLotInfo.SetRow( 0 );
		m_gridLotInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridLotInfo.SetText( (LPCTSTR) sCol[nCol] );
	}
	for( int nRow=1; nRow<MAX_LOT_INFO_ROW_NO + 1; nRow++ )
	{
		m_gridLotInfo.SetCol( 0 );
		m_gridLotInfo.SetRow( nRow );
		m_gridLotInfo.SetCellBackColor( LIGHT_MAGENTA_COLOR );
		m_gridLotInfo.SetText( (LPCTSTR) sRow[nRow - 1] );
	}

	for( int i=0; i<MAX_PORT_NO; i++ ) SetDataToGridLotInfo( i );
}

//--------------------------------------------------------------------
// Grid Initialize (Map Info)
//--------------------------------------------------------------------
void CJobsTabCimView::GridMapInfoInit()
{
	// Para GridCtrl ʱȭ
	m_gridMapInfo.SetRows( MAX_SLOT_NO + 1 );
	m_gridMapInfo.SetCols( MAX_PORT_NO + 1 );
	CString sCol[] = { "NO", "PORT1", "PORT2", "PORT3" };
	CString sRow[25];
	
	for( int nCol=0; nCol<MAX_PORT_NO + 1; nCol++ )
	{
		if( nCol == 0 ) m_gridMapInfo.SetColWidth( nCol, 525 );
		else m_gridMapInfo.SetColWidth( nCol, 1175 );
		m_gridMapInfo.SetCol( nCol );
		m_gridMapInfo.SetRow( 0 );
		m_gridMapInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridMapInfo.SetText( (LPCTSTR) sCol[nCol] );
	}
	for( int nRow=1; nRow<MAX_SLOT_NO + 1; nRow++ )
	{
		m_gridMapInfo.SetCol( 0 );
		m_gridMapInfo.SetRow( nRow );
		m_gridMapInfo.SetCellBackColor( LIGHT_MAGENTA_COLOR );
		sRow[nRow - 1].Format( "%d", MAX_SLOT_NO - nRow + 1 );
		m_gridMapInfo.SetText( (LPCTSTR) sRow[nRow - 1] );
	}
}

//---------------------------------------------------------------------------
// Initialize the color static control
//---------------------------------------------------------------------------
void CJobsTabCimView::CtrlStateInit()
{
	// Ctrl Mode
	for( int i=0; i<3; i++ )
	{
		m_stcCtrlMode[i].SubclassDlgItem( IDC_OFFLINE + i, this );
		m_stcCtrlMode[i].SetTextColor( DARK_GRAY_COLOR );
		m_stcCtrlMode[i].SetBkColor( GRAY_COLOR );

		m_stcLoaderMode[i].SubclassDlgItem( IDC_LD_REMOTE + i, this );
		m_stcLoaderMode[i].SetTextColor( DARK_GRAY_COLOR );
		m_stcLoaderMode[i].SetBkColor( GRAY_COLOR );
	}

	for( i=0; i<MAX_PORT_NO; i++ )
	{
		m_stcPortFull[i].SubclassDlgItem( IDC_FULL_PORT1 + i, this );
		m_stcPortFull[i].SetTextColor( DARK_GRAY_COLOR );
		m_stcPortFull[i].SetBkColor( GRAY_COLOR );

		m_stcPortEmpty[i].SubclassDlgItem( IDC_EMPTY_PORT1 + i, this );
		m_stcPortEmpty[i].SetTextColor( DARK_GRAY_COLOR );
		m_stcPortEmpty[i].SetBkColor( GRAY_COLOR );
	}
}

//--------------------------------------------------------------------
//------------- For LOT Information Grid Control ---------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------
// Set Recipe Data to GridCtrl : For Column only
//--------------------------------------------------------------------
void CJobsTabCimView::SetDataToGridLotInfo(int i)
{
	CString sData;
	int nRow = 1;

	COLORREF colorTEXT;
	if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeCONTROL ) colorTEXT = DARK_GREEN_COLOR;
	else if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeMONITOR ) colorTEXT = DARK_RED_COLOR;
	else colorTEXT = BLACK_COLOR;

	// Recipe ID
	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_gridLotInfo.SetCellForeColor( colorTEXT );
	CString sVal = m_pDicsData->m_PortInfo[i].sRcpId;
	m_gridLotInfo.SetText( (LPCTSTR) sVal );

	// CST ID
	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_gridLotInfo.SetCellForeColor( colorTEXT );
	sVal = m_pDicsData->m_PortInfo[i].sCstId;
	m_gridLotInfo.SetText( (LPCTSTR) sVal );

	// Lot ID
	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_gridLotInfo.SetCellForeColor( colorTEXT );
	sVal = m_pDicsData->m_PortInfo[i].sLotId;
	m_gridLotInfo.SetText( (LPCTSTR) sVal );

	// Lot judge
	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_gridLotInfo.SetCellForeColor( colorTEXT );
	sVal.Format( "%c", m_pDicsData->m_PortInfo[i].cLotJudge );
	m_gridLotInfo.SetText( (LPCTSTR) sVal );

	// Lot Sort
	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_gridLotInfo.SetCellForeColor( colorTEXT );
	sVal.Format("%c",m_pDicsData->m_PortInfo[i].cLotSortType );
	m_gridLotInfo.SetText( (LPCTSTR) sVal );

	// OpID
	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_gridLotInfo.SetCellForeColor( colorTEXT );
	sVal = m_pDicsData->m_PortInfo[i].sOpId;
	m_gridLotInfo.SetText( (LPCTSTR) sVal );

	// Product ID
	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_gridLotInfo.SetCellForeColor( colorTEXT );
	sVal = m_pDicsData->m_PortInfo[i].sProdId;
	m_gridLotInfo.SetText( (LPCTSTR) sVal );

	// QTY
	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_gridLotInfo.SetCellForeColor( colorTEXT );
	sVal.Format( "%d",m_pDicsData->m_PortInfo[i].nQty );
	m_gridLotInfo.SetText( (LPCTSTR) sVal );

	// Slot Map
	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_gridLotInfo.SetCellForeColor( colorTEXT );
	sVal = m_pDicsData->m_PortInfo[i].sSlotInfoMap;
	m_gridLotInfo.SetText( (LPCTSTR) sVal );

	// Lot Status
	char cVal = m_pDicsData->m_PortInfo[i].cLotStatus;
//	if( cVal == CDicsData::lotCOMMAND_WAIT )	sVal = "WAIT COMMAND";
	if( cVal == CPortInfo::lotWAIT )			sVal = "WAIT PROCESS";
	else if( cVal == CPortInfo::lotPROCESSING )		sVal = "PROCESSING";
	else if( cVal == CPortInfo::lotEND )			sVal = "NORMAL END";
	else if( cVal == CPortInfo::lotABORT )			sVal = "LOT ABORT";
	else if( cVal == CPortInfo::lotCANCEL )			sVal = "LOT CANCEL"; 
	else sVal = "EMPTY";
	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_gridLotInfo.SetCellForeColor( colorTEXT );
	m_gridLotInfo.SetText( (LPCTSTR) sVal );

	// Port Status
	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_gridLotInfo.SetCellForeColor( colorTEXT );
	sVal = m_pDicsData->m_PortInfo[i].sPortStatus;
	m_gridLotInfo.SetText( (LPCTSTR) sVal );

	// Port type
	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_gridLotInfo.SetCellForeColor( colorTEXT );
	sVal = m_pDicsData->m_PortInfo[i].sPortType;
	m_gridLotInfo.SetText( (LPCTSTR) sVal );

	// Port Mode
	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_gridLotInfo.SetCellForeColor( colorTEXT );
	sVal = ( m_pDicsData->m_PortInfo[i].cTrsMode == CDicsData::modeAGV ) ? "AUTO" : "MANUAL";
	m_gridLotInfo.SetText( (LPCTSTR) sVal );

	m_pDicsData->m_PortInfo[i].WriteProfilePortInfo( i );
}

//--------------------------------------------------------------------
// Get Data from GridCtrl : For Column only
//--------------------------------------------------------------------
void CJobsTabCimView::GetDataFromGridLotInfo(int i)
{
	CString sData;
	int nRow = 1;

	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_pDicsData->m_PortInfo[i].sRcpId = m_gridLotInfo.GetText();

	sData = m_pDicsData->m_PortInfo[i].sRcpId;
	for( int n=0; n<MAX_SLOT_NO; n++)
	m_pDicsData->m_PortInfo[i].m_GlsInfo[n].sRecipeId = sData;

	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_pDicsData->m_PortInfo[i].sCstId = m_gridLotInfo.GetText();

	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_pDicsData->m_PortInfo[i].sLotId = m_gridLotInfo.GetText();

	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	sData = m_gridLotInfo.GetText();
	if( sData.GetLength() > 0 ) m_pDicsData->m_PortInfo[i].cLotJudge = sData.GetAt( 0 );

	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	sData = m_gridLotInfo.GetText();
	if( sData.GetLength() > 0 ) m_pDicsData->m_PortInfo[i].cLotSortType = sData.GetAt( 0 );

	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_pDicsData->m_PortInfo[i].sOpId = m_gridLotInfo.GetText();

	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_pDicsData->m_PortInfo[i].sProdId = m_gridLotInfo.GetText();

	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_pDicsData->m_PortInfo[i].nQty = atoi( m_gridLotInfo.GetText() );

	m_gridLotInfo.SetRow( nRow++ );
	m_gridLotInfo.SetCol( i + 1 );
	m_pDicsData->m_PortInfo[i].sSlotInfoSel = m_gridLotInfo.GetText();
}

//--------------------------------------------------------------------
// Set Recipe Data to GridCtrl : For Column only
//--------------------------------------------------------------------
void CJobsTabCimView::SetPrepareMonitorMode(int i)
{
	// Enable the Process Start Button
	EnableProcessStartButton( i, TRUE );
	
	// Enable the Cancel Button
	EnablePortCancelButton( i, TRUE );

	// ------------------------------------
	// Set the background color to LIGHT_YELLOW
	SetBackColorGridLotInfo( i, TRUE, 1 );

	// Set flag
	m_bCanModify[i] = TRUE;
}

//--------------------------------------------------------------------
// Set Recipe Data to GridCtrl : For Column only
//--------------------------------------------------------------------
void CJobsTabCimView::SetPrepareOfflineMode(int i)
{
	// Enable the Process Start Button
	EnableProcessStartButton( i, TRUE );
	
	// Enable the Cancel Button
	EnablePortCancelButton( i, TRUE );

	// ------------------------------------
	// Set the background color to LIGHT_YELLOW
	SetBackColorGridLotInfo( i, TRUE, 9 );

	// Set recipe ID as default
	m_gridLotInfo.SetRow( 1 );
	m_gridLotInfo.SetCol( i + 1 );

	CString sData;
	sData.Format( "%s", m_pDicsData->m_GenInfo.sRecipeId );
	m_gridLotInfo.SetText( sData );

	// Set flag
	m_bCanModify[i] = TRUE;
}

//--------------------------------------------------------------------
// SetBackColorGridLotInfo
//--------------------------------------------------------------------
void CJobsTabCimView::SetBackColorGridLotInfo( int i, BOOL bSetBackColor, int nModifyNo )
{
	COLORREF colorTEXT;
	if( bSetBackColor ) colorTEXT = YELLOW_COLOR;
	else colorTEXT = WHITE_COLOR;

	// Set Value
	m_nCanModifyNo = nModifyNo;
	
	// Set the lot info state
	m_pDicsData->m_IfCim.bEnableButtonLotInfo[i] = bSetBackColor;
	if( m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeCONTROL || (m_pDicsData->m_PortInfo[i].cEsFlag == 'E') )
	{
		for( int nRow=0; nRow<m_nCanModifyNo; nRow++ )
		{
			m_gridLotInfo.SetRow( nRow + 1 );
			m_gridLotInfo.SetCol( i + 1 );
			m_gridLotInfo.SetCellBackColor( colorTEXT );
		}
	}
}

//--------------------------------------------------------------------
//------------- For Map Information Grid Control ---------------------
//--------------------------------------------------------------------
// Set Recipe Data to MapCtrl : For Column only
// i : Port No
//--------------------------------------------------------------------
void CJobsTabCimView::SetDataToGridMapInfo(int i, BOOL* bGlassMap )
{
	COLORREF colorTEXT;
	if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeCONTROL ) colorTEXT = GREEN_COLOR;
	else if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeMONITOR ) colorTEXT = RED_COLOR;
	else colorTEXT = BLACK_COLOR;

	CString strText;

	for( int nSlot=0; nSlot<MAX_SLOT_NO; nSlot++ )
	{
		m_gridMapInfo.SetCol( i + 1 );
		m_gridMapInfo.SetRow( MAX_SLOT_NO - nSlot );
		m_gridMapInfo.SetCellForeColor( colorTEXT );
		if( bGlassMap[nSlot] )
		{
			m_gridMapInfo.SetCellBackColor( DARK_GRAY_COLOR );
			//strText.Format( "Y(%s)",m_pDicsData->m_PortInfo[i].sGlassRcpId[ nSlot ] );
			strText.Format( "     Y" );
			m_gridMapInfo.SetText( strText );
		}
		else
		{
			m_gridMapInfo.SetCellBackColor( WHITE_COLOR );
			m_gridMapInfo.SetText( (LPCTSTR) "     N" );
		}
	}
}

//--------------------------------------------------------------------
// Set Recipe Data to MapCtrl : For Column only
// i : Port No
//--------------------------------------------------------------------
void CJobsTabCimView::SetSelDataToGridMapInfo(int i, BOOL* bGlassMap )
{
	COLORREF colorTEXT;
	if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeCONTROL ) colorTEXT = GREEN_COLOR;
	else if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeMONITOR ) colorTEXT = RED_COLOR;
	else colorTEXT = BLACK_COLOR;
	
	for( int nSlot=0; nSlot<MAX_SLOT_NO; nSlot++ )
	{
		m_gridMapInfo.SetCol( i + 1 );
		m_gridMapInfo.SetRow( MAX_SLOT_NO - nSlot );
		m_gridMapInfo.SetCellForeColor( colorTEXT );
		if( bGlassMap[nSlot] ) m_gridMapInfo.SetCellBackColor( DARK_GRAY_COLOR );
		else m_gridMapInfo.SetCellBackColor( WHITE_COLOR );
	}
}

//--------------------------------------------------------------------
// Set Recipe Data to MapCtrl : For Column only
// i : Port No
//--------------------------------------------------------------------
void CJobsTabCimView::SetSlotStateToGridMapInfo(int i, int j, int nState )
{
	m_gridMapInfo.SetCol( i + 1 );
	m_gridMapInfo.SetRow( MAX_SLOT_NO - j  );

	if( nState == CDicsData::glassIN )
	{
		if( m_gridMapInfo.GetText() == "     N" )
		{
			m_gridMapInfo.SetText( (LPCTSTR) "     Y" );			
		}
	}

	COLORREF colorTEXT;
	if( nState == CDicsData::glassOUT ) colorTEXT = GREEN_COLOR;
	else if( nState == CDicsData::glassIN ) colorTEXT = YELLOW_COLOR;
	else if( nState == CDicsData::glassNO ) colorTEXT = RED_COLOR;
	m_gridMapInfo.SetCellBackColor( colorTEXT );

}

void CJobsTabCimView::SetSlotStateToGridMapInfo(int i, int nState)
{
	m_gridMapInfo.SetCol( i + 1 );
	
	for( int j = 0; j < MAX_SLOT_NO; j++)
	{
		m_gridMapInfo.SetRow( MAX_SLOT_NO - j  );

		if( m_gridMapInfo.GetText() == "     Y" )
		{
			COLORREF colorTEXT;
			if( nState == CDicsData::glassOUT ) colorTEXT = GREEN_COLOR;
			else if( nState == CDicsData::glassIN ) colorTEXT = YELLOW_COLOR;
			m_gridMapInfo.SetCellBackColor( colorTEXT );
		}
	}
}

//--------------------------------------------------------------------
// i : Port No
// j : Slot No
//--------------------------------------------------------------------
void CJobsTabCimView::SetSlotScrapToGridMapInfo(int i, int j)
{
	if( m_gridMapInfo.GetText() == "     N" ) return;
	m_gridMapInfo.SetCol( i + 1 );
	m_gridMapInfo.SetRow( MAX_SLOT_NO - j  );
	m_gridMapInfo.SetCellBackColor( RED_COLOR );
	m_gridMapInfo.SetText( (LPCTSTR) "     N" );
}

//--------------------------------------------------------------------
//------------- For Control State Button ---------------------
//--------------------------------------------------------------------
// Set the color static control
//---------------------------------------------------------------------------
void CJobsTabCimView::SetCtrlState( int nCtrlType, int nCtrlNo, int nState )
{
	if( nCtrlType == MSG_CTRL_MODE )
	{
		// Clear the current state
		for( int i=0; i<3; i++ )
		{
			m_stcCtrlMode[i].StartBkBlink( FALSE );
			m_stcCtrlMode[i].StartTextBlink( FALSE );
			m_stcCtrlMode[i].SetTextColor( DARK_GRAY_COLOR );
			m_stcCtrlMode[i].SetBkColor( GRAY_COLOR );
		}

		// Set the control mode index
		long nBkColor;
		long nTextColor;
		if( nCtrlNo == CDicsData::modeCONTROL ) 
		{ 
			nCtrlNo = 2; 
			nBkColor = GREEN_COLOR;
			nTextColor = BLACK_COLOR;
		}
		else if( nCtrlNo == CDicsData::modeMONITOR ) 
		{
			nCtrlNo = 1;
			nBkColor = YELLOW_COLOR;
			nTextColor = BLACK_COLOR;
		}
		else 
		{
			nCtrlNo = 0;
			nBkColor = WHITE_COLOR;
			nTextColor = RED_COLOR;
		}

		if( nState == CDicsData::stateON ) 
		{
			m_stcCtrlMode[nCtrlNo].SetTextColor( nTextColor );
			m_stcCtrlMode[nCtrlNo].SetBkColor( nBkColor );	
		}
		else if( nState == CDicsData::stateTOGGLE ) 
		{
			m_stcCtrlMode[nCtrlNo].SetBlinkBkColors( RED_COLOR, YELLOW_COLOR );
			m_stcCtrlMode[nCtrlNo].SetBlinkTextColors( YELLOW_COLOR, RED_COLOR );
			m_stcCtrlMode[nCtrlNo].StartBkBlink( TRUE, CColorStatic::ST_FLS_NORMAL );
			m_stcCtrlMode[nCtrlNo].StartTextBlink( TRUE, CColorStatic::ST_FLS_NORMAL );
		}
	}
	else if( nCtrlType == MSG_LOADER_MODE )
	{ 
		// Clear the current state
		for( int i=0; i<3; i++ )
		{
			m_stcLoaderMode[i].StartBkBlink( FALSE );
			m_stcLoaderMode[i].StartTextBlink( FALSE );
			m_stcLoaderMode[i].SetTextColor( DARK_GRAY_COLOR );
			m_stcLoaderMode[i].SetBkColor( GRAY_COLOR );
		}

		// Set the control mode index
		long nBkColor;
		long nTextColor;
		if( nCtrlNo == CDicsData::modeREMOTE ) 
		{ 
			nCtrlNo = 0; 
			nBkColor = GREEN_COLOR;
			nTextColor = BLACK_COLOR;
		}
		else if( nCtrlNo == CDicsData::modeLOCAL ) 
		{
			nCtrlNo = 1;
			nBkColor = WHITE_COLOR;
			nTextColor = BLACK_COLOR;
		}
		else 
		{
			nCtrlNo = 2;
			nBkColor = RED_COLOR;
			nTextColor = BLACK_COLOR;
		}

		if( nState == CDicsData::stateON ) 
		{
			m_stcLoaderMode[nCtrlNo].SetTextColor( nTextColor );
			m_stcLoaderMode[nCtrlNo].SetBkColor( nBkColor );	
		}
		else if( nState == CDicsData::stateTOGGLE ) 
		{
			m_stcLoaderMode[nCtrlNo].SetBlinkBkColors( RED_COLOR, YELLOW_COLOR );
			m_stcLoaderMode[nCtrlNo].SetBlinkTextColors( YELLOW_COLOR, RED_COLOR );
			m_stcLoaderMode[nCtrlNo].StartBkBlink( TRUE, CColorStatic::ST_FLS_NORMAL );
			m_stcLoaderMode[nCtrlNo].StartTextBlink( TRUE, CColorStatic::ST_FLS_NORMAL );
		}
	}
}

//---------------------------------------------------------------------------
// Set the color static control
//---------------------------------------------------------------------------
void CJobsTabCimView::SetTrsMode( int i, char cTrsMode )
{
	if( cTrsMode == CDicsData::modeAGV )
	{
		m_btnPortAgv[i].SetBGColor( GREEN_COLOR );
		m_btnPortAgv[i].SetFGColor( BLACK_COLOR );
		m_btnPortMgv[i].SetBGColor( GRAY_COLOR );
		m_btnPortMgv[i].SetFGColor( BLACK_COLOR );
	}
	else
	{
		m_btnPortMgv[i].SetBGColor( RED_COLOR );
		m_btnPortMgv[i].SetFGColor( BLACK_COLOR );
		m_btnPortAgv[i].SetBGColor( GRAY_COLOR );
		m_btnPortAgv[i].SetFGColor( BLACK_COLOR );
	}

	m_btnPortAgv[i].Invalidate();
	m_btnPortMgv[i].Invalidate();
}

void CJobsTabCimView::SetPortMode( int i, char cPortMode )
{
	if( cPortMode == CPortInfo::modeENABLE )
	{
		m_btnPortEnable[i].SetBGColor( GREEN_COLOR );
		m_btnPortEnable[i].SetFGColor( BLACK_COLOR );
		m_btnPortDisable[i].SetBGColor( GRAY_COLOR );
		m_btnPortDisable[i].SetFGColor( BLACK_COLOR );
	}
	else
	{
		m_btnPortDisable[i].SetBGColor( RED_COLOR );
		m_btnPortDisable[i].SetFGColor( BLACK_COLOR );
		m_btnPortEnable[i].SetBGColor( GRAY_COLOR );
		m_btnPortEnable[i].SetFGColor( BLACK_COLOR );
	}

	m_btnPortEnable[i].Invalidate();
	m_btnPortDisable[i].Invalidate();
}

//--------------------------------------------------------------------
// Auto/Manual
//--------------------------------------------------------------------
void CJobsTabCimView::EnableTrsAction( int nPortNo, BOOL bEnable )
{
	GetDlgItem( IDC_AGV_PORT1 + nPortNo )->EnableWindow( bEnable );
	GetDlgItem( IDC_MGV_PORT1 + nPortNo )->EnableWindow( bEnable );
}

//--------------------------------------------------------------------
// Enable/Disable
//--------------------------------------------------------------------
void CJobsTabCimView::EnablePortAction( int nPortNo, BOOL bEnable )
{
	GetDlgItem( IDC_ENABLE_PORT1 + nPortNo )->EnableWindow( bEnable );
	GetDlgItem( IDC_DISABLE_PORT1 + nPortNo )->EnableWindow( bEnable );
}

//--------------------------------------------------------------------
// Grid Control
//--------------------------------------------------------------------
BEGIN_EVENTSINK_MAP(CJobsTabCimView, CFormView)
    //{{AFX_EVENTSINK_MAP(CJobsTabCimView)
	ON_EVENT(CJobsTabCimView, IDC_GRID_MAP_INFO, -601 /* DblClick */, OnDblClickGridMapInfo, VTS_NONE)
//	ON_EVENT(CJobsTabCimView, IDC_GRID_MAP_INFO, -600 /* Click */, OnClickGridMapInfo, VTS_NONE)
	ON_EVENT(CJobsTabCimView, IDC_GRID_LOT_INFO, -600 /* Click */, OnClickGridLotInfo, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

//--------------------------------------------------------------------
// Lot Info
//--------------------------------------------------------------------
void CJobsTabCimView::OnClickGridLotInfo() 
{
	int nRow = m_gridLotInfo.GetRowSel();
	int nCol = m_gridLotInfo.GetColSel();

	if( !m_bCanModify[nCol - 1] ) return;

	// CST ID or less than 8
	if( nRow > m_nCanModifyNo ) return;

	CString sData = m_gridLotInfo.GetText();
	CDlgEditVal dlg;
	dlg.m_sOldVal = dlg.m_sCurVal = sData;
	dlg.m_nFormat = CDlgEditVal::formatSTRING;

	if( dlg.DoModal() == IDOK )
	{
		sData = dlg.m_sCurVal;

		// Recipe Range Check             //<-JOE, YOUNG JAE (041214)
		if( nRow == 1 )  
		{
			int nRecipe = atoi( sData );
			CDicsDoc* pDoc = ( (CDicsView *) m_pView )->GetDocument();
			if( pDoc->m_pRecipeSet->FindRecipe( sData ) == FALSE ) 
			{
				AfxMessageBox("NO Matching Recipe (Out of Range of Recipe)");
				return;
			}
		}
		
		// CSTID Check
		if( nRow == 2 && m_pDicsData->m_PortInfo[nCol-1].sCstId != sData )
		{
			AfxMessageBox("NO Matching CSTID");
			return;
		}

		if( nRow == 9 && m_pDicsData->m_PortInfo[nCol-1].sSlotInfoMap != sData )
		{
			AfxMessageBox("NO Matching Slot Map Info");
			return;
		}

		m_gridLotInfo.SetText( (LPCTSTR) sData );
		GetDataFromGridLotInfo( nCol - 1 );
	}
}

//--------------------------------------------------------------------
// Map Info
//--------------------------------------------------------------------
void CJobsTabCimView::OnDblClickGridMapInfo() 
{
	int nRow = m_gridMapInfo.GetRowSel();
	int nCol = m_gridMapInfo.GetColSel();
	CString sVal = m_gridMapInfo.GetText();

	// zero based port number
	int i = nCol - 1;
	int j = MAX_SLOT_NO - nRow;

	if( sVal != "     Y" ) return;

	if( AfxMessageBox( "Do you have key in Glass ID?", MB_YESNO | MB_ICONQUESTION ) == IDYES )
	{
//		CString sData = m_pDicsData->m_PortInfo[i].sGlassId[j];
		CDlgEditVal dlg;
		dlg.m_nType = CDlgEditVal::typeGLASSID;
		dlg.m_sTitle = "Glass ID";
		dlg.DoModal();
		m_pDicsData->m_PortInfo[i].sOpGlassId[j] = dlg.m_sCurVal;
		return;
	}

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;

	if( !pMainFrame->m_bAuto )
	{
		if( AfxMessageBox( "Do you want to Delete Report ?", MB_YESNO | MB_ICONQUESTION ) == IDYES )
		{
			m_pDicsData->m_IfLoader.nScrapPortNo = i + 1;
			m_pDicsData->m_IfLoader.nScrapSlotNo = j + 1;

			m_pDicsData->m_IfLoader.bScrapReq = TRUE;
			return;
		}
	}
	// To convert the map
	OnClickGridMapInfo();

/*	CDlgGlassInfo dlg;
	dlg.m_pDicsData = m_pDicsData;
	dlg.m_nPortNo = i;
	dlg.m_nSlotNo = j;*/
}

void CJobsTabCimView::OnClickGridMapInfo() 
{
	int nRow = m_gridMapInfo.GetRowSel();
	int nCol = m_gridMapInfo.GetColSel();
	CString sVal = m_gridMapInfo.GetText();
	if( sVal != "     Y" ) return;

	// zero based number
	int i = nCol - 1;
	int j = MAX_SLOT_NO - nRow;

	if( !m_bCanModify[i] ) return;

	if( m_pDicsData->m_PortInfo[i].bGlassMapSel[j] )
	{
		m_pDicsData->m_PortInfo[i].bGlassMapSel[j] = FALSE;
		m_gridMapInfo.SetCol( i + 1 );
        m_gridMapInfo.SetRow( MAX_SLOT_NO - j );
		m_gridMapInfo.SetCellBackColor( WHITE_COLOR );
	}
	else
	{
		m_pDicsData->m_PortInfo[i].bGlassMapSel[j] = TRUE;
		m_gridMapInfo.SetCol( i + 1 );
        m_gridMapInfo.SetRow( MAX_SLOT_NO - j );
		m_gridMapInfo.SetCellBackColor( DARK_GRAY_COLOR );
	}
}

//--------------------------------------------------------------------
// Change to AGV Mode
//--------------------------------------------------------------------
void CJobsTabCimView::OnPortAgv(UINT nID) 
{
	int i = nID - IDC_AGV_PORT1;

	if( m_pDicsData->m_PortInfo[i].cTrsMode == CDicsData::modeAGV ) return;

	if( AfxMessageBox( "Do you want to change to AUTO mode ?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) return;

	//CString sBuf;
	//sBuf.Format( "CLICK_BUTTON\tPort%d enable", i + 1 );
	//Log.TextOut( sBuf );

	m_pDicsData->m_IfCim.bTrsModeChangeReq[i] = TRUE;
	m_pDicsData->m_IfCim.cTrsMode[i] = CDicsData::modeAGV;
//	SetTrsMode( i, CDicsData::modeAGV );
}

//--------------------------------------------------------------------
// Change to MGV Mode
//--------------------------------------------------------------------
void CJobsTabCimView::OnPortMgv(UINT nID) 
{
	int i = nID - IDC_MGV_PORT1;

	if( m_pDicsData->m_PortInfo[i].cTrsMode == CDicsData::modeMGV ) return;

	if( AfxMessageBox( "Do you want to change to MANUAL mode ?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) return;

	//CString sBuf;
	//sBuf.Format( "CLICK_BUTTON\tPort%d enable", i + 1 );
	//Log.TextOut( sBuf );

	m_pDicsData->m_IfCim.bTrsModeChangeReq[i] = TRUE;
	m_pDicsData->m_IfCim.cTrsMode[i] = CDicsData::modeMGV;
//	SetTrsMode( i, CDicsData::modeMGV );
}

//--------------------------------------------------------------------
// Port Enable
//--------------------------------------------------------------------
void CJobsTabCimView::OnPortEnable(UINT nID) 
{/*
	int i = nID - IDC_ENABLE_PORT1;

	if( m_pDicsData->m_IfLoader.cCstState[i] == CLoaderSeq::cstEXIST ) return;

	if( m_pDicsData->m_PortInfo[i].cPortMode == CPortInfo::modeENABLE ) return;

	if( AfxMessageBox( "Do you want to change port mode to enable ?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) return;

	//CString sBuf;
	//sBuf.Format( "CLICK_BUTTON\tPort%d enable", i + 1 );
	//Log.TextOut( sBuf );

	m_pDicsData->m_IfCim.bPortModeChangeReq[i] = TRUE;
	m_pDicsData->m_IfCim.cPortMode[i] = CPortInfo::modeENABLE;

//	SetPortMode( i, CPortInfo::modeENABLE ); */
}

//--------------------------------------------------------------------
// Port Enable
//--------------------------------------------------------------------
void CJobsTabCimView::OnPortDisable(UINT nID) 
{/*
	int i = nID - IDC_DISABLE_PORT1;

 	if( m_pDicsData->m_IfLoader.cCstState[i] ==  CLoaderSeq::cstEXIST ) return;

	if( m_pDicsData->m_PortInfo[i].cPortMode == CPortInfo::modeDISABLE ) return;

	if( AfxMessageBox( "Do you want to change port mode to disable ?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) return;

	//CString sBuf;
	//sBuf.Format( "CLICK_BUTTON\tPort%d disable", i + 1 );
	//Log.TextOut( sBuf );

	m_pDicsData->m_IfCim.bPortModeChangeReq[i] = TRUE;
	m_pDicsData->m_IfCim.cPortMode[i] = CPortInfo::modeDISABLE; */
//	SetPortMode( i, CPortInfo::modeDISABLE );
}

//--------------------------------------------------------------------
// Process Start
//--------------------------------------------------------------------
void CJobsTabCimView::OnPortStart(UINT nID)
{/*
	if( AfxMessageBox( "Is Receipe Correct ?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) return;
	if( AfxMessageBox( "Do you want to start the process ?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) return;

	int i = nID - IDC_PROCESS_START_PORT1;

	if( (m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeOFFLINE) && m_pDicsData->m_PortInfo[i].sLotId == "" )
	{
		AfxMessageBox( "Please!! Input LOTID", MB_OK );
		return;
	}

	// Flag Reset, Disable button
	m_bCanModify[i] = FALSE;

	// Disable Process Start Button
	EnableProcessStartButton( i, FALSE );

	// Set the background color to WHITE_COLOR
	SetBackColorGridLotInfo( i, FALSE );
	
	// Get data from grid control
	GetDataFromGridLotInfo( i );

	// Set Flag
	m_pDicsData->m_IfCim.bProcessStartReq[i] = TRUE; */
}

//--------------------------------------------------------------------
// LD Port Cancel
//--------------------------------------------------------------------
void CJobsTabCimView::OnPortCancel(UINT nID) 
{/*
	if( AfxMessageBox( "Do you want to cancel the port ?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) return;

	int i = nID - IDC_CANCEL_PORT1;

	CString sBuf;

	// Flag Reset, Disable button
	m_bCanModify[i] = FALSE;

	// Disable the Cancel Button
	EnableProcessStartButton( i, FALSE );
	EnablePortCancelButton( i, FALSE );

	// Set the background color to WHITE_COLOR
	SetBackColorGridLotInfo( i, FALSE );

	// Set Flag
	m_pDicsData->m_IfCim.bPortCancelReq[i] = TRUE; */
}

//--------------------------------------------------------------------
// UL Port Abort
//--------------------------------------------------------------------
void CJobsTabCimView::OnPortAbort(UINT nID) 
{/*
	if( AfxMessageBox( "Do you want to abort the port ?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) return;

	int i = nID - IDC_ABORT_PORT1;

	// Disable the Abort Button
	EnablePortAbortButton( i, FALSE );
	
	// Set Flag
	m_pDicsData->m_IfCim.bPortAbortReq[i] = TRUE; */
}

//--------------------------------------------------------------------
// UL Port Abort
//--------------------------------------------------------------------
void CJobsTabCimView::OnPortReload(UINT nID) 
{/*
	int i = nID - IDC_RELOAD_PORT1;
	if( m_pDicsData->m_PortInfo[i].cTrsMode == CDicsData::modeAGV ) 
	{
		AfxMessageBox( "You can't reload to Auto Mode, Please!! Change Manual Mode", MB_OK | MB_ICONQUESTION );
		return;
	}

	if( AfxMessageBox( "Do you want to reload the port ?", MB_YESNO | MB_ICONQUESTION ) != IDYES ) return;

	// Disable the Abort Button
	EnablePortReloadButton( i, FALSE );
	
	// Set Flag
	m_pDicsData->m_IfLoader.bPortReloadReq[i] = TRUE; */
}

//--------------------------------------------------------------------
// Enable / Disable the Port Cancel Button
// bOnlySet 
//	1. TRUE Mode ȯ Ǹ鼭 bEnableButtonCancel   SetҶ
//		==> SeqCtlModeChange() ϰ 
//	2. Default : FALSE Normal Sequence ϸ鼭 ش  Setؾ ϴ 
//	3. Remote Mode϶ ۾ڰ  Button  .
//--------------------------------------------------------------------
void CJobsTabCimView::EnablePortCancelButton( int i, BOOL bEnable )
{
	GetDlgItem( IDC_CANCEL_PORT1 + i )->EnableWindow( bEnable );

	if( bEnable /*&& m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeCONTROL*/ )
	{
		// Set the Red color
		m_btnPortCancel[i].SetBGColor( RED_COLOR );
		m_btnPortCancel[i].Invalidate();
	}
	else
	{
		m_btnPortCancel[i].SetBGColor( GRAY_COLOR );
		m_btnPortCancel[i].Invalidate();
	}
}

//--------------------------------------------------------------------
// Enable / Disable the Port Start Button
// bOnlySet 
//	1. TRUE Mode ȯ Ǹ鼭 bEnableButtonStart   SetҶ
//		==> SeqCtlModeChange() ϰ 
//	2. Default : FALSE Normal Sequence ϸ鼭 ش  Setؾ ϴ 
//	3. Remote Mode϶ ۾ڰ  Button  .
//--------------------------------------------------------------------
void CJobsTabCimView::EnableProcessStartButton( int i, BOOL bEnable, BOOL bOnlySet )
{
	// Set the lot info state
	if( !bOnlySet ) m_pDicsData->m_IfCim.bEnableButtonStart[i] = bEnable;

//	if( bEnable && ( m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeCONTROL 
//		|| m_pDicsData->m_PortInfo[i].cEsFlag == 'E' ) )
	if( bEnable )
	{
		GetDlgItem( IDC_PROCESS_START_PORT1 + i )->EnableWindow( TRUE );

		// Set the Red color
		m_btnPortStart[i].SetBGColor( GREEN_COLOR );
		m_btnPortStart[i].Invalidate();
	}
	else
	{
		GetDlgItem( IDC_PROCESS_START_PORT1 + i )->EnableWindow( FALSE );

		m_btnPortStart[i].SetBGColor( GRAY_COLOR );
		m_btnPortStart[i].Invalidate();
	}
}

//--------------------------------------------------------------------
// Enable / Disable the Port Abort Button
// bOnlySet 
//	1. TRUE Mode ȯ Ǹ鼭 bEnableButtonAbort   SetҶ
//		==> SeqCtlModeChange() ϰ 
//	2. Default : FALSE Normal Sequence ϸ鼭 ش  Setؾ ϴ 
//	3. Remote Mode϶ ۾ڰ  Button  .
//--------------------------------------------------------------------
void CJobsTabCimView::EnablePortAbortButton( int i, BOOL bEnable, BOOL bOnlySet )
{
	// Set the lot info state
	if( !bOnlySet ) m_pDicsData->m_IfCim.bEnableButtonAbort[i] = bEnable;

//	if( bEnable && m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeCONTROL )
	if( bEnable )
	{
		GetDlgItem( i + IDC_ABORT_PORT1 )->EnableWindow( TRUE );

		// Set the Red color
		m_btnPortAbort[i].SetBGColor( RED_COLOR );
		m_btnPortAbort[i].Invalidate();
	}
	else
	{
		GetDlgItem( i + IDC_ABORT_PORT1 )->EnableWindow( FALSE );

		m_btnPortAbort[i].SetBGColor( GRAY_COLOR );
		m_btnPortAbort[i].Invalidate();
	}
}

//--------------------------------------------------------------------
//--------------------------------------------------------------------
void CJobsTabCimView::EnablePortReloadButton( int i, BOOL bEnable )
{
	if( bEnable )
	{
		GetDlgItem( i + IDC_RELOAD_PORT1 )->EnableWindow( TRUE );

		// Set the Red color
		m_btnPortReload[i].SetBGColor( GREEN_COLOR );
		m_btnPortReload[i].Invalidate();
	}
	else
	{
		GetDlgItem( i + IDC_RELOAD_PORT1 )->EnableWindow( FALSE );

		m_btnPortReload[i].SetBGColor( GRAY_COLOR );
		m_btnPortReload[i].Invalidate();
	}
}

//--------------------------------------------------------------------
// Display the terminal message
//--------------------------------------------------------------------
void CJobsTabCimView::SetTerminalMsg( CString sMsg )
{
	COleDateTime tm = COleDateTime::GetCurrentTime();
	CString sTime;
	sTime.Format( "[RECV] %04d/%02d/%02d %02d:%02d:%02d - ", 
		tm.GetYear(), tm.GetMonth(), tm.GetDay(), tm.GetHour(), tm.GetMinute(), tm.GetSecond() );
	
	CString sVal;
	sVal.Format( "%5s%s", sTime, sMsg );
	if( m_cbTerminalMsg.GetCount() >= 50 ) m_cbTerminalMsg.DeleteString( 0 );
	int i = m_cbTerminalMsg.AddString( sVal );
	m_cbTerminalMsg.SetCurSel( i );

	// Save Data
	( (CDicsView*) m_pView)->m_pHost->m_sTerminalMessage = 
		( (CDicsView*) m_pView)->m_pHost->m_sTerminalMessage + sVal + "\r\n"; 
}

#include "DlgHostMsg.h"

void CJobsTabCimView::OnHostMessage() 
{
//	CDlgHostMsg Dlg;
	
//	Dlg.SetHost( ( (CDicsView*) m_pView)->m_pHost );
//	Dlg.m_sMessage = ( (CDicsView*) m_pView)->m_pHost->m_sTerminalMessage;
//	Dlg.DoModal();
}

void CJobsTabCimView::OnVcrMode( WPARAM wParam, LPARAM lParam )
{
	if( wParam == 202 )
	{
		CDicsApp* pApp = (CDicsApp*) AfxGetApp();
		CMainFrame* pMainFrame = (CMainFrame*)pApp->m_pMainWnd;
//		if( pMainFrame->m_bAuto ) return;
		if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;

		CString sData;
		int nVcrMode;
		CDlgVcrMode Dlg;
		Dlg.DoModal();
		nVcrMode = Dlg.nVcrCodeNo;

		if( nVcrMode == 1 )
		{
			m_pDicsData->m_IfCim.sVcrMode = "OS";
			m_msgVcrReport.SetOpMsg( "ON(Error Skip)" );
		}
		else if( nVcrMode == 2 )
		{
			m_pDicsData->m_IfCim.sVcrMode = "OK";
			m_msgVcrReport.SetOpMsg( "ON(Error KeyIn)" );
		}
		else if( nVcrMode == 3 )
		{
			m_pDicsData->m_IfCim.sVcrMode = "FS";
			m_msgVcrReport.SetOpMsg( "OFF(Skip)" );
		}
		else if( nVcrMode == 4 )
		{
			m_pDicsData->m_IfCim.sVcrMode = "FK";
			m_msgVcrReport.SetOpMsg( "OFF(Always KeyIn)" );
		}
	}
}
void CJobsTabCimView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	CFormView::OnTimer(nIDEvent);
}

void CJobsTabCimView::UpdateObjects()
{
	UpdatePortStatus();
}

void CJobsTabCimView::UpdatePortStatus()
{
	static	int nOldPortStatus[MAX_PORT_NO] = { -1, -1, -1 };
	
	for( int i = 0 ; i < MAX_PORT_NO ; i++ )
	{
		if( ( nOldPortStatus[i] != 1 ) && ( m_pDicsData->m_PortInfo[i].cPortStatus == CDicsData::portLC ) )
		{
			nOldPortStatus[i] = 1;

			m_stcPortFull[i].SetTextColor( BLACK_COLOR );
			m_stcPortFull[i].SetBkColor( GREEN_COLOR );

			m_stcPortEmpty[i].SetTextColor( BLACK_COLOR );
			m_stcPortEmpty[i].SetBkColor( GRAY_COLOR );
		}
		else if( ( nOldPortStatus[i] != 0 ) && ( m_pDicsData->m_PortInfo[i].cPortStatus == CDicsData::portUC ) )
		{
			nOldPortStatus[i] = 0;

			m_stcPortFull[i].SetTextColor( BLACK_COLOR );
			m_stcPortFull[i].SetBkColor( GRAY_COLOR );

			m_stcPortEmpty[i].SetTextColor( BLACK_COLOR );
			m_stcPortEmpty[i].SetBkColor( RED_COLOR );
		}
	}
}

void CJobsTabCimView::OnTestModeStart() 
{/*
	// TODO: Add your control notification handler code here
	CDicsView*	pView = (CDicsView*) m_pView;

	CDlgTestRunSet	dlg;
	BOOL	bPortState[MAX_PORT_NO] = { TRUE, TRUE, TRUE };
	CString		sMsg;

	BOOL bEnable = pView->m_pDicsData->m_GenInfo.bAuto &
					( pView->m_pDicsData->m_LoginInfo.nCurUserLevel >= CDicsData::idENGINEER ) &
					( pView->m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) &
					( pView->m_pDicsData->m_GenInfo.bEqpInitComp );

	if( ( m_pDicsData->m_EqpInfo.cCtlMode != CDicsData::modeOFFLINE ) )
	{
		AfxMessageBox( "Can't run Test-Mode. Change to OFFLINE first." );
		return;
	}
	if( !m_pDicsData->m_GenInfo.bEqpInitComp )
	{
		AfxMessageBox( "Can't run Test-Mode. Excute Equipment Initialize first." );
		return;
	}
	if( m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER )
	{
		AfxMessageBox( "Can't run Test-Mode. Change to user to ENGINEER first." );
		return;
	}
	if( !m_pDicsData->m_GenInfo.bAuto )
	{
		AfxMessageBox( "Can't run Test-Mode. Change to Auto first." );
		return;
	}
	if( m_pDicsData->m_EqpInfo.cEqpState != CDicsData::modeIDLE )
	{
		AfxMessageBox( "Can't run Test-Mode. Please push when Equipment is IDLE state." );
		return;
	}

	for( int i = 0 ; i < MAX_PORT_NO ; i++ )
	{
		bPortState[i] &= ( ( m_pDicsData->m_PortInfo[i].cPortStatus == CDicsData::portLC ) ? 1 : 0 );
	}

	if( !bPortState[0] && !bPortState[1] && !bPortState[2] )
	{
		AfxMessageBox( "Can't run Test-Mode. Cassette is not ready." );
		return;
	}


	for( i = 0 ; i < MAX_PORT_NO ; i++ )
	{
		dlg.m_bPortEnable[i] = bPortState[i];
	}

	dlg.SetView( pView );
	if( dlg.DoModal() == IDOK )
	{
		if( dlg.m_macPortSelect[0].GetCheck() || dlg.m_macPortSelect[1].GetCheck() || dlg.m_macPortSelect[2].GetCheck() )
		{
			pView->m_pCimSeq->m_TestModeFlag.bTestModeRunning = TRUE;
			pView->m_pCimSeq->m_TestModeFlag.bTestModeCancel = FALSE;
			pView->m_pCimSeq->m_TestModeFlag.bSlotSelectComplete = FALSE;
			pView->m_pCimSeq->m_TestModeFlag.nCurSelCount = 0;
			pView->m_pCimSeq->m_TestModeFlag.nInputGlassCount = 0;
			pView->m_pCimSeq->m_TestModeFlag.nOutputGlassCount = 0;
			pView->m_pCimSeq->m_TestModeFlag.nTestSettingCount = dlg.m_nTestCount;
			pView->m_pCimSeq->m_TestModeFlag.sTestRecipeId = dlg.m_sRecipeId;

			EnableTestModeButton( FALSE );

			sMsg.Format( "0 / 0 / %d", dlg.m_nTestCount );
			m_msgGlassCount.SetOpMsg( sMsg );

			for( int i = 0 ; i < MAX_PORT_NO ; i++ )
			{
				if( dlg.m_macPortSelect[i].GetCheck() && !pView->m_pCimSeq->m_TestModeFlag.bSlotSelectComplete )
				{
					pView->m_pCimSeq->m_TestModeFlag.bCstSelect[i] = TRUE;
					for( int j = 0 ; j < MAX_SLOT_NO ; j++ )
					{
						if( m_pDicsData->m_PortInfo[i].bGlassMapSel[j] && !pView->m_pCimSeq->m_TestModeFlag.bSlotSelectComplete )
						{
							pView->m_pCimSeq->m_TestModeFlag.nCurSelCount++;
							m_pDicsData->m_PortInfo[i].m_GlsInfo[j].sRecipeId = pView->m_pCimSeq->m_TestModeFlag.sTestRecipeId;
							if( pView->m_pCimSeq->m_TestModeFlag.nCurSelCount >= pView->m_pCimSeq->m_TestModeFlag.nTestSettingCount )
							{
								pView->m_pCimSeq->m_TestModeFlag.bSlotSelectComplete = TRUE;
							}
						}
						else if( m_pDicsData->m_PortInfo[i].bGlassMapSel[j] && pView->m_pCimSeq->m_TestModeFlag.bSlotSelectComplete )
						{
							m_pDicsData->m_PortInfo[i].bGlassMapSel[j]= FALSE;
							m_gridMapInfo.SetCol( i + 1 );
							m_gridMapInfo.SetRow( MAX_SLOT_NO - j );
							m_gridMapInfo.SetCellBackColor( WHITE_COLOR );
						}
					}
				}
				else if( dlg.m_macPortSelect[i].GetCheck() && pView->m_pCimSeq->m_TestModeFlag.bSlotSelectComplete )
				{
					pView->m_pCimSeq->m_TestModeFlag.bCstSelect[i] = FALSE;
					m_bCanLotModify[i] = m_bCanMapModify[i] = FALSE;

					EnableProcessStartButton( i, FALSE );
					EnablePortCancelButton( i, FALSE );
					SetBackColorGridLotInfo( i, FALSE );

					m_pDicsData->m_IfCim.bPortCancelReq[i] = TRUE;
				}
				else if( !dlg.m_macPortSelect[i].GetCheck() && bPortState[i] )
				{
					m_bCanLotModify[i] = m_bCanMapModify[i] = FALSE;

					EnableProcessStartButton( i, FALSE );
					EnablePortCancelButton( i, FALSE );
					SetBackColorGridLotInfo( i, FALSE );

					m_pDicsData->m_IfCim.bPortCancelReq[i] = TRUE;
				}
				else
				{
					pView->m_pCimSeq->m_TestModeFlag.bCstSelect[i] = FALSE;
				}
			}
		}
	}	*/
}

void CJobsTabCimView::OnTestModeEnd() 
{/*
	// TODO: Add your control notification handler code here
	CDicsView*	pView = (CDicsView*) m_pView;
	int nRv;

	if( ( nRv = AfxMessageBox( "Are you want to Cancel Test Mode Run??", MB_YESNO ) ) != IDYES )
		return;

	for( int i = 0 ; i < MAX_PORT_NO ; i++ )
	{
		if( pView->m_pCimSeq->m_TestModeFlag.bCstSelect[i] = TRUE )
		{
			pView->m_pCimSeq->m_TestModeFlag.bCstSelect[i] = FALSE;
			
			if( m_pDicsData->m_PortInfo[i].cLdState == CDicsData::modeRUN )
			{
				EnablePortAbortButton( i, FALSE );
				m_pDicsData->m_IfCim.bPortAbortReq[i] = TRUE;
			}
			else if( m_pDicsData->m_PortInfo[i].cLdState == CDicsData::modeIDLE )
			{
				m_bCanLotModify[i] = m_bCanMapModify[i] = FALSE;

				EnableProcessStartButton( i, FALSE );
				EnablePortCancelButton( i, FALSE );
				SetBackColorGridLotInfo( i, FALSE );

				m_pDicsData->m_IfCim.bPortCancelReq[i] = TRUE;
			}
			else
			{
				pView->m_pCimSeq->m_TestModeFlag.bTestModeCancel = TRUE;
			}
		}
	}

	pView->m_pCimSeq->m_TestModeFlag.bTestModeRunning = FALSE;
	pView->m_pCimSeq->m_TestModeFlag.bSlotSelectComplete = TRUE;

	EnableTestModeButton( TRUE );	 */
}

void CJobsTabCimView::EnableTestModeButton(BOOL bEnable)
{
	GetDlgItem( IDC_TEST_MODE_START )->EnableWindow( bEnable );
	GetDlgItem( IDC_TEST_MODE_END )->EnableWindow( !bEnable );
}
