#if !defined(AFX_JOBSTABCIMVIEW_H__8C83A811_4E0E_4BA1_B5EC_7D0E7E620A60__INCLUDED_)
#define AFX_JOBSTABCIMVIEW_H__8C83A811_4E0E_4BA1_B5EC_7D0E7E620A60__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// JobsTabCimView.h : header file
//

#include "X\ColorStatic.h"
#include "X\ColorBtn.h"
#include "X\MsgBox.h"
#include "X\MacButtons.h"
#include "DicsData.h"

/////////////////////////////////////////////////////////////////////////////
// CJobsTabCimView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CJobsTabCimView : public CFormView
{
public:
	CJobsTabCimView();           // protected constructor used by dynamic creation
	CJobsTabCimView( CView* pView, int nTabNo );
	DECLARE_DYNCREATE(CJobsTabCimView)

// Form Data
public:
	//{{AFX_DATA(CJobsTabCimView)
	enum { IDD = IDD_JOBS_TAB_CIM_VIEW };
	CComboBox	m_cbTerminalMsg;
	CMSFlexGrid	m_gridMapInfo;
	CMSFlexGrid	m_gridLotInfo;
	CMacButton	m_macHostMessage;
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Attributes
public:
	CView*	m_pView;
	CDicsData*		m_pDicsData;

	int				m_nTabNo;
	CMsgBox			m_msgCimMessage;
	CMsgBox			m_msgGlassCount;
	CMsgBox			m_msgVcrReport;

	// color brush
	HBRUSH			m_hbrBgColor;
	HBRUSH			m_hbrTextColor;

	CColorStatic	m_stcCtrlMode[3];
	CColorStatic	m_stcLoaderMode[3];
	CColorStatic	m_stcPortEmpty[MAX_PORT_NO];
	CColorStatic	m_stcPortFull[MAX_PORT_NO];

	CColorButton	m_btnPortAgv[MAX_PORT_NO];
	CColorButton	m_btnPortMgv[MAX_PORT_NO];
	CColorButton	m_btnPortStart[MAX_PORT_NO];
	CColorButton	m_btnPortCancel[MAX_PORT_NO];
	CColorButton	m_btnPortAbort[MAX_PORT_NO];
	CColorButton	m_btnPortReload[MAX_PORT_NO];
	CColorButton	m_btnPortEnable[MAX_PORT_NO];
	CColorButton	m_btnPortDisable[MAX_PORT_NO];

	BOOL			m_bCanModify[MAX_PORT_NO];
	BOOL            m_bChangedMapData[MAX_PORT_NO];
	BOOL			m_bCanLotModify[MAX_PORT_NO];
	BOOL			m_bCanMapModify[MAX_PORT_NO];

	int				m_nCanModifyNo;
	int				m_nTestModeTotalCount;
	int				m_nTestModeCurCount;

// Operations
public:
	void GridLotInfoInit();
	void GridMapInfoInit();
	void CtrlStateInit();
	void SetDataToGridLotInfo(int i);
	void GetDataFromGridLotInfo(int i);
	void SetDataToGridMapInfo(int i, BOOL* bGlassMap );
	void SetSelDataToGridMapInfo(int i, BOOL* bGlassMap );
	void SetSlotStateToGridMapInfo(int i, int j, int nState);
	void SetSlotStateToGridMapInfo(int i, int nState);
	void SetSlotScrapToGridMapInfo(int i, int j);

	void CtrlStateClear(int nCtrlType);
	void SetCtrlState( int nCtrlType, int nCtrlNo, int nState );
	void SetPrepareMonitorMode(int i);
	void SetPrepareOfflineMode(int i);
	void SetLdPortInfo(int i);
	void SetBackColorGridLotInfo( int i, BOOL bSetBackColor, int nModifyNo = 9 );
	void SetTrsMode( int i, char cTrsMode );
	void SetPortMode( int i, char cPortMode );
	void SetPortState( int i, char cPortState );
	void EnableTrsAction( int nPortNo, BOOL bEnable );
	void EnablePortAction( int nPortNo, BOOL bEnable );
	void SetTerminalMsg( CString sMsg );

	void EnablePortCancelButton( int i, BOOL bEnable );
	void EnableProcessStartButton( int i, BOOL bEnable, BOOL bOnlySet = FALSE );
	void EnablePortAbortButton( int i, BOOL bEnable , BOOL bOnlySet = FALSE);
	void EnablePortReloadButton( int i, BOOL bEnable );

	void EnableTestModeButton(BOOL bEnable);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJobsTabCimView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	void UpdatePortStatus();
	void UpdateObjects();
	virtual ~CJobsTabCimView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CJobsTabCimView)
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnClose();
	afx_msg void OnDblClickGridMapInfo();
	afx_msg void OnClickGridMapInfo();
	afx_msg void OnClickGridLotInfo();
	afx_msg void OnPortAgv( UINT nID );
	afx_msg void OnPortMgv( UINT nID );
	afx_msg void OnPortEnable( UINT nID );
	afx_msg void OnPortDisable( UINT nID );
	afx_msg void OnPortStart( UINT nID );
	afx_msg void OnPortCancel( UINT nID );
	afx_msg void OnPortAbort( UINT nID );
	afx_msg void OnPortReload( UINT nID );
	afx_msg void OnHostMessage();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnTestModeStart();
	afx_msg void OnTestModeEnd();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	afx_msg void OnVcrMode( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JOBSTABCIMVIEW_H__8C83A811_4E0E_4BA1_B5EC_7D0E7E620A60__INCLUDED_)
