// JobsTabDoorView.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "JobsTabDoorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJobsTabDoorView

IMPLEMENT_DYNCREATE(CJobsTabDoorView, CFormView)

CJobsTabDoorView::CJobsTabDoorView()
	: CFormView(CJobsTabDoorView::IDD)
{
	//{{AFX_DATA_INIT(CJobsTabDoorView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CJobsTabDoorView::CJobsTabDoorView(CView* pView, int nTabNo)
: CFormView(CJobsTabDoorView::IDD)
{
	m_pView = pView;
	m_nTabNo = nTabNo;
	SetEqpAssy( ((CDicsView*)m_pView)->m_pEqpAssy );
}

CJobsTabDoorView::~CJobsTabDoorView()
{
}

void CJobsTabDoorView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJobsTabDoorView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CJobsTabDoorView, CFormView)
	//{{AFX_MSG_MAP(CJobsTabDoorView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJobsTabDoorView diagnostics

#ifdef _DEBUG
void CJobsTabDoorView::AssertValid() const
{
	CFormView::AssertValid();
}

void CJobsTabDoorView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJobsTabDoorView message handlers
BOOL CJobsTabDoorView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CJobsTabDoorView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	CDicsDoc* pDoc = (CDicsDoc*) ( (CDicsView*)m_pView->GetDocument() );

	for( int i=0; i<MAX_DOOR_OPEN_NO; i++ )
	{
		m_stcDoorOpen[i].SubclassDlgItem( IDC_FDOOR_OPEN1 + i, this );
		m_stcDoorOpen[i].SetTextColor( BLACK_COLOR );
		m_stcDoorOpen[i].SetBkColor( WHITE_COLOR );
	}
	for( int i=0; i< m_pEqpAssy->m_SwitchEmo.GetDiSize(); i++)
	{
		//m_stcEMO[i].SubclassDlgItem( IDC_INCV_EMO_SRU_CONFIRM + i, this );
		m_stcEMO[i].SubclassDlgItem( IDC_INCV_EMO_PIN_OP + i, this );
		m_stcEMO[i].SetTextColor( BLACK_COLOR );
		m_stcEMO[i].SetBkColor( WHITE_COLOR );		
	}
	for( int i=0; i<m_pEqpAssy->m_SensorDIAlarm.GetDiSize(); i++ )
	{
		m_strDIAlarm[i].SubclassDlgItem( IDC_INCV_EMO_LOADER + i, this );
		m_strDIAlarm[i].SetTextColor( BLACK_COLOR );
		m_strDIAlarm[i].SetBkColor( WHITE_COLOR );
	}
}

// -----------------------------------------------------------
// Existence Sensor display
// -----------------------------------------------------------
void CJobsTabDoorView::SetColorStatic( CColorStatic& stcObject, BOOL bState, COLORREF OnColor, COLORREF OffColor )
{	
	if( bState ) 
	{
		stcObject.StartBkBlink( FALSE );
		stcObject.StartTextBlink( FALSE );
		stcObject.SetTextColor( BLACK_COLOR );
		stcObject.SetBkColor( OnColor );
	}
	else
	{
		stcObject.StartBkBlink( FALSE );
		stcObject.StartTextBlink( FALSE );
		stcObject.SetTextColor( BLACK_COLOR );
		stcObject.SetBkColor( OffColor );
	}
}

void CJobsTabDoorView::UpdateObjects()
{
	UpdateDoorOpen();
}

void CJobsTabDoorView::UpdateDoorOpen()
{
#ifdef _MY_DEBUG
	static BOOL bDebugDoorOpenSensor[MAX_DOOR_OPEN_NO] = { FALSE, };
	static BOOL bDebugEMOSensor[MAX_EMO_NO] = { FALSE, };
	static BOOL bDebugAlarmSensor[MAX_DIALARM_NO] = { FALSE, };
#endif
	
	static BOOL bOldDoorOpenState[MAX_DOOR_OPEN_NO] = { FALSE, };
	static BOOL bOldEMOState[MAX_EMO_NO] = { FALSE, };
	static BOOL bOldAlarmState[MAX_DIALARM_NO] = { FALSE, };

	for( int i = 0 ; i < m_pEqpAssy->m_SensorDoor.GetDiSize() ; i ++ )
	{
#ifndef _MY_DEBUG
		if( !bOldDoorOpenState[i] && m_pEqpAssy->m_SensorDoor.Get(i) )
#else
		if( !bOldDoorOpenState[i] && bDebugDoorOpenSensor[i] )
#endif
		{
			bOldDoorOpenState[i] = TRUE; 
			SetColorStatic( m_stcDoorOpen[i], TRUE, RED_COLOR );
		}
#ifndef _MY_DEBUG
		if( bOldDoorOpenState[i] && !m_pEqpAssy->m_SensorDoor.Get( i ) )
#else
		if( bOldDoorOpenState[i] && !bDebugDoorOpenSensor[i] )
#endif
		{
			bOldDoorOpenState[i] = FALSE; 
			SetColorStatic( m_stcDoorOpen[i], FALSE, RED_COLOR );
		}
	}

	for( int i = 0 ; i < m_pEqpAssy->m_SwitchEmo.GetDiSize() ; i ++ )
	{
#ifndef _MY_DEBUG
		if( !bOldEMOState[i] && m_pEqpAssy->m_SwitchEmo.Get(i) )
#else
		if( !bOldEMOState[i] && bDebugEMOSensor[i] )
#endif
		{
			bOldEMOState[i] = TRUE; 
			SetColorStatic( m_stcEMO[i], TRUE, RED_COLOR );
		}
#ifndef _MY_DEBUG
		if( bOldEMOState[i] && !m_pEqpAssy->m_SwitchEmo.Get( i ) )
#else
		if( bOldEMOState[i] && !bDebugEMOSensor[i] )
#endif
		{
			bOldEMOState[i] = FALSE; 
			SetColorStatic( m_stcEMO[i], FALSE, RED_COLOR );
		}
	}


	for( int i = 0 ; i < m_pEqpAssy->m_SensorDIAlarm.GetDiSize() ; i ++ )
	{
#ifndef _MY_DEBUG
		if( !bOldAlarmState[i] && m_pEqpAssy->m_SensorDIAlarm.Get(i) )
#else
		if( !bOldAlarmState[i] && bDebugAlarmSensor[i] )
#endif
		{
			bOldAlarmState[i] = TRUE; 
			SetColorStatic( m_strDIAlarm[i], TRUE, RED_COLOR );
		}
#ifndef _MY_DEBUG
		if( bOldAlarmState[i] && !m_pEqpAssy->m_SensorDIAlarm.Get( i ) )
#else
		if( bOldAlarmState[i] && !bDebugAlarmSensor[i] )
#endif
		{
			bOldAlarmState[i] = FALSE; 
			SetColorStatic( m_strDIAlarm[i], FALSE, RED_COLOR );
		}
	}
	// m_SensorDIAlarm
}