//{{AFX_INCLUDES()
#include "msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_JOBSTABEUVSTATUSVIEW_H__FE20709E_7728_4298_9FAC_9543D4B7A04B__INCLUDED_)
#define AFX_JOBSTABEUVSTATUSVIEW_H__FE20709E_7728_4298_9FAC_9543D4B7A04B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// JobsTabEuvStatusView.h : header file
//

#include "..\X\ColorStatic.h"
#include "..\X\ColorBtn.h"
#include "..\X\MsgBox.h"
#include "..\X\MacButtons.h"
#include "..\DicsData.h"

/////////////////////////////////////////////////////////////////////////////
// CJobsTabEuvStatusView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "..\X\Led.h"	// Added by ClassView
#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\Sequence\EuvSeq.h"

#include "..\FactoryLib\EqpAssy.h"

class CJobsTabEuvStatusView : public CFormView
{
public:
	CJobsTabEuvStatusView();           // protected constructor used by dynamic creation
	CJobsTabEuvStatusView( CView* pView, int nTabNo );
	DECLARE_DYNCREATE(CJobsTabEuvStatusView)

// Form Data
public:
	//{{AFX_DATA(CJobsTabEuvStatusView)
	enum { IDD = IDD_JOBS_TAB_USHIO_EUV_STATUS_VIEW };
	//}}AFX_DATA

// Attributes
public:
	CView* m_pView;
	CDicsData*		m_pDicsData;
	XCtlDevice*		m_pDevice;
	CEuvSeq*		m_pEuv;
	CEqpAssy*			m_pEqpAssy;
	void SetEqpAssy( CEqpAssy* pEqpAssy ) { m_pEqpAssy = pEqpAssy; }

	int				m_nTabNo;
	int 			m_nEuvHour[MAX_LAMP_NO];
	int				m_nEuvMin[MAX_LAMP_NO];
	int				m_nEuvSec[MAX_LAMP_NO];

	BOOL			m_bLampOnSelect[MAX_LAMP_CONTROL_NO];
	BOOL			m_bUERT;
	BOOL			m_bUHER;
	
	// Lamp Use Time
	CMSFlexGrid		m_gridLampUseTime;

	// Intensity Check
	CMSFlexGrid		m_gridLampIntensity;
	CMacRadioButton	m_macIntensityCheckSelect[MAX_LAMP_INTENSITY_NO];
//	CMacCheckBox	m_macIntensityCheckOn;

	// Euv Status
	CMacCheckBox	m_macRemoteMode;
	CMacCheckBox	m_macRemotePos;
	CMacCheckBox	m_macBusy;
	CMacCheckBox	m_macReady;

	// Euv Operation
	CMacCheckBox	m_macEuvLocalModeLock;
	CMacCheckBox	m_macEuvRemoteMode;
	CMacCheckBox	m_macEmergency;
	CMacCheckBox	m_macEuvReset;
	CMacCheckBox	m_macCounterReset;
	CMacCheckBox	m_macUsedTimeReset;
	CMacCheckBox	m_macHumReset;
	
	// Alarm Status
	CMacCheckBox	m_macLampUsedTimeOver;
	CMacCheckBox	m_macLampOnFail;
	CMacCheckBox	m_macProtectiveFunc;
	CMacCheckBox	m_macElectricCircuitError;
	CMacCheckBox	m_macN2PressOver;
	CMacCheckBox	m_macLampHouseOverheat;
	CMacCheckBox	m_macLampHouseOpen;
	CMacCheckBox	m_macTransformerOverheat;
	CMacCheckBox	m_macN2PressDrop;
	CMacCheckBox	m_macElectricCircuitCoverOpen;
	CMacCheckBox	m_macControlError;
	CMacCheckBox	m_macEuvEmo;

	// Humidifier Status
	CMacCheckBox	m_macHumReady;
	CMacCheckBox	m_macHumError;

	// Lamp On/Off Operation
	CMacCheckBox	m_macLampOnSelect[MAX_LAMP_CONTROL_NO];
	CMacCheckBox	m_macLampOn;
	
	// UT Valve Om/Off Operation
	CMsgBox			m_msgValve[3];
	CMacCheckBox	m_macPcwOn;
	CMacCheckBox	m_macN2On;
	CMacCheckBox	m_macHumidifierN2On;

	// House Up/Down Operation
	CMacCheckBox	m_macHousePos[2];
	CMacRadioButton	m_macHouseUp;
	CMacRadioButton	m_macHouseDown;

	// House Up/Down Operation Time Check
	BOOL			m_bHouseUp;
	BOOL			m_bHouseDown;
	int				m_nHouseMoveOk;

	// EUV Test Operation //eun 070126

	CMacCheckBox	m_macEuvTestLampOnSelect[MAX_LAMP_CONTROL_NO];

	// Message
	CMsgBox			m_msgEuv;

	CString			m_sMessage;

// Operations
public:
	void SetDevice( XCtlDevice* pDevice ) { m_pDevice = pDevice; }
	void GridInit_LampUseTime();
	void SetDataToGridCtrl_LampUseTime();
	void GridInit_LampIntensity();
	void SetDataToGridCtrl_LampIntensity();
	void SetDataToGridCtrl_LampIntensity( int nPos );
	void SetLampSelect( int nLampNo );
	void UpdateObjects( );
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );
	void CheckPushBtnTime();
	void CheckEMOStatus();
	void SetMelody();
	void OnEuvLampOnSelect( UINT nID );
	void EnableButton(BOOL bStatus);
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJobsTabEuvStatusView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CJobsTabEuvStatusView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CJobsTabEuvStatusView)
	afx_msg void OnClose();
	afx_msg void OnEuvLampOnSelect1();
	afx_msg void OnEuvLampOnSelect2();
	afx_msg void OnEuvLampOnSelect3();
	afx_msg void OnEuvLampOnSelect4();
	afx_msg void OnEuvLampOnSelect5();
	afx_msg void OnEuvLampOnSelect6();
	afx_msg void OnEuvLampOnSelect7();
	afx_msg void OnEuvLampOnSelect8();
	afx_msg void OnN2Valve();
	afx_msg void OnPcwValve();
	afx_msg void OnCdaValve();
	afx_msg void OnEuvLampOn();
	afx_msg void OnEuvIntensityCheck();
	afx_msg void OnClickGridLampIntensity();
	afx_msg void OnDblClickGridUsedTime();
	afx_msg void OnEuvLocalModeLock();
	afx_msg void OnEuvRemoteMode();
	afx_msg void OnEuvEmergency();
	afx_msg void OnEuvReset();
	afx_msg void OnEuvCounterReset();
	afx_msg void OnEuvLampUseTimeAllReset();
	afx_msg void OnHumidifierReset();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	afx_msg LRESULT OnBtnPushed(WPARAM WParam, LPARAM lParam);
	afx_msg LRESULT OnBtnReleased(WPARAM WParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JOBSTABEUVSTATUSVIEW_H__FE20709E_7728_4298_9FAC_9543D4B7A04B__INCLUDED_)
