// JobsTabInterfaceView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "..\MainFrm.h"
#include "JobsTabInterfaceView.h"
#include "..\Dlg\DlgEditVal.h"
#include "string.h"
#include "..\Dlg\DlgHostMsg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//----------------------------------------------------------------------------------------------
// Description : LOADING ( CLEANER -> ROBOT ) { Display Message, Arrow Direction } 
//----------------------------------------------------------------------------------------------
CIM_IF_INFO CJobsTabInterfaceView::m_LdIfInfo[MAX_PROCESS_STEP] = 
{ 
	{ "CLN LOAD REQ",  right }, 
	{ "RBT READY LD STAGE", left },
	{ "CLN ACCESS LD STAGE", right },
	{ "RBT ACCESS LD STAGE", left },
	{ "CLN GLS RECV COMP", left },
	{ "RBT READY COMP", right },
};

//----------------------------------------------------------------------------------------------
// Description : UNLOADING ( ROBOT -> CLEANER ) { Display Message, Arrow Direction } 
//----------------------------------------------------------------------------------------------
// 
CIM_IF_INFO CJobsTabInterfaceView::m_UlIfInfo[MAX_PROCESS_STEP] = 
{
	{ "CLN UNLOAD REQ", right }, 
	{ "OHCV READY UL STAGE", left },  
	{ "CLN ACCESS UL STAGE", right },
	{ "OHCV ACCESS UL LO ARM", left },
	{ "CLN GLS SEND COMP", right },  
	{ "OHCV READY COMP", left },
};

/////////////////////////////////////////////////////////////////////////////
// CJobsTabInterfaceView

IMPLEMENT_DYNCREATE(CJobsTabInterfaceView, CFormView)

CJobsTabInterfaceView::CJobsTabInterfaceView()
	: CFormView(CJobsTabInterfaceView::IDD)
{
	//{{AFX_DATA_INIT(CJobsTabInterfaceView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CJobsTabInterfaceView::CJobsTabInterfaceView(CView* pView, int nTabNo)
	: CFormView(CJobsTabInterfaceView::IDD)
{
	m_pView		= pView;
	m_nTabNo	= nTabNo; 
}

CJobsTabInterfaceView::~CJobsTabInterfaceView()
{
}

CString CJobsTabInterfaceView::m_sLDInputSignalName[] = 
{
	"RBT STATUS(0x030)",
	"RBT SUBST ON UP ARM(0x031)",
	"RBT SUBST ON LO ARM(0x032)",
	"RBT ACCESS UP ARM(0x033)",
	"RBT ACCESS LO ARM(0x034)",
	"TRANSFER REQ(0x035)",
	"RBT READY(0x036)",
	"TIMEOUT RESET(0x037)",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
};

CString CJobsTabInterfaceView::m_sLDOutputSignalName[] = 
{
	"CLN STATUS(0x0A0)",
	"CLN SUBST ON EQ STAGE(0x0A1)",
	"CLN STAGE ACCESS POSSIBLE(0x0A2)",	
	"LOAD REQ(0x0A3)",
	"UNLOAD REQ(0x0A4)",
	"EXCHANGE REQ(0x0A5)",
	"TIMEOUT RESET(0x0A6)",
	"ANY GLS PROCESS FLAG IS ON(0x0AF)",
	"",
	"",	
	"",
	"",
	"",
	"",
	"",
	"",
	""
};

CString CJobsTabInterfaceView::m_sULInputSignalName[] = 
{
	"RBT STATUS(0x0E0)",
	"RBT SUBST ON UP ARM(0x0E1)",
	"RBT SUBST ON LO ARM(0x0E2)",
	"RBT ACCESS UP ARM(0x0E3)",
	"RBT ACCESS LO ARM(0x0E4)",
	"TRANSFER REQ(0x0E5)",
	"RBT READY(0x0E6)",
	"TIMEOUT RESET(0x0E7)",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
};

CString CJobsTabInterfaceView::m_sULOutputSignalName[] = 
{
	"CLN STATUS(0x090)",
	"CLN SUBST ON EQ STAGE(0x091)",
	"CLN STAGE ACCESS POSSIBLE(0x092)",	
	"LOAD REQ(0x093)",
	"UNLOAD REQ(0x094)",
	"EXCHANGE REQ(0x095)",
	"TIMEOUT RESET(0x096)",
	"ANY GLS PROCESS FLAG IS ON(0x09F)",
	"",
	"",	
	"",
	"",
	"",
	"",
	"",
	"",
	""

};

CString CJobsTabInterfaceView::m_sInputWordName[] =
{
	"CST PORT NO",
	"CST SLOT NO",
	"GLASS ID",
	"RECIPE ID",
	"PROCESS FLAG",
	"RESERVED",
};

void CJobsTabInterfaceView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJobsTabInterfaceView)
	//}}AFX_DATA_MAP
	DDX_Control( pDX, IDC_GRID_LD, m_gridLdSignalInput );
	DDX_Control( pDX, IDC_GRID_LD2, m_gridLdSignalOutput );
	DDX_Control( pDX, IDC_GRID_UL, m_gridUlSignalInput );
	DDX_Control( pDX, IDC_GRID_UL2, m_gridUlSignalOutput );
	DDX_Control( pDX, IDC_GRID_WORD_DATA, m_gridLdWordData );
	DDX_Control( pDX, IDC_GRID_WORD_DATA2, m_gridUlWordData );
	DDX_Control(pDX, IDC_HOST_MESSAGE, m_macHostMessage);
}

BEGIN_MESSAGE_MAP(CJobsTabInterfaceView, CFormView)
	//{{AFX_MSG_MAP(CJobsTabInterfaceView)
	ON_WM_CTLCOLOR()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_WM_RBUTTONDOWN()
	ON_BN_CLICKED(IDC_HOST_MESSAGE, OnHostMessage)
	//}}AFX_MSG_MAP
	ON_MESSAGE( WM_CIM_INTERFACE_VIEW, OnCimInterface )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJobsTabInterfaceView diagnostics

#ifdef _DEBUG
void CJobsTabInterfaceView::AssertValid() const
{
	CFormView::AssertValid();
}

void CJobsTabInterfaceView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJobsTabInterfaceView message handlers

BOOL CJobsTabInterfaceView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CJobsTabInterfaceView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Set the pointer
	m_pDicsData = ( (CDicsView*) m_pView)->m_pDicsData;
//	m_pLoader = ( (CDicsView*) m_pView)->m_pLoader;

	// AI MSG ǥ (AC з)
	CRect r;
	GetDlgItem( IDC_STATIC_TERMINAL_MSG )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgTerminalMessage.Create( 0, "0.0", WS_CHILD|WS_VISIBLE, r, this, IDC_STATIC_TERMINAL_MSG,
		WHITE_COLOR, BLACK_COLOR, 16 );

	m_msgTerminalMessage.SetOpMsg( " " );

	GetDlgItem( IDC_BAR_L )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 2, 2, 2, 2 );
	m_msgLeftBar.Create( 800, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_BAR_L,
			LIGHT_BLUE_COLOR, WHITE_COLOR, 18, TRUE );
	m_msgLeftBar.SetOpMsg(" ");

	GetDlgItem( IDC_BAR_R )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 2, 2, 2, 2 );
	m_msgRightBar.Create( 810, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_BAR_R,
			LIGHT_BLUE_COLOR, WHITE_COLOR, 18, TRUE );
	m_msgRightBar.SetOpMsg(" ");

	GetDlgItem( IDC_MSG_PROCESS )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 2, 2, 2, 2 );
	m_msgProcess.Create( 820, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_MSG_PROCESS,
			LIGHT_BLUE_COLOR, BLACK_COLOR, 16, TRUE );
	m_msgProcess.SetOpMsg(" ");

	GetDlgItem( IDC_BAR_L2 )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 2, 2, 2, 2 );
	m_msgLeftBar2.Create( 830, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_BAR_L,
			LIGHT_BLUE_COLOR, WHITE_COLOR, 18, TRUE );
	m_msgLeftBar2.SetOpMsg(" ");

	GetDlgItem( IDC_BAR_R2 )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 2, 2, 2, 2 );
	m_msgRightBar2.Create( 840, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_BAR_R,
			LIGHT_BLUE_COLOR, WHITE_COLOR, 18, TRUE );
	m_msgRightBar2.SetOpMsg(" ");

	GetDlgItem( IDC_MSG_PROCESS2 )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 2, 2, 2, 2 );
	m_msgProcess2.Create( 850, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_MSG_PROCESS,
			LIGHT_BLUE_COLOR, BLACK_COLOR, 16, TRUE );
	m_msgProcess2.SetOpMsg(" ");

	for( int i = 0 ; i < MAX_PROCESS_STEP ; i++ )
	{
		m_stcLdProcessStep[i].SubclassDlgItem( IDC_LD_STEP1 + i, this );
		m_stcLdProcessStep[i].SetTextColor( BLUE_COLOR );
		m_stcUlProcessStep[i].SubclassDlgItem( IDC_UL_STEP1 + i, this );
		m_stcUlProcessStep[i].SetTextColor( BLUE_COLOR );
	}

	for( int i = 0; i < MAX_PROCESS_STEP; i++ )
	{
		GetDlgItem( IDC_LD_R_ARROW1 + i )->ShowWindow( FALSE );
		GetDlgItem( IDC_LD_L_ARROW1 + i )->ShowWindow( FALSE );
		GetDlgItem( IDC_UL_R_ARROW1 + i )->ShowWindow( FALSE );
		GetDlgItem( IDC_UL_L_ARROW1 + i )->ShowWindow( FALSE );
	}

	InitLdGrid();
	InitUlGrid();
	InitWordDataGrid();
	
	// Get brush
	m_hbrBgColor =	CreateSolidBrush( BG_COLOR );
	m_hbrLightYellow = CreateSolidBrush( LIGHT_YELLOW_COLOR );
	m_hbrLightBlue = CreateSolidBrush( LIGHT_BLUE_COLOR );
	m_hbrTextColor = CreateSolidBrush( BLUE_COLOR );

	MAC_COLOR_SET color_set;
	m_macHostMessage.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macHostMessage.SetColorSetting( color_set );
	m_macHostMessage.SetBold(); 

	SetTimer ( TIMER_INTERFACE_MONITOR, 500, NULL );
}

HBRUSH CJobsTabInterfaceView::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CFormView::OnCtlColor(pDC, pWnd, nCtlColor);

/*	UINT id = pWnd->GetDlgCtrlID();
	switch( nCtlColor )
	{
	
		case CTLCOLOR_STATIC:
			if( id == IDC_STATIC_INPUT_BG )
			{
				hbr = m_hbrLightBlue;
				pDC->SetBkMode( TRANSPARENT );
				pDC->SetTextColor( BLACK_COLOR );
			}
			else if( id == IDC_STATIC_DATA1 ||
				id == IDC_STATIC_DATA2 ||
				id == IDC_STATIC_DATA3 ||
				id == IDC_STATIC_DATA4 ||
				id == IDC_STATIC_DATA5 ||
				id == IDC_STATIC_DATA6 ||
				id == IDC_STATIC_DATA7 ||
				id == IDC_STATIC_DATA8 ||
				id == IDC_STATIC_DATA9 ||
				id == IDC_STATIC_DATA10 ||
				id == IDC_STATIC_DATA11 ||
				id == IDC_STATIC_DATA12 ||
				id == IDC_STATIC_DATA13 ||
				id == IDC_STATIC_DATA14 )
			{
				hbr = m_hbrLightYellow;
				pDC->SetBkMode( TRANSPARENT );
				pDC->SetTextColor( BLACK_COLOR );
			}
			break;
	}
	*/
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CJobsTabInterfaceView::OnClose() 
{
	KillTimer( TIMER_INTERFACE_MONITOR );

	DeleteObject( m_hbrBgColor );
	DeleteObject( m_hbrTextColor );
	DeleteObject( m_hbrLightBlue );
	DeleteObject( m_hbrLightYellow );
	
	CFormView::OnClose();
}

//--------------------------------------------------------------------
// Grid Initialize (Port Info)
//--------------------------------------------------------------------
#define MAX_LOT_INFO_COL_NO		3
#define MAX_LOT_INFO_ROW_NO		16



BEGIN_EVENTSINK_MAP(CJobsTabInterfaceView, CFormView)
    //{{AFX_EVENTSINK_MAP(CJobsTabInterfaceView)
	ON_EVENT(CJobsTabInterfaceView, IDC_GRID_LD2, -601 /* DblClick */, OnDblClickMelOutLD, VTS_NONE)
	ON_EVENT(CJobsTabInterfaceView, IDC_GRID_UL2, -601 /* DblClick */, OnDblClickMelOutUL, VTS_NONE)		
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

//--------------------------------------------------------------------
// Description : Display the terminal message
//--------------------------------------------------------------------
void CJobsTabInterfaceView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if( ( (CDicsView*) m_pView )->m_nSelectedTab == 1 ) MonitorInterface();
	
	CFormView::OnTimer(nIDEvent);
}

void CJobsTabInterfaceView::MonitorInterface()
{
	short nVal;


//----------------------------------------------------------------------------------------------
// Description : MELSEC LOAD INPUT - BIT AREA
//----------------------------------------------------------------------------------------------
	m_pMelsec->ReceiveBit( m_pMelsec->m_NetworkInfo.nNetworkNo, m_pMelsec->m_NetworkInfo.nStationNo, 0x0030, nVal );

	int nMelLdInputAdd[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
	for( int i=0; i<MAX_SIGNAL_ROW_NO-8; i++ ) 
	{
		static int nOldLdSignalInputStatus[MAX_SIGNAL_ROW_NO-8] ={ 0, };

		if( !nOldLdSignalInputStatus[i] && ( ( nVal >> i ) & 0x01 ) )
		{
			nOldLdSignalInputStatus[i] = TRUE;
			m_gridLdSignalInput.SetRow( nMelLdInputAdd[i] + 1 );
			m_gridLdSignalInput.SetCol( 0 );
			m_gridLdSignalInput.SetCellBackColor( GREEN_COLOR );
		}
		else if( nOldLdSignalInputStatus[i] && !( ( nVal >> i ) & 0x01 ) )
		{
			nOldLdSignalInputStatus[i] = FALSE;
			m_gridLdSignalInput.SetRow( nMelLdInputAdd[i] + 1 );
			m_gridLdSignalInput.SetCol( 0 );
			m_gridLdSignalInput.SetCellBackColor( WHITE_COLOR );
		}
	}

//----------------------------------------------------------------------------------------------
// Description : MELSEC LOAD OUTPUT - BIT AREA
//----------------------------------------------------------------------------------------------
	m_pMelsec->ReceiveBit( m_pMelsec->m_NetworkInfo.nNetworkNo, m_pMelsec->m_NetworkInfo.nStationNo, 
		                   0x00A0, nVal );
	int nMelLdOutputAdd[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
	for( int i=0; i<MAX_SIGNAL_ROW_NO-7; i++ ) 
	{
		static int nOldLdSignalOutputStatus[MAX_SIGNAL_ROW_NO-7] = { 0, };
		
		if( !nOldLdSignalOutputStatus[i] && ( ( nVal >> i ) & 0x01 ) ) 
		{
			nOldLdSignalOutputStatus[i] = TRUE;
			m_gridLdSignalOutput.SetRow( nMelLdOutputAdd[i] + 1 );
			m_gridLdSignalOutput.SetCol( 0 );
			m_gridLdSignalOutput.SetCellBackColor( GREEN_COLOR );
		}
		else if( nOldLdSignalOutputStatus[i] && !( ( nVal >> i ) & 0x01 ) ) 
		{
			nOldLdSignalOutputStatus[i] = FALSE;
			m_gridLdSignalOutput.SetRow( nMelLdOutputAdd[i] + 1 );
			m_gridLdSignalOutput.SetCol( 0 );
			m_gridLdSignalOutput.SetCellBackColor( WHITE_COLOR );
		}
	}

//----------------------------------------------------------------------------------------------
// Description : MELSEC UNLOAD INPUT - BIT AREA
//----------------------------------------------------------------------------------------------
	m_pMelsec->ReceiveBit( m_pMelsec->m_NetworkInfo.nNetworkNo, m_pMelsec->m_NetworkInfo.nStationNo, 
		                  0x00E0, nVal );
	int nMelUlInputAdd[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
	for( int i=0; i<MAX_SIGNAL_ROW_NO-8; i++ ) 
	{
		static int nOldUlSignalInputStatus[MAX_SIGNAL_ROW_NO-8] ={ 0, };

		if( !nOldUlSignalInputStatus[i] && ( ( nVal >> i ) & 0x01 ) )
		{
			nOldUlSignalInputStatus[i] = TRUE;
			m_gridUlSignalInput.SetRow( nMelUlInputAdd[i] + 1 );
			m_gridUlSignalInput.SetCol( 0 );
			m_gridUlSignalInput.SetCellBackColor( GREEN_COLOR );
		}
		else if( nOldUlSignalInputStatus[i] && !( ( nVal >> i ) & 0x01 ) )
		{
			nOldUlSignalInputStatus[i] = FALSE;
			m_gridUlSignalInput.SetRow( nMelUlInputAdd[i] + 1 );
			m_gridUlSignalInput.SetCol( 0 );
			m_gridUlSignalInput.SetCellBackColor( WHITE_COLOR );
		}
	}

//----------------------------------------------------------------------------------------------
// Description : MELSEC UNLOAD OUTPUT - BIT AREA
//----------------------------------------------------------------------------------------------
	m_pMelsec->ReceiveBit( m_pMelsec->m_NetworkInfo.nNetworkNo, m_pMelsec->m_NetworkInfo.nStationNo, 
		                   0x0090, nVal );
	int nMelUlOutputAdd[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
	for( int i=0; i<MAX_SIGNAL_ROW_NO-7; i++ ) 
	{
		static int nOldUlSignalOutputStatus[MAX_SIGNAL_ROW_NO-7] = { 0, };
		
		if( i != 7 )
		{
			if( !nOldUlSignalOutputStatus[i] && ( ( nVal >> i ) & 0x01 ) ) 
			{
				nOldUlSignalOutputStatus[i] = TRUE;
				m_gridUlSignalOutput.SetRow( nMelUlOutputAdd[i] + 1 );
				m_gridUlSignalOutput.SetCol( 0 );
				m_gridUlSignalOutput.SetCellBackColor( GREEN_COLOR );
			}
			else if( nOldUlSignalOutputStatus[i] && !( ( nVal >> i ) & 0x01 ) ) 
			{
				nOldUlSignalOutputStatus[i] = FALSE;
				m_gridUlSignalOutput.SetRow( nMelUlOutputAdd[i] + 1 );
				m_gridUlSignalOutput.SetCol( 0 );
				m_gridUlSignalOutput.SetCellBackColor( WHITE_COLOR );
			}
		}
		else
		{
			if( !nOldUlSignalOutputStatus[i] && ( ( nVal >> (i+8) ) & 0x01 ) ) 
			{
				nOldUlSignalOutputStatus[i] = TRUE;
				m_gridUlSignalOutput.SetRow( nMelUlOutputAdd[i] + 1 );
				m_gridUlSignalOutput.SetCol( 0 );
				m_gridUlSignalOutput.SetCellBackColor( GREEN_COLOR );
			}
			else if( nOldUlSignalOutputStatus[i] && !( ( nVal >> (i+8) ) & 0x01 ) ) 
			{
				nOldUlSignalOutputStatus[i] = FALSE;
				m_gridUlSignalOutput.SetRow( nMelUlOutputAdd[i] + 1 );
				m_gridUlSignalOutput.SetCol( 0 );
				m_gridUlSignalOutput.SetCellBackColor( WHITE_COLOR );
			}
		}
	}

//----------------------------------------------------------------------------------------------
// Description : MELSEC OUTPUT - BIT AREA
//----------------------------------------------------------------------------------------------
	/*
	m_pMelsec->ReceiveBit( m_pMelsec->m_NetworkInfo.nNetworkNo, m_pMelsec->m_NetworkInfo.nStationNo, 
		                   0x0090, nVal );
	for( int i=0; i<MAX_SIGNAL_ROW_NO-13; i++ ) 
	{
		static int nOldEqpSignalStatus[MAX_SIGNAL_ROW_NO-13] = { 0, };
		
		if( !nOldEqpSignalStatus[i] && ( ( nVal >> i ) & 0x01 ) ) 
		{
			nOldEqpSignalStatus[i] = TRUE;
			m_gridUlSignalInput.SetRow( i + 13 );
			m_gridUlSignalInput.SetCol( 0 );
			m_gridUlSignalInput.SetCellBackColor( GREEN_COLOR );
		}
		else if( nOldEqpSignalStatus[i] && !( ( nVal >> i ) & 0x01 ) ) 
		{
			nOldEqpSignalStatus[i] = FALSE;
			m_gridUlSignalInput.SetRow( i + 13 );
			m_gridUlSignalInput.SetCol( 0 );
			m_gridUlSignalInput.SetCellBackColor( WHITE_COLOR );
		}
	}
	*/
//	for( i=0; i<5; i++ ) 
//	{
//		if( ( nVal >> i ) & 0x01 ) m_ledOut[i+11].SetLed( CLed::LED_COLOR_GREEN, CLed::LED_ON, CLed::LED_ROUND );
//		else m_ledOut[i+11].SetLed( CLed::LED_COLOR_GREEN, CLed::LED_OFF, CLed::LED_ROUND );
//	}

	CString sBuf;
	static CString sOldLdBuf[MAX_WORD_DATA_COL_NO] = { " ", };
	static CString sOldUlBuf[MAX_WORD_DATA_COL_NO] = { " ", };

#ifndef _MY_DEBUG
	nVal = miwLOAD_CST_PORT_NO;
	sBuf.Format( "%d", nVal);// "%c%c", nVal & 0xFF, ( ( nVal & 0xFF00 ) >> 8 ) );
#else
	sBuf = "_1";
#endif
	sBuf.ReleaseBuffer();
	if( strcmp( sBuf, sOldLdBuf[0] ) != 0 )
	{
		sOldLdBuf[0] = sBuf;
		m_gridLdWordData.SetCol( 0 );
		m_gridLdWordData.SetRow( 1 );
		m_gridLdWordData.SetText( sBuf );
		m_gridLdWordData.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridLdWordData.SetCellAlignment( 4 );
	}

#ifndef _MY_DEBUG
	nVal = miwLOAD_CST_SLOT_NO;
	sBuf.Format( "%d", nVal);// "%c%c", nVal & 0xFF, ( ( nVal & 0xFF00 ) >> 8 ) );
#else
	sBuf = "01";
#endif
	sBuf.ReleaseBuffer();
	if( strcmp( sBuf, sOldLdBuf[1] ) != 0 )
	{
		sOldLdBuf[1] = sBuf;
		m_gridLdWordData.SetCol( 1 );
		m_gridLdWordData.SetRow( 1 );
		m_gridLdWordData.SetText( sBuf );
		m_gridLdWordData.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridLdWordData.SetCellAlignment( 4 );
	}

#ifndef _MY_DEBUG
	miwLOAD_GLASS_ID( sBuf.GetBuffer( 14 ), 14 );
#else
	sBuf = "1A120090933237";
#endif
	sBuf.ReleaseBuffer();
	if( strcmp( sBuf, sOldLdBuf[2] ) != 0 )
	{
		sOldLdBuf[2] = sBuf;
		m_gridLdWordData.SetCol( 2 );
		m_gridLdWordData.SetRow( 1 );
		m_gridLdWordData.SetText( sBuf );
		m_gridLdWordData.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridLdWordData.SetCellAlignment( 4 );
	}

#ifndef _MY_DEBUG
	miwLOAD_RECIPE_ID( sBuf.GetBuffer( 16 ), 16	);
#else
	sBuf = "1B-0123456789011";
#endif
	sBuf.ReleaseBuffer();
	if( strcmp( sBuf, sOldLdBuf[3] ) != 0 )
	{
		sOldLdBuf[3] = sBuf;
		m_gridLdWordData.SetCol( 3 );
		m_gridLdWordData.SetRow( 1 );
		m_gridLdWordData.SetText( sBuf );
		m_gridLdWordData.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridLdWordData.SetCellAlignment( 4 );
	}

#ifndef _MY_DEBUG
	nVal = miwLOAD_PROCESS_FLAG;
	//sBuf.Format( "%c%c", nVal & 0xFF, ( ( nVal & 0xFF00 ) >> 8 ) );
	sBuf.Format("%d", nVal);
#else
	sBuf = "_1";
#endif
	sBuf.ReleaseBuffer();
	if( strcmp( sBuf, sOldLdBuf[4] ) != 0 )
	{
		sOldLdBuf[4] = sBuf;
		m_gridLdWordData.SetCol( 4 );
		m_gridLdWordData.SetRow( 1 );
		m_gridLdWordData.SetText( sBuf );
		m_gridLdWordData.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridLdWordData.SetCellAlignment( 4 );
	}

/*
#ifndef _MY_DEBUG
	miwLOAD_RESERVED( sBuf.GetBuffer( 4 ), 4	);
#else
	sBuf = "0000";
#endif
	sBuf.ReleaseBuffer();
	if( strcmp( sBuf, sOldLdBuf[5] ) != 0 )
	{
		sOldLdBuf[5] = sBuf;
		m_gridLdWordData.SetCol( 5 );
		m_gridLdWordData.SetRow( 1 );
		m_gridLdWordData.SetText( sBuf );
		m_gridLdWordData.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridLdWordData.SetCellAlignment( 4 );
	}
*/
	//===============================================================================
#ifndef _MY_DEBUG
	nVal = moswUNLOAD_CST_PORT_NO;
	sBuf.Format( "%d", nVal);// "%c%c", nVal & 0xFF, ( ( nVal & 0xFF00 ) >> 8 ) );
#else
	sBuf = "_1";
#endif
	sBuf.ReleaseBuffer();
	if( strcmp( sBuf, sOldUlBuf[0] ) != 0 )
	{
		sOldUlBuf[0] = sBuf;
		m_gridUlWordData.SetCol( 0 );
		m_gridUlWordData.SetRow( 1 );
		m_gridUlWordData.SetText( sBuf );
		m_gridUlWordData.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridUlWordData.SetCellAlignment( 4 );
	}

#ifndef _MY_DEBUG
	nVal = moswUNLOAD_CST_SLOT_NO;
	sBuf.Format( "%d", nVal);// "%c%c", nVal & 0xFF, ( ( nVal & 0xFF00 ) >> 8 ) );
#else
	sBuf = "01";
#endif
	sBuf.ReleaseBuffer();
	if( strcmp( sBuf, sOldUlBuf[1] ) != 0 )
	{
		sOldUlBuf[1] = sBuf;
		m_gridUlWordData.SetCol( 1 );
		m_gridUlWordData.SetRow( 1 );
		m_gridUlWordData.SetText( sBuf );
		m_gridUlWordData.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridUlWordData.SetCellAlignment( 4 );
	}

#ifndef _MY_DEBUG
	moswUNLOAD_GLASS_ID( sBuf.GetBuffer( 14 ), 14 );
#else
	sBuf = "1A120090933237";
#endif
	sBuf.ReleaseBuffer();
	if( strcmp( sBuf, sOldUlBuf[2] ) != 0 )
	{
		sOldUlBuf[2] = sBuf;
		m_gridUlWordData.SetCol( 2 );
		m_gridUlWordData.SetRow( 1 );
		m_gridUlWordData.SetText( sBuf );
		m_gridUlWordData.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridUlWordData.SetCellAlignment( 4 );
	}

#ifndef _MY_DEBUG
	moswUNLOAD_RECIPE_ID( sBuf.GetBuffer( 16 ), 16	);
#else
	sBuf = "1B-0123456789011";
#endif
	sBuf.ReleaseBuffer();
	if( strcmp( sBuf, sOldUlBuf[3] ) != 0 )
	{
		sOldUlBuf[3] = sBuf;
		m_gridUlWordData.SetCol( 3 );
		m_gridUlWordData.SetRow( 1 );
		m_gridUlWordData.SetText( sBuf );
		m_gridUlWordData.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridUlWordData.SetCellAlignment( 4 );
	}

#ifndef _MY_DEBUG
	nVal = moswUNLOAD_PROCESS_FLAG;
	//sBuf.Format( "%c%c", nVal & 0xFF, ( ( nVal & 0xFF00 ) >> 8 ) );
	sBuf.Format("%d", nVal);
#else
	sBuf = "_1";
#endif
	sBuf.ReleaseBuffer();
	if( strcmp( sBuf, sOldUlBuf[4] ) != 0 )
	{
		sOldUlBuf[4] = sBuf;
		m_gridUlWordData.SetCol( 4 );
		m_gridUlWordData.SetRow( 1 );
		m_gridUlWordData.SetText( sBuf );
		m_gridUlWordData.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridUlWordData.SetCellAlignment( 4 );
	}

/*
#ifndef _MY_DEBUG
	moswUNLOAD_RESERVED( sBuf.GetBuffer( 4 ), 4	);
#else
	sBuf = "0000";
#endif
	sBuf.ReleaseBuffer();
	if( strcmp( sBuf, sOldUlBuf[5] ) != 0 )
	{
		sOldUlBuf[5] = sBuf;
		m_gridUlWordData.SetCol( 5 );
		m_gridUlWordData.SetRow( 1 );
		m_gridUlWordData.SetText( sBuf );
		m_gridUlWordData.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridUlWordData.SetCellAlignment( 4 );
	}
*/
}
// ljy_050220 : CJobsTab2View -> 04HC30   Ϸ(1).

void CJobsTabInterfaceView::InitLdGrid()
{
	m_gridLdSignalInput.SetRows( MAX_SIGNAL_ROW_NO ); 
	m_gridLdSignalInput.SetCols( 1 );
	//-------------------------------------------
	m_gridLdSignalInput.SetRow( 0 );
	m_gridLdSignalInput.SetCol( 0 );  
	m_gridLdSignalInput.SetColWidth( 0, 3050 );
	 
	m_gridLdSignalInput.SetCellAlignment( 4 );
	m_gridLdSignalInput.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridLdSignalInput.SetText( "IN SIGNAL" ); 

	m_gridLdSignalOutput.SetRows( MAX_SIGNAL_ROW_NO ); 
	m_gridLdSignalOutput.SetCols( 1 );
	//-------------------------------------------
	m_gridLdSignalOutput.SetRow( 0 );
	m_gridLdSignalOutput.SetCol( 0 );  
	m_gridLdSignalOutput.SetColWidth( 0, 3350 );
	 
	m_gridLdSignalOutput.SetCellAlignment( 4 );
	m_gridLdSignalOutput.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridLdSignalOutput.SetText( "OUT SIGNAL" ); 

	SetDataToLdGrid();
}

void CJobsTabInterfaceView::InitUlGrid()
{
	m_gridUlSignalInput.SetRows( MAX_SIGNAL_ROW_NO ); 
	m_gridUlSignalInput.SetCols( 1 );
	//-------------------------------------------
	m_gridUlSignalInput.SetRow( 0 );  
	m_gridUlSignalInput.SetColWidth( 0, 3050 );

	m_gridUlSignalInput.SetCol( 0 ); 
	m_gridUlSignalInput.SetCellAlignment( 4 );
	m_gridUlSignalInput.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridUlSignalInput.SetText( "IN SIGNAL" );

	m_gridUlSignalOutput.SetRows( MAX_SIGNAL_ROW_NO ); 
	m_gridUlSignalOutput.SetCols( 1 );
	//-------------------------------------------
	m_gridUlSignalOutput.SetRow( 0 );  
	m_gridUlSignalOutput.SetColWidth( 0, 3350 );

	m_gridUlSignalOutput.SetCol( 0 ); 
	m_gridUlSignalOutput.SetCellAlignment( 4 );
	m_gridUlSignalOutput.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridUlSignalOutput.SetText( "OUT SIGNAL" );

	SetDataToUlGrid();
}

void CJobsTabInterfaceView::InitWordDataGrid()
{
	m_gridLdWordData.SetRows( 2 );
	m_gridLdWordData.SetCols( MAX_WORD_DATA_COL_NO);

	m_gridUlWordData.SetRows( 2 );
	m_gridUlWordData.SetCols( MAX_WORD_DATA_COL_NO);

	SetDataToWordDataGrid();
}

void CJobsTabInterfaceView::SetDataToLdGrid()
{
	for( int i = 1; i < MAX_SIGNAL_ROW_NO; i++ )
	{
		m_gridLdSignalInput.SetRow( i );
		m_gridLdSignalInput.SetCol( 0 );
		m_gridLdSignalInput.SetCellAlignment( 4 );
		m_gridLdSignalInput.SetText( (LPCTSTR) m_sLDInputSignalName[i - 1] );

		m_gridLdSignalOutput.SetRow( i );
		m_gridLdSignalOutput.SetCol( 0 );
		m_gridLdSignalOutput.SetCellAlignment( 4 );
		m_gridLdSignalOutput.SetText( (LPCTSTR) m_sLDOutputSignalName[i - 1] );
	}
}

void CJobsTabInterfaceView::SetDataToUlGrid()
{
	for( int i = 1; i < MAX_SIGNAL_ROW_NO; i++ )
	{
		m_gridUlSignalInput.SetRow( i );
		m_gridUlSignalInput.SetCol( 0 );
		m_gridUlSignalInput.SetCellAlignment( 4 );
		m_gridUlSignalInput.SetText( (LPCTSTR) m_sULInputSignalName[i - 1] );		

		m_gridUlSignalOutput.SetRow( i );
		m_gridUlSignalOutput.SetCol( 0 );
		m_gridUlSignalOutput.SetCellAlignment( 4 );
		m_gridUlSignalOutput.SetText( (LPCTSTR) m_sULOutputSignalName[i - 1] );
	}
}

void CJobsTabInterfaceView::SetDataToWordDataGrid()
{
	for( int i = 0; i < MAX_WORD_DATA_COL_NO; i++ )
	{
		m_gridLdWordData.SetRow( 0 );
		m_gridLdWordData.SetCol( i );
		m_gridLdWordData.SetColWidth( i, 2035 );

		m_gridLdWordData.SetCellAlignment( 4 );				
		m_gridLdWordData.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridLdWordData.SetText( (LPCTSTR) m_sInputWordName[i] );

		m_gridUlWordData.SetRow( 0 );
		m_gridUlWordData.SetCol( i );
		m_gridUlWordData.SetColWidth( i, 2035 );

		m_gridUlWordData.SetCellAlignment( 4 );				
		m_gridUlWordData.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridUlWordData.SetText( (LPCTSTR) m_sInputWordName[i] );
	}
}

#define LOADING		0
#define UNLOADING	1

LRESULT CJobsTabInterfaceView::OnCimInterface( WPARAM wParam, LPARAM lParam )
{
	int nProcess = 0;
	int nStep = 0;
	int nArrowDir = 0;

	nStep = (int)wParam % 10;

	if( !nStep )	//Clear the process flow if step is 0
	{
		for( int i = 0; i < MAX_PROCESS_STEP; i++ ) 
		{
			if( wParam < 10 )
			{
				m_msgProcess.SetOpMsg( " " );
				m_stcLdProcessStep[i].SetWindowText( " " );
				GetDlgItem( IDC_LD_R_ARROW1 + i )->ShowWindow( FALSE );
				GetDlgItem( IDC_LD_L_ARROW1 + i )->ShowWindow( FALSE );
			}
			else 
			{
				m_msgProcess2.SetOpMsg( " " );
				m_stcUlProcessStep[i].SetWindowText( " " );
				GetDlgItem( IDC_UL_R_ARROW1 + i )->ShowWindow( FALSE );
				GetDlgItem( IDC_UL_L_ARROW1 + i )->ShowWindow( FALSE );
			}
			UpdateWindow();
		}
	}

	if( (int)wParam < MAX_LD_MSG )
	{
		m_msgProcess.SetOpMsg( "LOADING" );
		nProcess = LOADING;
	}
	else
	{
		m_msgProcess2.SetOpMsg( "UNLOADING" );
		nProcess = UNLOADING;
	}

	switch( nProcess ) 
	{
		case LOADING:
			m_stcLdProcessStep[nStep].SetWindowText( m_LdIfInfo[nStep].sStepMsg );
			nArrowDir = m_LdIfInfo[nStep].nDirection;
			SetArrow( LOADING, nArrowDir, nStep );
			break;
		case UNLOADING:
			m_stcUlProcessStep[nStep].SetWindowText( m_UlIfInfo[nStep].sStepMsg );
			nArrowDir = m_UlIfInfo[nStep].nDirection;
			SetArrow( UNLOADING, nArrowDir, nStep );
			break;
	}
	return 0;
}

void CJobsTabInterfaceView::SetArrow( int nProc, int nDir, int nNo )
{
	if( nDir ) 
	{
		if( nProc )
		{
			GetDlgItem( IDC_UL_R_ARROW1 + nNo )->ShowWindow( TRUE );
			GetDlgItem( IDC_UL_L_ARROW1 + nNo )->ShowWindow( FALSE );
		}
		else
		{
			GetDlgItem( IDC_LD_R_ARROW1 + nNo )->ShowWindow( TRUE );
			GetDlgItem( IDC_LD_L_ARROW1 + nNo )->ShowWindow( FALSE );
		}
		
	}
	else 
	{
		if( nProc )
		{
			GetDlgItem( IDC_UL_R_ARROW1 + nNo )->ShowWindow( FALSE );
			GetDlgItem( IDC_UL_L_ARROW1 + nNo )->ShowWindow( TRUE );
		}
		else
		{
			GetDlgItem( IDC_LD_R_ARROW1 + nNo )->ShowWindow( FALSE );
			GetDlgItem( IDC_LD_L_ARROW1 + nNo )->ShowWindow( TRUE );
		}
	}

	UpdateWindow();
}

// Only for Test
void CJobsTabInterfaceView::OnRButtonDown(UINT nFlags, CPoint point) 
{

	return;
	for( int i = 0; i < MAX_PROCESS_STEP; i++ )
	{
		SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_HDC_LD_REQ + i, (LPARAM) 0L );
		Sleep( 2000 );
	}

//	Sleep( 1500 );

//	SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_GLASS_EXCHANGE, (LPARAM) 0L );

	Sleep( 1500 );
	
	for( int i = 0; i < MAX_LD_MSG; i++ )
	{
		SendMessage( WM_CIM_INTERFACE_VIEW, (WPARAM) MSG_HDC_UL_REQ + i, (LPARAM) 0L );
		Sleep( 2000 );
	}
	
	CFormView::OnRButtonDown(nFlags, point);
}

void CJobsTabInterfaceView::OnHostMessage() 
{
	CDlgHostMsg Dlg;
	
	Dlg.SetHost( ( (CDicsView*) m_pView)->m_pHost );
	Dlg.m_sMessage = ( (CDicsView*) m_pView)->m_pHost->m_sTerminalMessage;
	Dlg.DoModal();
}
//2008.10.15 kimgun
void CJobsTabInterfaceView::OnDblClickMelOutLD()
{
	CDicsApp* pApp = ( CDicsApp* )AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* )pApp->m_pMainWnd;
	if( pMainFrame->m_bAuto ) return;
	int nRow = m_gridLdSignalOutput.GetRowSel();
	if( m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER ||
		(nRow != 5 && nRow != 6 ) ) return;
	
	if( AfxMessageBox("Do you want bit change?", MB_YESNO) == IDYES )
	{	
		switch(nRow)
		{
			case 5:
				if( !mosbLOAD_UNLOAD_REQUEST )
					mobLOAD_UNLOAD_REQUEST( ON );
				else if( mosbLOAD_UNLOAD_REQUEST )
					mobLOAD_UNLOAD_REQUEST( OFF );
				break;
			case 6:
				if( !mosbLOAD_EQP_ACCESS_POSSIBLE )
					mobLOAD_EQP_ACCESS_POSSIBLE( ON );
				else if( mosbLOAD_EQP_ACCESS_POSSIBLE )
					mobLOAD_EQP_ACCESS_POSSIBLE( OFF );
				break;
		}
	}
}

void CJobsTabInterfaceView::OnDblClickMelOutUL()
{
	CDicsApp* pApp = ( CDicsApp* )AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* )pApp->m_pMainWnd;
	if( pMainFrame->m_bAuto ) return;
	int nRow = m_gridUlSignalOutput.GetRowSel();
	if( m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER ||
		(nRow != 5 && nRow != 6 ) ) return;
	
	if( AfxMessageBox("Do you want bit change?", MB_YESNO) == IDYES )
	{	
		switch(nRow)
		{
			case 5:
				if( !mosbUNLOAD_UNLOAD_REQUEST )
					mobUNLOAD_UNLOAD_REQUEST( ON );
				else if( mosbUNLOAD_UNLOAD_REQUEST )
					mobUNLOAD_UNLOAD_REQUEST( OFF );
				break;
			case 6:
				if( !mosbUNLOAD_EQP_ACCESS_POSSIBLE )
					mobUNLOAD_EQP_ACCESS_POSSIBLE( ON );
				else if( mosbUNLOAD_EQP_ACCESS_POSSIBLE )
					mobUNLOAD_EQP_ACCESS_POSSIBLE( OFF );
				break;
		}
	}
}