//{{AFX_INCLUDES()
#include "msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_JOBSTABINTERFACEVIEW_H__FE20709E_7728_4298_9FAC_9543D4B7A04B__INCLUDED_)
#define AFX_JOBSTABINTERFACEVIEW_H__FE20709E_7728_4298_9FAC_9543D4B7A04B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// JobsTabInterfaceView.h : header file
//

#include "X\ColorStatic.h"
#include "X\ColorBtn.h"
#include "X\MsgBox.h"
#include "DicsData.h"

/////////////////////////////////////////////////////////////////////////////
// CJobsTabInterfaceView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "X\Led.h"	// Added by ClassView
#include "X\xctlmelsec.h"	// Added by ClassView
#include "X\XCtlDevice.h"	// Added by ClassView

#define MAX_PROCESS_STEP		6
#define MAX_SIGNAL_ROW_NO		18
#define MAX_WORD_DATA_COL_NO	5

typedef struct _tagCIM_IF_INFO {
	LPCTSTR sStepMsg;
	int	nDirection;
} CIM_IF_INFO;

class CJobsTabInterfaceView : public CFormView
{
public:
	CJobsTabInterfaceView();           // protected constructor used by dynamic creation
	CJobsTabInterfaceView( CView* pView, int nTabNo );
	DECLARE_DYNCREATE(CJobsTabInterfaceView)

// Form Data
public:
	//{{AFX_DATA(CJobsTabInterfaceView)
	enum { IDD = IDD_JOBS_TAB_INTERFACE_VIEW };
	//}}AFX_DATA

// Attributes

public:
	int				m_nTabNo;
	CView*			m_pView;
	CDicsData*		m_pDicsData;
	XCtlDevice *	m_pDevice;
	XCtlMelsec *	m_pMelsec;

	CMsgBox			m_msgCimMessage;
	CMsgBox			m_msgTerminalMessage;

	// color brush
	HBRUSH			m_hbrBgColor;
	HBRUSH			m_hbrLightBlue;
	HBRUSH			m_hbrTextColor;
	HBRUSH			m_hbrLightYellow;

	CMSFlexGrid		m_gridLdSignalInput;
	CMSFlexGrid		m_gridLdSignalOutput;
	CMSFlexGrid		m_gridUlSignalInput;
	CMSFlexGrid		m_gridUlSignalOutput;
	CMSFlexGrid		m_gridLdWordData;
	CMSFlexGrid		m_gridUlWordData;

	CMsgBox			m_msgLeftBar;
	CMsgBox			m_msgRightBar;
	CMsgBox			m_msgProcess;
	CMsgBox			m_msgLeftBar2;
	CMsgBox			m_msgRightBar2;
	CMsgBox			m_msgProcess2;
	BOOL			m_bIsExchange;
	
	CColorStatic	m_stcLdProcessStep[MAX_PROCESS_STEP];
	CColorStatic	m_stcUlProcessStep[MAX_PROCESS_STEP];

	CBitmapButton	m_btnProcessStepLd[MAX_PROCESS_STEP];
	CBitmapButton	m_btnProcessStepUl[MAX_PROCESS_STEP];

	CMacButton	m_macHostMessage;

	enum ARROW_DIR { left, right };	//HDC->LOADER:right, LOADER->HDC:left
	static CIM_IF_INFO	m_LdIfInfo[MAX_PROCESS_STEP];

	static CIM_IF_INFO	m_UlIfInfo[MAX_PROCESS_STEP];
	static CString m_sLDInputSignalName[17];
	static CString m_sLDOutputSignalName[17];
	static CString m_sULInputSignalName[17];
	static CString m_sULOutputSignalName[17];
	static CString m_sInputWordName[14];

// Operations
public:
#ifdef _CIM_SKIP
	CFileMap*			m_pFileMap;
	void SetFileMap(CFileMap* pFileMap)	 { m_pFileMap = pFileMap; }
#endif
	void SetMelsec( XCtlMelsec* pMelsec ) { m_pMelsec = pMelsec; }
	void SetDevice( XCtlDevice* pDevice ) { m_pDevice = pDevice; }
	void SetArrow( int nProc, int nDir, int nNo );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJobsTabInterfaceView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
// Implementation
public:
	void SetDataToWordDataGrid();
	void SetDataToUlGrid();
	void SetDataToLdGrid();
	void InitWordDataGrid();
	void InitUlGrid();
	void InitLdGrid();
	void MonitorInterface();
	virtual ~CJobsTabInterfaceView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CJobsTabInterfaceView)
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnHostMessage();
	afx_msg void OnDblClickMelOutUL();
	afx_msg void OnDblClickMelOutLD();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	afx_msg LRESULT OnCimInterface( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JOBSTABINTERFACEVIEW_H__FE20709E_7728_4298_9FAC_9543D4B7A04B__INCLUDED_)
