// JobsTabLoaderView.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "JobsTabLoaderView.h"

#include "..\X\XLog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJobsTabLoaderView

IMPLEMENT_DYNCREATE(CJobsTabLoaderView, CFormView)

CJobsTabLoaderView::CJobsTabLoaderView()
	: CFormView(CJobsTabLoaderView::IDD)
{
	//{{AFX_DATA_INIT(CJobsTabLoaderView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CJobsTabLoaderView::CJobsTabLoaderView(CView* pView, int nTabNo)
	: CFormView(CJobsTabLoaderView::IDD)
{
	m_pView		= pView;
	m_nTabNo	= nTabNo;

//	m_nPos = posSOURCE;
	m_nRobotAction	= 0;
	m_nCstAction	= 0;
	m_nPortNo		= 0;
	m_nOriginNo		= 0;

	// Sequence no
	m_nSeqMoveRbtNo = 0;
	m_nSeqOriginNo	= 0;
	m_nSeqTempStopNo	= 0;
	m_nSeqCstInitNo = 0;
	for( int i=0; i<MAX_PORT_NO; i++ )
	{
		m_nSeqCstRechuckNo[i] = 0;
		m_nSeqCstMappingNo[i] = 0;
		m_nSeqCstReserveNo[i] = 0;
		m_nSeqCstMoveOutNo[i] = 0;
	}
	
}

CJobsTabLoaderView::~CJobsTabLoaderView()
{
}

void CJobsTabLoaderView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJobsTabLoaderView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Control(pDX, IDC_COMBO_PORT, m_cbPort);
	DDX_Control(pDX, IDC_COMBO_ORIGIN, m_cbOrigin);
	DDX_Control(pDX, IDC_GRID_MAP_INFO, m_gridMapInfo);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CJobsTabLoaderView, CFormView)
	//{{AFX_MSG_MAP(CJobsTabLoaderView)
/*	ON_BN_CLICKED(IDC_LD_STAGE, OnLdStage)
	ON_BN_CLICKED(IDC_UL_STAGE, OnUlStage)
	ON_BN_CLICKED(IDC_UPPER_HAND, OnUpperHand)
	ON_BN_CLICKED(IDC_LOWER_HAND, OnLowerHand)
	ON_BN_CLICKED(IDC_SET_SOURCE, OnSetSource)
	ON_BN_CLICKED(IDC_SET_TARGET, OnSetTarget)
	ON_BN_CLICKED(IDC_MOVE, OnMove)
	ON_BN_CLICKED(IDC_MOVE_STANDBY, OnMoveStandby)*/
	ON_BN_CLICKED(IDC_ORIGIN, OnOrigin)
	ON_BN_CLICKED(IDC_Y_ALIGN, OnYAlign)
//	ON_BN_CLICKED(IDC_STOP, OnStop)
//	ON_BN_CLICKED(IDC_PAUSE, OnPause)
//	ON_BN_CLICKED(IDC_RESTART, OnRestart)
	ON_BN_CLICKED(IDC_INIT, OnCstInit)
	ON_BN_CLICKED(IDC_RECHUCK, OnCstRechuck)
	ON_BN_CLICKED(IDC_MAPPING, OnCstMapping)
//	ON_BN_CLICKED(IDC_RESERVE, OnCstReserve)
	ON_BN_CLICKED(IDC_CST_MOVE_OUT, OnCstMoveOut)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJobsTabLoaderView diagnostics

#ifdef _DEBUG
void CJobsTabLoaderView::AssertValid() const
{
	CFormView::AssertValid();
}

void CJobsTabLoaderView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJobsTabLoaderView message handlers

BOOL CJobsTabLoaderView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CJobsTabLoaderView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Set the devieceNet
	m_pDevice	 = ( (CDicsView*) m_pView )->m_pDevice;
	m_pDicsData  = ( (CDicsView*) m_pView )->m_pDicsData;
	m_pTimer	 = ( (CDicsView*) m_pView )->m_pTimer;
//	m_pLoaderSeq = ( (CDicsView*) m_pView )->m_pLoaderSeq;

	// CMsgBox : Date (400)
	CRect r;
	GetDlgItem( IDC_MESSAGE )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgMessage.Create( 400, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_MESSAGE,
			YELLOW_COLOR, BLUE_COLOR, 18, TRUE );
	m_msgMessage.SetOpMsg( "Loader Manual Operation" );
	
	GetDlgItem( IDC_SOURCE )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgSource.Create( 400, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_SOURCE,
			WHITE_COLOR, RED_COLOR, 18, TRUE );
	m_msgSource.SetOpMsg( "Select Source" );

	GetDlgItem( IDC_TARGET )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgTarget.Create( 401, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_TARGET,
			WHITE_COLOR, RED_COLOR, 18, TRUE );
	m_msgTarget.SetOpMsg( "Select Target" );

	GetDlgItem( IDC_UPPER_HAND_GLASS_INFO )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgUpperHandGlass.Create( 402, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_UPPER_HAND_GLASS_INFO,
			WHITE_COLOR, BLUE_COLOR, 18, TRUE );
	m_msgUpperHandGlass.SetOpMsg( " " );

	GetDlgItem( IDC_LOWER_HAND_GLASS_INFO )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgLowerHandGlass.Create( 403, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_LOWER_HAND_GLASS_INFO,
			WHITE_COLOR, BLUE_COLOR, 18, TRUE );
	m_msgLowerHandGlass.SetOpMsg( " " );


	// Color Button
	m_btnSource.Attach( IDC_SET_SOURCE, this, YELLOW_COLOR, BLUE_COLOR, DARK_GRAY_COLOR );
	m_btnTarget.Attach( IDC_SET_TARGET, this );

	m_btnLdStage.Attach( IDC_LD_STAGE, this );
	m_btnUlStage.Attach( IDC_UL_STAGE, this );
	m_btnUpHand.Attach( IDC_UPPER_HAND, this );
	m_btnLoHand.Attach( IDC_LOWER_HAND, this );

	m_btnMove.Attach( IDC_MOVE, this );
	m_btnMoveStandby.Attach( IDC_MOVE_STANDBY, this );
	
	m_btnInit.Attach( IDC_INIT, this );
	m_btnRechuck.Attach( IDC_RECHUCK, this );
	m_btnMapping.Attach( IDC_MAPPING, this );
	m_btnCstMoveOut.Attach( IDC_CST_MOVE_OUT, this );

	m_btnOrigin.Attach( IDC_ORIGIN, this );
	m_btnYAlign.Attach( IDC_Y_ALIGN, this );
	m_btnReserve.Attach( IDC_RESERVE, this );
	m_btnStop.Attach( IDC_STOP, this );
	m_btnPause.Attach( IDC_PAUSE, this );
	m_btnRestart.Attach( IDC_RESTART, this );

	// Static Text
	m_stcUpperHandGlass.SubclassDlgItem( IDC_UPPER_HAND_GLASS_ON_OFF, this );
	m_stcUpperHandGlass.SetBkColor( WHITE_COLOR );
	m_stcUpperHandGlass.SetTextColor( BLUE_COLOR );
	m_stcLowerHandGlass.SubclassDlgItem( IDC_LOWER_HAND_GLASS_ON_OFF, this );
	m_stcLowerHandGlass.SetTextColor( BLUE_COLOR );
	m_stcLowerHandGlass.SetBkColor( WHITE_COLOR );

	// Set LED
/*	for( int i=0; i<8; i++ )
	{
		m_ledOut[i].SetLed( CLed::LED_COLOR_GREEN, CLed::LED_OFF, CLed::LED_ROUND );
		m_ledIn[i].SetLed( CLed::LED_COLOR_GREEN, CLed::LED_OFF, CLed::LED_ROUND );
	}*/

	// Set combo
	m_cbPort.SetCurSel( m_nPortNo );
	m_cbOrigin.SetCurSel( m_nOriginNo );
	
	// Set the grid map control
	GridMapInfoInit();

	SetTimer( TIMER_LOADER, 20, NULL );
}

//--------------------------------------------------------------------
// OnClose
//--------------------------------------------------------------------
void CJobsTabLoaderView::OnClose() 
{
	KillTimer( TIMER_LOADER );
	
	CFormView::OnClose();
}

//--------------------------------------------------------------------
// Grid Initialize (Map Info)
//--------------------------------------------------------------------
void CJobsTabLoaderView::GridMapInfoInit()
{
	// Para GridCtrl ʱȭ
	m_gridMapInfo.SetRows( MAX_SLOT_NO + 1 );
	m_gridMapInfo.SetCols( MAX_PORT_NO + 1 );
	CString sCol[] = { "NO", "PORT1", "PORT2", "PORT3" };
	CString sRow[25];
	
	for( int nCol=0; nCol<MAX_PORT_NO + 1; nCol++ )
	{
		if( nCol == 0 ) m_gridMapInfo.SetColWidth( nCol, 525 );
		else m_gridMapInfo.SetColWidth( nCol, 1175 );
		m_gridMapInfo.SetCol( nCol );
		m_gridMapInfo.SetRow( 0 );
		m_gridMapInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridMapInfo.SetText( (LPCTSTR) sCol[nCol] );
	}
	for( int nRow=1; nRow<MAX_SLOT_NO + 1; nRow++ )
	{
		m_gridMapInfo.SetCol( 0 );
		m_gridMapInfo.SetRow( nRow );
		m_gridMapInfo.SetCellBackColor( LIGHT_MAGENTA_COLOR );
		sRow[nRow - 1].Format( "%d", MAX_SLOT_NO - nRow + 1 );
		m_gridMapInfo.SetText( (LPCTSTR) sRow[nRow - 1] );
	}
}

//--------------------------------------------------------------------
//------------- For Map Information Grid Control ---------------------
//--------------------------------------------------------------------
// Set Recipe Data to MapCtrl : For Column only
// i : Port No
//--------------------------------------------------------------------
void CJobsTabLoaderView::SetDataToGridMapInfo(int i, BOOL* bGlassMap )
{
	COLORREF colorTEXT;
	if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeCONTROL ) colorTEXT = GREEN_COLOR;
	else if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeMONITOR ) colorTEXT = RED_COLOR;
	else colorTEXT = BLACK_COLOR;

	for( int nSlot=0; nSlot<MAX_SLOT_NO; nSlot++ )
	{
		m_gridMapInfo.SetCol( i + 1 );
		m_gridMapInfo.SetRow( MAX_SLOT_NO - nSlot );
		m_gridMapInfo.SetCellForeColor( colorTEXT );
		if( bGlassMap[nSlot] )
		{
			m_gridMapInfo.SetCellBackColor( DARK_GRAY_COLOR );
			m_gridMapInfo.SetText( (LPCTSTR) "     Y" );
		}
		else
		{
			m_gridMapInfo.SetCellBackColor( WHITE_COLOR );
			m_gridMapInfo.SetText( (LPCTSTR) "     N" );
		}
	}
}

//--------------------------------------------------------------------
// Set Recipe Data to MapCtrl : For Column only
// i : Port No
//--------------------------------------------------------------------
void CJobsTabLoaderView::SetSelDataToGridMapInfo(int i, BOOL* bGlassMap )
{
	COLORREF colorTEXT;
	if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeCONTROL ) colorTEXT = GREEN_COLOR;
	else if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeMONITOR ) colorTEXT = RED_COLOR;
	else colorTEXT = BLACK_COLOR;
	
	for( int nSlot=0; nSlot<MAX_SLOT_NO; nSlot++ )
	{
		m_gridMapInfo.SetCol( i + 1 );
		m_gridMapInfo.SetRow( MAX_SLOT_NO - nSlot );
		m_gridMapInfo.SetCellForeColor( colorTEXT );
		if( bGlassMap[nSlot] ) m_gridMapInfo.SetCellBackColor( DARK_GRAY_COLOR );
		else m_gridMapInfo.SetCellBackColor( WHITE_COLOR );
	}
}

//--------------------------------------------------------------------
// Set Recipe Data to MapCtrl : For Column only
// i : Port No
//--------------------------------------------------------------------
void CJobsTabLoaderView::SetSlotStateToGridMapInfo(int i, int j, int nState)
{
	m_gridMapInfo.SetCol( i + 1 );
	m_gridMapInfo.SetRow( MAX_SLOT_NO - j  );

	if( nState == CDicsData::glassIN )
	{
		if( m_gridMapInfo.GetText() == "     N" )
		{
			m_gridMapInfo.SetText( (LPCTSTR) "     Y" );			
		}
	}

	COLORREF colorTEXT;
	if( nState == CDicsData::glassOUT ) colorTEXT = GREEN_COLOR;
	else if( nState == CDicsData::glassIN ) colorTEXT = YELLOW_COLOR;
	else if( nState == CDicsData::glassIN_MANUAL ) colorTEXT = DARK_GRAY_COLOR;
	else if( nState == CDicsData::glassNO ) colorTEXT = RED_COLOR;
	m_gridMapInfo.SetCellBackColor( colorTEXT );
}

void CJobsTabLoaderView::SetSlotStateToGridMapInfo(int i, int nState)
{
	m_gridMapInfo.SetCol( i + 1 );
	
	for( int j = 0; j < MAX_SLOT_NO; j++)
	{
		m_gridMapInfo.SetRow( MAX_SLOT_NO - j  );

		if( m_gridMapInfo.GetText() == "     Y" )
		{
			COLORREF colorTEXT;
			if( nState == CDicsData::glassOUT ) colorTEXT = GREEN_COLOR;
			else if( nState == CDicsData::glassIN ) colorTEXT = YELLOW_COLOR;
			m_gridMapInfo.SetCellBackColor( colorTEXT );
		}
	}
}

void CJobsTabLoaderView::OnOrigin() 
{/*
	// TODO: Add your control notification handler code here
	m_btnOrigin.SetBGColor( GREEN_COLOR );
	m_btnOrigin.SetFGColor( BLACK_COLOR );
	m_btnOrigin.Invalidate();

	m_nOriginNo = m_cbOrigin.GetCurSel();
	m_nRobotAction = CLoaderSeq::opORIGIN;	*/
}

void CJobsTabLoaderView::OnYAlign() 
{
	// TODO: Add your control notification handler code here
/*	m_btnYAlign.SetBGColor( GREEN_COLOR );
	m_btnYAlign.SetFGColor( BLACK_COLOR );
	m_btnYAlign.Invalidate();

	m_nStageNo	= CLoaderSeq::stageLD + 5;
	m_nRobotAction = CLoaderSeq::opY_ALIGN;	 */
}

//--------------------------------------------------------------------
// OnCstInit
//--------------------------------------------------------------------
void CJobsTabLoaderView::OnCstInit() 
{
	m_btnInit.SetBGColor( GREEN_COLOR );
	m_btnInit.SetFGColor( BLACK_COLOR );
	m_btnInit.Invalidate();

	m_nCstAction = cstINIT;
}

//--------------------------------------------------------------------
// OnCstRechuck
//--------------------------------------------------------------------
void CJobsTabLoaderView::OnCstRechuck() 
{
	m_btnRechuck.SetBGColor( GREEN_COLOR );
	m_btnRechuck.SetFGColor( BLACK_COLOR );
	m_btnRechuck.Invalidate();

	m_nPortNo = m_cbPort.GetCurSel();
	m_nCstAction = cstRECHUCK;
}

//--------------------------------------------------------------------
// OnCstMapping
//--------------------------------------------------------------------
void CJobsTabLoaderView::OnCstMapping() 
{
	m_btnMapping.SetBGColor( GREEN_COLOR );
	m_btnMapping.SetFGColor( BLACK_COLOR );
	m_btnMapping.Invalidate();

	m_nPortNo = m_cbPort.GetCurSel();
	m_nCstAction = cstMAPPING;
}

void CJobsTabLoaderView::OnCstMoveOut() 
{
	m_btnCstMoveOut.SetBGColor( GREEN_COLOR );
	m_btnCstMoveOut.SetFGColor( BLACK_COLOR );
	m_btnCstMoveOut.Invalidate();

	m_nPortNo = m_cbPort.GetCurSel();
	m_nCstAction = cstMOVE_OUT;
}

void CJobsTabLoaderView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if( ( (CDicsView*) m_pView )->m_nSelectedTab == m_nTabNo )
	{
//		CheckLoaderIf();
		SeqRobot();
		SeqCst();
	}
	
	CFormView::OnTimer(nIDEvent);
}

//--------------------------------------------------------------------
// CheckLoaderIf
//--------------------------------------------------------------------
void CJobsTabLoaderView::SeqRobot() 
{/*
	if( !m_nRobotAction ) return;

	int nRes;
	switch( m_nRobotAction )
	{
	case CLoaderSeq::opORIGIN:
		if( ( nRes = SeqOrigin() ) == 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			m_nRobotAction = 0;
		}
		else if( nRes > 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			m_nRobotAction = 0;
		}
		break;

/*	case CLoaderSeq::stopFORCED_STOP:

		break;
	case CLoaderSeq::stopPAUSE:

		break;
	case CLoaderSeq::stopPAUSE_RELEASE:
		if( ( nRes = SeqTempStop() ) == 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			m_nRobotAction = 0;
		}
		else if( nRes > 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			m_nRobotAction = 0;
		}
		break;

	case CLoaderSeq::opPUT:
		if( ( nRes = SeqMoveRbt( m_nRobotAction, m_nStageNo, m_nArmNo, m_nSlotNo ) ) == 0 )
		{
			if( m_nStageNo <= 5 )
			{
				SetSlotStateToGridMapInfo( m_nStageNo - 1, m_nSlotNo - 1, CDicsData::glassIN_MANUAL );
				m_pLoaderSeq->SetParaPutIntoCstAgain();
				m_pLoaderSeq->SetCstState( m_nStageNo, m_nSlotNo, CGlass::glsREADY );
			}
			SetHandGlassInfo( m_nArmNo, 0, 0 );
			
			// Set Source
			OnSetSource();

			// Set Button Color
			ResetButtonColorAll();
			SetLog( "ROBOT", 0, 0, "PUT OK" );
			m_nRobotAction = 0;
		}
		else if( nRes > 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			SetLog( "ROBOT", 0, 0, "PUT NG" );
			m_nRobotAction = 0;
		}
		break;
	case CLoaderSeq::opPUT_STANDBY:
		if( ( nRes = SeqMoveRbt( m_nRobotAction, m_nStageNo, m_nArmNo, m_nSlotNo ) ) == 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			SetLog( "ROBOT", 0, 0, "PUT Standby OK" );
			m_nRobotAction = 0;
		}
		else if( nRes > 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			SetLog( "ROBOT", 0, 0, "PUT Standby NG" );
			m_nRobotAction = 0;
		}
		break;
	case CLoaderSeq::opGET:
		if( ( nRes = SeqMoveRbt( m_nRobotAction, m_nStageNo, m_nArmNo, m_nSlotNo ) ) == 0 )
		{
			if( m_nStageNo <= 5 )
				SetSlotStateToGridMapInfo( m_nStageNo - 1, m_nSlotNo - 1, CDicsData::glassOUT );
			SetHandGlassInfo( m_nArmNo, m_nStageNo, m_nSlotNo );

			// Set Source
			OnSetSource();
			
			// Set Button Color
			ResetButtonColorAll();
			SetLog( "ROBOT", 0, 0, "GET OK" );
			m_nRobotAction = 0;
		}
		else if( nRes > 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			SetLog( "ROBOT", 0, 0, "GET NG" );
			m_nRobotAction = 0;
		}
		break;
	case CLoaderSeq::opGET_STANDBY:
		if( ( nRes = SeqMoveRbt( m_nRobotAction, m_nStageNo, m_nArmNo, m_nSlotNo ) ) == 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			SetLog( "ROBOT", 0, 0, "GET Standby OK" );
			m_nRobotAction = 0;
		}
		else if( nRes > 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			SetLog( "ROBOT", 0, 0, "GET Standby NG" );
			m_nRobotAction = 0;
		}
		break;
	case CLoaderSeq::opY_ALIGN:
		if( ( nRes = SeqMoveRbt( m_nRobotAction, m_nStageNo, m_nArmNo, m_nSlotNo ) ) == 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			SetLog( "ROBOT", 0, 0, "Y-Align OK" );
			m_nRobotAction = 0;
		}
		else if( nRes > 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			SetLog( "ROBOT", 0, 0, "Y-Align NG" );
			m_nRobotAction = 0;
		}
		break;*/
//	} 
}

//--------------------------------------------------------------------
// CheckLoaderIf
//--------------------------------------------------------------------
void CJobsTabLoaderView::SeqCst() 
{
	if( !m_nCstAction ) return;

	int nRes;
	switch( m_nCstAction )
	{
	case cstRECHUCK:
		if( ( nRes = SeqCstRechuck( m_nPortNo ) ) == 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			m_nCstAction = 0;
		}
		else if( nRes > 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			m_nCstAction = 0;
		}
		break;

	case cstMAPPING:
		if( ( nRes = SeqCstMapping( m_nPortNo ) ) == 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			m_nCstAction = 0;
		}
		else if( nRes > 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			m_nCstAction = 0;
		}
		break;

/*	case cstRESERVE:
		if( ( nRes = SeqCstReserve( m_nPortNo ) ) == 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			m_nCstAction = 0;
		}
		else if( nRes > 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			m_nCstAction = 0;
		}
		break;*/
	case cstMOVE_OUT:
		if( ( nRes = SeqCstMoveOut( m_nPortNo ) ) == 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			m_nCstAction = 0;
		}
		else if( nRes > 0 )
		{
			// Set Button Color
			ResetButtonColorAll();
			m_nCstAction = 0;
		}
		break;
	}
}

//--------------------------------------------------------------------
// Description : 
//--------------------------------------------------------------------
int CJobsTabLoaderView::SeqMoveRbt( int nAction, int nStageNo, int nArmNo, int nSlotNo )
{
	int nSeqNo = m_nSeqMoveRbtNo;
	int nRes = -1; 
	int tm = TM_LOADER_MANUAL;

	switch( nSeqNo )
	{
	case 0:
		//------------------------- R61
		// Set parameter
//		m_pLoaderSeq->m_LoaderInfo.R61_nOpType	= nAction;
//		m_pLoaderSeq->m_LoaderInfo.R61_nArmNo	= nArmNo;
//		m_pLoaderSeq->m_LoaderInfo.R61_nTargetNo	= nStageNo;	// Stage Number : 6, 7, 8, ...
//		m_pLoaderSeq->m_LoaderInfo.R61_nSlotNo	= ( nStageNo <= 5 ) ? nSlotNo : 1;
//		m_pLoaderSeq->m_LoaderInfo.R61_nBendingPara	= CLoaderSequence::bending06_07;

		// Upper Stage
//		if( nStageNo == 6 ) doIF_UP_STAGE_ACCESS_POSSIBLE( TRUE );
		// Lower Stage
//		else if( nStageNo == 7 ) doIF_LO_STAGE_ACCESS_POSSIBLE( TRUE );

#ifndef _LOADER_DEBUG
		if( nAction == 2)
		{
		   if( 1 )
		   {
//			   nAction = 0;
				nRes = 0;
				nSeqNo = 0;
		   }
		}
		else if( nAction == 4)
		{
			if( 1 )
		   {
				nRes = 0;
				nSeqNo = 0;
		   }
		}
		else if( 1 )
#else
		if( 1 )
#endif
		{
			// Set Log
			m_sMessage.Format( "Command : Stage No = %d, Slot No = %d", nStageNo, nSlotNo );
			SetLog( "ROBOT", 0, 0, m_sMessage );
			TIMER_ON( tm, 150 );	// 10 sec
			nSeqNo = 10;
		}
		break;
	//------------------------- A61
	case 10:
#ifndef _LOADER_DEBUG
		if( 1 )
#else
		if( 1 )
#endif
		{
				// Set Log
				m_sMessage.Format( "Command Set OK" );
				SetLog( "ROBOT", 0, 0, m_sMessage );
				
				// Set Message
				m_msgMessage.SetOpMsg( m_sMessage );

				TIMER_ON( tm, 600 );	// 60 sec
				nSeqNo = 20;

		}
		else if( TIMER( tm ) )
		{
			// Log
			m_sMessage.Format( "Timeout Error (A61)" );
			SetLog( "ROBOT", 0, 0, m_sMessage );
			
			// Set Message
			m_msgMessage.SetOpMsg( m_sMessage );

			nRes = 1;
			nSeqNo = 0;
		}
		break;

	//------------------------- A62
	case 20:
#ifndef _LOADER_DEBUG
		if( 1 )
#else
		if( 1 )
#endif
		{
				// Set Log
			m_sMessage.Format( "Move Complete" );
			SetLog( "ROBOT", 0, 0, m_sMessage );

			// Set Message
			m_msgMessage.SetOpMsg( m_sMessage );

			// Upper Stage
			nRes = 0;
			nSeqNo = 0;

		}
		else if( TIMER( tm ) )
		{
			// Log
			m_sMessage.Format( "Timeout Error (A62)" );
			SetLog( "ROBOT", 0, 0, m_sMessage );
			
			// Set Message
			m_msgMessage.SetOpMsg( m_sMessage );

			// Upper Stage

			nRes = 1;
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqMoveRbtNo = nSeqNo;
	return nRes;
}

//--------------------------------------------------------------------
// Description : 
//--------------------------------------------------------------------
int CJobsTabLoaderView::SeqOrigin()
{
	int nSeqNo = m_nSeqOriginNo;
	int nRes = -1; 
	int tm = TM_LOADER_MANUAL;

	switch( nSeqNo )
	{
		//------------------------- R32
	case 0:
#ifndef _LOADER_DEBUG
		if( 1 )
#else
		if( 1 )
#endif
		{
			// Set Log
			SetLog( "ROBOT", 0, 0, "Request Home Move (R32)" );

			TIMER_ON( tm, 150 );	// 10 sec
			nSeqNo = 10;
		}
		break;
	//------------------------- A32
	case 10:
#ifndef _LOADER_DEBUG
		if( 1 )
#else
		if( 1 )
#endif
		{
			// Set Log
			m_sMessage.Format( "Home Move OK");
			SetLog( "ROBOT", 0, 0, m_sMessage );

			// Set Message
			m_msgMessage.SetOpMsg( m_sMessage );
			nRes = 0;
			nSeqNo = 0;
		}
		else if( TIMER( tm ) )
		{
			// Log
			m_sMessage.Format( "Timeout Error (A32)" );
			SetLog( "ROBOT", 0, 0, m_sMessage );

			// Set Message
			m_msgMessage.SetOpMsg( m_sMessage );
			nRes = 1;
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqOriginNo = nSeqNo;
	return nRes;
}

//--------------------------------------------------------------------
// Description : 
//--------------------------------------------------------------------
int CJobsTabLoaderView::SeqCstRechuck(int i)
{/*
	int nSeqNo = m_nSeqCstRechuckNo[i];
	int nRes = -1; 
	int tm = TM_LOADER_MANUAL;

	switch( nSeqNo )
	{
	//------------------------- R81
	case 0:
		{
			// Set Log
			SetLog( "CST", i + 1, 0, "Request Rechuck (R81)" );

			// Set flag
			m_pDicsData->m_IfLoader.bPortReloadReq[i] = TRUE;

			TIMER_ON( tm, 150 );	// 10 sec
			nSeqNo = 10;
		}
		break;
	// A81
	case 10:
		if( m_pLoaderSeq->SeqCstReload(i) )
		{
			// Set Log
			SetDataToGridMapInfo( i, m_pDicsData->m_IfLoader.nGlassMap[i] );
			m_sMessage.Format( "CST Rechuck Complete (A81)" );
			SetLog( "CST", i + 1, 0, m_sMessage );

			// Set Message
			m_msgMessage.SetOpMsg( m_sMessage );
			TIMER_ON( tm, 600 );	// 60 sec
			nRes = 0;
			nSeqNo = 0;
		}
		else if( TIMER( tm ) )
		{
			// Log
			m_sMessage.Format( "Timeout Error (A81)" );
			SetLog( "CST", i + 1, 0, m_sMessage );
			
			// Set Message
			m_msgMessage.SetOpMsg( m_sMessage );
			nRes = 1;
			nSeqNo = 0;
		}
		break;

	//------------------------- A72
	case 20:
#ifndef _LOADER_DEBUG
		if( m_pDicsData->m_IfLoader.bMoveIn[i] )
#else
		if( 1 )
#endif
		{
			// Reset Flag
			m_pDicsData->m_IfLoader.bMoveIn[i] = FALSE;
			SetDataToGridMapInfo( i, m_pDicsData->m_IfLoader.nGlassMap[i] );

			// Set Log
			m_sMessage.Format( "CST mapping Complete" );
			SetLog( "CST", i + 1, 0, m_sMessage );

			// Set Message
			m_msgMessage.SetOpMsg( m_sMessage );
			nRes = 0;
			nSeqNo = 0;
		}
		else if( TIMER( tm ) )
		{
			// Log
			m_sMessage.Format( "Timeout Error (A72)" );
			SetLog( "CST", i + 1, 0, m_sMessage );
			
			// Set Message
			m_msgMessage.SetOpMsg( m_sMessage );
			nRes = 1;
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqCstRechuckNo[i] = nSeqNo;
	return nRes;*/
	return -1;
}

//--------------------------------------------------------------------
// Description : 
//--------------------------------------------------------------------
int CJobsTabLoaderView::SeqCstMapping(int i)
{
	int nSeqNo = m_nSeqCstMappingNo[i];
	int nRes = -1; 
	int tm = TM_LOADER_MANUAL;

	switch( nSeqNo )
	{
	//------------------------- R82
	case 0:
		// Set Data : Port No
		m_pDicsData->m_PortInfo[i].nPortNo = i + 1;

#ifndef _LOADER_DEBUG
		if( 1 )
#else
		if( 1 )
#endif
		{
			// Set Log
			SetLog( "CST", i + 1, 0, "Request Mapping (R82)" );

			TIMER_ON( tm, 100 );	// 10 sec
			nSeqNo = 10;
		}
		break;
	//------------------------- R182
	case 10:
#ifndef _LOADER_DEBUG
		if( 1 )
#else
		if( 1 )
#endif
		{
			// Set Log
			SetLog( "CST", i + 1, 0, "Request Mapping Confirm (R182) : Accepted" );
			
			// Set Message
			m_msgMessage.SetOpMsg( "Command Set OK (R82)" );
			TIMER_ON( tm, 600 );	// 60 sec
			nSeqNo = 20;

		}
		else if( TIMER( tm ) )
		{
			// Set Log
			m_sMessage.Format( "Timeout Error (A82)" );
			SetLog( "CST", i + 1, 0, m_sMessage );

			// Set Message
			m_msgMessage.SetOpMsg( m_sMessage );
			nRes = 1;
			nSeqNo = 0;
		}
		break;

	//------------------------- R83
	case 20:
#ifndef _LOADER_DEBUG
		if( 1 )
#else
		if( 1 )
#endif
		{
#ifdef _MY_DEBUG
#ifdef _LOADER_DEBUG
				// Get Mapping Data : _MY_DEBUG && _LOADER_DEBUG ϶ 
				for( int j =0; j<MAX_SLOT_NO; j++ ) 
				{
					if( j < 10 ) m_pDicsData->m_IfLoader.nGlassMap[i][j] = 1;
					else m_pDicsData->m_IfLoader.nGlassMap[i][j] = 0;
				}
#endif
#endif
				// Set Log
				m_sMessage.Format( "Mapping OK (R83)" );
				SetLog( "CST", i + 1, 0, m_sMessage );
				
				// Set Message
				m_msgMessage.SetOpMsg( m_sMessage );
				nRes = 0;
				nSeqNo = 0;

		}
		else if( TIMER( tm ) )
		{
			// Log
			m_sMessage.Format( "Timeout Error (R83)" );
			SetLog( "CST", i + 1, 0, m_sMessage );
			
			// Set Message
			m_msgMessage.SetOpMsg( m_sMessage );
			nRes = 1;
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqCstMappingNo[i] = nSeqNo;
	return nRes;
}

//--------------------------------------------------------------------
// Description : 
//--------------------------------------------------------------------
int CJobsTabLoaderView::SeqCstMoveOut(int i)
{
	int nSeqNo = m_nSeqCstMoveOutNo[i];
	int nRes = -1; 
	int tm = TM_LOADER_MANUAL;

	switch( nSeqNo )
	{
	//------------------------- R73
	case 0:
#ifndef _LOADER_DEBUG
		m_pDicsData->m_PortInfo[i].nPortNo = i;
#else

#endif
		{
			// Set Log
			SetLog( "CST", i + 1, 0, "Request CST Move-out (R73)" );

//			TIMER_ON( tm, 150 );	// 10 sec
			nSeqNo = 10;
		}
		break;
	// A73
	case 10:
#ifndef _LOADER_DEBUG
		if( 1 )
#else
		if( 1 )
#endif
		{
			// Reset flag
			nRes = 0;
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqCstMoveOutNo[i] = nSeqNo;
	return nRes;
}

//---------------------------------------------------------------------------
// Reset Button Color
//---------------------------------------------------------------------------
void CJobsTabLoaderView::ResetButtonColorAll()
{
	m_btnLdStage.SetBGColor( GRAY_COLOR );
	m_btnLdStage.SetFGColor( BLACK_COLOR );
	m_btnLdStage.Invalidate();

	m_btnUlStage.SetBGColor( GRAY_COLOR );
	m_btnUlStage.SetFGColor( BLACK_COLOR );
	m_btnUlStage.Invalidate();

	m_btnUpHand.SetBGColor( GRAY_COLOR );
	m_btnUpHand.SetFGColor( BLACK_COLOR );
	m_btnUpHand.Invalidate();

	m_btnLoHand.SetBGColor( GRAY_COLOR );
	m_btnLoHand.SetFGColor( BLACK_COLOR );
	m_btnLoHand.Invalidate();

	m_btnMove.SetBGColor( GRAY_COLOR );
	m_btnMove.SetFGColor( BLACK_COLOR );
	m_btnMove.Invalidate();

	m_btnMoveStandby.SetBGColor( GRAY_COLOR );
	m_btnMoveStandby.SetFGColor( BLACK_COLOR );
	m_btnMoveStandby.Invalidate();

	m_btnOrigin.SetBGColor( GRAY_COLOR );
	m_btnOrigin.SetFGColor( BLACK_COLOR );
	m_btnOrigin.Invalidate();

	m_btnYAlign.SetBGColor( GRAY_COLOR );
	m_btnYAlign.SetFGColor( BLACK_COLOR );
	m_btnYAlign.Invalidate();

	m_btnStop.SetBGColor( GRAY_COLOR );
	m_btnStop.SetFGColor( BLACK_COLOR );
	m_btnStop.Invalidate();

	m_btnPause.SetBGColor( GRAY_COLOR );
	m_btnPause.SetFGColor( BLACK_COLOR );
	m_btnPause.Invalidate();

	m_btnRestart.SetBGColor( GRAY_COLOR );
	m_btnRestart.SetFGColor( BLACK_COLOR );
	m_btnRestart.Invalidate();

	// CST
	m_btnInit.SetBGColor( GRAY_COLOR );
	m_btnInit.SetFGColor( BLACK_COLOR );
	m_btnInit.Invalidate();

	m_btnRechuck.SetBGColor( GRAY_COLOR );
	m_btnRechuck.SetFGColor( BLACK_COLOR );
	m_btnRechuck.Invalidate();

	m_btnMapping.SetBGColor( GRAY_COLOR );
	m_btnMapping.SetFGColor( BLACK_COLOR );
	m_btnMapping.Invalidate();

	m_btnReserve.SetBGColor( GRAY_COLOR );
	m_btnReserve.SetFGColor( BLACK_COLOR );
	m_btnReserve.Invalidate();

	m_btnCstMoveOut.SetBGColor( GRAY_COLOR );
	m_btnCstMoveOut.SetFGColor( BLACK_COLOR );
	m_btnCstMoveOut.Invalidate();
}

//---------------------------------------------------------------------------
// Set the Log
//---------------------------------------------------------------------------
void CJobsTabLoaderView::SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage )
{
	// Log
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	m_sMessage.Format( "LOADVIEW\t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( m_sMessage );

	m_sMessage.Format( "%s : %s", sSeqName, sMessage );
	( (CDicsView*) m_pView )->SendMessage( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) m_sMessage );
}

