#if !defined(AFX_JOBSTABLOADERVIEW_H__7F0D41FB_47E6_4AFE_AEF5_D878F6D01014__INCLUDED_)
#define AFX_JOBSTABLOADERVIEW_H__7F0D41FB_47E6_4AFE_AEF5_D878F6D01014__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// JobsTabLoaderView.h : header file
//

#include "X\MsgBox.h"
#include "X\ColorBtn.h"
#include "X\ColorStatic.h"
#include "X\led.h"
#include "X\XCtlDevice.h"
#include "X\XTimer.h"
#include "DicsData.h"
/////////////////////////////////////////////////////////////////////////////
// CJobsTabLoaderView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CJobsTabLoaderView : public CFormView
{
public:
	CJobsTabLoaderView();           // protected constructor used by dynamic creation
	CJobsTabLoaderView( CView* pView, int nTabNo );
	DECLARE_DYNCREATE(CJobsTabLoaderView)

// Form Data
public:
	//{{AFX_DATA(CJobsTabLoaderView)
	enum { IDD = IDD_JOBS_TAB_LOADER_VIEW };
	CComboBox	m_cbPort;
	CComboBox	m_cbOrigin;
	CMSFlexGrid	m_gridMapInfo;
	CLed	m_ledOut[8];
	CLed	m_ledIn[8];
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Attributes
public:
	CView*			m_pView;
	XCtlDevice*		m_pDevice;
	XCtlMelsec *	m_pMelsec;
//	CDaihen*		m_pLoader;
	CDicsData*		m_pDicsData;
	XTimer*			m_pTimer;
//	CLoaderSeq*		m_pLoaderSeq;

	int				m_nTabNo;

	CString			m_sMessage;

	CMsgBox			m_msgMessage;
	CMsgBox			m_msgSource;
	CMsgBox			m_msgTarget;

	CColorButton	m_btnSource;
	CColorButton	m_btnTarget;

	CColorButton	m_btnLdStage;
	CColorButton	m_btnUlStage;
	CColorButton	m_btnUpHand;
	CColorButton	m_btnLoHand;

	CColorButton	m_btnMove;
	CColorButton	m_btnMoveStandby;

	CColorButton	m_btnInit;
	CColorButton	m_btnRechuck;
	CColorButton	m_btnMapping;
	CColorButton	m_btnReserve;
	CColorButton	m_btnCstMoveOut;

	CColorButton	m_btnOrigin;
	CColorButton	m_btnYAlign;
	CColorButton	m_btnStop;
	CColorButton	m_btnPause;
	CColorButton	m_btnRestart;

	CColorStatic	m_stcUpperHandGlass;
	CMsgBox			m_msgUpperHandGlass;
	CColorStatic	m_stcLowerHandGlass;
	CMsgBox			m_msgLowerHandGlass;

	int		m_nPos;
	int		m_nStageNo;
	int		m_nSlotNo;
	int		m_nArmNo;
	int		m_nRobotAction;
	int		m_nPortNo;
	int		m_nOriginNo;
	int		m_nCstAction;
	int		m_nGlassAction;

	int		m_nSeqMoveRbtNo;
	int		m_nSeqOriginNo;
	int		m_nSeqTempStopNo;
	int		m_nSeqCstInitNo;
	int		m_nSeqCstRechuckNo[MAX_PORT_NO];
	int		m_nSeqCstMappingNo[MAX_PORT_NO];
	int		m_nSeqCstReserveNo[MAX_PORT_NO];
	int		m_nSeqCstMoveOutNo[MAX_PORT_NO];

	enum	_glsTRANSFER	{ glsGET, glsPUT };
	enum	_POSITION		{ posSOURCE, posTARGET };
	enum	_CST_ACTION		{ cstNONE, cstINIT, cstRECHUCK, cstMAPPING, cstRESERVE, cstMOVE_OUT};

// Operations
public:
	void GridMapInfoInit();
	void SetDataToGridMapInfo(int i, BOOL* bGlassMap );
	void SetSelDataToGridMapInfo(int i, BOOL* bGlassMap );
	void SetSlotStateToGridMapInfo(int i, int j, int nState);
	void SetSlotStateToGridMapInfo(int i, int nState);
/*	void SetSlotScrapToGridMapInfo(int i, int j);
	void SetHandGlassInfo(int nArmNo, int nPortNo, int nSlotNo);
	void CheckLoaderIf();*/
	void SeqRobot();
	void SeqCst();
	int  SeqMoveRbt( int nAction, int nStageNo, int nArmNo, int nSlotNo );
	int  SeqOrigin();
//	int  SeqTempStop();
	int  SeqCstInit();
	int  SeqCstRechuck(int i);
	int	 SeqCstMapping(int i);
//	int  SeqCstReserve(int i);
	int  SeqCstMoveOut(int i);
	void ResetButtonColorAll();
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJobsTabLoaderView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CJobsTabLoaderView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CJobsTabLoaderView)
	afx_msg void OnOrigin();
	afx_msg void OnYAlign();
	afx_msg void OnCstInit();
	afx_msg void OnCstRechuck();
	afx_msg void OnCstMapping();
	afx_msg void OnCstMoveOut();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JOBSTABLOADERVIEW_H__7F0D41FB_47E6_4AFE_AEF5_D878F6D01014__INCLUDED_)
