// JobsTabMotorLoadFactor.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "..\MainFrm.h"
#include "JobsTabMotorLoadFactorView.h"
#include "..\Dlg\DlgCalibration.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CJobsTabMotorLoadFactorView
	
IMPLEMENT_DYNCREATE(CJobsTabMotorLoadFactorView, CFormView)

CJobsTabMotorLoadFactorView::CJobsTabMotorLoadFactorView()
	: CFormView(CJobsTabMotorLoadFactorView::IDD)
{
	//{{AFX_DATA_INIT(CJobsTabMotorLoadFactorView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CJobsTabMotorLoadFactorView::CJobsTabMotorLoadFactorView(CView* pView, int nTabNo)
	: CFormView(CJobsTabMotorLoadFactorView::IDD)
{
	m_nTabNo	= nTabNo; 
	m_pView		= pView;
	m_bInitialUpdateComp = FALSE;
	SetDicsData( ( (CDicsView*)m_pView )->m_pDicsData );
	SetDevice( ((CDicsView*)m_pView)->m_pDevice );
	SetEqpAssy( ((CDicsView*)m_pView)->m_pEqpAssy );
}

CJobsTabMotorLoadFactorView::~CJobsTabMotorLoadFactorView()
{
	if( m_ocxAnalogInput ) delete []m_ocxAnalogInput;
	m_ocxAnalogInput = NULL;
}

void CJobsTabMotorLoadFactorView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJobsTabMotorLoadFactorView)

}

BEGIN_MESSAGE_MAP(CJobsTabMotorLoadFactorView, CFormView)
	//{{AFX_MSG_MAP(CJobsTabMotorLoadFactorView)
		// NOTE - the ClassWizard will add and remove mapping macros here.

	ON_STN_CLICKED(IDC_UNIT_ANALOGVIEW1, &CJobsTabMotorLoadFactorView::OnStnClickedUnitAnalogview1)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJobsTabMotorLoadFactorView diagnostics

#ifdef _DEBUG
void CJobsTabMotorLoadFactorView::AssertValid() const
{
	CFormView::AssertValid();
}

void CJobsTabMotorLoadFactorView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJobsTabMotorLoadFactorView message handlers

BOOL CJobsTabMotorLoadFactorView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CJobsTabMotorLoadFactorView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	// TODO: Add your specialized code here and/or call the base class

	m_pSetupItems = ( (CDicsView*)m_pView )->GetDocument()->m_pSetupItems;

	SetAnalogOcxInitParameter();
	SetAiInitParameter();
	m_pSetupItems->GetRegistryTabInterlockSetView();

	( (CDicsView*) m_pView )->SetSeqInitParameter();
	( (CDicsView*) m_pView )->SetSeqStart();
	m_bInitialUpdateComp = TRUE;

	// hskwak 20.01.17 Init
	for( int i=0; i<MAX_LF_VIEW_AI_NO; i++ )
	{
		m_aiView[i].SubclassDlgItem( IDC_UNIT_ANALOGVIEW1 + i, this );
		m_aiView[i].SetTextColor( BLACK_COLOR );
		m_aiView[i].SetBkColor( GRAY_COLOR );
	} 
	m_bAiControlHide = TRUE;
	SetHideAiControl(m_bAiControlHide);
}

void CJobsTabMotorLoadFactorView::SetAnalogOcxInitParameter()
{
	m_ocxAnalogInput = new CAnalogCtrl[MAX_LF_VIEW_AI_NO];

	for( int i = 0 ; i < MAX_LF_VIEW_AI_NO; i++ )
	{
		m_ocxAnalogInput[i].SubclassDlgItem( IDC_ANALOGCTRLCTRL68+i, this);
		m_ocxAnalogInput[i].SetAlarmEnable();
		int nAddress = m_ocxAnalogInput[i].GetAiRealID();
		m_ocxAnalogInput[i].SetInitParameterSet( nAddress );
		UINT uResId = m_ocxAnalogInput[i].GetAnalogOcxCtlId();
		for( int j = 0; j < m_pEqpAssy->m_AnalogInput.GetAiSize(); j++ )
		{
			if( nAddress == m_pEqpAssy->m_AnalogInput.m_aiSet[j].nReal )
			{
				CString sAiName = m_ocxAnalogInput[i].GetAnalogUnitName();
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].nOwnerViewNo = CDicsView::viewJobMotorLoadFactor;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].sName = sAiName;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].nOwnerUnitNo = m_ocxAnalogInput[i].GetApdReportUnitNo();
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].uRESID = uResId;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].sKind = m_ocxAnalogInput[i].GetUnitOfKind( nAddress );
				if( m_ocxAnalogInput[i].GetApdReportSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nApdReportNo = j;
					m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nApdReportNo = -1;
				if( m_ocxAnalogInput[i].GetInterlockUsingSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nAiIntrNo = j;
					m_pEqpAssy->m_AnalogInput.m_nMaxIntrAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nAiIntrNo = -1;
				if( m_ocxAnalogInput[i].GetEdcReportSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nEdcReportNo = m_pEqpAssy->m_AnalogInput.m_nMaxEdcAiNo;
					m_pEqpAssy->m_AnalogInput.m_nMaxEdcAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nEdcReportNo = -1;
				break;
			}
		}
	}
}

void CJobsTabMotorLoadFactorView::SetAiInitParameter()
{
	float fAnalogVal = 0.0f;
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		if( m_pEqpAssy->m_AnalogInput.m_aiSet[i].nOwnerViewNo != CDicsView::viewJobMotorLoadFactor ) continue;
		int nAddress = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nReal;
		int nOcxId = m_pEqpAssy->m_AnalogInput.m_aiSet[i].uRESID - (MAX_PVIEW1_AI_NO + MAX_PVIEW2_AI_NO );
		if( nOcxId >= 0 )
		{
			fAnalogVal =  m_pEqpAssy->m_AnalogInput.GetRealVal( i );
			m_ocxAnalogInput[nOcxId].SetAnalogCalDisplay( fAnalogVal );
		}
	}
}

void CJobsTabMotorLoadFactorView::SetBitmaps()
{
}

void CJobsTabMotorLoadFactorView::SetColorStatic(CColorStatic &stcObject, BOOL bState, COLORREF color)
{
	if( bState ) 
	{
		stcObject.StartBkBlink( FALSE );
		stcObject.StartTextBlink( FALSE );
		stcObject.SetTextColor( BLACK_COLOR );
		stcObject.SetBkColor( color );
	}
	else
	{
		stcObject.StartBkBlink( FALSE );
		stcObject.StartTextBlink( FALSE );
		stcObject.SetTextColor( BLACK_COLOR );
		stcObject.SetBkColor( WHITE_COLOR );
	}
}

void CJobsTabMotorLoadFactorView::UpdateObjects()
{
	UpdateAI();
}

void CJobsTabMotorLoadFactorView::UpdateAI()
{
	float fAnalogVal = 0.0f;
	int nCurAdcVal = 0;
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		if( m_pEqpAssy->m_AnalogInput.m_aiSet[i].nOwnerViewNo != CDicsView::viewJobMotorLoadFactor ) continue;
		int nAddress = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nReal;
		int nOcxId = m_pEqpAssy->m_AnalogInput.m_aiSet[i].uRESID - (MAX_PVIEW1_AI_NO + MAX_PVIEW2_AI_NO );
		if( nOcxId >= 0 )
		{
			m_pDevice->m_pFilterGain[nAddress]  = m_ocxAnalogInput[nOcxId].GetFilterGain();
			m_pDevice->m_aiInfo[nAddress].nScale   = m_ocxAnalogInput[nOcxId].GetCalScale();
			m_pDevice->m_aiInfo[nAddress].nAdcMin  = m_ocxAnalogInput[nOcxId].GetAdcMinVal();
			m_pDevice->m_aiInfo[nAddress].nAdcMax  = m_ocxAnalogInput[nOcxId].GetAdcMaxVal();
			m_pDevice->m_aiInfo[nAddress].fRealMin = m_ocxAnalogInput[nOcxId].GetRealMinVal();
			m_pDevice->m_aiInfo[nAddress].fRealMax = m_ocxAnalogInput[nOcxId].GetRealMaxVal();

			fAnalogVal =  m_pEqpAssy->m_AnalogInput.GetRealVal( i );
			nCurAdcVal = m_pEqpAssy->m_AnalogInput.GetAdcVal( i );
			m_ocxAnalogInput[nOcxId].SetCurAdcVal( nCurAdcVal );
			m_ocxAnalogInput[nOcxId].SetAnalogCalDisplay( fAnalogVal );
			
			UpdateAiView(nOcxId, fAnalogVal);	// hskwak 20.01.17 ai update
		}
	}
}

BEGIN_EVENTSINK_MAP(CJobsTabMotorLoadFactorView, CFormView)
    //{{AFX_EVENTSINK_MAP(CJobsTabMotorLoadFactorView)
	ON_EVENT_RANGE(CJobsTabMotorLoadFactorView, IDC_ANALOGCTRLCTRL68, IDC_ANALOGCTRLCTRL94, -600, OnClickAnalogInput, VTS_I2)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CJobsTabMotorLoadFactorView::OnClickAnalogInput( UINT nID )
{
	int nOcxId = nID - IDC_ANALOGCTRLCTRL68;
	int nAddress = m_ocxAnalogInput[nOcxId].GetAiRealID();
	m_pDevice->m_pFilterGain[nAddress]  = m_ocxAnalogInput[nOcxId].GetFilterGain();
	m_pDevice->m_aiInfo[nAddress].nScale   = m_ocxAnalogInput[nOcxId].GetCalScale();
	m_pDevice->m_aiInfo[nAddress].nAdcMin  = m_ocxAnalogInput[nOcxId].GetAdcMinVal();
	m_pDevice->m_aiInfo[nAddress].nAdcMax  = m_ocxAnalogInput[nOcxId].GetAdcMaxVal();
	m_pDevice->m_aiInfo[nAddress].fRealMin = m_ocxAnalogInput[nOcxId].GetRealMinVal();
	m_pDevice->m_aiInfo[nAddress].fRealMax = m_ocxAnalogInput[nOcxId].GetRealMaxVal();

	m_pDevice->m_aiInfo[nAddress].nLoLimit = m_ocxAnalogInput[nOcxId].GetLowLimitValue();
	m_pDevice->m_aiInfo[nAddress].nUpLimit = m_ocxAnalogInput[nOcxId].GetUpLimitValue();
	m_pDevice->m_aiInfo[nAddress].nLoWarning = m_ocxAnalogInput[nOcxId].GetLoWaringValue();
	m_pDevice->m_aiInfo[nAddress].nUpWarning = m_ocxAnalogInput[nOcxId].GetUpWarningValue();

	float fVal = m_ocxAnalogInput[nOcxId].GetCalculation();
}

// hskwak 20.01.17 ai hide
void CJobsTabMotorLoadFactorView::SetHideAiControl(BOOL bHide)
{
	for( int i = 0 ; i < MAX_LF_VIEW_AI_NO; i++ )
	{
		if(bHide)	GetDlgItem(IDC_ANALOGCTRLCTRL68+i)->ShowWindow(SW_HIDE);
		else		GetDlgItem(IDC_ANALOGCTRLCTRL68+i)->ShowWindow(SW_SHOW);	
	}
}

// hskwak 20.01.17 button event
void CJobsTabMotorLoadFactorView::OnStnClickedUnitAnalogview1()
{
	m_bAiControlHide = !m_bAiControlHide;
	SetHideAiControl(m_bAiControlHide);
}

// hskwak 20.01.17 ai status
void CJobsTabMotorLoadFactorView::UpdateAiView(int nId, float fAiVaue)
{
	static DWORD dTime = GetCurrentTime();
	
	CString sMessage;
	sMessage.Format( "%.2f A", fAiVaue);
	m_aiView[nId].SetWindowText( sMessage );
			
	int nAddress = m_ocxAnalogInput[nId].GetAiRealID();
	if( (int)fAiVaue < m_pDevice->m_aiInfo[nAddress].nLoLimit || (int)fAiVaue < m_pDevice->m_aiInfo[nAddress].nLoWarning ||
		(int)fAiVaue > m_pDevice->m_aiInfo[nAddress].nUpLimit || (int)fAiVaue > m_pDevice->m_aiInfo[nAddress].nUpWarning)
	{
		if(GetCurrentTime() - dTime < 500)
		{
			m_aiView[nId].SetBkColor( RED_COLOR );
			m_aiView[nId].SetTextColor( BLACK_COLOR );
		}
		else if(GetCurrentTime() - dTime < 1000)
		{
			m_aiView[nId].SetBkColor( YELLOW_COLOR );
			m_aiView[nId].SetTextColor( RED_COLOR );
		}
		else
		{
			dTime = GetCurrentTime();
		}
	}		
	else
	{
		m_aiView[nId].SetBkColor( YELLOW_COLOR );
	}
}
