// JobsTabPipingBufTankView.cpp :  Դϴ.
//

#include "stdafx.h"
#include "..\Dics.h"
#include "..\MainFrm.h"
#include "JobsTabPipingBufTankView.h"
#include "..\Dlg\DlgValve.h"
#include "..\Dlg\DlgBufTankPumpCln.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// CJobsTabPipingBufTankView

IMPLEMENT_DYNCREATE(CJobsTabPipingBufTankView, CFormView)

CJobsTabPipingBufTankView::CJobsTabPipingBufTankView()
	: CFormView(CJobsTabPipingBufTankView::IDD)
{

}

CJobsTabPipingBufTankView::CJobsTabPipingBufTankView(CView* pView, int nTabNo)
	: CFormView(CJobsTabPipingBufTankView::IDD)
{
	m_nTabNo	= nTabNo; 
	m_pView		= pView;
	m_bInitialUpdateComp = FALSE;
	SetDicsData( ( (CDicsView*)m_pView )->m_pDicsData );
	SetDevice( ((CDicsView*)m_pView)->m_pDevice );
	SetEqpAssy( ((CDicsView*)m_pView)->m_pEqpAssy );
}

CJobsTabPipingBufTankView::~CJobsTabPipingBufTankView()
{
	if( m_ocxAnalogInput ) delete []m_ocxAnalogInput;
	m_ocxAnalogInput = NULL;
}

void CJobsTabPipingBufTankView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_BUFTANK_PUMP1, m_ocxBufTankPump[0]);
	DDX_Control(pDX, IDC_BUFTANK_PUMP2, m_ocxBufTankPump[1]);
	DDX_Control(pDX, IDC_PROGRESS_BUFTANK, m_progBufTank[0] );

	DDX_Control(pDX, IDC_AUTOVALVECTRL17, m_ocxAutoValve[0]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL18, m_ocxAutoValve[1]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL19, m_ocxAutoValve[2]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL20, m_ocxAutoValve[3]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL21, m_ocxAutoValve[4]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL22, m_ocxAutoValve[5]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL23, m_ocxAutoValve[6]);

}

BEGIN_MESSAGE_MAP(CJobsTabPipingBufTankView, CFormView)
END_MESSAGE_MAP()


// CJobsTabPipingBufTankView Դϴ.

#ifdef _DEBUG
void CJobsTabPipingBufTankView::AssertValid() const
{
	CFormView::AssertValid();
}

#ifndef _WIN32_WCE
void CJobsTabPipingBufTankView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif
#endif //_DEBUG


// CJobsTabPipingBufTankView ޽ óԴϴ.

BOOL CJobsTabPipingBufTankView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CJobsTabPipingBufTankView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();

	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.

	m_pSetupItems = ( (CDicsView*)m_pView )->GetDocument()->m_pSetupItems;

#ifdef _BUFTANK_USE
	for( int i=0; i<MAX_DI_BUFTANK_NO; i ++ )
	{
		m_progBufTank[i].SetVertical( TRUE );
		m_progBufTank[i].SetBkColour( BG_COLOR );
		m_progBufTank[i].SetForeColour( BLUE_COLOR );
		m_progBufTank[i].SetShowText( TRUE );
		m_progBufTank[i].SetWindowText( "NORMAL" );
		m_progBufTank[i].SetRange( 0, (int)PVIEW3_BUFTANK_HEIGHT( i ) );
		m_progBufTank[i].SetPos( 0 );
	}
#endif

	UINT uBufTankHHID[MAX_DI_BUFTANK_NO] = { IDC_BUFTANK_HH, };	
	UINT uBufTankHID[MAX_DI_BUFTANK_NO] = {  IDC_BUFTANK_H, };	
	UINT uBufTankLID[MAX_DI_BUFTANK_NO] = {  IDC_BUFTANK_L, };	
	UINT uBufTankLLID[MAX_DI_BUFTANK_NO] = { IDC_BUFTANK_LL, };	

	for( int i = 0 ; i < MAX_DI_BUFTANK_NO ; i ++ )
	{
		m_stcBufTankHH[i].SubclassDlgItem( uBufTankHHID[i], this );
		m_stcBufTankHH[i].SetTextColor( BLACK_COLOR );
		m_stcBufTankHH[i].SetBkColor( WHITE_COLOR );

		m_stcBufTankH[i].SubclassDlgItem( uBufTankHID[i], this );
		m_stcBufTankH[i].SetTextColor( BLACK_COLOR );
		m_stcBufTankH[i].SetBkColor( WHITE_COLOR );

		m_stcBufTankL[i].SubclassDlgItem( uBufTankLID[i], this );
		m_stcBufTankL[i].SetTextColor( BLACK_COLOR );
		m_stcBufTankL[i].SetBkColor( WHITE_COLOR );

		m_stcBufTankLL[i].SubclassDlgItem( uBufTankLLID[i], this );
		m_stcBufTankLL[i].SetTextColor( BLACK_COLOR );
		m_stcBufTankLL[i].SetBkColor( WHITE_COLOR );
	}
	
	UINT nLeakSensorResId[MAX_BUFTANK_LEAK_SENSOR_NO] = { IDC_BUFTANK_LEAK, };

	for( int i = 0 ; i < MAX_BUFTANK_LEAK_SENSOR_NO ; i ++ )	
	{
		m_stcLeak[i].SubclassDlgItem( nLeakSensorResId[i], this );
		m_stcLeak[i].SetTextColor( RED_COLOR );
		m_stcLeak[i].SetBkColor( WHITE_COLOR );
	}

	SetAnalogOcxInitParameter();
	SetAiInitParameter();
	m_pSetupItems->GetRegistryTabInterlockSetView();

	( (CDicsView*) m_pView )->SetSeqInitParameter();
	( (CDicsView*) m_pView )->SetSeqStart();
	m_bInitialUpdateComp = TRUE;

}

void CJobsTabPipingBufTankView::SetAnalogOcxInitParameter()
{
#ifdef _BUFTANK_USE
	m_ocxAnalogInput = new CAnalogCtrl[MAX_PVIEW3_AI_NO];

	for( int i = 0 ; i < MAX_PVIEW3_AI_NO; i++ )
	{
		m_ocxAnalogInput[i].SubclassDlgItem( IDC_ANALOGCTRLCTRL101+i, this);
		m_ocxAnalogInput[i].SetAlarmEnable();
		int nAddress = m_ocxAnalogInput[i].GetAiRealID();
		m_ocxAnalogInput[i].SetInitParameterSet( nAddress );
		UINT uResId = m_ocxAnalogInput[i].GetAnalogOcxCtlId();
		for( int j = 0; j < m_pEqpAssy->m_AnalogInput.GetAiSize(); j++ )
		{
			if( nAddress == m_pEqpAssy->m_AnalogInput.m_aiSet[j].nReal )
			{
				CString sAiName = m_ocxAnalogInput[i].GetAnalogUnitName();
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].nOwnerViewNo = CDicsView::viewJobPipingBufTank;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].sName = sAiName;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].nOwnerUnitNo = m_ocxAnalogInput[i].GetApdReportUnitNo();
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].uRESID = uResId;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].sKind = m_ocxAnalogInput[i].GetUnitOfKind( nAddress );
				if( m_ocxAnalogInput[i].GetApdReportSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nApdReportNo = j;
					m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nApdReportNo = -1;
				if( m_ocxAnalogInput[i].GetInterlockUsingSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nAiIntrNo = j;
					m_pEqpAssy->m_AnalogInput.m_nMaxIntrAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nAiIntrNo = -1;
				if( m_ocxAnalogInput[i].GetEdcReportSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nEdcReportNo = m_pEqpAssy->m_AnalogInput.m_nMaxEdcAiNo;
					m_pEqpAssy->m_AnalogInput.m_nMaxEdcAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nEdcReportNo = -1;
				break;
			}
		}
	}
#endif
}

void CJobsTabPipingBufTankView::SetAiInitParameter()
{
	float fAnalogVal = 0.0f;

#ifdef _BUFTANK_USE
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		if( m_pEqpAssy->m_AnalogInput.m_aiSet[i].nOwnerViewNo != CDicsView::viewJobPipingBufTank ) continue;
		int nAddress = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nReal;
		int nOcxId = m_pEqpAssy->m_AnalogInput.m_aiSet[i].uRESID - ( MAX_PVIEW1_AI_NO + MAX_PVIEW2_AI_NO + MAX_LF_VIEW_AI_NO );
		if( nOcxId >= 0 )
		{
			fAnalogVal =  m_pEqpAssy->m_AnalogInput.GetRealVal( i );
			m_ocxAnalogInput[nOcxId].SetAnalogCalDisplay( fAnalogVal );
		}
	}
#endif
}

void CJobsTabPipingBufTankView::SetColorStatic(CColorStatic &stcObject, BOOL bState, COLORREF color)
{
	if( bState ) 
	{
		stcObject.StartBkBlink( FALSE );
		stcObject.StartTextBlink( FALSE );
		stcObject.SetTextColor( BLACK_COLOR );
		stcObject.SetBkColor( color );
	}
	else
	{
		stcObject.StartBkBlink( FALSE );
		stcObject.StartTextBlink( FALSE );
		stcObject.SetTextColor( BLACK_COLOR );
		stcObject.SetBkColor( WHITE_COLOR );
	}
}

void CJobsTabPipingBufTankView::UpdateObjects()
{
	UpdateAI();
	UpdateValve();
	UpdateDiwPump();
	UpdateDiwBufTank();
	UpdateLeakSensor();
	UpdateSensor();

}

void CJobsTabPipingBufTankView::UpdateAI()
{
#ifdef _BUFTANK_USE
	float fAnalogVal = 0.0f;
	int nCurAdcVal = 0;
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		if( m_pEqpAssy->m_AnalogInput.m_aiSet[i].nOwnerViewNo != CDicsView::viewJobPipingBufTank ) continue;
		int nAddress = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nReal;
		int nOcxId = m_pEqpAssy->m_AnalogInput.m_aiSet[i].uRESID - ( MAX_PVIEW1_AI_NO + MAX_PVIEW2_AI_NO + MAX_LF_VIEW_AI_NO );
		if( nOcxId >= 0 )
		{
			m_pDevice->m_pFilterGain[nAddress]  = m_ocxAnalogInput[nOcxId].GetFilterGain();
			m_pDevice->m_aiInfo[nAddress].nScale   = m_ocxAnalogInput[nOcxId].GetCalScale();
			m_pDevice->m_aiInfo[nAddress].nAdcMin  = m_ocxAnalogInput[nOcxId].GetAdcMinVal();
			m_pDevice->m_aiInfo[nAddress].nAdcMax  = m_ocxAnalogInput[nOcxId].GetAdcMaxVal();
			m_pDevice->m_aiInfo[nAddress].fRealMin = m_ocxAnalogInput[nOcxId].GetRealMinVal();
			m_pDevice->m_aiInfo[nAddress].fRealMax = m_ocxAnalogInput[nOcxId].GetRealMaxVal();

			fAnalogVal =  m_pEqpAssy->m_AnalogInput.GetRealVal( i );
			nCurAdcVal = m_pEqpAssy->m_AnalogInput.GetAdcVal( i );
			m_ocxAnalogInput[nOcxId].SetCurAdcVal( nCurAdcVal );
			m_ocxAnalogInput[nOcxId].SetAnalogCalDisplay( fAnalogVal );
		}
	}
#endif
}

void CJobsTabPipingBufTankView::UpdateValve()
{
#ifdef _BUFTANK_USE
	static BOOL bOldValveStateView4[MAX_PVIEW3_VALVE_NO] = { FALSE, };

	for( int i = 0 ; i < MAX_PVIEW3_VALVE_NO; i ++ )
	{
		if( !bOldValveStateView4[i] && m_pEqpAssy->m_AutoValvePiping.GetState( i +  MAX_PVIEW1_VALVE_NO+MAX_PVIEW2_VALVE_NO ) )
		{
			bOldValveStateView4[i] = TRUE;
			OnValveStatusChanged( TRUE, i );
		}
		else if( bOldValveStateView4[i] && !m_pEqpAssy->m_AutoValvePiping.GetState( i + MAX_PVIEW1_VALVE_NO+MAX_PVIEW2_VALVE_NO ) )
		{
			bOldValveStateView4[i] = FALSE;
			OnValveStatusChanged( FALSE, i );
		}
	}
#endif
}

void CJobsTabPipingBufTankView::UpdateDiwPump()
{
#ifdef _BUFTANK_USE
	static int nJobPump[MAX_PVIEW3_PUMP_NO] = { -1, };

	for( int i=0; i<MAX_PVIEW3_PUMP_NO; i++ )
	{
		BOOL bPumpOn = TRUE;
		bPumpOn &= m_pEqpAssy->m_DiTank[NO_BUFTANK].GetPumpOnState(i);

		BOOL bPumpAlarm = m_pEqpAssy->m_DiTank[NO_BUFTANK].GetPumpAlarm(i);
		if( bPumpOn && !bPumpAlarm && nJobPump[i] != 0 )
		{
			nJobPump[i] = 0;
			m_ocxBufTankPump[i].SetStart();
		}
		else if( !bPumpOn && !bPumpAlarm && nJobPump[i] != 1 )
		{
			nJobPump[i] = 1;
			m_ocxBufTankPump[i].SetStop();
		}
		else if( bPumpAlarm && nJobPump[i] != 2 )
		{
			nJobPump[i] = 2;
			m_ocxBufTankPump[i].SetAlarm();
		}
	}
#endif
}


void CJobsTabPipingBufTankView::UpdateDiwBufTank()
{
#ifdef _BUFTANK_USE
	float fVal[MAX_PVIEW3_TANK_NO] = { 0, };

	CPumpSeq* pPumpSeq = ( ((CDicsView*)m_pView)->m_pPumpSeq );
	for( int i=0; i<MAX_PVIEW3_TANK_NO; i++ )
	{
		if( pPumpSeq->m_SeqFlag.bDiTankLevel[i+NO_BUFTANK][CPumpSeq::lvHH] )		fVal[i] = (float)PVIEW3_BUFTANK_LEVEL_HH( i );
		else if( pPumpSeq->m_SeqFlag.bDiTankLevel[i+NO_BUFTANK][CPumpSeq::lvH] )	fVal[i] = (float)PVIEW3_BUFTANK_LEVEL_H( i );
		else if( pPumpSeq->m_SeqFlag.bDiTankLevel[i+NO_BUFTANK][CPumpSeq::lvM] )	fVal[i] = (float)PVIEW3_BUFTANK_LEVEL_M( i );
		else if( pPumpSeq->m_SeqFlag.bDiTankLevel[i+NO_BUFTANK][CPumpSeq::lvL] )	fVal[i] = (float)PVIEW3_BUFTANK_LEVEL_L( i );
		
		OnBufTankStatusChanged( i, (LPARAM)fVal[i] );
	}
#endif
}

void CJobsTabPipingBufTankView::UpdateLeakSensor()
{
	static BOOL bOldLeakSensorState[MAX_BUFTANK_LEAK_SENSOR_NO] = { FALSE, };

	for( int i = 0 ; i < MAX_BUFTANK_LEAK_SENSOR_NO; i ++ )
	{
		if( !bOldLeakSensorState[i] && m_pEqpAssy->m_SensorLeak.Get( NO_BUFTANK_LEAK+i ) )		
		{
			bOldLeakSensorState[i] = TRUE; 
			SetColorStatic( m_stcLeak[i], TRUE, CYAN_COLOR );
		}
		if( bOldLeakSensorState[i] && !m_pEqpAssy->m_SensorLeak.Get( NO_BUFTANK_LEAK+i ) )
		{
			bOldLeakSensorState[i] = FALSE; 
			SetColorStatic( m_stcLeak[i], FALSE, CYAN_COLOR );
		}
	}
}

void CJobsTabPipingBufTankView::UpdateSensor()
{
	static BOOL bBufTankLevelStatus[MAX_DI_BUFTANK_NO][MAX_DI_TANK_LEVEL_NO] = { FALSE, };


	for( int nTankNo=0; nTankNo<MAX_DI_BUFTANK_NO; nTankNo++ )
	{
		for( int nSensorNo=0; nSensorNo<MAX_DI_TANK_LEVEL_NO; nSensorNo++ )
		{
			if( !bBufTankLevelStatus[nTankNo][nSensorNo] && m_pEqpAssy->m_DiTank[nTankNo+NO_BUFTANK].GetTankLevel( nSensorNo ) )
			{
				bBufTankLevelStatus[nTankNo][nSensorNo] = TRUE;
				if( nSensorNo == CPumpSeq::lvHH ) SetColorStatic( m_stcBufTankHH[nTankNo], ON, RED_COLOR );
				else if( nSensorNo == CPumpSeq::lvH ) SetColorStatic( m_stcBufTankH[nTankNo], ON, GREEN_COLOR );
				else if( nSensorNo == CPumpSeq::lvM ) SetColorStatic( m_stcBufTankL[nTankNo], ON, GREEN_COLOR );
				else if( nSensorNo == CPumpSeq::lvL ) SetColorStatic( m_stcBufTankLL[nTankNo], ON, GREEN_COLOR );
			}
			else if( bBufTankLevelStatus[nTankNo][nSensorNo] && !m_pEqpAssy->m_DiTank[nTankNo+NO_BUFTANK].GetTankLevel( nSensorNo ) )
			{
				bBufTankLevelStatus[nTankNo][nSensorNo] = FALSE;
				if( nSensorNo == CPumpSeq::lvHH ) SetColorStatic( m_stcBufTankHH[nTankNo], OFF, RED_COLOR );
				else if( nSensorNo == CPumpSeq::lvH ) SetColorStatic( m_stcBufTankH[nTankNo], OFF, GREEN_COLOR );
				else if( nSensorNo == CPumpSeq::lvM ) SetColorStatic( m_stcBufTankL[nTankNo], OFF, GREEN_COLOR );
				else if( nSensorNo == CPumpSeq::lvL ) SetColorStatic( m_stcBufTankLL[nTankNo], OFF, GREEN_COLOR );
			}
		}	
	}
}


LRESULT CJobsTabPipingBufTankView::OnValveStatusChanged( WPARAM wParam, LPARAM lParam )
{
	if( !m_bInitialUpdateComp ) return 0;

	BOOL bState = (BOOL) wParam;
	int nValve = (int) lParam;

	if( bState ) m_ocxAutoValve[nValve].SetValveOn();
	else m_ocxAutoValve[nValve].SetValveOff();
	return 0;
}

LRESULT CJobsTabPipingBufTankView::OnPumpStatusChanged( WPARAM wParam, LPARAM lParam )
{
	switch( wParam )
	{
	case 0 :
		m_ocxBufTankPump[lParam].SetStart();
		break;
	case 1 :
		m_ocxBufTankPump[lParam].SetStop();
		break;
	case 2 :
		m_ocxBufTankPump[lParam].SetAlarm();
		break;
	}
	return 0;
}

LRESULT CJobsTabPipingBufTankView::OnBufTankStatusChanged( WPARAM wParam, LPARAM lParam )
{
#ifdef _BUFTANK_USE
	int nTankNo = (int) wParam;
	float fTankLevel = (float) lParam;

	LPCTSTR sMsg;
	COLORREF color;
	if( fTankLevel >= PVIEW3_BUFTANK_LEVEL_HH( nTankNo ) )
	{
		sMsg = "TOP";
		color = RED_COLOR;
		m_progBufTank[nTankNo].SetForeColour( color );
		m_progBufTank[nTankNo].SetWindowText( sMsg );
		m_progBufTank[nTankNo].SetPos( (int)fTankLevel );
	}
	else if( fTankLevel < PVIEW3_BUFTANK_LEVEL_HH( nTankNo ) && fTankLevel >= PVIEW3_BUFTANK_LEVEL_H( nTankNo ) )
	{
		sMsg = "HIGH";
		color = LIGHT_CYAN_COLOR;
		m_progBufTank[nTankNo].SetForeColour( color );
		m_progBufTank[nTankNo].SetWindowText( sMsg );
		m_progBufTank[nTankNo].SetPos( (int)fTankLevel );
	}
	else if( fTankLevel < PVIEW3_BUFTANK_LEVEL_H( nTankNo ) && fTankLevel >= PVIEW3_BUFTANK_LEVEL_M( nTankNo ) )
	{
		sMsg = "MIDDLE";
		color = LIGHT_ORANGE_COLOR;
		m_progBufTank[nTankNo].SetForeColour( color );
		m_progBufTank[nTankNo].SetWindowText( sMsg );
		m_progBufTank[nTankNo].SetPos( (int)fTankLevel );
	}
	else if( fTankLevel < PVIEW3_BUFTANK_LEVEL_M( nTankNo ) && fTankLevel >= PVIEW3_BUFTANK_LEVEL_L( nTankNo ) )
	{
		sMsg = "LOW";
		color = ORANGE_COLOR;
		m_progBufTank[nTankNo].SetForeColour( color );
		m_progBufTank[nTankNo].SetWindowText( sMsg );
		m_progBufTank[nTankNo].SetPos( (int)fTankLevel );
	}
	else if( fTankLevel < PVIEW3_BUFTANK_LEVEL_L( nTankNo ) )
	{
		sMsg = "BOTTOM";
		color = RED_COLOR;
		m_progBufTank[nTankNo].SetForeColour( color );
		m_progBufTank[nTankNo].SetWindowText( sMsg );
		m_progBufTank[nTankNo].SetPos( (int)fTankLevel );
	}
#endif
	return 0;
}


BEGIN_EVENTSINK_MAP(CJobsTabPipingBufTankView, CFormView)
	//{{AFX_EVENTSINK_MAP(CJobsTabPipingBufTankView)
	ON_EVENT_RANGE(CJobsTabPipingBufTankView, IDC_ANALOGCTRLCTRL101, IDC_ANALOGCTRLCTRL106, DISPID_CLICK, ClickAnalogInput, VTS_I2)
	ON_EVENT_RANGE(CJobsTabPipingBufTankView, IDC_AUTOVALVECTRL17, IDC_AUTOVALVECTRL23, DISPID_CLICK, ClickAutovalve, VTS_I2)
	ON_EVENT_RANGE(CJobsTabPipingBufTankView, IDC_BUFTANK_PUMP1, IDC_BUFTANK_PUMP2, DISPID_CLICK, ClickBuftankPump, VTS_I2)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()


void CJobsTabPipingBufTankView::ClickAnalogInput( UINT nID )
{
	int nOcxId = nID - IDC_ANALOGCTRLCTRL101;
	int nAddress = m_ocxAnalogInput[nOcxId].GetAiRealID();
	m_pDevice->m_pFilterGain[nAddress]  = m_ocxAnalogInput[nOcxId].GetFilterGain();
	m_pDevice->m_aiInfo[nAddress].nScale   = m_ocxAnalogInput[nOcxId].GetCalScale();
	m_pDevice->m_aiInfo[nAddress].nAdcMin  = m_ocxAnalogInput[nOcxId].GetAdcMinVal();
	m_pDevice->m_aiInfo[nAddress].nAdcMax  = m_ocxAnalogInput[nOcxId].GetAdcMaxVal();
	m_pDevice->m_aiInfo[nAddress].fRealMin = m_ocxAnalogInput[nOcxId].GetRealMinVal();
	m_pDevice->m_aiInfo[nAddress].fRealMax = m_ocxAnalogInput[nOcxId].GetRealMaxVal();

	m_pDevice->m_aiInfo[nAddress].nLoLimit = m_ocxAnalogInput[nOcxId].GetLowLimitValue();
	m_pDevice->m_aiInfo[nAddress].nUpLimit = m_ocxAnalogInput[nOcxId].GetUpLimitValue();
	m_pDevice->m_aiInfo[nAddress].nLoWarning = m_ocxAnalogInput[nOcxId].GetLoWaringValue();
	m_pDevice->m_aiInfo[nAddress].nUpWarning = m_ocxAnalogInput[nOcxId].GetUpWarningValue();

	float fVal = m_ocxAnalogInput[nOcxId].GetCalculation();
}


void CJobsTabPipingBufTankView::ClickAutovalve( UINT nID )
{
	int nAutoValveId = nID - IDC_AUTOVALVECTRL17;
	CDicsApp* pApp = ( CDicsApp* ) AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* ) pApp->m_pMainWnd;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto ) return;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;

	CDlgValve dlg;

	if( (((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP) && !pMainFrame->m_bAuto ) dlg.m_bPermitAccess = TRUE;
	else dlg.m_bPermitAccess = FALSE;
	
	int nAutoValveKeyCount = m_pEqpAssy->m_AutoValvePiping.GetDoSize();
	dlg.m_nValveNo = nAutoValveId + MAX_PVIEW1_VALVE_NO+MAX_PVIEW2_VALVE_NO;

	if( nAutoValveKeyCount <= dlg.m_nValveNo ) return;

	dlg.m_nWhatGroup = CDlgValve::vgJOB4;
	dlg.SetDevice( ( (CDicsView*)m_pView )->m_pDevice );
	dlg.SetEqpAssy(( (CDicsView*)m_pView )->m_pEqpAssy );
	dlg.DoModal();
}


void CJobsTabPipingBufTankView::ClickBuftankPump( UINT nID )
{
	int nPumpId = nID - IDC_BUFTANK_PUMP1;
	// TODO: Add your control notification handler code here
	CDicsApp* pApp = ( CDicsApp* )AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* )pApp->m_pMainWnd;
	if( pMainFrame->m_bAuto ) return;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;
	CDlgBufTankPumpCln dlg;
	dlg.SetDevice( ( (CDicsView*)m_pView )->m_pDevice );
	dlg.SetTankAssy( &m_pEqpAssy->m_DiTank[2] );
	dlg.m_nCurSelPump = nPumpId;
	dlg.DoModal();
}
