// JobsTabPipingView.cpp : implementation file
//

#include "StdAfx.h"
#include "..\Dics.h"
#include "..\MainFrm.h"		// kjd
#include "JobsTabPipingView.h"
#include "..\Dlg\DlgValve.h"
#include "..\Dlg\DlgPumpCln.h"
//#include "DlgEuv.h"
#include "..\Dlg\DlgGridRollBrush.h"
#include "..\Dlg\DlgCalibration.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJobsTabPipingView
	
IMPLEMENT_DYNCREATE(CJobsTabPipingView, CFormView)

CJobsTabPipingView::CJobsTabPipingView()
	: CFormView(CJobsTabPipingView::IDD)
{
	//{{AFX_DATA_INIT(CJobsTabPipingView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CJobsTabPipingView::CJobsTabPipingView(CView* pView, int nTabNo)
	: CFormView(CJobsTabPipingView::IDD)
{
	m_nTabNo	= nTabNo; 
	m_pView		= pView;
	m_bInitialUpdateComp = FALSE;
	SetDicsData( ( (CDicsView*)m_pView )->m_pDicsData );
	SetDevice( ((CDicsView*)m_pView)->m_pDevice );
	SetEqpAssy( ((CDicsView*)m_pView)->m_pEqpAssy );
}

CJobsTabPipingView::~CJobsTabPipingView()
{
	if( m_ocxAnalogInput ) delete []m_ocxAnalogInput;
}

void CJobsTabPipingView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJobsTabPipingView)
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_IONIZER1, m_ocxIonizer[0]);
	DDX_Control(pDX, IDC_PUMP1, m_ocxPump[0]);
	DDX_Control(pDX, IDC_PUMP2, m_ocxPump[1]);
	DDX_Control(pDX, IDC_PROGRESS_TANK1, m_progTank[0] );
	DDX_Control(pDX, IDC_SBJUNITCTRL1, m_ocxSbjUnit[0] );
	DDX_Control(pDX, IDC_SBJUNITCTRL2, m_ocxSbjUnit[1] );
	DDX_Control(pDX, IDC_AQKUNITCTRL1, m_ocxAqkUnit[0] );
	DDX_Control(pDX, IDC_SWR1_UP_SHW1, m_ocxSWR1ShwUnitUp[0] );
	DDX_Control(pDX, IDC_SWR1_UP_SHW2, m_ocxSWR1ShwUnitUp[1] );
	DDX_Control(pDX, IDC_SWR1_UP_SHW3, m_ocxSWR1ShwUnitUp[2] );
	DDX_Control(pDX, IDC_SWR1_UP_SHW4, m_ocxSWR1ShwUnitUp[3] );
	DDX_Control(pDX, IDC_SWR1_LO_SHW1, m_ocxSWR1ShwUnitLo[0] );
	DDX_Control(pDX, IDC_SWR1_LO_SHW2, m_ocxSWR1ShwUnitLo[1] );
	
	DDX_Control(pDX, IDC_SWR2_UP_SHW1, m_ocxSWR2ShwUnitUp[0] );
	DDX_Control(pDX, IDC_SWR2_UP_SHW2, m_ocxSWR2ShwUnitUp[1] );
	DDX_Control(pDX, IDC_SWR2_UP_SHW3, m_ocxSWR2ShwUnitUp[2] );
	DDX_Control(pDX, IDC_SWR2_UP_SHW4, m_ocxSWR2ShwUnitUp[3] );
	DDX_Control(pDX, IDC_SWR2_UP_SHW5, m_ocxSWR2ShwUnitUp[4] );
	DDX_Control(pDX, IDC_SWR2_UP_SHW6, m_ocxSWR2ShwUnitUp[5] );
	DDX_Control(pDX, IDC_SWR2_LO_SHW1, m_ocxSWR2ShwUnitLo[0] );
	DDX_Control(pDX, IDC_SWR2_LO_SHW2, m_ocxSWR2ShwUnitLo[1] );
	DDX_Control(pDX, IDC_SWR2_LO_SHW3, m_ocxSWR2ShwUnitLo[2] );
	DDX_Control(pDX, IDC_SWR2_LO_SHW4, m_ocxSWR2ShwUnitLo[3] );
	DDX_Control(pDX, IDC_SWR2_LO_SHW5, m_ocxSWR2ShwUnitLo[4] );
	DDX_Control(pDX, IDC_SWR2_LO_SHW6, m_ocxSWR2ShwUnitLo[5] );

	DDX_Control(pDX, IDC_SWR3_UP_SHW1, m_ocxSWR3ShwUnitUp[0] );
	DDX_Control(pDX, IDC_SWR3_UP_SHW2, m_ocxSWR3ShwUnitUp[1] );
	DDX_Control(pDX, IDC_SWR3_UP_SHW3, m_ocxSWR3ShwUnitUp[2] );
	DDX_Control(pDX, IDC_SWR3_UP_SHW4, m_ocxSWR3ShwUnitUp[3] );
	DDX_Control(pDX, IDC_SWR3_UP_SHW5, m_ocxSWR3ShwUnitUp[4] );
	DDX_Control(pDX, IDC_SWR3_UP_SHW6, m_ocxSWR3ShwUnitUp[5] );
	DDX_Control(pDX, IDC_SWR3_LO_SHW1, m_ocxSWR3ShwUnitLo[0] );
	DDX_Control(pDX, IDC_SWR3_LO_SHW2, m_ocxSWR3ShwUnitLo[1] );
	DDX_Control(pDX, IDC_SWR3_LO_SHW3, m_ocxSWR3ShwUnitLo[2] );
	DDX_Control(pDX, IDC_SWR3_LO_SHW4, m_ocxSWR3ShwUnitLo[3] );
	DDX_Control(pDX, IDC_SWR3_LO_SHW5, m_ocxSWR3ShwUnitLo[4] );
	DDX_Control(pDX, IDC_SWR3_LO_SHW6, m_ocxSWR3ShwUnitLo[5] );

	DDX_Control(pDX, IDC_AUTOVALVECTRL1, m_ocxAutoValve[0]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL2, m_ocxAutoValve[1]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL3, m_ocxAutoValve[2]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL4, m_ocxAutoValve[3]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL5, m_ocxAutoValve[4]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL6, m_ocxAutoValve[5]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL7, m_ocxAutoValve[6]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL8, m_ocxAutoValve[7]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL9, m_ocxAutoValve[8]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL10, m_ocxAutoValve[9]);
	DDX_Control(pDX, IDC_SWR2_RB1_UP_PIPING, m_ocxRollBrush[0]);
	DDX_Control(pDX, IDC_SWR2_RB1_LO_PIPING, m_ocxRollBrush[1]);
	DDX_Control(pDX, IDC_SWR2_RB2_UP_PIPING, m_ocxRollBrush[2]);
	DDX_Control(pDX, IDC_SWR2_RB2_LO_PIPING, m_ocxRollBrush[3]);
	DDX_Control(pDX, IDC_SWR3_RB1_UP_PIPING, m_ocxRollBrush[4]);
	DDX_Control(pDX, IDC_SWR3_RB1_LO_PIPING, m_ocxRollBrush[5]);
	DDX_Control(pDX, IDC_SWR3_RB2_UP_PIPING, m_ocxRollBrush[6]);	
	DDX_Control(pDX, IDC_SWR3_RB2_LO_PIPING, m_ocxRollBrush[7]);
}

BEGIN_MESSAGE_MAP(CJobsTabPipingView, CFormView)
	//{{AFX_MSG_MAP(CJobsTabPipingView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
//	ON_COMMAND_RANGE( IDC_AUTOVALVECTRL1, IDC_AUTOVALVECTRL8, OnClickValve )	// ljy_050329 : Range 1 ~ 6
	ON_MESSAGE( WM_VALVE_STATUS_CHANGED, OnValveStatusChanged )
	ON_MESSAGE( WM_MSG_BOX_CLICKED, OnMsgBoxClicked )
	ON_MESSAGE( WM_PUMP_STATUS_CHANGED, OnPumpStatusChanged )
	ON_MESSAGE( WM_TANK_STATUS_CHANGED, OnTankStatusChanged )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJobsTabPipingView diagnostics

#ifdef _DEBUG
void CJobsTabPipingView::AssertValid() const
{
	CFormView::AssertValid();
}

void CJobsTabPipingView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJobsTabPipingView message handlers

BOOL CJobsTabPipingView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CJobsTabPipingView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	m_pSetupItems = ( (CDicsView*)m_pView )->GetDocument()->m_pSetupItems;

	for( int i=0; i<MAX_PVIEW1_TANK_NO; i ++ )
	{
		m_progTank[i].SetVertical( TRUE );
		m_progTank[i].SetBkColour( BG_COLOR );
		m_progTank[i].SetForeColour( BLUE_COLOR );
		m_progTank[i].SetShowText( TRUE );
		m_progTank[i].SetWindowText( "NORMAL" );

		m_progTank[i].SetRange( 0, (int)PVIEW1_TANK_HEIGHT( i ) );
		m_progTank[i].SetPos( 0 );
	}

	UINT uUnitID[4] = { IDC_INCV_UNIT, IDC_SWR1_UNIT, IDC_SWR2_UNIT, IDC_SWR3_UNIT, };	

	for( int i=0; i<4; i++ )
	{
		m_stcUnit[i].SubclassDlgItem( uUnitID[i], this );
		m_stcUnit[i].SetTextColor( BLACK_COLOR );
		m_stcUnit[i].SetBkColor( BG_COLOR );
	}

	UINT uTankHHID[MAX_PVIEW1_TANK_NO]	= { IDC_TANK1_HH, };	
	UINT uTankHID[MAX_PVIEW1_TANK_NO]	= { IDC_TANK1_H, };	
	UINT uTankLID[MAX_PVIEW1_TANK_NO]	= { IDC_TANK1_L, };	
	UINT uTankLLID[MAX_PVIEW1_TANK_NO]	= { IDC_TANK1_LL, };	

	for( int i = 0 ; i < MAX_PVIEW1_TANK_NO ; i ++ )
	{
		m_stcTankHH[i].SubclassDlgItem( uTankHHID[i], this );
		m_stcTankHH[i].SetTextColor( BLACK_COLOR );
		m_stcTankHH[i].SetBkColor( WHITE_COLOR );

		m_stcTankH[i].SubclassDlgItem( uTankHID[i], this );
		m_stcTankH[i].SetTextColor( BLACK_COLOR );
		m_stcTankH[i].SetBkColor( WHITE_COLOR );

		m_stcTankL[i].SubclassDlgItem( uTankLID[i], this );
		m_stcTankL[i].SetTextColor( BLACK_COLOR );
		m_stcTankL[i].SetBkColor( WHITE_COLOR );

		m_stcTankLL[i].SubclassDlgItem( uTankLLID[i], this );
		m_stcTankLL[i].SetTextColor( BLACK_COLOR );
		m_stcTankLL[i].SetBkColor( WHITE_COLOR );
	}

	SetAnalogOcxInitParameter();
	SetAiInitParameter();
	m_pSetupItems->GetRegistryTabInterlockSetView();

//	( (CDicsView*) m_pView )->SetSeqInitParameter();
//	( (CDicsView*) m_pView )->SetSeqStart();
	m_bInitialUpdateComp = TRUE;
}

void CJobsTabPipingView::SetAnalogOcxInitParameter()
{
	m_ocxAnalogInput = new CAnalogCtrl[MAX_PVIEW1_AI_NO];
	CString strTemp;
	int nCnt=0;
	for( int i = 0 ; i < MAX_PVIEW1_AI_NO; i++ )
	{
#ifdef _MOTOR_LOAD_FACTOR		
		m_ocxAnalogInput[i].SubclassDlgItem( IDC_NEW_ANALOGCTRLCTRL1+i, this);
#else
		m_ocxAnalogInput[i].SubclassDlgItem( IDC_ANALOGCTRLCTRL4+i, this);
#endif
		m_ocxAnalogInput[i].SetAlarmEnable();
		int nAddress = m_ocxAnalogInput[i].GetAiRealID();
		m_ocxAnalogInput[i].SetInitParameterSet( nAddress );
		UINT uResId = m_ocxAnalogInput[i].GetAnalogOcxCtlId();
		for( int j = 0; j < m_pEqpAssy->m_AnalogInput.GetAiSize(); j++ )
		{
			if( nAddress == m_pEqpAssy->m_AnalogInput.m_aiSet[j].nReal )
			{
				//strTemp.Format("nAddress=%d, nRead=%d, uResId=%d, nCnt=%d", nAddress, m_pEqpAssy->m_AnalogInput.m_aiSet[j].nReal, uResId,  nCnt++);
				//AfxMessageBox(strTemp);
				CString sAiName = m_ocxAnalogInput[i].GetAnalogUnitName();
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].nOwnerViewNo = CDicsView::viewJobPiping;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].sName = sAiName;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].nOwnerUnitNo = m_ocxAnalogInput[i].GetApdReportUnitNo();
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].uRESID = uResId; //IDC_ANALOGCTRLCTRL1+i;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].sKind = m_ocxAnalogInput[i].GetUnitOfKind( nAddress );
				if( m_ocxAnalogInput[i].GetApdReportSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nApdReportNo = j;//m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo;
					m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nApdReportNo = -1;
				if( m_ocxAnalogInput[i].GetInterlockUsingSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nAiIntrNo = j;//m_pEqpAssy->m_AnalogInput.m_nMaxIntrAiNo;
					m_pEqpAssy->m_AnalogInput.m_nMaxIntrAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nAiIntrNo = -1;
				if( m_ocxAnalogInput[i].GetEdcReportSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nEdcReportNo = m_pEqpAssy->m_AnalogInput.m_nMaxEdcAiNo;
					m_pEqpAssy->m_AnalogInput.m_nMaxEdcAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nEdcReportNo = -1;
				break;
			}
		}
	}
}

void CJobsTabPipingView::SetAiInitParameter()
{
	float fAnalogVal = 0.0f;
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		if( m_pEqpAssy->m_AnalogInput.m_aiSet[i].nOwnerViewNo != CDicsView::viewJobPiping ) continue;

		int nAddress = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nReal;
		int nOcxId = m_pEqpAssy->m_AnalogInput.m_aiSet[i].uRESID;// - IDC_ANALOGCTRLCTRL1;

		if( nOcxId >= 0 )
		{
			fAnalogVal =  m_pEqpAssy->m_AnalogInput.GetRealVal( i );
			m_ocxAnalogInput[nOcxId].SetAnalogCalDisplay( fAnalogVal );
		}
	}
}

void CJobsTabPipingView::SetBitmaps()
{
}

void CJobsTabPipingView::SetColorStatic(CColorStatic &stcObject, BOOL bState, COLORREF color)
{
	if( bState ) 
	{
		stcObject.StartBkBlink( FALSE );
		stcObject.StartTextBlink( FALSE );
		stcObject.SetTextColor( BLACK_COLOR );
		stcObject.SetBkColor( color );
	}
	else
	{
		stcObject.StartBkBlink( FALSE );
		stcObject.StartTextBlink( FALSE );
		stcObject.SetTextColor( BLACK_COLOR );
		stcObject.SetBkColor( WHITE_COLOR );
	}
}

void CJobsTabPipingView::UpdateObjects()
{
//#ifndef _NO_RB
	UpdateRollBrush();
//#endif
#ifndef _NO_EUV
	UpdateEuv();
	UpdateEuvFlowSensor();
#endif
//	UpdateAk();
	UpdateIonizer();
	UpdateSensor();
	UpdateAI();
	UpdateValve();
	UpdateSBJ();
	UpdateAqk();
	UpdateShower();
	UpdateDiwPump();
	UpdateDiwTank();
//	UpdateIntegralFlow();
//	UpdatePower();
}

void CJobsTabPipingView::UpdateRollBrush()
{
	// 0: stop, 1: fw, 2: bw
	static int nOldRBStatus[MAX_PVIEW1_RB_NO] ={ 0, };
	BOOL bA, bB, bC, bD;
	bA = bB = bC = bD = FALSE;
	for( int i = 0; i < m_pEqpAssy->m_RbMotor.GetMaxSectionNo(); i ++ )
	{	
		bA = m_pEqpAssy->m_RbMotor.GetMotorFwState( i );
		bB = m_pEqpAssy->m_RbMotor.GetMotorBwState( i );
#ifndef _MY_DEBUG
		bC = m_pEqpAssy->m_RbMotor.GetMotorAlarm( i );
		bD = m_pEqpAssy->m_RbMotor.GetMotorCpAlarm( i );
#else
		bC = FALSE;
		bD = FALSE;
#endif
		if( ( bC || bD || (!bA && !bB) ) && ( nOldRBStatus[i] != 0 ) )
		{
			nOldRBStatus[i] = 0;
			m_ocxRollBrush[i].SetStop();
		}
		else if( !bC && !bD && bA && !bB && ( nOldRBStatus[i] != 1 ) )
		{
			nOldRBStatus[i] = 1;
			if( i%2==0 )		m_ocxRollBrush[i].SetCCW();
			else				m_ocxRollBrush[i].SetCW();
			m_ocxRollBrush[i].SetRun();
		}
		else if( !bC && !bD && !bA && bB && ( nOldRBStatus[i] != 2 ))
		{
			nOldRBStatus[i] = 2;
			if( i%2==0 )		m_ocxRollBrush[i].SetCW();
			else				m_ocxRollBrush[i].SetCCW();
			m_ocxRollBrush[i].SetRun();
		}
	}
}

void CJobsTabPipingView::UpdateAk()
{
	static BOOL bOldState[2] = { FALSE, };
	BOOL bState = FALSE;
	for( int i=0; i<2; i++ )
	{
		if( i== 0 ) bState = m_pEqpAssy->m_AutoValveAkUp.GetState();
		else bState = m_pEqpAssy->m_AutoValveAkLo.GetState();
		if( bState && !bOldState[i] )
		{
			bOldState[i] = TRUE; 
			m_ocxAK[i].SetRun();
		}
		else if( !bState  && bOldState[i] )
		{
			bOldState[i] = FALSE; 
			m_ocxAK[i].SetStop();
		}
	}
}

void CJobsTabPipingView::UpdateIonizer()
{
	static BOOL bRunStatus[MAX_PVIEW1_ION_NO] = { FALSE, };
	BOOL bAlarmState[MAX_PVIEW1_ION_NO] = { FALSE, };
	
	for( int nIonizerNo=0; nIonizerNo<MAX_PVIEW1_ION_NO; nIonizerNo++ )
	{
		for( int nAlarmNo=0; nAlarmNo<MAX_IONIZER_ALM_NO; nAlarmNo++ )
		{
			bAlarmState[nIonizerNo] |= m_pEqpAssy->m_SignalIonizer.Get( nIonizerNo*MAX_IONIZER_ALM_NO + nAlarmNo );
		}

		if( bAlarmState[nIonizerNo] && !bRunStatus[nIonizerNo] )
		{
			bRunStatus[nIonizerNo] = TRUE;
			m_ocxIonizer[nIonizerNo].SetAlarm();
		}
		else if( !bAlarmState[nIonizerNo] && bRunStatus[nIonizerNo] )
		{
			bRunStatus[nIonizerNo] = FALSE;
			m_ocxIonizer[nIonizerNo].SetStart();
		}
		else if( !bAlarmState[nIonizerNo] && !bRunStatus[nIonizerNo] )
		{
			bRunStatus[nIonizerNo] = TRUE;
			m_ocxIonizer[nIonizerNo].SetStart();
		}
	}	
}

void CJobsTabPipingView::UpdateSensor()
{
	static BOOL bTankLevelStatus[MAX_PVIEW1_TANK_NO][MAX_DI_TANK_LEVEL_NO] = { FALSE, };

	for( int nTankNo=0; nTankNo<MAX_PVIEW1_TANK_NO; nTankNo++ )
	{
		for( int nSensorNo=0; nSensorNo<MAX_DI_TANK_LEVEL_NO; nSensorNo++ )
		{
			if( !bTankLevelStatus[nTankNo][nSensorNo] && m_pEqpAssy->m_DiTank[nTankNo].GetTankLevel( nSensorNo ) )
			{
				bTankLevelStatus[nTankNo][nSensorNo] = TRUE;
				if( nSensorNo == CPumpSeq::lvHH ) SetColorStatic( m_stcTankHH[nTankNo], ON, RED_COLOR );
				else if( nSensorNo == CPumpSeq::lvH ) SetColorStatic( m_stcTankH[nTankNo], ON, GREEN_COLOR );
				else if( nSensorNo == CPumpSeq::lvM ) SetColorStatic( m_stcTankL[nTankNo], ON, GREEN_COLOR );
				else if( nSensorNo == CPumpSeq::lvL ) SetColorStatic( m_stcTankLL[nTankNo], ON, GREEN_COLOR );
			}
			else if( bTankLevelStatus[nTankNo][nSensorNo] && !m_pEqpAssy->m_DiTank[nTankNo].GetTankLevel( nSensorNo ) )
			{
				bTankLevelStatus[nTankNo][nSensorNo] = FALSE;
				if( nSensorNo == CPumpSeq::lvHH ) SetColorStatic( m_stcTankHH[nTankNo], OFF, RED_COLOR );
				else if( nSensorNo == CPumpSeq::lvH ) SetColorStatic( m_stcTankH[nTankNo], OFF, GREEN_COLOR );
				else if( nSensorNo == CPumpSeq::lvM ) SetColorStatic( m_stcTankL[nTankNo], OFF, GREEN_COLOR );
				else if( nSensorNo == CPumpSeq::lvL ) SetColorStatic( m_stcTankLL[nTankNo], OFF, GREEN_COLOR );
			}
		}	
	}
}

void CJobsTabPipingView::UpdateAI()
{
	float fAnalogVal = 0.0f;
	int nCurAdcVal = 0;

	for( int i=0;i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		if( m_pEqpAssy->m_AnalogInput.m_aiSet[i].nOwnerViewNo != CDicsView::viewJobPiping ) continue;
		int nAddress = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nReal;
		int nOcxId = m_pEqpAssy->m_AnalogInput.m_aiSet[i].uRESID;// - IDC_ANALOGCTRLCTRL1;
		if( nOcxId >= 0 )
		{
			m_pDevice->m_pFilterGain[nAddress]  = m_ocxAnalogInput[nOcxId].GetFilterGain();
			m_pDevice->m_aiInfo[nAddress].nScale   = m_ocxAnalogInput[nOcxId].GetCalScale();
			m_pDevice->m_aiInfo[nAddress].nAdcMin  = m_ocxAnalogInput[nOcxId].GetAdcMinVal();
			m_pDevice->m_aiInfo[nAddress].nAdcMax  = m_ocxAnalogInput[nOcxId].GetAdcMaxVal();
			m_pDevice->m_aiInfo[nAddress].fRealMin = m_ocxAnalogInput[nOcxId].GetRealMinVal();
			m_pDevice->m_aiInfo[nAddress].fRealMax = m_ocxAnalogInput[nOcxId].GetRealMaxVal();

			fAnalogVal =  m_pEqpAssy->m_AnalogInput.GetRealVal( i );
			nCurAdcVal = m_pEqpAssy->m_AnalogInput.GetAdcVal( i );
			m_ocxAnalogInput[nOcxId].SetCurAdcVal( nCurAdcVal );
			m_ocxAnalogInput[nOcxId].SetAnalogCalDisplay( fAnalogVal );
		}
	}
}

void CJobsTabPipingView::UpdateValve()
{
	static BOOL bOldValveStateView3[MAX_PVIEW1_VALVE_NO] = { FALSE, };

	//for( int i = 0 ; i < m_pEqpAssy->m_AutoValvePiping.GetDoSize(); i ++ )
	for( int i = 0 ; i < MAX_PVIEW1_VALVE_NO; i ++ )
	{
		if( !bOldValveStateView3[i] && m_pEqpAssy->m_AutoValvePiping.GetState( i ) )	//  ʿ.
		{
			bOldValveStateView3[i] = TRUE;
			OnValveStatusChanged( TRUE, i );
		}
		else if( bOldValveStateView3[i] && !m_pEqpAssy->m_AutoValvePiping.GetState( i ) )
		{
			bOldValveStateView3[i] = FALSE;
			OnValveStatusChanged( FALSE, i );
		}
	}
}

void CJobsTabPipingView::UpdateSBJ()
{
		   BOOL bUpdate = FALSE;
	static BOOL	bCDA    = FALSE;
	static BOOL	bDI     = FALSE;
	static BOOL	bCDA1   = FALSE;
	static BOOL	bDI1    = FALSE;

	if( m_pEqpAssy->m_AutoValveSbjDi.GetState() && !bDI && !bDI1 ) 
		{bDI=TRUE; bDI1=TRUE; bUpdate=TRUE;}
	else if( !m_pEqpAssy->m_AutoValveSbjDi.GetState() && bDI && bDI1 )
		{bDI=FALSE;bDI1=FALSE; bUpdate=TRUE;}

	if( m_pEqpAssy->m_AutoValveSbjCda.GetState( 0 ) && !bCDA && !bCDA1 ) 
		{bCDA=TRUE; bCDA1=TRUE; bUpdate=TRUE;}
	else if( !m_pEqpAssy->m_AutoValveSbjCda.GetState( 0 ) && bCDA && bCDA1 ) 
		{bCDA=FALSE; bCDA1=FALSE; bUpdate=TRUE;}

	if( bUpdate )
	{
		m_ocxSbjUnit[0].SetSbjState( bDI, bCDA );
		m_ocxSbjUnit[1].SetSbjState( bDI1, bCDA1 );
	}

	/*
	static BOOL bOldStateDi	= FALSE;
	static BOOL bOldStateCda = FALSE;
	int i=0;

	BOOL bDiOnCond = TRUE;
	BOOL bCdaOnCond = TRUE;
	BOOL bUpdate = FALSE;

	bCdaOnCond = m_pEqpAssy->m_AutoValveSbjCda.GetState(0);
	
	if( bDiOnCond && !bOldStateDi )
	{
		bOldStateDi = TRUE;
		bUpdate = TRUE;
	}
	else if( !bDiOnCond && bOldStateDi )
	{
		bOldStateDi = FALSE;
		bUpdate = TRUE;
	}

	if( bCdaOnCond && !bOldStateCda )
	{
		bOldStateCda = TRUE;
		bUpdate = TRUE;
	}
	else if( !bCdaOnCond && bOldStateCda )
	{
		bOldStateCda = FALSE;
		bUpdate = TRUE;
	}
	
	if( bUpdate )
	{
		m_ocxSbjUnit[0].SetSbjState( bOldStateDi, bOldStateCda );
		m_ocxSbjUnit[1].SetSbjState( bOldStateDi, bOldStateCda );
	}
	*/
}

void CJobsTabPipingView::UpdateAqk()
{
	static BOOL	bOldState = FALSE;
	BOOL bAqkOnCond = TRUE;

	bAqkOnCond = m_pEqpAssy->m_AutoValveSbjDi.GetState(0);	// 

	if( bAqkOnCond && !bOldState )
	{
		bOldState = TRUE;
		m_ocxAqkUnit[0].SetRun();
	}
	else if( !bAqkOnCond && bOldState )
	{
		bOldState = FALSE;
		m_ocxAqkUnit[0].SetStop();
	}
}

void CJobsTabPipingView::UpdateShower()
{
	static BOOL bOldState[3] = { FALSE, FALSE, FALSE };
	BOOL bShowerOnCond[3] = { TRUE, TRUE, TRUE };

	bShowerOnCond[0] &= m_pEqpAssy->m_AutoValveSbjDi.GetState( 0 );

	if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] )
	{
#ifndef _MY_DEBUG
		bShowerOnCond[1] &= m_pEqpAssy->m_DiTank[0].GetPumpOn( 0 );
#endif
		bShowerOnCond[1] &= m_pEqpAssy->m_DiTank[0].GetPumpOnState( 0 );
		bShowerOnCond[1] &= !m_pEqpAssy->m_DiTank[0].GetPumpAlarm( 0 );
	}
	else
	{
		bShowerOnCond[1] &= m_pEqpAssy->m_AutoValveDirect.GetState( 0 );
	}	
	
	if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE] )
	{
#ifndef _MY_DEBUG
		bShowerOnCond[2] &= m_pEqpAssy->m_DiTank[1].GetPumpOn( 0 );
#endif
		bShowerOnCond[2] &= m_pEqpAssy->m_DiTank[1].GetPumpOnState( 0 );
		bShowerOnCond[2] &= !m_pEqpAssy->m_DiTank[1].GetPumpAlarm( 0 );
	}
	else
	{
		bShowerOnCond[2] &= m_pEqpAssy->m_AutoValveDirect.GetState( 1 );
	}


	if( bShowerOnCond[0] && !bOldState[0] )
	{
		bOldState[0] = TRUE;

		m_ocxSWR1ShwUnitUp[0].SetRun();
		m_ocxSWR1ShwUnitUp[1].SetRun();
		m_ocxSWR1ShwUnitUp[2].SetRun();
		m_ocxSWR1ShwUnitUp[3].SetRun();

		m_ocxSWR1ShwUnitLo[0].SetRun();
 		m_ocxSWR1ShwUnitLo[1].SetRun();
	}
	else if( !bShowerOnCond[0] && bOldState[0] )
	{
		bOldState[0] = FALSE;

		m_ocxSWR1ShwUnitUp[0].SetStop();
		m_ocxSWR1ShwUnitUp[1].SetStop();
		m_ocxSWR1ShwUnitUp[2].SetStop();
		m_ocxSWR1ShwUnitUp[3].SetStop();
		
		m_ocxSWR1ShwUnitLo[0].SetStop();
 		m_ocxSWR1ShwUnitLo[1].SetStop();
	}

	if( bShowerOnCond[1] && !bOldState[1] )
	{
		bOldState[1] = TRUE;
		
		m_ocxSWR2ShwUnitUp[0].SetRun();
		m_ocxSWR2ShwUnitUp[1].SetRun();
		m_ocxSWR2ShwUnitUp[2].SetRun();
		m_ocxSWR2ShwUnitUp[3].SetRun();
		m_ocxSWR2ShwUnitUp[4].SetRun();
		m_ocxSWR2ShwUnitUp[5].SetRun();

		m_ocxSWR2ShwUnitLo[0].SetRun();
		m_ocxSWR2ShwUnitLo[1].SetRun();
		m_ocxSWR2ShwUnitLo[2].SetRun();
		m_ocxSWR2ShwUnitLo[3].SetRun();
		m_ocxSWR2ShwUnitLo[4].SetRun();
		m_ocxSWR2ShwUnitLo[5].SetRun();
	}
	else if( !bShowerOnCond[1] && bOldState[1] )
	{
		bOldState[1] = FALSE;

		m_ocxSWR2ShwUnitUp[0].SetStop();
		m_ocxSWR2ShwUnitUp[1].SetStop();
		m_ocxSWR2ShwUnitUp[2].SetStop();
		m_ocxSWR2ShwUnitUp[3].SetStop();
		m_ocxSWR2ShwUnitUp[4].SetStop();
		m_ocxSWR2ShwUnitUp[5].SetStop();

		m_ocxSWR2ShwUnitLo[0].SetStop();
		m_ocxSWR2ShwUnitLo[1].SetStop();
		m_ocxSWR2ShwUnitLo[2].SetStop();
		m_ocxSWR2ShwUnitLo[3].SetStop();
		m_ocxSWR2ShwUnitLo[4].SetStop();
		m_ocxSWR2ShwUnitLo[5].SetStop();
	}

	if( bShowerOnCond[2] && !bOldState[2] )
	{
		bOldState[2] = TRUE;

		m_ocxSWR3ShwUnitUp[0].SetRun();
		m_ocxSWR3ShwUnitUp[1].SetRun();
		m_ocxSWR3ShwUnitUp[2].SetRun();
		m_ocxSWR3ShwUnitUp[3].SetRun();
		m_ocxSWR3ShwUnitUp[4].SetRun();
		m_ocxSWR3ShwUnitUp[5].SetRun();
				
		m_ocxSWR3ShwUnitLo[0].SetRun();
		m_ocxSWR3ShwUnitLo[1].SetRun();
		m_ocxSWR3ShwUnitLo[2].SetRun();
		m_ocxSWR3ShwUnitLo[3].SetRun();
		m_ocxSWR3ShwUnitLo[4].SetRun();
		m_ocxSWR3ShwUnitLo[5].SetRun();	
	}
	else if( !bShowerOnCond[2] && bOldState[2] )
	{
		bOldState[2] = FALSE;
	
		m_ocxSWR3ShwUnitUp[0].SetStop();
		m_ocxSWR3ShwUnitUp[1].SetStop();
		m_ocxSWR3ShwUnitUp[2].SetStop();
		m_ocxSWR3ShwUnitUp[3].SetStop();
		m_ocxSWR3ShwUnitUp[4].SetStop();
		m_ocxSWR3ShwUnitUp[5].SetStop();
		
		m_ocxSWR3ShwUnitLo[0].SetStop();
		m_ocxSWR3ShwUnitLo[1].SetStop();
		m_ocxSWR3ShwUnitLo[2].SetStop();
		m_ocxSWR3ShwUnitLo[3].SetStop();
		m_ocxSWR3ShwUnitLo[4].SetStop();
		m_ocxSWR3ShwUnitLo[5].SetStop();
	}
}

void CJobsTabPipingView::UpdateDiwPump()
{
	static int nJob3Pump[MAX_PVIEW1_PUMP_NO] = { -1, };

	for( int i=0; i<MAX_PVIEW1_PUMP_NO; i++ )
	{
		BOOL bPumpOn = TRUE;
		bPumpOn &= m_pEqpAssy->m_DiTank[i].GetPumpOnState();
#ifndef _MY_DEBUG
		bPumpOn &= m_pEqpAssy->m_DiTank[i].GetPumpOn();
#endif
		BOOL bPumpAlarm = m_pEqpAssy->m_DiTank[i].GetPumpAlarm();
		if( bPumpOn && !bPumpAlarm && nJob3Pump[i] != 0 )
		{
			nJob3Pump[i] = 0;
			m_ocxPump[i].SetStart();
		}
		else if( !bPumpOn && !bPumpAlarm && nJob3Pump[i] != 1 )
		{
			nJob3Pump[i] = 1;
			m_ocxPump[i].SetStop();
		}
		else if( bPumpAlarm && nJob3Pump[i] != 2 )
		{
			nJob3Pump[i] = 2;
			m_ocxPump[i].SetAlarm();
		}
	}
}

void CJobsTabPipingView::UpdateDiwTank()
{
	float fVal[MAX_PVIEW1_TANK_NO] = { 0, };

	CPumpSeq* pPumpSeq = ( ((CDicsView*)m_pView)->m_pPumpSeq );
	for( int i=0; i<MAX_PVIEW1_TANK_NO; i++ )
	{
		if( pPumpSeq->m_SeqFlag.bDiTankLevel[i][CPumpSeq::lvHH] )		fVal[i] = (float)PVIEW1_TANK_LEVEL_HH( i );
		else if( pPumpSeq->m_SeqFlag.bDiTankLevel[i][CPumpSeq::lvH] )	fVal[i] = (float)PVIEW1_TANK_LEVEL_H( i );
		else if( pPumpSeq->m_SeqFlag.bDiTankLevel[i][CPumpSeq::lvM] )	fVal[i] = (float)PVIEW1_TANK_LEVEL_M( i );
		else if( pPumpSeq->m_SeqFlag.bDiTankLevel[i][CPumpSeq::lvL] )	fVal[i] = (float)PVIEW1_TANK_LEVEL_L( i );
		
		OnTankStatusChanged( i, (LPARAM)fVal[i] );
	}
}

void CJobsTabPipingView::UpdatePower()
{
	static float fOldPowerInstant = 0.;
	static float fOldPowerTotal = 0.;
	
	float fCurPowerInstant = ((CDicsView*)m_pView)->m_pXkm100->m_fCurrentPower;
	float fCurPowerTotal = ((CDicsView*)m_pView)->m_pXkm100->m_fTotalPower;
	
	CString sMsg = _T("");
	
	if( fCurPowerInstant != fOldPowerInstant  ) 
	{
		sMsg.Format( "%.2f", fCurPowerInstant );
		m_msgInstancePower.SetOpMsg( sMsg );
		fOldPowerInstant = fCurPowerInstant;
	}
	
	if( fCurPowerTotal != fOldPowerTotal  )
	{
		sMsg.Format( "%.1f", fCurPowerTotal );
		m_msgTotalPower.SetOpMsg( sMsg );
		fOldPowerTotal = fCurPowerTotal;
	}
}

LRESULT CJobsTabPipingView::OnValveStatusChanged( WPARAM wParam, LPARAM lParam )
{
	if( !m_bInitialUpdateComp ) return 0;

	BOOL bState = (BOOL) wParam;
	int nValve = (int) lParam;

	if( bState ) m_ocxAutoValve[nValve].SetValveOn();
	else m_ocxAutoValve[nValve].SetValveOff();
	return 0;
}

LRESULT CJobsTabPipingView::OnMsgBoxClicked( WPARAM wParam, LPARAM lParam )
{
	/*(
	if( wParam == IDC_SEBA_FLOW_METER_INSTANT || wParam == IDC_SEBA_FLOW_METER_TOTAL ||
		wParam == IDC_SEBA_FR_FLOW_METER_INSTANT || wParam == IDC_SEBA_FR_FLOW_METER_TOTAL )
		return 0;
	if( wParam == IDC_SEBA_FLOW_METER_RESET ) 
	{
		if( !((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto && 
			((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel >= CDicsData::idENGINEER )
		{
			if( AfxMessageBox( "Do you want to Reset TANK Flow Meter?", MB_YESNO, NULL ) == IDYES )
			{
#ifndef _MY_DEBUG
//				((CDicsView*)m_pView)->m_pFlowCtrl->Reset();
				m_pEqpAssy->m_IntegrateFlowmeter.Set( 0, ON );
				Sleep(300);
				m_pEqpAssy->m_IntegrateFlowmeter.Set( 0, OFF );
#else
				((CDicsView*)m_pView)->m_pFlowCtrl->m_fIntegralFlow = 0.;
#endif
			}
		}
		return 0;
	}

	if( wParam == IDC_SEBA_FR_FLOW_METER_RESET )
	{
		if( !((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto && 
			((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel >= CDicsData::idENGINEER )
		{
			if( AfxMessageBox( "Do you want to Reset FR Flow Meter?", MB_YESNO, NULL ) == IDYES )
			{
#ifndef _MY_DEBUG
//				((CDicsView*)m_pView)->m_pFlowCtrl->Reset();
				m_pEqpAssy->m_IntegrateFlowmeter.Set( 1, ON );
				Sleep(300);
				m_pEqpAssy->m_IntegrateFlowmeter.Set( 1, OFF );
#else
				((CDicsView*)m_pView)->m_pFlowCtrl2->m_fIntegralFlow = 0.;
#endif
			}
		}
		return 0;
	}
	*/
/*
	CDlgCalibration dlg;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP ) dlg.m_bPermitAccess = TRUE;
	else dlg.m_bPermitAccess = FALSE;
	dlg.m_nWhatGroup = CDlgCalibration::grpAI1;
	dlg.SetAI1( ( (CDicsView*) m_pView)->m_pAI1 );
	dlg.SetDevice( ( (CDicsView*) m_pView)->m_pDevice );
	dlg.m_nID = (int) wParam;
	dlg.DoModal();
*/
	return 0;
}

BEGIN_EVENTSINK_MAP(CJobsTabPipingView, CFormView)
    //{{AFX_EVENTSINK_MAP(CJobsTabPipingView)
	ON_EVENT(CJobsTabPipingView, IDC_PUMP1, DISPID_CLICK, OnClickPump1, VTS_NONE)
	ON_EVENT(CJobsTabPipingView, IDC_PUMP2, DISPID_CLICK, CJobsTabPipingView::ClickPump2, VTS_NONE)
	ON_EVENT(CJobsTabPipingView, IDC_SWR2_RB1_UP_PIPING, DISPID_CLICK, OnClickRb, VTS_NONE)
	ON_EVENT(CJobsTabPipingView, IDC_SWR2_RB1_LO_PIPING, DISPID_CLICK, OnClickRb, VTS_NONE)
	ON_EVENT(CJobsTabPipingView, IDC_SWR2_RB2_UP_PIPING, DISPID_CLICK, OnClickRb, VTS_NONE)
	ON_EVENT(CJobsTabPipingView, IDC_SWR2_RB2_LO_PIPING, DISPID_CLICK, OnClickRb, VTS_NONE)
	ON_EVENT(CJobsTabPipingView, IDC_SWR3_RB1_UP_PIPING, DISPID_CLICK, OnClickRb, VTS_NONE)
	ON_EVENT(CJobsTabPipingView, IDC_SWR3_RB1_LO_PIPING, DISPID_CLICK, OnClickRb, VTS_NONE)
	ON_EVENT(CJobsTabPipingView, IDC_SWR3_RB2_UP_PIPING, DISPID_CLICK, OnClickRb, VTS_NONE)
	ON_EVENT(CJobsTabPipingView, IDC_SWR3_RB2_LO_PIPING, DISPID_CLICK, OnClickRb, VTS_NONE)
	ON_EVENT_RANGE(CJobsTabPipingView, IDC_AUTOVALVECTRL1, IDC_AUTOVALVECTRL10/*130812 halesu*/, DISPID_CLICK, OnClickAutoValve, VTS_I2)
#ifdef _MOTOR_LOAD_FACTOR
	ON_EVENT_RANGE(CJobsTabPipingView, IDC_NEW_ANALOGCTRLCTRL1, IDC_NEW_ANALOGCTRLCTRL31, DISPID_CLICK, OnClickAnalogInput, VTS_I2)
#else
	ON_EVENT_RANGE(CJobsTabPipingView, IDC_ANALOGCTRLCTRL4, IDC_ANALOGCTRLCTRL40, DISPID_CLICK, OnClickAnalogInput, VTS_I2)
#endif
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CJobsTabPipingView::OnClickAnalogInput( UINT nID )
{
#ifdef _MOTOR_LOAD_FACTOR
	int nOcxId = nID - IDC_NEW_ANALOGCTRLCTRL1;
#else
	int nOcxId = nID - IDC_ANALOGCTRLCTRL4;
#endif
	int nAddress = m_ocxAnalogInput[nOcxId].GetAiRealID();
	m_pDevice->m_pFilterGain[nAddress]  = m_ocxAnalogInput[nOcxId].GetFilterGain();
	m_pDevice->m_aiInfo[nAddress].nScale   = m_ocxAnalogInput[nOcxId].GetCalScale();
	m_pDevice->m_aiInfo[nAddress].nAdcMin  = m_ocxAnalogInput[nOcxId].GetAdcMinVal();
	m_pDevice->m_aiInfo[nAddress].nAdcMax  = m_ocxAnalogInput[nOcxId].GetAdcMaxVal();
	m_pDevice->m_aiInfo[nAddress].fRealMin = m_ocxAnalogInput[nOcxId].GetRealMinVal();
	m_pDevice->m_aiInfo[nAddress].fRealMax = m_ocxAnalogInput[nOcxId].GetRealMaxVal();

	m_pDevice->m_aiInfo[nAddress].nLoLimit = m_ocxAnalogInput[nOcxId].GetLowLimitValue();
	m_pDevice->m_aiInfo[nAddress].nUpLimit = m_ocxAnalogInput[nOcxId].GetUpLimitValue();
	m_pDevice->m_aiInfo[nAddress].nLoWarning = m_ocxAnalogInput[nOcxId].GetLoWaringValue();
	m_pDevice->m_aiInfo[nAddress].nUpWarning = m_ocxAnalogInput[nOcxId].GetUpWarningValue();

	float fVal = m_ocxAnalogInput[nOcxId].GetCalculation();
}

void CJobsTabPipingView::OnClickEuv() 
{
	//kjd---------------------------------
	CDicsApp* pApp = ( CDicsApp* )AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* )pApp->m_pMainWnd;
//	if( pMainFrame->m_bAuto ) return;
//	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;
	//kjd---------------------------------
#ifndef _NO_EUV
	( (CDicsView*)m_pView )->m_tabCtrl.SelectTab(CDicsView::viewJobEuv);
	( (CDicsView*)m_pView )->SendMessage(WM_SEL_CHANGE_TAB, CDicsView::viewJobEuv);
#endif
}

void CJobsTabPipingView::OnClickRb() 
{
	if ( ((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto ) return;

	CDlgGridRollBrush dlg;
	dlg.SetDevice( ((CDicsView*)m_pView)->m_pDevice );
//	dlg.SetData( ((CDicsView*)m_pView)->m_pDicsData );
//	dlg.SetMmc( ((CDicsView*)m_pView)->m_pMmc );
	dlg.SetEqpAssy( m_pEqpAssy );
	dlg.SetRbSeq( ((CDicsView*)m_pView)->m_pRbSeq );
	dlg.m_nMotorEA		= MAX_PVIEW1_RB_NO;
	dlg.m_sMotorName	= "SWR2 RB1 UP;SWR2 RB1 LO;SWR2 RB2 UP;SWR2 RB2 LO;SWR3 RB1 UP;SWR3 RB1 LO;SWR3 RB2 UP;SWR3 RB2 LO;";
	dlg.SetSpeedRange( 100, 400, 100 );
	dlg.DoModal();
}

void CJobsTabPipingView::OnClickPump1()
{
	// TODO: Add your control notification handler code here
	CDicsApp* pApp = ( CDicsApp* )AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* )pApp->m_pMainWnd;
	if( pMainFrame->m_bAuto ) return;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;
	CDlgPumpCln dlg;
	dlg.SetDevice( ( (CDicsView*)m_pView )->m_pDevice );
	dlg.SetTankAssy( &m_pEqpAssy->m_DiTank[0] );
	dlg.m_nCurSelPump1 = 0;
	dlg.DoModal();		
}

void CJobsTabPipingView::ClickPump2()
{
	CDicsApp* pApp = ( CDicsApp* )AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* )pApp->m_pMainWnd;
	if( pMainFrame->m_bAuto ) return;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;
	CDlgPumpCln dlg;
	dlg.SetDevice( ( (CDicsView*)m_pView )->m_pDevice );
	dlg.SetTankAssy( &m_pEqpAssy->m_DiTank[1] );
	dlg.m_nCurSelPump1 = 0;
	dlg.DoModal();
}

void CJobsTabPipingView::OnClickAutoValve( UINT nID )
{
	CDicsApp* pApp = ( CDicsApp* ) AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* ) pApp->m_pMainWnd;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto ) return;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;

	CDlgValve dlg;

	// ljy_041104 : AUO User request
	if( (((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP) && !pMainFrame->m_bAuto ) dlg.m_bPermitAccess = TRUE;
	else dlg.m_bPermitAccess = FALSE;
	
	int nAutoValveKeyCount = m_pEqpAssy->m_AutoValvePiping.GetDoSize();
/*
	if( nID == IDC_AUTOVALVECTRL10 ) dlg.m_nValveNo = 9;
	else dlg.m_nValveNo = nID - IDC_AUTOVALVECTRL1;
*/
	dlg.m_nValveNo = nID - IDC_AUTOVALVECTRL1;
	if( nAutoValveKeyCount <= dlg.m_nValveNo ) return;

	dlg.m_nWhatGroup = CDlgValve::vgJOB3;
	dlg.SetDevice( ( (CDicsView*)m_pView )->m_pDevice );
	dlg.SetEqpAssy(( (CDicsView*)m_pView )->m_pEqpAssy );
	dlg.DoModal();	
}

LRESULT CJobsTabPipingView::OnPumpStatusChanged( WPARAM wParam, LPARAM lParam )
{
	switch( wParam )
	{
	case 0 :
		m_ocxPump[lParam].SetStart();
		break;
	case 1 :
		m_ocxPump[lParam].SetStop();
		break;
	case 2 :
		m_ocxPump[lParam].SetAlarm();
		break;
	}
	return 0;
}

LRESULT CJobsTabPipingView::OnTankStatusChanged( WPARAM wParam, LPARAM lParam )
{
	int nTankNo = (int) wParam;
	float fTankLevel = (float) lParam;

	LPCTSTR sMsg;
	COLORREF color;

	if( fTankLevel >= PVIEW1_TANK_LEVEL_HH( nTankNo ) )
	{
		sMsg = "TOP";
		color = RED_COLOR;
		m_progTank[nTankNo].SetForeColour( color );
		m_progTank[nTankNo].SetWindowText( sMsg );
		m_progTank[nTankNo].SetPos( (int)fTankLevel );
	}
	else if( fTankLevel < PVIEW1_TANK_LEVEL_HH( nTankNo ) && fTankLevel >= PVIEW1_TANK_LEVEL_H( nTankNo ) )
	{
		sMsg = "HIGH";
		color = LIGHT_CYAN_COLOR;
		m_progTank[nTankNo].SetForeColour( color );
		m_progTank[nTankNo].SetWindowText( sMsg );
		m_progTank[nTankNo].SetPos( (int)fTankLevel );
	}
	else if( fTankLevel < PVIEW1_TANK_LEVEL_H( nTankNo ) && fTankLevel >= PVIEW1_TANK_LEVEL_M( nTankNo ) )
	{
		sMsg = "MIDDLE";
		color = LIGHT_ORANGE_COLOR;
		m_progTank[nTankNo].SetForeColour( color );
		m_progTank[nTankNo].SetWindowText( sMsg );
		m_progTank[nTankNo].SetPos( (int)fTankLevel );
	}
	else if( fTankLevel < PVIEW1_TANK_LEVEL_M( nTankNo ) && fTankLevel >= PVIEW1_TANK_LEVEL_L( nTankNo ) )
	{
		sMsg = "LOW";
		color = ORANGE_COLOR;
		m_progTank[nTankNo].SetForeColour( color );
		m_progTank[nTankNo].SetWindowText( sMsg );
		m_progTank[nTankNo].SetPos( (int)fTankLevel );
	}
	else if( fTankLevel < PVIEW1_TANK_LEVEL_L( nTankNo ) )
	{
		sMsg = "BOTTOM";
		color = RED_COLOR;
		m_progTank[nTankNo].SetForeColour( color );
		m_progTank[nTankNo].SetWindowText( sMsg );
		m_progTank[nTankNo].SetPos( (int)fTankLevel );
	}
	return 0;
}

//--------------------------------------------------------------------
// OnTankLevelStatusChanged
//--------------------------------------------------------------------
//void CJobsTabPipingView::OnTankHHStatusChanged( WPARAM wParam, LPARAM lParam )
//{
//	SetColorStatic( m_stcTankHH[lParam], (BOOL)wParam, RED_COLOR );
//}

//--------------------------------------------------------------------
// OnTankLevelStatusChanged
//--------------------------------------------------------------------
//void CJobsTabPipingView::OnTankHStatusChanged( WPARAM wParam, LPARAM lParam )
//{
//	SetColorStatic( m_stcTankH[lParam], (BOOL)wParam, GREEN_COLOR );
//}

//--------------------------------------------------------------------
// OnTankLevelStatusChanged
//--------------------------------------------------------------------
//void CJobsTabPipingView::OnTankM2StatusChanged( WPARAM wParam, LPARAM lParam )
//{
////	SetColorStatic( m_stcTankM2[lParam], (BOOL)wParam, GREEN_COLOR );
//}

//--------------------------------------------------------------------
// OnTankLevelStatusChanged
//--------------------------------------------------------------------
//void CJobsTabPipingView::OnTankM1StatusChanged( WPARAM wParam, LPARAM lParam )
//{
//	SetColorStatic( m_stcTankM1[lParam], (BOOL)wParam, GREEN_COLOR );
//}

//--------------------------------------------------------------------
// OnTankLevelStatusChanged
//--------------------------------------------------------------------
//void CJobsTabPipingView::OnTankLStatusChanged( WPARAM wParam, LPARAM lParam )
//{
//	SetColorStatic( m_stcTankL[lParam], (BOOL)wParam, GREEN_COLOR );
//}

//--------------------------------------------------------------------
// OnTankLevelStatusChanged
//--------------------------------------------------------------------
//void CJobsTabPipingView::OnTankLLStatusChanged( WPARAM wParam, LPARAM lParam )
//{
//	SetColorStatic( m_stcTankLL[lParam], (BOOL)wParam, GREEN_COLOR );
//}

void CJobsTabPipingView::UpdateEuv()
{
#ifdef _NO_EUV
	return;
#endif

	// status : noUse, alarm, Lamp on, Lamp Off
	static int nStatus = 0;

//////////////////////////////////////////////////////////////////////////
// Euv Usage
	BOOL bUse = ( (CDicsView*)m_pView )->m_pEuvSeq->IsEuvUse();
	if( !bUse && nStatus != 1 )
	{
		m_ocxEuv.SetLampNoUse();
		nStatus = 1;
	}
	else if( bUse && nStatus == 1 )
	{
		nStatus = 0;
	}

	if( !bUse ) return;
	
//////////////////////////////////////////////////////////////////////////
// Euv Alarm
	BOOL bAlarm = ( (CDicsView*)m_pView )->m_pEuvSeq->GetEuvAlarm() ? TRUE : FALSE;
	if( bAlarm && nStatus != 2 ) 
	{
		m_ocxEuv.SetLampAlarm();
		nStatus = 2;
	}
	else if( !bAlarm && nStatus == 2 )
	{
		nStatus = 0;
	}

	if( bAlarm ) return;

	
//////////////////////////////////////////////////////////////////////////
// Lamp Selected
	static int nOldSelected[MAX_LAMP_CONTROL_NO] = { 0, };
	int nSelected[MAX_LAMP_CONTROL_NO] = { 0, };

#ifndef _LTYPE
	for( int i=0; i<MAX_LAMP_CONTROL_NO; i++ )
	{
		nSelected[i] = ( (CDicsView*)m_pView )->m_pEuvSeq->GetLampOnSelected( i ) ? 1 : 2;		
		if( nSelected[i] != nOldSelected[i] ) 
		{
			m_ocxEuv.LampSelect( 8-i , nSelected[i] == 1 ? TRUE : FALSE );
			nOldSelected[i] = nSelected[i];
			nStatus = 0;
		}
	}
#else
	for( int i=0; i<MAX_LAMP_CONTROL_NO; i++ )
	{
		nSelected[i] = ( (CDicsView*)m_pView )->m_pEuvSeq->GetLampOnSelected( i ) ? 1 : 2;		
		if( nSelected[i] != nOldSelected[i] ) 
		{
			m_ocxEuv.LampSelect( i+1 , nSelected[i] == 1 ? TRUE : FALSE );
			nOldSelected[i] = nSelected[i];
			nStatus = 0;
		}
	}
#endif

// Lamp On
	BOOL bOn = ( (CDicsView*)m_pView )->m_pEuvSeq->GetLampOnState();
	if( bOn && nStatus != 3 ) 
	{
		m_ocxEuv.SetLampOn();
		nStatus = 3;
	}
	else if( !bOn && nStatus != 4 )
	{
		m_ocxEuv.SetLampOff();
		nStatus = 4;
	}
}
/*
void CJobsTabPipingView::UpdateIntegralFlow()
{
	static float fOldFlowMeterInstant = 0.;
	static float fOldFlowMeterTotal = 0.;
	static float fOldFRFlowInstant	= 0.;		// 20100407 ssm
	static float fOldFRFlowTotal	= 0.;

	float fCurFlowMeterInstant = ((CDicsView*)m_pView)->m_pFlowCtrl->m_fCurFlowrate;
	float fCurFlowMeterTotal = ((CDicsView*)m_pView)->m_pFlowCtrl->m_fIntegralFlow;
	float fCurFRFlowInstant = ((CDicsView*)m_pView)->m_pFlowCtrl2->m_fCurFlowrate;	// 20100407 ssm
	float fCurFRFlowTotal = ((CDicsView*)m_pView)->m_pFlowCtrl2->m_fIntegralFlow;

#ifdef _MY_DEBUG	// 110726 halesu
	fOldFlowMeterTotal = fOldFlowMeterTotal + 0.1f;
	fOldFRFlowTotal	= fOldFRFlowTotal + 0.2f;
	m_pDicsData->fTotalFlowMeter[0]	= fOldFlowMeterTotal;
	m_pDicsData->fTotalFlowMeter[1]	= fOldFRFlowTotal;
#endif

	CString sMsg = _T("");

#ifdef _MY_DEBUG
	static DWORD dwTickStart = GetTickCount();

	if( m_pEqpAssy->m_AutoValveFrShower.GetState() )
	{		
		((CDicsView*)m_pView)->m_pFlowCtrl->m_fCurFlowrate = ((CDicsView*)m_pView)->m_pFlowCtrl->m_fCurFlowrate / 60;
		fCurFlowMeterInstant = ((CDicsView*)m_pView)->m_pFlowCtrl->m_fCurFlowrate;
		((CDicsView*)m_pView)->m_pFlowCtrl2->m_fCurFlowrate = ((CDicsView*)m_pView)->m_pFlowCtrl2->m_fCurFlowrate / 60;
		fCurFlowMeterInstant = ((CDicsView*)m_pView)->m_pFlowCtrl2->m_fCurFlowrate;
	}
	else
	{
		((CDicsView*)m_pView)->m_pFlowCtrl->m_fCurFlowrate = 0.;
		fCurFlowMeterInstant = 0.;
		((CDicsView*)m_pView)->m_pFlowCtrl2->m_fCurFlowrate = 0.;
		fCurFRFlowInstant = 0.;
	}

	if( ( GetTickCount() - dwTickStart ) > 1000 )
	{
		((CDicsView*)m_pView)->m_pFlowCtrl->m_fIntegralFlow = fCurFlowMeterInstant + fOldFlowMeterTotal;
		((CDicsView*)m_pView)->m_pFlowCtrl2->m_fIntegralFlow = fCurFRFlowInstant + fOldFRFlowTotal;
		dwTickStart = GetTickCount();
	}
#endif
	
	if( fCurFlowMeterInstant != fOldFlowMeterInstant )
	{
		sMsg.Format( "%.1f lpm", fCurFlowMeterInstant );
		m_msgFlowMeterInstant.SetOpMsg( sMsg );
		fOldFlowMeterInstant = fCurFlowMeterInstant;
	}

	if( fCurFlowMeterTotal != fOldFlowMeterTotal )
	{
		sMsg.Format( "%.1f L", fCurFlowMeterTotal );
		m_msgFlowMeterTotal.SetOpMsg( sMsg );
		fOldFlowMeterTotal = fCurFlowMeterTotal;
	}

	if( fCurFRFlowInstant != fOldFRFlowInstant )		// 20100407 ssm
	{
		sMsg.Format( "%.1f lpm", fCurFRFlowInstant );
		m_msgFRFlowInstant.SetOpMsg( sMsg );
		fOldFRFlowInstant = fCurFRFlowInstant;
	}

	if( fCurFRFlowTotal != fOldFRFlowTotal )
	{
		sMsg.Format( "%.1f L", fCurFRFlowTotal );
		m_msgFRFlowTotal.SetOpMsg( sMsg );
		fOldFRFlowTotal = fCurFRFlowTotal;
	}
}
*/
void CJobsTabPipingView::UpdateEuvFlowSensor()
{
	static BOOL bFlowAlarmH[MAX_EUV_UTIL_ALARM] = { FALSE, };
	static BOOL bFlowAlarmL[MAX_EUV_UTIL_ALARM] = { FALSE, };
	int nAlarmPos[MAX_EUV_UTIL_ALARM] = { 4, 2, 1};
	for( int i=0; i<MAX_EUV_UTIL_ALARM; i++ )
	{
// 		if( !bFlowAlarmH[i] && digEUV_UNIT_FLOW_LEVEL_HH( i ) )
// 		{
// 			bFlowAlarmH[i] = TRUE;
// 			SetColorStatic( m_stcEuvLevelH[i], TRUE, RED_COLOR );
// 		}
// 		else if( bFlowAlarmH[i] && !digEUV_UNIT_FLOW_LEVEL_HH( i ) )
// 		{
// 			bFlowAlarmH[i] = FALSE;
// 			SetColorStatic( m_stcEuvLevelH[i], FALSE, RED_COLOR );
// 		}
		
		if( !bFlowAlarmL[i] && m_pEqpAssy->m_UshioEuv.GetUtAlarm(nAlarmPos[i]) )
		{
			bFlowAlarmL[i] = TRUE;
			SetColorStatic( m_stcEuvLevelL[i], TRUE, RED_COLOR );
		}
		else if( bFlowAlarmL[i] && !m_pEqpAssy->m_UshioEuv.GetUtAlarm(nAlarmPos[i]) )
		{
			bFlowAlarmL[i] = FALSE;
			SetColorStatic( m_stcEuvLevelL[i], FALSE, WHITE_COLOR );
		}
	}		
}
