// JobsTabPipingView2.cpp :  Դϴ.
//
#include "StdAfx.h"
#include "..\Dics.h"
#include "JobsTabPipingView2.h"
#include "..\MainFrm.h"		// kjd
#include "..\Dlg\DlgValve.h"
#include "..\Dlg\DlgPumpCln.h"
//#include "DlgEuv.h"
#include "..\Dlg\DlgGridRollBrush.h"
#include "..\Dlg\DlgCalibration.h"


// CJobsTabPipingView2

IMPLEMENT_DYNCREATE(CJobsTabPipingView2, CFormView)

CJobsTabPipingView2::CJobsTabPipingView2()
	: CFormView(CJobsTabPipingView2::IDD)
{

}

CJobsTabPipingView2::CJobsTabPipingView2(CView* pView, int nTabNo)
	: CFormView(CJobsTabPipingView2::IDD)
{
	m_nTabNo	= nTabNo; 
	m_pView		= pView;
	m_bInitialUpdateComp = FALSE;
	SetDicsData( ( (CDicsView*)m_pView )->m_pDicsData );
	SetDevice( ((CDicsView*)m_pView)->m_pDevice );
	SetEqpAssy( ((CDicsView*)m_pView)->m_pEqpAssy );
}


CJobsTabPipingView2::~CJobsTabPipingView2()
{
	if( m_ocxAnalogInput ) delete []m_ocxAnalogInput;
}

void CJobsTabPipingView2::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_SWR4_IONIZER1, m_ocxIonizer[0]);
	DDX_Control(pDX, IDC_PROGRESS_TANK2, m_progTank[0] );
	DDX_Control(pDX, IDC_SWR4_SBJUNITCTRL1, m_ocxSbjUnit[0] );
	DDX_Control(pDX, IDC_SWR4_AQKUNITCTRL1, m_ocxAqkUnit[0] );
	DDX_Control(pDX, IDC_AIRKNIFECTRL1, m_ocxAK[0] );
	DDX_Control(pDX, IDC_AIRKNIFECTRL2, m_ocxAK[1] );
	DDX_Control(pDX, IDC_SWR4_UP_SHW1, m_ocxSWR4ShwUnitUp[0] );
	DDX_Control(pDX, IDC_SWR4_UP_SHW2, m_ocxSWR4ShwUnitUp[1] );
	DDX_Control(pDX, IDC_SWR4_UP_SHW3, m_ocxSWR4ShwUnitUp[2] );
	DDX_Control(pDX, IDC_AK_UP_SHW1,   m_ocxSWR4ShwUnitUp[3] );
	DDX_Control(pDX, IDC_SWR4_LO_SHW1, m_ocxSWR4ShwUnitLo[0] );
	DDX_Control(pDX, IDC_SWR4_LO_SHW2, m_ocxSWR4ShwUnitLo[1] );
	DDX_Control(pDX, IDC_SWR4_LO_SHW3, m_ocxSWR4ShwUnitLo[2] );

	DDX_Control(pDX, IDC_AUTOVALVECTRL11, m_ocxAutoValve[0]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL12, m_ocxAutoValve[1]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL13, m_ocxAutoValve[2]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL14, m_ocxAutoValve[3]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL15, m_ocxAutoValve[4]);
	DDX_Control(pDX, IDC_AUTOVALVECTRL16, m_ocxAutoValve[5]);

}

BEGIN_MESSAGE_MAP(CJobsTabPipingView2, CFormView)
	ON_MESSAGE( WM_VALVE_STATUS_CHANGED, OnValveStatusChanged )
	ON_MESSAGE( WM_MSG_BOX_CLICKED, OnMsgBoxClicked )
	ON_MESSAGE( WM_PUMP_STATUS_CHANGED, OnPumpStatusChanged )
	ON_MESSAGE( WM_TANK_STATUS_CHANGED, OnTankStatusChanged )
END_MESSAGE_MAP()


// CJobsTabPipingView2 Դϴ.

#ifdef _DEBUG
void CJobsTabPipingView2::AssertValid() const
{
	CFormView::AssertValid();
}

#ifndef _WIN32_WCE
void CJobsTabPipingView2::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif
#endif //_DEBUG


// CJobsTabPipingView2 ޽ óԴϴ.
BOOL CJobsTabPipingView2::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CJobsTabPipingView2::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	m_pSetupItems = ( (CDicsView*)m_pView )->GetDocument()->m_pSetupItems;

	for( int i=0; i<MAX_PVIEW2_TANK_NO; i ++ )
	{
		m_progTank[i].SetVertical( TRUE );
		m_progTank[i].SetBkColour( BG_COLOR );
		m_progTank[i].SetForeColour( BLUE_COLOR );
		m_progTank[i].SetShowText( TRUE );
		m_progTank[i].SetWindowText( "NORMAL" );

		m_progTank[i].SetRange( 0, (int)PVIEW2_TANK_HEIGHT( i ) );
		m_progTank[i].SetPos( 0 );
	}

	UINT uUnitID[4] = { IDC_SWR4_UNIT, IDC_AK_UNIT, IDC_BUF_UNIT, IDC_OUTCV_UNIT, };	

	for( int i=0; i<4; i++ )
	{
		m_stcUnit[i].SubclassDlgItem( uUnitID[i], this );
		m_stcUnit[i].SetTextColor( BLACK_COLOR );
		m_stcUnit[i].SetBkColor( BG_COLOR );
	}

	UINT uTankHHID[MAX_PVIEW2_TANK_NO]	= { IDC_TANK1_HH, };	
	UINT uTankHID[MAX_PVIEW2_TANK_NO]	= { IDC_TANK1_H, };	
	UINT uTankLID[MAX_PVIEW2_TANK_NO]	= { IDC_TANK1_L, };	
	UINT uTankLLID[MAX_PVIEW2_TANK_NO]	= { IDC_TANK1_LL, };	                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      

	for( int i = 0 ; i < MAX_PVIEW2_TANK_NO ; i ++ )
	{
		m_stcTankHH[i].SubclassDlgItem( uTankHHID[i], this );
		m_stcTankHH[i].SetTextColor( BLACK_COLOR );
		m_stcTankHH[i].SetBkColor( WHITE_COLOR );

		m_stcTankH[i].SubclassDlgItem( uTankHID[i], this );
		m_stcTankH[i].SetTextColor( BLACK_COLOR );
		m_stcTankH[i].SetBkColor( WHITE_COLOR );

		m_stcTankL[i].SubclassDlgItem( uTankLID[i], this );
		m_stcTankL[i].SetTextColor( BLACK_COLOR );
		m_stcTankL[i].SetBkColor( WHITE_COLOR );

		m_stcTankLL[i].SubclassDlgItem( uTankLLID[i], this );
		m_stcTankLL[i].SetTextColor( BLACK_COLOR );
		m_stcTankLL[i].SetBkColor( WHITE_COLOR );
	}

	SetAnalogOcxInitParameter();
	SetAiInitParameter();
	m_pSetupItems->GetRegistryTabInterlockSetView();

	( (CDicsView*) m_pView )->SetSeqInitParameter();
	( (CDicsView*) m_pView )->SetSeqStart();
	m_bInitialUpdateComp = TRUE;
}

void CJobsTabPipingView2::SetAnalogOcxInitParameter()
{
	m_ocxAnalogInput = new CAnalogCtrl[MAX_PVIEW2_AI_NO];
	for( int i = 0 ; i < MAX_PVIEW2_AI_NO; i++ )
	{
#ifdef _MOTOR_LOAD_FACTOR
		m_ocxAnalogInput[i].SubclassDlgItem( IDC_NEW_ANALOGCTRLCTRL32+i, this);
#else
		m_ocxAnalogInput[i].SubclassDlgItem( IDC_ANALOGCTRLCTRL33+i, this);
#endif
		m_ocxAnalogInput[i].SetAlarmEnable();
		int nAddress = m_ocxAnalogInput[i].GetAiRealID();
		m_ocxAnalogInput[i].SetInitParameterSet( nAddress );
		UINT uResId = m_ocxAnalogInput[i].GetAnalogOcxCtlId();
		for( int j = 0; j < m_pEqpAssy->m_AnalogInput.GetAiSize(); j++ )
		{
			if( nAddress == m_pEqpAssy->m_AnalogInput.m_aiSet[j].nReal )
			{
				CString sAiName = m_ocxAnalogInput[i].GetAnalogUnitName();
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].nOwnerViewNo = CDicsView::viewJobPiping2;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].sName = sAiName;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].nOwnerUnitNo = m_ocxAnalogInput[i].GetApdReportUnitNo();
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].uRESID = uResId; //IDC_ANALOGCTRLCTRL1+i;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].sKind = m_ocxAnalogInput[i].GetUnitOfKind( nAddress );
				if( m_ocxAnalogInput[i].GetApdReportSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nApdReportNo = j;//m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo;
					m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nApdReportNo = -1;
				if( m_ocxAnalogInput[i].GetInterlockUsingSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nAiIntrNo = j;//m_pEqpAssy->m_AnalogInput.m_nMaxIntrAiNo;
					m_pEqpAssy->m_AnalogInput.m_nMaxIntrAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nAiIntrNo = -1;
				if( m_ocxAnalogInput[i].GetEdcReportSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nEdcReportNo = m_pEqpAssy->m_AnalogInput.m_nMaxEdcAiNo;
					m_pEqpAssy->m_AnalogInput.m_nMaxEdcAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nEdcReportNo = -1;
				break;
			}
		}
	}
}

void CJobsTabPipingView2::SetAiInitParameter()
{
	float fAnalogVal = 0.0f;
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	//for( int i=0; i<MAX_PVIEW2_AI_NO; i++ )
	{
		if( m_pEqpAssy->m_AnalogInput.m_aiSet[i].nOwnerViewNo != CDicsView::viewJobPiping2 ) continue;

		int nAddress = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nReal;
		int nOcxId = m_pEqpAssy->m_AnalogInput.m_aiSet[i].uRESID - MAX_PVIEW1_AI_NO;
		if( nOcxId >= 0 )
		{
			fAnalogVal =  m_pEqpAssy->m_AnalogInput.GetRealVal( i );
			m_ocxAnalogInput[nOcxId].SetAnalogCalDisplay( fAnalogVal );
		}
	}
}

void CJobsTabPipingView2::SetBitmaps()
{
}

void CJobsTabPipingView2::SetColorStatic(CColorStatic &stcObject, BOOL bState, COLORREF color)
{
	if( bState ) 
	{
		stcObject.StartBkBlink( FALSE );
		stcObject.StartTextBlink( FALSE );
		stcObject.SetTextColor( BLACK_COLOR );
		stcObject.SetBkColor( color );
	}
	else
	{
		stcObject.StartBkBlink( FALSE );
		stcObject.StartTextBlink( FALSE );
		stcObject.SetTextColor( BLACK_COLOR );
		stcObject.SetBkColor( WHITE_COLOR );
	}
}

void CJobsTabPipingView2::UpdateObjects()
{
//#ifndef _NO_RB
//	UpdateRollBrush();
//#endif
#ifndef _NO_EUV
	UpdateEuv();
	UpdateEuvFlowSensor();
#endif
	UpdateAk();
	UpdateIonizer();
	UpdateSensor();
	UpdateAI();
	UpdateValve();
	UpdateSBJ();
	UpdateAqk();
	UpdateShower();
//	UpdateDiwPump();
	UpdateDiwTank();
//	UpdateIntegralFlow();
//	UpdatePower();
}

void CJobsTabPipingView2::UpdateRollBrush()
{
	/*
	// 0: stop, 1: fw, 2: bw
	static int nOldRBStatus[MAX_PVIEW2_RB_NO] ={ 0, };
	BOOL bA, bB, bC, bD;
	bA = bB = bC = bD = FALSE;
	for( int i = 0; i < m_pEqpAssy->m_RbMotor.GetMaxSectionNo(); i ++ )
	{	
		bA = m_pEqpAssy->m_RbMotor.GetMotorFwState( i );
		bB = m_pEqpAssy->m_RbMotor.GetMotorBwState( i );
#ifndef _MY_DEBUG
		bC = m_pEqpAssy->m_RbMotor.GetMotorAlarm( i );
		bD = m_pEqpAssy->m_RbMotor.GetMotorCpAlarm( i );
#else
		bC = FALSE;
		bD = FALSE;
#endif
		if( ( bC || bD || (!bA && !bB) ) && ( nOldRBStatus[i] != 0 ) )
		{
			nOldRBStatus[i] = 0;
			m_ocxRollBrush[i].SetStop();
		}
		else if( !bC && !bD && bA && !bB && ( nOldRBStatus[i] != 1 ) )
		{
			nOldRBStatus[i] = 1;
			m_ocxRollBrush[i].SetCW();
			m_ocxRollBrush[i].SetRun();
		}
		else if( !bC && !bD && !bA && bB && ( nOldRBStatus[i] != 2 ))
		{
			nOldRBStatus[i] = 2;
			m_ocxRollBrush[i].SetCCW();
			m_ocxRollBrush[i].SetRun();
		}
	}
	*/
}

void CJobsTabPipingView2::UpdateAk()
{
	static BOOL bOldState[MAX_PVIEW2_AIRK_NO] = { FALSE, };
	BOOL bState = FALSE;
	for( int i=0; i<MAX_PVIEW2_AIRK_NO; i++ )
	{
		if( i== 0 ) bState = m_pEqpAssy->m_AutoValveAkUp.GetState();
		else		bState = m_pEqpAssy->m_AutoValveAkLo.GetState();
		if( bState && !bOldState[i] )
		{
			bOldState[i] = TRUE; 
			m_ocxAK[i].SetRun();
		}
		else if( !bState  && bOldState[i] )
		{
			bOldState[i] = FALSE; 
			m_ocxAK[i].SetStop();
		}
	}
}

void CJobsTabPipingView2::UpdateIonizer()
{
	static BOOL bRunStatus[MAX_PVIEW2_ION_NO] = { FALSE, };
	BOOL bAlarmState[MAX_PVIEW2_ION_NO] = { FALSE, };
	
	for( int nIonizerNo=0; nIonizerNo<MAX_PVIEW2_ION_NO; nIonizerNo++ )
	{
		for( int nAlarmNo=0; nAlarmNo<MAX_IONIZER_ALM_NO; nAlarmNo++ )
		{
			bAlarmState[nIonizerNo] |= m_pEqpAssy->m_SignalIonizer.Get( (nIonizerNo+1)*MAX_IONIZER_ALM_NO + nAlarmNo );
		}

		if( bAlarmState[nIonizerNo] && !bRunStatus[nIonizerNo] )
		{
			bRunStatus[nIonizerNo] = TRUE;
			m_ocxIonizer[nIonizerNo].SetAlarm();
		}
		else if( !bAlarmState[nIonizerNo] && bRunStatus[nIonizerNo] )
		{
			bRunStatus[nIonizerNo] = FALSE;
			m_ocxIonizer[nIonizerNo].SetStart();
		}
		else if( !bAlarmState[nIonizerNo] && !bRunStatus[nIonizerNo] )
		{
			bRunStatus[nIonizerNo] = TRUE;
			m_ocxIonizer[nIonizerNo].SetStart();
		}
	}	
}

void CJobsTabPipingView2::UpdateSensor()
{
	static BOOL bTankLevelStatus[MAX_PVIEW2_TANK_NO][MAX_DI_TANK_LEVEL_NO] = { FALSE, };

	for( int nTankNo=0; nTankNo<MAX_PVIEW2_TANK_NO; nTankNo++ )
	{
		for( int nSensorNo=0; nSensorNo<MAX_DI_TANK_LEVEL_NO; nSensorNo++ )
		{
			if( !bTankLevelStatus[nTankNo][nSensorNo] && m_pEqpAssy->m_DiTank[nTankNo+MAX_PVIEW1_TANK_NO].GetTankLevel( nSensorNo ) )
			{
				bTankLevelStatus[nTankNo][nSensorNo] = TRUE;
				if( nSensorNo == CPumpSeq::lvHH ) SetColorStatic( m_stcTankHH[nTankNo], ON, RED_COLOR );
				else if( nSensorNo == CPumpSeq::lvH ) SetColorStatic( m_stcTankH[nTankNo], ON, GREEN_COLOR );
				else if( nSensorNo == CPumpSeq::lvM ) SetColorStatic( m_stcTankL[nTankNo], ON, GREEN_COLOR );
				else if( nSensorNo == CPumpSeq::lvL ) SetColorStatic( m_stcTankLL[nTankNo], ON, GREEN_COLOR );
			}
			else if( bTankLevelStatus[nTankNo][nSensorNo] && !m_pEqpAssy->m_DiTank[nTankNo+MAX_PVIEW1_TANK_NO].GetTankLevel( nSensorNo ) )
			{
				bTankLevelStatus[nTankNo][nSensorNo] = FALSE;
				if( nSensorNo == CPumpSeq::lvHH ) SetColorStatic( m_stcTankHH[nTankNo], OFF, RED_COLOR );
				else if( nSensorNo == CPumpSeq::lvH ) SetColorStatic( m_stcTankH[nTankNo], OFF, GREEN_COLOR );
				else if( nSensorNo == CPumpSeq::lvM ) SetColorStatic( m_stcTankL[nTankNo], OFF, GREEN_COLOR );
				else if( nSensorNo == CPumpSeq::lvL ) SetColorStatic( m_stcTankLL[nTankNo], OFF, GREEN_COLOR );
			}
		}	
	}
}

void CJobsTabPipingView2::UpdateAI()
{
	float fAnalogVal = 0.0f;
	int nCurAdcVal = 0;
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		if( m_pEqpAssy->m_AnalogInput.m_aiSet[i].nOwnerViewNo != CDicsView::viewJobPiping2 ) continue;
		int nAddress = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nReal;
		int nOcxId = m_pEqpAssy->m_AnalogInput.m_aiSet[i].uRESID - MAX_PVIEW1_AI_NO;
		if( nOcxId >= 0 )
		{
			m_pDevice->m_pFilterGain[nAddress]  = m_ocxAnalogInput[nOcxId].GetFilterGain();
			m_pDevice->m_aiInfo[nAddress].nScale   = m_ocxAnalogInput[nOcxId].GetCalScale();
			m_pDevice->m_aiInfo[nAddress].nAdcMin  = m_ocxAnalogInput[nOcxId].GetAdcMinVal();
			m_pDevice->m_aiInfo[nAddress].nAdcMax  = m_ocxAnalogInput[nOcxId].GetAdcMaxVal();
			m_pDevice->m_aiInfo[nAddress].fRealMin = m_ocxAnalogInput[nOcxId].GetRealMinVal();
			m_pDevice->m_aiInfo[nAddress].fRealMax = m_ocxAnalogInput[nOcxId].GetRealMaxVal();

			fAnalogVal =  m_pEqpAssy->m_AnalogInput.GetRealVal( i );
			nCurAdcVal = m_pEqpAssy->m_AnalogInput.GetAdcVal( i );
			m_ocxAnalogInput[nOcxId].SetCurAdcVal( nCurAdcVal );
			m_ocxAnalogInput[nOcxId].SetAnalogCalDisplay( fAnalogVal );
		}
	}
}

void CJobsTabPipingView2::UpdateValve()
{
	static BOOL bOldValveStateView3[MAX_PVIEW2_VALVE_NO] = { FALSE, };

	for( int i = 0 ; i < MAX_PVIEW2_VALVE_NO; i ++ )
	{
		if( !bOldValveStateView3[i] && m_pEqpAssy->m_AutoValvePiping.GetState( i+MAX_PVIEW1_VALVE_NO ) )
		{
			bOldValveStateView3[i] = TRUE;
			OnValveStatusChanged( TRUE, i );
		}
		else if( bOldValveStateView3[i] && !m_pEqpAssy->m_AutoValvePiping.GetState( i+MAX_PVIEW1_VALVE_NO ) )
		{
			bOldValveStateView3[i] = FALSE;
			OnValveStatusChanged( FALSE, i );
		}
	}
}

void CJobsTabPipingView2::UpdateSBJ()
{
		   BOOL bUpdate = FALSE;
	static BOOL	bCDA2    = FALSE;
	static BOOL	bDI2     = FALSE;

	if( m_pEqpAssy->m_AutoValveFrShower.GetState() && !bDI2 ) 
		{bDI2=TRUE; bUpdate=TRUE;}
	else if( !m_pEqpAssy->m_AutoValveFrShower.GetState() && bDI2 )
		{bDI2=FALSE; bUpdate=TRUE;}

	if( m_pEqpAssy->m_AutoValveSbjCda.GetState( 1 ) && !bCDA2 )
		{bCDA2=TRUE; bUpdate=TRUE;}
	else if( !m_pEqpAssy->m_AutoValveSbjCda.GetState( 1 ) && bCDA2 )
		{bCDA2=FALSE; bUpdate=TRUE;}

	if( bUpdate )	m_ocxSbjUnit[0].SetSbjState( bDI2, bCDA2 );


/*
	static BOOL bOldStateDi	= FALSE;
	static BOOL bOldStateCda = FALSE;

	BOOL bDiOnCond = TRUE;
	BOOL bCdaOnCond = TRUE;
	BOOL bUpdate = FALSE;

	//bCdaOnCond = m_pEqpAssy->m_AutoValveFrShower.GetState(MAX_PVIEW1_SBJ_NO);
	bCdaOnCond = m_pEqpAssy->m_AutoValveSbjCda.GetState(1);

	if( bDiOnCond && !bOldStateDi )
	{
		bOldStateDi = TRUE;
		bUpdate = TRUE;
	}
	else if( !bDiOnCond && bOldStateDi )
	{
		bOldStateDi = FALSE;
		bUpdate = TRUE;
	}

	if( bCdaOnCond && !bOldStateCda )
	{
		bOldStateCda = TRUE;
		bUpdate = TRUE;
	}
	else if( !bCdaOnCond && bOldStateCda )
	{
		bOldStateCda = FALSE;
		bUpdate = TRUE;
	}

	if( bUpdate )
	{
		m_ocxSbjUnit[0].SetSbjState( bOldStateDi, bOldStateCda );
	}
*/
}

void CJobsTabPipingView2::UpdateAqk()
{
	static BOOL	bOldState = FALSE;
	BOOL bAqkOnCond = TRUE;

	bAqkOnCond = m_pEqpAssy->m_AutoValveFrShower.GetState();

	if( bAqkOnCond && !bOldState )
	{
		bOldState = TRUE;
		m_ocxAqkUnit[0].SetRun();
	}
	else if( !bAqkOnCond && bOldState )
	{
		bOldState = FALSE;
		m_ocxAqkUnit[0].SetStop();
	}
}

void CJobsTabPipingView2::UpdateShower()
{
	static BOOL bOldState[1] = { FALSE, };
	BOOL bShowerOnCond[1] = { TRUE,  };

	bShowerOnCond[0] &= m_pEqpAssy->m_AutoValveFrShower.GetState();
	
	if( bShowerOnCond[0] && !bOldState[0] )
	{
		bOldState[0] = TRUE;

		m_ocxSWR4ShwUnitUp[0].SetRun();
		m_ocxSWR4ShwUnitUp[1].SetRun();
		m_ocxSWR4ShwUnitUp[2].SetRun();
		m_ocxSWR4ShwUnitUp[3].SetRun();

		m_ocxSWR4ShwUnitLo[0].SetRun();
 		m_ocxSWR4ShwUnitLo[1].SetRun();
 		m_ocxSWR4ShwUnitLo[2].SetRun();
	}
	else if( !bShowerOnCond[0] && bOldState[0] )
	{
		bOldState[0] = FALSE;

		m_ocxSWR4ShwUnitUp[0].SetStop();
		m_ocxSWR4ShwUnitUp[1].SetStop();
		m_ocxSWR4ShwUnitUp[2].SetStop();
		m_ocxSWR4ShwUnitUp[3].SetStop();
		
		m_ocxSWR4ShwUnitLo[0].SetStop();
 		m_ocxSWR4ShwUnitLo[1].SetStop();
 		m_ocxSWR4ShwUnitLo[2].SetStop();
	}
}

void CJobsTabPipingView2::UpdateDiwPump()
{
/*	static int nJob3Pump[MAX_PVIEW2_PUMP_NO] = { -1, };

	for( int i=0; i<MAX_PVIEW2_PUMP_NO; i++ )
	{
		BOOL bPumpOn = TRUE;
		bPumpOn &= m_pEqpAssy->m_DiTank[i].GetPumpOnState();
#ifndef _MY_DEBUG
		bPumpOn &= m_pEqpAssy->m_DiTank[i].GetPumpOn();
#endif
		BOOL bPumpAlarm = m_pEqpAssy->m_DiTank[i].GetPumpAlarm();
		if( bPumpOn && !bPumpAlarm && nJob3Pump[i] != 0 )
		{
			nJob3Pump[i] = 0;
			m_ocxPump[i].SetStart();
		}
		else if( !bPumpOn && !bPumpAlarm && nJob3Pump[i] != 1 )
		{
			nJob3Pump[i] = 1;
			m_ocxPump[i].SetStop();
		}
		else if( bPumpAlarm && nJob3Pump[i] != 2 )
		{
			nJob3Pump[i] = 2;
			m_ocxPump[i].SetAlarm();
		}
	}
*/
}

void CJobsTabPipingView2::UpdateDiwTank()
{
	if(MAX_PVIEW2_TANK_NO <= 0 )	return;
	float fVal[MAX_PVIEW2_TANK_NO] = { 0, };

	CPumpSeq* pPumpSeq = ( ((CDicsView*)m_pView)->m_pPumpSeq );
	for( int i=0; i<MAX_PVIEW2_TANK_NO; i++ )
	{
		if( pPumpSeq->m_SeqFlag.bDiTankLevel[i+MAX_PVIEW1_TANK_NO][CPumpSeq::lvHH] )		fVal[i] = (float)PVIEW2_TANK_LEVEL_HH( i );
		else if( pPumpSeq->m_SeqFlag.bDiTankLevel[i+MAX_PVIEW1_TANK_NO][CPumpSeq::lvH] )	fVal[i] = (float)PVIEW2_TANK_LEVEL_H( i );
		else if( pPumpSeq->m_SeqFlag.bDiTankLevel[i+MAX_PVIEW1_TANK_NO][CPumpSeq::lvM] )	fVal[i] = (float)PVIEW2_TANK_LEVEL_M( i );
		else if( pPumpSeq->m_SeqFlag.bDiTankLevel[i+MAX_PVIEW1_TANK_NO][CPumpSeq::lvL] )	fVal[i] = (float)PVIEW2_TANK_LEVEL_L( i );
		
		OnTankStatusChanged( i, (LPARAM)fVal[i] );
	}
}

void CJobsTabPipingView2::UpdatePower()
{
	static float fOldPowerInstant = 0.;
	static float fOldPowerTotal = 0.;
	
	float fCurPowerInstant = ((CDicsView*)m_pView)->m_pXkm100->m_fCurrentPower;
	float fCurPowerTotal = ((CDicsView*)m_pView)->m_pXkm100->m_fTotalPower;
	
	CString sMsg = _T("");
	
	if( fCurPowerInstant != fOldPowerInstant  ) 
	{
		sMsg.Format( "%.2f", fCurPowerInstant );
		m_msgInstancePower.SetOpMsg( sMsg );
		fOldPowerInstant = fCurPowerInstant;
	}
	
	if( fCurPowerTotal != fOldPowerTotal  )
	{
		sMsg.Format( "%.1f", fCurPowerTotal );
		m_msgTotalPower.SetOpMsg( sMsg );
		fOldPowerTotal = fCurPowerTotal;
	}
}

LRESULT CJobsTabPipingView2::OnValveStatusChanged( WPARAM wParam, LPARAM lParam )
{
	if( !m_bInitialUpdateComp ) return 0;

	BOOL bState = (BOOL) wParam;
	int nValve = (int) lParam;

	if( bState ) m_ocxAutoValve[nValve].SetValveOn();
	else m_ocxAutoValve[nValve].SetValveOff();
	return 0;
}

LRESULT CJobsTabPipingView2::OnMsgBoxClicked( WPARAM wParam, LPARAM lParam )
{
	return 0;
}

BEGIN_EVENTSINK_MAP(CJobsTabPipingView2, CFormView)
    //{{AFX_EVENTSINK_MAP(CJobsTabPipingView2)
//	ON_EVENT(CJobsTabPipingView2, IDC_PUMP1, -600 /* Click */, OnClickPump1, VTS_NONE)
//	ON_EVENT(CJobsTabPipingView2, IDC_EUV1, -600 /* Click */, OnClickEuv, VTS_NONE)
	ON_EVENT_RANGE(CJobsTabPipingView2, IDC_AUTOVALVECTRL11, IDC_AUTOVALVECTRL16/*130812 halesu*/, -600, OnClickAutoValve, VTS_I2)
#ifdef _MOTOR_LOAD_FACTOR
	ON_EVENT_RANGE(CJobsTabPipingView2, IDC_NEW_ANALOGCTRLCTRL32, IDC_NEW_ANALOGCTRLCTRL60, -600, OnClickAnalogInput, VTS_I2)
#else
	ON_EVENT_RANGE(CJobsTabPipingView2, IDC_ANALOGCTRLCTRL33, IDC_ANALOGCTRLCTRL0, -600, OnClickAnalogInput, VTS_I2)
#endif
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CJobsTabPipingView2::OnClickAnalogInput( UINT nID )
{
#ifdef _MOTOR_LOAD_FACTOR
	int nOcxId = nID - IDC_NEW_ANALOGCTRLCTRL32;
#else
	int nOcxId = nID - IDC_ANALOGCTRLCTRL33;
#endif
	int nAddress = m_ocxAnalogInput[nOcxId].GetAiRealID();
	m_pDevice->m_pFilterGain[nAddress]  = m_ocxAnalogInput[nOcxId].GetFilterGain();
	m_pDevice->m_aiInfo[nAddress].nScale   = m_ocxAnalogInput[nOcxId].GetCalScale();
	m_pDevice->m_aiInfo[nAddress].nAdcMin  = m_ocxAnalogInput[nOcxId].GetAdcMinVal();
	m_pDevice->m_aiInfo[nAddress].nAdcMax  = m_ocxAnalogInput[nOcxId].GetAdcMaxVal();
	m_pDevice->m_aiInfo[nAddress].fRealMin = m_ocxAnalogInput[nOcxId].GetRealMinVal();
	m_pDevice->m_aiInfo[nAddress].fRealMax = m_ocxAnalogInput[nOcxId].GetRealMaxVal();

	m_pDevice->m_aiInfo[nAddress].nLoLimit = m_ocxAnalogInput[nOcxId].GetLowLimitValue();
	m_pDevice->m_aiInfo[nAddress].nUpLimit = m_ocxAnalogInput[nOcxId].GetUpLimitValue();
	m_pDevice->m_aiInfo[nAddress].nLoWarning = m_ocxAnalogInput[nOcxId].GetLoWaringValue();
	m_pDevice->m_aiInfo[nAddress].nUpWarning = m_ocxAnalogInput[nOcxId].GetUpWarningValue();

	float fVal = m_ocxAnalogInput[nOcxId].GetCalculation();
}

void CJobsTabPipingView2::OnClickEuv() 
{
	//kjd---------------------------------
	CDicsApp* pApp = ( CDicsApp* )AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* )pApp->m_pMainWnd;
//	if( pMainFrame->m_bAuto ) return;
//	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;
	//kjd---------------------------------
#ifndef _NO_EUV
	( (CDicsView*)m_pView )->m_tabCtrl.SelectTab(CDicsView::viewJobEuv);
	( (CDicsView*)m_pView )->SendMessage(WM_SEL_CHANGE_TAB, CDicsView::viewJobEuv);
#endif
}

void CJobsTabPipingView2::OnClickRb() 
{
	if ( ((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto ) return;

	CDlgGridRollBrush dlg;
	dlg.SetDevice( ((CDicsView*)m_pView)->m_pDevice );
//	dlg.SetData( ((CDicsView*)m_pView)->m_pDicsData );
//	dlg.SetMmc( ((CDicsView*)m_pView)->m_pMmc );
	dlg.SetEqpAssy( m_pEqpAssy );
	dlg.SetRbSeq( ((CDicsView*)m_pView)->m_pRbSeq );
	dlg.m_nMotorEA		= MAX_PVIEW2_RB_NO;
	dlg.m_sMotorName	= "SWR2 RB1 UP;SWR2 RB1 LO;SWR2 RB2 UP;SWR2 RB2 LO;SWR3 RB1 UP;SWR3 RB1 LO;SWR3 RB2 UP;SWR3 RB2 LO;";
	dlg.SetSpeedRange( 100, 400, 100 );
	dlg.DoModal();
}

void CJobsTabPipingView2::OnClickPump1() 
{
	// TODO: Add your control notification handler code here
	CDicsApp* pApp = ( CDicsApp* )AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* )pApp->m_pMainWnd;
	if( pMainFrame->m_bAuto ) return;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;
	CDlgPumpCln dlg;
	dlg.SetDevice( ( (CDicsView*)m_pView )->m_pDevice );
	dlg.SetTankAssy( &m_pEqpAssy->m_DiTank[0] );
	dlg.m_nCurSelPump1 = 0;
	dlg.DoModal();		
}

void CJobsTabPipingView2::OnClickAutoValve( UINT nID )
{
	CDicsApp* pApp = ( CDicsApp* ) AfxGetApp();
	CMainFrame* pMainFrame = ( CMainFrame* ) pApp->m_pMainWnd;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto ) return;
	if( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;

	CDlgValve dlg;

	// ljy_041104 : AUO User request
	if( (((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel > CDicsData::idOP) && !pMainFrame->m_bAuto ) dlg.m_bPermitAccess = TRUE;
	else dlg.m_bPermitAccess = FALSE;
	
	int nAutoValveKeyCount = m_pEqpAssy->m_AutoValvePiping.GetDoSize();

	dlg.m_nValveNo = nID - IDC_AUTOVALVECTRL11 + MAX_PVIEW1_VALVE_NO;
	if( nAutoValveKeyCount <= dlg.m_nValveNo ) return;

	dlg.m_nWhatGroup = CDlgValve::vgJOB3;
	dlg.SetDevice( ( (CDicsView*)m_pView )->m_pDevice );
	dlg.SetEqpAssy(( (CDicsView*)m_pView )->m_pEqpAssy );
	dlg.DoModal();	
}

LRESULT CJobsTabPipingView2::OnPumpStatusChanged( WPARAM wParam, LPARAM lParam )
{
/*	
	switch( wParam )
	{
	case 0 :
		m_ocxPump[lParam].SetStart();
		break;
	case 1 :
		m_ocxPump[lParam].SetStop();
		break;
	case 2 :
		m_ocxPump[lParam].SetAlarm();
		break;
	}
*/
	return 0;
}

LRESULT CJobsTabPipingView2::OnTankStatusChanged( WPARAM wParam, LPARAM lParam )
{
	int nTankNo = (int) wParam;
	float fTankLevel = (float) lParam;

	LPCTSTR sMsg;
	COLORREF color;

	if( fTankLevel >= PVIEW2_TANK_LEVEL_HH( nTankNo ) )
	{
		sMsg = "TOP";
		color = RED_COLOR;
		m_progTank[nTankNo].SetForeColour( color );
		m_progTank[nTankNo].SetWindowText( sMsg );
		m_progTank[nTankNo].SetPos( (int)fTankLevel );
	}
	else if( fTankLevel < PVIEW2_TANK_LEVEL_HH( nTankNo ) && fTankLevel >= PVIEW2_TANK_LEVEL_H( nTankNo ) )
	{
		sMsg = "HIGH";
		color = LIGHT_CYAN_COLOR;
		m_progTank[nTankNo].SetForeColour( color );
		m_progTank[nTankNo].SetWindowText( sMsg );
		m_progTank[nTankNo].SetPos( (int)fTankLevel );
	}
	else if( fTankLevel < PVIEW2_TANK_LEVEL_H( nTankNo ) && fTankLevel >= PVIEW2_TANK_LEVEL_M( nTankNo ) )
	{
		sMsg = "MIDDLE";
		color = LIGHT_ORANGE_COLOR;
		m_progTank[nTankNo].SetForeColour( color );
		m_progTank[nTankNo].SetWindowText( sMsg );
		m_progTank[nTankNo].SetPos( (int)fTankLevel );
	}
	else if( fTankLevel < PVIEW2_TANK_LEVEL_M( nTankNo ) && fTankLevel >= PVIEW2_TANK_LEVEL_L( nTankNo ) )
	{
		sMsg = "LOW";
		color = ORANGE_COLOR;
		m_progTank[nTankNo].SetForeColour( color );
		m_progTank[nTankNo].SetWindowText( sMsg );
		m_progTank[nTankNo].SetPos( (int)fTankLevel );
	}
	else if( fTankLevel < PVIEW2_TANK_LEVEL_L( nTankNo ) )
	{
		sMsg = "BOTTOM";
		color = RED_COLOR;
		m_progTank[nTankNo].SetForeColour( color );
		m_progTank[nTankNo].SetWindowText( sMsg );
		m_progTank[nTankNo].SetPos( (int)fTankLevel );
	}
	return 0;
}

void CJobsTabPipingView2::UpdateEuv()
{
#ifdef _NO_EUV
	return;
#endif

	// status : noUse, alarm, Lamp on, Lamp Off
	static int nStatus = 0;

//////////////////////////////////////////////////////////////////////////
// Euv Usage
	BOOL bUse = ( (CDicsView*)m_pView )->m_pEuvSeq->IsEuvUse();
	if( !bUse && nStatus != 1 )
	{
		m_ocxEuv.SetLampNoUse();
		nStatus = 1;
	}
	else if( bUse && nStatus == 1 )
	{
		nStatus = 0;
	}

	if( !bUse ) return;
	
//////////////////////////////////////////////////////////////////////////
// Euv Alarm
	BOOL bAlarm = ( (CDicsView*)m_pView )->m_pEuvSeq->GetEuvAlarm() ? TRUE : FALSE;
	if( bAlarm && nStatus != 2 ) 
	{
		m_ocxEuv.SetLampAlarm();
		nStatus = 2;
	}
	else if( !bAlarm && nStatus == 2 )
	{
		nStatus = 0;
	}

	if( bAlarm ) return;

	
//////////////////////////////////////////////////////////////////////////
// Lamp Selected
	static int nOldSelected[MAX_LAMP_CONTROL_NO] = { 0, };
	int nSelected[MAX_LAMP_CONTROL_NO] = { 0, };

#ifndef _LTYPE
	for( int i=0; i<MAX_LAMP_CONTROL_NO; i++ )
	{
		nSelected[i] = ( (CDicsView*)m_pView )->m_pEuvSeq->GetLampOnSelected( i ) ? 1 : 2;		
		if( nSelected[i] != nOldSelected[i] ) 
		{
			m_ocxEuv.LampSelect( 8-i , nSelected[i] == 1 ? TRUE : FALSE );
			nOldSelected[i] = nSelected[i];
			nStatus = 0;
		}
	}
#else
	for( int i=0; i<MAX_LAMP_CONTROL_NO; i++ )
	{
		nSelected[i] = ( (CDicsView*)m_pView )->m_pEuvSeq->GetLampOnSelected( i ) ? 1 : 2;		
		if( nSelected[i] != nOldSelected[i] ) 
		{
			m_ocxEuv.LampSelect( i+1 , nSelected[i] == 1 ? TRUE : FALSE );
			nOldSelected[i] = nSelected[i];
			nStatus = 0;
		}
	}
#endif

// Lamp On
	BOOL bOn = ( (CDicsView*)m_pView )->m_pEuvSeq->GetLampOnState();
	if( bOn && nStatus != 3 ) 
	{
		m_ocxEuv.SetLampOn();
		nStatus = 3;
	}
	else if( !bOn && nStatus != 4 )
	{
		m_ocxEuv.SetLampOff();
		nStatus = 4;
	}
}

void CJobsTabPipingView2::UpdateEuvFlowSensor()
{
	static BOOL bFlowAlarmH[MAX_EUV_UTIL_ALARM] = { FALSE, };
	static BOOL bFlowAlarmL[MAX_EUV_UTIL_ALARM] = { FALSE, };
	int nAlarmPos[MAX_EUV_UTIL_ALARM] = { 4, 2, 1};
	for( int i=0; i<MAX_EUV_UTIL_ALARM; i++ )
	{		
		if( !bFlowAlarmL[i] && m_pEqpAssy->m_UshioEuv.GetUtAlarm(nAlarmPos[i]) )
		{
			bFlowAlarmL[i] = TRUE;
			SetColorStatic( m_stcEuvLevelL[i], TRUE, RED_COLOR );
		}
		else if( bFlowAlarmL[i] && !m_pEqpAssy->m_UshioEuv.GetUtAlarm(nAlarmPos[i]) )
		{
			bFlowAlarmL[i] = FALSE;
			SetColorStatic( m_stcEuvLevelL[i], FALSE, WHITE_COLOR );
		}
	}
		
}