//{{AFX_INCLUDES()
#include "..\ionizer.h"
#include "..\pump.h"
#include "..\AnalogCtrl.h"
//}}AFX_INCLUDES

#pragma once

// CJobsTabPipingView2  Դϴ.

#include "..\X\AVICtrl.h"	// Added by ClassView
#include "..\X\colorstatic.h"	// Added by ClassView
#include "..\X\TextProgressCtrl.h"	// Added by ClassView
#include "..\sbjunit.h"
#include "..\aqkunit.h"
#include "..\shwunit.h"
#include "..\AirKnife.h"
#include "..\AutoValve.h"
#include "..\X\ColorBtn.h"
#include "..\X\MsgBox.h"
#include "..\FactoryLib\EqpAssy.h"


#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#define MAX_PIPING_VIEW_AI_NO	60//30//24

class CJobsTabPipingView2 : public CFormView
{
public:
	CJobsTabPipingView2();           // protected constructor used by dynamic creation
	CJobsTabPipingView2( CView* pView, int nTabNo );
	DECLARE_DYNCREATE(CJobsTabPipingView2)

public:
#ifdef _MOTOR_LOAD_FACTOR
	enum { IDD = IDD_JOBS_TAB_PIPING_VIEW2_MLF };
#else
	enum { IDD = IDD_JOBS_TAB_PIPING_VIEW2 };
#endif

#ifdef _DEBUG
	virtual void AssertValid() const;
#ifndef _WIN32_WCE
	virtual void Dump(CDumpContext& dc) const;
#endif
#endif

	//}}AFX_DATA
	CIonizer		m_ocxIonizer[MAX_PVIEW2_ION_NO];
	//CRollBrush		m_ocxRollBrush[MAX_PVIEW2_RB_NO];
	CSbjUnit		m_ocxSbjUnit[MAX_PVIEW2_SBJ_NO];
	CAqkUnit		m_ocxAqkUnit[1];
	CAirKnife		m_ocxAK[MAX_PVIEW2_AIRK_NO];
	CShwUnit		m_ocxSWR4ShwUnitUp[4];
	CShwUnit		m_ocxSWR4ShwUnitLo[3];

	CAutoValve		m_ocxAutoValve[MAX_PVIEW2_VALVE_NO];
	CTextProgressCtrl m_progTank[MAX_PVIEW2_TANK_NO];
	//CPump			m_ocxPump[MAX_PVIEW2_PUMP_NO];
	CAnalogCtrl		*m_ocxAnalogInput;
// Attributes
public:
	int				m_nTabNo;
	CView*			m_pView;
	CSetupItems*	m_pSetupItems;
	XCtlDevice*		m_pDevice;
	CDicsData*		m_pDicsData;
	CEqpAssy*		m_pEqpAssy;

	CColorStatic	m_stcUnit[7];
	CMsgBox			m_msgFlowMeterTotal;
	CMsgBox			m_msgFlowMeterInstant;
	CMsgBox			m_msgFlowMeterReset;

	CMsgBox			m_msgFRFlowTotal;		// 20100407 ssm
	CMsgBox			m_msgFRFlowInstant;
	CMsgBox			m_msgFRFlowReset;
	CMacButton		m_macIntegralReset;
	CMsgBox			m_msgTotalPower;			// 20100707 ssm
	CMsgBox			m_msgInstancePower;			// 20100707 ssm

	BOOL			m_bInitialUpdateComp;


	CColorStatic	m_stcTankHH[MAX_DI_TANK_NO];
	CColorStatic	m_stcTankH[MAX_DI_TANK_NO];
//	CColorStatic	m_stcTankM2[MAX_DI_TANK_NO];
//	CColorStatic	m_stcTankM1[MAX_DI_TANK_NO];
	CColorStatic	m_stcTankL[MAX_DI_TANK_NO];
	CColorStatic	m_stcTankLL[MAX_DI_TANK_NO];

	CColorStatic	m_stcEuvLevelH[MAX_EUV_UTIL_ALARM];
	CColorStatic	m_stcEuvLevelL[MAX_EUV_UTIL_ALARM];
	CColorStatic	m_stcEuv;
	CEUVHouse		m_ocxEuv;

// Operations
public:
	void SetBitmaps();
	void SetAnalogOcxInitParameter();
	void SetAiInitParameter();
	void SetDevice( XCtlDevice* pDevice ) { m_pDevice = pDevice; }
	void SetEqpAssy( CEqpAssy* pEqpAssy ) { m_pEqpAssy = pEqpAssy; }
	void SetDicsData( CDicsData* pDicsData ){ m_pDicsData = pDicsData; }
	void SetColorStatic(CColorStatic &stcObject, BOOL bState, COLORREF color);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJobsTabPipingView2)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

	// Implementation
public:
	virtual ~CJobsTabPipingView2();
	void UpdateObjects();
#ifdef _DEBUG
//	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CJobsTabPipingView2)
	afx_msg void OnClickPump1();
	afx_msg void OnClickEuv();
	afx_msg void OnClickRb();
	afx_msg void OnClickAutoValve( UINT nID );
	afx_msg void OnClickAnalogInput( UINT nID );
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	afx_msg LRESULT OnValveStatusChanged( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnMsgBoxClicked( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnPumpStatusChanged( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnTankStatusChanged( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
public:
	void UpdateEuvFlowSensor();
	void UpdateIntegralFlow();

protected:
	void UpdateRollBrush();
	void UpdateAk();
	void UpdateIonizer();
	void UpdateSensor();
	void UpdateAI();
	void UpdateValve();
	void UpdateSBJ();
	void UpdateAqk();
	void UpdateShower();
	void UpdateDiwPump();
	void UpdateDiwTank();
	void UpdateEuv();
	void UpdatePower();		// 20100708 ssm
};



