// JobsTabProcessDataView.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "JobsTabProcessDataView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//extern XLog EdcLog;
extern XLog ApdLog;

/////////////////////////////////////////////////////////////////////////////
// CJobsTabProcessDataView

IMPLEMENT_DYNCREATE(CJobsTabProcessDataView, CFormView)

CJobsTabProcessDataView::CJobsTabProcessDataView()
	: CFormView(CJobsTabProcessDataView::IDD)
{
	//{{AFX_DATA_INIT(CJobsTabProcessDataView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CJobsTabProcessDataView::CJobsTabProcessDataView(CView* pView, int nTabNo)
	: CFormView(CJobsTabProcessDataView::IDD)
{
	m_pView = pView;
	m_nTabNo = nTabNo;
	SetEqpAssy( ((CDicsView*)m_pView)->m_pEqpAssy );
}

CJobsTabProcessDataView::~CJobsTabProcessDataView()
{
}

void CJobsTabProcessDataView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJobsTabProcessDataView)
	DDX_Control(pDX, IDC_GRID_EDC_DATA, m_gridEdcData);
	DDX_Control(pDX, IDC_GRID_APD_DATA, m_gridApdData);
	DDX_Control(pDX, IDC_GRID_PARTS_DATA, m_gridPartsData);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CJobsTabProcessDataView, CFormView)
	//{{AFX_MSG_MAP(CJobsTabProcessDataView)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_MESSAGE( WM_EDC_DATA_CHANGED, OnEdcDataChanged )
	ON_MESSAGE( WM_APD_DATA_CHANGED, OnApdDataChanged )
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
	ON_WM_MOUSEWHEEL()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJobsTabProcessDataView diagnostics

#ifdef _DEBUG
void CJobsTabProcessDataView::AssertValid() const
{
	CFormView::AssertValid();
}

void CJobsTabProcessDataView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJobsTabProcessDataView message handlers

void CJobsTabProcessDataView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	CDicsDoc* pDoc = (CDicsDoc*) ( (CDicsView*)m_pView->GetDocument() );
	SetSetupItems( pDoc->m_pSetupItems );

	m_hbrBgColor =	CreateSolidBrush( BG_COLOR );
	m_hbrTextColor = CreateSolidBrush( BLUE_COLOR );

	m_hbrDarkGray =	CreateSolidBrush( DARK_GRAY_COLOR );
	m_hbrBlack = CreateSolidBrush( BLACK_COLOR );
	m_hbrYellow = CreateSolidBrush( YELLOW_COLOR );

	m_hbrLightRed =	CreateSolidBrush( LIGHT_RED_COLOR );
	m_hbrLightBlue = CreateSolidBrush( LIGHT_BLUE_COLOR );
	m_hbrLightYellow = CreateSolidBrush( LIGHT_YELLOW_COLOR );
	m_hbrLightGreen = CreateSolidBrush( LIGHT_GREEN_COLOR );
	m_hbrLightCyan = CreateSolidBrush( LIGHT_CYAN_COLOR );
	m_hbrLightMagenta = CreateSolidBrush( LIGHT_MAGENTA_COLOR );

//	GridInit_EdcData();
	GridInit_ApdData();
	GridInit_PartsData();

	// TODO: Add your specialized code here and/or call the base class	
}

void CJobsTabProcessDataView::GridInit_EdcData()
{
	CDicsView* pView = (CDicsView*)m_pView;
	CDicsData* pDicsData = pView->m_pDicsData;

	LPTSTR sLvcText[] = { " NO ", " DATA NAME ", " VALUE ", " UNIT " };
	int nColWidth[] = { 500, 3280, 1300, 1300 }; 

	CString sName[] = {	"Job Mode",
						"Pump Use",
						"LD Broken Use",
						"UL Broken Use",
						"Gear DI Supply Use",
						"Euv Lamp 1 Used Time",
						"Euv Lamp 2 Used Time",
						"Euv Lamp 3 Used Time",
						"Euv Lamp 4 Used Time",
						"Euv Lamp 5 Used Time",
						"Euv Lamp 6 Used Time",
						"Recipe ID", };

	int nNormalDataNo = sizeof( sName ) / sizeof( CString );	

	AI_SET* pAiSet = NULL;

	int nRows	= nNormalDataNo + m_pEqpAssy->m_AnalogInput.m_nMaxEdcAiNo;
	int nCols	= 4;

	if( nRows <= 9 ) nColWidth[1] += 270;

	CString	sBuf;
	COLORREF color;
	
	m_gridEdcData.SetRows( nRows + 1 ); 
	m_gridEdcData.SetCols( nCols );

	//-------------------------------------------
	m_gridEdcData.SetRow( 0 );  
	for( int i=0; i<nCols; i++ )
	{
		m_gridEdcData.SetColWidth( i, nColWidth[i] );
		m_gridEdcData.SetCol( i ); 
		m_gridEdcData.SetCellAlignment( 4 );
		m_gridEdcData.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridEdcData.SetText( sLvcText[i] ); 
	}

	//SetDataToGridCtrl_EdcData();
	for( int i=0; i<nNormalDataNo + m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		if( i < nNormalDataNo )
		{
			// 1st column
			m_gridEdcData.SetCol( 0 );
			m_gridEdcData.SetRow( i + 1 );
			m_gridEdcData.SetCellAlignment( 4 );	// Center adjusted
			m_gridEdcData.SetCellBackColor( LIGHT_ORANGE_COLOR );
			sBuf.Format( "%d", i + 1 ); 
			m_gridEdcData.SetText( (LPCTSTR)sBuf );

			// 2nd column
			m_gridEdcData.SetCol( 1 );
			m_gridEdcData.SetRow( i + 1 );
			m_gridEdcData.SetCellFontBold( TRUE );
			sBuf = sName[i];
			m_gridEdcData.SetText( (LPCTSTR)sBuf );

			// 4th column
			m_gridEdcData.SetCol( 3 );
			m_gridEdcData.SetRow( i + 1 );
			m_gridEdcData.SetCellAlignment( 4 );
			sBuf = " ";
			m_gridEdcData.SetText( (LPCTSTR)sBuf );
		}
		else
		{
			int nEdcNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i-nNormalDataNo].nEdcReportNo;
			if( nEdcNo < 0 ) continue;
			// 1st column
			m_gridEdcData.SetCol( 0 );
			m_gridEdcData.SetRow( nNormalDataNo + nEdcNo + 1 );
			m_gridEdcData.SetCellAlignment( 4 );	// Center adjusted
			m_gridEdcData.SetCellBackColor( LIGHT_ORANGE_COLOR );
			sBuf.Format( "%d", nNormalDataNo + nEdcNo + 1 ); 
			m_gridEdcData.SetText( (LPCTSTR)sBuf );

			// 2nd column
			m_gridEdcData.SetCol( 1 );
			m_gridEdcData.SetRow( nNormalDataNo + nEdcNo + 1 );
			m_gridEdcData.SetCellFontBold( TRUE );
			sBuf = m_pEqpAssy->m_AnalogInput.m_aiSet[i-nNormalDataNo].sName;
			m_gridEdcData.SetText( (LPCTSTR)sBuf );

			// 4th column
			m_gridEdcData.SetCol( 3 );
			m_gridEdcData.SetRow( nNormalDataNo + nEdcNo + 1 );
			m_gridEdcData.SetCellAlignment( 4 );

			int nID = i-nNormalDataNo;
//			int nKind = m_pEqpAssy->m_AnalogInput.m_aiSet[i-nNormalDataNo].sKind;
			sBuf = m_pEqpAssy->m_AnalogInput.m_aiSet[i-nNormalDataNo].sKind;

			if( sBuf == "kPa" ) color = LIGHT_CYAN_COLOR;
			else if( sBuf == "lpm" ) color = LIGHT_RED_COLOR;
			else if( sBuf == "Pa" ) color = LIGHT_YELLOW_COLOR;
			else if( sBuf == "mm/s" ) color = WHITE_COLOR;
			else if( sBuf == "Mohm" ) color = WHITE_COLOR;
			else if( sBuf == "V" ) color = WHITE_COLOR;
			else if( sBuf == "deg" ) color = WHITE_COLOR;
			else if( sBuf == "L" ) color = WHITE_COLOR;
			else if( sBuf == "mW"  ) color = LIGHT_MAGENTA_COLOR;
			else color = WHITE_COLOR;	
			m_gridEdcData.SetText( (LPCTSTR)sBuf );

			for( int j=1; j<nCols; j++ )
			{
				m_gridEdcData.SetCol( j );
				m_gridEdcData.SetCellBackColor( color );
			}
		}
	}

	if( pAiSet != NULL ) delete []pAiSet;
}

void CJobsTabProcessDataView::GridInit_ApdData()
{
	CDicsView* pView = (CDicsView*)m_pView;
	CDicsData* pDicsData = pView->m_pDicsData;

	LPTSTR sLvcText[] = { " NO ", " DATA NAME ", " VALUE ", " UNIT " };
	//int nColWidth[] = { 500, 3300, 1600, 1000 }; 
	int nColWidth[] = { 500, 3550, 1500, 900 }; 
	
	CString sName[] = {	"SLOT NO",
						"RECIPE NO",
						"GLASS LOADING TIME",
						"GLASS UNLOADING TIME" };

	CString sName2[] = {	"INCV_ION_CONT",		"INCV_ION_LEVEL",		"INCV_ION_COND",	"INCV_FFU1_PWR",	"INCV_FFU2_PWR",
							"INCV_FFU3_PWR",		"S3_TANK1_LV_L",		"S3_TANK1_LV_M",	"S3_TANK1_LV_H",	"S3_TANK1_LV_HH",
							"S4_TANK2_LV_L",		"S4_TANK2_LV_M",		"S4_TANK2_LV_H",	"S4_TANK2_LV_HH",	"AK_HEPA_PWR",		
							"BUF_ION_CONT",			"BUF_ION_LEVEL",		"BUF_ION_COND",		"OUTCV_FFU1_PWR",	"OUTCV_FFU2_PWR",	
							"OUTCV_FFU3_PWR",		"S2_RB1_UP_IGAP",		"S2_RB1_LO_IGAP",	"S2_RB2_UP_IGAP",	"S2_RB2_LO_IGAP",	
							"S3_RB1_UP_IGAP",		"S3_RB1_LO_IGAP",		"S3_RB2_UP_IGAP",	"S3_RB2_LO_IGAP",	"PINCYL_DN_TIME",	
							"PINCYL_UP_TIME",		"LD_UNIT_TIME",			"SWR1_UNIT_TIME",	"SWR2_UNIT_TIME",	"SWR3_UNIT_TIME",
							"SWR4_UNIT_TIME",		"AK_UNIT_TIME",			"BUF_UNIT_TIME",	"UL_UNIT_TIME",		};	//39ea
	int nNormalDataNo = sizeof( sName ) / sizeof( CString );
	int nNormalDataNo2 = sizeof( sName2 ) / sizeof( CString );
	
	int nRows	= nNormalDataNo + m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo + nNormalDataNo2;
	int nCols	= 4;
	int i;
	if( nRows <= 23 ) nColWidth[1] += 270;

	CString	sBuf;
	COLORREF color;
	
	m_gridApdData.SetRows( nRows + 1 ); 
	m_gridApdData.SetCols( nCols );

	//-------------------------------------------
	m_gridApdData.SetRow( 0 ); 
	
	for( i=0; i<nCols; i++ )
	{
		m_gridApdData.SetColWidth( i, nColWidth[i] );
		m_gridApdData.SetCol( i ); 
		m_gridApdData.SetCellAlignment( 4 );
		m_gridApdData.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridApdData.SetText( sLvcText[i] ); 
	}

	//SetDataToGridCtrl_ApdData();
	for( i=0; i<( nNormalDataNo + m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo + nNormalDataNo2 ); i++ )
	{
		if( i < nNormalDataNo || i > ( nNormalDataNo + m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo - 1 ) )
		{
			// 1st column
			m_gridApdData.SetCol( 0 );
			m_gridApdData.SetRow( i + 1 );
			m_gridApdData.SetCellAlignment( 4 );	// Center adjusted
			m_gridApdData.SetCellBackColor( LIGHT_ORANGE_COLOR );
			sBuf.Format( "%d", i + 1 ); 
			m_gridApdData.SetText( (LPCTSTR)sBuf );
			
			// 2nd column
			m_gridApdData.SetCol( 1 );
			m_gridApdData.SetRow( i + 1 );
			m_gridApdData.SetCellFontBold( TRUE );
			if( i < nNormalDataNo )	sBuf = sName[i];
			else					sBuf = sName2[i - m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo - nNormalDataNo];
			m_gridApdData.SetText( (LPCTSTR)sBuf );

			// 4th column
			if( i < nNormalDataNo )
			{
				m_gridApdData.SetCol( 3 );
				m_gridApdData.SetRow( i + 1 );
				m_gridApdData.SetCellAlignment( 4 );
				sBuf = " ";
				m_gridApdData.SetText( (LPCTSTR)sBuf );
			}
			else if( nNormalDataNo + m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo - 1 < i &&  i <= nNormalDataNo + m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo - 1 + 21)
			{
				m_gridApdData.SetCol( 3 );
				m_gridApdData.SetRow( i + 1 );
				m_gridApdData.SetCellAlignment( 4 );
				sBuf = " ";
				m_gridApdData.SetText( (LPCTSTR)sBuf );
				color = WHITE_COLOR;
				m_gridApdData.SetCellBackColor( color );
			}
			else if( nNormalDataNo + m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo - 1 + 21 < i && i<= nNormalDataNo + m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo - 1 + 29)
			{
				m_gridApdData.SetCol( 3 );
				m_gridApdData.SetRow( i + 1 );
				m_gridApdData.SetCellAlignment( 4 );
				sBuf = "mm";
				m_gridApdData.SetText( (LPCTSTR)sBuf );
				color = LIGHT_MAGENTA_COLOR;
				m_gridApdData.SetCellBackColor( color );
			}
			else 
			{
				m_gridApdData.SetCol( 3 );
				m_gridApdData.SetRow( i + 1 );
				m_gridApdData.SetCellAlignment( 4 );
				sBuf = "sec";
				m_gridApdData.SetText( (LPCTSTR)sBuf );
				color = LIGHT_MAGENTA_COLOR;
				m_gridApdData.SetCellBackColor( color );
			}
		}
		else
		{
			int nApdNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i-nNormalDataNo].nApdReportNo;
			if( nApdNo < 0 ) continue;
			// 1st column
			m_gridApdData.SetCol( 0 );
			m_gridApdData.SetRow( nNormalDataNo + nApdNo + 1 );
			m_gridApdData.SetCellAlignment( 4 );	// Center adjusted
			m_gridApdData.SetCellBackColor( LIGHT_ORANGE_COLOR );
			sBuf.Format( "%d", nNormalDataNo + nApdNo + 1 ); 
			m_gridApdData.SetText( (LPCTSTR)sBuf );
			
			// 2nd column
			m_gridApdData.SetCol( 1 );
			m_gridApdData.SetRow( nNormalDataNo + nApdNo + 1 );
			m_gridApdData.SetCellFontBold( TRUE );
			sBuf = m_pEqpAssy->m_AnalogInput.m_aiSet[i-nNormalDataNo].sName;
			m_gridApdData.SetText( (LPCTSTR)sBuf );

			// 4th column
			m_gridApdData.SetCol( 3 );
			m_gridApdData.SetRow( nNormalDataNo + nApdNo + 1 );
			m_gridApdData.SetCellAlignment( 4 );

			int nID = i-nNormalDataNo;
//			int nKind = m_pEqpAssy->m_AnalogInput.m_aiSet[i-nNormalDataNo].sKind;
			sBuf = m_pEqpAssy->m_AnalogInput.m_aiSet[i-nNormalDataNo].sKind;

			if( sBuf == "kPa" ) color = LIGHT_CYAN_COLOR;
			else if( sBuf == "lpm" ) color = LIGHT_RED_COLOR;
			else if( sBuf == "Pa" ) color = LIGHT_YELLOW_COLOR;
			else if( sBuf == "mm/s" ) color = WHITE_COLOR;
			else if( sBuf == "Mohm" ) color = WHITE_COLOR;
			else if( sBuf == "V" ) color = WHITE_COLOR;
			else if( sBuf == "deg" ) color = WHITE_COLOR;
			else if( sBuf == "L" ) color = WHITE_COLOR;
			else if( sBuf == "mW"  ) color = LIGHT_MAGENTA_COLOR;
			else color = WHITE_COLOR;	
			m_gridApdData.SetText( (LPCTSTR)sBuf );

			for( int j=1; j<nCols; j++ )
			{
				m_gridApdData.SetCol( j );
				m_gridApdData.SetCellBackColor( color );
			}
		}		
	}
}

void CJobsTabProcessDataView::GridInit_PartsData()
{
	CDicsData* pDicsData = ((CDicsView*)m_pView)->m_pDicsData;

	LPTSTR sLvcText[] = { " NO ", " NAME ", " GLS NO(EA) ", " USED TIME(H) " };
	int nColWidth[] = { 500, 3350, 1400, 1400 }; 
	
	int nRows	= MAX_PARTS_NO+1;
	int nCols	= 4;
	int i;
	if( nRows <= 10 ) nColWidth[1] += 270;

	CString	sBuf;

	m_gridPartsData.SetRows( nRows ); 
	m_gridPartsData.SetCols( nCols );

	//-------------------------------------------
	m_gridPartsData.SetRow( 0 );  
	for( i=0; i<nCols; i++ )
	{
		m_gridPartsData.SetColWidth( i, nColWidth[i] );
		m_gridPartsData.SetCol( i ); 
		m_gridPartsData.SetCellAlignment( 4 );
		m_gridPartsData.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridPartsData.SetText( sLvcText[i] ); 
	}


	for( i=0; i<MAX_PARTS_NO; i++ )
	{
		// 1st column
		m_gridPartsData.SetCol( 0 );
		m_gridPartsData.SetRow( i + 1 );
		m_gridPartsData.SetCellAlignment( 4 );	// Center adjusted
		m_gridPartsData.SetCellBackColor( LIGHT_ORANGE_COLOR );
		sBuf.Format( "%d", i + 1 ); 
		m_gridPartsData.SetText( (LPCTSTR)sBuf );

		// 2nd column
		m_gridPartsData.SetCol( 1 );
		m_gridPartsData.SetRow( i + 1 );
		m_gridPartsData.SetCellFontBold( TRUE );
		sBuf = m_pSetupItems->m_infoPartsLifeTimePara[i].sName;
		m_gridPartsData.SetText( (LPCTSTR)sBuf );
	}
	
	SetDataToGridCtrl_PartsData();
}


void CJobsTabProcessDataView::SetDataToGridCtrl_EdcData()
{
	int nUnitNo = IF_UNIT_UL*2 + 1;
	CString sBuf;
	CString	sEdcLog;
	
	CDicsView* pDicsView = (CDicsView*)m_pView;
	CDicsData* pDicsData = pDicsView->m_pDicsData;

/*	sEdcLog.Format( "%s", "Daily Check Report" );
	EdcLog.TextOut( sEdcLog );

	for( int i=0; i<MAX_EDC_DATA_NO; i++ )
	{
		// 3rd column
		// value
		m_gridEdcData.SetCol( 2 );
		m_gridEdcData.SetRow( i + 1 );
		m_gridEdcData.SetCellAlignment( 4 );
		sBuf = pDicsView->m_pCimSeq->m_sEDC[i];
		m_gridEdcData.SetText( (LPCTSTR)sBuf );

		CString sData[4];	
		sData[0].Format( "%d", i + 1 ); 
		m_gridEdcData.SetCol( 1 );	
		sData[1] = m_gridEdcData.GetText();
		m_gridEdcData.SetCol( 2 );	
		sData[2] = m_gridEdcData.GetText();
		m_gridEdcData.SetCol( 3 );	
		sData[3] = m_gridEdcData.GetText();
		sEdcLog.Format( "\t%s : %s %s", sData[1], sData[2], sData[3] );
		EdcLog.TextOut( sEdcLog );	
	}

	EdcLog.TextOut( "==============================================================" );*/
}

void CJobsTabProcessDataView::SetDataToGridCtrl_ApdData()
{
	
	CDicsView* pView = (CDicsView*)m_pView;
	CDicsData* pDicsData = pView->m_pDicsData;
	CDicsDoc* pDoc = ( (CDicsView*) m_pView )->GetDocument();
	
#ifndef _NO_UL_HAND			// 20100610 ssm
	int nUnitNo		= IF_UNIT_UL_HAND*2;
#else
	int nUnitNo		= IF_UNIT_UL*2 +1;
#endif

	int nMaxDataNo	= 4 + MAX_AI_INTR_NO + MAX_APD_STATUS_DATA_IO_NO; //CCimSeq::apdAI_START+pView->m_pAI1->m_nMaxApdAiNo;
	CString sBuf;
	CString	sApdLog;


	sApdLog.Format( "\tGLASS DATA : %04X/%04X",
					pDicsData->m_GlsInfo[nUnitNo].nGlassData[0],
					pDicsData->m_GlsInfo[nUnitNo].nGlassData[1] );
	ApdLog.TextOut( sApdLog );	

	for( int i=0; i<nMaxDataNo; i++ )
	{
		// 3rd column
		// value
		m_gridApdData.SetCol( 2 );
		m_gridApdData.SetRow( i + 1 );
		m_gridApdData.SetCellAlignment( 4 );
	
		sBuf = pDicsData->m_GlsInfo[nUnitNo].sApdData[i];
	
		if ( i == CDicsData::apdGLS_START_TIME || i == CDicsData::apdGLS_END_TIME )
		{
			if( sBuf.GetLength() >= 12 )
			{
				sBuf = sBuf.Mid(2,sBuf.GetLength() -2 );	//200219
				sBuf.Format("%s.%s.%s %s:%s:%s", 
							sBuf.Mid( 0, 2 ),
							sBuf.Mid( 2, 2 ),
							sBuf.Mid( 4, 2 ),
							sBuf.Mid( 6, 2 ),
							sBuf.Mid( 8, 2 ),
							sBuf.Mid(10, 2 ) );
				m_gridApdData.SetText( (LPCTSTR)sBuf );
			}
		}
		else
		{
			m_gridApdData.SetText( (LPCTSTR)sBuf );
		}

		CString sData[4];	
		sData[0].Format( "%d", i + 1 ); 
		m_gridApdData.SetCol( 1 );	
		sData[1] = m_gridApdData.GetText();
		m_gridApdData.SetCol( 2 );	
		sData[2] = m_gridApdData.GetText();
		m_gridApdData.SetCol( 3 );	
		sData[3] = m_gridApdData.GetText();
		sApdLog.Format( "\t%s : %s %s", sData[1], sData[2], sData[3] );
		ApdLog.TextOut( sApdLog );
	}

	pDicsData->WriteProfileGlassData( nUnitNo );
	
	ApdLog.TextOut( "\t==============================================================" );
}

void CJobsTabProcessDataView::SetDataToGridCtrl_PartsData()
{
	CString sBuf;

	CDicsData* pDicsData = ((CDicsView*)m_pView)->m_pDicsData;

	int nVal[2] ={0,};

	for( int i=0; i<MAX_PARTS_NO; i++ )
	{
		// 3rd column
		m_gridPartsData.SetCol( 2 );
		m_gridPartsData.SetRow( i + 1 );
		m_gridPartsData.SetCellAlignment( 4 );
		nVal[0]	= ((CDicsView*)m_pView)->m_pCommonIntrSeq->GetPartsGlsCount( i );
		nVal[1]	= m_pSetupItems->m_nValuePartsLifeTimePara[0][i];
		sBuf.Format( "%d / %d", nVal[0], nVal[1]);
		m_gridPartsData.SetText( (LPCTSTR)sBuf );
		if( nVal[0] >= nVal[1] ) m_gridPartsData.SetCellBackColor( LIGHT_RED_COLOR );
		else	m_gridPartsData.SetCellBackColor( WHITE_COLOR );

		// 4rd column
		m_gridPartsData.SetCol( 3 );
		m_gridPartsData.SetRow( i + 1 );
		m_gridPartsData.SetCellAlignment( 4 );
		nVal[0]	= ((CDicsView*)m_pView)->m_pCommonIntrSeq->GetPartsUsedTime( i );
		nVal[1]	= m_pSetupItems->m_nValuePartsLifeTimePara[1][i];
		sBuf.Format( "%d / %d", nVal[0], nVal[1]);
		m_gridPartsData.SetText( (LPCTSTR)sBuf );
		if( nVal[0] >= nVal[1] ) m_gridPartsData.SetCellBackColor( LIGHT_RED_COLOR );
		else	m_gridPartsData.SetCellBackColor( WHITE_COLOR );
	}
}

void CJobsTabProcessDataView::OnClose() 
{
	DeleteObject( m_hbrBgColor );
	DeleteObject( m_hbrTextColor );
	DeleteObject( m_hbrDarkGray );
	DeleteObject( m_hbrBlack );
	DeleteObject( m_hbrYellow );
	DeleteObject( m_hbrLightRed );
	DeleteObject( m_hbrLightBlue );
	DeleteObject( m_hbrLightYellow );
	DeleteObject( m_hbrLightGreen );
	DeleteObject( m_hbrLightCyan );
	DeleteObject( m_hbrLightMagenta );

	CFormView::OnClose();
}

BOOL CJobsTabProcessDataView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

LRESULT CJobsTabProcessDataView::OnEdcDataChanged( WPARAM wParam, LPARAM lParam )
{
	SetDataToGridCtrl_EdcData();
	return 0;
}

LRESULT CJobsTabProcessDataView::OnApdDataChanged( WPARAM wParam, LPARAM lParam )
{
	SetDataToGridCtrl_ApdData();
	return 0;
}

HBRUSH CJobsTabProcessDataView::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CFormView::OnCtlColor(pDC, pWnd, nCtlColor);
	
//	UINT id = pWnd->GetDlgCtrlID();
//	switch( nCtlColor )
//	{
//		case CTLCOLOR_STATIC:
//			if( id == IDC_STATIC_TITLE1 || 
//				id == IDC_STATIC_TITLE2 ||
//				id == IDC_STATIC_TITLE3 )
//			{
//				hbr = m_hbrBgColor;
//				pDC->SetBkMode( TRANSPARENT );
//				pDC->SetTextColor( BLACK_COLOR );
//			}
//			break;
//	}
//	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CJobsTabProcessDataView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	CFormView::OnTimer(nIDEvent);
}

void CJobsTabProcessDataView::UpdateObjects() 
{
	UpdatePartsStatus();
}

void CJobsTabProcessDataView::UpdatePartsStatus() 
{
	static int nOldVal[MAX_PARTS_NO][4] = { 0, };
	int nCurVal[MAX_PARTS_NO][4];

	BOOL bChange = FALSE;
	for( int i=0; i<MAX_PARTS_NO; i++ )
	{
		nCurVal[i][0]	= ((CDicsView*)m_pView)->m_pCommonIntrSeq->GetPartsGlsCount( i );
		nCurVal[i][1]	= m_pSetupItems->m_nValuePartsLifeTimePara[0][i];
		nCurVal[i][2]	= ((CDicsView*)m_pView)->m_pCommonIntrSeq->GetPartsUsedTime( i );
		nCurVal[i][3]	= m_pSetupItems->m_nValuePartsLifeTimePara[1][i];
		
		for( int j=0; j<4; j++ )
		if( nOldVal[i][j] != nCurVal[i][j] )
		{
			nOldVal[i][j] = nCurVal[i][j];
			bChange = TRUE;
		}
	}

	if( bChange )	SetDataToGridCtrl_PartsData();
	
}

BEGIN_EVENTSINK_MAP(CJobsTabProcessDataView, CFormView)
    //{{AFX_EVENTSINK_MAP(CJobsTabProcessDataView)
	ON_EVENT(CJobsTabProcessDataView, IDC_GRID_PARTS_DATA, -601 /* DblClick */, OnDblClickGridPartsData, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CJobsTabProcessDataView::OnDblClickGridPartsData() 
{
	int nRow = m_gridPartsData.GetRow();
	int nCol = m_gridPartsData.GetCol();

	if ( nRow == 0 || nCol == 0) return;

	if( AfxMessageBox("Do you want to clear Current Value ? ", MB_YESNO ) != IDYES )
	{
		return;
	}
	else
	{
		((CDicsView*)m_pView)->m_pCommonIntrSeq->ResetPartsData( nRow-1 );
		SetDataToGridCtrl_PartsData();		
	}
}



BOOL CJobsTabProcessDataView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
#define MAX_ID	2
	DWORD dw;
	if(zDelta <=0)	dw = SB_LINEDOWN;
	else			dw = SB_LINEUP;

	CRect rect;
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	int nID[MAX_ID] = { IDC_GRID_APD_DATA, IDC_GRID_PARTS_DATA};
	int i;
	for( i=0; i<MAX_ID; i++)
	{
		if(((CMSFlexGrid*)GetDlgItem( nID[i] ))->GetRows() <= 20) continue;

		GetDlgItem( nID[i] )->GetWindowRect( &rect );

		if(rect.left < pt.x && pt.x < rect.right && rect.top < pt.y && pt.y < rect.bottom)
		{
			GetDlgItem(nID[i])->SendMessage(WM_VSCROLL, dw, 0);
		}
	}

	return CFormView::OnMouseWheel(nFlags, zDelta, pt);
}
