//{{AFX_INCLUDES()
#include "msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_JOBSTABPROCESSDATAVIEW_H__F9253BBD_44F0_40C4_8CAA_A96AEDF503F6__INCLUDED_)
#define AFX_JOBSTABPROCESSDATAVIEW_H__F9253BBD_44F0_40C4_8CAA_A96AEDF503F6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// JobsTabProcessDataView.h : header file
//
#include "..\FactoryLib\EqpAssy.h"

/////////////////////////////////////////////////////////////////////////////
// CJobsTabProcessDataView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CJobsTabProcessDataView : public CFormView
{
public:
	CJobsTabProcessDataView();           // protected constructor used by dynamic creation
	CJobsTabProcessDataView( CView* pView, int nTabNo );
	DECLARE_DYNCREATE(CJobsTabProcessDataView)

	HBRUSH			m_hbrBgColor;
	HBRUSH			m_hbrTextColor;
	HBRUSH			m_hbrLightRed;
	HBRUSH			m_hbrLightBlue;
	HBRUSH			m_hbrLightYellow;
	HBRUSH			m_hbrDarkGray;
	HBRUSH			m_hbrLightGreen;
	HBRUSH			m_hbrLightCyan;
	HBRUSH			m_hbrLightMagenta;
	HBRUSH			m_hbrBlack;
	HBRUSH			m_hbrYellow;

// Form Data
public:
	//{{AFX_DATA(CJobsTabProcessDataView)
	enum { IDD = IDD_JOBS_TAB_PROCESS_DATA_VIEW };
	CMSFlexGrid	m_gridEdcData;
	CMSFlexGrid	m_gridApdData;
	CMSFlexGrid	m_gridPartsData;
	//}}AFX_DATA

// Attributes
public:
	CView*				m_pView;
	int					m_nTabNo;
	XCtlDevice*			m_pDevice;
	CSetupItems*		m_pSetupItems;
	CEqpAssy*			m_pEqpAssy;
	void SetEqpAssy( CEqpAssy* pEqpAssy ) { m_pEqpAssy = pEqpAssy; }

	void GridInit_EdcData();
	void GridInit_ApdData();
	void GridInit_PartsData();
	void SetDataToGridCtrl_EdcData();
	void SetDataToGridCtrl_ApdData();
	void SetDataToGridCtrl_PartsData();
	void UpdateObjects();
	void UpdatePartsStatus();

// Operations
public:
	void SetDevice( XCtlDevice* pDevice ) { m_pDevice = pDevice; }
	void SetSetupItems( CSetupItems* pSetupItems ) { m_pSetupItems = pSetupItems; }
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJobsTabProcessDataView)
	public:
	virtual void OnInitialUpdate();
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CJobsTabProcessDataView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CJobsTabProcessDataView)
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnDblClickGridPartsData();
	//}}AFX_MSG
	afx_msg LRESULT OnEdcDataChanged(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnApdDataChanged(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
	DECLARE_EVENTSINK_MAP()
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JOBSTABPROCESSDATAVIEW_H__F9253BBD_44F0_40C4_8CAA_A96AEDF503F6__INCLUDED_)
