// RecipesTab1View.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "RecipesTab1View.h"
#include "RecipesView.h"
#include "..\Dlg\DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRecipesTab1View

IMPLEMENT_DYNCREATE(CRecipesTab1View, CFormView)

CRecipesTab1View::CRecipesTab1View()
	: CFormView(CRecipesTab1View::IDD)
{
	//{{AFX_DATA_INIT(CRecipesTab1View)
	//}}AFX_DATA_INIT
}

CRecipesTab1View::CRecipesTab1View(CView* pView)
	: CFormView(CRecipesTab1View::IDD)
{
	m_pView			= pView;
}

CRecipesTab1View::~CRecipesTab1View()
{
}

void CRecipesTab1View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRecipesTab1View)
	DDX_Control(pDX, IDC_GRID_RECIPE_INFO, m_gridCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRecipesTab1View, CFormView)
	//{{AFX_MSG_MAP(CRecipesTab1View)
	//}}AFX_MSG_MAP
	ON_WM_MOUSEWHEEL()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRecipesTab1View diagnostics

#ifdef _DEBUG
void CRecipesTab1View::AssertValid() const
{
	CFormView::AssertValid();
}

void CRecipesTab1View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRecipesTab1View message handlers

BOOL CRecipesTab1View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CRecipesTab1View::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Get the recipe ID
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// Backup the value to RecipeInfoTemp[]
	int nRow = pDoc->GetRowfromID( pDoc->m_sRecipeId );
	pDoc->m_pRecipeInfoTemp[nRow] = pDoc->m_pRecipeInfo[nRow];
	
	// Set the Grid control
	GridInit();
}

//--------------------------------------------------------------------
// Initialize the GridCtrl
//--------------------------------------------------------------------
void CRecipesTab1View::GridInit()
{
	LPTSTR sLvcText[] = { " Recipe Items ", " Value " };
	int nColWidth[] = { 4450, 4500 }; 
//#ifndef _NO_RB
	int nRows = MAX_RECIPE_BODY_NO + 1;
// #else
// 	int nRows = MAX_RECIPE_BODY_NO + 1 - 16;
// #endif
// #ifdef _NO_EUV	// SanghoCho 2015.04.22
// 	nRows = nRows - 4;
// #endif
	if( nRows <= 25 ) nColWidth[0] += 270;
	// initialize GridCtrl
	m_gridCtrl.SetRows( nRows ); 
	m_gridCtrl.SetCols( 2 );

	//-------------------------------------------
	m_gridCtrl.SetRow( 0 );  
	m_gridCtrl.SetColWidth( 0, nColWidth[0] );
	m_gridCtrl.SetCol( 0 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridCtrl.SetColWidth( 1, nColWidth[1] );
	m_gridCtrl.SetCol( 1 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[1] ); 

	SetDataToGridCtrl();
}

//--------------------------------------------------------------------
// Set data
//--------------------------------------------------------------------
void CRecipesTab1View::SetDataToGridCtrl()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRow = pDoc->GetRowfromID( pDoc->m_sRecipeId );
	if( nRow < 0 ) return;

	CDaoFieldInfo FieldInfo;
//#ifndef _NO_RB
#ifdef _NO_EUV
	for( int i=0; i<MAX_RECIPE_BODY_NO; i++ )
#else
	for( int i=0; i<MAX_RECIPE_BODY_NO; i++ )
#endif
	{
		// 1st column
		pDoc->m_pRecipeSet->GetFieldInfo( i, FieldInfo );
		m_gridCtrl.SetCol( 0 );
		m_gridCtrl.SetRow( i + 1 );
		m_gridCtrl.SetCellAlignment( 4 );
		m_gridCtrl.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridCtrl.SetText( (LPCTSTR) FieldInfo.m_strName );

		// 2nd column
		m_gridCtrl.SetCol( 1 );
		m_gridCtrl.SetRow( i + 1 );
		
		// Set the background color
		RECIPE_INFO *pRecipeInfo = pDoc->m_pRecipeInfoTemp;

		if( FieldInfo.m_strName == "ID" || 
			FieldInfo.m_strName == "CHANGE TIME" ) m_gridCtrl.SetCellBackColor( BG_COLOR_DISABLE );
		else m_gridCtrl.SetCellBackColor( BG_COLOR_INT );

		if( FieldInfo.m_nType == dbBoolean ) 
		{
			if( pRecipeInfo[nRow].sValue[i] == "ON" ||
				pRecipeInfo[nRow].sValue[i] == "CW" || 
				pRecipeInfo[nRow].sValue[i] == "FW" || 
				pRecipeInfo[nRow].sValue[i] == "YES" ) 
			{
				m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
				m_gridCtrl.SetCellForeColor( BLACK_COLOR );
			}
			else 
			{
				m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
				m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			}
		}
		m_gridCtrl.SetText( (LPCTSTR) pRecipeInfo[nRow].sValue[i] );
		m_gridCtrl.SetCellAlignment( 4 );
	}
// #else
// #ifdef _NO_EUV
// 	for( int i=0; i<MAX_RECIPE_BODY_NO-16-4; i++ )
// #else
// 	for( int i=0; i<MAX_RECIPE_BODY_NO-16; i++ )
// #endif
// 	{
// 		// 1st column
// 		pDoc->m_pRecipeSet->GetFieldInfo( i, FieldInfo );
// 		m_gridCtrl.SetCol( 0 );
// 		m_gridCtrl.SetRow( i + 1 );
// 		m_gridCtrl.SetCellAlignment( 4 );
// 		m_gridCtrl.SetCellBackColor( LIGHT_CYAN_COLOR );
// 		m_gridCtrl.SetText( (LPCTSTR) FieldInfo.m_strName );
// 
// 		// 2nd column
// 		m_gridCtrl.SetCol( 1 );
// 		m_gridCtrl.SetRow( i + 1 );
// 		
// 		// Set the background color
// 		RECIPE_INFO *pRecipeInfo = pDoc->m_pRecipeInfoTemp;
// 
// 		if( FieldInfo.m_strName == "ID" || 
// 			FieldInfo.m_strName == "CHANGE TIME" ) m_gridCtrl.SetCellBackColor( BG_COLOR_DISABLE );
// 		else m_gridCtrl.SetCellBackColor( BG_COLOR_INT );
// 
// 		if( FieldInfo.m_nType == dbBoolean ) 
// 		{
// 			if( pRecipeInfo[nRow].sValue[i] == "ON" ||
// 				pRecipeInfo[nRow].sValue[i] == "CW" || 
// 				pRecipeInfo[nRow].sValue[i] == "FW" || 
// 				pRecipeInfo[nRow].sValue[i] == "YES" ) 
// 			{
// 				m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
// 				m_gridCtrl.SetCellForeColor( BLACK_COLOR );
// 			}
// 			else 
// 			{
// 				m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
// 				m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
// 			}
// 		}
// 		m_gridCtrl.SetText( (LPCTSTR) pRecipeInfo[nRow].sValue[i] );
// 		m_gridCtrl.SetCellAlignment( 4 );
// 	}
// #endif

}

//--------------------------------------------------------------------
// Message Handler : OnDblClickRecipeInfo
//--------------------------------------------------------------------

BEGIN_EVENTSINK_MAP(CRecipesTab1View, CFormView)
    //{{AFX_EVENTSINK_MAP(CRecipesTab1View)
	ON_EVENT(CRecipesTab1View, IDC_GRID_RECIPE_INFO, -601 /* DblClick */, OnDblClickGridRecipeInfo, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CRecipesTab1View::OnDblClickGridRecipeInfo() 
{
	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	CDicsView* pView = (CDicsView*)pApp->m_pMainView;
	CDicsDoc* pDoc = (CDicsDoc*)( m_pView->GetDocument() );
	CString	sMsg;

	int nRow = m_gridCtrl.GetRow();
	int nCol = m_gridCtrl.GetCol();

	if( nRow == 0 ) return;

	if( pDoc->m_pDicsView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idADMIN && 
		nRow != 4 ) return;
	//2008.11.19 KIMGUN
//	if( pDoc->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUSE_EUV] == 0 &&
//		nRow > 6 && nRow < 11 )
//	{
//		AfxMessageBox( "EUV NO USE." );
//		return;
//	}

	if( pDoc->m_pDicsView->m_pDicsData->m_GenInfo.nGlassNo )
	{
		AfxMessageBox( "Equipment is not empty. You can't change Recipe Body." );
		return;
	}
	
	if( pDoc->m_pDicsView->m_pDicsData->m_GenInfo.bAuto )
	{
		AfxMessageBox( "Equipment is not Manual Mode. You can't change Recipe Body." );
		return;
	}

	RECIPE_INFO *pRecipeInfo = pDoc->m_pRecipeInfoTemp;
	int i = pDoc->GetRowfromID( pDoc->m_sRecipeId );

	if( m_gridCtrl.GetCellBackColor() == BG_COLOR_BOOL_ON || 
		m_gridCtrl.GetCellBackColor() == BG_COLOR_BOOL_OFF )
	{
		CString sVal = m_gridCtrl.GetText();
		CString	sOldVal;
		sOldVal = sVal;

		if( sVal == "ON" )
		{ 
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
			m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sVal = "OFF"; 
		}
		else if( sVal == "OFF" )
		{ 
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridCtrl.SetCellForeColor( BLACK_COLOR );
			sVal = "ON";
		}
		else if( sVal == "FW" )
		{ 
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
			m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sVal = "BW"; 
		}
		else if( sVal == "BW" )
		{
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridCtrl.SetCellForeColor( BLACK_COLOR );
			sVal = "FW";
		}
		else if( sVal == "CW" )
		{ 
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
			m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sVal = "CCW"; 
		}
		else if( sVal == "CCW" )
		{
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridCtrl.SetCellForeColor( BLACK_COLOR );
			sVal = "CW";
		}
		else if( sVal == "YES" )
		{
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sVal = "NO";
		}
		else if( sVal == "NO" )
		{
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridCtrl.SetCellForeColor( BLACK_COLOR );
			sVal = "YES";
		}

		if( sOldVal != sVal )
		{
			m_gridCtrl.SetText( (LPCTSTR) sVal );

			// Set the recipe body to temperary variable
			pRecipeInfo[i].sValue[nRow - 1] = sVal;
			
			sMsg.Format( "RCP CHANGE : %s ( %s -> %s )", pRecipeInfo[i].sName[nRow - 1], 
														 sOldVal, sVal );
			( (CRecipesView*) m_pView )->SetLog( "RECIPE  ", -1, -1, sMsg );
		}
	}
	else if( m_gridCtrl.GetCellBackColor() == BG_COLOR_INT )
	{
		CDlgEditVal dlg;
		dlg.m_sCurVal = dlg.m_sOldVal = m_gridCtrl.GetText();
		dlg.m_nType = CDlgEditVal::typeINPUT;
	
		int nIndex = nRow - 1;

		switch( nIndex )
		{	
		case CDaoRecipeSet::rcpCOMMENT :
			dlg.m_nFormat = CDlgEditVal::formatSTRING;				
			break;
		case CDaoRecipeSet::rcpTACT_TIME :
			dlg.m_bSetLimit = TRUE;
			dlg.m_dHigh = 200.;
			dlg.m_dLow	= 35.;
			dlg.m_nFormat = CDlgEditVal::formatDIGIT;	
			break;
		case CDaoRecipeSet::rcpCV_SPEED :
			dlg.m_bSetLimit = TRUE;
			dlg.m_dHigh = 20000.;
			dlg.m_dLow	= 1000.;
			dlg.m_nFormat = CDlgEditVal::formatDIGIT;	
			break;
		case CDaoRecipeSet::rcpSWR2_UP_RB1_GAP :
		case CDaoRecipeSet::rcpSWR2_LO_RB1_GAP :
		case CDaoRecipeSet::rcpSWR2_UP_RB2_GAP :
		case CDaoRecipeSet::rcpSWR2_LO_RB2_GAP :
		case CDaoRecipeSet::rcpSWR3_UP_RB1_GAP :
		case CDaoRecipeSet::rcpSWR3_LO_RB1_GAP :
		case CDaoRecipeSet::rcpSWR3_UP_RB2_GAP :
		case CDaoRecipeSet::rcpSWR3_LO_RB2_GAP :
			dlg.m_bSetLimit = TRUE;
			dlg.m_dHigh = 2.0;
			dlg.m_dLow	= 0.0;
			dlg.m_nFormat = CDlgEditVal::formatFLOAT;						
			break;
		case CDaoRecipeSet::rcpSWR2_UP_RB1_SPEED :
		case CDaoRecipeSet::rcpSWR2_LO_RB1_SPEED :
		case CDaoRecipeSet::rcpSWR2_UP_RB2_SPEED :
		case CDaoRecipeSet::rcpSWR2_LO_RB2_SPEED :
		case CDaoRecipeSet::rcpSWR3_UP_RB1_SPEED :
		case CDaoRecipeSet::rcpSWR3_LO_RB1_SPEED :
		case CDaoRecipeSet::rcpSWR3_UP_RB2_SPEED :
		case CDaoRecipeSet::rcpSWR3_LO_RB2_SPEED :
			dlg.m_bSetLimit = TRUE;
			dlg.m_dHigh = 600.;
			dlg.m_dLow	= 100.;
			dlg.m_nFormat = CDlgEditVal::formatDIGIT;			
			break;
		}
		
		if( dlg.DoModal() == IDOK && dlg.m_sOldVal != dlg.m_sCurVal)
		{
			m_gridCtrl.SetRowSel( nRow );
			m_gridCtrl.SetColSel( nCol );
			m_gridCtrl.SetText( (LPCTSTR) dlg.m_sCurVal );

			// Set the recipe body to temperary variable
			pRecipeInfo[i].sValue[nIndex] = dlg.m_sCurVal;
	
			sMsg.Format( "RCP CHANGE : %s ( %s -> %s )", pRecipeInfo[i].sName[nRow - 1], 
														 dlg.m_sOldVal, dlg.m_sCurVal );
			( (CRecipesView*)pView )->SetLog( "RECIPE  ", -1, -1, sMsg );
		}
	}

	// Apply the value to "All Recipe View" tab.
	( (CRecipesView*) m_pView )->m_pTabRecipesTab2View->SetDataToGridCtrl( i );
}



BOOL CRecipesTab1View::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
#define MAX_ID	1
	DWORD dw;
	if(zDelta <=0)	dw = SB_LINEDOWN;
	else			dw = SB_LINEUP;

	CRect rect;
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	int nID[MAX_ID] = { IDC_GRID_RECIPE_INFO};
	int i;
	for( i=0; i<MAX_ID; i++)
	{
		if(((CMSFlexGrid*)GetDlgItem( nID[i] ))->GetRows() <= 18) continue;

		GetDlgItem( nID[i] )->GetWindowRect( &rect );

		if(rect.left < pt.x && pt.x < rect.right && rect.top < pt.y && pt.y < rect.bottom)
		{
			GetDlgItem(nID[i])->SendMessage(WM_VSCROLL, dw, 0);
		}
	}
	return CFormView::OnMouseWheel(nFlags, zDelta, pt);
}
