// RecipesView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "RecipesView.h"
#include "..\Dlg\DlgEditVal.h"
#include "..\Dlg\DlgSelectID.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRecipesView

IMPLEMENT_DYNCREATE(CRecipesView, CFormView)

CRecipesView::CRecipesView()
	: CFormView(CRecipesView::IDD)
{
	//{{AFX_DATA_INIT(CRecipesView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_pTabRecipesTab1View	= NULL;
	m_nViewNo				= 0;
}

CRecipesView::~CRecipesView()
{
	GetDocument()->m_pRecipesWnd = NULL;
}

void CRecipesView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRecipesView)
	DDX_Control(pDX, IDC_TAB_RECIPES, m_tabCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRecipesView, CFormView)
	//{{AFX_MSG_MAP(CRecipesView)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_MESSAGE( WM_SEL_CHANGE_TAB, OnSelChangeTab )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRecipesView diagnostics

#ifdef _DEBUG
void CRecipesView::AssertValid() const
{
	CFormView::AssertValid();
}

void CRecipesView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CDicsDoc* CRecipesView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDicsDoc)));
	return (CDicsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRecipesView message handlers

void CRecipesView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Set the current view pointer
	GetDocument()->SetRecipesView( this );
	
	// Create the TAB view 
	CRect r;
	GetDlgItem( IDC_TAB_RECIPES )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 0, 0, 6, 30 );

	m_pTabRecipesTab1View = new CRecipesTab1View( this );
	CCreateContext context;
	m_pTabRecipesTab1View->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CRecipesTab1View::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabRecipesTab1View, "    ONE RECIPE VIEW    ", 0 );
	m_pTabRecipesTab1View->SetFocus();

	m_pTabRecipesTab2View = new CRecipesTab2View( this );
	m_pTabRecipesTab2View->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CRecipesTab2View::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabRecipesTab2View, "    ALL RECIPE VIEW    ", 1 );

	m_tabCtrl.SetSelectedColor( RED_COLOR );
	m_tabCtrl.SetMouseOverColor( GREEN_COLOR );
	m_tabCtrl.SetNormalColor( DARK_GRAY_COLOR );
}

void CRecipesView::OnDestroy() 
{
	CFormView::OnDestroy();
	
	if( m_pTabRecipesTab1View ) 
	{
		m_pTabRecipesTab1View->SendMessage( WM_CLOSE );
		delete m_pTabRecipesTab1View;
	}

	if( m_pTabRecipesTab2View ) 
	{
		m_pTabRecipesTab2View->SendMessage( WM_CLOSE );
		delete m_pTabRecipesTab2View;
	}
}

//---------------------------------------------------------------------------
// Tab selection is changed
//---------------------------------------------------------------------------
LRESULT CRecipesView::OnSelChangeTab( WPARAM wParam, LPARAM lParam )
{
	m_nViewNo = wParam;

	if( m_nViewNo==0 )		m_pTabRecipesTab1View->SetFocus();
	else if(m_nViewNo ==1 )	m_pTabRecipesTab2View->SetFocus();
	return 0;
}

//---------------------------------------------------------------------------
// OnRecipesSelect
//---------------------------------------------------------------------------
void CRecipesView::OnRecipesSelect()
{
	// Check the whether it is saved or not.
	CDicsDoc* pDoc = GetDocument();
	if( pDoc->IsRecipeChanged( pDoc->m_sRecipeId ) ) 
	{
		if( AfxMessageBox( "There is some changes of recipe value. \r\n"
			"Do you want to save it anyway ?", MB_YESNO ) == IDYES ) Save( pDoc->m_sRecipeId );
	}

	// Select another recipe
	CDlgSelectID dlg;
	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	CDicsView* pView = (CDicsView *) pApp->m_pMainView;

	dlg.m_sOldVal.Format( "%s",  pDoc->m_sRecipeId );
	dlg.SetView( pView );
		
//	CDlgEditVal dlg;
//
//	dlg.m_sCurVal.Format( "%d", pDoc->m_nRecipeId );
//	dlg.m_sOldVal = dlg.m_sCurVal;
//	dlg.m_nType = CDlgEditVal::typeINPUT;

	if( dlg.DoModal() == IDOK )
	{
		if( dlg.m_sCurVal == "" ) return;

		CString sRecipeId = dlg.m_sCurVal;
		
		if( sRecipeId != pDoc->m_sRecipeId )
		{
			int nRow = pDoc->GetRowfromID( sRecipeId );

			if( nRow == -1 )
			{
				AfxMessageBox( "Can not Select this RecipeNo : Not Exist" );
				return;
			}

			// Save the recipe ID
			pDoc->m_sRecipeId = sRecipeId;

			// Display the recipe value that is selected
			m_pTabRecipesTab1View->SetDataToGridCtrl();
			
			// Backup the value to RecipeInfoTemp[]
			pDoc->m_pRecipeInfoTemp[nRow] = pDoc->m_pRecipeInfo[nRow];

			pDoc->SetRecipeId();

//			CDicsApp* pApp = (CDicsApp*) AfxGetApp();
//			CDicsView* pView = (CDicsView*) pApp->m_pMainView;
//
//			pView->m_pDicsData->m_IfCim.bRecipeNoChangeReq	= TRUE;
//			pView->m_pDicsData->m_IfCim.nRecipeId			= sRecipeId;
//			pView->m_pDicsData->m_GenInfo.sRecipeId			= nsecipeId;

// for test
			pView->m_pMainSeq->SetRecipe2JobCond( pDoc->m_sRecipeId );
		}
	}
}

//---------------------------------------------------------------------------
// OnRecipesCopy
//---------------------------------------------------------------------------
void CRecipesView::OnRecipesCopy()
{
	CDicsDoc*	pDoc = GetDocument();
	CDicsApp*	pApp = (CDicsApp*)AfxGetApp();
	CDicsView* pView = (CDicsView *) pApp->m_pMainView;

	int nRowFrom = m_pTabRecipesTab2View->m_gridCtrl.GetRow();
	nRowFrom = ( nRowFrom > 0 ) ? nRowFrom : 1 ;
	
	if( pDoc->IsRecipeChanged() ) 
	{
		if( AfxMessageBox( "There is some changes of recipe value. \r\n"
			"Do you want to save it anyway ?", MB_YESNO ) == IDYES ) Save();
	}

	m_pTabRecipesTab2View->m_gridCtrl.SetRow( nRowFrom );

	CDlgSelectID dlg;


	dlg.m_sOldVal = m_pTabRecipesTab2View->m_gridCtrl.GetTextMatrix( nRowFrom, 0 );
	dlg.m_nType = CDlgSelectID::typeCOPY;
	dlg.SetView( pView );

	if( dlg.DoModal() == IDOK )
	{
		if( dlg.m_sCurVal == "" ) return;

		int nRowTo = pDoc->GetRowfromID( dlg.m_sCurVal );
	
		// Backup the recipe ID
		CString sRecipeID = pDoc->m_pRecipeInfoTemp[nRowTo].sValue[0];
		pDoc->m_pRecipeInfoTemp[nRowTo] = pDoc->m_pRecipeInfoTemp[nRowFrom-1];
		// It is not good idea, but use this way.
		pDoc->m_pRecipeInfoTemp[nRowTo].sValue[0] = sRecipeID;

		// Apply the value to "One Recipe View" tab.
		if( dlg.m_sCurVal == pDoc->m_sRecipeId )
			m_pTabRecipesTab1View->SetDataToGridCtrl();

		// Apply the value to "All Recipe View" tab.
		m_pTabRecipesTab2View->SetDataToGridCtrl( nRowTo );

		// Set the cursor at original position
		m_pTabRecipesTab2View->m_gridCtrl.SetRowSel( nRowFrom );
	}
}

//---------------------------------------------------------------------------
// OnRecipesSave
//---------------------------------------------------------------------------
void CRecipesView::OnRecipesSave()
{
	CDicsDoc* pDoc = GetDocument();
	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	CDicsView* pView = (CDicsView*)pApp->m_pMainView;
	CString	sMsg;

 	if( m_nViewNo == 0 ) // One View 
	{
		if( !pDoc->IsRecipeChanged( pDoc->m_sRecipeId ) ) return;
	}
	else // All View
	{
		if( !pDoc->IsRecipeChanged() ) return;
	}

	if( AfxMessageBox( "Do you really want to save the recipe value ?", MB_YESNO ) == IDNO ) return;

	if( m_nViewNo == 0 )
	{
		Save( pDoc->m_sRecipeId );
		sMsg.Format( "Recipe Save : ID %s", pDoc->m_sRecipeId );
		if( !pView->m_pDicsData->m_GenInfo.bEqpInitComp || pView->m_pDicsData->m_GenInfo.nGlassNo == 0 )//2009.01.08 kimgun
		( (CDicsView*)pView )->m_pMainSeq->SetRecipe2JobCond( pDoc->m_sRecipeId );//2008.12.03 kimgun
		( (CRecipesView*)pView )->SetLog( "RECIPE  ", 0, 0, sMsg );
	}
	else
	{
		Save();
		sMsg.Format( "Recipe Save : All" );
		if( !pView->m_pDicsData->m_GenInfo.bEqpInitComp || pView->m_pDicsData->m_GenInfo.nGlassNo == 0 )//2009.01.08 kimgun
		( (CDicsView*)pView )->m_pMainSeq->SetRecipe2JobCond( pDoc->m_sRecipeId );//2008.12.03 kimgun
		( (CRecipesView*)pView )->SetLog( "RECIPE  ", 0, 0, sMsg );
	}

	pView->m_pDicsData->m_GenInfo.bRecipeBodyChanged = TRUE;

}

//---------------------------------------------------------------------------
// OnRecipesSave
//---------------------------------------------------------------------------
void CRecipesView::Save(CString sRecipeId)
{
	CDicsDoc* pDoc = GetDocument();

	if( sRecipeId.GetLength() == 0 )	// All Recipe
	{
		for( int nRow=0; nRow<pDoc->m_nMaxRow; nRow++ )
		{
			CString sId = pDoc->m_pRecipeInfoTemp[nRow].sValue[CDaoRecipeSet::rcpID];
			if( !pDoc->IsRecipeChanged( sId ) ) continue;

			// Set the value to RecipeInfo[]
			pDoc->m_pRecipeInfo[nRow] = pDoc->m_pRecipeInfoTemp[nRow];
			
			// get the change time of recipe value
			pDoc->m_pRecipeInfo[nRow].dtChangeTime = COleDateTime::GetCurrentTime();

			// Save to database
			pDoc->m_pRecipeSet->SetRecipeInfo( pDoc->m_pRecipeInfo[nRow].sValue[0], pDoc->m_pRecipeInfo[nRow] );

			// Backup the value to RecipeInfoTemp[]
			pDoc->m_pRecipeInfoTemp[nRow] = pDoc->m_pRecipeInfo[nRow];

			// Display the recipe value again (because of date/time)
			m_pTabRecipesTab2View->SetDataToGridCtrl( nRow );
		}

		// Because of date/time
		m_pTabRecipesTab1View->SetDataToGridCtrl();
	}
	else	// One recipe
	{
		// Set the value to RecipeInfo[]
		int nRow = pDoc->GetRowfromID( sRecipeId );
		pDoc->m_pRecipeInfo[nRow] = pDoc->m_pRecipeInfoTemp[nRow];
		
		// get the change time of recipe value
		pDoc->m_pRecipeInfo[nRow].dtChangeTime = COleDateTime::GetCurrentTime();

		// Save to database
		pDoc->m_pRecipeSet->SetRecipeInfo( sRecipeId, pDoc->m_pRecipeInfo[nRow] );

		// Backup the value to RecipeInfoTemp[]
		pDoc->m_pRecipeInfoTemp[nRow] = pDoc->m_pRecipeInfo[nRow];

		// Display the recipe value again (because of date/time)
		m_pTabRecipesTab1View->SetDataToGridCtrl();
		m_pTabRecipesTab2View->SetDataToGridCtrl( nRow );

		// Inform to M/PLC
		CDicsApp* pApp = (CDicsApp*) AfxGetApp();
		CDicsView* pView = (CDicsView*) pApp->m_pMainView;
		
//		pView->m_pDicsData->m_IfCim.nModifyRecipeNo			= nRecipeId;
//		pView->m_pDicsData->m_IfCim.bRecipeModifyReportReq	= TRUE;

//		pView->m_pDicsData->m_IfCim.nRecipeId = nRecipeId;
//		pView->m_pDicsData->m_GenInfo.sRecipeId = sRecipeId;
	}

	// Set the current running recipe ID
	pDoc->SetRecipeId();
}

void CRecipesView::OnRecipesAdd()
{
	// Check the whether it is saved or not.
	CDicsDoc* pDoc = GetDocument();
	if( pDoc->IsRecipeChanged() ) 
	{
		if( AfxMessageBox( "There is some changes of recipe value. \r\n"
			"Do you want to save it anyway ?", MB_YESNO ) == IDYES ) Save();
	}

	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	CDicsView* pView = (CDicsView *) pApp->m_pMainView;
	CDlgEditVal dlg;

	dlg.m_nFormat = CDlgEditVal::formatDIGIT;
	dlg.m_nType = CDlgEditVal::typeINPUT;

	if( dlg.DoModal() == IDOK )
	{	
		CString sId = dlg.m_sCurVal;

//		if( nRcpId <= 0 || nRcpId > 32767 )
//		{
//			AfxMessageBox( "Wrong recipe ID" );
//		}
		int nCnt = sId.GetLength();
		if( nCnt == 0 || nCnt > 2 )
		{
			AfxMessageBox( "Wrong recipe ID" );
		}
//		else if( pView->GetDocument()->m_pRecipeSet->FindRecipe( sId ) ) 
		else if( pView->GetDocument()->GetRowfromID( sId ) > -1 )
		{
			AfxMessageBox( "Can not Add Recipe ID : Already Exist ID" );
		}
		else
		{
			if( IDYES == AfxMessageBox( "Do you really want to Add new recipe ID?", 
			MB_YESNO | MB_ICONQUESTION ) )
			{
				// Insert new Recipe data
				pDoc->m_pRecipeSet->AddRecipeId( sId );

				// Make new m_nRecipeInfo[] & m_nRecipeInfoTemp[]
				pDoc->UpDateRecipeData();

				// Redraw RecipesTab2View
//				m_pTabRecipesTab2View->GridInit();
				m_pTabRecipesTab2View->m_gridCtrl.SetRows(pDoc->m_nMaxRow + 1);
				m_pTabRecipesTab2View->SetDataToGridCtrl();
			}
		}
	}
}

void CRecipesView::OnRecipesDelete()
{
	// If you didn't select	
	int nSeletRow = m_pTabRecipesTab2View->m_gridCtrl.GetRow();
	if( nSeletRow == 0 ) return;
	
	// Check the whether it is saved or not.
	CDicsDoc* pDoc = GetDocument();
	if( pDoc->IsRecipeChanged() ) 
	{
		if( AfxMessageBox( "There is some changes of recipe value. \r\n"
			"Do you want to save it anyway ?", MB_YESNO ) == IDYES ) Save();
	}
	
//	CString sSelectId;
//	sSelectId = m_pTabRecipesTab2View->m_gridCtrl.GetTextMatrix( m_pTabRecipesTab2View->m_nSelectedRow, 1 );
	
	CString sSelectId = m_pTabRecipesTab2View->m_gridCtrl.GetTextMatrix( nSeletRow, 0 );

	CString sTmp("");
	sTmp.Format("Do you really want to delete recipe : %s ?", sSelectId );

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	// If you select current ID
	if( pDoc->m_sRecipeId == sSelectId || 
		pView->m_pDicsData->m_GenInfo.sRecipeId == sSelectId )
	{
		AfxMessageBox("Current Recipe ID!! If you want to delete this, change Recipe ID.", MB_OK | MB_ICONWARNING);
		return;
	}
	else if( IDYES == AfxMessageBox( sTmp, MB_YESNO | MB_ICONQUESTION ) )
	{

//		pView->m_pDicsData->m_IfCim.nDeleteRecipeNo		= nSelectId;
//		pView->m_pDicsData->m_IfCim.bRecipeDeleteReq	= TRUE;
		
//		// Delete data
		pDoc->m_pRecipeSet->DeleteRecipeId(sSelectId);
		pDoc->UpDateRecipeData();
		OnRecipesDeleteUpdate();
	}
}

void CRecipesView::OnRecipesDeleteUpdate()
{
	CDicsDoc *pDoc = GetDocument();
	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	CDicsView* pView = (CDicsView *) pApp->m_pMainView;

	// Redraw RecipesTab2View
//	m_pTabRecipesTab2View->GridInit();
	m_pTabRecipesTab2View->m_gridCtrl.SetRows( pDoc->m_nMaxRow + 1 );
	m_pTabRecipesTab2View->SetDataToGridCtrl();
}


void CRecipesView::SetLog(CString sSeqName, int nPortNo, int nSlotNo, CString sMessage)
{
	CDicsApp* pApp = ( CDicsApp * )AfxGetApp();
	CDicsView* pView = ( CDicsView * )pApp->m_pMainView;

	// Log
	CString sLog;
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	sLog.Format( "BTN     \t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( sLog );

	if( pView->m_pDicsData->m_GenInfo.bEnableEqpLog )
	{
		sLog.Format( "%s : %s", sSeqName, sMessage );
		pView->SendMessage( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) sLog );
	}
}