//{{AFX_INCLUDES()
#include "..\msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_SERVOTABSEMIAUTOVIEW_H__91B7989D_0CCF_4022_9CA1_F3DB5B411E54__INCLUDED_)
#define AFX_SERVOTABSEMIAUTOVIEW_H__91B7989D_0CCF_4022_9CA1_F3DB5B411E54__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ServoTabSemiAutoView.h : header file
//
#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\X\XMmc.h"
#include "..\X\MacButtons.h"
#include "..\X\PointListCtrl.h"
#include "..\X\colorbtn.h"	// Added by ClassView
#include "..\DicsData.h"
#include "..\DefineConstant.h"
#include "..\View\SetupItems.h"
#include "..\FactoryLib\EqpAssy.h"
/////////////////////////////////////////////////////////////////////////////
// CServoTabSemiAutoView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CServoTabSemiAutoView : public CFormView
{
public:
	CServoTabSemiAutoView();           // protected constructor used by dynamic creation
	CServoTabSemiAutoView( CView* pView );
	DECLARE_DYNCREATE(CServoTabSemiAutoView)

	CColorStatic m_MoveMsg[2];
	CColorStatic m_AlarmMsg;
//	static CString m_sRbtName[MAX_TR_RBT_NO+1];

	struct _tagRBT_IF{
		BOOL bRECV_RDY;
		BOOL bSEND_RDY;
		BOOL bRECV_COMP;
		BOOL bSEND_COMP;
		
		BOOL bREV_RECV_RDY;
		BOOL bREV_SEND_RDY;
		BOOL bREV_RECV_COMP;
		BOOL bREV_SEND_COMP;

		BOOL bINIT_POS;
		BOOL bSAFE_POS;
		BOOL bFAIL;
		BOOL bERROR;
		int nROLE; // roleRCV, roleSND;
	}m_RBT_IF[MAX_RBT_NO];

	enum _role{
		roleNONE,
		roleRECV, 
		roleSEND,
		roleREV_RECV,
		roleREV_SEND,
	};
	
	RBT_VEL			m_rvVel[MAX_RBT_NO];
	enum _FOCUS{ fcsFROM, fcsTO };
// Form Data
public:
	//{{AFX_DATA(CServoTabSemiAutoView)
	enum { IDD = IDD_SERVO_TAB_SEMI_AUTO_VIEW };
	CListBox	m_lbSeqLog;
	CMSFlexGrid	m_gridCtrl;
	CMacButton  m_macMove;
	CMacButton  m_macCancel;
	CMacButton  m_macAlarmReset;
	//}}AFX_DATA
	CMacButton  m_macServoButton[6];
	CMacCheckBox	m_macJointStatus[6];

// Attributes
public:
	CView*			m_pView;
	XCtlDevice*		m_pDevice;
	XMmc*			m_pMmc;
	CEqpAssy*		m_pEqpAssy;

	CDicsData*		m_pDicsData;
	CSetupItems*	m_pSetupItems;

	CString			m_sMessage;
	CColorButton	m_btnFrom;
	CColorButton	m_btnTo;

	int m_nOnFocus;
	int m_nArray[2];

	int m_nSeqUpCvSemiAutoNo;
	int m_nSeqLdUpdnSemiAutoNo;

	int	m_nSeqTrAlignNo;
	int	m_nSeqTrTurnNo;

	int m_nRobotReadyComp;
	int m_nSeqRobotReadyNo;
	int m_nAction;
	int m_nSeqGlassMoveNo;
	int m_nBeforeSendPosNo;
	int m_nBeforeRcvPosNo;
	int m_nRevBeforeSendPosNo;
	int m_nRevBeforeRecvPosNo;

	int m_nSeqTrMoveRbtPosNo;
	int m_nSeqTrJointNo;
	int m_nSeqFishRibNo;

	int m_nJointPos;

	BOOL m_bAlarm;
	BOOL m_bAlarmReset;
	BOOL m_bAlarmResetLdUpdn;
	BOOL m_bAutoMove;
	BOOL m_bBufCvStart;
	BOOL m_bAllCvStart;
	// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CServoTabSemiAutoView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	int	SeqTrAlign(int nType);
	int SeqTrMoveRbtPos(INT nRbtType, INT nPosNo);

	BOOL SeqFishRib(int nUnit, BOOL bAction);
	BOOL SeqTrJoint(int nPos, BOOL bAction);

	void SeqUpCvSemiAuto();
	void SeqLdUpdnSemiAuto();

	void GridInit();
	void SetDataToGridCtrl();
	void SetButton( int nID );
	void DisplayRbtFormInfo();

	int GetGlassExist( int nUnit );
	int GetJointPos();
	int IsTrJointConfirm();
	int IsTrGlassExist();

	BOOL IsCylinderSS(int nNO);
	BOOL IsTrPinAlign( int nPos,  BOOL bStatus );

	void SetDicsData( CDicsData * pDicsData ){m_pDicsData = pDicsData;}
	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );

//	enum TURN_LOCK_ACTION_MANU { eLOCK, eUNLOCK };
//	enum TR_UNIT_POSITION_MANU { posLD,/* posCENTER,*/ posUL };

	virtual ~CServoTabSemiAutoView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CServoTabSemiAutoView)
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnRbtMove();
	afx_msg void OnRbtCancel();
	afx_msg void OnAlarmReset();
	afx_msg void OnSetSource();
	afx_msg void OnSetTarget();
	afx_msg void OnClickGridRbt();
	afx_msg void OnRadioJoint1();
	afx_msg void OnRadioJoint2();
	afx_msg void OnRadioJoint3();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	afx_msg void OnBtnClicked( UINT nID );
	afx_msg void OnClickRbtInfo();
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SERVOTABSEMIAUTOVIEW_H__91B7989D_0CCF_4022_9CA1_F3DB5B411E54__INCLUDED_)
