// ServoTabView.cpp: implementation of the CServoTabView class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "ServoTabView.h"
#include "..\MainFrm.h"
#include "ServoView.h"
#include "..\DicsData.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString CServoTabView::strTitle[] =
{
	"SHOWER2 ROLLBRUSH1 UPPER UNIT TEACHING POINT LISTS",
	"SHOWER2 ROLLBRUSH1 LOWER UNIT TEACHING POINT LISTS",
	"SHOWER2 ROLLBRUSH2 UPPER UNIT TEACHING POINT LISTS",
	"SHOWER2 ROLLBRUSH2 LOWER UNIT TEACHING POINT LISTS",
	"SHOWER3 ROLLBRUSH1 UPPER UNIT TEACHING POINT LISTS",
	"SHOWER3 ROLLBRUSH1 LOWER UNIT TEACHING POINT LISTS",
	"SHOWER3 ROLLBRUSH2 UPPER UNIT TEACHING POINT LISTS",
	"SHOWER3 ROLLBRUSH2 LOWER UNIT TEACHING POINT LISTS",

};
/////////////////////////////////////////////////////////////////////////////
// CServoTabView

IMPLEMENT_DYNCREATE(CServoTabView, CFormView)

/////////////////////////////////////////////////////////////////////////////
//Point Move Speed Jog Move Speed Slider ϱ  define...
/////////////////////////////////////////////////////////////////////////////
#define MAX_EVENT_NO			4
#define MAX_SOURCE_NO			14
#define MAX_HAND_JOG_SPEED		1000	
#define MIN_HAND_JOG_SPEED		10
#define MAX_RB_JOG_SPEED		10
#define MIN_RB_JOG_SPEED		1
#define MAX_MOVE_RATIO			100
#define MIN_MOVE_RATIO			10

/////////////////////////////////////////////////////////////////////////////
//ServoHelp Dialog ocx Setting  define...
/////////////////////////////////////////////////////////////////////////////
#define LEFT_TYPE	0
#define RIGHT_TYPE	1

#define LD_HAND		0
#define UL_HAND		1

#define UP_HAND		0
#define LO_HAND		1

CServoTabView::CServoTabView()
	: CFormView(CServoTabView::IDD)
{
	//{{AFX_DATA_INIT(CServoTabView)
	m_fCurPosX = 0.0;
	m_fCurPosY = 0.0;
	m_fPosX = 0.0;
	m_fPosY = 0.0;
	m_fVelX = 0.0;
	m_fVelY = 0.0;
	//m_fErr = 0.0f;
	//}}AFX_DATA_INIT

	m_pMmc = NULL;
	m_pDevice = NULL;
	m_bPermitAccess = FALSE;
	m_nAction = actNONE;
	m_nPosNo = 0;
	m_nSign = 0;
	m_fJogVel = 0.0;
	m_nSelAxis = 0;
	m_nRbtAxis[0] = -1;
	m_nRbtAxis[1] = -1;
	m_nSrcPosNo = -1;
	m_nTarPosNo = -1;
	m_nRptPosNo = -1;

	m_fMoveSpeed = 0.0;
	m_fJogSpeed = 0.0;

	m_bHelpVisible = FALSE;

	for( int i = 0 ; i < MAX_RBT_NO ; i++ )
	{
		m_nOldEvent[i][0] = m_nOldEvent[i][1] = -1;
		m_nOldSource[i][0] = m_nOldSource[i][1] = -1;
	}

}

CServoTabView::CServoTabView(CView* pView, CString sRbtName, int nRbtType )
	: CFormView(CServoTabView::IDD)
{
	//{{AFX_DATA_INIT(CServoTabView)
	m_fCurPosX = 0.0;
	m_fCurPosY = 0.0;
	m_fPosX = 0.0;
	m_fPosY = 0.0;
	m_fVelX = 0.0;
	m_fVelY = 0.0;
	//m_fErr = 0.0f;
	//}}AFX_DATA_INIT

	m_pView = pView;
	m_pMmc = NULL;
	m_pDevice = NULL;
	m_bPermitAccess = FALSE;
	m_nAction = actNONE;
	m_nPosNo = 0;
	m_nSign = 0;
	m_fJogVel = 0.0;
	m_nSelAxis = 0;
	m_nRbtAxis[0] = -1;
	m_nRbtAxis[1] = -1;
	m_nSrcPosNo = -1;
	m_nTarPosNo = -1;
	m_nRptPosNo = -1;
	
	m_bMoveHomeBtn = FALSE;
	m_bMoveHomeReq = FALSE;
	m_nSeqMoveHomeNo	= 0;
	m_sRbtName  = sRbtName;
	m_nRbtType	= nRbtType;

	for( int i=0; i<MAX_RBT_NO; i++ )
	{
		m_nOldEvent[i][0]	= m_nOldEvent[i][1]	 = 0;
		m_nOldSource[i][0]	= m_nOldSource[i][1] = 0;
		m_dtheta = m_pMmc->m_AxisPara[m_pMmc->m_RbtInfo[m_nRbtType].nStart_axis].dTheta_H;
	}
}

CServoTabView::~CServoTabView()
{
}

void CServoTabView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CServoTabView)
	DDX_Control(pDX, IDC_RBT_ORG, m_macRbtOrg);
	DDX_Control(pDX, IDC_RBT_FIRST_AXIS, m_macRbtFirstAxis);
	DDX_Control(pDX, IDC_RBT_SECOND_AXIS, m_macRbtSecondAxis);
	DDX_Control(pDX, IDC_RBT_PLUS_X, m_macRbtPlusX);
	DDX_Control(pDX, IDC_RBT_MINUS_X, m_macRbtMinusX);
	DDX_Control(pDX, IDC_RBT_MOVE_REPEAT, m_macRbtMoveRepeat);
	DDX_Control(pDX, IDC_RBT_MOVE, m_macRbtMove);
	DDX_Control(pDX, IDC_RESET, m_macReset);
	DDX_Control(pDX, IDC_ESTOP, m_macEStop);
	DDX_Control(pDX, IDC_POS_TRANS, m_macPosTrans);
	DDX_Control(pDX, IDC_POS_SAVE, m_macPosSave);
	DDX_Control(pDX, IDC_POS_LOAD, m_macPosLoad);
//	DDX_Control(pDX, IDC_LIST_RBT_JOG_SPEED, m_listRbtJogSpeed);
//	DDX_Control(pDX, IDC_LIST_RBT_MOVE_SPEED, m_listRbtMoveSpeed);
	DDX_Control(pDX, IDC_MOVE_HOME, m_macMoveHome);//JUN	
	DDX_Control(pDX, IDC_SAVE, m_macSave);//JUN	
	DDX_Control(pDX, IDC_LC_POINT, m_lcPoint);
	DDX_Control(pDX, IDC_GRID_EVENT_STATE, m_gridEventState);
	DDX_Control(pDX, IDC_GRID_SOURCE_STATE, m_gridSourceState);
	DDX_Control(pDX, IDC_RBT_MOVE_SPEED, m_sliderMoveSpeed);
	DDX_Control(pDX, IDC_RBT_JOG_SPEED, m_sliderJogSpeed);
	DDX_Text(pDX, IDC_CUR_POS_X, m_fCurPosX);
	DDX_Text(pDX, IDC_CUR_POS_Y, m_fCurPosY);
	DDX_Text(pDX, IDC_POS_X, m_fPosX);
	DDX_Text(pDX, IDC_POS_Y, m_fPosY);
	DDX_Text(pDX, IDC_VEL_X, m_fVelX);
	DDX_Text(pDX, IDC_VEL_Y, m_fVelY);
	DDX_Text(pDX, IDC_EDIT_RBT_MOVE_SPEED, m_sMoveSpeed);
	DDX_Text(pDX, IDC_EDIT_RBT_JOG_SPEED, m_sJogSpeed);
	DDX_Text(pDX, IDC_EDIT_DTHETA, m_sthetaDisplay );//jun
	//DDX_Text(pDX, IDC_ERROR, m_fErr);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CServoTabView, CFormView)
	//{{AFX_MSG_MAP(CServoTabView)
	ON_WM_CTLCOLOR()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_ESTOP, OnEstop)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_BN_CLICKED(IDC_POS_TRANS, OnPosTrans)
	ON_BN_CLICKED(IDC_POS_SAVE, OnPosSave)
	ON_BN_CLICKED(IDC_POS_LOAD, OnPosLoad)
	ON_NOTIFY(NM_CLICK, IDC_LC_POINT, OnClickLcPoint)
	ON_NOTIFY(NM_DBLCLK, IDC_LC_POINT, OnDblClickLcPoint)
	ON_BN_CLICKED(IDC_RBT_MOVE, OnRbtMove)
	ON_BN_CLICKED(IDC_RBT_MOVE_REPEAT, OnRbtMoveRepeat)
	ON_BN_CLICKED(IDC_RBT_FIRST_AXIS, OnRbtFirstAxis)
	ON_BN_CLICKED(IDC_RBT_SECOND_AXIS, OnRbtSecondAxis)
	ON_BN_CLICKED(IDC_RBT_ORG, OnRbtOrg)
	ON_EN_CHANGE(IDC_VEL_X, OnChangeVelX)
	ON_EN_CHANGE(IDC_VEL_Y, OnChangeVelY)
	ON_EN_CHANGE(IDC_EDIT_RBT_MOVE_SPEED, OnChangeMoveVel)
	ON_EN_CHANGE(IDC_EDIT_RBT_JOG_SPEED, OnChangeJogVel)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_RBT_MOVE_SPEED, OnCustomdrawMoveSpeed)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_RBT_JOG_SPEED, OnCustomdrawJogSpeed)
//	ON_LBN_SELCHANGE(IDC_LIST_RBT_MOVE_SPEED, OnSelchangeListRbtMoveSpeed)
	ON_BN_CLICKED( IDC_BTN_HELP, OnServoHelp)
	ON_BN_CLICKED(IDC_BTN_EVENT_HELP, OnEventHelp)
	ON_BN_CLICKED(IDC_BTN_SOURCE_HELP, OnSourceHelp)
	ON_BN_CLICKED( IDC_MOVE_HOME, OnMoveHome)//JUN
	ON_BN_CLICKED( IDC_SAVE, OnSave )//JUN
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_BTN_PUSHED, OnBtnPushed)
	ON_MESSAGE(WM_BTN_RELEASED, OnBtnReleased)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServoTabView diagnostics

#ifdef _DEBUG
void CServoTabView::AssertValid() const
{
	CFormView::AssertValid();
}

void CServoTabView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CDicsDoc* CServoTabView::GetDocument()
{
	return (CDicsDoc*)m_pView->GetDocument();
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CServoTabView message handlers

BOOL CServoTabView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

//--------------------------------------------------------------------------------
// OnInitialUpdate
//--------------------------------------------------------------------------------
void CServoTabView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// Set Pointer
	m_pMmc = ( (CServoView*)m_pView )->m_pMmc;
	m_pDevice = ( (CServoView*)m_pView )->m_pDevice;
	m_pEqpAssy = ( (CServoView*)m_pView )->m_pEqpAssy;

	for( int i=0; i<MAX_AXES_RB_NO; i++ )
	{
		m_pMmc->SetAxisRatioFromRegistry( i );
		m_pMmc->SetAxisRatioToRegistry(i, m_pMmc->GetAxisRatio(i));
	}

	// Set the macButton
	MAC_COLOR_SET color_set;
	m_macEStop.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_RED_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macEStop.SetColorSetting( color_set );
	m_macEStop.SetBold();

	m_macRbtOrg.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macRbtOrg.SetColorSetting( color_set );
	m_macRbtOrg.SetBold();

	m_macReset.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macReset.SetColorSetting( color_set );
	m_macReset.SetBold();

	m_macPosTrans.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_RED_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macPosTrans.SetColorSetting( color_set );
	m_macPosTrans.SetBold();

	m_macPosSave.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macPosSave.SetColorSetting( color_set );
	m_macPosSave.SetBold();

	m_macPosLoad.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macPosLoad.SetColorSetting( color_set );
	m_macPosLoad.SetBold();

	m_macRbtPlusX.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macRbtPlusX.SetColorSetting( color_set );
	m_macRbtPlusX.SetBold();

	m_macRbtMinusX.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = LIGHT_ORANGE_COLOR;
	m_macRbtMinusX.SetColorSetting( color_set );
	m_macRbtMinusX.SetBold();

	m_macRbtMove.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = LIGHT_ORANGE_COLOR;
	m_macRbtMove.SetColorSetting( color_set );
	m_macRbtMove.SetBold();

	m_macRbtMoveRepeat.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = LIGHT_ORANGE_COLOR;
	m_macRbtMoveRepeat.SetColorSetting( color_set );
	m_macRbtMoveRepeat.SetBold();

	m_macRbtFirstAxis.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = LIGHT_ORANGE_COLOR;
	m_macRbtFirstAxis.SetColorSetting( color_set );
	m_macRbtFirstAxis.SetBold();

	m_macRbtSecondAxis.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = LIGHT_ORANGE_COLOR;
	m_macRbtSecondAxis.SetColorSetting( color_set );
	m_macRbtSecondAxis.SetBold();
	// Set the macButton

	m_macMoveHome.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = LIGHT_ORANGE_COLOR;
	m_macMoveHome.SetColorSetting( color_set );
	m_macMoveHome.SetBold();

	m_macSave.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = LIGHT_ORANGE_COLOR;
	m_macSave.SetColorSetting( color_set );
	m_macSave.SetBold();
	// Get the Mode
	//m_bPermitAccess = m_pView->GetDocument()->GetPermit();
//==>2008.08.13 KIMGUN
	CRect r;
	GetDlgItem( IDC_LC_POINT )->GetWindowRect( &r );
 
	GetDlgItem( IDC_STATIC_POINT )->SetWindowText(strTitle[m_nRbtType]);
/*	if( m_nRbtType != SWR2_RBT_RB_UNIT_UP_RB1_UNIT && m_nRbtType != SWR2_RBT_RB_UNIT_UP_RB2_UNIT &&
		m_nRbtType != SWR2_RBT_RB_UNIT_LO_RB1_UNIT && m_nRbtType != SWR2_RBT_RB_UNIT_LO_RB2_UNIT &&
		m_nRbtType != SWR3_RBT_RB_UNIT_UP_RB1_UNIT && m_nRbtType != SWR3_RBT_RB_UNIT_UP_RB2_UNIT &&
		m_nRbtType != SWR3_RBT_RB_UNIT_LO_RB1_UNIT && m_nRbtType != SWR3_RBT_RB_UNIT_LO_RB2_UNIT)
*/	{
		GetDlgItem(IDC_MOVE_HOME)->ShowWindow(FALSE);
		GetDlgItem(IDC_SAVE)->ShowWindow(FALSE);
		GetDlgItem(IDC_STATIC_ZERO_POS)->ShowWindow(FALSE);
		GetDlgItem(IDC_STATIC_BOX)->ShowWindow(FALSE);	

		if( MAX_MUX10 == 0 )
		{
			GetDlgItem(IDC_STATIC_DEGREE)->ShowWindow(FALSE);
			GetDlgItem(IDC_EDIT_DTHETA)->ShowWindow(FALSE);
		}
		else
		{
			GetDlgItem(IDC_STATIC_DEGREE)->SetWindowText("GAP INDICATOR VALUE");
			((CEdit*)GetDlgItem( IDC_EDIT_DTHETA ) )->SetReadOnly(TRUE);
		}
	}
//	else
	{
		r = CRect( 292,49,742,120);
		m_lcPoint.MoveWindow( &r, TRUE );
	}
//==>2008.08.13 KIMGUN	
	m_lcPoint.SetExtendedStyle( LVS_EX_FULLROWSELECT |
								LVS_EX_ONECLICKACTIVATE | 
								LVS_EX_UNDERLINEHOT | 
//								LVS_EX_CHECKBOXES |
								LVS_EX_GRIDLINES );
	// ListControl ʱȭ
	int nLvcFmt[] = { LVCFMT_CENTER, LVCFMT_RIGHT, LVCFMT_RIGHT, LVCFMT_RIGHT, LVCFMT_RIGHT, LVCFMT_LEFT };
	//LPTSTR sLvcText[] = { "NO", "X-AXIS     ", "Y-AXIS     ", "Z-AXIS     ", "T-AXIS ", "            N    A    M    E            " };
	LPTSTR sLvcText[] = { "NO", "X-AXIS     ", "Y-AXIS     ", "Z-AXIS     ", "T-AXIS ", "         N    A     M    E         " };

	LV_COLUMN lvc;
	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	for( int i=0; i<6; i++ )
	{
		lvc.fmt = nLvcFmt[i];
		lvc.pszText = sLvcText[i];
		lvc.cx = m_lcPoint.GetStringWidth(lvc.pszText) + 18;
		m_lcPoint.InsertColumn(i, &lvc);
	}

	// Set the jog speed
//	CString sJogSpeed[] = { "0.1", "0.5", "1", "5", "10", "20", "40", "80", "100" };
//	int nSize = sizeof( sJogSpeed ) / sizeof( CString );
//	if( m_nRbtType >=  RBT_RB_UNIT_LO_RB1_UNIT )
//		nSize = 3;
//	for( i=0; i<nSize; i++ ) 
//	{
//		m_listRbtJogSpeed.AddString( sJogSpeed[i] );
//	}
//	m_listRbtJogSpeed.SetCurSel( 0 );
//
//	// Set the move speed
//	CString sMoveSpeed[] = { "1.0", "0.9", "0.8", "0.7", "0.6", "0.5", "0.4", "0.3", "0.2", "0.1" };
//	nSize = sizeof( sMoveSpeed ) / sizeof( CString );
//	for( i=0; i<nSize; i++ ) 
//	{
//		m_listRbtMoveSpeed.AddString( sMoveSpeed[i] );
//	}
//	m_listRbtMoveSpeed.SetCurSel( 0 );
//#ifndef _NO_RB
	if( m_nRbtType == SWR2_RBT_RB_UNIT_UP_RB1_UNIT || m_nRbtType == SWR2_RBT_RB_UNIT_LO_RB1_UNIT ||
		m_nRbtType == SWR2_RBT_RB_UNIT_UP_RB2_UNIT || m_nRbtType == SWR2_RBT_RB_UNIT_LO_RB2_UNIT ||
		m_nRbtType == SWR3_RBT_RB_UNIT_UP_RB1_UNIT || m_nRbtType == SWR3_RBT_RB_UNIT_LO_RB1_UNIT ||
		m_nRbtType == SWR3_RBT_RB_UNIT_UP_RB2_UNIT || m_nRbtType == SWR3_RBT_RB_UNIT_LO_RB2_UNIT)
	{
		m_nMaxJogSpeed = (int)MAX_RB_JOG_SPEED;
		m_nMinJogSpeed = (int)MIN_RB_JOG_SPEED;
	}
	else
	{
		m_nMaxJogSpeed = (int)MAX_HAND_JOG_SPEED;
		m_nMinJogSpeed = (int)MIN_HAND_JOG_SPEED;
	}
// #else
// 	m_nMaxJogSpeed = (int)MAX_HAND_JOG_SPEED;
// 	m_nMinJogSpeed = (int)MIN_HAND_JOG_SPEED;
// #endif
	m_sliderJogSpeed.SetRange( m_nMinJogSpeed, m_nMaxJogSpeed );
	m_sliderJogSpeed.SetPos( m_nMaxJogSpeed - m_nMaxJogSpeed + m_nMinJogSpeed );
	m_sJogSpeed.Format( "%d", (int)( m_nMaxJogSpeed / 10 ) );
	m_fJogSpeed = m_nMaxJogSpeed / 10;

	m_sliderMoveSpeed.SetRange( (int)MIN_MOVE_RATIO, (int)MAX_MOVE_RATIO );
	m_sliderMoveSpeed.SetPos( (int)( MAX_MOVE_RATIO - MAX_MOVE_RATIO + MIN_MOVE_RATIO )  );
	m_sMoveSpeed.Format( "%d", MAX_MOVE_RATIO );
	m_fMoveSpeed = MAX_MOVE_RATIO;

	UpdateData( FALSE );

	for( int i = 0 ; i < 2 ; i++ )
	{
		m_stcNegLimit[i].SubclassDlgItem( IDC_NEG_LIMIT_SENSOR1 + i, this );
		m_stcNegLimit[i].SetTextColor( BLACK_COLOR );
		m_stcNegLimit[i].SetBkColor( WHITE_COLOR );

		m_stcHome[i].SubclassDlgItem( IDC_HOME_SENSOR1 + i, this );
		m_stcHome[i].SetTextColor( BLACK_COLOR );
		m_stcHome[i].SetBkColor( WHITE_COLOR );

		m_stcPosLimit[i].SubclassDlgItem( IDC_POS_LIMIT_SENSOR1 + i, this );
		m_stcPosLimit[i].SetTextColor( BLACK_COLOR );
		m_stcPosLimit[i].SetBkColor( WHITE_COLOR );
	}

	GetAxis();		// Get the mapping axis (m_nRbtAxis)
	SetRobotTeachingPoint( m_nRbtType );	// Set teaching point to list control
	m_pMmc->SetVelFromRegistry( m_nRbtType );	// Set the velocity of registry.
	
	// Set the robot velocity to view
	RBT_VEL vel = m_pMmc->GetVel( m_nRbtType );
	if( m_nRbtAxis[0] >= 0 ) m_fVelX = vel.dVel[m_nRbtAxis[0]]; 
	if( m_nRbtAxis[1] >= 0 ) m_fVelY = vel.dVel[m_nRbtAxis[1]];
	UpdateData( FALSE );

	// Display the axis name to view
	SetDlgItemText( IDC_SELECTED_AXIS, m_pMmc->m_sRbtAxisName[m_nRbtType][0] );
	for( int i=0; i<m_pMmc->m_RbtInfo[m_nRbtType].nMax_axes; i++ )
	{
		SetDlgItemText( IDC_RBT_FIRST_AXIS + i, m_pMmc->m_sRbtAxisName[m_nRbtType][i] );
	}
	if( m_pMmc->m_RbtInfo[m_nRbtType].nMax_axes <= 1 || m_pMmc->m_RbtInfo[m_nRbtType].link.bIs_linked )
	{
		GetDlgItem( IDC_RBT_SECOND_AXIS )->EnableWindow( FALSE );
		GetDlgItem( IDC_POS_Y )->EnableWindow( FALSE );
		GetDlgItem( IDC_VEL_Y)->EnableWindow( FALSE );
	}
	else
	{
		GetDlgItem( IDC_RBT_SECOND_AXIS )->EnableWindow( TRUE );
		GetDlgItem( IDC_POS_Y )->EnableWindow( TRUE );
		GetDlgItem( IDC_VEL_Y)->EnableWindow( TRUE );
	}

	// 簪  
	m_nPosNo = m_pMmc->GetCurPoint( m_nRbtType );
	m_nInitPos = m_nPosNo;
	m_lcPoint.SetCheck( m_nPosNo, TRUE );
	// rb theta ǥ 2008.09.09 kimgun
	if( MAX_MUX10 == 0 )
	{
		CString sBuf;
		sBuf.Format("%f",m_pMmc->m_AxisPara[m_pMmc->m_RbtInfo[m_nRbtType].nStart_axis].dTheta_H);
		SetDlgItemText(IDC_EDIT_DTHETA,sBuf);
	}
	else
	{
		CString sBuf;
		sBuf.Format("%.3f",((CDicsView*)m_pView)->m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+m_nRbtType ]);
		SetDlgItemText(IDC_EDIT_DTHETA,sBuf);
	}

	GetDlgItem( IDC_RBT_MOVE )->EnableWindow( FALSE );
	GetDlgItem( IDC_RBT_MOVE_REPEAT )->EnableWindow( FALSE );
	GetDlgItem( IDC_SAVE )->EnableWindow( FALSE );//2008.09.09 kimgun

	GridInit();

	// ʱ⿡  Home ϷǾ Button  Ѵ.
	EnableBtn( m_pMmc->m_bHomeComp[m_nRbtType] );

	// Set the timer (Running the sequence)
#ifdef _MY_DEBUG
	SetTimer( TIMER_ROBOT( m_nRbtType + 1 ), 1000, NULL );
#else
	SetTimer( TIMER_ROBOT( m_nRbtType + 1 ), 100, NULL );
#endif
}

//--------------------------------------------------------------------------------
// OnClose
//--------------------------------------------------------------------------------
void CServoTabView::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	KillTimer( TIMER_ROBOT( m_nRbtType + 1 ) );
	
	CFormView::OnClose();
}

//--------------------------------------------------------------------------------
// OnCtlColor
//--------------------------------------------------------------------------------
HBRUSH CServoTabView::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CFormView::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	UINT id = pWnd->GetDlgCtrlID();
	switch( nCtlColor )
	{
/*
		case CTLCOLOR_LISTBOX:
			if( id == IDC_LIST_RBT_MOVE_SPEED || id == IDC_LIST_RBT_JOG_SPEED ) 
			{
				hbr = ( (CServoView*)m_pView)->m_hbrYellow;
				pDC->SetBkMode( TRANSPARENT );
				pDC->SetTextColor( BLACK_COLOR );
			}
			break;
*/		
		case CTLCOLOR_STATIC:
			if( id == IDC_STATIC_SET_POS || id == IDC_STATIC_VEL ||
				id == IDC_STATIC_CUR_POS || id == IDC_STATIC_SENSOR ||
				id == IDC_STATIC_POINT )
			{
				hbr = ( (CServoView*)m_pView )->m_hbrBgColor;
				pDC->SetBkMode( TRANSPARENT );
				pDC->SetTextColor( BLACK_COLOR );
			}
			else if( id == IDC_X_EVENT || id == IDC_Y_EVENT || id == IDC_X_SOURCE || id == IDC_Y_SOURCE )
			{
				hbr = ( (CServoView*)m_pView )->m_hbrCyan;
				pDC->SetBkMode( TRANSPARENT );
				pDC->SetTextColor( BLACK_COLOR );
			}
			else if( id == IDC_STATIC_SOURCE || id == IDC_STATIC_EVENT )
			{
				hbr = ( (CServoView*)m_pView )->m_hbrBack;
				pDC->SetBkMode( TRANSPARENT );
				pDC->SetTextColor( BLACK_COLOR );
			}
			else if( id == IDC_SELECTED_AXIS )
			{
				hbr = ( (CServoView*)m_pView )->m_hbrMagenta;
				pDC->SetBkMode( TRANSPARENT );
				pDC->SetTextColor( BLACK_COLOR );
			}
			break;
	}	
	return hbr;
}

//--------------------------------------------------------------------------------
// OnTimer
//--------------------------------------------------------------------------------
void CServoTabView::OnTimer(UINT nIDEvent) 
{
	DisplayPosAndState();
	if( MAX_MUX10 != 0 )	DisplayTheta();
//	if( m_nAction == actNONE ) return;
//
	SeqRbtMove(); 
	SeqMoveHome();//Only R/B
	CFormView::OnTimer(nIDEvent);
}

//--------------------------------------------------------------------------------
// OnEstop
//--------------------------------------------------------------------------------
void CServoTabView::OnEstop() 
{
	CString sBuf;
	sBuf.Format( "E-STOP START" );
	( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf );

	GetDlgItem( IDC_ESTOP )->EnableWindow( FALSE );
	GetDlgItem( IDC_RESET )->EnableWindow( TRUE );
	EnableBtn( FALSE );
	m_nSeqMoveHomeNo = 0;//2008.09.04 kimgun
//	for( int i = 0; i < MAX_AXES; i++ )
//	m_pMmc->m_nSetCalThetaNo[i] = 0;//2008.09.04 kimgun
	m_nAction = actE_STOP;	
}

//--------------------------------------------------------------------------------
// OnReset
//--------------------------------------------------------------------------------
void CServoTabView::OnReset() 
{
	CString sBuf;
	sBuf.Format( "RESET START" );
	( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf);

	GetDlgItem( IDC_ESTOP )->EnableWindow( TRUE );
	GetDlgItem( IDC_RESET )->EnableWindow( FALSE );
	EnableBtn( FALSE );

	m_nAction = actRESET;	
}

//--------------------------------------------------------------------------------
// OnRbtOrg
//--------------------------------------------------------------------------------
void CServoTabView::OnRbtOrg() 
{
/*
#ifndef _NO_UL_HAND
	BOOL bUlHandAfterRecvSensorStatus	= m_pEqpAssy->m_PosSensorUlHand.GetAnd( UL_HAND_UNIT_AFTER_RECV_POS );
#endif

	if( ( m_nRbtType == RBT_LD_UPDN_UNIT ) && m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_LD, 1 ) )
	{
		AfxMessageBox( "PLEASE MOVE THE GLASS ON LD CV TO INSIDE OF LD UNIT" );
		return;
	}
#ifndef _NO_UL_HAND
	else if( m_nRbtType == RBT_UL_HAND_UNIT )
	{
		if( !m_pEqpAssy->m_CylinderUlHand.GetFw() && !m_pEqpAssy->m_CylinderUlHand.GetBw() )
		{
			AfxMessageBox( "UL Unit Hand Cylinder Position is not recognized" );
			return;
		}
		else if( !m_pEqpAssy->m_CylinderUlHand.GetBw() )
		{
			if( m_pEqpAssy->m_CylinderUlTilt.GetFw() || m_pEqpAssy->m_CylinderUlTilt.GetFwState() )
			{
				AfxMessageBox( "UL Unit Hand is interfered with Tilt Cylinder" );
				return;
			}
			else if( m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) || m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 ) )
			{
				if( bUlHandAfterRecvSensorStatus )
				{
					if( AfxMessageBox( "Are you sure MOVE? YES(START) / NO(CANCEL)", MB_YESNO ) == IDNO )	return;
				}
				else
				{
					AfxMessageBox( "UL Unit Hand is interfered with a Glass in UL Unit" );
					return;
				}
			}
		}
	}
#endif
*/
	CString sBuf;
	sBuf.Format( "HOME START" );
	( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf);
	EnableBtn( FALSE );

	m_pMmc->ResetRbtHomeSeq( m_nRbtType );	
	m_nAction = actHOME;	

}

//--------------------------------------------------------------------------------
// OnPosTrans
//--------------------------------------------------------------------------------
void CServoTabView::OnPosTrans() 
{
	CString sBuf;
	sBuf.Format( "POINT TRANSFER" );
	( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf);

	GetDlgItem( IDC_POS_SAVE )->EnableWindow( TRUE );
	UpdateData( TRUE );
	
	for( int i=0; i<MAX_RBT_AXES; i++ )
	{	
		CString sValue;
		if( m_nRbtAxis[0] == i )
		{
			m_pMmc->m_RbtInfo[m_nRbtType].pos[m_nPosNo].dPos[i] = m_fCurPosX;
			sValue.Format( "%.3f", m_fCurPosX ); m_lcPoint.SetItemText( m_nPosNo, i+1, sValue );
		}
		else if( m_nRbtAxis[1] == i )
		{
			m_pMmc->m_RbtInfo[m_nRbtType].pos[m_nPosNo].dPos[i] = m_fCurPosY;
			sValue.Format( "%.3f", m_fCurPosY ); m_lcPoint.SetItemText( m_nPosNo, i+1, sValue );
		}
		else
		{
			m_pMmc->m_RbtInfo[m_nRbtType].pos[m_nPosNo].dPos[i] = 0.0;
			sValue.Format( "%.3f", 0.0 ); m_lcPoint.SetItemText( m_nPosNo, i+1, sValue );
		}
	}
}

//--------------------------------------------------------------------------------
// OnPosSave
//--------------------------------------------------------------------------------
void CServoTabView::OnPosSave() 
{
	CString sBuf;
	sBuf.Format( "POINT SAVE" );
	( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf);
	GetDlgItem( IDC_POS_SAVE )->EnableWindow( FALSE );

	m_pMmc->PosMem2File( m_nRbtType );	
}

//--------------------------------------------------------------------------------
// OnPosLoad
//--------------------------------------------------------------------------------
void CServoTabView::OnPosLoad() 
{
	CString sBuf;
	sBuf.Format( "POINT LOAD" );
	( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf );
	SetRobotTeachingPoint( m_nRbtType );	
}

//--------------------------------------------------------------------------------
// OnClickLcPoint
//--------------------------------------------------------------------------------
void CServoTabView::OnClickLcPoint(NMHDR* pNMHDR, LRESULT* pResult) 
{
	//   
	m_lcPoint.SetCheck( m_nPosNo, FALSE );

	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*) pNMHDR;
	m_nPosNo = pNMListView->iItem;
	m_nTarPosNo = m_nPosNo;
	double fPos[MAX_RBT_AXES] = { 0.0, };

	// 簪  
	m_lcPoint.SetCheck( m_nPosNo, TRUE );

	INT nMask = m_pMmc->m_RbtInfo[m_nRbtType].nMask;
	for( int i=0; i<MAX_RBT_AXES; i++ ) 
	{
		if( nMask & ( 1 << i ) )
		{
			CString sValue = m_lcPoint.GetItemText( m_nPosNo, i + 1 );
			fPos[i] = atof( sValue );
		}
	}

	if( m_nRbtAxis[0] >= 0 ) m_fPosX = fPos[m_nRbtAxis[0]];
	if( m_nRbtAxis[1] >= 0 ) m_fPosY = fPos[m_nRbtAxis[1]];
	UpdateData( FALSE );
	
	*pResult = 0;
}

void CServoTabView::OnDblClickLcPoint(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	m_lcPoint.SetCheck( m_nPosNo, FALSE );

	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*) pNMHDR;
	m_nPosNo = pNMListView->iItem;
	m_nTarPosNo = m_nPosNo;
	double fPos[MAX_RBT_AXES] = { 0.0, };

	// 簪  
	m_lcPoint.SetCheck( m_nPosNo, TRUE );

	INT nMask = m_pMmc->m_RbtInfo[m_nRbtType].nMask;
	for( int i=0; i<MAX_RBT_AXES; i++ ) 
	{
		if( nMask & ( 1 << i ) )
		{
			CString sValue = m_lcPoint.GetItemText( m_nPosNo, i + 1 );
			fPos[i] = atof( sValue );
		}
	}

	if( m_nRbtAxis[0] > 0 ) m_fPosX = fPos[m_nRbtAxis[0]];
	if( m_nRbtAxis[1] > 0 ) m_fPosY = fPos[m_nRbtAxis[1]];
	
	CreateHelpDialog();

	*pResult = 0;
}

//--------------------------------------------------------------------------------
// OnRbtMove
//--------------------------------------------------------------------------------
void CServoTabView::OnRbtMove() 
{
	// TODO: Add your control notification handler code here
	BOOL bGlassExist = FALSE;
	int nIfNo = -1;
#ifndef _NO_UL_HAND
	BOOL bUlHandBeforeRecvSensorStatus = m_pMmc->GetHomeSwitch( RBT_UL_HAND_UNIT_S_AXIS );
#endif	
	switch( m_nRbtType )
	{
/*	case RBT_LD_UPDN_UNIT:
		if( m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_LD, 1 ) )
		{
			AfxMessageBox( "PLEASE MOVE THE GLASS ON LD CV TO INSIDE OF LD UNIT" );
			return;
		}
/*//*/
		else if( ( m_nPosNo == LD_UPDN_UNIT_RECV_POS ) && !m_pEqpAssy->m_CylinderLdTilt.GetBw() )
		{
          AfxMessageBox( "LD Unit Tilt Down status error" );
			return;
		}
/*//*/
		break;
*/
#ifndef _NO_UL_HAND
	case RBT_UL_HAND_UNIT:
		if( !m_pEqpAssy->m_CylinderUlHand.GetFw() && !m_pEqpAssy->m_CylinderUlHand.GetBw() )
		{
			AfxMessageBox( "UL Unit Hand Cylinder Position is not recognized" );
			return;
		}
		else if( !m_pEqpAssy->m_CylinderUlHand.GetBw() )
		{
			if( ( m_pEqpAssy->m_CylinderUlTilt.GetFwState() || m_pEqpAssy->m_CylinderUlTilt.GetFw() ) &&
				( m_nPosNo <= UL_HAND_UNIT_AFTER_RECV_POS ) )
			{
				AfxMessageBox( "UL Unit Hand is interfered with Tilt Cylinder" );
				return;
			}
			else if( ( m_pEqpAssy->m_CylinderUlTilt.GetBwState() || m_pEqpAssy->m_CylinderUlTilt.GetBw() ) &&
					 ( m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) || m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 ) ) &&
					 ( m_nPosNo <= UL_HAND_UNIT_AFTER_RECV_POS && !bUlHandBeforeRecvSensorStatus ) )
			{
				AfxMessageBox( "UL Unit Hand is interfered with a Glass in UL Unit" );
				return;
			}
		}
		break;
#endif
//#ifndef _NO_RB
	case SWR2_RBT_RB_UNIT_UP_RB1_UNIT:
	case SWR2_RBT_RB_UNIT_LO_RB1_UNIT:
	case SWR2_RBT_RB_UNIT_UP_RB2_UNIT:
	case SWR2_RBT_RB_UNIT_LO_RB2_UNIT:
	case SWR3_RBT_RB_UNIT_UP_RB1_UNIT:
	case SWR3_RBT_RB_UNIT_LO_RB1_UNIT:
	case SWR3_RBT_RB_UNIT_UP_RB2_UNIT:
	case SWR3_RBT_RB_UNIT_LO_RB2_UNIT:
		break;
//#endif
	}

	if( ( (CServoView*)m_pView )->CheckCond( m_nRbtType, m_pMmc->GetCurPoint( m_nRbtType ), bGlassExist, m_nPosNo ) &&
			CheckMoveVel( m_nRbtType, m_pMmc->GetCurPoint( m_nRbtType ), m_nPosNo ) &&
			CheckCv( m_nRbtType ) )
		{
			if( AfxMessageBox( "ARE YOU SURE MOVE? YES(START) / NO(CANCEL)", MB_YESNO ) == IDNO ) return;		
			SetRbtMove();
		}
	else
	{
		AfxMessageBox( "CAN'T MOVE ROBOT. CHECK INTERLOCK CONDITION");
		return;
	}
	
	UpdateData( TRUE );	
}

//--------------------------------------------------------------------------------
// OnRbtMoveRepeat
//--------------------------------------------------------------------------------
void CServoTabView::OnRbtMoveRepeat()
{
	// TODO: Add your control notification handler code here
/*	if( ( m_nRbtType == RBT_LD_UPDN_UNIT ) && m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_LD, 1 ) )
	{
		AfxMessageBox( "PLEASE MOVE THE GLASS ON LD CV TO INSIDE OF LD UNIT" );
		return;
	}
#ifndef _NO_UL_HAND
	else if( m_nRbtType == RBT_UL_HAND_UNIT )
	{
		if( !m_pEqpAssy->m_CylinderUlHand.GetFw() && !m_pEqpAssy->m_CylinderUlHand.GetBw() )
		{
			AfxMessageBox( "UL Unit Hand Cylinder Position is not recognized" );
			return;
		}
		else if( !m_pEqpAssy->m_CylinderUlHand.GetBw() )
		{
			if( m_pEqpAssy->m_CylinderUlTilt.GetFw() || m_pEqpAssy->m_CylinderUlTilt.GetFwState() )
			{
				AfxMessageBox( "UL Unit Hand is interfered with Tilt Cylinder" );
				return;
			}
			else if( m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) || m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 ) )
			{
				AfxMessageBox( "REPEAT Action Denied by the Glass on UL Unit" );
				return;
			}
		}
	}
#endif 

	static BOOL bRepeat = TRUE;

	BOOL bGlassExist = FALSE;
	int nIfNo = -1;

	if( !bRepeat || ( (CServoView*)m_pView )->CheckCond( m_nRbtType, m_pMmc->GetCurPoint( m_nRbtType ), bGlassExist, m_nPosNo ) )
	{
		if( bRepeat && ( IDNO == AfxMessageBox( "ARE YOU SURE REPEAT? YES(START) / NO(CANCEL)", MB_YESNO ) ) ) return;
	}
//	else return;

	if( bRepeat )
	{
		int nAxis = 0;

		UpdateData( TRUE );
		for( int i=0; i<MAX_RBT_AXES; i++ )
		{
			if( m_pMmc->m_RbtInfo[m_nRbtType].nMask & ( 1 << i ) )
			{
				if( nAxis == 0 ) m_rpPos.dPos[i] = m_fPosX;
				else if( nAxis == 1 ) m_rpPos.dPos[i] = m_fPosY;
				else m_rpPos.dPos[i] = 0.0;

				nAxis++;
			}
			else m_rpPos.dPos[i] = 0.0;
		}

		m_rpTargetPos = m_rpPos;
		m_nRptPosNo = m_nTarPosNo;
		m_nSrcPosNo = m_pMmc->GetCurPoint( m_nRbtType );

		if( !m_pMmc->GetCurPosition( m_nRbtType, m_rpCurPos ) ) return;

		// Reset flag
		bRepeat = FALSE;

		SetDlgItemText( IDC_RBT_MOVE_REPEAT, "STOP" );
		
		CString sBuf;
		sBuf.Format( "REPEAT MOVE START" );
		( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf );
		EnableBtn( FALSE );
		GetDlgItem( IDC_RBT_MOVE_REPEAT )->EnableWindow( TRUE );

		m_nAction = actMOVE_REPEAT;
	}
	else
	{
		bRepeat = TRUE;

		SetDlgItemText( IDC_RBT_MOVE_REPEAT, "REPEAT" );
		CString sBuf;
		sBuf.Format( "REPEAT MOVE STOP" );
		( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf );

		//int nPosNo = m_pMmc->GetCurPoint( m_nRbtNo );
		//if( m_nInitPos != nPosNo ) ( (CServoView*)m_pView )->m_pMainSeq->m_bManuMotorMove[m_nRbtNo] = TRUE;
		//else ((CServoView*)m_pView)->m_pMainSeq->m_bManuMotorMove[m_nRbtNo] = FALSE;

		EnableBtn( TRUE );

		m_macRbtMoveRepeat.SetCheck( 0 );
		m_nAction = actNONE;
	}
	*/
}

//--------------------------------------------------------------------------------
// OnRbtFirstAxis
//--------------------------------------------------------------------------------
void CServoTabView::OnRbtFirstAxis() 
{
	m_nSelAxis = 0;
	SetDlgItemText( IDC_SELECTED_AXIS, m_pMmc->m_sRbtAxisName[m_nRbtType][0] );
}

//--------------------------------------------------------------------------------
// OnRbtSecondAxis
//--------------------------------------------------------------------------------
void CServoTabView::OnRbtSecondAxis() 
{
	m_nSelAxis = 1;
	SetDlgItemText( IDC_SELECTED_AXIS, m_pMmc->m_sRbtAxisName[m_nRbtType][1] );
}

//--------------------------------------------------------------------------------
// OnBtnPushed : Jog Move
//--------------------------------------------------------------------------------
LRESULT CServoTabView::OnBtnPushed(WPARAM wParam, LPARAM lParam )
{
	CString sBuf;

	if( !( (CServoView*)m_pView )->IsJogCondition( m_nRbtType ) && 
	   ( (UINT)wParam == IDC_RBT_PLUS_X || (UINT)wParam == IDC_RBT_MINUS_X ) ) 
	{
		AfxMessageBox( "CAN'T MOVE ROBOT. CHECK INTERLOCK CONDITION");
		return 0;
	}
#ifndef _NO_UL_HAND
	if( m_nRbtType == RBT_UL_HAND_UNIT  && 
	  ( m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) || m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 ) ) &&
	  ( m_pEqpAssy->m_CylinderUlTilt.GetBwState() || m_pEqpAssy->m_CylinderUlTilt.GetBw() ) &&
	  ( m_pEqpAssy->m_CylinderUlHand.GetFw() || m_pEqpAssy->m_CylinderUlHand.GetFwState()) && 
	  (/* (UINT)wParam == IDC_RBT_PLUS_X || */(UINT)wParam == IDC_RBT_MINUS_X ) )
	{
		AfxMessageBox("INTERLOCK : UL Unit Have Glass Please Check!!");
		return 0;
	}
	
	if( ( m_nRbtType == RBT_UL_HAND_UNIT ) && 
		( m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) || m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 ) || !m_pEqpAssy->m_CylinderUlTilt.GetBw()) &&
		!m_pEqpAssy->m_CylinderUlHand.GetBw() &&
		(UINT)wParam == IDC_RBT_MINUS_X ) 
	{
		AfxMessageBox("INTERLOCK : UL Hand must be BW");
		return 0;
	}
#endif
	// Update the DDX
	UpdateData( TRUE );

	switch( (UINT)wParam ) 
	{
	case IDC_RBT_PLUS_X:
		{
			m_nSign = 1;
			sBuf.Format( "( + ) JOG MOVE");
			( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf );
		}
		break;
	case IDC_RBT_MINUS_X:
		{
			m_nSign = -1;
			sBuf.Format( "( - ) JOG MOVE");
			( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf );
		}
		break;
	default:
		return 0;
	}

	// Jog Move
//	CString sSpeed;
//	int nIndex = m_listRbtJogSpeed.GetCurSel();
//	m_listRbtJogSpeed.GetText( nIndex, sSpeed );
	m_fJogVel = atof( m_sJogSpeed );

	sBuf.Format( "( %.2f ) JOG SPEED", m_fJogVel);
	( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf );

	m_pMmc->StartVelMove( m_nRbtType, m_nRbtAxis[m_nSelAxis], m_nSign, m_fJogVel );
//	GetDlgItem( IDC_RBT_FIRST_AXIS )->EnableWindow( FALSE );
//	GetDlgItem( IDC_RBT_SECOND_AXIS )->EnableWindow( FALSE );

	return 0;
}

//--------------------------------------------------------------------
// When jog button is released  : Jog Move
//--------------------------------------------------------------------
LRESULT CServoTabView::OnBtnReleased(WPARAM wParam, LPARAM lParam)
{
	CString sBuf;
	switch((UINT)wParam) 
	{
	case IDC_RBT_PLUS_X:
		{
			m_macRbtPlusX.SetCheck( 0 );
			sBuf.Format( "( + ) JOG MOVE END" );
			( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf );
		}
		break;

	case IDC_RBT_MINUS_X:
		{
			m_macRbtMinusX.SetCheck( 0 );
			sBuf.Format("( - ) JOG MOVE END");
			( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf );
		}
		break;
	default:
		return 0;
	}

	// nAxis : +X(0), +Y(1), +Z(2), +(3), -X(4), -Y(5), -Z(6), -(7), 
	//		 =>   0      1      2       3      0      1      2       3
	m_pMmc->StopVelMove( m_nRbtType, m_nRbtAxis[m_nSelAxis] );
//	GetDlgItem( IDC_RBT_FIRST_AXIS )->EnableWindow( TRUE );
//	GetDlgItem( IDC_RBT_SECOND_AXIS )->EnableWindow( FALSE );
	return 0;
}

//--------------------------------------------------------------------------------
// OnChangeVelX
//--------------------------------------------------------------------------------
void CServoTabView::OnChangeVelX() 
{
	RBT_VEL rvVel;
	for( int i=0; i< MAX_RBT_AXES ; i++) rvVel.dVel[i] = 0.0;

	UpdateData( TRUE );	
/*
	if( m_nRbtType == 0 && m_fVelX > 250 )	// 110621 halesu
	{
		AfxMessageBox("MAX VELOCITY OF THIS UNIT IS 250\nPLEASE REINPUT");	
		
		rvVel = m_pMmc->GetVel(m_nRbtType);
		m_fVelX = 250;//rvVel.dVel[2];
		UpdateData( FALSE );
	}
*/
/*	if( m_nRbtType == RBT_LD_UPDN_UNIT && m_fVelX > 250 ) 
	{
		AfxMessageBox("MAX VELOCITY OF THIS UNIT IS 250\nPLEASE REINPUT");
		
		rvVel = m_pMmc->GetVel(m_nRbtType);
		m_fVelX = 250;//rvVel.dVel[2];
		UpdateData( FALSE );
	}
*/	if( m_nRbtAxis[0] >= 0 )	rvVel.dVel[m_nRbtAxis[0]] = m_fVelX;
	if( m_nRbtAxis[1] >= 0 )	rvVel.dVel[m_nRbtAxis[1]] = m_fVelY;
	
	CString sVel;
	sVel.Format( "%.2f", m_fVelX );
	
	CString sBuf;
	sBuf.Format( "CHANGE VEL : X => %f", m_fVelX );
	( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf );

	m_pMmc->SetVelToRegistry( m_nRbtType, rvVel );
}

//--------------------------------------------------------------------------------
// OnChangeVelY
//--------------------------------------------------------------------------------
void CServoTabView::OnChangeVelY() 
{
	RBT_VEL rvVel;
	for( int i=0; i< MAX_RBT_AXES ; i++) rvVel.dVel[i] = 0.0;

	UpdateData( TRUE );	
	if( m_nRbtAxis[0] >= 0 ) rvVel.dVel[m_nRbtAxis[0]] = m_fVelX;
	if( m_nRbtAxis[1] >= 0 ) rvVel.dVel[m_nRbtAxis[1]] = m_fVelY;
	
	CString sVel;
	sVel.Format( "%.2f", m_fVelY );
	
	CString sBuf;
	sBuf.Format( "CHANGE VEL : Y => %f", m_fVelY );
	( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf );

	m_pMmc->SetVelToRegistry( m_nRbtType, rvVel );
}

//--------------------------------------------------------------------------------
// for Change Move Velocity Ratio
//--------------------------------------------------------------------------------
void CServoTabView::OnChangeMoveVel() 
{
	UpdateData( TRUE );

	double fRatio;
	fRatio = atof( m_sMoveSpeed );

	if( fRatio < MIN_MOVE_RATIO )	return;
	else if( fRatio > MAX_MOVE_RATIO )
	{
		AfxMessageBox( "MAX MOVE RATIO IS 100" );
		m_sMoveSpeed.Format( "%d", (int) m_fMoveSpeed );
		UpdateData( FALSE );
		return;
	}

	m_fMoveSpeed = fRatio;
	m_pMmc->SetVelRatio( m_nRbtType, m_fMoveSpeed / 100 );
	m_sliderMoveSpeed.SetPos( (int)( MAX_MOVE_RATIO - m_fMoveSpeed + MIN_MOVE_RATIO ) );
}

BOOL CServoTabView::CheckCv( int nRbtType )
{
	BOOL bRv = TRUE;

/*	switch( nRbtType )
	{
	case RBT_LD_UPDN_UNIT:
		if ( m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_LD ) || m_pEqpAssy->m_CvMotor.GetMotorBwState( CV_NO_LD ) )
		{
			bRv =FALSE;
		}
		break;
	}
*/
	return bRv;
}

//--------------------------------------------------------------------------------
// for Check Move Velocity Ratio
//--------------------------------------------------------------------------------
BOOL CServoTabView::CheckMoveVel( int nRbtType, int nCurPos, int nTargetPos )
{
/*
	UpdateData( TRUE );

	double fRatio;
	fRatio = atof( m_sMoveSpeed );

	BOOL bRv = TRUE;

	BOOL bTrUnitGlassExist = digSERVO_GLS_EXIST( RBT_TR_UNIT ) || 
							( (CServoView*)m_pView )->m_pDicsData->m_GlsInfo[IF_UNIT_TR*2+0].bIsValid;
	BOOL bLdUpHandUnitGlassExist = digSERVO_GLS_EXIST( RBT_LD_FISH_UNIT ) || 
							( (CServoView*)m_pView )->m_pDicsData->m_GlsInfo[IF_UNIT_LD_FISH*2+0].bIsValid;

	BOOL bLdUnitGlassExist = m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) || ( (CServoView*)m_pView )->m_pDicsData->m_GlsInfo[IF_UNIT_LD*2+0].bIsValid;
	BOOL bUlUnitGlassExist = m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_UL ) || ( (CServoView*)m_pView )->m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].bIsValid;

	int nTrUnitPos		 = m_pMmc->GetCurPoint( RBT_TR_UNIT );
	int nLdUpHandUnitPos = m_pMmc->GetCurPoint( RBT_LD_FISH_UNIT );

	switch( nRbtType )
	{
	case RBT_LD_FISH_UNIT:
		if( nCurPos == LD_FISH_UNIT_RECV2_POS && nTargetPos == LD_FISH_UNIT_RECV1_POS && 
			bLdUpHandUnitGlassExist && nTrUnitPos == TR_UNIT_SEND_POS && fRatio > 20. )
		{
			bRv = FALSE;
		}
		else if( nCurPos == LD_FISH_UNIT_RECV1_POS && nTargetPos == LD_FISH_UNIT_RECV2_POS && 
				 bTrUnitGlassExist && nTrUnitPos == TR_UNIT_SEND_POS && fRatio > 20. ) 
		{
			bRv = FALSE;
		}
		else if( nCurPos == LD_FISH_UNIT_SEND1_POS && nTargetPos == LD_FISH_UNIT_SEND2_POS && 
				 bLdUpHandUnitGlassExist && fRatio > 20. )  
		{
			bRv = FALSE;
		}
		else if( nCurPos == LD_FISH_UNIT_SEND2_POS && nTargetPos == LD_FISH_UNIT_SEND1_POS && 
				 bLdUnitGlassExist && fRatio > 20. )  
		{
			bRv = FALSE;
		}
		break;
	}

	if ( !bRv )
	{
		AfxMessageBox("Can't Move Robot. Change Move Velocity!(10 ~ 20)");
	}

	return bRv;
*/
	return TRUE;
}

//--------------------------------------------------------------------------------
// for Change Jog Speed
//--------------------------------------------------------------------------------
void CServoTabView::OnChangeJogVel() 
{
	UpdateData( TRUE );

	double fSpeed;
	CString	sMsg;

	fSpeed = atof( m_sJogSpeed );

	if( fSpeed < ( m_nMinJogSpeed / 10 ) )	return;
	else if( fSpeed > ( m_nMaxJogSpeed / 10 ) )
	{
		sMsg.Format( "MAX JOG SPEED IS %d", m_nMaxJogSpeed );
		AfxMessageBox( sMsg );
		m_sJogSpeed.Format( "%d", (int) m_fJogSpeed );
		UpdateData( FALSE );
		return;
	}
	
	m_fJogSpeed = fSpeed;
	m_sliderJogSpeed.SetPos( (int)( m_nMaxJogSpeed - ( fSpeed * 10 ) + m_nMinJogSpeed ) );
}

//--------------------------------------------------------------------
// Robot Move Speed Selection Changed
//--------------------------------------------------------------------
//void CServoTabView::OnSelchangeListRbtMoveSpeed() 
//{
//	CString sSpeed;
//	int nIndex = m_listRbtMoveSpeed.GetCurSel();
//	m_listRbtMoveSpeed.GetText( nIndex, sSpeed );
//	double fVel = atof( sSpeed );
//	m_pMmc->SetVelRatio( m_nRbtType, fVel );
//}

//--------------------------------------------------------------------
// CListCtl (Add one row of the list control)
//--------------------------------------------------------------------
void CServoTabView::AddOneItem(int iNo, double fX, double fY, double fZ, double fTh, CString sName)
{
	int nActualIndex;
	int nCol = 0;
	char szTemp[30];
    LV_ITEM lvItem; 

	lvItem.mask = LVIF_TEXT;
    lvItem.state = 0; 
    lvItem.stateMask = 0; 
    lvItem.iImage = -1;
    lvItem.lParam = 0;

	// ȣ
	lvItem.iItem = m_lcPoint.GetItemCount() + 1; 
	lvItem.iSubItem = nCol++;
	wsprintf( szTemp, "%d", iNo );
	lvItem.pszText = szTemp;
	nActualIndex = m_lcPoint.InsertItem(  &lvItem );

	// X
	lvItem.iItem = nActualIndex;
	lvItem.iSubItem = nCol++;
	sprintf( szTemp, "%6.3lf", fX );
	lvItem.pszText = szTemp;
	m_lcPoint.SetItem( &lvItem );
		
	// Y
	lvItem.iItem = nActualIndex;
	lvItem.iSubItem = nCol++;
	sprintf( szTemp, "%6.3lf", fY );
	lvItem.pszText = szTemp;
	m_lcPoint.SetItem( &lvItem );

	// Z
	lvItem.iItem = nActualIndex;                           
	lvItem.iSubItem = nCol++;
	sprintf( szTemp, "%6.3lf", fZ );
	lvItem.pszText = szTemp;
	m_lcPoint.SetItem( &lvItem );
		
	// Theta
	lvItem.iItem = nActualIndex;
	lvItem.iSubItem = nCol++;
	sprintf( szTemp, "%6.3lf", fTh );
	lvItem.pszText = szTemp;
	m_lcPoint.SetItem( &lvItem );

	// Name
	lvItem.iItem = nActualIndex;
	lvItem.iSubItem = nCol++;
	sprintf( szTemp, "%s", sName );
	lvItem.pszText = szTemp;
	m_lcPoint.SetItem( &lvItem );
}

//--------------------------------------------------------------------------------
// GetAxis : Axis Mapping
//--------------------------------------------------------------------------------
int CServoTabView::GetAxis()
{
	INT nMask	= m_pMmc->m_RbtInfo[m_nRbtType].nMask;
	int nIndex = 0;

	for( int i=0; i<MAX_RBT_AXES; i++ ) 
	{
		if( nMask & ( 1 << i ) ) m_nRbtAxis[nIndex++] = i;
	}
	return 0;
}

//--------------------------------------------------------------------------------
// EnableBtn
//--------------------------------------------------------------------------------
void CServoTabView::EnableBtn(BOOL bEnable)
{
//	GetDlgItem( IDC_LIST_RBT_MOVE_SPEED )->EnableWindow( bEnable );
//	GetDlgItem( IDC_LIST_RBT_JOG_SPEED )->EnableWindow( bEnable );
	GetDlgItem( IDC_RBT_MOVE_SPEED )->EnableWindow( bEnable );
	GetDlgItem( IDC_RBT_JOG_SPEED )->EnableWindow( bEnable );
	GetDlgItem( IDC_EDIT_RBT_MOVE_SPEED )->EnableWindow( bEnable );
	GetDlgItem( IDC_EDIT_RBT_JOG_SPEED )->EnableWindow( bEnable );
	GetDlgItem( IDC_RBT_PLUS_X )->EnableWindow( bEnable );//2008.08.27 kimgun
	GetDlgItem( IDC_RBT_MINUS_X )->EnableWindow( bEnable );//2008.08.27 kimgun
	GetDlgItem( IDC_MOVE_HOME )->EnableWindow( bEnable );
//	GetDlgItem( IDC_SAVE )->EnableWindow( bEnable );
	
	GetDlgItem( IDC_LC_POINT )->EnableWindow( bEnable );

	GetDlgItem( IDC_RBT_ORG )->EnableWindow( bEnable );
	if( m_pMmc->m_bHomeComp[m_nRbtType] )GetDlgItem( IDC_RBT_MOVE )->EnableWindow( bEnable );
	if( m_pMmc->m_bHomeComp[m_nRbtType] )GetDlgItem( IDC_RBT_MOVE_REPEAT )->EnableWindow( bEnable );
}

//--------------------------------------------------------------------------------
// SetRobotTeachingPoint
//--------------------------------------------------------------------------------
void CServoTabView::SetRobotTeachingPoint(int nRbtType)
{
	m_lcPoint.DeleteAllItems();
	m_pMmc->PosFile2Mem( nRbtType );

	int nMaxPosNo = m_pMmc->m_RbtInfo[nRbtType].nMax_pos_no;
	for( int i=0; i<nMaxPosNo; i++ )
	{
		RBT_POS pos = m_pMmc->m_RbtInfo[nRbtType].pos[i];
		AddOneItem( i, pos.dPos[0], pos.dPos[1], pos.dPos[2], pos.dPos[3], m_pMmc->m_sRbtPosName[nRbtType][i] );
	}
}

//--------------------------------------------------------------------
// Display the position and state
//--------------------------------------------------------------------
void CServoTabView::DisplayPosAndState()
{
	static RBT_POS rpOldPos = {0,};
	static RBT_STATE rsOldState = {0,};

	RBT_POS rpPos = {0,};
	if( !m_pMmc->GetCurPosition( m_nRbtType, rpPos ) ) return;
	RBT_STATE rsState = m_pMmc->GetRbtStatus( m_nRbtType );
	for( int i=0; i<2; i++ )
	{
		// Pos
		CString sPos;
		if( m_nRbtAxis[i] < 0 ) break;

		if( rsState.axis_sensor[m_nRbtAxis[i]].PosLimit )
			m_stcPosLimit[i].SetBkColor( RED_COLOR );
		else
			m_stcPosLimit[i].SetBkColor( WHITE_COLOR );

		if( rsState.axis_sensor[m_nRbtAxis[i]].Home )
			m_stcHome[i].SetBkColor( GREEN_COLOR );
		else
			m_stcHome[i].SetBkColor( WHITE_COLOR );

		if( rsState.axis_sensor[m_nRbtAxis[i]].NegLimit )
			m_stcNegLimit[i].SetBkColor( RED_COLOR );
		else
			m_stcNegLimit[i].SetBkColor( WHITE_COLOR );
		
		// ̸ Checkϴ  dPos[i] -0.005   ö -0.00 ȯǾ Ǽ ƴ ̻ 
		//  νϿ "Ǽ Էϼ"  Message ڲ    Ѵ.
		if( rpPos.dPos[m_nRbtAxis[i]] < 0 && rpPos.dPos[m_nRbtAxis[i]] > -0.01 ) rpPos.dPos[m_nRbtAxis[i]] = 0.0;

		sPos.Format( "%.3f", rpPos.dPos[m_nRbtAxis[i]] );
		SetDlgItemText( IDC_CUR_POS_X + i, sPos );

		SetAxisEventState( i, m_pMmc->m_RbtState[m_nRbtType].nAxis_state[m_nRbtAxis[i]] );
		SetAxisSourceState( i, m_pMmc->m_RbtState[m_nRbtType].nAxis_source[m_nRbtAxis[i]] );

		if( MAX_MUX10 == 0 )
		{
			if( m_sthetaDisplay != "FAIL" && atof(m_sthetaDisplay) != 
				m_pMmc->m_AxisPara[m_pMmc->m_RbtInfo[m_nRbtType].nStart_axis].dTheta_H )
				GetDlgItem( IDC_SAVE )->EnableWindow( TRUE );
			else GetDlgItem( IDC_SAVE )->EnableWindow( FALSE );
		}
//		UpdateData( TRUE );	// SanghoCho 2015.05.20
		//Ʒ κ Gird control Ͽ displayѴ.
		// State
//		CString sCurState = m_pMmc->m_sAxisState[rsState.nAxis_state[m_nRbtAxis[i]]];
//		SetDlgItemText( IDC_X_EVENT + i, sCurState );
//
//		// Source
//		CString sCurSource = m_pMmc->m_sAxisSource[rsState.nAxis_source[m_nRbtAxis[i]]];
//		SetDlgItemText( IDC_X_SOURCE + i, sCurSource );
	}
}

//--------------------------------------------------------------------------------
// SetRbtMove
//--------------------------------------------------------------------------------
void CServoTabView::SetRbtMove()
{
	int nAxis = 0;
	RBT_POS rpPos;

	for( int i=0; i<MAX_RBT_AXES; i++ )
	{
		if( m_pMmc->m_RbtInfo[m_nRbtType].nMask & ( 1 << i ) )
		{
			if( nAxis == 0 ) rpPos.dPos[i] = m_fPosX;
			else if( nAxis == 1 ) rpPos.dPos[i] = m_fPosY;
			else rpPos.dPos[i] = 0.0;

			nAxis++;
		}
		else rpPos.dPos[i] = 0.0;
	}
	
	CString sBuf;
	sBuf.Format( "POSITION MOVE START : %f, %f, %f, %f", 
		rpPos.dPos[0], rpPos.dPos[1], 
		rpPos.dPos[2], rpPos.dPos[3] );
	( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf );
	EnableBtn( FALSE );
	m_nAction = actMOVE;
}

//--------------------------------------------------------------------------------
// SeqRbtMove
//--------------------------------------------------------------------------------
#ifndef _OK__
#define _OK__	0
#endif
#ifndef _NG__
#define _NG__	-1
#endif

void CServoTabView::SeqRbtMove()
{
	int nRv;
	static BOOL nTrPos = 3;	// Not Connection
	static int nCurPos;
	static int nCount = 0;

//	if( ( m_nRbtType == RBT_LD_TILT_UNIT ) || ( m_nRbtType == RBT_UL_TILT_UNIT ) )
//	{
//		if( ( (CServoView*)m_pView )->nCheckCondition( m_nRbtType, 2, TRUE ) == _OK__ ) m_nAction = actE_STOP;
//		if( ( (CServoView*)m_pView )->nCheckCondition( m_nRbtType, 3, TRUE ) == _OK__ ) m_nAction = actE_STOP;
//	}

	switch( m_nAction )
	{
	case actE_STOP:
		if( m_pMmc->EStopRbt( m_nRbtType ) )
		{
			( (CServoView*)m_pView )->SetLog( m_sRbtName, "E-STOP COMPLETE" );
		//	EnableBtn( TRUE );2008.09.02 kimgun estop ϰ moving Ұϴϱ..
			m_macEStop.SetCheck( 0 );
			m_nAction = actNONE;
		}
		break;
	case actRESET:
		if( m_pMmc->ResetRbt( m_nRbtType ) )
		{
			( (CServoView*)m_pView )->SetLog( m_sRbtName, "RESET COMPLETE" );
			EnableBtn( TRUE );
			m_macReset.SetCheck( 0 );
			m_nAction = actNONE;
		}
		break;
	case actHOME:
		{
			m_nAction = 300;
		}
		break;
	case 300 :
		if( ( nRv = m_pMmc->MoveRbtHome( m_nRbtType ) ) == 0 )
		{
			//  Position 0
			( (CServoView*)m_pView )->SetLog( m_sRbtName, "HOME COMPLETE" );
			EnableBtn( TRUE );
			m_macRbtOrg.SetCheck( 0 );
			m_nAction = actNONE;
		}
		else if( nRv > 0 )
		{
			( (CServoView*)m_pView )->SetLog( m_sRbtName, "HOMING FAILED", TRUE );
			EnableBtn( TRUE );
			m_macRbtOrg.SetCheck( 0 );
			m_nAction = actNONE;
		}
		break;
	case actMOVE:
		{
			m_nAction = 400;
		}
		break;
	case 400 :
		if( ( nRv = m_pMmc->MoveRbtPos( m_nRbtType, m_nPosNo ) ) == 0 )
		{
			CString sBuf;
			sBuf.Format("POS(%d) MOVE COMPLETE", m_nPosNo );
			( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf );

			//if( m_nInitPos != m_nPosNo ) ((CServoView*)m_pView)->m_pMainSeq->m_bManuMotorMove[m_nRbtNo] = TRUE;
			//else ((CServoView*)m_pView)->m_pMainSeq->m_bManuMotorMove[m_nRbtNo] = FALSE;

			EnableBtn( TRUE );
			m_macRbtMove.SetCheck( 0 );
			m_nAction = actNONE;
		}
		else if( nRv > 0 )
		{
			CString sBuf;
			sBuf.Format( "POS(%d) MOVE FAILED", m_nPosNo );
			( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf, TRUE );
			EnableBtn( TRUE );
			m_macRbtMove.SetCheck( 0 );
			m_nAction = actNONE;
		}
		break;
	case actMOVE_REPEAT:
		{
			m_nAction = 600;
		}
		break;
	case 600:
		if( ( nRv = m_pMmc->MoveRbtPos( m_nRbtType, m_rpTargetPos ) == 0 ) )
		{
			Sleep( 300 );
			static BOOL bSwitch = TRUE;
//			// dsptemp - for LD Up/Dn Unit Servo Motor Test
//			static DWORD dwTickStart = GetTickCount();

			if( bSwitch /*&& ( ( GetTickCount() - dwTickStart ) > 15000 )*/ ) 
			{
				bSwitch = FALSE;
				m_rpTargetPos = m_rpCurPos;
//				dwTickStart = GetTickCount();
			}
			else if( !bSwitch /*&& ( ( GetTickCount() - dwTickStart ) > 15000 )*/ )
			{
				m_rpTargetPos = m_rpPos;
				bSwitch = TRUE;
//				dwTickStart = GetTickCount();
			}
		}
		else if( nRv > 0 )
		{
			CString sBuf;
			sBuf.Format( "POS REPEAT MOVE FAILED", m_nPosNo );
			( (CServoView*)m_pView )->SetLog( m_sRbtName, sBuf, TRUE );
			EnableBtn( TRUE );

			m_macRbtMoveRepeat.SetCheck( 0 );
			m_nAction = actNONE;
		}
		break;
	} 
}

void CServoTabView::OnServoHelp()
{
	CreateHelpDialog();
}

void CServoTabView::CreateHelpDialog()
{
	UpdateData(TRUE);

	// record the cursor position
	CPoint ptCursorPos;
	::GetCursorPos(&ptCursorPos);

	// create an CAniDialog
	CDlgServoHelp dlg(ptCursorPos);

	dlg.m_bMovePossible = PreCheckInterlock();
	dlg.m_nRbtType = m_nRbtType;
	dlg.m_nPointNo = m_nPosNo;
	dlg.m_nCurPos = ( m_nSrcPosNo < 0 ) ? 0 : m_nSrcPosNo;

	/////////////////////////////////////////////////////////////////////////////
	//Servo Help Dialog ocx setting  Dialog  Setting Ѵ...
	/////////////////////////////////////////////////////////////////////////////
	{
		/////////////////////////////////////////////////////////////////////////////
		// Servo TR Ǵ R/B   Dialog ׸ ǥ ʴ´.
		/////////////////////////////////////////////////////////////////////////////
		dlg.m_nHandType = -1;
	}

	dlg.SetAniStyles( AS_TOPLEFT, AS_REFER );
	dlg.SetDispStyle( 0 );
	dlg.SetMmc( m_pMmc );

	// pop up
	dlg.DoModal(); 
} 

BOOL CServoTabView::PreCheckInterlock()
{

	BOOL bGlassExist = FALSE;
//	int nIfNo;
/*	if( m_nRbtType == RBT_LD_UPDN_UNIT ) nIfNo = IF_UNIT_LD;
	else nIfNo = -1;

	if( m_nRbtType == RBT_LD_UPDN_UNIT && m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_LD, 1 ) ) return FALSE;

	if( ( (CServoView*)m_pView )->CheckCond( m_nRbtType, m_pMmc->GetCurPoint( m_nRbtType ), bGlassExist, m_nPosNo ) &&
			CheckMoveVel( m_nRbtType, m_pMmc->GetCurPoint( m_nRbtType ), m_nPosNo ) &&
			CheckCv( m_nRbtType ) )
		return TRUE;
	else 
*/		return FALSE;
}

void CServoTabView::GridInit()
{
	LPTSTR sLvcText[] = { " NAME ", " 1-AXIS ", " 2-AXIS " };
	int nColWidth[] = { 2450, 640, 640 };

	LPTSTR	sEvent[] = { 
		"NO_EVENT",
		"STOP_EVENT",
		"E_STOP_EVENT",
		"ABORT_EVENT",
	};

	LPTSTR sSource[] = {
		"ST_NONE",
		"ST_HOME_SWITCH",
		"ST_POS_LIMIT",
		"ST_NEG_LIMIT",
		"ST_AMP_FAULT",
		"ST_ACC_LIMIT",
		"ST_VEL_LIMIT",
		"ST_SOFT_NEG_LIMIT",
		"ST_SOFT_POS_LIMIT",
		"ST_ERROR_LIMIT",
		"ST_PC_COMMAND",
		"ST_OUT_OF_FRAME",
		"ST_AMP_POWER_ONOFF",
		"ST_ABS_COMM_ERROR",
	};

	m_gridEventState.SetRows( MAX_EVENT_NO + 1 );
	m_gridEventState.SetCols( 3 );

	m_gridEventState.SetRow( 0 ); 
	m_gridEventState.SetCol( 0 );
	m_gridEventState.SetColWidth( 0, nColWidth[0] );
	m_gridEventState.SetCellAlignment( 4 );
	m_gridEventState.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridEventState.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridEventState.SetColWidth( 1, nColWidth[1] );
	m_gridEventState.SetCol( 1 ); 
	m_gridEventState.SetCellAlignment( 4 );
	m_gridEventState.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridEventState.SetText( sLvcText[1] );
	//---------------------------------------------
	m_gridEventState.SetColWidth( 2, nColWidth[2] );
	m_gridEventState.SetCol( 2 ); 
	m_gridEventState.SetCellAlignment( 4 );
	m_gridEventState.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridEventState.SetText( sLvcText[2] );

	for( int i = 1 ; i < MAX_EVENT_NO + 1 ; i++ )
	{
		m_gridEventState.SetRow( i ); 
		m_gridEventState.SetCol( 0 );
		m_gridEventState.SetCellAlignment( 1 );
		m_gridEventState.SetCellBackColor( WHITE_COLOR );
		m_gridEventState.SetText( sEvent[i-1] ); 

		m_gridEventState.SetCol( 1 );
		m_gridEventState.SetCellAlignment( 1 );
		m_gridEventState.SetCellBackColor( WHITE_COLOR );
		m_gridEventState.SetText( "" ); 

		m_gridEventState.SetCol( 2 );
		m_gridEventState.SetCellAlignment( 1 );
		m_gridEventState.SetCellBackColor( WHITE_COLOR );
		m_gridEventState.SetText( "" ); 
	}

	m_gridSourceState.SetRows( MAX_SOURCE_NO + 1 );
	m_gridSourceState.SetCols( 3 );

	m_gridSourceState.SetRow( 0 ); 
	m_gridSourceState.SetCol( 0 );
	m_gridSourceState.SetColWidth( 0, nColWidth[0] );
	m_gridSourceState.SetCellAlignment( 4 );
	m_gridSourceState.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridSourceState.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridSourceState.SetColWidth( 1, nColWidth[1] );
	m_gridSourceState.SetCol( 1 ); 
	m_gridSourceState.SetCellAlignment( 4 );
	m_gridSourceState.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridSourceState.SetText( sLvcText[1] );
	//---------------------------------------------
	m_gridSourceState.SetColWidth( 2, nColWidth[2] );
	m_gridSourceState.SetCol( 2 ); 
	m_gridSourceState.SetCellAlignment( 4 );
	m_gridSourceState.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridSourceState.SetText( sLvcText[2] );

	for( int i = 1 ; i < MAX_SOURCE_NO + 1 ; i++ )
	{
		m_gridSourceState.SetRow( i ); 
		m_gridSourceState.SetCol( 0 );
		m_gridSourceState.SetCellAlignment( 1 );
		m_gridSourceState.SetCellBackColor( WHITE_COLOR );
		m_gridSourceState.SetText( sSource[i-1] ); 

		m_gridSourceState.SetCol( 1 );
		m_gridSourceState.SetCellAlignment( 1 );
		m_gridSourceState.SetCellBackColor( WHITE_COLOR );
		m_gridSourceState.SetText( "" ); 

		m_gridSourceState.SetCol( 2 );
		m_gridSourceState.SetCellAlignment( 1 );
		m_gridSourceState.SetCellBackColor( WHITE_COLOR );
		m_gridSourceState.SetText( "" ); 
	}
}

/////////////////////////////////////////////////////////////////////////////
//for Event State grid update
/////////////////////////////////////////////////////////////////////////////
void CServoTabView::SetAxisEventState( int nAxis, int nEvent )
{
	if( nEvent == m_nOldEvent[m_nRbtType][nAxis] )	return;

	m_nOldEvent[m_nRbtType][nAxis] = nEvent;

	for( int i = 1 ; i < MAX_EVENT_NO + 1 ; i++ )
	{
		m_gridEventState.SetRow( i );
		m_gridEventState.SetCol( nAxis + 1 );
		if( i == ( nEvent + 1 ) )
		{
			if( i == 1 )
				m_gridEventState.SetCellBackColor( GREEN_COLOR );
			else
				m_gridEventState.SetCellBackColor( RED_COLOR );
		}
		else
			m_gridEventState.SetCellBackColor( WHITE_COLOR );
	}
}

/////////////////////////////////////////////////////////////////////////////
//for Source State grid update
/////////////////////////////////////////////////////////////////////////////
void CServoTabView::SetAxisSourceState( int nAxis, int nSource )
{
	BOOL	bSource[MAX_SOURCE_NO] = { FALSE, };

	nSource &= 0x1fff;

	if( nSource == m_nOldSource[m_nRbtType][nAxis] )	return;

	m_nOldSource[m_nRbtType][nAxis] = nSource;

	if( nSource == 0 )	bSource[0] = TRUE;
	else
	{
		for( int i = 0 ; i < MAX_SOURCE_NO - 1 ; i++ )
		{
			if( ( nSource >> i ) & 0x1 ) bSource[i+1] = TRUE;
		}
	}

	for( int i = 1 ; i <= MAX_SOURCE_NO ; i++ )
	{
		m_gridSourceState.SetRow( i );
		m_gridSourceState.SetCol( nAxis + 1 );
		if( bSource[i-1] )
		{
			if( i == 1 || i == 2 )
				m_gridSourceState.SetCellBackColor( GREEN_COLOR );
			else
				m_gridSourceState.SetCellBackColor( RED_COLOR );
		}
		else
			m_gridSourceState.SetCellBackColor( WHITE_COLOR );
	}

}

/////////////////////////////////////////////////////////////////////////////
//Move Speed Slider    edit box Update Ѵ.
/////////////////////////////////////////////////////////////////////////////
void CServoTabView::OnCustomdrawMoveSpeed(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here

	int nPos;
	nPos = m_sliderMoveSpeed.GetPos();
	m_sMoveSpeed.Format( "%d", MAX_MOVE_RATIO - nPos + MIN_MOVE_RATIO );
	m_fMoveSpeed = MAX_MOVE_RATIO - nPos + MIN_MOVE_RATIO;

//	GetDlgItem( IDC_EDIT_RBT_MOVE_SPEED )->UpdateData( FALSE );
	SetDlgItemText( IDC_EDIT_RBT_MOVE_SPEED, m_sMoveSpeed );

	m_pMmc->SetVelRatio( m_nRbtType, m_fMoveSpeed / 100 );
	m_sliderMoveSpeed.SetPos( (int)( MAX_MOVE_RATIO - m_fMoveSpeed + MIN_MOVE_RATIO ) );

	*pResult = 0;
}

/////////////////////////////////////////////////////////////////////////////
//Jog Speed Slider    edit box Update Ѵ.
/////////////////////////////////////////////////////////////////////////////
void CServoTabView::OnCustomdrawJogSpeed(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int nPos;
	nPos = m_sliderJogSpeed.GetPos();
	m_sJogSpeed.Format( "%.1f", ( (double)m_nMaxJogSpeed - (double)nPos + (double)m_nMinJogSpeed ) / 10 );
	m_fJogSpeed = ( (double)m_nMaxJogSpeed - (double)nPos + (double)m_nMinJogSpeed ) / 10;

	//GetDlgItem( IDC_EDIT_RBT_JOG_SPEED )->UpdateData( FALSE );
	SetDlgItemText( IDC_EDIT_RBT_JOG_SPEED, m_sJogSpeed );

	*pResult = 0;
}

/////////////////////////////////////////////////////////////////////////////
// EVENT  Help Display
/////////////////////////////////////////////////////////////////////////////
void CServoTabView::OnEventHelp()
{
	CPoint ptCursorPos;
	::GetCursorPos(&ptCursorPos);

	// create an CAniDialog
	CDlgMmcState dlg(ptCursorPos);

	m_gridEventState.SetCol( 0 );
	dlg.m_sStateName = m_gridEventState.GetText();
	dlg.m_nHelpContents = HELP_EVENT;
	dlg.SetAniStyles( AS_TOPLEFT, AS_REFER );
	dlg.SetDispStyle( 0 );
	
	// pop up
	dlg.DoModal();	
}

/////////////////////////////////////////////////////////////////////////////
// SOURCE  Help Display
/////////////////////////////////////////////////////////////////////////////
void CServoTabView::OnSourceHelp()
{
	CPoint ptCursorPos;
	::GetCursorPos(&ptCursorPos);

	// create an CAniDialog
	CDlgMmcState dlg(ptCursorPos);

	m_gridSourceState.SetCol( 0 );
	dlg.m_sStateName = m_gridSourceState.GetText();
	dlg.m_nHelpContents = HELP_SOURCE;
	dlg.SetAniStyles( AS_TOPLEFT, AS_REFER );
	dlg.SetDispStyle( 0 );

	// pop up
	dlg.DoModal();	
}
//--------------------------------------------------------------------------------
// OnMoveHome
//--------------------------------------------------------------------------------
void CServoTabView::OnMoveHome()
{
	if( ( (CServoView*)m_pView )->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idADMIN ) 
		return;
	if( AfxMessageBox( "ARE YOU SURE MOVE HOME? YES(START) / NO(CANCEL)", MB_YESNO ) == IDNO )	return;
	m_bMoveHomeBtn = TRUE;
	m_bMoveHomeReq = TRUE;
	EnableBtn(FALSE);
// 	GetDlgItem( IDC_MOVE_HOME )->EnableWindow( FALSE );
// 	GetDlgItem( IDC_SAVE )->EnableWindow( FALSE );
}
//--------------------------------------------------------------------------------
// OnMoveHome
//--------------------------------------------------------------------------------
void CServoTabView::OnSave()
{
	if( AfxMessageBox("Do you want to save a Theta value?" ,MB_YESNO) == IDNO ) return;
	m_pMmc->m_AxisPara[m_pMmc->m_RbtInfo[m_nRbtType].nStart_axis].dTheta_H = atof(m_sthetaDisplay);//0.72;//( m_dtheta / 180. ) * PI;
	m_pMmc->SetThetaToRegistry( m_nRbtType, m_pMmc->m_AxisPara[m_pMmc->m_RbtInfo[m_nRbtType].nStart_axis].dTheta_H );
	GetDlgItem( IDC_SAVE )->EnableWindow( FALSE );
}
//--------------------------------------------------------------------------------
// SeqMoveHome()
//--------------------------------------------------------------------------------
void CServoTabView::SeqMoveHome()
{
	if( !m_bMoveHomeBtn ) return;

	static DWORD dwTickStart = 0;
	static int nAxis = 0;
	double dTheta = 0;
	int nSeqNo = m_nSeqMoveHomeNo;
	
	switch( nSeqNo )
	{
	case 0:
		if( m_bMoveHomeReq )
		{
			m_bMoveHomeReq = FALSE;
			m_dtheta = 0;
			nSeqNo = 10;
		}
		break;
	case 10:
		{
			nAxis = m_pMmc->m_RbtInfo[m_nRbtType].nStart_axis;
			nSeqNo = 20;
		}
		break;
	case 20:
		if( ( m_dtheta = m_pMmc->SetCalTheta( m_nRbtType ) ) > 0 )
		{
			CString sPos;
			sPos.Format( "%.4f", m_dtheta );
			if( MAX_MUX10 == 0 )	SetDlgItemText( IDC_EDIT_DTHETA , sPos );
			m_dtheta = atof( sPos );		
			sPos = "R/B Theta Change :" + sPos;
			( (CServoView*)m_pView )->SetLog( m_sRbtName, sPos );
			m_bMoveHomeBtn = FALSE;
			m_pMmc->m_bHomeComp[m_nRbtType] = FALSE;
			EnableBtn(TRUE);
			nSeqNo = 0;
		}	
		else if ( m_dtheta == -100 )
		{
			if( MAX_MUX10 == 0 )	SetDlgItemText( IDC_EDIT_DTHETA , "FAIL" );
			( (CServoView*)m_pView )->SetLog( m_sRbtName, "GetCalTheta Fail" );
			m_pMmc->m_bHomeComp[m_nRbtType] = FALSE;
			EnableBtn(TRUE);			
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqMoveHomeNo = nSeqNo; 
}
//--------------------------------------------------------------------------------
// DisplayTheta
//--------------------------------------------------------------------------------
void CServoTabView::DisplayTheta()
{
	CString sBuf;
	static double dOldTheta[MAX_AXES] = { -1, };
	static double dOldGap[MAX_AXES] = { -1, };

	if( MAX_MUX10 == 0 )
	{
		if( m_dtheta != 2  )
		{
			if( dOldTheta[m_nRbtType] != m_dtheta )
			{
				dOldTheta[m_nRbtType] = m_dtheta;
				sBuf.Format("%f",m_pMmc->m_AxisPara[m_pMmc->m_RbtInfo[m_nRbtType].nStart_axis].dTheta_H);
				SetDlgItemText(IDC_EDIT_DTHETA,sBuf);
			}	
		}
		else 
		{
			sBuf = "FAIL";
			SetDlgItemText(IDC_EDIT_DTHETA,sBuf);
		}
	}
	else
	{
		sBuf.Format( "%.3f", ((CDicsView*)m_pView)->m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+m_nRbtType ]);
		if(dOldGap[m_nRbtType] != ((CDicsView*)m_pView)->m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+m_nRbtType ])
		{
			SetDlgItemText(IDC_EDIT_DTHETA,sBuf);
			dOldGap[m_nRbtType] = ((CDicsView*)m_pView)->m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+m_nRbtType ];
		}
	}
	UpdateData( TRUE );
}