// ServoTabView.h: interface for the CServoTabView class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERVOTABVIEW_H__42E6A0CC_A0E8_4CE3_8183_A920BA3EE6F9__INCLUDED_)
#define AFX_SERVOTABVIEW_H__42E6A0CC_A0E8_4CE3_8183_A920BA3EE6F9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ServoTabView.h : header file
//
#include "..\X\XMmc.h"
#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\X\PointListCtrl.h"
#include "..\X\MacButtons.h"
#include "..\DicsDoc.h"
#include "..\Sequence\MainSeq.h"
#include "..\Dlg\DlgServoHelp.h"
#include "..\Dlg\DlgMmcState.h"
#include "..\FactoryLib\EqpAssy.h"
/////////////////////////////////////////////////////////////////////////////
// CServoTabView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CServoTabView : public CFormView
{
public:
	CServoTabView();           // protected constructor used by dynamic creation
	CServoTabView( CView* pView , CString sRbtName, int nRbtType );
	DECLARE_DYNCREATE(CServoTabView)
	
	
// Form Data
public:
	//{{AFX_DATA(CServoTabView)
	enum { IDD = IDD_SERVO_TAB_VIEW };
	CMacCheckBox	m_macRbtOrg;
	CMacCheckBox	m_macRbtFirstAxis;
	CMacCheckBox	m_macRbtSecondAxis;
	CMacCheckBox	m_macRbtPlusX;
	CMacCheckBox	m_macRbtMinusX;
	CMacCheckBox	m_macRbtMoveRepeat;
	CMacCheckBox	m_macRbtMove;
	CMacCheckBox	m_macReset;
	CMacCheckBox	m_macEStop;
	CMacCheckBox	m_macPosTrans;
	CMacCheckBox	m_macPosSave;
	CMacCheckBox	m_macPosLoad;
	CMacCheckBox	m_macMoveHome;
	CMacCheckBox	m_macSave;
	CColorStatic	m_stcNegLimit[2];
	CColorStatic	m_stcHome[2];
	CColorStatic	m_stcPosLimit[2];
	CPointListCtrl	m_lcPoint;
	double	m_fCurPosX;
	double	m_fCurPosY;
	double	m_fPosX;
	double	m_fPosY;
	double	m_fVelX;
	double	m_fVelY;
	CMSFlexGrid		m_gridEventState;
	CMSFlexGrid		m_gridSourceState;
	CSliderCtrl		m_sliderMoveSpeed;
	CSliderCtrl		m_sliderJogSpeed;
	CString			m_sMoveSpeed;
	CString			m_sJogSpeed;
	CString			m_sthetaDisplay;
	int				m_nMaxJogSpeed;
	int				m_nMinJogSpeed;
	double			m_fMoveSpeed;
	double			m_fJogSpeed;
	//float	m_fErr;
	//}}AFX_DATA
	static CString strTitle[MAX_AXES_RB_NO];
// Attributes
public:

	struct tagOPERATION{
		BOOL	bMoveStart;
		int		nTargetPos;
		int		nSourcePos;
		BOOL	bRepeateMove;
		BOOL	bStop;
		double	dVelRatio;
	} m_OpFlag;

	
	CView*			m_pView;
	XMmc*			m_pMmc;
	XCtlDevice*		m_pDevice;
	CEqpAssy*		m_pEqpAssy;

	RBT_POS	m_rpPos;
	RBT_POS	m_rpCurPos;
	RBT_POS m_rpTargetPos;

	CString m_sRbtName;
	int		m_nRbtType;

	int		m_nInitPos;
	int		m_nRbtAxis[2];
	int		m_nSelAxis;
	double	m_fJogVel;
	int		m_nSign;
	int		m_nPosNo;
	int		m_nSrcPosNo;
	int		m_nTarPosNo;
	int		m_nRptPosNo;
	int		m_nAction;
	BOOL	m_bPermitAccess;
	BOOL	m_bMoveHomeBtn;
	BOOL	m_bMoveHomeReq;
	BOOL	m_bHelpVisible;
	int		m_nOldEvent[MAX_RBT_NO][2];
	int		m_nOldSource[MAX_RBT_NO][2];
	int		m_nSeqMoveHomeNo;//jun
	double	m_dtheta;//jun


	enum actROBOT
	{
		actNONE,
		actE_STOP,
		actRESET,
		actHOME,
		actMOVE,
		actR_MOVE,
		actMOVE_REPEAT
	};

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CServoTabView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	void SetAxisSourceState( int nAxis, int nEvent );
	void SetAxisEventState( int nAxis, int nEvent );
	void GridInit();
	BOOL PreCheckInterlock();
	void CreateHelpDialog();
	CDicsDoc* GetDocument();

	void AddOneItem( int iNo, double fX, double fY, double fZ, double fTh, CString sName );
	void EnableBtn( BOOL bEnable );
	void SetRobotTeachingPoint( int nRbtType );
	int	 GetAxis();
	void SetRbtMove();
	void DisplayPosAndState();

	void SeqRbtMove();
	void SeqMoveHome();	
	void DisplayTheta();
	BOOL CheckMoveVel( int nRbtType, int nCurPos, int nTargetPos );
	BOOL CheckCv( int nRbtType );

	virtual ~CServoTabView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CServoTabView)
	afx_msg void OnClose();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnEstop();
	afx_msg void OnReset();
	afx_msg void OnPosTrans();
	afx_msg void OnPosSave();
	afx_msg void OnPosLoad();
	afx_msg void OnClickLcPoint(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblClickLcPoint(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnRbtMove();
	afx_msg void OnRbtMoveRepeat();
	afx_msg void OnRbtFirstAxis();
	afx_msg void OnRbtSecondAxis();
	afx_msg void OnRbtOrg();
	afx_msg void OnChangeVelX();
	afx_msg void OnChangeVelY();
	afx_msg void OnChangeMoveVel();
	afx_msg void OnChangeJogVel();
//	afx_msg void OnSelchangeListRbtMoveSpeed();
	afx_msg	void OnServoHelp();
	afx_msg void OnEventHelp();
	afx_msg void OnSourceHelp();
	afx_msg void OnBtnKbd();
	afx_msg void OnMoveHome();//jun
	afx_msg void OnSave();	//jun
	afx_msg void OnCustomdrawMoveSpeed(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawJogSpeed(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	afx_msg LRESULT OnBtnPushed(WPARAM WParam, LPARAM lParam);
	afx_msg LRESULT OnBtnReleased(WPARAM WParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
#ifndef _DEBUG  // debug version in DicsView.cpp
inline CDicsDoc* CServoTabView::GetDocument()
   { return (CDicsDoc*)m_pDocument; }
#endif

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SERVOTABVIEW_H__42E6A0CC_A0E8_4CE3_8183_A920BA3EE6F9__INCLUDED_)
