// ServoView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "ServoView.h"
#include "..\MainFrm.h"
#include "..\X\Xlog.h"
//#include "WorkingSet.h"
//#include "KeyPad.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CServoView

IMPLEMENT_DYNCREATE(CServoView, CFormView)

CServoView::CServoView()
	: CFormView(CServoView::IDD)
{
	//{{AFX_DATA_INIT(CServoView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	
	for( int i=0 ; i<MAX_RBT_NO ; i++ )
	{
		m_pServoTabView[i] = NULL;
	}

	m_pTabServoTabSemiAutoView	= NULL;

	m_bHomeBtn = FALSE;
	m_bEStopBtn = FALSE;
	m_bMoveCancel = FALSE;			// ljy_050504
	m_bMoveHomeReq = FALSE;

	m_nRbtType = -1;
	m_nSeqAllEStopNo = 0;
	m_nSeqMoveHomeNo = 0;
	m_nRbNo = -1;
	m_nAxis = -1;

	for( int i = 0 ; i < MAX_RBT_NO ; i ++ )
	{
		m_SeqFlag[i].bMove		= FALSE;
		m_SeqFlag[i].bRepeate	= FALSE;
		m_SeqFlag[i].bCancel	= FALSE;
		m_SeqFlag[i].bEstop		= FALSE;
		m_SeqFlag[i].bReset		= FALSE;
	}
	m_nSeqUnitTrServoNo = 0;
	m_nSeqUnitLdUpHandServoNo = 0;

	// "{[POS1][<RBT1>(G),@1,@2,<RBT2>@5,]}{[POS2][<RBT3>(G)@1,@2,<RBT3>@5,<SS>*34,*25,]}"
	// [POS1]	=   ִ ġ Target Position
	// <RBT1>	=  ؾ RBT Counter part Servo system
	// (G)		= RBT1 Glass  
	// @1,		=  ߻  ִ RBT1 ġ Unsafe Counter part Robot Position 
	// SS		= ԷȮؾ  SENSOR ( ̵Ұ)
	// 29B		= diLD_UNIT_TR_ROBOT_HAND_INTERRUPT
	// DO       = 
/*
#define EUV_UNIT_HOUSE_CLOSE						DI_NODE1+49		// A Type
#define TR_UNIT_ROBOT_HAND_INTERRUPT				DI_NODE1+25		// B Type
#define LD_UNIT_GLS_EXIST_IN						DI_NODE1+0		// B Type
#define LD_UNIT_GLS_EXIST_OUT						DI_NODE1+1		// B Type
#define LD_FISH_UNIT_GLS_EXIST						DI_NODE1+39		// B Type
#define LD_FISH_UNIT_RIB_UP_L						DI_NODE1+35		// A Type
#define LD_FISH_UNIT_RIB_DN_L						DI_NODE1+36		// A Type
#define LD_FISH_UNIT_RIB_UP_R						DI_NODE1+37		// A Type
#define LD_FISH_UNIT_RIB_DN_R						DI_NODE1+38		// A Type
#define LD_UNIT_ALIGN1_BW							DI_NODE1+6		// A Type
#define LD_UNIT_ALIGN2_BW							DI_NODE1+8		// A Type
#define LD_UNIT_ALIGN3_BW							DI_NODE1+10		// A Type
#define LD_UNIT_ALIGN4_BW							DI_NODE1+12		// A Type
#define LD_UNIT_ALIGN1_FW							DI_NODE1+5		// A Type
#define LD_UNIT_ALIGN2_FW							DI_NODE1+7		// A Type
#define LD_UNIT_ALIGN3_FW							DI_NODE1+9		// A Type
#define LD_UNIT_ALIGN4_FW							DI_NODE1+11		// A Type
#define LD_FISH_UNIT_AFTER_RECV						DI_NODE1+31		// A Type
#define UL_POWER_JOINT_CONFIRM						DI_NODE1+18		// A Type
*/
	//////////////////////////////////////////////////////////////////////////
	// TR UNIT
	//////////////////////////////////////////////////////////////////////////	
/*	m_sInterlock[RBT_TR_UNIT][TR_UNIT_HOME_POS][0].Format( 
		"{[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLOK>]}",
		TR_UNIT_WAIT_POS,
		TR_UNIT_SEND_POS,
		TR_UNIT_RECV_POS );
	
	m_sInterlock[RBT_TR_UNIT][TR_UNIT_HOME_POS][1].Format( 
		"{[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLOK>]}",
		TR_UNIT_WAIT_POS,
		TR_UNIT_SEND_POS,
		TR_UNIT_RECV_POS );

	m_sInterlock[RBT_TR_UNIT][TR_UNIT_WAIT_POS][0].Format( 
		"{[POS%d][<SS>,*%dB,*%dB,]} {[POS%d][<LDFISH>(G),@%d,@%d,<SS>,*!%dA,*!%dA,*%dB,*%dB,]} {[POS%d][<SS>,*%dB,]}",
		TR_UNIT_HOME_POS, EUV_UNIT_HOUSE_CLOSE, TR_UNIT_ROBOT_HAND_INTERRUPT,		
		TR_UNIT_SEND_POS, LD_FISH_UNIT_RECV1_POS, LD_FISH_UNIT_RECV2_POS, LD_FISH_UNIT_RIB_UP_L, LD_FISH_UNIT_RIB_UP_R, EUV_UNIT_HOUSE_CLOSE, TR_UNIT_ROBOT_HAND_INTERRUPT,
		TR_UNIT_RECV_POS, TR_UNIT_ROBOT_HAND_INTERRUPT);	

	m_sInterlock[RBT_TR_UNIT][TR_UNIT_WAIT_POS][1].Format( 
		"{[POS%d][<SS>,*%dB,*%dB,]} {[POS%d][<LDFISH>(G),@%d,@%d,<SS>,*!%dA,*!%dA,*%dB,*%dB,]}",
		TR_UNIT_HOME_POS, EUV_UNIT_HOUSE_CLOSE, TR_UNIT_ROBOT_HAND_INTERRUPT,	
		TR_UNIT_SEND_POS, LD_FISH_UNIT_RECV1_POS, LD_FISH_UNIT_RECV2_POS, LD_FISH_UNIT_RIB_UP_L, LD_FISH_UNIT_RIB_UP_R, EUV_UNIT_HOUSE_CLOSE, TR_UNIT_ROBOT_HAND_INTERRUPT );
					
	m_sInterlock[RBT_TR_UNIT][TR_UNIT_RECV_POS][0].Format( "{[POS%d][<ALLOK>]} {[POS%d][<SS>,*%dB,*%dB,]} {[POS%d][<LDFISH>,@%d,<SS>,*!%dA,*!%dA,*%dB,*%dB,*!%dA,]}",
		TR_UNIT_HOME_POS,										
		TR_UNIT_WAIT_POS, EUV_UNIT_HOUSE_CLOSE, TR_UNIT_ROBOT_HAND_INTERRUPT,									
		TR_UNIT_SEND_POS, LD_FISH_UNIT_RECV1_POS, LD_FISH_UNIT_RIB_UP_L, LD_FISH_UNIT_RIB_UP_R, EUV_UNIT_HOUSE_CLOSE, TR_UNIT_ROBOT_HAND_INTERRUPT, UL_POWER_JOINT_CONFIRM );

	m_sInterlock[RBT_TR_UNIT][TR_UNIT_RECV_POS][1].Format( "{[POS%d][<ALLOK>]} {[POS%d][<SS>,*%dB,*%dB,]} {[POS%d][<LDFISH>(G),@%d,@%d,<SS>,*!%dA,*!%dA,*%dB,*%dB,*!%dA,*%dA,]}",
		TR_UNIT_HOME_POS,										
		TR_UNIT_WAIT_POS, EUV_UNIT_HOUSE_CLOSE, TR_UNIT_ROBOT_HAND_INTERRUPT,									
		TR_UNIT_SEND_POS, LD_FISH_UNIT_RECV1_POS, LD_FISH_UNIT_RECV2_POS, LD_FISH_UNIT_RIB_UP_L, LD_FISH_UNIT_RIB_UP_R, EUV_UNIT_HOUSE_CLOSE, TR_UNIT_ROBOT_HAND_INTERRUPT, UL_POWER_JOINT_CONFIRM, LD_FISH_UNIT_AFTER_RECV );
	
	m_sInterlock[RBT_TR_UNIT][TR_UNIT_SEND_POS][0].Format( "{[POS%d][<SS>,*%dB,*%dB,]} {[POS%d][<SS>,*%dB,*%dB,]} {[POS%d][<SS>,*%dB,*%dB,]}",
		TR_UNIT_HOME_POS, EUV_UNIT_HOUSE_CLOSE, TR_UNIT_ROBOT_HAND_INTERRUPT,										
		TR_UNIT_WAIT_POS, EUV_UNIT_HOUSE_CLOSE, TR_UNIT_ROBOT_HAND_INTERRUPT,								
		TR_UNIT_RECV_POS, EUV_UNIT_HOUSE_CLOSE, TR_UNIT_ROBOT_HAND_INTERRUPT );									
	
	m_sInterlock[RBT_TR_UNIT][TR_UNIT_SEND_POS][1].Format( "{[POS%d][<SS>,*%dB,*%dB,]} {[POS%d][<SS>,*%dB,*%dB,]} {[POS%d][<SS>,*%dB,*%dB,]}",
		TR_UNIT_HOME_POS, EUV_UNIT_HOUSE_CLOSE, TR_UNIT_ROBOT_HAND_INTERRUPT,										
		TR_UNIT_WAIT_POS, EUV_UNIT_HOUSE_CLOSE, TR_UNIT_ROBOT_HAND_INTERRUPT,									
		TR_UNIT_RECV_POS, EUV_UNIT_HOUSE_CLOSE, TR_UNIT_ROBOT_HAND_INTERRUPT );									
	//////////////////////////////////////////////////////////////////////////
	// LD FISH HAND UNIT
	//////////////////////////////////////////////////////////////////////////	
	m_sInterlock[RBT_LD_FISH_UNIT][LD_FISH_UNIT_HOME_POS][0].Format( 
		"{[POS%d][<ALLOK>]} {[POS%d][<SS>,*%dB,]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]}",
		LD_FISH_UNIT_SEND2_POS,
		LD_FISH_UNIT_SEND1_POS, LD_UNIT_GLS_EXIST_OUT,
		LD_FISH_UNIT_WAIT_POS ,
		LD_FISH_UNIT_RECV1_POS,
		LD_FISH_UNIT_RECV2_POS );

	m_sInterlock[RBT_LD_FISH_UNIT][LD_FISH_UNIT_HOME_POS][1].Format( 
		"{[POS%d][<ALLOK>]} {[POS%d][<SS>,*%dB,*!%dA,*!%dA,*!%dA,*!%dA,]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]}",
		LD_FISH_UNIT_SEND2_POS,
		LD_FISH_UNIT_SEND1_POS, LD_UNIT_GLS_EXIST_OUT, LD_UNIT_ALIGN1_FW, LD_UNIT_ALIGN2_FW, LD_UNIT_ALIGN3_FW, LD_UNIT_ALIGN4_FW,																									
		LD_FISH_UNIT_WAIT_POS ,
		LD_FISH_UNIT_RECV1_POS,																												
		LD_FISH_UNIT_RECV2_POS );

	m_sInterlock[RBT_LD_FISH_UNIT][LD_FISH_UNIT_SEND2_POS][0].Format( 
		"{[POS%d][<ALLOK>]} {[POS%d][<SS>,*%dB,*!%dA,*!%dA,*!%dA,*!%dA,]} {[POS%d][<SS>,*%dB,]} {[POS%d][<TR>,@%d,<SS>,*%dB,]} {[POS%d][<TR>,@%d,<SS>,*%dB,]}",
		LD_FISH_UNIT_SEND2_POS,
		LD_FISH_UNIT_SEND1_POS, LD_UNIT_GLS_EXIST_OUT, LD_UNIT_ALIGN1_FW, LD_UNIT_ALIGN2_FW, LD_UNIT_ALIGN3_FW, LD_UNIT_ALIGN4_FW,																								
		LD_FISH_UNIT_WAIT_POS ,	LD_UNIT_GLS_EXIST_OUT,																											
		LD_FISH_UNIT_RECV1_POS, TR_UNIT_SEND_POS, LD_UNIT_GLS_EXIST_OUT,																												
		LD_FISH_UNIT_RECV2_POS, TR_UNIT_SEND_POS, LD_UNIT_GLS_EXIST_OUT );

	m_sInterlock[RBT_LD_FISH_UNIT][LD_FISH_UNIT_SEND2_POS][1].Format( 
		"{[POS%d][<ALLOK>]} {[POS%d][<SS>,*%dB,*!%dA,*!%dA,*!%dA,*!%dA,]} {[POS%d][<SS>,*%dB,]} {[POS%d][<TR>,@%d,<SS>,*%dB,]} {[POS%d][<TR>,@%d,<SS>,*%dB,]}",
		LD_FISH_UNIT_SEND2_POS,
		LD_FISH_UNIT_SEND1_POS, LD_UNIT_GLS_EXIST_OUT, LD_UNIT_ALIGN1_FW, LD_UNIT_ALIGN2_FW, LD_UNIT_ALIGN3_FW, LD_UNIT_ALIGN4_FW,																									
		LD_FISH_UNIT_WAIT_POS ,	LD_UNIT_GLS_EXIST_OUT,																												
		LD_FISH_UNIT_RECV1_POS, TR_UNIT_SEND_POS, LD_UNIT_GLS_EXIST_OUT,																												
		LD_FISH_UNIT_RECV2_POS, TR_UNIT_SEND_POS, LD_UNIT_GLS_EXIST_OUT );

	m_sInterlock[RBT_LD_FISH_UNIT][LD_FISH_UNIT_SEND1_POS][0].Format( 
		"{[POS%d][<ALLOK>]} {[POS%d][<SS>,*!%dA,*!%dA,*!%dA,*!%dA,]} {[POS%d][<SS>,*!%dA,*!%dA,*!%dA,*!%dA,]} {[POS%d][<TR>,@%d,]} {[POS%d][<TR>,@%d,]}",
		LD_FISH_UNIT_WAIT_POS,
		LD_FISH_UNIT_SEND2_POS, LD_UNIT_ALIGN1_BW, LD_UNIT_ALIGN2_BW, LD_UNIT_ALIGN3_BW, LD_UNIT_ALIGN4_BW,															
		LD_FISH_UNIT_HOME_POS ,	LD_UNIT_ALIGN1_BW, LD_UNIT_ALIGN2_BW, LD_UNIT_ALIGN3_BW, LD_UNIT_ALIGN4_BW,
		LD_FISH_UNIT_RECV1_POS, TR_UNIT_SEND_POS,
		LD_FISH_UNIT_RECV2_POS, TR_UNIT_SEND_POS );

	m_sInterlock[RBT_LD_FISH_UNIT][LD_FISH_UNIT_SEND1_POS][1].Format( 
		"{[POS%d][<ALLOK>]} {[POS%d][<SS>,*!%dA,*!%dA,*!%dA,*!%dA,]} {[POS%d][<SS>,*!%dA,*!%dA,*!%dA,*!%dA,]} {[POS%d][<TR>,@%d,]} {[POS%d][<TR>,@%d,]}",
		LD_FISH_UNIT_WAIT_POS,
		LD_FISH_UNIT_SEND2_POS, LD_UNIT_ALIGN1_BW, LD_UNIT_ALIGN2_BW, LD_UNIT_ALIGN3_BW, LD_UNIT_ALIGN4_BW,															
		LD_FISH_UNIT_HOME_POS ,	LD_UNIT_ALIGN1_BW, LD_UNIT_ALIGN2_BW, LD_UNIT_ALIGN3_BW, LD_UNIT_ALIGN4_BW,
		LD_FISH_UNIT_RECV1_POS, TR_UNIT_SEND_POS,
		LD_FISH_UNIT_RECV2_POS, TR_UNIT_SEND_POS );

	m_sInterlock[RBT_LD_FISH_UNIT][LD_FISH_UNIT_WAIT_POS][0].Format( 
		"{[POS%d][<SS>,*%dB,]} {[POS%d][<SS>,*%dB,*!%dA,*!%dA,*!%dA,*!%dA,]} {[POS%d][<SS>,*%dB,*!%dA,*!%dA,*!%dA,*!%dA,]} {[POS%d][<TR>,@%d,]} {[POS%d][<TR>,@%d,]}",
		LD_FISH_UNIT_SEND1_POS, LD_UNIT_GLS_EXIST_OUT,																
		LD_FISH_UNIT_SEND2_POS, LD_UNIT_GLS_EXIST_OUT, LD_UNIT_ALIGN1_BW, LD_UNIT_ALIGN2_BW, LD_UNIT_ALIGN3_BW, LD_UNIT_ALIGN4_BW,
		LD_FISH_UNIT_HOME_POS,	LD_UNIT_GLS_EXIST_OUT, LD_UNIT_ALIGN1_BW, LD_UNIT_ALIGN2_BW, LD_UNIT_ALIGN3_BW, LD_UNIT_ALIGN4_BW,
		LD_FISH_UNIT_RECV1_POS, TR_UNIT_SEND_POS,
		LD_FISH_UNIT_RECV2_POS, TR_UNIT_SEND_POS );

	m_sInterlock[RBT_LD_FISH_UNIT][LD_FISH_UNIT_WAIT_POS][1].Format( 
		"{[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]} {[POS%d][<SS>,*%dB,*%dB,]} {[POS%d][<TR>,@%d,]} {[POS%d][<TR>,@%d,]}",
		LD_FISH_UNIT_SEND2_POS,								
		LD_FISH_UNIT_HOME_POS,
		LD_FISH_UNIT_SEND1_POS, LD_UNIT_GLS_EXIST_IN, LD_UNIT_GLS_EXIST_OUT,														
		LD_FISH_UNIT_RECV1_POS, TR_UNIT_SEND_POS,
		LD_FISH_UNIT_RECV2_POS, TR_UNIT_SEND_POS );

	m_sInterlock[RBT_LD_FISH_UNIT][LD_FISH_UNIT_RECV1_POS][0].Format( 
		"{[POS%d][<ALLOK>]} {[POS%d][<TR>,@%d,]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]}",
		LD_FISH_UNIT_RECV2_POS,
		LD_FISH_UNIT_WAIT_POS,	TR_UNIT_SEND_POS,
		LD_FISH_UNIT_SEND1_POS,	
		LD_FISH_UNIT_SEND2_POS,
		LD_FISH_UNIT_HOME_POS );															

	m_sInterlock[RBT_LD_FISH_UNIT][LD_FISH_UNIT_RECV1_POS][1].Format( 
		"{[POS%d][<ALLOK>]} {[POS%d][<TR>,@%d,]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]}",
		LD_FISH_UNIT_RECV2_POS,
		LD_FISH_UNIT_WAIT_POS,	TR_UNIT_SEND_POS,
		LD_FISH_UNIT_SEND1_POS, 
		LD_FISH_UNIT_SEND2_POS, 
		LD_FISH_UNIT_HOME_POS );															

	m_sInterlock[RBT_LD_FISH_UNIT][LD_FISH_UNIT_RECV2_POS][0].Format( 
		"{[POS%d][<TR>,@%d,]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLOK>]}",
		LD_FISH_UNIT_WAIT_POS,	TR_UNIT_SEND_POS,
		LD_FISH_UNIT_SEND1_POS,
		LD_FISH_UNIT_SEND2_POS,
		LD_FISH_UNIT_HOME_POS,
		LD_FISH_UNIT_RECV1_POS );								
		
	m_sInterlock[RBT_LD_FISH_UNIT][LD_FISH_UNIT_RECV2_POS][1].Format( 
		"{[POS%d][<TR>,@%d,]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLNOT>]} {[POS%d][<ALLOK>]}",
		LD_FISH_UNIT_WAIT_POS,	TR_UNIT_SEND_POS,
		LD_FISH_UNIT_SEND1_POS,
		LD_FISH_UNIT_SEND2_POS,
		LD_FISH_UNIT_HOME_POS,
		LD_FISH_UNIT_RECV1_POS );									

	//////////////////////////////////////////////////////////////////////////
	// RB UNIT
	//////////////////////////////////////////////////////////////////////////	
	m_sInterlock[RBT_RB_UNIT_UP_RB1_UNIT][RBT_RB_ZERO_POS][0].Format( "{[POS%d][<ALLOK>]}", RBT_RB_WAIT_POS );
	m_sInterlock[RBT_RB_UNIT_UP_RB1_UNIT][RBT_RB_ZERO_POS][1].Format( "{[POS%d][<ALLOK>]}", RBT_RB_WAIT_POS );
	m_sInterlock[RBT_RB_UNIT_UP_RB1_UNIT][RBT_RB_WAIT_POS][0].Format( "{[POS%d][<ALLOK>]}", RBT_RB_ZERO_POS );
	m_sInterlock[RBT_RB_UNIT_UP_RB1_UNIT][RBT_RB_WAIT_POS][1].Format( "{[POS%d][<ALLOK>]}", RBT_RB_ZERO_POS );

	m_sInterlock[RBT_RB_UNIT_UP_RB2_UNIT][RBT_RB_ZERO_POS][0].Format( "{[POS%d][<ALLOK>]}", RBT_RB_WAIT_POS );
	m_sInterlock[RBT_RB_UNIT_UP_RB2_UNIT][RBT_RB_ZERO_POS][1].Format( "{[POS%d][<ALLOK>]}", RBT_RB_WAIT_POS );
	m_sInterlock[RBT_RB_UNIT_UP_RB2_UNIT][RBT_RB_WAIT_POS][0].Format( "{[POS%d][<ALLOK>]}", RBT_RB_ZERO_POS );
	m_sInterlock[RBT_RB_UNIT_UP_RB2_UNIT][RBT_RB_WAIT_POS][1].Format( "{[POS%d][<ALLOK>]}", RBT_RB_ZERO_POS ); */
}

BOOL CServoView::CheckCond( int nRbtType, int nCurPos, BOOL bWithGlass, int nTargetPos )
{
/*
	CString sInterlock;
	CString sRbtName, sBuf, sBuf1, sTemp, sPosName;

	if( nCurPos == -1 )
	{
		AfxMessageBox( "Current Position is Not Exact! Please Place the Robot at Teached Position By Jog Operation" );
		return FALSE;
	}
	int		n;

#ifdef _MY_DEBUG
	bWithGlass = FALSE;
#endif

	sInterlock = m_sInterlock[nRbtType][nCurPos][bWithGlass];

	//ϴ ġ Interlock ִ°?
	sTemp.Format( "[POS%d]", nTargetPos );
	if( ( n = sInterlock.Find( (LPCTSTR)sTemp, 0 ) ) == -1 ) 
	{
		m_sInterlockMsg.Format( "Target position is not an available position" );
		return FALSE;
	}

	// ش ǥġ  Ǹ ´.
	int nNo;
	nNo = sInterlock.Find( "}", n );
	sBuf = sInterlock.Mid( n, nNo - n );
	CString sTargetPosCond;
	CString sTargetRbtCond;
	sBuf.TrimLeft( sTemp );
	sTargetPosCond = sBuf;
	// RBT or SS  ´.
	n = 0;
	while( ( n = sBuf.Find( "<", 0 ) ) != -1 )
	{
		sTemp = sBuf.Mid( 0, n );
		sBuf.TrimLeft( sTemp );
		int nOtherRbt = 0;
		// Get Robot or Sensor Name
		sRbtName = sBuf.Mid( 0, sBuf.Find( ">", 0 ) + 1 );
		if		( sRbtName == "<TR>" ) nOtherRbt = RBT_TR_UNIT;
		else if	( sRbtName == "<LDFISH>" ) nOtherRbt = RBT_LD_FISH_UNIT;
		else if ( sRbtName == "<SS>");
		else if ( sRbtName == "<DO>");
		else if ( sRbtName == "<ALLOK>" ) return TRUE;
		else if ( sRbtName == "<ALLNOT>" ) return FALSE;
		else 
		{
			CString sMsg;
			sMsg.Format( "Condition Define Error\n%s", sInterlock );
			AfxMessageBox( (LPCTSTR)sMsg );
			return FALSE;
		}
		//sTargetRbtCond = sBuf;
		sBuf.TrimLeft( sRbtName );
		if( sBuf.Find( "<" ) != -1 ) sBuf = sBuf.Mid( 0, sBuf.Find( "<", 1 ) );
		else sBuf = sBuf.Mid( 0, sBuf.Find( "]", 1 ) );
 
		sTargetRbtCond = sRbtName + sBuf;
		sBuf.TrimLeft( sRbtName );

		if( sRbtName != "<SS>" && sRbtName != "<DO>" )
		{
			BOOL bGlass = FALSE;
			if( sBuf.Find( "(G)" ) != -1 ) 
			{
				sBuf.TrimLeft( "(G)" );
				bGlass = TRUE;
			}
			int n1 = 0;
			while( ( n1 = sBuf.Find( "@", 0 ) ) != -1 )
			{
				sTemp = sBuf.Mid( 0, n1 + 1 );
				sBuf.TrimLeft( sTemp );
				sTemp = sBuf.Mid( 0, sBuf.Find( ",", 0 ) );
				if( m_pMmc->GetCurPoint( nOtherRbt ) == atoi( sTemp ) ||
					m_pMmc->GetCurPoint( nOtherRbt ) == -1 )
				{
					if( bGlass ) //Glass Checkؾ Ѵ.
					{
#ifndef _MY_DEBUG
						if( digSERVO_GLASS_SENSOR( nOtherRbt ) ) 
#else
						if( 1 )
#endif
						{
							CString sMsg;
							sMsg.Format( "%s position is %s : Glass Detected", sRbtName, sTemp );
							AfxMessageBox( (LPCSTR)sMsg );
							return FALSE;
						}
					}
					else if( ( n1 = sTargetPosCond.Find( "<SS>" ) ) == -1) //Only Target Position Check
					{
						CString sMsg;
						sMsg.Format( "%s position is %s", sRbtName, sTemp );
						AfxMessageBox( (LPCSTR)sMsg );
						return FALSE;
					}
				}
				n1++;
			}
		}
		else if( sRbtName == "<SS>" )
		{
			int n1 = 0;
			while( ( n1 = sBuf.Find( "*", 0 ) ) != -1 )
			{
				sTemp = sBuf.Mid( 0, n1 + 1 );
				sBuf = sBuf.Mid( sTemp.GetLength(), sBuf.GetLength() - sTemp.GetLength() );
				sTemp = sBuf.Mid( 0, sBuf.Find( ",", 0 ) );

				int bNot = FALSE;
				// ! ȮѴ.
				if( sTemp.Left( 1 ) != "!" ) bNot = FALSE;
				else
				{
					bNot = TRUE;
					sTemp.TrimLeft( "!" );
				}

				int nAddress;
				CString sType;
				BOOL bType; // Sensor Contact Type
				sType = sTemp.Right( 1 );

				if( sType == "A" ) bType = FALSE;
				else if( sType == "B" ) bType = TRUE;
				else 
				{
					sTemp.Format( "Sensor Contact Type Definition Error\n%s", sInterlock );
					AfxMessageBox( (LPCTSTR)sTemp, MB_OK );
					return FALSE;
				}
				sTemp.TrimRight( sType );
				nAddress = atoi( sTemp );

				BOOL bSensorInput = FALSE;
				if( bNot ) bSensorInput = !DioInput( nAddress ); //A Type Sensor Off
				else bSensorInput = DioInput( nAddress );

				if( ( bType ^ bSensorInput ) )
					return FALSE;
				n1++;
			}
		}
		else if( sRbtName == "<DO>" )
		{
			int n2 = 0;
			while( ( n2 = sBuf.Find( "#", 0 ) ) != -1 )
			{
				sTemp = sBuf.Mid( 0, n2 + 1 );
				sBuf = sBuf.Mid( sTemp.GetLength(), sBuf.GetLength() - sTemp.GetLength() );
				sTemp = sBuf.Mid( 0, sBuf.Find( ",", 0 ) );

				int nAddress;

				CString sType;
				BOOL bType; // DO Check On or Off
				sType = sTemp.Right( 1 );
				if( sType == "A" ) bType = FALSE;
				else if( sType == "B" ) bType = TRUE;
				else 
				{
					sTemp.Format( "DO Check On/Off Type Definition Error\n%s", sInterlock );
					AfxMessageBox( (LPCTSTR)sTemp, MB_OK );
					return FALSE;
				}
				sTemp.TrimRight( sType );
				nAddress = atoi( sTemp );

				BOOL bDoState = FALSE;
				bDoState = DioOutputState( nAddress );
				if( bType ^ bDoState )
					return FALSE;
				n2++;
			}
		}
		
		sTargetPosCond = sTargetPosCond.Right( sTargetPosCond.GetLength() - sTargetRbtCond.GetLength()  );
		sBuf = sTargetPosCond;
		n++;
	}
*/
	return TRUE;
}

CServoView::~CServoView()
{
	GetDocument()->m_pServoWnd = NULL;
}

void CServoView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CServoView)
	DDX_Control(pDX, IDC_TAB_SERVO, m_tabCtrl);
// 	DDX_Control(pDX, IDC_RBT_ALL_ESTOP, m_macEStop);
//	DDX_Control(pDX, IDC_RBT_INTERLOCK, m_bitmapInterlock);
//	DDX_Control(pDX, IDC_BUTTON_SOURCE, m_bmpSource);
//	DDX_Control(pDX, IDC_BUTTON_TARGET, m_bmpTarget);
	DDX_Control(pDX, IDC_RBT_ALL_ESTOP, m_bmpbtnEmo);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CServoView, CFormView)
	//{{AFX_MSG_MAP(CServoView)
	ON_WM_DESTROY()
	ON_NOTIFY(NM_CLICK, IDC_TAB_SERVO, OnClickTabServo)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED( IDC_RBT_ALL_ESTOP, OnAllEstop)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServoView diagnostics

#ifdef _DEBUG
void CServoView::AssertValid() const
{
	CFormView::AssertValid();
}

void CServoView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CDicsDoc* CServoView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDicsDoc)));
	return (CDicsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CServoView message handlers


//--------------------------------------------------------------------------------
// OnInitialUpdate
//--------------------------------------------------------------------------------
void CServoView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	CDicsDoc* pDoc = GetDocument();

	// Set pointer
 	m_pMmc = pDoc->m_pDicsView->m_pMmc;
	m_pDevice = pDoc->m_pDicsView->m_pDevice;
	m_pMelsec = pDoc->m_pDicsView->m_pMelsec;		// ljy_050128 : add
	m_pMainSeq = GetDocument()->m_pDicsView->m_pMainSeq;
	m_pDicsData = GetDocument()->m_pDicsView->m_pDicsData;
	m_pEqpAssy = GetDocument()->m_pDicsView->m_pEqpAssy;

	// Set the color brush
	m_hbrBack =	CreateSolidBrush( RGB(119, 207, 226) );
	m_hbrRed =	CreateSolidBrush( RED_COLOR );
	m_hbrBlue = CreateSolidBrush( BLUE_COLOR );
	m_hbrYellow = CreateSolidBrush( YELLOW_COLOR );
	m_hbrBgColor = CreateSolidBrush( BG_COLOR );
	
	m_hbrGreen = CreateSolidBrush( GREEN_COLOR );
	m_hbrCyan = CreateSolidBrush( CYAN_COLOR );
	m_hbrMagenta = CreateSolidBrush( LIGHT_MAGENTA_COLOR );
	m_hbrWhite = CreateSolidBrush( WHITE_COLOR );
	m_hbrBlack = CreateSolidBrush( BLACK_COLOR );

	// Load bitmap
//	m_bitmapInterlock.LoadBitmaps( IDB_DANGER_E, IDB_DANGER, 0, IDB_DANGER );

	// Create the TAB view 
	CRect r;
	GetDlgItem( IDC_TAB_SERVO )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 0, 0, 6, 30 );

	LPSTR sRbtName[MAX_RBT_NO] = {
//		"  LD UPDN  ",
//#ifndef _NO_UL_HAND
//		"  UL HAND  ",
//#endif
//#ifndef _NO_RB
//		"  SPARE   ",
		" SWR2 RB1 UP  ",
		" SWR2 RB1 LO  ",
		" SWR2 RB2 UP  ",
		" SWR2 RB2 LO  ",
		" SWR3 RB1 UP  ",
		" SWR3 RB1 LO  ",
		" SWR3 RB2 UP  ",
		" SWR3 RB2 LO  ",
//#endif
	};
	
	int nServoNo;
	CCreateContext context;
	for( int i=0; i<MAX_RBT_NO; i++ )
	{
//		if( i == RBT_SPARE_UNIT_S_AXIS ) continue;

		nServoNo = i;
		m_pServoTabView[i] = new CServoTabView( this, sRbtName[i], nServoNo );
		m_pServoTabView[i]->Create( NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CServoTabView::IDD, &context );
		m_tabCtrl.AddTab( (CWnd*)m_pServoTabView[i], sRbtName[nServoNo], nServoNo );
		if( i==0 )	m_pServoTabView[i]->SetFocus();
	}
/*	
	m_pTabServoTabSemiAutoView = new CServoTabSemiAutoView( this );
	m_pTabServoTabSemiAutoView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CServoTabSemiAutoView::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabServoTabSemiAutoView, "  SEMI-AUTO  ", nServoNo + 1 );
*/
	m_tabCtrl.SetSelectedColor( RED_COLOR );
	m_tabCtrl.SetMouseOverColor( GREEN_COLOR );
	m_tabCtrl.SetNormalColor( DARK_GRAY_COLOR );

	// Set the MAC button
//	MAC_COLOR_SET color_set;
//	m_macEStop.GetColorSetting( &color_set );
//	color_set.crFace = LIGHT_RED_COLOR;
//	color_set.crLiteShadow = MAGENTA_COLOR;
//	m_macEStop.SetColorSetting( color_set );
//	m_macEStop.SetBold();

	m_bmpbtnEmo.LoadBitmaps( IDB_BITMAP_EMO, IDB_BITMAP_EMO_PUSH, 0, IDB_BITMAP_EMO_PUSH );


	// Set the message box
	GetDlgItem( IDC_MESSAGE )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgMessage.Create( 202, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_MESSAGE,
			BLACK_COLOR, WHITE_COLOR, 14, TRUE );
	m_msgMessage.SetOpMsg( "Transfer Servo Operation" );

	// initialize the Static control
	SetTimer( TIMER_ROBOT( 0 ), 100, NULL );

	// SeqFlag Reset
}
//--------------------------------------------------------------------------------
// OnDestroy
//--------------------------------------------------------------------------------
void CServoView::OnDestroy() 
{
	CFormView::OnDestroy();

	KillTimer( TIMER_ROBOT( 0 ) );

//	CFormView::OnInitialUpdate();
	CDicsDoc* pDoc = GetDocument();

   	if ( pDoc->m_pDicsView )
	{	
		for( int i=0; i<MAX_RBT_NO; i++ ) 
		{
			pDoc->m_pDicsView->m_pMmc->SetVelRatio( i, 1. );
		}
		m_pMmc->InitParameter();
	}

	DeleteObject( m_hbrRed );
	DeleteObject( m_hbrBlue );
	DeleteObject( m_hbrYellow );
	DeleteObject( m_hbrBack );
	DeleteObject( m_hbrBgColor );

	DeleteObject( m_hbrGreen );
	DeleteObject( m_hbrCyan );
	DeleteObject( m_hbrMagenta );
	DeleteObject( m_hbrWhite );
	DeleteObject( m_hbrBlack );	

	for( int i=0 ; i<MAX_RBT_NO ; i++ )
	{
		if( m_pServoTabView[i] )
		{
			m_pServoTabView[i]->SendMessage( WM_CLOSE );
			delete m_pServoTabView[i];
		}
	}
/*
	if( m_pTabServoTabSemiAutoView ) 
	{
		m_pTabServoTabSemiAutoView->SendMessage( WM_CLOSE );
		delete m_pTabServoTabSemiAutoView;
	}
*/
}

//--------------------------------------------------------------------------------
// OnCtlColor
//--------------------------------------------------------------------------------
HBRUSH CServoView::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CFormView::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
//	UINT id = pWnd->GetDlgCtrlID();
//	switch( id )
//	{
//		case IDC_STATIC_BACKGROUND:
//			{
//				hbr = m_hbrBack;
//				pDC->SetBkMode( TRANSPARENT );
//			}
//			break;
//	}
	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

//--------------------------------------------------------------------------------
// OnTimer
//--------------------------------------------------------------------------------
void CServoView::OnTimer(UINT nIDEvent) 
{
	SeqAllEStop();		// ljy_041027 : Servo Unit All E-Stop
	SeqMoveHome();

	BOOL bMove = FALSE;

	for(int i=0; i<MAX_RBT_NO; i++)
	{
//		if( i == RBT_SPARE_UNIT_S_AXIS ) continue;

		bMove |= m_pServoTabView[i]->m_nAction;
	}

	if ( bMove ) m_pDicsData->m_SeqFlag.bServoMove = TRUE;
	else m_pDicsData->m_SeqFlag.bServoMove = FALSE;

//	SeqUnitLdUpHandServo();
	CFormView::OnTimer(nIDEvent);
}

//--------------------------------------------------------------------------------
// OnClickTabServo
//--------------------------------------------------------------------------------
void CServoView::OnClickTabServo(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	int nTab = m_tabCtrl.GetCurSel();

	SetRbtTab( nTab );

	m_pServoTabView[nTab]->SetFocus();
// 	CRect r;
//	GetDlgItem( IDC_STATIC_BACKGROUND )->GetWindowRect( &r );
//	ScreenToClient( &r );
//	InvalidateRect( &r );

	*pResult = 0;
}

//--------------------------------------------------------------------------------
// OnAllEstop
//--------------------------------------------------------------------------------
void CServoView::OnAllEstop()
{
	m_bEStopBtn = TRUE;
	SetLog( "MANUAL=>SERVO", "All E-STOP" );
	GetDlgItem( IDC_RBT_ALL_ESTOP )->EnableWindow( FALSE );
}

//--------------------------------------------------------------------------------
// SeqAllEStop
//--------------------------------------------------------------------------------
void CServoView::SeqAllEStop()
{
	// ljy_041027 : Servo Unit All E-Stop BTN
	if( !m_bEStopBtn ) return;
	CString sbf;
	
	int nSeqNo;
	nSeqNo = m_nSeqAllEStopNo;

	switch( nSeqNo )
	{
	case 0:
		//if( m_pMmc->EStopRbt( RBT_LD_UPDN_UNIT ) ) 
		nSeqNo = 10;
		break;
	case 10:
#ifndef _NO_UL_HAND
		if( m_pMmc->EStopRbt( RBT_UL_HAND_UNIT ) )	// nSeqNo = 20;
#endif
			nSeqNo = 20;
		break;
	case 20:
		if( m_pMmc->EStopRbt( SWR2_RBT_RB_UNIT_UP_RB1_UNIT ) ) // nSeqNo = 30;
			nSeqNo = 30;
		break;
	case 30:
		if( m_pMmc->EStopRbt( SWR2_RBT_RB_UNIT_LO_RB1_UNIT ) ) // nSeqNo = 40;
			nSeqNo = 40;
		break;
	case 40:
		if( m_pMmc->EStopRbt( SWR2_RBT_RB_UNIT_UP_RB2_UNIT ) ) // nSeqNo = 50;
			nSeqNo = 50;
		break;
	case 50:
		if( m_pMmc->EStopRbt( SWR2_RBT_RB_UNIT_LO_RB2_UNIT ) ) // nSeqNo = 100;
			nSeqNo = 60;
		break;
	case 60:
		if( m_pMmc->EStopRbt( SWR3_RBT_RB_UNIT_UP_RB1_UNIT ) ) // nSeqNo = 30;
			nSeqNo = 70;
		break;
	case 70:
		if( m_pMmc->EStopRbt( SWR3_RBT_RB_UNIT_LO_RB1_UNIT ) ) // nSeqNo = 40;
			nSeqNo = 80;
		break;
	case 80:
		if( m_pMmc->EStopRbt( SWR3_RBT_RB_UNIT_UP_RB2_UNIT ) ) // nSeqNo = 50;
			nSeqNo = 90;
		break;
	case 90:
		if( m_pMmc->EStopRbt( SWR3_RBT_RB_UNIT_LO_RB2_UNIT ) ) // nSeqNo = 100;
			nSeqNo = 150;
		break;
	case 150:
		{
			nSeqNo = 0;
			m_bEStopBtn = FALSE;
			GetDlgItem( IDC_RBT_ALL_ESTOP )->EnableWindow( TRUE );
		}
	}
	m_nSeqAllEStopNo = nSeqNo; 
}

//--------------------------------------------------------------------------------
// SeqMoveHome()
//--------------------------------------------------------------------------------
void CServoView::SeqMoveHome()
{
//	if( !m_bEStopBtn ) return;

	static DWORD dwTickStart = 0;
	int nSeqNo;
	nSeqNo = m_nSeqMoveHomeNo;

	switch( nSeqNo )
	{
	case 0:
		if( m_bMoveHomeReq )
		{
//			m_nRbtType
			m_bMoveHomeReq = FALSE;
			nSeqNo = 10;
		}
		break;
	case 10:
		{
			m_nRbNo = m_tabCtrl.GetCurSel();
			m_nAxis = m_pMmc->m_RbtInfo[m_nRbNo].nStart_axis;

			set_position( m_nAxis, 0.0 );

			dwTickStart = GetTickCount();

			nSeqNo = 20;
		}
		break;
	case 20:
		if( ( GetTickCount() - dwTickStart ) > 1000 )
		{
			RBT_VEL vel = m_pMmc->GetVel( m_nRbNo );
			double fVelX = vel.dVel[2]; 
			int nSign = -1;
			m_pMmc->StartVelMove( m_nRbNo, m_nAxis, nSign, fVelX );
//			set_home( m_nAxis, STOP_EVENT );			
			nSeqNo = 30;
		}
		break;
	case 30:
		if( home_switch( m_nAxis ) )
		{
			set_stop( m_nAxis );
			nSeqNo = 40;
		}
		break;
	case 40:
		{
			static RBT_POS	rpPos;
			int nCurPos = 0;
			double dtheta = 0;
			nCurPos = get_position( m_nAxis, &rpPos.dPos[2] );

			dtheta = 819200/( 360 * nCurPos );
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqMoveHomeNo = nSeqNo; 
}
//--------------------------------------------------------------------------------
// SeqAllEStop
//--------------------------------------------------------------------------------
void CServoView::SetRbtTab(int nTab)
{
	// 2_point focusing Ǿ ִ  ϱ 
//	GetDlgItem( IDC_RBT_INTERLOCK )->SetFocus();

	return;

	switch( nTab )
	{
	case 0:
		{
			// Set Log
			//SetLog( "MANUAL=>SERVO", "LD UPDN UNIT SERVO OPERATION" );

			SetLog( "MANUAL=>SERVO", "SWR2 Upper RB1 unit Servo Operation" );	// ljy_050128

			//int nMaxPosNo = m_pMmc->m_RbtInfo[RBT_TR_UNIT].nMax_pos_no;
			//for( int i=0; i<nMaxPosNo; i++ ) m_pTabServoTab1View->m_lcPoint.SetCheck( i, FALSE );
			//m_pTabServoTab1View->m_lcPoint.SetCheck( m_pMmc->GetCurPoint( RBT_TR_UNIT ), TRUE );
		}
		break;
	case 1:
		{
			// Set Log
			//SetLog( "MANUAL=>SERVO", "UL HAND unit Servo Operation" );

			SetLog( "MANUAL=>SERVO", "SWR2 Lower RB1 unit Lo Servo Operation" );	// ljy_050128

			//int nMaxPosNo = m_pMmc->m_RbtInfo[RBT_LD_FISH_UNIT].nMax_pos_no;
			//for( int i=0; i<nMaxPosNo; i++ ) m_pTabServoTab2View->m_lcPoint.SetCheck( i, FALSE );
			//m_pTabServoTab2View->m_lcPoint.SetCheck( m_pMmc->GetCurPoint( RBT_LD_UP_HAND_UNIT ), TRUE );
		}
		break;
	case 2:
		{
			// Set Log
			
			SetLog( "MANUAL=>SERVO", "SWR2 Upper RB2 unit Servo Operation" );	// ljy_050128

			// Highlight the current position
			//int nMaxPosNo = m_pMmc->m_RbtInfo[RBT_UP_RB1_UNIT].nMax_pos_no;
			//for( int i=0; i<nMaxPosNo; i++ ) m_pTabServoTab4View->m_lcPoint.SetCheck( i, FALSE );
			//m_pTabServoTab3View->m_lcPoint.SetCheck( m_pMmc->GetCurPoint( RBT_UP_RB1_UNIT ), TRUE 
		}
		break;
	case 3:
		{
			// Set Log
			
			SetLog( "MANUAL=>SERVO", "SWR2 Lower RB2 unit Servo Operation" );	// ljy_050128
			
			// Highlight the current position
			//int nMaxPosNo = m_pMmc->m_RbtInfo[RBT_UP_RB1_UNIT].nMax_pos_no;
			//for( int i=0; i<nMaxPosNo; i++ ) m_pTabServoTab4View->m_lcPoint.SetCheck( i, FALSE );
			//m_pTabServoTab3View->m_lcPoint.SetCheck( m_pMmc->GetCurPoint( RBT_UP_RB1_UNIT ), TRUE 
		}
		break;
	case 4:
		{
			// Set Log
			SetLog( "MANUAL=>SERVO", "SWR3 Upper RB1 unit Servo Operation" );	// ljy_050128
		}
		break;

	case 5:
		{
			// Set Log
			SetLog( "MANUAL=>SERVO", "SWR3 Lower RB1 unit Lo Servo Operation" );	// ljy_050128
		}
		break;
	case 6:
		{
			// Set Log
			
			SetLog( "MANUAL=>SERVO", "SWR3 Upper RB2 unit Servo Operation" );	// ljy_050128

			// Highlight the current position
			//int nMaxPosNo = m_pMmc->m_RbtInfo[RBT_UP_RB1_UNIT].nMax_pos_no;
			//for( int i=0; i<nMaxPosNo; i++ ) m_pTabServoTab4View->m_lcPoint.SetCheck( i, FALSE );
			//m_pTabServoTab3View->m_lcPoint.SetCheck( m_pMmc->GetCurPoint( RBT_UP_RB1_UNIT ), TRUE 
		}
		break;
	case 7:
		{
			// Set Log
			
			SetLog( "MANUAL=>SERVO", "SWR3 Lower RB2 unit Servo Operation" );	// ljy_050128
			
			// Highlight the current position
			//int nMaxPosNo = m_pMmc->m_RbtInfo[RBT_UP_RB1_UNIT].nMax_pos_no;
			//for( int i=0; i<nMaxPosNo; i++ ) m_pTabServoTab4View->m_lcPoint.SetCheck( i, FALSE );
			//m_pTabServoTab3View->m_lcPoint.SetCheck( m_pMmc->GetCurPoint( RBT_UP_RB1_UNIT ), TRUE 
		}
		break;

	case 8:
		{
			// Set Log
			SetLog( "MANUAL=>SERVO", "Glass Semi-Auto Move Operation" );
		}
		break;
	}
}

//--------------------------------------------------------------------------------
// SetLog
//--------------------------------------------------------------------------------
void CServoView::SetLog(CString sUnitName, CString sMessage, BOOL bError)
{
	CString sBuf;
	sBuf.Format("%s", sMessage );
	if( bError ) m_msgMessage.SetTextColor( RED_COLOR );
	else m_msgMessage.SetTextColor( WHITE_COLOR );
	m_msgMessage.SetOpMsg( sBuf );
	sBuf.Format( "SERVO\t%s\t\t\t%s", sUnitName, sMessage );
	Log.TextOut( sBuf );
}

//--------------------------------------------------------------------------------
// Robot CheckInterlock->nGetIntr->nCheckCodition(Position Sensor)
//--------------------------------------------------------------------------------
#ifndef OK
#define OK	1
#endif

#ifndef _OK__
#define _OK__	0
#endif
#ifndef _NG__
#define _NG__	-1
#endif




BOOL CServoView::IsJogCondition(int nRbtType)
{
	BOOL bRv = TRUE;

/*	switch( nRbtType ) 
	{

	case RBT_TR_UNIT:
		{
			if( !GetDocument()->m_pDicsView->m_pTrSeq->IsAllJointDown() )
			{
				bRv = FALSE;				
			}
		}
		break;
*/
/*	case RBT_LD_UPDN_UNIT:
		{
#ifndef _MY_DEBUG
			if( m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_LD, 1 ) )
#else
			if( m_pDicsData->m_bDebugOutSensor[IF_UNIT_LD] )
#endif
			{
				SetLog( "LD UPDN UNIT", "LD CV GLASS OUT SENSOR DETECT",TRUE );
				bRv = FALSE;
			}

			if ( m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_LD ) || m_pEqpAssy->m_CvMotor.GetMotorBwState( CV_NO_LD ) )
			{
				SetLog( "LD UPDN UNIT", "LD CV IS NOT STOP",TRUE );
				bRv = FALSE;
			}
		}
		break;
	}
*/
	return bRv;
}


