#if !defined(AFX_SERVOVIEW_H__C6BB3407_1758_4C1C_B815_E81AA8D12E69__INCLUDED_)
#define AFX_SERVOVIEW_H__C6BB3407_1758_4C1C_B815_E81AA8D12E69__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ServoView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CServoView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

// Include
#include "..\Sequence\MainSeq.h"

#include "..\DicsDoc.h"
#include "..\DicsData.h"	// Added by ClassView

#include "..\X\XMmc.h"
#include "..\X\XTabCtrl.h"
#include "..\X\MacButtons.h"
#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\X\XCtlMelsec.h"		// ljy_050128 : add
#include "..\X\ColorBtn.h"

#include "ServoTabView.h"
#include "ServoTabSemiAutoView.h"

#include "..\FactoryLib\EqpAssy.h"

class CServoView : public CFormView
{
protected:
	CServoView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CServoView)

// Form Data
public:
	//{{AFX_DATA(CServoView)
	enum { IDD = IDD_SERVO_FORM };

// 	CMacButton		m_macEStop;
//	CBitmapButton	m_bitmapInterlock;
	CXTabCtrl		m_tabCtrl;
//	CBitmapButton	m_bmpSource;
//	CBitmapButton	m_bmpTarget;
	CBitmapButton	m_bmpbtnEmo;
	CMacCheckBox	m_macMoveHome;
	//}}AFX_DATA

// Attributes
public:
	CDicsDoc* GetDocument();

	XMmc*					m_pMmc;
	XCtlDevice*				m_pDevice;
	XCtlMelsec*				m_pMelsec;		// ljy_050128 : add
	CDicsMainSeq*			m_pMainSeq;
	CDicsData*				m_pDicsData;

	CEqpAssy*				m_pEqpAssy;

	CMsgBox			m_msgMessage;
//	CColorStatic	m_RbtState[MAX_RBT_NO];		// +1 = SEMI-AUTO
//	CColorStatic	m_RbtSensor[MAX_TR_RBT_NO];
//	CColorStatic	m_RbtSelect[MAX_RBT_NO];	// +1 = SEMI-AUTO
//
//	CColorButton	m_btnRobot[MAX_RBT_NO];

	HBRUSH			m_hbrBack;
	HBRUSH			m_hbrRed;
	HBRUSH			m_hbrBlue;
	HBRUSH			m_hbrYellow;
	HBRUSH			m_hbrBgColor;

	HBRUSH			m_hbrGreen;
	HBRUSH			m_hbrCyan;
	HBRUSH			m_hbrMagenta;
	HBRUSH			m_hbrWhite;
	HBRUSH			m_hbrBlack;
	// Tab View
	CServoTabView*			m_pServoTabView[MAX_RBT_NO];
	CServoTabSemiAutoView*	m_pTabServoTabSemiAutoView;
	CString		m_sInterlock[MAX_RBT_NO][10][2];
	CString		m_sInterlockMsg;

	BOOL	m_bHomeBtn;
	BOOL	m_bEStopBtn;
	BOOL	m_bMoveCancel;						// ljy_050504
	BOOL	m_bMoveHomeReq;

	struct SEQ_FLAG{
		BOOL bMove;
		BOOL bRepeate;
		BOOL bCancel;
		BOOL bEstop;
		BOOL bReset;
	}m_SeqFlag[MAX_RBT_NO];


	int		m_nRbtType;
	int		m_nSeqAllEStopNo;
	int		m_nSeqMoveHomeNo;	
	int		m_nSeqUnitTrServoNo;
	int     m_nSeqUnitLdUpHandServoNo;
	int     m_nSeqUnitLdLoHandServoNo;
	int     m_nSeqUnitUlFishUnitServoNo;
	int     m_nSeqUnitUlLoHandServoNo;
	int		m_nRbNo;
	int		m_nAxis;
	
// Operations
public:
	BOOL CheckCond(int nRbtType, int nCurPos, BOOL bWithGlass, int nTargetPos);
	BOOL IsJogCondition(int nRbtType);


	void SetRbtTab( int nTab );
	void SetLog(CString sUnitName, CString sMessage, BOOL bError=FALSE );
	void SeqAllEStop();
	void SeqMoveHome();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CServoView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CServoView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CServoView)
	afx_msg void OnDestroy();
	afx_msg void OnClickTabServo(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnAllEstop();
	afx_msg void OnMoveHome();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DicsView.cpp
inline CDicsDoc* CServoView::GetDocument()
   { return (CDicsDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SERVOVIEW_H__C6BB3407_1758_4C1C_B815_E81AA8D12E69__INCLUDED_)
