// SetupItems.h: interface for the CSetupItems class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SETUPITEMS_H__A849BD0D_9D48_446A_8696_7A26F70C1DE2__INCLUDED_)
#define AFX_SETUPITEMS_H__A849BD0D_9D48_446A_8696_7A26F70C1DE2__INCLUDED_

#include "..\X\XCtlDevice.h"
#include "..\FactoryLib\IniData.h"	// Added by ClassView
#include "..\FactoryLib\EqpAssy.h"	

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSetupItems : public CObject  
{
public:
	CSetupItems();
	virtual ~CSetupItems();
	XCtlDevice * m_pDevice;
	void SetDevice( XCtlDevice * pDevice ){m_pDevice = pDevice;}
	CEqpAssy* m_pEqpAssy;
	void SetEqpAssy( CEqpAssy* pEqpAssy ){m_pEqpAssy = pEqpAssy;}

public:
	CIniData	m_IniSetUpInfo;
	CIniData	m_IniDualSensorSkip;	// SanghoCho 2015.04.30 FOR DUAL SENSOR

	static SETUP_INFO	m_infoSetup[];
	static SETUP_INFO	m_infoIdleRun[];

	static CString		m_sItemBathCoverIntr[];
	static CString		m_sItemDoorIntr[];
	static CString		m_sItemLeakDetectIntr[];
	static CString		m_sItemFFUAlarmIntr[];
	static CString		m_sItemBrokenIntr[];
	static CString		m_sItemETCIntr[];

	static SETUP_INFO	m_infoGaugeLimit[];
	static SETUP_INFO	m_infoInterfacePara[];
	static SETUP_INFO	m_infoHsmsPara[];
	static SETUP_INFO	m_infoHsmsPara1[];
	static SETUP_INFO	m_infoPartsLifeTimePara[];
	static SETUP_INFO	m_infoHpmjPara[];

	static CString		m_sItemCvLength[];
	static CV_INFO		m_infoCvMotorPara[];
	static CString		m_sNameTankLevel[];
	static int			m_nGageLimitAddress[];
	static CString		m_sItemInSensorOffTimeOut[];
	static CString		m_sItemOutSensorOffTimeOut[];
	static CString		m_sItemDvName[];

	static CString		m_sItemInSensorSkip[];		// SanghoCho 2015.04.30 FOR DUAL SENSOR
	static CString		m_sItemOutSensorSkip[];		// SanghoCho 2015.04.30 FOR DUAL SENSOR
	static CString		m_sItemSubInSensorSkip[];	// SanghoCho 2015.04.30 FOR DUAL SENSOR
	static CString		m_sItemSubOutSensorSkip[];	// SanghoCho 2015.04.30 FOR DUAL SENSOR

	int*		m_nValueSetup_Option;
	CString*	m_sValueSetup;
	int*		m_nValueIdleRun;
	int*		m_nValueInSensorOffTimeOut;
	int*		m_nValueOutSensorOffTimeOut;

	int*		m_nValueBathCoverIntr;
	int*		m_nValueDoorIntr;
	int*		m_nValueLeakDetectIntr;
	int*		m_nValueFFUAlarmIntr;
	int*		m_nValueBrokenIntr;
	int*		m_nValueETCIntr;

	int*		m_nValueGaugeLimit[4];
	int*		m_nValueGaugeLimit_Option;
	int*		m_nValueTankLevel;
	int*		m_nValuePartsLifeTimePara[2];
	CString*	m_sValueInterfacePara;
	CString*	m_sValueHsmsParaTemp;
	CString*	m_sValueHsmsParaTemp1;
	double*		m_fValueCvLength;
	double*		m_fValueCvMotorVelRatio;
	double*		m_fValueCvMotorRatio;
	double*		m_fValueCvMotorDia;
	CString*	m_sValueDvName;

	// Save for the calibration of C/V distance
	int m_nCvSpeed;
	BOOL m_bCalReq;
	BOOL m_bCalCancel;

	int*		m_nValueSetup_OptionTemp;
	CString*	m_sValueSetupTemp;
	int*		m_nValueIdleRunTemp;
	int*		m_nValueInSensorOffTimeOutTemp;
	int*		m_nValueOutSensorOffTimeOutTemp;

	int*		m_nValueBathCoverIntrTemp;
	int*		m_nValueDoorIntrTemp;
	int*		m_nValueLeakDetectIntrTemp;
	int*		m_nValueFFUAlarmIntrTemp;
	int*		m_nValueBrokenIntrTemp;
	int*		m_nValueETCIntrTemp;
	
	int*		m_nValueGaugeLimitTemp[4];
	int*		m_nValueGaugeLimit_OptionTemp;
	int*		m_nValueTankLevelTemp;
	int*		m_nValuePartsLifeTimeParaTemp[2];
	CString*	m_sValueHsmsPara;
	CString*	m_sValueHsmsPara1;
	CString*	m_sValueInterfaceParaTemp;
	CString*	m_sValueDvNameTemp;
	double*		m_fValueCvLengthTemp;
	double*		m_fValueCvMotorVelRatioTemp;
	double*		m_fValueCvMotorRatioTemp;
	double*		m_fValueCvMotorDiaTemp;
	double*		m_fValueCvSensorTime;

	int*	 	m_nValueInSensorSkipTemp;		// SanghoCho 2015.04.30 FOR DUAL SENSOR
	int*		m_nValueOutSensorSkipTemp;		// SanghoCho 2015.04.30 FOR DUAL SENSOR
	int*	 	m_nValueSubInSensorSkipTemp;	// SanghoCho 2015.04.30 FOR DUAL SENSOR
	int*		m_nValueSubOutSensorSkipTemp;	// SanghoCho 2015.04.30 FOR DUAL SENSOR

	int			m_nItemNoSetup;
	int			m_nItemNoIdleRun;
	int         m_nItemNoInSensorTimeOut;
	int         m_nItemNoOutSensorTimeOut;

	int			m_nItemNoBathCoverIntr;
	int			m_nItemNoDoorIntr;
	int			m_nItemNoLeakDetectIntr;
	int			m_nItemNoFFUAlarmIntr;
	int			m_nItemNoBrokenIntr;
	int			m_nItemNoETCIntr;
	
	int			m_nItemNoGaugeLimit;
	int			m_nItemNoInterfacePara;
	int			m_nItemNoPartsLifeTimePara;
	int			m_nItemNoCvLength;
	int			m_nItemNoCvMotorPara;
	int			m_nItemNoTankLevel;

	int			m_nItemNoHsmsPara;
	int			m_nItemNoHsmsPara1;
	int			m_nItemNoDvName;

	int			m_nUnitInSensorSkip;		// SanghoCho 2015.04.30 FOR DUAL SENSOR
	int			m_nUnitOutSensorSkip;		// SanghoCho 2015.04.30 FOR DUAL SENSOR
	int			m_nUnitSubInSensorSkip;		// SanghoCho 2015.04.30 FOR DUAL SENSOR
	int			m_nUnitSubOutSensorSkip;	// SanghoCho 2015.04.30 FOR DUAL SENSOR

//	static CString    m_sValueHpmjPara[4][MAX_AI_INTR_NO];

	enum { optionPASS_MODE, modePROCESS_MODE };
	enum { optionNO_USE, optionUSE };
	enum { optionNO_CHECK, optionCHECK };

	enum optionSETUP_INFO { optionNONE, optionBOOL1, optionBOOL2, optionBOOL3, optionBOOL4, optionBOOL5, optionBOOL6,
							optionTRI_STATE1, optionTRI_STATE2 };
	enum formatSETUP_INFO  { formatNONE, formatDIGIT, formatFLOAT, formatSTRING, formatHEX };

	enum nameSETUP_INFO
	{
		setupDI_PUMP1_USE,
		setupDI_PUMP2_USE,
#ifdef _BUFTANK_USE
		setupDI_BUFTANK_USE,
#endif
		setupSWR1_SBJ_USE,
		setupSWR4_SBJ_USE,
		setupLD_UNIT_BROKEN_SENSOR,		
		setupLD_UNIT_SCAN_SENSOR,
		setupUL_UNIT_BROKEN_SENSOR,		
		setupUL_UNIT_SCAN_SENSOR,
		setupUL_CV_ACCEL_SPEED,
		setupUL_CV_DECEL_SPEED,
		setupGLASS_SIZE,
		setupMAX_GLASS_NO,
		setupCV_TIMEOUT_DISTANCE,
		setupLD_UNIT_GLASS_STOP_DISTANCE,
		setupUL_UNIT_GLASS_STOP_DISTANCE,
		setupPUMP_INTERLOCK_CHECK_TIME,
		setupPUMP_INTERLOCK_FLOW_RATE,	
		setupEQP_INITIAL_TIME,
		setupLEVEL_SENSOR_CONFIRM_TIME,
		setupIDLE_WAIT_TIME,
		setupAK_INTERLOCK,
		setupAK_INTERLOCK2,
		setupMJ_CDA_PRESSURE_CHECK,		// 150903 halesu
		setupWAIT_IN_WET_CHAMBER,	// 160704 halesu
		setupUNLOAD_WAIT_ON_DELAY,	// 160704 halesu
// NO USE
//		setupTIMER_RESET_TIME,
//#ifndef _NO_RB
		setupSWR2_RB_SERVO1_USE,
		setupSWR2_RB_SERVO2_USE,
		setupSWR2_RB_SERVO3_USE,
		setupSWR2_RB_SERVO4_USE,
		setupSWR3_RB_SERVO1_USE,
		setupSWR3_RB_SERVO2_USE,
		setupSWR3_RB_SERVO3_USE,
		setupSWR3_RB_SERVO4_USE,
		setupGAUGE_CHECK_DELAY,	// 170721 halesu
		setupWR_CHECK_DELAY,	// 170721 halesu

		setupLD_ALIGN_CYL_TIMEOUT,	// 190514 hskwak	// Cylinder  Time Out
		setupUL_ALIGN_CYL_TIMEOUT,	// 190514 hskwak	// Cylinder  Time Out
		setupUL_ALIGN_UD_CYL_TIMEOUT,	// 190514 hskwak	// Cylinder  Time Out
		setupUL_PIN_UD_CYL_TIMEOUT,	// 190514 hskwak	// Cylinder  Time Out
		setupUL_TIMEOUT_PUMP_OFF_DELAY,	// Thomas 201208, UL Timeout Pump Off Delay
//#endif
		setupJOB_MODE,

		setupTIMER_RESET_TIME,	// NO Use
		setup_MJ_DI_MODE,
		setupPLASMA_USED,
		setupPLASMA_POWER_SET,
		setupPLASMA_N2_MFC_SET,
		setupPLASMA_CDA_MFC_SET,
		setupHPMJ_RUN_MODE,
		setupHPMJ_FRQ_SET,
		setupUSE_EUV,
		setupEUV1_LIFE_TIME,
		setupEUV2_LIFE_TIME,
		setupEUV3_LIFE_TIME,
		setupEUV4_LIFE_TIME,
		setupBUF3_UNIT_SCAN_SENSOR,
		setupUL_UNIT_CCD_SENSOR,
	};

	enum nameNO_USE
	{
		setupHPMJ_USE,
	};

	enum nameTANK_LEVEL
	{
		levelDI_TANK_HH,
		levelDI_TANK_H,
		levelDI_TANK_M,
		levelDI_TANK_L,

#ifdef _BUFTANK_USE
		levelDI_BUFTANK_HH,
		levelDI_BUFTANK_H,
		levelDI_BUFTANK_L,
		levelDI_BUFTANK_LL,
#endif
	};

	enum namePARTS_LIFETIME
	{
//#ifndef _NO_RB
		partsSWR2RB_1,
		partsSWR2RB_2,
		partsSWR2RB_3,
		partsSWR2RB_4,
		partsSWR3RB_1,
		partsSWR3RB_2,
		partsSWR3RB_3,
		partsSWR3RB_4,
//#endif
		partsDI_FILTER1,	// SWR1 DI1 Filter
		partsDI_FILTER2,	// SWR1 DI2 Filter
		partsDI_FILTER3,	// SWR2 DI FILTER
		partsDI_FILTER4,	// SWR3 DI FILTER
		partsDI_FILTER5,	// SWR4 DI1 FILTER
		partsDI_FILTER6,	// SWR4 DI2 FILTER
		partsCDA_FILTER1,	// SWR1 CDA ION AND AC Filter
		partsCDA_FILTER2,	// SWR1 CDA MJ Filter
		partsCDA_FILTER3,	// SWR4 CDA MJ Filter
		partsCDA_FILTER4,	// AK CDA LO AK Filter
		partsCDA_FILTER5,	// AK CDA UP AK Filter
		partsCDA_FILTER6,	// AK CDA ION AND AC Filter
	};
// #ifdef _NO_RB
// 	enum nameEXTRA
// 	{
// 		partsRB_1,
// 		partsRB_2,
// 		partsRB_3,
// 		partsRB_4,
// 	};
// #endif
	enum nameIDLERUN_INFO
	{ 
		idleDIW_ZONE_USE,
		idleDIW_IDLE_RUN_TIME,
		idleDIW_IDLE_STOP_TIME,
// NO USE		
		idleSWR2_UPPER_RB1_DIR,
		idleSWR2_LOWER_RB1_DIR,
		idleSWR2_UPPER_RB2_DIR,
		idleSWR2_LOWER_RB2_DIR,
		idleSWR3_UPPER_RB1_DIR,
		idleSWR3_LOWER_RB1_DIR,
		idleSWR3_UPPER_RB2_DIR,
		idleSWR3_LOWER_RB2_DIR,

		idleSWR2_UPPER_RB1_SPEED,
		idleSWR2_LOWER_RB1_SPEED,
		idleSWR2_UPPER_RB2_SPEED,
		idleSWR2_LOWER_RB2_SPEED,
		idleSWR3_UPPER_RB1_SPEED,
		idleSWR3_LOWER_RB1_SPEED,
		idleSWR3_UPPER_RB2_SPEED,
		idleSWR3_LOWER_RB2_SPEED,

		idleSWR2_UPPER_RB1_GAP,	// 170714 halesu
		idleSWR2_LOWER_RB1_GAP,	// 170714 halesu
		idleSWR2_UPPER_RB2_GAP,	// 170714 halesu
		idleSWR2_LOWER_RB2_GAP,	// 170714 halesu
		idleSWR3_UPPER_RB1_GAP,	// 170714 halesu
		idleSWR3_LOWER_RB1_GAP,	// 170714 halesu
		idleSWR3_UPPER_RB2_GAP,	// 170714 halesu
		idleSWR3_LOWER_RB2_GAP,	// 170714 halesu
	};

	enum nameCOVER_INTR
	{
		intrCOVER_OPEN1,
		intrCOVER_OPEN2,
		intrCOVER_OPEN3,
		intrCOVER_OPEN4,
		intrCOVER_OPEN5,
		intrCOVER_OPEN6,
		intrCOVER_OPEN7,
		intrCOVER_OPEN8,
		intrCOVER_OPEN9,
		intrCOVER_OPEN10,
		intrCOVER_OPEN11,
		intrCOVER_OPEN12,
		intrCOVER_OPEN13,
		intrCOVER_OPEN14,
		intrCOVER_OPEN15,
		intrCOVER_OPEN16,

	};

	enum nameDOOR_INTR
	{
		intrDOOR_OPEN1,
		intrDOOR_OPEN2,
		intrDOOR_OPEN3,
		intrDOOR_OPEN4,
		intrDOOR_OPEN5,
		intrDOOR_OPEN6,
		intrDOOR_OPEN7,
		intrDOOR_OPEN8,
		intrDOOR_OPEN9,
		intrDOOR_OPEN10,
		intrDOOR_OPEN11,
		intrDOOR_OPEN12,
		intrDOOR_OPEN13,
		intrDOOR_OPEN14,
		intrDOOR_OPEN15,
		intrDOOR_OPEN16,
		intrDOOR_OPEN17,
		intrDOOR_OPEN18,
		intrDOOR_OPEN19,
		intrDOOR_OPEN20,
		intrDOOR_OPEN21,
		intrDOOR_OPEN22,
		intrDOOR_OPEN23,
		intrDOOR_OPEN24,
		intrDOOR_OPEN25,
		intrDOOR_OPEN26,
		intrDOOR_OPEN27,
		intrDOOR_OPEN28,
		intrDOOR_OPEN29,
		intrDOOR_OPEN30,
		intrDOOR_OPEN31,
		intrDOOR_OPEN32,
		intrDOOR_OPEN33,
		intrDOOR_OPEN34,
		intrDOOR_OPEN35,
		intrDOOR_OPEN36,
		intrDOOR_OPEN37,
		intrDOOR_OPEN38,
		intrDOOR_OPEN39,
		intrDOOR_OPEN40,
		intrDOOR_OPEN41,
		intrDOOR_OPEN42,
		intrDOOR_OPEN43,
		intrDOOR_OPEN44,
	};

	enum nameLEAK_INTR
	{
		// 151120 halesu
		intrLEAK_SENSOR1, 
		intrLEAK_SENSOR2, 
		intrLEAK_SENSOR3,
	};

	enum nameFFU_INTR
	{
		intrFFU1,
		intrFFU2,
		intrFFU3,
		intrFFU4,
		intrFFU5,
		intrFFU6,
		intrFFU7,
	};

	enum nameBROKEN_INTR
	{
		intrUL_UNIT_BROKEN_SENSOR1,
		intrUL_UNIT_BROKEN_SENSOR2,
		intrUL_UNIT_BROKEN_SENSOR3,
		intrUL_UNIT_BROKEN_SENSOR4,
		intrUL_UNIT_BROKEN_ALL,
		intrUL_UNIT_BROKEN_SCAN,
	};

	enum nameETC_INTR
	{
		intrIONIZER1,
		intrIONIZER2,
// NO USE
		intrEUV_LEVEL1,
		intrEUV_LEVEL2,
		intrEUV_LEVEL3,
	};

	enum nameIN_SENSOR_OFF_TIME
	{
		insensorOFF_TIMEOUT_LD_UNIT_FRONT,
		insensorOFF_TIMEOUT_SWR1_UNIT_FRONT,
		insensorOFF_TIMEOUT_SWR2_UNIT_FRONT,
		insensorOFF_TIMEOUT_SWR3_UNIT_FRONT,
		insensorOFF_TIMEOUT_SWR4_UNIT_FRONT,
		insensorOFF_TIMEOUT_AK_UNIT_FRONT,
		insensorOFF_TIMEOUT_BUF_UNIT_FRONT,
		insensorOFF_TIMEOUT_UL_UNIT_FRONT,
	};

	enum nameOUT_SENSOR_OFF_TIME
	{
		outsensorOFF_TIMEOUT_LD_UNIT_FRONT,
		outsensorOFF_TIMEOUT_SWR1_UNIT_FRONT,
		outsensorOFF_TIMEOUT_SWR2_UNIT_FRONT,
		outsensorOFF_TIMEOUT_SWR3_UNIT_FRONT,
		outsensorOFF_TIMEOUT_SWR4_UNIT_FRONT,
		outsensorOFF_TIMEOUT_AK_UNIT_FRONT,
		outsensorOFF_TIMEOUT_BUF_UNIT_FRONT,
		outsensorOFF_TIMEOUT_UL_UNIT_FRONT,
	};

	enum nameGAUGE_LIMIT								
	{							
		gaugeSWR1_UNIT_CDA_IN_INCV_ION,				//  1				PG01		O
		gaugeSWR1_UNIT_CDA_IN_SWR1_UP_AC,			//  2				PG02		O
		gaugeSWR1_UNIT_CDA_IN_SWR1_LO_AC,			//  3				PG03		O
		gaugeSWR1_UNIT_CDA_IN_ION_AND_AC_IN_FT,		//  4				PG04		O
		gaugeSWR1_UNIT_CDA_IN_SWR1_UP_MJ,			//  5				PG05		O
		gaugeSWR1_UNIT_CDA_IN_SWR1_LO_MJ,			//  6				PG06		O
		gaugeSWR1_UNIT_CDA_IN_SWR1_MJ_IN_FT,		//  7				PG07		O
		gaugeSWR1_UNIT_DI_SPL_IN_FT,				//  8				PG08		O
		gaugeSWR1_UNIT_CDA_IN_SWR1_UP_MJ_FL,		//  9				FI01		O
		gaugeSWR1_UNIT_CDA_IN_SWR1_LO_MJ_FL,		//  10				FI02		O
		gaugeSWR1_UNIT_DI_SPL_AK_FL,				//  11				FI03		O
		gaugeSWR1_UNIT_DI_SPL_UP_MJ_FL,				//  12				FI04		O
		gaugeSWR1_UNIT_DI_SPL_LO_MJ_FL,				//  13				FI05		O
		gaugeSWR1_UNIT_DI_SPL_IN_FT_FL,				//  14				FI06		O
		gaugeSWR1_UNIT_DI_SPL_LO_FL,				//  15				FI07		O
		gaugeSWR1_UNIT_DI_SPL_UP_FL,				//  16				FI08		O
		gaugeSWR1_UNIT_DI_SPL_WR,					//  17				WR			O
		gaugeSWR1_UNIT_EXH_DM,						//  18				DM01		O
		gaugeSWR2_UNIT_DI_IN_FT_PG,					//  19				PG09		O
		gaugeSWR2_UNIT_DI_RETURN_FL,				//  20				FL09		O
		gaugeSWR2_UNIT_DI_SPL_LO_FL,				//  21				FL10		O
		gaugeSWR2_UNIT_DI_SPL_FL,					//  22				FL11		O
		gaugeSWR2_UNIT_DI_SPL_UP_FL,				//  23				FL12		O
		gaugeSWR2_UNIT_DI_SPL_WR,					//  24				WR			O
		gaugeSWR2_UNIT_EXH_DM,						//  25				DM02		O
		gaugeSWR3_UNIT_DI_IN_SWR3_IN_FT_PG,			//  26				PG10		O
		gaugeSWR3_UNIT_CDA_IN_SWR4_MJ_PG,			//  27				PG16		O
		gaugeSWR3_UNIT_CDA_IN_SPARE_PORT_PG,		//  28				PG17		O
		gaugeSWR3_UNIT_CDA_IN_SWR4_MJ_IN_FT_PG,		//  29				PG18		O
		gaugeSWR3_UNIT_DI_SPL_LO_SWR3_FL,			//  30				FL13		O
		gaugeSWR3_UNIT_DI_SPL_SWR3_IN_FT_FL,		//  31				FL14		O
		gaugeSWR3_UNIT_DI_SPL_UP_SWR3_FL,			//  32				FL15		O
		gaugeSWR3_UNIT_CDA_IN_SWR4_MJ_FL,			//  33				FL24		O
		gaugeSWR3_UNIT_CDA_IN_SPARE_PORT_FL,		//  34				FL25		O
		gaugeSWR3_UNIT_DI_SPL_WR,					//  35				WR			O
		gaugeSWR3_UNIT_EXH_DM,						//  36				DM03		O
		gaugeSWR4_UNIT_LO_SWR_FL,					//  37				FL16		O
		gaugeSWR4_UNIT_MJ_FL,						//  38				FL17		O
		gaugeSWR4_UNIT_UP_SWR_FL,					//  39				FL18		O
		gaugeSWR4_UNIT_AK_FL,						//  40				FL19		O
		gaugeSWR4_UNIT_DI_SPL_FL,					//  41				FL20		O
		gaugeSWR4_UNIT_EXH_DM,						//  42				DM04		O
		gaugeSWR4_UNIT_DI_TANK2_CM,					//  43				CM01		O
		gaugeAK_UNIT_DI_SPL_SWR4_IN_FT_PG,			//  44				PG11		O
		gaugeAK_UNIT_CDA_IN_LO_AK_IN_FT_PG,			//  45				PG12		O
		gaugeAK_UNIT_CDA_IN_UP_AK_IN_FT_PG,			//  46				PG13		O
		gaugeAK_UNIT_CDA_IN_LO_AK_PG,				//  47				PG14		O
		gaugeAK_UNIT_CDA_IN_UP_AK_PG,				//  48				PG15		O
		gaugeAK_UNIT_CDA_IN_ION_AND_AC_IN_FT_PG,	//  49				PG19
		gaugeAK_UNIT_CDA_IN_UP_SWR4_AC_PG,			//  50				PG20
		gaugeAK_UNIT_CDA_IN_LO_SWR4_AC_PG,			//  51				PG21
		gaugeAK_UNIT_CDA_IN_OUT_ION_PG,				//  52				PG22
		gaugeAK_UNIT_DRIVING_AIR_PG,				//  53				PG23		O
		gaugeAK_UNIT_EXH_DM_U,						//  54				DM05		O
		gaugeAK_UNIT_EXH_DM_L,						//  55				DM06		O
		gaugeAK_UNIT_DI_SPL_SHOWER4_IN_FT_FL,		//  56				FL21		O
		gaugeAK_UNIT_CDA_IN_LO_AK_IN_FT_FL,			//  57				FL22		O
		gaugeAK_UNIT_CDA_IN_UP_AK_IN_FT_FL,			//  58				FL23		O
		gaugeAK_UNIT_DI_SPL_WR,						//  59				WR-SWR4		O
		GaugeOUTCV_UNIT_ESD_SURIFACE_POTENTIAL,		//  60				??			O
#ifdef _MOTOR_LOAD_FACTOR
		gaugeS2RB_UP_SV1_LF,					 	//  61
		gaugeS2RB_LO_SV1_LF,					 	//  62
		gaugeS2RB_UP_SV2_LF,					 	//  63
		gaugeS2RB_LO_SV2_LF,					 	//  64
		gaugeS3RB_UP_SV1_LF,					 	//  65
		gaugeS3RB_LO_SV1_LF,					 	//  66
		gaugeS3RB_UP_SV2_LF,					 	//  67
		gaugeS3RB_LO_SV2_LF,					 	//  68
		gaugeS2RB_UP_M1_LF,						 	//  69
		gaugeS2RB_LO_M1_LF,						 	//  70
		gaugeS2RB_UP_M2_LF,						 	//  71
		gaugeS2RB_LO_M2_LF,						 	//  72
		gaugeS3RB_UP_M1_LF,						 	//  73
		gaugeS3RB_LO_M1_LF,						 	//  74
		gaugeS3RB_UP_M2_LF,						 	//  75
		gaugeS3RB_LO_M2_LF,						 	//  76
		gaugeINCV_M_LF,							 	//  77
		gaugeS1CV_M_LF,							 	//  78
		gaugeS2CV_M1_LF,						 	//  79
		gaugeS2CV_M2_LF,						 	//  80
		gaugeS3CV_M1_LF,						 	//  81
		gaugeS3CV_M2_LF,						 	//  82
		gaugeS4CV_M_LF,							 	//  83
		gaugeAKCV_M1_LF,						 	//  84
		gaugeAKCV_M2_LF,						 	//  85
		gaugeBUFCV_M_LF,						 	//  86
		gaugeOUTCV_M_LF,						 	//  87
#endif
#ifdef _BUFTANK_USE
		gaugeBUFTANK_UNIT_DIW_SPL1_PG,				//  88				BUFTANK		O
		gaugeBUFTANK_UNIT_DIW_SPL2_PG,				//  89				BUFTANK		O
		gaugeBUFTANK_UNIT_DIW_SPL1_FL,				//  90				BUFTANK		O
		gaugeBUFTANK_UNIT_DIW_SPL2_FL,				//  91				BUFTANK		O
		gaugeBUFTANK_UNIT_DIW_SPL1_TO_SWR_FL,		//  92				BUFTANK		O
		gaugeBUFTANK_UNIT_DIW_SPL2_TO_SWR_FL,		//  93				BUFTANK		O
#endif

	}; 							
 							
  
   
	enum nameUL_UNIT_DRIVING_AIR_PRESSHPMJ
	{
		gaugeHPMJ_UNIT_SHOWER_FLOW,
		gaugeHPMJ_UNIT_FILTER_IN_PRESS,
		gaugeHPMJ_UNIT_FILTER_OUT_PRESS,
		gaugeHPMJ_UNIT_MAIN_DI_PRESS,
		gaugeHPMJ_UNIT_RESISTIVITY,		
		gaugeHPMJ_UNIT_CO2_PRESS,
		gaugeHPMJ_UNIT_INVERTER_CURRENT,
		gaugeHPMJ_UNIT_FILTER_DIFFER_PRESS,
	};

	enum nameINTERFACE_PARA
	{ 
		melsecMELSLOT_NO,
		melsecNETWORK_NO,
		melsecSTATION_NO,
		timeoutINTERFACE_T1,	// Cause by UPS - Measure by DWS	: Warning
		timeoutINTERFACE_T2,
		timeoutINTERFACE_T3,	// Cause by DWS - Measure by UPS	: Transfer Stop & Recovery
		timeoutINTERFACE_T4,	// Cause by DWS - Measure by UPS	: Transfer Stop & Recovery
		timeoutINTERFACE_T5,	// Cause by DWS - Measure by UPS	: Transfer Stop & Recovery
		timeoutINTERFACE_T6,	// Cause by UPS - Measure by DWS	: Transfer Stop & Recovery
	};

	enum nameHSMS_PARA
	{ 
		hsmsINIT_COMM_STATE,
		hsmsINIT_CONTROL_STATE,
		hsmsCOMM_TIMEOUT,
		hsmsHEART_BEAT,
		hsmsT3,
		hsmsT5,
		hsmsT6,
		hsmsT7,
		hsmsT8,
		hsmsT9,
		hsmsLINK_TEST_TIMER,
		hsmsDEVICE_ID,
		hsmsPORT_NUMBER,
		hsmsIP_ADDRESS,
		hsmsCONNECTION_MODE,
		hsmsEQP_ID,
		hsmsPROCESS_ID,
		hsmsINDEX_ID
	};

public:
	void InitSetupItems();
	void InitTempVarTabJobCondView();
	void InitTempVarTabInterlockSetView();
	void InitTempVarTabInterlockSet2View();
	void InitTempVarTabCVDistanceSetView();
	void InitTempVarTabCVMotorParaView();
	void InitTempVarTabInterfaceParaView();
	void InitTempVarTabInterfaceParaView1();
	void InitTempVarTabDVParaView();
	BOOL IsSetupChangedTabJobCondView();
	BOOL IsSetupChangedTabInterlockSetView();
	BOOL IsSetupChangedTabInterlockSet2View();
	BOOL IsSetupChangedTabCVDistanceSetView();
	BOOL IsSetupChangedTabCVMotorParaView();
	BOOL IsSetupChangedTabInterfaceParaView();
	BOOL IsSetupChangedTabInterfaceParaView1();
	BOOL IsSetupChangedTabDVParaView();
	void GetRegistryTabJobCondView();
	void GetRegistryTabInterlockSetView();
	void GetRegistryTabInterlockSet2View();
	void GetRegistryTabCVDistanceSetView();
	void GetRegistryTabCVMotorParaView();
	void GetRegistryTabInterfaceParaView();
	void GetRegistryTabInterfaceParaView1();
	void GetRegistryTabDVParaView();
	void GetRegistryTabDualSensorSkip();
	void SetRegistryTabJobCondView();
	void SetRegistryTabInterlockSetView();
	void SetRegistryTabInterlockSet2View();
	void SetRegistryTabCVDistanceSetView();
	void SetRegistryTabCVMotorParaView();
	void SetRegistryTabInterfaceParaView();
	void SetRegistryTabInterfaceParaView1();
	void SetRegistryTabDVParaView();
	void SetRegistryDualSensorSkip();	// SanghoCho 2015.04.30 FOR DUAL SENSOR
};

#endif // !defined(AFX_SETUPITEMS_H__A849BD0D_9D48_446A_8696_7A26F70C1DE2__INCLUDED_)
