// SetupTabCVDistanceSetView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "SetupTabCVDistanceSetView.h"
#include "..\Dlg\DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupTabCVDistanceSetView

IMPLEMENT_DYNCREATE(CSetupTabCVDistanceSetView, CFormView)

CSetupTabCVDistanceSetView::CSetupTabCVDistanceSetView()
	: CFormView(CSetupTabCVDistanceSetView::IDD)
{
	//{{AFX_DATA_INIT(CSetupTabCVDistanceSetView)
	m_nIndex = -1;
	//}}AFX_DATA_INIT
}

CSetupTabCVDistanceSetView::CSetupTabCVDistanceSetView(CView* pView)
	: CFormView(CSetupTabCVDistanceSetView::IDD)
{
	m_pView = pView;
}

CSetupTabCVDistanceSetView::~CSetupTabCVDistanceSetView()
{
}

void CSetupTabCVDistanceSetView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupTabCVDistanceSetView)
	DDX_Control(pDX, IDC_COMBO_CV_SPEED, m_cbCvSpeed);
	DDX_Control(pDX, IDC_GRID_SETUP_INFO, m_gridCvLength);
	DDX_Control(pDX, IDC_GRID_INSENSOR_OFF_TIMEOUT_INFO, m_gridInSensorOffTimeOutInfo);
	DDX_Control(pDX, IDC_GRID_OUTSENSOR_OFF_TIMEOUT_INFO, m_gridOutSensorOffTimeOutInfo);
	DDX_Control(pDX, IDC_START, m_macStart );
	DDX_Control(pDX, IDC_STOP, m_macStop);
	DDX_CBIndex(pDX, IDC_COMBO_CV_SPEED, m_nIndex);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSetupTabCVDistanceSetView, CFormView)
	//{{AFX_MSG_MAP(CSetupTabCVDistanceSetView)
	ON_CBN_SELCHANGE(IDC_COMBO_CV_SPEED, OnSelchangeComboCvSpeed)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	//}}AFX_MSG_MAP
	ON_WM_MOUSEWHEEL()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupTabCVDistanceSetView diagnostics

#ifdef _DEBUG
void CSetupTabCVDistanceSetView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSetupTabCVDistanceSetView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSetupTabCVDistanceSetView message handlers

BOOL CSetupTabCVDistanceSetView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CSetupTabCVDistanceSetView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Create the Comment message box
	CRect r;
	GetDlgItem( IDC_COMMENT )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgComment.Create( 100, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_IO_IN_NOTE, WHITE, BLUE_COLOR, 18, TRUE );
	m_msgComment.SetAlign( CMsgBox::alignLEFT );
	m_msgComment.SetOpMsg( "Ready" );

	// Create the note title message box
	GetDlgItem( IDC_COMMENT_STATIC )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgCommentStatic.Create( 101, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_NOTE_STATIC, LIGHT_YELLOW_COLOR, BLUE_COLOR, 18, TRUE );
	m_msgCommentStatic.SetAlign( CMsgBox::alignLEFT );
	m_msgCommentStatic.SetOpMsg( "COMMENT" );

	// Set the MAC button
	MAC_COLOR_SET color_set;
	m_macStart.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macStart.SetColorSetting( color_set );
	m_macStart.SetBold();

	m_macStop.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_YELLOW_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macStop.SetColorSetting( color_set );
	m_macStop.SetBold();

	// Set the combo box
	for( int i=0; i<20; i++ )
	{
		CString sValue;
		sValue.Format( "%d", ( i + 1 ) * CV_SPEED_INTERVAL * 7 );
		m_cbCvSpeed.AddString( sValue );
	}
	m_cbCvSpeed.SetCurSel( 7 );

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// Get the C/V speed
	OnSelchangeComboCvSpeed() ;
	
	// Initialize the temperary variable
	pDoc->m_pSetupItems->InitTempVarTabCVDistanceSetView();

	// Set the items
	GridInit();
	GridInit_InSensorOffTimeoutInfo();
	GridInit_OutSensorOffTimeoutInfo();

	GetDlgItem( IDC_STOP )->EnableWindow( FALSE );
}

//--------------------------------------------------------------------
// Initialize the GridCtrl (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabCVDistanceSetView::GridInit()
{
	LPTSTR sLvcText[] = { " ITEMS ", " OLD VALUE ", " NEW VALUE " };
	int nColWidth[] = { 5400, 1650, 1650 }; 
	
	// initialize GridCtrl
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoCvLength;
	if( nRows <= 22 ) nColWidth[0] += 270;
	m_gridCvLength.SetRows( nRows + 1 ); 
	m_gridCvLength.SetCols( 3 );

	m_gridCvLength.SetRow( 0 );  
	for( int i=0; i<3; i++ )
	{
		m_gridCvLength.SetColWidth( i, nColWidth[i] );
		m_gridCvLength.SetCol( i ); 
		m_gridCvLength.SetCellAlignment( 4 );
		m_gridCvLength.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridCvLength.SetText( sLvcText[i] ); 
	}

	SetDataToGridCtrl();
}

//--------------------------------------------------------------------
// Set data (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabCVDistanceSetView::SetDataToGridCtrl()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoCvLength;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridCvLength.SetCol( 0 );
		m_gridCvLength.SetRow( i + 1 );
		m_gridCvLength.SetCellAlignment( 0 );	// Left adjusted
		m_gridCvLength.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_sItemCvLength[i] );
		m_gridCvLength.SetText( (LPCTSTR) sBuf );

		// 2nd column (Old Value)
		m_gridCvLength.SetCol( 1 );
		m_gridCvLength.SetRow( i + 1 );
		
		// Set Text
		sBuf.Format( "%.1f mm", pDoc->m_pSetupItems->m_fValueCvLength[i] );
		m_gridCvLength.SetCellAlignment( 4 );
		m_gridCvLength.SetCellBackColor( BG_COLOR );
		m_gridCvLength.SetText( (LPCTSTR) sBuf );

		// 3rd column (New Value)
		m_gridCvLength.SetCol( 2 );
		m_gridCvLength.SetRow( i + 1 );
		
		// Set Text
		sBuf.Format( "%.1f mm", pDoc->m_pSetupItems->m_fValueCvLengthTemp[i] );
		m_gridCvLength.SetCellAlignment( 4 );
		m_gridCvLength.SetText( (LPCTSTR) sBuf );
	}
}

BEGIN_EVENTSINK_MAP(CSetupTabCVDistanceSetView, CFormView)
    //{{AFX_EVENTSINK_MAP(CSetupTabCVDistanceSetView)
	ON_EVENT(CSetupTabCVDistanceSetView, IDC_GRID_SETUP_INFO, -601 /* DblClick */, OnDblClickGridSetupInfo, VTS_NONE)
	ON_EVENT(CSetupTabCVDistanceSetView, IDC_GRID_INSENSOR_OFF_TIMEOUT_INFO, -601 /* DblClick */, OnDblClickGridInSensorOffTimeOut, VTS_NONE)
	ON_EVENT(CSetupTabCVDistanceSetView, IDC_GRID_OUTSENSOR_OFF_TIMEOUT_INFO, -601 /* DblClick */, OnDblClickGridOutSensorOffTimeOut, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CSetupTabCVDistanceSetView::OnDblClickGridSetupInfo() 
{
	int nRow = m_gridCvLength.GetRow();
	int nCol = m_gridCvLength.GetCol();

	if ( nRow == 0 || nCol != 2 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	CString sBuf;

	CDlgEditVal dlg;
	dlg.m_sOldVal.Format( "%.1f", pDoc->m_pSetupItems->m_fValueCvLengthTemp[nRow - 1] );
	dlg.m_sCurVal = dlg.m_sOldVal;
	dlg.m_nType = CDlgEditVal::typeINPUT;
	dlg.m_nFormat = CDlgEditVal::formatFLOAT;
	if( dlg.DoModal() == IDOK )
	{
		sBuf = dlg.m_sCurVal + " mm";
		m_gridCvLength.SetText( (LPCTSTR) sBuf );

		// Set the changed value to temperary variable
		pDoc->m_pSetupItems->m_fValueCvLengthTemp[nRow - 1] = atof( dlg.m_sCurVal );
	}
}

void CSetupTabCVDistanceSetView::OnSelchangeComboCvSpeed() 
{
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	UpdateData( TRUE );
	pDoc->m_pSetupItems->m_nCvSpeed = ( m_nIndex + 1 ) * CV_SPEED_INTERVAL * 7;
}

void CSetupTabCVDistanceSetView::OnStart() 
{
	if( AfxMessageBox( "Do you really want to calibrate the interval of conveyor ?", MB_YESNO ) == IDNO ) return;	

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	pDoc->m_pSetupItems->m_bCalReq = TRUE;
	m_msgComment.SetOpMsg( "On calibration ... Wait for a moment" );

	GetDlgItem( IDC_START )->EnableWindow( FALSE );
	GetDlgItem( IDC_STOP )->EnableWindow( TRUE );
	GetDlgItem( IDC_COMBO_CV_SPEED )->EnableWindow( FALSE );
}

void CSetupTabCVDistanceSetView::OnStop()
{
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	pDoc->m_pSetupItems->m_bCalCancel = TRUE;
}

void CSetupTabCVDistanceSetView::GridInit_InSensorOffTimeoutInfo()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 2500, 1300 }; 

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// initialize GridCtrl
	int nRows = pDoc->m_pSetupItems->m_nItemNoInSensorTimeOut;
	if( nRows <= 6 ) nColWidth[0] += 270;

	m_gridInSensorOffTimeOutInfo.SetRows( nRows + 1 ); 
	m_gridInSensorOffTimeOutInfo.SetCols( 2 );

	//-------------------------------------------
	m_gridInSensorOffTimeOutInfo.SetRow( 0 );  
	m_gridInSensorOffTimeOutInfo.SetColWidth( 0, nColWidth[0] );
	m_gridInSensorOffTimeOutInfo.SetCol( 0 ); 
	m_gridInSensorOffTimeOutInfo.SetCellAlignment( 4 );
	m_gridInSensorOffTimeOutInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridInSensorOffTimeOutInfo.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridInSensorOffTimeOutInfo.SetColWidth( 1, nColWidth[1] );
	m_gridInSensorOffTimeOutInfo.SetCol( 1 ); 
	m_gridInSensorOffTimeOutInfo.SetCellAlignment( 4 );
	m_gridInSensorOffTimeOutInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridInSensorOffTimeOutInfo.SetText( sLvcText[1] ); 

	SetDataToGridCtrl_InSensorOffTimeOutInfo();
}

void CSetupTabCVDistanceSetView::SetDataToGridCtrl_InSensorOffTimeOutInfo()
{
	CString sBuf;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoInSensorTimeOut;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridInSensorOffTimeOutInfo.SetCol( 0 );
		m_gridInSensorOffTimeOutInfo.SetRow( i + 1 );
		m_gridInSensorOffTimeOutInfo.SetCellAlignment( 0 );	// Left adjusted
		m_gridInSensorOffTimeOutInfo.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_sItemInSensorOffTimeOut[i] );
		m_gridInSensorOffTimeOutInfo.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridInSensorOffTimeOutInfo.SetCol( 1 );
		m_gridInSensorOffTimeOutInfo.SetRow( i + 1 );
		
		// Set the background color
		if( pDoc->m_pSetupItems->m_nValueInSensorOffTimeOutTemp[i] == 1 ) 
		{
			m_gridInSensorOffTimeOutInfo.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridInSensorOffTimeOutInfo.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "CHECK" );
		}
		else 
		{
			m_gridInSensorOffTimeOutInfo.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridInSensorOffTimeOutInfo.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO CHECK" );
		}

		m_gridInSensorOffTimeOutInfo.SetText( (LPCTSTR) sBuf );
		m_gridInSensorOffTimeOutInfo.SetCellAlignment( 4 );
	}	
}

void CSetupTabCVDistanceSetView::GridInit_OutSensorOffTimeoutInfo()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 2500, 1300 }; 

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// initialize GridCtrl
	int nRows = pDoc->m_pSetupItems->m_nItemNoOutSensorTimeOut  ;
	if( nRows <= 6 ) nColWidth[0] += 270;

	m_gridOutSensorOffTimeOutInfo.SetRows( nRows + 1 ); 
	m_gridOutSensorOffTimeOutInfo.SetCols( 2 );

	//-------------------------------------------
	m_gridOutSensorOffTimeOutInfo.SetRow( 0 );  
	m_gridOutSensorOffTimeOutInfo.SetColWidth( 0, nColWidth[0] );
	m_gridOutSensorOffTimeOutInfo.SetCol( 0 ); 
	m_gridOutSensorOffTimeOutInfo.SetCellAlignment( 4 );
	m_gridOutSensorOffTimeOutInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridOutSensorOffTimeOutInfo.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridOutSensorOffTimeOutInfo.SetColWidth( 1, nColWidth[1] );
	m_gridOutSensorOffTimeOutInfo.SetCol( 1 ); 
	m_gridOutSensorOffTimeOutInfo.SetCellAlignment( 4 );
	m_gridOutSensorOffTimeOutInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridOutSensorOffTimeOutInfo.SetText( sLvcText[1] ); 

	SetDataToGridCtrl_OutSensorOffTimeOutInfo();
}

void CSetupTabCVDistanceSetView::SetDataToGridCtrl_OutSensorOffTimeOutInfo()
{
	CString sBuf;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoOutSensorTimeOut;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridOutSensorOffTimeOutInfo.SetCol( 0 );
		m_gridOutSensorOffTimeOutInfo.SetRow( i + 1 );
		m_gridOutSensorOffTimeOutInfo.SetCellAlignment( 0 );	// Left adjusted
		m_gridOutSensorOffTimeOutInfo.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_sItemOutSensorOffTimeOut[i] );
		m_gridOutSensorOffTimeOutInfo.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridOutSensorOffTimeOutInfo.SetCol( 1 );
		m_gridOutSensorOffTimeOutInfo.SetRow( i + 1 );
		
		// Set the background color
		if( pDoc->m_pSetupItems->m_nValueOutSensorOffTimeOutTemp[i] == 1 ) 
		{
			m_gridOutSensorOffTimeOutInfo.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridOutSensorOffTimeOutInfo.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "CHECK" );
		}
		else 
		{
			m_gridOutSensorOffTimeOutInfo.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridOutSensorOffTimeOutInfo.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO CHECK" );
		}

		m_gridOutSensorOffTimeOutInfo.SetText( (LPCTSTR) sBuf );
		m_gridOutSensorOffTimeOutInfo.SetCellAlignment( 4 );
	}		
}

void CSetupTabCVDistanceSetView::OnDblClickGridInSensorOffTimeOut() 
{
	int nRow = m_gridInSensorOffTimeOutInfo.GetRow();
	int nCol = m_gridInSensorOffTimeOutInfo.GetCol();

	if ( nRow == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	CString sVal = m_gridInSensorOffTimeOutInfo.GetText();
	if( sVal == "CHECK" )
	{ 
		m_gridInSensorOffTimeOutInfo.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
		m_gridInSensorOffTimeOutInfo.SetCellForeColor( DARK_GRAY_COLOR );
		sVal = "NO CHECK"; 
		
		// Set the changed value to temperary variable
		pDoc->m_pSetupItems->m_nValueInSensorOffTimeOutTemp[nRow - 1] = 0;
	}
	else
	{ 
		m_gridInSensorOffTimeOutInfo.SetCellBackColor( BG_COLOR_BOOL_ON );
		m_gridInSensorOffTimeOutInfo.SetCellForeColor( BLACK_COLOR );
		sVal = "CHECK";

		// Set the changed value to temperary variable
		pDoc->m_pSetupItems->m_nValueInSensorOffTimeOutTemp[nRow - 1] = 1;
	}
	m_gridInSensorOffTimeOutInfo.SetText( (LPCTSTR) sVal );
}

void CSetupTabCVDistanceSetView::OnDblClickGridOutSensorOffTimeOut() 
{
	int nRow = m_gridOutSensorOffTimeOutInfo.GetRow();
	int nCol = m_gridOutSensorOffTimeOutInfo.GetCol();

	if ( nRow == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	CString sVal = m_gridOutSensorOffTimeOutInfo.GetText();
	if( sVal == "CHECK" )
	{ 
		m_gridOutSensorOffTimeOutInfo.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
		m_gridOutSensorOffTimeOutInfo.SetCellForeColor( DARK_GRAY_COLOR );
		sVal = "NO CHECK"; 
		
		// Set the changed value to temperary variable
		pDoc->m_pSetupItems->m_nValueOutSensorOffTimeOutTemp[nRow - 1] = 0;
	}
	else
	{ 
		m_gridOutSensorOffTimeOutInfo.SetCellBackColor( BG_COLOR_BOOL_ON );
		m_gridOutSensorOffTimeOutInfo.SetCellForeColor( BLACK_COLOR );
		sVal = "CHECK";

		// Set the changed value to temperary variable
		pDoc->m_pSetupItems->m_nValueOutSensorOffTimeOutTemp[nRow - 1] = 1;
	}
	m_gridOutSensorOffTimeOutInfo.SetText( (LPCTSTR) sVal );
}


BOOL CSetupTabCVDistanceSetView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
/*
#define MAX_ID	2
	DWORD dw;
	if(zDelta <=0)	dw = SB_LINEDOWN;
	else			dw = SB_LINEUP;

	CRect rect;
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	int nID[MAX_ID] = { IDC_GRID_INSENSOR_OFF_TIMEOUT_INFO, IDC_GRID_OUTSENSOR_OFF_TIMEOUT_INFO};
	int i;
	for( i=0; i<MAX_ID; i++)
	{
		//if(((CMSFlexGrid*)GetDlgItem( nID[i] ))->GetRows() <= 18) continue;

		GetDlgItem( nID[i] )->GetWindowRect( &rect );

		if(rect.left < pt.x && pt.x < rect.right && rect.top < pt.y && pt.y < rect.bottom)
		{
			GetDlgItem(nID[i])->SendMessage(WM_VSCROLL, dw, 0);
		}
	}
*/
	return CFormView::OnMouseWheel(nFlags, zDelta, pt);
}
