// SetupTabCVMotorParaView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "SetupTabCVMotorParaView.h"
#include "..\Dlg\DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupTabCVMotorParaView

IMPLEMENT_DYNCREATE(CSetupTabCVMotorParaView, CFormView)

CSetupTabCVMotorParaView::CSetupTabCVMotorParaView()
	: CFormView(CSetupTabCVMotorParaView::IDD)
{
	//{{AFX_DATA_INIT(CSetupTabCVMotorParaView)
	//}}AFX_DATA_INIT
}

CSetupTabCVMotorParaView::CSetupTabCVMotorParaView(CView* pView)
	: CFormView(CSetupTabCVMotorParaView::IDD)
{
	m_pView = pView;
}

CSetupTabCVMotorParaView::~CSetupTabCVMotorParaView()
{
}

void CSetupTabCVMotorParaView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupTabCVMotorParaView)
	DDX_Control(pDX, IDC_GRID_SETUP_INFO, m_gridCvPara);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSetupTabCVMotorParaView, CFormView)
	//{{AFX_MSG_MAP(CSetupTabCVMotorParaView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupTabCVMotorParaView diagnostics

#ifdef _DEBUG
void CSetupTabCVMotorParaView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSetupTabCVMotorParaView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSetupTabCVMotorParaView message handlers

BOOL CSetupTabCVMotorParaView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CSetupTabCVMotorParaView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Create the Comment message box
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// Initialize the temporary variable
	pDoc->m_pSetupItems->InitTempVarTabCVMotorParaView();

	// Set the items
	GridInit();
}

//--------------------------------------------------------------------
// Initialize the GridCtrl (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabCVMotorParaView::GridInit()
{
	LPTSTR sLvcText[] = { " ITEMS ", "VELOCITY RATIO", "GEAR RATIO", " DIAMETER " };	// { " ITEMS ", " NEW VALUE " }
	int nColWidth[] = { 4500, 2500, 2500, 2000 };	// ljy_050401 : change { 9000, 2500 }->{ 6000, 2500, 2500 }

	// initialize GridCtrl
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoCvMotorPara;
	if( nRows <= 27 ) nColWidth[0] += 270;
	m_gridCvPara.SetRows( nRows + 1 ); 
	m_gridCvPara.SetCols( 4 );	// ljy_050401 : change 2->3

	m_gridCvPara.SetRow( 0 );  
	for( int i=0; i<4; i++ )	// ljy_050401 : change 2->3
	{
		m_gridCvPara.SetColWidth( i, nColWidth[i] );
		m_gridCvPara.SetCol( i ); 
		m_gridCvPara.SetCellAlignment( 4 );
		m_gridCvPara.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridCvPara.SetText( sLvcText[i] ); 
	}

	SetDataToGridCtrl();
}

//--------------------------------------------------------------------
// Set data (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabCVMotorParaView::SetDataToGridCtrl()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoCvMotorPara;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridCvPara.SetCol( 0 );
		m_gridCvPara.SetRow( i + 1 );
		m_gridCvPara.SetCellAlignment( 0 );	// Left adjusted
		m_gridCvPara.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_infoCvMotorPara[i].sName );
		m_gridCvPara.SetText( (LPCTSTR) sBuf );

		for( int j=1; j<4; j++ )
		{
			// 2nd column (New Value)
			m_gridCvPara.SetCol( j );
			m_gridCvPara.SetRow( i + 1 );

			// Set Text
			if( j == 1 ) sBuf.Format( "%.3f", pDoc->m_pSetupItems->m_fValueCvMotorVelRatioTemp[i] );
			else if( j == 2 ) sBuf.Format( "%.1f", pDoc->m_pSetupItems->m_fValueCvMotorRatioTemp[i] );
			else sBuf.Format( "%.1f mm", pDoc->m_pSetupItems->m_fValueCvMotorDiaTemp[i] );
			m_gridCvPara.SetCellAlignment( 4 );
			m_gridCvPara.SetText( (LPCTSTR) sBuf );
		}
	}
}

BEGIN_EVENTSINK_MAP(CSetupTabCVMotorParaView, CFormView)
    //{{AFX_EVENTSINK_MAP(CSetupTabCVMotorParaView)
	ON_EVENT(CSetupTabCVMotorParaView, IDC_GRID_SETUP_INFO, -601 /* DblClick */, OnDblClickGridSetupInfo, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CSetupTabCVMotorParaView::OnDblClickGridSetupInfo() 
{
	int nRow = m_gridCvPara.GetRow();
	int nCol = m_gridCvPara.GetCol();

	if ( nRow == 0 || nCol == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	CString sBuf;
	CDlgEditVal dlg;

	if( nCol == 1 ) dlg.m_sOldVal.Format( "%.3f", pDoc->m_pSetupItems->m_fValueCvMotorVelRatioTemp[nRow - 1] );
	else if( nCol == 2 ) dlg.m_sOldVal.Format( "%.1f", pDoc->m_pSetupItems->m_fValueCvMotorRatioTemp[nRow - 1] );
	else dlg.m_sOldVal.Format( "%.1f", pDoc->m_pSetupItems->m_fValueCvMotorDiaTemp[nRow - 1] );

	dlg.m_sCurVal = dlg.m_sOldVal;
	dlg.m_nType = CDlgEditVal::typeINPUT;
	dlg.m_nFormat = CDlgEditVal::formatFLOAT;
	if( dlg.DoModal() == IDOK )
	{
		if( nCol == 1 ) sBuf = dlg.m_sCurVal;
		else if( nCol == 2 ) sBuf = dlg.m_sCurVal;
		else sBuf = dlg.m_sCurVal + " mm";
		m_gridCvPara.SetText( (LPCTSTR) sBuf );

		// Set the changed value to temporary variable
		if( nCol == 1 ) pDoc->m_pSetupItems->m_fValueCvMotorVelRatioTemp[nRow - 1] = atof( dlg.m_sCurVal );
		else if( nCol == 2 ) pDoc->m_pSetupItems->m_fValueCvMotorRatioTemp[nRow - 1] = atof( dlg.m_sCurVal );
		else pDoc->m_pSetupItems->m_fValueCvMotorDiaTemp[nRow - 1] = atof( dlg.m_sCurVal );
	}
}



