// SetupTabDVParaView.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "SetupTabDVParaView.h"
#include "..\Dlg\DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupTabDVParaView

IMPLEMENT_DYNCREATE(CSetupTabDVParaView, CFormView)

CSetupTabDVParaView::CSetupTabDVParaView()
	: CFormView(CSetupTabDVParaView::IDD)
{
	//{{AFX_DATA_INIT(CSetupTabDVParaView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CSetupTabDVParaView::CSetupTabDVParaView(CView* pView)
	: CFormView(CSetupTabDVParaView::IDD)
{
	m_pView = pView;
}

CSetupTabDVParaView::~CSetupTabDVParaView()
{
}

void CSetupTabDVParaView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupTabDVParaView)
	DDX_Control(pDX, IDC_GRID_DV_NAME, m_gridDvName);
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupTabDVParaView, CFormView)
	//{{AFX_MSG_MAP(CSetupTabDVParaView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupTabDVParaView diagnostics

#ifdef _DEBUG
void CSetupTabDVParaView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSetupTabDVParaView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSetupTabDVParaView message handlers

BOOL CSetupTabDVParaView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CSetupTabDVParaView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	GridInit_DV();
	
}

//--------------------------------------------------------------------
// Initialize the GridCtrl (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabDVParaView::GridInit_DV()
{
	LPTSTR sLvcText[] = { " DV ID ", "   DV NAME   " };
	int nColWidth[] = { 2000, 5200 }; 

	// initialize GridCtrl
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoDvName;
	m_gridDvName.SetRows( nRows + 1 ); 
	m_gridDvName.SetCols( 2 );

	m_gridDvName.SetRow( 0 );  
	for( int i=0; i<2; i++ )
	{
		m_gridDvName.SetColWidth( i, nColWidth[i] );
		m_gridDvName.SetCol( i ); 
		m_gridDvName.SetCellAlignment( 4 );
		m_gridDvName.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridDvName.SetText( sLvcText[i] ); 
	}

	SetDataToGridCtrl_DV();
}

//--------------------------------------------------------------------
// Set data (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabDVParaView::SetDataToGridCtrl_DV()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoDvName;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridDvName.SetCol( 0 );
		m_gridDvName.SetRow( i + 1 );
		m_gridDvName.SetCellAlignment( 4 );	// Left adjusted : 0, Center adjusted : 4
		m_gridDvName.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d", i + 1 );
		m_gridDvName.SetText( (LPCTSTR) sBuf );

		// 2nd column (New Value)
		m_gridDvName.SetCol( 1 );
		m_gridDvName.SetRow( i + 1 );
		
		// Set Text
		sBuf.Format( "%s", pDoc->m_pSetupItems->m_sValueDvNameTemp[i] );
		m_gridDvName.SetCellAlignment( 4 );
		m_gridDvName.SetText( (LPCTSTR) sBuf );
	}
}

BEGIN_EVENTSINK_MAP(CSetupTabDVParaView, CFormView)
    //{{AFX_EVENTSINK_MAP(CSetupTabDVParaView)
	ON_EVENT(CSetupTabDVParaView, IDC_GRID_DV_NAME, -601 /* DblClick */, OnDblClickGridDvName, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CSetupTabDVParaView::OnDblClickGridDvName() 
{
	int nRow = m_gridDvName.GetRowSel();
	int nCol = m_gridDvName.GetColSel();

	if ( nRow == 0 || nCol != 1 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	CString sBuf;
	CDlgEditVal dlg;
	dlg.m_sOldVal.Format( "%s", pDoc->m_pSetupItems->m_sValueDvNameTemp[nRow - 1] );
	dlg.m_sCurVal = dlg.m_sOldVal;
	dlg.m_nType = CDlgEditVal::typeINPUT;
	dlg.m_nFormat = CDlgEditVal::formatSTRING;
	if( dlg.DoModal() == IDOK )
	{
		sBuf = dlg.m_sCurVal;
		if( sBuf.GetLength() > 50 ) 
		{
			AfxMessageBox( "Name length is too long (<50)", MB_OK | MB_ICONSTOP | MB_SYSTEMMODAL );
			return;
		}
		m_gridDvName.SetText( (LPCTSTR) sBuf );

		// Set the changed value to temporary variable
		pDoc->m_pSetupItems->m_sValueDvNameTemp[nRow - 1] = dlg.m_sCurVal;
	}
}
