// SetupTab6View.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "SetupTabHpmjParaView.h"
#include "..\Dlg\DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupTabHpmjParaView

IMPLEMENT_DYNCREATE(CSetupTabHpmjParaView, CFormView)

CSetupTabHpmjParaView::CSetupTabHpmjParaView()
	: CFormView(CSetupTabHpmjParaView::IDD)
{
	//{{AFX_DATA_INIT(CSetupTabHpmjParaView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CSetupTabHpmjParaView::CSetupTabHpmjParaView(CView* pView)
	: CFormView(CSetupTabHpmjParaView::IDD)
{
	m_pView = pView;
}

CSetupTabHpmjParaView::~CSetupTabHpmjParaView()
{
}

void CSetupTabHpmjParaView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupTabHpmjParaView)
	DDX_Control(pDX, IDC_GRID_GAUGE_LIMIT, m_gridGaugeLimit);
	DDX_Control(pDX, IDC_GRID_SETUP_INFO, m_gridSetupInfo);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupTabHpmjParaView, CFormView)
	//{{AFX_MSG_MAP(CSetupTabHpmjParaView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupTabHpmjParaView diagnostics

#ifdef _DEBUG
void CSetupTabHpmjParaView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSetupTabHpmjParaView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSetupTabHpmjParaView message handlers

BOOL CSetupTabHpmjParaView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CSetupTabHpmjParaView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Initialize the temperary variable
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	pDoc->m_pSetupItems->InitTempVarTabHpmjParaView();

	// Set the items
	GridInit_SetupInfo();
	GridInit_GaugeLimit();
}

//--------------------------------------------------------------------
// Initialize the GridCtrl (SetupInfo)
//--------------------------------------------------------------------
void CSetupTabHpmjParaView::GridInit_SetupInfo()
{
	LPTSTR sLvcText[] = { " ITEMS ", " OPTION ", " VALUE ", " DESCRIPTION " };
	int nColWidth[] = { 4220, 1500, 1500, 4500 }; 

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// initialize GridCtrl
	int nRows = pDoc->m_pSetupItems->m_nItemNoHpmjSetup;
	if( nRows <= 27 ) nColWidth[0] += 70;

	m_gridSetupInfo.SetRows( nRows + 1 ); 
	m_gridSetupInfo.SetCols( 4 );

	//-------------------------------------------
	m_gridSetupInfo.SetRow( 0 );  
	for( int i=0; i<4; i++ )
	{
		m_gridSetupInfo.SetColWidth( i, nColWidth[i] );
		m_gridSetupInfo.SetCol( i ); 
		m_gridSetupInfo.SetCellAlignment( 4 );
		m_gridSetupInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridSetupInfo.SetText( sLvcText[i] ); 
	}

	SetDataToGridCtrl_SetupInfo();
}

//--------------------------------------------------------------------
// Set data (SetupInfo)
//--------------------------------------------------------------------
void CSetupTabHpmjParaView::SetDataToGridCtrl_SetupInfo()
{
	CString sBuf;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoHpmjSetup;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridSetupInfo.SetCol( 0 );
		m_gridSetupInfo.SetRow( i + 1 );
		m_gridSetupInfo.SetCellAlignment( 0 );	// Left adjusted
		m_gridSetupInfo.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_infoHpmjSetup[i].sName );
		m_gridSetupInfo.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridSetupInfo.SetCol( 1 );
		m_gridSetupInfo.SetRow( i + 1 );
		SetBoolTypeValue( pDoc->m_pSetupItems->m_nValueHpmjSetup_OptionTemp[i], 
						  pDoc->m_pSetupItems->m_infoHpmjSetup[i].nOption, 
						  m_gridSetupInfo );		

		// 3rd column
		m_gridSetupInfo.SetCol( 2 );
		m_gridSetupInfo.SetRow( i + 1 );

		if( pDoc->m_pSetupItems->m_infoHpmjSetup[i].sUnit == "NONE" )
		{
			m_gridSetupInfo.SetCellBackColor( BG_COLOR );
			m_gridSetupInfo.SetCellForeColor( BG_COLOR );
			sBuf.Format( "" );
		}
		else
		{
			sBuf = pDoc->m_pSetupItems->m_sValueHpmjSetupTemp[i] + " " + 
				pDoc->m_pSetupItems->m_infoHpmjSetup[i].sUnit;
		}
		m_gridSetupInfo.SetCellAlignment( 4 );
		m_gridSetupInfo.SetText( (LPCTSTR) sBuf );

		// 4rd column
		m_gridSetupInfo.SetCol( 3 );
		m_gridSetupInfo.SetRow( i + 1 );
		m_gridSetupInfo.SetCellAlignment( 4 );
		if( i == 0 ) m_gridSetupInfo.SetText( (LPCTSTR)" " );
		else if( i == 1 ) m_gridSetupInfo.SetText( (LPCTSTR)" 1 : PRESS SET / 2 : FREQUENCY SET " );
		else if( i == 2 ) m_gridSetupInfo.SetText( (LPCTSTR)"  ļ(40.0~60.0) " );
		else if( i == 3 ) m_gridSetupInfo.SetText( (LPCTSTR)"  з(80.0~150.0) " );
	}
}

//--------------------------------------------------------------------
// Initialize the GridCtrl(GaugeLimit)
//--------------------------------------------------------------------
void CSetupTabHpmjParaView::GridInit_GaugeLimit()
{
	LPTSTR sLvcText[] = { " ITEMS ", " OPTION ", "MIN ", " W_MIN ", " W_MAX ", " MAX " };
	int nColWidth[] = { 4220, 1500, 1500, 1500, 1500, 1500 }; 

	// initialize GridCtrl
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoHpmjPara;
	if( nRows <= 27 ) nColWidth[0] += 70;
	m_gridGaugeLimit.SetRows( nRows + 1 ); 
	m_gridGaugeLimit.SetCols( 6 );

	m_gridGaugeLimit.SetRow( 0 );  
	for( int i=0; i<6; i++ )
	{
		m_gridGaugeLimit.SetColWidth( i, nColWidth[i] );
		m_gridGaugeLimit.SetCol( i ); 
		m_gridGaugeLimit.SetCellAlignment( 4 );
		m_gridGaugeLimit.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridGaugeLimit.SetText( sLvcText[i] ); 
	}
	SetDataToGridCtrl_GaugeLimit();
}

//--------------------------------------------------------------------
// Set data (GaugeLimit)
//--------------------------------------------------------------------
void CSetupTabHpmjParaView::SetDataToGridCtrl_GaugeLimit()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoHpmjPara;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridGaugeLimit.SetCol( 0 );
		m_gridGaugeLimit.SetRow( i + 1 );
		m_gridGaugeLimit.SetCellAlignment( 0 );	// Left adjusted
		m_gridGaugeLimit.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s (%s)", i + 1, pDoc->m_pSetupItems->m_infoHpmjPara[i].sName,
			pDoc->m_pSetupItems->m_infoHpmjPara[i].sUnit );
		m_gridGaugeLimit.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridGaugeLimit.SetCol( 1 );
		m_gridGaugeLimit.SetRow( i + 1 );
		m_gridGaugeLimit.SetCellAlignment( 4 );

		// Set the background color
		CString sBuf;
		if( pDoc->m_pSetupItems->m_nValueHpmjPara_OptionTemp[i] == 1 ) 
		{
			m_gridGaugeLimit.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridGaugeLimit.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "CHECK" );
		}
		else 
		{
			m_gridGaugeLimit.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridGaugeLimit.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO CHECK" );
		}
		m_gridGaugeLimit.SetText( (LPCTSTR) sBuf );

		//3rd ~ 6th column
		for( int j=0; j<4; j++ )
		{
			m_gridGaugeLimit.SetCol( j + 2 );
			m_gridGaugeLimit.SetRow( i + 1 );
			
			// Set Text
//			sBuf.Format( "%d %s", pDoc->m_pSetupItems->m_nValueGaugeLimitTemp[j][i],
//				pDoc->m_pSetupItems->m_infoGaugeLimit[i].sUnit );

			sBuf.Format( "%s", pDoc->m_pSetupItems->m_sValueHpmjParaTemp[j][i] );
			m_gridGaugeLimit.SetCellAlignment( 4 );

			// Set the background color
			if( i == CSetupItems::gaugeHPMJ_UNIT_FILTER_DIFFER_PRESS )
			{
				if( j == 3 ) m_gridGaugeLimit.SetCellBackColor( LIGHT_RED_COLOR );
				else if( j == 2) m_gridGaugeLimit.SetCellBackColor( LIGHT_YELLOW_COLOR );
				else m_gridGaugeLimit.SetCellBackColor( BG_COLOR_DISABLE );

				if( j == 0 || j == 1 ) m_gridGaugeLimit.SetText( " " );
				else m_gridGaugeLimit.SetText( (LPCTSTR) sBuf );
			}
			else
			{
				if( j == 0 || j == 3 ) m_gridGaugeLimit.SetCellBackColor( LIGHT_RED_COLOR );
				else m_gridGaugeLimit.SetCellBackColor( LIGHT_YELLOW_COLOR );

				m_gridGaugeLimit.SetText( (LPCTSTR) sBuf );
			}

		}
	}
}

//--------------------------------------------------------------------
// SetBoolTypeValue
//--------------------------------------------------------------------
void CSetupTabHpmjParaView::SetBoolTypeValue(int nValue, int nOption, CMSFlexGrid& gridCtrl)
{
	CString sBuf;
	if( nOption == CSetupItems::optionBOOL1 ) 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "PROCESS MDOE" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "PASS MDOE" );
		}
	}
	else if( nOption == CSetupItems::optionBOOL2 ) 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "USE" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO USE" );
		}
	}
	else if( nOption == CSetupItems::optionBOOL3 ) 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "CHECK" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO CHECK" );
		}
	}
	else if( nOption == CSetupItems::optionBOOL4 ) 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "FW" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "BW" );
		}
	}
	else if( nOption == CSetupItems::optionBOOL5 ) 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "ACTIVE" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "PASSIVE" );
		}
	}
	else if( nOption == CSetupItems::optionBOOL6 ) 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "PRESSURE" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "FREQUENCY" );
		}
	}
	else
	{
		gridCtrl.SetCellBackColor( BG_COLOR );
		gridCtrl.SetCellForeColor( BG_COLOR );
		sBuf.Format( "" );
	}

	gridCtrl.SetCellAlignment( 4 );
	gridCtrl.SetText( (LPCTSTR) sBuf );
}

BEGIN_EVENTSINK_MAP(CSetupTabHpmjParaView, CFormView)
    //{{AFX_EVENTSINK_MAP(CSetupTabHpmjParaView)
	ON_EVENT(CSetupTabHpmjParaView, IDC_GRID_SETUP_INFO, -601 /* DblClick */, OnDblClickGridSetupInfo, VTS_NONE)
	ON_EVENT(CSetupTabHpmjParaView, IDC_GRID_GAUGE_LIMIT, -601 /* DblClick */, OnDblClickGridGaugeLimit, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

//--------------------------------------------------------------------
// OnDblClickGridSetupInfo
//--------------------------------------------------------------------
void CSetupTabHpmjParaView::OnDblClickGridSetupInfo() 
{
	int nRow = m_gridSetupInfo.GetRowSel();
	int nCol = m_gridSetupInfo.GetColSel();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView->m_pDicsData->m_GenInfo.bAuto || pView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER ) return;

	if ( nRow == 0 ) return;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	CString sBuf;

	if( nCol == 1 && m_gridSetupInfo.GetCellBackColor() != BG_COLOR )	// Option
	{
		pDoc->m_pSetupItems->m_nValueHpmjSetup_OptionTemp[nRow - 1] = 
			( pDoc->m_pSetupItems->m_nValueHpmjSetup_OptionTemp[nRow - 1] == 1 ) ? 0 : 1;
		SetBoolTypeValue( pDoc->m_pSetupItems->m_nValueHpmjSetup_OptionTemp[nRow - 1], 
						  pDoc->m_pSetupItems->m_infoHpmjSetup[nRow - 1].nOption, 
						  m_gridSetupInfo );
	}
	else if( nCol == 2 && m_gridSetupInfo.GetCellBackColor() != BG_COLOR )	// Value
	{
		CDlgEditVal dlg;
		dlg.m_sCurVal = dlg.m_sOldVal = pDoc->m_pSetupItems->m_sValueHpmjSetupTemp[nRow - 1];
		dlg.m_nType = CDlgEditVal::typeINPUT;
		dlg.m_nFormat = pDoc->m_pSetupItems->m_infoHpmjSetup[nRow - 1].nFormat;
		if( dlg.DoModal() == IDOK )
		{
			sBuf = dlg.m_sCurVal + " " + pDoc->m_pSetupItems->m_infoHpmjSetup[nRow - 1].sUnit;
			m_gridSetupInfo.SetText( (LPCTSTR) sBuf );

			// Set the changed value to temperary variable
			pDoc->m_pSetupItems->m_sValueHpmjSetupTemp[nRow - 1] = dlg.m_sCurVal;
		}
	}
}

//--------------------------------------------------------------------
// OnDblClickGridGaugeLimit
//--------------------------------------------------------------------
void CSetupTabHpmjParaView::OnDblClickGridGaugeLimit() 
{
	int nRow = m_gridGaugeLimit.GetRowSel();
	int nCol = m_gridGaugeLimit.GetColSel();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView->m_pDicsData->m_GenInfo.bAuto || pView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER ) return;

	if ( nRow == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	CString sBuf;

	if( nCol == 1 )
	{
		sBuf = m_gridGaugeLimit.GetText();
		if( sBuf == "CHECK" )
		{ 
			m_gridGaugeLimit.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
			m_gridGaugeLimit.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf = "NO CHECK"; 
			
			// Set the changed value to temperary variable
			pDoc->m_pSetupItems->m_nValueHpmjPara_OptionTemp[nRow - 1] = 0;
		}
		else
		{ 
			m_gridGaugeLimit.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridGaugeLimit.SetCellForeColor( BLACK_COLOR );
			sBuf = "CHECK";

			// Set the changed value to temperary variable
			pDoc->m_pSetupItems->m_nValueHpmjPara_OptionTemp[nRow - 1] = 1;
		}
		m_gridGaugeLimit.SetText( (LPCTSTR) sBuf );
	}
	else
	{
		if( m_gridGaugeLimit.GetCellBackColor() != BG_COLOR )
		{
			CDlgEditVal dlg;
			dlg.m_sOldVal.Format( "%s", pDoc->m_pSetupItems->m_sValueHpmjParaTemp[nCol - 2][nRow - 1] );
			dlg.m_sCurVal = dlg.m_sOldVal;
			dlg.m_nType = CDlgEditVal::typeINPUT;
			dlg.m_nFormat = pDoc->m_pSetupItems->m_infoHpmjPara[nRow - 1].nFormat;
			if( dlg.DoModal() == IDOK )
			{
	//			sBuf.Format( "%s %s", dlg.m_sCurVal, pDoc->m_pSetupItems->m_infoGaugeLimit[nRow - 1].sUnit );
	//			m_gridGaugeLimit.SetText( (LPCTSTR) dlg.m_sCurVal );

				sBuf = dlg.m_sCurVal;

				// Set the changed value to temperary variable
				pDoc->m_pSetupItems->m_sValueHpmjParaTemp[nCol - 2][nRow - 1] = dlg.m_sCurVal;
				m_gridGaugeLimit.SetText( (LPCTSTR) sBuf );
			}
		}
	}
}
