// SetupTabHsmsParaView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "SetupTabHsmsParaView.h"
#include "..\Dlg\DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupTabHsmsParaView

IMPLEMENT_DYNCREATE(CSetupTabHsmsParaView, CFormView)

CSetupTabHsmsParaView::CSetupTabHsmsParaView()
	: CFormView(CSetupTabHsmsParaView::IDD)
{
	//{{AFX_DATA_INIT(CSetupTabHsmsParaView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}
CSetupTabHsmsParaView::CSetupTabHsmsParaView(CView* pView)
	: CFormView(CSetupTabHsmsParaView::IDD)
{
	m_pView = pView;
}
CSetupTabHsmsParaView::~CSetupTabHsmsParaView()
{
}

void CSetupTabHsmsParaView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupTabHsmsParaView)
	DDX_Control(pDX, IDC_GRID_HSMS_PARA, m_gridHsmsPara);
	DDX_Control(pDX, IDC_GRID_APD_PARA, m_gridApdPara);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CSetupTabHsmsParaView, CFormView)
	//{{AFX_MSG_MAP(CSetupTabHsmsParaView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupTabHsmsParaView diagnostics

#ifdef _DEBUG
void CSetupTabHsmsParaView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSetupTabHsmsParaView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSetupTabHsmsParaView message handlers

BOOL CSetupTabHsmsParaView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CSetupTabHsmsParaView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	pDoc->m_pSetupItems->InitTempVarTabHsmsParaView();

	// Set the items
	GridInit_Hsms();
	GridInit_Apd();
}
//--------------------------------------------------------------------
// Initialize the GridCtrl (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabHsmsParaView::GridInit_Hsms()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 4900, 2800 }; 

	// initialize GridCtrl
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoHsmsPara;
	if( nRows <= 27 ) nColWidth[0] += 270;
	m_gridHsmsPara.SetRows( nRows + 1 ); 
	m_gridHsmsPara.SetCols( 2 );

	m_gridHsmsPara.SetRow( 0 );  
	for( int i=0; i<2; i++ )
	{
		m_gridHsmsPara.SetColWidth( i, nColWidth[i] );
		m_gridHsmsPara.SetCol( i ); 
		m_gridHsmsPara.SetCellAlignment( 4 );
		m_gridHsmsPara.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridHsmsPara.SetText( sLvcText[i] ); 
	}

	SetDataToGridCtrl_Hsms();
}

//--------------------------------------------------------------------
// Set data (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabHsmsParaView::SetDataToGridCtrl_Hsms()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoHsmsPara;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridHsmsPara.SetCol( 0 );
		m_gridHsmsPara.SetRow( i + 1 );
		m_gridHsmsPara.SetCellAlignment( 0 );	// Left adjusted
		m_gridHsmsPara.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_infoHsmsPara[i].sName );
		m_gridHsmsPara.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridHsmsPara.SetCol( 1 );
		m_gridHsmsPara.SetRow( i + 1 );

		// Set the background color
		if( pDoc->m_pSetupItems->m_infoHsmsPara[i].nOption == CSetupItems::optionBOOL5 )
		{
			CString sBuf;
			if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp[i] == "ACTIVE" ) 
			{
				m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_ON );
				m_gridHsmsPara.SetCellForeColor( BLACK_COLOR );
			}
			else 
			{
				m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_OFF );
				m_gridHsmsPara.SetCellForeColor( DARK_GRAY_COLOR );
			}
		}
		
		// Set Text
		sBuf.Format( "%s %s", 
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[i], 
			pDoc->m_pSetupItems->m_infoHsmsPara[i].sUnit );
		m_gridHsmsPara.SetCellAlignment( 4 );
		m_gridHsmsPara.SetText( (LPCTSTR) sBuf );
	}
}


BEGIN_EVENTSINK_MAP(CSetupTabHsmsParaView, CFormView)
    //{{AFX_EVENTSINK_MAP(CSetupTabHsmsParaView)
	ON_EVENT(CSetupTabHsmsParaView, IDC_GRID_HSMS_PARA, -601 /* DblClick */, OnDblClickGridHsmsPara, VTS_NONE)
	ON_EVENT(CSetupTabHsmsParaView, IDC_GRID_APD_PARA, -601 /* DblClick */, OnDblClickGridApdPara, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CSetupTabHsmsParaView::OnDblClickGridHsmsPara() 
{
	int nRow = m_gridHsmsPara.GetRowSel();
	int nCol = m_gridHsmsPara.GetColSel();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView->m_pDicsData->m_GenInfo.bAuto || pView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;//Bryan_071231

	if ( nRow == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	if( pDoc->m_pSetupItems->m_infoHsmsPara[nRow - 1].nOption == CSetupItems::optionBOOL5 )
	{
		if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] == "ACTIVE" ) 
		{
			m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridHsmsPara.SetCellForeColor( DARK_GRAY_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] = "PASSIVE";
		}
		else 
		{
			m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridHsmsPara.SetCellForeColor( BLACK_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] = "ACTIVE";
		}

		CString sBuf;
		sBuf.Format( "%s %s", 
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1], 
			pDoc->m_pSetupItems->m_infoHsmsPara[nRow - 1].sUnit );
	 	    m_gridHsmsPara.SetText( (LPCTSTR) sBuf );
	}
	else
	{
		CDlgEditVal dlg;
		dlg.m_sCurVal = dlg.m_sOldVal = pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1];
		dlg.m_nType = CDlgEditVal::typeINPUT;
		dlg.m_nFormat = pDoc->m_pSetupItems->m_infoHsmsPara[nRow - 1].nFormat;
		if( dlg.DoModal() == IDOK )
		{
			// Set the changed value to temperary variable
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] = dlg.m_sCurVal;

			CString sBuf;
			sBuf.Format( "%s %s", dlg.m_sCurVal, pDoc->m_pSetupItems->m_infoHsmsPara[nRow - 1].sUnit );
			m_gridHsmsPara.SetText( (LPCTSTR) sBuf );
		}
	}
}

void CSetupTabHsmsParaView::GridInit_Apd()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 3100, 2000 }; 

	// initialize GridCtrl
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoApdPara;
	if( nRows <= 27 ) nColWidth[0] += 270;
	m_gridApdPara.SetRows( nRows + 1 ); 
	m_gridApdPara.SetCols( 2 );

	m_gridApdPara.SetRow( 0 );  
	for( int i=0; i<2; i++ )
	{
		m_gridApdPara.SetColWidth( i, nColWidth[i] );
		m_gridApdPara.SetCol( i ); 
		m_gridApdPara.SetCellAlignment( 4 );
		m_gridApdPara.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridApdPara.SetText( sLvcText[i] ); 
	}

	SetDataToGridCtrl_Apd();
}

void CSetupTabHsmsParaView::SetDataToGridCtrl_Apd()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoApdPara;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridApdPara.SetCol( 0 );
		m_gridApdPara.SetRow( i + 1 );
		m_gridApdPara.SetCellAlignment( 0 );	// Left adjusted
		m_gridApdPara.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_infoApdPara[i].sName );
		m_gridApdPara.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridApdPara.SetCol( 1 );
		m_gridApdPara.SetRow( i + 1 );

		// Set the background color
		if( pDoc->m_pSetupItems->m_infoApdPara[i].nOption == CSetupItems::optionBOOL5 )
		{
			CString sBuf;
			if( pDoc->m_pSetupItems->m_sValueApdParaTemp[i] == "ACTIVE" ) 
			{
				m_gridApdPara.SetCellBackColor( BG_COLOR_BOOL_ON );
				m_gridApdPara.SetCellForeColor( BLACK_COLOR );
			}
			else 
			{
				m_gridApdPara.SetCellBackColor( BG_COLOR_BOOL_OFF );
				m_gridApdPara.SetCellForeColor( DARK_GRAY_COLOR );
			}
		}
		
		// Set Text
		sBuf.Format( "%s %s", 
			pDoc->m_pSetupItems->m_sValueApdParaTemp[i], 
			pDoc->m_pSetupItems->m_infoApdPara[i].sUnit );
		m_gridApdPara.SetCellAlignment( 4 );
		m_gridApdPara.SetText( (LPCTSTR) sBuf );
	}
}


void CSetupTabHsmsParaView::OnDblClickGridApdPara()
{
	int nRow = m_gridApdPara.GetRowSel();
	int nCol = m_gridApdPara.GetColSel();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView->m_pDicsData->m_GenInfo.bAuto || pView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) return;//Bryan_071231

	if ( nRow == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	if( pDoc->m_pSetupItems->m_infoApdPara[nRow - 1].nOption == CSetupItems::optionBOOL5 )
	{
		if( pDoc->m_pSetupItems->m_sValueApdParaTemp[nRow - 1] == "ACTIVE" ) 
		{
			m_gridApdPara.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridApdPara.SetCellForeColor( DARK_GRAY_COLOR );
			pDoc->m_pSetupItems->m_sValueApdParaTemp[nRow - 1] = "PASSIVE";
		}
		else 
		{
			m_gridApdPara.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridApdPara.SetCellForeColor( BLACK_COLOR );
			pDoc->m_pSetupItems->m_sValueApdParaTemp[nRow - 1] = "ACTIVE";
		}

		CString sBuf;
		sBuf.Format( "%s %s", 
			pDoc->m_pSetupItems->m_sValueApdParaTemp[nRow - 1], 
			pDoc->m_pSetupItems->m_infoApdPara[nRow - 1].sUnit );
		m_gridApdPara.SetText( (LPCTSTR) sBuf );
	}
	else
	{
		CDlgEditVal dlg;
		dlg.m_sCurVal = dlg.m_sOldVal = pDoc->m_pSetupItems->m_sValueApdParaTemp[nRow - 1];
		dlg.m_nType = CDlgEditVal::typeINPUT;
		dlg.m_nFormat = pDoc->m_pSetupItems->m_infoApdPara[nRow - 1].nFormat;
		if( dlg.DoModal() == IDOK )
		{
			// Set the changed value to temperary variable
			pDoc->m_pSetupItems->m_sValueApdParaTemp[nRow - 1] = dlg.m_sCurVal;

			CString sBuf;
			sBuf.Format( "%s %s", dlg.m_sCurVal, pDoc->m_pSetupItems->m_infoApdPara[nRow - 1].sUnit );
			m_gridApdPara.SetText( (LPCTSTR) sBuf );
		}
	}
}

