// SetupTabInterfaceParaView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "SetupTabInterfaceParaView.h"
#include "..\Dlg\DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupTabInterfaceParaView

IMPLEMENT_DYNCREATE(CSetupTabInterfaceParaView, CFormView)

CSetupTabInterfaceParaView::CSetupTabInterfaceParaView()
	: CFormView(CSetupTabInterfaceParaView::IDD)
{
	//{{AFX_DATA_INIT(CSetupTabInterfaceParaView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CSetupTabInterfaceParaView::CSetupTabInterfaceParaView(CView* pView)
	: CFormView(CSetupTabInterfaceParaView::IDD)
{
	m_pView = pView;
}

CSetupTabInterfaceParaView::~CSetupTabInterfaceParaView()
{
}

void CSetupTabInterfaceParaView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupTabInterfaceParaView)
	DDX_Control(pDX, IDC_GRID_HSMS_PARA, m_gridHsmsPara);
	DDX_Control(pDX, IDC_GRID_INTERFACE_PARA, m_gridInterfacePara);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupTabInterfaceParaView, CFormView)
	//{{AFX_MSG_MAP(CSetupTabInterfaceParaView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupTabInterfaceParaView diagnostics

#ifdef _DEBUG
void CSetupTabInterfaceParaView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSetupTabInterfaceParaView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSetupTabInterfaceParaView message handlers

BOOL CSetupTabInterfaceParaView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CSetupTabInterfaceParaView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// Initialize the temperary variable
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	pDoc->m_pSetupItems->InitTempVarTabInterfaceParaView();

	// Set the items
	GridInit_Hsms();
	GridInit_MainMc();
}

//--------------------------------------------------------------------
// Initialize the GridCtrl (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabInterfaceParaView::GridInit_Hsms()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 5100, 3000 }; 

	// initialize GridCtrl
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoHsmsPara;
	if( nRows <= 27 ) nColWidth[0] += 270;
	m_gridHsmsPara.SetRows( nRows + 1 ); 
	m_gridHsmsPara.SetCols( 2 );

	m_gridHsmsPara.SetRow( 0 );  
	for( int i=0; i<2; i++ )
	{
		m_gridHsmsPara.SetColWidth( i, nColWidth[i] );
		m_gridHsmsPara.SetCol( i ); 
		m_gridHsmsPara.SetCellAlignment( 4 );
		m_gridHsmsPara.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridHsmsPara.SetText( sLvcText[i] ); 
	}

	SetDataToGridCtrl_Hsms();
}

//--------------------------------------------------------------------
// Initialize the GridCtrl (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabInterfaceParaView::GridInit_MainMc()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 3100, 2000 }; 

	// initialize GridCtrl
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoInterfacePara;
	if( nRows <= 27 ) nColWidth[0] += 270;
	m_gridInterfacePara.SetRows( nRows + 1 ); 
	m_gridInterfacePara.SetCols( 2 );

	m_gridInterfacePara.SetRow( 0 );  
	for( int i=0; i<2; i++ )
	{
		m_gridInterfacePara.SetColWidth( i, nColWidth[i] );
		m_gridInterfacePara.SetCol( i ); 
		m_gridInterfacePara.SetCellAlignment( 4 );
		m_gridInterfacePara.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridInterfacePara.SetText( sLvcText[i] ); 
	}

	SetDataToGridCtrl();
}

//--------------------------------------------------------------------
// Set data (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabInterfaceParaView::SetDataToGridCtrl()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoInterfacePara;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridInterfacePara.SetCol( 0 );
		m_gridInterfacePara.SetRow( i + 1 );
		m_gridInterfacePara.SetCellAlignment( 0 );	// Left adjusted
		m_gridInterfacePara.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_infoInterfacePara[i].sName );
		m_gridInterfacePara.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridInterfacePara.SetCol( 1 );
		m_gridInterfacePara.SetRow( i + 1 );
		
		// Set Text
		sBuf.Format( "%s %s", 
			pDoc->m_pSetupItems->m_sValueInterfaceParaTemp[i], 
			pDoc->m_pSetupItems->m_infoInterfacePara[i].sUnit );
		m_gridInterfacePara.SetCellAlignment( 4 );
		m_gridInterfacePara.SetText( (LPCTSTR) sBuf );
	}
}

//--------------------------------------------------------------------
// Set data (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabInterfaceParaView::SetDataToGridCtrl_Hsms()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoHsmsPara;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridHsmsPara.SetCol( 0 );
		m_gridHsmsPara.SetRow( i + 1 );
		m_gridHsmsPara.SetCellAlignment( 0 );	// Left adjusted
		m_gridHsmsPara.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_infoHsmsPara[i].sName );
		m_gridHsmsPara.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridHsmsPara.SetCol( 1 );
		m_gridHsmsPara.SetRow( i + 1 );

		// Set the background color
		if( pDoc->m_pSetupItems->m_infoHsmsPara[i].nOption == CSetupItems::optionBOOL5 )
		{
			CString sBuf;
			if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp[i] == "ACTIVE" ) 
				{
					m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_ON );
					m_gridHsmsPara.SetCellForeColor( BLACK_COLOR );
				}
				else 
				{
					m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_OFF );
					m_gridHsmsPara.SetCellForeColor( DARK_GRAY_COLOR );
				}
			}
			else if( pDoc->m_pSetupItems->m_infoHsmsPara[i].nOption == CSetupItems::optionBOOL6 )
			{
				CString sBuf;
			if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp[i] == "ENABLE" ) 
				{
					m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_ON );
					m_gridHsmsPara.SetCellForeColor( BLACK_COLOR );
				}
				else 
				{
					m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_OFF );
					m_gridHsmsPara.SetCellForeColor( DARK_GRAY_COLOR );
				}
			}
			else if( pDoc->m_pSetupItems->m_infoHsmsPara[i].nOption == CSetupItems::optionTRI_STATE2 )
			{
			if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp[i] == "OFFLINE" )
			{
				m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_OFF );
				m_gridHsmsPara.SetCellForeColor( DARK_GRAY_COLOR );
			}
			else
			{
				m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_ON );
				m_gridHsmsPara.SetCellForeColor( BLACK_COLOR );
			}
		} 
		
		// Set Text
		sBuf.Format( "%s %s", 
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[i], 
			pDoc->m_pSetupItems->m_infoHsmsPara[i].sUnit );
		m_gridHsmsPara.SetCellAlignment( 4 );
		m_gridHsmsPara.SetText( (LPCTSTR) sBuf );
		}
	}

BEGIN_EVENTSINK_MAP(CSetupTabInterfaceParaView, CFormView)
    //{{AFX_EVENTSINK_MAP(CSetupTabInterfaceParaView)
	ON_EVENT(CSetupTabInterfaceParaView, IDC_GRID_HSMS_PARA, -601 /* DblClick */, OnDblClickGridHsmsPara, VTS_NONE)
	ON_EVENT(CSetupTabInterfaceParaView, IDC_GRID_INTERFACE_PARA, -601 /* DblClick */, OnDblClickGridInterfacePara, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CSetupTabInterfaceParaView::OnDblClickGridHsmsPara() 
{
	int nRow = m_gridHsmsPara.GetRowSel();
	int nCol = m_gridHsmsPara.GetColSel();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView->m_pDicsData->m_GenInfo.bAuto || pView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER ) return;

	if ( nRow == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	if( pDoc->m_pSetupItems->m_infoHsmsPara[nRow - 1].nOption == CSetupItems::optionBOOL5 )
	{
		if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] == "ACTIVE" ) 
		{
			m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridHsmsPara.SetCellForeColor( DARK_GRAY_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] = "PASSIVE";
		}
		else 
		{
			m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridHsmsPara.SetCellForeColor( BLACK_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] = "ACTIVE";
		}

		CString sBuf;
		sBuf.Format( "%s %s", 
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1], 
			pDoc->m_pSetupItems->m_infoHsmsPara[nRow - 1].sUnit );
		m_gridHsmsPara.SetText( (LPCTSTR) sBuf );
	}
	else if( pDoc->m_pSetupItems->m_infoHsmsPara[nRow - 1].nOption == CSetupItems::optionBOOL6 )
	{
		if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] == "ENABLE" ) 
		{
			m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridHsmsPara.SetCellForeColor( DARK_GRAY_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] = "DISABLE";
		}
		else
		{
			m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridHsmsPara.SetCellForeColor( BLACK_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] = "ENABLE";
		}

		CString sBuf;
		sBuf.Format( "%s %s", 
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1], 
			pDoc->m_pSetupItems->m_infoHsmsPara[nRow - 1].sUnit );
		m_gridHsmsPara.SetText( (LPCTSTR) sBuf );
	}
	else if( pDoc->m_pSetupItems->m_infoHsmsPara[nRow - 1].nOption == CSetupItems::optionTRI_STATE2 )
	{
		if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] == "OFFLINE" ) 
		{
			m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridHsmsPara.SetCellForeColor( BLACK_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] = "LOCAL";
		}
		else if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] == "LOCAL" ) 
		{
			m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridHsmsPara.SetCellForeColor( BLACK_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] = "REMOTE";
		}
		else
		{
			m_gridHsmsPara.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridHsmsPara.SetCellForeColor( DARK_GRAY_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] = "OFFLINE";
		}

		CString sBuf;
		sBuf.Format( "%s %s", 
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1], 
			pDoc->m_pSetupItems->m_infoHsmsPara[nRow - 1].sUnit );
		m_gridHsmsPara.SetText( (LPCTSTR) sBuf );
	}
	else
	{
		CDlgEditVal dlg;
		dlg.m_sCurVal = dlg.m_sOldVal = pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1];
		dlg.m_nType = CDlgEditVal::typeINPUT;
		dlg.m_nFormat = pDoc->m_pSetupItems->m_infoHsmsPara[nRow - 1].nFormat;
		if( dlg.DoModal() == IDOK )
		{
			// Set the changed value to temperary variable
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp[nRow - 1] = dlg.m_sCurVal;

			CString sBuf;
			sBuf.Format( "%s %s", dlg.m_sCurVal, pDoc->m_pSetupItems->m_infoHsmsPara[nRow - 1].sUnit );
			m_gridHsmsPara.SetText( (LPCTSTR) sBuf );
		}
	}
}

void CSetupTabInterfaceParaView::OnDblClickGridInterfacePara() 
{
	int nRow = m_gridInterfacePara.GetRow();
	int nCol = m_gridInterfacePara.GetCol();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	CString	sMsg;

	if ( nRow == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	if( pDoc->m_pDicsView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER )
		return ;

	CDlgEditVal dlg;
	dlg.m_sCurVal = dlg.m_sOldVal = pDoc->m_pSetupItems->m_sValueInterfaceParaTemp[nRow - 1];
	dlg.m_nType = CDlgEditVal::typeINPUT;
	if( dlg.DoModal() == IDOK )
	{
		// Set the changed value to temperary variable
		pDoc->m_pSetupItems->m_sValueInterfaceParaTemp[nRow - 1] = dlg.m_sCurVal;

		CString sBuf;
		sBuf.Format( "%s %s", dlg.m_sCurVal, pDoc->m_pSetupItems->m_infoInterfacePara[nRow - 1].sUnit );
		m_gridInterfacePara.SetText( (LPCTSTR) sBuf );
	}
}
