// SetupTabInterlockSet2View.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "SetupTabInterlockSet2View.h"
#include "..\Dlg\DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupTabInterlockSet2View

IMPLEMENT_DYNCREATE(CSetupTabInterlockSet2View, CFormView)

CSetupTabInterlockSet2View::CSetupTabInterlockSet2View()
	: CFormView(CSetupTabInterlockSet2View::IDD)
{
	//{{AFX_DATA_INIT(CSetupTabInterlockSet2View)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CSetupTabInterlockSet2View::CSetupTabInterlockSet2View(CView* pView)
	: CFormView(CSetupTabInterlockSet2View::IDD)
{
	m_pView = pView;
}

CSetupTabInterlockSet2View::~CSetupTabInterlockSet2View()
{
}

void CSetupTabInterlockSet2View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupTabInterlockSet2View)
	DDX_Control(pDX, IDC_GRID_BATH_COVER_INTR, m_gridBathCoverIntr);
	DDX_Control(pDX, IDC_GRID_DOOR_INTR, m_gridDoorIntr);
	DDX_Control(pDX, IDC_GRID_LEAK_DETECT_INTR, m_gridLeakDetectIntr);
	DDX_Control(pDX, IDC_GRID_FFU_ALARM_INTR, m_gridFFUAlarmIntr);
	DDX_Control(pDX, IDC_GRID_BROKEN_INTR, m_gridBrokenIntr);
	DDX_Control(pDX, IDC_GRID_ETC_INTR, m_gridETCIntr);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupTabInterlockSet2View, CFormView)
	//{{AFX_MSG_MAP(CSetupTabInterlockSet2View)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
	ON_WM_MOUSEWHEEL()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupTabInterlockSet2View diagnostics

#ifdef _DEBUG
void CSetupTabInterlockSet2View::AssertValid() const
{
	CFormView::AssertValid();
}

void CSetupTabInterlockSet2View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSetupTabInterlockSet2View message handlers

BOOL CSetupTabInterlockSet2View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CSetupTabInterlockSet2View::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Initialize the temporary variable
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	pDoc->m_pSetupItems->InitTempVarTabInterlockSet2View();

	// Set the items
	GridInit_BathCoverIntr();
	GridInit_DoorIntr();
	GridInit_LeakDetectIntr();
	GridInit_FFUAlarmIntr();
//	GridInit_BrokenIntr();
	GridInit_ETCIntr();

	GetDlgItem( IDC_GRID_BROKEN_INTR )->ShowWindow( FALSE );
}

//--------------------------------------------------------------------
// Initialize the GridCtrl (SensorIntr)
//--------------------------------------------------------------------

void CSetupTabInterlockSet2View::GridInit_BathCoverIntr()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 4600, 1300 };

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// initialize GridCtrl
	int nRows = pDoc->m_pSetupItems->m_nItemNoBathCoverIntr;
	if( nRows <= 7 ) nColWidth[1] += 270;

	m_gridBathCoverIntr.SetRows( nRows + 1 ); 
	m_gridBathCoverIntr.SetCols( 2 );

	//-------------------------------------------
	m_gridBathCoverIntr.SetRow( 0 );  
	m_gridBathCoverIntr.SetColWidth( 0, nColWidth[0] );
	m_gridBathCoverIntr.SetCol( 0 ); 
	m_gridBathCoverIntr.SetCellAlignment( 4 );
	m_gridBathCoverIntr.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridBathCoverIntr.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridBathCoverIntr.SetColWidth( 1, nColWidth[1] );
	m_gridBathCoverIntr.SetCol( 1 ); 
	m_gridBathCoverIntr.SetCellAlignment( 4 );
	m_gridBathCoverIntr.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridBathCoverIntr.SetText( sLvcText[1] ); 

	SetDataToGridCtrl_BathCoverIntr();
}

//--------------------------------------------------------------------
// Set data (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabInterlockSet2View::SetDataToGridCtrl_BathCoverIntr()
{
	CString sBuf;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoBathCoverIntr;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridBathCoverIntr.SetCol( 0 );
		m_gridBathCoverIntr.SetRow( i + 1 );
		m_gridBathCoverIntr.SetCellAlignment( 0 );	// Left adjusted
		m_gridBathCoverIntr.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_sItemBathCoverIntr[i] );
		m_gridBathCoverIntr.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridBathCoverIntr.SetCol( 1 );
		m_gridBathCoverIntr.SetRow( i + 1 );
		
		// Set the background color
		if( pDoc->m_pSetupItems->m_nValueBathCoverIntrTemp[i] == 1 ) 
		{
			m_gridBathCoverIntr.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridBathCoverIntr.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "CHECK" );
		}
		else 
		{
			m_gridBathCoverIntr.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridBathCoverIntr.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO CHECK" );
		}

		m_gridBathCoverIntr.SetText( (LPCTSTR) sBuf );
		m_gridBathCoverIntr.SetCellAlignment( 4 );
	}
}


void CSetupTabInterlockSet2View::GridInit_DoorIntr()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 4600, 1300 };

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// initialize GridCtrl
	int nRows = pDoc->m_pSetupItems->m_nItemNoDoorIntr;
	if( nRows <= 7 ) nColWidth[1] += 270;

	m_gridDoorIntr.SetRows( nRows + 1 ); 
	m_gridDoorIntr.SetCols( 2 );

	//-------------------------------------------
	m_gridDoorIntr.SetRow( 0 );  
	m_gridDoorIntr.SetColWidth( 0, nColWidth[0] );
	m_gridDoorIntr.SetCol( 0 ); 
	m_gridDoorIntr.SetCellAlignment( 4 );
	m_gridDoorIntr.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridDoorIntr.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridDoorIntr.SetColWidth( 1, nColWidth[1] );
	m_gridDoorIntr.SetCol( 1 ); 
	m_gridDoorIntr.SetCellAlignment( 4 );
	m_gridDoorIntr.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridDoorIntr.SetText( sLvcText[1] ); 

	SetDataToGridCtrl_DoorIntr();
}

//--------------------------------------------------------------------
// Set data (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabInterlockSet2View::SetDataToGridCtrl_DoorIntr()
{
	CString sBuf;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoDoorIntr;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridDoorIntr.SetCol( 0 );
		m_gridDoorIntr.SetRow( i + 1 );
		m_gridDoorIntr.SetCellAlignment( 0 );	// Left adjusted
		m_gridDoorIntr.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_sItemDoorIntr[i] );
		m_gridDoorIntr.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridDoorIntr.SetCol( 1 );
		m_gridDoorIntr.SetRow( i + 1 );
		
		// Set the background color
		if( pDoc->m_pSetupItems->m_nValueDoorIntrTemp[i] == 1 ) 
		{
			m_gridDoorIntr.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridDoorIntr.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "CHECK" );
		}
		else 
		{
			m_gridDoorIntr.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridDoorIntr.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO CHECK" );
		}

		m_gridDoorIntr.SetText( (LPCTSTR) sBuf );
		m_gridDoorIntr.SetCellAlignment( 4 );
	}
}

void CSetupTabInterlockSet2View::GridInit_LeakDetectIntr()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 4600, 1300 };

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// initialize GridCtrl
	int nRows = pDoc->m_pSetupItems->m_nItemNoLeakDetectIntr;
	if( nRows <= 7 ) nColWidth[1] += 270;

	m_gridLeakDetectIntr.SetRows( nRows + 1 ); 
	m_gridLeakDetectIntr.SetCols( 2 );

	//-------------------------------------------
	m_gridLeakDetectIntr.SetRow( 0 );  
	m_gridLeakDetectIntr.SetColWidth( 0, nColWidth[0] );
	m_gridLeakDetectIntr.SetCol( 0 ); 
	m_gridLeakDetectIntr.SetCellAlignment( 4 );
	m_gridLeakDetectIntr.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridLeakDetectIntr.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridLeakDetectIntr.SetColWidth( 1, nColWidth[1] );
	m_gridLeakDetectIntr.SetCol( 1 ); 
	m_gridLeakDetectIntr.SetCellAlignment( 4 );
	m_gridLeakDetectIntr.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridLeakDetectIntr.SetText( sLvcText[1] ); 

	SetDataToGridCtrl_LeakDetectIntr();
}

//--------------------------------------------------------------------
// Set data (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabInterlockSet2View::SetDataToGridCtrl_LeakDetectIntr()
{
	CString sBuf;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoLeakDetectIntr;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridLeakDetectIntr.SetCol( 0 );
		m_gridLeakDetectIntr.SetRow( i + 1 );
		m_gridLeakDetectIntr.SetCellAlignment( 0 );	// Left adjusted
		m_gridLeakDetectIntr.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_sItemLeakDetectIntr[i] );
		m_gridLeakDetectIntr.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridLeakDetectIntr.SetCol( 1 );
		m_gridLeakDetectIntr.SetRow( i + 1 );
		
		// Set the background color
		if( pDoc->m_pSetupItems->m_nValueLeakDetectIntrTemp[i] == 1 ) 
		{
			m_gridLeakDetectIntr.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridLeakDetectIntr.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "CHECK" );
		}
		else 
		{
			m_gridLeakDetectIntr.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridLeakDetectIntr.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO CHECK" );
		}

		m_gridLeakDetectIntr.SetText( (LPCTSTR) sBuf );
		m_gridLeakDetectIntr.SetCellAlignment( 4 );
	}
}

void CSetupTabInterlockSet2View::GridInit_FFUAlarmIntr()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 4600, 1300 };

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// initialize GridCtrl
	int nRows = pDoc->m_pSetupItems->m_nItemNoFFUAlarmIntr;
	if( nRows <= 7 ) nColWidth[1] += 270;

	m_gridFFUAlarmIntr.SetRows( nRows + 1 ); 
	m_gridFFUAlarmIntr.SetCols( 2 );

	//-------------------------------------------
	m_gridFFUAlarmIntr.SetRow( 0 );  
	m_gridFFUAlarmIntr.SetColWidth( 0, nColWidth[0] );
	m_gridFFUAlarmIntr.SetCol( 0 ); 
	m_gridFFUAlarmIntr.SetCellAlignment( 4 );
	m_gridFFUAlarmIntr.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridFFUAlarmIntr.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridFFUAlarmIntr.SetColWidth( 1, nColWidth[1] );
	m_gridFFUAlarmIntr.SetCol( 1 ); 
	m_gridFFUAlarmIntr.SetCellAlignment( 4 );
	m_gridFFUAlarmIntr.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridFFUAlarmIntr.SetText( sLvcText[1] ); 

	SetDataToGridCtrl_FFUAlarmIntr();
}

//--------------------------------------------------------------------
// Set data (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabInterlockSet2View::SetDataToGridCtrl_FFUAlarmIntr()
{
	CString sBuf;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoFFUAlarmIntr;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridFFUAlarmIntr.SetCol( 0 );
		m_gridFFUAlarmIntr.SetRow( i + 1 );
		m_gridFFUAlarmIntr.SetCellAlignment( 0 );	// Left adjusted
		m_gridFFUAlarmIntr.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_sItemFFUAlarmIntr[i] );
		m_gridFFUAlarmIntr.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridFFUAlarmIntr.SetCol( 1 );
		m_gridFFUAlarmIntr.SetRow( i + 1 );
		
		// Set the background color
		if( pDoc->m_pSetupItems->m_nValueFFUAlarmIntrTemp[i] == 1 ) 
		{
			m_gridFFUAlarmIntr.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridFFUAlarmIntr.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "CHECK" );
		}
		else 
		{
			m_gridFFUAlarmIntr.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridFFUAlarmIntr.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO CHECK" );
		}

		m_gridFFUAlarmIntr.SetText( (LPCTSTR) sBuf );
		m_gridFFUAlarmIntr.SetCellAlignment( 4 );
	}
}


void CSetupTabInterlockSet2View::GridInit_BrokenIntr()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 4600, 1300 };

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// initialize GridCtrl
	int nRows = pDoc->m_pSetupItems->m_nItemNoBrokenIntr;
	if( nRows <= 7 ) nColWidth[1] += 220;

	m_gridBrokenIntr.SetRows( nRows + 1 ); 
	m_gridBrokenIntr.SetCols( 2 );

	//-------------------------------------------
	m_gridBrokenIntr.SetRow( 0 );  
	m_gridBrokenIntr.SetColWidth( 0, nColWidth[0] );
	m_gridBrokenIntr.SetCol( 0 ); 
	m_gridBrokenIntr.SetCellAlignment( 4 );
	m_gridBrokenIntr.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridBrokenIntr.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridBrokenIntr.SetColWidth( 1, nColWidth[1] );
	m_gridBrokenIntr.SetCol( 1 ); 
	m_gridBrokenIntr.SetCellAlignment( 4 );
	m_gridBrokenIntr.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridBrokenIntr.SetText( sLvcText[1] ); 

	SetDataToGridCtrl_BrokenIntr();
}

//--------------------------------------------------------------------
// Set data (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabInterlockSet2View::SetDataToGridCtrl_BrokenIntr()
{
	CString sBuf;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoBrokenIntr;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridBrokenIntr.SetCol( 0 );
		m_gridBrokenIntr.SetRow( i + 1 );
		m_gridBrokenIntr.SetCellAlignment( 0 );	// Left adjusted
		m_gridBrokenIntr.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_sItemBrokenIntr[i] );
		m_gridBrokenIntr.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridBrokenIntr.SetCol( 1 );
		m_gridBrokenIntr.SetRow( i + 1 );
		
		// Set the background color
		if( pDoc->m_pSetupItems->m_nValueBrokenIntrTemp[i] == 1 ) 
		{
			m_gridBrokenIntr.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridBrokenIntr.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "CHECK" );
		}
		else 
		{
			m_gridBrokenIntr.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridBrokenIntr.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO CHECK" );
		}

		m_gridBrokenIntr.SetText( (LPCTSTR) sBuf );
		m_gridBrokenIntr.SetCellAlignment( 4 );
	}
}

void CSetupTabInterlockSet2View::GridInit_ETCIntr()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 4600, 1300 };

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// initialize GridCtrl
	int nRows = pDoc->m_pSetupItems->m_nItemNoETCIntr;
	if( nRows <= 7 ) nColWidth[1] += 270;

	m_gridETCIntr.SetRows( nRows + 1 ); 
	m_gridETCIntr.SetCols( 2 );

	//-------------------------------------------
	m_gridETCIntr.SetRow( 0 );  
	m_gridETCIntr.SetColWidth( 0, nColWidth[0] );
	m_gridETCIntr.SetCol( 0 ); 
	m_gridETCIntr.SetCellAlignment( 4 );
	m_gridETCIntr.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridETCIntr.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridETCIntr.SetColWidth( 1, nColWidth[1] );
	m_gridETCIntr.SetCol( 1 ); 
	m_gridETCIntr.SetCellAlignment( 4 );
	m_gridETCIntr.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridETCIntr.SetText( sLvcText[1] ); 

	SetDataToGridCtrl_ETCIntr();
}

//--------------------------------------------------------------------
// Set data (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabInterlockSet2View::SetDataToGridCtrl_ETCIntr()
{
	CString sBuf;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoETCIntr;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridETCIntr.SetCol( 0 );
		m_gridETCIntr.SetRow( i + 1 );
		m_gridETCIntr.SetCellAlignment( 0 );	// Left adjusted
		m_gridETCIntr.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_sItemETCIntr[i] );
		m_gridETCIntr.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridETCIntr.SetCol( 1 );
		m_gridETCIntr.SetRow( i + 1 );
		
		// Set the background color
		if( pDoc->m_pSetupItems->m_nValueETCIntrTemp[i] == 1 ) 
		{
			m_gridETCIntr.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridETCIntr.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "CHECK" );
		}
		else 
		{
			m_gridETCIntr.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridETCIntr.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO CHECK" );
		}

		m_gridETCIntr.SetText( (LPCTSTR) sBuf );
		m_gridETCIntr.SetCellAlignment( 4 );
	}
}



BEGIN_EVENTSINK_MAP(CSetupTabInterlockSet2View, CFormView)
    //{{AFX_EVENTSINK_MAP(CSetupTabInterlockSet2View)
	ON_EVENT(CSetupTabInterlockSet2View, IDC_GRID_BATH_COVER_INTR, -601 /* DblClick */, OnDblClickGridBathCoverIntr, VTS_NONE)
	ON_EVENT(CSetupTabInterlockSet2View, IDC_GRID_DOOR_INTR, -601 /* DblClick */, OnDblClickGridDoorIntr, VTS_NONE)
	ON_EVENT(CSetupTabInterlockSet2View, IDC_GRID_LEAK_DETECT_INTR, -601 /* DblClick */, OnDblClickGridLeakDetectIntr, VTS_NONE)
	ON_EVENT(CSetupTabInterlockSet2View, IDC_GRID_FFU_ALARM_INTR, -601 /* DblClick */, OnDblClickGridFFUAlarmIntr, VTS_NONE)
	ON_EVENT(CSetupTabInterlockSet2View, IDC_GRID_BROKEN_INTR, -601 /* DblClick */, OnDblClickGridBrokenIntr, VTS_NONE)
	ON_EVENT(CSetupTabInterlockSet2View, IDC_GRID_ETC_INTR, -601 /* DblClick */, OnDblClickGridETCIntr, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

//--------------------------------------------------------------------
// OnDblClickGridSensorIntr
//--------------------------------------------------------------------

void CSetupTabInterlockSet2View::OnDblClickGridBathCoverIntr() 
{
	int nRow = m_gridBathCoverIntr.GetRow();
	int nCol = m_gridBathCoverIntr.GetCol();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	CString		sMsg;

	if ( nRow == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	if( pDoc->m_pDicsView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER )
		return ;

	CString sVal = m_gridBathCoverIntr.GetText();
	if( sVal == "CHECK" )
	{ 
		m_gridBathCoverIntr.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
		m_gridBathCoverIntr.SetCellForeColor( DARK_GRAY_COLOR );
		sVal = "NO CHECK"; 
		
		// Set the changed value to temporary variable
		pDoc->m_pSetupItems->m_nValueBathCoverIntrTemp[nRow - 1] = 0;

//		sMsg.Format( "Interlock : %s ( Check -> No Check )", pDoc->m_pSetupItems->m_sItemSensorIntr[nRow - 1] );
//		pView->m_pMainSeq->SetLog( "SETUP   ", 0, 0, sMsg );
	}
	else
	{ 
		m_gridBathCoverIntr.SetCellBackColor( BG_COLOR_BOOL_ON );
		m_gridBathCoverIntr.SetCellForeColor( BLACK_COLOR );
		sVal = "CHECK";

		// Set the changed value to temperary variable
		pDoc->m_pSetupItems->m_nValueBathCoverIntrTemp[nRow - 1] = 1;

//		sMsg.Format( "Interlock : %s ( No Check -> Check )", pDoc->m_pSetupItems->m_sItemSensorIntr[nRow - 1] );
//		pView->m_pMainSeq->SetLog( "SETUP   ", 0, 0, sMsg );
	}
	m_gridBathCoverIntr.SetText( (LPCTSTR) sVal );
}
void CSetupTabInterlockSet2View::OnDblClickGridDoorIntr() 
{
	int nRow = m_gridDoorIntr.GetRow();
	int nCol = m_gridDoorIntr.GetCol();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	CString		sMsg;

	if ( nRow == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	if( pDoc->m_pDicsView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER )
		return ;

	CString sVal = m_gridDoorIntr.GetText();
	if( sVal == "CHECK" )
	{ 
		m_gridDoorIntr.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
		m_gridDoorIntr.SetCellForeColor( DARK_GRAY_COLOR );
		sVal = "NO CHECK"; 
		
		// Set the changed value to temporary variable
		pDoc->m_pSetupItems->m_nValueDoorIntrTemp[nRow - 1] = 0;

//		sMsg.Format( "Interlock : %s ( Check -> No Check )", pDoc->m_pSetupItems->m_sItemSensorIntr[nRow - 1] );
//		pView->m_pMainSeq->SetLog( "SETUP   ", 0, 0, sMsg );
	}
	else
	{ 
		m_gridDoorIntr.SetCellBackColor( BG_COLOR_BOOL_ON );
		m_gridDoorIntr.SetCellForeColor( BLACK_COLOR );
		sVal = "CHECK";

		// Set the changed value to temperary variable
		pDoc->m_pSetupItems->m_nValueDoorIntrTemp[nRow - 1] = 1;

//		sMsg.Format( "Interlock : %s ( No Check -> Check )", pDoc->m_pSetupItems->m_sItemSensorIntr[nRow - 1] );
//		pView->m_pMainSeq->SetLog( "SETUP   ", 0, 0, sMsg );
	}
	m_gridDoorIntr.SetText( (LPCTSTR) sVal );
}

void CSetupTabInterlockSet2View::OnDblClickGridLeakDetectIntr() 
{
	int nRow = m_gridLeakDetectIntr.GetRow();
	int nCol = m_gridLeakDetectIntr.GetCol();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	CString		sMsg;

	if ( nRow == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	if( pDoc->m_pDicsView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER )
		return ;

	CString sVal = m_gridLeakDetectIntr.GetText();
	if( sVal == "CHECK" )
	{ 
		m_gridLeakDetectIntr.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
		m_gridLeakDetectIntr.SetCellForeColor( DARK_GRAY_COLOR );
		sVal = "NO CHECK"; 
		
		// Set the changed value to temporary variable
		pDoc->m_pSetupItems->m_nValueLeakDetectIntrTemp[nRow - 1] = 0;

//		sMsg.Format( "Interlock : %s ( Check -> No Check )", pDoc->m_pSetupItems->m_sItemSensorIntr[nRow - 1] );
//		pView->m_pMainSeq->SetLog( "SETUP   ", 0, 0, sMsg );
	}
	else
	{ 
		m_gridLeakDetectIntr.SetCellBackColor( BG_COLOR_BOOL_ON );
		m_gridLeakDetectIntr.SetCellForeColor( BLACK_COLOR );
		sVal = "CHECK";

		// Set the changed value to temperary variable
		pDoc->m_pSetupItems->m_nValueLeakDetectIntrTemp[nRow - 1] = 1;

//		sMsg.Format( "Interlock : %s ( No Check -> Check )", pDoc->m_pSetupItems->m_sItemSensorIntr[nRow - 1] );
//		pView->m_pMainSeq->SetLog( "SETUP   ", 0, 0, sMsg );
	}
	m_gridLeakDetectIntr.SetText( (LPCTSTR) sVal );
}

void CSetupTabInterlockSet2View::OnDblClickGridFFUAlarmIntr() 
{
	int nRow = m_gridFFUAlarmIntr.GetRow();
	int nCol = m_gridFFUAlarmIntr.GetCol();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	CString		sMsg;

	if ( nRow == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	if( pDoc->m_pDicsView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER )
		return ;

	CString sVal = m_gridFFUAlarmIntr.GetText();
	if( sVal == "CHECK" )
	{ 
		m_gridFFUAlarmIntr.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
		m_gridFFUAlarmIntr.SetCellForeColor( DARK_GRAY_COLOR );
		sVal = "NO CHECK"; 
		
		// Set the changed value to temporary variable
		pDoc->m_pSetupItems->m_nValueFFUAlarmIntrTemp[nRow - 1] = 0;

//		sMsg.Format( "Interlock : %s ( Check -> No Check )", pDoc->m_pSetupItems->m_sItemSensorIntr[nRow - 1] );
//		pView->m_pMainSeq->SetLog( "SETUP   ", 0, 0, sMsg );
	}
	else
	{ 
		m_gridFFUAlarmIntr.SetCellBackColor( BG_COLOR_BOOL_ON );
		m_gridFFUAlarmIntr.SetCellForeColor( BLACK_COLOR );
		sVal = "CHECK";

		// Set the changed value to temperary variable
		pDoc->m_pSetupItems->m_nValueFFUAlarmIntrTemp[nRow - 1] = 1;

//		sMsg.Format( "Interlock : %s ( No Check -> Check )", pDoc->m_pSetupItems->m_sItemSensorIntr[nRow - 1] );
//		pView->m_pMainSeq->SetLog( "SETUP   ", 0, 0, sMsg );
	}
	m_gridFFUAlarmIntr.SetText( (LPCTSTR) sVal );
}
void CSetupTabInterlockSet2View::OnDblClickGridBrokenIntr() 
{
	int nRow = m_gridBrokenIntr.GetRow();
	int nCol = m_gridBrokenIntr.GetCol();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	CString		sMsg;

	if ( nRow == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	if( pDoc->m_pDicsView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER )
		return ;

	CString sVal = m_gridBrokenIntr.GetText();
	if( sVal == "CHECK" )
	{ 
		m_gridBrokenIntr.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
		m_gridBrokenIntr.SetCellForeColor( DARK_GRAY_COLOR );
		sVal = "NO CHECK"; 
		
		// Set the changed value to temporary variable
		pDoc->m_pSetupItems->m_nValueBrokenIntrTemp[nRow - 1] = 0;

//		sMsg.Format( "Interlock : %s ( Check -> No Check )", pDoc->m_pSetupItems->m_sItemSensorIntr[nRow - 1] );
//		pView->m_pMainSeq->SetLog( "SETUP   ", 0, 0, sMsg );
	}
	else
	{ 
		m_gridBrokenIntr.SetCellBackColor( BG_COLOR_BOOL_ON );
		m_gridBrokenIntr.SetCellForeColor( BLACK_COLOR );
		sVal = "CHECK";

		// Set the changed value to temperary variable
		pDoc->m_pSetupItems->m_nValueBrokenIntrTemp[nRow - 1] = 1;

//		sMsg.Format( "Interlock : %s ( No Check -> Check )", pDoc->m_pSetupItems->m_sItemSensorIntr[nRow - 1] );
//		pView->m_pMainSeq->SetLog( "SETUP   ", 0, 0, sMsg );
	}
	m_gridBrokenIntr.SetText( (LPCTSTR) sVal );
}

void CSetupTabInterlockSet2View::OnDblClickGridETCIntr() 
{
	int nRow = m_gridETCIntr.GetRow();
	int nCol = m_gridETCIntr.GetCol();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	CString		sMsg;

	if ( nRow == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	if( pDoc->m_pDicsView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER )
		return ;

	CString sVal = m_gridETCIntr.GetText();
	if( sVal == "CHECK" )
	{ 
		m_gridETCIntr.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
		m_gridETCIntr.SetCellForeColor( DARK_GRAY_COLOR );
		sVal = "NO CHECK"; 
		
		// Set the changed value to temporary variable
		pDoc->m_pSetupItems->m_nValueETCIntrTemp[nRow - 1] = 0;

//		sMsg.Format( "Interlock : %s ( Check -> No Check )", pDoc->m_pSetupItems->m_sItemSensorIntr[nRow - 1] );
//		pView->m_pMainSeq->SetLog( "SETUP   ", 0, 0, sMsg );
	}
	else
	{ 
		m_gridETCIntr.SetCellBackColor( BG_COLOR_BOOL_ON );
		m_gridETCIntr.SetCellForeColor( BLACK_COLOR );
		sVal = "CHECK";

		// Set the changed value to temperary variable
		pDoc->m_pSetupItems->m_nValueETCIntrTemp[nRow - 1] = 1;

//		sMsg.Format( "Interlock : %s ( No Check -> Check )", pDoc->m_pSetupItems->m_sItemSensorIntr[nRow - 1] );
//		pView->m_pMainSeq->SetLog( "SETUP   ", 0, 0, sMsg );
	}
	m_gridETCIntr.SetText( (LPCTSTR) sVal );
}

BOOL CSetupTabInterlockSet2View::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
#define MAX_ID	5
	DWORD dw;
	if(zDelta <=0)	dw = SB_LINEDOWN;
	else			dw = SB_LINEUP;

	CRect rect;
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	int nID[MAX_ID] = { IDC_GRID_DOOR_INTR, IDC_GRID_BATH_COVER_INTR, IDC_GRID_FFU_ALARM_INTR, IDC_GRID_ETC_INTR, IDC_GRID_LEAK_DETECT_INTR };
	int i;
	for( i=0; i<MAX_ID; i++)
	{
		if(((CMSFlexGrid*)GetDlgItem( nID[i] ))->GetRows() <= 8) continue;

		GetDlgItem( nID[i] )->GetWindowRect( &rect );

		if(rect.left < pt.x && pt.x < rect.right && rect.top < pt.y && pt.y < rect.bottom)
		{
			GetDlgItem(nID[i])->SendMessage(WM_VSCROLL, dw, 0);
		}
	}

	return CFormView::OnMouseWheel(nFlags, zDelta, pt);
}
