// SetupTabInterlockSetView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "SetupTabInterlockSetView.h"
#include "..\Dlg\DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupTabInterlockSetView

IMPLEMENT_DYNCREATE(CSetupTabInterlockSetView, CFormView)

CSetupTabInterlockSetView::CSetupTabInterlockSetView()
	: CFormView(CSetupTabInterlockSetView::IDD)
{
	//{{AFX_DATA_INIT(CSetupTabInterlockSetView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CSetupTabInterlockSetView::CSetupTabInterlockSetView(CView* pView)
	: CFormView(CSetupTabInterlockSetView::IDD)
{
	m_pView = pView;
}

CSetupTabInterlockSetView::~CSetupTabInterlockSetView()
{
}

void CSetupTabInterlockSetView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupTabInterlockSetView)
	DDX_Control(pDX, IDC_GRID_GAUGE_LIMIT, m_gridGaugeLimit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupTabInterlockSetView, CFormView)
	//{{AFX_MSG_MAP(CSetupTabInterlockSetView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
	ON_WM_MOUSEWHEEL()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupTabInterlockSetView diagnostics

#ifdef _DEBUG
void CSetupTabInterlockSetView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSetupTabInterlockSetView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSetupTabInterlockSetView message handlers

BOOL CSetupTabInterlockSetView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CSetupTabInterlockSetView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Initialize the temporary variable
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	m_pEqpAssy = pView->m_pEqpAssy;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	pDoc->m_pSetupItems->GetRegistryTabInterlockSetView();
	pDoc->m_pSetupItems->InitTempVarTabInterlockSetView();
	// Set the items
	GridInit_GaugeLimit();
}

//--------------------------------------------------------------------
// Initialize the GridCtrl(GaugeLimit)
//--------------------------------------------------------------------
void CSetupTabInterlockSetView::GridInit_GaugeLimit()
{
	LPTSTR sLvcText[] = { " ITEMS ", " OPTION ", "MIN ", " W_MIN ", " W_MAX ", " MAX " };
	int nColWidth[] = { 7000, 1300, 900, 900, 900, 900 }; 

	// initialize GridCtrl
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows;
	nRows = m_pEqpAssy->m_AnalogInput.m_nMaxIntrAiNo;
	if( nRows <= 27 ) nColWidth[0] += 270;
	m_gridGaugeLimit.SetRows( nRows + 1 ); 
	m_gridGaugeLimit.SetCols( 6 );

	m_gridGaugeLimit.SetRow( 0 );  
	for( int i=0; i<6; i++ )
	{
		m_gridGaugeLimit.SetColWidth( i, nColWidth[i] );
		m_gridGaugeLimit.SetCol( i ); 
		m_gridGaugeLimit.SetCellAlignment( 4 );
		m_gridGaugeLimit.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridGaugeLimit.SetText( sLvcText[i] ); 
	}
	SetDataToGridCtrl_GaugeLimit();
}

//--------------------------------------------------------------------
// Set data (GaugeLimit)
//--------------------------------------------------------------------
void CSetupTabInterlockSetView::SetDataToGridCtrl_GaugeLimit()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = m_pEqpAssy->m_AnalogInput.GetAiSize();

	for( int i=0; i<nRows; i++ )
	{
		int nIntrNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nAiIntrNo;
		if( nIntrNo < 0 ) continue;

		// 1st column
		m_gridGaugeLimit.SetCol( 0 );
		m_gridGaugeLimit.SetRow( nIntrNo + 1 );
		m_gridGaugeLimit.SetCellAlignment( 0 );	// Left adjusted
		m_gridGaugeLimit.SetCellBackColor( LIGHT_CYAN_COLOR );
	
		sBuf.Format( "%d. %s", nIntrNo + 1, m_pEqpAssy->m_AnalogInput.m_aiSet[i].sName );
		m_gridGaugeLimit.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridGaugeLimit.SetCol( 1 );
		m_gridGaugeLimit.SetRow( nIntrNo + 1 );
		m_gridGaugeLimit.SetCellAlignment( 4 );

		// Set the background color
		CString sBuf;
		
		if( pDoc->m_pSetupItems->m_nValueGaugeLimit_OptionTemp[nIntrNo] == 1 ) 
		{
			m_gridGaugeLimit.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridGaugeLimit.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "CHECK" );
		}
		else 
		{
			m_gridGaugeLimit.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridGaugeLimit.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO CHECK" );
		}
		
		m_gridGaugeLimit.SetText( (LPCTSTR) sBuf );

		//3rd ~ 6th column
		for( int j=0; j<4; j++ )
		{
			m_gridGaugeLimit.SetCol( j + 2 );
			m_gridGaugeLimit.SetRow( nIntrNo + 1 );
			
			sBuf.Format( "%d", pDoc->m_pSetupItems->m_nValueGaugeLimitTemp[j][nIntrNo] );
			m_gridGaugeLimit.SetCellAlignment( 4 );

			// Set the background color
			if( j == 0 || j == 3 ) m_gridGaugeLimit.SetCellBackColor( LIGHT_RED_COLOR );
			else m_gridGaugeLimit.SetCellBackColor( LIGHT_YELLOW_COLOR );
			m_gridGaugeLimit.SetText( (LPCTSTR) sBuf );
		}
	}
}

BEGIN_EVENTSINK_MAP(CSetupTabInterlockSetView, CFormView)
    //{{AFX_EVENTSINK_MAP(CSetupTabInterlockSetView)
	ON_EVENT(CSetupTabInterlockSetView, IDC_GRID_GAUGE_LIMIT, -601 /* DblClick */, OnDblClickGridGaugeLimit, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()


//--------------------------------------------------------------------
// OnDblClickGridGaugeLimit
//--------------------------------------------------------------------
void CSetupTabInterlockSetView::OnDblClickGridGaugeLimit() 
{
	int nRow = m_gridGaugeLimit.GetRow();
	int nCol = m_gridGaugeLimit.GetCol();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if ( nRow == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	if( pDoc->m_pDicsView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER )
		return ;
	CString sBuf;

	CString		sLog;
	CString		sMsg;

	if( nCol == 1 )
	{
		sBuf = m_gridGaugeLimit.GetText();
		if( sBuf == "CHECK" )
		{ 
			m_gridGaugeLimit.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
			m_gridGaugeLimit.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf = "NO CHECK"; 
			// Set the changed value to temporary variable
//			for( int nAiNo=0; nAiNo<m_pEqpAssy->m_AnalogInput.GetAiSize(); nAiNo++ )
//				if( (nRow-1) == m_pEqpAssy->m_AnalogInput.m_aiSet[nAiNo].nAiIntrNo ) break;
//			if( nAiNo == m_pEqpAssy->m_AnalogInput.GetAiSize() ) return;
			int nIntrNo = nRow - 1;
			if( nIntrNo < 0 ) return;
			pDoc->m_pSetupItems->m_nValueGaugeLimit_OptionTemp[nIntrNo] = 0;
		}
		else
		{ 
			m_gridGaugeLimit.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridGaugeLimit.SetCellForeColor( BLACK_COLOR );
			sBuf = "CHECK";
			// Set the changed value to temporary variable
//			for( int nAiNo=0; nAiNo<m_pEqpAssy->m_AnalogInput.GetAiSize(); nAiNo++ )
//				if( (nRow-1) == m_pEqpAssy->m_AnalogInput.m_aiSet[nAiNo].nAiIntrNo ) break;
//			if( nAiNo == m_pEqpAssy->m_AnalogInput.GetAiSize() ) return;

			int nIntrNo = nRow - 1;
			if( nIntrNo < 0 ) return;
			pDoc->m_pSetupItems->m_nValueGaugeLimit_OptionTemp[nIntrNo] = 1;
		}
		m_gridGaugeLimit.SetText( (LPCTSTR) sBuf );
	}
	else
	{
		CDicsApp* pApp = (CDicsApp*) AfxGetApp();
		CDicsView* pView = (CDicsView*) pApp->m_pMainView;
		int nReal = 0;
		int nAiNo = 0;
		
		int nIntrNo = nRow - 1;
		if( nIntrNo < 0 ) return;
		for( nAiNo=0; nAiNo<m_pEqpAssy->m_AnalogInput.GetAiSize(); nAiNo++ )
			if( nIntrNo == m_pEqpAssy->m_AnalogInput.m_aiSet[nAiNo].nAiIntrNo ) break;
		if( nAiNo == m_pEqpAssy->m_AnalogInput.GetAiSize() ) return;
		
		CDlgEditVal dlg;
		dlg.m_sTitle.Format( "%s", m_pEqpAssy->m_AnalogInput.m_aiSet[nAiNo].sName );
		dlg.m_pDevice = pView->m_pDevice;
		dlg.m_nType = CDlgEditVal::typeAI;
		dlg.m_nFormat = pDoc->m_pSetupItems->m_infoGaugeLimit[nIntrNo].nFormat;
		dlg.m_nReal = nAiNo;
		dlg.m_sOldVal.Format( "%d", pDoc->m_pSetupItems->m_nValueGaugeLimitTemp[nCol - 2][nIntrNo] );
		dlg.m_sCurVal = dlg.m_sOldVal;
		dlg.SetEqpAssy( m_pEqpAssy );//2008.11.07 kimgun
		
		CString		sLimit;
		if( dlg.DoModal() == IDOK )
		{
			sBuf = dlg.m_sCurVal;

			// Set the changed value to temperary variable
			pDoc->m_pSetupItems->m_nValueGaugeLimitTemp[nCol - 2][nIntrNo] = atoi( dlg.m_sCurVal );
			m_gridGaugeLimit.SetText( (LPCTSTR) sBuf );

			if( nCol == 2 ) sLimit = "MIN";
			else if( nCol == 3 ) sLimit = "W_MIN";
			else if( nCol == 4 ) sLimit = "W_MAX";
			else if( nCol == 5 ) sLimit = "MAX";
		}
	}
}



BOOL CSetupTabInterlockSetView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
#define MAX_ID	1

	DWORD dw;
	if(zDelta <=0)	dw = SB_LINEDOWN;
	else			dw = SB_LINEUP;

	CRect rect;
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	int nID[MAX_ID] = { IDC_GRID_GAUGE_LIMIT };
	int i;
	for( i=0; i<MAX_ID; i++)
	{
		if(((CMSFlexGrid*)GetDlgItem( nID[i] ))->GetRows() <= 8) continue;

		GetDlgItem( nID[i] )->GetWindowRect( &rect );

		if(rect.left < pt.x && pt.x < rect.right && rect.top < pt.y && pt.y < rect.bottom)
		{
			GetDlgItem(nID[i])->SendMessage(WM_VSCROLL, dw, 0);
		}
	}

	return CFormView::OnMouseWheel(nFlags, zDelta, pt);
}
