// SetupTabJobConditionView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "SetupTabJobConditionView.h"
#include "SetupView.h"
#include "..\Dlg\DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupTabJobConditionView

IMPLEMENT_DYNCREATE(CSetupTabJobConditionView, CFormView)

CSetupTabJobConditionView::CSetupTabJobConditionView()
	: CFormView(CSetupTabJobConditionView::IDD)
{
	//{{AFX_DATA_INIT(CSetupTabJobConditionView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CSetupTabJobConditionView::CSetupTabJobConditionView(CView* pView)
	: CFormView(CSetupTabJobConditionView::IDD)
{
	m_pView = pView;
}

CSetupTabJobConditionView::~CSetupTabJobConditionView()
{
}

void CSetupTabJobConditionView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupTabJobConditionView)
	DDX_Control(pDX, IDC_GRID_IDLE_RUN_INFO, m_gridIdleRunInfo);
	DDX_Control(pDX, IDC_GRID_SETUP_INFO, m_gridSetupInfo);
	DDX_Control(pDX, IDC_GRID_TANK_LEVEL_INFO, m_gridTankLevelInfo);
	DDX_Control(pDX, IDC_GRID_PARTS_LIFETIME_PARA, m_gridPartsLifeTimePara);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupTabJobConditionView, CFormView)
	//{{AFX_MSG_MAP(CSetupTabJobConditionView)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_WM_MOUSEWHEEL()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupTabJobConditionView diagnostics

#ifdef _DEBUG
void CSetupTabJobConditionView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSetupTabJobConditionView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSetupTabJobConditionView message handlers

BOOL CSetupTabJobConditionView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CSetupTabJobConditionView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	pDoc->m_pSetupItems->InitTempVarTabJobCondView();

	GridInit_SetupInfo();
	GridInit_IdleRunInfo();
	GridInit_TankLevelInfo();
	GridInit_PartsLifeTimeInfo();
}

void CSetupTabJobConditionView::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	CFormView::OnClose();
}

//--------------------------------------------------------------------
// Initialize the GridCtrl (SetupInfo)
//--------------------------------------------------------------------
void CSetupTabJobConditionView::GridInit_SetupInfo()
{
	LPTSTR sLvcText[] = { " ITEMS ", " OPTION ", " VALUE " };
	int nColWidth[] = { 3900, 2200, 2000 }; 

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// initialize GridCtrl
	int nRows = pDoc->m_pSetupItems->m_nItemNoSetup;
	if( nRows <= 23 ) nColWidth[2] += 270;

	m_gridSetupInfo.SetRows( nRows + 1 ); 
	m_gridSetupInfo.SetCols( 3 );

	//-------------------------------------------
	m_gridSetupInfo.SetRow( 0 );  
	for( int i=0; i<3; i++ )
	{
		m_gridSetupInfo.SetColWidth( i, nColWidth[i] );
		m_gridSetupInfo.SetCol( i ); 
		m_gridSetupInfo.SetCellAlignment( 4 );
		m_gridSetupInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridSetupInfo.SetText( sLvcText[i] ); 
	}

	SetDataToGridCtrl_SetupInfo();
}

//--------------------------------------------------------------------
// Set data (SetupInfo)
//--------------------------------------------------------------------
void CSetupTabJobConditionView::SetDataToGridCtrl_SetupInfo()
{
	CString sBuf;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoSetup;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridSetupInfo.SetCol( 0 );
		m_gridSetupInfo.SetRow( i + 1 );
		m_gridSetupInfo.SetCellAlignment( 0 );	// Left adjusted
		m_gridSetupInfo.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_infoSetup[i].sName );
		m_gridSetupInfo.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridSetupInfo.SetCol( 1 );
		m_gridSetupInfo.SetRow( i + 1 );
		SetBoolTypeValue( pDoc->m_pSetupItems->m_nValueSetup_OptionTemp[i], 
						  pDoc->m_pSetupItems->m_infoSetup[i].nOption, 
						  m_gridSetupInfo );		

		// 3rd column
		m_gridSetupInfo.SetCol( 2 );
		m_gridSetupInfo.SetRow( i + 1 );

		if( pDoc->m_pSetupItems->m_infoSetup[i].sUnit == "NONE" )
		{
			m_gridSetupInfo.SetCellBackColor( BG_COLOR );
			m_gridSetupInfo.SetCellForeColor( BG_COLOR );
			sBuf.Format( "" );
		}
		else
		{
			sBuf = pDoc->m_pSetupItems->m_sValueSetup[i] + " " + 
				pDoc->m_pSetupItems->m_infoSetup[i].sUnit;
		}
		m_gridSetupInfo.SetCellAlignment( 4 );
		m_gridSetupInfo.SetText( (LPCTSTR) sBuf );
	}
}

//--------------------------------------------------------------------
// Initialize the GridCtrl(IdleRunInfo)
//--------------------------------------------------------------------
void CSetupTabJobConditionView::GridInit_IdleRunInfo()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 3100, 1730 }; 

	// initialize GridCtrl
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoIdleRun;
	if( nRows <= 11 ) nColWidth[1] += 270;
	
	m_gridIdleRunInfo.SetRows( nRows + 1 ); 
	m_gridIdleRunInfo.SetCols( 2 );

	//-------------------------------------------
	m_gridIdleRunInfo.SetRow( 0 );  
	m_gridIdleRunInfo.SetColWidth( 0, nColWidth[0] );
	m_gridIdleRunInfo.SetCol( 0 ); 
	m_gridIdleRunInfo.SetCellAlignment( 4 );
	m_gridIdleRunInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridIdleRunInfo.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridIdleRunInfo.SetColWidth( 1, nColWidth[1] );
	m_gridIdleRunInfo.SetCol( 1 ); 
	m_gridIdleRunInfo.SetCellAlignment( 4 );
	m_gridIdleRunInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridIdleRunInfo.SetText( sLvcText[1] ); 

	SetDataToGridCtrl_IdleRunInfo();
}

//--------------------------------------------------------------------
// Set data (IdleRunInfo)
//--------------------------------------------------------------------
void CSetupTabJobConditionView::SetDataToGridCtrl_IdleRunInfo()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoIdleRun;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridIdleRunInfo.SetCol( 0 );
		m_gridIdleRunInfo.SetRow( i + 1 );
		m_gridIdleRunInfo.SetCellAlignment( 0 );	// Left adjusted
		m_gridIdleRunInfo.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_infoIdleRun[i].sName );
		m_gridIdleRunInfo.SetText( (LPCTSTR) sBuf );

		m_gridIdleRunInfo.SetCol( 1 );
		m_gridIdleRunInfo.SetRow( i + 1 );

		if( pDoc->m_pSetupItems->m_infoIdleRun[i].nOption != CSetupItems::optionNONE ) 
		{
			SetBoolTypeValue( pDoc->m_pSetupItems->m_nValueIdleRunTemp[i], 
						  pDoc->m_pSetupItems->m_infoIdleRun[i].nOption, 
						  m_gridIdleRunInfo );
		}
		else
		{
//			sBuf.Format( "%d", pDoc->m_pSetupItems->m_nValueIdleRunTemp[i] );
//			sBuf = sBuf + " " + pDoc->m_pSetupItems->m_infoIdleRun[i].sUnit;
//			m_gridIdleRunInfo.SetCellAlignment( 4 );
//			m_gridIdleRunInfo.SetText( (LPCTSTR) sBuf );

			// ljy_050425 : RB Gap Int Float .
			if( pDoc->m_pSetupItems->m_infoIdleRun[i].nFormat == CSetupItems::formatFLOAT )
			{
				sBuf.Format( "%3.1f", (float)( pDoc->m_pSetupItems->m_nValueIdleRunTemp[i] / 10.0 ) );
				sBuf = sBuf + " " + pDoc->m_pSetupItems->m_infoIdleRun[i].sUnit;
				m_gridIdleRunInfo.SetCellAlignment( 4 );
				m_gridIdleRunInfo.SetText( (LPCTSTR) sBuf );
			}
			else
			{
				sBuf.Format( "%d", pDoc->m_pSetupItems->m_nValueIdleRunTemp[i] );
				sBuf = sBuf + " " + pDoc->m_pSetupItems->m_infoIdleRun[i].sUnit;
				m_gridIdleRunInfo.SetCellAlignment( 4 );
				m_gridIdleRunInfo.SetText( (LPCTSTR) sBuf );
			}
		}
	}
}

//--------------------------------------------------------------------
// Initialize the GridCtrl(TankLevel)
//--------------------------------------------------------------------
void CSetupTabJobConditionView::GridInit_TankLevelInfo()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 3100, 1730 }; 

	// initialize GridCtrl
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoTankLevel;
	if( nRows <= 5 ) nColWidth[1] += 270;

	m_gridTankLevelInfo.SetRows( nRows + 1 ); 
	m_gridTankLevelInfo.SetCols( 2 );

	//-------------------------------------------
	m_gridTankLevelInfo.SetRow( 0 );  
	m_gridTankLevelInfo.SetColWidth( 0, nColWidth[0] );
	m_gridTankLevelInfo.SetCol( 0 ); 
	m_gridTankLevelInfo.SetCellAlignment( 4 );
	m_gridTankLevelInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridTankLevelInfo.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridTankLevelInfo.SetColWidth( 1, nColWidth[1] );
	m_gridTankLevelInfo.SetCol( 1 ); 
	m_gridTankLevelInfo.SetCellAlignment( 4 );
	m_gridTankLevelInfo.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridTankLevelInfo.SetText( sLvcText[1] ); 

	SetDataToGridCtrl_TankLevelInfo();
}

//--------------------------------------------------------------------
// Set data (Tank Level)
//--------------------------------------------------------------------
void CSetupTabJobConditionView::SetDataToGridCtrl_TankLevelInfo()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoTankLevel;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridTankLevelInfo.SetCol( 0 );
		m_gridTankLevelInfo.SetRow( i + 1 );
		m_gridTankLevelInfo.SetCellAlignment( 0 );	// Left adjusted
		m_gridTankLevelInfo.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_sNameTankLevel[i] );
		m_gridTankLevelInfo.SetText( (LPCTSTR) sBuf );

		m_gridTankLevelInfo.SetCol( 1 );
		m_gridTankLevelInfo.SetRow( i + 1 );

		sBuf.Format( "%d", pDoc->m_pSetupItems->m_nValueTankLevelTemp[i] );
		sBuf = sBuf + " L";
		m_gridTankLevelInfo.SetCellAlignment( 4 );
		m_gridTankLevelInfo.SetText( (LPCTSTR) sBuf );
	}
}

//--------------------------------------------------------------------
// SetBoolTypeValue
//--------------------------------------------------------------------
void CSetupTabJobConditionView::SetBoolTypeValue(int nValue, int nOption, CMSFlexGrid& gridCtrl)
{
	CString sBuf;
	if( nOption == CSetupItems::optionBOOL1 ) 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "PROCESS MODE" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "PASS MODE" );
		}
	}
	else if( nOption == CSetupItems::optionBOOL2 ) 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "USE" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO USE" );
		}
	}
	else if( nOption == CSetupItems::optionBOOL3 || nOption == CSetupItems::optionBOOL6 )	// 150915 halesu 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "CHECK" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "NO CHECK" );
		}
	}
	else if( nOption == CSetupItems::optionBOOL4 ) 
	{
		if( nValue == 1 )
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			gridCtrl.SetCellForeColor( BLACK_COLOR );
			sBuf.Format( "CW" );
		}
		else 
		{
			gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sBuf.Format( "CCW" );
		}
	}
	else
	{
		gridCtrl.SetCellBackColor( BG_COLOR );
		gridCtrl.SetCellForeColor( BG_COLOR );
		sBuf.Format( "" );
	}

	gridCtrl.SetCellAlignment( 4 );
	gridCtrl.SetText( (LPCTSTR) sBuf );
}

void CSetupTabJobConditionView::GridInit_PartsLifeTimeInfo()
{
	LPTSTR sLvcText[] = { " NAME ", " GLS NO ", " TIME " };
	int nColWidth[] = { 2800, 1000, 1040 }; 

	// initialize GridCtrl
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	
	// Main MC Parameter----------------------------------------------
	int nRows = pDoc->m_pSetupItems->m_nItemNoPartsLifeTimePara;
	if( nRows <= 3 ) nColWidth[0] += 270;

	m_gridPartsLifeTimePara.SetRows( nRows + 1 );
	m_gridPartsLifeTimePara.SetCols( 3 );

	m_gridPartsLifeTimePara.SetRow( 0 );
	for( int i = 0 ; i < 3 ; i ++ )
	{
		m_gridPartsLifeTimePara.SetColWidth( i, nColWidth[i] );
		m_gridPartsLifeTimePara.SetCol( i ); 
		m_gridPartsLifeTimePara.SetCellAlignment( 4 );
		m_gridPartsLifeTimePara.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridPartsLifeTimePara.SetText( sLvcText[i] ); 
	}
	SetDataToGridCtrl_PartsLifeTimeInfo();
}

void CSetupTabJobConditionView::SetDataToGridCtrl_PartsLifeTimeInfo()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoPartsLifeTimePara;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridPartsLifeTimePara.SetCol( 0 );
		m_gridPartsLifeTimePara.SetRow( i + 1 );
		m_gridPartsLifeTimePara.SetCellAlignment( 0 );	// Left adjusted
		m_gridPartsLifeTimePara.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_infoPartsLifeTimePara[i].sName );
		m_gridPartsLifeTimePara.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridPartsLifeTimePara.SetCol( 1 );
		m_gridPartsLifeTimePara.SetRow( i + 1 );

		// Set Text
		sBuf.Format( "%d %s", 
			pDoc->m_pSetupItems->m_nValuePartsLifeTimeParaTemp[0][i], "ea" );
		m_gridPartsLifeTimePara.SetCellAlignment( 4 );
		m_gridPartsLifeTimePara.SetText( (LPCTSTR) sBuf );

		// 3rd column
		m_gridPartsLifeTimePara.SetCol( 2 );
		m_gridPartsLifeTimePara.SetRow( i + 1 );

		// Set Text
		sBuf.Format( "%d %s", 
			pDoc->m_pSetupItems->m_nValuePartsLifeTimeParaTemp[1][i], 
			pDoc->m_pSetupItems->m_infoPartsLifeTimePara[i].sUnit );
		m_gridPartsLifeTimePara.SetCellAlignment( 4 );
		m_gridPartsLifeTimePara.SetText( (LPCTSTR) sBuf );
	}
}


BEGIN_EVENTSINK_MAP(CSetupTabJobConditionView, CFormView)
    //{{AFX_EVENTSINK_MAP(CSetupTabJobConditionView)
	ON_EVENT(CSetupTabJobConditionView, IDC_GRID_SETUP_INFO, -601 /* DblClick */, OnDblClickGridSetupInfo, VTS_NONE)
	ON_EVENT(CSetupTabJobConditionView, IDC_GRID_IDLE_RUN_INFO, -601 /* DblClick */, OnDblClickGridIdleRunInfo, VTS_NONE)
	ON_EVENT(CSetupTabJobConditionView, IDC_GRID_TANK_LEVEL_INFO, -601 /* DblClick */, OnDblClickGridTankLevelInfo, VTS_NONE)
	ON_EVENT(CSetupTabJobConditionView, IDC_GRID_PARTS_LIFETIME_PARA, -601 /* DblClick */, OnDblClickGridPartsLifeTimeInfo, VTS_NONE)
	ON_EVENT(CSetupTabJobConditionView, IDC_GRID_SETUP_INFO, -603 /* KeyPress */, OnKeyPressGridSetupInfo, VTS_PI2)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

//--------------------------------------------------------------------
// OnDblClickGridSetupInfo
//--------------------------------------------------------------------
void CSetupTabJobConditionView::OnDblClickGridSetupInfo() 
{
	int nRow = m_gridSetupInfo.GetRow();
	int nCol = m_gridSetupInfo.GetCol();

	if ( nRow == 0 ) return;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	CString sBuf;

	if( nCol == 1 && m_gridSetupInfo.GetCellBackColor() != BG_COLOR )	// Option
	{
#ifndef _MY_DEBUG
//#ifndef _NO_RB		// 20100719 ssm
		if( pDoc->m_pSetupItems->m_nValueSetup_Option[nRow - 1] != 1 &&
			pDoc->m_pDicsView->m_pDicsData->m_GenInfo.bEqpInitComp// &&
		//	( //( nRow - 1 ) == CSetupItems::setupRB_SERVO1_USE ||
			  //( nRow - 1 ) == CSetupItems::setupRB_SERVO2_USE ||
			  //( nRow - 1 ) == CSetupItems::setupRB_SERVO3_USE ||
			  //( nRow - 1 ) == CSetupItems::setupRB_SERVO4_USE ||
//			  ( nRow - 1 ) == CSetupItems::setupUSE_EUV ) 
			)
		{
			AfxMessageBox("It cannot be changed from 'NO USE' to 'USE'!! \n\n To change 'USE' mode, Restart program and initialize again");
			return;
		}
//#endif
#endif
#ifndef _NO_EUV		// 20100719 ssm
		if( pDoc->m_pSetupItems->m_nValueSetup_Option[nRow - 1] != 1 &&
			pDoc->m_pDicsView->m_pDicsData->m_GenInfo.bEqpInitComp &&
			( ( nRow - 1 ) == CSetupItems::setupUSE_EUV ) )
		{
			AfxMessageBox("It cannot be changed from 'NO USE' to 'USE'!! \n\n To change 'USE' mode, Restart program and initialize again");
			return;
		}
#endif
		pDoc->m_pSetupItems->m_nValueSetup_OptionTemp[nRow - 1] = 
			( pDoc->m_pSetupItems->m_nValueSetup_OptionTemp[nRow - 1] == 1 ) ? 0 : 1;
		SetBoolTypeValue( pDoc->m_pSetupItems->m_nValueSetup_OptionTemp[nRow - 1], 
						  pDoc->m_pSetupItems->m_infoSetup[nRow - 1].nOption, 
						  m_gridSetupInfo );
	}
	else if( nCol == 2 && m_gridSetupInfo.GetCellBackColor() != BG_COLOR )	// Value
	{
		CDlgEditVal dlg;
		dlg.m_sCurVal = dlg.m_sOldVal = pDoc->m_pSetupItems->m_sValueSetupTemp[nRow - 1];
		dlg.m_nType = CDlgEditVal::typeINPUT;
		dlg.m_nFormat = pDoc->m_pSetupItems->m_infoSetup[nRow - 1].nFormat;

		if( dlg.DoModal() == IDOK )
		{
			if ( ( nRow-1 == CSetupItems::setupMAX_GLASS_NO ) && atoi( dlg.m_sCurVal ) > MAX_EQP_GLASS_NO )
			{
				sBuf.Format( "Setting value is out of range. (1 ~ %d EA)", MAX_EQP_GLASS_NO );
				AfxMessageBox( sBuf );
			}
			else 
			{
				sBuf = dlg.m_sCurVal + " " + pDoc->m_pSetupItems->m_infoSetup[nRow - 1].sUnit;
				m_gridSetupInfo.SetText( (LPCTSTR) sBuf );

				// Set the changed value to temperary variable
				pDoc->m_pSetupItems->m_sValueSetupTemp[nRow - 1] = dlg.m_sCurVal;
			}
		}
	}
}

void CSetupTabJobConditionView::OnDblClickGridIdleRunInfo() 
{
	int nRow = m_gridIdleRunInfo.GetRow();
	int nCol = m_gridIdleRunInfo.GetCol();

	if ( nRow == 0 ) return;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	CString sBuf;

	if( pDoc->m_pSetupItems->m_infoIdleRun[nRow - 1].nOption != CSetupItems::optionNONE ) 
	{
		pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1] = 
			( pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1] == 1 ) ? 0 : 1;
		SetBoolTypeValue( pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1], 
						  pDoc->m_pSetupItems->m_infoIdleRun[nRow - 1].nOption, 
						  m_gridIdleRunInfo );
	}
	else
	{
		CDlgEditVal dlg;
		if( pDoc->m_pSetupItems->m_infoIdleRun[nRow - 1].nFormat != CSetupItems::formatFLOAT )
		{
			dlg.m_sOldVal.Format( "%d", pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1] );
		}
		else
		{
			dlg.m_sOldVal.Format( "%.1f", (float)(pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1]/10.0) );
		}
		dlg.m_sCurVal = dlg.m_sOldVal;
		dlg.m_nType = CDlgEditVal::typeINPUT;
		dlg.m_nFormat = pDoc->m_pSetupItems->m_infoIdleRun[nRow - 1].nFormat;
		if( dlg.DoModal() == IDOK )
		{
			int nVal = atoi( dlg.m_sCurVal );
			int nIndex = nRow - 1;
			if( ( nIndex >= CSetupItems::idleSWR2_UPPER_RB1_SPEED && nIndex <= CSetupItems::idleSWR3_LOWER_RB2_SPEED ) && 
				( nVal < 60 || nVal > 600 ) )
			{
				AfxMessageBox( "Setting value is out of range. (60 ~ 600 rpm)" );
				return;
			}

			// hskwak 191015 Type
//			sBuf = dlg.m_sCurVal + " " + pDoc->m_pSetupItems->m_infoIdleRun[nRow - 1].sUnit;
//			m_gridIdleRunInfo.SetText( (LPCTSTR) sBuf );

//			// Set the changed value to temperary variable
//			pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1] = atoi( dlg.m_sCurVal );

			if( pDoc->m_pSetupItems->m_infoIdleRun[nRow - 1].nFormat == CSetupItems::formatFLOAT )
			{
				sBuf.Format("%3.1f %s", atof(dlg.m_sCurVal), pDoc->m_pSetupItems->m_infoIdleRun[nRow - 1].sUnit);
				m_gridIdleRunInfo.SetText( (LPCTSTR) sBuf );

				// Set the changed value to temperary variable
				pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1] = (int)(atof( dlg.m_sCurVal )*10.0);
			}
			else
			{
				sBuf = dlg.m_sCurVal + " " + pDoc->m_pSetupItems->m_infoIdleRun[nRow - 1].sUnit;
				m_gridIdleRunInfo.SetText( (LPCTSTR) sBuf );

				// Set the changed value to temperary variable
				pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1] = atoi( dlg.m_sCurVal );
			}
		}
	}



/*  by molnic 060110
	int nRow = m_gridIdleRunInfo.GetRow();
	int nCol = m_gridIdleRunInfo.GetCol();

	if ( nRow == 0 || nCol == 0 ) return;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	CString sBuf;

	if( pDoc->m_pSetupItems->m_infoIdleRun[nRow - 1].nOption != CSetupItems::optionNONE ) 
	{
		pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1] = 
			( pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1] == 1 ) ? 0 : 1;
		SetBoolTypeValue( pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1], 
						  pDoc->m_pSetupItems->m_infoIdleRun[nRow - 1].nOption, 
						  m_gridIdleRunInfo );
	}
	else
	{
		CDlgEditVal dlg;
		int nIndex = nRow - 1;
		// ljy_050425 : Display
/ *      by molnic 060106
		if( nIndex == CSetupItems::idleUPPER_RB1_GAP || nIndex == CSetupItems::idleUPPER_RB2_GAP )
		{
			dlg.m_sOldVal.Format( "%3.1f", (float)( pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1] / 10.0 ) );
		}
		else dlg.m_sOldVal.Format( "%d", pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1] );
* /

		dlg.m_sCurVal = dlg.m_sOldVal;
		dlg.m_nType = CDlgEditVal::typeINPUT;
		dlg.m_nFormat = pDoc->m_pSetupItems->m_infoIdleRun[nRow - 1].nFormat;
		if( dlg.DoModal() == IDOK )
		{
			int nVal = atoi( dlg.m_sCurVal );
			//int nIndex = nRow - 1;
			if( ( nIndex >= CSetupItems::idleUPPER_RB1_SPEED && nIndex <= CSetupItems::idleLOWER_RB2_SPEED ) && 
				( nVal < 0 || nVal > 600 ) )	// ljy_041229 : Change Range ( 60 ~ 600 )
			{
				AfxMessageBox( "Setting value is out of range. (0 ~ 600 rpm)" );
				return;
			}
			double dVal = atof( dlg.m_sCurVal );	// ljy_050425 : Ҽ ڸ .

													/ *			by molnic 060106
			if( ( nIndex == CSetupItems::idleUPPER_RB1_GAP || nIndex == CSetupItems::idleUPPER_RB2_GAP ) &&
				( dVal < 0.0 || dVal > 2.0 ) )
			{
				AfxMessageBox( "Setting value is out of range. (0 ~ 2.0 mm)" );
				return;
			}* /

			sBuf = dlg.m_sCurVal + " " + pDoc->m_pSetupItems->m_infoIdleRun[nRow - 1].sUnit;
			m_gridIdleRunInfo.SetText( (LPCTSTR) sBuf );

			// Set the changed value to temperary variable
			//pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1] = atoi( dlg.m_sCurVal );

			// ljy_050425 : RB Gap   Ҷ 10 ϰ, Display  ٽ 10  ش.

			/ *		by molnic 060106
			if( nIndex == CSetupItems::idleUPPER_RB1_GAP || nIndex == CSetupItems::idleUPPER_RB2_GAP )
				{
					pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1] = (int)( 10 * atof( dlg.m_sCurVal ) );
				}
				else
				{
					pDoc->m_pSetupItems->m_nValueIdleRunTemp[nRow - 1] = atoi( dlg.m_sCurVal );
				}* /
	
		}
	}*/

}

// ljy_050220 : CSetupTabJobConditionView -> 04HC30   Ϸ(1).

void CSetupTabJobConditionView::OnDblClickGridTankLevelInfo() 
{
	int nRow = m_gridTankLevelInfo.GetRow();
	int nCol = m_gridTankLevelInfo.GetCol();

	if ( nRow == 0 ) return;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	CString sBuf;

	CDlgEditVal dlg;
	dlg.m_sOldVal.Format( "%d", pDoc->m_pSetupItems->m_nValueTankLevelTemp[nRow - 1] );
	dlg.m_sCurVal = dlg.m_sOldVal;
	dlg.m_nType = CDlgEditVal::typeINPUT;
	dlg.m_nFormat = CSetupItems::formatDIGIT;
	if( dlg.DoModal() == IDOK )
	{
		int nVal = atoi( dlg.m_sCurVal );
		int nIndex = nRow - 1;
/*
		if( ( nIndex >= CSetupItems::idleUPPER_RB11_SPEED && nIndex <= CSetupItems::idleLOWER_RB32_SPEED ) && 
			( nVal < 60 || nVal > 600 ) )
		{
			AfxMessageBox( "Setting value is out of range. (60 ~ 600 rpm)" );
			return;
		}
*/
		sBuf = dlg.m_sCurVal + " " + "L";
		m_gridTankLevelInfo.SetText( (LPCTSTR) sBuf );

		// Set the changed value to temperary variable
		pDoc->m_pSetupItems->m_nValueTankLevelTemp[nRow - 1] = atoi( dlg.m_sCurVal );
	}
}

void CSetupTabJobConditionView::OnDblClickGridPartsLifeTimeInfo() 
{
	int nRow = m_gridPartsLifeTimePara.GetRow();
	int nCol = m_gridPartsLifeTimePara.GetCol();

	if ( nRow == 0 ) return;
	if ( nCol == 0 ) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	CDlgEditVal dlg;
	dlg.m_sOldVal.Format( "%d", pDoc->m_pSetupItems->m_nValuePartsLifeTimeParaTemp[nCol - 1][nRow - 1] );
	dlg.m_sCurVal = dlg.m_sOldVal;
	dlg.m_nType = CDlgEditVal::typeINPUT;
	dlg.m_nFormat = pDoc->m_pSetupItems->m_infoPartsLifeTimePara[nRow - 1].nFormat;
	if( dlg.DoModal() == IDOK )
	{
		// Set the changed value to temperary variable
		pDoc->m_pSetupItems->m_nValuePartsLifeTimeParaTemp[nCol - 1][nRow - 1] = atoi( dlg.m_sCurVal );

		CString sBuf;
		if( nCol <= 1 ) sBuf.Format( "%s %s", dlg.m_sCurVal, "ea" );
		else	sBuf.Format( "%s %s", dlg.m_sCurVal, pDoc->m_pSetupItems->m_infoPartsLifeTimePara[nRow - 1].sUnit );
		m_gridPartsLifeTimePara.SetText( (LPCTSTR) sBuf );
	}
}

void CSetupTabJobConditionView::OnKeyPressGridSetupInfo(short FAR* KeyAscii) 
{
	// TODO: Add your control notification handler code here
	if( *KeyAscii == ' ' ) 
		OnDblClickGridSetupInfo();
}

BOOL CSetupTabJobConditionView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
#define MAX_ID	4
	DWORD dw;
	if(zDelta <=0)	dw = SB_LINEDOWN;
	else			dw = SB_LINEUP;

	CRect rect;
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	int nID[MAX_ID] = { IDC_GRID_SETUP_INFO, IDC_GRID_IDLE_RUN_INFO, IDC_GRID_TANK_LEVEL_INFO, IDC_GRID_PARTS_LIFETIME_PARA };
	int i;
	for( i=0; i<MAX_ID; i++)
	{
		if(((CMSFlexGrid*)GetDlgItem( nID[i] ))->GetRows() <= 8) continue;

		GetDlgItem( nID[i] )->GetWindowRect( &rect );

		if(rect.left < pt.x && pt.x < rect.right && rect.top < pt.y && pt.y < rect.bottom)
		{
			GetDlgItem(nID[i])->SendMessage(WM_VSCROLL, dw, 0);
		}
	}
	return CFormView::OnMouseWheel(nFlags, zDelta, pt);
}
