// SetupView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "SetupView.h"
#include "..\X\XLog.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupView

IMPLEMENT_DYNCREATE(CSetupView, CFormView)

CSetupView::CSetupView()
	: CFormView(CSetupView::IDD)
{
	//{{AFX_DATA_INIT(CSetupView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_pTabSetupTabJobConditionView	= NULL;
	m_pTabSetupTabInterlockSetView	= NULL;
	m_pTabSetupTabInterlockSet2View	= NULL;
	m_pTabSetupTabCVDistanceSetView	= NULL;
//	m_pTabSetupTabCVMotorParaView	= NULL;
	m_pTabSetupTabInterfaceParaView = NULL;
	m_pTabSetupTabInterfaceParaView1 = NULL;
//	m_pTabSetupTabDVParaView		= NULL;
	m_nViewNo			= 0;
}

CSetupView::~CSetupView()
{
	GetDocument()->m_pSetupWnd = NULL;
}

void CSetupView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupView)
	DDX_Control(pDX, IDC_TAB_SETUP, m_tabCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupView, CFormView)
	//{{AFX_MSG_MAP(CSetupView)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_MESSAGE( WM_SEL_CHANGE_TAB, OnSelChangeTab )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupView diagnostics

#ifdef _DEBUG
void CSetupView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSetupView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CDicsDoc* CSetupView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDicsDoc)));
	return (CDicsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSetupView message handlers

void CSetupView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Set the current view pointer
	GetDocument()->SetSetupView( this );
	
	// Create the TAB view 
	CRect r;
	GetDlgItem( IDC_TAB_SETUP )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 0, 0, 6, 30 );

	m_pTabSetupTabJobConditionView = new CSetupTabJobConditionView( this );
	CCreateContext context;
	m_pTabSetupTabJobConditionView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CSetupTabJobConditionView::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabSetupTabJobConditionView, "    JOB COND   ", viewJobCond );
	m_pTabSetupTabJobConditionView->SetFocus();

	m_pTabSetupTabInterlockSetView = new CSetupTabInterlockSetView( this );
	m_pTabSetupTabInterlockSetView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CSetupTabInterlockSetView::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabSetupTabInterlockSetView, "    INTERLOCK SET   ", viewInterlockSet );

	m_pTabSetupTabInterlockSet2View = new CSetupTabInterlockSet2View( this );
	m_pTabSetupTabInterlockSet2View->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CSetupTabInterlockSet2View::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabSetupTabInterlockSet2View, "    INTERLOCK SET2    ", viewInterlockSet2 );

	m_pTabSetupTabInterfaceParaView = new CSetupTabInterfaceParaView( this );
	m_pTabSetupTabInterfaceParaView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CSetupTabInterfaceParaView::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabSetupTabInterfaceParaView, "    HSMS PARA    ", viewInterfacePara );

	m_pTabSetupTabInterfaceParaView1 = new CSetupTabInterfaceParaView1( this );
	m_pTabSetupTabInterfaceParaView1->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CSetupTabInterfaceParaView1::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabSetupTabInterfaceParaView1, "    HSMS1 PARA    ", viewInterfacePara1 );

	m_pTabSetupTabCVDistanceSetView = new CSetupTabCVDistanceSetView( this );
	m_pTabSetupTabCVDistanceSetView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CSetupTabCVDistanceSetView::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabSetupTabCVDistanceSetView, "    CV DISTANCE SET   ", viewCVDistanceSet );
/*
	m_pTabSetupTabCVMotorParaView = new CSetupTabCVMotorParaView( this );
	m_pTabSetupTabCVMotorParaView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CSetupTabCVMotorParaView::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabSetupTabCVMotorParaView, "    C/V MOTOR PARA   ", viewCVMotorPara );

	m_pTabSetupTabDVParaView = new CSetupTabDVParaView( this );
	m_pTabSetupTabDVParaView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CSetupTabDVParaView::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabSetupTabDVParaView, "    EQP DV PARA   ", viewDVPara );
*/
	m_tabCtrl.SetSelectedColor( RED_COLOR );
	m_tabCtrl.SetMouseOverColor( GREEN_COLOR );
	m_tabCtrl.SetNormalColor( DARK_GRAY_COLOR );
}

void CSetupView::OnDestroy() 
{
	CFormView::OnDestroy();
	
	if( m_pTabSetupTabJobConditionView ) 
	{
		m_pTabSetupTabJobConditionView->SendMessage( WM_CLOSE );
		delete m_pTabSetupTabJobConditionView;
	}

	if( m_pTabSetupTabInterlockSetView ) 
	{
		m_pTabSetupTabInterlockSetView->SendMessage( WM_CLOSE );
		delete m_pTabSetupTabInterlockSetView;
	}

	if( m_pTabSetupTabInterlockSet2View ) 
	{
		m_pTabSetupTabInterlockSet2View->SendMessage( WM_CLOSE );
		delete m_pTabSetupTabInterlockSet2View;
	}

	if( m_pTabSetupTabInterfaceParaView ) 
	{
		m_pTabSetupTabInterfaceParaView->SendMessage( WM_CLOSE );
		delete m_pTabSetupTabInterfaceParaView;
	}
	if( m_pTabSetupTabInterfaceParaView1 ) 
	{
		m_pTabSetupTabInterfaceParaView1->SendMessage( WM_CLOSE );
		delete m_pTabSetupTabInterfaceParaView1;
	}
	if( m_pTabSetupTabCVDistanceSetView ) 
	{
		m_pTabSetupTabCVDistanceSetView->SendMessage( WM_CLOSE );
		delete m_pTabSetupTabCVDistanceSetView;
	}
/*
	if( m_pTabSetupTabCVMotorParaView ) 
	{
		m_pTabSetupTabCVMotorParaView->SendMessage( WM_CLOSE );
		delete m_pTabSetupTabCVMotorParaView;
	}

	if( m_pTabSetupTabDVParaView ) 
	{
		m_pTabSetupTabDVParaView->SendMessage( WM_CLOSE );
		delete m_pTabSetupTabDVParaView;
	}
*/
}

//---------------------------------------------------------------------------
// Tab selection is changed
//---------------------------------------------------------------------------
LRESULT CSetupView::OnSelChangeTab( WPARAM wParam, LPARAM lParam )
{
	m_nViewNo = wParam;

	if( m_nViewNo == 0 )		m_pTabSetupTabJobConditionView->SetFocus();
	else if( m_nViewNo == 1 )	m_pTabSetupTabInterlockSetView->SetFocus();
	else if( m_nViewNo == 2 )	m_pTabSetupTabInterlockSet2View->SetFocus();
	else if( m_nViewNo == 3 )	m_pTabSetupTabInterfaceParaView->SetFocus();
	else if( m_nViewNo == 4 )	m_pTabSetupTabInterfaceParaView1->SetFocus();
	else if( m_nViewNo == 5 )	m_pTabSetupTabCVDistanceSetView->SetFocus();
	return 0;
}

//---------------------------------------------------------------------------
// OnSetupSave
//---------------------------------------------------------------------------
void CSetupView::OnSetupSave(BOOL bAllSave)
{
	CDicsDoc* pDoc = GetDocument();

	if( bAllSave )
	{
		if( pDoc->m_pSetupItems->IsSetupChangedTabJobCondView() ) 
		{
			pDoc->m_pSetupItems->SetRegistryTabJobCondView();

			// display the main view also (Setup Info)
			pDoc->m_pDicsView->m_pTabJobsMainView->SetDataToGridCtrl_SetupInfo();
		}
		if( pDoc->m_pSetupItems->IsSetupChangedTabInterlockSetView() ) pDoc->m_pSetupItems->SetRegistryTabInterlockSetView();
		if( pDoc->m_pSetupItems->IsSetupChangedTabInterlockSet2View() ) pDoc->m_pSetupItems->SetRegistryTabInterlockSet2View();
		if( pDoc->m_pSetupItems->IsSetupChangedTabInterfaceParaView() ) pDoc->m_pSetupItems->SetRegistryTabInterfaceParaView();
		if( pDoc->m_pSetupItems->IsSetupChangedTabInterfaceParaView1() ) pDoc->m_pSetupItems->SetRegistryTabInterfaceParaView1();
		if( pDoc->m_pSetupItems->IsSetupChangedTabCVDistanceSetView() ) pDoc->m_pSetupItems->SetRegistryTabCVDistanceSetView();
//		if( pDoc->m_pSetupItems->IsSetupChangedTabCVMotorParaView() ) pDoc->m_pSetupItems->SetRegistryTabCVMotorParaView();	// 20100629 ssm
//		if( pDoc->m_pSetupItems->IsSetupChangedTabDVParaView() ) pDoc->m_pSetupItems->SetRegistryTabDVParaView();		// 20100629 ssm
	}
	else
	{
		if( m_nViewNo == viewJobCond )	// Setup Info Tab View (TAB1)
		{
			if( !pDoc->m_pSetupItems->IsSetupChangedTabJobCondView() ) return;
			if( AfxMessageBox( "Do you really want to save the setup information value ?", MB_YESNO ) == IDNO ) return;
			pDoc->m_pSetupItems->SetRegistryTabJobCondView();
			
			// display the main view also (Setup Info)
			pDoc->m_pDicsView->m_pTabJobsMainView->SetDataToGridCtrl_SetupInfo();
			pDoc->m_pDicsView->m_pDicsData->m_GenInfo.nMaxEqpGlassNo = atoi( pDoc->m_pSetupItems->m_sValueSetup[CSetupItems::setupMAX_GLASS_NO] );
		}
		else if( m_nViewNo == viewInterlockSet )	// Interlock Tab View (TAB2)
		{
			if( !pDoc->m_pSetupItems->IsSetupChangedTabInterlockSetView() ) return;
			if( AfxMessageBox( "Do you really want to save the interlock value ?", MB_YESNO ) == IDNO ) return;
			pDoc->m_pSetupItems->SetRegistryTabInterlockSetView();
		}
		else if( m_nViewNo == viewInterlockSet2 )	// Interlock2 Tab View (TAB3)
		{
			if( !pDoc->m_pSetupItems->IsSetupChangedTabInterlockSet2View() ) return;
			if( AfxMessageBox( "Do you really want to save the interlock2 value ?", MB_YESNO ) == IDNO ) return;
			pDoc->m_pSetupItems->SetRegistryTabInterlockSet2View();
		}
		else if( m_nViewNo == viewInterfacePara )	// Interface para (TAB4)
		{
			if( !pDoc->m_pSetupItems->IsSetupChangedTabInterfaceParaView() ) return;
			if( AfxMessageBox( "Do you really want to save the Interface Para value ?", MB_YESNO ) == IDNO ) return;
			pDoc->m_pSetupItems->SetRegistryTabInterfaceParaView();

			// Update the old values
			m_pTabSetupTabInterfaceParaView->SetDataToGridCtrl();

			pDoc->m_pDicsView->m_pDicsData->m_IfCim.bMelsecParaChangeReq = TRUE;
		}
		else if( m_nViewNo == viewInterfacePara1 )	// Interface para
		{
			if( !pDoc->m_pSetupItems->IsSetupChangedTabInterfaceParaView1() ) return;
			if( AfxMessageBox( "Do you really want to save the Interface Para value ?", MB_YESNO ) == IDNO ) return;
			pDoc->m_pSetupItems->SetRegistryTabInterfaceParaView1();

		}
		else if( m_nViewNo == viewCVDistanceSet )	// C/V Distance Tab View (TAB5)
		{
			if( !pDoc->m_pSetupItems->IsSetupChangedTabCVDistanceSetView() ) return;
			if( AfxMessageBox( "Do you really want to save the CV Distance value ?", MB_YESNO ) == IDNO ) return;
			pDoc->m_pSetupItems->SetRegistryTabCVDistanceSetView();

			// Update the old values
			m_pTabSetupTabCVDistanceSetView->SetDataToGridCtrl();
		}
/*		else if( m_nViewNo == viewCVMotorPara )	// C/V MOTOR PARA VIEW (TAB5)
		{
			if( !pDoc->m_pSetupItems->IsSetupChangedTabCVMotorParaView() ) return;
			if( AfxMessageBox( "Do you really want to save the C/V motor parameter value ?", MB_YESNO ) == IDNO ) return;
			pDoc->m_pSetupItems->SetRegistryTabCVMotorParaView();
			m_pTabSetupTabCVMotorParaView->SetDataToGridCtrl();
		}
		else if( m_nViewNo == viewDVPara )	// DV PARA VIEW (TAB5)	// 20100629 ssm
		{
 			if( !pDoc->m_pSetupItems->IsSetupChangedTabDVParaView() ) return;
			if( AfxMessageBox( "Do you really want to save the DV parameter value ?", MB_YESNO ) == IDNO ) return;
			pDoc->m_pSetupItems->SetRegistryTabDVParaView();
			m_pTabSetupTabDVParaView->SetDataToGridCtrl_DV();
		}
*/
	}
	SaveReport();
}

//---------------------------------------------------------------------------
// OnSetupView
//---------------------------------------------------------------------------
void CSetupView::OnSetupView(WPARAM wParam, LPARAM lParam)
{
	CDicsDoc* pDoc = GetDocument();

	if( wParam ) 
	{
		// Set color to original it.
		for( int i=0; i<pDoc->m_pSetupItems->m_nItemNoCvLength; i++ )
		{
			m_pTabSetupTabCVDistanceSetView->m_gridCvLength.SetRow( i + 1 );
			m_pTabSetupTabCVDistanceSetView->m_gridCvLength.SetCol( 2 );
			m_pTabSetupTabCVDistanceSetView->m_gridCvLength.SetCellBackColor( WHITE_COLOR );
		}

		m_pTabSetupTabCVDistanceSetView->SetDataToGridCtrl();

		if( pDoc->m_pSetupItems->m_bCalCancel )
		{
			m_pTabSetupTabCVDistanceSetView->m_msgComment.SetOpMsg( "On calibration ... Cancel" );
			pDoc->m_pSetupItems->m_bCalCancel = FALSE;
		}
		else m_pTabSetupTabCVDistanceSetView->m_msgComment.SetOpMsg( "Ends calibration" );
		
		m_pTabSetupTabCVDistanceSetView->GetDlgItem( IDC_STOP )->EnableWindow( FALSE );
		m_pTabSetupTabCVDistanceSetView->GetDlgItem( IDC_START )->EnableWindow( TRUE );
		m_pTabSetupTabCVDistanceSetView->GetDlgItem( IDC_COMBO_CV_SPEED )->EnableWindow( TRUE );
	}
	else
	{
		m_pTabSetupTabCVDistanceSetView->m_gridCvLength.SetRow( (int) lParam );
		m_pTabSetupTabCVDistanceSetView->m_gridCvLength.SetCol( 2 );
		m_pTabSetupTabCVDistanceSetView->m_gridCvLength.SetCellBackColor( YELLOW_COLOR );

		m_pTabSetupTabCVDistanceSetView->SetDataToGridCtrl();
	}
}

void CSetupView::SaveReport()
{
	CDicsDoc* pDoc = GetDocument();
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;
	CString sBuf;
//////////////////////JOB COND////////////////////////////////////////////////////
	//Job cond setting status
	int nEa = pDoc->m_pSetupItems->m_nItemNoSetup;
	int i;
	for( i = 0; i < nEa; i++)
	{
		if( pDoc->m_pSetupItems->m_infoSetup[i].sUnit == "NONE" )
		sBuf.Format( "%s: %d", pDoc->m_pSetupItems->m_infoSetup[i].sName,pDoc->m_pSetupItems->m_nValueSetup_OptionTemp[i]);
		else 
		sBuf.Format( "%s: %s", pDoc->m_pSetupItems->m_infoSetup[i].sName,
							   pDoc->m_pSetupItems->m_sValueSetup[i] + " " + pDoc->m_pSetupItems->m_infoSetup[i].sUnit);
		SetLog( "JOB COND   ", sBuf );
	}

/////////////////////INTERLOCK1/////////////////////////////////////////////////////
	//Gauge interlock setting status
	nEa = m_pTabSetupTabInterlockSetView->m_pEqpAssy->m_AnalogInput.GetAiSize();
	for( i = 0; i < nEa - 1; i++)
	{
		int nIntrNo = m_pTabSetupTabInterlockSetView->m_pEqpAssy->m_AnalogInput.m_aiSet[i].nAiIntrNo;
		sBuf.Format( "%s: %d==>%d %d %d %d", m_pTabSetupTabInterlockSetView->m_pEqpAssy->m_AnalogInput.m_aiSet[i].sName ,
								  pDoc->m_pSetupItems->m_nValueGaugeLimit_OptionTemp[nIntrNo],
								  pDoc->m_pSetupItems->m_nValueGaugeLimitTemp[0][nIntrNo],
								  pDoc->m_pSetupItems->m_nValueGaugeLimitTemp[1][nIntrNo],
								  pDoc->m_pSetupItems->m_nValueGaugeLimitTemp[2][nIntrNo],
								  pDoc->m_pSetupItems->m_nValueGaugeLimitTemp[3][nIntrNo]);
		SetLog( "INTERLOCK   ", sBuf );
	}
/////////////////////INTERLOCK2/////////////////////////////////////////////////////
	//door interlock setting status
	nEa = pDoc->m_pSetupItems->m_nItemNoDoorIntr;
	for(  i = 0; i < nEa; i++)
	{
		sBuf.Format( "%s: %d", pDoc->m_pSetupItems->m_sItemDoorIntr[i],pDoc->m_pSetupItems->m_nValueDoorIntrTemp[i] );
		SetLog( "INTERLOCK2   ", sBuf );
	}

	//Bath interlock setting status
	nEa = pDoc->m_pSetupItems->m_nItemNoBathCoverIntr;
	for( i = 0; i < nEa; i++)
	{
		sBuf.Format( "%s: %d", pDoc->m_pSetupItems->m_sItemBathCoverIntr[i],pDoc->m_pSetupItems->m_nValueBathCoverIntrTemp[i] );
		SetLog( "INTERLOCK2   ", sBuf );
	}

	//Leak interlock setting status
	nEa = pDoc->m_pSetupItems->m_nItemNoLeakDetectIntr;
	for( i = 0; i < nEa; i++)
	{
		sBuf.Format( "%s: %d", pDoc->m_pSetupItems->m_sItemLeakDetectIntr[i],pDoc->m_pSetupItems->m_nValueLeakDetectIntrTemp[i] );
		SetLog( "INTERLOCK2   ", sBuf );
	}

	//FFU interlock setting status
	nEa = pDoc->m_pSetupItems->m_nItemNoFFUAlarmIntr;
	for( i = 0; i < nEa; i++)
	{
		sBuf.Format( "%s: %d", pDoc->m_pSetupItems->m_sItemFFUAlarmIntr[i],pDoc->m_pSetupItems->m_nValueFFUAlarmIntrTemp[i] );
		SetLog( "INTERLOCK2   ", sBuf );
	}

	//Etc interlock setting status
	nEa = pDoc->m_pSetupItems->m_nItemNoETCIntr;
	for( i = 0; i < nEa; i++)
	{
		sBuf.Format( "%s: %d", pDoc->m_pSetupItems->m_sItemETCIntr[i],pDoc->m_pSetupItems->m_nValueETCIntrTemp[i] );
		SetLog( "INTERLOCK2   ", sBuf );
	}
}

void CSetupView::SetLog(CString sSeqName, CString sMessage)
{
	CString sLog;
	sLog.Format( "SETUPVIEW \t%s\t%s\t%s\t%s", sSeqName, "0", "0", sMessage );
	Log.TextOut( sLog );
}