// SystemTab2View.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "SystemTab2View.h"
#include "SystemView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSystemTab2View

IMPLEMENT_DYNCREATE(CSystemTab2View, CFormView)

CSystemTab2View::CSystemTab2View()
	: CFormView(CSystemTab2View::IDD)
{
	//{{AFX_DATA_INIT(CSystemTab2View)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CSystemTab2View::CSystemTab2View(CView* pView)
	: CFormView(CSystemTab2View::IDD)
{
	m_pView = pView;
}

CSystemTab2View::~CSystemTab2View()
{
}

void CSystemTab2View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSystemTab2View)
	DDX_Control(pDX, IDC_GRID_OUTCHECK_LIST, m_gridCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSystemTab2View, CFormView)
	//{{AFX_MSG_MAP(CSystemTab2View)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_WM_MOUSEWHEEL()
	ON_WM_TIMER()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSystemTab2View diagnostics

#ifdef _DEBUG
void CSystemTab2View::AssertValid() const
{
	CFormView::AssertValid();
}

void CSystemTab2View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSystemTab2View message handlers

BOOL CSystemTab2View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CSystemTab2View::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	m_pDevice =	((CSystemView*) m_pView)->m_pDevice;
//	m_bPermitAccess  = ( (CDicsView*) m_pView)->GetDocument()->m_bPermitAccess;

	CRect r;
	CString sMessage;
	GetDlgItem( IDC_IO_OUT_NOTE )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgNote.Create( 500, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_IO_OUT_NOTE,
			WHITE, BLUE_COLOR, 18, TRUE );
	sMessage.Format( " " );
	m_msgNote.SetAlign( CMsgBox::alignLEFT );
	m_msgNote.SetOpMsg( sMessage );	

	GetDlgItem( IDC_NOTE_STATIC )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgNoteStatic.Create( 101, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_NOTE_STATIC,
			LIGHT_YELLOW_COLOR, BLUE_COLOR, 18, TRUE );
	m_msgNoteStatic.SetOpMsg( " " );


	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView * pView = ( (CDicsView*)pApp->m_pMainView );
	m_nMaxOutNo = pView->m_Do.GetChannelSize();
	GridInit();
	SetTimer(TIMER_IO_DO, 100, NULL);
}

void CSystemTab2View::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	KillTimer( TIMER_IO_DO );
	CFormView::OnClose();
}

BEGIN_EVENTSINK_MAP(CSystemTab2View, CFormView)
    //{{AFX_EVENTSINK_MAP(CSystemTab2View)
	ON_EVENT(CSystemTab2View, IDC_GRID_OUTCHECK_LIST, -600 /* Click */, OnClickOutcheckList, VTS_NONE)
	ON_EVENT(CSystemTab2View, IDC_GRID_OUTCHECK_LIST, -601 /* DblClick */, OnDblClickOutcheckList, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

//--------------------------------------------------------------------
// Initialize the GridCtrl
//--------------------------------------------------------------------
void CSystemTab2View::GridInit()
{
	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	CDicsView* pView = (CDicsView*)pApp->m_pMainView;
	CDicsDoc* pDoc = (CDicsDoc*)( m_pView->GetDocument() );
	LPTSTR sLvcText[] = { " NO.", " Wire No.", " Description", " STATUS", "" };
	int COLWIDTH[] = { 1000, 1500, 8450, 2450, 0 }; 

	if ( ((CSystemView*) m_pView)->m_nNameOrDesc == CSystemView::showNAME ) m_msgNoteStatic.SetOpMsg( "Description" );
	else m_msgNoteStatic.SetOpMsg( "I/O Name" );

	if( pDoc->m_pDicsView->m_pDicsData->m_LoginInfo.nCurUserLevel == CDicsData::idADMIN )
	{
		sLvcText[4] = "REPEAT";
		COLWIDTH[3] = 1225; 
		COLWIDTH[4] = 1225; 
	}
	if ( ((CSystemView*) m_pView)->m_nNameOrDesc == CSystemView::showNAME ) sLvcText[2] = " I/O Name";

	// initialize GridCtrl
	m_gridCtrl.SetRows( m_nMaxOutNo + 1 ); 
	m_gridCtrl.SetCols( 5 );

	//-------------------------------------------
	m_gridCtrl.SetRow(0);  
	m_gridCtrl.SetColWidth(0,COLWIDTH[0]);
	m_gridCtrl.SetCol(0); 
	m_gridCtrl.SetCellAlignment(4);
	m_gridCtrl.SetCellBackColor(LIGHT_BLUE_COLOR);
	m_gridCtrl.SetText(sLvcText[0]); 
	//---------------------------------------------
	m_gridCtrl.SetColWidth(1,COLWIDTH[1]);
	m_gridCtrl.SetCol(1); 
	m_gridCtrl.SetCellAlignment(4);
	m_gridCtrl.SetCellBackColor(LIGHT_BLUE_COLOR);
	m_gridCtrl.SetText(sLvcText[1]); 
	//---------------------------------------------
	m_gridCtrl.SetColWidth(2,COLWIDTH[2]);
	m_gridCtrl.SetCol(2); 
	m_gridCtrl.SetCellAlignment(4);
	m_gridCtrl.SetCellBackColor(LIGHT_BLUE_COLOR);
	m_gridCtrl.SetText(sLvcText[2]); 
	//---------------------------------------------
	m_gridCtrl.SetColWidth(3,COLWIDTH[3]);
	m_gridCtrl.SetCol(3); 
	m_gridCtrl.SetCellAlignment(4);
	m_gridCtrl.SetCellBackColor(LIGHT_BLUE_COLOR);
	m_gridCtrl.SetText(sLvcText[3]);
	//---------------------------------------------	Virtual
	m_gridCtrl.SetColWidth(4,COLWIDTH[4]);
	m_gridCtrl.SetCol(4); 
	m_gridCtrl.SetCellAlignment(4);
	m_gridCtrl.SetCellBackColor(LIGHT_BLUE_COLOR);
	m_gridCtrl.SetText(sLvcText[4]);

	SetDataToGridCtrl();
	m_bRepeat = FALSE;
}

//--------------------------------------------------------------------
// Set data
//--------------------------------------------------------------------
void CSystemTab2View::SetDataToGridCtrl()
{
/*
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*)(m_pView->GetDocument());

	for( int nRow=1; nRow<m_nMaxOutNo+1; nRow++ )
	{
		CIOItem* pItem;
		pItem = ( (CSystemView*) m_pView )->GetIOItem( "do", nRow-1 );

		// 1. I/O Number
		m_gridCtrl.SetCol( 0 );
		m_gridCtrl.SetRow( nRow );
		m_gridCtrl.SetCellAlignment( 4 );
		m_gridCtrl.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d",  pItem->m_nIoNo );
		m_gridCtrl.SetText( (LPCTSTR) sBuf );

		// 2. Wire Number
		m_gridCtrl.SetCol( 1 );
		m_gridCtrl.SetRow( nRow );
		sBuf.Format( "%s",  pItem->m_sWireNo );
		if( sBuf == "NULL" || sBuf == "") m_gridCtrl.SetCellBackColor( YELLOW_COLOR );
		m_gridCtrl.SetText( (LPCTSTR) sBuf );
		m_gridCtrl.SetCellAlignment( 4 );

		// 3. Comment
		m_gridCtrl.SetCol( 2 );
		m_gridCtrl.SetRow( nRow );

		if ( ((CSystemView*) m_pView)->m_nNameOrDesc == CSystemView::showNAME )
			sBuf.Format(" %s", pItem->m_sName );
		else sBuf.Format(" %s", pItem->m_sDesc );

		if( sBuf == "Not defined" ) m_gridCtrl.SetCellBackColor( YELLOW_COLOR );
		m_gridCtrl.SetText( (LPCTSTR) sBuf );

		// 4. I/O State : Get I/O state
		m_gridCtrl.SetCol( 3 );
		m_gridCtrl.SetRow( nRow );
		if( DioOutputState(pItem->m_nIoNo) )
		{
			sBuf = "ON";
			m_gridCtrl.SetCellBackColor( GREEN_COLOR );
			m_gridCtrl.SetCellForeColor( BLACK_COLOR );
		}
		else
		{
			sBuf = "OFF";
			m_gridCtrl.SetCellBackColor( WHITE_COLOR );
			m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
		}
		m_gridCtrl.SetText( (LPCTSTR) sBuf );
		m_gridCtrl.SetCellAlignment( 4 );

		// 5. ID
		m_gridCtrl.SetCol( 4 );
		m_gridCtrl.SetRow( nRow );
//		sBuf.Format("%ld", m_pSetPo->m_ID );
//		m_gridCtrl.SetText( (LPCTSTR) sBuf );
	}
*/
	
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView * pView = ( (CDicsView*)pApp->m_pMainView );
	CString sBuf;

	int nSize = pView->m_Do.GetChannelSize();
	
	for( int nRow = 0; nRow < nSize ; nRow++ )
	{
		// 1. I/O Number
		m_gridCtrl.SetCol( 0 );
		m_gridCtrl.SetRow( nRow + 1 );
		m_gridCtrl.SetCellAlignment( 4 );
		m_gridCtrl.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d", pView->m_Do.m_pDo[nRow].GetAddress() );
		m_gridCtrl.SetText( (LPCTSTR) sBuf );

		// 2. Wire Number
		m_gridCtrl.SetCol( 1 );
		m_gridCtrl.SetRow( nRow + 1);
		sBuf.Format( "%s",  pView->m_Do.m_pDo[nRow].GetWiringNo( "Y" ) );
		if( sBuf == "NULL" || sBuf == "" ) m_gridCtrl.SetCellBackColor( YELLOW_COLOR );
		m_gridCtrl.SetText( (LPCTSTR) sBuf );
		m_gridCtrl.SetCellAlignment( 4 );

		// 3. Comment
		m_gridCtrl.SetCol( 2 );
		m_gridCtrl.SetRow( nRow + 1 );

		if ( ((CSystemView*) m_pView)->m_nNameOrDesc == CSystemView::showNAME )
			sBuf.Format(" %s", pView->m_Do.m_pDo[nRow].GetName() );
		else sBuf.Format(" %s", pView->m_Do.m_pDo[nRow].GetName() );

		if( sBuf == "Not defined" ) m_gridCtrl.SetCellBackColor( YELLOW_COLOR );
		m_gridCtrl.SetText( (LPCTSTR) sBuf );

		// 4. I/O State : Get I/O state
		m_gridCtrl.SetCol( 3 );
		m_gridCtrl.SetRow( nRow + 1 );
		if( pView->m_Do.m_pDo[nRow].Get() )
		{
			sBuf = "ON";
			m_gridCtrl.SetCellBackColor( GREEN_COLOR );
			m_gridCtrl.SetCellForeColor( BLACK_COLOR );
		}
		else
		{
			sBuf = "OFF";
			m_gridCtrl.SetCellBackColor( WHITE_COLOR );
			m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
		}
		m_gridCtrl.SetText( (LPCTSTR) sBuf );
		m_gridCtrl.SetCellAlignment( 4 );

		// 5. ID
		m_gridCtrl.SetCol( 4 );
		m_gridCtrl.SetRow( nRow + 1 );

//		sBuf.Format("%ld", m_pSetPi->m_ID );
//		m_gridCtrl.SetText( (LPCTSTR) sBuf );
	}

}

//--------------------------------------------------------------------
// Message Handler : OnClickOutcheckList
//--------------------------------------------------------------------
void CSystemTab2View::OnClickOutcheckList() 
{
	int nRow = m_gridCtrl.GetRowSel();

	if ( nRow == 0) return;

	CString sBuf;
	CDicsDoc* pDoc = (CDicsDoc*)(m_pView->GetDocument());
	CIOItem* pItem = ((CSystemView*) m_pView)->GetIOItem( "do", nRow - 1 );

	if ( ((CSystemView*) m_pView)->m_nNameOrDesc == CSystemView::showNAME )
		sBuf.Format( "%s",  pItem->m_sDesc );
	else sBuf.Format( "%s",  pItem->m_sName );

	m_msgNote.SetOpMsg( sBuf );
}

//--------------------------------------------------------------------
// Message Handler : OnDblClickOutcheckList
//--------------------------------------------------------------------
void CSystemTab2View::OnDblClickOutcheckList() 
{
	// TODO: Add your control notification handler code here
	int nRow = m_gridCtrl.GetRowSel();
	int y = nRow;

	int nCol = m_gridCtrl.GetColSel();
	
	if( nCol != 4 )
	{
		m_gridCtrl.SetRow( y );
		m_gridCtrl.SetCol( 3 );

		CString str = m_gridCtrl.GetText();

		CDicsApp * pApp = (CDicsApp*) AfxGetApp();
		CDicsView * pView = ( (CDicsView*)pApp->m_pMainView );

		if( str != "" )
		{
			BOOL state = pView->m_Do.m_pDo[y-1].Get();
			if( state ) pView->m_Do.m_pDo[y-1].Set( FALSE );
			else pView->m_Do.m_pDo[y-1].Set( TRUE );

			if( state )
			{	
				m_gridCtrl.SetCellBackColor( WHITE_COLOR );
				m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
				str = "OFF";
			}
			else
			{
				m_gridCtrl.SetCellBackColor( GREEN_COLOR );
				m_gridCtrl.SetCellForeColor( BLACK_COLOR );
				str = "ON";
			}

			m_gridCtrl.SetRow( y );
			m_gridCtrl.SetCol( 3 );
			m_gridCtrl.SetText( str );
			m_gridCtrl.SetCellAlignment( 4 );
		}
	}
	else if( nRow != 0 && m_bRepeat == FALSE )
	{
		CString str = m_gridCtrl.GetText();

		if( str == "" )
		{
			m_gridCtrl.SetCellBackColor( GREEN_COLOR );
			m_gridCtrl.SetCellForeColor( BLACK_COLOR );
			str = "Repeat";
			m_gridCtrl.SetText( str );
			m_gridCtrl.SetCellAlignment( 4 );
		}
		else
		{
			m_gridCtrl.SetCellBackColor( WHITE_COLOR );
			m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			str = "";
			m_gridCtrl.SetText( str );
			m_gridCtrl.SetCellAlignment( 4 );
		}
	}
}



BOOL CSystemTab2View::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
#define MAX_ID	1
	DWORD dw;
	if(zDelta <=0)	dw = SB_LINEDOWN;
	else			dw = SB_LINEUP;

	CRect rect;
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	int nID[MAX_ID] = { IDC_GRID_OUTCHECK_LIST};
	int i;
	for( i=0; i<MAX_ID; i++)
	{
		if(((CMSFlexGrid*)GetDlgItem( nID[i] ))->GetRows() <= 18) continue;

		GetDlgItem( nID[i] )->GetWindowRect( &rect );

		if(rect.left < pt.x && pt.x < rect.right && rect.top < pt.y && pt.y < rect.bottom)
		{
			GetDlgItem(nID[i])->SendMessage(WM_VSCROLL, dw, 0);
		}
	}

	return CFormView::OnMouseWheel(nFlags, zDelta, pt);
}


void CSystemTab2View::MonitorOutput()
{
	static DWORD dCurrentTime = GetCurrentTime();

	int i=0;
	if( m_bRepeat == TRUE && (GetCurrentTime() - dCurrentTime) > (DWORD)(m_nRepeatTime) )
	{
		dCurrentTime = GetCurrentTime();

		for( i=0; i<m_nMaxOutNo; i++ )
		{
			CString str =m_gridCtrl.GetTextMatrix(i+1, 4);

			CDicsApp * pApp = (CDicsApp*) AfxGetApp();
			CDicsView * pView = ( (CDicsView*)pApp->m_pMainView );

			m_gridCtrl.SetRow( i+1 );
			m_gridCtrl.SetCol( 3 );

			if( str != "" )
			{
				BOOL state = pView->m_Do.m_pDo[i].Get();
				if( state ) pView->m_Do.m_pDo[i].Set( FALSE );
				else pView->m_Do.m_pDo[i].Set( TRUE );

				if( state )
				{	
					m_gridCtrl.SetCellBackColor( WHITE_COLOR );
					m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
					str = "OFF";
				}
				else
				{
					m_gridCtrl.SetCellBackColor( GREEN_COLOR );
					m_gridCtrl.SetCellForeColor( BLACK_COLOR );
					str = "ON";
				}

				m_gridCtrl.SetRow( i+1 );
				m_gridCtrl.SetCol( 3 );
				m_gridCtrl.SetText( str );
				m_gridCtrl.SetCellAlignment( 4 );
			}
		}
	}
	else if(m_bRepeat == FALSE)
	{
		dCurrentTime = GetCurrentTime();
	}
}

void CSystemTab2View::OnTimer(UINT_PTR nIDEvent)
{
	MonitorOutput();
	CFormView::OnTimer(nIDEvent);
}
