// SystemTab2View.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "SystemTab4View.h"
#include "SystemView.h"
#include "..\DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSystemTab4View

IMPLEMENT_DYNCREATE(CSystemTab4View, CFormView)

CSystemTab4View::CSystemTab4View()
	: CFormView(CSystemTab4View::IDD)
{
	//{{AFX_DATA_INIT(CSystemTab4View)
	//}}AFX_DATA_INIT
}

CSystemTab4View::CSystemTab4View(CView* pView)
	: CFormView(CSystemTab4View::IDD)
{
	m_pView			= pView;
	m_nSetPage		= 0;
	m_nStartAddress	= 0x0000;
}

CSystemTab4View::~CSystemTab4View()
{
}

void CSystemTab4View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSystemTab4View)
	DDX_Control(pDX, IDC_COMBO_ADDRESS, m_cbAddress);
	DDX_Control(pDX, IDC_GRID_CTRL, m_gridCtrl);
	DDX_Control(pDX, IDC_MEL_NEXT, m_macNextButton);
	DDX_Control(pDX, IDC_MEL_PREV, m_macPrevButton);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSystemTab4View, CFormView)
	//{{AFX_MSG_MAP(CSystemTab4View)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_MEL_PREV, OnMelPrev)
	ON_BN_CLICKED(IDC_MEL_NEXT, OnMelNext)
	ON_CBN_SELCHANGE(IDC_COMBO_ADDRESS, OnSelchangeComboAddress)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSystemTab4View diagnostics

#ifdef _DEBUG
void CSystemTab4View::AssertValid() const
{
	CFormView::AssertValid();
}

void CSystemTab4View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSystemTab4View message handlers

void CSystemTab4View::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// Set the MAC button
	MAC_COLOR_SET color_set;
	m_macPrevButton.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macPrevButton.SetColorSetting( color_set );
	m_macPrevButton.SetBold();

	m_macNextButton.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macNextButton.SetColorSetting( color_set );
	m_macNextButton.SetBold();

	// Set Combo Box
	for( int i=0; i<0x20; i++ ) 
	{
		CString sVal;
		sVal.Format( "W%04X", 0x100 * i );
		m_cbAddress.AddString( sVal );
	}
	m_cbAddress.SetCurSel( 0 );
	
	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	m_pMelsec =	pApp->m_pMainView->m_pMelsec;
	GridInit();

	SetTimer( TIMER_MANUAL, 500, NULL );
}

void CSystemTab4View::OnDestroy() 
{
	CFormView::OnDestroy();
	
	// TODO: Add your message handler code here
	KillTimer( TIMER_MANUAL );
	
}

BOOL CSystemTab4View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

//--------------------------------------------------------------------
// Initialize the GridCtrl
//--------------------------------------------------------------------
void CSystemTab4View::GridInit()
{
	LPTSTR sCol[] = { " ADDRESS", " STATUS", " ADDRESS", " STATUS" };
	int COLWIDTH[] = { 2000, 2940, 2000, 2940 }; 
	
	// Initialize GridCtrl 
	m_gridCtrl.SetRows( 17 ); 
	m_gridCtrl.SetCols( 4 );

//-------------------------------------------
	m_gridCtrl.SetRow( 0 );  
	m_gridCtrl.SetColWidth( 0, COLWIDTH[0] );
	m_gridCtrl.SetCol( 0 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sCol[0] ); 
//---------------------------------------------
	m_gridCtrl.SetColWidth( 1, COLWIDTH[1] );
	m_gridCtrl.SetCol( 1 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sCol[1] ); 
//---------------------------------------------
	m_gridCtrl.SetColWidth( 2, COLWIDTH[2] );
	m_gridCtrl.SetCol( 2 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sCol[2] ); 
//---------------------------------------------
	m_gridCtrl.SetColWidth( 3, COLWIDTH[3] );
	m_gridCtrl.SetCol( 3 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sCol[3] ); 

	// Set background color
	for( int nCol=0; nCol<4; nCol++ )
	{
		for( int nRow=0; nRow<0x10; nRow++ )
		{
			if( nCol%2 == 0 )
			{
				m_gridCtrl.SetCol( nCol );
				m_gridCtrl.SetRow( nRow+1 );
				m_gridCtrl.SetCellBackColor( LIGHT_CYAN_COLOR );
			}
		}
	}
	SetCellIndex();
}

//--------------------------------------------------------------------
//--------------------------------------------------------------------
void CSystemTab4View::SetCellIndex()
{
	// Set Text
	CString sHexVal;
	for( int nCol=0; nCol<2; nCol++ )
	{
		for( int nRow=0; nRow<0x10; nRow++ )
		{
			m_gridCtrl.SetCellAlignment( 4 );
			m_gridCtrl.SetCol( nCol * 2 );
			m_gridCtrl.SetRow( nRow + 1 );

			sHexVal.Format( "W%04X", m_nStartAddress + nRow + nCol * 16 + m_nSetPage * 32 );
			m_gridCtrl.SetText( (LPCTSTR) sHexVal );
		}
	}
}

//--------------------------------------------------------------------
// Monitoring
//--------------------------------------------------------------------
void CSystemTab4View::OnTimer(UINT nIDEvent) 
{
	if( ( (CSystemView*) m_pView )->m_nSelectedTab == 3 ) SetCellValue();
	
	CFormView::OnTimer(nIDEvent);
}

void CSystemTab4View::SetCellValue()
{
	// Get value
	short nVal[32];
	m_pMelsec->RandR32( m_pMelsec->m_NetworkInfo.nUpNetworkNo, 
						m_pMelsec->m_NetworkInfo.nUpStationNo, 
						m_nStartAddress + 16 * 2 * m_nSetPage, 
						nVal, XMelsec::devW );

	// Get value
	for( int i = m_nSetPage*2; i < (m_nSetPage+1)*2; i++ )
	{
		for( int j=0; j<0x10; j++ )
		{
			m_nValue[i][j] = nVal[ 16 * ( i - m_nSetPage*2 ) + j];
		}
	}

	// Set to cell
	for( int nCol=0; nCol<2; nCol++ )
	{
		for( int nRow=0; nRow<0x10; nRow++ )
		{
			if( m_nOldValue[/*2 * m_nSetPage +*/ nCol][nRow] == m_nValue[2 * m_nSetPage + nCol][nRow] ) continue;
			m_nOldValue[/*2 * m_nSetPage +*/ nCol][nRow] = m_nValue[2 * m_nSetPage + nCol][nRow];

			CString sVal;
			sVal.Format( "%02X", m_nValue[2 * m_nSetPage + nCol][nRow] );
			m_gridCtrl.SetCol( nCol*2+1 );
			m_gridCtrl.SetRow( nRow+1 );
			m_gridCtrl.SetText( (LPCTSTR) sVal );
			m_gridCtrl.SetCellAlignment( 4 );
		}
	}
}

//--------------------------------------------------------------------
// Previous Page
//--------------------------------------------------------------------
void CSystemTab4View::OnMelPrev() 
{
	if( m_nSetPage > 0 ) 
	{
		m_nSetPage--;
		SetCellIndex();
	}
}

//--------------------------------------------------------------------
// Next Page
//--------------------------------------------------------------------
void CSystemTab4View::OnMelNext() 
{
	if( m_nSetPage < 16 / 2 - 1 ) 
	{
		m_nSetPage++;
		SetCellIndex();
	}
}

BEGIN_EVENTSINK_MAP(CSystemTab4View, CFormView)
    //{{AFX_EVENTSINK_MAP(CSystemTab4View)
	ON_EVENT(CSystemTab4View, IDC_GRID_CTRL, -601 /* DblClick */, OnDblClickGridCtrl, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CSystemTab4View::OnDblClickGridCtrl() 
{
	int nCol = m_gridCtrl.GetColSel();
	if( nCol % 2 == 0 ) return;

	int nRow = m_gridCtrl.GetRowSel();
	int nBitAddress = m_nStartAddress + 32 * m_nSetPage + 16 * ( nCol / 2 ) + nRow - 1;

	int nVal = m_nValue[2 * m_nSetPage + ( nCol / 2 )][nRow - 1];
	CDlgEditVal dlg;
	CString sTemp;
	sTemp.Format( "%d", nVal );
	dlg.m_sOldVal = dlg.m_sCurVal = sTemp;

	if( dlg.DoModal() == IDOK )
	{
		nVal = atoi( dlg.m_sCurVal );

		MelWrite( nBitAddress, nVal );
		m_nValue[2 * m_nSetPage + ( nCol / 2)][nRow - 1] = nVal;
		m_nOldValue[2 * m_nSetPage + ( nCol / 2)][nRow - 1] = nVal;
		
		CString sData;
		sData.Format( " %02X", nVal );
		m_gridCtrl.SetText( (LPCTSTR) sData );
	}
}

//--------------------------------------------------------------------
// Get Combo Box selection value
//--------------------------------------------------------------------
void CSystemTab4View::OnSelchangeComboAddress() 
{
	int nSel = m_cbAddress.GetCurSel();
	if( nSel >= 0 ) 
	{
		m_nStartAddress = nSel * 0x100;
		m_nSetPage = 0;
		SetCellIndex();
	}
}
