// SystemTabAiView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "SystemTabAiView.h"
#include "SystemView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSystemTabAiView

IMPLEMENT_DYNCREATE(CSystemTabAiView, CFormView)

CSystemTabAiView::CSystemTabAiView()
	: CFormView(CSystemTabAiView::IDD)
{
	//{{AFX_DATA_INIT(CSystemTabAiView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CSystemTabAiView::CSystemTabAiView(CView* pView)
	: CFormView(CSystemTabAiView::IDD)
{

	m_pView = pView;
}

CSystemTabAiView::~CSystemTabAiView()
{
}

void CSystemTabAiView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSystemTabAiView)
	DDX_Control(pDX, IDC_GRID_INCHECK_LIST, m_gridCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSystemTabAiView, CFormView)
	//{{AFX_MSG_MAP(CSystemTabAiView)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_WM_MOUSEWHEEL()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSystemTabAiView diagnostics

#ifdef _DEBUG
void CSystemTabAiView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSystemTabAiView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSystemTabAiView message handlers

BOOL CSystemTabAiView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CSystemTabAiView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	m_pDevice =	( (CSystemView*) m_pView )->m_pDevice;

	// Create the note message box
	CRect r;
	GetDlgItem( IDC_IO_IN_NOTE )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgNote.Create( 100, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_IO_IN_NOTE, WHITE, BLUE_COLOR, 18, TRUE );
	m_msgNote.SetAlign( CMsgBox::alignLEFT );
	m_msgNote.SetOpMsg( " " );

	// Create the note title message box
	GetDlgItem( IDC_NOTE_STATIC )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgNoteStatic.Create( 101, " ", WS_CHILD|WS_VISIBLE, r, this, IDC_NOTE_STATIC, LIGHT_YELLOW_COLOR, BLUE_COLOR, 18, TRUE );
	m_msgNoteStatic.SetOpMsg( " " );

	// Get the maximum input point number
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView * pView = ( (CDicsView*)pApp->m_pMainView );
	m_nMaxInNo = pView->m_Ai.GetChannelSize();

	// Set the Grid control
	GridInit();

	// Set Timer
	SetTimer( TIMER_IO_TEST, 500, NULL );
}

void CSystemTabAiView::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	KillTimer( TIMER_IO_TEST );
	CFormView::OnClose();
}

BEGIN_EVENTSINK_MAP(CSystemTabAiView, CFormView)
    //{{AFX_EVENTSINK_MAP(CSystemTabAiView)
	ON_EVENT(CSystemTabAiView, IDC_GRID_INCHECK_LIST, -600 /* Click */, OnClickIncheckList, VTS_NONE)
	ON_EVENT(CSystemTabAiView, IDC_GRID_INCHECK_LIST, -601 /* DblClick */, OnDblClickIncheckList, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

//--------------------------------------------------------------------
// Initialize the GridCtrl
//--------------------------------------------------------------------
void CSystemTabAiView::GridInit()
{
	if ( ((CSystemView*) m_pView)->m_nNameOrDesc == CSystemView::showNAME ) m_msgNoteStatic.SetOpMsg( "Description" );
	else m_msgNoteStatic.SetOpMsg( "I/O Name" );

	LPTSTR sLvcText[] = { " NO.", " Wire No.", " Description", " STATUS", "" };
	if ( ((CSystemView*) m_pView)->m_nNameOrDesc == CSystemView::showNAME ) sLvcText[2] = " I/O Name";

	int nColWidth[] = { 1000, 1500, 8450, 2450, 0 }; 

	// initialize GridCtrl
	m_gridCtrl.SetRows( m_nMaxInNo + 1 ); 
	m_gridCtrl.SetCols( 5 );

	//-------------------------------------------
	m_gridCtrl.SetRow( 0 );  
	m_gridCtrl.SetColWidth( 0, nColWidth[0] );
	m_gridCtrl.SetCol( 0 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridCtrl.SetColWidth( 1, nColWidth[1] );
	m_gridCtrl.SetCol( 1 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[1] ); 
	//---------------------------------------------
	m_gridCtrl.SetColWidth( 2, nColWidth[2] );
	m_gridCtrl.SetCol( 2 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[2] ); 
	//---------------------------------------------
	m_gridCtrl.SetColWidth( 3, nColWidth[3] );
	m_gridCtrl.SetCol( 3 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[3] );
	//---------------------------------------------	Virtual
	m_gridCtrl.SetColWidth( 4, nColWidth[4] );
	m_gridCtrl.SetCol( 4 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[4] );

	SetDataToGridCtrl();
}

//--------------------------------------------------------------------
// Set data
//--------------------------------------------------------------------
void CSystemTabAiView::SetDataToGridCtrl()
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView * pView = ( (CDicsView*)pApp->m_pMainView );
	CString sBuf;

	int nSize = pView->m_Ai.GetChannelSize();
	
	for( int nRow = 0; nRow < nSize ; nRow++ )
	{
		// 1. I/O Number
		m_gridCtrl.SetCol( 0 );
		m_gridCtrl.SetRow( nRow + 1 );
		m_gridCtrl.SetCellAlignment( 4 );
		m_gridCtrl.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d", pView->m_Ai.m_pAi[nRow].GetAddress() );
		m_gridCtrl.SetText( (LPCTSTR) sBuf );

		// 2. Wire Number
		m_gridCtrl.SetCol( 1 );
		m_gridCtrl.SetRow( nRow + 1);
		sBuf.Format( "%s",  pView->m_Ai.m_pAi[nRow].GetWiringNo( "Ai" ) );
		if( sBuf == "NULL" || sBuf == "" ) m_gridCtrl.SetCellBackColor( YELLOW_COLOR );
		m_gridCtrl.SetText( (LPCTSTR) sBuf );
		m_gridCtrl.SetCellAlignment( 4 );

		// 3. Comment
		m_gridCtrl.SetCol( 2 );
		m_gridCtrl.SetRow( nRow + 1 );

		if ( ((CSystemView*) m_pView)->m_nNameOrDesc == CSystemView::showNAME )
			sBuf.Format(" %s", pView->m_Ai.m_pAi[nRow].GetName() );
		else sBuf.Format(" %s", pView->m_Ai.m_pAi[nRow].GetName() );

		if( sBuf == "Not defined" ) m_gridCtrl.SetCellBackColor( YELLOW_COLOR );
		m_gridCtrl.SetText( (LPCTSTR) sBuf );

		// 4. I/O State : Get I/O state
//		m_gridCtrl.SetCol( 3 );
//		m_gridCtrl.SetRow( nRow + 1 );
//		if( pView->m_Ai.m_pAi[nRow].Get() )
//		{
//			sBuf = "ON";
//			m_gridCtrl.SetCellBackColor( GREEN_COLOR );
//			m_gridCtrl.SetCellForeColor( BLACK_COLOR );
//		}
//		else
//		{
//			sBuf = "OFF";
//			m_gridCtrl.SetCellBackColor( WHITE_COLOR );
//			m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
//		}
//		m_gridCtrl.SetText( (LPCTSTR) sBuf );
//		m_gridCtrl.SetCellAlignment( 4 );

		// 5. ID
		m_gridCtrl.SetCol( 4 );
		m_gridCtrl.SetRow( nRow + 1 );

//		sBuf.Format("%ld", m_pSetPi->m_ID );
//		m_gridCtrl.SetText( (LPCTSTR) sBuf );
	}
}

//--------------------------------------------------------------------
// Monitoring all the input
//--------------------------------------------------------------------
void CSystemTabAiView::MonitorInput()
{
	CDicsApp * pApp = (CDicsApp*) AfxGetApp();
	CDicsView * pView = ( (CDicsView*)pApp->m_pMainView );
	CString sBuf;
	
	m_gridCtrl.SetCol( 3 );
	m_gridCtrl.SetCellAlignment( 4 );
	for( int i = 0 ; i < pView->m_Ai.GetChannelSize() ; i++ )
	{
		//BOOL bFlag = DioInput(i);
		float fVal = pView->m_Ai.m_pAi[i].Get();
		sBuf.Format( "%.5f", fVal );

		m_gridCtrl.SetRow( i + 1 );
		if( m_gridCtrl.GetText() == sBuf ) continue;
		m_gridCtrl.SetText( (LPCTSTR) sBuf );
	}
}

//--------------------------------------------------------------------
// Message Handler : OnClickIncheckList
//--------------------------------------------------------------------
void CSystemTabAiView::OnClickIncheckList() 
{
	int nRow = m_gridCtrl.GetRowSel();

//	if ( nRow == 0 ) return;
//
//	CString sBuf;
//	CDicsDoc* pDoc = (CDicsDoc*)(m_pView->GetDocument());
//	CIOItem* pItem = ((CSystemView*) m_pView)->GetIOItem( "di", nRow - 1 );
//
//	if ( ((CSystemView*) m_pView)->m_nNameOrDesc == CSystemView::showNAME )
//		sBuf.Format( "%s",  pItem->m_sDesc );
//	else sBuf.Format( "%s",  pItem->m_sName );

// 	m_msgNote.SetOpMsg( sBuf );
}

//--------------------------------------------------------------------
// Message Handler : OnDblClickIncheckList
//--------------------------------------------------------------------
void CSystemTabAiView::OnDblClickIncheckList() 
{
	// TODO: Add your control notification handler code here
	int nRow = m_gridCtrl.GetRowSel();
	CDicsApp * pApp = (CDicsApp*) AfxGetApp();
	CDicsView * pView = ( (CDicsView*)pApp->m_pMainView );
	//pView->m_Ai.m_pAi[nRow-1].DoModal();
}

//--------------------------------------------------------------------
// Message Handler : OnTimer
//--------------------------------------------------------------------
void CSystemTabAiView::OnTimer(UINT nIDEvent) 
{
	MonitorInput();	
	CFormView::OnTimer(nIDEvent);
}


BOOL CSystemTabAiView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
#define MAX_ID	1
	DWORD dw;
	if(zDelta <=0)	dw = SB_LINEDOWN;
	else			dw = SB_LINEUP;

	CRect rect;
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	int nID[MAX_ID] = { IDC_GRID_INCHECK_LIST };
	int i;
	for( i=0; i<MAX_ID; i++)
	{
		if(((CMSFlexGrid*)GetDlgItem( nID[i] ))->GetRows() <= 18) continue;

		GetDlgItem( nID[i] )->GetWindowRect( &rect );

		if(rect.left < pt.x && pt.x < rect.right && rect.top < pt.y && pt.y < rect.bottom)
		{
			GetDlgItem(nID[i])->SendMessage(WM_VSCROLL, dw, 0);
		}
	}	

	return CFormView::OnMouseWheel(nFlags, zDelta, pt);
}
