// SystemTabDeviceView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "SystemTabDeviceView.h"
#include "SystemView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSystemTabDeviceView

IMPLEMENT_DYNCREATE(CSystemTabDeviceView, CFormView)

CSystemTabDeviceView::CSystemTabDeviceView()
	: CFormView(CSystemTabDeviceView::IDD)
{
	//{{AFX_DATA_INIT(CSystemTabDeviceView)
	m_sDeviceName = _T("");
	m_sDataValue = _T("");
	m_sSection = _T("");
	m_sKey = _T("");
	//}}AFX_DATA_INIT
}

CSystemTabDeviceView::CSystemTabDeviceView(CView* pView)
	: CFormView(CSystemTabDeviceView::IDD)
{
	m_pDeviceArray			= NULL;
	m_hCurSelectedTreeItem	= NULL;
	m_pView					= pView;
}

CSystemTabDeviceView::~CSystemTabDeviceView()
{
}

void CSystemTabDeviceView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSystemTabDeviceView)
	DDX_Control(pDX, IDC_LIST_CHANNELS, m_lstCtrlChannels);
	DDX_Control(pDX, IDC_TREE_DEVICE_CONFIG, m_treeDevices);
	DDX_Text(pDX, IDC_EDIT_DEVICE_NAME, m_sDeviceName);
	DDX_Text(pDX, IDC_EDIT_ITEM_DATA, m_sDataValue);
	DDX_Text(pDX, IDC_EDIT_SECTION, m_sSection);
	DDX_Text(pDX, IDC_EDIT_KEY, m_sKey);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSystemTabDeviceView, CFormView)
	//{{AFX_MSG_MAP(CSystemTabDeviceView)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON_ADD_CHANNEL, OnButtonAddChannel)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_SAVE, OnButtonSave)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE_DEVICE_CONFIG, OnSelchangedTreeDeviceConfig)
	ON_COMMAND(ID_INFO_ADD, OnInfoAdd)
	ON_COMMAND(ID_INFO_DEL, OnInfoDel)
	ON_NOTIFY(NM_RCLICK, IDC_TREE_DEVICE_CONFIG, OnRclickTreeDeviceConfig)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSystemTabDeviceView diagnostics

#ifdef _DEBUG
void CSystemTabDeviceView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSystemTabDeviceView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSystemTabDeviceView message handlers

BOOL CSystemTabDeviceView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CSystemTabDeviceView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	m_pDevice =	((CSystemView*) m_pView)->m_pDevice;

	CDicsApp *	pApp	= (CDicsApp*) AfxGetApp();
	CDicsView * pView	= ( (CDicsView*)pApp->m_pMainView );
	m_pAssy				= pView->m_pEqpAssy;
	m_pDeviceArray		= m_pAssy->GetDeviceArray();
	m_pChannelPackage	= m_pAssy->m_pChannelPackage;
	
//	m_bPermitAccess  = ( (CDicsView*) m_pView)->GetDocument()->m_bPermitAccess;

	//m_nMaxOutNo = pView->m_Ao.GetChannelSize();
	LoadDevicesToTreeView();
	( (CButton*)GetDlgItem(IDC_BUTTON_ADD_CHANNEL) )->EnableWindow( FALSE );

	InitListCtrlOfChannels();
}

void CSystemTabDeviceView::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	
	CFormView::OnClose();
}

BEGIN_EVENTSINK_MAP(CSystemTabDeviceView, CFormView)
    //{{AFX_EVENTSINK_MAP(CSystemTabDeviceView)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()


void CSystemTabDeviceView::LoadDevicesToTreeView()
{
	int nDevicesCount = 0;
	nDevicesCount = m_pDeviceArray->GetSize();

	HTREEITEM h;
	for( int i = 0 ; i < nDevicesCount ; i ++ )
	{
		CDevice * pDevcie;
		pDevcie = (CDevice*)m_pDeviceArray->GetAt( i );
		//if( pDevcie->IsInitialized() ) 
		h = m_treeDevices.InsertItem( pDevcie->GetName(), TVI_ROOT, TVI_LAST );
		AddDeviceInformation( h, pDevcie );
	}
}

void CSystemTabDeviceView::ClearTreeView()
{
	m_treeDevices.DeleteAllItems();
}

void CSystemTabDeviceView::AddDeviceInformation(HTREEITEM hParents, void *device)
{
	CStringList * pSectionList;
	pSectionList = ( ( CDevice* )device )->GetSectionList();

	POSITION pos = NULL;
	HTREEITEM * h;

	h = new HTREEITEM[pSectionList->GetCount()];

	pos = pSectionList->GetHeadPosition();
	for( int i = 0 ; i < pSectionList->GetCount() ; i ++ )
	{
		h[i] = m_treeDevices.InsertItem( (LPCTSTR)pSectionList->GetAt( pos ), hParents );
		{
			CStringList *pKeyList;
			pKeyList = ( ( CDevice* )device )->GetKeyList( pSectionList->GetAt( pos ) );
			POSITION keypos;
			keypos = pKeyList->GetHeadPosition();
			for( int j = 0 ; j < pKeyList->GetCount() ; j ++ )
			{
				m_treeDevices.InsertItem( pKeyList->GetAt( keypos ), h[i] );
				pKeyList->GetNext( keypos );
			}
		}
		m_treeDevices.Expand( h[i], TVE_EXPAND );
		pSectionList->GetNext( pos );
	}
	delete [] h;
}

void CSystemTabDeviceView::OnButtonAddChannel() 
{
	// TODO: Add your control notification handler code 
	BOOL bFind = FALSE;
	if( m_sSection.Find( "DI" ) == 0 ) bFind = TRUE;
	else if( m_sSection.Find( "DO" ) == 0 ) bFind = TRUE;
	else if( m_sSection.Find( "AI" ) == 0 ) bFind = TRUE;
	else if( m_sSection.Find( "AO" ) == 0 ) bFind = TRUE;
	else if( m_sKey.Find( "DI" ) == 0 ) bFind = TRUE;
	else if( m_sKey.Find( "DO" ) == 0 ) bFind = TRUE;
	else if( m_sKey.Find( "AI" ) == 0 ) bFind = TRUE;
	else if( m_sKey.Find( "AO" ) == 0 ) bFind = TRUE;
//	else if( m_sKey.Find( "PARA") == 0 ) bFind = TRUE;

	if( bFind )
	{
		int nCurSel = 0;
		nCurSel = m_lstCtrlChannels.GetSelectionMark();
		if( nCurSel >= 0 )
		{
			m_sDataValue = m_lstCtrlChannels.GetItemText( nCurSel, 2 );
		}
 		UpdateData( FALSE );
	}

	UpdateData( TRUE );
	CDevice * pDevice;
	pDevice = (CDevice*)m_pAssy->GetDeviceFromDeviceArray( m_sDeviceName );
	if( pDevice != NULL )
	{
		pDevice->SetIniStringValue( m_sSection, m_sKey, m_sDataValue );
		
		CString sSecName, sKeyVal, sKeyName, sBuf;
		POSITION keypos, keypos1;
		CStringList* pSectionList = pDevice->GetSectionListPoint();
		CStringList** pSecKeyList = pDevice->GetSectionKeyList();
		CStringList* pKeyList;
		keypos = pSectionList->GetHeadPosition();
		for( int i=0; i<pSectionList->GetCount(); i++ )
		{
			sSecName = pSectionList->GetAt( keypos );
			if( sSecName == m_sSection )
			{
				pKeyList = pSecKeyList[i];
				keypos1 = pKeyList->GetHeadPosition();
				for( int j=0; j<pKeyList->GetCount(); j++ )
				{
					sBuf = pKeyList->GetAt( keypos1 );
					int nIndex = sBuf.ReverseFind('=');
					if( nIndex <= 0 ) continue;
					sKeyName = sBuf.Mid( 0, nIndex );
					if( m_sKey == sKeyName )
					{
						sKeyVal.Format("%s=%s", sKeyName, m_sDataValue);
						pKeyList->SetAt( keypos1, sKeyVal );
					}
					pKeyList->GetNext( keypos1 );
				}
			}
			pSectionList->GetNext( keypos );
		}
	}
	CString sItemText;
	sItemText = m_sKey + "=" + m_sDataValue;
	m_treeDevices.SetItemText( m_hCurSelectedTreeItem, sItemText );
	m_treeDevices.Expand( m_hCurSelectedTreeItem, TVE_EXPAND );
	m_treeDevices.SelectItem( m_hCurSelectedTreeItem );
}

void CSystemTabDeviceView::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	
}

void CSystemTabDeviceView::OnButtonSave() 
{
	// TODO: Add your control notification handler code here
	
}

void CSystemTabDeviceView::ShowChannels(int nChannelsType)
{
	static int nOldChannelsName = -1;
	if( nChannelsType == nOldChannelsName )
	{
		int nCount = m_lstCtrlChannels.GetItemCount();
		if( nCount > 0 ) return;
	}
	m_lstCtrlChannels.DeleteAllItems();

	int i = 0;

	switch( nChannelsType ) 
	{
	case CChannels::DI :
		{
			CDigitalInputs* p = m_pChannelPackage->GetDIChannels();
			for( i = 0 ; i < p->GetChannelSize() ; i ++ )
			{
				XDigitalInput * x;
				x = &p->m_pDi[i];
				AddOneItemOnChannelsLstCtrl( 
					x->GetAddress(), 
					x->GetWiringNo( "X" ), 
					x->GetName(),
					x->GetCurrConnectedObjectNo(),
					x->GetConnectPoint());
			}
			CString sName;
			int nLastAddr = i;
			for( i = 0 ; i < MAX_AXES ; i ++ )
			{
				sName.Format("MMC_HOME_AXIS%d", i);
				AddOneItemOnChannelsLstCtrl( 
					nLastAddr+i, 
					"H", 
					sName,
					0,
					"A");
			}
		}
		break;
	case CChannels::DO :
		{
			CDigitalOutputs* p = m_pChannelPackage->GetDOChannels();
			for( i = 0 ; i < p->GetChannelSize() ; i ++ )
			{
				XDigitalOutput * x;
				x = &p->m_pDo[i];
				AddOneItemOnChannelsLstCtrl( 
					x->GetAddress(), 
					x->GetWiringNo( "Y" ), 
					x->GetName(),
					x->GetCurrConnectedObjectNo(),
					x->GetConnectPoint());
			}
		}
		break;
	case CChannels::AI :
		{
			CAnalogInputs* p = m_pChannelPackage->GetAIChannels();
			for( i = 0 ; i < p->GetChannelSize() ; i ++ )
			{
				XAnalogInput * x;
				x = &p->m_pAi[i];
				AddOneItemOnChannelsLstCtrl( 
					x->GetAddress(), 
					x->GetWiringNo( "Ai" ), 
					x->GetName(),
					x->GetCurrConnectedObjectNo(),
					x->GetConnectPoint());
			}
		}
		break;
	case CChannels::AO :
		{
			CAnalogOutputs* p = m_pChannelPackage->GetAOChannels();
			for( i = 0 ; i < p->GetChannelSize() ; i ++ )
			{
				XAnalogOutput * x;
				x = &p->m_pAo[i];
				AddOneItemOnChannelsLstCtrl( 
					x->GetAddress(), 
					x->GetWiringNo( "Ao" ), 
					x->GetName(),
					x->GetCurrConnectedObjectNo(),
					x->GetConnectPoint());
			}
		}
		break;
	}
	nOldChannelsName = nChannelsType;
}

void CSystemTabDeviceView::OnSelchangedTreeDeviceConfig(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
    HTREEITEM hItem = pNMTreeView->itemNew.hItem;

	// Save last selected tree item
	m_hCurSelectedTreeItem = hItem;

	// Process Root Item
	HTREEITEM hCur,hRoot;
	hCur = hItem;
	while( 1 )
	{
		hRoot = m_treeDevices.GetParentItem( hCur );
		if( hRoot == NULL )
		{
			m_sDeviceName = m_treeDevices.GetItemText( hCur );
			break;
		}
		else 
			hCur = hRoot;
	}

	CDevice * pDevice;
	pDevice = (CDevice*)m_pAssy->GetDeviceFromDeviceArray( m_sDeviceName );

	// Process Selected Item
	CString sText = m_treeDevices.GetItemText( hItem );
	int nIndex = sText.Find( "=", 0 );
	if( nIndex != -1 )
	{
		m_sDataValue = sText.Mid( nIndex + 1 );
		m_sKey	= sText.Mid( 0, nIndex );
		HTREEITEM hParentItem = m_treeDevices.GetParentItem( hItem );
		m_sSection = m_treeDevices.GetItemText( hParentItem );
		pDevice->GetKeyList( m_sSection );

		BOOL bFind = FALSE;
		if( m_sSection.Find( "DI" ) == 0 ) bFind = TRUE;
		if( m_sKey.Find( "DI" ) == 0 ) bFind = TRUE;
		if( bFind )
		{
			ShowChannels( CChannels::DI );
		}
		bFind = FALSE;
		if( m_sSection.Find( "DO" ) == 0 ) bFind = TRUE;
		if( m_sKey.Find( "DO" ) == 0 ) bFind = TRUE;
		if( bFind )
		{
			ShowChannels( CChannels::DO );
		}
		bFind = FALSE;
		if( m_sSection.Find( "AI" ) == 0 ) bFind = TRUE;
		if( m_sKey.Find( "AI" ) == 0 ) bFind = TRUE;
		if( bFind )
		{
			ShowChannels( CChannels::AI );
		}
		bFind = FALSE;
		if( m_sSection.Find( "AO" ) == 0 ) bFind = TRUE;
		if( m_sKey.Find( "AO" ) == 0 ) bFind = TRUE;
		if( bFind )
		{
			ShowChannels( CChannels::AO );
		}
		UpdateData( FALSE );

		( (CButton*)GetDlgItem(IDC_BUTTON_ADD_CHANNEL) )->EnableWindow( TRUE );
	}
	else
	{
		m_sSection		= "";
		m_sKey			= "";
		m_sDataValue	= "";
		UpdateData( FALSE );
		( (CButton*)GetDlgItem(IDC_BUTTON_ADD_CHANNEL) )->EnableWindow( FALSE );
	}
	
	*pResult = 0;
}

void CSystemTabDeviceView::InitListCtrlOfChannels()
{
	m_lstCtrlChannels.SetExtendedStyle( LVS_EX_FULLROWSELECT |
								LVS_EX_ONECLICKACTIVATE | 
								LVS_EX_UNDERLINEHOT | 
//								LVS_EX_CHECKBOXES |
								LVS_EX_GRIDLINES );
	// ListControl ʱȭ
	int nLvcFmt[] = { LVCFMT_CENTER, LVCFMT_CENTER, LVCFMT_LEFT, LVCFMT_CENTER, LVCFMT_CENTER };		// 231220 halesu OverRead Fix
	LPTSTR sLvcText[] = { "No", "Wire No", "               Name                                                                     ", "Used", "CPOINT" };

	LV_COLUMN lvc;
	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_TEXT;
	for( int i=0; i<5; i++ )
	{
		lvc.fmt = nLvcFmt[i];
		lvc.pszText = sLvcText[i];
		lvc.cx = m_lstCtrlChannels.GetStringWidth(lvc.pszText) + 18;
		m_lstCtrlChannels.InsertColumn(i, &lvc);
	}
}

void CSystemTabDeviceView::AddOneItemOnChannelsLstCtrl( int nAdd, CString sWireNo, CString sName, int nConnectedObjectNo,CString sCpoint )
{
	int nActualIndex;
	int nCol = 0;
	char szTemp[100];
    LV_ITEM lvItem; 

	lvItem.mask = LVIF_TEXT;
    lvItem.state = 0; 
    lvItem.stateMask = 0; 
    lvItem.iImage = -1;
    lvItem.lParam = 0;

	// Add
	lvItem.iItem = m_lstCtrlChannels.GetItemCount() + 1; 
	lvItem.iSubItem = nCol++;
	wsprintf( szTemp, "%d", nAdd );
	lvItem.pszText = szTemp;
	nActualIndex = m_lstCtrlChannels.InsertItem(  &lvItem );

	// Wire
	lvItem.iItem = nActualIndex;
	lvItem.iSubItem = nCol++;
	sprintf( szTemp, "%s", sWireNo );
	lvItem.pszText = szTemp;
	m_lstCtrlChannels.SetItem( &lvItem );
		
	// Name
	lvItem.iItem = nActualIndex;
	lvItem.iSubItem = nCol++;
	sprintf( szTemp, "%s", sName );
	lvItem.pszText = szTemp;
	m_lstCtrlChannels.SetItem( &lvItem );

	// GetCurrConnectedObjectNo
	lvItem.iItem = nActualIndex;
	lvItem.iSubItem = nCol++;
	sprintf( szTemp, "%d", nConnectedObjectNo );
	lvItem.pszText = szTemp;
	m_lstCtrlChannels.SetItem( &lvItem );

	lvItem.iItem = nActualIndex;
	lvItem.iSubItem = nCol++;
	sprintf( szTemp, "%s", sCpoint );
	lvItem.pszText = szTemp;
	m_lstCtrlChannels.SetItem( &lvItem );

	if ( nConnectedObjectNo  > 0 ) m_lstCtrlChannels.SetCheck( nActualIndex, TRUE );
}

void CSystemTabDeviceView::OnRclickTreeDeviceConfig(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	UINT uFlags;
	CPoint	point;
	CRect	rec;

	GetCursorPos( &point );
	GetDlgItem( IDC_TREE_DEVICE_CONFIG )->GetWindowRect( rec );

	point.x = point.x - rec.left;
	point.y = point.y - rec.top;

	HTREEITEM hItem = m_treeDevices.HitTest(point, &uFlags);

	if( (hItem != NULL ) && ( TVHT_ONITEM & uFlags ) )
	{
	   m_treeDevices.Select(hItem, TVGN_CARET);
	}
	else return;

	CString sText = m_treeDevices.GetItemText( hItem );
	int nIndex = sText.Find( "=", 0 );
	if( nIndex != -1 )
	{
		m_sKey	= sText.Mid( 0, nIndex );
		HTREEITEM hParentItem = m_treeDevices.GetParentItem( hItem );
		m_sSection = m_treeDevices.GetItemText( hParentItem );

		BOOL bFind = FALSE;
		if( m_sSection.Find( "DI" ) == 0 ) bFind = TRUE;
		else if( m_sSection.Find( "DO" ) == 0 ) bFind = TRUE;
		else if( m_sSection.Find( "AI" ) == 0 ) bFind = TRUE;
		else if( m_sSection.Find( "AO" ) == 0 ) bFind = TRUE;
		else if( m_sKey.Find( "DI" ) == 0 ) bFind = TRUE;
		else if( m_sKey.Find( "DO" ) == 0 ) bFind = TRUE;
		else if( m_sKey.Find( "AI" ) == 0 ) bFind = TRUE;
		else if( m_sKey.Find( "AO" ) == 0 ) bFind = TRUE;
		else if( m_sKey.Find( "PARA") == 0 ) bFind = TRUE;
		
		if( ( m_sKey.Find("[") < 0 ) && ( m_sKey.Find("]") < 0 ) ) bFind = FALSE;
		if( bFind )
		{
 			//CPoint point;
			GetCursorPos(&point);
			// load and display popup menu
			CMenu menu;
			menu.LoadMenu(IDR_CLICK_INFO);
			CMenu* pPopup = menu.GetSubMenu(0);
			
			// show and track the menu
			DWORD dwID = pPopup->TrackPopupMenu((TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_NONOTIFY|TPM_RETURNCMD),
										   point.x, point.y, this);

			SendMessage(WM_COMMAND, dwID);	
			*pResult = 0;
		}
	}
	else return;
}

void CSystemTabDeviceView::OnInfoAdd(/*NMHDR* pNMHDR, LRESULT* pResult*/) 
{
	// TODO: Add your command handler code here
//	*pResult = 1;
	
	CDevice * pDevice;
	pDevice = (CDevice*)m_pAssy->GetDeviceFromDeviceArray( m_sDeviceName );

	ConfigrationFileRemove(m_sDeviceName);
	// ȭ  ...
	pDevice->FileOpen( m_sDeviceName, "Configuration");

	HTREEITEM hItem2 = m_treeDevices.GetSelectedItem();
	HTREEITEM hItem1 = m_treeDevices.GetParentItem( hItem2 );
	HTREEITEM hItem0 = m_treeDevices.GetParentItem( hItem1 );
	RebuildConfiguration( pDevice, TRUE );
	while( 1 )
	{
		HTREEITEM hChild = m_treeDevices.GetChildItem( hItem0 );
		if( hChild == NULL ) break;
		m_treeDevices.DeleteItem( hChild );
	}
	AddDeviceInformation( hItem0, pDevice );
}

void CSystemTabDeviceView::OnInfoDel(/*NMHDR* pNMHDR, LRESULT* pResult*/) 
{
	// TODO: Add your command handler code here
//	*pResult = 1;
	
	CDevice * pDevice;
	pDevice = (CDevice*)m_pAssy->GetDeviceFromDeviceArray( m_sDeviceName );

	ConfigrationFileRemove(m_sDeviceName);
	// ȭ  ...
	pDevice->FileOpen( m_sDeviceName, "Configuration");

	HTREEITEM hItem2 = m_treeDevices.GetSelectedItem();
	HTREEITEM hItem1 = m_treeDevices.GetParentItem( hItem2 );
	HTREEITEM hItem0 = m_treeDevices.GetParentItem( hItem1 );
	RebuildConfiguration( pDevice, FALSE );
	while( 1 )
	{
		HTREEITEM hChild = m_treeDevices.GetChildItem( hItem0 );
		if( hChild == NULL ) break;
		m_treeDevices.DeleteItem( hChild );
	}
	AddDeviceInformation( hItem0, pDevice );
}

void CSystemTabDeviceView::ConfigrationFileRemove(CString sDeviceFileName)
{
	CString  sFile;
	CString  sPath;
	WIN32_FIND_DATA DirData;
	HANDLE hDir;
		
	sFile.Format( "D:\\DICS\\Configuration\\*.*" );

	hDir = FindFirstFile((LPCTSTR) sFile, &DirData);

	do
	{
		CString sFileName = m_sDeviceName; 
		if (DirData.dwFileAttributes && FILE_ATTRIBUTE_DIRECTORY)
		{
			if( sFileName != "." && sFileName != ".." )
			{
				CString  strDate;
				CFileStatus FileStatus;
				CFile File;

				sFileName = "D:\\DICS\\Configuration\\" + sFileName;
				File.GetStatus( sFileName, FileStatus );
				sPath = sFileName;
			}
		}
	} while( FindNextFile(hDir, &DirData) );

	FindClose( hDir );		
	sFile.Format( "%s.ini", sPath);
	if( sPath != "" )
	{ 	
		HANDLE hFile;
		WIN32_FIND_DATA FileData;

		hFile = FindFirstFile((LPCTSTR) sFile, &FileData);
		if( hFile != (void*) 0xffffffff )
		{ 
			do
			{
				CString sFileName = FileData.cFileName;
				CFileStatus FileStatus;
				CFile File;
				CString sFullName;
				sFullName.Format( "D:\\DICS\\Configuration\\%s", sFileName );
				File.GetStatus( sFileName, FileStatus );
				
				TRY
				{
					File.Remove( sFullName );
				}
				CATCH( CFileException, e )
				{
#ifdef _DEBUG
					afxDump << "File" << sFullName << "cannot be removed \n";
#endif
				}
				END_CATCH
			}
			while( FindNextFile(hFile, &FileData) );
		}
		FindClose( hFile );
		RemoveDirectory( sPath ); //    Directory ...
	}
}

CString CSystemTabDeviceView::FindSectionKey(CString sSection)
{
	CString sText;
	CString sFindLinkDeviceName;
	sText  = sSection;
	CString sFind;
	sFind = sText.Mid(0,2);

	if(  ( m_sSection.Find( "DI" ) == 0 ) || ( m_sKey.Find( "DI" ) == 0 ) )
	{
		sFindLinkDeviceName = "diSPARE";
	}
	else if( ( m_sSection.Find( "DO" ) == 0 ) || ( m_sKey.Find( "DO" ) == 0 ) )
	{
		sFindLinkDeviceName = "doSPARE";
	}
	else if( ( m_sSection.Find( "AI" ) == 0 ) || ( m_sKey.Find( "AI" ) == 0 ) )
	{
		sFindLinkDeviceName = "aiSPARE";
	}
	else if(( m_sSection.Find( "AO" ) == 0 ) || ( m_sKey.Find( "AO" ) == 0 ) )
	{
		sFindLinkDeviceName = "aoSPARE";
	}
	else
	{
		sFindLinkDeviceName = "NONE";
	}
	return sFindLinkDeviceName;
}

void CSystemTabDeviceView::RebuildConfiguration(CDevice* pDevice, BOOL bAdd)
{
	CString sName(""), sName1(""), sValue(""), sBuf(""), sSectionName(""), sClickKeyText("");
	POSITION sectionpos, keypos;
	int nIndex=0, nIndex1=0, nKeyNo=0;

	HTREEITEM hItem = m_treeDevices.GetSelectedItem();
	CString sClickText = m_treeDevices.GetItemText( hItem );

	CStringList* pSectionList = pDevice->GetSectionListPoint();
	CStringList** pSecKeyList = pDevice->GetSectionKeyList();

	sectionpos = pSectionList->GetHeadPosition();
	int nMaxSectionCount = pSectionList->GetCount();
	for( int i=0; i<nMaxSectionCount; i++ )
	{
		sSectionName = pSectionList->GetAt( sectionpos );
		if( sSectionName == m_sSection ) // ADD, DEL ϱ  Section̴.
		{
			nKeyNo=0;
			CStringList* pKeyList = pSecKeyList[i];
			keypos = pKeyList->GetHeadPosition();
			int nMaxKeyCount = pKeyList->GetCount();

			nIndex = sClickText.ReverseFind('[');
			if( nIndex <= 0 )
			{
				for( int j=0; j<nMaxKeyCount; j++ )
				{
					sBuf = pKeyList->GetAt( keypos );
					nIndex1 = sBuf.ReverseFind('=');
					if( nIndex1 <= 0 ) continue;
					sName = sBuf.Mid( 0, nIndex1 );
					sValue = sBuf.Mid( nIndex1+1 );
					pDevice->SetIniStringValue( sSectionName, sName, sValue );
					pKeyList->GetNext( keypos );
				}
				pSectionList->GetNext( sectionpos );
				continue;
			}
			
			sClickKeyText = sClickText.Mid( 0, nIndex );

			for( int j=0; j<nMaxKeyCount; j++ )
			{
				sBuf = pKeyList->GetAt( keypos );
				if( sBuf == sClickText )
				{
					if( bAdd )
					{
						nIndex = sBuf.ReverseFind('=');
						if( nIndex <= 0 ) continue;
						sName = sBuf.Mid( 0, nIndex );
						nIndex1 = sName.ReverseFind('[');
						if( nIndex1 <= 0 ) continue;
						sName1 = sName.Mid( 0, nIndex1 );
						sName.Format("%s[%d]", sName1, nKeyNo);
						sValue = sBuf.Mid( nIndex+1 );
						pDevice->SetIniStringValue( sSectionName, sName, sValue );
						sBuf.Format("%s=%s", sName, sValue);
						pKeyList->SetAt( keypos, sBuf );
						nKeyNo++;
						
						sName.Format("%s[%d]", sName1, nKeyNo);
						sValue = FindSectionKey( sSectionName );
						pDevice->SetIniStringValue( sSectionName, sName, sValue );
						sBuf.Format("%s=%s", sName, sValue);
						pKeyList->InsertAfter( keypos, sBuf );
						nKeyNo++;
						pKeyList->GetNext( keypos );
					}
					else
					{
						if( nMaxKeyCount > 1 )
						{
							if( j > 0 )
							{
								pKeyList->RemoveAt( keypos );
								pKeyList->GetPrev( keypos );
							}
							else
							{
								pKeyList->RemoveHead();
								keypos = pKeyList->GetHeadPosition();
								continue;
							}
						}
						else
						{
							nIndex = sBuf.ReverseFind('=');
							if( nIndex <= 0 ) continue;
							sName = sBuf.Mid( 0, nIndex );
							nIndex1 = sName.ReverseFind('[');
							if( nIndex1 <= 0 ) continue;
							sName1 = sName.Mid( 0, nIndex1 );
							sName.Format("%s[%d]", sName1, nKeyNo);
							sValue = FindSectionKey( sSectionName );
							pDevice->SetIniStringValue( sSectionName, sName, sValue );
							sBuf.Format("%s=%s", sName, sValue);
							pKeyList->SetAt( keypos, sBuf );
							nKeyNo++;
						}
					}
				}
				else
				{
					nIndex = sBuf.ReverseFind('=');
					if( nIndex <= 0 ) continue;
					sName = sBuf.Mid( 0, nIndex );
					nIndex1 = sName.ReverseFind('[');
					if( nIndex1 <= 0 ) continue;
					sName1 = sName.Mid( 0, nIndex1 );
					if( sName1 == sClickKeyText )
					{
						sName.Format("%s[%d]", sName1, nKeyNo);
						sValue = sBuf.Mid( nIndex+1 );
						pDevice->SetIniStringValue( sSectionName, sName, sValue );
						sBuf.Format("%s=%s", sName, sValue);
						pKeyList->SetAt( keypos, sBuf );
						nKeyNo++;
					}
					else
					{
						sValue = sBuf.Mid( nIndex+1 );
						pDevice->SetIniStringValue( sSectionName, sName, sValue );
						sBuf.Format("%s=%s", sName, sValue);
						pKeyList->SetAt( keypos, sBuf );
					}
				}
				pKeyList->GetNext( keypos );
			}
		}
		else	// ̰ Key List ͼ ׳ ѷش.
		{
			CStringList* pKeyList = pSecKeyList[i];
			keypos = pKeyList->GetHeadPosition();
			for( int j=0; j<pKeyList->GetCount(); j++ )
			{
				sBuf = pKeyList->GetAt( keypos );
				nIndex = sBuf.ReverseFind('=');
				if( nIndex <= 0 ) continue;
				sName = sBuf.Mid( 0, nIndex );
				sValue = sBuf.Mid( nIndex+1 );
				pDevice->SetIniStringValue( sSectionName, sName, sValue );
				pKeyList->GetNext( keypos );
			}
		}

		pSectionList->GetNext( sectionpos );
	}
}
