//{{AFX_INCLUDES()
#include "..\msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_SYSTEMTABDEVICEVIEW_H__EDFF4C03_1C5B_4D53_A005_19FF443A6D4D__INCLUDED_)
#define AFX_SYSTEMTABDEVICEVIEW_H__EDFF4C03_1C5B_4D53_A005_19FF443A6D4D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SystemTab2View.h : header file
//
#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\X\MsgBox.h"
#include "..\FactoryLib\DigitalInputsList.h"
#include "..\X\PointListCtrl.h"

/////////////////////////////////////////////////////////////////////////////
// CSystemTabDeviceView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CSystemTabDeviceView : public CFormView
{
public:
	CSystemTabDeviceView();           // protected constructor used by dynamic creation
	CSystemTabDeviceView( CView* pView );
	DECLARE_DYNCREATE(CSystemTabDeviceView)

// Form Data
public:
	//{{AFX_DATA(CSystemTabDeviceView)
	enum { IDD = IDD_SYSTEM_TABDEVICE_VIEW };
	CPointListCtrl	m_lstCtrlChannels;
//	CListCtrl	m_lstCtrlChannels;
	CTreeCtrl	m_treeDevices;
	CString	m_sDeviceName;
	CString	m_sDataValue;
	CString	m_sSection;
	CString	m_sKey;
	//}}AFX_DATA
	CMsgBox		m_msgNote;
	CMsgBox		m_msgNoteStatic;

// Attributes
public:
	CView*			m_pView;
	CEqpAssy*		m_pAssy;

	BOOL			m_bPermitAccess;
	int				m_nMaxOutNo;
	XCtlDevice*		m_pDevice;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSystemTabDeviceView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	void RebuildConfiguration(CDevice* device, BOOL bAdd);
	void ConfigrationFileRemove(CString sDeviceFileName);
	CPtrArray* m_pDeviceArray;
	virtual ~CSystemTabDeviceView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CSystemTabDeviceView)
	afx_msg void OnClose();
	afx_msg void OnButtonAddChannel();
	afx_msg void OnButtonClear();
	afx_msg void OnButtonSave();
	afx_msg void OnSelchangedTreeDeviceConfig(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnInfoAdd(/*NMHDR* pNMHDR, LRESULT* pResult*/);
	afx_msg void OnInfoDel(/*NMHDR* pNMHDR, LRESULT* pResult*/);
	afx_msg void OnRclickTreeDeviceConfig(NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CString FindSectionKey( CString sSection);
	void AddOneItemOnChannelsLstCtrl(int nAdd, CString sWireNo, CString sName, int nConnectedObjectNo, CString sCpoint);
	void InitListCtrlOfChannels();
	HTREEITEM m_hCurSelectedTreeItem;
	void AddDeviceInformation(HTREEITEM hParents, void * device);
	void LoadDevicesToTreeView();
	CChannelPackage* m_pChannelPackage;
	void ShowChannels(int nChannelsType);
	int m_nCurDeviceNo;
	void ClearTreeView();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SYSTEMTABDEVICEVIEW_H__EDFF4C03_1C5B_4D53_A005_19FF443A6D4D__INCLUDED_)
