// SystemView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "SystemView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSystemView

IMPLEMENT_DYNCREATE(CSystemView, CFormView)

CSystemView::CSystemView()
	: CFormView(CSystemView::IDD)
{
	//{{AFX_DATA_INIT(CSystemView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_pTabSystemTab1View	= NULL;
	m_pTabSystemTab2View	= NULL;
//	m_pTabSystemTab3View	= NULL;
//	m_pTabSystemTab4View	= NULL;
	m_pTabSystemTabAiView	= NULL;
	m_pTabSystemTabAoView	= NULL;
	m_pTapSystemTabDeviceView	= NULL;

	m_pDevice	= NULL;
	m_nLineNo		= 0;
}

CSystemView::~CSystemView()
{
	GetDocument()->m_pSystemWnd = NULL;
}

void CSystemView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSystemView)
	DDX_Control(pDX, IDC_TAB_SYSTEM, m_tabCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSystemView, CFormView)
	//{{AFX_MSG_MAP(CSystemView)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_MESSAGE( WM_SEL_CHANGE_TAB, OnSelChangeTab )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSystemView diagnostics

#ifdef _DEBUG
void CSystemView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSystemView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CDicsDoc* CSystemView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDicsDoc)));
	return (CDicsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSystemView message handlers

void CSystemView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	CDicsView * pView	= ( (CDicsView*)pApp->m_pMainView );
	m_pAssy				= pView->m_pEqpAssy;
	m_pChannelPackage	= m_pAssy->m_pChannelPackage;

	// get the registry variables
	m_nNameOrDesc = pApp->GetProfileInt( "DICS SET", "Name or Desc", showNAME );

	// Set the current view pointer
	GetDocument()->SetSystemView( this );

	// Get the devicenet pointer
	m_pDevice = ( (CDicsView*) pApp->m_pMainView )->m_pDevice;

	m_nTotalDi = m_nTotalDo = 0;
	UINT uMaxNode = m_pDevice->GetMaxNode();
	for( UINT i=0; i<uMaxNode; i++ )
	{
		m_nTotalDi += m_pDevice->m_pPointDI[i];
		m_nTotalDo += m_pDevice->m_pPointDO[i];
	}

	IoInit( m_nTotalDi, m_nTotalDo );

	// Create the TAB view 
	CRect r;
	GetDlgItem( IDC_TAB_SYSTEM )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 0, 0, 6, 30 );

	m_pTabSystemTab1View = new CSystemTab1View( this );
	CCreateContext context;
	m_pTabSystemTab1View->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CSystemTab1View::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabSystemTab1View, "    I/O CHECK INPUT VIEW    ", 0 );
	m_pTabSystemTab1View->SetFocus();

	m_pTabSystemTab2View = new CSystemTab2View( this );
	m_pTabSystemTab2View->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CSystemTab2View::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabSystemTab2View, "    I/O CHECK OUTPUT VIEW    ", 1 );

	m_pTabSystemTabAiView = new CSystemTabAiView( this );
	m_pTabSystemTabAiView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CSystemTabAiView::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabSystemTabAiView, "    ANALOG INPUT VIEW    ", 1 );

	m_pTabSystemTabAoView = new CSystemTabAoView( this );
	m_pTabSystemTabAoView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CSystemTabAoView::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabSystemTabAoView, "    ANALOG OUTPUT VIEW    ", 1 );

	m_pTapSystemTabDeviceView = new CSystemTabDeviceView( this );
	m_pTapSystemTabDeviceView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CSystemTabDeviceView::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTapSystemTabDeviceView, "    DEVICE  ASSEMBLY    ", 1 );


	m_tabCtrl.SetSelectedColor( RED_COLOR );
	m_tabCtrl.SetMouseOverColor( GREEN_COLOR );
	m_tabCtrl.SetNormalColor( DARK_GRAY_COLOR );
}

//--------------------------------------------------------------------
// OnDestroy
//--------------------------------------------------------------------
void CSystemView::OnDestroy() 
{
	CFormView::OnDestroy();
    CIOItem* pIoItem;
	int index;
    for ( index = 0 ; index < m_arrayDiItem.GetSize() ; index++ )
    {
        pIoItem = m_arrayDiItem.GetAt( index );
        delete pIoItem;
        pIoItem = NULL;
    }

    for ( index = 0 ; index < m_arrayDoItem.GetSize() ; index++ )
    {
        pIoItem = m_arrayDoItem.GetAt( index );
        delete pIoItem;
        pIoItem = NULL;
    }

    m_arrayDiItem.RemoveAll();
    m_arrayDoItem.RemoveAll();
	
	if( m_pTabSystemTab1View ) 
	{
		m_pTabSystemTab1View->SendMessage( WM_CLOSE );
		delete m_pTabSystemTab1View;
	}

	if( m_pTabSystemTab2View ) 
	{
		m_pTabSystemTab2View->SendMessage( WM_CLOSE );
		delete m_pTabSystemTab2View;
	}
	if( m_pTabSystemTabAiView ) 
	{
		m_pTabSystemTabAiView->SendMessage( WM_CLOSE );
		delete m_pTabSystemTabAiView;
	}
	if( m_pTabSystemTabAoView ) 
	{
		m_pTabSystemTabAoView->SendMessage( WM_CLOSE );
		delete m_pTabSystemTabAoView;
	}

	if( m_pTapSystemTabDeviceView )
	{
		m_pTapSystemTabDeviceView->SendMessage( WM_CLOSE );
		delete m_pTapSystemTabDeviceView;
	}
	
}

//---------------------------------------------------------------------------
// OnSelChangeTab
//---------------------------------------------------------------------------
LRESULT CSystemView::OnSelChangeTab( WPARAM wParam, LPARAM lParam )
{
	m_nSelectedTab = (int) wParam;

	if( m_nSelectedTab == 0 )		m_pTabSystemTab1View->SetFocus();
	else if( m_nSelectedTab == 1 )	m_pTabSystemTab2View->SetFocus();
	else if( m_nSelectedTab == 2 )	m_pTabSystemTabAiView->SetFocus();
	else if( m_nSelectedTab == 3 )	m_pTabSystemTabAoView->SetFocus();
	else if( m_nSelectedTab == 4 )	m_pTapSystemTabDeviceView->SetFocus();
	return 0;
}


//--------------------------------------------------------------------
// IoInit
//--------------------------------------------------------------------
BOOL CSystemView::IoInit(int nTotalDi, int nTotalDo)
{
	CIOItem* pItem;

	BOOL bSpare = FALSE;
	CString sBuf = "Not defined";
	CString sWireNo = "NULL";
	int i;
	for( i=0; i<nTotalDi ; i++ )
	{
		pItem = new CIOItem( bSpare, sBuf, i, sWireNo, sBuf );
		m_arrayDiItem.Add( pItem );
	}

	for( i=0; i<nTotalDo; i++ )
	{
		pItem = new CIOItem( bSpare, sBuf, i, sWireNo, sBuf );
		m_arrayDoItem.Add( pItem );
	}
	return TRUE;
}

//--------------------------------------------------------------------
// ParseIO
//--------------------------------------------------------------------
BOOL CSystemView::ParseIO(LPCTSTR lpszFileName)
{
	FILE* pFileIo;
	CString sData;

	if( ( pFileIo = fopen( lpszFileName, "rt" ) ) == NULL ) 
	{
		AfxMessageBox( "IO file is not loaded" );
		return FALSE;
	}

	while( !feof( pFileIo ) )
	{
		char szLine[200];

		// Read one line
		CString sData;
		fgets( szLine, 200, pFileIo );
		sData.Format("%s", szLine );
		m_nLineNo += 1;

		// Parse the first token
		char szSeps[] = " \t\n";
		char* ptoken;
		CString sToken;

		ptoken = strtok( szLine, szSeps );
		sToken.Format( "%s", ptoken );

		// Check the slash begin & end
		static BOOL bSkip = FALSE;
		if( !sToken.Compare( "//BEGIN" ) ) bSkip = TRUE;
		if( bSkip )
		{
			if( !sToken.Compare( "//END" ) ) { bSkip = FALSE; }
			continue;
		}
		
		// Parse the useful line again.
		if( sToken.Find( "////" ) )	// Check the skip one line
		{
			ParseIOLine( sData.GetBuffer( sData.GetLength() ) );
			sData.ReleaseBuffer();
		}
	} 

	fclose( pFileIo ); 

	return TRUE;
}

//--------------------------------------------------------------------
// ParseIOLine
// Format : #define diIN_CV_BROKEN1 ( DioInput(DI_NODE1+0) ? 1 : 0 ) // NOTE : Description1
//			#define dosRB_UNIT_RB1_MOTOR_CW(A) DioOutputState(DO_NODE2+12)	// NOTE : Description2
//--------------------------------------------------------------------
BOOL CSystemView::ParseIOLine( char* szLine )
{
	return TRUE;
}

//--------------------------------------------------------------------
// AddIOItem
//--------------------------------------------------------------------
BOOL CSystemView::AddIOItem(BOOL bSpare, CString sName, int nIoNo, CString sDesc)
{
    CIOItem* pItem;

	CString sType;
	sType = sName.Mid(0, 2);

	if( sType == "di" ) 
	{
		pItem = m_arrayDiItem.GetAt( nIoNo );

		pItem->m_bSpare = bSpare;
		pItem->m_sName = sName;
		pItem->m_nIoNo = nIoNo;
		pItem->m_sDesc = sDesc;
	}
	else if( sType == "do" ) 
	{
		pItem = m_arrayDoItem.GetAt( nIoNo );

		pItem->m_bSpare = bSpare;
		pItem->m_sName = sName;
		pItem->m_nIoNo = nIoNo;
		pItem->m_sDesc = sDesc;
	}
	else return FALSE;

    return TRUE;	
}

//--------------------------------------------------------------------
// GetIOItem
//--------------------------------------------------------------------
CIOItem* CSystemView::GetIOItem(CString sType, int nId)
{
	CIOItem* pItem;

	if( sType == "di" ) pItem = m_arrayDiItem.GetAt( nId );
	else if( sType == "do" ) pItem = m_arrayDoItem.GetAt( nId );

	return pItem;	
}

//--------------------------------------------------------------------
// SetWireName
//--------------------------------------------------------------------
BOOL CSystemView::SetWireName(int nMaxNode)
{
	return TRUE;
}

//--------------------------------------------------------------------
// Convert digit to octal value
//--------------------------------------------------------------------
int CSystemView::d2o( int nVal )
{
	//dec to oct
	CString sBuf;
	sBuf.Format( "%o", nVal );
	
	int nRv = 0;
	nRv = atoi( sBuf );
	return nRv;
}

//--------------------------------------------------------------------
// DisplayErrMsg
//--------------------------------------------------------------------
void CSystemView::DisplayErrMsg( char* szComment )
{
	CString sMsg;
	sMsg.Format( "%s : %d line(s)", szComment, m_nLineNo );
	AfxMessageBox( sMsg );
}

//--------------------------------------------------------------------
// OnWriteFile
//--------------------------------------------------------------------
BOOL CSystemView::OnWriteFile()
{
	CString m_sPathName;

	// Backup the current directory
	char szPathName[100];	
	GetCurrentDirectory( 100, szPathName );

	CFileDialog fileWriteDlg( FALSE, _T("TXT"), NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
		_T( "IO TEXT Files (*.TXT)|*.txt|"
			"All Files (*.*)|*.*||") );

	if ( fileWriteDlg.DoModal() == IDCANCEL ) return FALSE;

		
	// Get the path name
	m_sPathName = fileWriteDlg.GetPathName();

	CStdioFile file;
	CString szBuf;

	if( !file.Open( m_sPathName, CFile::modeCreate | CFile::modeWrite | CFile::typeText ) ) 
	{
		AfxMessageBox( "File could not be written" );
		SetCurrentDirectory( szPathName );
		return FALSE;
	}

	szBuf.Format( "***********************  DIGITAL INPUT LIST  ***********************\n\n" );
	file.WriteString( szBuf );
	szBuf.Format( " Io No	Name	Wire No \n" );
	file.WriteString( szBuf ) ;

	{
		CDigitalInputs* p = m_pChannelPackage->GetDIChannels();
		for( int i = 0 ; i < p->GetChannelSize() ; i ++ )
		{
			XDigitalInput * x;
			x = &p->m_pDi[i];
			
			szBuf.Format( " %3d\t%s\t%s\n", x->GetAddress(),x->GetWiringNo( "X" ),x->GetName() );
			file.WriteString( szBuf ) ;
			
		}
	}
	

	szBuf.Format( "\n***********************  DIGITAL OUTPUT LIST  ***********************\n\n" );
	file.WriteString( szBuf ) ;
	szBuf.Format( " Io No	Name	Wire No \n" );
	file.WriteString( szBuf ) ;

	{
		CDigitalOutputs* p = m_pChannelPackage->GetDOChannels();
		
		for( int i = 0 ; i < p->GetChannelSize() ; i ++ )
		{
			XDigitalOutput * x;
			x = &p->m_pDo[i];
			
			szBuf.Format( " %3d\t%s\t%s\n", x->GetAddress(), x->GetWiringNo( "Y" ),x->GetName() );
			file.WriteString( szBuf ) ;
		}
	}

	szBuf.Format( "\n***********************  ANALOG INPUT LIST  ***********************\n\n" );
	file.WriteString( szBuf ) ;
	szBuf.Format( " Io No	Name	Wire No \n" );
	file.WriteString( szBuf ) ;
	
	{
		CAnalogInputs* p = m_pChannelPackage->GetAIChannels();
		for( int i = 0 ; i < p->GetChannelSize() ; i ++ )
		{
			XAnalogInput * x;
			x = &p->m_pAi[i];
			
			szBuf.Format( " %3d\t%s\t%s\n", x->GetAddress(), x->GetWiringNo( "Ai" ),x->GetName() );
			file.WriteString( szBuf ) ;
		}
	}


	szBuf.Format( "\n***********************  ANALOG OUTPUT LIST  ***********************\n\n" );
	file.WriteString( szBuf ) ;
	szBuf.Format( " Io No	Name	Wire No \n" );
	file.WriteString( szBuf ) ;
	{
		CAnalogOutputs* p = m_pChannelPackage->GetAOChannels();
		for( int i = 0 ; i < p->GetChannelSize() ; i ++ )
		{
			XAnalogOutput * x;
			x = &p->m_pAo[i];
			
			szBuf.Format( " %3d\t%s\t%s\n", x->GetAddress(), x->GetWiringNo( "Ao" ),x->GetName() );
			file.WriteString( szBuf ) ;
		}
	}


	file.Close();

	// Set to the original path
	SetCurrentDirectory( szPathName );
	return TRUE;
}
