#if !defined(AFX_SYSTEMVIEW_H__51AF53F3_363E_4CDD_B401_A6D98517DB96__INCLUDED_)
#define AFX_SYSTEMVIEW_H__51AF53F3_363E_4CDD_B401_A6D98517DB96__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SystemView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSystemView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

// Include
#include "..\X\XTabCtrl.h"
#include "..\X\XCtlDevice.h"

#include "SystemTab1View.h"
#include "SystemTab2View.h"
//#include "SystemTab3View.h"
//#include "SystemTab4View.h"
#include "SystemTabAiView.h"
#include "SystemTabAoView.h"
#include "SystemTabDeviceView.h"	// Added by ClassView

/////////////////////////////////////////////////////////////////////////////
// IO Class information.
class CIOItem
{
public:
	CIOItem( BOOL bSpare, CString sName, int nIoNo, CString sWireNo, CString sDesc )
	{
		m_bSpare	= bSpare;
		m_sName		= sName;
		m_nIoNo		= nIoNo;
		m_sWireNo	= sWireNo;
		m_sDesc		= sDesc;
	}
public:
	BOOL m_bSpare;
	CString m_sName;
	int	m_nIoNo;
	CString m_sWireNo;
	CString m_sDesc;
};

class CSystemView : public CFormView
{
protected:
	CSystemView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CSystemView)

// Form Data
public:
	//{{AFX_DATA(CSystemView)
	enum { IDD = IDD_SYSTEM_FORM };
	CXTabCtrl	m_tabCtrl;
	//}}AFX_DATA

// Attributes
public:
	CDicsDoc* GetDocument();

	// Tab View
	CSystemTab1View*	m_pTabSystemTab1View;
	CSystemTab2View*	m_pTabSystemTab2View;
//	CSystemTab3View*	m_pTabSystemTab3View;
//	CSystemTab4View*	m_pTabSystemTab4View;
	CSystemTabAiView*	m_pTabSystemTabAiView;
	CSystemTabAoView*	m_pTabSystemTabAoView;
	CSystemTabDeviceView* m_pTapSystemTabDeviceView;

	XCtlDevice*		m_pDevice;
	CEqpAssy*		m_pAssy;

	//  defineio.h read function------------------------------------------------------
	//	CTypedPtrArray  ϱ ؼ StdAfx.h #include <afxtempl.h>ؾ Ѵ.
	CTypedPtrArray< CPtrArray, CIOItem* > m_arrayDiItem;	
	CTypedPtrArray< CPtrArray, CIOItem* > m_arrayDoItem;
	
	int m_nTotalDi;
	int m_nTotalDo;

	int	m_nNameOrDesc;
	enum NAME_OR_DES { showNAME, showDESC };
	enum KIND_DI_DO  { kindDI, kindDO };

	int m_nLineNo;
	int m_nSelectedTab;
//  -------------------------------------------------------------------------------

// Operations
public:
	BOOL OnWriteFile();

	BOOL IoInit(int nTotalDi, int nTotalDo);
	BOOL AddIOItem( BOOL bSpare, CString sName, int nIoNo, CString sDesc );
	CIOItem* GetIOItem(CString sType, int nId);
	BOOL ParseIO(LPCTSTR lpszFileName);
	BOOL ParseIOLine( char* szLine );

	int d2o( int nVal );
	int GetNodeCount( CString sType, int nNodeNum);
	BOOL SetWireName(int nMaxNode);

	void DisplayErrMsg( char* szComment );
	CChannelPackage* m_pChannelPackage;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSystemView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CSystemView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CSystemView)
	afx_msg void OnDestroy();
	//}}AFX_MSG
	afx_msg LRESULT OnSelChangeTab( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DicsView.cpp
inline CDicsDoc* CSystemView::GetDocument()
   { return (CDicsDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SYSTEMVIEW_H__51AF53F3_363E_4CDD_B401_A6D98517DB96__INCLUDED_)
