#if !defined(AFX_JOBSTABHPMJSTATUSVIEW_H__8F11652D_9459_4AA9_BAE3_7922219061F3__INCLUDED_)
#define AFX_JOBSTABHPMJSTATUSVIEW_H__8F11652D_9459_4AA9_BAE3_7922219061F3__INCLUDED_

#include "..\analogctrl.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// jobstabhpmjstatusview.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CJobsTabHpmjStatusView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "..\X\ColorStatic.h"
#include "..\X\MacButtons.h"
#include "..\FactoryLib\EqpAssy.h"

#define MAX_GRID_COL	10
#define MAX_GRID_ROW	10
#define MAX_GRID_CTRLS	10

typedef struct tagVer2_GRID_INFO
{
	INT				nRows;
	INT				nCols;
	LPTSTR			sItem[MAX_GRID_COL];
	LPTSTR			sText[MAX_GRID_ROW];
	INT				nColWidth[MAX_GRID_COL];
	unsigned int	uCellBackColor;
	BOOL			bTitle;
} GRID_INFO_VER2;

#define MAX_HPMJ_VIEW_AI_NO 6

class CJobsTabHpmjStatusView : public CFormView
{
public:
	CJobsTabHpmjStatusView();           // protected constructor used by dynamic creation
	CJobsTabHpmjStatusView( CView* pView, int nTabNo ); 
	DECLARE_DYNCREATE(CJobsTabHpmjStatusView)

// Form Data
public:
	//{{AFX_DATA(CJobsTabHpmjStatusView)
	enum { IDD = IDD_JOBS_TAB_HPMJ_STATUS_VIEW };
	CAnalogCtrl*	m_ocxAnalogInput;
	CShwUnit		m_ocxShwUnit[4];
	CMacCheckBox	m_checkRun;
	CMacCheckBox	m_checkRemote;
	CMacCheckBox	m_checkReady;
	CMacCheckBox	m_checkPing;
	CMacCheckBox	m_checkWarning;
	CMacCheckBox	m_checkAlarm;
	CMacRadioButton	m_macStop;
	CMacRadioButton	m_macStart;
	CMacRadioButton	m_macRemoteMode;
	CMacRadioButton	m_macLocalMode;
	CMacRadioButton	m_macRunTimeReset;
	CMacRadioButton	m_macPumpCountReset;
	CMacRadioButton	m_macFilterCountReset;
	CMacRadioButton	m_macBuzzerOff;
	CMacRadioButton	m_macAlarmReset;
	CMSFlexGrid	m_gridParaData;
	CMSFlexGrid	m_gridPpidData;
	CMSFlexGrid	m_gridStateData;
	CPump	m_ocxPump;
	//}}AFX_DATA

// Attributes
public:
	int				m_nTabNo;
	CView*			m_pView;
	XCtlDevice*		m_pDevice;
	CSetupItems*	m_pSetupItems;
	CEqpAssy*		m_pEqpAssy;

	void SetDevice( XCtlDevice* pDevice ) { m_pDevice = pDevice; }
	void SetEqpAssy( CEqpAssy* pEqpAssy ) { m_pEqpAssy = pEqpAssy; }
// Operations
public:
	void UpdatePpidData();
	void UpdateParaData();
	void UpdateStateData();

	float				m_fStateData[9];
	float				m_fParaData[6][4];
	float				m_fPpidData[3];

	static	GRID_INFO_VER2		m_GridInfo[MAX_GRID_CTRLS];	
	enum	nameGRID_CTRL	{ gStateInfo, gParaInfo, gSetupInfo };

	void UpdateButton();
	void SetAnalogOcxInitParameter();
	void SetAiInitParameter();
	void SetDataToGridCtrl_PpidData();
	void SetDataToGridCtrl_ParaData();
	void SetDataToGridCtrl_StateData();
	void GridInit(CMSFlexGrid &gridCtrl, GRID_INFO_VER2 gridInfo);
	enum _inputSTATE{
		hpmjEMO,
		hpmjLEAK,
		hpmjINVTALARM,
		hpmjCOGEN2POWER,
		hpmjPUMPRUN,
	};
	
	enum _outputSTATE{
		hpmjINVTRUN,
		hpmjINVTRESET,
		hpmjMANUAL,
		hpmjPUMPMCON,
	};

	enum _analogInSTATE{
		hpmjSHOWR,
		hpmjINPRESS,
		hpmjOUTPRESS,
		hpmjMAINDIPRESS,
		hpmjDIW_RESISTIVITY,
		hpmjCO2PRESS
	};
		
	enum _analogOutSTATE{
		INVERTER_HERTZ,
	};

	void UpdateObjects();
	void UpdateShower();
	void UpdateAI();
	int m_nHpmjKeyCount;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJobsTabHpmjStatusView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	void UpdateInputStatus();
	void UpdatePump();
	virtual ~CJobsTabHpmjStatusView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CJobsTabHpmjStatusView)
	afx_msg void OnRemote();
	afx_msg void OnLocal();
	afx_msg void OnStart();
	afx_msg void OnStop();
	afx_msg void OnRunTimeReset();
	afx_msg void OnPumpCountReset();
	afx_msg void OnFilterCountReset();
	afx_msg void OnBuzzerOff();
	afx_msg void OnAlarmReset();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JOBSTABHPMJSTATUSVIEW_H__8F11652D_9459_4AA9_BAE3_7922219061F3__INCLUDED_)
