// MsgBox.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "MsgBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMsgBox

CMsgBox::CMsgBox()
{
	m_szOpMsg = "";
	m_nFontSize = 11;
	m_nAlign = alignCENTER;
}

CMsgBox::~CMsgBox()
{
}


BEGIN_MESSAGE_MAP(CMsgBox, CWnd)
	//{{AFX_MSG_MAP(CMsgBox)
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMsgBox message handlers

BOOL CMsgBox::Create(int nID, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT &rect, CWnd *pParentWnd, UINT nResID, COLORREF colorBack, COLORREF colorText, int nFontSize, BOOL bNonClick)
{
	if( !CWnd::Create(NULL, lpszWindowName, dwStyle, rect, pParentWnd, nResID ) )
		return FALSE;

	m_nID = nID;
	m_pOwner = pParentWnd;
	m_colorBack = colorBack;
	m_colorText = colorText;
	m_nFontSize = nFontSize;

	m_bNonClick = bNonClick;

	// TODO: Add your specialized creation code here
	if( !m_FontL.CreateFont( 50, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, 
		DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 
		/*FIXED_PITCH|FF_MODERN|*/TMPF_TRUETYPE, "ARIAL" ) )
			return FALSE;
//	if( !m_FontS.CreateFont( 13, 0, 0, 0, FW_NORMAL, FALSE, FALSE, 0, 
//		DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 
//		FIXED_PITCH|FF_MODERN|TMPF_TRUETYPE, "ü" ) )
//			return -1;

	if( !m_FontS.CreateFont( m_nFontSize, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, 
		DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 
		FIXED_PITCH|FF_MODERN|TMPF_TRUETYPE, "ARIAL" ) )
			return FALSE;

	return TRUE;
}

void CMsgBox::OnPaint() 
{
	LOGFONT LogFont;
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CFont * pOldFont = dc.SelectObject( &m_FontS );
	CBrush * pOldBrush = dc.SelectObject( &m_Brush );
//	CPen * pOldPen = dc.SelectObject(&m_Pen[idYELLOW]);
	int oldBkMode = dc.SetBkMode( TRANSPARENT );
	
	CRect r;
	this->GetWindowRect(&r);
//	dc.FillRect(RectWnd, &m_Brush);
	dc.FillSolidRect(0, 0, r.right-r.left, r.bottom-r.top, m_colorBack);
	dc.SetTextColor( m_colorText );
	dc.SetTextAlign(TA_CENTER);
	m_FontS.GetLogFont(&LogFont);

	if(m_szOpMsg == "") dc.TextOut((r.right-r.left)/2, (r.bottom-r.top-LogFont.lfHeight)/2,"0");
	else if( m_nAlign == CMsgBox::alignLEFT)
	{
		dc.SetTextAlign(TA_LEFT);
		dc.TextOut(5, (r.bottom-r.top-LogFont.lfHeight)/2, m_szOpMsg );
	}
	else if( m_nAlign == alignCENTER)
	{
		dc.TextOut((r.right-r.left)/2, (r.bottom-r.top-LogFont.lfHeight)/2, m_szOpMsg );
	}

//	if(m_szOpMsg != "") dc.TextOut((r.right-r.left)/2, (r.bottom-r.top-LogFont.lfHeight)/2, m_szOpMsg );

	dc.SelectObject( pOldFont );
	dc.SelectObject( pOldBrush );
	dc.SetBkMode( oldBkMode );
}

int CMsgBox::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_Brush.CreateSolidBrush( YELLOW );

	m_Pen[0].CreatePen( PS_SOLID, 1, BLACK );
	m_Pen[1].CreatePen( PS_SOLID, 1, BLUE );
	m_Pen[2].CreatePen( PS_SOLID, 1, GREEN );
	m_Pen[3].CreatePen( PS_SOLID, 1, CYAN );
	m_Pen[4].CreatePen( PS_SOLID, 1, RED );
	m_Pen[5].CreatePen( PS_SOLID, 1, MAGENTA );
	m_Pen[6].CreatePen( PS_SOLID, 1, BROWN );
	m_Pen[7].CreatePen( PS_SOLID, 1, DARKGRAY );
	m_Pen[8].CreatePen( PS_SOLID, 1, LIGHTGRAY );
	m_Pen[9].CreatePen( PS_SOLID, 1, LIGHTBLUE );
	m_Pen[10].CreatePen( PS_SOLID, 1, LIGHTGREEN );
	m_Pen[11].CreatePen( PS_SOLID, 1, LIGHTCYAN );
	m_Pen[12].CreatePen( PS_SOLID, 1, LIGHTRED );
	m_Pen[13].CreatePen( PS_SOLID, 1, LIGHTMAGENTA );
	m_Pen[14].CreatePen( PS_SOLID, 1, YELLOW );
	m_Pen[15].CreatePen( PS_SOLID, 1, WHITE );

	return 0;
}

void CMsgBox::OnDestroy() 
{
	CWnd::OnDestroy();
	
	m_Brush.DeleteObject();
	m_Pen[0].DeleteObject();
	m_Pen[1].DeleteObject();
	m_Pen[2].DeleteObject();
	m_Pen[3].DeleteObject();
	m_Pen[4].DeleteObject();
	m_Pen[5].DeleteObject();
	m_Pen[6].DeleteObject();
	m_Pen[7].DeleteObject();
	m_Pen[8].DeleteObject();
	m_Pen[9].DeleteObject();
	m_Pen[10].DeleteObject();
	m_Pen[11].DeleteObject();
	m_Pen[12].DeleteObject();
	m_Pen[13].DeleteObject();
	m_Pen[14].DeleteObject();
	m_Pen[15].DeleteObject();
}

void CMsgBox::SetOpMsg(LPCTSTR szMsg)
{
	m_szOpMsg = szMsg;
	if( m_szOpMsg != m_szOldOpMsg )
	{
		m_szOldOpMsg = m_szOpMsg;
		Invalidate();
	}
}

void CMsgBox::OnLButtonDown(UINT nFlags, CPoint point) 
{
//	if( m_bNonClick ) return;
//	m_pOwner->SendMessage( WM_MSG_BOX_CLICKED, m_nID, 0L );

	CWnd::OnLButtonDown(nFlags, point);
}

void CMsgBox::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if( m_bNonClick ) return;
	m_pOwner->SendMessage( WM_MSG_BOX_CLICKED, m_nID, 0L );

	CWnd::OnLButtonUp(nFlags, point);
}

void CMsgBox::SetTextColor( COLORREF colorText )
{
	m_colorText = colorText;
	Invalidate();
}

void CMsgBox::SetBgColor( COLORREF colorBack )
{
	m_colorBack = colorBack;
	Invalidate();
}