// MuxCom.h: interface for the CMuxCom class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MUXCOM_H__6DF41946_09AE_48EC_A63C_CEE6E2765581__INCLUDED_)
#define AFX_MUXCOM_H__6DF41946_09AE_48EC_A63C_CEE6E2765581__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "XCommThread.h"

#define	GAP_MAX_BYTE	60

class  CMuxCom : public XCommThread  
{
public:
	CMuxCom();
	virtual ~CMuxCom();
public:
	CString& ParseData(CString sData);  

	CMutex m_Mutex;
	
	BOOL SendCommand( char ch );
	BOOL SendCommand( CString sCmd );
	BOOL WatchComm();

	BOOL IsCommRcvd();
	void DataReceived();

	int m_nRptNo;

	CEvent	m_evCommReceived;

	CString m_sReceivedData;
	CString m_sSendData;
	CString m_sParseData;

	CString m_sGapData[4];

	int m_nTimeout;
	int m_nRetryNo;

	enum MuxOutCommand 
	{
		cChenalNo1 = '1',
		cChenalNo2 = '2',
		cChenalNo3 = '3',
		cChenalNo4 = '4',
		cChenalNoA = 'A'
	};

	enum ControlCharacters
	{
		ccSTX	= 0x02,		// Start Byte
		ccETX	= 0x03,		// End Byte
		ccNOD1	= 0x30,		// Node No Byte
		ccNOD2	= 0x30,		// Char '0'
		ccSBA1	= 0x30,		// Char '0'
		ccSBA2	= 0x30,		// Char '0'
		ccSID	= 0x30,		// Char '0'
		ccData	= 0001,
		ccBCC_H	= 0x33,		// Char '3'
		ccBCC_L	= 0x31,		// Char '1'
		ccENQ	= 0x05,		// Request to Send
		ccEOT	= 0x04,		// Request to Receive
		ccACK	= 0x06,		// Correct Reception
		ccNAK	= 0x15,		// Incorrect Reception
		ccCR	= 0x0D,		// CR, N
	};
};

#endif // !defined(AFX_MUXCOM_H__6DF41946_09AE_48EC_A63C_CEE6E2765581__INCLUDED_)
