// MuxCom2.cpp: implementation of the CMuxCom class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "MuxCom2.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMuxCom2::CMuxCom2()
	: m_evCommReceived( FALSE, TRUE ) // Initially Own = FALSE, Manual Reset = TRUE
{
	m_nTimeout = 3000;
	m_nRetryNo = 3;
}



CMuxCom2::~CMuxCom2()
{

}

//---------------------------------------------------------------------------
// Polling function
// m_bConnected = False Ǳ ѹݺ
//---------------------------------------------------------------------------
BOOL CMuxCom2::WatchComm()
{
	DWORD		dwEvtMask;
	OVERLAPPED	os;

	memset( &os, 0, sizeof( OVERLAPPED ) ) ;
	os.hEvent = CreateEvent( NULL, TRUE, FALSE, NULL );
	if( os.hEvent == NULL )
	{
		AfxMessageBox( "Can't create the event of WatchCommProc !", MB_OK | MB_ICONSTOP | MB_SYSTEMMODAL );
		return FALSE;
	}

	switch( m_nEvtType )
	{
		case 0 :
			if( !SetCommMask( m_hComm, EV_RXCHAR ) ) return FALSE;
			break;
		case 1 :
			if( !SetCommMask( m_hComm, EV_RXFLAG ) ) return FALSE;
			break;
	}

	CSingleLock slLock( &m_Mutex );

	while( m_bConnected )
	{
		//TRACE0( "In WatchComm Thread--------------------\n" );
		dwEvtMask = 0 ;
		WaitCommEvent( m_hComm, &dwEvtMask, NULL );

		if( slLock.Lock( 0 ) )
		{
			switch( m_nEvtType )
			{
				case 0 :
					if( (dwEvtMask & EV_RXCHAR) == EV_RXCHAR ) DataReceived();
					break;
				case 1 :
					if( (dwEvtMask & EV_RXFLAG) == EV_RXFLAG ) DataReceived();
					break;
			}
			slLock.Unlock();
		}
	}
	CloseHandle( os.hEvent );

	return TRUE;
}

//---------------------------------------------------------------------------
// Event ߻Ͽ data ޴ Լ(Evnet : EV_RXCHAR, EV_RXFLAG)
//---------------------------------------------------------------------------
void CMuxCom2::DataReceived()
{
	UINT uLen = Read( m_sReceivedData.GetBuffer( GAP_MAX_BYTE ), GAP_MAX_BYTE );
	m_sReceivedData.ReleaseBuffer();
	if( uLen <= 0 )	return;

	m_evCommReceived.SetEvent();
}

//--------------------------------------------------------------------
// PC <= MUX : "01A+0000.000\r"	: channel 1
//			   "02A+0000.000\r"	: channel 2
//			   ...
//			   "01A+0000.000\r02A+0000.000\r03A+0000.000\r04A+0000.000\r"	: Channel All
//--------------------------------------------------------------------
BOOL CMuxCom2::IsCommRcvd()
{
	BOOL bRcvd = FALSE;
	CSingleLock slCommReceived( &m_evCommReceived );
	
	slCommReceived.Lock( 0 );
	bRcvd = slCommReceived.IsLocked();
	if( bRcvd ) 
		m_evCommReceived.ResetEvent();
	return bRcvd;
}

//--------------------------------------------------------------------
//  Data Parsingϴ Լ
//--------------------------------------------------------------------
CString& CMuxCom2::ParseData(CString sData)
{
	if( sData.GetLength() < 12 ) m_sParseData = "0.00";
	else
	{
		double dRes = atof( sData.Mid( 3, 9 ) );
		m_sParseData.Format( "%.2f", dRes );
	}

	return m_sParseData;
}

//--------------------------------------------------------------------
// PC => MUX : "1\r"	: channel 1
//			   "2\r"	: channel 2
//			   ...
//			   "A\r"	: Channel All
//--------------------------------------------------------------------
BOOL CMuxCom2::SendCommand( char ch )
{
	BOOL bRv = FALSE;
	m_sSendData.Format( "%c\r", ch );
	bRv = Write( m_sSendData.GetBuffer(m_sSendData.GetLength()), m_sSendData.GetLength() );
	m_sSendData.ReleaseBuffer();
	return bRv;
}

BOOL CMuxCom2::SendCommand( CString sCmd )
{
	BOOL bRv = FALSE;
	m_sSendData.Format( "%C%s%C", ccSTX, sCmd, ccETX );
	bRv = Write( m_sSendData.GetBuffer( m_sSendData.GetLength() ), m_sSendData.GetLength() );
	m_sSendData.ReleaseBuffer();
	return bRv;
}
