// XCCLink.h: interface for the XCCLink class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XCCLINK_H__2F99FDA2_FA82_4256_8716_5F0847396D8A__INCLUDED_)
#define AFX_XCCLINK_H__2F99FDA2_FA82_4256_8716_5F0847396D8A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct tagADDR_INFO_CCLINK
{
	int nDevType;
	int nStartAddr;
	int nSize;
} ADDR_INFO_CCLINK;

class XCCLink
{
public:
	XCCLink();
	virtual ~XCCLink();

public:
	BOOL Open(int nChannel, int nMode);
	BOOL Close();
	BOOL Monitor( short nNetNo, short nStNo );

	BOOL SendBit( short nNetNo, short nStNo, short nDevNo, short nData );
	short ReceiveBit( short nNetNo, short nStNo, short nDevNo );

	BOOL Send( short nNetNo, short nStNo, short nDevNo, short nData, short nSize = 1 );
	BOOL Receive( short nNetNo, short nStNo, short nDevNo, short& nData, short nType, short nSize = 1 );

	BOOL RandR( short nNetNo, short nStNo, short* nDev, short* nData, short nSize );
	BOOL RandR32( short nNetNo, short nStNo, short nDevNo, short* nData, short nType );
	BOOL RandW( short nNetNo, short nStNo, short* nDev, short* nData, short nSize );

	void ReadErrorCode();

private:
	long m_lPath;

public:
	int	m_nAlarmCode;
	int m_nState;
	BOOL m_bIsOpen;
	CMap < int, int, CString, LPCTSTR > m_mapError;

	enum linkSTATE
	{
		linkNone,
		linkNormal,
		linkError,
	};

	enum devTYPE 
	{
		devX = 1,			//	1		DevX	X
		devY = 2,			//	2		DevY	Y
		devL = 3,			//	3		DevL	L
		devM = 4,			//	4		DevM	M
		devSM = 5,			//	5		DevSM	Special MSB(link special B for MELSECNET/10,/H,CC-Link IE Controller Network or CC-Link)
		devF = 6,			//	6		DevF	F
		devTT = 7,			//	7		DevTT	T(contact)
		devTC = 8,			//	8		DevTC	T(coil)
		devCT = 9,			//	9		DevCT	C(contact)
		devCC = 10,			//	10		DevCC	C(coil)
		devTN = 11,			//	11		DevTN	T(current value)
		devCN = 12,			//	12		DevCN	C(current value)
		devD = 13,			//	13		DevD	D
		devSD = 14,			//	14		DevSD	Special DSW(link special W for MELSECNET/10,/H,CC-Link IE Controller Network or CC-Link)
		devTM_T = 15,		//	15		DevTM	T(setting value main)
		devTS_T = 16,		//	16		DevTS	T(setting value sub1)
		devTS2_T = 16002,	//	16002	DevTS2	T(setting value sub2)
		devTS3_T = 16003,	//	16003	DevTS3	T(setting value sub3)
		devCM_C = 17,		//	17		DevCM	C(setting value main)
		devTS_C = 18,		//	18		DevTS	C(setting value sub1)
		devTS2_C = 18002,	//	18002	DevTS2	C(setting value sub2)
		devTS3_C = 18003,	//	18003	DevTS3	C(setting value sub3)
		devA = 19,			//	19		DevA	A
		devZ = 20,			//	20		DevZ	Z
		devV = 21,			//	21		DevV	V(index register)
		devR = 22,			//	22		DevR	R *8
		devZR = 220,		//	220		DevZR	ZR *8
							//	22000~22256	DevER0~256	Extend R *5 *8The argument value of device name setting (0-256*6):Block No.
		devB = 23,			//	23	DevB	B	
		devW = 24,			//	24	DevW	W
		devQSB = 25,		//	25	DevQSB	Q/QnA link special relay(Q/QnACPUup)
		devSTT = 26,		//	26	DevSTT	Retentive timer
		devSTC = 27,		//	27	DevSTC	Retentive timer
		devQSW = 28,		//	28	DevQSW	Q/QnA link special register(Q/QnACPUup)
		devQV = 30,			//	30	DevQV	Q/QnA edge relay(Q/QnACPUup)
		devSTN = 35,		//	35	DevSTN	Retentive timer
		devFS = 40,			//	40	DevFS	S(FxCPU)
		devMAIL = 101,		//	101	DevMAIL	Q/QnA SEND function(arrival acknowledgement  required) or RECV function *7
		devMAILNC = 102,	//	102	DevMAILNC	Q/QnA SEND function(arrival acknowledgement not required) *7
							//	1001~1255	DevLX1~255	Direct link inputThe argument value of device name setting (1-255*6):Network No.
							//	2001~2255	DevLY1~255	Direct link outputThe argument value of device name setting (1-255*6):Network No.
							//	23001~23255	DevLB1~255	Direct link relayThe argument value of device name setting (1-255*6):Network No.
							//	24001~24255	DevLW1~255	Direct link registerThe argument value of device name setting (1-255*6):Network No.
							//	25001~25255	DevLSB1~255	Direct link special relay(network unit side)The argument value of device name setting (1-255*6):Network No.
							//	28001~28255	DevLSW1~255	Direct link special register(network unit side)The argument value of device name setting (1-255*6):Network No.
							//	29000~29255	DevSPG0~255	Special direct buffer registerThe argument value of device name setting (0-255*6): Start I/O No./ 16
							//	31000~31255	DevEM0~255	EM(shared device)
							//	32000~32255	DevED0~255	ED(shared device)	
		devRBM = -32768,	//	-32768	DevRBM	Buffer memory*1
		devRAB = -32736,	//	-32736	DevRAB	Random access buffer*1
		devRX = -32735,		//	-32735	DevRX	link input*1
		devRY = -32734,		//	-32734	DevRY	link output*1
		devRW = -32732,		//	-32732	DevRW	link register*1
		devSB = -32669,		//	-32669	DevSB	link special relay*1
		devSW = -32668,		//	-32668	DevSW	link special register*1
		devMRB = 33,		//	33	DevMRB	Own station random access buffer*2
		devWw = 36,			//	36	DevWw	Own station link register(send)*2
		devWr = 37,			//	37	DevWr	Own station link register(receive)*2
		devSPB = 50,		//	50	DevSPB	Own station buffer memory*3
							//	501~504	DevSPB 1~4	PLC common memory*4
	};
	short m_nBufSize;			// Bit count of reading data store area (buf[0]~buf[6])*2 = 7
	short* m_nReadData;			// Data that are read out.
								// buf[0] = 0;	OFF all of M100~M113 (It can store bit information of 16 points)
								// buf[1] = 10;	current value of D10
								// buf[2] = 200;	current value of D11
								// buf[3] = 300;	current value of D12
								// buf[4] = 400;	current value of D13
								// buf[5] = 0x3FFF;	all bits of M0~M13 are ON
								// buf[6] = 10;	current value of T10 is 10(1second)
	static ADDR_INFO_CCLINK m_AddrInfo[];
};

#endif // !defined(AFX_XCCLINK_H__2F99FDA2_FA82_4256_8716_5F0847396D8A__INCLUDED_)