// XChannel.h: interface for the XChannel class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XCHANNEL_H__41C586FF_2BDD_4076_AF64_2E90C2B650DA__INCLUDED_)
#define AFX_XCHANNEL_H__41C586FF_2BDD_4076_AF64_2E90C2B650DA__INCLUDED_

//#include "XCtlEtherCAT.h"	// Added by ClassView
#include "XCtlDevice.h"	// Added by ClassView
//#include "dlgtest.h"
#include "XMmc.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class XChannel //: public CDlgTest
{
public:
	CString GetConnectPoint();
	BOOL IsInitialized();
	void SetSimulationMode(BOOL bOn);
	CString GetWiringNo(CString sPrefix);
	int GetNo();
	int GetNodeNo();
	void Create();
	int GetCurrConnectedObjectNo();
	int AddConnectingObjectName(CString sName);
	BOOL Delete(int nAdd);
	void SetNodeNo(int nNode);
	void Create(XCtlDevice * pDevice, int nAdd, int nNode, int nNo, CString sName, CString sCpoint = "");
	void SetDevice(XCtlDevice * pDevice);
	void SetAddress(int nNo);
	void SetName(CString sName);
	int GetAddress();
	CString GetName();
	void SetDeviceLink(BOOL bLink);
	BOOL IsDeviceLink();
	////////////////////////////////////////MMC IO///////////
	void SetMmcLink( XMmc* pMmc, int nAxisNo, DWORD dEventSource );
	BOOL IsMmcLink();

	XChannel();
	virtual ~XChannel();
protected:
	static BOOL m_bSimulation;
	BOOL m_bInitialized;
	XCtlDevice *	m_pDevice;
	////////////////////////////////////////MMC IO///////////
	XMmc*			m_pMmc;
	BOOL			m_bIsMmcInput;
	int				m_nAxisNo;
	DWORD			m_dMmcEventSource;
	
protected:
	int m_nNo;
	BOOL RemoveConnectedObjectName(CString sName);
	CArray<CString, CString> m_arConnectedObjectNames;
	CString m_sName;
	int m_nAddress;
	int m_nNodeNo;
	CString m_sCpoint;
	BOOL m_bDeviceLink;
	BOOL IsActive();
};

#endif // !defined(AFX_XCHANNEL_H__41C586FF_2BDD_4076_AF64_2E90C2B650DA__INCLUDED_)
