// XCtlCCLink.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "XCtlCCLink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// XCtlCCLink

IMPLEMENT_DYNCREATE(XCtlCCLink, CWinThread)

XCtlCCLink::XCtlCCLink()
{
	m_bAutoDelete	= FALSE;
	m_pOwner		= NULL;

	m_hDead = CreateEvent( NULL, TRUE, FALSE, NULL );	// MANUAL Reset, Initial state = non-signal
	m_hKill = CreateEvent( NULL, TRUE, FALSE, NULL );


	InitParameter();
}

XCtlCCLink::~XCtlCCLink()
{
	CloseHandle( m_hDead );
	CloseHandle( m_hKill );
}

BOOL XCtlCCLink::InitInstance()
{
	while( WaitForSingleObject( m_hKill, 0 ) != WAIT_OBJECT_0 ) 
	{
		Sleep( 10 );
		Watch();
	}

	VERIFY( SetEvent( m_hDead ) );
	return FALSE;
}

int XCtlCCLink::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(XCtlCCLink, CWinThread)
	//{{AFX_MSG_MAP(XCtlCCLink)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// XCtlCCLink message handlers
BOOL XCtlCCLink::Start( CWnd* pOwner, int nChannel, int nMode )
{
	m_pOwner = pOwner;

	short rv = Open( nChannel, nMode );
	CreateThread();

	return rv;
}

BOOL XCtlCCLink::End()
{
	// Exit the thread
	if( m_hThread )
	{
		VERIFY( SetEvent( m_hKill ) );

		// When ExitInstance function calls, it is signaled.
		VERIFY( WaitForSingleObject( m_hDead, INFINITE ) == WAIT_OBJECT_0 );
		VERIFY( WaitForSingleObject( m_hThread, INFINITE ) == WAIT_OBJECT_0 );
		Sleep(200);
	}

	DWORD exitCode;
	if( !GetExitCodeThread( m_hThread, &exitCode ) )
	{
		if( GetLastError() == STILL_ACTIVE )
		{
			TerminateThread( m_hThread, -1 );
			Sleep( 200 );
			if( !GetExitCodeThread( m_hThread, &exitCode ) )
				AfxMessageBox( "Windows ϰ ý  OFFϿ ֽʽÿ.", MB_ICONSTOP | MB_SYSTEMMODAL | MB_OK );
		}
	}

	Close();
	return TRUE;
}

void XCtlCCLink::InitParameter()
{
	m_NetworkInfo.nNetworkNo = 3;
	m_NetworkInfo.nStationNo = 2;
	m_NetworkInfo.nUpStationNo = 1;	// 1
	m_NetworkInfo.nDnStationNo = 1;	// 1

	m_NetworkInfo.nUpNetworkNo = 4;	// 3
	m_NetworkInfo.nDnNetworkNo = 4;	// 3
}

void XCtlCCLink::Watch()
{
	Sleep( 1 );
	Monitor( m_NetworkInfo.nNetworkNo, m_NetworkInfo.nStationNo );
}

void XCtlCCLink::Msg( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if( m_pOwner == NULL ) return;

	m_pOwner->PostMessage( uMsg, wParam, lParam );
}

void XCtlCCLink::SetMelsecParameter(short nNetworkNo, short nStationNo, 
									short nUpNetworkNo, short nUpStationNo, 
									short nDnNetworkNo, short nDnStationNo )
{
	m_NetworkInfo.nNetworkNo = nNetworkNo;
	m_NetworkInfo.nStationNo = nStationNo;

	m_NetworkInfo.nUpNetworkNo = nUpNetworkNo;	// 3
	m_NetworkInfo.nUpStationNo = nUpStationNo;	// 1

	m_NetworkInfo.nDnNetworkNo = nDnNetworkNo;	// 3
	m_NetworkInfo.nDnStationNo = nDnStationNo;	// 1
}

void XCtlCCLink::UpdateState()
{
	if( m_nState == linkError )
	{
		//Msg( WM_HOST_LOG, 0, (LPARAM)(LPCTSTR) m_nAlarmCode );
	}
	else if( m_nState == linkNormal )
	{
	}
	else
	{
	}
}