//---------------------------------------------------------------------
// Copyright		: DMS Co., Ltd
// File Name		: XCtlDeviceNet.h
// Modified Date	: 2001.01.26
// Version			: Ver1.0
// Programmer		: Kim Dongsoo
// Description		: Interface for the CCtlDeviceNet class.
//					XDio   IO Accessϱ Ͽ 
//---------------------------------------------------------------------

#if !defined(AFX_XCTLDEVICENET_H__F5DFBB53_F343_11D4_9245_000086500CF9__INCLUDED_)
#define AFX_XCTLDEVICENET_H__F5DFBB53_F343_11D4_9245_000086500CF9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// XCtlDeviceNet.h : header file
//

#define WM_DEVICENET_MONITOR	 WM_USER + 1

#include "XDeviceNet.h"
typedef struct
{
	unsigned short wMac_id;
	unsigned short wAddr;
	unsigned short wBit;
} IO_BUFFER;

/////////////////////////////////////////////////////////////////////////////
// XCtlDeviceNet thread

class XCtlDeviceNet : public CWinThread, public XDeviceNet
{
	DECLARE_DYNCREATE(XCtlDeviceNet)
public:
	XCtlDeviceNet();           // protected constructor used by dynamic creation
	virtual ~XCtlDeviceNet();

// Attributes
public:
	BYTE** m_pInBuf;
	BYTE** m_pOutBuf;

	UINT* m_pPointDI;  
	UINT* m_pPointDO;
	UINT* m_pPointAI;
	UINT* m_pPointAO;
	UINT* m_pPointPC;

	int * m_pOldAdc;
	BOOL* m_pFirstVal;

	float * m_pFilterGain;

	struct aiInfo
	{
		int nAdcMax;
		int nAdcMin;
		float fRealMax;
		float fRealMin;
		int nLoLimit;
		int nUpLimit;
		int nLoWarning;
		int nUpWarning;
		BOOL bUseInterlock;
		BOOL bUseWarning;
		CString sName;
		CString	sUnitName;
		int nScale;
	} * m_aiInfo;
	struct aiInfo * m_aiInfoDefault;

	enum _aiSensorType
	{
		enPG35,		
		enDW_605,		
		enSENSYS,		
		enJLK_25,		
		enULK_25,		
		enCKD_FLOW,	
		enPT100OHM,	
		enLEVEL_GAGE,		
		enMAX_SENSOR_TYPE
	};

	enum _aiScale{
		scaleCOMMON,
		scaleLOG,
		scaleLOG10,
	};
	
	static AI_PRESET m_aiPreSet[enMAX_SENSOR_TYPE];


	int m_nAiNo;

// Operations
public:
	WORD GetPulseCnt(UINT uNo);
	void SetAiCalScale(int nID, int nScale = scaleCOMMON );
	void SetFilterGain(int nID, float f);
	void GetFilterGain(int nID, float& f);
	WORD GetAoValue(UINT uNo);
	void ResetInNodeAll();
	void SetRawAI(int nID, float fVal);
	void SetDiState(UINT no, BOOL bState);
	void SetAioValue(UINT uNo, WORD wValue);
	void GetWarningPara(int nID, BOOL &bSet, int &nUpWarning, int &nLoWarning);
	void SetWarningPara(int nID, BOOL bSet, int nUpWarning, int nLoWarning);
	void GetInterlockPara(int nID, BOOL &bSet, int &nUpLimit, int &nLoLimit);
	void SetInterlockPara(int nID, BOOL bSet, int nUpLimit, int nLoLimit);
	CString GetAiName( int nID );
	void SetAiName( int nID, CString sName );
	CString GetAiUnitName( int nID );
	void SetAiUnitName( int nID, CString sName );
	void Watch();
	void SetOwner(CWnd *pOwner);
	void Msg(UINT uMsg,  WPARAM wParam, LPARAM lParam);
	void ResetOutNodeAll();
	void ResetOutNode(UINT uNode);
	void SetCalPara(int nID, float fRealMax, float fRealMin, int nAdcMax, int nAdcMin);
	void GetCalPara(int nID, float& fRealMax, float& fRealMin, int& nAdcMax, int& nAdcMin, BOOL bDefault = FALSE, int nSensorType = 0 );
	float GetCalAI(int nID);

	BOOL Start(CWnd* pOwner, UINT uMaxNode, UINT* pPointAI, UINT* pPointAO, 
		UINT* pPointDI, UINT* pPointDO, UINT* pPointPC = NULL );
	BOOL End();
	BOOL GetDoState(UINT uNo);
	BOOL DioRead(UINT uNo);
//	BOOL DioRead();
	BOOL ReadData();
	BOOL DioWrite(UINT uNo, BOOL bState);
	int AioRead(UINT uNo);
	BOOL AioWrite(UINT uNo, WORD wValue);

	IO_BUFFER IoNo2AddrBit(UINT uNo, int nKind);

	UINT GetMaxNode() { return m_uMaxNode; }

	enum deviceIO
	{
		PC,
		DI,
		DO,
		AI,
		AO
	};

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(XCtlDeviceNet)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
protected:
	CWnd*	m_pOwner;
	HANDLE	m_hDead;
	HANDLE	m_hKill;

	// Generated message map functions
	//{{AFX_MSG(XCtlDeviceNet)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XCTLDEVICENET_H__F5DFBB53_F343_11D4_9245_000086500CF9__INCLUDED_)
