// XDigitalInput.cpp: implementation of the XDigitalInput class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "XDigitalInput.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
XDigitalInput::XDigitalInput()
{	
	m_bBContact = FALSE;
}

XDigitalInput::~XDigitalInput()
{

}

BOOL XDigitalInput::Get()
{
	BOOL bVal = FALSE;
	if( IsMmcLink() )
	{
#ifndef _MY_DEBUG
		INT nSource = axis_source( m_nAxisNo );
		bVal = ( nSource & m_dMmcEventSource ) ? 1 : 0;
#endif
	}
	else if( IsActive() )
	{
		bVal = m_pDevice->DioRead( m_nAddress );
		/*
		if( m_bBContact )
		bVal = !bVal;
		return bVal;*/
		
#ifndef _MY_DEBUG
		if( GetConnectPoint() == "B" )
#else
		if( 0 )
#endif
		{
			return ( bVal ? 0 : 1 );
		}
		else
		{
			return ( bVal ? 1 : 0 );
		}
	}

	return bVal;
}

void XDigitalInput::SetBContact(BOOL bContact)
{
	m_bBContact = bContact; 
}

BOOL XDigitalInput::IsBContact()
{
	return m_bBContact;
}

void XDigitalInput::SetState( BOOL bState)
{
	if( !IsMmcLink() )
		m_pDevice->SetDiState( m_nAddress, bState );
}
