// XEtherCAT.h: interface for the XEtherCAT class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XETHERCAT_H__2ECDEFC4_5E1E_4E74_AD25_DB180DBE57DA__INCLUDED_)
#define AFX_XETHERCAT_H__2ECDEFC4_5E1E_4E74_AD25_DB180DBE57DA__INCLUDED_

#include "..\TwinCat\TcAdsDef.h"
#include "..\TwinCat\TcAdsAPI.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class XEtherCAT  
{
public:
	XEtherCAT();
	virtual ~XEtherCAT();

	BOOL TcAdsWrite(unsigned long indexGroup, unsigned long indexOffset, unsigned long length, BYTE *Data);
	BOOL TcAdsRead(unsigned long indexGroup, unsigned long indexOffset, unsigned long length, BYTE Data[]);
	void TcAdsClose();
	BOOL TcAdsOpen(int AMSPORT);
	BOOL Monitor();
	BOOL TcStart();
	BOOL TcStop();

public:
	ITcSystemServerPtr m_TcComServer;

private:
	long			m_nErr, m_nPort;
	AmsAddr			m_Addr;
	PAmsAddr		m_pAddr;
		
	BOOL m_bOpen;
	BOOL m_bActive;

protected:
	static	CString m_sAdsState[];  // EtherCAT ° ִ 迭
	CString	m_sCurAdsState;  // DeviceNet ¸ Ÿ 
	long	m_nAdsState;
};

#endif // !defined(AFX_XETHERCAT_H__2ECDEFC4_5E1E_4E74_AD25_DB180DBE57DA__INCLUDED_)
