// XEuv.cpp: implementation of the XEuv class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "XEuv.h"

#include "..\Dics.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

XEuv::XEuv()
{

}

XEuv::~XEuv()
{

}

//---------------------------------------------------------------------------
// EUV Lamp On
//---------------------------------------------------------------------------
BOOL XEuv::LampOn( BOOL bOn )
{
	int nRv;

	if( bOn )
	{
		doIF_GSUV_LAMP_ON( ON );
		nRv = dosIF_GSUV_LAMP_ON;
	}
	else 
	{
		doIF_GSUV_LAMP_ON( OFF );
		nRv = !dosIF_GSUV_LAMP_ON;
	}
	return nRv;
}

//---------------------------------------------------------------------------
// Get EUV Status
//---------------------------------------------------------------------------
int XEuv::GetLampStatus()
{
	int nReturnLampStatus = 0;

	if ( diIF_GSUV_AUTO_MODE ) nReturnLampStatus |= euvREMOTE_MODE; // Remote Mode
	if ( diIF_GSUV_UV_MONITOR_READY ) nReturnLampStatus |= euvMONITOR_READY;				//   
	if ( diIF_GSUV_DATA_SET_ENABLE ) nReturnLampStatus |= euvDATA_SET_ENABLE;			//  

	return nReturnLampStatus;
}

//---------------------------------------------------------------------------
// Get EUV Alarm
//---------------------------------------------------------------------------
int XEuv::GetLampAlarm()
{
	int nRv = 0;

	if( diIF_GSUV_OVER_HEAT )		nRv |= euvAlmOverHeat;		// Lamp Over Heater Alarm
	if( diIF_GSUV_HOUSE_OPEN )		nRv |= euvAlmLampHouseOpen; // Lamp House Open Alarm
	if( diIF_GSUV_LAMP_FAULT )		nRv |= euvAlmLampFault;		// Lamp Fault Alarm
	if( diIF_GSUV_INVERTER_ERROR )  nRv |= euvAlmInverterErr;	// Inverter Alarm
	if( diIF_GSUV_UTILITY_ERROR )	nRv |= euvAlmUtilityErr;	// Utility Alarm   
	if( diIF_GSUV_N2_FLOW_ERROR )	nRv |= euvAlmN2Err;			// N2 Alarm
	if( diIF_GSUV_SUM_ERROR )		nRv |= euvAlmSumErr;		// EUV SUM Alarm 
	
	return nRv;
}

/////////////////////////////////////////////////////////////////////////
// Lamp  
////////////////////////////////////////////////////////////////////////

void XEuv::SetLampOnSelect( int nLampNo, BOOL bState )
{
	dogIF_GSUV_LAMP_SELECT( nLampNo, bState );
}


void XEuv::SetIntensityCheckPosition(int nPos)
{
	if ( nPos == -1 )
	{
		doIF_GSUV_MONITOR_LAMP_SELECT1( OFF );
		doIF_GSUV_MONITOR_LAMP_SELECT2( OFF );
		doIF_GSUV_MONITOR_LAMP_SELECT3( OFF );
	}

	if ( nPos == 0 )
	{
		doIF_GSUV_MONITOR_LAMP_SELECT1( ON );
		doIF_GSUV_MONITOR_LAMP_SELECT2( OFF );
		doIF_GSUV_MONITOR_LAMP_SELECT3( OFF );
	}
	else if ( nPos == 1 )
	{
		doIF_GSUV_MONITOR_LAMP_SELECT1( OFF );
		doIF_GSUV_MONITOR_LAMP_SELECT2( ON );
		doIF_GSUV_MONITOR_LAMP_SELECT3( OFF );
	}
	else if ( nPos == 2 )
	{
		doIF_GSUV_MONITOR_LAMP_SELECT1( ON );
		doIF_GSUV_MONITOR_LAMP_SELECT2( ON );
		doIF_GSUV_MONITOR_LAMP_SELECT3( OFF );
	}
	else if ( nPos == 3 )
	{
		doIF_GSUV_MONITOR_LAMP_SELECT1( OFF );
		doIF_GSUV_MONITOR_LAMP_SELECT2( OFF );
		doIF_GSUV_MONITOR_LAMP_SELECT3( ON );
	}
	else if ( nPos == 4 )
	{
		doIF_GSUV_MONITOR_LAMP_SELECT1( ON );
		doIF_GSUV_MONITOR_LAMP_SELECT2( OFF );
		doIF_GSUV_MONITOR_LAMP_SELECT3( ON );
	}
	else if ( nPos == 5 )
	{
		doIF_GSUV_MONITOR_LAMP_SELECT1( OFF );
		doIF_GSUV_MONITOR_LAMP_SELECT2( ON );
		doIF_GSUV_MONITOR_LAMP_SELECT3( ON );
	}

}

BOOL XEuv::IntensityCheck(BOOL bOn)
{
	if( bOn )
	{
		doIF_GSUV_DATA_SET( ON );
	}
	else doIF_GSUV_DATA_SET( OFF );

	return TRUE;
}