// XEuv.h: interface for the XEuv class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XEUV_H__56EBBC19_02F9_4695_8575_266EBDC8DB7E__INCLUDED_)
#define AFX_XEUV_H__56EBBC19_02F9_4695_8575_266EBDC8DB7E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#include "XCtlDevice.h"

class XEuv		// : public CObject  
{
public:
	XEuv();
	virtual ~XEuv();

	void SetDevice( XCtlDevice* pDevice ) { m_pDevice = pDevice; }
	
	BOOL LampOn( BOOL bOn = TRUE );
	BOOL LampRemote( BOOL bOn = TRUE );
	BOOL LampLocalLock( BOOL bOn = TRUE );
	BOOL LampEmg( BOOL bOn = TRUE );
	BOOL IntensityCheck( BOOL bOn = TRUE );

	int	GetLampStatus();
	int GetLampAlarm();

	CString GetLastError() { return m_sErrorMessage; }

public:
	BOOL GetInitialCount();
	void SetInitialCount( BOOL bInitialCount = FALSE );
	void SetLampOnSelect( int nLampNo, BOOL bState );	
	void SetIntensityCheckPosition( int nPos );

	int GetRadStab();
	int GetLampOverIntegration();
	XCtlDevice* m_pDevice;

	CString m_sErrorMessage;  

	enum euvSTATUS
	{
		euvREMOTE_MODE		= 0x01,
		euvMONITOR_READY	= 0x02,
		euvDATA_SET_ENABLE	= 0x04,
	};

	enum euvALARMINDEX
	{
		// GS 
		euvAlmOverHeat		 = 0x01, // Over heat
		euvAlmLampHouseOpen  = 0x02, // House Open
		euvAlmLampFault	     = 0x04, // Lamp Fault
		euvAlmInverterErr    = 0x08, // Inverter Error
		euvAlmUtilityErr     = 0x10, // Utility Error
		euvAlmN2Err		     = 0x20, // N2 Error
		euvAlmSumErr	     = 0x40, // Sum Error
	};

	enum euvINTERGRATION
	{
		euvINTERGULA1 = 0x01,
		euvINTERGULA2 = 0x02,
		euvINTERGULA3 = 0x04,
	};

	enum euvSTABILIZE 
	{
		euvSTABLE = 0x01,
		euvUNSTABLE = 0x02,
	};

	enum euvLAMPSELECT
	{
		euvLAMPSELULS1,
		euvLAMPSELULS2,
		euvLAMPSELULS3,
		euvLAMPALL
	};
};

#endif // !defined(AFX_XEUV_H__56EBBC19_02F9_4695_8575_266EBDC8DB7E__INCLUDED_)
