// XKM100.cpp: implementation of the CXKM100 class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "XKM100.h"
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXKM100::CXKM100()
{
	m_fTotalPower = 0.f;
	m_fCurrentPower = 0.f;
	m_bSendCommand = FALSE;
	m_bTotalPower	= FALSE;
	m_bCurrentPower	= FALSE;
	m_nControlStatus	= 0;
	m_nSeqPowerCheck	= 0;
}

CXKM100::~CXKM100()
{

}

// Response Frames			sTx|Node No|Sub address|End code|Response Text|ETX|BCC|   // BCC USE, NoUse choice
//							  1|   2   | 2         | 2      |             | 1 | 1 |
//	Response Text			MRC|SRC|Response Code|Read Data|		// variable area
//                           2 |  2|     4       | 4~8     |

void CXKM100::DataReceived()
{
	if( !m_bSendCommand )
		return;
	else
		m_bSendCommand = FALSE;
	
	char buf[256] ="";
	Sleep( 500 );	// test complete 20100824
	
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	//int nLen = XComm::Read( buf, 40 );
	int nLen = XComm::Read( buf, 60 ); 
	m_sReceivedData = CString( buf );
	int nData = m_sReceivedData.GetLength();
//	SetLog( "RCVD1", 0, 0, m_sReceivedData );

  	//if( nLen > 0 && nData == 24 )
	if( nLen > 0 && nData == 56 || nData == 57 )
	{
//		SetLog( "RCVD2", 0, 0, m_sReceivedData );

		CString sBuf = "";
		CString sBuf1 = "";
		int nSdata = 0;
		sBuf1 = m_sReceivedData.Mid( 15, 8 );
		nSdata = HexaString2Integer( sBuf1 );
		sBuf1.Format( "%d", nSdata );
		m_fCurrentPower = (float)( atof( sBuf1 ) / 100.0 );

		// test complete 20100824
		sBuf1 = m_sReceivedData.Mid( 47, 8 );
		nSdata = HexaString2Integer( sBuf1 );
		sBuf1.Format( "%d", nSdata );
		m_fTotalPower = (float)(atof( sBuf1) / 10.0 );

		pView->m_pDicsData->m_GenInfo.bDataRecvCheck = FALSE;
	}
	else pView->m_pDicsData->m_GenInfo.nDataCheckCount++;
/*			else if( buf[19] == ccETX )		// for km100 status check
			{
				m_sReceivedData = CString( buf );
				CString sBuf = "";
				sBuf = m_sReceivedData.Mid( 11, 4 );	// 091007 ssm
				if( sBuf == "0000" )
				{
					CString sBuf1;
					//  Data
					sBuf1 = m_sReceivedData.Mid( 15, 2 );
					if( sBuf1 == "00")
					{
						//normal
						m_nControlStatus = 1;
					}
					else
					{
						// 01 Stop
						m_nControlStatus = 2;
					}
				}
			}
*/
	m_bSendCommand = FALSE;
}

void CXKM100::SetLog(CString sSeqName, int nPortNo, int nSlotNo, CString sMessage)
{
	// Log
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	m_sMessage.Format( "FLOW\t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( m_sMessage );

	m_sMessage.Format( "%s : %s", sSeqName, sMessage );
	Msg( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) m_sMessage );
}

//// Command Frames  STX|unit No|sub address|SID|Command Text|ETX|BCC|  // BCC can choice of ( Use, No use )
////               1byte| 2     |   2       | 1 |     16     | 1 | 1 |
////								00		  0
//// Command Text    MRC|SRC|Parameter type|read start address|bit Position|Number of element|
////                   2| 2 |		2      |         4        |   2        |      4          |
//// read variable	  01| 01|									 00
void CXKM100::SendCommand(int nNo)
{
	int nBCC = 0;
	CString sData = "";
	FlushTx();

	static int nCount = 0;

	switch( nNo )
	{
	case 0:
		{
			sData.Format( "010000601%C", ccETX );
			nBCC = GetBCC( sData );
			m_sSendData.Format( "%C010000601%C%C", ccSTX, ccETX, nBCC );
			m_bSendCommand = Write( (LPCTSTR)m_sSendData );
		}
		break;
	case 1:
		{
			// 0005 element No 0 ~ 5
			sData.Format( "010000101C00004000005%C", ccETX ); //test complete 20100824
			nBCC = GetBCC( sData );
			m_sSendData.Format( "%C010000101C00004000005%C%C", ccSTX, ccETX, nBCC ); //test complete 20100824
			m_bSendCommand = Write( (LPCTSTR)m_sSendData );
		}
		break;
	case 2:
		{		
			sData.Format( "010000101C00008000000%C", ccETX );
			nBCC = GetBCC( sData );
			m_sSendData.Format( "%C010000101C00008000001%C%C", ccSTX, ccETX, nBCC );
			m_bSendCommand = Write( (LPCTSTR)m_sSendData );
		}
		break;
	case 3:
		{
			if( nCount < 1 )
			{
				sData.Format( "010000101C00004000000%C", ccETX );
				nBCC = GetBCC( sData );
				m_sSendData.Format( "%C010000101C00004000001%C%C", ccSTX, ccETX, nBCC );
				m_bSendCommand = Write( (LPCTSTR)m_sSendData );
				nCount++; 
			}
			else
			{
				sData.Format( "010000101C00008000001%C", ccETX );
				nBCC = GetBCC( sData );
				m_sSendData.Format( "%C010000101C00008000001%C%C", ccSTX, ccETX, nBCC );
				m_bSendCommand = Write( (LPCTSTR)m_sSendData );
				nCount = 0;
			}
		}
		break;
	}
	return;
}

void CXKM100::Reset()
{
	m_fTotalPower = 0.f;
	m_fCurrentPower = 0.f; 
}

int CXKM100::HexaString2Integer(CString sHex)
{
	int nRv = 0, nV;
	CString sTemp;
	for( int i = 0 ; i < sHex.GetLength() ; i ++ )
	{
		nV = sHex.GetAt( i );
		if( nV >= 'A' && nV <= 'F' )
		{
			nRv += (int) pow( (float)0x10, ( sHex.GetLength() - ( i + 1 ) ) ) * ( nV - 'A' + 0xA );
		}
		else if( nV >= 'a' && nV <= 'f' )
		{
			nRv += (int) pow( (float)0x10, ( sHex.GetLength() - ( i + 1 ) ) ) * ( nV - 'a' + 0xA );
		}
		else if( nV >= '0' && nV <= '9' )
		{
			nRv += (int) pow( (float)0x10, ( sHex.GetLength() - ( i + 1 ) ) ) * ( nV - '0' );
		}
	}
	return nRv;
}

int CXKM100::GetBCC( CString sData )
{
	int nBCC = 0;
	int nVal = 0;
	int nSize = sData.GetLength();
	
	for( int i=0 ; i<nSize ; i++ )
	{
		nVal = sData.GetAt( i );
		
		if( i == 0 )
		{
			nBCC = nVal;
		}
		else
		{
			nBCC = nBCC ^ nVal;
		}
	}
	
	return nBCC;
}

void CXKM100::SeqPowerCheck()
{
	int nSeqNo = m_nSeqPowerCheck;
	static DWORD dwTickStart = 0;

	switch( nSeqNo ) 
	{
	case 0 :
		{
			// Status check
//			SendCommand( 0 );		// 
			dwTickStart = GetTickCount();
			nSeqNo = 10;
		}
		break;

	case 10:
		if( GetTickCount() - dwTickStart > 5000 )
		{
			//	Effective instantaneous power (kW)
			SendCommand( 1 );
			dwTickStart = GetTickCount();
			nSeqNo = 20;
		}
		break;

	case 20:
		if( GetTickCount() - dwTickStart > 5000 )
		{
			// Total power consumption(kWh)
			SendCommand( 2 );
			dwTickStart = GetTickCount();
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqPowerCheck = nSeqNo; 
}