// XKM100.h: interface for the CXKM100 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CXKM100_H__020B74A6_26E5_4A7B_91B2_A81AE31AB3B3__INCLUDED_)
#define AFX_CXKM100_H__020B74A6_26E5_4A7B_91B2_A81AE31AB3B3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "XCommThread.h"
#include "DicsData.h"

class CXKM100 : public XCommThread  
{
public:
	void DataReceived();
	void SetDeviceNet( XCtlDevice * pDevice ){ m_pDevice = pDevice; }
	CXKM100();
	virtual ~CXKM100();

	enum ControlCharacters {
		ccSTX = 0x02,		// Start Byte
		ccETX = 0x03,		// End Byte
		ccENQ = 0x05,		// Request to Send
		ccEOT = 0x04,		// Request to Receive
		ccACK = 0x06,		// Correct Reception
		ccNAK = 0x15,		// Incorrect Reception		
	};

	enum _TERMINATE_CODE{
		ccOK = 0x11,
		ccNG = 0x0F,
	};

public:
	void Reset();
	void SendCommand( int nNo );
	void SetLog(CString sSeqName, int nPortNo, int nSlotNo, CString sMessage);
	float	m_fTotalPower;			// Total power consumption(kWh) · 
	float	m_fCurrentPower;		// Effective instantaneous power (kW) ȿ ð
    BOOL	m_bTotalPower;
    BOOL	m_bCurrentPower;
	int		m_nControlStatus;		// 20100708 ssm
	BOOL	m_bSendCommand;
	CString m_sSendData;
	int HexaString2Integer(CString sHex);
	void SeqPowerCheck();			// 20100708 ssm
	int		m_nSeqPowerCheck;		// 20100708 ssm
	int GetBCC( CString sData );	// 20100813 ssm

	XCtlDevice* m_pDevice;
};

#endif // !defined(AFX_CXKM100_H__020B74A6_26E5_4A7B_91B2_A81AE31AB3B3__INCLUDED_)
