// XKdyA.cpp: implementation of the CXKdyA class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "XKdyA.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXKdyA::CXKdyA()
{
	for( int i = 0;  i < constDataNum; i++)
	{
		nCurData[i] = 0;
	}

	m_bSendCommand = FALSE;

	m_sCheckSum = "";
	m_sSendData = "";
}

CXKdyA::~CXKdyA()
{

}

void CXKdyA::DataReceived()
{
	if( !m_bSendCommand )
		return;
	else
		m_bSendCommand = FALSE;
	char buf[256];

	memset(buf, 0x00, 256);
	Sleep( 10 );

		int nLen = XComm::Read( buf, 101 );

	if( nLen > 0 )
	{
		if( buf[0] == ccSTX )
		{
			if( buf[97] == ccETX )

			{
				m_sReceivedData = CString( buf );

				CString sBuf;
				CString sValue;
				CString sHex;

				//  Data
				sBuf = m_sReceivedData.Mid(5, 40);

				int index = 0;
				int number;
				for( int i = 0; i < 10; i++)
				{
					sValue = sBuf.Mid(0 + (i * 4), 4);

					HexToDecimal( sValue.GetBuffer(), number );
					sValue.ReleaseBuffer();
					nCurData[index++] = number;
				}

				sBuf = m_sReceivedData.Mid(45, 16);
				sValue = sBuf.Mid(0, 8);
				HexToDecimal( sValue.GetBuffer(), number );
				sValue.ReleaseBuffer();
				nCurData[index++] = number;
				sValue = sBuf.Mid(8, 8);
				HexToDecimal( sValue.GetBuffer(), number );
				sValue.ReleaseBuffer();
				nCurData[index++] = number;

				sBuf = m_sReceivedData.Mid(61, 12);
				for( int i = 0; i < 3; i++)
				{
					sValue = sBuf.Mid(0 + (i * 4), 4);

					HexToDecimal( sValue.GetBuffer(), number );
					sValue.ReleaseBuffer();
					nCurData[index++] = number;
				}
			}
		}
	}
}
//  A function that does this

bool CXKdyA::HexToDecimal (char* HexNumber, int& Number)
{ 
	char* pStopString; 
	Number = strtol (HexNumber, &pStopString, 16);
	return (bool)(Number != LONG_MAX);
}

void CXKdyA::SetLog(CString sSeqName, int nPortNo, int nSlotNo, CString sMessage)
{
	// Log
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	m_sMessage.Format( "VA_METER\t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( m_sMessage );

	m_sMessage.Format( "%s : %s", sSeqName, sMessage );
	Msg( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) m_sMessage );
}

void CXKdyA::SendCommand()
{
	FlushTx();

	m_sCheckSum = "00FFWR0D000017";

	int bcc  = 0;


	// SumCheck ó ۵Ǵ Control ڵ带   Data ASCII ڵ尪   16  ڸ ASCIIڵ ȯѰ..
	for( int i = 0; i < m_sCheckSum.GetLength(); i++)
	{
		bcc += m_sCheckSum[i];
	}

	char lowBcc = (char)(bcc & 0x00FF);			//   :  Ʈ 
	//char highBcc = (char)((bcc >> 8) & 0x00FF);	//   :  Ʈ

	// 16  ڸ
	CString sHex = "";
	sHex.Format("%X", lowBcc);

	m_sSendData.Format( "%C%s%s", ccENQ, m_sCheckSum, sHex);
	m_bSendCommand = Write( (LPCTSTR)m_sSendData );
	return;
}

void CXKdyA::Reset()
{
	for( int i = 0;  i < 15; i++)	// 231220 halesu OverRead Fix
	{
		nCurData[i] = 0;
	}
}

USHORT CXKdyA::CRC16(unsigned char *puchMsg, USHORT usDataLen)
{
	USHORT crc, flag;
	crc = 0xffff;
	while(usDataLen--)
	{
		crc ^= *puchMsg++; // ^ : XOR
		for (USHORT i = 0 ; i < 8 ; i++)
		{
			flag = crc & 0x0001;
			crc >>= 1;
			if(flag) crc ^= 0xA001;
		}
	}
	crc = ((crc >> 8) & 0x00ff) + ((crc << 8) & 0xff00);
	return crc;
}