// XKdyA.h: interface for the CXKdyA class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XKdyA_H__020B74A6_26E5_4A7B_91B2_A81AE31AB3B3__INCLUDED_)
#define AFX_XKdyA_H__020B74A6_26E5_4A7B_91B2_A81AE31AB3B3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "XCommThread.h"
#include "..\FactoryLib\EqpAssy.h"
#include <vector>

#define	DEVICE_ADDRESS	0

class CXKdyA : public XCommThread  
{
public:
	void DataReceived();
	void SetDeviceNet( XCtlDevice * pDevice ){ m_pDevice = pDevice; }
	CXKdyA();
	virtual ~CXKdyA();

	static int const constDataNum = 15;
	int		m_nTerminateCode;
	int nCurData[constDataNum];
	BOOL	m_bSendCommand;
	CString m_sSendData;
	CString m_sCheckSum;

	enum ControlCharacters {
		ccSTX = 0x02,		// Start Byte
		ccETX = 0x03,		// End Byte
		ccENQ = 0x05,		// Request to Send
		ccEOT = 0x04,		// Request to Receive
		ccACK = 0x06,		// Correct Reception
		ccNAK = 0x15,		// Incorrect Reception		
	};

	enum _TERMINATE_CODE{
		ccOK = 0x11,
		ccNG = 0x0F,
	};

	CEqpAssy*			m_pEqpAssy;
	XCtlDevice* m_pDevice;
	void SetEqpAssy( CEqpAssy* pEqpAssy )						{ m_pEqpAssy = pEqpAssy; }

public:
	USHORT	CRC16(unsigned char *puchMsg, USHORT usDataLen);
	bool HexToDecimal (char* HexNumber, int& Number);

	void Reset();
	void SendCommand();
	void SetLog(CString sSeqName, int nPortNo, int nSlotNo, CString sMessage);
};

#endif // !defined(AFX_VAFLOWMETER_H__020B74A6_26E5_4A7B_91B2_A81AE31AB3B3__INCLUDED_)
