// XLT300.h: interface for the XLT300 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XLT300_H__B708C414_FF3D_4A69_A1CE_F30BC388EAF3__INCLUDED_)
#define AFX_XLT300_H__B708C414_FF3D_4A69_A1CE_F30BC388EAF3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "XCommThread.h"
#define MAX_LT300_NO	2

class XLT300 : public XCommThread  
{
public:
	int HexaString2Integer(CString sHex);
	CString GetCommandResult(CString sCommand);
	int GetCurPvValue(int nSlaveAddress);
	int GetCurSvValue(int nSlaveAddress);
	int GetLRC(int nValue);
	int SetSvValue(int nSlaveAddress, int nSv);
	int m_nSlaveAddress;
	int m_nFunctionCode;
	int m_nDataSection;
	int m_nErrorCheck;
	int m_nMessage;

	float * m_fCurSvValue;
	float * m_fCurPvValue;

	CString m_sSendData;

	CArray <CString, CString> m_arSendData;

	enum _FUNC_CODE{
		fncdGET_DIGITAL_PARA = 1,
		fncdGET_DIGITAL_INPUT_DATA,
		fncdGET_ANALOG_PARA,
		fncdGET_ANALOG_INPUT_DATA,
		fncdSET_DIGITAL_PARA,
		fncdSET_ANALOG_PARA,
		fncdSEND_RCVD_DATA,
		fncdSET_DIGITAL_PARAS = 15,
		fncdSET_ANALOG_PARAS
	};

	enum _REF_NO{
		refDIGITAL_PARA = 1,
		refDIGITAL_INPUT_DATA = 10001,
		refANALOG_INPUT_DATA = 30001,
		refANALOG_PARA = 40001
	};

	enum _PARAMETER{
		paraAUTO_TUNNING = 101,
		paraRJ_ERROR	= 10004,
		paraDI1_STATUS	= 10009,
		paraDI2_STATUS	= 10010,
		paraEV1_STATUS1	= 10117,
		paraEV1_STATUS2,
		paraEV2_STATUS1,
		paraEV2_STATUS2,
		paraEV3_STATUS1,
		paraEV3_STATUS2,
		paraPV			= 30101,
		paraPV_STATUS,
		paraSV,
		paraSV_STATUS,
		paraMV1,
		paraMV1_STATUS,
		paraMV2,
		paraMV2_STATUS,
		paraEX_SV,
		paraEX_EV1,
		paraEX_EV2,
		paraEX_EV3,
		paraEX_P_GAIN	= 30114,
		paraEX_I_GAIN,
		paraEX_D_GAIN,
		paraEX_NO		= 30124,
		paraEV_STATUS	= 30142,
		paraSV1			= 40201,
		paraREMOTE_SV1	= 49512,
	};
	XLT300();
	virtual ~XLT300();

protected:
	void DataReceived();
};

#endif // !defined(AFX_XLT300_H__B708C414_FF3D_4A69_A1CE_F30BC388EAF3__INCLUDED_)
