// XLog.cpp: implementation of the XLog class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "XLog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define MAX_DAYS	30

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

XLog::XLog()
{
	m_nLenCnt = 0;
	m_sFileName.Empty();
	m_fileLog.m_hFile = NULL;
	m_nStampType = stampDateTime;
	m_bEnable = TRUE;
}

XLog::~XLog()
{
	Close();
}

XLog::XLog( LPCTSTR lpszName, int nStampType, BOOL bAppended )
{
	m_nLenCnt = 0;
	m_fileLog.m_hFile = NULL;
// m_bEnable = FALSE;
	m_bEnable = TRUE;
	
	CTime time = CTime::GetCurrentTime();
	CString sDate = time.Format(_T("%Y-%m-%d"));
	
// CString szDateTime = time.Format(_T("%y%m%d%H%M%S"));

	m_nStampType = nStampType;
	m_sName = CString( lpszName );

	CString sTemp = _T("");
	sTemp.Format( "%sLog", _DICS_ROOT );
//	CreateDirectory("D:\\DICS\\Log",NULL);	
	CreateDirectory(sTemp,NULL);	

#ifdef _USE_DATE_DIR
	CString sPath;

//	sPath.Format( "D:\\DICS\\Log\\Log[%s]", sDate );
	sPath.Format( "%sLog\\Log[%s]", _DICS_ROOT, sDate );
	CreateDirectory( sPath, NULL );

	m_sFileName.Format( "%s\\%s(%s).log", sPath, m_sName, sDate );
	m_sDate = time.Format( _T( "%m%d" ) );
#else
//	m_sFileName.Format( "D:\\DICS\\Log\\%s(%s).log", m_sName, sDate );
	m_sFileName.Format( "%sLog\\%s(%s).log", _DICS_ROOT, m_sName, sDate );
	m_sDate = time.Format( _T( "%m%d" ) );
#endif

	if( bAppended )
	{
		if( !m_fileLog.Open( m_sFileName, CFile::modeReadWrite | CFile::shareDenyNone ) ) //  File  FALSE return
		{
			m_fileLog.Open( m_sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone );
		}
		try
		{
			if( m_fileLog.m_hFile != m_fileLog.hFileNull ) 
			{
				if( m_fileLog.m_hFile ) m_fileLog.SeekToEnd(); // file pointer 
			}
		}
		catch( CFileException* pEX )
		{
			pEX->Delete();
		}
	}
	else
	{
		m_fileLog.Open( m_sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone );
	}

	RemoveFile();
}

XLog::XLog( LPCTSTR lpszDir, LPCTSTR lpszName, int nStampType, BOOL bAppended )
{
	m_nLenCnt = 0;
	m_fileLog.m_hFile = NULL;
//	m_bEnable = FALSE;
	m_bEnable = TRUE;
	
	CTime time = CTime::GetCurrentTime();
	CString sDate = time.Format(_T("%Y-%m-%d"));
//	CString szDateTime = time.Format(_T("%y%m%d%H%M%S"));

	m_nStampType = nStampType;
	m_sName = CString( lpszName );

	CreateDirectory( lpszDir, NULL );

	CString sNewDir;
//	sNewDir.Format( "D:\\DICS\\%s\\%s", lpszDir, sDate );
	sNewDir.Format( "%s%s\\%s", _DICS_ROOT, lpszDir, sDate );
	CreateDirectory( sNewDir, NULL );
	
	//m_sFileName.Format( "%s\\%s%s.log", lpszDir, m_sName, sDate );
	m_sFileName.Format( "%s\\%s(%s).log", sNewDir, m_sName, sDate );
	m_sDate = time.Format( _T( "%m%d" ) );

	if( bAppended )
	{
		if( !m_fileLog.Open( m_sFileName, CFile::modeReadWrite | CFile::shareDenyNone ) ) //  File  FALSE return
		{
			m_fileLog.Open( m_sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone );
		}
		try
		{
			if( m_fileLog.m_hFile != m_fileLog.hFileNull ) 
			{
				if( m_fileLog.m_hFile ) m_fileLog.SeekToEnd();	// file pointer 
			}
		}
		catch( CFileException* pEX )
		{
			pEX->Delete();
		}
	}
	else
	{
		m_fileLog.Open( m_sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone );
	}
	RemoveFile();
}

//------------------------------------------------------------------------------------
// Log ȭ  .
//------------------------------------------------------------------------------------
int XLog::NewFile(BOOL bAppended)
{
	try
	{
		if( m_fileLog.m_hFile != m_fileLog.hFileNull )
		{
			m_fileLog.Close();
		}
		else
		{
			TRACE( "!!!!!!!!!!!!!!!!!! Assertion Failed !!!!!!!!!!!!!!!!!!!" );
		}
	}
	catch( CFileException* pEX )
	{
		pEX->Delete();
	}

	m_bEnable = TRUE;

	CTime time = CTime::GetCurrentTime();
	CString sDate = time.Format(_T("%Y-%m-%d"));
	
//	CString szDateTime = time.Format(_T("%y%m%d%H%M%S"));
//	m_sFileName.Format( "log\\%s%s.log", m_sName, sDate );
	

#ifdef _USE_DATE_DIR
	CString sPath;

//	sPath.Format( "D:\\DICS\\Log\\Log[%s]", sDate );
	sPath.Format( "%sLog\\Log[%s]", _DICS_ROOT, sDate );
	CreateDirectory( sPath, NULL );

	m_sFileName.Format( "%s\\%s(%s).log", sPath, m_sName, sDate );
	m_sDate = time.Format( _T( "%m%d" ) );
#else
//	m_sFileName.Format( "D:\\DICS\\Log\\%s(%s).log", m_sName, sDate );
	m_sFileName.Format( "%sLog\\%s(%s).log", _DICS_ROOT, m_sName, sDate );
	m_sDate = time.Format( _T( "%m%d" ) );
#endif

	if( bAppended )
	{
		if( !m_fileLog.Open( m_sFileName, CFile::modeReadWrite | CFile::shareDenyNone ) ) //  File  FALSE return
		{
			m_fileLog.Open( m_sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone );
			return -1;
		}

		try
		{
			if( m_fileLog.m_hFile != m_fileLog.hFileNull ) 
			{
				m_fileLog.SeekToEnd(); // file pointer 
			}
		}
		catch( CFileException* pEX )
		{
			pEX->Delete();
		}
	}
	else
	{
		m_fileLog.Open( m_sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone );
	}

	return 0;
}

//------------------------------------------------------------------------------------
// Log ȭ OpenѴ.
//------------------------------------------------------------------------------------
int XLog::OpenFile( LPCTSTR lpszName, int nStampType )
{
	CTime time = CTime::GetCurrentTime();
//	CString sDateTime = time.Format(_T("%y%m%d%H%M%S"));
	CString sDate = time.Format(_T("%Y-%m-%d"));

	m_nStampType = nStampType;
	m_sName = CString( lpszName );
//	m_sFileName.Format( "D:\\DICS\\log\\%s(%s).log", m_sName, sDate );
	m_sFileName.Format( "%slog\\%s(%s).log", _DICS_ROOT, m_sName, sDate );

	if( !m_fileLog.Open( m_sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone ) )
	{
		return -1; // Error() : File Open Error
	}

	return 0;
}

//------------------------------------------------------------------------------------
// Log ȭ CloseѴ.
//------------------------------------------------------------------------------------
void XLog::Close()
{
	try
	{
		if( m_fileLog.m_hFile != m_fileLog.hFileNull ) 
		{
			m_fileLog.Close();
		}
	}
	catch( CFileException* pEX )
	{
		pEX->Delete();
	}
}

//------------------------------------------------------------------------------------
// Log ȭϿ ڿ .
//------------------------------------------------------------------------------------
void XLog::TextOut(LPCTSTR lpszStr, int nStampType)
{
	if( !m_bEnable ) return;

//	if( ++m_nLenCnt > 1000 ) m_nLenCnt=0, NewFile();

//	If a day is changed, we have to create a new file.
	COleDateTime time = COleDateTime::GetCurrentTime();
	CString sDate;
	sDate.Format( "%02d%02d", time.GetMonth(), time.GetDay() );

	if( sDate.Compare( m_sDate ) != 0 ) 
	{
		NewFile();
		RemoveFile();
	}

	CString sBuf( lpszStr );
		
//	COleDateTime tm = COleDateTime::GetCurrentTime();
//	CString sDateTime = tm.Format(_T("%Y/%m/%d %H:%M:%S"));

	SYSTEMTIME SystemTime;
	GetLocalTime(&SystemTime);
	CString sDateTime;
	sDateTime.Format("%4d/%02d/%02d %02d:%02d:%02d'%03d",
		SystemTime.wYear, 
		SystemTime.wMonth, 
		SystemTime.wDay, 
		SystemTime.wHour, 
		SystemTime.wMinute, 
		SystemTime.wSecond, 
		SystemTime.wMilliseconds );
	
	if( sBuf != "" )
		sBuf = sDateTime + "\t" + sBuf;
		
	try
	{
		if( m_fileLog.m_hFile != m_fileLog.hFileNull ) 
		{
			m_fileLog.Write( sBuf + "\r\n", sBuf.GetLength()+2 );
		}
	}
	catch( CFileException* pEX )
	{
		pEX->Delete();
	}
}

void XLog::TimeStampOut()
{
	CTime time = CTime::GetCurrentTime();
	CString sDateTime = time.Format(_T("\r\n%Y/%#m/%#d(%a) %X\r\n\r\n"));

	try
	{
		if( m_fileLog.m_hFile != m_fileLog.hFileNull ) 
		{
			m_fileLog.Write( sDateTime, sDateTime.GetLength() );
		}
	}
	catch( CFileException* pEX )
	{
		pEX->Delete();
	}
}

void XLog::HexOut( void *pszBuf, int nLength )
{
	int i, j;
	char ch;
	CString sTmp, sOut;
//	if( ++m_nLenCnt > 1000 ) m_nLenCnt=0, NewFile();
	for( i=0; i*16 <= nLength; i++ )
	{
		sOut = "\t";
		// Hexa Code Area
		for( j=0; j < 16; j++ )
		{
			if( i*16+j >= nLength ) break;
			sTmp.Format( "%02x %s", ((char*)pszBuf)[i*16+j]&0xff, (j==7)?" ":"" );
			sOut += sTmp;
		}
		// Empty Area
		if( j < 16 )
		{
			for( ; j < 16; j++ )
			{
				sOut += "    ";
			}
		}			
		// Character Area
		for( j=0; j < 16; j++ )
		{
			if( i*16+j >= nLength ) break;
			ch = ((char*)pszBuf)[i*16+j];
			if( ch < 0x20 || ch > 0x80 ) ch = '.';
			sTmp.Format( "%c", ch );
			sOut += sTmp;
		}
		TextOut( (LPCTSTR)sOut, XLog::stampNoDateTime );
	}
}

void XLog::Enable(BOOL bEnable)
{
	m_bEnable = bEnable;
}

BOOL XLog::IsEnable()
{
	return m_bEnable;
}

//------------------------------------------------------------------------------
//  Log ȭ notepad ش.
//------------------------------------------------------------------------------
void XLog::Show()
{
	WinExec( "notepad.exe " + m_sFileName, SW_SHOW );
}

//------------------------------------------------------------------------------
// hjyou Coding :: Remove File before 30 days.
//------------------------------------------------------------------------------
int XLog::RemoveFile()
{
	// set the current directory to ".\Log"
	// SetCurrentDirectory( ".\\Log" );
#ifdef _USE_DATE_DIR
	CTime CurTime = CTime::GetCurrentTime();

	CTime time = CTime::GetCurrentTime();
	CString sDate = time.Format(_T("%Y-%m-%d"));	

	CFileFind FileFind;
	CString  sFile;
	CString  sPath;

//	sFile.Format( "D:\\DICS\\Log\\*.*" );
	sFile.Format( "%sLog\\*.*", _DICS_ROOT );

	WIN32_FIND_DATA DirData;
	HANDLE hDir;
		

	hDir = FindFirstFile((LPCTSTR) sFile, &DirData);
		
	//2004.06.23 Kim Youngsik =>
	//MAX_DAYS  Directory ã´...
	do
	{
		CString sFileName = DirData.cFileName; 
		if (DirData.dwFileAttributes && FILE_ATTRIBUTE_DIRECTORY)
		{
			if( sFileName != "." && sFileName != ".." )
			{
				CString  strDate;
				CFileStatus FileStatus;
				CFile File;

//				sFileName = "D:\\DICS\\Log\\" + sFileName;
				CString sTemp = _T("");
				sTemp.Format( "%sLog\\", _DICS_ROOT );
				sFileName = sTemp + sFileName;
				File.GetStatus( sFileName, FileStatus );
				CTime FileTime = FileStatus.m_mtime;

				CTimeSpan Diff = CurTime - FileTime;
				if( Diff.GetDays() > MAX_DAYS )
				{
					sPath = sFileName;
				}
			}
		}
	} while( FindNextFile(hDir, &DirData) );
	FindClose( hDir );
	//2004.06.23 Kim Youngsik <=
		
	sFile.Format( "%s\\*.log", sPath);

	// ã Directory Ʒ  File ...
	if( sPath != "" )
	{ 	
		HANDLE hFile;
		WIN32_FIND_DATA FileData;

		hFile = FindFirstFile((LPCTSTR) sFile, &FileData);
		if( hFile != (void*) 0xffffffff )
		{ 
			do
			{
				CString sFileName = FileData.cFileName; //FileFind.GetFileName();
				CFileStatus FileStatus;
				CFile File;
				CString sFullName;

//				sFileName = sPath + sFileName;
				sFullName.Format( "%s\\%s", sPath, sFileName );
				File.GetStatus( sFileName, FileStatus );
				CTime FileTime = FileStatus.m_ctime;

				CTimeSpan Diff = CurTime - FileTime;
				if( Diff.GetDays() > MAX_DAYS )
				{
					TRY
					{
						File.Remove( sFullName );
					}
					CATCH( CFileException, e )
					{
#ifdef _DEBUG
						afxDump << "File" << sFullName << "cannot be removed \n";
#endif
					}
					END_CATCH
				}
			}
			while( FindNextFile(hFile, &FileData) );
		}

		FindClose( hFile );
		RemoveDirectory( sPath ); //    Directory ...
	}
#else
	CTime CurTime = CTime::GetCurrentTime();

	CString sFile;
	CString sPath;

	CFileFind FileFind;
	BOOL bResult = FileFind.FindFile( ".\\Log\\*.log" );	

	//2005.05.16 =>
	if( !bResult )
	{
		FileFind.Close();
		return 0;
	}
	//2005.05.16 <=

	while( FileFind.FindNextFile() )
	{
		CString sFileName = FileFind.GetFileName();
		CFileStatus FileStatus;
		CFile File;

		sFileName = ".\\Log\\" + sFileName;
		File.GetStatus( sFileName, FileStatus );
		CTime FileTime = FileStatus.m_mtime;

		CTimeSpan Diff = CurTime - FileTime;

		if( Diff.GetDays() > MAX_DAYS )
		{
			TRY
			{
				File.Remove( sFileName );
			}
			CATCH( CFileException, e )
			{
#ifdef _DEBUG
				afxDump << "File" << sFileName << "cannot be removed \n";
#endif
			}
			END_CATCH
		}
	}
	FileFind.Close();
#endif
	return 0;
}
