// XLog.h: interface for the XLog class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LOG_H__1A4A3D05_AF25_11D3_BAEA_00600834616E__INCLUDED_)
#define AFX_LOG_H__1A4A3D05_AF25_11D3_BAEA_00600834616E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define _USE_DATE_DIR

class XLog : public CObject  
{
public:
	XLog();
	XLog( LPCTSTR lpszName, int nStampType = stampDateTime, BOOL bAppended = TRUE );
	XLog( LPCTSTR lpszDir, LPCTSTR lpszName, int nStampType = stampDateTime, BOOL bAppended = TRUE );
	virtual ~XLog();

public:
	int RemoveFile();
	int NewFile( BOOL bAppended = TRUE );
	int OpenFile( LPCTSTR lpszName, int nStampType = stampDateTime );

	BOOL IsEnable();

	void Show();
	void Enable( BOOL bEnable=TRUE );
	void Close();
	void HexOut( void *pszBuf, int nLength );
	void TimeStampOut();
	void TextOut( LPCTSTR lpszStr, int nStampType = stampDateTime );

	CString m_sName;
	CString m_sFileName;
	CString m_sDate;

	enum _LogStampType 
	{
		stampNoDateTime,
		stampDateTime
	};

protected:
	int m_nLenCnt;
	int m_nStampType;

	BOOL m_bEnable;

	CFile m_fileLog;
private:
};

extern XLog DetLog;
extern XLog Log;
extern XLog ManuLog;
#endif // !defined(AFX_LOG_H__1A4A3D05_AF25_11D3_BAEA_00600834616E__INCLUDED_)
