// XMelsec.cpp: implementation of the XMelsec class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "XMelsec.h"
#include "..\Melsec\mdfunc.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
ADDR_INFO XMelsec::m_AddrInfo[] = 
{
	// hskwak 2019.05.31
	{ devB, 0x0030, 16 },	// RBT->CLN		0x0030 ---> 0x003F
	{ devB, 0x0090, 16 },	// CLN->OHCV	0x0090 ---> 0x009F
	{ devB, 0x00A0, 16 },	// CLN->RBT		0x00A0 ---> 0x00AF
	{ devB, 0x00E0, 16 },	// OHCV->CLN	0x00E0 ---> 0x00EF

	{ devW, 0x0A00, 1},		// RBT->CLN		CST_PORT_NO
	{ devW, 0x0A01, 1},		// RBT->CLN		CST_SLOT_NO
	{ devW, 0x0A02, 7},		// RBT->CLN		GLASS_ID
	{ devW, 0x0A09, 8},		// RBT->CLN		RECIPE_ID
	{ devW, 0x0A11, 1},		// RBT->CLN		PROCESS_FLAG
	{ devW, 0x0A12, 3},		// RBT->CLN		CAS_ID
	{ devW, 0x0A15, 7},		// RBT->CLN		LOT_ID
	{ devW, 0x0A1C, 2},		// RBT->CLN		RESERVED

	{ devW, 0x0C00, 1},		// CLN->OHCV	CST_PORT_NO
	{ devW, 0x0C01, 1},		// CLN->OHCV	CST_SLOT_NO
	{ devW, 0x0C02, 7},		// CLN->OHCV	GLASS_ID
	{ devW, 0x0C09, 8},		// CLN->OHCV	RECIPE_ID
	{ devW, 0x0C11, 1},		// CLN->OHCV	PROCESS_FLAG
	{ devW, 0x0C12, 2},		// CLN->OHCV	RESERVE

	{ devB, 0x0000, 16 },	// CIM->CLN		0x0000 ---> 0x000F
	{ devB, 0x0030, 16 },	// CIM->CLN		0x0030 ---> 0x003F
	{ devB, 0x0060, 16 },	// RBT->CLN		0x0060 ---> 0x006F
	{ devB, 0x00B0, 16 },	// CLN->RBT		0x00B0 ---> 0x00BF

	{ devW, 0x0000, 16},		// CIM->CLN		Alive Check.
	{ devW, 0x0030, 16},		// CIM->CLN		Run Mode Change Command

	{ devW, 0x0C00, 32},	// CLN->CIM		Link Signal DownStream
	{ devW, 0x0C20, 32},	// CLN->CIM		Link Signal UpStream

	{ devW, 0x0C40, 1}, 	// CLN->CIM		Alive Check.
	{ devW, 0x0C44, 1}, 	// CLN->CIM		EQ Status.
	{ devW, 0x0C45, 1}, 	// CLN->CIM		CIM Connect Status.
	{ devW, 0x0C46, 1}, 	// CLN->CIM		Control Status Mode.
	{ devW, 0x0C47, 1}, 	// CLN->CIM		EQ Run Mode.

	{ devW, 0x0C50, 1}, 	// CLN->CIM		Position Data Unit Port #1
	{ devW, 0x0C51, 1}, 	// CLN->CIM		Position Data Unit Slot #1
	{ devW, 0x0C52, 1}, 	// CLN->CIM		Position Data Unit Port #2
	{ devW, 0x0C53, 1}, 	// CLN->CIM		Position Data Unit Slot #2
	{ devW, 0x0C54, 1}, 	// CLN->CIM		Position Data Unit Port #3
	{ devW, 0x0C55, 1}, 	// CLN->CIM		Position Data Unit Slot #3
	{ devW, 0x0C56, 1}, 	// CLN->CIM		Position Data Unit Port #4
	{ devW, 0x0C57, 1}, 	// CLN->CIM		Position Data Unit Slot #4
	{ devW, 0x0C58, 1}, 	// CLN->CIM		Position Data Unit Port #5
	{ devW, 0x0C59, 1}, 	// CLN->CIM		Position Data Unit Slot #5
	{ devW, 0x0C5A, 1}, 	// CLN->CIM		Position Data Unit Port #6
	{ devW, 0x0C5B, 1}, 	// CLN->CIM		Position Data Unit Slot #6
	{ devW, 0x0C5C, 1}, 	// CLN->CIM		Position Data Unit Port #7
	{ devW, 0x0C5D, 1}, 	// CLN->CIM		Position Data Unit Slot #7
	{ devW, 0x0C5E, 1}, 	// CLN->CIM		Position Data Unit Port #8
	{ devW, 0x0C5F, 1}, 	// CLN->CIM		Position Data Unit Slot #8
	
	{ devW, 0x0C60, 1}, 	// CLN->CIM		Alarm Level
	{ devW, 0x0C61, 1}, 	// CLN->CIM		Alarm Type
	{ devW, 0x0C62, 1}, 	// CLN->CIM		Alarm code
	{ devW, 0x0C63, 40}, 	// CLN->CIM		Alarm Text;
	
	{ devW, 0x0C8D, 1}, 	// CLN->CIM		Run Mode Change
	
	{ devW, 0x0C90, 1}, 	// CLN->CIM		Panel Remove PortNo
	{ devW, 0x0C91, 1}, 	// CLN->CIM		Panel Remove SlotNo
};

XMelsec::XMelsec()
{
	m_nDevType = 0;	// The device type that are selected in MELSECNET data library 
	m_nDevNo = 0;     // device number    
	m_lPath = 0;		// 
	m_nMode = 0;		// mode data by own card form registry
	m_nStNo = 0;		// the station number to set in MELSEC data library
	m_nChannel = 0;		// Channel is a communication medium to communicate between computers
	m_nAlarmCode = 0;
	m_nPlcForm = 0;
	m_nBufSize = 0;
	m_nControlCode = 0;

	m_nReadData = NULL;
	m_nReadDataBuf =NULL; // 2009.02.27 minhan
}

XMelsec::~XMelsec()
{
// 011-9491-2204
}

BOOL XMelsec::Open(int nChannel, int nMode)
{
	int nRv;

	// Assign the memory
	int nLen = sizeof( m_AddrInfo ) / sizeof( ADDR_INFO );
	for( int i=0; i<nLen; i++ ) 
	{
		if( m_AddrInfo[i].nDevType == devB ) m_nBufSize += ( m_AddrInfo[i].nSize - 1 ) / 16 + 1;
		else if( m_AddrInfo[i].nDevType == devW ) m_nBufSize += m_AddrInfo[i].nSize;
	}
	m_nReadData = new short[m_nBufSize];
    m_nReadDataBuf = new short[m_nBufSize]; // 2009.02.27 minhan
	// short	ret;		return value				OUT
	// long		*path;		opened loop path pointer
	// short	channel;	path of channel				IN
	// short	mode;		dummy(select -1)			IN
	if( ( nRv = mdOpen( nChannel, nMode, &m_lPath ) ) != 0 )
	{
		CString sError;
		m_nAlarmCode = nRv;
		sError.Format( "MELSEC-NET10 : mdOpen error [%d]", nRv );
		AfxMessageBox( sError );

		return FALSE;
	}
	return TRUE;
}

BOOL XMelsec::Close()
{
	int nRv;

	// Release the memory
	if( m_nReadData != NULL ) delete []m_nReadData; m_nReadData = NULL;
    if( m_nReadDataBuf != NULL ) delete []m_nReadDataBuf; m_nReadDataBuf = NULL; // 2009.02.27 minhan

	// short	ret;	return value	OUT
	if( ( nRv = mdClose( m_lPath ) ) != 0 )
	{
		CString sError;
		m_nAlarmCode = nRv;
		sError.Format( "mdClose error [%d]", nRv );
		AfxMessageBox( sError );

		return FALSE;
	}
	return TRUE;
}

BOOL XMelsec::SendBit( short nNetNo, short nStNo, short nDevNo, short nData )
{
#ifdef _SIMULATE_MELSEC
	return TRUE;
#endif

	int nRv;

	// short	ret;	return value						OUT
	// long		path;	path of channel						IN
	// short	stno;	station number						IN
	//			2 Byte : Upper = Network No.
	//					 Lower = Station No. or Group No.
	// short	devtyp;	device type							IN
	// short	devno;	front device No.					IN
	// short	data;	written data (single precision)		IN
	int nStationNo = nStNo + ( nNetNo << 8 );
	if( nData )
	{
		if( ( nRv = mdDevSet( m_lPath, nStationNo, devB, nDevNo ) ) != 0 )
		{
			CString sError;
#ifdef _MEL_ALARM
			m_nAlarmCode = nRv;
			sError.Format( "mdDevSet error [%d]", nRv );
			AfxMessageBox( sError );
#endif
			return FALSE;
		}
	}
	else
	{
		if( ( nRv = mdDevRst( m_lPath, nStationNo, devB, nDevNo ) ) != 0 )
		{
			CString sError;
#ifdef _MEL_ALARM
			m_nAlarmCode = nRv;
			sError.Format( "mdDevRst error [%d]", nRv );
			AfxMessageBox( sError );
#endif
			return FALSE;
		}
	}

	return TRUE;
}

BOOL XMelsec::SendWord( short nNetNo, short nStNo, short nDevNo, short nData )
{
#ifdef _SIMULATE_MELSEC
	return TRUE;
#endif

	int nRv;
	short nSize = 2;	// 2 bytes

	// short	ret;	return value						OUT
	// long		path;	path of channel						IN
	// short	stno;	station number						IN
	// short	devtyp;	device type							IN
	// short	devno;	front device No.					IN
	// short	data;	written data (single precision)		IN
	int nStationNo = nStNo + ( nNetNo << 8 );

	if( ( nRv = mdSend( m_lPath, nStationNo, devW, nDevNo, &nSize, &nData ) ) != 0 )
	{
		CString sError;
#ifdef _MEL_ALARM
		m_nAlarmCode = nRv;
		sError.Format( "mdSend error [%d]", nRv );
		AfxMessageBox( sError );
#endif
		return FALSE;
	}
	return TRUE;
}


BOOL XMelsec::ReceiveBit( short nNetNo, short nStNo, short nDevNo, short& nData )
{
#ifdef _SIMULATE_MELSEC
	return TRUE;
#endif

	// Find the address
	int nLen = sizeof( m_AddrInfo ) / sizeof( ADDR_INFO );
	int nIndex = 0;
	for( int i=0; i<nLen; i++ )
	{
		if( m_AddrInfo[i].nDevType == devB && 
			( nDevNo >= m_AddrInfo[i].nStartAddr && nDevNo < m_AddrInfo[i].nStartAddr + m_AddrInfo[i].nSize ) )
		{
			// Send the bit data
			nData = m_nReadData[nIndex];
			return TRUE;
		}

		if( m_AddrInfo[i].nDevType == devB ) nIndex += ( m_AddrInfo[i].nSize - 1 ) / 16 + 1;
		else if( m_AddrInfo[i].nDevType == devW ) nIndex += m_AddrInfo[i].nSize;
	}
	CString sError;
	sError.Format( "ReceiveBit Address %d is not registered", nDevNo );
	AfxMessageBox( sError );

	nData = 0;
	return FALSE;
}

short XMelsec::ReceiveBit( short nNetNo, short nStNo, short nDevNo )
{
#ifdef _SIMULATE_MELSEC
	return TRUE;
#endif

	// Find the address
	int nLen = sizeof( m_AddrInfo ) / sizeof( ADDR_INFO );
	int nIndex = 0;
	for( int i=0; i<nLen; i++ )
	{
		if( m_AddrInfo[i].nDevType == devB && 
			( nDevNo >= m_AddrInfo[i].nStartAddr && nDevNo < m_AddrInfo[i].nStartAddr + m_AddrInfo[i].nSize ) )
		{
			// Send the bit data
			return ( ( m_nReadData[nIndex] >> ( nDevNo - m_AddrInfo[i].nStartAddr ) ) & 0x0001 );
		}

		if( m_AddrInfo[i].nDevType == devB ) nIndex += ( m_AddrInfo[i].nSize - 1 ) / 16 + 1;
		else if( m_AddrInfo[i].nDevType == devW ) nIndex += m_AddrInfo[i].nSize;
	}

	CString sError;
	sError.Format( "ReceiveBit Address %d is not registered", nDevNo );
	AfxMessageBox( sError );
	return 0;
}

/*
BOOL XMelsec::ReceiveBit( short nNetNo, short nStNo, short nDevNo, short& nData )
{
#ifdef _SIMULATE_MELSEC
	return TRUE;
#endif

	int nRv;
	short nSize = 32;	// 16 bit

	// short	ret;	return value					OUT
	// long		path;	path of channel					IN
	// short	stno;	station number					IN
	// short	devtyp;	device type						IN
	// short	devno;	front device No.				IN
	// short	data[];	read data(single precision)		OUT
	short nStationNo = nStNo + ( nNetNo << 8 );

	short nDev[4];
	nDev[0] = 1;
	nDev[1] = devB;
	nDev[2] = nDevNo; //nSize * ( nDevNo / nSize );
	nDev[3] = nSize;

	if( ( nRv = mdRandR( m_lPath, nStationNo, nDev, &nData, 2 ) ) != 0 )

//	if( ( iRv = mdReceive(m_lPath, nStationNo, devB, nRealDevNo, &nSize, &nData) ) != 0 )
	{
		CString sError;
#ifdef _MEL_ALARM
		m_nAlarmCode = nRv;
		sError.Format( "mdReceive error [%d]", nRv );
		AfxMessageBox( sError );
#endif
		return FALSE;
	}

//	nData = nData & 0x0001; //( nData >> ( nDevNo % nSize ) ) & 0x01;

	return TRUE;
}

short XMelsec::ReceiveBit( short nNetNo, short nStNo, short nDevNo )
{
#ifdef _SIMULATE_MELSEC
	return TRUE;
#endif

	int nRv;
	short nSize = 16;	// 16 bit
	short nData;

	// short	ret;	return value					OUT
	// long		path;	path of channel					IN
	// short	stno;	station number					IN
	// short	devtyp;	device type						IN
	// short	devno;	front device No.				IN
	// short	data[];	read data(single precision)		OUT
	short nStationNo = nStNo + ( nNetNo << 8 );

	short nDev[4];
	nDev[0] = 1;
	nDev[1] = devB;
	nDev[2] = nDevNo; //nSize * ( nDevNo / nSize );
	nDev[3] = nSize;

	if( ( nRv = mdRandR( m_lPath, nStationNo, nDev, &nData, 2 ) ) != 0 )
//	if( ( iRv = mdReceive(m_lPath, nStationNo, devB, nRealDevNo, &nSize, &nData) ) != 0 )
	{
		CString sError;
#ifdef _MEL_ALARM
		m_nAlarmCode = nRv;
		sError.Format( "mdReceive error [%d]", nRv );
		AfxMessageBox( sError );
#endif
		return 0;
	}
	
//	nData = nData & 0x0001; //( nData >> ( nDevNo % nSize ) ) & 0x01;

//	return nData;
	return ( nData & 0x0001 );
}
*/

BOOL XMelsec::ReceiveWord( short nNetNo, short nStNo, short nDevNo, short& nData )
{
#ifdef _SIMULATE_MELSEC
	return TRUE;
#endif

	int nRv;
	short nSize = 2;	// 2 bytes

	// short	ret;	return value					OUT
	// long		path;	path of channel					IN
	// short	stno;	station number					IN
	// short	devtyp;	device type						IN
	// short	devno;	front device No.				IN
	// short	data[];	read data(single precision)		OUT
	int nStationNo = nStNo + ( nNetNo << 8 );

	if( ( nRv = mdReceive(m_lPath, nStationNo, devW, nDevNo, &nSize, &nData) ) != 0 )
	{
		CString sError;

#ifdef _MEL_ALARM
		m_nAlarmCode = nRv;
		sError.Format( "mdReceive error [%d]", nRv );
		AfxMessageBox( sError );
#endif
		return FALSE;
	}
	return TRUE;	
}

short XMelsec::ReceiveWord( short nNetNo, short nStNo, short nDevNo )
{
#ifdef _SIMULATE_MELSEC
	return TRUE;
#endif

	// Find the address
	int nLen = sizeof( m_AddrInfo ) / sizeof( ADDR_INFO );
	int nIndex = 0;
	for( int i=0; i<nLen; i++ )
	{
		if( m_AddrInfo[i].nDevType == devW && 
			( nDevNo >= m_AddrInfo[i].nStartAddr && nDevNo < m_AddrInfo[i].nStartAddr + m_AddrInfo[i].nSize ) )
		{
			// Send Data
			return m_nReadData[nIndex + nDevNo - m_AddrInfo[i].nStartAddr];
		}

		if( m_AddrInfo[i].nDevType == devB ) nIndex += ( m_AddrInfo[i].nSize - 1 ) / 16 + 1;
		else if( m_AddrInfo[i].nDevType == devW ) nIndex += m_AddrInfo[i].nSize;
	}

	CString sError;
	sError.Format( "ReceiveWord Address %d is not registered", nDevNo );
	AfxMessageBox( sError );
	return 0;
}

/*short XMelsec::ReceiveWord( short nNetNo, short nStNo, short nDevNo )
{
#ifdef _SIMULATE_MELSEC
	return TRUE;
#endif

	int nRv;
	short nSize = 2;	// 2 bytes
	short nData;

	// short	ret;	return value					OUT
	// long		path;	path of channel					IN
	// short	stno;	station number					IN
	// short	devtyp;	device type						IN
	// short	devno;	front device No.				IN
	// short	data[];	read data(single precision)		OUT
	int nStationNo = nStNo + ( nNetNo << 8 );

	if( ( nRv = mdReceive(m_lPath, nStationNo, devW, nDevNo, &nSize, &nData) ) != 0 )
	{
		CString sError;

#ifdef _MEL_ALARM
		m_nAlarmCode = nRv;
		sError.Format( "mdReceive error [%d]", nRv );
		AfxMessageBox( sError );
#endif
		return 0;
	}
	return nData;
}*/

	//////////////////////////////////////////////////////////////
// ReadString(D007000, lpszBuf, 8)
// lpszBuf = "1234abcd"
// sStr   = 32 31 34 33 62 61 64 63
short XMelsec::ReadString(short nNetNo, short nStNo, short nDevNo, LPTSTR lpszBuf, int nBufLen)
{
#ifdef _SIMULATE_MELSEC
	return 33;
#endif

	// Find the address
	int nLen = sizeof( m_AddrInfo ) / sizeof( ADDR_INFO );
	int nIndex = 0;
	int i;
	for( i=0; i<nLen; i++ )
	{
		if( m_AddrInfo[i].nDevType == devW && 
			( nDevNo >= m_AddrInfo[i].nStartAddr && nDevNo < m_AddrInfo[i].nStartAddr + m_AddrInfo[i].nSize ) )
		{
			nIndex = nIndex + nDevNo - m_AddrInfo[i].nStartAddr;
			break;
		}

		if( m_AddrInfo[i].nDevType == devB ) nIndex += ( m_AddrInfo[i].nSize - 1 ) / 16 + 1;
		else if( m_AddrInfo[i].nDevType == devW ) nIndex += m_AddrInfo[i].nSize;
	}

	// Check the address
	if( i == nLen ) 
	{
		CString sError;
		sError.Format( "ReceiveWord Address %d is not registered", nDevNo );
		AfxMessageBox( sError );
		return 0;
	}

	// Convert to string
	int nStationNo = nStNo + ( nNetNo << 8 );
	int nWord = nBufLen / 2 + nBufLen % 2;
	CString sStr;

	for( i=0; i<nWord; i++ )
	{
		short nSize = 2;
		short nData = m_nReadData[nIndex + i];

		char ch;
		ch = nData & 0x00FF;
		if( ch == 0 ) ch = ' ';
		sStr += ch;
		ch = ( nData >> 8 ) & 0x00FF;
		if( ch == 0 ) ch = ' ';
		sStr += ch;
	}

	strncpy( lpszBuf, sStr.GetBuffer(nBufLen), nBufLen );
	sStr.ReleaseBuffer();
	lpszBuf[nBufLen] = '\x0';
	return 0;
}

//////////////////////////////////////////////////////////////
CString XMelsec::Word2Ascii( short nData )
{
	CString sData = "";
	char ch;

	ch = ( nData >> 8 ) & 0x00FF;
	if( ch == 0 ) ch = ' ';
	sData += ch;

	ch = nData & 0x00FF;
	if( ch == 0 ) ch = ' ';
	sData += ch;

	return sData;
}

//////////////////////////////////////////////////////////////
short XMelsec::Ascii2Word( CString sData )
{
	short nData = 0;
	if( sData.GetLength() >= 2 )
	{
		char ch1 = sData.GetAt( 0 );
		char ch2 = sData.GetAt( 1 );
		nData = ch1 | ( ch2 << 8 );
	}
	return nData;
}

//////////////////////////////////////////////////////////////
//jemoon : 1008
CString XMelsec::Word2Binary( short nData )
{
	CString strRval = "";
	CString	strTmp;
	
	for( int i=15; i>=0; i-- )
	{
		strTmp.Format("%d", ( nData>>i ) & 0x01);
		strRval += strTmp;
		if(i%4 == 0 && i != 0) 
		{
			strRval += " ";
		}
	}

	return strRval;
}

// Hexڿ word ȯ
// jemoon : 041011
short XMelsec::Hex2Word(CString sHex)
{
	short nRval;
	::sscanf(sHex, "%x", &nRval);
	return nRval;
}

// DWORD ڿ ȯ
// jemoon : 041011
CString XMelsec::Word2Hex(short nData)
{
	CString sHex;
	sHex.Format("%04X", nData & 0x0000FFFF);
	return sHex;
}

/*
//////////////////////////////////////////////////////////////
// ReadString(D007000, lpszBuf, 8)
// lpszBuf = "1234abcd"
// sStr   = 32 31 34 33 62 61 64 63
short XMelsec::ReadString(short nNetNo, short nStNo, short nDevNo, LPTSTR lpszBuf, int nLen)
{
#ifdef _SIMULATE_MELSEC
	return 33;
#endif

	int nStationNo = nStNo + ( nNetNo << 8 );
	int nWord = nLen / 2 + nLen % 2;
	int nRv;
	CString sStr;

	for( int i=0; i<nWord; i++ )
	{
		short nSize = 2;
		short nData;
		if( ( nRv = mdReceive( m_lPath, nStationNo, devW, nDevNo + i, &nSize, &nData ) ) != 0 )
		{
			CString sError;
#ifdef _MEL_ALARM
			m_nAlarmCode = nRv;
			sError.Format( "mdReceive error [%d]", nRv );
			AfxMessageBox( sError );
#endif
			return 0;
		}

		char ch;
		ch = nData & 0x00FF;
		if( ch == 0 ) ch = ' ';
		sStr += ch;
		ch = ( nData >> 8 ) & 0x00FF;
		if( ch == 0 ) ch = ' ';
		sStr += ch;
	}

	strncpy( lpszBuf, sStr.GetBuffer(nLen), nLen );
	sStr.ReleaseBuffer();
	lpszBuf[nLen] = '\x0';
	return 0;
}*/

//////////////////////////////////////////////////////////////
// ReadString(D007000, lpszBuf, 8)
// lpszBuf = "1234abcd"
// sStr   = 32 31 34 33 62 61 64 63
short XMelsec::WriteString(short nNetNo, short nStNo, short nDevNo, CString sStr, int nLen)
{
#ifdef _SIMULATE_MELSEC
	return 0;
#endif
	int nStationNo = nStNo + ( nNetNo << 8 );
	int nWord = nLen / 2 + nLen % 2;
	int nRv;

	for( int i=0; i < nWord; i++ )
	{
		short nSize = 2;
		short nData;
		char ch1, ch2;

		if( sStr.GetLength() <= i*2 ) ch1 = 0x20;// ljy_050614 : ch1 = 0;
		else ch1 = sStr.GetAt( i*2 );

		if( sStr.GetLength() <= i*2 + 1 ) ch2 = 0x20;// ljy_050614 : ch2 = 0;
		else ch2 = sStr.GetAt( i*2 + 1 );

//		if( ch1 == ' ' ) ch1 = 0;	// ''
//		if( ch2 == ' ' ) ch2 = 0;
		if( ch1 == ' ' ) ch1 = 0x20;	// Space ״ ...........
		if( ch2 == ' ' ) ch2 = 0x20;
		if( ch1 == '\r' ) ch1 = 0x00;	// Space ״ ...........
		if( ch2 == '\r' ) ch2 = 0x00;

		nData = ( ch2 << 8 ) | ch1;

		if( ( nRv = mdSend( m_lPath, nStationNo, devW, nDevNo + i, &nSize, &nData ) ) != 0 )
		{
			CString sError;
#ifdef _MEL_ALARM
			m_nAlarmCode = nRv;
			sError.Format( "mdSend error [%d]", nRv );
			AfxMessageBox( sError );
#endif
			return 0;
		}
	}
	return 0;
}

BOOL XMelsec::DevSet( short nNetNo, short nStNo, short nDevNo )
{
	int nRv;

	// short	ret;	return value			OUT
	// long		path;	path of channel			IN
	// short	stno;	station number			IN
	// short	devtyp;	device type				IN
	// short	devno;	selected device number	IN
	int nStationNo = nStNo + ( nNetNo << 8 );

	if( ( nRv = mdDevSet( m_lPath, nStationNo, devB, nDevNo ) ) != 0 )
	{
		CString sError;
#ifdef _MEL_ALARM
		m_nAlarmCode = nRv;
		sError.Format( "mdDevSet error [%d]", nRv );
		AfxMessageBox( sError );
#endif
		return FALSE;
	}
	return TRUE;
}

BOOL XMelsec::DevRst( short nNetNo, short nStNo, short nDevNo )
{
	int nRv;

	// short	ret;	return value			OUT
	// long		path;	path of channel			IN
	// short	stno;	station number			IN
	// short	devtyp;	device type				IN
	// short	devno;	selected device number	IN
	int nStationNo = nStNo + ( nNetNo << 8 );

	nRv = mdDevRst( m_lPath, nStationNo, m_nDevType, m_nDevNo );

	if( nRv != 0 )
	{
		CString sError;
#ifdef _MEL_ALARM
		m_nAlarmCode = nRv;
		sError.Format( "mdDevRst error [%d]", nRv );
		AfxMessageBox( sError );
#endif
		return FALSE;
	}
	return TRUE;
}

BOOL XMelsec::Control()
{
	int nRv;
	// short	ret;	return value	OUT
	// long		path;	path of channel	IN
	// short	stno;	station number	IN
	// short	buf;	selected code	IN
	nRv = mdControl( m_lPath, m_nStNo, m_nControlCode );

	if( nRv != 0 )
	{
		CString sError;
		m_nAlarmCode = nRv;
		sError.Format( "mdControl error [%d]", nRv );
		AfxMessageBox( sError );
		return FALSE;
	}
	return TRUE;
}

BOOL XMelsec::RandW( short nNetNo, short nStNo, short* nDev, short* nData, short nSize )   // buf -> OUT
{
	int nRv;
	// short	ret;	return value					OUT
	// long		path;	path of channel					IN
	// short	stno;	station number					IN
	// short	dev[ ];	random selected device			IN
	// short	buf[ ];	written data(single precision)	OUT
	// short	bufsize;	dummy						IN

	short nStationNo = nStNo + ( nNetNo << 8 );
	
	nRv = mdRandW( m_lPath, nStationNo, nDev, nData, nSize );

	if( nRv != 0 )
	{
		CString sError;
#ifdef _MEL_ALARM
		m_nAlarmCode = nRv;
		sError.Format( "mdRandW error [%d]", nRv );
		AfxMessageBox( sError );
#endif
		return FALSE;
	}
	return TRUE;	
}

BOOL XMelsec::RandR( short nNetNo, short nStNo, short* nDev, short* nData, short nSize )
{
	int nRv;
	// short	ret;	return value								OUT
	// long		path;	path of channel								IN
	// short	stno;	station number								IN
	// short	dev[ ];	random selected device						IN
	// short	buf[ ];	reading data(single precision)				OUT
	// short	bufsize;	bit count of reading data store area	IN
	
	short nStationNo = nStNo + ( nNetNo << 8 );
	
	nRv = mdRandR(m_lPath, nStationNo, nDev, nData, nSize );

	if( nRv != 0 )
	{
		CString sError;
#ifdef _MEL_ALARM
		m_nAlarmCode = nRv;
		sError.Format( "mdRandR error [%d]", nRv );
		AfxMessageBox( sError );
#endif
		return FALSE;
	}
	return TRUE;	
}

BOOL XMelsec::RandR32( short nNetNo, short nStNo, short nDevNo, short* nData, short nType )
{
	int nRv;
	// short	ret;	return value								OUT
	// long		path;	path of channel								IN
	// short	stno;	station number								IN
	// short	dev[ ];	random selected device						IN
	// short	buf[ ];	reading data(single precision)				OUT
	// short	bufsize;	bit count of reading data store area	IN
	
	short nStationNo = nStNo + ( nNetNo << 8 );
	short nDev[7];
	nDev[0] = 2;
	nDev[1] = nType;
	nDev[2] = nDevNo;
	nDev[3] = 16;
	nDev[4] = nType;
	nDev[5] = nDevNo + 0x10;
	nDev[6] = 16;
	
	// nData : array size = 32
	int nBufSize = ( nType == devB ) ? 4 : 64;
	nRv = mdRandR(m_lPath, nStationNo, nDev, nData, nBufSize );

	if( nRv != 0 )
	{
		CString sError;
#ifdef _MEL_ALARM
		m_nAlarmCode = nRv;
		sError.Format( "mdRandR error [%d]", nRv );
		AfxMessageBox( sError );
#endif
		return FALSE;
	}
	return TRUE;	
}

BOOL XMelsec::TypeRead()
// short	ret;	return value		OUT
// long		path;	path of channel		IN
// short	stno;	station number		IN
// short	*buf;	format name code	OUT
{
	int nRv;
	CString sError;

	nRv = mdTypeRead( m_lPath, m_nStNo, &m_nPlcForm );

	if( nRv != 0 )
	{
		m_nAlarmCode = nRv;
		sError.Format("mdTypeRead error [%d]", nRv);
		AfxMessageBox(sError);

		return FALSE;
	}
	return TRUE;	
}

BOOL XMelsec::Monitor( short nNetNo, short nStNo )
{
	int nRv;
	// short	ret;	return value								OUT
	// long		path;	path of channel								IN
	// short	stno;	station number								IN
	// short	dev[ ];	random selected device						IN
	// short	buf[ ];	reading data(single precision)				OUT
	// short	bufsize;	bit count of reading data store area	IN
	
	short nStationNo = nStNo + ( nNetNo << 8 );

	int nLen = sizeof( m_AddrInfo ) / sizeof( ADDR_INFO );
	short* nDev = new short[3 * nLen + 1];
	nDev[0] = nLen;
	for( int i=0; i<nLen; i++ ) 
	{
		nDev[3 * i + 1] = m_AddrInfo[i].nDevType;
		nDev[3 * i + 2] = m_AddrInfo[i].nStartAddr;
		nDev[3 * i + 3] = m_AddrInfo[i].nSize;
	}
	
	nRv = mdRandR( m_lPath, nStationNo, nDev, m_nReadDataBuf, 2 * m_nBufSize ); // 2009.02.27 minhan
//	nRv = mdRandR( m_lPath, nStationNo, nDev, m_nReadData, 2 * m_nBufSize );
	delete nDev;

	if( nRv == 0 ) // 2009.02.27 minhan
	{
       for( int i = 0 ; i < m_nBufSize; i ++ )
	   {
            m_nReadData[i] = m_nReadDataBuf[i];
	   }
         return TRUE;
	}
    else
	{
		CString sError;
#ifdef _MEL_ALARM
		m_nAlarmCode = nRv;
		sError.Format( "mdRandR error [%d]", nRv );
		AfxMessageBox( sError );
#endif
		return FALSE;
	}
//	return TRUE; // 2009.02.27 minhan
}

BOOL XMelsec::SendBitData( short nNetNo, short nStNo, short nDevNo, short nData )
{
#ifdef _SIMULATE_MELSEC
	return TRUE;
#endif

	int nRv;
	BOOL bBit;

	int nStationNo = nStNo + ( nNetNo << 8 );

	for( int i=0; i<16; i++ )
	{
		bBit = ( ( nData >> i ) & 0x0001 ) ? TRUE : FALSE;

		if( bBit )
		{
			if( ( nRv = mdDevSet( m_lPath, nStationNo, devB, nDevNo + i ) ) != 0 )
			{
				CString sError;
#ifdef _MEL_ALARM
				m_nAlarmCode = nRv;
				sError.Format( "mdDevSet error [%d]", nRv );
				AfxMessageBox( sError );
#endif
				return FALSE;
			}
		}
		else
		{
			if( ( nRv = mdDevRst( m_lPath, nStationNo, devB, nDevNo + i ) ) != 0 )
			{
				CString sError;
#ifdef _MEL_ALARM
				m_nAlarmCode = nRv;
				sError.Format( "mdDevRst error [%d]", nRv );
				AfxMessageBox( sError );
#endif
				return FALSE;
			}
		}
	}

	return TRUE;
}

BOOL XMelsec::SendBitData32( short nNetNo, short nStNo, short nDevNo, short nData )
{
#ifdef _SIMULATE_MELSEC
	return TRUE;
#endif

	int nRv;
	BOOL bBit;

	int nStationNo = nStNo + ( nNetNo << 8 );

	for( int i=0; i<32; i++ )
	{
		bBit = ( ( nData >> i ) & 0x0001 ) ? TRUE : FALSE;

		if( bBit )
		{
			if( ( nRv = mdDevSet( m_lPath, nStationNo, devB, nDevNo + i ) ) != 0 )
			{
				CString sError;
#ifdef _MEL_ALARM
				m_nAlarmCode = nRv;
				sError.Format( "mdDevSet error [%d]", nRv );
				AfxMessageBox( sError );
#endif
				return FALSE;
			}
		}
		else
		{
			if( ( nRv = mdDevRst( m_lPath, nStationNo, devB, nDevNo + i ) ) != 0 )
			{
				CString sError;
#ifdef _MEL_ALARM
				m_nAlarmCode = nRv;
				sError.Format( "mdDevRst error [%d]", nRv );
				AfxMessageBox( sError );
#endif
				return FALSE;
			}
		}
	}

	return TRUE;
}
