// XMelsec.h: interface for the XMelsec class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XMELSEC_H__41293758_7B30_41CA_A5C9_EFA5999866B0__INCLUDED_)
#define AFX_XMELSEC_H__41293758_7B30_41CA_A5C9_EFA5999866B0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#define _MEL_ALARM		// md error not occur

typedef struct tagADDR_INFO
{
	int nDevType;
	int nStartAddr;
	int nSize;
} ADDR_INFO;

class XMelsec
{
public:
	XMelsec();
	virtual ~XMelsec();

public:
	void SetChannel( short nChannel ) { m_nChannel = nChannel; }

	BOOL Open(int nChannel, int nMode);
	BOOL Close();
	BOOL SendBit( short nNetNo, short nStNo, short nDevNo, short nData );
	BOOL SendWord( short nNetNo, short nStNo, short nDevNo, short nData );
	BOOL ReceiveBit( short nNetNo, short nStNo, short nDevNo, short& nData );
	BOOL ReceiveWord( short nNetNo, short nStNo, short nDevNo, short& nData );
	BOOL SendBitData( short nNetNo, short nStNo, short nDevNo, short nData );
	BOOL SendBitData32( short nNetNo, short nStNo, short nDevNo, short nData );
	BOOL DevSet( short nNetNo, short nStNo, short nDevNo );
	BOOL DevRst( short nNetNo, short nStNo, short nDevNo );
	BOOL TypeRead();
	BOOL Control();
	//BOOL RandR( short nNetNo, short nStNo );
	BOOL RandR( short nNetNo, short nStNo, short* nDev, short* nData, short nSize );
	BOOL RandR32( short nNetNo, short nStNo, short nDevNo, short* nData, short nType = devB );
	BOOL RandW( short nNetNo, short nStNo, short* nDev, short* nData, short nSize );
	BOOL Monitor( short nNetNo, short nStNo );

	short ReceiveBit( short nNetNo, short nStNo, short nDevNo );
	short ReadString(short nNetNo, short nStNo, short nDevNo, LPTSTR lpszBuf, int nLen);
	short WriteString(short nNetNo, short nStNo, short nDevNo, CString sStr, int nLen);
	short ReceiveWord( short nNetNo, short nStNo, short nDevNo );

	CString Word2Ascii( short nData );
	short Ascii2Word( CString sData );
	CString Word2Binary( short nData );
	short Hex2Word(CString sHex);
	CString Word2Hex(short nData);
	
private:
	long m_lPath;		 

public:
	BOOL m_bAlignKey;

	int m_nAlarmCode;   //  ߻Ǿ ˶ ڵ ȣ

	enum channel 
	{ 
		melsecnet10_Slot1 = 51,
		melsecnet10_Slot2 = 52, 
		melsecnet10_Slot3 = 53, 
		melsecnet10_Slot4 = 54
	};

	enum devTYPE 
	{
		devX = 1,		// 1	DevX	X
		devY = 2,		// 2	DevY	Y
		devL = 3,		// 3	DevL	L
		devM = 4,		// 4	DevM	M
		devSM = 5,		// 5	DevSM	Special MSB(link special B for MELSECNET/10 or CC-Link)
		devF = 6,		// 6	DevF	F
		devTT = 7,		// 7	DevTT	T(contact)
		devTC = 8,		// 8	DevTC	T(coil)
		devCT = 9,		// 9	DevCT	C(contact)
		devCC = 10,		// 10	DevCC	C(coil)
		devTN = 11,		// 11	DevTN	T(current value)
		devCN = 12,		// 12	DevCN	C(current value)
		devD = 13,		// 13	DevD	D
		devSD = 14,		// 14	DevSD	SpecialDSW(link special W for MELSECNET/10 or CC-Link)
		devTM_T = 15,		// 15	DevTM	T(setting value main)
		devTS_T = 16,		// 16	DevTS	T(setting value sub1)
		devTS2_T = 16002,	// 16002	DevTS2	T(setting value sub2)
		devTS3_T = 16003,	// 16003	DevTS3	T(setting value sub3)
		devCM_C = 17,		// 17	DevCM	C(setting value main)
		devTS_C = 18,		// 18	DevTS	C(setting value sub1)
		devTS2_C = 18002,	// 18002	DevTS2	C(setting value sub2)
		devTS3_C = 18003,	// 18003	DevTS3	C(setting value sub3)
		devA = 19,		// 19	DevA	A
		devZ = 20,		// 20	DevZ	Z
		devV = 21,		// 21	DevV	V(index register)
		devR = 22,		// 22	DevR	R
						// 22001~22256	DevER1~256	Extend R
		devB = 23,		// 23	DevB	B
		devW = 24,		// 24	DevW	W
		devQSB = 25,	// 25	DevQSB	Q/QnA link special relay(Q/QnACPUup)
		devSTT = 26,	// 26	DevSTT	Retentive timer
		devSTC = 27,	// 27	DevSTC	Retentive timer
		devQSW = 28,	// 28	DevQSW	Q/QnA link special register(Q/QnACPUup)
		devQV = 30,		// 30	DevQV	Q/QnA edge relay(Q/QnACPUup)
		devSTN = 35,	// 35	DevSTN	Retentive timer
		devFS = 40,		// 40	DevFS	S(FxCPU)
						// *** // 101	DevMAIL	Q/QnA SEND function(arrival acknowledgement  required) or RECV function
						// *** // 102	DevMAILNC	Q/QnA SEND function(arrival acknowledgement not required)
						// 1001~1255	DevLX1~255	Direct link input
						// 2001~2255	DevLY1~255	Direct link output
						// 23001~23255	DevLB1~255	Direct link relay
						// 24001~24255	DevLW1~255	Direct link register
						// 25001~25255	DevLSB1~255	Direct link special relay(network unit side)
						// 28001~28255	DevLSW1~255	Direct link special register(network unit side)
						// 29000~29255	DevSPG0~255	Special direct buffer register
						// 31000~31255	DevEM0~255	EM(shared device)
						// 32000~32255	DevED0~255	ED(shared device)
						// 8000h	DevRBM	Buffer memory*1
						// 8020h	DevRAB	Random access buffer*1
						// 8021h	DevRX	link input*1
						// 8022h	DevRY	link output*1
						// 8024h	DevRW	link register*1
						// 8063h	DevSB	link special relay*1
						// 8064h	DevSW	link spcial register*1
						// 33	DevMRB	Own station random access buffer*2
						// 36	DevWw	Own station link register(send)*2
						// 37	DevWr	Own station link register(receive)*2
						// 50	DevSPB	Own station buffer memory*3
	};

	short m_nPlcForm;	// PLC format name	code
						// A1N								A1H
						// A2N(S1),A2S						A2H
						// A3N,A1SH,A2SH					A3H
						// A3H,A3M							A4H
						// AJ72								ABH
						// T3A(Amode)						A8H
						// T3A(Tmode)						A9H
						// A2A								92H
						// A2AS1							93H
						// A3A								94H
						// A0J2H,A1S						98H
						// A2C,A2CJ							9AH
						// A2U,A2US							82H
						// A2U-S1,A2US-S1					83H
						// A3UA2USH-S1						84H
						// A4U								85H
						// Q2A,Q2AH,Q2AS,Q2ASH				21H
						// Q2AS-S1,A2AH-S1,Q2AS-S1,Q2ASH-S1	22H
						// Q3A								23H
						// Q4A,Q4AR							24H
						// DOS/Vcomputer,PC98(NEC)			90H
						// Q02,Q02H							41H
						// Q06H								42H
						// Q12H								43H
						// Q25H								44H
						// Q02,Q02H (A mode)				141H
						// Q06H (A mode)					142H

	short m_nDevType;	// The device type that are selected in MELSECNET data library 
						// Code setting 	Device name setting 	

	short m_nDevNo;     // device number  ( Point   ȣ )
						// dev[0] = 4;	(M100~M115, D10~D13, M0~M13, T10)
						// dev[1] = DevM;
						// dev[2] = 100;    Device No.
						// dev[3] = 16;		16points(M100~M115)
						// dev[4] = DevD;
						// dev[5] = 10;		Device No.
	short m_nMode;		// mode data by own card form registry
						// Link Mode
						// 0 : Online
						// 2 : offline
						// 3 : Forward loop test
						// 4 : Reverse loop test
						// 5 : Between station test( main station )
						// 6 : Between station test( sub station )
						// 7 : Self loop test
						// 8 : Self loop test(inside)
						// 9 : H/W test
	short m_nStNo;		// the station number to set in MELSEC data library
						// Station number (2 bytes data) setting in MELSECNET/10communication 
						// Upper bytes : network number               1~239(OxEF)
						// Lower bytes : station NO or group NO

						// 240(OxFO)	all stations
						// 1~64(Ox40)	other station
						// 129(Ox81)~137(ox89)	group NO.1~9

	short m_nChannel;	// Channel is a communication medium to communicate between computers
						// 51	MELSECNET/10(first slot)	MELSECNET/10 communication
						// Specify the channel no.
						// Upper : Receiver station channel number
						// Lower : Transmitter station channel number
	short m_nDataS[16];	
	short m_nDataR[16];
	short m_nSize[20];	// send byte size(2 to 960 bytes)	
	short m_nControlCode;	    // Remotes RUN/STOP/PAUSE to PLC
								// Remote RUN	0
								// Remote STOP	1
								// Remote PAUSE	2	
	short m_nBufSize;			// Bit count of reading data store area (buf[0]~buf[6])*2 = 7
	short* m_nWriteData;		// buf[0] = 0;	all of the bits of M100~M113 are OFF
								// buf[1] = 10;	current value of D10
								// buf[2] = 200;	current value of D11
								// buf[3] = 300;	current value of D12
								// buf[4] = 400;	current value of D13
	short* m_nReadData;			// Data that are read out.

								// buf[0] = 0;	OFF all of M100~M113 (It can store bit information of 16 points)
								// buf[1] = 10;	current value of D10
								// buf[2] = 200;	current value of D11
								// buf[3] = 300;	current value of D12
								// buf[4] = 400;	current value of D13
								// buf[5] = 0x3FFF;	all bits of M0~M13 are ON
								// buf[6] = 10;	current value of T10 is 10(1second) 
	short* m_nReadDataBuf;      // Data that are read out.

								// buf[0] = 0;	OFF all of M100~M113 (It can store bit information of 16 points)
								// buf[1] = 10;	current value of D10
								// buf[2] = 200;	current value of D11
								// buf[3] = 300;	current value of D12
								// buf[4] = 400;	current value of D13
								// buf[5] = 0x3FFF;	all bits of M0~M13 are ON
								// buf[6] = 10;	current value of T10 is 10(1second) 
	short m_nDev[6];	// Contents of random selected device (dev[ ])

						// dev[0]	block count
						// dev[1]	device type of blockNo.1
						// dev[2]	front device number of block number 1
						// dev[3]	points of block number 1
						// dev[4]	device type of block No.2
						// dev[5]	front device number of block No.2
						// dev[6]	points of block No.2

	static ADDR_INFO m_AddrInfo[];

};

#endif // !defined(AFX_XMELSEC_H__41293758_7B30_41CA_A5C9_EFA5999866B0__INCLUDED_)
