// XComm.h: interface for the XComm class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XCOMM_H__B247E062_F4E8_11D1_90B8_0020AFF708E8__INCLUDED_)
#define AFX_XCOMM_H__B247E062_F4E8_11D1_90B8_0020AFF708E8__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <afxmt.h>

class XComm  
{
public:
	char	GetCheckSum(LPCSTR lpszMsg, int nLen);
	CMutex	m_mutex;
	void	PutChar( char ch );
	DWORD	TimeoutRead( LPSTR lpszBuf, DWORD dwLength, int nTimeout );
	CString& GetErrorMsg();
	BOOL	Write( LPCTSTR lpszBuf, DWORD dwLength=-1 );
	DWORD	Read( LPSTR lpszBuf, DWORD dwLength );
	void	SetTimeout( int nReadTimeout, int nWriteTimeout=0 );
	BOOL	Close();

	BOOL	Open( LPCTSTR lpszPortName, 
				DWORD dwBaud, 
				BYTE byByte, 
				BYTE byStop, 
				BYTE byParity, 
				char cEvtChar );

	XComm();
	virtual ~XComm();

protected:
	BOOL	SetDCB( DWORD dwBaud, BYTE byByteSize, BYTE byStopSize, BYTE byParity, char cEvtChar = 0 );
//	void Flush(); // jemoon : 070205 Modify
	void FlushTx();
	void FlushRx();

// Added by KDS 041118
	BOOL IsInQue();
// Added by KDS 041118

	int		m_nPortNo;  // ø Ʈ ڸ Ÿ COM1, COM2, COM3, COM4 -> 1, 2, 3, 4 
	int		m_nEvtType; // Event ߻ Flag

	BOOL	m_bEmulation;

	CString m_sErrMsg;

	HANDLE	m_hComm;  // ø Ʈ Handle

	//The OVERLAPPED structure contains information used in 
	//asynchronous input and output (I/O). 
	OVERLAPPED m_osWrite, m_osRead;
};

#endif // !defined(AFX_XCOMM_H__B247E062_F4E8_11D1_90B8_0020AFF708E8__INCLUDED_)
