// XmlLog.cpp: implementation of the CXmlLog class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "XmlLog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXmlLog::CXmlLog()
{
	m_nLenCnt = 0;
	m_sFileName.Empty();
	m_fileLog.m_hFile = NULL;
	m_nStampType = stampDateTime;
	bFileClosed	 = FALSE;

}

CXmlLog::~CXmlLog()
{

}
CXmlLog::CXmlLog( LPCTSTR lpszName, int nStampType, BOOL bAppended )
{
	m_nLenCnt = 0;
	m_fileLog.m_hFile = NULL;
	m_bEnable = TRUE;
	if( !bAppended ) return;
		
	CTime time = CTime::GetCurrentTime();
	CString sDate = time.Format(_T("%y%m%d"));
	
	SYSTEMTIME SystemTime;
	GetLocalTime(&SystemTime);
	CString sDateTime;
	sDateTime.Format("%4d%02d%02d%02d%02d%02d%03d",
		SystemTime.wYear, 
		SystemTime.wMonth, 
		SystemTime.wDay, 
		SystemTime.wHour, 
		SystemTime.wMinute, 
		SystemTime.wSecond, 
		SystemTime.wMilliseconds );

	m_nStampType = nStampType;
	m_sName = CString( lpszName );

	CString sPath;
	sPath.Format( "D:\\DICS\\Log\\TAS\\TasLog[%s]", sDate );
	m_sFullFilePath = sPath;
	CreateDirectory( sPath, NULL );

	m_sFileName.Format( "%s\\%s_%s.xml", sPath, m_sName, sDateTime );

	if( bAppended )
	{
		if( !m_fileLog.Open( m_sFileName, CFile::modeReadWrite | CFile::shareDenyNone ) ) //  File  FALSE return
		{
			m_fileLog.Open( m_sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone );
			CString sBuf;
			sBuf = "<?xml version=\"1.0\" encoding=\"utf-8\" standalone='yes'?>";
			m_fileLog.Write( sBuf + "\r\n", sBuf.GetLength()+2 );
			sBuf = "<TAS>";
			m_fileLog.Write( sBuf + "\r\n", sBuf.GetLength()+2 );
			m_sMakeTasFileName.Format("%s_%s.xml",m_sName, sDateTime  );
			bFileClosed = FALSE;
		}
		try
		{
			if( m_fileLog.m_hFile != (UINT) m_fileLog.hFileNull ) 
			{
				if( m_fileLog.m_hFile ) m_fileLog.SeekToEnd(); // file pointer 
			}
		}
		catch( CFileException* pEX )
		{
			pEX->Delete();
		}
	}
	else
	{
		m_fileLog.Open( m_sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone );
		CString sBuf;
		sBuf = "<?xml version=\"1.0\" encoding=\"utf-8\" standalone='yes'?>";
		m_fileLog.Write( sBuf + "\r\n", sBuf.GetLength()+2 );
		sBuf = "<TAS>";
		m_fileLog.Write( sBuf + "\r\n", sBuf.GetLength()+2 );
		m_sMakeTasFileName.Format("%s_%s.xml",m_sName, sDateTime  );
		bFileClosed = FALSE;
	}
	//RemoveFile();
}
//------------------------------------------------------------------------------------
// Log ȭ  .
//------------------------------------------------------------------------------------
int CXmlLog::NewFile(CString sFileName, BOOL bAppended )
{
	CString sBuf;
	
	try
	{
		if( m_fileLog.m_hFile != (UINT)m_fileLog.hFileNull )
		{
			sBuf = "</TAS>";
			m_fileLog.Write( sBuf + "\r\n", sBuf.GetLength()+2 );
			m_fileLog.Close();
		}
		else
		{
			TRACE( "!!!!!!!!!!!!!!!!!! Assertion Failed !!!!!!!!!!!!!!!!!!!" );
		}
	}
	catch( CFileException* pEX )
	{
		pEX->Delete();
	}

	m_bEnable = TRUE;

	CTime time = CTime::GetCurrentTime();
	CString sDate = time.Format(_T("%y%m%d"));

	SYSTEMTIME SystemTime;
	GetLocalTime(&SystemTime);
	CString sDateTime;
	sDateTime.Format("%4d%02d%02d%02d%02d%02d%03d",
		SystemTime.wYear, 
		SystemTime.wMonth, 
		SystemTime.wDay, 
		SystemTime.wHour, 
		SystemTime.wMinute, 
		SystemTime.wSecond, 
		SystemTime.wMilliseconds );

	CString sPath;
	sPath.Format( "D:\\DICS\\Log\\TAS\\TasLog[%s]", sDate );
	m_sFullFilePath = sPath;
	CreateDirectory( sPath, NULL );

	m_sFileName.Format( "%s\\%s_%s.xml", sPath, sFileName, sDateTime );

	if( bAppended )
	{
		if( !m_fileLog.Open( m_sFileName, CFile::modeReadWrite | CFile::shareDenyNone ) ) //  File  FALSE return
		{

			m_fileLog.Open( m_sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone );
			CString sBuf;
			sBuf = "<?xml version=\"1.0\" encoding=\"utf-8\" standalone='yes'?>";
			m_fileLog.Write( sBuf + "\r\n", sBuf.GetLength()+2 );
			sBuf = "<TAS>";
			m_fileLog.Write( sBuf + "\r\n", sBuf.GetLength()+2 );
			m_sMakeTasFileName.Format("%s_%s.xml",sFileName, sDateTime  );

			bFileClosed = FALSE;	
			return -1;
		}
		
		try
		{
			if( m_fileLog.m_hFile != (UINT) m_fileLog.hFileNull ) 
			{
				m_fileLog.SeekToEnd(); // file pointer 
			}
		}
		catch( CFileException* pEX )
		{
			pEX->Delete();
		}
	}
	else
	{
		m_fileLog.Open( m_sFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone );
		CString sBuf;
		sBuf = "<?xml version=\"1.0\" encoding=\"utf-8\" standalone='yes'?>";
		m_fileLog.Write( sBuf + "\r\n", sBuf.GetLength()+2 );
		sBuf = "<TAS>";
		m_fileLog.Write( sBuf + "\r\n", sBuf.GetLength()+2 );
		m_sMakeTasFileName.Format("%s_%s.xml",m_sName, sDateTime  );
		bFileClosed = FALSE;
	}

	return 0;
}
int CXmlLog::RemoveFile()
{

	CTime CurTime = CTime::GetCurrentTime();

	CTime time = CTime::GetCurrentTime();
	CString sDate = time.Format(_T("%y%m%d"));	

	CFileFind FileFind;
	CString  sFile;
	CString  sPath;

	sFile.Format( "D:\\DICS\\Log\\TAS\\*.*" );

	WIN32_FIND_DATA DirData;
	HANDLE hDir;
		

	hDir = FindFirstFile((LPCTSTR) sFile, &DirData);
		
	//2004.06.23 Kim Youngsik =>
	//MAX_DAYS  Directory ã´...
	do
	{
		CString sFileName = DirData.cFileName; 
		if (DirData.dwFileAttributes && FILE_ATTRIBUTE_DIRECTORY)
		{
			if( sFileName != "." && sFileName != ".." )
			{
				CString  strDate;
				CFileStatus FileStatus;
				CFile File;

				sFileName = "D:\\DICS\\Log\\TAS\\" + sFileName;
				File.GetStatus( sFileName, FileStatus );
				CTime FileTime = FileStatus.m_mtime;

				CTimeSpan Diff = CurTime - FileTime;
				if( Diff.GetDays() > 3 )
				{
					sPath = sFileName;
				}
			}
		}
	} while( FindNextFile(hDir, &DirData) );
	FindClose( hDir );
	//2004.06.23 Kim Youngsik <=
		
	sFile.Format( "%s\\*.xml", sPath);

	// ã Directory Ʒ  File ...
	if( sPath != "" )
	{ 	
		HANDLE hFile;
		WIN32_FIND_DATA FileData;

		hFile = FindFirstFile((LPCTSTR) sFile, &FileData);
		if( hFile != (void*) 0xffffffff )
		{ 
			do
			{
				CString sFileName = FileData.cFileName; //FileFind.GetFileName();
				CFileStatus FileStatus;
				CFile File;
				CString sFullName;

//				sFileName = sPath + sFileName;
				sFullName.Format( "%s\\%s", sPath, sFileName );
				File.GetStatus( sFileName, FileStatus );
				CTime FileTime = FileStatus.m_mtime;

				CTimeSpan Diff = CurTime - FileTime;
				if( Diff.GetDays() > 3 )
				{
					TRY
					{
						File.Remove( sFullName );
					}
					CATCH( CFileException, e )
					{
#ifdef _DEBUG
						afxDump << "File" << sFullName << "cannot be removed \n";
#endif
					}
					END_CATCH
				}
			}
			while( FindNextFile(hFile, &FileData) );
		}

		FindClose( hFile );
		RemoveDirectory( sPath ); //    Directory ...
	}

	return 0;
}
//------------------------------------------------------------------------------------
// Log ȭϿ ڿ .
//------------------------------------------------------------------------------------
void CXmlLog::TextOut(LPCTSTR lpszStr )
{
	if( !m_bEnable ) return;
	if( bFileClosed ) return;

	CString sBuf;
	CString sFile;
	sBuf.Format("<DATA %s />", lpszStr );
	if( sBuf != "" )
		sBuf = sBuf;
	try
	{
		if( m_fileLog.m_hFile != (UINT)m_fileLog.hFileNull ) 
		{
			m_fileLog.Write( sBuf + "\r\n", sBuf.GetLength()+2 );
		}
	}
	catch( CFileException* pEX )
	{
		pEX->Delete();
	}
}

void CXmlLog::Close()
{

	bFileClosed = TRUE;
	CString sBuf;
	try
	{
		if( m_fileLog.m_hFile != (UINT)m_fileLog.hFileNull ) 
		{
			sBuf = "</TAS>";
			m_fileLog.Write( sBuf + "\r\n", sBuf.GetLength()+2 );
			m_fileLog.Close();
		}
	}
	catch( CFileException* pEX )
	{
		pEX->Delete();
	}
}
