//---------------------------------------------------------------------------
// Copyright		: DMS Co., LTd
// File Name		: X\XTimer.cpp
// Modified Date	: 2000.11.28, 
// Version			: 1.0
// Programmer		: kds
// XTimer.cpp		: implementation of the XTimer class.
//					   ϴ XTimer class .
// Description		:
// Usage :
//	1. CTitleView <XTimer m_pTimer;> 
//	2. 
//---------------------------------------------------------------------------

#include "stdafx.h"
#include "..\Dics.h"
#include "XTimer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// XTimer
#ifndef MAX_TIMER_NO 
#define MAX_TIMER_NO 23
#endif

XTimer::XTimer( int nMaxTimerNo )
{
	m_nMaxTimerNo = nMaxTimerNo;

	InitTimerWindow();
}

XTimer::XTimer()
{
	m_nMaxTimerNo = MAX_TIMER_NO;

	InitTimerWindow();
}

XTimer::~XTimer()
{
	KillTimer( timer_Root );

	delete[] m_pTimer;
}


BEGIN_MESSAGE_MAP(XTimer, CWnd)
	//{{AFX_MSG_MAP(XTimer)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// XTimer message handlers

void XTimer::InitTimerWindow()
{
	m_pTimer  = new struct tagSEQ_TIMER[m_nMaxTimerNo];

	m_bTimerOn = 0;
	for( int i=0; i<m_nMaxTimerNo; i++ ) TimerReset( i );
	
	//In the debug version of MFC, the VERIFY macro evaluates its argument. 
	//If the result is 0, the macro prints a diagnostic message and halts the program. 
	//If the condition is nonzero, it does nothing.

	VERIFY(CreateEx(0, AfxRegisterWndClass(0), _T("Seq Timer"), 
		WS_OVERLAPPED, 0, 0, 0, 0, NULL, NULL));
}

//void XTimer::TimerUpdate( void )
//{
//	for( register int i = 0; i < m_nMaxTimerNo; i++ )
//	{
//		if( m_pTimer[i].nStart ) // update timer
//		{
//			if( !m_pTimer[i].bPause )	// ljy_051217
//			{
//				DWORD dwCount = GetTickCount() - m_pTimer[i].dwTickStart;
//				m_pTimer[i].dwNow = m_pTimer[i].dwNow + dwCount;
//				m_pTimer[i].dwTickStart = GetTickCount();
//			}
//
////			if( !m_pTimer[i].bPause ) m_pTimer[i].dwNow = m_pTimer[i].dwNow + 1;
//			if( m_pTimer[i].dwNow >= m_pTimer[i].dwCount ) // set timer overflow bit 
//			{    
//				m_pTimer[i].nStart = 0;
//				m_pTimer[i].nOver = 1;
//			}
//		}
//	}
//}

void XTimer::TimerUpdate( void )
{
	DWORD dwGetTickCnt = GetTickCount();
	
	for( register int i = 0; i < m_nMaxTimerNo; i++ )
	{
		if( m_pTimer[i].nStart ) // update timer
		{
			if( !m_pTimer[i].bPause )	// ljy_051217
			{
				m_pTimer[i].dwNow = dwGetTickCnt - m_pTimer[i].dwTickStart;
			}

			if( m_pTimer[i].dwNow >= m_pTimer[i].dwCount ) // set timer overflow bit 
			{    
				m_pTimer[i].nStart = 0;
				m_pTimer[i].nOver = 1;
			}
		}
	}
}


void XTimer::TimerTurnOn( int nTimerID, int nTimeCount )
{
	if( nTimerID >= m_nMaxTimerNo ) 
	{
		AfxMessageBox( "Invalid Timer ID" );
		return;
	}

	if( nTimeCount < 0 ) nTimeCount = 0;		

	m_pTimer[nTimerID].nOver	= 0;
	m_pTimer[nTimerID].dwNow	= 0;
	m_pTimer[nTimerID].dwCount	= nTimeCount * 100;
	m_pTimer[nTimerID].bPause	= FALSE;
	m_pTimer[nTimerID].dwTickStart = GetTickCount();	// ljy_051217
	m_pTimer[nTimerID].nStart	= 1;

	if( !m_bTimerOn ) 
	{
		if( SetTimer( timer_Root, 100, 0 ) )
			m_bTimerOn = TRUE;
	}
}

void XTimer::TimerReset( int nTimerID )
{
	m_pTimer[nTimerID].nOver	= 0;
	m_pTimer[nTimerID].nStart	= 0;
	m_pTimer[nTimerID].dwNow	= 0;
	m_pTimer[nTimerID].dwCount	= 0;
	m_pTimer[nTimerID].bPause	= FALSE;
}

int XTimer::Timer( int nTimerID )
{
	if( m_pTimer[nTimerID].nOver )
	{
		m_pTimer[nTimerID].nStart = 0;
		m_pTimer[nTimerID].nOver  = 0;
		return 1;
	}
	return 0;
}

void XTimer::OnTimer( UINT nIDEvent ) 
{
	switch( nIDEvent )
	{
	case  timer_Root:
		TimerUpdate();
		break;
	}

	CWnd::OnTimer( nIDEvent );
}


void XTimer::PauseTimer( int nTimerID )
{
	m_pTimer[nTimerID].bPause = TRUE;
}

//void XTimer::RePlayTimer( int nTimerID )
//{
//	if( nTimerID < 0 )	// ljy_051217
//	{
//		for( int i=0; i<MAX_TIMER_NO; i++ )
//		{
//			if( m_pTimer[i].bPause ) m_pTimer[i].dwTickStart = GetTickCount();
//			m_pTimer[i].bPause = FALSE;
//		}
//	}
//	else
//	{
//		m_pTimer[nTimerID].bPause = FALSE;
//		m_pTimer[nTimerID].dwTickStart = GetTickCount();
//	}
//}

void XTimer::RePlayTimer( int nTimerID )
{
	DWORD dwGetTickCnt = GetTickCount();

	if( nTimerID < 0 )	// ljy_051217
	{
		for( int i=0; i<MAX_TIMER_NO; i++ )
		{
			if( m_pTimer[i].bPause )
			{
				m_pTimer[i].dwTickStart = dwGetTickCnt - m_pTimer[i].dwNow;
				m_pTimer[i].bPause = FALSE;
			}
		}
	}
	else
	{
		if( m_pTimer[nTimerID].bPause )
		{
			m_pTimer[nTimerID].dwTickStart = dwGetTickCnt - m_pTimer[nTimerID].dwNow;
			m_pTimer[nTimerID].bPause = FALSE;
		}
	}
}


