// XCtlMelsec.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "XCtlMelsec.h"
#include "XLog.h"
#include "..\MainFrm.h"
#include "..\DicsView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// XCtlMelsec

IMPLEMENT_DYNCREATE(XCtlMelsec, CWinThread)

XCtlMelsec::XCtlMelsec()
{
	m_bAutoDelete	= FALSE;
	m_pOwner		= NULL;

	m_hDead = CreateEvent( NULL, TRUE, FALSE, NULL );	// MANUAL Reset, Initial state = non-signal
	m_hKill = CreateEvent( NULL, TRUE, FALSE, NULL );


	InitParameter();
}

XCtlMelsec::~XCtlMelsec()
{
	CloseHandle( m_hDead );
	CloseHandle( m_hKill );
}

BOOL XCtlMelsec::InitInstance()
{
	while( WaitForSingleObject( m_hKill, 0 ) != WAIT_OBJECT_0 ) 
	{
		Sleep( 10 );
		Watch();
	}

	VERIFY( SetEvent( m_hDead ) );
	return FALSE;
}

int XCtlMelsec::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(XCtlMelsec, CWinThread)
	//{{AFX_MSG_MAP(XCtlMelsec)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/*CHdcDoc* XCtlMelsec::GetDocument()
{
	return (CHdcDoc*)(((CHdcView*)m_pOwner)->GetDocument());
}*/
/////////////////////////////////////////////////////////////////////////////
// XCtlMelsec message handlers

//--------------------------------------------------------------------
// Procedure   : Start
// Description : Start the thread => OpenCard
// Arguments   : see the below
// Returns     : BOOL
//--------------------------------------------------------------------
BOOL XCtlMelsec::Start(CWnd* pOwner, int nChannel, int nMode)	
{
	m_pOwner = pOwner;

	short rv = Open( nChannel, nMode );
	CreateThread();

	return rv;
}

//--------------------------------------------------------------------
// Procedure   : End
// Description : Exit the thread => CloseCard
// Arguments   : see the below
// Returns     : BOOL
//--------------------------------------------------------------------
BOOL XCtlMelsec::End()
{
	// Exit the thread
	if( m_hThread )
	{
		VERIFY( SetEvent( m_hKill ) );

		// When ExitInstance function calls, it is signaled.
		VERIFY( WaitForSingleObject( m_hDead, INFINITE ) == WAIT_OBJECT_0 );
		VERIFY( WaitForSingleObject( m_hThread, INFINITE ) == WAIT_OBJECT_0 );
		Sleep(200);
	}

	DWORD exitCode;
	if( !GetExitCodeThread( m_hThread, &exitCode ) )
	{
		if( GetLastError() == STILL_ACTIVE )
		{
			TerminateThread( m_hThread, -1 );
			Sleep( 200 );
			if( !GetExitCodeThread( m_hThread, &exitCode ) )
				AfxMessageBox( "Windows ϰ ý  OFFϿ ֽʽÿ.", MB_ICONSTOP | MB_SYSTEMMODAL | MB_OK );
		}
	}

	Close();
	return TRUE;
}

//--------------------------------------------------------------------
// Procedure   : Watch
// Description : Thread ɶ   ݺ
// Arguments   : void
// Returns     : void
//--------------------------------------------------------------------
void XCtlMelsec::Watch()
{
	Sleep( 100 );
	Monitor( m_NetworkInfo.nNetworkNo, m_NetworkInfo.nStationNo );
}

//--------------------------------------------------------------------
// MelsecNet10  PLC ޸𸮿 ִ Glass Data д Լ
// DicsMainSeq 
//--------------------------------------------------------------------


//--------------------------------------------------------------------
// MelsecNet10  PLC ޸𸮿 Glass Data  Լ
// DicsMainSeq 
//--------------------------------------------------------------------


//--------------------------------------------------------------------
//   Message 
//--------------------------------------------------------------------
void XCtlMelsec::Msg(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	if( m_pOwner )
	{
		m_pOwner->PostMessage( uMsg, wParam, lParam );
	}
	return;
}

//--------------------------------------------------------------------
// LotApdData PLC ޸𸮿  Լ
//--------------------------------------------------------------------


//--------------------------------------------------------------------
// DailyCheckData PLC ޸𸮿  Լ
//--------------------------------------------------------------------


//--------------------------------------------------------------------
// Timer ϴ Լ
//--------------------------------------------------------------------

//--------------------------------------------------------------------
// Parameter ʱȭϴ Լ
//--------------------------------------------------------------------
void XCtlMelsec::InitParameter()
{
	m_NetworkInfo.nNetworkNo = 3;
	m_NetworkInfo.nStationNo = 2;
	m_NetworkInfo.nUpStationNo = 2;	// 1
	m_NetworkInfo.nDnStationNo = 2;	// 1

	m_NetworkInfo.nUpNetworkNo = 2;	// 3
	m_NetworkInfo.nDnNetworkNo = 2;	// 3
}

void XCtlMelsec::SetMelsecParameter(short nNetworkNo, short nStationNo, 
									short nUpNetworkNo, short nUpStationNo, 
									short nDnNetworkNo, short nDnStationNo)
{
	m_NetworkInfo.nNetworkNo = nNetworkNo;
	m_NetworkInfo.nStationNo = nStationNo;

	m_NetworkInfo.nUpNetworkNo = nUpNetworkNo;	// 3
	m_NetworkInfo.nUpStationNo = nUpStationNo;	// 1

	m_NetworkInfo.nDnNetworkNo = nDnNetworkNo;	// 3
	m_NetworkInfo.nDnStationNo = nDnStationNo;	// 1
}

//--------------------------------------------------------------------
// RecipeBody PLC ޸𸮿  Լ
//--------------------------------------------------------------------


//--------------------------------------------------------------------
// Interface õ ȣ  ResetϿ ִ Լ
//--------------------------------------------------------------------


//--------------------------------------------------------------------
// ˶ ߻Ͽ PLC Memory õ ȣ ϴ Լ
//--------------------------------------------------------------------


//--------------------------------------------------------------------
// ˶ ResetҶ PLC Memory õ ȣ ϴ Լ
//--------------------------------------------------------------------


//-------------------------------------------------------------------------------
// PLC Memory  Data  о Data  ParsingϿ ִ Լ
//-------------------------------------------------------------------------------

