//------------------------------------------------------------------------------------------------
// Copyright		: DMS Co., Ltd
// File Name		: XDeviceNet.cpp
// Modified Date	: 2000.11.23, 2001.01.17, 2001.01.27
// Version			: Ver1.0
// Programmer		: Kim Dongsoo
// Description		: implementation of the XDeviceNet class.
//		1. DIO : XDio   Ѵ.
//		2. AIO?
// Programming Issues :
//		1. 1/19 Ϸ   ִµ... α׷ Ҷ  Class  ״´.
//		    m_bAutoDelete = FALSE;   ʾƼ .
//		   ڵ ش Class Delete Ǵµ  Delete ϴϱ α׷  .
//		2. 2001.01.27 : XCtlDeviceNet ϳ   DeviceNet ó XDeviceNet Class
//			XCtlDeviceNet Ϲ XDio óϴ Ͱ   ó Ҽ ְ Ͽ.
//			Thread XCtlDeviceNet óϵ Ͽ.
//------------------------------------------------------------------------------------------------

// #include files
#include "stdafx.h"
#include "XDeviceNet.h"

// MFC auto-defined
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// dnscan32.dll function pointers
dnsAddDevice DNS_AddDevice;
dnsDeleteDevice DNS_DeleteDevice;
dnsCloseCard DNS_CloseCard;
dnsDriver DNS_Driver;
dnsFreeDriver DNS_FreeDriver;
dnsGetBusStatus DNS_GetBusStatus;
dnsGetClientEvent DNS_GetClientEvent;
dnsGetClientStatus DNS_GetClientStatus;
dnsGetDevice DNS_GetDevice;
dnsGetDeviceEvent DNS_GetDeviceEvent;
dnsGetDevicePath DNS_GetDevicePath;
dnsGetDeviceStatus DNS_GetDeviceStatus;
dnsGetModuleHeader DNS_GetModuleHeader;
dnsGetServerEvent DNS_GetServerEvent;
dnsGetServerPath DNS_GetServerPath;
dnsGetServerStatus DNS_GetServerStatus;
dnsInitializePathBuffer DNS_InitializePathBuffer;
dnsIoActive DNS_IoActive;
dnsIoIdle DNS_IoIdle;
dnsLoadDriver DNS_LoadDriver;
dnsLog DNS_Log;
dnsOffline DNS_Offline;
dnsOnline DNS_Online;
dnsOpenCard DNS_OpenCard;
dnsReadDeviceIo DNS_ReadDeviceIo;
dnsReadServerIo DNS_ReadServerIo;
dnsReceiveDeviceExplicit DNS_ReceiveDeviceExplicit;
dnsReceiveServerExplicit DNS_ReceiveServerExplicit;
dnsRegisterBusStatusEvent DNS_RegisterBusStatusEvent;
dnsRegisterClientEvent DNS_RegisterClientEvent;
dnsRegisterDeviceEvent DNS_RegisterDeviceEvent;
dnsRegisterServerEvent DNS_RegisterServerEvent;
dnsSendDeviceExplicit DNS_SendDeviceExplicit;
dnsSendServerExplicit DNS_SendServerExplicit;
dnsSetAccessTimeout DNS_SetAccessTimeout;
dnsSetEventNotificationInterval DNS_SetEventNotificationInterval;
dnsStartScan DNS_StartScan;
dnsStopScan DNS_StopScan;
dnsUnRegisterBusStatusEvent DNS_UnRegisterBusStatusEvent;
dnsUnRegisterClientEvent DNS_UnRegisterClientEvent;
dnsUnRegisterDeviceEvent DNS_UnRegisterDeviceEvent;
dnsUnRegisterServerEvent DNS_UnRegisterServerEvent;
dnsVersion DNS_Version;
dnsWriteDeviceIo DNS_WriteDeviceIo;
dnsWriteServerIo DNS_WriteServerIo;

// dnerr32.dll function pointers
dneCommandError DNE_CommandError;

/////////////////////////////////////////////////////////////////////////////
// XDeviceNet
//------------------------------------------------------
// Procedure   : m_sDeviceStatus
// Description : Initialize the static variables
// Arguments   : static variable
// Returns     : 
//------------------------------------------------------
CString XDeviceNet::m_sDeviceStatus[] =
{ 
	"Device not in scan list",
	"Device Idle (not being scanned)",
	"Active",
	"Timeout!",
	"Error opening UCMM connection!",
	"Master/Slave connection set is busy!",
	"Error allocating Master/Slave connection set!",
	"Device Vendor Id mismatch!",
	"Error reading Device Vendor Id!",
	"Device Product Type mismatch!",
	"Error reading Product Type!",
	"Device Product Code mismatch!",
	"Error reading Product Code!",
	"Invalid I/O 1 connection input size!",
	"Error reading I/O 1 connection input size!",
	"Invalid I/O 1 connection output size!",
	"Invalid I/O 1 connection output size!",
	"Invalid I/O 2 connection input size!",
	"Error reading I/O 2 connection input size!",
	"Invalid I/O 2 connection output size!",
	"Invalid I/O 2 connection output size!",
	"Error setting I/O 1 connection EPR!",
	"Error setting I/O 2 connection EPR!",
	"Master/Slave connection set synch fault!",
	"Unknown status code!"
};

//------------------------------------------------------
// Procedure   : XDeviceNet
// Description : Construction
// Arguments   : void
// Returns     : 
//------------------------------------------------------
XDeviceNet::XDeviceNet()
{
	m_bOpen			= FALSE;
	m_bOnline		= FALSE;
	m_bStart		= FALSE;
	m_bActive		= FALSE;
	m_bInputUpdated	= FALSE;
}

//------------------------------------------------------
// Procedure   : ~XDeviceNet
// Description : Destruction
// Arguments   : void
// Returns     : 
//------------------------------------------------------
XDeviceNet::~XDeviceNet()
{
	delete m_DeviceConfig;
}

/////////////////////////////////////////////////////////////////////////////
// XDeviceNet message handlers
//------------------------------------------------------
// Procedure   : GetProcAddresses
// Description : Load dnscan32 DLL 
// Arguments   : HMODULE LibInst (DLL Library Instance)
// Returns     : BOOL TRUE = success
//                    FALSE = function not found
//------------------------------------------------------
BOOL XDeviceNet::GetProcAddresses( HMODULE LibInst )
{
    if ( (DNS_AddDevice = ( dnsAddDevice )GetProcAddress( LibInst, "DNS_AddDevice" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_DeleteDevice = ( dnsDeleteDevice )GetProcAddress( LibInst, "DNS_DeleteDevice" )) == NULL )
    {
        return FALSE;
    }
    if ( (DNS_CloseCard = ( dnsCloseCard )GetProcAddress( LibInst, "DNS_CloseCard" )) == NULL)
	{
        return FALSE;
    }
    if ( (DNS_Driver = ( dnsDriver )GetProcAddress( LibInst, "DNS_Driver" )) == NULL)
	{
        return FALSE;
    }
    if ( (DNS_FreeDriver = ( dnsFreeDriver )GetProcAddress( LibInst, "DNS_FreeDriver" )) == NULL)
	{
        return FALSE;
    }
    if ( (DNS_GetBusStatus = ( dnsGetBusStatus )GetProcAddress( LibInst, "DNS_GetBusStatus" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_GetClientEvent = ( dnsGetClientEvent )GetProcAddress( LibInst, "DNS_GetClientEvent" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_GetClientStatus = ( dnsGetClientStatus )GetProcAddress( LibInst, "DNS_GetClientStatus" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_GetDevice = ( dnsGetDevice )GetProcAddress( LibInst, "DNS_GetDevice" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_GetDeviceEvent = ( dnsGetDeviceEvent )GetProcAddress( LibInst, "DNS_GetDeviceEvent" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_GetDevicePath = ( dnsGetDevicePath )GetProcAddress( LibInst, "DNS_GetDevicePath" )) == NULL)
    {
        return FALSE;
    }
	if ( (DNS_GetDeviceStatus = ( dnsGetDeviceStatus )GetProcAddress( LibInst, "DNS_GetDeviceStatus" )) == NULL)
    {
        return FALSE;
    }
	if ( (DNS_GetModuleHeader = ( dnsGetModuleHeader )GetProcAddress( LibInst, "DNS_GetModuleHeader" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_GetServerEvent = ( dnsGetServerEvent )GetProcAddress( LibInst, "DNS_GetServerEvent" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_GetServerPath = ( dnsGetServerPath )GetProcAddress( LibInst, "DNS_GetServerPath" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_GetServerStatus = ( dnsGetServerStatus )GetProcAddress( LibInst, "DNS_GetServerStatus" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_InitializePathBuffer = ( dnsInitializePathBuffer )GetProcAddress( LibInst, "DNS_InitializePathBuffer")) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_IoActive = ( dnsIoActive )GetProcAddress( LibInst, "DNS_IoActive")) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_IoIdle = ( dnsIoIdle )GetProcAddress( LibInst, "DNS_IoIdle")) == NULL)
	{
        return FALSE;
    }
    if ( (DNS_LoadDriver = ( dnsLoadDriver )GetProcAddress( LibInst, "DNS_LoadDriver")) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_Log = ( dnsLog )GetProcAddress( LibInst, "DNS_Log")) == NULL)
    {
        return FALSE;
    }
	if ( (DNS_Offline = ( dnsOffline )GetProcAddress( LibInst, "DNS_Offline" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_Online = ( dnsOnline )GetProcAddress( LibInst, "DNS_Online" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_OpenCard = ( dnsOpenCard )GetProcAddress( LibInst, "DNS_OpenCard" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_ReadDeviceIo = ( dnsReadDeviceIo )GetProcAddress( LibInst, "DNS_ReadDeviceIo" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_ReadServerIo = ( dnsReadServerIo )GetProcAddress( LibInst, "DNS_ReadServerIo" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_ReceiveDeviceExplicit = ( dnsReceiveDeviceExplicit )GetProcAddress( LibInst, "DNS_ReceiveDeviceExplicit" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_ReceiveServerExplicit = ( dnsReceiveServerExplicit )GetProcAddress( LibInst, "DNS_ReceiveServerExplicit" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_RegisterBusStatusEvent = ( dnsRegisterBusStatusEvent )GetProcAddress( LibInst, "DNS_RegisterBusStatusEvent" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_RegisterClientEvent = ( dnsRegisterClientEvent )GetProcAddress( LibInst, "DNS_RegisterClientEvent" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_RegisterDeviceEvent = ( dnsRegisterDeviceEvent )GetProcAddress( LibInst, "DNS_RegisterDeviceEvent" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_RegisterServerEvent = ( dnsRegisterServerEvent )GetProcAddress( LibInst, "DNS_RegisterServerEvent" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_SendDeviceExplicit = ( dnsSendDeviceExplicit )GetProcAddress( LibInst, "DNS_SendDeviceExplicit" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_SendServerExplicit = ( dnsSendServerExplicit )GetProcAddress( LibInst, "DNS_SendServerExplicit" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_SetAccessTimeout = ( dnsSetAccessTimeout )GetProcAddress( LibInst, "DNS_SetAccessTimeout")) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_SetEventNotificationInterval = ( dnsSetEventNotificationInterval )GetProcAddress( LibInst, "DNS_SetEventNotificationInterval" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_StartScan = ( dnsStartScan )GetProcAddress( LibInst, "DNS_StartScan" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_StopScan = ( dnsStopScan )GetProcAddress( LibInst, "DNS_StopScan" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_UnRegisterBusStatusEvent = ( dnsUnRegisterBusStatusEvent )GetProcAddress( LibInst, "DNS_UnRegisterBusStatusEvent" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_UnRegisterClientEvent = ( dnsUnRegisterClientEvent )GetProcAddress( LibInst, "DNS_UnRegisterClientEvent" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_UnRegisterDeviceEvent = ( dnsUnRegisterDeviceEvent )GetProcAddress( LibInst, "DNS_UnRegisterDeviceEvent" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_UnRegisterServerEvent = ( dnsUnRegisterServerEvent )GetProcAddress( LibInst, "DNS_UnRegisterServerEvent" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_Version = ( dnsVersion )GetProcAddress( LibInst, "DNS_Version" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_WriteDeviceIo = ( dnsWriteDeviceIo )GetProcAddress( LibInst, "DNS_WriteDeviceIo" )) == NULL)
    {
        return FALSE;
    }
    if ( (DNS_WriteServerIo = ( dnsWriteServerIo )GetProcAddress( LibInst, "DNS_WriteServerIo" )) == NULL)
    {
        return FALSE;
    }

    return TRUE;
}

void XDeviceNet::SetMaxNode(UINT uMaxNode)
{
	m_uMaxNode = uMaxNode;

	DNS_DEVICE_CFG DeviceConfig = {0};

	m_DeviceConfig = new DNS_DEVICE_CFG[m_uMaxNode];

	for( UINT i=0; i<m_uMaxNode; i++ )
	{
		m_DeviceConfig[i] = DeviceConfig;
	}
}

//--------------------------------------------------------------------
// Procedure   : OpenCard
// Description : (SST DeviceNet card type : 5136-DNP (32bit ISA card)
//	1. load the library of dnscan32.dll
//	2. get the function pointer of dnscan32
//	3. load the library of dnerr32.dll
//	4. get the function pointer of dnerr32
//	5. DNS_LoaderDriver()
//	6. DNS_OpenCard()
// Arguments   : void
// Returns     : BOOL TRUE = success
//                    FALSE = execution failed
//--------------------------------------------------------------------
BOOL XDeviceNet::OpenCard(char* szName)
{
	// load dnscan32 DLL
	m_hLibInst = LoadLibrary( "dnscan32.dll" );

	if( m_hLibInst == NULL )
    {
        AfxMessageBox( "LoadLibrary Failed", MB_OK, MB_ICONEXCLAMATION );
		return FALSE;
	}
    // get proc addresses for dnscan32 function calls
    if( GetProcAddresses( m_hLibInst ) == FALSE )
    {
		AfxMessageBox( "Invalid Library!", MB_OK, MB_ICONEXCLAMATION );        
        FreeLibrary( m_hLibInst );        
		return FALSE;
	}

    // load dnerr32 DLL
    m_hErrInst = LoadLibrary( "dnerr32.dll" );

	if( m_hErrInst == NULL )
    {
		AfxMessageBox( "LoadLibrary Failed", MB_OK, MB_ICONEXCLAMATION );        
        FreeLibrary( m_hLibInst );        		
        return FALSE;
	}
    // get proc address for error library
    if ( (DNE_CommandError = ( dneCommandError )GetProcAddress( m_hErrInst, "DNE_CommandError" )) == FALSE)
    {
		AfxMessageBox( "Invalid Library!", MB_OK, MB_ICONEXCLAMATION );
        FreeLibrary( m_hLibInst );
        FreeLibrary( m_hErrInst );
        return FALSE;
    }

    // load the hardware driver DLL
	if( DNS_LoadDriver( "ssdn32.dll" ) == FALSE )
    {
		AfxMessageBox( "Unable to load hardware driver DLL", MB_OK, MB_ICONEXCLAMATION );
        FreeLibrary( m_hLibInst );
        FreeLibrary( m_hErrInst );
        return FALSE;
    }

    // open a card connection (default : 0x250 => set by dip switch)
    if( DNS_OpenCard( &m_dwCardHandle, szName, NULL, 0 ) == FALSE )
    {
		// retrieve the error string
        DNE_CommandError( GetLastError(), m_szErrorString, sizeof(m_szErrorString) );
		AfxMessageBox( "DNS_OpenCard : " + CString( m_szErrorString ), MB_OK, MB_ICONEXCLAMATION );
		DNS_FreeDriver();
        FreeLibrary( m_hLibInst );
        FreeLibrary( m_hErrInst );
        return FALSE;
    }

	m_bOpen		= TRUE;

	return TRUE;
}

//--------------------------------------------------------------------
// Procedure   : Online
// Description : 
//	1. Set the scanner parameter (MacId, BaudRate) : Scanner MacId = 0
//	2. DNS_Online() / DNS_Offline()
// Arguments   : BOOL bOnline (TRUE : Online, FALSE : Offline)
// Returns     : BOOL TRUE = success
//                    FALSE = execution failed
//--------------------------------------------------------------------
BOOL XDeviceNet::Online( BOOL bOnline )
{
	if( bOnline )
	{
		DNS_SCANNER_CFG ScannerConfig = {0};

		// setup the scanner parameters and go online    
		// no server parameters selected.
		ScannerConfig.MacId = 0;	// SST DeviceNet Card MacID
		ScannerConfig.BaudRate = DN_500K;
		ScannerConfig.StrobeInterval = 50;
		ScannerConfig.ResponseTimeout = 1000;
	
		// no connection established for the device
		ScannerConfig.Flags = 0;

		if( DNS_Online( m_dwCardHandle, &ScannerConfig ) == FALSE )
		{
			// retrieve the error string
			DNE_CommandError( GetLastError(), m_szErrorString, sizeof(m_szErrorString) );
			AfxMessageBox( "DNS_Online : " + CString( m_szErrorString ), MB_ICONSTOP | MB_SYSTEMMODAL | MB_OK );
			CloseCard();
			return FALSE;
		}

		m_bOnline = TRUE;
	}
	else
	{
		if( DNS_Offline( m_dwCardHandle ) == FALSE )
		{
			// retrieve the error string
			DNE_CommandError( GetLastError(), m_szErrorString, sizeof(m_szErrorString) );
			AfxMessageBox( "DNS_Offline : " + CString(  m_szErrorString ), MB_OK, MB_ICONEXCLAMATION );        
			CloseCard();
			return FALSE;
		}

		m_bOnline = FALSE;
	}

	return TRUE;
}

//--------------------------------------------------------------------
// Procedure   : AddDevice
// Description : 
//	1. Set the Device Configuration (MacId, In/Out size)
//	2. DNS_AddDevice()
// Arguments   : WORD wMacId
//				 WORD wInputSize
//				 WORD wOutputSize
//				 WORD wConnectionFlag
// Returns     : BOOL TRUE = success
//                    FALSE = execution failed
//--------------------------------------------------------------------
BOOL XDeviceNet::AddDevice( WORD wMacId, WORD wInputSize, WORD wOutputSize, WORD wConnectionFlag )
{
	// setup device configuration and add slave to scanlist
	m_DeviceConfig[wMacId - 1].MacId = wMacId;

	// if vendor id, product code, and product type are 0 they will be ignored
	// a call to DNS_GetDevice will retrieve the VendorId, DeviceType, and ProductCode
	// read from the device
	m_DeviceConfig[wMacId - 1].VendorId = 0;
	m_DeviceConfig[wMacId - 1].ProductCode = 0;
	m_DeviceConfig[wMacId - 1].DeviceType = 0;

	// device is polled
	m_DeviceConfig[wMacId - 1].Flags = wConnectionFlag;

	// poll connection alone uses I/O connection 1
	m_DeviceConfig[wMacId - 1].Input1Size = wInputSize;
	m_DeviceConfig[wMacId - 1].Input1Offset = 0x1000 + 0x200 * ( wMacId - 1 );
	m_DeviceConfig[wMacId - 1].Output1Size = wOutputSize;
	m_DeviceConfig[wMacId - 1].Output1Offset = 0x1100 + 0x200 * ( wMacId - 1 );

	// add the device to the scan list
	if( DNS_AddDevice( m_dwCardHandle, &m_DeviceConfig[wMacId - 1] ) == FALSE )
	{
		// retrieve the error string
		DNE_CommandError( GetLastError(), m_szErrorString, sizeof(m_szErrorString) );
		AfxMessageBox( "DNS_AddDevice : " + CString( m_szErrorString ), MB_OK, MB_ICONEXCLAMATION );
		CloseCard();
		return FALSE;
	}

	return TRUE;
}

//--------------------------------------------------------------------
// Procedure   : StartScan
// Description : DNS_StartScan() / DNS_StopScan()
// Arguments   : BOOL bStart
// Returns     : BOOL TRUE = success
//                    FALSE = execution failed
//--------------------------------------------------------------------
BOOL XDeviceNet::StartScan(BOOL bStart)
{
	if( bStart )
	{
		// start scanning
		if( DNS_StartScan( m_dwCardHandle ) == FALSE )
		{
			// retrieve the error string
			DNE_CommandError( GetLastError(), m_szErrorString, sizeof(m_szErrorString) );
			AfxMessageBox( "DNS_StartScan : " + CString( m_szErrorString ), MB_OK, MB_ICONEXCLAMATION );
			CloseCard();

			return FALSE;
		}

		m_bStart = TRUE;
	}
	else
	{
		// stop scanning
		if( DNS_StopScan( m_dwCardHandle ) == FALSE )
		{
			// retrieve the error string
			DNE_CommandError( GetLastError(), m_szErrorString, sizeof(m_szErrorString) );
			AfxMessageBox( "DNS_StopScan : " + CString( m_szErrorString ), MB_OK, MB_ICONEXCLAMATION );
			CloseCard();
			return FALSE;
		}
		m_bStart = FALSE;
	}
	return TRUE;
}

//--------------------------------------------------------------------
// Procedure   : ReadIo
// Description : DNS_ReadDeviceIo()
// Arguments   : WORD wMacId 
// Returns     : BOOL TRUE = success
//                    FALSE = execution failed
//--------------------------------------------------------------------
BOOL XDeviceNet::ReadIo(WORD wMacId, BYTE* pBuffer)
{
	if( m_bActive && m_bInputUpdated )
	{
		if( DNS_ReadDeviceIo( m_dwCardHandle, m_DeviceConfig[wMacId - 1].MacId, DNS_INPUT1, pBuffer, m_DeviceConfig[wMacId - 1].Input1Size ) == FALSE )
		{
			// retrieve the error string
			DNE_CommandError( GetLastError(), m_szErrorString, sizeof(m_szErrorString) );
			AfxMessageBox( "DNS_ReadDeviceIo : " + CString( m_szErrorString ), MB_OK, MB_ICONEXCLAMATION );
			CloseCard();
			return FALSE;
		}
	}
	return TRUE;
}

//--------------------------------------------------------------------
// Procedure   : WriteIo
// Description : DNS_WriteDeviceIo()
// Arguments   : WORD wMacId 
// Returns     : BOOL TRUE = success
//                    FALSE = execution failed
//--------------------------------------------------------------------
BOOL XDeviceNet::WriteIo(WORD wMacId, BYTE* pBuffer)
{
	if( m_bActive )
	{
		if( DNS_WriteDeviceIo( m_dwCardHandle, m_DeviceConfig[wMacId - 1].MacId, DNS_OUTPUT1, pBuffer, m_DeviceConfig[wMacId - 1].Output1Size ) == FALSE )
		{
			// retrieve the error string
			DNE_CommandError( GetLastError(), m_szErrorString, sizeof(m_szErrorString) );
			AfxMessageBox( "DNS_WriteDeviceIo : " + CString( m_szErrorString ), MB_OK, MB_ICONEXCLAMATION );
			CloseCard();
			return FALSE;
		}
	}
	return TRUE;
}

//------------------------------------------------------
//
// Procedure   : CloseCard 
//
// Description : Close the card and free the libraries
//
// Arguments   : DWORD m_dwCardHandle
//               HMODULE m_hLibInst
//               HMODULE ErrInst
//
// Returns     : void
//
//------------------------------------------------------
void XDeviceNet::CloseCard()
{
	if( m_bOpen )
	{
		DNS_CloseCard( m_dwCardHandle );
		DNS_FreeDriver();
		FreeLibrary( m_hLibInst );
		FreeLibrary( m_hErrInst );

		m_bOpen		= FALSE;
		m_bOnline	= FALSE;
		m_bStart	= FALSE;
		m_bActive	= FALSE;
	}
}

//--------------------------------------------------------------------
// Procedure   : Monitor
// Description : DNS_GetDeviceStatus()
//				Monitoring the current DeviceNet status
// ߰  : Multi Board Ͽ Monitoring ϴ 
// Arguments   : WORD wMacID
// Return      : BOOL 
//				FALSE	: Status is not changed
//				TRUE	: Status is changed
//--------------------------------------------------------------------
BOOL XDeviceNet::Monitor(WORD wMacId)
{
	if( !m_bOpen ) return FALSE;

	// device status data structure
	DNS_STATUS DeviceStatus = {0};

	// local device status bytef
	static BYTE byPreviousStatus = 0xff;

	// local device event buffer
	BYTE DeviceEvent = {0};

	// read the device status
	if( DNS_GetDeviceStatus( m_dwCardHandle, m_DeviceConfig[wMacId - 1].MacId, &DeviceStatus ) == FALSE )
	{
		// retrieve the error string
		DNE_CommandError( GetLastError(), m_szErrorString, sizeof( m_szErrorString ) );
		AfxMessageBox( "DNS_GetDeviceStatus : " + CString( m_szErrorString ), MB_OK, MB_ICONEXCLAMATION );
		CloseCard();
		return FALSE;
	}

	BOOL bRv = FALSE;

	// update screen only if status changes
	if( byPreviousStatus != DeviceStatus.StatusCode )
	{
		// save the current status
		byPreviousStatus = DeviceStatus.StatusCode;

		// display device status
		switch( DeviceStatus.StatusCode )
		{
		case DNS_NON_EXIST:
		case DNS_IDLE:
		case DNS_ACTIVE:
		case DNS_TIMEOUT:
		case DNS_FAULT_UCMM:
		case DNS_MS_BUSY:
		case DNS_FAULT_MS:
		case DNS_BAD_VENDOR:
		case DNS_FAULT_VENDOR:
		case DNS_BAD_TYPE:
		case DNS_FAULT_TYPE:
		case DNS_BAD_CODE:
		case DNS_FAULT_CODE:
		case DNS_BAD_IO1_INPUT_SIZE:
		case DNS_FAULT_IO1_INPUT_SIZE:
		case DNS_BAD_IO1_OUTPUT_SIZE:
		case DNS_FAULT_IO1_OUTPUT_SIZE:
		case DNS_BAD_IO2_INPUT_SIZE:
		case DNS_FAULT_IO2_INPUT_SIZE:
		case DNS_BAD_IO2_OUTPUT_SIZE:
		case DNS_FAULT_IO2_OUTPUT_SIZE:
		case DNS_FAULT_SETTING_IO1_RATE:
		case DNS_FAULT_SETTING_IO2_RATE:
		case DNS_MS_SYNC:
			m_sCurDeviceStatus = m_sDeviceStatus[DeviceStatus.StatusCode];
			break;
		default:
			m_sCurDeviceStatus = "Unknown status code!";
			break;
		}
		bRv = TRUE;
	}

	// when it is only DNS_ACTIVE, we can scan the device.
	if( DeviceStatus.StatusCode == DNS_ACTIVE ) 
	{
		BYTE byDeviceEvent = {0};

		// retrieve the I/O Input 1 event flags
		if( DNS_GetDeviceEvent( m_dwCardHandle, wMacId, DNS_IO1_EVENT, &byDeviceEvent ) == FALSE )
		{
			// retrieve the error string
			DNE_CommandError( GetLastError(), m_szErrorString, sizeof(m_szErrorString) );
			AfxMessageBox( "DNS_GetDeviceEvent : " + CString( m_szErrorString ), MB_OK, MB_ICONEXCLAMATION );        
			CloseCard();
			return FALSE;
		}
		else
		{
			// is there an input data update event present
			if( byDeviceEvent & DNS_INPUT_DATA_UPDATE ) m_bInputUpdated = TRUE;
			else m_bInputUpdated = FALSE;
		}
		m_bActive = TRUE;
	}
	else m_bActive = FALSE;
	
	return bRv;
}