// CvSeq.cpp: implementation of the CCvSeq class.
// Ver 1.1
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "CvSeq.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCvSeq::CCvSeq()
{

}

CCvSeq::~CCvSeq()
{

}

void CCvSeq::InitParameter()
{
	m_nSeqUnitLdNo	= 0;
	m_nSeqUnitUl1No	= 0;
	m_nSeqUnitUl2No = 0;
	m_nSeqUnitUlTiltNo = 0;
	m_nSeqAkManualCheckNo = 0;
	m_nSeqCVMotorDeccelNo = 0;
	m_bUnloadWaitRequest = FALSE;
	m_bAkManualAlarm = FALSE;

	m_pDicsData->m_GenInfo.bUlTimeOut = FALSE;
	m_pDicsData->m_GenInfo.bUlNotReady = FALSE;
	int i = 0;
///////////////////////////////////////////////////////////////////////////////
// Init : Member
///////////////////////////////////////////////////////////////////////////////
	for( i = IF_UNIT_LD; i < MAX_UNIT_NO ; i ++ )
	{
		m_nSeqInSensorNo[i]				= 0;
		m_nSeqOutSensorNo[i]			= 0;
		m_nSeqInSensorSickAlarmNo[i]	= 0;
		m_nSeqOutSensorSickAlarmNo[i]	= 0;
	}

	m_nStopCountAll		= 0;
	m_nStopCount		= 0;	
///////////////////////////////////////////////////////////////////////////////
// Init : IfFlag
///////////////////////////////////////////////////////////////////////////////
	for( i=0; i<MAX_IF_NO; i++ )
	{
		m_pDicsData->m_IfFlag[i].bInReady				= FALSE;				// in TRUE̸ .
		m_pDicsData->m_IfFlag[i].bOutReady				= FALSE;
		m_pDicsData->m_IfFlag[i].bInComp				= FALSE;
		m_pDicsData->m_IfFlag[i].bWaitPos				= FALSE;
		m_pDicsData->m_IfFlag[i].bInError				= FALSE;
		m_pDicsData->m_IfFlag[i].bOutError				= FALSE;
		m_pDicsData->m_IfFlag[i].bSeqStop				= FALSE;
		m_pDicsData->m_IfFlag[i].bInSick				= FALSE; 
		m_pDicsData->m_IfFlag[i].bOutSick				= FALSE; 
		m_pDicsData->m_IfFlag[i].bInLogicCheckIgnore	= TRUE;
		m_pDicsData->m_IfFlag[i].bOutLogicCheckIgnore	= TRUE;
		m_pDicsData->m_IfFlag[i].bRecoveryReq			= FALSE;
		m_pDicsData->m_IfFlag[i].bCvBwReq				= FALSE;
		m_pDicsData->m_IfFlag[i].bRecvComp				= FALSE;

		
		m_pDicsData->m_IfFlag[i].bOutComp = TRUE;								// outcomp FALSE  CV .

		if( i != IF_UNIT_LD)		// LOAD FALSḚ  TRUE̴.
		{
			m_pDicsData->m_IfFlag[i].bInComp			= TRUE;
		}
	}
	
///////////////////////////////////////////////////////////////////////////////		
// Init : SeqFlag
///////////////////////////////////////////////////////////////////////////////
	for( i=0; i<MAX_UNIT_NO; i++ )
	{
		for( int j=0; j<MAX_STOP_COUNT_NO; j++ )
		{
			m_pDicsData->m_SeqFlag.nRollerState[j][i]		= cvSTOP;
			m_pDicsData->m_SeqFlag.nRollerStateAll[j][i]	= cvSTOP;
			m_pDicsData->m_SeqFlag.bSeqStopState[j][i]		= FALSE;
		}			
	}

	m_pDicsData->m_SeqFlag.bStopCount1		= FALSE;
	m_pDicsData->m_SeqFlag.bStopCount2		= FALSE;
	m_pDicsData->m_SeqFlag.bGlassOutComp1	= TRUE;
	m_pDicsData->m_SeqFlag.bGlassOutComp2	= TRUE;
	m_pDicsData->m_SeqFlag.bGlassGetComp	= FALSE;
///////////////////////////////////////////////////////////////////////////////		
// Init : Debug Mode
///////////////////////////////////////////////////////////////////////////////		
#ifdef _MY_DEBUG
	for( i=0; i<MAX_UNIT_NO; i++ )
	{
		m_pDicsData->m_bDebugInSensor[i] = FALSE;
		m_pDicsData->m_bDebugOutSensor[i] = FALSE;
	}
#endif

	for( i=0; i<MAX_CV_NO; i++ )
	{
		m_CvMotor.nCvAuto[i] = cvSTOP;
		m_CvMotor.nSpeedAuto[i] = 0;
	}
	for( i=0; i<MAX_CV_MOTOR_NO; i++ )
	{
		m_CvMotor.nCvManual[i] = cvSTOP;
		m_CvMotor.nSpeedManual[i] = 0 ;
	}	
}

BOOL CCvSeq::Initialize()
{
	m_nSeqInitNo	= 0;

	InitParameter();
	
	return TRUE;
}

BOOL CCvSeq::Sequence()
{
	Sleep( 10 );

	SeqInit();

	SeqUnitLd();	// Ϻ (in)_ , ο EV Ÿ Ϻη ԵǴ .  ʿ.
					// ó InCV . Robot     Ǿ ٷ Ǹ ȵǱ   ִ.
	SeqInSensor( IF_UNIT_SWR1 );
	SeqInSensor( IF_UNIT_SWR2 );
	SeqInSensor( IF_UNIT_SWR3 );	
	SeqInSensor( IF_UNIT_SWR4 );	
	SeqInSensor( IF_UNIT_AK );
	SeqInSensor( IF_UNIT_BUF );

	SeqOutSensor( IF_UNIT_LD );
	SeqOutSensor( IF_UNIT_SWR1 );
	SeqOutSensor( IF_UNIT_SWR2 );
	SeqOutSensor( IF_UNIT_SWR3 );
	SeqOutSensor( IF_UNIT_SWR4 );
	SeqOutSensor( IF_UNIT_AK );
	SeqOutSensor( IF_UNIT_BUF );

	SeqUnitUl1();	// out . in out Լ  Ѵ. UN IN sensor .
	if( m_pDicsData->m_GenInfo.bAuto )
	{
		SeqCVMotorAccelDeccel();
	}
	SeqUnitUl2();	//  UN OUT sensor .

	SeqCvMotorSpeedControl();

	for( int i = CV_NO_LD; i<m_pEqpAssy->m_CvMotor.GetMaxSectionNo(); i++) 
	{
		SeqCv(i);	
		SeqCvMotorControl(i);
	}
	
	for( int i = CV_NO_LD; i<m_pEqpAssy->m_CvMotorAll.GetMaxSectionNo(); i++) 
	{
		SeqCvMotorManualControl(i);
	}

	CheckStopCountCond();

	SeqCvManualControlInterlock();
	SeqAkManualInterlockCheck();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
// Initialize The Sequence
//////////////////////////////////////////////////////////////////////////
void CCvSeq::SeqInit()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	static int nReturnSeqNo = 0;
	static DWORD dwTickStart = 0;

	// Use for alarm reset
	static int nAlarmId[MAX_CV_MOTOR_NO] = { 0, };
	CString sSeqName( "SeqInit    " );
	int tm = TM_SEQ_INIT_CV;

	static CString sCvName[] = 
	{
		"LD UNIT CV MOTOR",
		"SWR1 UNIT CV MOTOR",
		"SWR2 UNIT CV MOTOR",
		"SWR3 UNIT CV MOTOR",
		"SWR4 UNIT CV MOTOR",
		"AK UNIT CV MOTOR",
		"BUF UNIT CV MOTOR",
		"UL UNIT CV MOTOR"
	};

	int nSeqNo = m_nSeqInitNo;

	DWORD dwOutCvAlignTime = 1000 * atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_ALIGN_CYL_TIMEOUT]);
	DWORD dwOutCvAlignUDTime = 1000 * atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_ALIGN_UD_CYL_TIMEOUT]);
	DWORD dwOutCvPinTime = 1000 * atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_PIN_UD_CYL_TIMEOUT]);
	
	switch( nSeqNo )
	{
	case 0 :
		if( m_SeqFlag.bInitReq )
		{
			Msg( WM_INIT_STATUS, MSG_STATUS_RESET_MAIN, NULL, TRUE );

			nSeqNo = 5;
		}
		break;
	case 5 :
		if( m_SeqFlag.bInitReq )
		{
			nSeqNo = 6;
		}
		break;
		// hskwak 2019.0520 Ul CV GLS Data ְ PIN UP Ǿ ִٸ ְ  GLS ִ Sensor ȮѴ.
	case 6:
		{
			BOOL bIsValid = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2].bIsValid;
#ifndef _MY_DEBUG
			BOOL bStatePinUp = m_pEqpAssy->m_CylinderUlPinUD.GetBw();
#else
			BOOL bStatePinUp = m_pEqpAssy->m_CylinderUlPinUD.GetBwState();
#endif
//			if( bIsValid && !bStatePinUp)	// GLS Data ְ PIN UP .
			{
				m_pEqpAssy->m_CylinderUlAlign.SetBw();
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], 0, 0, "UL ALIGN BW : ON" );
				dwTickStart = GetTickCount();
				nSeqNo = 7;
			}
//			else
//			{
//				nSeqNo = 10;	// GLS Data ְ PIN UP  ° ƴϴ.
//			}
		}
		break;
	case 7:
		{
#ifndef _MY_DEBUG
			if( m_pEqpAssy->m_CylinderUlAlign.GetBw() )
#else
			if( m_pEqpAssy->m_CylinderUlAlign.GetBwState() )
#endif
			{
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], 0, 0, "UL ALIGN BW : OK" );
				nSeqNo = 8;
			}
			else if( ( GetTickCount() - dwTickStart ) > dwOutCvAlignTime )
			{
				nAlarmId[0] = ALM_OUTCV_UNIT_ALIGN_BW;
				m_pEqpStateSeq->SetAlarm( nAlarmId[0] );

				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], 0, 0, "UL ALING BW : NG" );
				nReturnSeqNo = nSeqNo;
				nSeqNo = 5000;			
			}
		}
		break;
	case 8:
		{
			m_pEqpAssy->m_CylinderUlAlignUD.SetBw();
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], 0, 0, "UL ALIGN DOWN : ON" );
			dwTickStart = GetTickCount();
			nSeqNo = 9;
		}
		break;
	case 9:
		{
#ifndef _MY_DEBUG
			if( m_pEqpAssy->m_CylinderUlAlignUD.GetBw() )
#else
			if( m_pEqpAssy->m_CylinderUlAlignUD.GetBwState() )
#endif
			{
				dwTickStart = GetTickCount();
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], 0, 0, "UL ALIGN DOWN : OK" );
				nSeqNo = 10;
			}
			else if( ( GetTickCount() - dwTickStart ) > dwOutCvAlignUDTime )
			{
				nAlarmId[0] = ALM_OUTCV_UNIT_ALIGN_DOWN;
				m_pEqpStateSeq->SetAlarm( nAlarmId[0] );

				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], 0, 0, "UL ALING DOWN : NG" );
				nReturnSeqNo = nSeqNo;
				nSeqNo = 5000;
			}
		}
		break;
	case 10:
		m_pEqpAssy->m_CylinderUlPinUD.SetBw();
		SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], 0, 0, "UL PIN DOWN : ON" );
		dwTickStart = GetTickCount();
		nSeqNo = 11;
		break;
	case 11:
		{
			m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[DN] = GetTickCount() - dwTickStart;
#ifndef _MY_DEBUG
			if( m_pEqpAssy->m_CylinderUlPinUD.GetBw() )
#else
//			if( ( GetTickCount() - dwTickStart ) < 2300 )	return;	
			if( m_pEqpAssy->m_CylinderUlPinUD.GetBwState() )
#endif
			{
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], 0, 0, "UL PIN DOWN : OK" );
				nSeqNo = 15;
			}
			else if( ( GetTickCount() - dwTickStart ) > dwOutCvPinTime )
			{
				m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[DN]=0;
				nAlarmId[0] = ALM_OUTCV_UNIT_PIN_DOWN;
				m_pEqpStateSeq->SetAlarm( nAlarmId[0] );

				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], 0, 0, "UL PIN DOWN : NG" );
				nReturnSeqNo = nSeqNo;
				nSeqNo = 5000;
			}
		}
		break;
	case 15 :
		{
			m_SeqFlag.bInitReq	= FALSE;
			m_SeqFlag.bInitComp	= FALSE;
			m_SeqFlag.bInitFail	= FALSE;

			m_pDicsView->m_pIfSeq->ResetInterfaceSignalAll();
			m_pDicsView->m_pMainSeq->SetRecipe2JobCond( m_pDicsData->m_GenInfo.sRecipeId );

			Msg( WM_EQP_MESSAGE, MSG_EQP_MESSAGE, (LPARAM)(LPCTSTR)"INITIALIZE : START", FALSE );

			m_sMessage.Format( "%2d%d", CDicsData::initCHECK_CV_GLASS, MSG_STATUS_START );
			Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
			
			BOOL bOk = TRUE;
			for( int i = IF_UNIT_LD ; i < m_pEqpAssy->m_CvMotor.GetMaxSectionNo(); i++ )
			{
				int nSensorNo = i;
#ifndef _MY_DEBUG
				if( !m_pDicsData->m_GenInfo.nGlassNo && 
				   ( m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo, 0 ) || m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) ) )
#else
				if( 0 )
#endif
				{
					bOk = FALSE;
					nAlarmId[i] = ALM_GLASS_SENSING1 + nSensorNo;
					m_pEqpStateSeq->SetAlarm( nAlarmId[i] );

					m_sMessage.Format( "%s GLASS SENSING ALARM", m_pDicsData->m_sUnitName[nSensorNo] );
					SetLog( sSeqName, 0, 0, m_sMessage );
				}
			}

			if( bOk )
			{
				nSeqNo = 20;
			}
			else
			{
				m_sMessage.Format("%2d%d", CDicsData::initCHECK_CV_GLASS, MSG_STATUS_NG );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				m_SeqFlag.bInitFail	= TRUE;
				nSeqNo = 1000;
			}
		}
		break;
	case 20 :
		{
			BOOL bOk = TRUE;
			for( int i = IF_UNIT_LD ; i < m_pEqpAssy->m_CvMotor.GetMaxSectionNo(); i++ )
			{
				int nSensorNo = i;

#ifndef _MY_DEBUG
				if( ( m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid && !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo, 0 ) ) || 
					( m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid && !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) ) ||
					( m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid && m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) && !m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid && nSensorNo <= IF_UNIT_AK ) ||
					( m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid && m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo + 1, 0 ) && !m_pDicsData->m_GlsInfo[nSensorNo*2 + 2].bIsValid && nSensorNo <= IF_UNIT_AK )) 
#else
				if( 0 )
#endif
				{
					bOk = FALSE;
					nAlarmId[i] = ALM_GLASS_DATA_ERROR1 + nSensorNo;
					m_pEqpStateSeq->SetAlarm( nAlarmId[i] );

					m_sMessage.Format( "%s GLASS DATA ALARM", m_pDicsData->m_sUnitName[nSensorNo] );
					SetLog( sSeqName, 0, 0, m_sMessage );
				}
			}

			if( bOk )
			{
				m_sMessage.Format("%2d%d", CDicsData::initCHECK_CV_GLASS, MSG_STATUS_OK );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				m_sMessage.Format( "%2d%d", CDicsData::initCHECK_CV_CP, MSG_STATUS_START );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				nSeqNo = 30;
			}
			else
			{
				m_sMessage.Format("%2d%d", CDicsData::initCHECK_CV_GLASS, MSG_STATUS_NG );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				m_SeqFlag.bInitFail	= TRUE;
				nSeqNo = 1000;
			}
		}
		break;
	case 30 :
		{
			BOOL bOk = TRUE;
			for( int i = 0 ; i < m_pEqpAssy->m_CvMotorAll.GetMaxSectionNo(); i++ )
			{
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_CvMotorAll.GetMotorCpAlarm( i ) )
#else
				if( FALSE )
#endif
				{
					bOk = FALSE;
					m_sMessage.Format( "%s CP DOWN ALARM", sCvName[i] );
					SetLog( sSeqName, 0, 0, m_sMessage );
				}
			}

			if( bOk )
			{
				m_sMessage.Format("%2d%d", CDicsData::initCHECK_CV_CP, MSG_STATUS_OK );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				m_sMessage.Format( "%2d%d", CDicsData::initCHECK_CV_ALARM, MSG_STATUS_START );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				nSeqNo = 40;
			}
			else
			{
				m_sMessage.Format( "%2d%d", CDicsData::initCHECK_CV_CP, MSG_STATUS_NG );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				m_SeqFlag.bInitFail	= TRUE;
				nSeqNo = 1000;
			}
		}
		break;
	case 40 :
		{
			BOOL bOk = TRUE;
			for( int i=0; i<m_pEqpAssy->m_CvMotorAll.GetMaxSectionNo(); i++ )
			{
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_CvMotorAll.GetMotorAlarm( i ) )
#else
				if( FALSE )
#endif
				{
					bOk = FALSE;
					m_sMessage.Format( "%s DRIVER ALARM", sCvName[i] );
					SetLog( sSeqName, 0, 0, m_sMessage );
				}
			}

			if( bOk )
			{
				m_sMessage.Format("%2d%d", CDicsData::initCHECK_CV_ALARM, MSG_STATUS_OK );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );

				nSeqNo = 70;
			}
			else
			{
				m_sMessage.Format( "%2d%d", CDicsData::initCHECK_CV_ALARM, MSG_STATUS_NG );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_MAIN, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
					
				m_SeqFlag.bInitFail	= TRUE;
				nSeqNo = 1000;
			}
		}
		break;
	case 70 :
		{
			for( int i=IF_UNIT_LD*2; i<m_pEqpAssy->m_GlassExistUnit.GetMaxSectionNo(); i++ )
			{
				int nSensorNo = i/2;
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo, 0 ) || m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) )
#else
				if( m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid || m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid )
#endif
				{
					m_pDicsData->m_GenInfo.bCleanOut	= TRUE;
					m_pDicsData->m_GenInfo.bCycleStop	= TRUE;

					m_pDicsData->m_SeqFlag.bTimeOver = FALSE;
					Msg( WM_TACT_TIME, ttCOUNT_START, 0L );
				}
			}
			nSeqNo = 100;
		}
		break;
	case 100 :
		{
			m_SeqFlag.bInitReq	= FALSE;
			m_SeqFlag.bInitComp	= TRUE;

			InitParameter();
			SetSeqNo();

			SetLog( sSeqName, 0, 0, "INITIALIZE : COMPLETE" );
			nSeqNo = 0;
		}
		break;
	case 1000 :
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			m_SeqFlag.bInitReq  = FALSE;

			for( int i=0; i<MAX_CV_MOTOR_NO; i++ )
			{
				if( nAlarmId[i] > 0 )
				{
					m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
					nAlarmId[i] = 0;
				}
			}

			SetLog( sSeqName, 0, 0, "ALARM RESET" );
			nSeqNo = 5;
		}
		break;
	case 5000:	// Alarm Recovery (Actuator Timeout Alarm)
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{	
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nSlotNo;

			m_pEqpStateSeq->ResetAlarm( nAlarmId[0] );
			nAlarmId[0] = 0;

			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "ALARM RESET" );
			dwTickStart = GetTickCount();
			nSeqNo = nReturnSeqNo;
		}
		break;
	}
	m_nSeqInitNo = nSeqNo;
}

void CCvSeq::SeqUnitLd()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	int nSensorNo = IF_UNIT_LD;
	int tm1 = TM_IN_SENSOR_ON( IF_UNIT_LD );
	int tm2 = TM_IN_SENSOR_OFF( IF_UNIT_LD );
	static int nTime1 = 0;
	static int nTime2 = 0;

	static DWORD dwTickStart = 0;
	static CString sOldRecipeId = m_pDicsData->m_GenInfo.sRecipeId;
	static int nAlarmId = 0;

	int nSeqNo = m_nSeqUnitLdNo;
	static int nReturnSeqNo = 0;
	static int nSlotNo		= 0;
	static int nPortNo		= 0;
	static int nGlassNo		= 0;

	TimerControl( ssIN, nSensorNo );

	DWORD dwInCvCylCheckTime = 1000 * atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupLD_ALIGN_CYL_TIMEOUT]);

	if( !GetSeqRunCond( nSensorNo ) )	return;

	CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();

	switch( nSeqNo )
	{
	case 0:
		{
			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid;
	
			if( bIsValid)
			{
				// When there is glass data.
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugInSensor[nSensorNo] = TRUE;
#endif
				nSeqNo = 50;
				m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE;
			}
			else
			{
				// NO Glass Data, but Glass Sensing
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo, 0 ) ) 
#else
				if( m_pDicsData->m_bDebugInSensor[nSensorNo] ) 
#endif
				{
					m_pDicsData->m_IfFlag[CV_NO_LD].bSeqStop = FALSE; 
					nSeqNo = 200; 
				}
				else
				{
					nSeqNo = 1;
				}
			}
		}
		break;
	case 1:
		{
			nSlotNo = 0;
			nPortNo = 0;
			nSeqNo = 10;
		}
		break;

	case 10:
		{
			m_pEqpAssy->m_CylinderLdAlign.SetBw();

			SetLog ( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "LD ALIGN BW : ON" );
			dwTickStart = GetTickCount();
			nSeqNo = 20;
		}
		break;

	case 20:
		{
#ifndef _MY_DEBUG
			if( m_pEqpAssy->m_CylinderLdAlign.GetBw() )
#else
			if( m_pEqpAssy->m_CylinderLdAlign.GetBwState() )
#endif
			{
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "LD ALIGN BW : OK" );
				nSeqNo = 30;
			}
		else if( ( GetTickCount() - dwTickStart ) > dwInCvCylCheckTime )	// setting ð
			{
				nAlarmId = ALM_INCV_UNIT_ALIGN_BW;
				m_pEqpStateSeq->SetAlarm( nAlarmId );

				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "LD ALING BW : NG" );
				nReturnSeqNo = nSeqNo;
				nSeqNo = 5000;		
			}
		}
		break;		
	case 30:
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo, 0 ) && 
			!m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) &&
			!m_pDicsData->m_GenInfo.bCycleStop && 
			!m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_LD ) &&
			m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateCLEAN] == 0 &&
			!m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid &&
			!m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid )
#else
		if( !m_pDicsData->m_bDebugInSensor[nSensorNo] 
			&& !m_pDicsData->m_bDebugOutSensor[nSensorNo] 
			&& !m_pDicsData->m_GenInfo.bCycleStop 
			&& m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateCLEAN] == 0 )
#endif
		{
			if( m_pDicsData->m_GenInfo.nGlassNo < (atoi(pDoc->m_pSetupItems->m_sValueSetup[CSetupItems::setupMAX_GLASS_NO])) )
			{
				// Glass Receive Request
				m_pDicsData->m_IfRecv.bBit[CDicsData::rcvREQ] = TRUE;
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "GLASS RECEIVE REQUEST" );
				nSeqNo = 40;
			}
		}
		break;
	case 40:
		if( m_pDicsData->m_IfRecv.bBit[CDicsData::rcvCOMP] )
		{
#ifdef _MY_DEBUG
			m_pDicsData->m_bDebugInSensor[nSensorNo] = TRUE;
#endif
			m_pDicsData->m_IfRecv.bBit[CDicsData::rcvCOMP] = FALSE;
			m_pDicsData->m_IfFlag[nSensorNo].bInReady = FALSE;

			int nGlassNo = m_pDicsData->FindGlassNo();
			m_pDicsData->SetGlassData( nSensorNo*2 + 0, nGlassNo );	// 2nd parameter : Glass No

			// Show the glass
			m_pGlassAni->StartGlassMove( nGlassNo );
			// Add a glass
			m_pDicsData->m_GenInfo.nGlassNo += 1;
			Msg( WM_GLASS_NO, m_pDicsData->m_GenInfo.nGlassNo, 1L, FALSE );
			
			//  LD <<<
			m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].bProcessed = TRUE;

			nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nSlotNo;
			nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nPortNo;
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "IN SENSOR : ON" );

			// Set Recipe ID
			CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();

			CString sRecipeId = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].sRecipeId;
				
			if( pDoc->GetRowfromID( sRecipeId ) < 0 )
			{
				sRecipeId = pDoc->m_pRecipeInfo[0].sValue[0] ;
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "RECIPEID : NG" );
			}
			m_pDicsData->m_GenInfo.sRecipeId = sRecipeId ;
			// >>>>>>

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "GLASS RECEIVE COMPLETE" );			
			nSeqNo = 50;
		}
		else if( m_pDicsData->m_IfRecv.bBit[CDicsData::rcvCANCEL_REQ] )
		{
			m_pDicsData->m_IfRecv.bBit[CDicsData::rcvCANCEL_REQ] = FALSE;
			nSeqNo = 1;
		}
		break;
	case 50:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo, 0 ) )
#else
		if( 1 )
#endif
		{
			m_pEqpAssy->m_CylinderLdAlign.SetFw();

			dwTickStart = GetTickCount();
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "GLASS EXIST : OK" );
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "LD ALIGN FW : ON" );

			nSeqNo = 60;
		}
		else if( ( GetTickCount() - dwTickStart ) > 5000 )
		{
			nAlarmId = ALM_INCV_GLS_NOT_EXIST_AFTER_RECV;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "GLASS EXIST : NG" );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 3000;
		}
		break;
	case 60:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_CylinderLdAlign.GetFw() )
#else
		if( m_pEqpAssy->m_CylinderLdAlign.GetFwState() )
#endif
		{
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "LD ALIGN FW : OK" );
			nSeqNo = 70;
		}
		else if( ( GetTickCount() - dwTickStart ) > dwInCvCylCheckTime )
		{
			nAlarmId = ALM_INCV_UNIT_ALIGN_FW;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "LD ALIGN FW : NG" );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 5000;		
		}
		break;

	case 70:
		if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupLD_UNIT_BROKEN_SENSOR] )
		{
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "LD FIXED BROKEN SENSOR CHECK : NOUSE(1ST)" );
			nSeqNo = 100;
		}
		else
		{	
			if( !m_pEqpAssy->m_FixedBrokenSensorLd.GetAnd( 0 ) )	  nAlarmId = ALM_LD_UNIT_BROKEN_SENSOR1;
			else if( !m_pEqpAssy->m_FixedBrokenSensorLd.GetAnd( 1 ) ) nAlarmId = ALM_LD_UNIT_BROKEN_SENSOR2;
			else if( !m_pEqpAssy->m_FixedBrokenSensorLd.GetAnd( 2 ) ) nAlarmId = ALM_LD_UNIT_BROKEN_SENSOR3;
			else if( !m_pEqpAssy->m_FixedBrokenSensorLd.GetAnd( 3 ) ) nAlarmId = ALM_LD_UNIT_BROKEN_SENSOR4;
			else nAlarmId = 0;
			
#ifdef _MY_DEBUG
			nAlarmId = 0;
#endif
			if( nAlarmId == 0 )
			{
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "LD FIXED BROKEN SENSOR : OK" );
				nSeqNo = 100;
			}
			else
			{
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "LD FIXED BROKEN SENSOR : NG(1ST)" );
				dwTickStart = GetTickCount();
				nSeqNo = 80;
			}
		}
		break;
	case 80:
		if( (GetTickCount() - dwTickStart) > 2000 )
		{
			nSeqNo = 90;
		}
		break;
	case 90:
		if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupLD_UNIT_BROKEN_SENSOR] )	// Thomas 200211
		{
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "LD FIXED BROKEN SENSOR CHECK : NOUSE(2ND)" );
			nSeqNo = 100;	// Thomas 200211
		}
		else
		{	
			if( !m_pEqpAssy->m_FixedBrokenSensorLd.GetAnd( 0 ) )	  nAlarmId = ALM_LD_UNIT_BROKEN_SENSOR1;
			else if( !m_pEqpAssy->m_FixedBrokenSensorLd.GetAnd( 1 ) ) nAlarmId = ALM_LD_UNIT_BROKEN_SENSOR2;
			else if( !m_pEqpAssy->m_FixedBrokenSensorLd.GetAnd( 2 ) ) nAlarmId = ALM_LD_UNIT_BROKEN_SENSOR3;
			else if( !m_pEqpAssy->m_FixedBrokenSensorLd.GetAnd( 3 ) ) nAlarmId = ALM_LD_UNIT_BROKEN_SENSOR4;
			else nAlarmId = 0;
			
#ifdef _MY_DEBUG
			nAlarmId = 0;
#endif
			if( nAlarmId == 0 )
			{
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "LD FIXED BROKEN SENSOR : OK" );
				nSeqNo = 100;	// Thomas 200211
			}
			else
			{
				m_pEqpStateSeq->SetAlarm( nAlarmId );
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "LD FIXED BROKEN SENSOR : NG(2ND)" );
				nReturnSeqNo = nSeqNo;
				nSeqNo = 1000;
			}
		}
		break;


	case 100 :  // Check Recipe
		if( m_pDicsData->m_GenInfo.sRecipeId == sOldRecipeId &&
			!m_pDicsData->m_GenInfo.bRecipeBodyChanged )
		{
			nSeqNo = 120;
		}
		else	// Recipe ID ޶
		{
			nSeqNo = 110;
		}
		break;
	case 110 :
		if( !m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 1].bIsValid && 
			!m_pDicsData->m_GlsInfo[IF_UNIT_SWR1*2 + 0].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_SWR1*2 + 1].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_SWR2*2 + 0].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_SWR2*2 + 1].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_SWR3*2 + 0].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_SWR3*2 + 1].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_SWR4*2 + 0].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_SWR4*2 + 1].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_AK*2 + 0].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_AK*2 + 1].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_BUF*2 + 0].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_BUF*2 + 1].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].bIsValid &&
			!m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].bIsValid )	// Recipe   BUF, UL Ȯ  ɵ? Tack Time.
		{
			sOldRecipeId = m_pDicsData->m_GenInfo.sRecipeId;

			if( m_pDicsData->m_GenInfo.bRecipeBodyChanged )
			{
				m_pDicsData->m_GenInfo.bRecipeBodyChanged = FALSE;
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], 0, nSlotNo, "RECIPE BODY : CHANGED" );

			}
			else
			{
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], 0, nSlotNo, "RECIPE ID : CHANGED" );
			}
			nSeqNo = 120;
		}
		break;
	case 120:		
		{
			m_pDicsView->m_pMainSeq->SetRecipe2JobCond( m_pDicsData->m_GenInfo.sRecipeId );

			// JobView Recipe Items Update
			CDicsDoc* pDoc = ( (CDicsView *) m_pOwnerWnd )->GetDocument();
			pDoc->SetRecipeId( m_pDicsData->m_GenInfo.sRecipeId );
			nSeqNo = 140;
		}
		break;
	case 140 :
		{
			BOOL bOk = TRUE;
			for( int i=IF_UNIT_LD; i<=IF_UNIT_UL; i++ )
			{
				bOk &= CheckUnitCondition( ssIN, i );	// hskwak 19.0515   ¸   Ѵ.(RB  )
			}
			
			if( bOk )
			{
				// hskwak 2020/01/03
				if( m_pDicsView->m_pHost1->m_bCeidEnable[ nSensorNo])  
				{
					m_pDicsView->m_pHost1->m_bEventReportReq[nSensorNo] = TRUE;
					SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "GLASS IN EVENT REPORT" );
				}

				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "UNIT CONDITION CHECK : OK" );
				nSeqNo = 150;
			}
			else
			{	
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "UNIT CONDITION CHECK : NG" );				
				nReturnSeqNo = nSeqNo;
				nSeqNo = 4000;
			}
		}
		break;
		//   Unload Up Hand, Unload Lo Hand, Tr Glass Ȳ ȮϿ 
		// AK   ִ  ߻  ִ Checkϰ  ϵ 
	case 150 :
		{
			int nGlassEA = 0;
			for( int i=IF_UNIT_LD; i<MAX_IF_NO; i++ )
			{
				if( m_pDicsData->m_GlsInfo[i*2 + 0].bIsValid )
					nGlassEA++;
				if( m_pDicsData->m_GlsInfo[i*2 + 1].bIsValid )
					nGlassEA++;			// hskwak 19.0515 Gls Data .
			}

			//if( nGlassEA < 4 )	// Interface  Ѵ.
			{
				int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nPortNo;
				int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nSlotNo;
				m_sMessage.Format( "ADVANCED GLASS = %d", nGlassEA );
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, m_sMessage );
				nSeqNo = 160;
				dwTickStart = GetTickCount();
			}
		}
		break;
	case 160 :
		if( m_pDicsData->m_SeqFlag.bTimeOver &&		// hskwak 19.0515  tack time check time out
			!m_pDicsData->m_SeqFlag.bStopCount1 &&	// 
			!m_pDicsData->m_SeqFlag.bStopCount2 )
		{
			m_pDicsData->m_SeqFlag.bTimeOver = FALSE;

			// Set Recipe log
			m_sMessage.Format( "RECIPE ID : %s", m_pDicsData->m_GenInfo.sRecipeId );
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, m_sMessage );
			
			// Set Tact time Log
			m_sMessage.Format( "TACT TIME : %d", ( (CDicsView *) m_pOwnerWnd )->m_nTactTime );
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, m_sMessage );

#ifndef _NO_EUV
			nSeqNo = 180;
#else
			nSeqNo = 200;
#endif			
		}
//		if( GetTickCount() - dwTickStart > 500 )
//		{
//			CString strTemp;
//			strTemp.Format("bTimeOver=%d, bStopCount1=%d, bStopCount2=%d", m_pDicsData->m_SeqFlag.bTimeOver, m_pDicsData->m_SeqFlag.bStopCount1, m_pDicsData->m_SeqFlag.bStopCount2);
//			AfxMessageBox(strTemp);
	//	}
		break;
#ifndef _NO_EUV
	case 180:
		if( !m_pDicsView->m_pEuvSeq->IsEuvUse() )
		{
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "EUV OK (EUV No Use)" );		
			nSeqNo = 200;
		}
		else if( !m_pDicsView->m_pEuvSeq->GetEuvAlarm() && 
				  m_pDicsView->m_pEuvSeq->IsEuvReady() &&
				  !m_pDicsData->m_IfEuv.bEuvUtilAlarm )
		{
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "EUV OK (EUV Use)" );
			nSeqNo = 200;
		}
		else
		{
			nAlarmId = ALM_EUV_NOT_READY;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			// Log
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "EUV Lamp Not Ready" );
			nReturnSeqNo = nSeqNo;		
			nSeqNo = 2000;
		}
		break;
#endif
	case 200:	// Glass starts
		if( m_pDicsData->m_IfFlag[IF_UNIT_LD].bOutComp )
		{
			// Flag Reset
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bInReady = TRUE;
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bInComp = TRUE;

			// Tact Time Counting Start : 
			m_pDicsData->m_SeqFlag.bTimeOver = FALSE;
			Msg( WM_TACT_TIME, ttCOUNT_START, 0L );

			for( int i=0; i<MAX_PARTS_NO; i++ )
			{
				m_pDicsView->m_pCommonIntrSeq->PartsGlsCountIncrease( i );
			}

			// Set the glass move speed
			int nGlassNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nGlassNo;

			m_pGlassAni->SetGlassMoveSpeed( nGlassNo, m_pDicsData->m_JobCond.nCvSpeed / 60 );

			// glass move
			//m_pGlassAni->GlassMove( nGlassNo, (IF_UNIT_LD+1)*2 + 1 );// hskwak 20190529
			m_pGlassAni->GlassMove( nGlassNo, (IF_UNIT_LD*2 + 1));

			GetTimeOut( IF_UNIT_LD, 0, &nTime1, &nTime2 );
#ifndef _MY_DEBUG
			TIMER_ON( tm1, nTime1 );
#else
			TIMER_ON( tm1, 20 );
			
			m_pDicsData->m_bDebugInSensor[IF_UNIT_LD] = FALSE;
#endif
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "LD UNIT MOVE TIME COUNT START" );
			nSeqNo = 210;
		}
		break;
	case 210:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_LD, 1 ) )
#else
		if( TIMER( tm1 ) )
#endif
		{
#ifdef _MY_DEBUG
			m_pDicsData->m_bDebugOutSensor[IF_UNIT_LD] = TRUE;
#endif
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bOutComp = FALSE;

			// C/V Restart for previous alarm
			if( m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError ) 
			{
				m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError = FALSE;
				m_pDicsData->m_IfFlag[IF_UNIT_LD].bRecoveryReq = FALSE;
			}

			// Glass Move Region
			nGlassNo = m_pDicsData->m_GlsInfo[IF_UNIT_LD*2 + 0].nGlassNo;
			//m_pGlassAni->GlassMoveRegion( nGlassNo, (IF_UNIT_LD+1)*2 + 1 );
			m_pGlassAni->GlassMoveRegion( nGlassNo, (IF_UNIT_LD*2 + 1));
			TIMER_ON( tm2, nTime2 + 50 );

			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "OUT SENSOR : ON" );
			nSeqNo = 220;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm1 ) )	// Sensor On Timeout Error
#else
		else if( 0 )
#endif
		{
			// Flag Set
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError = TRUE;
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bRecoveryReq = FALSE;

			// Set Alarm
			nAlarmId = ALM_SENSOR_OUT_ON_TIMEOUT1 + IF_UNIT_LD;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "OUT SENSOR ON TIMEOUT : NG" );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 1000;
		}
		break;
	case 220:
		//-----------------------------------------------------------------------------------------
		// LD UNIT Length : 1500 > Glass Size : 1300
		//-----------------------------------------------------------------------------------------
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_LD, 1 ))
#else
		if( !m_pDicsData->m_bDebugOutSensor[IF_UNIT_LD] )
#endif
		{
			// C/V Restart for previous alarm
			if( m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError ) 
			{
				m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError = FALSE;
			}
			
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "OUT SENSOR : OFF"/*, NEXT IN SENSOR : OFF(1ST)"*/ );
			dwTickStart = GetTickCount();
			nSeqNo = 230;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm2 ) )		
#else
		else if( FALSE )
#endif
		{
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bInError = TRUE;
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bRecoveryReq = FALSE;//2008.08.28 kimgun CHECK ʿ.

			// Set Alarm
			nAlarmId = ALM_SENSOR_OUT_OFF_TIMEOUT1 + IF_UNIT_LD;		// Off time Check.
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "OUT SENSOR OFF TIMEOUT : NG" );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 1000;
		}
		break;
	case 230:
		if( ( GetTickCount() - dwTickStart ) > 500 )
		{
#ifndef _MY_DEBUG
			if( !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_LD, 1 ))// && !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_SW1, 0 ))
#else
			if( !m_pDicsData->m_bDebugOutSensor[IF_UNIT_LD] )
#endif
			{
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugInterlockSensor = FALSE;
#endif
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "OUT SENSOR : OFF"/*, NEXT IN SENSOR : OFF(2ND)"*/ );
				nSeqNo = 240;
			}
			else
			{
				nSeqNo = 220;
			}
		}
		break;
	case 240 :
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_LD, 0 ) && !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_LD, 1 ) )
			/*&& !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_SWR1, 0 )*/ // && !m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_LD ) )
#else
		if( !m_pDicsData->m_bDebugInSensor[IF_UNIT_LD] && !m_pDicsData->m_bDebugOutSensor[IF_UNIT_LD] &&
			/*!m_pDicsData->m_bDebugInSensor[IF_UNIT_SWR1] &&*/ !m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_LD ) ) 
#endif
		{
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "LD CV UNIT : GLASS SEND COMPLETE" );
			//nSeqNo = 250;
			nSeqNo = 300;	// 231122 halesu move to SeqLdScanBroken()
		}
		break;
	case 250:	// hskwak 2019.06.22 SCAN Sensor ߰.
		if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupLD_UNIT_SCAN_SENSOR] )
		{
			SetLog(  m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo,"LD SCAN BROKEN SENSOR : NOUSE" );
			nSeqNo = 300;
		}
		else
		{
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo,"LD SCAN BROKEN SENSOR : USE" );
			nSeqNo = 260;
		}		
		break;
	case 260:
#ifndef _MY_DEBUG
		if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupLD_UNIT_SCAN_SENSOR] || 
			!m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_LD] ) 
#else
		if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupLD_UNIT_SCAN_SENSOR] )
#endif
		{

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "LD SCAN BROKEN SENSOR : OK" );
			nSeqNo = 300;
		}
#ifndef _MY_DEBUG
		else if( m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_LD] )
#else
		else
#endif
		{
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;

			nAlarmId = ALM_LD_UNIT_SCAN_SENSOR;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "LD SCAN BROKEN SENSOR : NG" );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 3000;
		}	
		break;

	case 300:
		{
			nSeqNo = 1;
		}
		break;
	case 1000:	// Alarm Recovery (Timeout Error)
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Set Timer
			TIMER_ON( tm1, nTime1 );
			TIMER_ON( tm2, nTime2 );

			// C/V Restart
			m_pDicsData->m_IfFlag[IF_UNIT_LD].bRecoveryReq = TRUE;

			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "ALARM RESET" );
			nSeqNo = nReturnSeqNo;
		}
		break;
	case 2000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			if ( m_pDicsView->m_pEuvSeq->GetEuvAlarm() ) return;
			if( m_pDicsData->m_IfEuv.bEuvUtilAlarm ) return;//2008.12.08 kimgun
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "ALARM RESET" );
			nSeqNo = nReturnSeqNo;
		}
		break;	
	case 3000 :	// Alarm Recovery (General Error)
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			m_pDicsData->m_IfFlag[IF_UNIT_LD].bOutError = FALSE;  
		//	m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = TRUE;

			m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_LD] = FALSE;


			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "ALARM RESET" );
			nSeqNo = nReturnSeqNo;
		}
		break;
	case 4000 :	// Alarm Recovery (Unit Condition Alarm)
		{
			BOOL bOk = TRUE;
			for( int i = IF_UNIT_LD; i<=IF_UNIT_UL; i++ )
			{
				bOk &= CheckUnitCondition( ssIN, i );
			}
			
			if( bOk )
			{
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_LD], nPortNo, nSlotNo, "UNIT CONDITION CHECK : OK(RECHECK)" );
				nSeqNo = nReturnSeqNo;
			}
		}
		break;
	case 5000:	// Alarm Recovery (Actuator Timeout Alarm)
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{			
			m_pEqpStateSeq->ResetAlarm( nAlarmId );
			nAlarmId = 0;

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "ALARM RESET" );
			dwTickStart = GetTickCount();
			nSeqNo = nReturnSeqNo;
		}
		break;
	}// Switch End
	
	m_nSeqUnitLdNo = nSeqNo;
}

void CCvSeq::SeqUnitUl1()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	int nSeqNo = m_nSeqUnitUl1No;
	static int nReturnSeqNo = 0;
	static DWORD dwTickStart = 0;

	// Use for alarm reset
	static int nAlarmId = 0;

	int nSensorNo = IF_UNIT_UL;
	int tm1 = TM_IN_SENSOR_ON( IF_UNIT_UL );
	int tm2 = TM_IN_SENSOR_OFF( IF_UNIT_UL );
	int tm3 = TM_IN_SENSOR_IN2OUT( IF_UNIT_UL );

	static int nTime1 = 0;
	static int nTime2 = 0;
	static int nTime3 = 0;
	static int nSlotNo, nPortNo, nGlassNo = 0;
	static BOOL bTm3Warning = FALSE;

	// 160704 halesu
	static BOOL bUnloadWaitOn = FALSE;
	DWORD dwDelayTime = 1000 * atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUNLOAD_WAIT_ON_DELAY] );	
	
	TimerControl( ssIN, nSensorNo );

	if( !GetSeqRunCond( nSensorNo) && nSeqNo != 1000 )	return;	// 110105 halesu

	switch( nSeqNo )
	{
	case 0:
		{
			if( nAlarmId > 0 )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId );
				nAlarmId = 0;
			}

			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid;
	
			if( bIsValid )
			{  // When there is glass data.
				m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady	= TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bInComp		= FALSE;
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugInSensor[nSensorNo]		= TRUE;
				m_pDicsData->m_bDebugOutSensor[nSensorNo - 1]	= TRUE;
				m_nSeqOutSensorNo[nSensorNo - 1] = 0;
#endif
				nSeqNo = 1;
			}
			else
			{	// NO Glass Data, but Glass Sensing
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) ) 
#else
				if( m_pDicsData->m_bDebugInSensor[nSensorNo] ) 
#endif
				{ 
					m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE; 
					nSeqNo = 500;
				}
				else
				{
					nSeqNo = 1;
				}
			}
		}
		break;
	case 1:
#ifndef _MY_DEBUG
		if( m_pDicsData->m_IfFlag[IF_UNIT_UL - 1].bOutReady &&
			!m_pDicsData->m_IfFlag[IF_UNIT_UL - 1].bOutError && 
			m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) )
#else
		if( m_pDicsData->m_IfFlag[IF_UNIT_UL - 1].bOutReady &&
			!m_pDicsData->m_IfFlag[IF_UNIT_UL - 1].bOutError && 
			m_pDicsData->m_bDebugInSensor[IF_UNIT_UL] )
#endif
		{
			// Flag Reset
			m_pDicsData->m_IfFlag[IF_UNIT_UL - 1].bOutReady = FALSE;

			GlassDataMove( (IF_UNIT_UL - 1)*2 + 1, IF_UNIT_UL*2 + 0, &nSlotNo, &nPortNo );

			//2008.11.07 kimgun APC DATA Glass HEAD ġ  
			m_pDicsData->m_GlsInfo[IF_UNIT_UL * 2].sGlassHeadPos.Format("%d",195 + IF_UNIT_UL );

			// hskwak 2020/01/03 
			if( m_pDicsView->m_pHost1->m_bCeidEnable[nSensorNo*2-1] )
			{
				m_pDicsView->m_pHost1->m_bEventReportReq[nSensorNo*2-1] = TRUE;
			}
			if( m_pDicsView->m_pHost1->m_bCeidEnable[nSensorNo*2] )
			{
				m_pDicsView->m_pHost1->m_bEventReportReq[nSensorNo*2] = TRUE;
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "GLASS IN EVENT REPORT" );
			}

			nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].nPortNo;
			nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].nSlotNo;
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "IN SENSOR : ON" );

			nSeqNo = 10;
		}
		break;
	case 10:
		if( m_pDicsData->m_SeqFlag.bGlassOutComp1 )
		{
 			m_pDicsData->m_SeqFlag.bGlassOutComp1 = FALSE;

			// glass move
			nGlassNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].nGlassNo;			
			m_pGlassAni->SetGlassMoveSpeed( nGlassNo, m_pDicsData->m_JobCond.nCvSpeed / 60 );
			//m_pGlassAni->GlassMove( nGlassNo, (IF_UNIT_UL+1)*2 + 1, TRUE, TRUE );		// hskwak 20190529
			m_pGlassAni->GlassMove( nGlassNo, (IF_UNIT_UL)*2+1, TRUE, TRUE ); 

			GetTimeOut( IF_UNIT_UL, 0, &nTime1, &nTime2, &nTime3 );
#ifndef _MY_DEBUG
			TIMER_ON( tm1, nTime1 );
			TIMER_ON( tm2, nTime2 );
			TIMER_ON( tm3, nTime3 );
#else
			TIMER_ON( tm1, 90 );
			TIMER_ON( tm2, 90 );
			TIMER_ON( tm3, 90 );
#endif
			bTm3Warning = FALSE;

			// 160704 halesu
			bUnloadWaitOn = FALSE;
			dwTickStart = GetTickCount();

			nSeqNo = 20;
		}
		else 
		{
			m_pDicsData->m_GenInfo.bUlTimeOut = TRUE;
			// C/V Stop
			CvStop( IF_UNIT_UL );
			
			// glass move
			nGlassNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].nGlassNo;
			//m_pGlassAni->GlassMove( nGlassNo, (IF_UNIT_UL+1)*2 + 1, FALSE );	// hskwak 20190529
			m_pGlassAni->GlassMove( nGlassNo, (IF_UNIT_UL)*2+1, FALSE );

			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "UNLOADING TIMEOUT : NG" );
			nSeqNo = 100;
		}
		break;		
	case 20:
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) )
#else
		if( TIMER( tm2 ) )
#endif
		{
#ifdef _MY_DEBUG
			m_pDicsData->m_bDebugInSensor[IF_UNIT_UL] = FALSE;
#endif
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "IN SENSOR : OFF(1ST)" );
			dwTickStart = GetTickCount();
			nSeqNo = 30;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm2 ) )
#else
		else if( FALSE )
#endif
		{
			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "IN SENSOR OFF TIMEOUT" );
			nSeqNo = 30;
		}
		else if( !bUnloadWaitOn && GetTickCount() - dwTickStart > dwDelayTime )
		{
			bUnloadWaitOn = TRUE;
			m_bUnloadWaitRequest = TRUE;
		}
		else if(SeqULRobotInterlock(IF_UNIT_UL, TRUE))
		{
			m_pDicsData->m_IfFlag[nSensorNo].bInError = TRUE;
			m_pDicsData->m_IfFlag[IF_UNIT_UL].bRecoveryReq = FALSE;

			nAlarmId = ALM_ROBOT_HAND_INTERRUPT2;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			nReturnSeqNo = nSeqNo;
			nSeqNo = 1000;
		}
		break;
	case 30:
		{
#ifndef _MY_DEBUG
			BOOL bOutSensorOn = m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 );
			if( bOutSensorOn && TIMER( tm3 ) )
#else
			if( TIMER( tm1 ) || m_pDicsData->m_bDebugOutSensor[IF_UNIT_UL] )
#endif
			{
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugOutSensor[IF_UNIT_UL] = TRUE;
#endif
				m_pDicsData->m_IfFlag[IF_UNIT_UL].bInReady = TRUE;
				m_pDicsData->m_IfFlag[IF_UNIT_UL].bInLogicCheckIgnore = FALSE;
				m_pDicsData->m_IfFlag[IF_UNIT_UL].bInComp = TRUE;

				// C/V Restart for previous alarm
				if( m_pDicsData->m_IfFlag[IF_UNIT_UL].bInError ) 
				{
					m_pDicsData->m_IfFlag[IF_UNIT_UL].bInError	= FALSE;
					m_pDicsData->m_IfFlag[IF_UNIT_UL].bRecoveryReq = FALSE;
				}
				
				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL],  nPortNo, nSlotNo, "OUT SENSOR : ON" );
				nSeqNo = 1;
			}
#ifndef _MY_DEBUG
			else if( bOutSensorOn && !bTm3Warning )
#else
			else if( 0 )
#endif
			{
				SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "OUT SENSOR : NG(1ST)" );
				dwTickStart = GetTickCount();
				nSeqNo = 35;
			}
#ifndef _MY_DEBUG
			else if( TIMER( tm1 ) )	// Sensor On Timeout Error
#else
			else if( FALSE )
#endif
			{
				m_pDicsData->m_IfFlag[nSensorNo].bInError = TRUE;
				m_pDicsData->m_IfFlag[IF_UNIT_UL].bRecoveryReq = FALSE;

				nAlarmId = ALM_SENSOR_OUT_ON_TIMEOUT1 + IF_UNIT_UL;
				m_pEqpStateSeq->SetAlarm( nAlarmId );

				SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "OUT SENSOR ON TIMEOUT : NG" );
				nReturnSeqNo = nSeqNo;
				nSeqNo = 1000;
			}
			else if(SeqULRobotInterlock(IF_UNIT_UL, TRUE))
			{
				m_pDicsData->m_IfFlag[nSensorNo].bInError = TRUE;
				m_pDicsData->m_IfFlag[IF_UNIT_UL].bRecoveryReq = FALSE;

				nAlarmId = ALM_ROBOT_HAND_INTERRUPT2;
				m_pEqpStateSeq->SetAlarm( nAlarmId );

				nReturnSeqNo = nSeqNo;
				nSeqNo = 1000;
			}
		}
		break;
	case 35 :
		if( GetTickCount() - dwTickStart > 500 )
		{
			if( m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 ) && !bTm3Warning )
			{
				bTm3Warning = TRUE;

				SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "OUT SENSOR : NG(2ND)" );
				nSeqNo = 30;
			}
			else
			{
				nSeqNo = 30;
			}
		}
		else if( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) )
		{
			nSeqNo=30;
		}
		break;

	// Unloading Timeout Case1 :
	// UL C/V Glass  UL Lo Hand ޾ư ʾ  ó
	case 100:
		if( m_pDicsData->m_SeqFlag.bGlassOutComp1 )
		{	
			m_pDicsData->m_GenInfo.bUlTimeOut = FALSE;

			SetLog( m_pDicsData->m_sInSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "UNLOADING TIMEOUT : RELEASE" );
			nSeqNo = 10;
		}
		break;
	case 500 :	// SetSeqNo  case
		{
			double dGlassSize	= GLASS_SIZE;
			double dCvSpeed		= m_pDicsData->m_JobCond.nCvSpeed / 60.0;	// mm/s
#ifndef _MY_DEBUG
			nTime2	= (int)( ( dGlassSize / dCvSpeed ) * 10 );
#else
			nTime2	= (int)( ( (dGlassSize/3.) / dCvSpeed ) * 10 );
#endif
			TIMER_ON( tm2, nTime2 );

			nSeqNo = 20;
		}
		break;
	case 1000:	// Error ó (Timeout Error)
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Set Timer
			TIMER_ON( tm1, nTime1 );
			TIMER_ON( tm2, nTime2 );

			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq   = TRUE;

			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 0].nSlotNo;
			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "ALARM RESET" );
			nSeqNo = nReturnSeqNo;
		}
		break;
	}	
	m_nSeqUnitUl1No = nSeqNo;
}

void CCvSeq::SeqCVMotorAccelDeccel()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	static DWORD dwTickStart = 0;
	static int nCvSpeed = m_pDicsData->m_JobCond.nCvSpeedSet[IF_UNIT_UL][CJobCond::speedNORMAL];
	int nCvDecelSpeed	= (int)atoi(m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_CV_DECEL_SPEED]);
	int nCvAccelSpeed	= (int)atoi(m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_CV_ACCEL_SPEED]);
	int nSeqNo = m_nSeqCVMotorDeccelNo;


	m_sSeqName.Format( "SeqCVMotorDeccel" );
//	SetLog( m_sSeqName, 0, 0, m_sSeqName );
	if( !m_pDicsData->m_GenInfo.bAuto && m_CvMotor.nCvManual[MAX_CV_MOTOR_NO-1] != cvFW)	return;


	switch ( nSeqNo )
	{
	case 0:
		{
			if( m_pEqpAssy->m_GlassExistAccelSensorUl.GetOr(0) &&  m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ))
			{
				SetLog( m_sSeqName, 0, 0, "UL CV ACCEL SENSOR DETECT" );
				nSeqNo = 5;
			}
		}
		break;
	case 5:
		{
			m_pEqpAssy->m_CvMotor.SetMotorSpeed( (IF_UNIT_UL), nCvAccelSpeed );		// Motor ӵ .  ٸ Part.
			m_pEqpAssy->m_CvMotor.SetMotorSpeed( (IF_UNIT_BUF), nCvAccelSpeed );	// ACCEL  UL  Glass BUF ġ ִ.
			nSeqNo = 10;
		}
		break;
	case 10:
		{
			if( m_pEqpAssy->m_GlassExistDecelSensorUl.GetOr(0) )
			{
				SetLog( m_sSeqName, 0, 0, "UL CV DECEL SENSOR DETECT" );
				nSeqNo = 15;
				dwTickStart = GetTickCount();
				nCvSpeed = nCvAccelSpeed;

			}
		}
		break;			
	case 15:
		{
			m_pEqpAssy->m_CvMotor.SetMotorSpeed( (IF_UNIT_UL), nCvSpeed );	// Motor ӵ .  ٸ Part.
			m_pEqpAssy->m_CvMotor.SetMotorSpeed( (IF_UNIT_BUF), nCvSpeed );	// DECEL  Ǹ BUF ӵ  Ͽ ش.

			m_sMessage.Format( "CV MOTOR SPEED %d", nCvSpeed );
			SetLog( m_sSeqName, 0, 0, m_sMessage );
			
			nCvSpeed -= 200;

			if( nCvSpeed < nCvDecelSpeed )
			{
				nCvSpeed = nCvDecelSpeed;
			}
			if( nCvDecelSpeed >= nCvSpeed )
			{
				m_pEqpAssy->m_CvMotor.SetMotorSpeed( (IF_UNIT_UL), nCvSpeed );
				m_pEqpAssy->m_CvMotor.SetMotorSpeed( (IF_UNIT_BUF), nCvSpeed );
				m_sMessage.Format( "CV MOTOR SPEED %d", nCvSpeed );
				SetLog( m_sSeqName, 0, 0, m_sMessage );
				nSeqNo = 20;
			}
		}
		break;		
	case 20:
//		if( GetTickCount() - dwTickStart > 2000 )		//   ִ   .(2 -> )
		{
			nSeqNo = 25;
		}
		break;
	case 25:
//		if( !m_pEqpAssy->m_GlassExistDecelSensorUl.GetOr() )
		if(m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 ))
		{
/*			if( !m_pDicsData->m_GenInfo.bAuto && m_pEqpAssy->m_CvMotorAll.GetMotorFwState( MAX_CV_MOTOR_NO-1, 0)) break;
			if( m_pDicsData->m_GenInfo.bAuto && m_pEqpAssy->m_CvMotorAll.GetMotorFwState( MAX_CV_MOTOR_NO-1, 0)) break;

			nCvSpeed = m_pDicsData->m_JobCond.nCvSpeedSet[IF_UNIT_UL][CJobCond::speedNORMAL];
			m_pEqpAssy->m_CvMotor.SetMotorSpeed( (IF_UNIT_UL), nCvSpeed );
			m_pEqpAssy->m_CvMotor.SetMotorSpeed( (IF_UNIT_BUF), nCvSpeed );
			SetLog( m_sSeqName, 0, 0, "CV MOTOR SPEED NORMAL" );
*/
			nSeqNo = 30;
		}
		break;
	case 30:
		if(!m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 ))
		{
			nCvSpeed = m_pDicsData->m_JobCond.nCvSpeedSet[IF_UNIT_UL][CJobCond::speedNORMAL];
			m_pEqpAssy->m_CvMotor.SetMotorSpeed( (IF_UNIT_UL), nCvSpeed );
			m_pEqpAssy->m_CvMotor.SetMotorSpeed( (IF_UNIT_BUF), nCvSpeed );
			SetLog( m_sSeqName, 0, 0, "CV MOTOR SPEED NORMAL" );
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqCVMotorDeccelNo = nSeqNo;
}

void CCvSeq::SeqUnitUl2()
{ 
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	int nSensorNo = IF_UNIT_UL;
	int tm1 = TM_UL_CV_STOP;
	int tm2 = TM_OUT_SENSOR_OFF( nSensorNo );
	int tm3 = TM_OUT_SENSOR_OUT2IN( nSensorNo );

	int nSeqNo = m_nSeqUnitUl2No;
	static int nReturnSeqNo = 0;
	static BOOL bInitCylinder = FALSE;

	BOOL bStateAlignDown, bStatePinDown;

	// Use for alarm reset
	static int nAlarmId = 0;
	static DWORD dwTickStart = 0;
 	static int nGlassNo, nSlotNo, nPortNo = 0;

	TimerControl( ssOUT, nSensorNo );

	DWORD dwOutCvAlignTime = 1000 * atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_ALIGN_CYL_TIMEOUT]);
	DWORD dwOutCvAlignUDTime = 1000 * atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_ALIGN_UD_CYL_TIMEOUT]);
	DWORD dwOutCvPinTime = 1000 * atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_PIN_UD_CYL_TIMEOUT]);

	// Thomas 200211
	static BOOL bConditionOk = TRUE;
	if( !GetSeqRunCond( nSensorNo) && nSeqNo != 45 && nSeqNo != 1000 && nSeqNo != 2000 )
	{
		if( bConditionOk )
		{
			bConditionOk = FALSE;
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "Run Condition Check : NG" );
		}
		return;
	}
	if( !bConditionOk )
	{
		bConditionOk = TRUE;
		SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "Run Condition Check : OK" );
	}
	//////////////////////////////////////////////////////////////////////////////////////

	switch( nSeqNo )
	{
	case 0:
		{
			if( nAlarmId > 0 )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId );
				nAlarmId = 0;
				if( m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_UL] )
				{
					m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_UL] = FALSE;
				}
			}

			// ¿  б ׸ .
			// 1. Data , GLS   - Normal
			// 2. GLS  Ǿ ְ PIN DOWN   
			// 3. GLS Data ְ PIN UP  . PIN Up Ǿ ־  GLS ִ Ȯ ʿ.
			//		Ȯν Glass  ٽ ó ۵.(case 1)
			//		Ȯν Glass  PIN UP   Robot .(case 105)

			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid;

			if(bIsValid)
			{
				// When there is glass data.
				m_pDicsData->m_IfFlag[nSensorNo].bInReady	= TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bOutComp	= FALSE;
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugOutSensor[nSensorNo]	= TRUE;
				m_nSeqUnitUl1No = 0;
#endif
				m_pDicsData->m_SeqFlag.bGlassOutComp1 = FALSE;
				nSeqNo = 1;
			}
			else
			{
				// No Glass Data, but Glass Sensing
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 )) 
#else
				if( m_pDicsData->m_bDebugOutSensor[nSensorNo] )  
#endif
				{	// Data  Glass  .
					m_pDicsData->m_IfFlag[nSensorNo].bOutComp = FALSE; 
					m_pDicsData->m_SeqFlag.bGlassOutComp1 =  FALSE;
					nSeqNo = 500;
				}
				else // Data  Glass  .
				{
					nSeqNo = 1;
				}
			}
		}
		break;

		// Align/Align UD/ PIN UD BW, DN ̵ Ų. Align BW/FW Align Up/Down    ϴٸ 3 Cylinder ÿ BW, Down Ű   Ѵ.
	case 1:
		if( bInitCylinder == TRUE )
		{
			nSeqNo = 7;
		}
		else
		{
			m_pEqpAssy->m_CylinderUlAlign.SetBw();
		
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN BW : ON" );
			dwTickStart = GetTickCount();
			nSeqNo = 2;
		}
		break;

	case 2:
		{
#ifndef _MY_DEBUG
			if( m_pEqpAssy->m_CylinderUlAlign.GetBw() )
#else
			if( m_pEqpAssy->m_CylinderUlAlign.GetBwState() )
#endif
			{
				dwTickStart = GetTickCount();
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN BW : OK" );
				nSeqNo = 3;
			}
			else if( ( GetTickCount() - dwTickStart ) > dwOutCvAlignTime )
			{
				nAlarmId = ALM_OUTCV_UNIT_ALIGN_BW;
				m_pEqpStateSeq->SetAlarm( nAlarmId );

				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALING BW : NG" );
				nReturnSeqNo = nSeqNo;
				nSeqNo = 5000;			
			}
		}
		break;

	case 3:
		{
			if( SeqULRobotInterlock(nSensorNo, TRUE) == TRUE )
			{
				nAlarmId = ALM_ROBOT_HAND_INTERRUPT2;
				m_pEqpStateSeq->SetAlarm( nAlarmId );

				nReturnSeqNo = nSeqNo;
				nSeqNo = 5000;
				break;
			}

			m_pEqpAssy->m_CylinderUlAlignUD.SetBw();
			m_pEqpAssy->m_CylinderUlPinUD.SetBw();

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN DONW : ON" );
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL PIN DOWN : ON" );
			dwTickStart = GetTickCount();
			nSeqNo = 4;
		}
		break;

	case 4:
		{
			m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[DN] = GetTickCount() - dwTickStart;
#ifndef _MY_DEBUG
			bStateAlignDown = m_pEqpAssy->m_CylinderUlAlignUD.GetBw();
			bStatePinDown = m_pEqpAssy->m_CylinderUlPinUD.GetBw();
#else
			bStateAlignDown = m_pEqpAssy->m_CylinderUlAlignUD.GetBwState();
			bStatePinDown = m_pEqpAssy->m_CylinderUlPinUD.GetBwState();
			if( ( GetTickCount() - dwTickStart ) < 2100 )	return;	
#endif
			if( bStateAlignDown && bStatePinDown )
			{
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN DOWN : OK" );
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL PIN DOWN : OK" );
				bInitCylinder = TRUE;
				nSeqNo = 7;
			}
			else if( ( GetTickCount() - dwTickStart ) > dwOutCvAlignUDTime && !bStateAlignDown)
			{
				m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[DN]=0;
				nAlarmId = ALM_OUTCV_UNIT_ALIGN_DOWN;
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN DOWN : NG" );
				m_pEqpStateSeq->SetAlarm( nAlarmId );
				nReturnSeqNo = nSeqNo;
				nSeqNo = 5000;			
			}
			else if( ( GetTickCount() - dwTickStart ) > dwOutCvPinTime && !bStatePinDown)
			{
				m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[DN]=0;
				nAlarmId = ALM_OUTCV_UNIT_PIN_DOWN;
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL PIN DOWN : NG" );
				m_pEqpStateSeq->SetAlarm( nAlarmId );
				nReturnSeqNo = nSeqNo;
			nSeqNo = 5000;			
			}
		}
		break;

	case 7:
		{
#ifndef _MY_DEBUG
			if( m_pDicsData->m_IfFlag[nSensorNo].bInReady &&
				m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) &&
				!m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo, 0 ) )
#else
			if( m_pDicsData->m_IfFlag[nSensorNo].bInReady && m_pDicsData->m_bDebugOutSensor[nSensorNo] )
#endif
			{
				m_pDicsData->m_IfFlag[nSensorNo].bInReady = FALSE;
				m_pDicsData->m_IfFlag[nSensorNo].bOutComp = FALSE;

				m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].UlWaitTime	= COleDateTime::GetCurrentTime();

				// Glass Data Move
				GlassDataMove( nSensorNo*2 + 0, nSensorNo*2 + 1, &nSlotNo, &nPortNo );
				m_pDicsData->m_GlsInfoSend = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1];

				nPortNo = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nPortNo;
				nSlotNo = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nSlotNo;
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "OUT SENSOR : ON" );
				nSeqNo = 9;
			}
		}
		break;
		
	case 9 :
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) )
#else
		if( 1 )
#endif
		{
			double nTime;
			nTime = atof( m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_UNIT_GLASS_STOP_DISTANCE] );
			nTime = (( nTime  / ( m_pDicsData->m_JobCond.nCvSpeed / 60 )) * 10 );

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "GLASS IN UL UNIT" );

#ifndef _MY_DEBUG
			TIMER_ON( tm1, (int)nTime );
#else
			TIMER_ON( tm1, (int)nTime );
#endif
	
			nSeqNo = 10;
		}
		break;
	case 10:
		if( TIMER( tm1 ) )
		{
			m_pDicsData->m_IfFlag[nSensorNo].bOutReady = TRUE;
			m_pDicsData->m_IfFlag[nSensorNo].bOutComp	= TRUE;

			// Glass Move Region : Auto Stop
			int nGlassNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nGlassNo;
			//m_pGlassAni->GlassMoveRegion( nGlassNo, (IF_UNIT_UL+1) * 2 + 1, TRUE );
			m_pGlassAni->GlassMoveRegion( nGlassNo, (IF_UNIT_UL) * 2 + 1, TRUE );
			nSeqNo = 20;
		}
		break;
	case 20:
		if( !m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_UL )  )
		{
			if( m_pDicsView->m_pHost1->m_bCeidEnable[nSensorNo*2+1] )
			{
//				m_pDicsView->m_pHost1->S6F11( IF_UNIT_UL * 2 + 2 );
				m_pDicsView->m_pHost1->m_bEventReportReq[nSensorNo*2+1] = TRUE;
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "GLASS IN EVENT REPORT" );
			}
			nSeqNo = 25;
		}
		break;
	case 25:
		if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUL_UNIT_SCAN_SENSOR] )
		{
			SetLog(  m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo,"SCAN BROKEN SENSOR : NOUSE" );
			nSeqNo = 40;
		}
		else
		{
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo,"SCAN BROKEN SENSOR : USE" );
			nSeqNo = 30;
		}		
		break;
	case 30:
#ifndef _MY_DEBUG
		if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUL_UNIT_SCAN_SENSOR] || 
			!m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_UL] ) 
#else
		if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUL_UNIT_SCAN_SENSOR] )
#endif
		{
			int nPortNo = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nSlotNo;
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "SCAN BROKEN SENSOR : OK" );
			nSeqNo = 40;
		}
#ifndef _MY_DEBUG
		else if( m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_UL] )
#else
		else	
#endif
		{
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;

			nAlarmId = ALM_UL_UNIT_SCAN_SENSOR;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			int nPortNo = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nSlotNo;
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "SCAN BROKEN SENSOR : NG" );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 2000;
		}	
		break;
	case 40:
		if( !m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_UL ) )
		{
			nSeqNo = 50;
		}
		break;
	case 50:
		if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUL_UNIT_BROKEN_SENSOR] )
		{
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "FIXED BROKEN SENSOR CHECK : NOUSE(1ST)" );
			nSeqNo = 80;
		}
		else
		{	
			if( !m_pEqpAssy->m_FixedBrokenSensorUl.GetAnd( 0 ) )	  nAlarmId = ALM_UL_UNIT_BROKEN_SENSOR1;
			else if( !m_pEqpAssy->m_FixedBrokenSensorUl.GetAnd( 1 ) ) nAlarmId = ALM_UL_UNIT_BROKEN_SENSOR2;
			else if( !m_pEqpAssy->m_FixedBrokenSensorUl.GetAnd( 2 ) ) nAlarmId = ALM_UL_UNIT_BROKEN_SENSOR3;
			else if( !m_pEqpAssy->m_FixedBrokenSensorUl.GetAnd( 3 ) ) nAlarmId = ALM_UL_UNIT_BROKEN_SENSOR4;
			else nAlarmId = 0;
			
#ifdef _MY_DEBUG
			nAlarmId = 0;
#endif
			if( nAlarmId == 0 )
			{
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "FIXED BROKEN SENSOR : OK" );
				nSeqNo = 80;
			}
			else
			{
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "FIXED BROKEN SENSOR : NG(1ST)" );
				dwTickStart = GetTickCount();
				nSeqNo = 60;
			}
		}
		break;
	case 60:
		if( (GetTickCount() - dwTickStart) > 2000 )
		{
			nSeqNo = 70;
		}
		break;
	case 70:
		if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUL_UNIT_BROKEN_SENSOR] )		
		{
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "FIXED BROKEN SENSOR CHECK : NOUSE(2ND)" );
			nSeqNo = 80;
		}
		else
		{	
			if( !m_pEqpAssy->m_FixedBrokenSensorUl.GetAnd( 0 ) )	  nAlarmId = ALM_UL_UNIT_BROKEN_SENSOR1;
			else if( !m_pEqpAssy->m_FixedBrokenSensorUl.GetAnd( 1 ) ) nAlarmId = ALM_UL_UNIT_BROKEN_SENSOR2;
			else if( !m_pEqpAssy->m_FixedBrokenSensorUl.GetAnd( 2 ) ) nAlarmId = ALM_UL_UNIT_BROKEN_SENSOR3;
			else if( !m_pEqpAssy->m_FixedBrokenSensorUl.GetAnd( 3 ) ) nAlarmId = ALM_UL_UNIT_BROKEN_SENSOR4;
			else nAlarmId = 0;
			
#ifdef _MY_DEBUG
			nAlarmId = 0;
#endif
			if( nAlarmId == 0 )
			{
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "FIXED BROKEN SENSOR : OK" );
				nSeqNo = 80;
			}
			else
			{
				m_pEqpStateSeq->SetAlarm( nAlarmId );
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "FIXED BROKEN SENSOR : NG(2ND)" );
				nReturnSeqNo = nSeqNo;
				nSeqNo = 1000;
			}
		}
		break;
	case 80:
		if( m_pEqpStateSeq->IsAlarm( ALM_AK_FLOW_DEVIATION ) )
		{
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "AK DEVIATION CHECK : NG" );
			nSeqNo = 90;
		}
		else
		{
			nSeqNo = 100;
		}
		break;
	case 90:
		if( !m_pEqpStateSeq->IsAlarm( ALM_AK_FLOW_DEVIATION ) )
		{
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "AK DEVIATION CHECK : OK" );
			nSeqNo = 100;
		}
		break;
	// Align UP -> Align FW -> Pin UP
	case 100:
		m_pEqpAssy->m_CylinderUlAlignUD.SetFw();
		
		SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN UP : ON" );
		dwTickStart = GetTickCount();
		nSeqNo = 102;
		break;

	case 102:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_CylinderUlAlignUD.GetFw() )
#else
		if( m_pEqpAssy->m_CylinderUlAlignUD.GetFwState() )
#endif
		{
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN UP : OK" );
#ifdef _MY_DEBUG
			Sleep(1900);
#endif
			nSeqNo = 103;
		}
		else if( ( GetTickCount() - dwTickStart ) > dwOutCvAlignUDTime )
		{
			nAlarmId = ALM_OUTCV_UNIT_ALIGN_UP;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALING UP : NG" );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 5000;		
		}
		break;

	case 103:
		m_pEqpAssy->m_CylinderUlAlign.SetFw();
		SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN FW : ON" );
		dwTickStart = GetTickCount();
		nSeqNo = 104;
		break;

	case 104:
		#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_CylinderUlAlign.GetFw())
#else
		if( m_pEqpAssy->m_CylinderUlAlign.GetFwState())
#endif
		{
#ifdef _MY_DEBUG
			Sleep(1000);
#endif
			dwTickStart = GetTickCount();
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN FW : OK" );
			nSeqNo = 105;
		}
		else if( ( GetTickCount() - dwTickStart ) > dwOutCvAlignTime )
		{
			nAlarmId = ALM_OUTCV_UNIT_ALIGN_FW;
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN FW : NG" );
			m_pEqpStateSeq->SetAlarm( nAlarmId );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 5000;		
		}
		break;


	case 105:
		if( SeqULRobotInterlock(nSensorNo, TRUE) == TRUE )
		{
			nAlarmId = ALM_ROBOT_HAND_INTERRUPT2;
			m_pEqpStateSeq->SetAlarm( nAlarmId );

			nReturnSeqNo = nSeqNo;
			nSeqNo = 5000;
			break;
		}
		m_pEqpAssy->m_CylinderUlPinUD.SetFw();
			
		SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL PIN UP : ON" );
		dwTickStart = GetTickCount();
		nSeqNo = 106;
		break;

	case 106:
		m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[UP] = GetTickCount() - dwTickStart;
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_CylinderUlPinUD.GetFw() )
#else
		if( ( GetTickCount() - dwTickStart ) < 1000 )	return;	
		if( m_pEqpAssy->m_CylinderUlPinUD.GetFwState())
#endif
		{
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL PIN UP : OK" );
			nSeqNo = 110;
		}
		else if( ( GetTickCount() - dwTickStart ) > dwOutCvPinTime )
		{
			m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[UP]=0;
			nAlarmId = ALM_OUTCV_UNIT_PIN_UP;
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL PIN UP : NG" );
			m_pEqpStateSeq->SetAlarm( nAlarmId );
			nReturnSeqNo = nSeqNo;
			nSeqNo = 5000;		
		}
		break;
		
	case 110:
		{
			// hskwak 20191011 APD Data   .
			// Save APD 
//			if( nSensorNo == IF_UNIT_BUF )
			{
				ApdSave( nSensorNo * 2 + 1, nPortNo, nSlotNo );
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "APD SAVE" );
			}

			m_pDicsData->m_IfFlag[nSensorNo].bRecvComp = TRUE;
#ifdef _NO_UL_HAND
			m_bUnloadWaitRequest = TRUE;
			( (CDicsView *) m_pOwnerWnd )->m_pCvSeq->m_bUnloadWaitRequest = TRUE;	// SanghoCho 2015.04.01
#endif
			nSeqNo = 130;
#ifdef _NO_UL_HAND
			nSeqNo = 115;
#endif
#ifdef _MY_DEBUG
			dwTickStart = GetTickCount();
#endif
			m_pEqpAssy->m_CylinderUlAlign.SetBw();	// PIN Up  ϴ  Align  Ų.
		}
		break;
	case 115:
		{
			
			m_pDicsData->m_IfSend.bBit[CDicsData::sndREQ] = TRUE;

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "GLASS SEND REQUEST" );
			nSeqNo = 120;
		}
		break;
	case 120:
		// κ    Align UP ̸ Down Ѵ.
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_CylinderUlAlign.GetBw() && !m_pEqpAssy->m_CylinderUlAlignUD.GetBw() )
#else
		if( m_pEqpAssy->m_CylinderUlAlign.GetBwState() && !m_pEqpAssy->m_CylinderUlAlignUD.GetBwState() )
#endif
		{
			m_pEqpAssy->m_CylinderUlAlignUD.SetBw();
		}

#ifdef _MY_DEBUG
		if( GetTickCount() - dwTickStart < 2000)	break;
#endif

		if( m_pDicsData->m_IfSend.bBit[CDicsData::sndCOMP] )
		{
			m_pDicsData->m_IfSend.bBit[CDicsData::sndCOMP] = FALSE;
			nSeqNo = 130;
		}
		break;

	case 130:
		// Align/Align UD/ PIN UD BW, DN ̵ Ų. Align BW/FW Align Up/Down    ϴٸ 3 Cylinder ÿ BW, Down Ű   Ѵ.
		{
			m_pEqpAssy->m_CylinderUlAlign.SetBw();
		
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN BW : ON" );
			dwTickStart = GetTickCount();
			nSeqNo = 150;
		}
		break;

	case 150:
		{
#ifndef _MY_DEBUG
			if( m_pEqpAssy->m_CylinderUlAlign.GetBw() )
#else
			if( m_pEqpAssy->m_CylinderUlAlign.GetBwState() )
#endif
			{
				dwTickStart = GetTickCount();
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN BW : OK" );
				nSeqNo = 160;
			}
			else if( ( GetTickCount() - dwTickStart ) > dwOutCvAlignTime )
			{
				nAlarmId = ALM_OUTCV_UNIT_ALIGN_BW;
				m_pEqpStateSeq->SetAlarm( nAlarmId );

				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALING BW : NG" );
				nReturnSeqNo = nSeqNo;
				nSeqNo = 5000;			
			}
		}
		break;

	case 160:
		{
			if( SeqULRobotInterlock(nSensorNo, TRUE) == TRUE )
			{
				nAlarmId = ALM_ROBOT_HAND_INTERRUPT2;
				m_pEqpStateSeq->SetAlarm( nAlarmId );

				nReturnSeqNo = nSeqNo;
				nSeqNo = 5000;
				break;
			}

			m_pEqpAssy->m_CylinderUlAlignUD.SetBw();
			m_pEqpAssy->m_CylinderUlPinUD.SetBw();

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN DONW : ON" );
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL PIN DOWN : ON" );
			dwTickStart = GetTickCount();
			nSeqNo = 170;
		}
		break;

	case 170:
		{
			m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[DN] = GetTickCount() - dwTickStart;
#ifndef _MY_DEBUG
			bStateAlignDown = m_pEqpAssy->m_CylinderUlAlignUD.GetBw();
			bStatePinDown = m_pEqpAssy->m_CylinderUlPinUD.GetBw();
#else
			bStateAlignDown = m_pEqpAssy->m_CylinderUlAlignUD.GetBwState();
			bStatePinDown = m_pEqpAssy->m_CylinderUlPinUD.GetBwState();
			if( ( GetTickCount() - dwTickStart ) < 1000 )	return;	
#endif
			if( bStateAlignDown && bStatePinDown )
			{
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN DOWN : OK" );
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL PIN DOWN : OK" );
				nSeqNo = 180;
			}
			else if( ( GetTickCount() - dwTickStart ) > dwOutCvAlignUDTime && !bStateAlignDown)
			{
				m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[DN]=0;
				nAlarmId = ALM_OUTCV_UNIT_ALIGN_DOWN;
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL ALIGN DOWN : NG" );
				m_pEqpStateSeq->SetAlarm( nAlarmId );
				nReturnSeqNo = nSeqNo;
				nSeqNo = 5000;			
			}
			else if( ( GetTickCount() - dwTickStart ) > dwOutCvPinTime && !bStatePinDown)
			{
				m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[DN]=0;
				nAlarmId = ALM_OUTCV_UNIT_PIN_DOWN;
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "UL PIN DOWN : NG" );
				m_pEqpStateSeq->SetAlarm( nAlarmId );
				nReturnSeqNo = nSeqNo;
			nSeqNo = 5000;			
			}
		}
		break;
	case 180:
		{
#ifdef _MY_DEBUG
			m_pDicsData->m_bDebugOutSensor[nSensorNo] = FALSE;
#endif
			int nGlassNo = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nGlassNo;
			m_pGlassAni->EndGlassMove( nGlassNo );
			m_pDicsData->DeleteGlassData( nSensorNo*2+1);
			m_pDicsData->m_GlsInfo[nSensorNo*2+1].bProcessFlag = 0;	// 191002 hskwak Processflag delete
			
			m_pDicsData->m_GenInfo.nGlassNo -= 1;
			if( m_pDicsData->m_GenInfo.nGlassNo < 0 ) m_pDicsData->m_GenInfo.nGlassNo = 0;
			Msg( WM_GLASS_NO, m_pDicsData->m_GenInfo.nGlassNo, 0L, FALSE );
			
			m_pDicsData->m_SeqFlag.bUnloadProcess = FALSE;
			m_pDicsData->m_SeqFlag.bGlassGetComp = TRUE;

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "GLASS SEND COMPLETE" );
			nSeqNo = 190;
		}
		break;
	case 190:
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) && m_pDicsData->m_SeqFlag.bGlassGetComp )
#else
		if( !m_pDicsData->m_bDebugOutSensor[nSensorNo] )
#endif
		{
			m_pDicsData->m_SeqFlag.bGlassGetComp = FALSE;
			m_pDicsData->m_IfFlag[nSensorNo].bOutReady = FALSE;

			nSeqNo = 200;
		}
		break;
	case 200:
		{
			m_pDicsData->m_SeqFlag.bGlassOutComp1 = TRUE;
			nSeqNo = 1;
		}
		break;
	case 500 :	// SetSeqNo  case
		{
			nSeqNo = 20;
		}
		break;
	case 1000 :	// Error ó (General Error)
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId );

			SetLog( m_pDicsData->m_sOutSensorUnitName[IF_UNIT_UL], nPortNo, nSlotNo, "ALARM RESET" );
			nSeqNo = nReturnSeqNo;
		}
		break;
	case 2000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nSlotNo;

			m_pEqpStateSeq->ResetAlarm( nAlarmId );
			nAlarmId = 0;

			m_pDicsData->m_IfFlag[IF_UNIT_UL].bOutError = FALSE;  
		//	m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = TRUE;

			m_pDicsData->m_IfScan.bGlassBroken[BS_UNIT_UL] = FALSE;

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo, nSlotNo, "SCAN BROKEN SENSOR : ALARM RESET" );
			nSeqNo = nReturnSeqNo;
		}
		break;
	case 5000: // Alarm Recovery (Actuator Timeout Alarm)
		{
			int nPortNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nPortNo;
			int nSlotNo = m_pDicsData->m_GlsInfo[IF_UNIT_UL*2 + 1].nSlotNo;

			m_pEqpStateSeq->ResetAlarm( nAlarmId );
			nAlarmId = 0;

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo, nSlotNo, "ALARM RESET" );
			dwTickStart = GetTickCount();
			nSeqNo = nReturnSeqNo;
		}
		break;
	} // Switch End 
	m_nSeqUnitUl2No = nSeqNo;
}

void CCvSeq::SetSeqNo()	// α׷    Sequence .
{
	int i = 0;
	for( int i=ssIN; i<2; i++ )
	{
		for( int nSensorNo=IF_UNIT_LD; nSensorNo<IF_UNIT_UL; nSensorNo++ )
		{
			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + i].bIsValid;
			
			if( bIsValid ) // When there is glass data.
			{
				// glass move ON
				// int nGlassNo = m_pDicsData->m_GlsInfo[j*2 + i].nGlassNo;
				// m_pGlassAni->GlassMove( nGlassNo, TRUE );
				
				if( i == ssIN && nSensorNo == IF_UNIT_LD ) 
				{
					// Set Sequence No
					m_nSeqUnitLdNo = 100;		// 20100715 ssm NO use Broken
				}
				else if( nSensorNo == IF_UNIT_UL ) 
				{
					if( i == ssIN )  // SeqUnitUl1()
					{
						// Set flag
						m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady = TRUE;
						m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE;
						m_nSeqUnitUl1No = 10;
					}
					else if( i == ssOUT ) // SeqUnitUl2()
					{
						// Flag reset
						m_pDicsData->m_SeqFlag.bGlassOutComp1 = FALSE;
						m_nSeqUnitUl2No = 0;	// Glass Position Check. 
					}
				}
				else // In case of C/V
				{
					if( i == ssIN ) // SeqInSensor
					{
						// Set flag
						if( nSensorNo != IF_UNIT_LD ) m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady = TRUE;
						m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE;
					}
					else if( i == ssOUT && nSensorNo == IF_UNIT_LD ) 
					{ 
					 	m_nSeqUnitLdNo = 200; 
					}
					else if( i == ssOUT ) // SeqOutSensor
					{
						// Set flag
						m_pDicsData->m_IfFlag[nSensorNo].bInReady = TRUE;
						m_pDicsData->m_IfFlag[nSensorNo].bOutComp = FALSE;
					}
				}
#ifdef _MY_DEBUG
				if( i == ssIN )
				{
					m_pDicsData->m_bDebugInSensor[nSensorNo] = TRUE;
//					if( nSensorNo > IF_UNIT_LD )
//						m_pDicsData->m_bDebugOutSensor[nSensorNo - 1] = TRUE;	// hskwak skip
				}
				else 
				{
					m_pDicsData->m_bDebugOutSensor[nSensorNo] = TRUE;
//					if( nSensorNo > IF_UNIT_LD )
//					m_pDicsData->m_bDebugInSensor[nSensorNo] = TRUE;	// hskwak skip
				}
#endif
			}
		}
	}
	
	// glass data doesn't exist, but glass is sensed.
	for( i=ssIN; i<2; i++ )
	{
		for( int nSensorNo=IF_UNIT_LD; nSensorNo<IF_UNIT_UL; nSensorNo++ )
		{
			// 1. Sequence No 0̸ 
			// 2.  Sensor  Ǿ ִ Ȳ 
			// 3.  Glass ͼ ٷ  Glass Ǹ
			// 4. bInReady or bOutReady True ǰ Sensor ǹǷ ٷ Data Ѿ .
			// 5. Data  ߻ ==>  Ǵ Sensor Off Ǵ  Ȯؾ 
			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + i].bIsValid;
			if( !bIsValid )
			{
				if( nSensorNo >= IF_UNIT_LD && nSensorNo <= IF_UNIT_UL )
				{
#ifndef _MY_DEBUG
					if( i == ssIN && m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo, 0 ) && nSensorNo == IF_UNIT_LD ) 
#else
					if( i == ssIN && m_pDicsData->m_bDebugInSensor[nSensorNo] && nSensorNo == IF_UNIT_LD ) 
#endif
					{ 
//						m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE; // 2009.03.03 minhan 
						m_nSeqUnitLdNo = 200; 
					}
#ifndef _MY_DEBUG
					if( i == ssIN && m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo, 0 ) && nSensorNo != IF_UNIT_LD ) 
#else
					if( i == ssIN && m_pDicsData->m_bDebugInSensor[nSensorNo] && nSensorNo != IF_UNIT_LD ) 
#endif
					{
						m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE; 
						m_nSeqInSensorNo[nSensorNo] = 500; 
					}
#ifndef _MY_DEBUG
					if( i == ssOUT && m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) && nSensorNo == IF_UNIT_LD ) 
#else
					if( i == ssOUT && m_pDicsData->m_bDebugOutSensor[nSensorNo] && nSensorNo == IF_UNIT_LD ) 
#endif
					{ 
					 	m_nSeqUnitLdNo = 240;
					}
#ifndef _MY_DEBUG
					else if( i == ssOUT && m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) ) 
#else
					else if( i == ssOUT && m_pDicsData->m_bDebugOutSensor[nSensorNo] ) 
#endif
					{ 
						m_pDicsData->m_IfFlag[nSensorNo].bOutComp = FALSE; 
						m_nSeqOutSensorNo[nSensorNo] = 500; 
					}
				}
			}
		}
	}
}

BOOL CCvSeq::CheckUnitCondition( int nSensorType, int nUnitNo )	//   Interlock Ȯ.
{ 
	BOOL bOk = TRUE;
	int nIndex = nUnitNo-IF_UNIT_LD+nSensorType;

	for( int i=ssIN; i<=nSensorType; i++ )
	{
		bOk &= m_pDicsView->m_pCommonIntrSeq->GetCvCond( nUnitNo + i );
	}

	bOk &= m_pDicsView->m_pGaugeIntrSeq->GetGaugeCond( nIndex );

	switch( nUnitNo )
	{
	case IF_UNIT_LD:
		if( nSensorType == ssIN )
		{
			if( m_pDicsData->m_JobCond.bJobProcessUse == 1 )
			{
				bOk &= m_pDicsView->m_pRbSeq->GetRbCond();
			}
		}
		break;

	case IF_UNIT_SWR1:
		if( m_pDicsData->m_JobCond.bJobProcessUse == 1 )
		{
			if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] )
			{
				bOk &= m_pDicsView->m_pPumpSeq->m_SeqFlag.bDiTankReady[0];
				bOk &= !m_pEqpAssy->m_DiTank[0].GetPumpAlarm();
				bOk &= !m_pDicsView->m_pPumpSeq->m_SeqFlag.bInsufficientDiFlowrate[0];				
			}
		}
		break;
	case IF_UNIT_SWR2:
		if( m_pDicsData->m_JobCond.bJobProcessUse == 1 )
		{
			if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE] )
			{
				bOk &= m_pDicsView->m_pPumpSeq->m_SeqFlag.bDiTankReady[1];
				bOk &= !m_pEqpAssy->m_DiTank[0].GetPumpAlarm();
				bOk &= !m_pDicsView->m_pPumpSeq->m_SeqFlag.bInsufficientDiFlowrate[1];				
			}
		}
		break;
	case IF_UNIT_SWR3:
		if( m_pDicsData->m_JobCond.bJobProcessUse == 1 )
		{
			if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE] )
			{
				bOk &= m_pDicsView->m_pPumpSeq->m_SeqFlag.bDiTankReady[1];
				bOk &= !m_pEqpAssy->m_DiTank[1].GetPumpAlarm();
				bOk &= !m_pDicsView->m_pPumpSeq->m_SeqFlag.bInsufficientDiFlowrate[1];				
			}
		}
		break;
	case IF_UNIT_SWR4:
		break;
	case IF_UNIT_AK:
		break;
	case IF_UNIT_UL:
		break;
	}
	
	return bOk;
}

void CCvSeq::SeqAkManualInterlockCheck()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	int nSeqNo = m_nSeqAkManualCheckNo;
	
	static DWORD dwTickStart; 

	BOOL bUse[4]    = { FALSE,};

	static BOOL bAlarm[4][2]    = { { FALSE, FALSE,}, };
	static BOOL bWarning[4][2]  = { { FALSE, FALSE,}, };	
	static int nCheckAiNo[4] = {0,0,0,0};
	BOOL bCheckCond = TRUE; 
		
	double dCurVal[4] = { 0,};	

	int nLowLimit[4]   = { 0,};
	int	nLoWarning[4] = { 0,};	
	int	nUpWarning[4] = { 0,};
	int nUpLimit[4]	  = { 0,};

	bCheckCond &= !m_pDicsData->m_GenInfo.bAuto;
	bCheckCond &= ( m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_AK1 ) || 
					m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_AK1 ) || 
					m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_AK2 ) ||
					m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_AK2 ) );
	bCheckCond &= ( m_pEqpAssy->m_AutoValveAkUp.GetState() || m_pEqpAssy->m_AutoValveAkLo.GetState() );

	switch( nSeqNo )
	{
	case 0:
		if( bCheckCond )
		{
			dwTickStart = GetTickCount();
			nSeqNo = 10;
		}
		break;

	case 10:
		if( !bCheckCond )
		{
			nSeqNo = 0;
		}
		else if( GetTickCount() - dwTickStart > 3000 )
		{
			for( int nAiNo = 0; nAiNo < m_pEqpAssy->m_AnalogInput.GetAiSize(); nAiNo++ )
			{
				for(int i=0; i<m_pEqpAssy->m_AnalogInputAk.GetAiSize(); i++)
				{
					if( m_pEqpAssy->m_AnalogInput.GetAddress( nAiNo ) == m_pEqpAssy->m_AnalogInputAk.GetAddress( i ) )
					{
						nCheckAiNo[i] = nAiNo;
						int nIntrNo = m_pEqpAssy->m_AnalogInput.m_aiSet[nAiNo].nAiIntrNo;
						if( nIntrNo < 0 ) continue;
						dCurVal[i] = (double) m_pEqpAssy->m_AnalogInputAk.GetRealVal( i );

						bUse[i]	   = m_pSetupItems->m_nValueGaugeLimit_Option[nIntrNo];
						nLowLimit[i]	= m_pSetupItems->m_nValueGaugeLimit[0][nIntrNo];
						nLoWarning[i]	= m_pSetupItems->m_nValueGaugeLimit[1][nIntrNo];
						nUpWarning[i]	= m_pSetupItems->m_nValueGaugeLimit[2][nIntrNo];
						nUpLimit[i]		= m_pSetupItems->m_nValueGaugeLimit[3][nIntrNo];
					}
				}
			}
			
			for(int i=0; i<4; i++)
			{
				if( bCheckCond && bUse[i] )
				{
					if(	nLowLimit[i] >= dCurVal[i]  ) bAlarm[i][0] = TRUE;
					else if( nLowLimit[i] < dCurVal[i] && nLoWarning[i] >= dCurVal[i] ) bWarning[i][0] = TRUE;
					else if( nUpLimit[i] <= dCurVal[i] ) bAlarm[i][1] = TRUE;
					else if( nUpLimit[i] > dCurVal[i] && nUpWarning[i] <= dCurVal[i] ) bWarning[i][1] = TRUE;
				}
			}
			
			if ( bAlarm[0][0] || bAlarm[0][1] || bWarning[0][0] || bWarning[0][1] ||
				 bAlarm[1][0] || bAlarm[1][1] || bWarning[1][0] || bWarning[1][1] || 
				 bAlarm[2][0] || bAlarm[2][1] || bWarning[2][0] || bWarning[2][1] ||
				 bAlarm[3][0] || bAlarm[3][1] || bWarning[3][0] || bWarning[3][1] )
			{
				for( int i=0; i<4; i++ )
				{
					bAlarm[i][0] = FALSE;
					bAlarm[i][1] = FALSE;
					bWarning[i][0] = FALSE;
					bWarning[i][1] = FALSE;
				}
				dwTickStart = GetTickCount();
				nSeqNo = 15;
			}
			else nSeqNo = 0;
		}
		break;
	case 15:
		if( !bCheckCond )
		{
			nSeqNo = 0;
		}
		else if( GetTickCount() - dwTickStart > 1000 )
		{
			for( int nAiNo = 0; nAiNo < m_pEqpAssy->m_AnalogInput.GetAiSize(); nAiNo++ )
			{
				for(int i=0; i<m_pEqpAssy->m_AnalogInputAk.GetAiSize(); i++)
				{
					if( m_pEqpAssy->m_AnalogInput.GetAddress( nAiNo ) == m_pEqpAssy->m_AnalogInputAk.GetAddress( i ) )
					{
						int nIntrNo = m_pEqpAssy->m_AnalogInput.m_aiSet[nAiNo].nAiIntrNo;
						if( nIntrNo < 0 ) continue;
						dCurVal[i] = (double) m_pEqpAssy->m_AnalogInputAk.GetRealVal( i );

						bUse[i]	   = m_pSetupItems->m_nValueGaugeLimit_Option[nIntrNo];
						nLowLimit[i]	= m_pSetupItems->m_nValueGaugeLimit[0][nIntrNo];
						nLoWarning[i]	= m_pSetupItems->m_nValueGaugeLimit[1][nIntrNo];
						nUpWarning[i]	= m_pSetupItems->m_nValueGaugeLimit[2][nIntrNo];
						nUpLimit[i]		= m_pSetupItems->m_nValueGaugeLimit[3][nIntrNo];
					}
				}
			}
			
			for(int i=0; i<4; i++)
			{
				if( bCheckCond && bUse[i] )
				{
					if(	nLowLimit[i] >= dCurVal[i]  ) bAlarm[i][0] = TRUE;
					else if( nLowLimit[i] < dCurVal[i] && nLoWarning[i] >= dCurVal[i] ) bWarning[i][0] = TRUE;
					else if( nUpLimit[i] <= dCurVal[i] ) bAlarm[i][1] = TRUE;
					else if( nUpLimit[i] > dCurVal[i] && nUpWarning[i] <= dCurVal[i] ) bWarning[i][1] = TRUE;
				}
			}
			
			if ( bAlarm[0][0] || bAlarm[0][1] || bWarning[0][0] || bWarning[0][1] ||
				 bAlarm[1][0] || bAlarm[1][1] || bWarning[1][0] || bWarning[1][1] || 
				 bAlarm[2][0] || bAlarm[2][1] || bWarning[2][0] || bWarning[2][1] ||
				 bAlarm[3][0] || bAlarm[3][1] || bWarning[3][0] || bWarning[3][1] )
			{
				for( int j=0; j<MAX_CV_MOTOR_NO; j++ )
				{
					m_CvMotor.nCvManual[j] = CCvSeq::cvSTOP;
				}

				m_bAkManualAlarm = TRUE;
				nSeqNo = 20;
			}
			else nSeqNo = 0;
		}
		break;
	case 20:
		{
			for( int i=0; i<4; i++)
			{
				if ( bAlarm[i][0] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_LOWER_ALARM1 + nCheckAiNo[i] );
			    if ( bAlarm[i][1] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_UPPER_ALARM1 + nCheckAiNo[i] );
				if ( bWarning[i][0] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_LOWER_WARNING1 + nCheckAiNo[i] );
				if ( bWarning[i][1] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_UPPER_WARNING1 + nCheckAiNo[i] );
			}
			nSeqNo = 30;
		}
		break;

	case 30:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			for ( int i=0; i<4; i++ )
			{ 
				if ( bAlarm[i][0] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_LOWER_ALARM1 + nCheckAiNo[i] );
					 bAlarm[i][0] = FALSE;
				}
				if ( bAlarm[i][1] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_UPPER_ALARM1 + nCheckAiNo[i] );
					bAlarm[i][1] = FALSE;
				}
				if ( bWarning[i][0] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_LOWER_WARNING1 + nCheckAiNo[i] );
					bWarning[i][0] =FALSE;
				}
				if ( bWarning[i][1] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_UPPER_WARNING1 + nCheckAiNo[i] );
					bWarning[i][1] = FALSE;
				}
			}
			m_bAkManualAlarm = FALSE;

			nSeqNo = 0;
		}
		break;
	}
	m_nSeqAkManualCheckNo = nSeqNo;
}

void CCvSeq::SeqCvManualControlInterlock()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	static int nSeqNo = 0;
	static DWORD dwStartTick = 0;

	switch( nSeqNo )
	{
	case 0 :
		if( !m_pDicsData->m_GenInfo.bAuto )
		{
			dwStartTick = GetTickCount();
			nSeqNo = 10;
		}
		break;
	case 10 :
		if( m_pDicsData->m_GenInfo.bAuto ) 
		{
			nSeqNo = 0;
		} 
		else if( GetTickCount() - dwStartTick > 500 )
		{
			BOOL bLdCvFw = m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_LD );
			BOOL bLdCvBw = m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_LD );
			BOOL bUlCvFw = m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_UL );
			BOOL bUlCvBw = m_pEqpAssy->m_CvMotorAll.GetMotorBwState( CV_MOTOR_NO_UL );
			
			BOOL bCvStop = FALSE;
#ifndef _MY_DEBUG
			bCvStop |= ( bLdCvBw && m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_LD, 0 ) );	// LD BW   LD  ù  Ǹ ڷ  ʴ´.
			bCvStop |= ( bUlCvFw && m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 ) );	// UL FW   UL    Ǹ   ʴ´.
			bCvStop |= ( bLdCvFw && !m_pEqpAssy->m_CylinderLdAlign.GetFw() );		// LD FW   Align FW ƴϸ Conv ̰.
			bCvStop |= ( bLdCvFw && !m_pEqpAssy->m_CylinderLdAlign.GetFw() );
			bCvStop |= ( bLdCvFw && SeqLDRobotInterlock(IF_UNIT_LD, FALSE) );
			bCvStop |= ( bLdCvBw && SeqLDRobotInterlock(IF_UNIT_LD, FALSE) );
#ifndef _MY_INTERLOCK_UL_CYLINER
			bCvStop |= ( bUlCvFw && !m_pEqpAssy->m_CylinderUlAlignUD.GetBw() );		// UL FW   Align UD Down ° ƴϸ ̰.
			bCvStop |= ( bUlCvFw && !m_pEqpAssy->m_CylinderUlPinUD.GetBw() );		// UL FW   PIN UD Down ° ƴϸ ̰.
			bCvStop |= ( bUlCvBw && !m_pEqpAssy->m_CylinderUlAlignUD.GetBw() );		// UL FW   Align UD Down ° ƴϸ ̰.
			bCvStop |= ( bUlCvBw && !m_pEqpAssy->m_CylinderUlPinUD.GetBw() );		// UL FW   PIN UD Down ° ƴϸ ̰.
			bCvStop |= ( bUlCvBw && SeqULRobotInterlock(IF_UNIT_UL, FALSE));
			bCvStop |= ( bUlCvFw && SeqULRobotInterlock(IF_UNIT_UL, FALSE));
#endif
#else
			bCvStop |= ( bLdCvBw && m_pDicsData->m_bDebugOutSensor[IF_UNIT_LD] ) ;
			bCvStop |= ( bUlCvFw && m_pDicsData->m_bDebugOutSensor[IF_UNIT_UL] ) ;
			bCvStop |= ( bLdCvFw && !m_pEqpAssy->m_CylinderLdAlign.GetFwState() );		// LD FW   Align FW ƴϸ Conv ̰.
#ifndef _MY_INTERLOCK_UL_CYLINER
			bCvStop |= ( bUlCvFw && !m_pEqpAssy->m_CylinderUlAlignUD.GetBwState() );		// UL FW   Align UD Down ° ƴϸ ̰.
			bCvStop |= ( bUlCvFw && !m_pEqpAssy->m_CylinderUlPinUD.GetBwState());		// UL FW   PIN UD Down ° ƴϸ ̰.
			bCvStop |= ( bUlCvBw && !m_pEqpAssy->m_CylinderUlAlignUD.GetBwState() );		// UL FW   Align UD Down ° ƴϸ ̰.
			bCvStop |= ( bUlCvBw && !m_pEqpAssy->m_CylinderUlPinUD.GetBwState());		// UL FW   PIN UD Down ° ƴϸ ̰.
#endif
#endif
			if( bCvStop )
			{
				for( int i = CV_NO_LD ; i < m_pEqpAssy->m_CvMotorAll.GetMaxSectionNo(); i++ )
				{
					m_CvMotor.nCvManual[i] = cvSTOP;
				}
			}

			nSeqNo = 0;
		}
		break;
	}
}

void CCvSeq::SeqInSensor(int nSensorNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	int nSeqNo = m_nSeqInSensorNo[nSensorNo];
	static int nReturnSeqNo[MAX_UNIT_NO]		  = { 0, };
	static DWORD dwTickStart[MAX_UNIT_NO]		  = { 0, };
	
	int tm1 = TM_IN_SENSOR_ON( nSensorNo );
	int tm2 = TM_IN_SENSOR_OFF( nSensorNo );
	int tm3 = TM_IN_SENSOR_IN2OUT( nSensorNo );
		
	static int nTime1[MAX_UNIT_NO] = { 0, };
	static int nTime2[MAX_UNIT_NO] = { 0, };
	static int nTime3[MAX_UNIT_NO] = { 0, };
	static BOOL bTm3Warning[MAX_UNIT_NO] = { FALSE, };
	
	static int nPortNo[MAX_UNIT_NO] = { 0, };
	static int nSlotNo[MAX_UNIT_NO] = { 0, };
	static int nGlassNo[MAX_UNIT_NO] = { 0, };
	static int nAlarmId[MAX_UNIT_NO] = { 0, };

	TimerControl( ssIN, nSensorNo );

	if( !GetSeqRunCond( nSensorNo ) )	return;

	switch( nSeqNo )
	{
	case 0:
		{
			if( nAlarmId[nSensorNo] > 0 )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId[nSensorNo] );
				nAlarmId[nSensorNo] = 0;
			}

			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].bIsValid;
	
			if( bIsValid )
			{
				// When there is glass data.
				m_pDicsData->m_IfFlag[nSensorNo].bInComp		= FALSE;
				m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady	= TRUE;
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugInSensor[nSensorNo]		= TRUE;
				m_pDicsData->m_bDebugOutSensor[nSensorNo - 1]	= TRUE;
				m_nSeqOutSensorNo[nSensorNo - 1] = 0;
#endif
				nSeqNo = 1;
			}
			else
			{
				// No Glass Data, but Glass Sensing
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo, 0 ) ) 
#else
				if( m_pDicsData->m_bDebugInSensor[nSensorNo] ) 
#endif
				{ 
					m_pDicsData->m_IfFlag[nSensorNo].bInComp = FALSE; 
					nSeqNo = 500;
				}
				else
				{
					nSeqNo = 1; 
				}
			}
		}
		break;
	case 1:
		//-----------------------------------------------------------------------------------------
		// 1. bOutReady : Program ׾   Sensor Ǿ  ̰ TRUE Ǵµ
		//    => ׷ ʵ? => ׷  History   True Ѵ.
		// 2. bOutError : Error   Glass  Դ  ϰ Ҽ ִµ ̶
		//    Sensor Ǵ ͵ ϰ Ѵ.
		//    =>  : Error ߻ϸ   C/V  Sequence θ ʴµ,  Error
		//       ߻ C/V   C/V  Ѵ.
		//-----------------------------------------------------------------------------------------
#ifndef _MY_DEBUG
		if( m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady &&
			!m_pDicsData->m_IfFlag[nSensorNo - 1].bOutError &&
			m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo, 0 ) )
#else
		if( m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady && 
			!m_pDicsData->m_IfFlag[nSensorNo - 1].bOutError &&
			m_pDicsData->m_bDebugInSensor[nSensorNo] )
#endif
		{
			m_pDicsData->m_IfFlag[nSensorNo - 1].bOutReady = FALSE;

			//if( m_pDicsView->m_pHost1->m_bCeidEnable[ nSensorNo] && nSensorNo == IF_UNIT_SWR1 )
			if( m_pDicsView->m_pHost1->m_bCeidEnable[ nSensorNo*2-1]) // hskwak 2020/01/03 
			{
				m_pDicsView->m_pHost1->m_bEventReportReq[nSensorNo*2-1] = TRUE;
			}
			if( m_pDicsView->m_pHost1->m_bCeidEnable[ nSensorNo*2]) // hskwak 2020/01/03 
			{
//				m_pDicsView->m_pHost1->S6F11( nSensorNo * 2 + 1 );
				m_pDicsView->m_pHost1->m_bEventReportReq[nSensorNo*2] = TRUE;
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "GLASS IN EVENT REPORT" );
			}

			// Glass Data Move
			GlassDataMove( ( nSensorNo - 1 )*2 + 1, nSensorNo*2 + 0, &nSlotNo[nSensorNo], &nPortNo[nSensorNo] );	//200219

			//2008.11.07 kimgun APC DATA Glass Head ġ  
			m_pDicsData->m_GlsInfo[nSensorNo * 2].sGlassHeadPos.Format("%d",195 + nSensorNo );

			nSlotNo[nSensorNo] = m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].nSlotNo;
			nPortNo[nSensorNo] = m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].nPortNo;

			// glass move
			nGlassNo[nSensorNo] = m_pDicsData->m_GlsInfo[nSensorNo*2 + 0].nGlassNo;
			m_pGlassAni->SetGlassMoveSpeed( nGlassNo[nSensorNo], m_pDicsData->m_JobCond.nCvSpeed / 60 );
			//m_pGlassAni->GlassMove( nGlassNo[nSensorNo], nSensorNo*2 + 3 );	// hskwak 20190529
			m_pGlassAni->GlassMove( nGlassNo[nSensorNo], nSensorNo*2+1);

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "IN SENSOSR : ON" );	

			GetTimeOut( nSensorNo, 0, &nTime1[nSensorNo], &nTime2[nSensorNo], &nTime3[nSensorNo] );
			CString strLog;
			strLog.Format("Time1:%d,Time2:%d,Time3:%d", nTime1[nSensorNo], nTime2[nSensorNo], nTime3[nSensorNo]);
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], strLog );

#ifndef _MY_DEBUG
			TIMER_ON( tm1, nTime1[nSensorNo] );
			TIMER_ON( tm2, nTime2[nSensorNo] );
			TIMER_ON( tm3, nTime3[nSensorNo] );
#else
			TIMER_ON( tm1, 90 );
			TIMER_ON( tm2, 90 );
			TIMER_ON( tm3, 90 );
#endif
			bTm3Warning[nSensorNo] = FALSE;
			
			if( nSensorNo == IF_UNIT_AK && m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupWAIT_IN_WET_CHAMBER] )	// 160704 halesu)
			{
				nSeqNo = 5;
			}
			else
			{
				nSeqNo = 10;
			}
		}
		break;
	case 5:
		if( 1 )
		{
			nSeqNo = 10;
		}
		else 
		{				
			m_pDicsData->m_GenInfo.bUlNotReady = TRUE;

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNLOAD UNIT IS NOT READY" );
			nSeqNo = 100;
		}
		break;	
	case 10:	// Check the out complete (Whether Out Sensor is Off or not)
		if( m_pDicsData->m_IfFlag[nSensorNo].bOutComp )
		{
			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "OUT COMPLETE : OK" );
			nSeqNo = 20;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm3 ) )
#else 
		else if( FALSE )
#endif
		{
			m_pDicsData->m_IfFlag[nSensorNo].bInLogicCheckIgnore = TRUE;

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "OUT COMPLETE : NG" );
			nSeqNo = 20;
		}
		break;
	case 20:
		{
		// ׸ Out Sensor Ǹ شϴ Glass  ¥ Ǵ ̴.
#ifndef _MY_DEBUG
			BOOL bOutSensorOn = m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 );//2009.03.20 kimgun warning.
			if( bOutSensorOn &&
				( TIMER( tm3 ) || m_pDicsData->m_IfFlag[nSensorNo].bInLogicCheckIgnore ) )
#else
			if( TIMER( tm1 ) )
#endif
			{
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugOutSensor[nSensorNo] = TRUE;
#endif
				// Flag Reset
				m_pDicsData->m_IfFlag[nSensorNo].bOutComp = FALSE;

				// Flag Set
				m_pDicsData->m_IfFlag[nSensorNo].bInReady = TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bInLogicCheckIgnore = FALSE;

				// C/V Restart for previous alarm
				if( m_pDicsData->m_IfFlag[nSensorNo].bInError ) 
				{
					m_pDicsData->m_IfFlag[nSensorNo].bInError     = FALSE;
//					m_pDicsData->m_IfFlag[nSensorNo].bAlarm       = FALSE;
//					m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
//					CvRestart( nSensorNo );
				}

				//2008.08.28 kimgun InError case 3000 
				// ϹǷ 쿡  bRecoveryReq     ִ.
				m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;

				// glass move
				//m_pGlassAni->GlassMoveRegion( nGlassNo[nSensorNo], (nSensorNo+1)*2 + 1 );			// hskwak 20190529
				m_pGlassAni->GlassMoveRegion( nGlassNo[nSensorNo], (nSensorNo)*2+1);	
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "OUT SENSOR : ON" );
				nSeqNo = 30;
			}
#ifndef _MY_DEBUG
			else if( bOutSensorOn && !bTm3Warning[nSensorNo] )	// tm3 Glass Ǵ 
#else
			else if( 0 )
#endif
			{
				// Flag Reset
				m_pDicsData->m_IfFlag[nSensorNo].bOutComp = FALSE;

				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "OUT SENSOR : NG(1ST)" );		
				dwTickStart[nSensorNo] = GetTickCount();
				nSeqNo = 25;
			}	
#ifndef _MY_DEBUG
			else if( TIMER( tm1 ) )	// Sensor On Timeout Error
#else
			else if( 0 )
#endif
			{
				// Flag Set
				m_pDicsData->m_IfFlag[nSensorNo].bInError	  = TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;//2008.08.28 kimgun
//				m_pDicsData->m_IfFlag[nSensorNo].bAlarm       = TRUE;

				// Set Alarm
//				nAlarmId[nSensorNo] = ALM_SENSOR_OUT_ON_TIMEOUT1 + nSensorNo - IF_UNIT_LD;
				nAlarmId[nSensorNo] = ALM_SENSOR_OUT_ON_TIMEOUT1 + nSensorNo;
				m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );

				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "OUT SENSOR ON TIMEOUT : NG" );
				nReturnSeqNo[nSensorNo] = nSeqNo;
				nSeqNo = 1000;
			}
			else if( !CheckUnitCondition( ssIN, nSensorNo ) ) 
			{
				// C/V Stop
				m_pDicsData->m_IfFlag[nSensorNo].bInError = TRUE;
//				m_pDicsData->m_IfFlag[nSensorNo].bAlarm = TRUE;

				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNIT CONDITION CHECK : NG" );			
				nReturnSeqNo[nSensorNo] = nSeqNo;
				nSeqNo = 3000;
			}
		}
		break;
	case 25:
		if( GetTickCount() - dwTickStart[nSensorNo] > 500 )
		{
			if( m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) && !bTm3Warning[nSensorNo] )
			{
				bTm3Warning[nSensorNo] = TRUE;
	
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "OUT SENSOR : NG(2ND)" );
				nSeqNo=20;
			}
			else
			{
				nSeqNo=20;
			}
		}
		else if( !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) )
		{
			nSeqNo=20;
		}
		break;
	case 30:
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo, 0 ) )
#else
		if( TIMER( tm2 ) )
#endif
		{
			// C/V Restart for previous alarm
			if( m_pDicsData->m_IfFlag[nSensorNo].bInError ) 
			{
				 m_pDicsData->m_IfFlag[nSensorNo].bInError     = FALSE;
//				 m_pDicsData->m_IfFlag[nSensorNo].bAlarm       = FALSE;
//				 m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;2008.08.28 kimgun
			}

			//2008.08.28 kimgun InError case 3000 
            // ϹǷ 쿡  bRecoveryReq     ִ.
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "IN SENSOR : OFF(1ST)" );
			dwTickStart[nSensorNo] = GetTickCount();
			nSeqNo = 40;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm2 ) )	// Sensor Off Timeout Error
#else
		else if( FALSE )
#endif
		{
            if( m_pSetupItems->m_nValueInSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 1 )
			{
				// Flag Set
				m_pDicsData->m_IfFlag[nSensorNo].bInError = TRUE;
//				m_pDicsData->m_IfFlag[nSensorNo].bAlarm = TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;

				// Set Alarm
				nAlarmId[nSensorNo] = ALM_SENSOR_IN_OFF_TIMEOUT1 + nSensorNo;
				m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );

				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "IN SENSOR OFF TIMEOUT : NG" );
				nReturnSeqNo[nSensorNo] = nSeqNo;
				nSeqNo = 1000;
			}
			else
			{
				SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "IN SENSOR OFF TIMEOUT : NOUSE(1ST)" );
				dwTickStart[nSensorNo] = GetTickCount();
				nSeqNo = 40;
			}
		}
		break;
	case 40:
		if( GetTickCount() - dwTickStart[nSensorNo] > 1000 )
		{
#ifndef _MY_DEBUG
            if( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo, 0 ) || m_pSetupItems->m_nValueInSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 0 )
#else
			if( 1 )
#endif
			{
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugInSensor[nSensorNo] = FALSE;
#endif
				// Flag Set
				m_pDicsData->m_IfFlag[nSensorNo].bInComp = TRUE;
				
				// C/V Restart for previous alarm
				if( m_pDicsData->m_IfFlag[nSensorNo].bInError ) 
				{
					m_pDicsData->m_IfFlag[nSensorNo].bInError     = FALSE;
//					m_pDicsData->m_IfFlag[nSensorNo].bAlarm       = FALSE;
//					m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;2008.08.28 kimgun
//					CvRestart( nSensorNo );
				}

				//2008.08.28 kimgun InError case 3000 
				// ϹǷ 쿡  bRecoveryReq     ִ.
			    m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;

#ifndef _MY_DEBUG
				if( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo, 0 ) )
#else
				if( 1 )
#endif
				{
					SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "IN SENSOR : OFF(2ND)" );
				}
				else if( m_pSetupItems->m_nValueInSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 0 )
				{
					SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "IN SENSOR OFF TIMEOUT : NOUSE(2ND)" );
				}
				nSeqNo = 1;
			}
			else
			{
				nSeqNo = 30;
			}
		}
		break;
	case 100:
/*
		if( m_pDicsData->m_SeqFlag.bUlUnitRecvReady ||
			m_pDicsData->m_SeqFlag.bPreRecvReady ||
			m_pDicsData->m_IfFlag[IF_UNIT_UL].bSendReqCv )
*/
		if( m_pDicsData->m_IfFlag[IF_UNIT_UL].bSendReqCv )

		{	
			m_pDicsData->m_GenInfo.bUlNotReady = FALSE;

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNLOAD UNIT IS READY : OK" );
//			dwTickStart[nSensorNo] = GetTickCount();
//			nSeqNo = 105;
			nSeqNo = 5;
		}
		break;
	case 105:
		if( GetTickCount() - dwTickStart[nSensorNo] > 2000 )
		{
			m_pDicsData->m_GenInfo.bUlNotReady = FALSE;

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNLOAD UNIT IS READY : OK" );
			nSeqNo = 5;
		}
		break;
	case 500 :	// SetSeqNo  case
		{
			double dGlassSize	= GLASS_SIZE;
			double dCvSpeed		= m_pDicsData->m_JobCond.nCvSpeed / 60.0;	// mm/s
#ifndef _MY_DEBUG
			nTime2[nSensorNo]	= (int)( ( dGlassSize / dCvSpeed ) * 10 );
#else
			nTime2[nSensorNo]	= (int)( ( (dGlassSize/3.) / dCvSpeed ) * 10 );
#endif
			TIMER_ON( tm2, nTime2[nSensorNo] );

			nSeqNo = 30;
		}
		break;
	case 1000:	// Alarm Recovery (Timeout Error)
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Set Timer
			TIMER_ON( tm1, nTime1[nSensorNo] );
			TIMER_ON( tm2, nTime2[nSensorNo] );

			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = TRUE;

			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId[nSensorNo] );
			nAlarmId[nSensorNo] = 0;

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "ALARM RESET" );
			nSeqNo = nReturnSeqNo[nSensorNo];
		}
		break;
	case 3000 :	// Alarm Recovery (Unit Condition Alarm)
#ifndef _MY_DEBUG
		if( CheckUnitCondition( ssIN, nSensorNo ) )
#else
		if( CheckUnitCondition( ssIN, nSensorNo ) )
#endif
		{
			// C/V Restart
			m_pDicsData->m_IfFlag[nSensorNo].bInError = FALSE;
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm = FALSE;

			SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNIT CONDITION CHECK : OK(RECHECK)" );
			nSeqNo = nReturnSeqNo[nSensorNo];
		}
		break;
	} // Switch End
	m_nSeqInSensorNo[nSensorNo] = nSeqNo;
}

void CCvSeq::SeqOutSensor(int nSensorNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return; 

	int nSeqNo = m_nSeqOutSensorNo[nSensorNo];
	static int nReturnSeqNo[MAX_UNIT_NO]		  = { 0, };
	static DWORD dwTickStart[MAX_UNIT_NO]		  = { 0, };
		
	int tm1 = TM_OUT_SENSOR_ON( nSensorNo );
	int tm2 = TM_OUT_SENSOR_OFF( nSensorNo );
	int tm3 = TM_OUT_SENSOR_OUT2IN( nSensorNo );
	static int nTime1[MAX_UNIT_NO] = { 0, };
	static int nTime2[MAX_UNIT_NO] = { 0, };
	static int nTime3[MAX_UNIT_NO] = { 0, };
	static BOOL bTm3Warning[MAX_UNIT_NO] = { FALSE, };
	
	static int nPortNo[MAX_UNIT_NO] = { 0, };
	static int nSlotNo[MAX_UNIT_NO] = { 0, };
	static int nGlassNo[MAX_UNIT_NO] = { 0, };
	static int nAlarmId[MAX_UNIT_NO] = { 0, };

	TimerControl( ssOUT, nSensorNo );

	if( !GetSeqRunCond( nSensorNo) )	return;

	switch( nSeqNo )
	{
	case 0 :
		{
			if( nAlarmId[nSensorNo] > 0 )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId[nSensorNo] );
				nAlarmId[nSensorNo] = 0;
			}

			BOOL bIsValid = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].bIsValid;
			if( bIsValid )
			{
				// When there is glass data.
				m_pDicsData->m_IfFlag[nSensorNo].bInReady	= TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bOutComp	= FALSE;
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugOutSensor[nSensorNo]	= TRUE;
				if ( ( nSensorNo != IF_UNIT_LD ) && ( nSensorNo != IF_UNIT_UL ) )
				{
					m_pDicsData->m_bDebugInSensor[nSensorNo]	= TRUE;
				}
				m_nSeqInSensorNo[nSensorNo] = 0;				
#endif
				nSeqNo = 1;
			}
			else
			{
				// NO Glass Data, but Glass Sensing
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) ) 
#else
				if( m_pDicsData->m_bDebugOutSensor[nSensorNo] ) 
#endif
				{ 
					m_pDicsData->m_IfFlag[nSensorNo].bOutComp = FALSE; 
					nSeqNo = 500;
				}
				else
				{
					nSeqNo = 1;
				}
			}
		}
		break;
	case 1 :
		//-----------------------------------------------------------------------------------------
		// 1. bInReady : Program ׾   Sensor Ǿ  ̰ TRUE Ǵµ
		//    => ׷ ʵ? => ׷  History   True Ѵ.
		// 2. bOutError : Error   Glass  Դ  ϰ Ҽ ִµ ̶
		//    Sensor Ǵ ͵ ϰ Ѵ.
		//    =>  : Error ߻ϸ   C/V  Sequence θ ʴµ,  Error
		//       ߻ C/V   C/V  Ѵ.
		//-----------------------------------------------------------------------------------------
#ifndef _MY_DEBUG
		if( m_pDicsData->m_IfFlag[nSensorNo].bInReady &&
			!m_pDicsData->m_IfFlag[nSensorNo].bInError &&
			m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) )
#else
		if( m_pDicsData->m_IfFlag[nSensorNo].bInReady && 
			!m_pDicsData->m_IfFlag[nSensorNo].bInError &&
			m_pDicsData->m_bDebugOutSensor[nSensorNo] )
#endif
		{
//			SetApdData( nSensorNo );
			
			// Flag Reset
			m_pDicsData->m_IfFlag[nSensorNo].bInReady = FALSE;

			// Glass Data Move
			GlassDataMove( nSensorNo*2 + 0, nSensorNo*2 + 1, &nSlotNo[nSensorNo], &nPortNo[nSensorNo] );

			// Glass Move
			nGlassNo[nSensorNo] = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nGlassNo;
			m_pGlassAni->SetGlassMoveSpeed( nGlassNo[nSensorNo], m_pDicsData->m_JobCond.nCvSpeed / 60 );
			//m_pGlassAni->GlassMove( nGlassNo[nSensorNo], ( nSensorNo + 2 ) * 2 + 0 );	// hskwak 20190529
			m_pGlassAni->GlassMove( nGlassNo[nSensorNo], ( (nSensorNo+1)*2+0 ));

			nSlotNo[nSensorNo] = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nSlotNo;
			nPortNo[nSensorNo] = m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].nPortNo;
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "OUT SENSOR : ON" );

			GetTimeOut( nSensorNo, 1, &nTime1[nSensorNo], &nTime2[nSensorNo], &nTime3[nSensorNo] );
#ifndef _MY_DEBUG
			TIMER_ON( tm1, nTime1[nSensorNo] );
			TIMER_ON( tm2, nTime2[nSensorNo] );
			TIMER_ON( tm3, nTime3[nSensorNo] );
#else
			TIMER_ON( tm1, 80 );
			TIMER_ON( tm2, 80 );
			TIMER_ON( tm3, 80 );
#endif
			bTm3Warning[nSensorNo] = FALSE;

 			if( nSensorNo == IF_UNIT_SWR4 && m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupWAIT_IN_WET_CHAMBER] )	// 160704 halesu
			{
 				nSeqNo = 5;
			}
 			//else if( nSensorNo == IF_UNIT_AK )
			else if( nSensorNo == IF_UNIT_BUF )
			{
				nSeqNo = 7;
			}
			else
			{
				nSeqNo = 10;
			}
		}
		break;
	case 5:

#ifndef _MY_DEBUG
		if(	!m_pEqpStateSeq->IsAlarm( ALM_AK_FLOW_DEVIATION ) &&
			!m_pDicsData->m_GenInfo.bUlTimeOut &&
			( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) && !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 )  &&
			 !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_BUF, 0 ) && !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_BUF, 1) &&
			 !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_AK, 0 ) && !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_AK, 1))
			&& m_pEqpAssy->m_CylinderUlPinUD.GetBw() && !m_pDicsData->m_GlsInfo[IF_UNIT_UL*2].bIsValid && !m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].bIsValid)
#else
			if(	!m_pEqpStateSeq->IsAlarm( ALM_AK_FLOW_DEVIATION ) &&
				!m_pDicsData->m_GenInfo.bUlTimeOut &&
			( !m_pDicsData->m_bDebugInSensor[IF_UNIT_UL] && !m_pDicsData->m_bDebugOutSensor[IF_UNIT_UL] ))
#endif
		{
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNLOAD UNIT IS READY STATE" );
			nSeqNo = 10;
		}
		else 
		{	
			m_pDicsData->m_GenInfo.bUlNotReady = TRUE;	// SanghoCho 2015.08.18

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNLOAD UNIT IS NOT READY" );			
			nSeqNo = 100;
		}
		break;
	case 7:	// SanghoCho 2015.08.18
/*
		if( m_pDicsData->m_SeqFlag.bUlUnitRecvReady )
		{
			m_pDicsData->m_SeqFlag.bPreRecvReady = FALSE;

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNLOAD UNIT IS READY STATE" );
			nSeqNo = 10;
		}
*/
#ifndef _MY_DEBUG
		if(	!m_pDicsData->m_GenInfo.bUlTimeOut &&
			( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) && !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 ) ) 
			&& m_pEqpAssy->m_CylinderUlPinUD.GetBw() && !m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].bIsValid)
#else
		if(	!m_pDicsData->m_GenInfo.bUlTimeOut &&
			( !m_pDicsData->m_bDebugInSensor[IF_UNIT_UL] && !m_pDicsData->m_bDebugOutSensor[IF_UNIT_UL] ) && m_pEqpAssy->m_CylinderUlPinUD.GetBwState())
#endif
		{
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNLOAD UNIT IS READY STATE" );
			nSeqNo = 10;
		}
		else 
		{
			m_pDicsData->m_GenInfo.bUlNotReady = TRUE;

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNLOAD UNIT IS NOT READY" );
			nSeqNo = 200;
		}
		break;
	case 10:
		if( !CheckUnitCondition( ssOUT, nSensorNo ) ) 
		{
			// C/V Stop
//			CvStop( nSensorNo );
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm = TRUE;

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNIT CONDITION CHECK : NG" );
			nReturnSeqNo[nSensorNo] = nSeqNo;
			nSeqNo = 3000;
		}
		else if( m_pDicsData->m_IfFlag[nSensorNo + 1].bInComp )
		{
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "IN COMPLETE : OK" );
			nSeqNo = 15;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm3 ) )
#else 
		else if( FALSE )
#endif
		{
			m_pDicsData->m_IfFlag[nSensorNo].bOutLogicCheckIgnore = TRUE;

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "IN COMPLETE : NG" );
			nSeqNo = 15;
		}
		break;
	case 15 :
		if( CheckUnitCondition( ssOUT, nSensorNo ) )
		{	
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNIT CONDITION CHECK : OK" );
/*
			// Save APD 
			if( nSensorNo == IF_UNIT_BUF )
			{
				ApdSave( nSensorNo * 2 + 1, nPortNo[nSensorNo], nSlotNo[nSensorNo] );
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "APD SAVE" );
			}
*/
			nSeqNo = 20;
		}
		else
		{
//			CvStop( nSensorNo );
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;			
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm = TRUE;

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNIT CONDITION CHECK : NG" );
			nReturnSeqNo[nSensorNo] = nSeqNo;
			nSeqNo = 3000;			
		}
		break;
	case 20:
		{
#ifndef _MY_DEBUG
			BOOL bInSensorOn =  m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo + 1, 0 );
			if( bInSensorOn &&
				( TIMER( tm3 ) || m_pDicsData->m_IfFlag[nSensorNo].bOutLogicCheckIgnore ) )
#else
			if( TIMER( tm1 ) )
#endif
			{
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugInSensor[nSensorNo + 1] = TRUE;
#endif
				// Flag Reset
				m_pDicsData->m_IfFlag[nSensorNo + 1].bInComp = FALSE;

				// Flag Set
				m_pDicsData->m_IfFlag[nSensorNo].bOutReady = TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bOutLogicCheckIgnore = FALSE;

				// C/V Restart
				if( m_pDicsData->m_IfFlag[nSensorNo].bOutError ) 
				{
					m_pDicsData->m_IfFlag[nSensorNo].bOutError    = FALSE;
//					m_pDicsData->m_IfFlag[nSensorNo].bAlarm       = FALSE;
//					m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
//					CvRestart( nSensorNo );
				}

				//2008.08.28 kimgun OutError case 3000 
				// ϹǷ 쿡  bRecoveryReq     ִ.
				m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;

				// Glass Move
				//m_pGlassAni->GlassMoveRegion( nGlassNo[nSensorNo], ( nSensorNo + 2 )*2 + 0 );		// hskwak 20190529
				m_pGlassAni->GlassMoveRegion( nGlassNo[nSensorNo], (nSensorNo+1)*2+0);

				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "NEXT IN SENSOR : ON" );
				nSeqNo = 30;
			}
#ifndef _MY_DEBUG
			else if( bInSensorOn &&  !bTm3Warning[nSensorNo] )
#else
			else if( 0 )
#endif
			{
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "NEXT IN SENSOR : NG(1ST)" );
				dwTickStart[nSensorNo] = GetTickCount();		
				nSeqNo = 25;
			}
#ifndef _MY_DEBUG
			else if( TIMER( tm1 ) )
#else
			else if( 0 )
#endif
			{
				// Flag Set
				m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
//				m_pDicsData->m_IfFlag[nSensorNo].bAlarm    = TRUE;

				// C/V Stop
//				CvStop( nSensorNo, m_pDicsData->m_IfFlag[nSensorNo].bOutError );

				// Set Alarm
//				nAlarmId[nSensorNo] = ALM_SENSOR_IN_ON_TIMEOUT1 + nSensorNo + 1 - IF_UNIT_LD;
				nAlarmId[nSensorNo] = ALM_SENSOR_IN_ON_TIMEOUT1 + nSensorNo + 1;
				m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );

				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "NEXT IN SENSOR ON TIMEOUT : NG" );
				nReturnSeqNo[nSensorNo] = nSeqNo;
				nSeqNo = 1000;
			}
			if( !CheckUnitCondition( ssOUT, nSensorNo ) ) 
			{
				// C/V Stop
//				CvStop( nSensorNo );
				m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
//				m_pDicsData->m_IfFlag[nSensorNo].bAlarm = TRUE;

				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNIT CONDITION CHECK : NG" );
				nReturnSeqNo[nSensorNo] = nSeqNo;
				nSeqNo = 3000;
			}

			if(nSensorNo == IF_UNIT_LD && SeqLDRobotInterlock(nSensorNo, TRUE))
			{
				m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;

				nAlarmId[nSensorNo] = ALM_ROBOT_HAND_INTERRUPT1;
				m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );

				nReturnSeqNo[nSensorNo] = nSeqNo;
				nSeqNo = 1000;
			}
		}
		break;
	case 25 :
		if( GetTickCount() - dwTickStart[nSensorNo] > 500 )
		{
			if( m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo + 1, 0 ) && !bTm3Warning[nSensorNo] )
			{
				bTm3Warning[nSensorNo] = TRUE;

				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "NEXT IN SENSOR : NG(2ND)" );
				nSeqNo=20;
			}
			else
			{
				nSeqNo=20;
			}
		}
		else if( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( nSensorNo + 1, 0 ) )
		{
			nSeqNo=20;
		}
		break;
	case 30:
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) )
#else
		if( TIMER( tm2 ) )
#endif
		{
			// C/V Restart for previous alarm
			if( m_pDicsData->m_IfFlag[nSensorNo].bOutError ) 
			{
				 m_pDicsData->m_IfFlag[nSensorNo].bOutError	   = FALSE;
//				 m_pDicsData->m_IfFlag[nSensorNo].bAlarm	   = FALSE;
//				 m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
//				 CvRestart( nSensorNo );
			}
			//2008.08.28 kimgun OutError case 3000 
			// ϹǷ 쿡  bRecoveryReq     ִ.
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "OUT SENSOR : OFF(1ST)" );
			dwTickStart[nSensorNo] = GetTickCount();
			nSeqNo = 40;
		}
#ifndef _MY_DEBUG
		else if( TIMER( tm2 ) )		
#else
		else if( nSensorNo == IF_UNIT_SWR2 )
#endif
		{
			// C/V Stop
            if( m_pSetupItems->m_nValueOutSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 1 )
			{
				m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
				m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;
//				m_pDicsData->m_IfFlag[nSensorNo].bAlarm = TRUE;

//				CvStop( nSensorNo, m_pDicsData->m_IfFlag[nSensorNo].bOutError );

				nAlarmId[nSensorNo] = ALM_SENSOR_OUT_OFF_TIMEOUT1 + nSensorNo;
				m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );

				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "OUT SENSOR OFF TIMEOUT : NG" );
				nReturnSeqNo[nSensorNo] = nSeqNo;
				nSeqNo = 1000;
			}
			else
			{
				SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "OUT SENSOR OFF TIMEOUT : NOUSE(1ST)" );
				dwTickStart[nSensorNo] = GetTickCount();
				nSeqNo = 40;
			}
		}
		else if(nSensorNo == IF_UNIT_LD && SeqLDRobotInterlock(nSensorNo, TRUE))
		{
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = TRUE;
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;

			nAlarmId[nSensorNo] = ALM_ROBOT_HAND_INTERRUPT1;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nSensorNo] );

			nReturnSeqNo[nSensorNo] = nSeqNo;
			nSeqNo = 1000;
		}
		break;
	case 40:
		if( GetTickCount() - dwTickStart[nSensorNo] > 1000 )
		{
#ifndef _MY_DEBUG
            if( !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) ||
				m_pSetupItems->m_nValueOutSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 0 )
#else
			if( 1 )
#endif
			{
#ifdef _MY_DEBUG
				m_pDicsData->m_bDebugOutSensor[nSensorNo] = FALSE;
#endif
				// Flag Set
				m_pDicsData->m_IfFlag[nSensorNo].bOutComp = TRUE;

				// C/V Restart
				if( m_pDicsData->m_IfFlag[nSensorNo].bOutError ) 
				{
					m_pDicsData->m_IfFlag[nSensorNo].bOutError	  = FALSE;
//					m_pDicsData->m_IfFlag[nSensorNo].bAlarm		  = FALSE;
//					m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;2008.08.28 kimgun
//					CvRestart( nSensorNo );
				}

				//2008.08.28 kimgun OutError case 3000 
				// ϹǷ 쿡  bRecoveryReq     ִ.
				m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = FALSE;

				//2008.11.07 kimgun APC DATA Glass Tail ġ  
				for( int i = nSensorNo * 2; i < IF_UNIT_UL * 2 + 1; i++ )
				{
					if( m_pDicsData->m_GlsInfo[i].bIsValid )
					{
						m_pDicsData->m_GlsInfo[i].sGlassTailPos.Format("%d",195 + nSensorNo + 1 );
						break;
					}
				}

#ifndef _MY_DEBUG
				if( !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( nSensorNo, 1 ) )
#else
				if( 1 )
#endif
				{
					SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "OUT SENSOR : OFF(2ND)" );
				}
				else if( m_pSetupItems->m_nValueOutSensorOffTimeOut[nSensorNo - IF_UNIT_LD] == 0 )
				{
					SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "OUT SENSOR OFF TIMEOUT : NOUSE(2ND)" );
				}
				nSeqNo = 1;
			}
			else
			{
				nSeqNo = 30;
			}
		}
		break;
	case 100:
#ifndef _MY_DEBUG
//		if(( m_pDicsData->m_SeqFlag.bUlUnitRecvReady || m_pDicsData->m_SeqFlag.bPreRecvReady ) &&
//		if(( m_pDicsData->m_SeqFlag.bPreRecvReady ) && !m_pEqpStateSeq->IsAlarm( ALM_AK_FLOW_DEVIATION ))
		if(	!m_pEqpStateSeq->IsAlarm( ALM_AK_FLOW_DEVIATION ) &&
			!m_pDicsData->m_GenInfo.bUlTimeOut &&
			( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) && !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1)  &&
			 !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_BUF, 0 ) && !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_BUF, 1) &&
			 !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_AK, 0 ) && !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_AK, 1))
			&& m_pEqpAssy->m_CylinderUlPinUD.GetBw() && !m_pDicsData->m_GlsInfo[IF_UNIT_UL*2].bIsValid && !m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].bIsValid)
#else
		if( !m_pDicsData->m_GenInfo.bUlTimeOut &&
			( !m_pDicsData->m_bDebugInSensor[IF_UNIT_UL] && !m_pDicsData->m_bDebugOutSensor[IF_UNIT_UL] ))
#endif
		{
			if( nSensorNo == IF_UNIT_SWR2 )
			{
				dwTickStart[nSensorNo] = GetTickCount();
				nSeqNo = 105;
			}
			else
			{				
				m_pDicsData->m_GenInfo.bUlNotReady = FALSE;
				nSeqNo = 5;
			}

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNLOAD UNIT IS READY : OK" );
		}
		break;
	case 105:
		if( GetTickCount() - dwTickStart[nSensorNo] > 3000 )
		{
			m_pDicsData->m_GenInfo.bUlNotReady = FALSE;
			nSeqNo = 5;
		}
		break;
	case 200:	// SanghoCho 2015.08.18
#ifndef _MY_DEBUG
		if(	!m_pDicsData->m_GenInfo.bUlTimeOut &&
			( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) && !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 )) 
			&& m_pEqpAssy->m_CylinderUlPinUD.GetBw() && !m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].bIsValid)
//		if( m_pDicsData->m_SeqFlag.bUlUnitRecvReady )
#else
		if ( !m_pDicsData->m_GenInfo.bUlTimeOut &&
			( !m_pDicsData->m_bDebugInSensor[IF_UNIT_UL] && !m_pDicsData->m_bDebugOutSensor[IF_UNIT_UL] ) &&  m_pEqpAssy->m_CylinderUlPinUD.GetBwState())
#endif
		{
			m_pDicsData->m_GenInfo.bUlNotReady = FALSE;

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNLOAD UNIT IS READY : OK" );			
			nSeqNo = 7;
		}
		break;
	case 500 :
		{
			double dGlassSize	= GLASS_SIZE;
			double dCvSpeed		= m_pDicsData->m_JobCond.nCvSpeed / 60.0; // mm/s
#ifndef _MY_DEBUG
			nTime2[nSensorNo]	= (int)( ( dGlassSize / dCvSpeed ) * 10 );
#else
			nTime2[nSensorNo]	= (int)( ( (dGlassSize/3.) / dCvSpeed ) * 10 );
#endif
			TIMER_ON( tm2, nTime2[nSensorNo] );

			nSeqNo = 30;
		}
		break;
	case 1000:	// Alarm Recovery (Timeout Error)
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			// Set Timer
			TIMER_ON( tm1, nTime1[nSensorNo] );
			TIMER_ON( tm2, nTime2[nSensorNo] );
			
			// C/V Restart
//			CurCvRestart( nSensorNo );
			m_pDicsData->m_IfFlag[nSensorNo].bRecoveryReq = TRUE;

			// Reset Alarm
			m_pEqpStateSeq->ResetAlarm( nAlarmId[nSensorNo] );

			nPortNo[nSensorNo] = atoi( m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].sPortNo );
			nSlotNo[nSensorNo] = atoi( m_pDicsData->m_GlsInfo[nSensorNo*2 + 1].sSlotNo );
			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "ALARM RESET" );
			nSeqNo = nReturnSeqNo[nSensorNo];
		}
		break;
	case 3000 :	// Alarm Recovery (Unit Condition Alarm)
		if( CheckUnitCondition( ssOUT, nSensorNo ) )
		{
			// C/V Restart
//			CvRestart( nSensorNo );			
			m_pDicsData->m_IfFlag[nSensorNo].bOutError = FALSE;
//			m_pDicsData->m_IfFlag[nSensorNo].bAlarm = FALSE;

			SetLog( m_pDicsData->m_sOutSensorUnitName[nSensorNo], nPortNo[nSensorNo], nSlotNo[nSensorNo], "UNIT CONDITION CHECK : OK(RECHECK)" );
			nSeqNo = nReturnSeqNo[nSensorNo];
		}
		break;

	} // Switch End

	m_nSeqOutSensorNo[nSensorNo] = nSeqNo;
}

//******************************************************************************
//
//
//	-o-----o--o----o--o----o--o----o--o----o--o----o--o----o-
//	|		||		||		||		||		||		||		||
//	|	0	||	1	||	2	||	3	||	4	||	5	||	6	||		MAX_UNIT_NO = 7
//	----------------------------------------------------------
//	(M0)---->|(M1)---------->|(M2)------------------>|(M3)-->|		MAX_CV_NO = 4
//	
//	n=	1			2					3				1			nInfoSet[MAX_CV_NO][1] = n
//
//	static int nInfoSet[MAX_CV_NO][2]
//	{
//		{ IF_UNIT_O, 1},
//		{ IF_UNIT_1, 2},
//		{ IF_UNIT_3, 3},
//		{ IF_UNIT_6, 1},
//	};
//******************************************************************************
void CCvSeq::SeqCv(int nCvNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	if( !m_pDicsData->m_GenInfo.bEqpInitComp ) return;

	static int nInfoSet[MAX_UNIT_NO][2] = {
		{ IF_UNIT_LD, 1 },
		{ IF_UNIT_SWR1,1 },
		{ IF_UNIT_SWR2,1 },
		{ IF_UNIT_SWR3, 1 },
		{ IF_UNIT_SWR4, 1 },
		{ IF_UNIT_AK, 1 },
		{ IF_UNIT_BUF, 1 },
		{ IF_UNIT_UL, 1 }
	};
//#ifndef _NO_RB
//	static CString	m_sUnitName[MAX_UNIT_NO] = { "","","", "LD", "EUV", "RB", "FR", "AK", "UL", };
//#else
	static CString	m_sUnitName[MAX_UNIT_NO] = {"LD", "SWR1", "SWR2", "SWR3", "SWR4", "AK","BUF","UL", };
//#endif
	int nUnit = nInfoSet[nCvNo][cvinfoSTART_UNIT];
	int nUnitEA = nInfoSet[nCvNo][cvinfoUNIT_NO];
	//******************************************************************************
	// Get Run Condition
	//******************************************************************************
	BOOL bRunCond = FALSE;
	static BOOL bUlCvStop = FALSE;

	for( int i = 0 ; i < nUnitEA ; i ++ )
	{
		//hskwak 190515 ߿ κ Ȯ ʿ.
		nUnit = nUnit + i;
		bRunCond |= ( m_pDicsData->m_IfFlag[nUnit-1].bOutReady & ( nUnit != IF_UNIT_LD ) );			// O
 		bRunCond |= ( !m_pDicsData->m_IfFlag[nUnit-1].bOutComp & ( nUnit != IF_UNIT_LD ) );			// X
		bRunCond |= m_pDicsData->m_IfFlag[nUnit].bInReady;		// O
		bRunCond |= m_pDicsData->m_IfFlag[nUnit].bOutReady;		// O
		bRunCond |= ( m_pDicsData->m_GlsInfo[nUnit*2+0].bIsValid & ( nUnit != IF_UNIT_LD ) );	// O
		bRunCond |= !m_pDicsData->m_IfFlag[nUnit].bOutComp;	// X
		bRunCond |= ( !m_pDicsData->m_IfFlag[nUnit+1].bInComp &		// X
					  ( ( nUnit != IF_UNIT_UL ) ) );		
	}
	nUnit = nInfoSet[nCvNo][cvinfoSTART_UNIT];
	//==>2008.10.12 kimgun Sbj stop Ȯϰ ϱ.. 
//	if( nUnit == IF_UNIT_SWR2 && m_CvMotor.nCvAuto[IF_UNIT_SWR1] != cvFW && 
//	     m_pDicsData->m_IfFlag[IF_UNIT_SWR2].bOutComp )
//	{
//		bRunCond = FALSE;	
//	}

	if( nUnit == IF_UNIT_UL && m_pDicsData->m_IfFlag[IF_UNIT_UL].bInComp  && 
	     m_pDicsData->m_IfFlag[IF_UNIT_UL].bOutComp && (m_pDicsData->m_IfFlag[nUnit-1].bOutComp || m_pDicsData->m_GlsInfo[IF_UNIT_UL*2+1].bIsValid))
	{
		bRunCond = FALSE;

	}

	//******************************************************************************
	// Get Alarm Condition
	//******************************************************************************
	BOOL bAlarm = FALSE;
	for( int i = nCvNo; i < MAX_UNIT_NO ; i ++ )
	{
		nUnit = nInfoSet[i][cvinfoSTART_UNIT];
		nUnitEA = nInfoSet[i][cvinfoUNIT_NO];
		for( int j = 0 ; j < nUnitEA ; j ++ )
		{
			nUnit = nUnit + j;
			bAlarm |= m_pDicsData->m_IfFlag[nUnit].bInError | m_pDicsData->m_IfFlag[nUnit].bOutError;
		}
		if( i <= IF_UNIT_AK )
		{
			bAlarm |= m_pDicsData->m_GenInfo.bAkInterlock;
		}
	}
	//******************************************************************************
	// Get Recovery Condition
	//******************************************************************************
	BOOL bRecoveryReq = FALSE;
	for( int i = nCvNo ; i < nCvNo + 3 ; i ++ )//2008.08.28 KIMGUN Glass ִ 3~4 Unit ⶧..
	{                                      //߻ ˶ġ ڷ 2 ڱ C/V ȸ Ű.. 
		if( (nCvNo == MAX_CV_NO) || (i >= MAX_CV_NO) ) continue;

		nUnit = nInfoSet[i][cvinfoSTART_UNIT];
		nUnitEA = nInfoSet[i][cvinfoUNIT_NO];
		for( int j = 0 ; j < nUnitEA ; j ++ )
		{
			nUnit = nUnit + j;
			bRecoveryReq |= m_pDicsData->m_IfFlag[nUnit].bRecoveryReq;
		}
	}
	//******************************************************************************
	// Get Interlock Condition
	//******************************************************************************
	BOOL bInterlock = FALSE;
	bInterlock|= !m_pDicsData->m_GenInfo.bAuto;
	bInterlock|= m_pDicsData->m_GenInfo.bPause;
	bInterlock|= ( m_pDicsData->m_GenInfo.bUlTimeOut && nInfoSet[nCvNo][cvinfoSTART_UNIT] < IF_UNIT_UL );

/*
	bInterlock|= ( m_pDicsData->m_GenInfo.bUlNotReady && 
				   m_pDicsData->m_GlsInfo[IF_UNIT_SWR2*2+1].bIsValid &&
				   nInfoSet[nCvNo][cvinfoSTART_UNIT] < IF_UNIT_AK );

	bInterlock|= ( m_pDicsData->m_GenInfo.bUlNotReady && 
				   nInfoSet[nCvNo][cvinfoSTART_UNIT] == IF_UNIT_AK && 
				   m_pDicsData->m_GlsInfo[IF_UNIT_SWR2*2+1].bIsValid &&
				   m_pDicsData->m_IfFlag[IF_UNIT_AK].bOutComp && 
				   ( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) || m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 )));

	bInterlock|= ( m_pDicsData->m_GenInfo.bUlNotReady && 
				   nInfoSet[nCvNo][cvinfoSTART_UNIT] < IF_UNIT_UL && 
				   ( m_pDicsData->m_GlsInfo[IF_UNIT_AK*2+0].bIsValid || m_pDicsData->m_GlsInfo[IF_UNIT_AK*2+1].bIsValid ));
*/
	bInterlock|= ( m_pDicsData->m_GenInfo.bUlNotReady && 
				   m_pDicsData->m_GlsInfo[IF_UNIT_AK*2+1].bIsValid &&
				   nInfoSet[nCvNo][cvinfoSTART_UNIT] < IF_UNIT_BUF );

	bInterlock|= ( m_pDicsData->m_GenInfo.bUlNotReady && 
				   nInfoSet[nCvNo][cvinfoSTART_UNIT] == IF_UNIT_BUF && 
				   m_pDicsData->m_GlsInfo[IF_UNIT_AK*2+1].bIsValid &&
				   m_pDicsData->m_IfFlag[IF_UNIT_BUF].bOutComp && 
				   ( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_UL, 0 ) || m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 )));
	
	bInterlock|= ( m_pDicsData->m_GenInfo.bUlNotReady && 
				   nInfoSet[nCvNo][cvinfoSTART_UNIT] < IF_UNIT_UL && 
				   ( /*m_pDicsData->m_GlsInfo[IF_UNIT_BUF*2+0].bIsValid ||*/ 
				   m_pDicsData->m_GlsInfo[IF_UNIT_BUF*2+1].bIsValid ));

	if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupWAIT_IN_WET_CHAMBER] )
	{
		bInterlock|= ( m_pDicsData->m_GenInfo.bUlNotReady && 
					   nInfoSet[nCvNo][cvinfoSTART_UNIT] < IF_UNIT_AK && 
					   m_pDicsData->m_GlsInfo[IF_UNIT_SWR4*2+1].bIsValid );

		// hskwak 191015 AK Stop Interlock
		bInterlock|= ( m_pDicsData->m_GenInfo.bUlNotReady && 
					   nInfoSet[nCvNo][cvinfoSTART_UNIT] == IF_UNIT_AK && 
					   m_pDicsData->m_GlsInfo[IF_UNIT_SWR4*2+1].bIsValid &&
					   ( !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_AK, 0 ) &&
					   !m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_AK, 1 ) &&
					   !m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_BUF, 0 )));
	}

	bInterlock|= m_pDicsData->m_GenInfo.bLeakSensor;
	bInterlock|= m_pDicsData->m_GenInfo.bEmo;
	bInterlock|= m_pDicsData->m_GenInfo.bAreaSensor;
	bInterlock|= m_pDicsData->m_GenInfo.bCoverOpen;
	bInterlock|= m_pDicsData->m_GenInfo.bDoorOpen;
	bInterlock|= m_pDicsData->m_GenInfo.bIonizerAlarm;
	bInterlock|= m_pDicsData->m_SeqFlag.bUlHandAlarm;

	//******************************************************************************
	// Set C/V Motor Command
	//******************************************************************************
	if( !bInterlock && bRunCond && ( bRecoveryReq || !bAlarm ) )
	{
		if( m_CvMotor.nCvAuto[nCvNo] != cvFW )
			SetLog( m_sUnitName[nCvNo], -1, -1, "CV FW" );

		m_CvMotor.nCvAuto[nCvNo] = cvFW;

			if( m_pDicsData->m_GenInfo.bSbjStop &&				// MJ  CvSTOP 쿡 .
			(m_CvMotor.nCvAuto[IF_UNIT_SWR1] != cvSTOP  ||
 			m_CvMotor.nCvAuto[IF_UNIT_SWR2] != cvSTOP ))
			{
				m_pDicsData->m_GenInfo.bSbjStop = FALSE;
			}
	}
	else
	{
		if( m_CvMotor.nCvAuto[nCvNo] != cvSTOP )
			SetLog( m_sUnitName[nCvNo], -1, -1, "CV STOP" );

		m_CvMotor.nCvAuto[nCvNo] = cvSTOP;

		if( !m_pDicsData->m_GenInfo.bSbjStop &&
			( bInterlock || ( bAlarm && nInfoSet[nCvNo][cvinfoSTART_UNIT] > IF_UNIT_SWR1 ) ) )
		{
			BOOL bSbjStop = FALSE;
			for( int i=nInfoSet[nCvNo][cvinfoSTART_UNIT]+1; i<=IF_UNIT_SWR1; i++ )
			{
				// glass  FR    ߸  . 2008.12.08 kimgun
#ifndef _MY_DEBUG
				if( m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( i, 0 ) || m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( i, 1 ) )
#else
				if( m_pDicsData->m_bDebugInSensor[i] ||  m_pDicsData->m_bDebugOutSensor[i] )
#endif
					bSbjStop = TRUE;
			}
				if( !bSbjStop )
				m_pDicsData->m_GenInfo.bSbjStop = TRUE;
		}
	}
}

void CCvSeq::SeqCvMotorControl(int nCvNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( m_pDicsData->m_GenInfo.bAuto )
	{
		if( m_CvMotor.nCvAuto[nCvNo] == cvFW )
		{
			m_pEqpAssy->m_CvMotor.SetMotorFw( nCvNo, ON );
			m_pEqpAssy->m_CvMotor.SetMotorBw( nCvNo, OFF );
		}
		else if( m_CvMotor.nCvAuto[nCvNo] == cvBW )
		{
			m_pEqpAssy->m_CvMotor.SetMotorFw( nCvNo, OFF );
			m_pEqpAssy->m_CvMotor.SetMotorBw( nCvNo, ON );
		}
		else if( m_CvMotor.nCvAuto[nCvNo] == cvSTOP )
		{
			m_pEqpAssy->m_CvMotor.SetMotorFw( nCvNo, OFF );
			m_pEqpAssy->m_CvMotor.SetMotorBw( nCvNo, OFF );
		}
	} 
}

void CCvSeq::SeqCvMotorSpeedControl()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	static int nSeqCvMotorSpeedControlNo = 0;
	static int nCurSpeedAuto[MAX_CV_NO] = { 0, };
	static int nCurSpeedManual[MAX_CV_MOTOR_NO] = { 0, };
	static CString	m_sUnitName[MAX_UNIT_NO] = { "LD", "SWR1", "SWR2", "SWR3", "SWR4", "AK", "BUF", "UL", };

	int nSeqNo = nSeqCvMotorSpeedControlNo;

	switch( nSeqNo ) 
	{
	case 0 :
		if( !m_pDicsData->m_GenInfo.bAuto )
		{
			nSeqNo = 10;			
		}
		else
		{
			for( int i=CV_NO_LD; i<m_pEqpAssy->m_CvMotor.GetMaxSectionNo(); i++ )
			{
				int nCvSpeed = m_pDicsData->m_JobCond.nCvSpeedSet[i][CJobCond::speedNORMAL];

				if( nCvSpeed != nCurSpeedAuto[i] )
				{
					// speed monitor 140103 halesu
					CString m_sMessage;
					m_sMessage.Format("%s : %d --> %d", m_sUnitName[i], nCurSpeedAuto[i], nCvSpeed);
					SetLog("SpeedControl", 0, 0, m_sMessage);

					nCurSpeedAuto[i] = nCvSpeed;
					m_pEqpAssy->m_CvMotor.SetMotorSpeed( i, nCvSpeed );
				}
			}	
		}
		break;
	case 10 :
		if( m_pDicsData->m_GenInfo.bAuto )
		{
			for( int i=CV_NO_LD ; i<m_pEqpAssy->m_CvMotor.GetMaxSectionNo(); i++ )
			{
				nCurSpeedAuto[i] = 0;
			}
			nSeqNo = 0;
		}
		else
		{
			for( int i=CV_NO_LD; i<m_pEqpAssy->m_CvMotorAll.GetMaxSectionNo(); i++ )
			{
				int nCvSpeed = m_CvMotor.nSpeedManual[i];
				if( nCvSpeed != nCurSpeedManual[i] )
				{
					nCurSpeedManual[i] = nCvSpeed; 
					m_pEqpAssy->m_CvMotorAll.SetMotorSpeed( i, nCvSpeed );
				}
			}
		}
		break;
	}
	nSeqCvMotorSpeedControlNo = nSeqNo;
}

void CCvSeq::SeqCvMotorManualControl(int nCvMotorNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	if( !m_pDicsData->m_GenInfo.bAuto )
	{
		if ( m_CvMotor.nCvManual[nCvMotorNo] == cvFW )
		{
			m_pEqpAssy->m_CvMotorAll.SetMotorFw( nCvMotorNo, ON );
			m_pEqpAssy->m_CvMotorAll.SetMotorBw( nCvMotorNo, OFF );
		}
		else if( m_CvMotor.nCvManual[nCvMotorNo] == cvBW )
		{
			m_pEqpAssy->m_CvMotorAll.SetMotorFw( nCvMotorNo, OFF );
			m_pEqpAssy->m_CvMotorAll.SetMotorBw( nCvMotorNo, ON );
		}
		else if( m_CvMotor.nCvManual[nCvMotorNo] == cvSTOP )
		{
			m_pEqpAssy->m_CvMotorAll.SetMotorFw( nCvMotorNo, OFF );
			m_pEqpAssy->m_CvMotorAll.SetMotorBw( nCvMotorNo, OFF );
		}		
	}
	else 
	{
		m_CvMotor.nCvManual[nCvMotorNo] = cvSTOP;
	} 
}
void CCvSeq::TimerControl( int nSensorType, int nSensorNo )
{
	static BOOL bTimerPause[MAX_CV_NO*2] = { FALSE, };
	int nIndex = nSensorNo*2 + nSensorType;

	if( ( m_CvMotor.nCvAuto[nSensorNo] == cvFW ) && bTimerPause[nIndex] )
	{
		
		TimerRestart( nIndex );
		bTimerPause[nIndex] = FALSE;

		// Glass Start
		BOOL bIsValid = m_pDicsData->m_GlsInfo[nIndex].bIsValid;
		if( bIsValid ) 
		{
			int nGlassNo = m_pDicsData->m_GlsInfo[nIndex].nGlassNo;
			m_pGlassAni->GlassMove( nGlassNo, nIndex + 3, TRUE );
		}
	}
	else if( ( m_CvMotor.nCvAuto[nSensorNo] == cvSTOP ) && !bTimerPause[nIndex] )
	{
		TimerStop( nIndex );
		bTimerPause[nIndex] = TRUE;

		// Glass Stop
		BOOL bIsValid = m_pDicsData->m_GlsInfo[nIndex].bIsValid;
		if( bIsValid ) 
		{
			int nGlassNo = m_pDicsData->m_GlsInfo[nIndex].nGlassNo;
			m_pGlassAni->GlassMove( nGlassNo, nIndex + 3, FALSE );
		}
	}
}

void CCvSeq::GetTimeOut(int nSensorNo, int nIsOutSensor, int* nTm1, int* nTm2, int* nTm3)
{
	double dCvSpeed = 0.0;
	double dCvAccSpeed = 0.0;
	double dCvDecSpeed = 0.0;
	double dCvLength = m_pSetupItems->m_fValueCvLength[( nSensorNo )*2 + (nIsOutSensor * 1)];//Test

	double dCvLengthInToAcc = m_pSetupItems->m_fValueCvLength[ ( IF_UNIT_UL )*2 + (1) ];//Test
	double dCvLengthAccToDec = m_pSetupItems->m_fValueCvLength[ ( IF_UNIT_UL )*2 + (2) ];//Test
	double dCvLengthDecToOut = m_pSetupItems->m_fValueCvLength[ ( IF_UNIT_UL )*2 + (3) ];//Test

	dCvSpeed = m_pDicsData->m_JobCond.nCvSpeed / 60.0; // mm/sec
	dCvAccSpeed = atof(m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_CV_ACCEL_SPEED]) / 60.0;
	dCvDecSpeed = atof(m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_CV_DECEL_SPEED]) / 60.0;

	double dCvMarginOn		= TIMEOUT_MARGIN_LENGTH_ON;
	double dCvMarginOff		= TIMEOUT_MARGIN_LENGTH_OFF;
	double dMarginOnTime	= dCvMarginOn / dCvSpeed;
	double dMarginOffTime	= dCvMarginOff / dCvSpeed;

	double dGlassSize		= GLASS_SIZE;

	if( nSensorNo == IF_UNIT_UL )
	{
//		*nTm1 = (int)( ( (850 / dCvSpeed) +(950 / dCvAccSpeed) +(250/dCvDecSpeed) + dMarginOnTime) * 10 );
//		*nTm2 = (int)( ( (850 / dCvSpeed) +(1000 / dCvAccSpeed) + dMarginOffTime) * 10 );
//		if( nTm3 != NULL )
//			*nTm3 = (int)(( (850 / dCvSpeed) +(950 / dCvAccSpeed) +(250/dCvDecSpeed) - dMarginOnTime ) * 10 );
		*nTm1 = (int)( ( (dCvLengthInToAcc / dCvSpeed) +(dCvLengthAccToDec / dCvAccSpeed) +(dCvLengthDecToOut/dCvDecSpeed) + dMarginOnTime) * 10 );
		*nTm2 = (int)( ( (dCvLengthInToAcc / dCvSpeed) +((dCvLengthAccToDec+50) / dCvAccSpeed) + dMarginOffTime) * 10 );
		if( nTm3 != NULL )
			*nTm3 = (int)(( (dCvLengthInToAcc / dCvSpeed) +(dCvLengthAccToDec / dCvAccSpeed) +(dCvLengthDecToOut/dCvDecSpeed) - dMarginOnTime ) * 10 );
		return;
	}
	// In Sensor Time out Setting
	*nTm1 = (int)( ( dCvLength / dCvSpeed + dMarginOnTime ) * 10 );
	*nTm2 = (int)( ( ( dGlassSize / dCvSpeed ) + dMarginOffTime ) * 10 );
	if( nTm3 != NULL )
		*nTm3 = (int)( ( dCvLength / dCvSpeed - dMarginOnTime ) * 10 );
#ifdef _MY_DEBUG
	*nTm1 = (int)( ( dCvLength / dCvSpeed ) * 10 );
	*nTm2 = (int)( ( dGlassSize / dCvSpeed ) * 10 );
	if( nTm3 != NULL )
		*nTm3 = (int)( ( dCvLength / dCvSpeed + dMarginOnTime ) * 10 );
#endif
}

BOOL CCvSeq::GetSeqRunCond( int nSensorNo )
{
	BOOL bRunCond   = TRUE;
	BOOL bAlarm		= FALSE;
	BOOL bUlTimeout = FALSE;

	// Check CvStop Condition
	for( int i = nSensorNo + 1; i<= IF_UNIT_UL; i++ )
	{
		bAlarm |= m_pDicsData->m_IfFlag[i].bInError;
		bAlarm |= m_pDicsData->m_IfFlag[i].bOutError;

//		bAlarm |= m_pDicsData->m_IfFlag[i].bAlarm;
	}
	 bUlTimeout = ( m_pDicsData->m_GenInfo.bUlTimeOut && nSensorNo != IF_UNIT_UL );

	if( nSensorNo != IF_UNIT_UL )
	{
		bAlarm |= m_pDicsData->m_GenInfo.bUlTimeOut;
		bAlarm |= m_pDicsData->m_GenInfo.bAkInterlock;	// 120306 halesu
	}

	if( m_pDicsData->m_GlsInfo[IF_UNIT_AK*2 + 0].bIsValid ||
		m_pDicsData->m_GlsInfo[IF_UNIT_AK*2 + 1].bIsValid )
	{
		if( nSensorNo < IF_UNIT_AK )
		{
			bAlarm |= m_pDicsData->m_GenInfo.bUlNotReady;
		}
	}
	//else if( m_pDicsData->m_GlsInfo[IF_UNIT_SWR2*2 + 1].bIsValid )
	//{
	//	if( nSensorNo < IF_UNIT_SWR2 )
	//	{
	//		bAlarm |= m_pDicsData->m_GenInfo.bUlNotReady;
	//	}
	//}
	else if( !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupWAIT_IN_WET_CHAMBER] &&
			  m_pDicsData->m_GlsInfo[IF_UNIT_BUF*2 + 1].bIsValid )
	{
		if( nSensorNo < IF_UNIT_BUF )
		{
			bAlarm |= m_pDicsData->m_GenInfo.bUlNotReady;
		}
	}
	else if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupWAIT_IN_WET_CHAMBER] && 
			 m_pDicsData->m_GlsInfo[IF_UNIT_SWR4*2 + 1].bIsValid )
	{
		if( nSensorNo < IF_UNIT_SWR4 )
		{
			bAlarm |= m_pDicsData->m_GenInfo.bUlNotReady;
		}
	}

	bRunCond &=	m_pDicsData->m_GenInfo.bAuto &  
				!m_pDicsData->m_GenInfo.bEmo &
				!m_pDicsData->m_GenInfo.bCoverOpen &
				!m_pDicsData->m_GenInfo.bDoorOpen &
				!m_pDicsData->m_GenInfo.bLeakSensor &
				!m_pDicsData->m_GenInfo.bPause &
				!bUlTimeout &
				!bAlarm;

	return bRunCond;
}

void CCvSeq::ApdSave(UINT nID, int nPortNo, int nSlotNo)
{
	int nSlot = m_pDicsData->m_GlsInfo[nID].nGlass_slot;
	m_sMessage.Format( "UNIT NO : %d, GLS SLOT : %d", nID, nSlot );
	SetLog( "APD SAVE", nPortNo, nSlotNo, m_sMessage );	

#ifndef _NO_EUV
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[2] = m_pDicsData->m_IfEuv.fLampIntensity[0];
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[3] = m_pDicsData->m_IfEuv.fLampIntensity[1];
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[4] = m_pDicsData->m_IfEuv.fLampIntensity[2]; 
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[5] = m_pDicsData->m_IfEuv.fLampIntensity[3]; 
#endif
	CString sString;
 //hskwak 190712 .
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[CDicsData::apdSLOT_NO] = (double)m_pDicsData->m_GlsInfo[nID].nSlotNo;
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[CDicsData::apdRCP_ID] = (double)atof( m_pDicsData->m_GlsInfo[nID].sRecipeId );
/*	m_pDicsData->m_CimApd[nSlot].dbGLSApd[CDicsData::apdCV_SPEED] = (double)m_pDicsData->m_JobCond.nCvSpeed;
*/
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[CCimSeq::apdSLOT_NO] = (double)m_pDicsData->m_GlsInfo[nID].nSlotNo;
	m_pDicsData->m_CimApd[nSlot].dbGLSApd[CCimSeq::apdRCP_ID] = (double)atof( m_pDicsData->m_GlsInfo[nID].sRecipeId );
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		int nApdNo = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nApdReportNo;
		if( nApdNo < 0 ) continue;
		m_pDicsData->m_CimApd[nSlot].dbGLSApd[CCimSeq::apdAI_START + nApdNo] = (double)m_pEqpAssy->m_AnalogInput.GetRealVal( i );
	}

	// hskwak 190812 APD Status  ߰.
	for( int i=0; i<m_pEqpAssy->m_SensorAPDStatus.GetDiSize(); i++)
	{
		if( m_pEqpAssy->m_SensorAPDStatus.Get(i) == TRUE)
		{
			if( m_pDicsData->m_nSensorAPDStatusType[i] == FALSE ) 
				m_pDicsData->m_CimApd[nSlot].dbGLSApd[CCimSeq::apdStatus_START + i] = 1.0;
			else
				m_pDicsData->m_CimApd[nSlot].dbGLSApd[CCimSeq::apdStatus_START + i] = 0.0;
		}
		else
		{
			if( m_pDicsData->m_nSensorAPDStatusType[i] == FALSE ) 
				m_pDicsData->m_CimApd[nSlot].dbGLSApd[CCimSeq::apdStatus_START + i] = 0.0;
			else
				m_pDicsData->m_CimApd[nSlot].dbGLSApd[CCimSeq::apdStatus_START + i] = 1.0;
		}
	}

	for( int i=0; i<MAX_APD_STATUS_DATA_GAP_NO; i++)
	{
		m_pDicsData->m_CimApd[nSlot].dbGLSApd[CCimSeq::apdGap_START + i] = m_pDicsData->m_RB_TachometerData[CDicsData::SWR2_RB1_UP_TACHOMETER+i ];
	}

	CString strBuf;
	for( int i=0; i< MAX_APD_STATUS_DATA_PIMTIME_NO; i++)
	{
		strBuf.Format("%d.%d", m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[i]/1000, m_pEqpAssy->m_CylinderUlPinUD.m_nActionTime[i]%1000/100);
		m_pDicsData->m_CimApd[nSlot].dbGLSApd[CCimSeq::apdPinTime_START+i] = (double)atof(strBuf);
	}

	for( int i=0; i<MAX_APD_STATUS_DATA_TACKTIME_NO; i++ )
	{
		m_pDicsData->m_CimApd[nSlot].dbGLSApd[CCimSeq::apdTackTime_START + i] = m_pDicsData->m_dUnitTackTime[i ];
	}

	

	sString.Format( "%02d", (int)m_pDicsData->m_CimApd[nSlot].dbGLSApd[CDicsData::apdSLOT_NO] );
	m_pDicsData->m_GlsInfo[nID].sApdData[CDicsData::apdSLOT_NO] = sString;
	sString.Format( "%02d", (int)m_pDicsData->m_CimApd[nSlot].dbGLSApd[CDicsData::apdRCP_ID] );
	m_pDicsData->m_GlsInfo[nID].sApdData[CDicsData::apdRCP_ID] = sString;
/*	sString.Format( "%02d", (int)m_pDicsData->m_CimApd[nSlot].dbGLSApd[CDicsData::apdCV_SPEED] );
	m_pDicsData->m_GlsInfo[nID].sApdData[CDicsData::apdCV_SPEED] = sString;
*/	

	for( int j=CCimSeq::apdAI_START; j<MAX_APD_DATA_NO; j++ )
	{		
		if( j<CCimSeq::apdAI_START+MAX_AI_INTR_NO )
			sString.Format( "%4.1f", m_pDicsData->m_CimApd[nSlot].dbGLSApd[j] );
		else if(  j<CCimSeq::apdAI_START+MAX_AI_INTR_NO+MAX_APD_STATUS_DATA_DI_NO )
			sString.Format( "%1.0f", m_pDicsData->m_CimApd[nSlot].dbGLSApd[j] );
		else 
			sString.Format( "%4.2f", m_pDicsData->m_CimApd[nSlot].dbGLSApd[j] );
//		m_pDicsData->m_GlsInfo[nID].sApdData[j].Format("%10.3f", m_pDicsData->m_CimApd[nSlot].dbGLSApd[j] );
		m_pDicsData->m_GlsInfo[nID].sApdData[j] = sString;
	}

	m_pDicsData->WriteProfileGlassData( nID );
	
}
void CCvSeq::CvStop(int nCvNo, BOOL bError)
{
// NOOP 
}

void CCvSeq::CvStopAll()
{
// NOOP 
}

void CCvSeq::CurCvRestart(int i)
{
// NOOP 
}

void CCvSeq::CvRestart(int nCvNo)
{
// NOOP 
}

void CCvSeq::CvRestartAll()
{
// NOOP 
}

void CCvSeq::CheckStopCountCond()
{
	BOOL bAlarm = FALSE;
	for( int i = IF_UNIT_LD; i<= IF_UNIT_UL; i++ )
	{
		bAlarm |= m_pDicsData->m_IfFlag[i].bInError;
		bAlarm |= m_pDicsData->m_IfFlag[i].bOutError;
//		bAlarm |= m_pDicsData->m_IfFlag[i].bAlarm;
	}
	bAlarm |= m_pDicsData->m_GenInfo.bUlTimeOut;
	bAlarm |= m_pDicsData->m_GenInfo.bUlNotReady;
	
	if ( bAlarm )
		m_pDicsData->m_SeqFlag.bStopCount1 = TRUE;
	else 
		m_pDicsData->m_SeqFlag.bStopCount1 = FALSE;
}

//---------------------------------------------------------------------------
// Set the Log
//---------------------------------------------------------------------------
void CCvSeq::SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage )
{
	// Log
	CString sLog;
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );
	
	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );
	
	sLog.Format( "CvSeq   \t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( sLog );
	
	if( m_pDicsData->m_GenInfo.bEnableEqpLog )
	{
		sLog.Format( "%s : %s", sSeqName, sMessage );
		Msg( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) sLog );
	}
}

BOOL CCvSeq::SeqULRobotInterlock(int nSensorNo, BOOL bError)
{
	BOOL bInterlock = FALSE;
	BOOL bUlUnitHandInterLock = m_pEqpAssy->m_SensorRobotHandInterlock.Get( 1 );

	if(bUlUnitHandInterLock == TRUE)
	{
		SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "Unload Robot Hand Sensing : NG" );
		bInterlock = TRUE;
	}

	return bInterlock;
}

BOOL CCvSeq::SeqLDRobotInterlock(int nSensorNo, BOOL bError)
{
	BOOL bInterlock = FALSE;
	BOOL bLdUnitHandInterLock = m_pEqpAssy->m_SensorRobotHandInterlock.Get( 0 );

	if(bLdUnitHandInterLock == TRUE)
	{
		SetLog( m_pDicsData->m_sInSensorUnitName[nSensorNo], 0, 0, "Load Robot Hand Sensing : NG" );
		bInterlock = TRUE;
	}

	return bInterlock;
}